# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class F1AP_CommonDataTypes:

    _name_  = u'F1AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 3]
    
    _obj_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name=u'ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class F1AP_Constants:

    _name_  = u'F1AP-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 4]
    
    _obj_ = [
        u'id-Reset',
        u'id-F1Setup',
        u'id-ErrorIndication',
        u'id-gNBDUConfigurationUpdate',
        u'id-gNBCUConfigurationUpdate',
        u'id-UEContextSetup',
        u'id-UEContextRelease',
        u'id-UEContextModification',
        u'id-UEContextModificationRequired',
        u'id-UEMobilityCommand',
        u'id-UEContextReleaseRequest',
        u'id-InitialULRRCMessageTransfer',
        u'id-DLRRCMessageTransfer',
        u'id-ULRRCMessageTransfer',
        u'id-privateMessage',
        u'id-UEInactivityNotification',
        u'id-GNBDUResourceCoordination',
        u'id-SystemInformationDeliveryCommand',
        u'id-Paging',
        u'id-Notify',
        u'id-WriteReplaceWarning',
        u'id-PWSCancel',
        u'id-PWSRestartIndication',
        u'id-PWSFailureIndication',
        u'id-GNBDUStatusIndication',
        u'id-RRCDeliveryReport',
        u'id-F1Removal',
        u'id-NetworkAccessRateReduction',
        u'id-TraceStart',
        u'id-DeactivateTrace',
        u'id-DUCURadioInformationTransfer',
        u'id-CUDURadioInformationTransfer',
        u'id-BAPMappingConfiguration',
        u'id-GNBDUResourceConfiguration',
        u'id-IABTNLAddressAllocation',
        u'id-IABUPConfigurationUpdate',
        u'id-resourceStatusReportingInitiation',
        u'id-resourceStatusReporting',
        u'id-accessAndMobilityIndication',
        u'id-accessSuccess',
        u'id-cellTrafficTrace',
        u'id-PositioningMeasurementExchange',
        u'id-PositioningAssistanceInformationControl',
        u'id-PositioningAssistanceInformationFeedback',
        u'id-PositioningMeasurementReport',
        u'id-PositioningMeasurementAbort',
        u'id-PositioningMeasurementFailureIndication',
        u'id-PositioningMeasurementUpdate',
        u'id-TRPInformationExchange',
        u'id-PositioningInformationExchange',
        u'id-PositioningActivation',
        u'id-PositioningDeactivation',
        u'id-E-CIDMeasurementInitiation',
        u'id-E-CIDMeasurementFailureIndication',
        u'id-E-CIDMeasurementReport',
        u'id-E-CIDMeasurementTermination',
        u'id-PositioningInformationUpdate',
        u'id-ReferenceTimeInformationReport',
        u'id-ReferenceTimeInformationReportingControl',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxNRARFCN',
        u'maxnoofErrors',
        u'maxnoofIndividualF1ConnectionsToReset',
        u'maxCellingNBDU',
        u'maxnoofSCells',
        u'maxnoofSRBs',
        u'maxnoofDRBs',
        u'maxnoofULUPTNLInformation',
        u'maxnoofDLUPTNLInformation',
        u'maxnoofBPLMNs',
        u'maxnoofCandidateSpCells',
        u'maxnoofPotentialSpCells',
        u'maxnoofNrCellBands',
        u'maxnoofSIBTypes',
        u'maxnoofSITypes',
        u'maxnoofPagingCells',
        u'maxnoofTNLAssociations',
        u'maxnoofQoSFlows',
        u'maxnoofSliceItems',
        u'maxCellineNB',
        u'maxnoofExtendedBPLMNs',
        u'maxnoofUEIDs',
        u'maxnoofBPLMNsNR',
        u'maxnoofUACPLMNs',
        u'maxnoofUACperPLMN',
        u'maxnoofAdditionalSIBs',
        u'maxnoofslots',
        u'maxnoofTLAs',
        u'maxnoofGTPTLAs',
        u'maxnoofBHRLCChannels',
        u'maxnoofRoutingEntries',
        u'maxnoofIABSTCInfo',
        u'maxnoofSymbols',
        u'maxnoofServingCells',
        u'maxnoofDUFSlots',
        u'maxnoofHSNASlots',
        u'maxnoofServedCellsIAB',
        u'maxnoofChildIABNodes',
        u'maxnoofNonUPTrafficMappings',
        u'maxnoofTLAsIAB',
        u'maxnoofMappingEntries',
        u'maxnoofDSInfo',
        u'maxnoofEgressLinks',
        u'maxnoofULUPTNLInformationforIAB',
        u'maxnoofUPTNLAddresses',
        u'maxnoofSLDRBs',
        u'maxnoofQoSParaSets',
        u'maxnoofPC5QoSFlows',
        u'maxnoofSSBAreas',
        u'maxnoofPhysicalResourceBlocks',
        u'maxnoofPhysicalResourceBlocks-1',
        u'maxnoofPRACHconfigs',
        u'maxnoofRACHReports',
        u'maxnoofRLFReports',
        u'maxnoofAdditionalPDCPDuplicationTNL',
        u'maxnoofRLCDuplicationState',
        u'maxnoofCHOcells',
        u'maxnoofMDTPLMNs',
        u'maxnoofCAGsupported',
        u'maxnoofNIDsupported',
        u'maxnoofNRSCSs',
        u'maxnoofExtSliceItems',
        u'maxnoofPosMeas',
        u'maxnoofTRPInfoTypes',
        u'maxnoofTRPs',
        u'maxnoofSRSTriggerStates',
        u'maxnoofSpatialRelations',
        u'maxnoBcastCell',
        u'maxnoofAngleInfo',
        u'maxnooflcs-gcs-translation',
        u'maxnoofPath',
        u'maxnoofMeasE-CID',
        u'maxnoofSSBs',
        u'maxnoSRS-ResourceSets',
        u'maxnoSRS-ResourcePerSet',
        u'maxnoSRS-Carriers',
        u'maxnoSCSs',
        u'maxnoSRS-Resources',
        u'maxnoSRS-PosResources',
        u'maxnoSRS-PosResourceSets',
        u'maxnoSRS-PosResourcePerSet',
        u'maxnoofPRS-ResourceSets',
        u'maxnoofPRS-ResourcesPerSet',
        u'maxNoOfMeasTRPs',
        u'maxnoofPRSresourceSets',
        u'maxnoofPRSresources',
        u'id-Cause',
        u'id-Cells-Failed-to-be-Activated-List',
        u'id-Cells-Failed-to-be-Activated-List-Item',
        u'id-Cells-to-be-Activated-List',
        u'id-Cells-to-be-Activated-List-Item',
        u'id-Cells-to-be-Deactivated-List',
        u'id-Cells-to-be-Deactivated-List-Item',
        u'id-CriticalityDiagnostics',
        u'id-CUtoDURRCInformation',
        u'id-DRBs-FailedToBeModified-Item',
        u'id-DRBs-FailedToBeModified-List',
        u'id-DRBs-FailedToBeSetup-Item',
        u'id-DRBs-FailedToBeSetup-List',
        u'id-DRBs-FailedToBeSetupMod-Item',
        u'id-DRBs-FailedToBeSetupMod-List',
        u'id-DRBs-ModifiedConf-Item',
        u'id-DRBs-ModifiedConf-List',
        u'id-DRBs-Modified-Item',
        u'id-DRBs-Modified-List',
        u'id-DRBs-Required-ToBeModified-Item',
        u'id-DRBs-Required-ToBeModified-List',
        u'id-DRBs-Required-ToBeReleased-Item',
        u'id-DRBs-Required-ToBeReleased-List',
        u'id-DRBs-Setup-Item',
        u'id-DRBs-Setup-List',
        u'id-DRBs-SetupMod-Item',
        u'id-DRBs-SetupMod-List',
        u'id-DRBs-ToBeModified-Item',
        u'id-DRBs-ToBeModified-List',
        u'id-DRBs-ToBeReleased-Item',
        u'id-DRBs-ToBeReleased-List',
        u'id-DRBs-ToBeSetup-Item',
        u'id-DRBs-ToBeSetup-List',
        u'id-DRBs-ToBeSetupMod-Item',
        u'id-DRBs-ToBeSetupMod-List',
        u'id-DRXCycle',
        u'id-DUtoCURRCInformation',
        u'id-gNB-CU-UE-F1AP-ID',
        u'id-gNB-DU-UE-F1AP-ID',
        u'id-gNB-DU-ID',
        u'id-GNB-DU-Served-Cells-Item',
        u'id-gNB-DU-Served-Cells-List',
        u'id-gNB-DU-Name',
        u'id-NRCellID',
        u'id-oldgNB-DU-UE-F1AP-ID',
        u'id-ResetType',
        u'id-ResourceCoordinationTransferContainer',
        u'id-RRCContainer',
        u'id-SCell-ToBeRemoved-Item',
        u'id-SCell-ToBeRemoved-List',
        u'id-SCell-ToBeSetup-Item',
        u'id-SCell-ToBeSetup-List',
        u'id-SCell-ToBeSetupMod-Item',
        u'id-SCell-ToBeSetupMod-List',
        u'id-Served-Cells-To-Add-Item',
        u'id-Served-Cells-To-Add-List',
        u'id-Served-Cells-To-Delete-Item',
        u'id-Served-Cells-To-Delete-List',
        u'id-Served-Cells-To-Modify-Item',
        u'id-Served-Cells-To-Modify-List',
        u'id-SpCell-ID',
        u'id-SRBID',
        u'id-SRBs-FailedToBeSetup-Item',
        u'id-SRBs-FailedToBeSetup-List',
        u'id-SRBs-FailedToBeSetupMod-Item',
        u'id-SRBs-FailedToBeSetupMod-List',
        u'id-SRBs-Required-ToBeReleased-Item',
        u'id-SRBs-Required-ToBeReleased-List',
        u'id-SRBs-ToBeReleased-Item',
        u'id-SRBs-ToBeReleased-List',
        u'id-SRBs-ToBeSetup-Item',
        u'id-SRBs-ToBeSetup-List',
        u'id-SRBs-ToBeSetupMod-Item',
        u'id-SRBs-ToBeSetupMod-List',
        u'id-TimeToWait',
        u'id-TransactionID',
        u'id-TransmissionActionIndicator',
        u'id-UE-associatedLogicalF1-ConnectionItem',
        u'id-UE-associatedLogicalF1-ConnectionListResAck',
        u'id-gNB-CU-Name',
        u'id-SCell-FailedtoSetup-List',
        u'id-SCell-FailedtoSetup-Item',
        u'id-SCell-FailedtoSetupMod-List',
        u'id-SCell-FailedtoSetupMod-Item',
        u'id-RRCReconfigurationCompleteIndicator',
        u'id-Cells-Status-Item',
        u'id-Cells-Status-List',
        u'id-Candidate-SpCell-List',
        u'id-Candidate-SpCell-Item',
        u'id-Potential-SpCell-List',
        u'id-Potential-SpCell-Item',
        u'id-FullConfiguration',
        u'id-C-RNTI',
        u'id-SpCellULConfigured',
        u'id-InactivityMonitoringRequest',
        u'id-InactivityMonitoringResponse',
        u'id-DRB-Activity-Item',
        u'id-DRB-Activity-List',
        u'id-EUTRA-NR-CellResourceCoordinationReq-Container',
        u'id-EUTRA-NR-CellResourceCoordinationReqAck-Container',
        u'id-Protected-EUTRA-Resources-List',
        u'id-RequestType',
        u'id-ServCellIndex',
        u'id-RAT-FrequencyPriorityInformation',
        u'id-ExecuteDuplication',
        u'id-NRCGI',
        u'id-PagingCell-Item',
        u'id-PagingCell-List',
        u'id-PagingDRX',
        u'id-PagingPriority',
        u'id-SItype-List',
        u'id-UEIdentityIndexValue',
        u'id-gNB-CUSystemInformation',
        u'id-HandoverPreparationInformation',
        u'id-GNB-CU-TNL-Association-To-Add-Item',
        u'id-GNB-CU-TNL-Association-To-Add-List',
        u'id-GNB-CU-TNL-Association-To-Remove-Item',
        u'id-GNB-CU-TNL-Association-To-Remove-List',
        u'id-GNB-CU-TNL-Association-To-Update-Item',
        u'id-GNB-CU-TNL-Association-To-Update-List',
        u'id-MaskedIMEISV',
        u'id-PagingIdentity',
        u'id-DUtoCURRCContainer',
        u'id-Cells-to-be-Barred-List',
        u'id-Cells-to-be-Barred-Item',
        u'id-TAISliceSupportList',
        u'id-GNB-CU-TNL-Association-Setup-List',
        u'id-GNB-CU-TNL-Association-Setup-Item',
        u'id-GNB-CU-TNL-Association-Failed-To-Setup-List',
        u'id-GNB-CU-TNL-Association-Failed-To-Setup-Item',
        u'id-DRB-Notify-Item',
        u'id-DRB-Notify-List',
        u'id-NotficationControl',
        u'id-RANAC',
        u'id-PWSSystemInformation',
        u'id-RepetitionPeriod',
        u'id-NumberofBroadcastRequest',
        u'id-Cells-To-Be-Broadcast-List',
        u'id-Cells-To-Be-Broadcast-Item',
        u'id-Cells-Broadcast-Completed-List',
        u'id-Cells-Broadcast-Completed-Item',
        u'id-Broadcast-To-Be-Cancelled-List',
        u'id-Broadcast-To-Be-Cancelled-Item',
        u'id-Cells-Broadcast-Cancelled-List',
        u'id-Cells-Broadcast-Cancelled-Item',
        u'id-NR-CGI-List-For-Restart-List',
        u'id-NR-CGI-List-For-Restart-Item',
        u'id-PWS-Failed-NR-CGI-List',
        u'id-PWS-Failed-NR-CGI-Item',
        u'id-ConfirmedUEID',
        u'id-Cancel-all-Warning-Messages-Indicator',
        u'id-GNB-DU-UE-AMBR-UL',
        u'id-DRXConfigurationIndicator',
        u'id-RLC-Status',
        u'id-DLPDCPSNLength',
        u'id-GNB-DUConfigurationQuery',
        u'id-MeasurementTimingConfiguration',
        u'id-DRB-Information',
        u'id-ServingPLMN',
        u'id-Protected-EUTRA-Resources-Item',
        u'id-GNB-CU-RRC-Version',
        u'id-GNB-DU-RRC-Version',
        u'id-GNBDUOverloadInformation',
        u'id-CellGroupConfig',
        u'id-RLCFailureIndication',
        u'id-UplinkTxDirectCurrentListInformation',
        u'id-DC-Based-Duplication-Configured',
        u'id-DC-Based-Duplication-Activation',
        u'id-SULAccessIndication',
        u'id-AvailablePLMNList',
        u'id-PDUSessionID',
        u'id-ULPDUSessionAggregateMaximumBitRate',
        u'id-ServingCellMO',
        u'id-QoSFlowMappingIndication',
        u'id-RRCDeliveryStatusRequest',
        u'id-RRCDeliveryStatus',
        u'id-BearerTypeChange',
        u'id-RLCMode',
        u'id-Duplication-Activation',
        u'id-Dedicated-SIDelivery-NeededUE-List',
        u'id-Dedicated-SIDelivery-NeededUE-Item',
        u'id-DRX-LongCycleStartOffset',
        u'id-ULPDCPSNLength',
        u'id-SelectedBandCombinationIndex',
        u'id-SelectedFeatureSetEntryIndex',
        u'id-ResourceCoordinationTransferInformation',
        u'id-ExtendedServedPLMNs-List',
        u'id-ExtendedAvailablePLMN-List',
        u'id-Associated-SCell-List',
        u'id-latest-RRC-Version-Enhanced',
        u'id-Associated-SCell-Item',
        u'id-Cell-Direction',
        u'id-SRBs-Setup-List',
        u'id-SRBs-Setup-Item',
        u'id-SRBs-SetupMod-List',
        u'id-SRBs-SetupMod-Item',
        u'id-SRBs-Modified-List',
        u'id-SRBs-Modified-Item',
        u'id-Ph-InfoSCG',
        u'id-RequestedBandCombinationIndex',
        u'id-RequestedFeatureSetEntryIndex',
        u'id-RequestedP-MaxFR2',
        u'id-DRX-Config',
        u'id-IgnoreResourceCoordinationContainer',
        u'id-UEAssistanceInformation',
        u'id-NeedforGap',
        u'id-PagingOrigin',
        u'id-new-gNB-CU-UE-F1AP-ID',
        u'id-RedirectedRRCmessage',
        u'id-new-gNB-DU-UE-F1AP-ID',
        u'id-NotificationInformation',
        u'id-PLMNAssistanceInfoForNetShar',
        u'id-UEContextNotRetrievable',
        u'id-BPLMN-ID-Info-List',
        u'id-SelectedPLMNID',
        u'id-UAC-Assistance-Info',
        u'id-RANUEID',
        u'id-GNB-DU-TNL-Association-To-Remove-Item',
        u'id-GNB-DU-TNL-Association-To-Remove-List',
        u'id-TNLAssociationTransportLayerAddressgNBDU',
        u'id-portNumber',
        u'id-AdditionalSIBMessageList',
        u'id-Cell-Type',
        u'id-IgnorePRACHConfiguration',
        u'id-CG-Config',
        u'id-PDCCH-BlindDetectionSCG',
        u'id-Requested-PDCCH-BlindDetectionSCG',
        u'id-Ph-InfoMCG',
        u'id-MeasGapSharingConfig',
        u'id-systemInformationAreaID',
        u'id-areaScope',
        u'id-RRCContainer-RRCSetupComplete',
        u'id-TraceActivation',
        u'id-TraceID',
        u'id-Neighbour-Cell-Information-List',
        u'id-SymbolAllocInSlot',
        u'id-NumDLULSymbols',
        u'id-AdditionalRRMPriorityIndex',
        u'id-DUCURadioInformationType',
        u'id-CUDURadioInformationType',
        u'id-AggressorgNBSetID',
        u'id-VictimgNBSetID',
        u'id-LowerLayerPresenceStatusChange',
        u'id-Transport-Layer-Address-Info',
        u'id-Neighbour-Cell-Information-Item',
        u'id-IntendedTDD-DL-ULConfig',
        u'id-QosMonitoringRequest',
        u'id-BHChannels-ToBeSetup-List',
        u'id-BHChannels-ToBeSetup-Item',
        u'id-BHChannels-Setup-List',
        u'id-BHChannels-Setup-Item',
        u'id-BHChannels-ToBeModified-Item',
        u'id-BHChannels-ToBeModified-List',
        u'id-BHChannels-ToBeReleased-Item',
        u'id-BHChannels-ToBeReleased-List',
        u'id-BHChannels-ToBeSetupMod-Item',
        u'id-BHChannels-ToBeSetupMod-List',
        u'id-BHChannels-FailedToBeModified-Item',
        u'id-BHChannels-FailedToBeModified-List',
        u'id-BHChannels-FailedToBeSetupMod-Item',
        u'id-BHChannels-FailedToBeSetupMod-List',
        u'id-BHChannels-Modified-Item',
        u'id-BHChannels-Modified-List',
        u'id-BHChannels-SetupMod-Item',
        u'id-BHChannels-SetupMod-List',
        u'id-BHChannels-Required-ToBeReleased-Item',
        u'id-BHChannels-Required-ToBeReleased-List',
        u'id-BHChannels-FailedToBeSetup-Item',
        u'id-BHChannels-FailedToBeSetup-List',
        u'id-BHInfo',
        u'id-BAPAddress',
        u'id-ConfiguredBAPAddress',
        u'id-BH-Routing-Information-Added-List',
        u'id-BH-Routing-Information-Added-List-Item',
        u'id-BH-Routing-Information-Removed-List',
        u'id-BH-Routing-Information-Removed-List-Item',
        u'id-UL-BH-Non-UP-Traffic-Mapping',
        u'id-Activated-Cells-to-be-Updated-List',
        u'id-Child-Nodes-List',
        u'id-IAB-Info-IAB-DU',
        u'id-IAB-Info-IAB-donor-CU',
        u'id-IAB-TNL-Addresses-To-Remove-List',
        u'id-IAB-TNL-Addresses-To-Remove-Item',
        u'id-IAB-Allocated-TNL-Address-List',
        u'id-IAB-Allocated-TNL-Address-Item',
        u'id-IABIPv6RequestType',
        u'id-IABv4AddressesRequested',
        u'id-IAB-Barred',
        u'id-TrafficMappingInformation',
        u'id-UL-UP-TNL-Information-to-Update-List',
        u'id-UL-UP-TNL-Information-to-Update-List-Item',
        u'id-UL-UP-TNL-Address-to-Update-List',
        u'id-UL-UP-TNL-Address-to-Update-List-Item',
        u'id-DL-UP-TNL-Address-to-Update-List',
        u'id-DL-UP-TNL-Address-to-Update-List-Item',
        u'id-NRV2XServicesAuthorized',
        u'id-LTEV2XServicesAuthorized',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-LTEUESidelinkAggregateMaximumBitrate',
        u'id-SIB12-message',
        u'id-SIB13-message',
        u'id-SIB14-message',
        u'id-SLDRBs-FailedToBeModified-Item',
        u'id-SLDRBs-FailedToBeModified-List',
        u'id-SLDRBs-FailedToBeSetup-Item',
        u'id-SLDRBs-FailedToBeSetup-List',
        u'id-SLDRBs-Modified-Item',
        u'id-SLDRBs-Modified-List',
        u'id-SLDRBs-Required-ToBeModified-Item',
        u'id-SLDRBs-Required-ToBeModified-List',
        u'id-SLDRBs-Required-ToBeReleased-Item',
        u'id-SLDRBs-Required-ToBeReleased-List',
        u'id-SLDRBs-Setup-Item',
        u'id-SLDRBs-Setup-List',
        u'id-SLDRBs-ToBeModified-Item',
        u'id-SLDRBs-ToBeModified-List',
        u'id-SLDRBs-ToBeReleased-Item',
        u'id-SLDRBs-ToBeReleased-List',
        u'id-SLDRBs-ToBeSetup-Item',
        u'id-SLDRBs-ToBeSetup-List',
        u'id-SLDRBs-ToBeSetupMod-Item',
        u'id-SLDRBs-ToBeSetupMod-List',
        u'id-SLDRBs-SetupMod-List',
        u'id-SLDRBs-FailedToBeSetupMod-List',
        u'id-SLDRBs-SetupMod-Item',
        u'id-SLDRBs-FailedToBeSetupMod-Item',
        u'id-SLDRBs-ModifiedConf-List',
        u'id-SLDRBs-ModifiedConf-Item',
        u'id-UEAssistanceInformationEUTRA',
        u'id-PC5LinkAMBR',
        u'id-SL-PHY-MAC-RLC-Config',
        u'id-SL-ConfigDedicatedEUTRA-Info',
        u'id-AlternativeQoSParaSetList',
        u'id-CurrentQoSParaSetIndex',
        u'id-gNBCUMeasurementID',
        u'id-gNBDUMeasurementID',
        u'id-RegistrationRequest',
        u'id-ReportCharacteristics',
        u'id-CellToReportList',
        u'id-CellMeasurementResultList',
        u'id-HardwareLoadIndicator',
        u'id-ReportingPeriodicity',
        u'id-TNLCapacityIndicator',
        u'id-CarrierList',
        u'id-ULCarrierList',
        u'id-FrequencyShift7p5khz',
        u'id-SSB-PositionsInBurst',
        u'id-NRPRACHConfig',
        u'id-RACHReportInformationList',
        u'id-RLFReportInformationList',
        u'id-TDD-UL-DLConfigCommonNR',
        u'id-CNPacketDelayBudgetDownlink',
        u'id-ExtendedPacketDelayBudget',
        u'id-TSCTrafficCharacteristics',
        u'id-ReportingRequestType',
        u'id-TimeReferenceInformation',
        u'id-CNPacketDelayBudgetUplink',
        u'id-AdditionalPDCPDuplicationTNL-List',
        u'id-RLCDuplicationInformation',
        u'id-AdditionalDuplicationIndication',
        u'id-ConditionalInterDUMobilityInformation',
        u'id-ConditionalIntraDUMobilityInformation',
        u'id-targetCellsToCancel',
        u'id-requestedTargetCellGlobalID',
        u'id-ManagementBasedMDTPLMNList',
        u'id-TraceCollectionEntityIPAddress',
        u'id-PrivacyIndicator',
        u'id-TraceCollectionEntityURI',
        u'id-mdtConfiguration',
        u'id-ServingNID',
        u'id-NPNBroadcastInformation',
        u'id-NPNSupportInfo',
        u'id-NID',
        u'id-AvailableSNPN-ID-List',
        u'id-SIB10-message',
        u'id-DLCarrierList',
        u'id-ExtendedTAISliceSupportList',
        u'id-RequestedSRSTransmissionCharacteristics',
        u'id-PosAssistance-Information',
        u'id-PosBroadcast',
        u'id-RoutingID',
        u'id-PosAssistanceInformationFailureList',
        u'id-PosMeasurementQuantities',
        u'id-PosMeasurementResultList',
        u'id-TRPInformationTypeListTRPReq',
        u'id-TRPInformationTypeItem',
        u'id-TRPInformationListTRPResp',
        u'id-TRPInformationItem',
        u'id-LMF-MeasurementID',
        u'id-SRSType',
        u'id-ActivationTime',
        u'id-AbortTransmission',
        u'id-PositioningBroadcastCells',
        u'id-SRSConfiguration',
        u'id-PosReportCharacteristics',
        u'id-PosMeasurementPeriodicity',
        u'id-TRPList',
        u'id-RAN-MeasurementID',
        u'id-LMF-UE-MeasurementID',
        u'id-RAN-UE-MeasurementID',
        u'id-E-CID-MeasurementQuantities',
        u'id-E-CID-MeasurementQuantities-Item',
        u'id-E-CID-MeasurementPeriodicity',
        u'id-E-CID-MeasurementResult',
        u'id-Cell-Portion-ID',
        u'id-SFNInitialisationTime',
        u'id-SystemFrameNumber',
        u'id-SlotNumber',
        u'id-TRP-MeasurementRequestList',
        u'id-MeasurementBeamInfoRequest',
        u'id-E-CID-ReportCharacteristics',
        u'id-ConfiguredTACIndication',
        u'id-Extended-GNB-CU-Name',
        u'id-Extended-GNB-DU-Name',
        u'id-F1CTransferPath',
        u'id-SFN-Offset',
        u'id-TransmissionStopIndicator',
        u'id-SrsFrequency',
        u'id-SCGIndicator',
        u'id-EstimatedArrivalProbability',
        u'id-TRPType',
        u'id-SRSSpatialRelationPerSRSResource',
        u'id-PDCPTerminatingNodeDLTNLAddrInfo',
        u'id-ENBDLTNLAddress',
        u'id-PosMeasurementPeriodicityExtended',
        u'id-PRS-Resource-ID',
        u'id-LocationMeasurementInformation',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-Reset',
        u'id-F1Setup',
        u'id-ErrorIndication',
        u'id-gNBDUConfigurationUpdate',
        u'id-gNBCUConfigurationUpdate',
        u'id-UEContextSetup',
        u'id-UEContextRelease',
        u'id-UEContextModification',
        u'id-UEContextModificationRequired',
        u'id-UEMobilityCommand',
        u'id-UEContextReleaseRequest',
        u'id-InitialULRRCMessageTransfer',
        u'id-DLRRCMessageTransfer',
        u'id-ULRRCMessageTransfer',
        u'id-privateMessage',
        u'id-UEInactivityNotification',
        u'id-GNBDUResourceCoordination',
        u'id-SystemInformationDeliveryCommand',
        u'id-Paging',
        u'id-Notify',
        u'id-WriteReplaceWarning',
        u'id-PWSCancel',
        u'id-PWSRestartIndication',
        u'id-PWSFailureIndication',
        u'id-GNBDUStatusIndication',
        u'id-RRCDeliveryReport',
        u'id-F1Removal',
        u'id-NetworkAccessRateReduction',
        u'id-TraceStart',
        u'id-DeactivateTrace',
        u'id-DUCURadioInformationTransfer',
        u'id-CUDURadioInformationTransfer',
        u'id-BAPMappingConfiguration',
        u'id-GNBDUResourceConfiguration',
        u'id-IABTNLAddressAllocation',
        u'id-IABUPConfigurationUpdate',
        u'id-resourceStatusReportingInitiation',
        u'id-resourceStatusReporting',
        u'id-accessAndMobilityIndication',
        u'id-accessSuccess',
        u'id-cellTrafficTrace',
        u'id-PositioningMeasurementExchange',
        u'id-PositioningAssistanceInformationControl',
        u'id-PositioningAssistanceInformationFeedback',
        u'id-PositioningMeasurementReport',
        u'id-PositioningMeasurementAbort',
        u'id-PositioningMeasurementFailureIndication',
        u'id-PositioningMeasurementUpdate',
        u'id-TRPInformationExchange',
        u'id-PositioningInformationExchange',
        u'id-PositioningActivation',
        u'id-PositioningDeactivation',
        u'id-E-CIDMeasurementInitiation',
        u'id-E-CIDMeasurementFailureIndication',
        u'id-E-CIDMeasurementReport',
        u'id-E-CIDMeasurementTermination',
        u'id-PositioningInformationUpdate',
        u'id-ReferenceTimeInformationReport',
        u'id-ReferenceTimeInformationReportingControl',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxNRARFCN',
        u'maxnoofErrors',
        u'maxnoofIndividualF1ConnectionsToReset',
        u'maxCellingNBDU',
        u'maxnoofSCells',
        u'maxnoofSRBs',
        u'maxnoofDRBs',
        u'maxnoofULUPTNLInformation',
        u'maxnoofDLUPTNLInformation',
        u'maxnoofBPLMNs',
        u'maxnoofCandidateSpCells',
        u'maxnoofPotentialSpCells',
        u'maxnoofNrCellBands',
        u'maxnoofSIBTypes',
        u'maxnoofSITypes',
        u'maxnoofPagingCells',
        u'maxnoofTNLAssociations',
        u'maxnoofQoSFlows',
        u'maxnoofSliceItems',
        u'maxCellineNB',
        u'maxnoofExtendedBPLMNs',
        u'maxnoofUEIDs',
        u'maxnoofBPLMNsNR',
        u'maxnoofUACPLMNs',
        u'maxnoofUACperPLMN',
        u'maxnoofAdditionalSIBs',
        u'maxnoofslots',
        u'maxnoofTLAs',
        u'maxnoofGTPTLAs',
        u'maxnoofBHRLCChannels',
        u'maxnoofRoutingEntries',
        u'maxnoofIABSTCInfo',
        u'maxnoofSymbols',
        u'maxnoofServingCells',
        u'maxnoofDUFSlots',
        u'maxnoofHSNASlots',
        u'maxnoofServedCellsIAB',
        u'maxnoofChildIABNodes',
        u'maxnoofNonUPTrafficMappings',
        u'maxnoofTLAsIAB',
        u'maxnoofMappingEntries',
        u'maxnoofDSInfo',
        u'maxnoofEgressLinks',
        u'maxnoofULUPTNLInformationforIAB',
        u'maxnoofUPTNLAddresses',
        u'maxnoofSLDRBs',
        u'maxnoofQoSParaSets',
        u'maxnoofPC5QoSFlows',
        u'maxnoofSSBAreas',
        u'maxnoofPhysicalResourceBlocks',
        u'maxnoofPhysicalResourceBlocks-1',
        u'maxnoofPRACHconfigs',
        u'maxnoofRACHReports',
        u'maxnoofRLFReports',
        u'maxnoofAdditionalPDCPDuplicationTNL',
        u'maxnoofRLCDuplicationState',
        u'maxnoofCHOcells',
        u'maxnoofMDTPLMNs',
        u'maxnoofCAGsupported',
        u'maxnoofNIDsupported',
        u'maxnoofNRSCSs',
        u'maxnoofExtSliceItems',
        u'maxnoofPosMeas',
        u'maxnoofTRPInfoTypes',
        u'maxnoofTRPs',
        u'maxnoofSRSTriggerStates',
        u'maxnoofSpatialRelations',
        u'maxnoBcastCell',
        u'maxnoofAngleInfo',
        u'maxnooflcs-gcs-translation',
        u'maxnoofPath',
        u'maxnoofMeasE-CID',
        u'maxnoofSSBs',
        u'maxnoSRS-ResourceSets',
        u'maxnoSRS-ResourcePerSet',
        u'maxnoSRS-Carriers',
        u'maxnoSCSs',
        u'maxnoSRS-Resources',
        u'maxnoSRS-PosResources',
        u'maxnoSRS-PosResourceSets',
        u'maxnoSRS-PosResourcePerSet',
        u'maxnoofPRS-ResourceSets',
        u'maxnoofPRS-ResourcesPerSet',
        u'maxNoOfMeasTRPs',
        u'maxnoofPRSresourceSets',
        u'maxnoofPRSresources',
        u'id-Cause',
        u'id-Cells-Failed-to-be-Activated-List',
        u'id-Cells-Failed-to-be-Activated-List-Item',
        u'id-Cells-to-be-Activated-List',
        u'id-Cells-to-be-Activated-List-Item',
        u'id-Cells-to-be-Deactivated-List',
        u'id-Cells-to-be-Deactivated-List-Item',
        u'id-CriticalityDiagnostics',
        u'id-CUtoDURRCInformation',
        u'id-DRBs-FailedToBeModified-Item',
        u'id-DRBs-FailedToBeModified-List',
        u'id-DRBs-FailedToBeSetup-Item',
        u'id-DRBs-FailedToBeSetup-List',
        u'id-DRBs-FailedToBeSetupMod-Item',
        u'id-DRBs-FailedToBeSetupMod-List',
        u'id-DRBs-ModifiedConf-Item',
        u'id-DRBs-ModifiedConf-List',
        u'id-DRBs-Modified-Item',
        u'id-DRBs-Modified-List',
        u'id-DRBs-Required-ToBeModified-Item',
        u'id-DRBs-Required-ToBeModified-List',
        u'id-DRBs-Required-ToBeReleased-Item',
        u'id-DRBs-Required-ToBeReleased-List',
        u'id-DRBs-Setup-Item',
        u'id-DRBs-Setup-List',
        u'id-DRBs-SetupMod-Item',
        u'id-DRBs-SetupMod-List',
        u'id-DRBs-ToBeModified-Item',
        u'id-DRBs-ToBeModified-List',
        u'id-DRBs-ToBeReleased-Item',
        u'id-DRBs-ToBeReleased-List',
        u'id-DRBs-ToBeSetup-Item',
        u'id-DRBs-ToBeSetup-List',
        u'id-DRBs-ToBeSetupMod-Item',
        u'id-DRBs-ToBeSetupMod-List',
        u'id-DRXCycle',
        u'id-DUtoCURRCInformation',
        u'id-gNB-CU-UE-F1AP-ID',
        u'id-gNB-DU-UE-F1AP-ID',
        u'id-gNB-DU-ID',
        u'id-GNB-DU-Served-Cells-Item',
        u'id-gNB-DU-Served-Cells-List',
        u'id-gNB-DU-Name',
        u'id-NRCellID',
        u'id-oldgNB-DU-UE-F1AP-ID',
        u'id-ResetType',
        u'id-ResourceCoordinationTransferContainer',
        u'id-RRCContainer',
        u'id-SCell-ToBeRemoved-Item',
        u'id-SCell-ToBeRemoved-List',
        u'id-SCell-ToBeSetup-Item',
        u'id-SCell-ToBeSetup-List',
        u'id-SCell-ToBeSetupMod-Item',
        u'id-SCell-ToBeSetupMod-List',
        u'id-Served-Cells-To-Add-Item',
        u'id-Served-Cells-To-Add-List',
        u'id-Served-Cells-To-Delete-Item',
        u'id-Served-Cells-To-Delete-List',
        u'id-Served-Cells-To-Modify-Item',
        u'id-Served-Cells-To-Modify-List',
        u'id-SpCell-ID',
        u'id-SRBID',
        u'id-SRBs-FailedToBeSetup-Item',
        u'id-SRBs-FailedToBeSetup-List',
        u'id-SRBs-FailedToBeSetupMod-Item',
        u'id-SRBs-FailedToBeSetupMod-List',
        u'id-SRBs-Required-ToBeReleased-Item',
        u'id-SRBs-Required-ToBeReleased-List',
        u'id-SRBs-ToBeReleased-Item',
        u'id-SRBs-ToBeReleased-List',
        u'id-SRBs-ToBeSetup-Item',
        u'id-SRBs-ToBeSetup-List',
        u'id-SRBs-ToBeSetupMod-Item',
        u'id-SRBs-ToBeSetupMod-List',
        u'id-TimeToWait',
        u'id-TransactionID',
        u'id-TransmissionActionIndicator',
        u'id-UE-associatedLogicalF1-ConnectionItem',
        u'id-UE-associatedLogicalF1-ConnectionListResAck',
        u'id-gNB-CU-Name',
        u'id-SCell-FailedtoSetup-List',
        u'id-SCell-FailedtoSetup-Item',
        u'id-SCell-FailedtoSetupMod-List',
        u'id-SCell-FailedtoSetupMod-Item',
        u'id-RRCReconfigurationCompleteIndicator',
        u'id-Cells-Status-Item',
        u'id-Cells-Status-List',
        u'id-Candidate-SpCell-List',
        u'id-Candidate-SpCell-Item',
        u'id-Potential-SpCell-List',
        u'id-Potential-SpCell-Item',
        u'id-FullConfiguration',
        u'id-C-RNTI',
        u'id-SpCellULConfigured',
        u'id-InactivityMonitoringRequest',
        u'id-InactivityMonitoringResponse',
        u'id-DRB-Activity-Item',
        u'id-DRB-Activity-List',
        u'id-EUTRA-NR-CellResourceCoordinationReq-Container',
        u'id-EUTRA-NR-CellResourceCoordinationReqAck-Container',
        u'id-Protected-EUTRA-Resources-List',
        u'id-RequestType',
        u'id-ServCellIndex',
        u'id-RAT-FrequencyPriorityInformation',
        u'id-ExecuteDuplication',
        u'id-NRCGI',
        u'id-PagingCell-Item',
        u'id-PagingCell-List',
        u'id-PagingDRX',
        u'id-PagingPriority',
        u'id-SItype-List',
        u'id-UEIdentityIndexValue',
        u'id-gNB-CUSystemInformation',
        u'id-HandoverPreparationInformation',
        u'id-GNB-CU-TNL-Association-To-Add-Item',
        u'id-GNB-CU-TNL-Association-To-Add-List',
        u'id-GNB-CU-TNL-Association-To-Remove-Item',
        u'id-GNB-CU-TNL-Association-To-Remove-List',
        u'id-GNB-CU-TNL-Association-To-Update-Item',
        u'id-GNB-CU-TNL-Association-To-Update-List',
        u'id-MaskedIMEISV',
        u'id-PagingIdentity',
        u'id-DUtoCURRCContainer',
        u'id-Cells-to-be-Barred-List',
        u'id-Cells-to-be-Barred-Item',
        u'id-TAISliceSupportList',
        u'id-GNB-CU-TNL-Association-Setup-List',
        u'id-GNB-CU-TNL-Association-Setup-Item',
        u'id-GNB-CU-TNL-Association-Failed-To-Setup-List',
        u'id-GNB-CU-TNL-Association-Failed-To-Setup-Item',
        u'id-DRB-Notify-Item',
        u'id-DRB-Notify-List',
        u'id-NotficationControl',
        u'id-RANAC',
        u'id-PWSSystemInformation',
        u'id-RepetitionPeriod',
        u'id-NumberofBroadcastRequest',
        u'id-Cells-To-Be-Broadcast-List',
        u'id-Cells-To-Be-Broadcast-Item',
        u'id-Cells-Broadcast-Completed-List',
        u'id-Cells-Broadcast-Completed-Item',
        u'id-Broadcast-To-Be-Cancelled-List',
        u'id-Broadcast-To-Be-Cancelled-Item',
        u'id-Cells-Broadcast-Cancelled-List',
        u'id-Cells-Broadcast-Cancelled-Item',
        u'id-NR-CGI-List-For-Restart-List',
        u'id-NR-CGI-List-For-Restart-Item',
        u'id-PWS-Failed-NR-CGI-List',
        u'id-PWS-Failed-NR-CGI-Item',
        u'id-ConfirmedUEID',
        u'id-Cancel-all-Warning-Messages-Indicator',
        u'id-GNB-DU-UE-AMBR-UL',
        u'id-DRXConfigurationIndicator',
        u'id-RLC-Status',
        u'id-DLPDCPSNLength',
        u'id-GNB-DUConfigurationQuery',
        u'id-MeasurementTimingConfiguration',
        u'id-DRB-Information',
        u'id-ServingPLMN',
        u'id-Protected-EUTRA-Resources-Item',
        u'id-GNB-CU-RRC-Version',
        u'id-GNB-DU-RRC-Version',
        u'id-GNBDUOverloadInformation',
        u'id-CellGroupConfig',
        u'id-RLCFailureIndication',
        u'id-UplinkTxDirectCurrentListInformation',
        u'id-DC-Based-Duplication-Configured',
        u'id-DC-Based-Duplication-Activation',
        u'id-SULAccessIndication',
        u'id-AvailablePLMNList',
        u'id-PDUSessionID',
        u'id-ULPDUSessionAggregateMaximumBitRate',
        u'id-ServingCellMO',
        u'id-QoSFlowMappingIndication',
        u'id-RRCDeliveryStatusRequest',
        u'id-RRCDeliveryStatus',
        u'id-BearerTypeChange',
        u'id-RLCMode',
        u'id-Duplication-Activation',
        u'id-Dedicated-SIDelivery-NeededUE-List',
        u'id-Dedicated-SIDelivery-NeededUE-Item',
        u'id-DRX-LongCycleStartOffset',
        u'id-ULPDCPSNLength',
        u'id-SelectedBandCombinationIndex',
        u'id-SelectedFeatureSetEntryIndex',
        u'id-ResourceCoordinationTransferInformation',
        u'id-ExtendedServedPLMNs-List',
        u'id-ExtendedAvailablePLMN-List',
        u'id-Associated-SCell-List',
        u'id-latest-RRC-Version-Enhanced',
        u'id-Associated-SCell-Item',
        u'id-Cell-Direction',
        u'id-SRBs-Setup-List',
        u'id-SRBs-Setup-Item',
        u'id-SRBs-SetupMod-List',
        u'id-SRBs-SetupMod-Item',
        u'id-SRBs-Modified-List',
        u'id-SRBs-Modified-Item',
        u'id-Ph-InfoSCG',
        u'id-RequestedBandCombinationIndex',
        u'id-RequestedFeatureSetEntryIndex',
        u'id-RequestedP-MaxFR2',
        u'id-DRX-Config',
        u'id-IgnoreResourceCoordinationContainer',
        u'id-UEAssistanceInformation',
        u'id-NeedforGap',
        u'id-PagingOrigin',
        u'id-new-gNB-CU-UE-F1AP-ID',
        u'id-RedirectedRRCmessage',
        u'id-new-gNB-DU-UE-F1AP-ID',
        u'id-NotificationInformation',
        u'id-PLMNAssistanceInfoForNetShar',
        u'id-UEContextNotRetrievable',
        u'id-BPLMN-ID-Info-List',
        u'id-SelectedPLMNID',
        u'id-UAC-Assistance-Info',
        u'id-RANUEID',
        u'id-GNB-DU-TNL-Association-To-Remove-Item',
        u'id-GNB-DU-TNL-Association-To-Remove-List',
        u'id-TNLAssociationTransportLayerAddressgNBDU',
        u'id-portNumber',
        u'id-AdditionalSIBMessageList',
        u'id-Cell-Type',
        u'id-IgnorePRACHConfiguration',
        u'id-CG-Config',
        u'id-PDCCH-BlindDetectionSCG',
        u'id-Requested-PDCCH-BlindDetectionSCG',
        u'id-Ph-InfoMCG',
        u'id-MeasGapSharingConfig',
        u'id-systemInformationAreaID',
        u'id-areaScope',
        u'id-RRCContainer-RRCSetupComplete',
        u'id-TraceActivation',
        u'id-TraceID',
        u'id-Neighbour-Cell-Information-List',
        u'id-SymbolAllocInSlot',
        u'id-NumDLULSymbols',
        u'id-AdditionalRRMPriorityIndex',
        u'id-DUCURadioInformationType',
        u'id-CUDURadioInformationType',
        u'id-AggressorgNBSetID',
        u'id-VictimgNBSetID',
        u'id-LowerLayerPresenceStatusChange',
        u'id-Transport-Layer-Address-Info',
        u'id-Neighbour-Cell-Information-Item',
        u'id-IntendedTDD-DL-ULConfig',
        u'id-QosMonitoringRequest',
        u'id-BHChannels-ToBeSetup-List',
        u'id-BHChannels-ToBeSetup-Item',
        u'id-BHChannels-Setup-List',
        u'id-BHChannels-Setup-Item',
        u'id-BHChannels-ToBeModified-Item',
        u'id-BHChannels-ToBeModified-List',
        u'id-BHChannels-ToBeReleased-Item',
        u'id-BHChannels-ToBeReleased-List',
        u'id-BHChannels-ToBeSetupMod-Item',
        u'id-BHChannels-ToBeSetupMod-List',
        u'id-BHChannels-FailedToBeModified-Item',
        u'id-BHChannels-FailedToBeModified-List',
        u'id-BHChannels-FailedToBeSetupMod-Item',
        u'id-BHChannels-FailedToBeSetupMod-List',
        u'id-BHChannels-Modified-Item',
        u'id-BHChannels-Modified-List',
        u'id-BHChannels-SetupMod-Item',
        u'id-BHChannels-SetupMod-List',
        u'id-BHChannels-Required-ToBeReleased-Item',
        u'id-BHChannels-Required-ToBeReleased-List',
        u'id-BHChannels-FailedToBeSetup-Item',
        u'id-BHChannels-FailedToBeSetup-List',
        u'id-BHInfo',
        u'id-BAPAddress',
        u'id-ConfiguredBAPAddress',
        u'id-BH-Routing-Information-Added-List',
        u'id-BH-Routing-Information-Added-List-Item',
        u'id-BH-Routing-Information-Removed-List',
        u'id-BH-Routing-Information-Removed-List-Item',
        u'id-UL-BH-Non-UP-Traffic-Mapping',
        u'id-Activated-Cells-to-be-Updated-List',
        u'id-Child-Nodes-List',
        u'id-IAB-Info-IAB-DU',
        u'id-IAB-Info-IAB-donor-CU',
        u'id-IAB-TNL-Addresses-To-Remove-List',
        u'id-IAB-TNL-Addresses-To-Remove-Item',
        u'id-IAB-Allocated-TNL-Address-List',
        u'id-IAB-Allocated-TNL-Address-Item',
        u'id-IABIPv6RequestType',
        u'id-IABv4AddressesRequested',
        u'id-IAB-Barred',
        u'id-TrafficMappingInformation',
        u'id-UL-UP-TNL-Information-to-Update-List',
        u'id-UL-UP-TNL-Information-to-Update-List-Item',
        u'id-UL-UP-TNL-Address-to-Update-List',
        u'id-UL-UP-TNL-Address-to-Update-List-Item',
        u'id-DL-UP-TNL-Address-to-Update-List',
        u'id-DL-UP-TNL-Address-to-Update-List-Item',
        u'id-NRV2XServicesAuthorized',
        u'id-LTEV2XServicesAuthorized',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-LTEUESidelinkAggregateMaximumBitrate',
        u'id-SIB12-message',
        u'id-SIB13-message',
        u'id-SIB14-message',
        u'id-SLDRBs-FailedToBeModified-Item',
        u'id-SLDRBs-FailedToBeModified-List',
        u'id-SLDRBs-FailedToBeSetup-Item',
        u'id-SLDRBs-FailedToBeSetup-List',
        u'id-SLDRBs-Modified-Item',
        u'id-SLDRBs-Modified-List',
        u'id-SLDRBs-Required-ToBeModified-Item',
        u'id-SLDRBs-Required-ToBeModified-List',
        u'id-SLDRBs-Required-ToBeReleased-Item',
        u'id-SLDRBs-Required-ToBeReleased-List',
        u'id-SLDRBs-Setup-Item',
        u'id-SLDRBs-Setup-List',
        u'id-SLDRBs-ToBeModified-Item',
        u'id-SLDRBs-ToBeModified-List',
        u'id-SLDRBs-ToBeReleased-Item',
        u'id-SLDRBs-ToBeReleased-List',
        u'id-SLDRBs-ToBeSetup-Item',
        u'id-SLDRBs-ToBeSetup-List',
        u'id-SLDRBs-ToBeSetupMod-Item',
        u'id-SLDRBs-ToBeSetupMod-List',
        u'id-SLDRBs-SetupMod-List',
        u'id-SLDRBs-FailedToBeSetupMod-List',
        u'id-SLDRBs-SetupMod-Item',
        u'id-SLDRBs-FailedToBeSetupMod-Item',
        u'id-SLDRBs-ModifiedConf-List',
        u'id-SLDRBs-ModifiedConf-Item',
        u'id-UEAssistanceInformationEUTRA',
        u'id-PC5LinkAMBR',
        u'id-SL-PHY-MAC-RLC-Config',
        u'id-SL-ConfigDedicatedEUTRA-Info',
        u'id-AlternativeQoSParaSetList',
        u'id-CurrentQoSParaSetIndex',
        u'id-gNBCUMeasurementID',
        u'id-gNBDUMeasurementID',
        u'id-RegistrationRequest',
        u'id-ReportCharacteristics',
        u'id-CellToReportList',
        u'id-CellMeasurementResultList',
        u'id-HardwareLoadIndicator',
        u'id-ReportingPeriodicity',
        u'id-TNLCapacityIndicator',
        u'id-CarrierList',
        u'id-ULCarrierList',
        u'id-FrequencyShift7p5khz',
        u'id-SSB-PositionsInBurst',
        u'id-NRPRACHConfig',
        u'id-RACHReportInformationList',
        u'id-RLFReportInformationList',
        u'id-TDD-UL-DLConfigCommonNR',
        u'id-CNPacketDelayBudgetDownlink',
        u'id-ExtendedPacketDelayBudget',
        u'id-TSCTrafficCharacteristics',
        u'id-ReportingRequestType',
        u'id-TimeReferenceInformation',
        u'id-CNPacketDelayBudgetUplink',
        u'id-AdditionalPDCPDuplicationTNL-List',
        u'id-RLCDuplicationInformation',
        u'id-AdditionalDuplicationIndication',
        u'id-ConditionalInterDUMobilityInformation',
        u'id-ConditionalIntraDUMobilityInformation',
        u'id-targetCellsToCancel',
        u'id-requestedTargetCellGlobalID',
        u'id-ManagementBasedMDTPLMNList',
        u'id-TraceCollectionEntityIPAddress',
        u'id-PrivacyIndicator',
        u'id-TraceCollectionEntityURI',
        u'id-mdtConfiguration',
        u'id-ServingNID',
        u'id-NPNBroadcastInformation',
        u'id-NPNSupportInfo',
        u'id-NID',
        u'id-AvailableSNPN-ID-List',
        u'id-SIB10-message',
        u'id-DLCarrierList',
        u'id-ExtendedTAISliceSupportList',
        u'id-RequestedSRSTransmissionCharacteristics',
        u'id-PosAssistance-Information',
        u'id-PosBroadcast',
        u'id-RoutingID',
        u'id-PosAssistanceInformationFailureList',
        u'id-PosMeasurementQuantities',
        u'id-PosMeasurementResultList',
        u'id-TRPInformationTypeListTRPReq',
        u'id-TRPInformationTypeItem',
        u'id-TRPInformationListTRPResp',
        u'id-TRPInformationItem',
        u'id-LMF-MeasurementID',
        u'id-SRSType',
        u'id-ActivationTime',
        u'id-AbortTransmission',
        u'id-PositioningBroadcastCells',
        u'id-SRSConfiguration',
        u'id-PosReportCharacteristics',
        u'id-PosMeasurementPeriodicity',
        u'id-TRPList',
        u'id-RAN-MeasurementID',
        u'id-LMF-UE-MeasurementID',
        u'id-RAN-UE-MeasurementID',
        u'id-E-CID-MeasurementQuantities',
        u'id-E-CID-MeasurementQuantities-Item',
        u'id-E-CID-MeasurementPeriodicity',
        u'id-E-CID-MeasurementResult',
        u'id-Cell-Portion-ID',
        u'id-SFNInitialisationTime',
        u'id-SystemFrameNumber',
        u'id-SlotNumber',
        u'id-TRP-MeasurementRequestList',
        u'id-MeasurementBeamInfoRequest',
        u'id-E-CID-ReportCharacteristics',
        u'id-ConfiguredTACIndication',
        u'id-Extended-GNB-CU-Name',
        u'id-Extended-GNB-DU-Name',
        u'id-F1CTransferPath',
        u'id-SFN-Offset',
        u'id-TransmissionStopIndicator',
        u'id-SrsFrequency',
        u'id-SCGIndicator',
        u'id-EstimatedArrivalProbability',
        u'id-TRPType',
        u'id-SRSSpatialRelationPerSRSResource',
        u'id-PDCPTerminatingNodeDLTNLAddrInfo',
        u'id-ENBDLTNLAddress',
        u'id-PosMeasurementPeriodicityExtended',
        u'id-PRS-Resource-ID',
        u'id-LocationMeasurementInformation',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-Reset >-----#
    id_Reset = INT(name=u'id-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Reset._val = 0
    
    #-----< id-F1Setup >-----#
    id_F1Setup = INT(name=u'id-F1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_F1Setup._val = 1
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name=u'id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 2
    
    #-----< id-gNBDUConfigurationUpdate >-----#
    id_gNBDUConfigurationUpdate = INT(name=u'id-gNBDUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNBDUConfigurationUpdate._val = 3
    
    #-----< id-gNBCUConfigurationUpdate >-----#
    id_gNBCUConfigurationUpdate = INT(name=u'id-gNBCUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNBCUConfigurationUpdate._val = 4
    
    #-----< id-UEContextSetup >-----#
    id_UEContextSetup = INT(name=u'id-UEContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSetup._val = 5
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name=u'id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 6
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name=u'id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 7
    
    #-----< id-UEContextModificationRequired >-----#
    id_UEContextModificationRequired = INT(name=u'id-UEContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModificationRequired._val = 8
    
    #-----< id-UEMobilityCommand >-----#
    id_UEMobilityCommand = INT(name=u'id-UEMobilityCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEMobilityCommand._val = 9
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name=u'id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 10
    
    #-----< id-InitialULRRCMessageTransfer >-----#
    id_InitialULRRCMessageTransfer = INT(name=u'id-InitialULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_InitialULRRCMessageTransfer._val = 11
    
    #-----< id-DLRRCMessageTransfer >-----#
    id_DLRRCMessageTransfer = INT(name=u'id-DLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DLRRCMessageTransfer._val = 12
    
    #-----< id-ULRRCMessageTransfer >-----#
    id_ULRRCMessageTransfer = INT(name=u'id-ULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ULRRCMessageTransfer._val = 13
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 14
    
    #-----< id-UEInactivityNotification >-----#
    id_UEInactivityNotification = INT(name=u'id-UEInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEInactivityNotification._val = 15
    
    #-----< id-GNBDUResourceCoordination >-----#
    id_GNBDUResourceCoordination = INT(name=u'id-GNBDUResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUResourceCoordination._val = 16
    
    #-----< id-SystemInformationDeliveryCommand >-----#
    id_SystemInformationDeliveryCommand = INT(name=u'id-SystemInformationDeliveryCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_SystemInformationDeliveryCommand._val = 17
    
    #-----< id-Paging >-----#
    id_Paging = INT(name=u'id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 18
    
    #-----< id-Notify >-----#
    id_Notify = INT(name=u'id-Notify', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Notify._val = 19
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name=u'id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 20
    
    #-----< id-PWSCancel >-----#
    id_PWSCancel = INT(name=u'id-PWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSCancel._val = 21
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name=u'id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 22
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name=u'id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 23
    
    #-----< id-GNBDUStatusIndication >-----#
    id_GNBDUStatusIndication = INT(name=u'id-GNBDUStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUStatusIndication._val = 24
    
    #-----< id-RRCDeliveryReport >-----#
    id_RRCDeliveryReport = INT(name=u'id-RRCDeliveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_RRCDeliveryReport._val = 25
    
    #-----< id-F1Removal >-----#
    id_F1Removal = INT(name=u'id-F1Removal', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_F1Removal._val = 26
    
    #-----< id-NetworkAccessRateReduction >-----#
    id_NetworkAccessRateReduction = INT(name=u'id-NetworkAccessRateReduction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_NetworkAccessRateReduction._val = 27
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name=u'id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 28
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name=u'id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 29
    
    #-----< id-DUCURadioInformationTransfer >-----#
    id_DUCURadioInformationTransfer = INT(name=u'id-DUCURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DUCURadioInformationTransfer._val = 30
    
    #-----< id-CUDURadioInformationTransfer >-----#
    id_CUDURadioInformationTransfer = INT(name=u'id-CUDURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_CUDURadioInformationTransfer._val = 31
    
    #-----< id-BAPMappingConfiguration >-----#
    id_BAPMappingConfiguration = INT(name=u'id-BAPMappingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BAPMappingConfiguration._val = 32
    
    #-----< id-GNBDUResourceConfiguration >-----#
    id_GNBDUResourceConfiguration = INT(name=u'id-GNBDUResourceConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUResourceConfiguration._val = 33
    
    #-----< id-IABTNLAddressAllocation >-----#
    id_IABTNLAddressAllocation = INT(name=u'id-IABTNLAddressAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_IABTNLAddressAllocation._val = 34
    
    #-----< id-IABUPConfigurationUpdate >-----#
    id_IABUPConfigurationUpdate = INT(name=u'id-IABUPConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_IABUPConfigurationUpdate._val = 35
    
    #-----< id-resourceStatusReportingInitiation >-----#
    id_resourceStatusReportingInitiation = INT(name=u'id-resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReportingInitiation._val = 36
    
    #-----< id-resourceStatusReporting >-----#
    id_resourceStatusReporting = INT(name=u'id-resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReporting._val = 37
    
    #-----< id-accessAndMobilityIndication >-----#
    id_accessAndMobilityIndication = INT(name=u'id-accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_accessAndMobilityIndication._val = 38
    
    #-----< id-accessSuccess >-----#
    id_accessSuccess = INT(name=u'id-accessSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_accessSuccess._val = 39
    
    #-----< id-cellTrafficTrace >-----#
    id_cellTrafficTrace = INT(name=u'id-cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_cellTrafficTrace._val = 40
    
    #-----< id-PositioningMeasurementExchange >-----#
    id_PositioningMeasurementExchange = INT(name=u'id-PositioningMeasurementExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementExchange._val = 41
    
    #-----< id-PositioningAssistanceInformationControl >-----#
    id_PositioningAssistanceInformationControl = INT(name=u'id-PositioningAssistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningAssistanceInformationControl._val = 42
    
    #-----< id-PositioningAssistanceInformationFeedback >-----#
    id_PositioningAssistanceInformationFeedback = INT(name=u'id-PositioningAssistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningAssistanceInformationFeedback._val = 43
    
    #-----< id-PositioningMeasurementReport >-----#
    id_PositioningMeasurementReport = INT(name=u'id-PositioningMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementReport._val = 44
    
    #-----< id-PositioningMeasurementAbort >-----#
    id_PositioningMeasurementAbort = INT(name=u'id-PositioningMeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementAbort._val = 45
    
    #-----< id-PositioningMeasurementFailureIndication >-----#
    id_PositioningMeasurementFailureIndication = INT(name=u'id-PositioningMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementFailureIndication._val = 46
    
    #-----< id-PositioningMeasurementUpdate >-----#
    id_PositioningMeasurementUpdate = INT(name=u'id-PositioningMeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementUpdate._val = 47
    
    #-----< id-TRPInformationExchange >-----#
    id_TRPInformationExchange = INT(name=u'id-TRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_TRPInformationExchange._val = 48
    
    #-----< id-PositioningInformationExchange >-----#
    id_PositioningInformationExchange = INT(name=u'id-PositioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningInformationExchange._val = 49
    
    #-----< id-PositioningActivation >-----#
    id_PositioningActivation = INT(name=u'id-PositioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningActivation._val = 50
    
    #-----< id-PositioningDeactivation >-----#
    id_PositioningDeactivation = INT(name=u'id-PositioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningDeactivation._val = 51
    
    #-----< id-E-CIDMeasurementInitiation >-----#
    id_E_CIDMeasurementInitiation = INT(name=u'id-E-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementInitiation._val = 52
    
    #-----< id-E-CIDMeasurementFailureIndication >-----#
    id_E_CIDMeasurementFailureIndication = INT(name=u'id-E-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementFailureIndication._val = 53
    
    #-----< id-E-CIDMeasurementReport >-----#
    id_E_CIDMeasurementReport = INT(name=u'id-E-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementReport._val = 54
    
    #-----< id-E-CIDMeasurementTermination >-----#
    id_E_CIDMeasurementTermination = INT(name=u'id-E-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementTermination._val = 55
    
    #-----< id-PositioningInformationUpdate >-----#
    id_PositioningInformationUpdate = INT(name=u'id-PositioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningInformationUpdate._val = 56
    
    #-----< id-ReferenceTimeInformationReport >-----#
    id_ReferenceTimeInformationReport = INT(name=u'id-ReferenceTimeInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ReferenceTimeInformationReport._val = 57
    
    #-----< id-ReferenceTimeInformationReportingControl >-----#
    id_ReferenceTimeInformationReportingControl = INT(name=u'id-ReferenceTimeInformationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ReferenceTimeInformationReportingControl._val = 58
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxNRARFCN >-----#
    maxNRARFCN = INT(name=u'maxNRARFCN', mode=MODE_VALUE)
    maxNRARFCN._val = 3279165
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name=u'maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofIndividualF1ConnectionsToReset >-----#
    maxnoofIndividualF1ConnectionsToReset = INT(name=u'maxnoofIndividualF1ConnectionsToReset', mode=MODE_VALUE)
    maxnoofIndividualF1ConnectionsToReset._val = 65536
    
    #-----< maxCellingNBDU >-----#
    maxCellingNBDU = INT(name=u'maxCellingNBDU', mode=MODE_VALUE)
    maxCellingNBDU._val = 512
    
    #-----< maxnoofSCells >-----#
    maxnoofSCells = INT(name=u'maxnoofSCells', mode=MODE_VALUE)
    maxnoofSCells._val = 32
    
    #-----< maxnoofSRBs >-----#
    maxnoofSRBs = INT(name=u'maxnoofSRBs', mode=MODE_VALUE)
    maxnoofSRBs._val = 8
    
    #-----< maxnoofDRBs >-----#
    maxnoofDRBs = INT(name=u'maxnoofDRBs', mode=MODE_VALUE)
    maxnoofDRBs._val = 64
    
    #-----< maxnoofULUPTNLInformation >-----#
    maxnoofULUPTNLInformation = INT(name=u'maxnoofULUPTNLInformation', mode=MODE_VALUE)
    maxnoofULUPTNLInformation._val = 2
    
    #-----< maxnoofDLUPTNLInformation >-----#
    maxnoofDLUPTNLInformation = INT(name=u'maxnoofDLUPTNLInformation', mode=MODE_VALUE)
    maxnoofDLUPTNLInformation._val = 2
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name=u'maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofCandidateSpCells >-----#
    maxnoofCandidateSpCells = INT(name=u'maxnoofCandidateSpCells', mode=MODE_VALUE)
    maxnoofCandidateSpCells._val = 64
    
    #-----< maxnoofPotentialSpCells >-----#
    maxnoofPotentialSpCells = INT(name=u'maxnoofPotentialSpCells', mode=MODE_VALUE)
    maxnoofPotentialSpCells._val = 64
    
    #-----< maxnoofNrCellBands >-----#
    maxnoofNrCellBands = INT(name=u'maxnoofNrCellBands', mode=MODE_VALUE)
    maxnoofNrCellBands._val = 32
    
    #-----< maxnoofSIBTypes >-----#
    maxnoofSIBTypes = INT(name=u'maxnoofSIBTypes', mode=MODE_VALUE)
    maxnoofSIBTypes._val = 32
    
    #-----< maxnoofSITypes >-----#
    maxnoofSITypes = INT(name=u'maxnoofSITypes', mode=MODE_VALUE)
    maxnoofSITypes._val = 32
    
    #-----< maxnoofPagingCells >-----#
    maxnoofPagingCells = INT(name=u'maxnoofPagingCells', mode=MODE_VALUE)
    maxnoofPagingCells._val = 512
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name=u'maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofQoSFlows >-----#
    maxnoofQoSFlows = INT(name=u'maxnoofQoSFlows', mode=MODE_VALUE)
    maxnoofQoSFlows._val = 64
    
    #-----< maxnoofSliceItems >-----#
    maxnoofSliceItems = INT(name=u'maxnoofSliceItems', mode=MODE_VALUE)
    maxnoofSliceItems._val = 1024
    
    #-----< maxCellineNB >-----#
    maxCellineNB = INT(name=u'maxCellineNB', mode=MODE_VALUE)
    maxCellineNB._val = 256
    
    #-----< maxnoofExtendedBPLMNs >-----#
    maxnoofExtendedBPLMNs = INT(name=u'maxnoofExtendedBPLMNs', mode=MODE_VALUE)
    maxnoofExtendedBPLMNs._val = 6
    
    #-----< maxnoofUEIDs >-----#
    maxnoofUEIDs = INT(name=u'maxnoofUEIDs', mode=MODE_VALUE)
    maxnoofUEIDs._val = 65536
    
    #-----< maxnoofBPLMNsNR >-----#
    maxnoofBPLMNsNR = INT(name=u'maxnoofBPLMNsNR', mode=MODE_VALUE)
    maxnoofBPLMNsNR._val = 12
    
    #-----< maxnoofUACPLMNs >-----#
    maxnoofUACPLMNs = INT(name=u'maxnoofUACPLMNs', mode=MODE_VALUE)
    maxnoofUACPLMNs._val = 12
    
    #-----< maxnoofUACperPLMN >-----#
    maxnoofUACperPLMN = INT(name=u'maxnoofUACperPLMN', mode=MODE_VALUE)
    maxnoofUACperPLMN._val = 64
    
    #-----< maxnoofAdditionalSIBs >-----#
    maxnoofAdditionalSIBs = INT(name=u'maxnoofAdditionalSIBs', mode=MODE_VALUE)
    maxnoofAdditionalSIBs._val = 63
    
    #-----< maxnoofslots >-----#
    maxnoofslots = INT(name=u'maxnoofslots', mode=MODE_VALUE)
    maxnoofslots._val = 5120
    
    #-----< maxnoofTLAs >-----#
    maxnoofTLAs = INT(name=u'maxnoofTLAs', mode=MODE_VALUE)
    maxnoofTLAs._val = 16
    
    #-----< maxnoofGTPTLAs >-----#
    maxnoofGTPTLAs = INT(name=u'maxnoofGTPTLAs', mode=MODE_VALUE)
    maxnoofGTPTLAs._val = 16
    
    #-----< maxnoofBHRLCChannels >-----#
    maxnoofBHRLCChannels = INT(name=u'maxnoofBHRLCChannels', mode=MODE_VALUE)
    maxnoofBHRLCChannels._val = 65536
    
    #-----< maxnoofRoutingEntries >-----#
    maxnoofRoutingEntries = INT(name=u'maxnoofRoutingEntries', mode=MODE_VALUE)
    maxnoofRoutingEntries._val = 1024
    
    #-----< maxnoofIABSTCInfo >-----#
    maxnoofIABSTCInfo = INT(name=u'maxnoofIABSTCInfo', mode=MODE_VALUE)
    maxnoofIABSTCInfo._val = 45
    
    #-----< maxnoofSymbols >-----#
    maxnoofSymbols = INT(name=u'maxnoofSymbols', mode=MODE_VALUE)
    maxnoofSymbols._val = 14
    
    #-----< maxnoofServingCells >-----#
    maxnoofServingCells = INT(name=u'maxnoofServingCells', mode=MODE_VALUE)
    maxnoofServingCells._val = 32
    
    #-----< maxnoofDUFSlots >-----#
    maxnoofDUFSlots = INT(name=u'maxnoofDUFSlots', mode=MODE_VALUE)
    maxnoofDUFSlots._val = 320
    
    #-----< maxnoofHSNASlots >-----#
    maxnoofHSNASlots = INT(name=u'maxnoofHSNASlots', mode=MODE_VALUE)
    maxnoofHSNASlots._val = 5120
    
    #-----< maxnoofServedCellsIAB >-----#
    maxnoofServedCellsIAB = INT(name=u'maxnoofServedCellsIAB', mode=MODE_VALUE)
    maxnoofServedCellsIAB._val = 512
    
    #-----< maxnoofChildIABNodes >-----#
    maxnoofChildIABNodes = INT(name=u'maxnoofChildIABNodes', mode=MODE_VALUE)
    maxnoofChildIABNodes._val = 1024
    
    #-----< maxnoofNonUPTrafficMappings >-----#
    maxnoofNonUPTrafficMappings = INT(name=u'maxnoofNonUPTrafficMappings', mode=MODE_VALUE)
    maxnoofNonUPTrafficMappings._val = 32
    
    #-----< maxnoofTLAsIAB >-----#
    maxnoofTLAsIAB = INT(name=u'maxnoofTLAsIAB', mode=MODE_VALUE)
    maxnoofTLAsIAB._val = 1024
    
    #-----< maxnoofMappingEntries >-----#
    maxnoofMappingEntries = INT(name=u'maxnoofMappingEntries', mode=MODE_VALUE)
    maxnoofMappingEntries._val = 67108864
    
    #-----< maxnoofDSInfo >-----#
    maxnoofDSInfo = INT(name=u'maxnoofDSInfo', mode=MODE_VALUE)
    maxnoofDSInfo._val = 64
    
    #-----< maxnoofEgressLinks >-----#
    maxnoofEgressLinks = INT(name=u'maxnoofEgressLinks', mode=MODE_VALUE)
    maxnoofEgressLinks._val = 2
    
    #-----< maxnoofULUPTNLInformationforIAB >-----#
    maxnoofULUPTNLInformationforIAB = INT(name=u'maxnoofULUPTNLInformationforIAB', mode=MODE_VALUE)
    maxnoofULUPTNLInformationforIAB._val = 32678
    
    #-----< maxnoofUPTNLAddresses >-----#
    maxnoofUPTNLAddresses = INT(name=u'maxnoofUPTNLAddresses', mode=MODE_VALUE)
    maxnoofUPTNLAddresses._val = 8
    
    #-----< maxnoofSLDRBs >-----#
    maxnoofSLDRBs = INT(name=u'maxnoofSLDRBs', mode=MODE_VALUE)
    maxnoofSLDRBs._val = 512
    
    #-----< maxnoofQoSParaSets >-----#
    maxnoofQoSParaSets = INT(name=u'maxnoofQoSParaSets', mode=MODE_VALUE)
    maxnoofQoSParaSets._val = 8
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name=u'maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnoofSSBAreas >-----#
    maxnoofSSBAreas = INT(name=u'maxnoofSSBAreas', mode=MODE_VALUE)
    maxnoofSSBAreas._val = 64
    
    #-----< maxnoofPhysicalResourceBlocks >-----#
    maxnoofPhysicalResourceBlocks = INT(name=u'maxnoofPhysicalResourceBlocks', mode=MODE_VALUE)
    maxnoofPhysicalResourceBlocks._val = 275
    
    #-----< maxnoofPhysicalResourceBlocks-1 >-----#
    maxnoofPhysicalResourceBlocks_1 = INT(name=u'maxnoofPhysicalResourceBlocks-1', mode=MODE_VALUE)
    maxnoofPhysicalResourceBlocks_1._val = 274
    
    #-----< maxnoofPRACHconfigs >-----#
    maxnoofPRACHconfigs = INT(name=u'maxnoofPRACHconfigs', mode=MODE_VALUE)
    maxnoofPRACHconfigs._val = 16
    
    #-----< maxnoofRACHReports >-----#
    maxnoofRACHReports = INT(name=u'maxnoofRACHReports', mode=MODE_VALUE)
    maxnoofRACHReports._val = 64
    
    #-----< maxnoofRLFReports >-----#
    maxnoofRLFReports = INT(name=u'maxnoofRLFReports', mode=MODE_VALUE)
    maxnoofRLFReports._val = 64
    
    #-----< maxnoofAdditionalPDCPDuplicationTNL >-----#
    maxnoofAdditionalPDCPDuplicationTNL = INT(name=u'maxnoofAdditionalPDCPDuplicationTNL', mode=MODE_VALUE)
    maxnoofAdditionalPDCPDuplicationTNL._val = 2
    
    #-----< maxnoofRLCDuplicationState >-----#
    maxnoofRLCDuplicationState = INT(name=u'maxnoofRLCDuplicationState', mode=MODE_VALUE)
    maxnoofRLCDuplicationState._val = 3
    
    #-----< maxnoofCHOcells >-----#
    maxnoofCHOcells = INT(name=u'maxnoofCHOcells', mode=MODE_VALUE)
    maxnoofCHOcells._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name=u'maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCAGsupported >-----#
    maxnoofCAGsupported = INT(name=u'maxnoofCAGsupported', mode=MODE_VALUE)
    maxnoofCAGsupported._val = 12
    
    #-----< maxnoofNIDsupported >-----#
    maxnoofNIDsupported = INT(name=u'maxnoofNIDsupported', mode=MODE_VALUE)
    maxnoofNIDsupported._val = 12
    
    #-----< maxnoofNRSCSs >-----#
    maxnoofNRSCSs = INT(name=u'maxnoofNRSCSs', mode=MODE_VALUE)
    maxnoofNRSCSs._val = 5
    
    #-----< maxnoofExtSliceItems >-----#
    maxnoofExtSliceItems = INT(name=u'maxnoofExtSliceItems', mode=MODE_VALUE)
    maxnoofExtSliceItems._val = 65535
    
    #-----< maxnoofPosMeas >-----#
    maxnoofPosMeas = INT(name=u'maxnoofPosMeas', mode=MODE_VALUE)
    maxnoofPosMeas._val = 16384
    
    #-----< maxnoofTRPInfoTypes >-----#
    maxnoofTRPInfoTypes = INT(name=u'maxnoofTRPInfoTypes', mode=MODE_VALUE)
    maxnoofTRPInfoTypes._val = 64
    
    #-----< maxnoofTRPs >-----#
    maxnoofTRPs = INT(name=u'maxnoofTRPs', mode=MODE_VALUE)
    maxnoofTRPs._val = 65535
    
    #-----< maxnoofSRSTriggerStates >-----#
    maxnoofSRSTriggerStates = INT(name=u'maxnoofSRSTriggerStates', mode=MODE_VALUE)
    maxnoofSRSTriggerStates._val = 3
    
    #-----< maxnoofSpatialRelations >-----#
    maxnoofSpatialRelations = INT(name=u'maxnoofSpatialRelations', mode=MODE_VALUE)
    maxnoofSpatialRelations._val = 64
    
    #-----< maxnoBcastCell >-----#
    maxnoBcastCell = INT(name=u'maxnoBcastCell', mode=MODE_VALUE)
    maxnoBcastCell._val = 16384
    
    #-----< maxnoofAngleInfo >-----#
    maxnoofAngleInfo = INT(name=u'maxnoofAngleInfo', mode=MODE_VALUE)
    maxnoofAngleInfo._val = 65535
    
    #-----< maxnooflcs-gcs-translation >-----#
    maxnooflcs_gcs_translation = INT(name=u'maxnooflcs-gcs-translation', mode=MODE_VALUE)
    maxnooflcs_gcs_translation._val = 3
    
    #-----< maxnoofPath >-----#
    maxnoofPath = INT(name=u'maxnoofPath', mode=MODE_VALUE)
    maxnoofPath._val = 2
    
    #-----< maxnoofMeasE-CID >-----#
    maxnoofMeasE_CID = INT(name=u'maxnoofMeasE-CID', mode=MODE_VALUE)
    maxnoofMeasE_CID._val = 64
    
    #-----< maxnoofSSBs >-----#
    maxnoofSSBs = INT(name=u'maxnoofSSBs', mode=MODE_VALUE)
    maxnoofSSBs._val = 255
    
    #-----< maxnoSRS-ResourceSets >-----#
    maxnoSRS_ResourceSets = INT(name=u'maxnoSRS-ResourceSets', mode=MODE_VALUE)
    maxnoSRS_ResourceSets._val = 16
    
    #-----< maxnoSRS-ResourcePerSet >-----#
    maxnoSRS_ResourcePerSet = INT(name=u'maxnoSRS-ResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_ResourcePerSet._val = 16
    
    #-----< maxnoSRS-Carriers >-----#
    maxnoSRS_Carriers = INT(name=u'maxnoSRS-Carriers', mode=MODE_VALUE)
    maxnoSRS_Carriers._val = 32
    
    #-----< maxnoSCSs >-----#
    maxnoSCSs = INT(name=u'maxnoSCSs', mode=MODE_VALUE)
    maxnoSCSs._val = 5
    
    #-----< maxnoSRS-Resources >-----#
    maxnoSRS_Resources = INT(name=u'maxnoSRS-Resources', mode=MODE_VALUE)
    maxnoSRS_Resources._val = 64
    
    #-----< maxnoSRS-PosResources >-----#
    maxnoSRS_PosResources = INT(name=u'maxnoSRS-PosResources', mode=MODE_VALUE)
    maxnoSRS_PosResources._val = 64
    
    #-----< maxnoSRS-PosResourceSets >-----#
    maxnoSRS_PosResourceSets = INT(name=u'maxnoSRS-PosResourceSets', mode=MODE_VALUE)
    maxnoSRS_PosResourceSets._val = 16
    
    #-----< maxnoSRS-PosResourcePerSet >-----#
    maxnoSRS_PosResourcePerSet = INT(name=u'maxnoSRS-PosResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_PosResourcePerSet._val = 16
    
    #-----< maxnoofPRS-ResourceSets >-----#
    maxnoofPRS_ResourceSets = INT(name=u'maxnoofPRS-ResourceSets', mode=MODE_VALUE)
    maxnoofPRS_ResourceSets._val = 2
    
    #-----< maxnoofPRS-ResourcesPerSet >-----#
    maxnoofPRS_ResourcesPerSet = INT(name=u'maxnoofPRS-ResourcesPerSet', mode=MODE_VALUE)
    maxnoofPRS_ResourcesPerSet._val = 64
    
    #-----< maxNoOfMeasTRPs >-----#
    maxNoOfMeasTRPs = INT(name=u'maxNoOfMeasTRPs', mode=MODE_VALUE)
    maxNoOfMeasTRPs._val = 64
    
    #-----< maxnoofPRSresourceSets >-----#
    maxnoofPRSresourceSets = INT(name=u'maxnoofPRSresourceSets', mode=MODE_VALUE)
    maxnoofPRSresourceSets._val = 8
    
    #-----< maxnoofPRSresources >-----#
    maxnoofPRSresources = INT(name=u'maxnoofPRSresources', mode=MODE_VALUE)
    maxnoofPRSresources._val = 64
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 0
    
    #-----< id-Cells-Failed-to-be-Activated-List >-----#
    id_Cells_Failed_to_be_Activated_List = INT(name=u'id-Cells-Failed-to-be-Activated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Failed_to_be_Activated_List._val = 1
    
    #-----< id-Cells-Failed-to-be-Activated-List-Item >-----#
    id_Cells_Failed_to_be_Activated_List_Item = INT(name=u'id-Cells-Failed-to-be-Activated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Failed_to_be_Activated_List_Item._val = 2
    
    #-----< id-Cells-to-be-Activated-List >-----#
    id_Cells_to_be_Activated_List = INT(name=u'id-Cells-to-be-Activated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Activated_List._val = 3
    
    #-----< id-Cells-to-be-Activated-List-Item >-----#
    id_Cells_to_be_Activated_List_Item = INT(name=u'id-Cells-to-be-Activated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Activated_List_Item._val = 4
    
    #-----< id-Cells-to-be-Deactivated-List >-----#
    id_Cells_to_be_Deactivated_List = INT(name=u'id-Cells-to-be-Deactivated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Deactivated_List._val = 5
    
    #-----< id-Cells-to-be-Deactivated-List-Item >-----#
    id_Cells_to_be_Deactivated_List_Item = INT(name=u'id-Cells-to-be-Deactivated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Deactivated_List_Item._val = 6
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 7
    
    #-----< id-CUtoDURRCInformation >-----#
    id_CUtoDURRCInformation = INT(name=u'id-CUtoDURRCInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CUtoDURRCInformation._val = 9
    
    #-----< id-DRBs-FailedToBeModified-Item >-----#
    id_DRBs_FailedToBeModified_Item = INT(name=u'id-DRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeModified_Item._val = 12
    
    #-----< id-DRBs-FailedToBeModified-List >-----#
    id_DRBs_FailedToBeModified_List = INT(name=u'id-DRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeModified_List._val = 13
    
    #-----< id-DRBs-FailedToBeSetup-Item >-----#
    id_DRBs_FailedToBeSetup_Item = INT(name=u'id-DRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetup_Item._val = 14
    
    #-----< id-DRBs-FailedToBeSetup-List >-----#
    id_DRBs_FailedToBeSetup_List = INT(name=u'id-DRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetup_List._val = 15
    
    #-----< id-DRBs-FailedToBeSetupMod-Item >-----#
    id_DRBs_FailedToBeSetupMod_Item = INT(name=u'id-DRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetupMod_Item._val = 16
    
    #-----< id-DRBs-FailedToBeSetupMod-List >-----#
    id_DRBs_FailedToBeSetupMod_List = INT(name=u'id-DRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetupMod_List._val = 17
    
    #-----< id-DRBs-ModifiedConf-Item >-----#
    id_DRBs_ModifiedConf_Item = INT(name=u'id-DRBs-ModifiedConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ModifiedConf_Item._val = 18
    
    #-----< id-DRBs-ModifiedConf-List >-----#
    id_DRBs_ModifiedConf_List = INT(name=u'id-DRBs-ModifiedConf-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ModifiedConf_List._val = 19
    
    #-----< id-DRBs-Modified-Item >-----#
    id_DRBs_Modified_Item = INT(name=u'id-DRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Modified_Item._val = 20
    
    #-----< id-DRBs-Modified-List >-----#
    id_DRBs_Modified_List = INT(name=u'id-DRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Modified_List._val = 21
    
    #-----< id-DRBs-Required-ToBeModified-Item >-----#
    id_DRBs_Required_ToBeModified_Item = INT(name=u'id-DRBs-Required-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeModified_Item._val = 22
    
    #-----< id-DRBs-Required-ToBeModified-List >-----#
    id_DRBs_Required_ToBeModified_List = INT(name=u'id-DRBs-Required-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeModified_List._val = 23
    
    #-----< id-DRBs-Required-ToBeReleased-Item >-----#
    id_DRBs_Required_ToBeReleased_Item = INT(name=u'id-DRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeReleased_Item._val = 24
    
    #-----< id-DRBs-Required-ToBeReleased-List >-----#
    id_DRBs_Required_ToBeReleased_List = INT(name=u'id-DRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeReleased_List._val = 25
    
    #-----< id-DRBs-Setup-Item >-----#
    id_DRBs_Setup_Item = INT(name=u'id-DRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Setup_Item._val = 26
    
    #-----< id-DRBs-Setup-List >-----#
    id_DRBs_Setup_List = INT(name=u'id-DRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Setup_List._val = 27
    
    #-----< id-DRBs-SetupMod-Item >-----#
    id_DRBs_SetupMod_Item = INT(name=u'id-DRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_SetupMod_Item._val = 28
    
    #-----< id-DRBs-SetupMod-List >-----#
    id_DRBs_SetupMod_List = INT(name=u'id-DRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_SetupMod_List._val = 29
    
    #-----< id-DRBs-ToBeModified-Item >-----#
    id_DRBs_ToBeModified_Item = INT(name=u'id-DRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeModified_Item._val = 30
    
    #-----< id-DRBs-ToBeModified-List >-----#
    id_DRBs_ToBeModified_List = INT(name=u'id-DRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeModified_List._val = 31
    
    #-----< id-DRBs-ToBeReleased-Item >-----#
    id_DRBs_ToBeReleased_Item = INT(name=u'id-DRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeReleased_Item._val = 32
    
    #-----< id-DRBs-ToBeReleased-List >-----#
    id_DRBs_ToBeReleased_List = INT(name=u'id-DRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeReleased_List._val = 33
    
    #-----< id-DRBs-ToBeSetup-Item >-----#
    id_DRBs_ToBeSetup_Item = INT(name=u'id-DRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetup_Item._val = 34
    
    #-----< id-DRBs-ToBeSetup-List >-----#
    id_DRBs_ToBeSetup_List = INT(name=u'id-DRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetup_List._val = 35
    
    #-----< id-DRBs-ToBeSetupMod-Item >-----#
    id_DRBs_ToBeSetupMod_Item = INT(name=u'id-DRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetupMod_Item._val = 36
    
    #-----< id-DRBs-ToBeSetupMod-List >-----#
    id_DRBs_ToBeSetupMod_List = INT(name=u'id-DRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetupMod_List._val = 37
    
    #-----< id-DRXCycle >-----#
    id_DRXCycle = INT(name=u'id-DRXCycle', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRXCycle._val = 38
    
    #-----< id-DUtoCURRCInformation >-----#
    id_DUtoCURRCInformation = INT(name=u'id-DUtoCURRCInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUtoCURRCInformation._val = 39
    
    #-----< id-gNB-CU-UE-F1AP-ID >-----#
    id_gNB_CU_UE_F1AP_ID = INT(name=u'id-gNB-CU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UE_F1AP_ID._val = 40
    
    #-----< id-gNB-DU-UE-F1AP-ID >-----#
    id_gNB_DU_UE_F1AP_ID = INT(name=u'id-gNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_UE_F1AP_ID._val = 41
    
    #-----< id-gNB-DU-ID >-----#
    id_gNB_DU_ID = INT(name=u'id-gNB-DU-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_ID._val = 42
    
    #-----< id-GNB-DU-Served-Cells-Item >-----#
    id_GNB_DU_Served_Cells_Item = INT(name=u'id-GNB-DU-Served-Cells-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_Served_Cells_Item._val = 43
    
    #-----< id-gNB-DU-Served-Cells-List >-----#
    id_gNB_DU_Served_Cells_List = INT(name=u'id-gNB-DU-Served-Cells-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_Served_Cells_List._val = 44
    
    #-----< id-gNB-DU-Name >-----#
    id_gNB_DU_Name = INT(name=u'id-gNB-DU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_Name._val = 45
    
    #-----< id-NRCellID >-----#
    id_NRCellID = INT(name=u'id-NRCellID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCellID._val = 46
    
    #-----< id-oldgNB-DU-UE-F1AP-ID >-----#
    id_oldgNB_DU_UE_F1AP_ID = INT(name=u'id-oldgNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_oldgNB_DU_UE_F1AP_ID._val = 47
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name=u'id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 48
    
    #-----< id-ResourceCoordinationTransferContainer >-----#
    id_ResourceCoordinationTransferContainer = INT(name=u'id-ResourceCoordinationTransferContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResourceCoordinationTransferContainer._val = 49
    
    #-----< id-RRCContainer >-----#
    id_RRCContainer = INT(name=u'id-RRCContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCContainer._val = 50
    
    #-----< id-SCell-ToBeRemoved-Item >-----#
    id_SCell_ToBeRemoved_Item = INT(name=u'id-SCell-ToBeRemoved-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeRemoved_Item._val = 51
    
    #-----< id-SCell-ToBeRemoved-List >-----#
    id_SCell_ToBeRemoved_List = INT(name=u'id-SCell-ToBeRemoved-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeRemoved_List._val = 52
    
    #-----< id-SCell-ToBeSetup-Item >-----#
    id_SCell_ToBeSetup_Item = INT(name=u'id-SCell-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetup_Item._val = 53
    
    #-----< id-SCell-ToBeSetup-List >-----#
    id_SCell_ToBeSetup_List = INT(name=u'id-SCell-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetup_List._val = 54
    
    #-----< id-SCell-ToBeSetupMod-Item >-----#
    id_SCell_ToBeSetupMod_Item = INT(name=u'id-SCell-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetupMod_Item._val = 55
    
    #-----< id-SCell-ToBeSetupMod-List >-----#
    id_SCell_ToBeSetupMod_List = INT(name=u'id-SCell-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetupMod_List._val = 56
    
    #-----< id-Served-Cells-To-Add-Item >-----#
    id_Served_Cells_To_Add_Item = INT(name=u'id-Served-Cells-To-Add-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Add_Item._val = 57
    
    #-----< id-Served-Cells-To-Add-List >-----#
    id_Served_Cells_To_Add_List = INT(name=u'id-Served-Cells-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Add_List._val = 58
    
    #-----< id-Served-Cells-To-Delete-Item >-----#
    id_Served_Cells_To_Delete_Item = INT(name=u'id-Served-Cells-To-Delete-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Delete_Item._val = 59
    
    #-----< id-Served-Cells-To-Delete-List >-----#
    id_Served_Cells_To_Delete_List = INT(name=u'id-Served-Cells-To-Delete-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Delete_List._val = 60
    
    #-----< id-Served-Cells-To-Modify-Item >-----#
    id_Served_Cells_To_Modify_Item = INT(name=u'id-Served-Cells-To-Modify-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Modify_Item._val = 61
    
    #-----< id-Served-Cells-To-Modify-List >-----#
    id_Served_Cells_To_Modify_List = INT(name=u'id-Served-Cells-To-Modify-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Modify_List._val = 62
    
    #-----< id-SpCell-ID >-----#
    id_SpCell_ID = INT(name=u'id-SpCell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpCell_ID._val = 63
    
    #-----< id-SRBID >-----#
    id_SRBID = INT(name=u'id-SRBID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBID._val = 64
    
    #-----< id-SRBs-FailedToBeSetup-Item >-----#
    id_SRBs_FailedToBeSetup_Item = INT(name=u'id-SRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetup_Item._val = 65
    
    #-----< id-SRBs-FailedToBeSetup-List >-----#
    id_SRBs_FailedToBeSetup_List = INT(name=u'id-SRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetup_List._val = 66
    
    #-----< id-SRBs-FailedToBeSetupMod-Item >-----#
    id_SRBs_FailedToBeSetupMod_Item = INT(name=u'id-SRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetupMod_Item._val = 67
    
    #-----< id-SRBs-FailedToBeSetupMod-List >-----#
    id_SRBs_FailedToBeSetupMod_List = INT(name=u'id-SRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetupMod_List._val = 68
    
    #-----< id-SRBs-Required-ToBeReleased-Item >-----#
    id_SRBs_Required_ToBeReleased_Item = INT(name=u'id-SRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Required_ToBeReleased_Item._val = 69
    
    #-----< id-SRBs-Required-ToBeReleased-List >-----#
    id_SRBs_Required_ToBeReleased_List = INT(name=u'id-SRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Required_ToBeReleased_List._val = 70
    
    #-----< id-SRBs-ToBeReleased-Item >-----#
    id_SRBs_ToBeReleased_Item = INT(name=u'id-SRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeReleased_Item._val = 71
    
    #-----< id-SRBs-ToBeReleased-List >-----#
    id_SRBs_ToBeReleased_List = INT(name=u'id-SRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeReleased_List._val = 72
    
    #-----< id-SRBs-ToBeSetup-Item >-----#
    id_SRBs_ToBeSetup_Item = INT(name=u'id-SRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetup_Item._val = 73
    
    #-----< id-SRBs-ToBeSetup-List >-----#
    id_SRBs_ToBeSetup_List = INT(name=u'id-SRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetup_List._val = 74
    
    #-----< id-SRBs-ToBeSetupMod-Item >-----#
    id_SRBs_ToBeSetupMod_Item = INT(name=u'id-SRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetupMod_Item._val = 75
    
    #-----< id-SRBs-ToBeSetupMod-List >-----#
    id_SRBs_ToBeSetupMod_List = INT(name=u'id-SRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetupMod_List._val = 76
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name=u'id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 77
    
    #-----< id-TransactionID >-----#
    id_TransactionID = INT(name=u'id-TransactionID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransactionID._val = 78
    
    #-----< id-TransmissionActionIndicator >-----#
    id_TransmissionActionIndicator = INT(name=u'id-TransmissionActionIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmissionActionIndicator._val = 79
    
    #-----< id-UE-associatedLogicalF1-ConnectionItem >-----#
    id_UE_associatedLogicalF1_ConnectionItem = INT(name=u'id-UE-associatedLogicalF1-ConnectionItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalF1_ConnectionItem._val = 80
    
    #-----< id-UE-associatedLogicalF1-ConnectionListResAck >-----#
    id_UE_associatedLogicalF1_ConnectionListResAck = INT(name=u'id-UE-associatedLogicalF1-ConnectionListResAck', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalF1_ConnectionListResAck._val = 81
    
    #-----< id-gNB-CU-Name >-----#
    id_gNB_CU_Name = INT(name=u'id-gNB-CU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_Name._val = 82
    
    #-----< id-SCell-FailedtoSetup-List >-----#
    id_SCell_FailedtoSetup_List = INT(name=u'id-SCell-FailedtoSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetup_List._val = 83
    
    #-----< id-SCell-FailedtoSetup-Item >-----#
    id_SCell_FailedtoSetup_Item = INT(name=u'id-SCell-FailedtoSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetup_Item._val = 84
    
    #-----< id-SCell-FailedtoSetupMod-List >-----#
    id_SCell_FailedtoSetupMod_List = INT(name=u'id-SCell-FailedtoSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetupMod_List._val = 85
    
    #-----< id-SCell-FailedtoSetupMod-Item >-----#
    id_SCell_FailedtoSetupMod_Item = INT(name=u'id-SCell-FailedtoSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetupMod_Item._val = 86
    
    #-----< id-RRCReconfigurationCompleteIndicator >-----#
    id_RRCReconfigurationCompleteIndicator = INT(name=u'id-RRCReconfigurationCompleteIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCReconfigurationCompleteIndicator._val = 87
    
    #-----< id-Cells-Status-Item >-----#
    id_Cells_Status_Item = INT(name=u'id-Cells-Status-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Status_Item._val = 88
    
    #-----< id-Cells-Status-List >-----#
    id_Cells_Status_List = INT(name=u'id-Cells-Status-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Status_List._val = 89
    
    #-----< id-Candidate-SpCell-List >-----#
    id_Candidate_SpCell_List = INT(name=u'id-Candidate-SpCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Candidate_SpCell_List._val = 90
    
    #-----< id-Candidate-SpCell-Item >-----#
    id_Candidate_SpCell_Item = INT(name=u'id-Candidate-SpCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Candidate_SpCell_Item._val = 91
    
    #-----< id-Potential-SpCell-List >-----#
    id_Potential_SpCell_List = INT(name=u'id-Potential-SpCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Potential_SpCell_List._val = 92
    
    #-----< id-Potential-SpCell-Item >-----#
    id_Potential_SpCell_Item = INT(name=u'id-Potential-SpCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Potential_SpCell_Item._val = 93
    
    #-----< id-FullConfiguration >-----#
    id_FullConfiguration = INT(name=u'id-FullConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FullConfiguration._val = 94
    
    #-----< id-C-RNTI >-----#
    id_C_RNTI = INT(name=u'id-C-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_C_RNTI._val = 95
    
    #-----< id-SpCellULConfigured >-----#
    id_SpCellULConfigured = INT(name=u'id-SpCellULConfigured', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpCellULConfigured._val = 96
    
    #-----< id-InactivityMonitoringRequest >-----#
    id_InactivityMonitoringRequest = INT(name=u'id-InactivityMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InactivityMonitoringRequest._val = 97
    
    #-----< id-InactivityMonitoringResponse >-----#
    id_InactivityMonitoringResponse = INT(name=u'id-InactivityMonitoringResponse', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InactivityMonitoringResponse._val = 98
    
    #-----< id-DRB-Activity-Item >-----#
    id_DRB_Activity_Item = INT(name=u'id-DRB-Activity-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Activity_Item._val = 99
    
    #-----< id-DRB-Activity-List >-----#
    id_DRB_Activity_List = INT(name=u'id-DRB-Activity-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Activity_List._val = 100
    
    #-----< id-EUTRA-NR-CellResourceCoordinationReq-Container >-----#
    id_EUTRA_NR_CellResourceCoordinationReq_Container = INT(name=u'id-EUTRA-NR-CellResourceCoordinationReq-Container', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_NR_CellResourceCoordinationReq_Container._val = 101
    
    #-----< id-EUTRA-NR-CellResourceCoordinationReqAck-Container >-----#
    id_EUTRA_NR_CellResourceCoordinationReqAck_Container = INT(name=u'id-EUTRA-NR-CellResourceCoordinationReqAck-Container', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_NR_CellResourceCoordinationReqAck_Container._val = 102
    
    #-----< id-Protected-EUTRA-Resources-List >-----#
    id_Protected_EUTRA_Resources_List = INT(name=u'id-Protected-EUTRA-Resources-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Protected_EUTRA_Resources_List._val = 105
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name=u'id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 106
    
    #-----< id-ServCellIndex >-----#
    id_ServCellIndex = INT(name=u'id-ServCellIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServCellIndex._val = 107
    
    #-----< id-RAT-FrequencyPriorityInformation >-----#
    id_RAT_FrequencyPriorityInformation = INT(name=u'id-RAT-FrequencyPriorityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_FrequencyPriorityInformation._val = 108
    
    #-----< id-ExecuteDuplication >-----#
    id_ExecuteDuplication = INT(name=u'id-ExecuteDuplication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExecuteDuplication._val = 109
    
    #-----< id-NRCGI >-----#
    id_NRCGI = INT(name=u'id-NRCGI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCGI._val = 111
    
    #-----< id-PagingCell-Item >-----#
    id_PagingCell_Item = INT(name=u'id-PagingCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCell_Item._val = 112
    
    #-----< id-PagingCell-List >-----#
    id_PagingCell_List = INT(name=u'id-PagingCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCell_List._val = 113
    
    #-----< id-PagingDRX >-----#
    id_PagingDRX = INT(name=u'id-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingDRX._val = 114
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name=u'id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 115
    
    #-----< id-SItype-List >-----#
    id_SItype_List = INT(name=u'id-SItype-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SItype_List._val = 116
    
    #-----< id-UEIdentityIndexValue >-----#
    id_UEIdentityIndexValue = INT(name=u'id-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentityIndexValue._val = 117
    
    #-----< id-gNB-CUSystemInformation >-----#
    id_gNB_CUSystemInformation = INT(name=u'id-gNB-CUSystemInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CUSystemInformation._val = 118
    
    #-----< id-HandoverPreparationInformation >-----#
    id_HandoverPreparationInformation = INT(name=u'id-HandoverPreparationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverPreparationInformation._val = 119
    
    #-----< id-GNB-CU-TNL-Association-To-Add-Item >-----#
    id_GNB_CU_TNL_Association_To_Add_Item = INT(name=u'id-GNB-CU-TNL-Association-To-Add-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Add_Item._val = 120
    
    #-----< id-GNB-CU-TNL-Association-To-Add-List >-----#
    id_GNB_CU_TNL_Association_To_Add_List = INT(name=u'id-GNB-CU-TNL-Association-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Add_List._val = 121
    
    #-----< id-GNB-CU-TNL-Association-To-Remove-Item >-----#
    id_GNB_CU_TNL_Association_To_Remove_Item = INT(name=u'id-GNB-CU-TNL-Association-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Remove_Item._val = 122
    
    #-----< id-GNB-CU-TNL-Association-To-Remove-List >-----#
    id_GNB_CU_TNL_Association_To_Remove_List = INT(name=u'id-GNB-CU-TNL-Association-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Remove_List._val = 123
    
    #-----< id-GNB-CU-TNL-Association-To-Update-Item >-----#
    id_GNB_CU_TNL_Association_To_Update_Item = INT(name=u'id-GNB-CU-TNL-Association-To-Update-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Update_Item._val = 124
    
    #-----< id-GNB-CU-TNL-Association-To-Update-List >-----#
    id_GNB_CU_TNL_Association_To_Update_List = INT(name=u'id-GNB-CU-TNL-Association-To-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Update_List._val = 125
    
    #-----< id-MaskedIMEISV >-----#
    id_MaskedIMEISV = INT(name=u'id-MaskedIMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaskedIMEISV._val = 126
    
    #-----< id-PagingIdentity >-----#
    id_PagingIdentity = INT(name=u'id-PagingIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingIdentity._val = 127
    
    #-----< id-DUtoCURRCContainer >-----#
    id_DUtoCURRCContainer = INT(name=u'id-DUtoCURRCContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUtoCURRCContainer._val = 128
    
    #-----< id-Cells-to-be-Barred-List >-----#
    id_Cells_to_be_Barred_List = INT(name=u'id-Cells-to-be-Barred-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Barred_List._val = 129
    
    #-----< id-Cells-to-be-Barred-Item >-----#
    id_Cells_to_be_Barred_Item = INT(name=u'id-Cells-to-be-Barred-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Barred_Item._val = 130
    
    #-----< id-TAISliceSupportList >-----#
    id_TAISliceSupportList = INT(name=u'id-TAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAISliceSupportList._val = 131
    
    #-----< id-GNB-CU-TNL-Association-Setup-List >-----#
    id_GNB_CU_TNL_Association_Setup_List = INT(name=u'id-GNB-CU-TNL-Association-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Setup_List._val = 132
    
    #-----< id-GNB-CU-TNL-Association-Setup-Item >-----#
    id_GNB_CU_TNL_Association_Setup_Item = INT(name=u'id-GNB-CU-TNL-Association-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Setup_Item._val = 133
    
    #-----< id-GNB-CU-TNL-Association-Failed-To-Setup-List >-----#
    id_GNB_CU_TNL_Association_Failed_To_Setup_List = INT(name=u'id-GNB-CU-TNL-Association-Failed-To-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Failed_To_Setup_List._val = 134
    
    #-----< id-GNB-CU-TNL-Association-Failed-To-Setup-Item >-----#
    id_GNB_CU_TNL_Association_Failed_To_Setup_Item = INT(name=u'id-GNB-CU-TNL-Association-Failed-To-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Failed_To_Setup_Item._val = 135
    
    #-----< id-DRB-Notify-Item >-----#
    id_DRB_Notify_Item = INT(name=u'id-DRB-Notify-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Notify_Item._val = 136
    
    #-----< id-DRB-Notify-List >-----#
    id_DRB_Notify_List = INT(name=u'id-DRB-Notify-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Notify_List._val = 137
    
    #-----< id-NotficationControl >-----#
    id_NotficationControl = INT(name=u'id-NotficationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotficationControl._val = 138
    
    #-----< id-RANAC >-----#
    id_RANAC = INT(name=u'id-RANAC', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAC._val = 139
    
    #-----< id-PWSSystemInformation >-----#
    id_PWSSystemInformation = INT(name=u'id-PWSSystemInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSSystemInformation._val = 140
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name=u'id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 141
    
    #-----< id-NumberofBroadcastRequest >-----#
    id_NumberofBroadcastRequest = INT(name=u'id-NumberofBroadcastRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberofBroadcastRequest._val = 142
    
    #-----< id-Cells-To-Be-Broadcast-List >-----#
    id_Cells_To_Be_Broadcast_List = INT(name=u'id-Cells-To-Be-Broadcast-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_To_Be_Broadcast_List._val = 144
    
    #-----< id-Cells-To-Be-Broadcast-Item >-----#
    id_Cells_To_Be_Broadcast_Item = INT(name=u'id-Cells-To-Be-Broadcast-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_To_Be_Broadcast_Item._val = 145
    
    #-----< id-Cells-Broadcast-Completed-List >-----#
    id_Cells_Broadcast_Completed_List = INT(name=u'id-Cells-Broadcast-Completed-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Completed_List._val = 146
    
    #-----< id-Cells-Broadcast-Completed-Item >-----#
    id_Cells_Broadcast_Completed_Item = INT(name=u'id-Cells-Broadcast-Completed-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Completed_Item._val = 147
    
    #-----< id-Broadcast-To-Be-Cancelled-List >-----#
    id_Broadcast_To_Be_Cancelled_List = INT(name=u'id-Broadcast-To-Be-Cancelled-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast_To_Be_Cancelled_List._val = 148
    
    #-----< id-Broadcast-To-Be-Cancelled-Item >-----#
    id_Broadcast_To_Be_Cancelled_Item = INT(name=u'id-Broadcast-To-Be-Cancelled-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast_To_Be_Cancelled_Item._val = 149
    
    #-----< id-Cells-Broadcast-Cancelled-List >-----#
    id_Cells_Broadcast_Cancelled_List = INT(name=u'id-Cells-Broadcast-Cancelled-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Cancelled_List._val = 150
    
    #-----< id-Cells-Broadcast-Cancelled-Item >-----#
    id_Cells_Broadcast_Cancelled_Item = INT(name=u'id-Cells-Broadcast-Cancelled-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Cancelled_Item._val = 151
    
    #-----< id-NR-CGI-List-For-Restart-List >-----#
    id_NR_CGI_List_For_Restart_List = INT(name=u'id-NR-CGI-List-For-Restart-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI_List_For_Restart_List._val = 152
    
    #-----< id-NR-CGI-List-For-Restart-Item >-----#
    id_NR_CGI_List_For_Restart_Item = INT(name=u'id-NR-CGI-List-For-Restart-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI_List_For_Restart_Item._val = 153
    
    #-----< id-PWS-Failed-NR-CGI-List >-----#
    id_PWS_Failed_NR_CGI_List = INT(name=u'id-PWS-Failed-NR-CGI-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWS_Failed_NR_CGI_List._val = 154
    
    #-----< id-PWS-Failed-NR-CGI-Item >-----#
    id_PWS_Failed_NR_CGI_Item = INT(name=u'id-PWS-Failed-NR-CGI-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWS_Failed_NR_CGI_Item._val = 155
    
    #-----< id-ConfirmedUEID >-----#
    id_ConfirmedUEID = INT(name=u'id-ConfirmedUEID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfirmedUEID._val = 156
    
    #-----< id-Cancel-all-Warning-Messages-Indicator >-----#
    id_Cancel_all_Warning_Messages_Indicator = INT(name=u'id-Cancel-all-Warning-Messages-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cancel_all_Warning_Messages_Indicator._val = 157
    
    #-----< id-GNB-DU-UE-AMBR-UL >-----#
    id_GNB_DU_UE_AMBR_UL = INT(name=u'id-GNB-DU-UE-AMBR-UL', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_UE_AMBR_UL._val = 158
    
    #-----< id-DRXConfigurationIndicator >-----#
    id_DRXConfigurationIndicator = INT(name=u'id-DRXConfigurationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRXConfigurationIndicator._val = 159
    
    #-----< id-RLC-Status >-----#
    id_RLC_Status = INT(name=u'id-RLC-Status', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLC_Status._val = 160
    
    #-----< id-DLPDCPSNLength >-----#
    id_DLPDCPSNLength = INT(name=u'id-DLPDCPSNLength', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLPDCPSNLength._val = 161
    
    #-----< id-GNB-DUConfigurationQuery >-----#
    id_GNB_DUConfigurationQuery = INT(name=u'id-GNB-DUConfigurationQuery', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DUConfigurationQuery._val = 162
    
    #-----< id-MeasurementTimingConfiguration >-----#
    id_MeasurementTimingConfiguration = INT(name=u'id-MeasurementTimingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementTimingConfiguration._val = 163
    
    #-----< id-DRB-Information >-----#
    id_DRB_Information = INT(name=u'id-DRB-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Information._val = 164
    
    #-----< id-ServingPLMN >-----#
    id_ServingPLMN = INT(name=u'id-ServingPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingPLMN._val = 165
    
    #-----< id-Protected-EUTRA-Resources-Item >-----#
    id_Protected_EUTRA_Resources_Item = INT(name=u'id-Protected-EUTRA-Resources-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Protected_EUTRA_Resources_Item._val = 168
    
    #-----< id-GNB-CU-RRC-Version >-----#
    id_GNB_CU_RRC_Version = INT(name=u'id-GNB-CU-RRC-Version', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_RRC_Version._val = 170
    
    #-----< id-GNB-DU-RRC-Version >-----#
    id_GNB_DU_RRC_Version = INT(name=u'id-GNB-DU-RRC-Version', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_RRC_Version._val = 171
    
    #-----< id-GNBDUOverloadInformation >-----#
    id_GNBDUOverloadInformation = INT(name=u'id-GNBDUOverloadInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNBDUOverloadInformation._val = 172
    
    #-----< id-CellGroupConfig >-----#
    id_CellGroupConfig = INT(name=u'id-CellGroupConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellGroupConfig._val = 173
    
    #-----< id-RLCFailureIndication >-----#
    id_RLCFailureIndication = INT(name=u'id-RLCFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCFailureIndication._val = 174
    
    #-----< id-UplinkTxDirectCurrentListInformation >-----#
    id_UplinkTxDirectCurrentListInformation = INT(name=u'id-UplinkTxDirectCurrentListInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkTxDirectCurrentListInformation._val = 175
    
    #-----< id-DC-Based-Duplication-Configured >-----#
    id_DC_Based_Duplication_Configured = INT(name=u'id-DC-Based-Duplication-Configured', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DC_Based_Duplication_Configured._val = 176
    
    #-----< id-DC-Based-Duplication-Activation >-----#
    id_DC_Based_Duplication_Activation = INT(name=u'id-DC-Based-Duplication-Activation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DC_Based_Duplication_Activation._val = 177
    
    #-----< id-SULAccessIndication >-----#
    id_SULAccessIndication = INT(name=u'id-SULAccessIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SULAccessIndication._val = 178
    
    #-----< id-AvailablePLMNList >-----#
    id_AvailablePLMNList = INT(name=u'id-AvailablePLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AvailablePLMNList._val = 179
    
    #-----< id-PDUSessionID >-----#
    id_PDUSessionID = INT(name=u'id-PDUSessionID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionID._val = 180
    
    #-----< id-ULPDUSessionAggregateMaximumBitRate >-----#
    id_ULPDUSessionAggregateMaximumBitRate = INT(name=u'id-ULPDUSessionAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULPDUSessionAggregateMaximumBitRate._val = 181
    
    #-----< id-ServingCellMO >-----#
    id_ServingCellMO = INT(name=u'id-ServingCellMO', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingCellMO._val = 182
    
    #-----< id-QoSFlowMappingIndication >-----#
    id_QoSFlowMappingIndication = INT(name=u'id-QoSFlowMappingIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSFlowMappingIndication._val = 183
    
    #-----< id-RRCDeliveryStatusRequest >-----#
    id_RRCDeliveryStatusRequest = INT(name=u'id-RRCDeliveryStatusRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCDeliveryStatusRequest._val = 184
    
    #-----< id-RRCDeliveryStatus >-----#
    id_RRCDeliveryStatus = INT(name=u'id-RRCDeliveryStatus', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCDeliveryStatus._val = 185
    
    #-----< id-BearerTypeChange >-----#
    id_BearerTypeChange = INT(name=u'id-BearerTypeChange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerTypeChange._val = 186
    
    #-----< id-RLCMode >-----#
    id_RLCMode = INT(name=u'id-RLCMode', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCMode._val = 187
    
    #-----< id-Duplication-Activation >-----#
    id_Duplication_Activation = INT(name=u'id-Duplication-Activation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Duplication_Activation._val = 188
    
    #-----< id-Dedicated-SIDelivery-NeededUE-List >-----#
    id_Dedicated_SIDelivery_NeededUE_List = INT(name=u'id-Dedicated-SIDelivery-NeededUE-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dedicated_SIDelivery_NeededUE_List._val = 189
    
    #-----< id-Dedicated-SIDelivery-NeededUE-Item >-----#
    id_Dedicated_SIDelivery_NeededUE_Item = INT(name=u'id-Dedicated-SIDelivery-NeededUE-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dedicated_SIDelivery_NeededUE_Item._val = 190
    
    #-----< id-DRX-LongCycleStartOffset >-----#
    id_DRX_LongCycleStartOffset = INT(name=u'id-DRX-LongCycleStartOffset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRX_LongCycleStartOffset._val = 191
    
    #-----< id-ULPDCPSNLength >-----#
    id_ULPDCPSNLength = INT(name=u'id-ULPDCPSNLength', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULPDCPSNLength._val = 192
    
    #-----< id-SelectedBandCombinationIndex >-----#
    id_SelectedBandCombinationIndex = INT(name=u'id-SelectedBandCombinationIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedBandCombinationIndex._val = 193
    
    #-----< id-SelectedFeatureSetEntryIndex >-----#
    id_SelectedFeatureSetEntryIndex = INT(name=u'id-SelectedFeatureSetEntryIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedFeatureSetEntryIndex._val = 194
    
    #-----< id-ResourceCoordinationTransferInformation >-----#
    id_ResourceCoordinationTransferInformation = INT(name=u'id-ResourceCoordinationTransferInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResourceCoordinationTransferInformation._val = 195
    
    #-----< id-ExtendedServedPLMNs-List >-----#
    id_ExtendedServedPLMNs_List = INT(name=u'id-ExtendedServedPLMNs-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedServedPLMNs_List._val = 196
    
    #-----< id-ExtendedAvailablePLMN-List >-----#
    id_ExtendedAvailablePLMN_List = INT(name=u'id-ExtendedAvailablePLMN-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedAvailablePLMN_List._val = 197
    
    #-----< id-Associated-SCell-List >-----#
    id_Associated_SCell_List = INT(name=u'id-Associated-SCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Associated_SCell_List._val = 198
    
    #-----< id-latest-RRC-Version-Enhanced >-----#
    id_latest_RRC_Version_Enhanced = INT(name=u'id-latest-RRC-Version-Enhanced', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_latest_RRC_Version_Enhanced._val = 199
    
    #-----< id-Associated-SCell-Item >-----#
    id_Associated_SCell_Item = INT(name=u'id-Associated-SCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Associated_SCell_Item._val = 200
    
    #-----< id-Cell-Direction >-----#
    id_Cell_Direction = INT(name=u'id-Cell-Direction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Direction._val = 201
    
    #-----< id-SRBs-Setup-List >-----#
    id_SRBs_Setup_List = INT(name=u'id-SRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Setup_List._val = 202
    
    #-----< id-SRBs-Setup-Item >-----#
    id_SRBs_Setup_Item = INT(name=u'id-SRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Setup_Item._val = 203
    
    #-----< id-SRBs-SetupMod-List >-----#
    id_SRBs_SetupMod_List = INT(name=u'id-SRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_SetupMod_List._val = 204
    
    #-----< id-SRBs-SetupMod-Item >-----#
    id_SRBs_SetupMod_Item = INT(name=u'id-SRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_SetupMod_Item._val = 205
    
    #-----< id-SRBs-Modified-List >-----#
    id_SRBs_Modified_List = INT(name=u'id-SRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Modified_List._val = 206
    
    #-----< id-SRBs-Modified-Item >-----#
    id_SRBs_Modified_Item = INT(name=u'id-SRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Modified_Item._val = 207
    
    #-----< id-Ph-InfoSCG >-----#
    id_Ph_InfoSCG = INT(name=u'id-Ph-InfoSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ph_InfoSCG._val = 208
    
    #-----< id-RequestedBandCombinationIndex >-----#
    id_RequestedBandCombinationIndex = INT(name=u'id-RequestedBandCombinationIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedBandCombinationIndex._val = 209
    
    #-----< id-RequestedFeatureSetEntryIndex >-----#
    id_RequestedFeatureSetEntryIndex = INT(name=u'id-RequestedFeatureSetEntryIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedFeatureSetEntryIndex._val = 210
    
    #-----< id-RequestedP-MaxFR2 >-----#
    id_RequestedP_MaxFR2 = INT(name=u'id-RequestedP-MaxFR2', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedP_MaxFR2._val = 211
    
    #-----< id-DRX-Config >-----#
    id_DRX_Config = INT(name=u'id-DRX-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRX_Config._val = 212
    
    #-----< id-IgnoreResourceCoordinationContainer >-----#
    id_IgnoreResourceCoordinationContainer = INT(name=u'id-IgnoreResourceCoordinationContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IgnoreResourceCoordinationContainer._val = 213
    
    #-----< id-UEAssistanceInformation >-----#
    id_UEAssistanceInformation = INT(name=u'id-UEAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAssistanceInformation._val = 214
    
    #-----< id-NeedforGap >-----#
    id_NeedforGap = INT(name=u'id-NeedforGap', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedforGap._val = 215
    
    #-----< id-PagingOrigin >-----#
    id_PagingOrigin = INT(name=u'id-PagingOrigin', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingOrigin._val = 216
    
    #-----< id-new-gNB-CU-UE-F1AP-ID >-----#
    id_new_gNB_CU_UE_F1AP_ID = INT(name=u'id-new-gNB-CU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_new_gNB_CU_UE_F1AP_ID._val = 217
    
    #-----< id-RedirectedRRCmessage >-----#
    id_RedirectedRRCmessage = INT(name=u'id-RedirectedRRCmessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedirectedRRCmessage._val = 218
    
    #-----< id-new-gNB-DU-UE-F1AP-ID >-----#
    id_new_gNB_DU_UE_F1AP_ID = INT(name=u'id-new-gNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_new_gNB_DU_UE_F1AP_ID._val = 219
    
    #-----< id-NotificationInformation >-----#
    id_NotificationInformation = INT(name=u'id-NotificationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotificationInformation._val = 220
    
    #-----< id-PLMNAssistanceInfoForNetShar >-----#
    id_PLMNAssistanceInfoForNetShar = INT(name=u'id-PLMNAssistanceInfoForNetShar', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMNAssistanceInfoForNetShar._val = 221
    
    #-----< id-UEContextNotRetrievable >-----#
    id_UEContextNotRetrievable = INT(name=u'id-UEContextNotRetrievable', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextNotRetrievable._val = 222
    
    #-----< id-BPLMN-ID-Info-List >-----#
    id_BPLMN_ID_Info_List = INT(name=u'id-BPLMN-ID-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BPLMN_ID_Info_List._val = 223
    
    #-----< id-SelectedPLMNID >-----#
    id_SelectedPLMNID = INT(name=u'id-SelectedPLMNID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedPLMNID._val = 224
    
    #-----< id-UAC-Assistance-Info >-----#
    id_UAC_Assistance_Info = INT(name=u'id-UAC-Assistance-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UAC_Assistance_Info._val = 225
    
    #-----< id-RANUEID >-----#
    id_RANUEID = INT(name=u'id-RANUEID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANUEID._val = 226
    
    #-----< id-GNB-DU-TNL-Association-To-Remove-Item >-----#
    id_GNB_DU_TNL_Association_To_Remove_Item = INT(name=u'id-GNB-DU-TNL-Association-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_TNL_Association_To_Remove_Item._val = 227
    
    #-----< id-GNB-DU-TNL-Association-To-Remove-List >-----#
    id_GNB_DU_TNL_Association_To_Remove_List = INT(name=u'id-GNB-DU-TNL-Association-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_TNL_Association_To_Remove_List._val = 228
    
    #-----< id-TNLAssociationTransportLayerAddressgNBDU >-----#
    id_TNLAssociationTransportLayerAddressgNBDU = INT(name=u'id-TNLAssociationTransportLayerAddressgNBDU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLAssociationTransportLayerAddressgNBDU._val = 229
    
    #-----< id-portNumber >-----#
    id_portNumber = INT(name=u'id-portNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_portNumber._val = 230
    
    #-----< id-AdditionalSIBMessageList >-----#
    id_AdditionalSIBMessageList = INT(name=u'id-AdditionalSIBMessageList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalSIBMessageList._val = 231
    
    #-----< id-Cell-Type >-----#
    id_Cell_Type = INT(name=u'id-Cell-Type', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Type._val = 232
    
    #-----< id-IgnorePRACHConfiguration >-----#
    id_IgnorePRACHConfiguration = INT(name=u'id-IgnorePRACHConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IgnorePRACHConfiguration._val = 233
    
    #-----< id-CG-Config >-----#
    id_CG_Config = INT(name=u'id-CG-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_Config._val = 234
    
    #-----< id-PDCCH-BlindDetectionSCG >-----#
    id_PDCCH_BlindDetectionSCG = INT(name=u'id-PDCCH-BlindDetectionSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCCH_BlindDetectionSCG._val = 235
    
    #-----< id-Requested-PDCCH-BlindDetectionSCG >-----#
    id_Requested_PDCCH_BlindDetectionSCG = INT(name=u'id-Requested-PDCCH-BlindDetectionSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Requested_PDCCH_BlindDetectionSCG._val = 236
    
    #-----< id-Ph-InfoMCG >-----#
    id_Ph_InfoMCG = INT(name=u'id-Ph-InfoMCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ph_InfoMCG._val = 237
    
    #-----< id-MeasGapSharingConfig >-----#
    id_MeasGapSharingConfig = INT(name=u'id-MeasGapSharingConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasGapSharingConfig._val = 238
    
    #-----< id-systemInformationAreaID >-----#
    id_systemInformationAreaID = INT(name=u'id-systemInformationAreaID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_systemInformationAreaID._val = 239
    
    #-----< id-areaScope >-----#
    id_areaScope = INT(name=u'id-areaScope', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_areaScope._val = 240
    
    #-----< id-RRCContainer-RRCSetupComplete >-----#
    id_RRCContainer_RRCSetupComplete = INT(name=u'id-RRCContainer-RRCSetupComplete', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCContainer_RRCSetupComplete._val = 241
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name=u'id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 242
    
    #-----< id-TraceID >-----#
    id_TraceID = INT(name=u'id-TraceID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceID._val = 243
    
    #-----< id-Neighbour-Cell-Information-List >-----#
    id_Neighbour_Cell_Information_List = INT(name=u'id-Neighbour-Cell-Information-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbour_Cell_Information_List._val = 244
    
    #-----< id-SymbolAllocInSlot >-----#
    id_SymbolAllocInSlot = INT(name=u'id-SymbolAllocInSlot', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SymbolAllocInSlot._val = 246
    
    #-----< id-NumDLULSymbols >-----#
    id_NumDLULSymbols = INT(name=u'id-NumDLULSymbols', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumDLULSymbols._val = 247
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name=u'id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 248
    
    #-----< id-DUCURadioInformationType >-----#
    id_DUCURadioInformationType = INT(name=u'id-DUCURadioInformationType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUCURadioInformationType._val = 249
    
    #-----< id-CUDURadioInformationType >-----#
    id_CUDURadioInformationType = INT(name=u'id-CUDURadioInformationType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CUDURadioInformationType._val = 250
    
    #-----< id-AggressorgNBSetID >-----#
    id_AggressorgNBSetID = INT(name=u'id-AggressorgNBSetID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AggressorgNBSetID._val = 251
    
    #-----< id-VictimgNBSetID >-----#
    id_VictimgNBSetID = INT(name=u'id-VictimgNBSetID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VictimgNBSetID._val = 252
    
    #-----< id-LowerLayerPresenceStatusChange >-----#
    id_LowerLayerPresenceStatusChange = INT(name=u'id-LowerLayerPresenceStatusChange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LowerLayerPresenceStatusChange._val = 253
    
    #-----< id-Transport-Layer-Address-Info >-----#
    id_Transport_Layer_Address_Info = INT(name=u'id-Transport-Layer-Address-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transport_Layer_Address_Info._val = 254
    
    #-----< id-Neighbour-Cell-Information-Item >-----#
    id_Neighbour_Cell_Information_Item = INT(name=u'id-Neighbour-Cell-Information-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbour_Cell_Information_Item._val = 255
    
    #-----< id-IntendedTDD-DL-ULConfig >-----#
    id_IntendedTDD_DL_ULConfig = INT(name=u'id-IntendedTDD-DL-ULConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntendedTDD_DL_ULConfig._val = 256
    
    #-----< id-QosMonitoringRequest >-----#
    id_QosMonitoringRequest = INT(name=u'id-QosMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringRequest._val = 257
    
    #-----< id-BHChannels-ToBeSetup-List >-----#
    id_BHChannels_ToBeSetup_List = INT(name=u'id-BHChannels-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetup_List._val = 258
    
    #-----< id-BHChannels-ToBeSetup-Item >-----#
    id_BHChannels_ToBeSetup_Item = INT(name=u'id-BHChannels-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetup_Item._val = 259
    
    #-----< id-BHChannels-Setup-List >-----#
    id_BHChannels_Setup_List = INT(name=u'id-BHChannels-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Setup_List._val = 260
    
    #-----< id-BHChannels-Setup-Item >-----#
    id_BHChannels_Setup_Item = INT(name=u'id-BHChannels-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Setup_Item._val = 261
    
    #-----< id-BHChannels-ToBeModified-Item >-----#
    id_BHChannels_ToBeModified_Item = INT(name=u'id-BHChannels-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeModified_Item._val = 262
    
    #-----< id-BHChannels-ToBeModified-List >-----#
    id_BHChannels_ToBeModified_List = INT(name=u'id-BHChannels-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeModified_List._val = 263
    
    #-----< id-BHChannels-ToBeReleased-Item >-----#
    id_BHChannels_ToBeReleased_Item = INT(name=u'id-BHChannels-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeReleased_Item._val = 264
    
    #-----< id-BHChannels-ToBeReleased-List >-----#
    id_BHChannels_ToBeReleased_List = INT(name=u'id-BHChannels-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeReleased_List._val = 265
    
    #-----< id-BHChannels-ToBeSetupMod-Item >-----#
    id_BHChannels_ToBeSetupMod_Item = INT(name=u'id-BHChannels-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetupMod_Item._val = 266
    
    #-----< id-BHChannels-ToBeSetupMod-List >-----#
    id_BHChannels_ToBeSetupMod_List = INT(name=u'id-BHChannels-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetupMod_List._val = 267
    
    #-----< id-BHChannels-FailedToBeModified-Item >-----#
    id_BHChannels_FailedToBeModified_Item = INT(name=u'id-BHChannels-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeModified_Item._val = 268
    
    #-----< id-BHChannels-FailedToBeModified-List >-----#
    id_BHChannels_FailedToBeModified_List = INT(name=u'id-BHChannels-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeModified_List._val = 269
    
    #-----< id-BHChannels-FailedToBeSetupMod-Item >-----#
    id_BHChannels_FailedToBeSetupMod_Item = INT(name=u'id-BHChannels-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetupMod_Item._val = 270
    
    #-----< id-BHChannels-FailedToBeSetupMod-List >-----#
    id_BHChannels_FailedToBeSetupMod_List = INT(name=u'id-BHChannels-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetupMod_List._val = 271
    
    #-----< id-BHChannels-Modified-Item >-----#
    id_BHChannels_Modified_Item = INT(name=u'id-BHChannels-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Modified_Item._val = 272
    
    #-----< id-BHChannels-Modified-List >-----#
    id_BHChannels_Modified_List = INT(name=u'id-BHChannels-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Modified_List._val = 273
    
    #-----< id-BHChannels-SetupMod-Item >-----#
    id_BHChannels_SetupMod_Item = INT(name=u'id-BHChannels-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_SetupMod_Item._val = 274
    
    #-----< id-BHChannels-SetupMod-List >-----#
    id_BHChannels_SetupMod_List = INT(name=u'id-BHChannels-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_SetupMod_List._val = 275
    
    #-----< id-BHChannels-Required-ToBeReleased-Item >-----#
    id_BHChannels_Required_ToBeReleased_Item = INT(name=u'id-BHChannels-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Required_ToBeReleased_Item._val = 276
    
    #-----< id-BHChannels-Required-ToBeReleased-List >-----#
    id_BHChannels_Required_ToBeReleased_List = INT(name=u'id-BHChannels-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Required_ToBeReleased_List._val = 277
    
    #-----< id-BHChannels-FailedToBeSetup-Item >-----#
    id_BHChannels_FailedToBeSetup_Item = INT(name=u'id-BHChannels-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetup_Item._val = 278
    
    #-----< id-BHChannels-FailedToBeSetup-List >-----#
    id_BHChannels_FailedToBeSetup_List = INT(name=u'id-BHChannels-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetup_List._val = 279
    
    #-----< id-BHInfo >-----#
    id_BHInfo = INT(name=u'id-BHInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHInfo._val = 280
    
    #-----< id-BAPAddress >-----#
    id_BAPAddress = INT(name=u'id-BAPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAPAddress._val = 281
    
    #-----< id-ConfiguredBAPAddress >-----#
    id_ConfiguredBAPAddress = INT(name=u'id-ConfiguredBAPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredBAPAddress._val = 282
    
    #-----< id-BH-Routing-Information-Added-List >-----#
    id_BH_Routing_Information_Added_List = INT(name=u'id-BH-Routing-Information-Added-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Added_List._val = 283
    
    #-----< id-BH-Routing-Information-Added-List-Item >-----#
    id_BH_Routing_Information_Added_List_Item = INT(name=u'id-BH-Routing-Information-Added-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Added_List_Item._val = 284
    
    #-----< id-BH-Routing-Information-Removed-List >-----#
    id_BH_Routing_Information_Removed_List = INT(name=u'id-BH-Routing-Information-Removed-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Removed_List._val = 285
    
    #-----< id-BH-Routing-Information-Removed-List-Item >-----#
    id_BH_Routing_Information_Removed_List_Item = INT(name=u'id-BH-Routing-Information-Removed-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Removed_List_Item._val = 286
    
    #-----< id-UL-BH-Non-UP-Traffic-Mapping >-----#
    id_UL_BH_Non_UP_Traffic_Mapping = INT(name=u'id-UL-BH-Non-UP-Traffic-Mapping', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_BH_Non_UP_Traffic_Mapping._val = 287
    
    #-----< id-Activated-Cells-to-be-Updated-List >-----#
    id_Activated_Cells_to_be_Updated_List = INT(name=u'id-Activated-Cells-to-be-Updated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Activated_Cells_to_be_Updated_List._val = 288
    
    #-----< id-Child-Nodes-List >-----#
    id_Child_Nodes_List = INT(name=u'id-Child-Nodes-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Child_Nodes_List._val = 289
    
    #-----< id-IAB-Info-IAB-DU >-----#
    id_IAB_Info_IAB_DU = INT(name=u'id-IAB-Info-IAB-DU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Info_IAB_DU._val = 290
    
    #-----< id-IAB-Info-IAB-donor-CU >-----#
    id_IAB_Info_IAB_donor_CU = INT(name=u'id-IAB-Info-IAB-donor-CU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Info_IAB_donor_CU._val = 291
    
    #-----< id-IAB-TNL-Addresses-To-Remove-List >-----#
    id_IAB_TNL_Addresses_To_Remove_List = INT(name=u'id-IAB-TNL-Addresses-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_TNL_Addresses_To_Remove_List._val = 292
    
    #-----< id-IAB-TNL-Addresses-To-Remove-Item >-----#
    id_IAB_TNL_Addresses_To_Remove_Item = INT(name=u'id-IAB-TNL-Addresses-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_TNL_Addresses_To_Remove_Item._val = 293
    
    #-----< id-IAB-Allocated-TNL-Address-List >-----#
    id_IAB_Allocated_TNL_Address_List = INT(name=u'id-IAB-Allocated-TNL-Address-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Allocated_TNL_Address_List._val = 294
    
    #-----< id-IAB-Allocated-TNL-Address-Item >-----#
    id_IAB_Allocated_TNL_Address_Item = INT(name=u'id-IAB-Allocated-TNL-Address-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Allocated_TNL_Address_Item._val = 295
    
    #-----< id-IABIPv6RequestType >-----#
    id_IABIPv6RequestType = INT(name=u'id-IABIPv6RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABIPv6RequestType._val = 296
    
    #-----< id-IABv4AddressesRequested >-----#
    id_IABv4AddressesRequested = INT(name=u'id-IABv4AddressesRequested', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABv4AddressesRequested._val = 297
    
    #-----< id-IAB-Barred >-----#
    id_IAB_Barred = INT(name=u'id-IAB-Barred', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Barred._val = 298
    
    #-----< id-TrafficMappingInformation >-----#
    id_TrafficMappingInformation = INT(name=u'id-TrafficMappingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrafficMappingInformation._val = 299
    
    #-----< id-UL-UP-TNL-Information-to-Update-List >-----#
    id_UL_UP_TNL_Information_to_Update_List = INT(name=u'id-UL-UP-TNL-Information-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Information_to_Update_List._val = 300
    
    #-----< id-UL-UP-TNL-Information-to-Update-List-Item >-----#
    id_UL_UP_TNL_Information_to_Update_List_Item = INT(name=u'id-UL-UP-TNL-Information-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Information_to_Update_List_Item._val = 301
    
    #-----< id-UL-UP-TNL-Address-to-Update-List >-----#
    id_UL_UP_TNL_Address_to_Update_List = INT(name=u'id-UL-UP-TNL-Address-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Address_to_Update_List._val = 302
    
    #-----< id-UL-UP-TNL-Address-to-Update-List-Item >-----#
    id_UL_UP_TNL_Address_to_Update_List_Item = INT(name=u'id-UL-UP-TNL-Address-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Address_to_Update_List_Item._val = 303
    
    #-----< id-DL-UP-TNL-Address-to-Update-List >-----#
    id_DL_UP_TNL_Address_to_Update_List = INT(name=u'id-DL-UP-TNL-Address-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_UP_TNL_Address_to_Update_List._val = 304
    
    #-----< id-DL-UP-TNL-Address-to-Update-List-Item >-----#
    id_DL_UP_TNL_Address_to_Update_List_Item = INT(name=u'id-DL-UP-TNL-Address-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_UP_TNL_Address_to_Update_List_Item._val = 305
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name=u'id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 306
    
    #-----< id-LTEV2XServicesAuthorized >-----#
    id_LTEV2XServicesAuthorized = INT(name=u'id-LTEV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEV2XServicesAuthorized._val = 307
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name=u'id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 308
    
    #-----< id-LTEUESidelinkAggregateMaximumBitrate >-----#
    id_LTEUESidelinkAggregateMaximumBitrate = INT(name=u'id-LTEUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEUESidelinkAggregateMaximumBitrate._val = 309
    
    #-----< id-SIB12-message >-----#
    id_SIB12_message = INT(name=u'id-SIB12-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB12_message._val = 310
    
    #-----< id-SIB13-message >-----#
    id_SIB13_message = INT(name=u'id-SIB13-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB13_message._val = 311
    
    #-----< id-SIB14-message >-----#
    id_SIB14_message = INT(name=u'id-SIB14-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB14_message._val = 312
    
    #-----< id-SLDRBs-FailedToBeModified-Item >-----#
    id_SLDRBs_FailedToBeModified_Item = INT(name=u'id-SLDRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeModified_Item._val = 313
    
    #-----< id-SLDRBs-FailedToBeModified-List >-----#
    id_SLDRBs_FailedToBeModified_List = INT(name=u'id-SLDRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeModified_List._val = 314
    
    #-----< id-SLDRBs-FailedToBeSetup-Item >-----#
    id_SLDRBs_FailedToBeSetup_Item = INT(name=u'id-SLDRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetup_Item._val = 315
    
    #-----< id-SLDRBs-FailedToBeSetup-List >-----#
    id_SLDRBs_FailedToBeSetup_List = INT(name=u'id-SLDRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetup_List._val = 316
    
    #-----< id-SLDRBs-Modified-Item >-----#
    id_SLDRBs_Modified_Item = INT(name=u'id-SLDRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Modified_Item._val = 317
    
    #-----< id-SLDRBs-Modified-List >-----#
    id_SLDRBs_Modified_List = INT(name=u'id-SLDRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Modified_List._val = 318
    
    #-----< id-SLDRBs-Required-ToBeModified-Item >-----#
    id_SLDRBs_Required_ToBeModified_Item = INT(name=u'id-SLDRBs-Required-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeModified_Item._val = 319
    
    #-----< id-SLDRBs-Required-ToBeModified-List >-----#
    id_SLDRBs_Required_ToBeModified_List = INT(name=u'id-SLDRBs-Required-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeModified_List._val = 320
    
    #-----< id-SLDRBs-Required-ToBeReleased-Item >-----#
    id_SLDRBs_Required_ToBeReleased_Item = INT(name=u'id-SLDRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeReleased_Item._val = 321
    
    #-----< id-SLDRBs-Required-ToBeReleased-List >-----#
    id_SLDRBs_Required_ToBeReleased_List = INT(name=u'id-SLDRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeReleased_List._val = 322
    
    #-----< id-SLDRBs-Setup-Item >-----#
    id_SLDRBs_Setup_Item = INT(name=u'id-SLDRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Setup_Item._val = 323
    
    #-----< id-SLDRBs-Setup-List >-----#
    id_SLDRBs_Setup_List = INT(name=u'id-SLDRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Setup_List._val = 324
    
    #-----< id-SLDRBs-ToBeModified-Item >-----#
    id_SLDRBs_ToBeModified_Item = INT(name=u'id-SLDRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeModified_Item._val = 325
    
    #-----< id-SLDRBs-ToBeModified-List >-----#
    id_SLDRBs_ToBeModified_List = INT(name=u'id-SLDRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeModified_List._val = 326
    
    #-----< id-SLDRBs-ToBeReleased-Item >-----#
    id_SLDRBs_ToBeReleased_Item = INT(name=u'id-SLDRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeReleased_Item._val = 327
    
    #-----< id-SLDRBs-ToBeReleased-List >-----#
    id_SLDRBs_ToBeReleased_List = INT(name=u'id-SLDRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeReleased_List._val = 328
    
    #-----< id-SLDRBs-ToBeSetup-Item >-----#
    id_SLDRBs_ToBeSetup_Item = INT(name=u'id-SLDRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetup_Item._val = 329
    
    #-----< id-SLDRBs-ToBeSetup-List >-----#
    id_SLDRBs_ToBeSetup_List = INT(name=u'id-SLDRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetup_List._val = 330
    
    #-----< id-SLDRBs-ToBeSetupMod-Item >-----#
    id_SLDRBs_ToBeSetupMod_Item = INT(name=u'id-SLDRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetupMod_Item._val = 331
    
    #-----< id-SLDRBs-ToBeSetupMod-List >-----#
    id_SLDRBs_ToBeSetupMod_List = INT(name=u'id-SLDRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetupMod_List._val = 332
    
    #-----< id-SLDRBs-SetupMod-List >-----#
    id_SLDRBs_SetupMod_List = INT(name=u'id-SLDRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_SetupMod_List._val = 333
    
    #-----< id-SLDRBs-FailedToBeSetupMod-List >-----#
    id_SLDRBs_FailedToBeSetupMod_List = INT(name=u'id-SLDRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetupMod_List._val = 334
    
    #-----< id-SLDRBs-SetupMod-Item >-----#
    id_SLDRBs_SetupMod_Item = INT(name=u'id-SLDRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_SetupMod_Item._val = 335
    
    #-----< id-SLDRBs-FailedToBeSetupMod-Item >-----#
    id_SLDRBs_FailedToBeSetupMod_Item = INT(name=u'id-SLDRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetupMod_Item._val = 336
    
    #-----< id-SLDRBs-ModifiedConf-List >-----#
    id_SLDRBs_ModifiedConf_List = INT(name=u'id-SLDRBs-ModifiedConf-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ModifiedConf_List._val = 337
    
    #-----< id-SLDRBs-ModifiedConf-Item >-----#
    id_SLDRBs_ModifiedConf_Item = INT(name=u'id-SLDRBs-ModifiedConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ModifiedConf_Item._val = 338
    
    #-----< id-UEAssistanceInformationEUTRA >-----#
    id_UEAssistanceInformationEUTRA = INT(name=u'id-UEAssistanceInformationEUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAssistanceInformationEUTRA._val = 339
    
    #-----< id-PC5LinkAMBR >-----#
    id_PC5LinkAMBR = INT(name=u'id-PC5LinkAMBR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5LinkAMBR._val = 340
    
    #-----< id-SL-PHY-MAC-RLC-Config >-----#
    id_SL_PHY_MAC_RLC_Config = INT(name=u'id-SL-PHY-MAC-RLC-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SL_PHY_MAC_RLC_Config._val = 341
    
    #-----< id-SL-ConfigDedicatedEUTRA-Info >-----#
    id_SL_ConfigDedicatedEUTRA_Info = INT(name=u'id-SL-ConfigDedicatedEUTRA-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SL_ConfigDedicatedEUTRA_Info._val = 342
    
    #-----< id-AlternativeQoSParaSetList >-----#
    id_AlternativeQoSParaSetList = INT(name=u'id-AlternativeQoSParaSetList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeQoSParaSetList._val = 343
    
    #-----< id-CurrentQoSParaSetIndex >-----#
    id_CurrentQoSParaSetIndex = INT(name=u'id-CurrentQoSParaSetIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CurrentQoSParaSetIndex._val = 344
    
    #-----< id-gNBCUMeasurementID >-----#
    id_gNBCUMeasurementID = INT(name=u'id-gNBCUMeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNBCUMeasurementID._val = 345
    
    #-----< id-gNBDUMeasurementID >-----#
    id_gNBDUMeasurementID = INT(name=u'id-gNBDUMeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNBDUMeasurementID._val = 346
    
    #-----< id-RegistrationRequest >-----#
    id_RegistrationRequest = INT(name=u'id-RegistrationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RegistrationRequest._val = 347
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name=u'id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 348
    
    #-----< id-CellToReportList >-----#
    id_CellToReportList = INT(name=u'id-CellToReportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReportList._val = 349
    
    #-----< id-CellMeasurementResultList >-----#
    id_CellMeasurementResultList = INT(name=u'id-CellMeasurementResultList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResultList._val = 350
    
    #-----< id-HardwareLoadIndicator >-----#
    id_HardwareLoadIndicator = INT(name=u'id-HardwareLoadIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HardwareLoadIndicator._val = 351
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name=u'id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 352
    
    #-----< id-TNLCapacityIndicator >-----#
    id_TNLCapacityIndicator = INT(name=u'id-TNLCapacityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLCapacityIndicator._val = 353
    
    #-----< id-CarrierList >-----#
    id_CarrierList = INT(name=u'id-CarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CarrierList._val = 354
    
    #-----< id-ULCarrierList >-----#
    id_ULCarrierList = INT(name=u'id-ULCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCarrierList._val = 355
    
    #-----< id-FrequencyShift7p5khz >-----#
    id_FrequencyShift7p5khz = INT(name=u'id-FrequencyShift7p5khz', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FrequencyShift7p5khz._val = 356
    
    #-----< id-SSB-PositionsInBurst >-----#
    id_SSB_PositionsInBurst = INT(name=u'id-SSB-PositionsInBurst', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SSB_PositionsInBurst._val = 357
    
    #-----< id-NRPRACHConfig >-----#
    id_NRPRACHConfig = INT(name=u'id-NRPRACHConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPRACHConfig._val = 358
    
    #-----< id-RACHReportInformationList >-----#
    id_RACHReportInformationList = INT(name=u'id-RACHReportInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACHReportInformationList._val = 359
    
    #-----< id-RLFReportInformationList >-----#
    id_RLFReportInformationList = INT(name=u'id-RLFReportInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLFReportInformationList._val = 360
    
    #-----< id-TDD-UL-DLConfigCommonNR >-----#
    id_TDD_UL_DLConfigCommonNR = INT(name=u'id-TDD-UL-DLConfigCommonNR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_UL_DLConfigCommonNR._val = 361
    
    #-----< id-CNPacketDelayBudgetDownlink >-----#
    id_CNPacketDelayBudgetDownlink = INT(name=u'id-CNPacketDelayBudgetDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetDownlink._val = 362
    
    #-----< id-ExtendedPacketDelayBudget >-----#
    id_ExtendedPacketDelayBudget = INT(name=u'id-ExtendedPacketDelayBudget', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPacketDelayBudget._val = 363
    
    #-----< id-TSCTrafficCharacteristics >-----#
    id_TSCTrafficCharacteristics = INT(name=u'id-TSCTrafficCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSCTrafficCharacteristics._val = 364
    
    #-----< id-ReportingRequestType >-----#
    id_ReportingRequestType = INT(name=u'id-ReportingRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingRequestType._val = 365
    
    #-----< id-TimeReferenceInformation >-----#
    id_TimeReferenceInformation = INT(name=u'id-TimeReferenceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeReferenceInformation._val = 366
    
    #-----< id-CNPacketDelayBudgetUplink >-----#
    id_CNPacketDelayBudgetUplink = INT(name=u'id-CNPacketDelayBudgetUplink', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetUplink._val = 369
    
    #-----< id-AdditionalPDCPDuplicationTNL-List >-----#
    id_AdditionalPDCPDuplicationTNL_List = INT(name=u'id-AdditionalPDCPDuplicationTNL-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalPDCPDuplicationTNL_List._val = 370
    
    #-----< id-RLCDuplicationInformation >-----#
    id_RLCDuplicationInformation = INT(name=u'id-RLCDuplicationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCDuplicationInformation._val = 371
    
    #-----< id-AdditionalDuplicationIndication >-----#
    id_AdditionalDuplicationIndication = INT(name=u'id-AdditionalDuplicationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDuplicationIndication._val = 372
    
    #-----< id-ConditionalInterDUMobilityInformation >-----#
    id_ConditionalInterDUMobilityInformation = INT(name=u'id-ConditionalInterDUMobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConditionalInterDUMobilityInformation._val = 373
    
    #-----< id-ConditionalIntraDUMobilityInformation >-----#
    id_ConditionalIntraDUMobilityInformation = INT(name=u'id-ConditionalIntraDUMobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConditionalIntraDUMobilityInformation._val = 374
    
    #-----< id-targetCellsToCancel >-----#
    id_targetCellsToCancel = INT(name=u'id-targetCellsToCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_targetCellsToCancel._val = 375
    
    #-----< id-requestedTargetCellGlobalID >-----#
    id_requestedTargetCellGlobalID = INT(name=u'id-requestedTargetCellGlobalID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_requestedTargetCellGlobalID._val = 376
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name=u'id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 377
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name=u'id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 378
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name=u'id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 379
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name=u'id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 380
    
    #-----< id-mdtConfiguration >-----#
    id_mdtConfiguration = INT(name=u'id-mdtConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_mdtConfiguration._val = 381
    
    #-----< id-ServingNID >-----#
    id_ServingNID = INT(name=u'id-ServingNID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingNID._val = 382
    
    #-----< id-NPNBroadcastInformation >-----#
    id_NPNBroadcastInformation = INT(name=u'id-NPNBroadcastInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNBroadcastInformation._val = 383
    
    #-----< id-NPNSupportInfo >-----#
    id_NPNSupportInfo = INT(name=u'id-NPNSupportInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNSupportInfo._val = 384
    
    #-----< id-NID >-----#
    id_NID = INT(name=u'id-NID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NID._val = 385
    
    #-----< id-AvailableSNPN-ID-List >-----#
    id_AvailableSNPN_ID_List = INT(name=u'id-AvailableSNPN-ID-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AvailableSNPN_ID_List._val = 386
    
    #-----< id-SIB10-message >-----#
    id_SIB10_message = INT(name=u'id-SIB10-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB10_message._val = 387
    
    #-----< id-DLCarrierList >-----#
    id_DLCarrierList = INT(name=u'id-DLCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCarrierList._val = 389
    
    #-----< id-ExtendedTAISliceSupportList >-----#
    id_ExtendedTAISliceSupportList = INT(name=u'id-ExtendedTAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedTAISliceSupportList._val = 390
    
    #-----< id-RequestedSRSTransmissionCharacteristics >-----#
    id_RequestedSRSTransmissionCharacteristics = INT(name=u'id-RequestedSRSTransmissionCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSRSTransmissionCharacteristics._val = 391
    
    #-----< id-PosAssistance-Information >-----#
    id_PosAssistance_Information = INT(name=u'id-PosAssistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosAssistance_Information._val = 392
    
    #-----< id-PosBroadcast >-----#
    id_PosBroadcast = INT(name=u'id-PosBroadcast', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosBroadcast._val = 393
    
    #-----< id-RoutingID >-----#
    id_RoutingID = INT(name=u'id-RoutingID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RoutingID._val = 394
    
    #-----< id-PosAssistanceInformationFailureList >-----#
    id_PosAssistanceInformationFailureList = INT(name=u'id-PosAssistanceInformationFailureList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosAssistanceInformationFailureList._val = 395
    
    #-----< id-PosMeasurementQuantities >-----#
    id_PosMeasurementQuantities = INT(name=u'id-PosMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementQuantities._val = 396
    
    #-----< id-PosMeasurementResultList >-----#
    id_PosMeasurementResultList = INT(name=u'id-PosMeasurementResultList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementResultList._val = 397
    
    #-----< id-TRPInformationTypeListTRPReq >-----#
    id_TRPInformationTypeListTRPReq = INT(name=u'id-TRPInformationTypeListTRPReq', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeListTRPReq._val = 398
    
    #-----< id-TRPInformationTypeItem >-----#
    id_TRPInformationTypeItem = INT(name=u'id-TRPInformationTypeItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeItem._val = 399
    
    #-----< id-TRPInformationListTRPResp >-----#
    id_TRPInformationListTRPResp = INT(name=u'id-TRPInformationListTRPResp', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationListTRPResp._val = 400
    
    #-----< id-TRPInformationItem >-----#
    id_TRPInformationItem = INT(name=u'id-TRPInformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationItem._val = 401
    
    #-----< id-LMF-MeasurementID >-----#
    id_LMF_MeasurementID = INT(name=u'id-LMF-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_MeasurementID._val = 402
    
    #-----< id-SRSType >-----#
    id_SRSType = INT(name=u'id-SRSType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSType._val = 403
    
    #-----< id-ActivationTime >-----#
    id_ActivationTime = INT(name=u'id-ActivationTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationTime._val = 404
    
    #-----< id-AbortTransmission >-----#
    id_AbortTransmission = INT(name=u'id-AbortTransmission', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AbortTransmission._val = 405
    
    #-----< id-PositioningBroadcastCells >-----#
    id_PositioningBroadcastCells = INT(name=u'id-PositioningBroadcastCells', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningBroadcastCells._val = 406
    
    #-----< id-SRSConfiguration >-----#
    id_SRSConfiguration = INT(name=u'id-SRSConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSConfiguration._val = 407
    
    #-----< id-PosReportCharacteristics >-----#
    id_PosReportCharacteristics = INT(name=u'id-PosReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosReportCharacteristics._val = 408
    
    #-----< id-PosMeasurementPeriodicity >-----#
    id_PosMeasurementPeriodicity = INT(name=u'id-PosMeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementPeriodicity._val = 409
    
    #-----< id-TRPList >-----#
    id_TRPList = INT(name=u'id-TRPList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPList._val = 410
    
    #-----< id-RAN-MeasurementID >-----#
    id_RAN_MeasurementID = INT(name=u'id-RAN-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_MeasurementID._val = 411
    
    #-----< id-LMF-UE-MeasurementID >-----#
    id_LMF_UE_MeasurementID = INT(name=u'id-LMF-UE-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_UE_MeasurementID._val = 412
    
    #-----< id-RAN-UE-MeasurementID >-----#
    id_RAN_UE_MeasurementID = INT(name=u'id-RAN-UE-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_MeasurementID._val = 413
    
    #-----< id-E-CID-MeasurementQuantities >-----#
    id_E_CID_MeasurementQuantities = INT(name=u'id-E-CID-MeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementQuantities._val = 414
    
    #-----< id-E-CID-MeasurementQuantities-Item >-----#
    id_E_CID_MeasurementQuantities_Item = INT(name=u'id-E-CID-MeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementQuantities_Item._val = 415
    
    #-----< id-E-CID-MeasurementPeriodicity >-----#
    id_E_CID_MeasurementPeriodicity = INT(name=u'id-E-CID-MeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementPeriodicity._val = 416
    
    #-----< id-E-CID-MeasurementResult >-----#
    id_E_CID_MeasurementResult = INT(name=u'id-E-CID-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementResult._val = 417
    
    #-----< id-Cell-Portion-ID >-----#
    id_Cell_Portion_ID = INT(name=u'id-Cell-Portion-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Portion_ID._val = 418
    
    #-----< id-SFNInitialisationTime >-----#
    id_SFNInitialisationTime = INT(name=u'id-SFNInitialisationTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime._val = 419
    
    #-----< id-SystemFrameNumber >-----#
    id_SystemFrameNumber = INT(name=u'id-SystemFrameNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SystemFrameNumber._val = 420
    
    #-----< id-SlotNumber >-----#
    id_SlotNumber = INT(name=u'id-SlotNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SlotNumber._val = 421
    
    #-----< id-TRP-MeasurementRequestList >-----#
    id_TRP_MeasurementRequestList = INT(name=u'id-TRP-MeasurementRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementRequestList._val = 422
    
    #-----< id-MeasurementBeamInfoRequest >-----#
    id_MeasurementBeamInfoRequest = INT(name=u'id-MeasurementBeamInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementBeamInfoRequest._val = 423
    
    #-----< id-E-CID-ReportCharacteristics >-----#
    id_E_CID_ReportCharacteristics = INT(name=u'id-E-CID-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_ReportCharacteristics._val = 424
    
    #-----< id-ConfiguredTACIndication >-----#
    id_ConfiguredTACIndication = INT(name=u'id-ConfiguredTACIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredTACIndication._val = 425
    
    #-----< id-Extended-GNB-CU-Name >-----#
    id_Extended_GNB_CU_Name = INT(name=u'id-Extended-GNB-CU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_CU_Name._val = 426
    
    #-----< id-Extended-GNB-DU-Name >-----#
    id_Extended_GNB_DU_Name = INT(name=u'id-Extended-GNB-DU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_DU_Name._val = 427
    
    #-----< id-F1CTransferPath >-----#
    id_F1CTransferPath = INT(name=u'id-F1CTransferPath', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F1CTransferPath._val = 428
    
    #-----< id-SFN-Offset >-----#
    id_SFN_Offset = INT(name=u'id-SFN-Offset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFN_Offset._val = 429
    
    #-----< id-TransmissionStopIndicator >-----#
    id_TransmissionStopIndicator = INT(name=u'id-TransmissionStopIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmissionStopIndicator._val = 430
    
    #-----< id-SrsFrequency >-----#
    id_SrsFrequency = INT(name=u'id-SrsFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SrsFrequency._val = 431
    
    #-----< id-SCGIndicator >-----#
    id_SCGIndicator = INT(name=u'id-SCGIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGIndicator._val = 432
    
    #-----< id-EstimatedArrivalProbability >-----#
    id_EstimatedArrivalProbability = INT(name=u'id-EstimatedArrivalProbability', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EstimatedArrivalProbability._val = 433
    
    #-----< id-TRPType >-----#
    id_TRPType = INT(name=u'id-TRPType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPType._val = 434
    
    #-----< id-SRSSpatialRelationPerSRSResource >-----#
    id_SRSSpatialRelationPerSRSResource = INT(name=u'id-SRSSpatialRelationPerSRSResource', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelationPerSRSResource._val = 435
    
    #-----< id-PDCPTerminatingNodeDLTNLAddrInfo >-----#
    id_PDCPTerminatingNodeDLTNLAddrInfo = INT(name=u'id-PDCPTerminatingNodeDLTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCPTerminatingNodeDLTNLAddrInfo._val = 436
    
    #-----< id-ENBDLTNLAddress >-----#
    id_ENBDLTNLAddress = INT(name=u'id-ENBDLTNLAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENBDLTNLAddress._val = 437
    
    #-----< id-PosMeasurementPeriodicityExtended >-----#
    id_PosMeasurementPeriodicityExtended = INT(name=u'id-PosMeasurementPeriodicityExtended', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementPeriodicityExtended._val = 438
    
    #-----< id-PRS-Resource-ID >-----#
    id_PRS_Resource_ID = INT(name=u'id-PRS-Resource-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Resource_ID._val = 439
    
    #-----< id-LocationMeasurementInformation >-----#
    id_LocationMeasurementInformation = INT(name=u'id-LocationMeasurementInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationMeasurementInformation._val = 440
    
    _all_ = [
        id_Reset,
        id_F1Setup,
        id_ErrorIndication,
        id_gNBDUConfigurationUpdate,
        id_gNBCUConfigurationUpdate,
        id_UEContextSetup,
        id_UEContextRelease,
        id_UEContextModification,
        id_UEContextModificationRequired,
        id_UEMobilityCommand,
        id_UEContextReleaseRequest,
        id_InitialULRRCMessageTransfer,
        id_DLRRCMessageTransfer,
        id_ULRRCMessageTransfer,
        id_privateMessage,
        id_UEInactivityNotification,
        id_GNBDUResourceCoordination,
        id_SystemInformationDeliveryCommand,
        id_Paging,
        id_Notify,
        id_WriteReplaceWarning,
        id_PWSCancel,
        id_PWSRestartIndication,
        id_PWSFailureIndication,
        id_GNBDUStatusIndication,
        id_RRCDeliveryReport,
        id_F1Removal,
        id_NetworkAccessRateReduction,
        id_TraceStart,
        id_DeactivateTrace,
        id_DUCURadioInformationTransfer,
        id_CUDURadioInformationTransfer,
        id_BAPMappingConfiguration,
        id_GNBDUResourceConfiguration,
        id_IABTNLAddressAllocation,
        id_IABUPConfigurationUpdate,
        id_resourceStatusReportingInitiation,
        id_resourceStatusReporting,
        id_accessAndMobilityIndication,
        id_accessSuccess,
        id_cellTrafficTrace,
        id_PositioningMeasurementExchange,
        id_PositioningAssistanceInformationControl,
        id_PositioningAssistanceInformationFeedback,
        id_PositioningMeasurementReport,
        id_PositioningMeasurementAbort,
        id_PositioningMeasurementFailureIndication,
        id_PositioningMeasurementUpdate,
        id_TRPInformationExchange,
        id_PositioningInformationExchange,
        id_PositioningActivation,
        id_PositioningDeactivation,
        id_E_CIDMeasurementInitiation,
        id_E_CIDMeasurementFailureIndication,
        id_E_CIDMeasurementReport,
        id_E_CIDMeasurementTermination,
        id_PositioningInformationUpdate,
        id_ReferenceTimeInformationReport,
        id_ReferenceTimeInformationReportingControl,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxNRARFCN,
        maxnoofErrors,
        maxnoofIndividualF1ConnectionsToReset,
        maxCellingNBDU,
        maxnoofSCells,
        maxnoofSRBs,
        maxnoofDRBs,
        maxnoofULUPTNLInformation,
        maxnoofDLUPTNLInformation,
        maxnoofBPLMNs,
        maxnoofCandidateSpCells,
        maxnoofPotentialSpCells,
        maxnoofNrCellBands,
        maxnoofSIBTypes,
        maxnoofSITypes,
        maxnoofPagingCells,
        maxnoofTNLAssociations,
        maxnoofQoSFlows,
        maxnoofSliceItems,
        maxCellineNB,
        maxnoofExtendedBPLMNs,
        maxnoofUEIDs,
        maxnoofBPLMNsNR,
        maxnoofUACPLMNs,
        maxnoofUACperPLMN,
        maxnoofAdditionalSIBs,
        maxnoofslots,
        maxnoofTLAs,
        maxnoofGTPTLAs,
        maxnoofBHRLCChannels,
        maxnoofRoutingEntries,
        maxnoofIABSTCInfo,
        maxnoofSymbols,
        maxnoofServingCells,
        maxnoofDUFSlots,
        maxnoofHSNASlots,
        maxnoofServedCellsIAB,
        maxnoofChildIABNodes,
        maxnoofNonUPTrafficMappings,
        maxnoofTLAsIAB,
        maxnoofMappingEntries,
        maxnoofDSInfo,
        maxnoofEgressLinks,
        maxnoofULUPTNLInformationforIAB,
        maxnoofUPTNLAddresses,
        maxnoofSLDRBs,
        maxnoofQoSParaSets,
        maxnoofPC5QoSFlows,
        maxnoofSSBAreas,
        maxnoofPhysicalResourceBlocks,
        maxnoofPhysicalResourceBlocks_1,
        maxnoofPRACHconfigs,
        maxnoofRACHReports,
        maxnoofRLFReports,
        maxnoofAdditionalPDCPDuplicationTNL,
        maxnoofRLCDuplicationState,
        maxnoofCHOcells,
        maxnoofMDTPLMNs,
        maxnoofCAGsupported,
        maxnoofNIDsupported,
        maxnoofNRSCSs,
        maxnoofExtSliceItems,
        maxnoofPosMeas,
        maxnoofTRPInfoTypes,
        maxnoofTRPs,
        maxnoofSRSTriggerStates,
        maxnoofSpatialRelations,
        maxnoBcastCell,
        maxnoofAngleInfo,
        maxnooflcs_gcs_translation,
        maxnoofPath,
        maxnoofMeasE_CID,
        maxnoofSSBs,
        maxnoSRS_ResourceSets,
        maxnoSRS_ResourcePerSet,
        maxnoSRS_Carriers,
        maxnoSCSs,
        maxnoSRS_Resources,
        maxnoSRS_PosResources,
        maxnoSRS_PosResourceSets,
        maxnoSRS_PosResourcePerSet,
        maxnoofPRS_ResourceSets,
        maxnoofPRS_ResourcesPerSet,
        maxNoOfMeasTRPs,
        maxnoofPRSresourceSets,
        maxnoofPRSresources,
        id_Cause,
        id_Cells_Failed_to_be_Activated_List,
        id_Cells_Failed_to_be_Activated_List_Item,
        id_Cells_to_be_Activated_List,
        id_Cells_to_be_Activated_List_Item,
        id_Cells_to_be_Deactivated_List,
        id_Cells_to_be_Deactivated_List_Item,
        id_CriticalityDiagnostics,
        id_CUtoDURRCInformation,
        id_DRBs_FailedToBeModified_Item,
        id_DRBs_FailedToBeModified_List,
        id_DRBs_FailedToBeSetup_Item,
        id_DRBs_FailedToBeSetup_List,
        id_DRBs_FailedToBeSetupMod_Item,
        id_DRBs_FailedToBeSetupMod_List,
        id_DRBs_ModifiedConf_Item,
        id_DRBs_ModifiedConf_List,
        id_DRBs_Modified_Item,
        id_DRBs_Modified_List,
        id_DRBs_Required_ToBeModified_Item,
        id_DRBs_Required_ToBeModified_List,
        id_DRBs_Required_ToBeReleased_Item,
        id_DRBs_Required_ToBeReleased_List,
        id_DRBs_Setup_Item,
        id_DRBs_Setup_List,
        id_DRBs_SetupMod_Item,
        id_DRBs_SetupMod_List,
        id_DRBs_ToBeModified_Item,
        id_DRBs_ToBeModified_List,
        id_DRBs_ToBeReleased_Item,
        id_DRBs_ToBeReleased_List,
        id_DRBs_ToBeSetup_Item,
        id_DRBs_ToBeSetup_List,
        id_DRBs_ToBeSetupMod_Item,
        id_DRBs_ToBeSetupMod_List,
        id_DRXCycle,
        id_DUtoCURRCInformation,
        id_gNB_CU_UE_F1AP_ID,
        id_gNB_DU_UE_F1AP_ID,
        id_gNB_DU_ID,
        id_GNB_DU_Served_Cells_Item,
        id_gNB_DU_Served_Cells_List,
        id_gNB_DU_Name,
        id_NRCellID,
        id_oldgNB_DU_UE_F1AP_ID,
        id_ResetType,
        id_ResourceCoordinationTransferContainer,
        id_RRCContainer,
        id_SCell_ToBeRemoved_Item,
        id_SCell_ToBeRemoved_List,
        id_SCell_ToBeSetup_Item,
        id_SCell_ToBeSetup_List,
        id_SCell_ToBeSetupMod_Item,
        id_SCell_ToBeSetupMod_List,
        id_Served_Cells_To_Add_Item,
        id_Served_Cells_To_Add_List,
        id_Served_Cells_To_Delete_Item,
        id_Served_Cells_To_Delete_List,
        id_Served_Cells_To_Modify_Item,
        id_Served_Cells_To_Modify_List,
        id_SpCell_ID,
        id_SRBID,
        id_SRBs_FailedToBeSetup_Item,
        id_SRBs_FailedToBeSetup_List,
        id_SRBs_FailedToBeSetupMod_Item,
        id_SRBs_FailedToBeSetupMod_List,
        id_SRBs_Required_ToBeReleased_Item,
        id_SRBs_Required_ToBeReleased_List,
        id_SRBs_ToBeReleased_Item,
        id_SRBs_ToBeReleased_List,
        id_SRBs_ToBeSetup_Item,
        id_SRBs_ToBeSetup_List,
        id_SRBs_ToBeSetupMod_Item,
        id_SRBs_ToBeSetupMod_List,
        id_TimeToWait,
        id_TransactionID,
        id_TransmissionActionIndicator,
        id_UE_associatedLogicalF1_ConnectionItem,
        id_UE_associatedLogicalF1_ConnectionListResAck,
        id_gNB_CU_Name,
        id_SCell_FailedtoSetup_List,
        id_SCell_FailedtoSetup_Item,
        id_SCell_FailedtoSetupMod_List,
        id_SCell_FailedtoSetupMod_Item,
        id_RRCReconfigurationCompleteIndicator,
        id_Cells_Status_Item,
        id_Cells_Status_List,
        id_Candidate_SpCell_List,
        id_Candidate_SpCell_Item,
        id_Potential_SpCell_List,
        id_Potential_SpCell_Item,
        id_FullConfiguration,
        id_C_RNTI,
        id_SpCellULConfigured,
        id_InactivityMonitoringRequest,
        id_InactivityMonitoringResponse,
        id_DRB_Activity_Item,
        id_DRB_Activity_List,
        id_EUTRA_NR_CellResourceCoordinationReq_Container,
        id_EUTRA_NR_CellResourceCoordinationReqAck_Container,
        id_Protected_EUTRA_Resources_List,
        id_RequestType,
        id_ServCellIndex,
        id_RAT_FrequencyPriorityInformation,
        id_ExecuteDuplication,
        id_NRCGI,
        id_PagingCell_Item,
        id_PagingCell_List,
        id_PagingDRX,
        id_PagingPriority,
        id_SItype_List,
        id_UEIdentityIndexValue,
        id_gNB_CUSystemInformation,
        id_HandoverPreparationInformation,
        id_GNB_CU_TNL_Association_To_Add_Item,
        id_GNB_CU_TNL_Association_To_Add_List,
        id_GNB_CU_TNL_Association_To_Remove_Item,
        id_GNB_CU_TNL_Association_To_Remove_List,
        id_GNB_CU_TNL_Association_To_Update_Item,
        id_GNB_CU_TNL_Association_To_Update_List,
        id_MaskedIMEISV,
        id_PagingIdentity,
        id_DUtoCURRCContainer,
        id_Cells_to_be_Barred_List,
        id_Cells_to_be_Barred_Item,
        id_TAISliceSupportList,
        id_GNB_CU_TNL_Association_Setup_List,
        id_GNB_CU_TNL_Association_Setup_Item,
        id_GNB_CU_TNL_Association_Failed_To_Setup_List,
        id_GNB_CU_TNL_Association_Failed_To_Setup_Item,
        id_DRB_Notify_Item,
        id_DRB_Notify_List,
        id_NotficationControl,
        id_RANAC,
        id_PWSSystemInformation,
        id_RepetitionPeriod,
        id_NumberofBroadcastRequest,
        id_Cells_To_Be_Broadcast_List,
        id_Cells_To_Be_Broadcast_Item,
        id_Cells_Broadcast_Completed_List,
        id_Cells_Broadcast_Completed_Item,
        id_Broadcast_To_Be_Cancelled_List,
        id_Broadcast_To_Be_Cancelled_Item,
        id_Cells_Broadcast_Cancelled_List,
        id_Cells_Broadcast_Cancelled_Item,
        id_NR_CGI_List_For_Restart_List,
        id_NR_CGI_List_For_Restart_Item,
        id_PWS_Failed_NR_CGI_List,
        id_PWS_Failed_NR_CGI_Item,
        id_ConfirmedUEID,
        id_Cancel_all_Warning_Messages_Indicator,
        id_GNB_DU_UE_AMBR_UL,
        id_DRXConfigurationIndicator,
        id_RLC_Status,
        id_DLPDCPSNLength,
        id_GNB_DUConfigurationQuery,
        id_MeasurementTimingConfiguration,
        id_DRB_Information,
        id_ServingPLMN,
        id_Protected_EUTRA_Resources_Item,
        id_GNB_CU_RRC_Version,
        id_GNB_DU_RRC_Version,
        id_GNBDUOverloadInformation,
        id_CellGroupConfig,
        id_RLCFailureIndication,
        id_UplinkTxDirectCurrentListInformation,
        id_DC_Based_Duplication_Configured,
        id_DC_Based_Duplication_Activation,
        id_SULAccessIndication,
        id_AvailablePLMNList,
        id_PDUSessionID,
        id_ULPDUSessionAggregateMaximumBitRate,
        id_ServingCellMO,
        id_QoSFlowMappingIndication,
        id_RRCDeliveryStatusRequest,
        id_RRCDeliveryStatus,
        id_BearerTypeChange,
        id_RLCMode,
        id_Duplication_Activation,
        id_Dedicated_SIDelivery_NeededUE_List,
        id_Dedicated_SIDelivery_NeededUE_Item,
        id_DRX_LongCycleStartOffset,
        id_ULPDCPSNLength,
        id_SelectedBandCombinationIndex,
        id_SelectedFeatureSetEntryIndex,
        id_ResourceCoordinationTransferInformation,
        id_ExtendedServedPLMNs_List,
        id_ExtendedAvailablePLMN_List,
        id_Associated_SCell_List,
        id_latest_RRC_Version_Enhanced,
        id_Associated_SCell_Item,
        id_Cell_Direction,
        id_SRBs_Setup_List,
        id_SRBs_Setup_Item,
        id_SRBs_SetupMod_List,
        id_SRBs_SetupMod_Item,
        id_SRBs_Modified_List,
        id_SRBs_Modified_Item,
        id_Ph_InfoSCG,
        id_RequestedBandCombinationIndex,
        id_RequestedFeatureSetEntryIndex,
        id_RequestedP_MaxFR2,
        id_DRX_Config,
        id_IgnoreResourceCoordinationContainer,
        id_UEAssistanceInformation,
        id_NeedforGap,
        id_PagingOrigin,
        id_new_gNB_CU_UE_F1AP_ID,
        id_RedirectedRRCmessage,
        id_new_gNB_DU_UE_F1AP_ID,
        id_NotificationInformation,
        id_PLMNAssistanceInfoForNetShar,
        id_UEContextNotRetrievable,
        id_BPLMN_ID_Info_List,
        id_SelectedPLMNID,
        id_UAC_Assistance_Info,
        id_RANUEID,
        id_GNB_DU_TNL_Association_To_Remove_Item,
        id_GNB_DU_TNL_Association_To_Remove_List,
        id_TNLAssociationTransportLayerAddressgNBDU,
        id_portNumber,
        id_AdditionalSIBMessageList,
        id_Cell_Type,
        id_IgnorePRACHConfiguration,
        id_CG_Config,
        id_PDCCH_BlindDetectionSCG,
        id_Requested_PDCCH_BlindDetectionSCG,
        id_Ph_InfoMCG,
        id_MeasGapSharingConfig,
        id_systemInformationAreaID,
        id_areaScope,
        id_RRCContainer_RRCSetupComplete,
        id_TraceActivation,
        id_TraceID,
        id_Neighbour_Cell_Information_List,
        id_SymbolAllocInSlot,
        id_NumDLULSymbols,
        id_AdditionalRRMPriorityIndex,
        id_DUCURadioInformationType,
        id_CUDURadioInformationType,
        id_AggressorgNBSetID,
        id_VictimgNBSetID,
        id_LowerLayerPresenceStatusChange,
        id_Transport_Layer_Address_Info,
        id_Neighbour_Cell_Information_Item,
        id_IntendedTDD_DL_ULConfig,
        id_QosMonitoringRequest,
        id_BHChannels_ToBeSetup_List,
        id_BHChannels_ToBeSetup_Item,
        id_BHChannels_Setup_List,
        id_BHChannels_Setup_Item,
        id_BHChannels_ToBeModified_Item,
        id_BHChannels_ToBeModified_List,
        id_BHChannels_ToBeReleased_Item,
        id_BHChannels_ToBeReleased_List,
        id_BHChannels_ToBeSetupMod_Item,
        id_BHChannels_ToBeSetupMod_List,
        id_BHChannels_FailedToBeModified_Item,
        id_BHChannels_FailedToBeModified_List,
        id_BHChannels_FailedToBeSetupMod_Item,
        id_BHChannels_FailedToBeSetupMod_List,
        id_BHChannels_Modified_Item,
        id_BHChannels_Modified_List,
        id_BHChannels_SetupMod_Item,
        id_BHChannels_SetupMod_List,
        id_BHChannels_Required_ToBeReleased_Item,
        id_BHChannels_Required_ToBeReleased_List,
        id_BHChannels_FailedToBeSetup_Item,
        id_BHChannels_FailedToBeSetup_List,
        id_BHInfo,
        id_BAPAddress,
        id_ConfiguredBAPAddress,
        id_BH_Routing_Information_Added_List,
        id_BH_Routing_Information_Added_List_Item,
        id_BH_Routing_Information_Removed_List,
        id_BH_Routing_Information_Removed_List_Item,
        id_UL_BH_Non_UP_Traffic_Mapping,
        id_Activated_Cells_to_be_Updated_List,
        id_Child_Nodes_List,
        id_IAB_Info_IAB_DU,
        id_IAB_Info_IAB_donor_CU,
        id_IAB_TNL_Addresses_To_Remove_List,
        id_IAB_TNL_Addresses_To_Remove_Item,
        id_IAB_Allocated_TNL_Address_List,
        id_IAB_Allocated_TNL_Address_Item,
        id_IABIPv6RequestType,
        id_IABv4AddressesRequested,
        id_IAB_Barred,
        id_TrafficMappingInformation,
        id_UL_UP_TNL_Information_to_Update_List,
        id_UL_UP_TNL_Information_to_Update_List_Item,
        id_UL_UP_TNL_Address_to_Update_List,
        id_UL_UP_TNL_Address_to_Update_List_Item,
        id_DL_UP_TNL_Address_to_Update_List,
        id_DL_UP_TNL_Address_to_Update_List_Item,
        id_NRV2XServicesAuthorized,
        id_LTEV2XServicesAuthorized,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_LTEUESidelinkAggregateMaximumBitrate,
        id_SIB12_message,
        id_SIB13_message,
        id_SIB14_message,
        id_SLDRBs_FailedToBeModified_Item,
        id_SLDRBs_FailedToBeModified_List,
        id_SLDRBs_FailedToBeSetup_Item,
        id_SLDRBs_FailedToBeSetup_List,
        id_SLDRBs_Modified_Item,
        id_SLDRBs_Modified_List,
        id_SLDRBs_Required_ToBeModified_Item,
        id_SLDRBs_Required_ToBeModified_List,
        id_SLDRBs_Required_ToBeReleased_Item,
        id_SLDRBs_Required_ToBeReleased_List,
        id_SLDRBs_Setup_Item,
        id_SLDRBs_Setup_List,
        id_SLDRBs_ToBeModified_Item,
        id_SLDRBs_ToBeModified_List,
        id_SLDRBs_ToBeReleased_Item,
        id_SLDRBs_ToBeReleased_List,
        id_SLDRBs_ToBeSetup_Item,
        id_SLDRBs_ToBeSetup_List,
        id_SLDRBs_ToBeSetupMod_Item,
        id_SLDRBs_ToBeSetupMod_List,
        id_SLDRBs_SetupMod_List,
        id_SLDRBs_FailedToBeSetupMod_List,
        id_SLDRBs_SetupMod_Item,
        id_SLDRBs_FailedToBeSetupMod_Item,
        id_SLDRBs_ModifiedConf_List,
        id_SLDRBs_ModifiedConf_Item,
        id_UEAssistanceInformationEUTRA,
        id_PC5LinkAMBR,
        id_SL_PHY_MAC_RLC_Config,
        id_SL_ConfigDedicatedEUTRA_Info,
        id_AlternativeQoSParaSetList,
        id_CurrentQoSParaSetIndex,
        id_gNBCUMeasurementID,
        id_gNBDUMeasurementID,
        id_RegistrationRequest,
        id_ReportCharacteristics,
        id_CellToReportList,
        id_CellMeasurementResultList,
        id_HardwareLoadIndicator,
        id_ReportingPeriodicity,
        id_TNLCapacityIndicator,
        id_CarrierList,
        id_ULCarrierList,
        id_FrequencyShift7p5khz,
        id_SSB_PositionsInBurst,
        id_NRPRACHConfig,
        id_RACHReportInformationList,
        id_RLFReportInformationList,
        id_TDD_UL_DLConfigCommonNR,
        id_CNPacketDelayBudgetDownlink,
        id_ExtendedPacketDelayBudget,
        id_TSCTrafficCharacteristics,
        id_ReportingRequestType,
        id_TimeReferenceInformation,
        id_CNPacketDelayBudgetUplink,
        id_AdditionalPDCPDuplicationTNL_List,
        id_RLCDuplicationInformation,
        id_AdditionalDuplicationIndication,
        id_ConditionalInterDUMobilityInformation,
        id_ConditionalIntraDUMobilityInformation,
        id_targetCellsToCancel,
        id_requestedTargetCellGlobalID,
        id_ManagementBasedMDTPLMNList,
        id_TraceCollectionEntityIPAddress,
        id_PrivacyIndicator,
        id_TraceCollectionEntityURI,
        id_mdtConfiguration,
        id_ServingNID,
        id_NPNBroadcastInformation,
        id_NPNSupportInfo,
        id_NID,
        id_AvailableSNPN_ID_List,
        id_SIB10_message,
        id_DLCarrierList,
        id_ExtendedTAISliceSupportList,
        id_RequestedSRSTransmissionCharacteristics,
        id_PosAssistance_Information,
        id_PosBroadcast,
        id_RoutingID,
        id_PosAssistanceInformationFailureList,
        id_PosMeasurementQuantities,
        id_PosMeasurementResultList,
        id_TRPInformationTypeListTRPReq,
        id_TRPInformationTypeItem,
        id_TRPInformationListTRPResp,
        id_TRPInformationItem,
        id_LMF_MeasurementID,
        id_SRSType,
        id_ActivationTime,
        id_AbortTransmission,
        id_PositioningBroadcastCells,
        id_SRSConfiguration,
        id_PosReportCharacteristics,
        id_PosMeasurementPeriodicity,
        id_TRPList,
        id_RAN_MeasurementID,
        id_LMF_UE_MeasurementID,
        id_RAN_UE_MeasurementID,
        id_E_CID_MeasurementQuantities,
        id_E_CID_MeasurementQuantities_Item,
        id_E_CID_MeasurementPeriodicity,
        id_E_CID_MeasurementResult,
        id_Cell_Portion_ID,
        id_SFNInitialisationTime,
        id_SystemFrameNumber,
        id_SlotNumber,
        id_TRP_MeasurementRequestList,
        id_MeasurementBeamInfoRequest,
        id_E_CID_ReportCharacteristics,
        id_ConfiguredTACIndication,
        id_Extended_GNB_CU_Name,
        id_Extended_GNB_DU_Name,
        id_F1CTransferPath,
        id_SFN_Offset,
        id_TransmissionStopIndicator,
        id_SrsFrequency,
        id_SCGIndicator,
        id_EstimatedArrivalProbability,
        id_TRPType,
        id_SRSSpatialRelationPerSRSResource,
        id_PDCPTerminatingNodeDLTNLAddrInfo,
        id_ENBDLTNLAddress,
        id_PosMeasurementPeriodicityExtended,
        id_PRS_Resource_ID,
        id_LocationMeasurementInformation,
    ]

class F1AP_Containers:

    _name_  = u'F1AP-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 5]
    
    _obj_ = [
        u'F1AP-PROTOCOL-IES',
        u'F1AP-PROTOCOL-IES-PAIR',
        u'F1AP-PROTOCOL-EXTENSION',
        u'F1AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'F1AP-PROTOCOL-IES',
        u'F1AP-PROTOCOL-IES-PAIR',
        u'F1AP-PROTOCOL-EXTENSION',
        u'F1AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'F1AP-PROTOCOL-IES',
        u'F1AP-PROTOCOL-IES-PAIR',
        u'F1AP-PROTOCOL-EXTENSION',
        u'F1AP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< F1AP-PROTOCOL-IES >-----#
    F1AP_PROTOCOL_IES = CLASS(name=u'F1AP-PROTOCOL-IES', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _F1AP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _F1AP_PROTOCOL_IES_id),
        (u'criticality', _F1AP_PROTOCOL_IES_criticality),
        (u'Value', _F1AP_PROTOCOL_IES_Value),
        (u'presence', _F1AP_PROTOCOL_IES_presence),
        ])
    
    #-----< F1AP-PROTOCOL-IES-PAIR >-----#
    F1AP_PROTOCOL_IES_PAIR = CLASS(name=u'F1AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _F1AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _F1AP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _F1AP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _F1AP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _F1AP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _F1AP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _F1AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< F1AP-PROTOCOL-EXTENSION >-----#
    F1AP_PROTOCOL_EXTENSION = CLASS(name=u'F1AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _F1AP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _F1AP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _F1AP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _F1AP_PROTOCOL_EXTENSION_id),
        (u'criticality', _F1AP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _F1AP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _F1AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< F1AP-PRIVATE-IES >-----#
    F1AP_PRIVATE_IES = CLASS(name=u'F1AP-PRIVATE-IES', mode=MODE_TYPE)
    _F1AP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'PrivateIE-ID')))
    _F1AP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _F1AP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _F1AP_PRIVATE_IES_id),
        (u'criticality', _F1AP_PRIVATE_IES_criticality),
        (u'Value', _F1AP_PRIVATE_IES_Value),
        (u'presence', _F1AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name=u'ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _F1AP_PROTOCOL_IES_id,
        _F1AP_PROTOCOL_IES_criticality,
        _F1AP_PROTOCOL_IES_Value,
        _F1AP_PROTOCOL_IES_presence,
        F1AP_PROTOCOL_IES,
        _F1AP_PROTOCOL_IES_PAIR_id,
        _F1AP_PROTOCOL_IES_PAIR_firstCriticality,
        _F1AP_PROTOCOL_IES_PAIR_FirstValue,
        _F1AP_PROTOCOL_IES_PAIR_secondCriticality,
        _F1AP_PROTOCOL_IES_PAIR_SecondValue,
        _F1AP_PROTOCOL_IES_PAIR_presence,
        F1AP_PROTOCOL_IES_PAIR,
        _F1AP_PROTOCOL_EXTENSION_id,
        _F1AP_PROTOCOL_EXTENSION_criticality,
        _F1AP_PROTOCOL_EXTENSION_Extension,
        _F1AP_PROTOCOL_EXTENSION_presence,
        F1AP_PROTOCOL_EXTENSION,
        _F1AP_PRIVATE_IES_id,
        _F1AP_PRIVATE_IES_criticality,
        _F1AP_PRIVATE_IES_Value,
        _F1AP_PRIVATE_IES_presence,
        F1AP_PRIVATE_IES,
    ]

class F1AP_IEs:

    _name_  = u'F1AP-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 2]
    
    _obj_ = [
        u'AbortTransmission',
        u'AbortTransmission-ExtIEs',
        u'AccessPointPosition',
        u'AccessPointPosition-ExtIEs',
        u'Activated-Cells-to-be-Updated-List',
        u'Activated-Cells-to-be-Updated-List-Item',
        u'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        u'ActiveULBWP',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalDuplicationIndication',
        u'AdditionalPath-List',
        u'AdditionalPath-Item',
        u'AdditionalPath-Item-ExtIEs',
        u'AdditionalPDCPDuplicationTNL-List',
        u'AdditionalPDCPDuplicationTNL-Item',
        u'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        u'AdditionalSIBMessageList',
        u'AdditionalSIBMessageList-Item',
        u'AdditionalSIBMessageList-Item-ExtIEs',
        u'AdditionalRRMPriorityIndex',
        u'AggressorCellList',
        u'AggressorCellList-Item',
        u'AggressorCellList-Item-ExtIEs',
        u'AggressorgNBSetID',
        u'AggressorgNBSetID-ExtIEs',
        u'AllocationAndRetentionPriority',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AlternativeQoSParaSetList',
        u'AlternativeQoSParaSetItem',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AngleMeasurementQuality',
        u'AngleMeasurementQuality-ExtIEs',
        u'AperiodicSRSResourceTriggerList',
        u'AperiodicSRSResourceTrigger',
        u'Associated-SCell-Item',
        u'Associated-SCell-ItemExtIEs',
        u'AvailablePLMNList',
        u'AvailablePLMNList-Item',
        u'AvailablePLMNList-Item-ExtIEs',
        u'AvailableSNPN-ID-List',
        u'AvailableSNPN-ID-List-Item',
        u'AvailableSNPN-ID-List-ItemExtIEs',
        u'AveragingWindow',
        u'AreaScope',
        u'BandwidthSRS',
        u'BandwidthSRS-ExtIEs',
        u'BAPAddress',
        u'BAPCtrlPDUChannel',
        u'BAPlayerBHRLCchannelMappingInfo',
        u'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        u'BAPlayerBHRLCchannelMappingInfoList',
        u'BAPlayerBHRLCchannelMappingInfo-Item',
        u'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        u'BAPPathID',
        u'BAPRoutingID',
        u'BAPRoutingIDExtIEs',
        u'BitRate',
        u'BearerTypeChange',
        u'BHRLCChannelID',
        u'BHChannels-FailedToBeModified-Item',
        u'BHChannels-FailedToBeModified-ItemExtIEs',
        u'BHChannels-FailedToBeSetup-Item',
        u'BHChannels-FailedToBeSetup-ItemExtIEs',
        u'BHChannels-FailedToBeSetupMod-Item',
        u'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        u'BHChannels-Modified-Item',
        u'BHChannels-Modified-ItemExtIEs',
        u'BHChannels-Required-ToBeReleased-Item',
        u'BHChannels-Required-ToBeReleased-ItemExtIEs',
        u'BHChannels-Setup-Item',
        u'BHChannels-Setup-ItemExtIEs',
        u'BHChannels-SetupMod-Item',
        u'BHChannels-SetupMod-ItemExtIEs',
        u'BHChannels-ToBeModified-Item',
        u'BHChannels-ToBeModified-ItemExtIEs',
        u'BHChannels-ToBeReleased-Item',
        u'BHChannels-ToBeReleased-ItemExtIEs',
        u'BHChannels-ToBeSetup-Item',
        u'BHChannels-ToBeSetup-ItemExtIEs',
        u'BHChannels-ToBeSetupMod-Item',
        u'BHChannels-ToBeSetupMod-ItemExtIEs',
        u'BHInfo',
        u'BHInfo-ExtIEs',
        u'BHQoSInformation',
        u'BHQoSInformation-ExtIEs',
        u'BH-Routing-Information-Added-List-Item',
        u'BH-Routing-Information-Added-List-ItemExtIEs',
        u'BH-Routing-Information-Removed-List-Item',
        u'BH-Routing-Information-Removed-List-ItemExtIEs',
        u'BPLMN-ID-Info-List',
        u'BPLMN-ID-Info-Item',
        u'BPLMN-ID-Info-ItemExtIEs',
        u'ServedPLMNs-List',
        u'ServedPLMNs-Item',
        u'ServedPLMNs-ItemExtIEs',
        u'BroadcastCAGList',
        u'BroadcastNIDList',
        u'BroadcastSNPN-ID-List',
        u'BroadcastSNPN-ID-List-Item',
        u'BroadcastSNPN-ID-List-ItemExtIEs',
        u'BroadcastPNI-NPN-ID-List',
        u'BroadcastPNI-NPN-ID-List-Item',
        u'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        u'BurstArrivalTime',
        u'CAGID',
        u'Cancel-all-Warning-Messages-Indicator',
        u'Candidate-SpCell-Item',
        u'Candidate-SpCell-ItemExtIEs',
        u'CapacityValue',
        u'CapacityValue-ExtIEs',
        u'Cause',
        u'Cause-ExtIEs',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellGroupConfig',
        u'CellCapacityClassValue',
        u'Cell-Direction',
        u'CellMeasurementResultList',
        u'CellMeasurementResultItem',
        u'CellMeasurementResultItem-ExtIEs',
        u'Cell-Portion-ID',
        u'Cells-Failed-to-be-Activated-List-Item',
        u'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        u'Cells-Status-Item',
        u'Cells-Status-ItemExtIEs',
        u'Cells-To-Be-Broadcast-Item',
        u'Cells-To-Be-Broadcast-ItemExtIEs',
        u'Cells-Broadcast-Completed-Item',
        u'Cells-Broadcast-Completed-ItemExtIEs',
        u'Broadcast-To-Be-Cancelled-Item',
        u'Broadcast-To-Be-Cancelled-ItemExtIEs',
        u'Cells-Broadcast-Cancelled-Item',
        u'Cells-Broadcast-Cancelled-ItemExtIEs',
        u'Cells-to-be-Activated-List-Item',
        u'Cells-to-be-Activated-List-ItemExtIEs',
        u'Cells-to-be-Deactivated-List-Item',
        u'Cells-to-be-Deactivated-List-ItemExtIEs',
        u'Cells-to-be-Barred-Item',
        u'Cells-to-be-Barred-Item-ExtIEs',
        u'CellBarred',
        u'CellSize',
        u'CellToReportList',
        u'CellToReportItem',
        u'CellToReportItem-ExtIEs',
        u'CellType',
        u'CellType-ExtIEs',
        u'CellULConfigured',
        u'Child-Node-Cells-List',
        u'Child-Node-Cells-List-Item',
        u'Child-Node-Cells-List-Item-ExtIEs',
        u'Child-Nodes-List',
        u'Child-Nodes-List-Item',
        u'Child-Nodes-List-Item-ExtIEs',
        u'CHOtrigger-InterDU',
        u'CHOtrigger-IntraDU',
        u'CNUEPagingIdentity',
        u'CNUEPagingIdentity-ExtIEs',
        u'CompositeAvailableCapacityGroup',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'CompositeAvailableCapacity',
        u'CompositeAvailableCapacity-ExtIEs',
        u'CHO-Probability',
        u'ConditionalInterDUMobilityInformation',
        u'ConditionalInterDUMobilityInformation-ExtIEs',
        u'ConditionalIntraDUMobilityInformation',
        u'ConditionalIntraDUMobilityInformation-ExtIEs',
        u'ConfiguredTACIndication',
        u'CoordinateID',
        u'CP-TransportLayerAddress',
        u'CP-TransportLayerAddress-ExtIEs',
        u'CPTrafficType',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'C-RNTI',
        u'CUDURadioInformationType',
        u'CUDURadioInformationType-ExtIEs',
        u'CUDURIMInformation',
        u'CUDURIMInformation-ExtIEs',
        u'CUtoDURRCInformation',
        u'CUtoDURRCInformation-ExtIEs',
        u'DCBasedDuplicationConfigured',
        u'Dedicated-SIDelivery-NeededUE-Item',
        u'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        u'DL-PRS',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'DL-UP-TNL-Address-to-Update-List-Item',
        u'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'DLUPTNLInformation-ToBeSetup-List',
        u'DLUPTNLInformation-ToBeSetup-Item',
        u'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'DRB-Activity-Item',
        u'DRB-Activity-ItemExtIEs',
        u'DRB-Activity',
        u'DRBID',
        u'DRBs-FailedToBeModified-Item',
        u'DRBs-FailedToBeModified-ItemExtIEs',
        u'DRBs-FailedToBeSetup-Item',
        u'DRBs-FailedToBeSetup-ItemExtIEs',
        u'DRBs-FailedToBeSetupMod-Item',
        u'DRBs-FailedToBeSetupMod-ItemExtIEs',
        u'DRB-Information',
        u'DRB-Information-ItemExtIEs',
        u'DRBs-Modified-Item',
        u'DRBs-Modified-ItemExtIEs',
        u'DRBs-ModifiedConf-Item',
        u'DRBs-ModifiedConf-ItemExtIEs',
        u'DRB-Notify-Item',
        u'DRB-Notify-ItemExtIEs',
        u'DRBs-Required-ToBeModified-Item',
        u'DRBs-Required-ToBeModified-ItemExtIEs',
        u'DRBs-Required-ToBeReleased-Item',
        u'DRBs-Required-ToBeReleased-ItemExtIEs',
        u'DRBs-Setup-Item',
        u'DRBs-Setup-ItemExtIEs',
        u'DRBs-SetupMod-Item',
        u'DRBs-SetupMod-ItemExtIEs',
        u'DRBs-ToBeModified-Item',
        u'DRBs-ToBeModified-ItemExtIEs',
        u'DRBs-ToBeReleased-Item',
        u'DRBs-ToBeReleased-ItemExtIEs',
        u'DRBs-ToBeSetup-Item',
        u'DRBs-ToBeSetup-ItemExtIEs',
        u'DRBs-ToBeSetupMod-Item',
        u'DRBs-ToBeSetupMod-ItemExtIEs',
        u'DRXCycle',
        u'DRXCycle-ExtIEs',
        u'DRX-Config',
        u'DRXConfigurationIndicator',
        u'DRX-LongCycleStartOffset',
        u'DSInformationList',
        u'DSCP',
        u'DUtoCURRCContainer',
        u'DUCURadioInformationType',
        u'DUCURadioInformationType-ExtIEs',
        u'DUCURIMInformation',
        u'DUCURIMInformation-ExtIEs',
        u'DUF-Slot-Config-Item',
        u'DUF-Slot-Config-Item-ExtIEs',
        u'DUF-Slot-Config-List',
        u'DUFSlotformatIndex',
        u'DUFTransmissionPeriodicity',
        u'DU-RX-MT-RX',
        u'DU-TX-MT-TX',
        u'DU-RX-MT-TX',
        u'DU-TX-MT-RX',
        u'DUtoCURRCInformation',
        u'DUtoCURRCInformation-ExtIEs',
        u'DuplicationActivation',
        u'DuplicationIndication',
        u'DuplicationState',
        u'Dynamic5QIDescriptor',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'DynamicPQIDescriptor',
        u'DynamicPQIDescriptor-ExtIEs',
        u'E-CID-MeasurementQuantities',
        u'E-CID-MeasurementQuantities-ItemIEs',
        u'E-CID-MeasurementQuantities-Item',
        u'E-CID-MeasurementQuantitiesValue-ExtIEs',
        u'E-CID-MeasurementQuantitiesValue',
        u'E-CID-MeasurementResult',
        u'E-CID-MeasurementResult-ExtIEs',
        u'E-CID-MeasuredResults-List',
        u'E-CID-MeasuredResults-Item',
        u'E-CID-MeasuredResults-Item-ExtIEs',
        u'E-CID-MeasuredResults-Value',
        u'E-CID-MeasuredResults-Value-ExtIEs',
        u'E-CID-ReportCharacteristics',
        u'EgressBHRLCCHList',
        u'EgressBHRLCCHItem',
        u'EgressBHRLCCHItemExtIEs',
        u'Endpoint-IP-address-and-port',
        u'Endpoint-IP-address-and-port-ExtIEs',
        u'ExtendedAvailablePLMN-List',
        u'ExtendedAvailablePLMN-Item',
        u'ExplicitFormat',
        u'ExplicitFormat-ExtIEs',
        u'ExtendedAvailablePLMN-Item-ExtIEs',
        u'ExtendedServedPLMNs-List',
        u'ExtendedServedPLMNs-Item',
        u'ExtendedServedPLMNs-ItemExtIEs',
        u'ExtendedSliceSupportList',
        u'EUTRACells-List',
        u'EUTRACells-List-item',
        u'EUTRACells-List-itemExtIEs',
        u'EUTRA-Cell-ID',
        u'EUTRA-Coex-FDD-Info',
        u'EUTRA-Coex-FDD-Info-ExtIEs',
        u'EUTRA-Coex-Mode-Info',
        u'EUTRA-Coex-TDD-Info',
        u'EUTRA-Coex-TDD-Info-ExtIEs',
        u'EUTRA-CyclicPrefixDL',
        u'EUTRA-CyclicPrefixUL',
        u'EUTRA-PRACH-Configuration',
        u'EUTRA-PRACH-Configuration-ExtIEs',
        u'EUTRA-SpecialSubframe-Info',
        u'EUTRA-SpecialSubframe-Info-ExtIEs',
        u'EUTRA-SpecialSubframePatterns',
        u'EUTRA-SubframeAssignment',
        u'EUTRA-Transmission-Bandwidth',
        u'EUTRANQoS',
        u'EUTRANQoS-ExtIEs',
        u'ExecuteDuplication',
        u'ExtendedEARFCN',
        u'EUTRA-Mode-Info',
        u'EUTRA-Mode-Info-ExtIEs',
        u'EUTRA-NR-CellResourceCoordinationReq-Container',
        u'EUTRA-NR-CellResourceCoordinationReqAck-Container',
        u'EUTRA-FDD-Info',
        u'EUTRA-FDD-Info-ExtIEs',
        u'EUTRA-TDD-Info',
        u'EUTRA-TDD-Info-ExtIEs',
        u'EventType',
        u'ExtendedPacketDelayBudget',
        u'F1CPathNSA',
        u'F1CTransferPath',
        u'F1CTransferPath-ExtIEs',
        u'FDD-Info',
        u'FDD-Info-ExtIEs',
        u'Flows-Mapped-To-DRB-List',
        u'Flows-Mapped-To-DRB-Item',
        u'Flows-Mapped-To-DRB-ItemExtIEs',
        u'FR1-Bandwidth',
        u'FR2-Bandwidth',
        u'FreqBandNrItem',
        u'FreqBandNrItem-ExtIEs',
        u'FreqDomainLength',
        u'FreqDomainLength-ExtIEs',
        u'FrequencyShift7p5khz',
        u'FullConfiguration',
        u'FlowsMappedToSLDRB-List',
        u'FlowsMappedToSLDRB-Item',
        u'FlowsMappedToSLDRB-Item-ExtIEs',
        u'GBR-QosInformation',
        u'GBR-QosInformation-ExtIEs',
        u'GBR-QoSFlowInformation',
        u'GBR-QosFlowInformation-ExtIEs',
        u'CG-Config',
        u'GeographicalCoordinates',
        u'GeographicalCoordinates-ExtIEs',
        u'GNBCUMeasurementID',
        u'GNBDUMeasurementID',
        u'GNB-CUSystemInformation',
        u'GNB-CUSystemInformation-ExtIEs',
        u'GNB-CU-TNL-Association-Setup-Item',
        u'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-Item',
        u'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Add-Item',
        u'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Remove-Item',
        u'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Update-Item',
        u'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        u'GNB-CU-UE-F1AP-ID',
        u'GNB-DU-Cell-Resource-Configuration',
        u'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        u'GNB-DU-UE-F1AP-ID',
        u'GNB-DU-ID',
        u'GNB-CU-Name',
        u'GNB-DU-Name',
        u'Extended-GNB-CU-Name',
        u'Extended-GNB-CU-Name-ExtIEs',
        u'GNB-CU-NameVisibleString',
        u'GNB-CU-NameUTF8String',
        u'Extended-GNB-DU-Name',
        u'Extended-GNB-DU-Name-ExtIEs',
        u'GNB-DU-NameVisibleString',
        u'GNB-DU-NameUTF8String',
        u'GNB-DU-Served-Cells-Item',
        u'GNB-DU-Served-Cells-ItemExtIEs',
        u'GNB-DU-System-Information',
        u'GNB-DU-System-Information-ExtIEs',
        u'GNB-DUConfigurationQuery',
        u'GNBDUOverloadInformation',
        u'GNB-DU-TNL-Association-To-Remove-Item',
        u'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-RxTxTimeDiff',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'GNBSetID',
        u'GTP-TEID',
        u'GTPTLAs',
        u'GTPTLA-Item',
        u'GTPTLA-Item-ExtIEs',
        u'GTPTunnel',
        u'GTPTunnel-ExtIEs',
        u'HandoverPreparationInformation',
        u'HardwareLoadIndicator',
        u'HardwareLoadIndicator-ExtIEs',
        u'HSNASlotConfigList',
        u'HSNASlotConfigItem',
        u'HSNASlotConfigItem-ExtIEs',
        u'HSNADownlink',
        u'HSNAFlexible',
        u'HSNAUplink',
        u'HSNATransmissionPeriodicity',
        u'IAB-Barred',
        u'IAB-Info-IAB-donor-CU',
        u'IAB-Info-IAB-donor-CU-ExtIEs',
        u'IAB-Info-IAB-DU',
        u'IAB-Info-IAB-DU-ExtIEs',
        u'IAB-MT-Cell-List',
        u'IAB-MT-Cell-List-Item',
        u'IAB-MT-Cell-List-Item-ExtIEs',
        u'IAB-STC-Info',
        u'IAB-STC-Info-ExtIEs',
        u'IAB-STC-Info-List',
        u'IAB-STC-Info-Item',
        u'IAB-STC-Info-Item-ExtIEs',
        u'IAB-Allocated-TNL-Address-Item',
        u'IAB-Allocated-TNL-Address-Item-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-Mode-Info',
        u'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-FDD-Info',
        u'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-TDD-Info',
        u'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        u'IABIPv6RequestType',
        u'IABIPv6RequestType-ExtIEs',
        u'IABTNLAddress',
        u'IABTNLAddress-ExtIEs',
        u'IABTNLAddressesRequested',
        u'IABTNLAddressesRequested-ExtIEs',
        u'IAB-TNL-Addresses-To-Remove-Item',
        u'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        u'IABTNLAddressUsage',
        u'IABv4AddressesRequested',
        u'IABv4AddressesRequested-ExtIEs',
        u'ImplicitFormat',
        u'ImplicitFormat-ExtIEs',
        u'IgnorePRACHConfiguration',
        u'IgnoreResourceCoordinationContainer',
        u'InactivityMonitoringRequest',
        u'InactivityMonitoringResponse',
        u'InterfacesToTrace',
        u'IntendedTDD-DL-ULConfig',
        u'IntendedTDD-DL-ULConfig-ExtIEs',
        u'IPHeaderInformation',
        u'IPHeaderInformation-ItemExtIEs',
        u'IPtolayer2TrafficMappingInfo',
        u'IPtolayer2TrafficMappingInfoList',
        u'IPtolayer2TrafficMappingInfo-Item',
        u'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        u'L139Info',
        u'L139Info-ExtIEs',
        u'L839Info',
        u'L839Info-ExtIEs',
        u'LCID',
        u'LCS-to-GCS-TranslationAoA',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCStoGCSTranslationList',
        u'LCStoGCSTranslation',
        u'LCStoGCSTranslation-ExtIEs',
        u'LMF-MeasurementID',
        u'LMF-UE-MeasurementID',
        u'LocationMeasurementInformation',
        u'LocationUncertainty',
        u'LocationUncertainty-ExtIEs',
        u'LongDRXCycleLength',
        u'LowerLayerPresenceStatusChange',
        u'LTEUESidelinkAggregateMaximumBitrate',
        u'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'LTEV2XServicesAuthorized',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'MappingInformationIndex',
        u'MappingInformationtoRemove',
        u'MaskedIMEISV',
        u'MaxDataBurstVolume',
        u'MaxPacketLossRate',
        u'MIB-message',
        u'MeasConfig',
        u'MeasGapConfig',
        u'MeasGapSharingConfig',
        u'MeasurementBeamInfoRequest',
        u'MeasurementBeamInfo',
        u'MeasurementBeamInfo-ExtIEs',
        u'MeasurementTimingConfiguration',
        u'MessageIdentifier',
        u'MultiplexingInfo',
        u'MultiplexingInfo-ExtIEs',
        u'M2Configuration',
        u'M5Configuration',
        u'M5Configuration-ExtIEs',
        u'M5period',
        u'M5-Links-to-log',
        u'M6Configuration',
        u'M6Configuration-ExtIEs',
        u'M6report-Interval',
        u'M6-Links-to-log',
        u'M7Configuration',
        u'M7Configuration-ExtIEs',
        u'M7period',
        u'M7-Links-to-log',
        u'MDT-Activation',
        u'MDTConfiguration',
        u'MDTConfiguration-ExtIEs',
        u'MDTPLMNList',
        u'MeasuredResultsValue',
        u'MeasuredResultsValue-ExtIEs',
        u'MeasurementsToActivate',
        u'NeedforGap',
        u'Neighbour-Cell-Information-Item',
        u'Neighbour-Cell-Information-ItemExtIEs',
        u'NGRANAllocationAndRetentionPriority',
        u'NGRANAllocationAndRetentionPriority-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NID',
        u'NR-CGI-List-For-Restart-Item',
        u'NR-CGI-List-For-Restart-ItemExtIEs',
        u'NR-PRSBeamInformation',
        u'NR-PRSBeamInformation-ExtIEs',
        u'NR-PRSBeamInformationList',
        u'NR-PRSBeamInformationItem',
        u'NR-PRSBeamInformationItem-ExtIEs',
        u'NonDynamic5QIDescriptor',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NonDynamicPQIDescriptor',
        u'NonDynamicPQIDescriptor-ExtIEs',
        u'NonUPTrafficType',
        u'NoofDownlinkSymbols',
        u'NoofUplinkSymbols',
        u'Notification-Cause',
        u'NotificationControl',
        u'NotificationInformation',
        u'NotificationInformationExtIEs',
        u'NPNBroadcastInformation',
        u'NPNBroadcastInformation-ExtIEs',
        u'NPN-Broadcast-Information-SNPN',
        u'NPN-Broadcast-Information-SNPN-ExtIEs',
        u'NPN-Broadcast-Information-PNI-NPN',
        u'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        u'NPNSupportInfo',
        u'NPNSupportInfo-ExtIEs',
        u'NRCarrierList',
        u'NRCarrierItem',
        u'NRCarrierItem-ExtIEs',
        u'NRFreqInfo',
        u'NRFreqInfoExtIEs',
        u'NRCGI',
        u'NRCGI-ExtIEs',
        u'NR-Mode-Info',
        u'NR-Mode-Info-ExtIEs',
        u'NRPRACHConfig',
        u'NRPRACHConfig-ExtIEs',
        u'NRCellIdentity',
        u'NRNRB',
        u'NRPCI',
        u'NRPRACHConfigList',
        u'NRPRACHConfigItem',
        u'NRPRACHConfigItem-ExtIEs',
        u'NRSCS',
        u'NRUERLFReportContainer',
        u'NumberofActiveUEs',
        u'NumberOfBroadcasts',
        u'NumberofBroadcastRequest',
        u'NumDLULSymbols',
        u'NumDLULSymbols-ExtIEs',
        u'NRV2XServicesAuthorized',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'NZP-CSI-RS-ResourceID',
        u'OffsetToPointA',
        u'PacketDelayBudget',
        u'PacketErrorRate',
        u'PacketErrorRate-ExtIEs',
        u'PER-Scalar',
        u'PER-Exponent',
        u'PagingCell-Item',
        u'PagingCell-ItemExtIEs',
        u'PagingDRX',
        u'PagingIdentity',
        u'PagingIdentity-ExtIEs',
        u'PagingOrigin',
        u'PagingPriority',
        u'RelativePathDelay',
        u'RelativePathDelay-ExtIEs',
        u'PathlossReferenceInfo',
        u'PathlossReferenceInfo-ExtIEs',
        u'PathlossReferenceSignal',
        u'PathlossReferenceSignal-ExtIEs',
        u'PC5QoSFlowIdentifier',
        u'PC5-QoS-Characteristics',
        u'PC5-QoS-Characteristics-ExtIEs',
        u'PC5QoSParameters',
        u'PC5QoSParameters-ExtIEs',
        u'PC5FlowBitRates',
        u'PC5FlowBitRates-ExtIEs',
        u'PDCCH-BlindDetectionSCG',
        u'PDCP-SN',
        u'PDCPSNLength',
        u'PDUSessionID',
        u'ReportingPeriodicityValue',
        u'Periodicity',
        u'PeriodicitySRS',
        u'PeriodicityList',
        u'PeriodicityList-Item',
        u'PeriodicityList-ItemExtIEs',
        u'Permutation',
        u'Ph-InfoMCG',
        u'Ph-InfoSCG',
        u'PLMN-Identity',
        u'PortNumber',
        u'PosAssistance-Information',
        u'PosAssistanceInformationFailureList',
        u'PosBroadcast',
        u'PositioningBroadcastCells',
        u'MeasurementPeriodicity',
        u'MeasurementPeriodicityExtended',
        u'PosMeasurementQuantities',
        u'PosMeasurementQuantities-Item',
        u'PosMeasurementQuantities-ItemExtIEs',
        u'PosMeasurementResult',
        u'PosMeasurementResultItem',
        u'PosMeasurementResultItemExtIEs',
        u'PosMeasurementResultList',
        u'PosMeasurementResultList-Item',
        u'PosMeasurementResultList-ItemExtIEs',
        u'PosMeasurementType',
        u'PosReportCharacteristics',
        u'PosResourceSetType',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePR',
        u'PosResourceSetTypePR-ExtIEs',
        u'PosResourceSetTypeSP',
        u'PosResourceSetTypeSP-ExtIEs',
        u'PosResourceSetTypeAP',
        u'PosResourceSetTypeAP-ExtIEs',
        u'PosSRSResourceID-List',
        u'PosSRSResource-Item',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResource-List',
        u'PosSRSResourceSet-Item',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'PosSRSResourceSet-List',
        u'PrimaryPathIndication',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProtectedEUTRAResourceIndication',
        u'Protected-EUTRA-Resources-Item',
        u'Protected-EUTRA-Resources-ItemExtIEs',
        u'PRSConfiguration',
        u'PRSConfiguration-ExtIEs',
        u'PRSInformationPos',
        u'PRSInformationPos-ExtIEs',
        u'Potential-SpCell-Item',
        u'Potential-SpCell-ItemExtIEs',
        u'PRSAngleList',
        u'PRSAngleItem',
        u'PRSAngleItem-ItemExtIEs',
        u'PRSMuting',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2',
        u'PRSMutingOption2-ExtIEs',
        u'PRS-Resource-ID',
        u'PRSResource-List',
        u'PRSResource-Item',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRS-Resource-Set-ID',
        u'PRSResourceSet-List',
        u'PRSResourceSet-Item',
        u'PRSResourceSet-Item-ExtIEs',
        u'PWS-Failed-NR-CGI-Item',
        u'PWS-Failed-NR-CGI-ItemExtIEs',
        u'PWSSystemInformation',
        u'PWSSystemInformationExtIEs',
        u'PrivacyIndicator',
        u'QCI',
        u'QoS-Characteristics',
        u'QoS-Characteristics-ExtIEs',
        u'QoSFlowIdentifier',
        u'QoSFlowLevelQoSParameters',
        u'QoSFlowLevelQoSParameters-ExtIEs',
        u'QoSFlowMappingIndication',
        u'QoSInformation',
        u'QoSInformation-ExtIEs',
        u'QosMonitoringRequest',
        u'QoSParaSetIndex',
        u'QoSParaSetNotifyIndex',
        u'RACH-Config-Common',
        u'RACH-Config-Common-IAB',
        u'RACHReportContainer',
        u'RACHReportInformationList',
        u'RACHReportInformationItem',
        u'RACHReportInformationItem-ExtIEs',
        u'RadioResourceStatus',
        u'RadioResourceStatus-ExtIEs',
        u'RANAC',
        u'RAN-MeasurementID',
        u'RAN-UE-MeasurementID',
        u'RANUEID',
        u'RANUEPagingIdentity',
        u'RANUEPagingIdentity-ExtIEs',
        u'RAT-FrequencyPriorityInformation',
        u'RAT-FrequencyPriorityInformation-ExtIEs',
        u'RAT-FrequencySelectionPriority',
        u'Reestablishment-Indication',
        u'ReferencePoint',
        u'ReferencePoint-ExtIEs',
        u'ReferenceSFN',
        u'ReferenceSignal',
        u'ReferenceSignal-ExtIEs',
        u'RelativeCartesianLocation',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativeGeodeticLocation',
        u'RelativeGeodeticLocation-ExtIEs',
        u'ReferenceTime',
        u'RegistrationRequest',
        u'ReportCharacteristics',
        u'ReportingPeriodicity',
        u'RequestedBandCombinationIndex',
        u'RequestedFeatureSetEntryIndex',
        u'RequestedP-MaxFR2',
        u'Requested-PDCCH-BlindDetectionSCG',
        u'RequestedSRSTransmissionCharacteristics',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'RequestType',
        u'ResourceCoordinationEUTRACellInfo',
        u'ResourceCoordinationEUTRACellInfo-ExtIEs',
        u'ResourceCoordinationTransferInformation',
        u'ResourceCoordinationTransferInformation-ExtIEs',
        u'ResourceCoordinationTransferContainer',
        u'ResourceSetType',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'RepetitionPeriod',
        u'ReportingRequestType',
        u'ReportingRequestType-ExtIEs',
        u'ResourceType',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'RLCDuplicationInformation',
        u'RLCDuplicationInformation-ExtIEs',
        u'RLCDuplicationStateList',
        u'RLCDuplicationState-Item',
        u'RLCDuplicationState-Item-ExtIEs',
        u'RLCFailureIndication',
        u'RLCFailureIndication-ExtIEs',
        u'RLCMode',
        u'RLC-Status',
        u'RLC-Status-ExtIEs',
        u'RLFReportInformationList',
        u'RLFReportInformationItem',
        u'RLFReportInformationItem-ExtIEs',
        u'RIMRSDetectionStatus',
        u'RRCContainer',
        u'RRCContainer-RRCSetupComplete',
        u'RRCDeliveryStatus',
        u'RRCDeliveryStatus-ExtIEs',
        u'RRCDeliveryStatusRequest',
        u'RRCReconfigurationCompleteIndicator',
        u'RRC-Version',
        u'RRC-Version-ExtIEs',
        u'RoutingID',
        u'SCell-FailedtoSetup-Item',
        u'SCell-FailedtoSetup-ItemExtIEs',
        u'SCell-FailedtoSetupMod-Item',
        u'SCell-FailedtoSetupMod-ItemExtIEs',
        u'SCell-ToBeRemoved-Item',
        u'SCell-ToBeRemoved-ItemExtIEs',
        u'SCell-ToBeSetup-Item',
        u'SCell-ToBeSetup-ItemExtIEs',
        u'SCell-ToBeSetupMod-Item',
        u'SCell-ToBeSetupMod-ItemExtIEs',
        u'SCellIndex',
        u'SCGIndicator',
        u'SCS-SpecificCarrier',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information',
        u'Search-window-information-ExtIEs',
        u'SerialNumber',
        u'SIBType-PWS',
        u'SelectedBandCombinationIndex',
        u'SelectedFeatureSetEntryIndex',
        u'CG-ConfigInfo',
        u'ServCellIndex',
        u'ServingCellMO',
        u'Served-Cell-Information',
        u'Served-Cell-Information-ExtIEs',
        u'SFN-Offset',
        u'SFN-Offset-ExtIEs',
        u'Served-Cells-To-Add-Item',
        u'Served-Cells-To-Add-ItemExtIEs',
        u'Served-Cells-To-Delete-Item',
        u'Served-Cells-To-Delete-ItemExtIEs',
        u'Served-Cells-To-Modify-Item',
        u'Served-Cells-To-Modify-ItemExtIEs',
        u'Served-EUTRA-Cells-Information',
        u'Served-EUTRA-Cell-Information-ExtIEs',
        u'Service-State',
        u'Service-Status',
        u'Service-Status-ExtIEs',
        u'RelativeTime1900',
        u'ShortDRXCycleLength',
        u'ShortDRXCycleTimer',
        u'SIB1-message',
        u'SIB10-message',
        u'SIB12-message',
        u'SIB13-message',
        u'SIB14-message',
        u'SItype',
        u'SItype-List',
        u'SItype-Item',
        u'SItype-ItemExtIEs',
        u'SibtypetobeupdatedListItem',
        u'SibtypetobeupdatedListItem-ExtIEs',
        u'SLDRBID',
        u'SLDRBInformation',
        u'SLDRBs-FailedToBeModified-Item',
        u'SLDRBs-FailedToBeModified-ItemExtIEs',
        u'SLDRBs-FailedToBeSetup-Item',
        u'SLDRBs-FailedToBeSetup-ItemExtIEs',
        u'SLDRBs-FailedToBeSetupMod-Item',
        u'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SLDRBs-Modified-Item',
        u'SLDRBs-Modified-ItemExtIEs',
        u'SLDRBs-ModifiedConf-Item',
        u'SLDRBs-ModifiedConf-ItemExtIEs',
        u'SLDRBs-Required-ToBeModified-Item',
        u'SLDRBs-Required-ToBeModified-ItemExtIEs',
        u'SLDRBs-Required-ToBeReleased-Item',
        u'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        u'SLDRBs-Setup-Item',
        u'SLDRBs-Setup-ItemExtIEs',
        u'SLDRBs-SetupMod-Item',
        u'SLDRBs-SetupMod-ItemExtIEs',
        u'SLDRBs-ToBeModified-Item',
        u'SLDRBs-ToBeModified-ItemExtIEs',
        u'SLDRBs-ToBeReleased-Item',
        u'SLDRBs-ToBeReleased-ItemExtIEs',
        u'SLDRBs-ToBeSetup-Item',
        u'SLDRBs-ToBeSetup-ItemExtIEs',
        u'SLDRBs-ToBeSetupMod-Item',
        u'SLDRBs-ToBeSetupMod-ItemExtIEs',
        u'SL-PHY-MAC-RLC-Config',
        u'SL-ConfigDedicatedEUTRA-Info',
        u'SliceAvailableCapacity',
        u'SliceAvailableCapacity-ExtIEs',
        u'SliceAvailableCapacityList',
        u'SliceAvailableCapacityItem',
        u'SliceAvailableCapacityItem-ExtIEs',
        u'SNSSAIAvailableCapacity-List',
        u'SNSSAIAvailableCapacity-Item',
        u'SNSSAIAvailableCapacity-Item-ExtIEs',
        u'SliceSupportList',
        u'SliceSupportItem',
        u'SliceSupportItem-ExtIEs',
        u'SliceToReportList',
        u'SliceToReportItem',
        u'SliceToReportItem-ExtIEs',
        u'SlotNumber',
        u'SNSSAI-list',
        u'SNSSAI-Item',
        u'SNSSAI-Item-ExtIEs',
        u'Slot-Configuration-List',
        u'Slot-Configuration-Item',
        u'Slot-Configuration-ItemExtIEs',
        u'SNSSAI',
        u'SNSSAI-ExtIEs',
        u'SpatialDirectionInformation',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceID',
        u'SpatialRelationforResourceIDItem',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResource-List',
        u'SpatialRelationPerSRSResourceItem',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialRelationPos',
        u'SpatialInformationPos-ExtIEs',
        u'SpectrumSharingGroupID',
        u'SRBID',
        u'SRBs-FailedToBeSetup-Item',
        u'SRBs-FailedToBeSetup-ItemExtIEs',
        u'SRBs-FailedToBeSetupMod-Item',
        u'SRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SRBs-Modified-Item',
        u'SRBs-Modified-ItemExtIEs',
        u'SRBs-Required-ToBeReleased-Item',
        u'SRBs-Required-ToBeReleased-ItemExtIEs',
        u'SRBs-Setup-Item',
        u'SRBs-Setup-ItemExtIEs',
        u'SRBs-SetupMod-Item',
        u'SRBs-SetupMod-ItemExtIEs',
        u'SRBs-ToBeReleased-Item',
        u'SRBs-ToBeReleased-ItemExtIEs',
        u'SRBs-ToBeSetup-Item',
        u'SRBs-ToBeSetup-ItemExtIEs',
        u'SRBs-ToBeSetupMod-Item',
        u'SRBs-ToBeSetupMod-ItemExtIEs',
        u'SRSCarrier-List',
        u'SRSCarrier-List-Item',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfig',
        u'SRSConfig-ExtIEs',
        u'SRSConfiguration',
        u'SRSConfiguration-ExtIEs',
        u'SrsFrequency',
        u'SRSPosResourceID',
        u'SRSResource',
        u'SRSResource-ExtIEs',
        u'SRSResourceID',
        u'SRSResourceID-List',
        u'SRSResource-List',
        u'SRSResourceSet',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceSetID',
        u'SRSResourceSetList',
        u'SRSResourceSetItem',
        u'SRSResourceSetItemExtIEs',
        u'SRSResourceSet-List',
        u'SRSResourceTrigger',
        u'SRSResourceTrigger-ExtIEs',
        u'SSB',
        u'SSB-ExtIEs',
        u'SSB-freqInfo',
        u'SSB-Index',
        u'SSB-subcarrierSpacing',
        u'SSB-transmissionPeriodicity',
        u'SSB-transmissionTimingOffset',
        u'SSB-transmissionBitmap',
        u'SSB-transmisisonBitmap-ExtIEs',
        u'SSBAreaCapacityValueList',
        u'SSBAreaCapacityValueItem',
        u'SSBAreaCapacityValueItem-ExtIEs',
        u'SSBAreaRadioResourceStatusList',
        u'SSBAreaRadioResourceStatusItem',
        u'SSBAreaRadioResourceStatusItem-ExtIEs',
        u'SSBInformation',
        u'SSBInformation-ExtIEs',
        u'SSBInformationList',
        u'SSBInformationItem',
        u'SSBInformationItem-ExtIEs',
        u'SSB-PositionsInBurst',
        u'SSB-PositionsInBurst-ExtIEs',
        u'SSB-TF-Configuration',
        u'SSB-TF-Configuration-ExtIEs',
        u'SSBToReportList',
        u'SSBToReportItem',
        u'SSBToReportItem-ExtIEs',
        u'SUL-Information',
        u'SUL-InformationExtIEs',
        u'SubcarrierSpacing',
        u'SubscriberProfileIDforRFP',
        u'SULAccessIndication',
        u'SupportedSULFreqBandItem',
        u'SupportedSULFreqBandItem-ExtIEs',
        u'SymbolAllocInSlot',
        u'SymbolAllocInSlot-ExtIEs',
        u'SystemFrameNumber',
        u'SystemInformationAreaID',
        u'FiveGS-TAC',
        u'Configured-EPS-TAC',
        u'TargetCellList',
        u'TargetCellList-Item',
        u'TargetCellList-Item-ExtIEs',
        u'TDD-Info',
        u'TDD-Info-ExtIEs',
        u'TDD-UL-DLConfigCommonNR',
        u'TimeReferenceInformation',
        u'TimeReferenceInformation-ExtIEs',
        u'TimeInformationType',
        u'TimeStamp',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex',
        u'TimeStampSlotIndex-ExtIEs',
        u'TimeToWait',
        u'TimingMeasurementQuality',
        u'TimingMeasurementQuality-ExtIEs',
        u'TNLAssociationUsage',
        u'TNLCapacityIndicator',
        u'TNLCapacityIndicator-ExtIEs',
        u'TraceActivation',
        u'TraceActivation-ExtIEs',
        u'TraceDepth',
        u'TraceID',
        u'TrafficMappingInfo',
        u'TrafficMappingInfo-ExtIEs',
        u'TransportLayerAddress',
        u'TransactionID',
        u'Transmission-Bandwidth',
        u'Transmission-Bandwidth-ExtIEs',
        u'TransmissionComb',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos',
        u'TransmissionCombPos-ExtIEs',
        u'TransmissionStopIndicator',
        u'Transport-UP-Layer-Address-Info-To-Add-List',
        u'Transport-UP-Layer-Address-Info-To-Add-Item',
        u'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        u'Transport-UP-Layer-Address-Info-To-Remove-List',
        u'Transport-UP-Layer-Address-Info-To-Remove-Item',
        u'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        u'TransmissionActionIndicator',
        u'TRPID',
        u'TRPInformation',
        u'TRPInformation-ExtIEs',
        u'TRPInformationItem',
        u'TRPInformationItem-ExtIEs',
        u'TRPInformationTypeItem',
        u'TRPInformationTypeResponseList',
        u'TRPInformationTypeResponseItem',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPList',
        u'TRPListItem',
        u'TRPListItem-ExtIEs',
        u'TRPMeasurementQuality',
        u'TRPMeasurementQuality-ExtIEs',
        u'TRPMeasurementQuality-Item',
        u'TRPMeasurementQuality-Item-ExtIEs',
        u'TRP-MeasurementRequestList',
        u'TRP-MeasurementRequestItem',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRPPositionDefinitionType',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType',
        u'TRPReferencePointType-ExtIEs',
        u'TypeOfError',
        u'Transport-Layer-Address-Info',
        u'Transport-Layer-Address-Info-ExtIEs',
        u'TRPType',
        u'TSCAssistanceInformation',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UAC-Assistance-Info',
        u'UAC-Assistance-InfoExtIEs',
        u'UACPLMN-List',
        u'UACPLMN-Item',
        u'UACPLMN-Item-ExtIEs',
        u'UACType-List',
        u'UACType-Item',
        u'UACType-Item-ExtIEs',
        u'UACCategoryType',
        u'UACCategoryType-ExtIEs',
        u'UACOperatorDefined',
        u'UACOperatorDefined-ExtIEs',
        u'UACAction',
        u'UACReductionIndication',
        u'UE-associatedLogicalF1-ConnectionItem',
        u'UEAssistanceInformation',
        u'UEAssistanceInformationEUTRA',
        u'UE-associatedLogicalF1-ConnectionItemExtIEs',
        u'UE-CapabilityRAT-ContainerList',
        u'UEContextNotRetrievable',
        u'UEIdentityIndexValue',
        u'UEIdentityIndexValueChoice-ExtIEs',
        u'UL-AoA',
        u'UL-AoA-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping',
        u'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping-List',
        u'UL-BH-Non-UP-Traffic-Mapping-Item',
        u'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        u'ULConfiguration',
        u'ULConfigurationExtIEs',
        u'UL-RTOA-Measurement',
        u'UL-RTOA-Measurement-ExtIEs',
        u'UL-RTOA-MeasurementItem',
        u'UL-RTOA-MeasurementItem-ExtIEs',
        u'UL-SRS-RSRP',
        u'ULUEConfiguration',
        u'UL-UP-TNL-Information-to-Update-List-Item',
        u'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        u'UL-UP-TNL-Address-to-Update-List-Item',
        u'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'ULUPTNLInformation-ToBeSetup-List',
        u'ULUPTNLInformation-ToBeSetup-Item',
        u'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'Uncertainty',
        u'UplinkChannelBW-PerSCS-List',
        u'UplinkTxDirectCurrentListInformation',
        u'UPTransportLayerInformation',
        u'UPTransportLayerInformation-ExtIEs',
        u'URI-address',
        u'VictimgNBSetID',
        u'VictimgNBSetID-ExtIEs',
        u'VehicleUE',
        u'PedestrianUE',
        ]
    _type_ = [
        u'AbortTransmission',
        u'AccessPointPosition',
        u'Activated-Cells-to-be-Updated-List',
        u'Activated-Cells-to-be-Updated-List-Item',
        u'ActiveULBWP',
        u'AdditionalDuplicationIndication',
        u'AdditionalPath-List',
        u'AdditionalPath-Item',
        u'AdditionalPDCPDuplicationTNL-List',
        u'AdditionalPDCPDuplicationTNL-Item',
        u'AdditionalSIBMessageList',
        u'AdditionalSIBMessageList-Item',
        u'AdditionalRRMPriorityIndex',
        u'AggressorCellList',
        u'AggressorCellList-Item',
        u'AggressorgNBSetID',
        u'AllocationAndRetentionPriority',
        u'AlternativeQoSParaSetList',
        u'AlternativeQoSParaSetItem',
        u'AngleMeasurementQuality',
        u'AperiodicSRSResourceTriggerList',
        u'AperiodicSRSResourceTrigger',
        u'Associated-SCell-Item',
        u'AvailablePLMNList',
        u'AvailablePLMNList-Item',
        u'AvailableSNPN-ID-List',
        u'AvailableSNPN-ID-List-Item',
        u'AveragingWindow',
        u'AreaScope',
        u'BandwidthSRS',
        u'BAPAddress',
        u'BAPCtrlPDUChannel',
        u'BAPlayerBHRLCchannelMappingInfo',
        u'BAPlayerBHRLCchannelMappingInfoList',
        u'BAPlayerBHRLCchannelMappingInfo-Item',
        u'BAPPathID',
        u'BAPRoutingID',
        u'BitRate',
        u'BearerTypeChange',
        u'BHRLCChannelID',
        u'BHChannels-FailedToBeModified-Item',
        u'BHChannels-FailedToBeSetup-Item',
        u'BHChannels-FailedToBeSetupMod-Item',
        u'BHChannels-Modified-Item',
        u'BHChannels-Required-ToBeReleased-Item',
        u'BHChannels-Setup-Item',
        u'BHChannels-SetupMod-Item',
        u'BHChannels-ToBeModified-Item',
        u'BHChannels-ToBeReleased-Item',
        u'BHChannels-ToBeSetup-Item',
        u'BHChannels-ToBeSetupMod-Item',
        u'BHInfo',
        u'BHQoSInformation',
        u'BH-Routing-Information-Added-List-Item',
        u'BH-Routing-Information-Removed-List-Item',
        u'BPLMN-ID-Info-List',
        u'BPLMN-ID-Info-Item',
        u'ServedPLMNs-List',
        u'ServedPLMNs-Item',
        u'BroadcastCAGList',
        u'BroadcastNIDList',
        u'BroadcastSNPN-ID-List',
        u'BroadcastSNPN-ID-List-Item',
        u'BroadcastPNI-NPN-ID-List',
        u'BroadcastPNI-NPN-ID-List-Item',
        u'BurstArrivalTime',
        u'CAGID',
        u'Cancel-all-Warning-Messages-Indicator',
        u'Candidate-SpCell-Item',
        u'CapacityValue',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellGroupConfig',
        u'CellCapacityClassValue',
        u'Cell-Direction',
        u'CellMeasurementResultList',
        u'CellMeasurementResultItem',
        u'Cell-Portion-ID',
        u'Cells-Failed-to-be-Activated-List-Item',
        u'Cells-Status-Item',
        u'Cells-To-Be-Broadcast-Item',
        u'Cells-Broadcast-Completed-Item',
        u'Broadcast-To-Be-Cancelled-Item',
        u'Cells-Broadcast-Cancelled-Item',
        u'Cells-to-be-Activated-List-Item',
        u'Cells-to-be-Deactivated-List-Item',
        u'Cells-to-be-Barred-Item',
        u'CellBarred',
        u'CellSize',
        u'CellToReportList',
        u'CellToReportItem',
        u'CellType',
        u'CellULConfigured',
        u'Child-Node-Cells-List',
        u'Child-Node-Cells-List-Item',
        u'Child-Nodes-List',
        u'Child-Nodes-List-Item',
        u'CHOtrigger-InterDU',
        u'CHOtrigger-IntraDU',
        u'CNUEPagingIdentity',
        u'CompositeAvailableCapacityGroup',
        u'CompositeAvailableCapacity',
        u'CHO-Probability',
        u'ConditionalInterDUMobilityInformation',
        u'ConditionalIntraDUMobilityInformation',
        u'ConfiguredTACIndication',
        u'CoordinateID',
        u'CP-TransportLayerAddress',
        u'CPTrafficType',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'C-RNTI',
        u'CUDURadioInformationType',
        u'CUDURIMInformation',
        u'CUtoDURRCInformation',
        u'DCBasedDuplicationConfigured',
        u'Dedicated-SIDelivery-NeededUE-Item',
        u'DL-PRS',
        u'DL-PRSMutingPattern',
        u'DLPRSResourceCoordinates',
        u'DLPRSResourceSetARP',
        u'DL-PRSResourceSetARPLocation',
        u'DLPRSResourceARP',
        u'DL-PRSResourceARPLocation',
        u'DL-UP-TNL-Address-to-Update-List-Item',
        u'DLUPTNLInformation-ToBeSetup-List',
        u'DLUPTNLInformation-ToBeSetup-Item',
        u'DRB-Activity-Item',
        u'DRB-Activity',
        u'DRBID',
        u'DRBs-FailedToBeModified-Item',
        u'DRBs-FailedToBeSetup-Item',
        u'DRBs-FailedToBeSetupMod-Item',
        u'DRB-Information',
        u'DRBs-Modified-Item',
        u'DRBs-ModifiedConf-Item',
        u'DRB-Notify-Item',
        u'DRBs-Required-ToBeModified-Item',
        u'DRBs-Required-ToBeReleased-Item',
        u'DRBs-Setup-Item',
        u'DRBs-SetupMod-Item',
        u'DRBs-ToBeModified-Item',
        u'DRBs-ToBeReleased-Item',
        u'DRBs-ToBeSetup-Item',
        u'DRBs-ToBeSetupMod-Item',
        u'DRXCycle',
        u'DRX-Config',
        u'DRXConfigurationIndicator',
        u'DRX-LongCycleStartOffset',
        u'DSInformationList',
        u'DSCP',
        u'DUtoCURRCContainer',
        u'DUCURadioInformationType',
        u'DUCURIMInformation',
        u'DUF-Slot-Config-Item',
        u'DUF-Slot-Config-List',
        u'DUFSlotformatIndex',
        u'DUFTransmissionPeriodicity',
        u'DU-RX-MT-RX',
        u'DU-TX-MT-TX',
        u'DU-RX-MT-TX',
        u'DU-TX-MT-RX',
        u'DUtoCURRCInformation',
        u'DuplicationActivation',
        u'DuplicationIndication',
        u'DuplicationState',
        u'Dynamic5QIDescriptor',
        u'DynamicPQIDescriptor',
        u'E-CID-MeasurementQuantities',
        u'E-CID-MeasurementQuantities-Item',
        u'E-CID-MeasurementQuantitiesValue',
        u'E-CID-MeasurementResult',
        u'E-CID-MeasuredResults-List',
        u'E-CID-MeasuredResults-Item',
        u'E-CID-MeasuredResults-Value',
        u'E-CID-ReportCharacteristics',
        u'EgressBHRLCCHList',
        u'EgressBHRLCCHItem',
        u'Endpoint-IP-address-and-port',
        u'ExtendedAvailablePLMN-List',
        u'ExtendedAvailablePLMN-Item',
        u'ExplicitFormat',
        u'ExtendedServedPLMNs-List',
        u'ExtendedServedPLMNs-Item',
        u'ExtendedSliceSupportList',
        u'EUTRACells-List',
        u'EUTRACells-List-item',
        u'EUTRA-Cell-ID',
        u'EUTRA-Coex-FDD-Info',
        u'EUTRA-Coex-Mode-Info',
        u'EUTRA-Coex-TDD-Info',
        u'EUTRA-CyclicPrefixDL',
        u'EUTRA-CyclicPrefixUL',
        u'EUTRA-PRACH-Configuration',
        u'EUTRA-SpecialSubframe-Info',
        u'EUTRA-SpecialSubframePatterns',
        u'EUTRA-SubframeAssignment',
        u'EUTRA-Transmission-Bandwidth',
        u'EUTRANQoS',
        u'ExecuteDuplication',
        u'ExtendedEARFCN',
        u'EUTRA-Mode-Info',
        u'EUTRA-NR-CellResourceCoordinationReq-Container',
        u'EUTRA-NR-CellResourceCoordinationReqAck-Container',
        u'EUTRA-FDD-Info',
        u'EUTRA-TDD-Info',
        u'EventType',
        u'ExtendedPacketDelayBudget',
        u'F1CPathNSA',
        u'F1CTransferPath',
        u'FDD-Info',
        u'Flows-Mapped-To-DRB-List',
        u'Flows-Mapped-To-DRB-Item',
        u'FR1-Bandwidth',
        u'FR2-Bandwidth',
        u'FreqBandNrItem',
        u'FreqDomainLength',
        u'FrequencyShift7p5khz',
        u'FullConfiguration',
        u'FlowsMappedToSLDRB-List',
        u'FlowsMappedToSLDRB-Item',
        u'GBR-QosInformation',
        u'GBR-QoSFlowInformation',
        u'CG-Config',
        u'GeographicalCoordinates',
        u'GNBCUMeasurementID',
        u'GNBDUMeasurementID',
        u'GNB-CUSystemInformation',
        u'GNB-CU-TNL-Association-Setup-Item',
        u'GNB-CU-TNL-Association-Failed-To-Setup-Item',
        u'GNB-CU-TNL-Association-To-Add-Item',
        u'GNB-CU-TNL-Association-To-Remove-Item',
        u'GNB-CU-TNL-Association-To-Update-Item',
        u'GNB-CU-UE-F1AP-ID',
        u'GNB-DU-Cell-Resource-Configuration',
        u'GNB-DU-UE-F1AP-ID',
        u'GNB-DU-ID',
        u'GNB-CU-Name',
        u'GNB-DU-Name',
        u'Extended-GNB-CU-Name',
        u'GNB-CU-NameVisibleString',
        u'GNB-CU-NameUTF8String',
        u'Extended-GNB-DU-Name',
        u'GNB-DU-NameVisibleString',
        u'GNB-DU-NameUTF8String',
        u'GNB-DU-Served-Cells-Item',
        u'GNB-DU-System-Information',
        u'GNB-DUConfigurationQuery',
        u'GNBDUOverloadInformation',
        u'GNB-DU-TNL-Association-To-Remove-Item',
        u'GNB-RxTxTimeDiff',
        u'GNBRxTxTimeDiffMeas',
        u'GNBSetID',
        u'GTP-TEID',
        u'GTPTLAs',
        u'GTPTLA-Item',
        u'GTPTunnel',
        u'HandoverPreparationInformation',
        u'HardwareLoadIndicator',
        u'HSNASlotConfigList',
        u'HSNASlotConfigItem',
        u'HSNADownlink',
        u'HSNAFlexible',
        u'HSNAUplink',
        u'HSNATransmissionPeriodicity',
        u'IAB-Barred',
        u'IAB-Info-IAB-donor-CU',
        u'IAB-Info-IAB-DU',
        u'IAB-MT-Cell-List',
        u'IAB-MT-Cell-List-Item',
        u'IAB-STC-Info',
        u'IAB-STC-Info-List',
        u'IAB-STC-Info-Item',
        u'IAB-Allocated-TNL-Address-Item',
        u'IAB-DU-Cell-Resource-Configuration-Mode-Info',
        u'IAB-DU-Cell-Resource-Configuration-FDD-Info',
        u'IAB-DU-Cell-Resource-Configuration-TDD-Info',
        u'IABIPv6RequestType',
        u'IABTNLAddress',
        u'IABTNLAddressesRequested',
        u'IAB-TNL-Addresses-To-Remove-Item',
        u'IABTNLAddressUsage',
        u'IABv4AddressesRequested',
        u'ImplicitFormat',
        u'IgnorePRACHConfiguration',
        u'IgnoreResourceCoordinationContainer',
        u'InactivityMonitoringRequest',
        u'InactivityMonitoringResponse',
        u'InterfacesToTrace',
        u'IntendedTDD-DL-ULConfig',
        u'IPHeaderInformation',
        u'IPtolayer2TrafficMappingInfo',
        u'IPtolayer2TrafficMappingInfoList',
        u'IPtolayer2TrafficMappingInfo-Item',
        u'L139Info',
        u'L839Info',
        u'LCID',
        u'LCS-to-GCS-TranslationAoA',
        u'LCStoGCSTranslationList',
        u'LCStoGCSTranslation',
        u'LMF-MeasurementID',
        u'LMF-UE-MeasurementID',
        u'LocationMeasurementInformation',
        u'LocationUncertainty',
        u'LongDRXCycleLength',
        u'LowerLayerPresenceStatusChange',
        u'LTEUESidelinkAggregateMaximumBitrate',
        u'LTEV2XServicesAuthorized',
        u'MappingInformationIndex',
        u'MappingInformationtoRemove',
        u'MaskedIMEISV',
        u'MaxDataBurstVolume',
        u'MaxPacketLossRate',
        u'MIB-message',
        u'MeasConfig',
        u'MeasGapConfig',
        u'MeasGapSharingConfig',
        u'MeasurementBeamInfoRequest',
        u'MeasurementBeamInfo',
        u'MeasurementTimingConfiguration',
        u'MessageIdentifier',
        u'MultiplexingInfo',
        u'M2Configuration',
        u'M5Configuration',
        u'M5period',
        u'M5-Links-to-log',
        u'M6Configuration',
        u'M6report-Interval',
        u'M6-Links-to-log',
        u'M7Configuration',
        u'M7period',
        u'M7-Links-to-log',
        u'MDT-Activation',
        u'MDTConfiguration',
        u'MDTPLMNList',
        u'MeasuredResultsValue',
        u'MeasurementsToActivate',
        u'NeedforGap',
        u'Neighbour-Cell-Information-Item',
        u'NGRANAllocationAndRetentionPriority',
        u'NGRANHighAccuracyAccessPointPosition',
        u'NID',
        u'NR-CGI-List-For-Restart-Item',
        u'NR-PRSBeamInformation',
        u'NR-PRSBeamInformationList',
        u'NR-PRSBeamInformationItem',
        u'NonDynamic5QIDescriptor',
        u'NonDynamicPQIDescriptor',
        u'NonUPTrafficType',
        u'NoofDownlinkSymbols',
        u'NoofUplinkSymbols',
        u'Notification-Cause',
        u'NotificationControl',
        u'NotificationInformation',
        u'NPNBroadcastInformation',
        u'NPN-Broadcast-Information-SNPN',
        u'NPN-Broadcast-Information-PNI-NPN',
        u'NPNSupportInfo',
        u'NRCarrierList',
        u'NRCarrierItem',
        u'NRFreqInfo',
        u'NRCGI',
        u'NR-Mode-Info',
        u'NRPRACHConfig',
        u'NRCellIdentity',
        u'NRNRB',
        u'NRPCI',
        u'NRPRACHConfigList',
        u'NRPRACHConfigItem',
        u'NRSCS',
        u'NRUERLFReportContainer',
        u'NumberofActiveUEs',
        u'NumberOfBroadcasts',
        u'NumberofBroadcastRequest',
        u'NumDLULSymbols',
        u'NRV2XServicesAuthorized',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'NZP-CSI-RS-ResourceID',
        u'OffsetToPointA',
        u'PacketDelayBudget',
        u'PacketErrorRate',
        u'PER-Scalar',
        u'PER-Exponent',
        u'PagingCell-Item',
        u'PagingDRX',
        u'PagingIdentity',
        u'PagingOrigin',
        u'PagingPriority',
        u'RelativePathDelay',
        u'PathlossReferenceInfo',
        u'PathlossReferenceSignal',
        u'PC5QoSFlowIdentifier',
        u'PC5-QoS-Characteristics',
        u'PC5QoSParameters',
        u'PC5FlowBitRates',
        u'PDCCH-BlindDetectionSCG',
        u'PDCP-SN',
        u'PDCPSNLength',
        u'PDUSessionID',
        u'ReportingPeriodicityValue',
        u'Periodicity',
        u'PeriodicitySRS',
        u'PeriodicityList',
        u'PeriodicityList-Item',
        u'Permutation',
        u'Ph-InfoMCG',
        u'Ph-InfoSCG',
        u'PLMN-Identity',
        u'PortNumber',
        u'PosAssistance-Information',
        u'PosAssistanceInformationFailureList',
        u'PosBroadcast',
        u'PositioningBroadcastCells',
        u'MeasurementPeriodicity',
        u'MeasurementPeriodicityExtended',
        u'PosMeasurementQuantities',
        u'PosMeasurementQuantities-Item',
        u'PosMeasurementResult',
        u'PosMeasurementResultItem',
        u'PosMeasurementResultList',
        u'PosMeasurementResultList-Item',
        u'PosMeasurementType',
        u'PosReportCharacteristics',
        u'PosResourceSetType',
        u'PosResourceSetTypePR',
        u'PosResourceSetTypeSP',
        u'PosResourceSetTypeAP',
        u'PosSRSResourceID-List',
        u'PosSRSResource-Item',
        u'PosSRSResource-List',
        u'PosSRSResourceSet-Item',
        u'PosSRSResourceSet-List',
        u'PrimaryPathIndication',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProtectedEUTRAResourceIndication',
        u'Protected-EUTRA-Resources-Item',
        u'PRSConfiguration',
        u'PRSInformationPos',
        u'Potential-SpCell-Item',
        u'PRSAngleList',
        u'PRSAngleItem',
        u'PRSMuting',
        u'PRSMutingOption1',
        u'PRSMutingOption2',
        u'PRS-Resource-ID',
        u'PRSResource-List',
        u'PRSResource-Item',
        u'PRSResource-QCLInfo',
        u'PRSResource-QCLSourceSSB',
        u'PRSResource-QCLSourcePRS',
        u'PRS-Resource-Set-ID',
        u'PRSResourceSet-List',
        u'PRSResourceSet-Item',
        u'PWS-Failed-NR-CGI-Item',
        u'PWSSystemInformation',
        u'PrivacyIndicator',
        u'QCI',
        u'QoS-Characteristics',
        u'QoSFlowIdentifier',
        u'QoSFlowLevelQoSParameters',
        u'QoSFlowMappingIndication',
        u'QoSInformation',
        u'QosMonitoringRequest',
        u'QoSParaSetIndex',
        u'QoSParaSetNotifyIndex',
        u'RACH-Config-Common',
        u'RACH-Config-Common-IAB',
        u'RACHReportContainer',
        u'RACHReportInformationList',
        u'RACHReportInformationItem',
        u'RadioResourceStatus',
        u'RANAC',
        u'RAN-MeasurementID',
        u'RAN-UE-MeasurementID',
        u'RANUEID',
        u'RANUEPagingIdentity',
        u'RAT-FrequencyPriorityInformation',
        u'RAT-FrequencySelectionPriority',
        u'Reestablishment-Indication',
        u'ReferencePoint',
        u'ReferenceSFN',
        u'ReferenceSignal',
        u'RelativeCartesianLocation',
        u'RelativeGeodeticLocation',
        u'ReferenceTime',
        u'RegistrationRequest',
        u'ReportCharacteristics',
        u'ReportingPeriodicity',
        u'RequestedBandCombinationIndex',
        u'RequestedFeatureSetEntryIndex',
        u'RequestedP-MaxFR2',
        u'Requested-PDCCH-BlindDetectionSCG',
        u'RequestedSRSTransmissionCharacteristics',
        u'RequestType',
        u'ResourceCoordinationEUTRACellInfo',
        u'ResourceCoordinationTransferInformation',
        u'ResourceCoordinationTransferContainer',
        u'ResourceSetType',
        u'ResourceSetTypePeriodic',
        u'ResourceSetTypeSemi-persistent',
        u'ResourceSetTypeAperiodic',
        u'RepetitionPeriod',
        u'ReportingRequestType',
        u'ResourceType',
        u'ResourceTypePeriodic',
        u'ResourceTypeSemi-persistent',
        u'ResourceTypeAperiodic',
        u'ResourceTypePos',
        u'ResourceTypePeriodicPos',
        u'ResourceTypeSemi-persistentPos',
        u'ResourceTypeAperiodicPos',
        u'RLCDuplicationInformation',
        u'RLCDuplicationStateList',
        u'RLCDuplicationState-Item',
        u'RLCFailureIndication',
        u'RLCMode',
        u'RLC-Status',
        u'RLFReportInformationList',
        u'RLFReportInformationItem',
        u'RIMRSDetectionStatus',
        u'RRCContainer',
        u'RRCContainer-RRCSetupComplete',
        u'RRCDeliveryStatus',
        u'RRCDeliveryStatusRequest',
        u'RRCReconfigurationCompleteIndicator',
        u'RRC-Version',
        u'RoutingID',
        u'SCell-FailedtoSetup-Item',
        u'SCell-FailedtoSetupMod-Item',
        u'SCell-ToBeRemoved-Item',
        u'SCell-ToBeSetup-Item',
        u'SCell-ToBeSetupMod-Item',
        u'SCellIndex',
        u'SCGIndicator',
        u'SCS-SpecificCarrier',
        u'Search-window-information',
        u'SerialNumber',
        u'SIBType-PWS',
        u'SelectedBandCombinationIndex',
        u'SelectedFeatureSetEntryIndex',
        u'CG-ConfigInfo',
        u'ServCellIndex',
        u'ServingCellMO',
        u'Served-Cell-Information',
        u'SFN-Offset',
        u'Served-Cells-To-Add-Item',
        u'Served-Cells-To-Delete-Item',
        u'Served-Cells-To-Modify-Item',
        u'Served-EUTRA-Cells-Information',
        u'Service-State',
        u'Service-Status',
        u'RelativeTime1900',
        u'ShortDRXCycleLength',
        u'ShortDRXCycleTimer',
        u'SIB1-message',
        u'SIB10-message',
        u'SIB12-message',
        u'SIB13-message',
        u'SIB14-message',
        u'SItype',
        u'SItype-List',
        u'SItype-Item',
        u'SibtypetobeupdatedListItem',
        u'SLDRBID',
        u'SLDRBInformation',
        u'SLDRBs-FailedToBeModified-Item',
        u'SLDRBs-FailedToBeSetup-Item',
        u'SLDRBs-FailedToBeSetupMod-Item',
        u'SLDRBs-Modified-Item',
        u'SLDRBs-ModifiedConf-Item',
        u'SLDRBs-Required-ToBeModified-Item',
        u'SLDRBs-Required-ToBeReleased-Item',
        u'SLDRBs-Setup-Item',
        u'SLDRBs-SetupMod-Item',
        u'SLDRBs-ToBeModified-Item',
        u'SLDRBs-ToBeReleased-Item',
        u'SLDRBs-ToBeSetup-Item',
        u'SLDRBs-ToBeSetupMod-Item',
        u'SL-PHY-MAC-RLC-Config',
        u'SL-ConfigDedicatedEUTRA-Info',
        u'SliceAvailableCapacity',
        u'SliceAvailableCapacityList',
        u'SliceAvailableCapacityItem',
        u'SNSSAIAvailableCapacity-List',
        u'SNSSAIAvailableCapacity-Item',
        u'SliceSupportList',
        u'SliceSupportItem',
        u'SliceToReportList',
        u'SliceToReportItem',
        u'SlotNumber',
        u'SNSSAI-list',
        u'SNSSAI-Item',
        u'Slot-Configuration-List',
        u'Slot-Configuration-Item',
        u'SNSSAI',
        u'SpatialDirectionInformation',
        u'SpatialRelationInfo',
        u'SpatialRelationforResourceID',
        u'SpatialRelationforResourceIDItem',
        u'SpatialRelationPerSRSResource',
        u'SpatialRelationPerSRSResource-List',
        u'SpatialRelationPerSRSResourceItem',
        u'SpatialRelationPos',
        u'SpectrumSharingGroupID',
        u'SRBID',
        u'SRBs-FailedToBeSetup-Item',
        u'SRBs-FailedToBeSetupMod-Item',
        u'SRBs-Modified-Item',
        u'SRBs-Required-ToBeReleased-Item',
        u'SRBs-Setup-Item',
        u'SRBs-SetupMod-Item',
        u'SRBs-ToBeReleased-Item',
        u'SRBs-ToBeSetup-Item',
        u'SRBs-ToBeSetupMod-Item',
        u'SRSCarrier-List',
        u'SRSCarrier-List-Item',
        u'SRSConfig',
        u'SRSConfiguration',
        u'SrsFrequency',
        u'SRSPosResourceID',
        u'SRSResource',
        u'SRSResourceID',
        u'SRSResourceID-List',
        u'SRSResource-List',
        u'SRSResourceSet',
        u'SRSResourceSetID',
        u'SRSResourceSetList',
        u'SRSResourceSetItem',
        u'SRSResourceSet-List',
        u'SRSResourceTrigger',
        u'SSB',
        u'SSB-freqInfo',
        u'SSB-Index',
        u'SSB-subcarrierSpacing',
        u'SSB-transmissionPeriodicity',
        u'SSB-transmissionTimingOffset',
        u'SSB-transmissionBitmap',
        u'SSBAreaCapacityValueList',
        u'SSBAreaCapacityValueItem',
        u'SSBAreaRadioResourceStatusList',
        u'SSBAreaRadioResourceStatusItem',
        u'SSBInformation',
        u'SSBInformationList',
        u'SSBInformationItem',
        u'SSB-PositionsInBurst',
        u'SSB-TF-Configuration',
        u'SSBToReportList',
        u'SSBToReportItem',
        u'SUL-Information',
        u'SubcarrierSpacing',
        u'SubscriberProfileIDforRFP',
        u'SULAccessIndication',
        u'SupportedSULFreqBandItem',
        u'SymbolAllocInSlot',
        u'SystemFrameNumber',
        u'SystemInformationAreaID',
        u'FiveGS-TAC',
        u'Configured-EPS-TAC',
        u'TargetCellList',
        u'TargetCellList-Item',
        u'TDD-Info',
        u'TDD-UL-DLConfigCommonNR',
        u'TimeReferenceInformation',
        u'TimeInformationType',
        u'TimeStamp',
        u'TimeStampSlotIndex',
        u'TimeToWait',
        u'TimingMeasurementQuality',
        u'TNLAssociationUsage',
        u'TNLCapacityIndicator',
        u'TraceActivation',
        u'TraceDepth',
        u'TraceID',
        u'TrafficMappingInfo',
        u'TransportLayerAddress',
        u'TransactionID',
        u'Transmission-Bandwidth',
        u'TransmissionComb',
        u'TransmissionCombPos',
        u'TransmissionStopIndicator',
        u'Transport-UP-Layer-Address-Info-To-Add-List',
        u'Transport-UP-Layer-Address-Info-To-Add-Item',
        u'Transport-UP-Layer-Address-Info-To-Remove-List',
        u'Transport-UP-Layer-Address-Info-To-Remove-Item',
        u'TransmissionActionIndicator',
        u'TRPID',
        u'TRPInformation',
        u'TRPInformationItem',
        u'TRPInformationTypeItem',
        u'TRPInformationTypeResponseList',
        u'TRPInformationTypeResponseItem',
        u'TRPList',
        u'TRPListItem',
        u'TRPMeasurementQuality',
        u'TRPMeasurementQuality-Item',
        u'TRP-MeasurementRequestList',
        u'TRP-MeasurementRequestItem',
        u'TRPPositionDefinitionType',
        u'TRPPositionDirect',
        u'TRPPositionDirectAccuracy',
        u'TRPPositionReferenced',
        u'TRPReferencePointType',
        u'TypeOfError',
        u'Transport-Layer-Address-Info',
        u'TRPType',
        u'TSCAssistanceInformation',
        u'TSCTrafficCharacteristics',
        u'UAC-Assistance-Info',
        u'UACPLMN-List',
        u'UACPLMN-Item',
        u'UACType-List',
        u'UACType-Item',
        u'UACCategoryType',
        u'UACOperatorDefined',
        u'UACAction',
        u'UACReductionIndication',
        u'UE-associatedLogicalF1-ConnectionItem',
        u'UEAssistanceInformation',
        u'UEAssistanceInformationEUTRA',
        u'UE-CapabilityRAT-ContainerList',
        u'UEContextNotRetrievable',
        u'UEIdentityIndexValue',
        u'UL-AoA',
        u'UL-BH-Non-UP-Traffic-Mapping',
        u'UL-BH-Non-UP-Traffic-Mapping-List',
        u'UL-BH-Non-UP-Traffic-Mapping-Item',
        u'ULConfiguration',
        u'UL-RTOA-Measurement',
        u'UL-RTOA-MeasurementItem',
        u'UL-SRS-RSRP',
        u'ULUEConfiguration',
        u'UL-UP-TNL-Information-to-Update-List-Item',
        u'UL-UP-TNL-Address-to-Update-List-Item',
        u'ULUPTNLInformation-ToBeSetup-List',
        u'ULUPTNLInformation-ToBeSetup-Item',
        u'Uncertainty',
        u'UplinkChannelBW-PerSCS-List',
        u'UplinkTxDirectCurrentListInformation',
        u'UPTransportLayerInformation',
        u'URI-address',
        u'VictimgNBSetID',
        u'VehicleUE',
        u'PedestrianUE',
        ]
    _set_ = [
        u'AbortTransmission-ExtIEs',
        u'AccessPointPosition-ExtIEs',
        u'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalPath-Item-ExtIEs',
        u'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        u'AdditionalSIBMessageList-Item-ExtIEs',
        u'AggressorCellList-Item-ExtIEs',
        u'AggressorgNBSetID-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AngleMeasurementQuality-ExtIEs',
        u'Associated-SCell-ItemExtIEs',
        u'AvailablePLMNList-Item-ExtIEs',
        u'AvailableSNPN-ID-List-ItemExtIEs',
        u'BandwidthSRS-ExtIEs',
        u'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        u'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        u'BAPRoutingIDExtIEs',
        u'BHChannels-FailedToBeModified-ItemExtIEs',
        u'BHChannels-FailedToBeSetup-ItemExtIEs',
        u'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        u'BHChannels-Modified-ItemExtIEs',
        u'BHChannels-Required-ToBeReleased-ItemExtIEs',
        u'BHChannels-Setup-ItemExtIEs',
        u'BHChannels-SetupMod-ItemExtIEs',
        u'BHChannels-ToBeModified-ItemExtIEs',
        u'BHChannels-ToBeReleased-ItemExtIEs',
        u'BHChannels-ToBeSetup-ItemExtIEs',
        u'BHChannels-ToBeSetupMod-ItemExtIEs',
        u'BHInfo-ExtIEs',
        u'BHQoSInformation-ExtIEs',
        u'BH-Routing-Information-Added-List-ItemExtIEs',
        u'BH-Routing-Information-Removed-List-ItemExtIEs',
        u'BPLMN-ID-Info-ItemExtIEs',
        u'ServedPLMNs-ItemExtIEs',
        u'BroadcastSNPN-ID-List-ItemExtIEs',
        u'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        u'Candidate-SpCell-ItemExtIEs',
        u'CapacityValue-ExtIEs',
        u'Cause-ExtIEs',
        u'CellMeasurementResultItem-ExtIEs',
        u'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        u'Cells-Status-ItemExtIEs',
        u'Cells-To-Be-Broadcast-ItemExtIEs',
        u'Cells-Broadcast-Completed-ItemExtIEs',
        u'Broadcast-To-Be-Cancelled-ItemExtIEs',
        u'Cells-Broadcast-Cancelled-ItemExtIEs',
        u'Cells-to-be-Activated-List-ItemExtIEs',
        u'Cells-to-be-Deactivated-List-ItemExtIEs',
        u'Cells-to-be-Barred-Item-ExtIEs',
        u'CellToReportItem-ExtIEs',
        u'CellType-ExtIEs',
        u'Child-Node-Cells-List-Item-ExtIEs',
        u'Child-Nodes-List-Item-ExtIEs',
        u'CNUEPagingIdentity-ExtIEs',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'CompositeAvailableCapacity-ExtIEs',
        u'ConditionalInterDUMobilityInformation-ExtIEs',
        u'ConditionalIntraDUMobilityInformation-ExtIEs',
        u'CP-TransportLayerAddress-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'CUDURadioInformationType-ExtIEs',
        u'CUDURIMInformation-ExtIEs',
        u'CUtoDURRCInformation-ExtIEs',
        u'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'DRB-Activity-ItemExtIEs',
        u'DRBs-FailedToBeModified-ItemExtIEs',
        u'DRBs-FailedToBeSetup-ItemExtIEs',
        u'DRBs-FailedToBeSetupMod-ItemExtIEs',
        u'DRB-Information-ItemExtIEs',
        u'DRBs-Modified-ItemExtIEs',
        u'DRBs-ModifiedConf-ItemExtIEs',
        u'DRB-Notify-ItemExtIEs',
        u'DRBs-Required-ToBeModified-ItemExtIEs',
        u'DRBs-Required-ToBeReleased-ItemExtIEs',
        u'DRBs-Setup-ItemExtIEs',
        u'DRBs-SetupMod-ItemExtIEs',
        u'DRBs-ToBeModified-ItemExtIEs',
        u'DRBs-ToBeReleased-ItemExtIEs',
        u'DRBs-ToBeSetup-ItemExtIEs',
        u'DRBs-ToBeSetupMod-ItemExtIEs',
        u'DRXCycle-ExtIEs',
        u'DUCURadioInformationType-ExtIEs',
        u'DUCURIMInformation-ExtIEs',
        u'DUF-Slot-Config-Item-ExtIEs',
        u'DUtoCURRCInformation-ExtIEs',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'DynamicPQIDescriptor-ExtIEs',
        u'E-CID-MeasurementQuantities-ItemIEs',
        u'E-CID-MeasurementQuantitiesValue-ExtIEs',
        u'E-CID-MeasurementResult-ExtIEs',
        u'E-CID-MeasuredResults-Item-ExtIEs',
        u'E-CID-MeasuredResults-Value-ExtIEs',
        u'EgressBHRLCCHItemExtIEs',
        u'Endpoint-IP-address-and-port-ExtIEs',
        u'ExplicitFormat-ExtIEs',
        u'ExtendedAvailablePLMN-Item-ExtIEs',
        u'ExtendedServedPLMNs-ItemExtIEs',
        u'EUTRACells-List-itemExtIEs',
        u'EUTRA-Coex-FDD-Info-ExtIEs',
        u'EUTRA-Coex-TDD-Info-ExtIEs',
        u'EUTRA-PRACH-Configuration-ExtIEs',
        u'EUTRA-SpecialSubframe-Info-ExtIEs',
        u'EUTRANQoS-ExtIEs',
        u'EUTRA-Mode-Info-ExtIEs',
        u'EUTRA-FDD-Info-ExtIEs',
        u'EUTRA-TDD-Info-ExtIEs',
        u'F1CTransferPath-ExtIEs',
        u'FDD-Info-ExtIEs',
        u'Flows-Mapped-To-DRB-ItemExtIEs',
        u'FreqBandNrItem-ExtIEs',
        u'FreqDomainLength-ExtIEs',
        u'FlowsMappedToSLDRB-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GBR-QosFlowInformation-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GNB-CUSystemInformation-ExtIEs',
        u'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        u'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        u'Extended-GNB-CU-Name-ExtIEs',
        u'Extended-GNB-DU-Name-ExtIEs',
        u'GNB-DU-Served-Cells-ItemExtIEs',
        u'GNB-DU-System-Information-ExtIEs',
        u'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'GTPTLA-Item-ExtIEs',
        u'GTPTunnel-ExtIEs',
        u'HardwareLoadIndicator-ExtIEs',
        u'HSNASlotConfigItem-ExtIEs',
        u'IAB-Info-IAB-donor-CU-ExtIEs',
        u'IAB-Info-IAB-DU-ExtIEs',
        u'IAB-MT-Cell-List-Item-ExtIEs',
        u'IAB-STC-Info-ExtIEs',
        u'IAB-STC-Info-Item-ExtIEs',
        u'IAB-Allocated-TNL-Address-Item-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        u'IABIPv6RequestType-ExtIEs',
        u'IABTNLAddress-ExtIEs',
        u'IABTNLAddressesRequested-ExtIEs',
        u'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        u'IABv4AddressesRequested-ExtIEs',
        u'ImplicitFormat-ExtIEs',
        u'IntendedTDD-DL-ULConfig-ExtIEs',
        u'IPHeaderInformation-ItemExtIEs',
        u'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        u'L139Info-ExtIEs',
        u'L839Info-ExtIEs',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCStoGCSTranslation-ExtIEs',
        u'LocationUncertainty-ExtIEs',
        u'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'MeasurementBeamInfo-ExtIEs',
        u'MultiplexingInfo-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDTConfiguration-ExtIEs',
        u'MeasuredResultsValue-ExtIEs',
        u'Neighbour-Cell-Information-ItemExtIEs',
        u'NGRANAllocationAndRetentionPriority-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NR-CGI-List-For-Restart-ItemExtIEs',
        u'NR-PRSBeamInformation-ExtIEs',
        u'NR-PRSBeamInformationItem-ExtIEs',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NonDynamicPQIDescriptor-ExtIEs',
        u'NotificationInformationExtIEs',
        u'NPNBroadcastInformation-ExtIEs',
        u'NPN-Broadcast-Information-SNPN-ExtIEs',
        u'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        u'NPNSupportInfo-ExtIEs',
        u'NRCarrierItem-ExtIEs',
        u'NRFreqInfoExtIEs',
        u'NRCGI-ExtIEs',
        u'NR-Mode-Info-ExtIEs',
        u'NRPRACHConfig-ExtIEs',
        u'NRPRACHConfigItem-ExtIEs',
        u'NumDLULSymbols-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'PacketErrorRate-ExtIEs',
        u'PagingCell-ItemExtIEs',
        u'PagingIdentity-ExtIEs',
        u'RelativePathDelay-ExtIEs',
        u'PathlossReferenceInfo-ExtIEs',
        u'PathlossReferenceSignal-ExtIEs',
        u'PC5-QoS-Characteristics-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'PeriodicityList-ItemExtIEs',
        u'PosMeasurementQuantities-ItemExtIEs',
        u'PosMeasurementResultItemExtIEs',
        u'PosMeasurementResultList-ItemExtIEs',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePR-ExtIEs',
        u'PosResourceSetTypeSP-ExtIEs',
        u'PosResourceSetTypeAP-ExtIEs',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'Protected-EUTRA-Resources-ItemExtIEs',
        u'PRSConfiguration-ExtIEs',
        u'PRSInformationPos-ExtIEs',
        u'Potential-SpCell-ItemExtIEs',
        u'PRSAngleItem-ItemExtIEs',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2-ExtIEs',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRSResourceSet-Item-ExtIEs',
        u'PWS-Failed-NR-CGI-ItemExtIEs',
        u'PWSSystemInformationExtIEs',
        u'QoS-Characteristics-ExtIEs',
        u'QoSFlowLevelQoSParameters-ExtIEs',
        u'QoSInformation-ExtIEs',
        u'RACHReportInformationItem-ExtIEs',
        u'RadioResourceStatus-ExtIEs',
        u'RANUEPagingIdentity-ExtIEs',
        u'RAT-FrequencyPriorityInformation-ExtIEs',
        u'ReferencePoint-ExtIEs',
        u'ReferenceSignal-ExtIEs',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativeGeodeticLocation-ExtIEs',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'ResourceCoordinationEUTRACellInfo-ExtIEs',
        u'ResourceCoordinationTransferInformation-ExtIEs',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'ReportingRequestType-ExtIEs',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'RLCDuplicationInformation-ExtIEs',
        u'RLCDuplicationState-Item-ExtIEs',
        u'RLCFailureIndication-ExtIEs',
        u'RLC-Status-ExtIEs',
        u'RLFReportInformationItem-ExtIEs',
        u'RRCDeliveryStatus-ExtIEs',
        u'RRC-Version-ExtIEs',
        u'SCell-FailedtoSetup-ItemExtIEs',
        u'SCell-FailedtoSetupMod-ItemExtIEs',
        u'SCell-ToBeRemoved-ItemExtIEs',
        u'SCell-ToBeSetup-ItemExtIEs',
        u'SCell-ToBeSetupMod-ItemExtIEs',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information-ExtIEs',
        u'Served-Cell-Information-ExtIEs',
        u'SFN-Offset-ExtIEs',
        u'Served-Cells-To-Add-ItemExtIEs',
        u'Served-Cells-To-Delete-ItemExtIEs',
        u'Served-Cells-To-Modify-ItemExtIEs',
        u'Served-EUTRA-Cell-Information-ExtIEs',
        u'Service-Status-ExtIEs',
        u'SItype-ItemExtIEs',
        u'SibtypetobeupdatedListItem-ExtIEs',
        u'SLDRBs-FailedToBeModified-ItemExtIEs',
        u'SLDRBs-FailedToBeSetup-ItemExtIEs',
        u'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SLDRBs-Modified-ItemExtIEs',
        u'SLDRBs-ModifiedConf-ItemExtIEs',
        u'SLDRBs-Required-ToBeModified-ItemExtIEs',
        u'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        u'SLDRBs-Setup-ItemExtIEs',
        u'SLDRBs-SetupMod-ItemExtIEs',
        u'SLDRBs-ToBeModified-ItemExtIEs',
        u'SLDRBs-ToBeReleased-ItemExtIEs',
        u'SLDRBs-ToBeSetup-ItemExtIEs',
        u'SLDRBs-ToBeSetupMod-ItemExtIEs',
        u'SliceAvailableCapacity-ExtIEs',
        u'SliceAvailableCapacityItem-ExtIEs',
        u'SNSSAIAvailableCapacity-Item-ExtIEs',
        u'SliceSupportItem-ExtIEs',
        u'SliceToReportItem-ExtIEs',
        u'SNSSAI-Item-ExtIEs',
        u'Slot-Configuration-ItemExtIEs',
        u'SNSSAI-ExtIEs',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialInformationPos-ExtIEs',
        u'SRBs-FailedToBeSetup-ItemExtIEs',
        u'SRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SRBs-Modified-ItemExtIEs',
        u'SRBs-Required-ToBeReleased-ItemExtIEs',
        u'SRBs-Setup-ItemExtIEs',
        u'SRBs-SetupMod-ItemExtIEs',
        u'SRBs-ToBeReleased-ItemExtIEs',
        u'SRBs-ToBeSetup-ItemExtIEs',
        u'SRBs-ToBeSetupMod-ItemExtIEs',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfig-ExtIEs',
        u'SRSConfiguration-ExtIEs',
        u'SRSResource-ExtIEs',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceSetItemExtIEs',
        u'SRSResourceTrigger-ExtIEs',
        u'SSB-ExtIEs',
        u'SSB-transmisisonBitmap-ExtIEs',
        u'SSBAreaCapacityValueItem-ExtIEs',
        u'SSBAreaRadioResourceStatusItem-ExtIEs',
        u'SSBInformation-ExtIEs',
        u'SSBInformationItem-ExtIEs',
        u'SSB-PositionsInBurst-ExtIEs',
        u'SSB-TF-Configuration-ExtIEs',
        u'SSBToReportItem-ExtIEs',
        u'SUL-InformationExtIEs',
        u'SupportedSULFreqBandItem-ExtIEs',
        u'SymbolAllocInSlot-ExtIEs',
        u'TargetCellList-Item-ExtIEs',
        u'TDD-Info-ExtIEs',
        u'TimeReferenceInformation-ExtIEs',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex-ExtIEs',
        u'TimingMeasurementQuality-ExtIEs',
        u'TNLCapacityIndicator-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'TrafficMappingInfo-ExtIEs',
        u'Transmission-Bandwidth-ExtIEs',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos-ExtIEs',
        u'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        u'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        u'TRPInformation-ExtIEs',
        u'TRPInformationItem-ExtIEs',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPListItem-ExtIEs',
        u'TRPMeasurementQuality-ExtIEs',
        u'TRPMeasurementQuality-Item-ExtIEs',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType-ExtIEs',
        u'Transport-Layer-Address-Info-ExtIEs',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UAC-Assistance-InfoExtIEs',
        u'UACPLMN-Item-ExtIEs',
        u'UACType-Item-ExtIEs',
        u'UACCategoryType-ExtIEs',
        u'UACOperatorDefined-ExtIEs',
        u'UE-associatedLogicalF1-ConnectionItemExtIEs',
        u'UEIdentityIndexValueChoice-ExtIEs',
        u'UL-AoA-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        u'ULConfigurationExtIEs',
        u'UL-RTOA-Measurement-ExtIEs',
        u'UL-RTOA-MeasurementItem-ExtIEs',
        u'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        u'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'UPTransportLayerInformation-ExtIEs',
        u'VictimgNBSetID-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'AbortTransmission-ExtIEs',
        u'AccessPointPosition-ExtIEs',
        u'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalPath-Item-ExtIEs',
        u'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        u'AdditionalSIBMessageList-Item-ExtIEs',
        u'AggressorCellList-Item-ExtIEs',
        u'AggressorgNBSetID-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AngleMeasurementQuality-ExtIEs',
        u'Associated-SCell-ItemExtIEs',
        u'AvailablePLMNList-Item-ExtIEs',
        u'AvailableSNPN-ID-List-ItemExtIEs',
        u'BandwidthSRS-ExtIEs',
        u'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        u'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        u'BAPRoutingIDExtIEs',
        u'BHChannels-FailedToBeModified-ItemExtIEs',
        u'BHChannels-FailedToBeSetup-ItemExtIEs',
        u'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        u'BHChannels-Modified-ItemExtIEs',
        u'BHChannels-Required-ToBeReleased-ItemExtIEs',
        u'BHChannels-Setup-ItemExtIEs',
        u'BHChannels-SetupMod-ItemExtIEs',
        u'BHChannels-ToBeModified-ItemExtIEs',
        u'BHChannels-ToBeReleased-ItemExtIEs',
        u'BHChannels-ToBeSetup-ItemExtIEs',
        u'BHChannels-ToBeSetupMod-ItemExtIEs',
        u'BHInfo-ExtIEs',
        u'BHQoSInformation-ExtIEs',
        u'BH-Routing-Information-Added-List-ItemExtIEs',
        u'BH-Routing-Information-Removed-List-ItemExtIEs',
        u'BPLMN-ID-Info-ItemExtIEs',
        u'ServedPLMNs-ItemExtIEs',
        u'BroadcastSNPN-ID-List-ItemExtIEs',
        u'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        u'Candidate-SpCell-ItemExtIEs',
        u'CapacityValue-ExtIEs',
        u'Cause-ExtIEs',
        u'CellMeasurementResultItem-ExtIEs',
        u'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        u'Cells-Status-ItemExtIEs',
        u'Cells-To-Be-Broadcast-ItemExtIEs',
        u'Cells-Broadcast-Completed-ItemExtIEs',
        u'Broadcast-To-Be-Cancelled-ItemExtIEs',
        u'Cells-Broadcast-Cancelled-ItemExtIEs',
        u'Cells-to-be-Activated-List-ItemExtIEs',
        u'Cells-to-be-Deactivated-List-ItemExtIEs',
        u'Cells-to-be-Barred-Item-ExtIEs',
        u'CellToReportItem-ExtIEs',
        u'CellType-ExtIEs',
        u'Child-Node-Cells-List-Item-ExtIEs',
        u'Child-Nodes-List-Item-ExtIEs',
        u'CNUEPagingIdentity-ExtIEs',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'CompositeAvailableCapacity-ExtIEs',
        u'ConditionalInterDUMobilityInformation-ExtIEs',
        u'ConditionalIntraDUMobilityInformation-ExtIEs',
        u'CP-TransportLayerAddress-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'CUDURadioInformationType-ExtIEs',
        u'CUDURIMInformation-ExtIEs',
        u'CUtoDURRCInformation-ExtIEs',
        u'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'DRB-Activity-ItemExtIEs',
        u'DRBs-FailedToBeModified-ItemExtIEs',
        u'DRBs-FailedToBeSetup-ItemExtIEs',
        u'DRBs-FailedToBeSetupMod-ItemExtIEs',
        u'DRB-Information-ItemExtIEs',
        u'DRBs-Modified-ItemExtIEs',
        u'DRBs-ModifiedConf-ItemExtIEs',
        u'DRB-Notify-ItemExtIEs',
        u'DRBs-Required-ToBeModified-ItemExtIEs',
        u'DRBs-Required-ToBeReleased-ItemExtIEs',
        u'DRBs-Setup-ItemExtIEs',
        u'DRBs-SetupMod-ItemExtIEs',
        u'DRBs-ToBeModified-ItemExtIEs',
        u'DRBs-ToBeReleased-ItemExtIEs',
        u'DRBs-ToBeSetup-ItemExtIEs',
        u'DRBs-ToBeSetupMod-ItemExtIEs',
        u'DRXCycle-ExtIEs',
        u'DUCURadioInformationType-ExtIEs',
        u'DUCURIMInformation-ExtIEs',
        u'DUF-Slot-Config-Item-ExtIEs',
        u'DUtoCURRCInformation-ExtIEs',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'DynamicPQIDescriptor-ExtIEs',
        u'E-CID-MeasurementQuantities-ItemIEs',
        u'E-CID-MeasurementQuantitiesValue-ExtIEs',
        u'E-CID-MeasurementResult-ExtIEs',
        u'E-CID-MeasuredResults-Item-ExtIEs',
        u'E-CID-MeasuredResults-Value-ExtIEs',
        u'EgressBHRLCCHItemExtIEs',
        u'Endpoint-IP-address-and-port-ExtIEs',
        u'ExplicitFormat-ExtIEs',
        u'ExtendedAvailablePLMN-Item-ExtIEs',
        u'ExtendedServedPLMNs-ItemExtIEs',
        u'EUTRACells-List-itemExtIEs',
        u'EUTRA-Coex-FDD-Info-ExtIEs',
        u'EUTRA-Coex-TDD-Info-ExtIEs',
        u'EUTRA-PRACH-Configuration-ExtIEs',
        u'EUTRA-SpecialSubframe-Info-ExtIEs',
        u'EUTRANQoS-ExtIEs',
        u'EUTRA-Mode-Info-ExtIEs',
        u'EUTRA-FDD-Info-ExtIEs',
        u'EUTRA-TDD-Info-ExtIEs',
        u'F1CTransferPath-ExtIEs',
        u'FDD-Info-ExtIEs',
        u'Flows-Mapped-To-DRB-ItemExtIEs',
        u'FreqBandNrItem-ExtIEs',
        u'FreqDomainLength-ExtIEs',
        u'FlowsMappedToSLDRB-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GBR-QosFlowInformation-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GNB-CUSystemInformation-ExtIEs',
        u'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        u'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        u'Extended-GNB-CU-Name-ExtIEs',
        u'Extended-GNB-DU-Name-ExtIEs',
        u'GNB-DU-Served-Cells-ItemExtIEs',
        u'GNB-DU-System-Information-ExtIEs',
        u'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'GTPTLA-Item-ExtIEs',
        u'GTPTunnel-ExtIEs',
        u'HardwareLoadIndicator-ExtIEs',
        u'HSNASlotConfigItem-ExtIEs',
        u'IAB-Info-IAB-donor-CU-ExtIEs',
        u'IAB-Info-IAB-DU-ExtIEs',
        u'IAB-MT-Cell-List-Item-ExtIEs',
        u'IAB-STC-Info-ExtIEs',
        u'IAB-STC-Info-Item-ExtIEs',
        u'IAB-Allocated-TNL-Address-Item-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        u'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        u'IABIPv6RequestType-ExtIEs',
        u'IABTNLAddress-ExtIEs',
        u'IABTNLAddressesRequested-ExtIEs',
        u'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        u'IABv4AddressesRequested-ExtIEs',
        u'ImplicitFormat-ExtIEs',
        u'IntendedTDD-DL-ULConfig-ExtIEs',
        u'IPHeaderInformation-ItemExtIEs',
        u'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        u'L139Info-ExtIEs',
        u'L839Info-ExtIEs',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCStoGCSTranslation-ExtIEs',
        u'LocationUncertainty-ExtIEs',
        u'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'MeasurementBeamInfo-ExtIEs',
        u'MultiplexingInfo-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDTConfiguration-ExtIEs',
        u'MeasuredResultsValue-ExtIEs',
        u'Neighbour-Cell-Information-ItemExtIEs',
        u'NGRANAllocationAndRetentionPriority-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NR-CGI-List-For-Restart-ItemExtIEs',
        u'NR-PRSBeamInformation-ExtIEs',
        u'NR-PRSBeamInformationItem-ExtIEs',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NonDynamicPQIDescriptor-ExtIEs',
        u'NotificationInformationExtIEs',
        u'NPNBroadcastInformation-ExtIEs',
        u'NPN-Broadcast-Information-SNPN-ExtIEs',
        u'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        u'NPNSupportInfo-ExtIEs',
        u'NRCarrierItem-ExtIEs',
        u'NRFreqInfoExtIEs',
        u'NRCGI-ExtIEs',
        u'NR-Mode-Info-ExtIEs',
        u'NRPRACHConfig-ExtIEs',
        u'NRPRACHConfigItem-ExtIEs',
        u'NumDLULSymbols-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'PacketErrorRate-ExtIEs',
        u'PagingCell-ItemExtIEs',
        u'PagingIdentity-ExtIEs',
        u'RelativePathDelay-ExtIEs',
        u'PathlossReferenceInfo-ExtIEs',
        u'PathlossReferenceSignal-ExtIEs',
        u'PC5-QoS-Characteristics-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'PeriodicityList-ItemExtIEs',
        u'PosMeasurementQuantities-ItemExtIEs',
        u'PosMeasurementResultItemExtIEs',
        u'PosMeasurementResultList-ItemExtIEs',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePR-ExtIEs',
        u'PosResourceSetTypeSP-ExtIEs',
        u'PosResourceSetTypeAP-ExtIEs',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'Protected-EUTRA-Resources-ItemExtIEs',
        u'PRSConfiguration-ExtIEs',
        u'PRSInformationPos-ExtIEs',
        u'Potential-SpCell-ItemExtIEs',
        u'PRSAngleItem-ItemExtIEs',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2-ExtIEs',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRSResourceSet-Item-ExtIEs',
        u'PWS-Failed-NR-CGI-ItemExtIEs',
        u'PWSSystemInformationExtIEs',
        u'QoS-Characteristics-ExtIEs',
        u'QoSFlowLevelQoSParameters-ExtIEs',
        u'QoSInformation-ExtIEs',
        u'RACHReportInformationItem-ExtIEs',
        u'RadioResourceStatus-ExtIEs',
        u'RANUEPagingIdentity-ExtIEs',
        u'RAT-FrequencyPriorityInformation-ExtIEs',
        u'ReferencePoint-ExtIEs',
        u'ReferenceSignal-ExtIEs',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativeGeodeticLocation-ExtIEs',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'ResourceCoordinationEUTRACellInfo-ExtIEs',
        u'ResourceCoordinationTransferInformation-ExtIEs',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'ReportingRequestType-ExtIEs',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'RLCDuplicationInformation-ExtIEs',
        u'RLCDuplicationState-Item-ExtIEs',
        u'RLCFailureIndication-ExtIEs',
        u'RLC-Status-ExtIEs',
        u'RLFReportInformationItem-ExtIEs',
        u'RRCDeliveryStatus-ExtIEs',
        u'RRC-Version-ExtIEs',
        u'SCell-FailedtoSetup-ItemExtIEs',
        u'SCell-FailedtoSetupMod-ItemExtIEs',
        u'SCell-ToBeRemoved-ItemExtIEs',
        u'SCell-ToBeSetup-ItemExtIEs',
        u'SCell-ToBeSetupMod-ItemExtIEs',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information-ExtIEs',
        u'Served-Cell-Information-ExtIEs',
        u'SFN-Offset-ExtIEs',
        u'Served-Cells-To-Add-ItemExtIEs',
        u'Served-Cells-To-Delete-ItemExtIEs',
        u'Served-Cells-To-Modify-ItemExtIEs',
        u'Served-EUTRA-Cell-Information-ExtIEs',
        u'Service-Status-ExtIEs',
        u'SItype-ItemExtIEs',
        u'SibtypetobeupdatedListItem-ExtIEs',
        u'SLDRBs-FailedToBeModified-ItemExtIEs',
        u'SLDRBs-FailedToBeSetup-ItemExtIEs',
        u'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SLDRBs-Modified-ItemExtIEs',
        u'SLDRBs-ModifiedConf-ItemExtIEs',
        u'SLDRBs-Required-ToBeModified-ItemExtIEs',
        u'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        u'SLDRBs-Setup-ItemExtIEs',
        u'SLDRBs-SetupMod-ItemExtIEs',
        u'SLDRBs-ToBeModified-ItemExtIEs',
        u'SLDRBs-ToBeReleased-ItemExtIEs',
        u'SLDRBs-ToBeSetup-ItemExtIEs',
        u'SLDRBs-ToBeSetupMod-ItemExtIEs',
        u'SliceAvailableCapacity-ExtIEs',
        u'SliceAvailableCapacityItem-ExtIEs',
        u'SNSSAIAvailableCapacity-Item-ExtIEs',
        u'SliceSupportItem-ExtIEs',
        u'SliceToReportItem-ExtIEs',
        u'SNSSAI-Item-ExtIEs',
        u'Slot-Configuration-ItemExtIEs',
        u'SNSSAI-ExtIEs',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialInformationPos-ExtIEs',
        u'SRBs-FailedToBeSetup-ItemExtIEs',
        u'SRBs-FailedToBeSetupMod-ItemExtIEs',
        u'SRBs-Modified-ItemExtIEs',
        u'SRBs-Required-ToBeReleased-ItemExtIEs',
        u'SRBs-Setup-ItemExtIEs',
        u'SRBs-SetupMod-ItemExtIEs',
        u'SRBs-ToBeReleased-ItemExtIEs',
        u'SRBs-ToBeSetup-ItemExtIEs',
        u'SRBs-ToBeSetupMod-ItemExtIEs',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfig-ExtIEs',
        u'SRSConfiguration-ExtIEs',
        u'SRSResource-ExtIEs',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceSetItemExtIEs',
        u'SRSResourceTrigger-ExtIEs',
        u'SSB-ExtIEs',
        u'SSB-transmisisonBitmap-ExtIEs',
        u'SSBAreaCapacityValueItem-ExtIEs',
        u'SSBAreaRadioResourceStatusItem-ExtIEs',
        u'SSBInformation-ExtIEs',
        u'SSBInformationItem-ExtIEs',
        u'SSB-PositionsInBurst-ExtIEs',
        u'SSB-TF-Configuration-ExtIEs',
        u'SSBToReportItem-ExtIEs',
        u'SUL-InformationExtIEs',
        u'SupportedSULFreqBandItem-ExtIEs',
        u'SymbolAllocInSlot-ExtIEs',
        u'TargetCellList-Item-ExtIEs',
        u'TDD-Info-ExtIEs',
        u'TimeReferenceInformation-ExtIEs',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex-ExtIEs',
        u'TimingMeasurementQuality-ExtIEs',
        u'TNLCapacityIndicator-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'TrafficMappingInfo-ExtIEs',
        u'Transmission-Bandwidth-ExtIEs',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos-ExtIEs',
        u'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        u'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        u'TRPInformation-ExtIEs',
        u'TRPInformationItem-ExtIEs',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPListItem-ExtIEs',
        u'TRPMeasurementQuality-ExtIEs',
        u'TRPMeasurementQuality-Item-ExtIEs',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType-ExtIEs',
        u'Transport-Layer-Address-Info-ExtIEs',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UAC-Assistance-InfoExtIEs',
        u'UACPLMN-Item-ExtIEs',
        u'UACType-Item-ExtIEs',
        u'UACCategoryType-ExtIEs',
        u'UACOperatorDefined-ExtIEs',
        u'UE-associatedLogicalF1-ConnectionItemExtIEs',
        u'UEIdentityIndexValueChoice-ExtIEs',
        u'UL-AoA-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        u'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        u'ULConfigurationExtIEs',
        u'UL-RTOA-Measurement-ExtIEs',
        u'UL-RTOA-MeasurementItem-ExtIEs',
        u'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        u'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        u'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        u'UPTransportLayerInformation-ExtIEs',
        u'VictimgNBSetID-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AbortTransmission >-----#
    AbortTransmission = CHOICE(name=u'AbortTransmission', mode=MODE_TYPE)
    _AbortTransmission_sRSResourceSetID = INT(name=u'sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _AbortTransmission_releaseALL = NULL(name=u'releaseALL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AbortTransmission_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __AbortTransmission_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___AbortTransmission_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_id._const_tab = ___AbortTransmission_choice_extension_id_tab
    __AbortTransmission_choice_extension_id._const_tab_at = None
    __AbortTransmission_choice_extension_id._const_tab_id = u'id'
    __AbortTransmission_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___AbortTransmission_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_criticality._const_tab = ___AbortTransmission_choice_extension_criticality_tab
    __AbortTransmission_choice_extension_criticality._const_tab_at = ('..', u'id')
    __AbortTransmission_choice_extension_criticality._const_tab_id = u'criticality'
    __AbortTransmission_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___AbortTransmission_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_value._const_tab = ___AbortTransmission_choice_extension_value_tab
    __AbortTransmission_choice_extension_value._const_tab_at = ('..', u'id')
    __AbortTransmission_choice_extension_value._const_tab_id = u'Value'
    _AbortTransmission_choice_extension._cont = ASN1Dict([
        (u'id', __AbortTransmission_choice_extension_id),
        (u'criticality', __AbortTransmission_choice_extension_criticality),
        (u'value', __AbortTransmission_choice_extension_value),
        ])
    _AbortTransmission_choice_extension._ext = None
    AbortTransmission._cont = ASN1Dict([
        (u'sRSResourceSetID', _AbortTransmission_sRSResourceSetID),
        (u'releaseALL', _AbortTransmission_releaseALL),
        (u'choice-extension', _AbortTransmission_choice_extension),
        ])
    AbortTransmission._ext = None
    
    #-----< AbortTransmission-ExtIEs >-----#
    AbortTransmission_ExtIEs = CLASS(name=u'AbortTransmission-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    AbortTransmission_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AccessPointPosition >-----#
    AccessPointPosition = SEQ(name=u'AccessPointPosition', mode=MODE_TYPE)
    _AccessPointPosition_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _AccessPointPosition_latitudeSign._ext = None
    _AccessPointPosition_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _AccessPointPosition_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AccessPointPosition_directionOfAltitude = ENUM(name=u'directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_directionOfAltitude._cont = ASN1Dict([(u'height', 0), (u'depth', 1)])
    _AccessPointPosition_directionOfAltitude._ext = None
    _AccessPointPosition_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _AccessPointPosition_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _AccessPointPosition_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _AccessPointPosition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AccessPointPosition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__id._const_tab = ____AccessPointPosition_iE_Extensions__item__id_tab
    ___AccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___AccessPointPosition_iE_Extensions__item__id._const_tab_id = u'id'
    ___AccessPointPosition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab = ____AccessPointPosition_iE_Extensions__item__criticality_tab
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____AccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AccessPointPosition_iE_Extensions__item__id),
        (u'criticality', ___AccessPointPosition_iE_Extensions__item__criticality),
        (u'extensionValue', ___AccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __AccessPointPosition_iE_Extensions__item_._ext = None
    _AccessPointPosition_iE_Extensions._cont = __AccessPointPosition_iE_Extensions__item_
    _AccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AccessPointPosition._cont = ASN1Dict([
        (u'latitudeSign', _AccessPointPosition_latitudeSign),
        (u'latitude', _AccessPointPosition_latitude),
        (u'longitude', _AccessPointPosition_longitude),
        (u'directionOfAltitude', _AccessPointPosition_directionOfAltitude),
        (u'altitude', _AccessPointPosition_altitude),
        (u'uncertaintySemi-major', _AccessPointPosition_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _AccessPointPosition_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _AccessPointPosition_orientationOfMajorAxis),
        (u'uncertaintyAltitude', _AccessPointPosition_uncertaintyAltitude),
        (u'confidence', _AccessPointPosition_confidence),
        (u'iE-Extensions', _AccessPointPosition_iE_Extensions),
        ])
    AccessPointPosition._ext = None
    
    #-----< AccessPointPosition-ExtIEs >-----#
    AccessPointPosition_ExtIEs = CLASS(name=u'AccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Activated-Cells-to-be-Updated-List >-----#
    Activated_Cells_to_be_Updated_List = SEQ_OF(name=u'Activated-Cells-to-be-Updated-List', mode=MODE_TYPE)
    _Activated_Cells_to_be_Updated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List-Item')))
    Activated_Cells_to_be_Updated_List._cont = _Activated_Cells_to_be_Updated_List__item_
    Activated_Cells_to_be_Updated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Activated-Cells-to-be-Updated-List-Item >-----#
    Activated_Cells_to_be_Updated_List_Item = SEQ(name=u'Activated-Cells-to-be-Updated-List-Item', mode=MODE_TYPE)
    _Activated_Cells_to_be_Updated_List_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name=u'iAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-Mode-Info')))
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_._ext = None
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions._cont = __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Activated_Cells_to_be_Updated_List_Item._cont = ASN1Dict([
        (u'nRCGI', _Activated_Cells_to_be_Updated_List_Item_nRCGI),
        (u'iAB-DU-Cell-Resource-Configuration-Mode-Info', _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info),
        (u'iE-Extensions', _Activated_Cells_to_be_Updated_List_Item_iE_Extensions),
        ])
    Activated_Cells_to_be_Updated_List_Item._ext = None
    
    #-----< Activated-Cells-to-be-Updated-List-Item-ExtIEs >-----#
    Activated_Cells_to_be_Updated_List_Item_ExtIEs = CLASS(name=u'Activated-Cells-to-be-Updated-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Activated_Cells_to_be_Updated_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActiveULBWP >-----#
    ActiveULBWP = SEQ(name=u'ActiveULBWP', mode=MODE_TYPE)
    _ActiveULBWP_locationAndBandwidth = INT(name=u'locationAndBandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_locationAndBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37949)], ev=[], er=[])
    _ActiveULBWP_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _ActiveULBWP_subcarrierSpacing._ext = []
    _ActiveULBWP_cyclicPrefix = ENUM(name=u'cyclicPrefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_cyclicPrefix._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    _ActiveULBWP_cyclicPrefix._ext = None
    _ActiveULBWP_txDirectCurrentLocation = INT(name=u'txDirectCurrentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_txDirectCurrentLocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3301)], ev=[], er=[])
    _ActiveULBWP_shift7dot5kHz = ENUM(name=u'shift7dot5kHz', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActiveULBWP_shift7dot5kHz._cont = ASN1Dict([(u'true', 0)])
    _ActiveULBWP_shift7dot5kHz._ext = []
    _ActiveULBWP_sRSConfig = SEQ(name=u'sRSConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSConfig')))
    _ActiveULBWP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActiveULBWP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ActiveULBWP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ActiveULBWP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__id._const_tab = ____ActiveULBWP_iE_Extensions__item__id_tab
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_at = None
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_id = u'id'
    ___ActiveULBWP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab = ____ActiveULBWP_iE_Extensions__item__criticality_tab
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ActiveULBWP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab = ____ActiveULBWP_iE_Extensions__item__extensionValue_tab
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ActiveULBWP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ActiveULBWP_iE_Extensions__item__id),
        (u'criticality', ___ActiveULBWP_iE_Extensions__item__criticality),
        (u'extensionValue', ___ActiveULBWP_iE_Extensions__item__extensionValue),
        ])
    __ActiveULBWP_iE_Extensions__item_._ext = None
    _ActiveULBWP_iE_Extensions._cont = __ActiveULBWP_iE_Extensions__item_
    _ActiveULBWP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActiveULBWP._cont = ASN1Dict([
        (u'locationAndBandwidth', _ActiveULBWP_locationAndBandwidth),
        (u'subcarrierSpacing', _ActiveULBWP_subcarrierSpacing),
        (u'cyclicPrefix', _ActiveULBWP_cyclicPrefix),
        (u'txDirectCurrentLocation', _ActiveULBWP_txDirectCurrentLocation),
        (u'shift7dot5kHz', _ActiveULBWP_shift7dot5kHz),
        (u'sRSConfig', _ActiveULBWP_sRSConfig),
        (u'iE-Extensions', _ActiveULBWP_iE_Extensions),
        ])
    ActiveULBWP._ext = None
    
    #-----< ActiveULBWP-ExtIEs >-----#
    ActiveULBWP_ExtIEs = CLASS(name=u'ActiveULBWP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ActiveULBWP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalDuplicationIndication >-----#
    AdditionalDuplicationIndication = ENUM(name=u'AdditionalDuplicationIndication', mode=MODE_TYPE)
    AdditionalDuplicationIndication._cont = ASN1Dict([(u'three', 0), (u'four', 1)])
    AdditionalDuplicationIndication._ext = []
    
    #-----< AdditionalPath-List >-----#
    AdditionalPath_List = SEQ_OF(name=u'AdditionalPath-List', mode=MODE_TYPE)
    _AdditionalPath_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-Item')))
    AdditionalPath_List._cont = _AdditionalPath_List__item_
    AdditionalPath_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPath-Item >-----#
    AdditionalPath_Item = SEQ(name=u'AdditionalPath-Item', mode=MODE_TYPE)
    _AdditionalPath_Item_relativePathDelay = CHOICE(name=u'relativePathDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativePathDelay')))
    _AdditionalPath_Item_pathQuality = SEQ(name=u'pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality')), opt=True)
    _AdditionalPath_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPath_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalPath_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalPath_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalPath_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab = ____AdditionalPath_Item_iE_Extensions__item__id_tab
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalPath_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AdditionalPath_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalPath_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalPath_Item_iE_Extensions__item__criticality_tab
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AdditionalPath_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalPath_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPath_Item_iE_Extensions__item__extensionValue_tab
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalPath_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalPath_Item_iE_Extensions__item__id),
        (u'criticality', ___AdditionalPath_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalPath_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPath_Item_iE_Extensions__item_._ext = None
    _AdditionalPath_Item_iE_Extensions._cont = __AdditionalPath_Item_iE_Extensions__item_
    _AdditionalPath_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPath_Item._cont = ASN1Dict([
        (u'relativePathDelay', _AdditionalPath_Item_relativePathDelay),
        (u'pathQuality', _AdditionalPath_Item_pathQuality),
        (u'iE-Extensions', _AdditionalPath_Item_iE_Extensions),
        ])
    AdditionalPath_Item._ext = None
    
    #-----< AdditionalPath-Item-ExtIEs >-----#
    AdditionalPath_Item_ExtIEs = CLASS(name=u'AdditionalPath-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AdditionalPath_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPDCPDuplicationTNL-List >-----#
    AdditionalPDCPDuplicationTNL_List = SEQ_OF(name=u'AdditionalPDCPDuplicationTNL-List', mode=MODE_TYPE)
    _AdditionalPDCPDuplicationTNL_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-Item')))
    AdditionalPDCPDuplicationTNL_List._cont = _AdditionalPDCPDuplicationTNL_List__item_
    AdditionalPDCPDuplicationTNL_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPDCPDuplicationTNL-Item >-----#
    AdditionalPDCPDuplicationTNL_Item = SEQ(name=u'AdditionalPDCPDuplicationTNL-Item', mode=MODE_TYPE)
    _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation = CHOICE(name=u'additionalPDCPDuplicationUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id),
        (u'criticality', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_._ext = None
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions._cont = __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPDCPDuplicationTNL_Item._cont = ASN1Dict([
        (u'additionalPDCPDuplicationUPTNLInformation', _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation),
        (u'iE-Extensions', _AdditionalPDCPDuplicationTNL_Item_iE_Extensions),
        ])
    AdditionalPDCPDuplicationTNL_Item._ext = []
    
    #-----< AdditionalPDCPDuplicationTNL-ItemExtIEs >-----#
    AdditionalPDCPDuplicationTNL_ItemExtIEs = CLASS(name=u'AdditionalPDCPDuplicationTNL-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    AdditionalPDCPDuplicationTNL_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AdditionalSIBMessageList >-----#
    AdditionalSIBMessageList = SEQ_OF(name=u'AdditionalSIBMessageList', mode=MODE_TYPE)
    _AdditionalSIBMessageList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList-Item')))
    AdditionalSIBMessageList._cont = _AdditionalSIBMessageList__item_
    AdditionalSIBMessageList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< AdditionalSIBMessageList-Item >-----#
    AdditionalSIBMessageList_Item = SEQ(name=u'AdditionalSIBMessageList-Item', mode=MODE_TYPE)
    _AdditionalSIBMessageList_Item_additionalSIB = OCT_STR(name=u'additionalSIB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalSIBMessageList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalSIBMessageList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalSIBMessageList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalSIBMessageList_Item_iE_Extensions__item__id),
        (u'criticality', ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalSIBMessageList_Item_iE_Extensions__item_._ext = None
    _AdditionalSIBMessageList_Item_iE_Extensions._cont = __AdditionalSIBMessageList_Item_iE_Extensions__item_
    _AdditionalSIBMessageList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalSIBMessageList_Item._cont = ASN1Dict([
        (u'additionalSIB', _AdditionalSIBMessageList_Item_additionalSIB),
        (u'iE-Extensions', _AdditionalSIBMessageList_Item_iE_Extensions),
        ])
    AdditionalSIBMessageList_Item._ext = None
    
    #-----< AdditionalSIBMessageList-Item-ExtIEs >-----#
    AdditionalSIBMessageList_Item_ExtIEs = CLASS(name=u'AdditionalSIBMessageList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AdditionalSIBMessageList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name=u'AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AggressorCellList >-----#
    AggressorCellList = SEQ_OF(name=u'AggressorCellList', mode=MODE_TYPE)
    _AggressorCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorCellList-Item')))
    AggressorCellList._cont = _AggressorCellList__item_
    AggressorCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< AggressorCellList-Item >-----#
    AggressorCellList_Item = SEQ(name=u'AggressorCellList-Item', mode=MODE_TYPE)
    _AggressorCellList_Item_aggressorCell_ID = SEQ(name=u'aggressorCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _AggressorCellList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AggressorCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AggressorCellList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AggressorCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab = ____AggressorCellList_Item_iE_Extensions__item__id_tab
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AggressorCellList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AggressorCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab = ____AggressorCellList_Item_iE_Extensions__item__criticality_tab
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AggressorCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AggressorCellList_Item_iE_Extensions__item__id),
        (u'criticality', ___AggressorCellList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AggressorCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __AggressorCellList_Item_iE_Extensions__item_._ext = None
    _AggressorCellList_Item_iE_Extensions._cont = __AggressorCellList_Item_iE_Extensions__item_
    _AggressorCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AggressorCellList_Item._cont = ASN1Dict([
        (u'aggressorCell-ID', _AggressorCellList_Item_aggressorCell_ID),
        (u'iE-Extensions', _AggressorCellList_Item_iE_Extensions),
        ])
    AggressorCellList_Item._ext = None
    
    #-----< AggressorCellList-Item-ExtIEs >-----#
    AggressorCellList_Item_ExtIEs = CLASS(name=u'AggressorCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AggressorCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AggressorgNBSetID >-----#
    AggressorgNBSetID = SEQ(name=u'AggressorgNBSetID', mode=MODE_TYPE)
    _AggressorgNBSetID_aggressorgNBSetID = BIT_STR(name=u'aggressorgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _AggressorgNBSetID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AggressorgNBSetID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AggressorgNBSetID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AggressorgNBSetID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab = ____AggressorgNBSetID_iE_Extensions__item__id_tab
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab_at = None
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab_id = u'id'
    ___AggressorgNBSetID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AggressorgNBSetID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab = ____AggressorgNBSetID_iE_Extensions__item__criticality_tab
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab = ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AggressorgNBSetID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AggressorgNBSetID_iE_Extensions__item__id),
        (u'criticality', ___AggressorgNBSetID_iE_Extensions__item__criticality),
        (u'extensionValue', ___AggressorgNBSetID_iE_Extensions__item__extensionValue),
        ])
    __AggressorgNBSetID_iE_Extensions__item_._ext = None
    _AggressorgNBSetID_iE_Extensions._cont = __AggressorgNBSetID_iE_Extensions__item_
    _AggressorgNBSetID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AggressorgNBSetID._cont = ASN1Dict([
        (u'aggressorgNBSetID', _AggressorgNBSetID_aggressorgNBSetID),
        (u'iE-Extensions', _AggressorgNBSetID_iE_Extensions),
        ])
    AggressorgNBSetID._ext = None
    
    #-----< AggressorgNBSetID-ExtIEs >-----#
    AggressorgNBSetID_ExtIEs = CLASS(name=u'AggressorgNBSetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AggressorgNBSetID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name=u'AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name=u'AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetList >-----#
    AlternativeQoSParaSetList = SEQ_OF(name=u'AlternativeQoSParaSetList', mode=MODE_TYPE)
    _AlternativeQoSParaSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetItem')))
    AlternativeQoSParaSetList._cont = _AlternativeQoSParaSetList__item_
    AlternativeQoSParaSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetItem >-----#
    AlternativeQoSParaSetItem = SEQ(name=u'AlternativeQoSParaSetItem', mode=MODE_TYPE)
    _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex = INT(name=u'alternativeQoSParaSetIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL = INT(name=u'guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL = INT(name=u'guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_packetDelayBudget = INT(name=u'packetDelayBudget', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')), opt=True)
    _AlternativeQoSParaSetItem_packetErrorRate = SEQ(name=u'packetErrorRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')), opt=True)
    _AlternativeQoSParaSetItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlternativeQoSParaSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_at = None
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AlternativeQoSParaSetItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AlternativeQoSParaSetItem_iE_Extensions__item__id),
        (u'criticality', ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue),
        ])
    __AlternativeQoSParaSetItem_iE_Extensions__item_._ext = None
    _AlternativeQoSParaSetItem_iE_Extensions._cont = __AlternativeQoSParaSetItem_iE_Extensions__item_
    _AlternativeQoSParaSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlternativeQoSParaSetItem._cont = ASN1Dict([
        (u'alternativeQoSParaSetIndex', _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex),
        (u'guaranteedFlowBitRateDL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL),
        (u'guaranteedFlowBitRateUL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL),
        (u'packetDelayBudget', _AlternativeQoSParaSetItem_packetDelayBudget),
        (u'packetErrorRate', _AlternativeQoSParaSetItem_packetErrorRate),
        (u'iE-Extensions', _AlternativeQoSParaSetItem_iE_Extensions),
        ])
    AlternativeQoSParaSetItem._ext = []
    
    #-----< AlternativeQoSParaSetItem-ExtIEs >-----#
    AlternativeQoSParaSetItem_ExtIEs = CLASS(name=u'AlternativeQoSParaSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AlternativeQoSParaSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AngleMeasurementQuality >-----#
    AngleMeasurementQuality = SEQ(name=u'AngleMeasurementQuality', mode=MODE_TYPE)
    _AngleMeasurementQuality_azimuthQuality = INT(name=u'azimuthQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AngleMeasurementQuality_azimuthQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AngleMeasurementQuality_zenithQuality = INT(name=u'zenithQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AngleMeasurementQuality_zenithQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AngleMeasurementQuality_resolution = ENUM(name=u'resolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AngleMeasurementQuality_resolution._cont = ASN1Dict([(u'deg0dot1', 0)])
    _AngleMeasurementQuality_resolution._ext = []
    _AngleMeasurementQuality_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AngleMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AngleMeasurementQuality_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AngleMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__id_tab
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab_id = u'id'
    ___AngleMeasurementQuality_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AngleMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AngleMeasurementQuality_iE_Extensions__item__id),
        (u'criticality', ___AngleMeasurementQuality_iE_Extensions__item__criticality),
        (u'extensionValue', ___AngleMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __AngleMeasurementQuality_iE_Extensions__item_._ext = None
    _AngleMeasurementQuality_iE_Extensions._cont = __AngleMeasurementQuality_iE_Extensions__item_
    _AngleMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AngleMeasurementQuality._cont = ASN1Dict([
        (u'azimuthQuality', _AngleMeasurementQuality_azimuthQuality),
        (u'zenithQuality', _AngleMeasurementQuality_zenithQuality),
        (u'resolution', _AngleMeasurementQuality_resolution),
        (u'iE-Extensions', _AngleMeasurementQuality_iE_Extensions),
        ])
    AngleMeasurementQuality._ext = None
    
    #-----< AngleMeasurementQuality-ExtIEs >-----#
    AngleMeasurementQuality_ExtIEs = CLASS(name=u'AngleMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AngleMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRSResourceTriggerList >-----#
    AperiodicSRSResourceTriggerList = SEQ_OF(name=u'AperiodicSRSResourceTriggerList', mode=MODE_TYPE)
    _AperiodicSRSResourceTriggerList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AperiodicSRSResourceTrigger')))
    AperiodicSRSResourceTriggerList._cont = _AperiodicSRSResourceTriggerList__item_
    AperiodicSRSResourceTriggerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AperiodicSRSResourceTrigger >-----#
    AperiodicSRSResourceTrigger = INT(name=u'AperiodicSRSResourceTrigger', mode=MODE_TYPE)
    AperiodicSRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Associated-SCell-Item >-----#
    Associated_SCell_Item = SEQ(name=u'Associated-SCell-Item', mode=MODE_TYPE)
    _Associated_SCell_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Associated_SCell_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Associated_SCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Associated_SCell_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Associated_SCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab = ____Associated_SCell_Item_iE_Extensions__item__id_tab
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Associated_SCell_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Associated_SCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab = ____Associated_SCell_Item_iE_Extensions__item__criticality_tab
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Associated_SCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Associated_SCell_Item_iE_Extensions__item__id),
        (u'criticality', ___Associated_SCell_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Associated_SCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Associated_SCell_Item_iE_Extensions__item_._ext = None
    _Associated_SCell_Item_iE_Extensions._cont = __Associated_SCell_Item_iE_Extensions__item_
    _Associated_SCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Associated_SCell_Item._cont = ASN1Dict([
        (u'sCell-ID', _Associated_SCell_Item_sCell_ID),
        (u'iE-Extensions', _Associated_SCell_Item_iE_Extensions),
        ])
    Associated_SCell_Item._ext = None
    
    #-----< Associated-SCell-ItemExtIEs >-----#
    Associated_SCell_ItemExtIEs = CLASS(name=u'Associated-SCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Associated_SCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailablePLMNList >-----#
    AvailablePLMNList = SEQ_OF(name=u'AvailablePLMNList', mode=MODE_TYPE)
    _AvailablePLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList-Item')))
    AvailablePLMNList._cont = _AvailablePLMNList__item_
    AvailablePLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< AvailablePLMNList-Item >-----#
    AvailablePLMNList_Item = SEQ(name=u'AvailablePLMNList-Item', mode=MODE_TYPE)
    _AvailablePLMNList_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _AvailablePLMNList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailablePLMNList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AvailablePLMNList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AvailablePLMNList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__id_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AvailablePLMNList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AvailablePLMNList_Item_iE_Extensions__item__id),
        (u'criticality', ___AvailablePLMNList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue),
        ])
    __AvailablePLMNList_Item_iE_Extensions__item_._ext = None
    _AvailablePLMNList_Item_iE_Extensions._cont = __AvailablePLMNList_Item_iE_Extensions__item_
    _AvailablePLMNList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailablePLMNList_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _AvailablePLMNList_Item_pLMNIdentity),
        (u'iE-Extensions', _AvailablePLMNList_Item_iE_Extensions),
        ])
    AvailablePLMNList_Item._ext = None
    
    #-----< AvailablePLMNList-Item-ExtIEs >-----#
    AvailablePLMNList_Item_ExtIEs = CLASS(name=u'AvailablePLMNList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AvailablePLMNList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailableSNPN-ID-List >-----#
    AvailableSNPN_ID_List = SEQ_OF(name=u'AvailableSNPN-ID-List', mode=MODE_TYPE)
    _AvailableSNPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List-Item')))
    AvailableSNPN_ID_List._cont = _AvailableSNPN_ID_List__item_
    AvailableSNPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< AvailableSNPN-ID-List-Item >-----#
    AvailableSNPN_ID_List_Item = SEQ(name=u'AvailableSNPN-ID-List-Item', mode=MODE_TYPE)
    _AvailableSNPN_ID_List_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _AvailableSNPN_ID_List_Item_availableNIDList = SEQ_OF(name=u'availableNIDList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastNIDList')))
    _AvailableSNPN_ID_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id),
        (u'criticality', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_._ext = None
    _AvailableSNPN_ID_List_Item_iE_Extensions._cont = __AvailableSNPN_ID_List_Item_iE_Extensions__item_
    _AvailableSNPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailableSNPN_ID_List_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _AvailableSNPN_ID_List_Item_pLMN_Identity),
        (u'availableNIDList', _AvailableSNPN_ID_List_Item_availableNIDList),
        (u'iE-Extensions', _AvailableSNPN_ID_List_Item_iE_Extensions),
        ])
    AvailableSNPN_ID_List_Item._ext = []
    
    #-----< AvailableSNPN-ID-List-ItemExtIEs >-----#
    AvailableSNPN_ID_List_ItemExtIEs = CLASS(name=u'AvailableSNPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AvailableSNPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AveragingWindow >-----#
    AveragingWindow = INT(name=u'AveragingWindow', mode=MODE_TYPE)
    AveragingWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< AreaScope >-----#
    AreaScope = ENUM(name=u'AreaScope', mode=MODE_TYPE)
    AreaScope._cont = ASN1Dict([(u'true', 0)])
    AreaScope._ext = []
    
    #-----< BandwidthSRS >-----#
    BandwidthSRS = CHOICE(name=u'BandwidthSRS', mode=MODE_TYPE)
    _BandwidthSRS_fR1 = ENUM(name=u'fR1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FR1-Bandwidth')))
    _BandwidthSRS_fR2 = ENUM(name=u'fR2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FR2-Bandwidth')))
    _BandwidthSRS_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BandwidthSRS_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BandwidthSRS_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_id._const_tab = ___BandwidthSRS_choice_extension_id_tab
    __BandwidthSRS_choice_extension_id._const_tab_at = None
    __BandwidthSRS_choice_extension_id._const_tab_id = u'id'
    __BandwidthSRS_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___BandwidthSRS_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_criticality._const_tab = ___BandwidthSRS_choice_extension_criticality_tab
    __BandwidthSRS_choice_extension_criticality._const_tab_at = ('..', u'id')
    __BandwidthSRS_choice_extension_criticality._const_tab_id = u'criticality'
    __BandwidthSRS_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___BandwidthSRS_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_value._const_tab = ___BandwidthSRS_choice_extension_value_tab
    __BandwidthSRS_choice_extension_value._const_tab_at = ('..', u'id')
    __BandwidthSRS_choice_extension_value._const_tab_id = u'Value'
    _BandwidthSRS_choice_extension._cont = ASN1Dict([
        (u'id', __BandwidthSRS_choice_extension_id),
        (u'criticality', __BandwidthSRS_choice_extension_criticality),
        (u'value', __BandwidthSRS_choice_extension_value),
        ])
    _BandwidthSRS_choice_extension._ext = None
    BandwidthSRS._cont = ASN1Dict([
        (u'fR1', _BandwidthSRS_fR1),
        (u'fR2', _BandwidthSRS_fR2),
        (u'choice-extension', _BandwidthSRS_choice_extension),
        ])
    BandwidthSRS._ext = None
    
    #-----< BandwidthSRS-ExtIEs >-----#
    BandwidthSRS_ExtIEs = CLASS(name=u'BandwidthSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BandwidthSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAPAddress >-----#
    BAPAddress = BIT_STR(name=u'BAPAddress', mode=MODE_TYPE)
    BAPAddress._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< BAPCtrlPDUChannel >-----#
    BAPCtrlPDUChannel = ENUM(name=u'BAPCtrlPDUChannel', mode=MODE_TYPE)
    BAPCtrlPDUChannel._cont = ASN1Dict([(u'true', 0)])
    BAPCtrlPDUChannel._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo >-----#
    BAPlayerBHRLCchannelMappingInfo = SEQ(name=u'BAPlayerBHRLCchannelMappingInfo', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd = SEQ_OF(name=u'bAPlayerBHRLCchannelMappingInfoToAdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfoList')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove = SEQ_OF(name=u'bAPlayerBHRLCchannelMappingInfoToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationtoRemove')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab_at = None
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id),
        (u'criticality', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue),
        ])
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_._ext = None
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions._cont = __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPlayerBHRLCchannelMappingInfo._cont = ASN1Dict([
        (u'bAPlayerBHRLCchannelMappingInfoToAdd', _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd),
        (u'bAPlayerBHRLCchannelMappingInfoToRemove', _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove),
        (u'iE-Extensions', _BAPlayerBHRLCchannelMappingInfo_iE_Extensions),
        ])
    BAPlayerBHRLCchannelMappingInfo._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo-ExtIEs >-----#
    BAPlayerBHRLCchannelMappingInfo_ExtIEs = CLASS(name=u'BAPlayerBHRLCchannelMappingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAPlayerBHRLCchannelMappingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAPlayerBHRLCchannelMappingInfoList >-----#
    BAPlayerBHRLCchannelMappingInfoList = SEQ_OF(name=u'BAPlayerBHRLCchannelMappingInfoList', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfo-Item')))
    BAPlayerBHRLCchannelMappingInfoList._cont = _BAPlayerBHRLCchannelMappingInfoList__item_
    BAPlayerBHRLCchannelMappingInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< BAPlayerBHRLCchannelMappingInfo-Item >-----#
    BAPlayerBHRLCchannelMappingInfo_Item = SEQ(name=u'BAPlayerBHRLCchannelMappingInfo-Item', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex = BIT_STR(name=u'mappingInformationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress = BIT_STR(name=u'priorHopBAPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID = BIT_STR(name=u'ingressbHRLCChannelID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress = BIT_STR(name=u'nextHopBAPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID = BIT_STR(name=u'egressbHRLCChannelID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id),
        (u'criticality', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_._ext = None
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions._cont = __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPlayerBHRLCchannelMappingInfo_Item._cont = ASN1Dict([
        (u'mappingInformationIndex', _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex),
        (u'priorHopBAPAddress', _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress),
        (u'ingressbHRLCChannelID', _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID),
        (u'nextHopBAPAddress', _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress),
        (u'egressbHRLCChannelID', _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID),
        (u'iE-Extensions', _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions),
        ])
    BAPlayerBHRLCchannelMappingInfo_Item._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo-ItemExtIEs >-----#
    BAPlayerBHRLCchannelMappingInfo_ItemExtIEs = CLASS(name=u'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAPlayerBHRLCchannelMappingInfo_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAPPathID >-----#
    BAPPathID = BIT_STR(name=u'BAPPathID', mode=MODE_TYPE)
    BAPPathID._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< BAPRoutingID >-----#
    BAPRoutingID = SEQ(name=u'BAPRoutingID', mode=MODE_TYPE)
    _BAPRoutingID_bAPAddress = BIT_STR(name=u'bAPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _BAPRoutingID_bAPPathID = BIT_STR(name=u'bAPPathID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPPathID')))
    _BAPRoutingID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPRoutingID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPRoutingID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BAPRoutingID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__id._const_tab = ____BAPRoutingID_iE_Extensions__item__id_tab
    ___BAPRoutingID_iE_Extensions__item__id._const_tab_at = None
    ___BAPRoutingID_iE_Extensions__item__id._const_tab_id = u'id'
    ___BAPRoutingID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BAPRoutingID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab = ____BAPRoutingID_iE_Extensions__item__criticality_tab
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BAPRoutingID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BAPRoutingID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab = ____BAPRoutingID_iE_Extensions__item__extensionValue_tab
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BAPRoutingID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BAPRoutingID_iE_Extensions__item__id),
        (u'criticality', ___BAPRoutingID_iE_Extensions__item__criticality),
        (u'extensionValue', ___BAPRoutingID_iE_Extensions__item__extensionValue),
        ])
    __BAPRoutingID_iE_Extensions__item_._ext = None
    _BAPRoutingID_iE_Extensions._cont = __BAPRoutingID_iE_Extensions__item_
    _BAPRoutingID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPRoutingID._cont = ASN1Dict([
        (u'bAPAddress', _BAPRoutingID_bAPAddress),
        (u'bAPPathID', _BAPRoutingID_bAPPathID),
        (u'iE-Extensions', _BAPRoutingID_iE_Extensions),
        ])
    BAPRoutingID._ext = None
    
    #-----< BAPRoutingIDExtIEs >-----#
    BAPRoutingIDExtIEs = CLASS(name=u'BAPRoutingIDExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAPRoutingIDExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name=u'BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4000000000000)], ev=[], er=[])
    
    #-----< BearerTypeChange >-----#
    BearerTypeChange = ENUM(name=u'BearerTypeChange', mode=MODE_TYPE)
    BearerTypeChange._cont = ASN1Dict([(u'true', 0)])
    BearerTypeChange._ext = []
    
    #-----< BHRLCChannelID >-----#
    BHRLCChannelID = BIT_STR(name=u'BHRLCChannelID', mode=MODE_TYPE)
    BHRLCChannelID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeModified-Item >-----#
    BHChannels_FailedToBeModified_Item = SEQ(name=u'BHChannels-FailedToBeModified-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeModified_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeModified_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeModified_Item_iE_Extensions._cont = __BHChannels_FailedToBeModified_Item_iE_Extensions__item_
    _BHChannels_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeModified_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_FailedToBeModified_Item_bHRLCChannelID),
        (u'cause', _BHChannels_FailedToBeModified_Item_cause),
        (u'iE-Extensions', _BHChannels_FailedToBeModified_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeModified_Item._ext = None
    
    #-----< BHChannels-FailedToBeModified-ItemExtIEs >-----#
    BHChannels_FailedToBeModified_ItemExtIEs = CLASS(name=u'BHChannels-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetup-Item >-----#
    BHChannels_FailedToBeSetup_Item = SEQ(name=u'BHChannels-FailedToBeSetup-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetup_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeSetup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeSetup_Item_iE_Extensions._cont = __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_
    _BHChannels_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeSetup_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_FailedToBeSetup_Item_bHRLCChannelID),
        (u'cause', _BHChannels_FailedToBeSetup_Item_cause),
        (u'iE-Extensions', _BHChannels_FailedToBeSetup_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeSetup_Item._ext = None
    
    #-----< BHChannels-FailedToBeSetup-ItemExtIEs >-----#
    BHChannels_FailedToBeSetup_ItemExtIEs = CLASS(name=u'BHChannels-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-Item >-----#
    BHChannels_FailedToBeSetupMod_Item = SEQ(name=u'BHChannels-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeSetupMod_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions._cont = __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeSetupMod_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID),
        (u'cause', _BHChannels_FailedToBeSetupMod_Item_cause),
        (u'iE-Extensions', _BHChannels_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeSetupMod_Item._ext = None
    
    #-----< BHChannels-FailedToBeSetupMod-ItemExtIEs >-----#
    BHChannels_FailedToBeSetupMod_ItemExtIEs = CLASS(name=u'BHChannels-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Modified-Item >-----#
    BHChannels_Modified_Item = SEQ(name=u'BHChannels-Modified-Item', mode=MODE_TYPE)
    _BHChannels_Modified_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Modified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Modified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__id_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_Modified_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_Modified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Modified_Item_iE_Extensions__item_._ext = None
    _BHChannels_Modified_Item_iE_Extensions._cont = __BHChannels_Modified_Item_iE_Extensions__item_
    _BHChannels_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Modified_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_Modified_Item_bHRLCChannelID),
        (u'iE-Extensions', _BHChannels_Modified_Item_iE_Extensions),
        ])
    BHChannels_Modified_Item._ext = None
    
    #-----< BHChannels-Modified-ItemExtIEs >-----#
    BHChannels_Modified_ItemExtIEs = CLASS(name=u'BHChannels-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Required-ToBeReleased-Item >-----#
    BHChannels_Required_ToBeReleased_Item = SEQ(name=u'BHChannels-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions._cont = __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Required_ToBeReleased_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID),
        (u'iE-Extensions', _BHChannels_Required_ToBeReleased_Item_iE_Extensions),
        ])
    BHChannels_Required_ToBeReleased_Item._ext = None
    
    #-----< BHChannels-Required-ToBeReleased-ItemExtIEs >-----#
    BHChannels_Required_ToBeReleased_ItemExtIEs = CLASS(name=u'BHChannels-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Setup-Item >-----#
    BHChannels_Setup_Item = SEQ(name=u'BHChannels-Setup-Item', mode=MODE_TYPE)
    _BHChannels_Setup_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__id_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Setup_Item_iE_Extensions__item_._ext = None
    _BHChannels_Setup_Item_iE_Extensions._cont = __BHChannels_Setup_Item_iE_Extensions__item_
    _BHChannels_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Setup_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_Setup_Item_bHRLCChannelID),
        (u'iE-Extensions', _BHChannels_Setup_Item_iE_Extensions),
        ])
    BHChannels_Setup_Item._ext = None
    
    #-----< BHChannels-Setup-ItemExtIEs >-----#
    BHChannels_Setup_ItemExtIEs = CLASS(name=u'BHChannels-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-SetupMod-Item >-----#
    BHChannels_SetupMod_Item = SEQ(name=u'BHChannels-SetupMod-Item', mode=MODE_TYPE)
    _BHChannels_SetupMod_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_SetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_SetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_SetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_SetupMod_Item_iE_Extensions._cont = __BHChannels_SetupMod_Item_iE_Extensions__item_
    _BHChannels_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_SetupMod_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_SetupMod_Item_bHRLCChannelID),
        (u'iE-Extensions', _BHChannels_SetupMod_Item_iE_Extensions),
        ])
    BHChannels_SetupMod_Item._ext = None
    
    #-----< BHChannels-SetupMod-ItemExtIEs >-----#
    BHChannels_SetupMod_ItemExtIEs = CLASS(name=u'BHChannels-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeModified-Item >-----#
    BHChannels_ToBeModified_Item = SEQ(name=u'BHChannels-ToBeModified-Item', mode=MODE_TYPE)
    _BHChannels_ToBeModified_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeModified_Item_bHQoSInformation = CHOICE(name=u'bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeModified_Item_rLCmode = ENUM(name=u'rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel = ENUM(name=u'bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeModified_Item_trafficMappingInfo = CHOICE(name=u'trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_ToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeModified_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeModified_Item_iE_Extensions._cont = __BHChannels_ToBeModified_Item_iE_Extensions__item_
    _BHChannels_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeModified_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_ToBeModified_Item_bHRLCChannelID),
        (u'bHQoSInformation', _BHChannels_ToBeModified_Item_bHQoSInformation),
        (u'rLCmode', _BHChannels_ToBeModified_Item_rLCmode),
        (u'bAPCtrlPDUChannel', _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel),
        (u'trafficMappingInfo', _BHChannels_ToBeModified_Item_trafficMappingInfo),
        (u'iE-Extensions', _BHChannels_ToBeModified_Item_iE_Extensions),
        ])
    BHChannels_ToBeModified_Item._ext = None
    
    #-----< BHChannels-ToBeModified-ItemExtIEs >-----#
    BHChannels_ToBeModified_ItemExtIEs = CLASS(name=u'BHChannels-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeReleased-Item >-----#
    BHChannels_ToBeReleased_Item = SEQ(name=u'BHChannels-ToBeReleased-Item', mode=MODE_TYPE)
    _BHChannels_ToBeReleased_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeReleased_Item_iE_Extensions._cont = __BHChannels_ToBeReleased_Item_iE_Extensions__item_
    _BHChannels_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeReleased_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_ToBeReleased_Item_bHRLCChannelID),
        (u'iE-Extensions', _BHChannels_ToBeReleased_Item_iE_Extensions),
        ])
    BHChannels_ToBeReleased_Item._ext = None
    
    #-----< BHChannels-ToBeReleased-ItemExtIEs >-----#
    BHChannels_ToBeReleased_ItemExtIEs = CLASS(name=u'BHChannels-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetup-Item >-----#
    BHChannels_ToBeSetup_Item = SEQ(name=u'BHChannels-ToBeSetup-Item', mode=MODE_TYPE)
    _BHChannels_ToBeSetup_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeSetup_Item_bHQoSInformation = CHOICE(name=u'bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeSetup_Item_rLCmode = ENUM(name=u'rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel = ENUM(name=u'bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeSetup_Item_trafficMappingInfo = CHOICE(name=u'trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeSetup_Item_iE_Extensions._cont = __BHChannels_ToBeSetup_Item_iE_Extensions__item_
    _BHChannels_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeSetup_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_ToBeSetup_Item_bHRLCChannelID),
        (u'bHQoSInformation', _BHChannels_ToBeSetup_Item_bHQoSInformation),
        (u'rLCmode', _BHChannels_ToBeSetup_Item_rLCmode),
        (u'bAPCtrlPDUChannel', _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel),
        (u'trafficMappingInfo', _BHChannels_ToBeSetup_Item_trafficMappingInfo),
        (u'iE-Extensions', _BHChannels_ToBeSetup_Item_iE_Extensions),
        ])
    BHChannels_ToBeSetup_Item._ext = None
    
    #-----< BHChannels-ToBeSetup-ItemExtIEs >-----#
    BHChannels_ToBeSetup_ItemExtIEs = CLASS(name=u'BHChannels-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetupMod-Item >-----#
    BHChannels_ToBeSetupMod_Item = SEQ(name=u'BHChannels-ToBeSetupMod-Item', mode=MODE_TYPE)
    _BHChannels_ToBeSetupMod_Item_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeSetupMod_Item_bHQoSInformation = CHOICE(name=u'bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeSetupMod_Item_rLCmode = ENUM(name=u'rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel = ENUM(name=u'bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeSetupMod_Item_trafficMappingInfo = CHOICE(name=u'trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeSetupMod_Item_iE_Extensions._cont = __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_
    _BHChannels_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeSetupMod_Item._cont = ASN1Dict([
        (u'bHRLCChannelID', _BHChannels_ToBeSetupMod_Item_bHRLCChannelID),
        (u'bHQoSInformation', _BHChannels_ToBeSetupMod_Item_bHQoSInformation),
        (u'rLCmode', _BHChannels_ToBeSetupMod_Item_rLCmode),
        (u'bAPCtrlPDUChannel', _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel),
        (u'trafficMappingInfo', _BHChannels_ToBeSetupMod_Item_trafficMappingInfo),
        (u'iE-Extensions', _BHChannels_ToBeSetupMod_Item_iE_Extensions),
        ])
    BHChannels_ToBeSetupMod_Item._ext = None
    
    #-----< BHChannels-ToBeSetupMod-ItemExtIEs >-----#
    BHChannels_ToBeSetupMod_ItemExtIEs = CLASS(name=u'BHChannels-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHInfo >-----#
    BHInfo = SEQ(name=u'BHInfo', mode=MODE_TYPE)
    _BHInfo_bAProutingID = SEQ(name=u'bAProutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')), opt=True)
    _BHInfo_egressBHRLCCHList = SEQ_OF(name=u'egressBHRLCCHList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EgressBHRLCCHList')), opt=True)
    _BHInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BHInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHInfo_iE_Extensions__item__id._const_tab = ____BHInfo_iE_Extensions__item__id_tab
    ___BHInfo_iE_Extensions__item__id._const_tab_at = None
    ___BHInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___BHInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BHInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHInfo_iE_Extensions__item__criticality._const_tab = ____BHInfo_iE_Extensions__item__criticality_tab
    ___BHInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BHInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BHInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BHInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab = ____BHInfo_iE_Extensions__item__extensionValue_tab
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BHInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BHInfo_iE_Extensions__item__id),
        (u'criticality', ___BHInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___BHInfo_iE_Extensions__item__extensionValue),
        ])
    __BHInfo_iE_Extensions__item_._ext = None
    _BHInfo_iE_Extensions._cont = __BHInfo_iE_Extensions__item_
    _BHInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHInfo._cont = ASN1Dict([
        (u'bAProutingID', _BHInfo_bAProutingID),
        (u'egressBHRLCCHList', _BHInfo_egressBHRLCCHList),
        (u'iE-Extensions', _BHInfo_iE_Extensions),
        ])
    BHInfo._ext = None
    
    #-----< BHInfo-ExtIEs >-----#
    BHInfo_ExtIEs = CLASS(name=u'BHInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHQoSInformation >-----#
    BHQoSInformation = CHOICE(name=u'BHQoSInformation', mode=MODE_TYPE)
    _BHQoSInformation_bHRLCCHQoS = SEQ(name=u'bHRLCCHQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _BHQoSInformation_eUTRANBHRLCCHQoS = SEQ(name=u'eUTRANBHRLCCHQoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRANQoS')))
    _BHQoSInformation_cPTrafficType = INT(name=u'cPTrafficType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CPTrafficType')))
    _BHQoSInformation_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHQoSInformation_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHQoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_id._const_tab = ___BHQoSInformation_choice_extension_id_tab
    __BHQoSInformation_choice_extension_id._const_tab_at = None
    __BHQoSInformation_choice_extension_id._const_tab_id = u'id'
    __BHQoSInformation_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___BHQoSInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_criticality._const_tab = ___BHQoSInformation_choice_extension_criticality_tab
    __BHQoSInformation_choice_extension_criticality._const_tab_at = ('..', u'id')
    __BHQoSInformation_choice_extension_criticality._const_tab_id = u'criticality'
    __BHQoSInformation_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___BHQoSInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_value._const_tab = ___BHQoSInformation_choice_extension_value_tab
    __BHQoSInformation_choice_extension_value._const_tab_at = ('..', u'id')
    __BHQoSInformation_choice_extension_value._const_tab_id = u'Value'
    _BHQoSInformation_choice_extension._cont = ASN1Dict([
        (u'id', __BHQoSInformation_choice_extension_id),
        (u'criticality', __BHQoSInformation_choice_extension_criticality),
        (u'value', __BHQoSInformation_choice_extension_value),
        ])
    _BHQoSInformation_choice_extension._ext = None
    BHQoSInformation._cont = ASN1Dict([
        (u'bHRLCCHQoS', _BHQoSInformation_bHRLCCHQoS),
        (u'eUTRANBHRLCCHQoS', _BHQoSInformation_eUTRANBHRLCCHQoS),
        (u'cPTrafficType', _BHQoSInformation_cPTrafficType),
        (u'choice-extension', _BHQoSInformation_choice_extension),
        ])
    BHQoSInformation._ext = None
    
    #-----< BHQoSInformation-ExtIEs >-----#
    BHQoSInformation_ExtIEs = CLASS(name=u'BHQoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BHQoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Added-List-Item >-----#
    BH_Routing_Information_Added_List_Item = SEQ(name=u'BH-Routing-Information-Added-List-Item', mode=MODE_TYPE)
    _BH_Routing_Information_Added_List_Item_bAPRoutingID = SEQ(name=u'bAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BH_Routing_Information_Added_List_Item_nextHopBAPAddress = BIT_STR(name=u'nextHopBAPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _BH_Routing_Information_Added_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id),
        (u'criticality', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_._ext = None
    _BH_Routing_Information_Added_List_Item_iE_Extensions._cont = __BH_Routing_Information_Added_List_Item_iE_Extensions__item_
    _BH_Routing_Information_Added_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BH_Routing_Information_Added_List_Item._cont = ASN1Dict([
        (u'bAPRoutingID', _BH_Routing_Information_Added_List_Item_bAPRoutingID),
        (u'nextHopBAPAddress', _BH_Routing_Information_Added_List_Item_nextHopBAPAddress),
        (u'iE-Extensions', _BH_Routing_Information_Added_List_Item_iE_Extensions),
        ])
    BH_Routing_Information_Added_List_Item._ext = None
    
    #-----< BH-Routing-Information-Added-List-ItemExtIEs >-----#
    BH_Routing_Information_Added_List_ItemExtIEs = CLASS(name=u'BH-Routing-Information-Added-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BH_Routing_Information_Added_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Removed-List-Item >-----#
    BH_Routing_Information_Removed_List_Item = SEQ(name=u'BH-Routing-Information-Removed-List-Item', mode=MODE_TYPE)
    _BH_Routing_Information_Removed_List_Item_bAPRoutingID = SEQ(name=u'bAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BH_Routing_Information_Removed_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id),
        (u'criticality', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_._ext = None
    _BH_Routing_Information_Removed_List_Item_iE_Extensions._cont = __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_
    _BH_Routing_Information_Removed_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BH_Routing_Information_Removed_List_Item._cont = ASN1Dict([
        (u'bAPRoutingID', _BH_Routing_Information_Removed_List_Item_bAPRoutingID),
        (u'iE-Extensions', _BH_Routing_Information_Removed_List_Item_iE_Extensions),
        ])
    BH_Routing_Information_Removed_List_Item._ext = None
    
    #-----< BH-Routing-Information-Removed-List-ItemExtIEs >-----#
    BH_Routing_Information_Removed_List_ItemExtIEs = CLASS(name=u'BH-Routing-Information-Removed-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BH_Routing_Information_Removed_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BPLMN-ID-Info-List >-----#
    BPLMN_ID_Info_List = SEQ_OF(name=u'BPLMN-ID-Info-List', mode=MODE_TYPE)
    _BPLMN_ID_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-Item')))
    BPLMN_ID_Info_List._cont = _BPLMN_ID_Info_List__item_
    BPLMN_ID_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BPLMN-ID-Info-Item >-----#
    BPLMN_ID_Info_Item = SEQ(name=u'BPLMN-ID-Info-Item', mode=MODE_TYPE)
    _BPLMN_ID_Info_Item_pLMN_Identity_List = SEQ_OF(name=u'pLMN-Identity-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _BPLMN_ID_Info_Item_extended_PLMN_Identity_List = SEQ_OF(name=u'extended-PLMN-Identity-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')), opt=True)
    _BPLMN_ID_Info_Item_fiveGS_TAC = OCT_STR(name=u'fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveGS-TAC')), opt=True)
    _BPLMN_ID_Info_Item_nr_cell_ID = BIT_STR(name=u'nr-cell-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _BPLMN_ID_Info_Item_ranac = INT(name=u'ranac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RANAC')), opt=True)
    _BPLMN_ID_Info_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BPLMN_ID_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 425), (u'criticality', u'ignore'), (u'Extension', _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 383), (u'criticality', u'reject'), (u'Extension', _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BPLMN_ID_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BPLMN_ID_Info_Item_iE_Extensions__item__id),
        (u'criticality', ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __BPLMN_ID_Info_Item_iE_Extensions__item_._ext = None
    _BPLMN_ID_Info_Item_iE_Extensions._cont = __BPLMN_ID_Info_Item_iE_Extensions__item_
    _BPLMN_ID_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BPLMN_ID_Info_Item._cont = ASN1Dict([
        (u'pLMN-Identity-List', _BPLMN_ID_Info_Item_pLMN_Identity_List),
        (u'extended-PLMN-Identity-List', _BPLMN_ID_Info_Item_extended_PLMN_Identity_List),
        (u'fiveGS-TAC', _BPLMN_ID_Info_Item_fiveGS_TAC),
        (u'nr-cell-ID', _BPLMN_ID_Info_Item_nr_cell_ID),
        (u'ranac', _BPLMN_ID_Info_Item_ranac),
        (u'iE-Extensions', _BPLMN_ID_Info_Item_iE_Extensions),
        ])
    BPLMN_ID_Info_Item._ext = []
    
    #-----< BPLMN-ID-Info-ItemExtIEs >-----#
    BPLMN_ID_Info_ItemExtIEs = CLASS(name=u'BPLMN-ID-Info-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _BPLMN_ID_Info_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _BPLMN_ID_Info_ItemExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    BPLMN_ID_Info_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 425), (u'criticality', u'ignore'), (u'Extension', _BPLMN_ID_Info_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 383), (u'criticality', u'reject'), (u'Extension', _BPLMN_ID_Info_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedPLMNs-List >-----#
    ServedPLMNs_List = SEQ_OF(name=u'ServedPLMNs-List', mode=MODE_TYPE)
    _ServedPLMNs_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServedPLMNs-Item')))
    ServedPLMNs_List._cont = _ServedPLMNs_List__item_
    ServedPLMNs_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ServedPLMNs-Item >-----#
    ServedPLMNs_Item = SEQ(name=u'ServedPLMNs-Item', mode=MODE_TYPE)
    _ServedPLMNs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ServedPLMNs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedPLMNs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ServedPLMNs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedPLMNs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    ____ServedPLMNs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 384), (u'criticality', u'reject'), (u'Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 390), (u'criticality', u'reject'), (u'Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedPLMNs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedPLMNs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedPLMNs_Item_iE_Extensions__item__id),
        (u'criticality', ___ServedPLMNs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedPLMNs_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedPLMNs_Item_iE_Extensions__item_._ext = None
    _ServedPLMNs_Item_iE_Extensions._cont = __ServedPLMNs_Item_iE_Extensions__item_
    _ServedPLMNs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedPLMNs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ServedPLMNs_Item_pLMN_Identity),
        (u'iE-Extensions', _ServedPLMNs_Item_iE_Extensions),
        ])
    ServedPLMNs_Item._ext = []
    
    #-----< ServedPLMNs-ItemExtIEs >-----#
    ServedPLMNs_ItemExtIEs = CLASS(name=u'ServedPLMNs-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ServedPLMNs_ItemExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')))
    _ServedPLMNs_ItemExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _ServedPLMNs_ItemExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    ServedPLMNs_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Extension', _ServedPLMNs_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 384), (u'criticality', u'reject'), (u'Extension', _ServedPLMNs_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 390), (u'criticality', u'reject'), (u'Extension', _ServedPLMNs_ItemExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastCAGList >-----#
    BroadcastCAGList = SEQ_OF(name=u'BroadcastCAGList', mode=MODE_TYPE)
    _BroadcastCAGList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CAGID')))
    BroadcastCAGList._cont = _BroadcastCAGList__item_
    BroadcastCAGList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastNIDList >-----#
    BroadcastNIDList = SEQ_OF(name=u'BroadcastNIDList', mode=MODE_TYPE)
    _BroadcastNIDList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    BroadcastNIDList._cont = _BroadcastNIDList__item_
    BroadcastNIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastSNPN-ID-List >-----#
    BroadcastSNPN_ID_List = SEQ_OF(name=u'BroadcastSNPN-ID-List', mode=MODE_TYPE)
    _BroadcastSNPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastSNPN-ID-List-Item')))
    BroadcastSNPN_ID_List._cont = _BroadcastSNPN_ID_List__item_
    BroadcastSNPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastSNPN-ID-List-Item >-----#
    BroadcastSNPN_ID_List_Item = SEQ(name=u'BroadcastSNPN-ID-List-Item', mode=MODE_TYPE)
    _BroadcastSNPN_ID_List_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _BroadcastSNPN_ID_List_Item_broadcastNIDList = SEQ_OF(name=u'broadcastNIDList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastNIDList')))
    _BroadcastSNPN_ID_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id),
        (u'criticality', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_._ext = None
    _BroadcastSNPN_ID_List_Item_iE_Extensions._cont = __BroadcastSNPN_ID_List_Item_iE_Extensions__item_
    _BroadcastSNPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastSNPN_ID_List_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _BroadcastSNPN_ID_List_Item_pLMN_Identity),
        (u'broadcastNIDList', _BroadcastSNPN_ID_List_Item_broadcastNIDList),
        (u'iE-Extensions', _BroadcastSNPN_ID_List_Item_iE_Extensions),
        ])
    BroadcastSNPN_ID_List_Item._ext = []
    
    #-----< BroadcastSNPN-ID-List-ItemExtIEs >-----#
    BroadcastSNPN_ID_List_ItemExtIEs = CLASS(name=u'BroadcastSNPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastSNPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastPNI-NPN-ID-List >-----#
    BroadcastPNI_NPN_ID_List = SEQ_OF(name=u'BroadcastPNI-NPN-ID-List', mode=MODE_TYPE)
    _BroadcastPNI_NPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastPNI-NPN-ID-List-Item')))
    BroadcastPNI_NPN_ID_List._cont = _BroadcastPNI_NPN_ID_List__item_
    BroadcastPNI_NPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastPNI-NPN-ID-List-Item >-----#
    BroadcastPNI_NPN_ID_List_Item = SEQ(name=u'BroadcastPNI-NPN-ID-List-Item', mode=MODE_TYPE)
    _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList = SEQ_OF(name=u'broadcastCAGList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastCAGList')))
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id),
        (u'criticality', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_._ext = None
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions._cont = __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastPNI_NPN_ID_List_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity),
        (u'broadcastCAGList', _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList),
        (u'iE-Extensions', _BroadcastPNI_NPN_ID_List_Item_iE_Extensions),
        ])
    BroadcastPNI_NPN_ID_List_Item._ext = []
    
    #-----< BroadcastPNI-NPN-ID-List-ItemExtIEs >-----#
    BroadcastPNI_NPN_ID_List_ItemExtIEs = CLASS(name=u'BroadcastPNI-NPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastPNI_NPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BurstArrivalTime >-----#
    BurstArrivalTime = OCT_STR(name=u'BurstArrivalTime', mode=MODE_TYPE)
    
    #-----< CAGID >-----#
    CAGID = BIT_STR(name=u'CAGID', mode=MODE_TYPE)
    CAGID._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< Cancel-all-Warning-Messages-Indicator >-----#
    Cancel_all_Warning_Messages_Indicator = ENUM(name=u'Cancel-all-Warning-Messages-Indicator', mode=MODE_TYPE)
    Cancel_all_Warning_Messages_Indicator._cont = ASN1Dict([(u'true', 0)])
    Cancel_all_Warning_Messages_Indicator._ext = []
    
    #-----< Candidate-SpCell-Item >-----#
    Candidate_SpCell_Item = SEQ(name=u'Candidate-SpCell-Item', mode=MODE_TYPE)
    _Candidate_SpCell_Item_candidate_SpCell_ID = SEQ(name=u'candidate-SpCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Candidate_SpCell_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Candidate_SpCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Candidate_SpCell_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Candidate_SpCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__id_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Candidate_SpCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Candidate_SpCell_Item_iE_Extensions__item__id),
        (u'criticality', ___Candidate_SpCell_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Candidate_SpCell_Item_iE_Extensions__item_._ext = None
    _Candidate_SpCell_Item_iE_Extensions._cont = __Candidate_SpCell_Item_iE_Extensions__item_
    _Candidate_SpCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Candidate_SpCell_Item._cont = ASN1Dict([
        (u'candidate-SpCell-ID', _Candidate_SpCell_Item_candidate_SpCell_ID),
        (u'iE-Extensions', _Candidate_SpCell_Item_iE_Extensions),
        ])
    Candidate_SpCell_Item._ext = []
    
    #-----< Candidate-SpCell-ItemExtIEs >-----#
    Candidate_SpCell_ItemExtIEs = CLASS(name=u'Candidate-SpCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Candidate_SpCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CapacityValue >-----#
    CapacityValue = SEQ(name=u'CapacityValue', mode=MODE_TYPE)
    _CapacityValue_capacityValue = INT(name=u'capacityValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CapacityValue_capacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _CapacityValue_sSBAreaCapacityValueList = SEQ_OF(name=u'sSBAreaCapacityValueList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaCapacityValueList')), opt=True)
    _CapacityValue_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CapacityValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CapacityValue_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CapacityValue_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__id._const_tab = ____CapacityValue_iE_Extensions__item__id_tab
    ___CapacityValue_iE_Extensions__item__id._const_tab_at = None
    ___CapacityValue_iE_Extensions__item__id._const_tab_id = u'id'
    ___CapacityValue_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CapacityValue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__criticality._const_tab = ____CapacityValue_iE_Extensions__item__criticality_tab
    ___CapacityValue_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CapacityValue_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CapacityValue_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CapacityValue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab = ____CapacityValue_iE_Extensions__item__extensionValue_tab
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CapacityValue_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CapacityValue_iE_Extensions__item__id),
        (u'criticality', ___CapacityValue_iE_Extensions__item__criticality),
        (u'extensionValue', ___CapacityValue_iE_Extensions__item__extensionValue),
        ])
    __CapacityValue_iE_Extensions__item_._ext = None
    _CapacityValue_iE_Extensions._cont = __CapacityValue_iE_Extensions__item_
    _CapacityValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CapacityValue._cont = ASN1Dict([
        (u'capacityValue', _CapacityValue_capacityValue),
        (u'sSBAreaCapacityValueList', _CapacityValue_sSBAreaCapacityValueList),
        (u'iE-Extensions', _CapacityValue_iE_Extensions),
        ])
    CapacityValue._ext = None
    
    #-----< CapacityValue-ExtIEs >-----#
    CapacityValue_ExtIEs = CLASS(name=u'CapacityValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CapacityValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseMisc')))
    _Cause_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cause_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cause_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_id._const_tab = ___Cause_choice_extension_id_tab
    __Cause_choice_extension_id._const_tab_at = None
    __Cause_choice_extension_id._const_tab_id = u'id'
    __Cause_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___Cause_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_criticality._const_tab = ___Cause_choice_extension_criticality_tab
    __Cause_choice_extension_criticality._const_tab_at = ('..', u'id')
    __Cause_choice_extension_criticality._const_tab_id = u'criticality'
    __Cause_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___Cause_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_value._const_tab = ___Cause_choice_extension_value_tab
    __Cause_choice_extension_value._const_tab_at = ('..', u'id')
    __Cause_choice_extension_value._const_tab_id = u'Value'
    _Cause_choice_extension._cont = ASN1Dict([
        (u'id', __Cause_choice_extension_id),
        (u'criticality', __Cause_choice_extension_criticality),
        (u'value', __Cause_choice_extension_value),
        ])
    _Cause_choice_extension._ext = None
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        (u'choice-extension', _Cause_choice_extension),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtIEs >-----#
    Cause_ExtIEs = CLASS(name=u'Cause-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    Cause_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'not-enough-user-plane-processing-resources', 1), (u'hardware-failure', 2), (u'om-intervention', 3), (u'unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'abstract-syntax-error-falsely-constructed-message', 5), (u'unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unspecified', 0), (u'rl-failure-rlc', 1), (u'unknown-or-already-allocated-gnb-cu-ue-f1ap-id', 2), (u'unknown-or-already-allocated-gnb-du-ue-f1ap-id', 3), (u'unknown-or-inconsistent-pair-of-ue-f1ap-id', 4), (u'interaction-with-other-procedure', 5), (u'not-supported-qci-Value', 6), (u'action-desirable-for-radio-reasons', 7), (u'no-radio-resources-available', 8), (u'procedure-cancelled', 9), (u'normal-release', 10), (u'cell-not-available', 11), (u'rl-failure-others', 12), (u'ue-rejection', 13), (u'resources-not-available-for-the-slice', 14), (u'amf-initiated-abnormal-release', 15), (u'release-due-to-pre-emption', 16), (u'plmn-not-served-by-the-gNB-CU', 17), (u'multiple-drb-id-instances', 18), (u'unknown-drb-id', 19), (u'multiple-bh-rlc-ch-id-instances', 20), (u'unknown-bh-rlc-ch-id', 21), (u'cho-cpc-resources-tobechanged', 22), (u'nPN-not-supported', 23), (u'nPN-access-denied', 24), (u'gNB-CU-Cell-Capacity-Exceeded', 25), (u'report-characteristics-empty', 26), (u'existing-measurement-ID', 27), (u'measurement-temporarily-not-available', 28), (u'measurement-not-supported-for-the-object', 29), (u'unknown-bh-address', 30), (u'unknown-bap-routing-id', 31), (u'insufficient-ue-capabilities', 32)])
    CauseRadioNetwork._ext = [u'cell-not-available', u'rl-failure-others', u'ue-rejection', u'resources-not-available-for-the-slice', u'amf-initiated-abnormal-release', u'release-due-to-pre-emption', u'plmn-not-served-by-the-gNB-CU', u'multiple-drb-id-instances', u'unknown-drb-id', u'multiple-bh-rlc-ch-id-instances', u'unknown-bh-rlc-ch-id', u'cho-cpc-resources-tobechanged', u'nPN-not-supported', u'nPN-access-denied', u'gNB-CU-Cell-Capacity-Exceeded', u'report-characteristics-empty', u'existing-measurement-ID', u'measurement-temporarily-not-available', u'measurement-not-supported-for-the-object', u'unknown-bh-address', u'unknown-bap-routing-id', u'insufficient-ue-capabilities']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'unspecified', 0), (u'transport-resource-unavailable', 1), (u'unknown-TNL-address-for-IAB', 2), (u'unknown-UP-TNL-information-for-IAB', 3)])
    CauseTransport._ext = [u'unknown-TNL-address-for-IAB', u'unknown-UP-TNL-information-for-IAB']
    
    #-----< CellGroupConfig >-----#
    CellGroupConfig = OCT_STR(name=u'CellGroupConfig', mode=MODE_TYPE)
    
    #-----< CellCapacityClassValue >-----#
    CellCapacityClassValue = INT(name=u'CellCapacityClassValue', mode=MODE_TYPE)
    CellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< Cell-Direction >-----#
    Cell_Direction = ENUM(name=u'Cell-Direction', mode=MODE_TYPE)
    Cell_Direction._cont = ASN1Dict([(u'dl-only', 0), (u'ul-only', 1)])
    Cell_Direction._ext = None
    
    #-----< CellMeasurementResultList >-----#
    CellMeasurementResultList = SEQ_OF(name=u'CellMeasurementResultList', mode=MODE_TYPE)
    _CellMeasurementResultList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultItem')))
    CellMeasurementResultList._cont = _CellMeasurementResultList__item_
    CellMeasurementResultList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< CellMeasurementResultItem >-----#
    CellMeasurementResultItem = SEQ(name=u'CellMeasurementResultItem', mode=MODE_TYPE)
    _CellMeasurementResultItem_cellID = SEQ(name=u'cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CellMeasurementResultItem_radioResourceStatus = SEQ(name=u'radioResourceStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RadioResourceStatus')), opt=True)
    _CellMeasurementResultItem_compositeAvailableCapacityGroup = SEQ(name=u'compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacityGroup')), opt=True)
    _CellMeasurementResultItem_sliceAvailableCapacity = SEQ(name=u'sliceAvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacity')), opt=True)
    _CellMeasurementResultItem_numberofActiveUEs = INT(name=u'numberofActiveUEs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberofActiveUEs')), opt=True)
    _CellMeasurementResultItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResultItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__id_tab
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellMeasurementResultItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResultItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__criticality_tab
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellMeasurementResultItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResultItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__extensionValue_tab
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellMeasurementResultItem_iE_Extensions__item__id),
        (u'criticality', ___CellMeasurementResultItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResultItem_iE_Extensions__item_._ext = None
    _CellMeasurementResultItem_iE_Extensions._cont = __CellMeasurementResultItem_iE_Extensions__item_
    _CellMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResultItem._cont = ASN1Dict([
        (u'cellID', _CellMeasurementResultItem_cellID),
        (u'radioResourceStatus', _CellMeasurementResultItem_radioResourceStatus),
        (u'compositeAvailableCapacityGroup', _CellMeasurementResultItem_compositeAvailableCapacityGroup),
        (u'sliceAvailableCapacity', _CellMeasurementResultItem_sliceAvailableCapacity),
        (u'numberofActiveUEs', _CellMeasurementResultItem_numberofActiveUEs),
        (u'iE-Extensions', _CellMeasurementResultItem_iE_Extensions),
        ])
    CellMeasurementResultItem._ext = None
    
    #-----< CellMeasurementResultItem-ExtIEs >-----#
    CellMeasurementResultItem_ExtIEs = CLASS(name=u'CellMeasurementResultItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellMeasurementResultItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-Portion-ID >-----#
    Cell_Portion_ID = INT(name=u'Cell-Portion-ID', mode=MODE_TYPE)
    Cell_Portion_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< Cells-Failed-to-be-Activated-List-Item >-----#
    Cells_Failed_to_be_Activated_List_Item = SEQ(name=u'Cells-Failed-to-be-Activated-List-Item', mode=MODE_TYPE)
    _Cells_Failed_to_be_Activated_List_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Failed_to_be_Activated_List_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_._ext = None
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions._cont = __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Failed_to_be_Activated_List_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_Failed_to_be_Activated_List_Item_nRCGI),
        (u'cause', _Cells_Failed_to_be_Activated_List_Item_cause),
        (u'iE-Extensions', _Cells_Failed_to_be_Activated_List_Item_iE_Extensions),
        ])
    Cells_Failed_to_be_Activated_List_Item._ext = []
    
    #-----< Cells-Failed-to-be-Activated-List-ItemExtIEs >-----#
    Cells_Failed_to_be_Activated_List_ItemExtIEs = CLASS(name=u'Cells-Failed-to-be-Activated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Failed_to_be_Activated_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Status-Item >-----#
    Cells_Status_Item = SEQ(name=u'Cells-Status-Item', mode=MODE_TYPE)
    _Cells_Status_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Status_Item_service_status = SEQ(name=u'service-status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Service-Status')))
    _Cells_Status_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Status_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Status_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_Status_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab = ____Cells_Status_Item_iE_Extensions__item__id_tab
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_Status_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_Status_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Status_Item_iE_Extensions__item__criticality_tab
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_Status_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_Status_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_Status_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_Status_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_Status_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Status_Item_iE_Extensions__item_._ext = None
    _Cells_Status_Item_iE_Extensions._cont = __Cells_Status_Item_iE_Extensions__item_
    _Cells_Status_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Status_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_Status_Item_nRCGI),
        (u'service-status', _Cells_Status_Item_service_status),
        (u'iE-Extensions', _Cells_Status_Item_iE_Extensions),
        ])
    Cells_Status_Item._ext = []
    
    #-----< Cells-Status-ItemExtIEs >-----#
    Cells_Status_ItemExtIEs = CLASS(name=u'Cells-Status-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Status_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-To-Be-Broadcast-Item >-----#
    Cells_To_Be_Broadcast_Item = SEQ(name=u'Cells-To-Be-Broadcast-Item', mode=MODE_TYPE)
    _Cells_To_Be_Broadcast_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_To_Be_Broadcast_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_._ext = None
    _Cells_To_Be_Broadcast_Item_iE_Extensions._cont = __Cells_To_Be_Broadcast_Item_iE_Extensions__item_
    _Cells_To_Be_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_To_Be_Broadcast_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_To_Be_Broadcast_Item_nRCGI),
        (u'iE-Extensions', _Cells_To_Be_Broadcast_Item_iE_Extensions),
        ])
    Cells_To_Be_Broadcast_Item._ext = []
    
    #-----< Cells-To-Be-Broadcast-ItemExtIEs >-----#
    Cells_To_Be_Broadcast_ItemExtIEs = CLASS(name=u'Cells-To-Be-Broadcast-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_To_Be_Broadcast_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Completed-Item >-----#
    Cells_Broadcast_Completed_Item = SEQ(name=u'Cells-Broadcast-Completed-Item', mode=MODE_TYPE)
    _Cells_Broadcast_Completed_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Broadcast_Completed_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_._ext = None
    _Cells_Broadcast_Completed_Item_iE_Extensions._cont = __Cells_Broadcast_Completed_Item_iE_Extensions__item_
    _Cells_Broadcast_Completed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Broadcast_Completed_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_Broadcast_Completed_Item_nRCGI),
        (u'iE-Extensions', _Cells_Broadcast_Completed_Item_iE_Extensions),
        ])
    Cells_Broadcast_Completed_Item._ext = []
    
    #-----< Cells-Broadcast-Completed-ItemExtIEs >-----#
    Cells_Broadcast_Completed_ItemExtIEs = CLASS(name=u'Cells-Broadcast-Completed-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Broadcast_Completed_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Broadcast-To-Be-Cancelled-Item >-----#
    Broadcast_To_Be_Cancelled_Item = SEQ(name=u'Broadcast-To-Be-Cancelled-Item', mode=MODE_TYPE)
    _Broadcast_To_Be_Cancelled_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id),
        (u'criticality', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_._ext = None
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions._cont = __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Broadcast_To_Be_Cancelled_Item._cont = ASN1Dict([
        (u'nRCGI', _Broadcast_To_Be_Cancelled_Item_nRCGI),
        (u'iE-Extensions', _Broadcast_To_Be_Cancelled_Item_iE_Extensions),
        ])
    Broadcast_To_Be_Cancelled_Item._ext = []
    
    #-----< Broadcast-To-Be-Cancelled-ItemExtIEs >-----#
    Broadcast_To_Be_Cancelled_ItemExtIEs = CLASS(name=u'Broadcast-To-Be-Cancelled-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Broadcast_To_Be_Cancelled_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Cancelled-Item >-----#
    Cells_Broadcast_Cancelled_Item = SEQ(name=u'Cells-Broadcast-Cancelled-Item', mode=MODE_TYPE)
    _Cells_Broadcast_Cancelled_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberOfBroadcasts')))
    _Cells_Broadcast_Cancelled_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_._ext = None
    _Cells_Broadcast_Cancelled_Item_iE_Extensions._cont = __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_
    _Cells_Broadcast_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Broadcast_Cancelled_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_Broadcast_Cancelled_Item_nRCGI),
        (u'numberOfBroadcasts', _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts),
        (u'iE-Extensions', _Cells_Broadcast_Cancelled_Item_iE_Extensions),
        ])
    Cells_Broadcast_Cancelled_Item._ext = []
    
    #-----< Cells-Broadcast-Cancelled-ItemExtIEs >-----#
    Cells_Broadcast_Cancelled_ItemExtIEs = CLASS(name=u'Cells-Broadcast-Cancelled-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Broadcast_Cancelled_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Activated-List-Item >-----#
    Cells_to_be_Activated_List_Item = SEQ(name=u'Cells-to-be-Activated-List-Item', mode=MODE_TYPE)
    _Cells_to_be_Activated_List_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Activated_List_Item_nRPCI = INT(name=u'nRPCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')), opt=True)
    _Cells_to_be_Activated_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CUSystemInformation')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-donor-CU')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List')))
    ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'reject'), (u'Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'ignore'), (u'Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 386), (u'criticality', u'ignore'), (u'Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Activated_List_Item_iE_Extensions._cont = __Cells_to_be_Activated_List_Item_iE_Extensions__item_
    _Cells_to_be_Activated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Activated_List_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_to_be_Activated_List_Item_nRCGI),
        (u'nRPCI', _Cells_to_be_Activated_List_Item_nRPCI),
        (u'iE-Extensions', _Cells_to_be_Activated_List_Item_iE_Extensions),
        ])
    Cells_to_be_Activated_List_Item._ext = []
    
    #-----< Cells-to-be-Activated-List-ItemExtIEs >-----#
    Cells_to_be_Activated_List_ItemExtIEs = CLASS(name=u'Cells-to-be-Activated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CUSystemInformation')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-donor-CU')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List')))
    Cells_to_be_Activated_List_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'reject'), (u'Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'ignore'), (u'Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 386), (u'criticality', u'ignore'), (u'Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Deactivated-List-Item >-----#
    Cells_to_be_Deactivated_List_Item = SEQ(name=u'Cells-to-be-Deactivated-List-Item', mode=MODE_TYPE)
    _Cells_to_be_Deactivated_List_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Deactivated_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Deactivated_List_Item_iE_Extensions._cont = __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_
    _Cells_to_be_Deactivated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Deactivated_List_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_to_be_Deactivated_List_Item_nRCGI),
        (u'iE-Extensions', _Cells_to_be_Deactivated_List_Item_iE_Extensions),
        ])
    Cells_to_be_Deactivated_List_Item._ext = []
    
    #-----< Cells-to-be-Deactivated-List-ItemExtIEs >-----#
    Cells_to_be_Deactivated_List_ItemExtIEs = CLASS(name=u'Cells-to-be-Deactivated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_to_be_Deactivated_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Barred-Item >-----#
    Cells_to_be_Barred_Item = SEQ(name=u'Cells-to-be-Barred-Item', mode=MODE_TYPE)
    _Cells_to_be_Barred_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Barred_Item_cellBarred = ENUM(name=u'cellBarred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellBarred')))
    _Cells_to_be_Barred_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Barred_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Barred')))
    ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cells_to_be_Barred_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cells_to_be_Barred_Item_iE_Extensions__item__id),
        (u'criticality', ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Barred_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Barred_Item_iE_Extensions._cont = __Cells_to_be_Barred_Item_iE_Extensions__item_
    _Cells_to_be_Barred_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Barred_Item._cont = ASN1Dict([
        (u'nRCGI', _Cells_to_be_Barred_Item_nRCGI),
        (u'cellBarred', _Cells_to_be_Barred_Item_cellBarred),
        (u'iE-Extensions', _Cells_to_be_Barred_Item_iE_Extensions),
        ])
    Cells_to_be_Barred_Item._ext = None
    
    #-----< Cells-to-be-Barred-Item-ExtIEs >-----#
    Cells_to_be_Barred_Item_ExtIEs = CLASS(name=u'Cells-to-be-Barred-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Barred')))
    Cells_to_be_Barred_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellBarred >-----#
    CellBarred = ENUM(name=u'CellBarred', mode=MODE_TYPE)
    CellBarred._cont = ASN1Dict([(u'barred', 0), (u'not-barred', 1)])
    CellBarred._ext = []
    
    #-----< CellSize >-----#
    CellSize = ENUM(name=u'CellSize', mode=MODE_TYPE)
    CellSize._cont = ASN1Dict([(u'verysmall', 0), (u'small', 1), (u'medium', 2), (u'large', 3)])
    CellSize._ext = []
    
    #-----< CellToReportList >-----#
    CellToReportList = SEQ_OF(name=u'CellToReportList', mode=MODE_TYPE)
    _CellToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportItem')))
    CellToReportList._cont = _CellToReportList__item_
    CellToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< CellToReportItem >-----#
    CellToReportItem = SEQ(name=u'CellToReportItem', mode=MODE_TYPE)
    _CellToReportItem_cellID = SEQ(name=u'cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CellToReportItem_sSBToReportList = SEQ_OF(name=u'sSBToReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBToReportList')), opt=True)
    _CellToReportItem_sliceToReportList = SEQ_OF(name=u'sliceToReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceToReportList')), opt=True)
    _CellToReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellToReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__id._const_tab = ____CellToReportItem_iE_Extensions__item__id_tab
    ___CellToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___CellToReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellToReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab = ____CellToReportItem_iE_Extensions__item__criticality_tab
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellToReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab = ____CellToReportItem_iE_Extensions__item__extensionValue_tab
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellToReportItem_iE_Extensions__item__id),
        (u'criticality', ___CellToReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellToReportItem_iE_Extensions__item__extensionValue),
        ])
    __CellToReportItem_iE_Extensions__item_._ext = None
    _CellToReportItem_iE_Extensions._cont = __CellToReportItem_iE_Extensions__item_
    _CellToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReportItem._cont = ASN1Dict([
        (u'cellID', _CellToReportItem_cellID),
        (u'sSBToReportList', _CellToReportItem_sSBToReportList),
        (u'sliceToReportList', _CellToReportItem_sliceToReportList),
        (u'iE-Extensions', _CellToReportItem_iE_Extensions),
        ])
    CellToReportItem._ext = None
    
    #-----< CellToReportItem-ExtIEs >-----#
    CellToReportItem_ExtIEs = CLASS(name=u'CellToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellType >-----#
    CellType = SEQ(name=u'CellType', mode=MODE_TYPE)
    _CellType_cellSize = ENUM(name=u'cellSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellSize')))
    _CellType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellType_iE_Extensions__item__id),
        (u'criticality', ___CellType_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        (u'cellSize', _CellType_cellSize),
        (u'iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name=u'CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellULConfigured >-----#
    CellULConfigured = ENUM(name=u'CellULConfigured', mode=MODE_TYPE)
    CellULConfigured._cont = ASN1Dict([(u'none', 0), (u'ul', 1), (u'sul', 2), (u'ul-and-sul', 3)])
    CellULConfigured._ext = []
    
    #-----< Child-Node-Cells-List >-----#
    Child_Node_Cells_List = SEQ_OF(name=u'Child-Node-Cells-List', mode=MODE_TYPE)
    _Child_Node_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Node-Cells-List-Item')))
    Child_Node_Cells_List._cont = _Child_Node_Cells_List__item_
    Child_Node_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Child-Node-Cells-List-Item >-----#
    Child_Node_Cells_List_Item = SEQ(name=u'Child-Node-Cells-List-Item', mode=MODE_TYPE)
    _Child_Node_Cells_List_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name=u'iAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-Mode-Info')), opt=True)
    _Child_Node_Cells_List_Item_iAB_STC_Info = SEQ(name=u'iAB-STC-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _Child_Node_Cells_List_Item_rACH_Config_Common = OCT_STR(name=u'rACH-Config-Common', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common')), opt=True)
    _Child_Node_Cells_List_Item_rACH_Config_Common_IAB = OCT_STR(name=u'rACH-Config-Common-IAB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common-IAB')), opt=True)
    _Child_Node_Cells_List_Item_cSI_RS_Configuration = OCT_STR(name=u'cSI-RS-Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_sR_Configuration = OCT_STR(name=u'sR-Configuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1 = OCT_STR(name=u'pDCCH-ConfigSIB1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_sCS_Common = OCT_STR(name=u'sCS-Common', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_multiplexingInfo = SEQ(name=u'multiplexingInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultiplexingInfo')), opt=True)
    _Child_Node_Cells_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Child_Node_Cells_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Child_Node_Cells_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Child_Node_Cells_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Child_Node_Cells_List_Item_iE_Extensions__item_._ext = None
    _Child_Node_Cells_List_Item_iE_Extensions._cont = __Child_Node_Cells_List_Item_iE_Extensions__item_
    _Child_Node_Cells_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Child_Node_Cells_List_Item._cont = ASN1Dict([
        (u'nRCGI', _Child_Node_Cells_List_Item_nRCGI),
        (u'iAB-DU-Cell-Resource-Configuration-Mode-Info', _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info),
        (u'iAB-STC-Info', _Child_Node_Cells_List_Item_iAB_STC_Info),
        (u'rACH-Config-Common', _Child_Node_Cells_List_Item_rACH_Config_Common),
        (u'rACH-Config-Common-IAB', _Child_Node_Cells_List_Item_rACH_Config_Common_IAB),
        (u'cSI-RS-Configuration', _Child_Node_Cells_List_Item_cSI_RS_Configuration),
        (u'sR-Configuration', _Child_Node_Cells_List_Item_sR_Configuration),
        (u'pDCCH-ConfigSIB1', _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1),
        (u'sCS-Common', _Child_Node_Cells_List_Item_sCS_Common),
        (u'multiplexingInfo', _Child_Node_Cells_List_Item_multiplexingInfo),
        (u'iE-Extensions', _Child_Node_Cells_List_Item_iE_Extensions),
        ])
    Child_Node_Cells_List_Item._ext = None
    
    #-----< Child-Node-Cells-List-Item-ExtIEs >-----#
    Child_Node_Cells_List_Item_ExtIEs = CLASS(name=u'Child-Node-Cells-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Child_Node_Cells_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Child-Nodes-List >-----#
    Child_Nodes_List = SEQ_OF(name=u'Child-Nodes-List', mode=MODE_TYPE)
    _Child_Nodes_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List-Item')))
    Child_Nodes_List._cont = _Child_Nodes_List__item_
    Child_Nodes_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Child-Nodes-List-Item >-----#
    Child_Nodes_List_Item = SEQ(name=u'Child-Nodes-List-Item', mode=MODE_TYPE)
    _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID = INT(name=u'gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID = INT(name=u'gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _Child_Nodes_List_Item_child_Node_Cells_List = SEQ_OF(name=u'child-Node-Cells-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Child-Node-Cells-List')), opt=True)
    _Child_Nodes_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Child_Nodes_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Child_Nodes_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Child_Nodes_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__id_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Child_Nodes_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Child_Nodes_List_Item_iE_Extensions__item__id),
        (u'criticality', ___Child_Nodes_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Child_Nodes_List_Item_iE_Extensions__item_._ext = None
    _Child_Nodes_List_Item_iE_Extensions._cont = __Child_Nodes_List_Item_iE_Extensions__item_
    _Child_Nodes_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Child_Nodes_List_Item._cont = ASN1Dict([
        (u'gNB-CU-UE-F1AP-ID', _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID),
        (u'gNB-DU-UE-F1AP-ID', _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID),
        (u'child-Node-Cells-List', _Child_Nodes_List_Item_child_Node_Cells_List),
        (u'iE-Extensions', _Child_Nodes_List_Item_iE_Extensions),
        ])
    Child_Nodes_List_Item._ext = None
    
    #-----< Child-Nodes-List-Item-ExtIEs >-----#
    Child_Nodes_List_Item_ExtIEs = CLASS(name=u'Child-Nodes-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Child_Nodes_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHOtrigger-InterDU >-----#
    CHOtrigger_InterDU = ENUM(name=u'CHOtrigger-InterDU', mode=MODE_TYPE)
    CHOtrigger_InterDU._cont = ASN1Dict([(u'cho-initiation', 0), (u'cho-replace', 1)])
    CHOtrigger_InterDU._ext = []
    
    #-----< CHOtrigger-IntraDU >-----#
    CHOtrigger_IntraDU = ENUM(name=u'CHOtrigger-IntraDU', mode=MODE_TYPE)
    CHOtrigger_IntraDU._cont = ASN1Dict([(u'cho-initiation', 0), (u'cho-replace', 1), (u'cho-cancel', 2)])
    CHOtrigger_IntraDU._ext = []
    
    #-----< CNUEPagingIdentity >-----#
    CNUEPagingIdentity = CHOICE(name=u'CNUEPagingIdentity', mode=MODE_TYPE)
    _CNUEPagingIdentity_fiveG_S_TMSI = BIT_STR(name=u'fiveG-S-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNUEPagingIdentity_fiveG_S_TMSI._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    _CNUEPagingIdentity_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CNUEPagingIdentity_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___CNUEPagingIdentity_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_id._const_tab = ___CNUEPagingIdentity_choice_extension_id_tab
    __CNUEPagingIdentity_choice_extension_id._const_tab_at = None
    __CNUEPagingIdentity_choice_extension_id._const_tab_id = u'id'
    __CNUEPagingIdentity_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___CNUEPagingIdentity_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_criticality._const_tab = ___CNUEPagingIdentity_choice_extension_criticality_tab
    __CNUEPagingIdentity_choice_extension_criticality._const_tab_at = ('..', u'id')
    __CNUEPagingIdentity_choice_extension_criticality._const_tab_id = u'criticality'
    __CNUEPagingIdentity_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___CNUEPagingIdentity_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_value._const_tab = ___CNUEPagingIdentity_choice_extension_value_tab
    __CNUEPagingIdentity_choice_extension_value._const_tab_at = ('..', u'id')
    __CNUEPagingIdentity_choice_extension_value._const_tab_id = u'Value'
    _CNUEPagingIdentity_choice_extension._cont = ASN1Dict([
        (u'id', __CNUEPagingIdentity_choice_extension_id),
        (u'criticality', __CNUEPagingIdentity_choice_extension_criticality),
        (u'value', __CNUEPagingIdentity_choice_extension_value),
        ])
    _CNUEPagingIdentity_choice_extension._ext = None
    CNUEPagingIdentity._cont = ASN1Dict([
        (u'fiveG-S-TMSI', _CNUEPagingIdentity_fiveG_S_TMSI),
        (u'choice-extension', _CNUEPagingIdentity_choice_extension),
        ])
    CNUEPagingIdentity._ext = None
    
    #-----< CNUEPagingIdentity-ExtIEs >-----#
    CNUEPagingIdentity_ExtIEs = CLASS(name=u'CNUEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CNUEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = SEQ(name=u'CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink = SEQ(name=u'compositeAvailableCapacityDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink = SEQ(name=u'compositeAvailableCapacityUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompositeAvailableCapacityGroup_iE_Extensions__item__id),
        (u'criticality', ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacityGroup_iE_Extensions._cont = __CompositeAvailableCapacityGroup_iE_Extensions__item_
    _CompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacityGroup._cont = ASN1Dict([
        (u'compositeAvailableCapacityDownlink', _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink),
        (u'compositeAvailableCapacityUplink', _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink),
        (u'iE-Extensions', _CompositeAvailableCapacityGroup_iE_Extensions),
        ])
    CompositeAvailableCapacityGroup._ext = None
    
    #-----< CompositeAvailableCapacityGroup-ExtIEs >-----#
    CompositeAvailableCapacityGroup_ExtIEs = CLASS(name=u'CompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacity >-----#
    CompositeAvailableCapacity = SEQ(name=u'CompositeAvailableCapacity', mode=MODE_TYPE)
    _CompositeAvailableCapacity_cellCapacityClassValue = INT(name=u'cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellCapacityClassValue')), opt=True)
    _CompositeAvailableCapacity_capacityValue = SEQ(name=u'capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CapacityValue')))
    _CompositeAvailableCapacity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompositeAvailableCapacity_iE_Extensions__item__id),
        (u'criticality', ___CompositeAvailableCapacity_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacity_iE_Extensions._cont = __CompositeAvailableCapacity_iE_Extensions__item_
    _CompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacity._cont = ASN1Dict([
        (u'cellCapacityClassValue', _CompositeAvailableCapacity_cellCapacityClassValue),
        (u'capacityValue', _CompositeAvailableCapacity_capacityValue),
        (u'iE-Extensions', _CompositeAvailableCapacity_iE_Extensions),
        ])
    CompositeAvailableCapacity._ext = None
    
    #-----< CompositeAvailableCapacity-ExtIEs >-----#
    CompositeAvailableCapacity_ExtIEs = CLASS(name=u'CompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHO-Probability >-----#
    CHO_Probability = INT(name=u'CHO-Probability', mode=MODE_TYPE)
    CHO_Probability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< ConditionalInterDUMobilityInformation >-----#
    ConditionalInterDUMobilityInformation = SEQ(name=u'ConditionalInterDUMobilityInformation', mode=MODE_TYPE)
    _ConditionalInterDUMobilityInformation_cho_trigger = ENUM(name=u'cho-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CHOtrigger-InterDU')))
    _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID = INT(name=u'targetgNB-DUUEF1APID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _ConditionalInterDUMobilityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 433), (u'criticality', u'ignore'), (u'Extension', _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id),
        (u'criticality', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_._ext = None
    _ConditionalInterDUMobilityInformation_iE_Extensions._cont = __ConditionalInterDUMobilityInformation_iE_Extensions__item_
    _ConditionalInterDUMobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConditionalInterDUMobilityInformation._cont = ASN1Dict([
        (u'cho-trigger', _ConditionalInterDUMobilityInformation_cho_trigger),
        (u'targetgNB-DUUEF1APID', _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID),
        (u'iE-Extensions', _ConditionalInterDUMobilityInformation_iE_Extensions),
        ])
    ConditionalInterDUMobilityInformation._ext = []
    
    #-----< ConditionalInterDUMobilityInformation-ExtIEs >-----#
    ConditionalInterDUMobilityInformation_ExtIEs = CLASS(name=u'ConditionalInterDUMobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ConditionalInterDUMobilityInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 433), (u'criticality', u'ignore'), (u'Extension', _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConditionalIntraDUMobilityInformation >-----#
    ConditionalIntraDUMobilityInformation = SEQ(name=u'ConditionalIntraDUMobilityInformation', mode=MODE_TYPE)
    _ConditionalIntraDUMobilityInformation_cho_trigger = ENUM(name=u'cho-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CHOtrigger-IntraDU')))
    _ConditionalIntraDUMobilityInformation_targetCellsTocancel = SEQ_OF(name=u'targetCellsTocancel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')), opt=True)
    _ConditionalIntraDUMobilityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 433), (u'criticality', u'ignore'), (u'Extension', _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id),
        (u'criticality', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_._ext = None
    _ConditionalIntraDUMobilityInformation_iE_Extensions._cont = __ConditionalIntraDUMobilityInformation_iE_Extensions__item_
    _ConditionalIntraDUMobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConditionalIntraDUMobilityInformation._cont = ASN1Dict([
        (u'cho-trigger', _ConditionalIntraDUMobilityInformation_cho_trigger),
        (u'targetCellsTocancel', _ConditionalIntraDUMobilityInformation_targetCellsTocancel),
        (u'iE-Extensions', _ConditionalIntraDUMobilityInformation_iE_Extensions),
        ])
    ConditionalIntraDUMobilityInformation._ext = []
    
    #-----< ConditionalIntraDUMobilityInformation-ExtIEs >-----#
    ConditionalIntraDUMobilityInformation_ExtIEs = CLASS(name=u'ConditionalIntraDUMobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ConditionalIntraDUMobilityInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 433), (u'criticality', u'ignore'), (u'Extension', _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConfiguredTACIndication >-----#
    ConfiguredTACIndication = ENUM(name=u'ConfiguredTACIndication', mode=MODE_TYPE)
    ConfiguredTACIndication._cont = ASN1Dict([(u'true', 0)])
    ConfiguredTACIndication._ext = []
    
    #-----< CoordinateID >-----#
    CoordinateID = INT(name=u'CoordinateID', mode=MODE_TYPE)
    CoordinateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< CP-TransportLayerAddress >-----#
    CP_TransportLayerAddress = CHOICE(name=u'CP-TransportLayerAddress', mode=MODE_TYPE)
    _CP_TransportLayerAddress_endpoint_IP_address = BIT_STR(name=u'endpoint-IP-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _CP_TransportLayerAddress_endpoint_IP_address_and_port = SEQ(name=u'endpoint-IP-address-and-port', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Endpoint-IP-address-and-port')))
    _CP_TransportLayerAddress_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CP_TransportLayerAddress_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___CP_TransportLayerAddress_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_id._const_tab = ___CP_TransportLayerAddress_choice_extension_id_tab
    __CP_TransportLayerAddress_choice_extension_id._const_tab_at = None
    __CP_TransportLayerAddress_choice_extension_id._const_tab_id = u'id'
    __CP_TransportLayerAddress_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___CP_TransportLayerAddress_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab = ___CP_TransportLayerAddress_choice_extension_criticality_tab
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab_at = ('..', u'id')
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab_id = u'criticality'
    __CP_TransportLayerAddress_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___CP_TransportLayerAddress_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_value._const_tab = ___CP_TransportLayerAddress_choice_extension_value_tab
    __CP_TransportLayerAddress_choice_extension_value._const_tab_at = ('..', u'id')
    __CP_TransportLayerAddress_choice_extension_value._const_tab_id = u'Value'
    _CP_TransportLayerAddress_choice_extension._cont = ASN1Dict([
        (u'id', __CP_TransportLayerAddress_choice_extension_id),
        (u'criticality', __CP_TransportLayerAddress_choice_extension_criticality),
        (u'value', __CP_TransportLayerAddress_choice_extension_value),
        ])
    _CP_TransportLayerAddress_choice_extension._ext = None
    CP_TransportLayerAddress._cont = ASN1Dict([
        (u'endpoint-IP-address', _CP_TransportLayerAddress_endpoint_IP_address),
        (u'endpoint-IP-address-and-port', _CP_TransportLayerAddress_endpoint_IP_address_and_port),
        (u'choice-extension', _CP_TransportLayerAddress_choice_extension),
        ])
    CP_TransportLayerAddress._ext = None
    
    #-----< CP-TransportLayerAddress-ExtIEs >-----#
    CP_TransportLayerAddress_ExtIEs = CLASS(name=u'CP-TransportLayerAddress-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CP_TransportLayerAddress_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPTrafficType >-----#
    CPTrafficType = INT(name=u'CPTrafficType', mode=MODE_TYPE)
    CPTrafficType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = INT(name=u'transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'transactionID', _CriticalityDiagnostics_transactionID),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name=u'CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        (u'iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        (u'iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        (u'typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        (u'iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< C-RNTI >-----#
    C_RNTI = INT(name=u'C-RNTI', mode=MODE_TYPE)
    C_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< CUDURadioInformationType >-----#
    CUDURadioInformationType = CHOICE(name=u'CUDURadioInformationType', mode=MODE_TYPE)
    _CUDURadioInformationType_rIM = SEQ(name=u'rIM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CUDURIMInformation')))
    _CUDURadioInformationType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CUDURadioInformationType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___CUDURadioInformationType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_id._const_tab = ___CUDURadioInformationType_choice_extension_id_tab
    __CUDURadioInformationType_choice_extension_id._const_tab_at = None
    __CUDURadioInformationType_choice_extension_id._const_tab_id = u'id'
    __CUDURadioInformationType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___CUDURadioInformationType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_criticality._const_tab = ___CUDURadioInformationType_choice_extension_criticality_tab
    __CUDURadioInformationType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __CUDURadioInformationType_choice_extension_criticality._const_tab_id = u'criticality'
    __CUDURadioInformationType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___CUDURadioInformationType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_value._const_tab = ___CUDURadioInformationType_choice_extension_value_tab
    __CUDURadioInformationType_choice_extension_value._const_tab_at = ('..', u'id')
    __CUDURadioInformationType_choice_extension_value._const_tab_id = u'Value'
    _CUDURadioInformationType_choice_extension._cont = ASN1Dict([
        (u'id', __CUDURadioInformationType_choice_extension_id),
        (u'criticality', __CUDURadioInformationType_choice_extension_criticality),
        (u'value', __CUDURadioInformationType_choice_extension_value),
        ])
    _CUDURadioInformationType_choice_extension._ext = None
    CUDURadioInformationType._cont = ASN1Dict([
        (u'rIM', _CUDURadioInformationType_rIM),
        (u'choice-extension', _CUDURadioInformationType_choice_extension),
        ])
    CUDURadioInformationType._ext = None
    
    #-----< CUDURadioInformationType-ExtIEs >-----#
    CUDURadioInformationType_ExtIEs = CLASS(name=u'CUDURadioInformationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CUDURadioInformationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CUDURIMInformation >-----#
    CUDURIMInformation = SEQ(name=u'CUDURIMInformation', mode=MODE_TYPE)
    _CUDURIMInformation_victimgNBSetID = BIT_STR(name=u'victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _CUDURIMInformation_rIMRSDetectionStatus = ENUM(name=u'rIMRSDetectionStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RIMRSDetectionStatus')))
    _CUDURIMInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CUDURIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CUDURIMInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CUDURIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab = ____CUDURIMInformation_iE_Extensions__item__id_tab
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___CUDURIMInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CUDURIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab = ____CUDURIMInformation_iE_Extensions__item__criticality_tab
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CUDURIMInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab = ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CUDURIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CUDURIMInformation_iE_Extensions__item__id),
        (u'criticality', ___CUDURIMInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___CUDURIMInformation_iE_Extensions__item__extensionValue),
        ])
    __CUDURIMInformation_iE_Extensions__item_._ext = None
    _CUDURIMInformation_iE_Extensions._cont = __CUDURIMInformation_iE_Extensions__item_
    _CUDURIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CUDURIMInformation._cont = ASN1Dict([
        (u'victimgNBSetID', _CUDURIMInformation_victimgNBSetID),
        (u'rIMRSDetectionStatus', _CUDURIMInformation_rIMRSDetectionStatus),
        (u'iE-Extensions', _CUDURIMInformation_iE_Extensions),
        ])
    CUDURIMInformation._ext = None
    
    #-----< CUDURIMInformation-ExtIEs >-----#
    CUDURIMInformation_ExtIEs = CLASS(name=u'CUDURIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CUDURIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CUtoDURRCInformation >-----#
    CUtoDURRCInformation = SEQ(name=u'CUtoDURRCInformation', mode=MODE_TYPE)
    _CUtoDURRCInformation_cG_ConfigInfo = OCT_STR(name=u'cG-ConfigInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CG-ConfigInfo')), opt=True)
    _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList = OCT_STR(name=u'uE-CapabilityRAT-ContainerList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UE-CapabilityRAT-ContainerList')), opt=True)
    _CUtoDURRCInformation_measConfig = OCT_STR(name=u'measConfig', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasConfig')), opt=True)
    _CUtoDURRCInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CUtoDURRCInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CUtoDURRCInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CUtoDURRCInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HandoverPreparationInformation')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimingConfiguration')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformation')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-Config')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformationEUTRA')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LocationMeasurementInformation')))
    ____CUtoDURRCInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 119), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 214), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 339), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 440), (u'criticality', u'ignore'), (u'Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab_at = None
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___CUtoDURRCInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CUtoDURRCInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CUtoDURRCInformation_iE_Extensions__item__id),
        (u'criticality', ___CUtoDURRCInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___CUtoDURRCInformation_iE_Extensions__item__extensionValue),
        ])
    __CUtoDURRCInformation_iE_Extensions__item_._ext = None
    _CUtoDURRCInformation_iE_Extensions._cont = __CUtoDURRCInformation_iE_Extensions__item_
    _CUtoDURRCInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CUtoDURRCInformation._cont = ASN1Dict([
        (u'cG-ConfigInfo', _CUtoDURRCInformation_cG_ConfigInfo),
        (u'uE-CapabilityRAT-ContainerList', _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList),
        (u'measConfig', _CUtoDURRCInformation_measConfig),
        (u'iE-Extensions', _CUtoDURRCInformation_iE_Extensions),
        ])
    CUtoDURRCInformation._ext = []
    
    #-----< CUtoDURRCInformation-ExtIEs >-----#
    CUtoDURRCInformation_ExtIEs = CLASS(name=u'CUtoDURRCInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HandoverPreparationInformation')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimingConfiguration')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformation')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-Config')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformationEUTRA')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LocationMeasurementInformation')))
    CUtoDURRCInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 119), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 214), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 339), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 440), (u'criticality', u'ignore'), (u'Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCBasedDuplicationConfigured >-----#
    DCBasedDuplicationConfigured = ENUM(name=u'DCBasedDuplicationConfigured', mode=MODE_TYPE)
    DCBasedDuplicationConfigured._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    DCBasedDuplicationConfigured._ext = [u'false']
    
    #-----< Dedicated-SIDelivery-NeededUE-Item >-----#
    Dedicated_SIDelivery_NeededUE_Item = SEQ(name=u'Dedicated-SIDelivery-NeededUE-Item', mode=MODE_TYPE)
    _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID = INT(name=u'gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _Dedicated_SIDelivery_NeededUE_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab_at = None
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id),
        (u'criticality', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue),
        ])
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_._ext = None
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions._cont = __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dedicated_SIDelivery_NeededUE_Item._cont = ASN1Dict([
        (u'gNB-CU-UE-F1AP-ID', _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID),
        (u'nRCGI', _Dedicated_SIDelivery_NeededUE_Item_nRCGI),
        (u'iE-Extensions', _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions),
        ])
    Dedicated_SIDelivery_NeededUE_Item._ext = []
    
    #-----< DedicatedSIDeliveryNeededUE-Item-ExtIEs >-----#
    DedicatedSIDeliveryNeededUE_Item_ExtIEs = CLASS(name=u'DedicatedSIDeliveryNeededUE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DedicatedSIDeliveryNeededUE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRS >-----#
    DL_PRS = SEQ(name=u'DL-PRS', mode=MODE_TYPE)
    _DL_PRS_prsid = INT(name=u'prsid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRS_prsid._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _DL_PRS_dl_PRSResourceSetID = INT(name=u'dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _DL_PRS_dl_PRSResourceID = INT(name=u'dl-PRSResourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _DL_PRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DL_PRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_PRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__id._const_tab = ____DL_PRS_iE_Extensions__item__id_tab
    ___DL_PRS_iE_Extensions__item__id._const_tab_at = None
    ___DL_PRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_PRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_PRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__criticality._const_tab = ____DL_PRS_iE_Extensions__item__criticality_tab
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_PRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab = ____DL_PRS_iE_Extensions__item__extensionValue_tab
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_PRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_PRS_iE_Extensions__item__id),
        (u'criticality', ___DL_PRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_PRS_iE_Extensions__item__extensionValue),
        ])
    __DL_PRS_iE_Extensions__item_._ext = None
    _DL_PRS_iE_Extensions._cont = __DL_PRS_iE_Extensions__item_
    _DL_PRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PRS._cont = ASN1Dict([
        (u'prsid', _DL_PRS_prsid),
        (u'dl-PRSResourceSetID', _DL_PRS_dl_PRSResourceSetID),
        (u'dl-PRSResourceID', _DL_PRS_dl_PRSResourceID),
        (u'iE-Extensions', _DL_PRS_iE_Extensions),
        ])
    DL_PRS._ext = None
    
    #-----< DL-PRS-ExtIEs >-----#
    DL_PRS_ExtIEs = CLASS(name=u'DL-PRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DL_PRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSMutingPattern >-----#
    DL_PRSMutingPattern = CHOICE(name=u'DL-PRSMutingPattern', mode=MODE_TYPE)
    _DL_PRSMutingPattern_two = BIT_STR(name=u'two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_four = BIT_STR(name=u'four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_six = BIT_STR(name=u'six', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_six._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_eight = BIT_STR(name=u'eight', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_sixteen = BIT_STR(name=u'sixteen', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_thirty_two = BIT_STR(name=u'thirty-two', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSMutingPattern_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DL_PRSMutingPattern_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_id._const_tab = ___DL_PRSMutingPattern_choice_extension_id_tab
    __DL_PRSMutingPattern_choice_extension_id._const_tab_at = None
    __DL_PRSMutingPattern_choice_extension_id._const_tab_id = u'id'
    __DL_PRSMutingPattern_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab = ___DL_PRSMutingPattern_choice_extension_criticality_tab
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_id = u'criticality'
    __DL_PRSMutingPattern_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSMutingPattern_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_value._const_tab = ___DL_PRSMutingPattern_choice_extension_value_tab
    __DL_PRSMutingPattern_choice_extension_value._const_tab_at = ('..', u'id')
    __DL_PRSMutingPattern_choice_extension_value._const_tab_id = u'Value'
    _DL_PRSMutingPattern_choice_extension._cont = ASN1Dict([
        (u'id', __DL_PRSMutingPattern_choice_extension_id),
        (u'criticality', __DL_PRSMutingPattern_choice_extension_criticality),
        (u'value', __DL_PRSMutingPattern_choice_extension_value),
        ])
    _DL_PRSMutingPattern_choice_extension._ext = None
    DL_PRSMutingPattern._cont = ASN1Dict([
        (u'two', _DL_PRSMutingPattern_two),
        (u'four', _DL_PRSMutingPattern_four),
        (u'six', _DL_PRSMutingPattern_six),
        (u'eight', _DL_PRSMutingPattern_eight),
        (u'sixteen', _DL_PRSMutingPattern_sixteen),
        (u'thirty-two', _DL_PRSMutingPattern_thirty_two),
        (u'choice-extension', _DL_PRSMutingPattern_choice_extension),
        ])
    DL_PRSMutingPattern._ext = None
    
    #-----< DL-PRSMutingPattern-ExtIEs >-----#
    DL_PRSMutingPattern_ExtIEs = CLASS(name=u'DL-PRSMutingPattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSMutingPattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceCoordinates >-----#
    DLPRSResourceCoordinates = SEQ(name=u'DLPRSResourceCoordinates', mode=MODE_TYPE)
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP = SEQ_OF(name=u'listofDL-PRSResourceSetARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceSetARP')))
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._cont = __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _DLPRSResourceCoordinates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceCoordinates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceCoordinates_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceCoordinates_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceCoordinates_iE_Extensions__item_._ext = None
    _DLPRSResourceCoordinates_iE_Extensions._cont = __DLPRSResourceCoordinates_iE_Extensions__item_
    _DLPRSResourceCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceCoordinates._cont = ASN1Dict([
        (u'listofDL-PRSResourceSetARP', _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP),
        (u'iE-Extensions', _DLPRSResourceCoordinates_iE_Extensions),
        ])
    DLPRSResourceCoordinates._ext = None
    
    #-----< DLPRSResourceCoordinates-ExtIEs >-----#
    DLPRSResourceCoordinates_ExtIEs = CLASS(name=u'DLPRSResourceCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceSetARP >-----#
    DLPRSResourceSetARP = SEQ(name=u'DLPRSResourceSetARP', mode=MODE_TYPE)
    _DLPRSResourceSetARP_dl_PRSResourceSetID = INT(name=u'dl-PRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation = CHOICE(name=u'dL-PRSResourceSetARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSResourceSetARPLocation')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP = SEQ_OF(name=u'listofDL-PRSResourceARP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceARP')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._cont = __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _DLPRSResourceSetARP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceSetARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceSetARP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__id_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceSetARP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceSetARP_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceSetARP_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceSetARP_iE_Extensions__item_._ext = None
    _DLPRSResourceSetARP_iE_Extensions._cont = __DLPRSResourceSetARP_iE_Extensions__item_
    _DLPRSResourceSetARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceSetARP._cont = ASN1Dict([
        (u'dl-PRSResourceSetID', _DLPRSResourceSetARP_dl_PRSResourceSetID),
        (u'dL-PRSResourceSetARPLocation', _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation),
        (u'listofDL-PRSResourceARP', _DLPRSResourceSetARP_listofDL_PRSResourceARP),
        (u'iE-Extensions', _DLPRSResourceSetARP_iE_Extensions),
        ])
    DLPRSResourceSetARP._ext = None
    
    #-----< DLPRSResourceSetARP-ExtIEs >-----#
    DLPRSResourceSetARP_ExtIEs = CLASS(name=u'DLPRSResourceSetARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceSetARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceSetARPLocation >-----#
    DL_PRSResourceSetARPLocation = CHOICE(name=u'DL-PRSResourceSetARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceSetARPLocation_relativeGeodeticLocation = SEQ(name=u'relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceSetARPLocation_relativeCartesianLocation = SEQ(name=u'relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceSetARPLocation_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSResourceSetARPLocation_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_id = u'id'
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_id = u'criticality'
    __DL_PRSResourceSetARPLocation_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_at = ('..', u'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_id = u'Value'
    _DL_PRSResourceSetARPLocation_choice_Extension._cont = ASN1Dict([
        (u'id', __DL_PRSResourceSetARPLocation_choice_Extension_id),
        (u'criticality', __DL_PRSResourceSetARPLocation_choice_Extension_criticality),
        (u'value', __DL_PRSResourceSetARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceSetARPLocation_choice_Extension._ext = None
    DL_PRSResourceSetARPLocation._cont = ASN1Dict([
        (u'relativeGeodeticLocation', _DL_PRSResourceSetARPLocation_relativeGeodeticLocation),
        (u'relativeCartesianLocation', _DL_PRSResourceSetARPLocation_relativeCartesianLocation),
        (u'choice-Extension', _DL_PRSResourceSetARPLocation_choice_Extension),
        ])
    DL_PRSResourceSetARPLocation._ext = None
    
    #-----< DL-PRSResourceSetARPLocation-ExtIEs >-----#
    DL_PRSResourceSetARPLocation_ExtIEs = CLASS(name=u'DL-PRSResourceSetARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSResourceSetARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceARP >-----#
    DLPRSResourceARP = SEQ(name=u'DLPRSResourceARP', mode=MODE_TYPE)
    _DLPRSResourceARP_dl_PRSResourceID = INT(name=u'dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceARP_dL_PRSResourceARPLocation = CHOICE(name=u'dL-PRSResourceARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSResourceARPLocation')))
    _DLPRSResourceARP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceARP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceARP_iE_Extensions__item__id_tab
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceARP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceARP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceARP_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceARP_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceARP_iE_Extensions__item_._ext = None
    _DLPRSResourceARP_iE_Extensions._cont = __DLPRSResourceARP_iE_Extensions__item_
    _DLPRSResourceARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceARP._cont = ASN1Dict([
        (u'dl-PRSResourceID', _DLPRSResourceARP_dl_PRSResourceID),
        (u'dL-PRSResourceARPLocation', _DLPRSResourceARP_dL_PRSResourceARPLocation),
        (u'iE-Extensions', _DLPRSResourceARP_iE_Extensions),
        ])
    DLPRSResourceARP._ext = None
    
    #-----< DLPRSResourceARP-ExtIEs >-----#
    DLPRSResourceARP_ExtIEs = CLASS(name=u'DLPRSResourceARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceARPLocation >-----#
    DL_PRSResourceARPLocation = CHOICE(name=u'DL-PRSResourceARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceARPLocation_relativeGeodeticLocation = SEQ(name=u'relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceARPLocation_relativeCartesianLocation = SEQ(name=u'relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceARPLocation_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSResourceARPLocation_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_id_tab
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_id = u'id'
    __DL_PRSResourceARPLocation_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_id = u'criticality'
    __DL_PRSResourceARPLocation_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_value_tab
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_at = ('..', u'id')
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_id = u'Value'
    _DL_PRSResourceARPLocation_choice_Extension._cont = ASN1Dict([
        (u'id', __DL_PRSResourceARPLocation_choice_Extension_id),
        (u'criticality', __DL_PRSResourceARPLocation_choice_Extension_criticality),
        (u'value', __DL_PRSResourceARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceARPLocation_choice_Extension._ext = None
    DL_PRSResourceARPLocation._cont = ASN1Dict([
        (u'relativeGeodeticLocation', _DL_PRSResourceARPLocation_relativeGeodeticLocation),
        (u'relativeCartesianLocation', _DL_PRSResourceARPLocation_relativeCartesianLocation),
        (u'choice-Extension', _DL_PRSResourceARPLocation_choice_Extension),
        ])
    DL_PRSResourceARPLocation._ext = None
    
    #-----< DL-PRSResourceARPLocation-ExtIEs >-----#
    DL_PRSResourceARPLocation_ExtIEs = CLASS(name=u'DL-PRSResourceARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSResourceARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List-Item >-----#
    DL_UP_TNL_Address_to_Update_List_Item = SEQ(name=u'DL-UP-TNL-Address-to-Update-List-Item', mode=MODE_TYPE)
    _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress = BIT_STR(name=u'oldIPAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress = BIT_STR(name=u'newIPAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id),
        (u'criticality', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._ext = None
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._cont = __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_UP_TNL_Address_to_Update_List_Item._cont = ASN1Dict([
        (u'oldIPAdress', _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress),
        (u'newIPAdress', _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress),
        (u'iE-Extensions', _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions),
        ])
    DL_UP_TNL_Address_to_Update_List_Item._ext = []
    
    #-----< DL-UP-TNL-Address-to-Update-List-ItemExtIEs >-----#
    DL_UP_TNL_Address_to_Update_List_ItemExtIEs = CLASS(name=u'DL-UP-TNL-Address-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DL_UP_TNL_Address_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLUPTNLInformation-ToBeSetup-List >-----#
    DLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'DLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE)
    _DLUPTNLInformation_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-Item')))
    DLUPTNLInformation_ToBeSetup_List._cont = _DLUPTNLInformation_ToBeSetup_List__item_
    DLUPTNLInformation_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< DLUPTNLInformation-ToBeSetup-Item >-----#
    DLUPTNLInformation_ToBeSetup_Item = SEQ(name=u'DLUPTNLInformation-ToBeSetup-Item', mode=MODE_TYPE)
    _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation = CHOICE(name=u'dLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions._cont = __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLUPTNLInformation_ToBeSetup_Item._cont = ASN1Dict([
        (u'dLUPTNLInformation', _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation),
        (u'iE-Extensions', _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions),
        ])
    DLUPTNLInformation_ToBeSetup_Item._ext = []
    
    #-----< DLUPTNLInformation-ToBeSetup-ItemExtIEs >-----#
    DLUPTNLInformation_ToBeSetup_ItemExtIEs = CLASS(name=u'DLUPTNLInformation-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLUPTNLInformation_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity-Item >-----#
    DRB_Activity_Item = SEQ(name=u'DRB-Activity-Item', mode=MODE_TYPE)
    _DRB_Activity_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRB_Activity_Item_dRB_Activity = ENUM(name=u'dRB-Activity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity')), opt=True)
    _DRB_Activity_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Activity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Activity_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab = ____DRB_Activity_Item_iE_Extensions__item__id_tab
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRB_Activity_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Activity_Item_iE_Extensions__item__criticality_tab
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRB_Activity_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRB_Activity_Item_iE_Extensions__item__id),
        (u'criticality', ___DRB_Activity_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRB_Activity_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Activity_Item_iE_Extensions__item_._ext = None
    _DRB_Activity_Item_iE_Extensions._cont = __DRB_Activity_Item_iE_Extensions__item_
    _DRB_Activity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Activity_Item._cont = ASN1Dict([
        (u'dRBID', _DRB_Activity_Item_dRBID),
        (u'dRB-Activity', _DRB_Activity_Item_dRB_Activity),
        (u'iE-Extensions', _DRB_Activity_Item_iE_Extensions),
        ])
    DRB_Activity_Item._ext = []
    
    #-----< DRB-Activity-ItemExtIEs >-----#
    DRB_Activity_ItemExtIEs = CLASS(name=u'DRB-Activity-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRB_Activity_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity >-----#
    DRB_Activity = ENUM(name=u'DRB-Activity', mode=MODE_TYPE)
    DRB_Activity._cont = ASN1Dict([(u'active', 0), (u'not-active', 1)])
    DRB_Activity._ext = None
    
    #-----< DRBID >-----#
    DRBID = INT(name=u'DRBID', mode=MODE_TYPE)
    DRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< DRBs-FailedToBeModified-Item >-----#
    DRBs_FailedToBeModified_Item = SEQ(name=u'DRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeModified_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeModified_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeModified_Item_iE_Extensions._cont = __DRBs_FailedToBeModified_Item_iE_Extensions__item_
    _DRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeModified_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_FailedToBeModified_Item_dRBID),
        (u'cause', _DRBs_FailedToBeModified_Item_cause),
        (u'iE-Extensions', _DRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    DRBs_FailedToBeModified_Item._ext = []
    
    #-----< DRBs-FailedToBeModified-ItemExtIEs >-----#
    DRBs_FailedToBeModified_ItemExtIEs = CLASS(name=u'DRBs-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetup-Item >-----#
    DRBs_FailedToBeSetup_Item = SEQ(name=u'DRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeSetup_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeSetup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeSetup_Item_iE_Extensions._cont = __DRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _DRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_FailedToBeSetup_Item_dRBID),
        (u'cause', _DRBs_FailedToBeSetup_Item_cause),
        (u'iE-Extensions', _DRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    DRBs_FailedToBeSetup_Item._ext = []
    
    #-----< DRBs-FailedToBeSetup-ItemExtIEs >-----#
    DRBs_FailedToBeSetup_ItemExtIEs = CLASS(name=u'DRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetupMod-Item >-----#
    DRBs_FailedToBeSetupMod_Item = SEQ(name=u'DRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeSetupMod_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeSetupMod_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_FailedToBeSetupMod_Item_dRBID),
        (u'cause', _DRBs_FailedToBeSetupMod_Item_cause),
        (u'iE-Extensions', _DRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    DRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< DRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    DRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name=u'DRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Information >-----#
    DRB_Information = SEQ(name=u'DRB-Information', mode=MODE_TYPE)
    _DRB_Information_dRB_QoS = SEQ(name=u'dRB-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _DRB_Information_sNSSAI = SEQ(name=u'sNSSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _DRB_Information_notificationControl = ENUM(name=u'notificationControl', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NotificationControl')), opt=True)
    _DRB_Information_flows_Mapped_To_DRB_List = SEQ_OF(name=u'flows-Mapped-To-DRB-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Flows-Mapped-To-DRB-List')))
    _DRB_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRB_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__id._const_tab = ____DRB_Information_iE_Extensions__item__id_tab
    ___DRB_Information_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRB_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRB_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__criticality._const_tab = ____DRB_Information_iE_Extensions__item__criticality_tab
    ___DRB_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRB_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRB_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRB_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab = ____DRB_Information_iE_Extensions__item__extensionValue_tab
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRB_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRB_Information_iE_Extensions__item__id),
        (u'criticality', ___DRB_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRB_Information_iE_Extensions__item__extensionValue),
        ])
    __DRB_Information_iE_Extensions__item_._ext = None
    _DRB_Information_iE_Extensions._cont = __DRB_Information_iE_Extensions__item_
    _DRB_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Information._cont = ASN1Dict([
        (u'dRB-QoS', _DRB_Information_dRB_QoS),
        (u'sNSSAI', _DRB_Information_sNSSAI),
        (u'notificationControl', _DRB_Information_notificationControl),
        (u'flows-Mapped-To-DRB-List', _DRB_Information_flows_Mapped_To_DRB_List),
        (u'iE-Extensions', _DRB_Information_iE_Extensions),
        ])
    DRB_Information._ext = None
    
    #-----< DRB-Information-ItemExtIEs >-----#
    DRB_Information_ItemExtIEs = CLASS(name=u'DRB-Information-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRB_Information_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Modified-Item >-----#
    DRBs_Modified_Item = SEQ(name=u'DRBs-Modified-Item', mode=MODE_TYPE)
    _DRBs_Modified_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Modified_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Modified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Modified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_Modified_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_Modified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Modified_Item_iE_Extensions__item_._ext = None
    _DRBs_Modified_Item_iE_Extensions._cont = __DRBs_Modified_Item_iE_Extensions__item_
    _DRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Modified_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_Modified_Item_dRBID),
        (u'lCID', _DRBs_Modified_Item_lCID),
        (u'dLUPTNLInformation-ToBeSetup-List', _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List),
        (u'iE-Extensions', _DRBs_Modified_Item_iE_Extensions),
        ])
    DRBs_Modified_Item._ext = []
    
    #-----< DRBs-Modified-ItemExtIEs >-----#
    DRBs_Modified_ItemExtIEs = CLASS(name=u'DRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Modified_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _DRBs_Modified_ItemExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_Modified_ItemExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _DRBs_Modified_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_Modified_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _DRBs_Modified_ItemExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ModifiedConf-Item >-----#
    DRBs_ModifiedConf_Item = SEQ(name=u'DRBs-ModifiedConf-Item', mode=MODE_TYPE)
    _DRBs_ModifiedConf_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ModifiedConf_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ModifiedConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_ModifiedConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_ModifiedConf_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ModifiedConf_Item_iE_Extensions__item_._ext = None
    _DRBs_ModifiedConf_Item_iE_Extensions._cont = __DRBs_ModifiedConf_Item_iE_Extensions__item_
    _DRBs_ModifiedConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ModifiedConf_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_ModifiedConf_Item_dRBID),
        (u'uLUPTNLInformation-ToBeSetup-List', _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List),
        (u'iE-Extensions', _DRBs_ModifiedConf_Item_iE_Extensions),
        ])
    DRBs_ModifiedConf_Item._ext = []
    
    #-----< DRBs-ModifiedConf-ItemExtIEs >-----#
    DRBs_ModifiedConf_ItemExtIEs = CLASS(name=u'DRBs-ModifiedConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    DRBs_ModifiedConf_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Notify-Item >-----#
    DRB_Notify_Item = SEQ(name=u'DRB-Notify-Item', mode=MODE_TYPE)
    _DRB_Notify_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRB_Notify_Item_notification_Cause = ENUM(name=u'notification-Cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Notification-Cause')))
    _DRB_Notify_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Notify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Notify_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRB_Notify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetNotifyIndex')))
    ____DRB_Notify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRB_Notify_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRB_Notify_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRB_Notify_Item_iE_Extensions__item__id),
        (u'criticality', ___DRB_Notify_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRB_Notify_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Notify_Item_iE_Extensions__item_._ext = None
    _DRB_Notify_Item_iE_Extensions._cont = __DRB_Notify_Item_iE_Extensions__item_
    _DRB_Notify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Notify_Item._cont = ASN1Dict([
        (u'dRBID', _DRB_Notify_Item_dRBID),
        (u'notification-Cause', _DRB_Notify_Item_notification_Cause),
        (u'iE-Extensions', _DRB_Notify_Item_iE_Extensions),
        ])
    DRB_Notify_Item._ext = []
    
    #-----< DRB-Notify-ItemExtIEs >-----#
    DRB_Notify_ItemExtIEs = CLASS(name=u'DRB-Notify-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRB_Notify_ItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetNotifyIndex')))
    DRB_Notify_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _DRB_Notify_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeModified-Item >-----#
    DRBs_Required_ToBeModified_Item = SEQ(name=u'DRBs-Required-ToBeModified-Item', mode=MODE_TYPE)
    _DRBs_Required_ToBeModified_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Required_ToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_Required_ToBeModified_Item_iE_Extensions._cont = __DRBs_Required_ToBeModified_Item_iE_Extensions__item_
    _DRBs_Required_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Required_ToBeModified_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_Required_ToBeModified_Item_dRBID),
        (u'dLUPTNLInformation-ToBeSetup-List', _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List),
        (u'iE-Extensions', _DRBs_Required_ToBeModified_Item_iE_Extensions),
        ])
    DRBs_Required_ToBeModified_Item._ext = []
    
    #-----< DRBs-Required-ToBeModified-ItemExtIEs >-----#
    DRBs_Required_ToBeModified_ItemExtIEs = CLASS(name=u'DRBs-Required-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    DRBs_Required_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeReleased-Item >-----#
    DRBs_Required_ToBeReleased_Item = SEQ(name=u'DRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _DRBs_Required_ToBeReleased_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _DRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _DRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_Required_ToBeReleased_Item_dRBID),
        (u'iE-Extensions', _DRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    DRBs_Required_ToBeReleased_Item._ext = []
    
    #-----< DRBs-Required-ToBeReleased-ItemExtIEs >-----#
    DRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name=u'DRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Setup-Item >-----#
    DRBs_Setup_Item = SEQ(name=u'DRBs-Setup-Item', mode=MODE_TYPE)
    _DRBs_Setup_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Setup_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Setup_Item_iE_Extensions__item_._ext = None
    _DRBs_Setup_Item_iE_Extensions._cont = __DRBs_Setup_Item_iE_Extensions__item_
    _DRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Setup_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_Setup_Item_dRBID),
        (u'lCID', _DRBs_Setup_Item_lCID),
        (u'dLUPTNLInformation-ToBeSetup-List', _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List),
        (u'iE-Extensions', _DRBs_Setup_Item_iE_Extensions),
        ])
    DRBs_Setup_Item._ext = []
    
    #-----< DRBs-Setup-ItemExtIEs >-----#
    DRBs_Setup_ItemExtIEs = CLASS(name=u'DRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Setup_ItemExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_Setup_ItemExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_Setup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _DRBs_Setup_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-SetupMod-Item >-----#
    DRBs_SetupMod_Item = SEQ(name=u'DRBs-SetupMod-Item', mode=MODE_TYPE)
    _DRBs_SetupMod_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_SetupMod_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_SetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_SetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_SetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_SetupMod_Item_iE_Extensions._cont = __DRBs_SetupMod_Item_iE_Extensions__item_
    _DRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_SetupMod_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_SetupMod_Item_dRBID),
        (u'lCID', _DRBs_SetupMod_Item_lCID),
        (u'dLUPTNLInformation-ToBeSetup-List', _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List),
        (u'iE-Extensions', _DRBs_SetupMod_Item_iE_Extensions),
        ])
    DRBs_SetupMod_Item._ext = []
    
    #-----< DRBs-SetupMod-ItemExtIEs >-----#
    DRBs_SetupMod_ItemExtIEs = CLASS(name=u'DRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_SetupMod_ItemExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_SetupMod_ItemExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_SetupMod_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 344), (u'criticality', u'ignore'), (u'Extension', _DRBs_SetupMod_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeModified-Item >-----#
    DRBs_ToBeModified_Item = SEQ(name=u'DRBs-ToBeModified-Item', mode=MODE_TYPE)
    _DRBs_ToBeModified_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeModified_Item_qoSInformation = CHOICE(name=u'qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')), opt=True)
    _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeModified_Item_uLConfiguration = SEQ(name=u'uLConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BearerTypeChange')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionStopIndicator')))
    ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 430), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_ToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeModified_Item_iE_Extensions._cont = __DRBs_ToBeModified_Item_iE_Extensions__item_
    _DRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeModified_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_ToBeModified_Item_dRBID),
        (u'qoSInformation', _DRBs_ToBeModified_Item_qoSInformation),
        (u'uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List),
        (u'uLConfiguration', _DRBs_ToBeModified_Item_uLConfiguration),
        (u'iE-Extensions', _DRBs_ToBeModified_Item_iE_Extensions),
        ])
    DRBs_ToBeModified_Item._ext = []
    
    #-----< DRBs-ToBeModified-ItemExtIEs >-----#
    DRBs_ToBeModified_ItemExtIEs = CLASS(name=u'DRBs-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BearerTypeChange')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionStopIndicator')))
    DRBs_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 430), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeReleased-Item >-----#
    DRBs_ToBeReleased_Item = SEQ(name=u'DRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _DRBs_ToBeReleased_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeReleased_Item_iE_Extensions._cont = __DRBs_ToBeReleased_Item_iE_Extensions__item_
    _DRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeReleased_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_ToBeReleased_Item_dRBID),
        (u'iE-Extensions', _DRBs_ToBeReleased_Item_iE_Extensions),
        ])
    DRBs_ToBeReleased_Item._ext = []
    
    #-----< DRBs-ToBeReleased-ItemExtIEs >-----#
    DRBs_ToBeReleased_ItemExtIEs = CLASS(name=u'DRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetup-Item >-----#
    DRBs_ToBeSetup_Item = SEQ(name=u'DRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _DRBs_ToBeSetup_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeSetup_Item_qoSInformation = CHOICE(name=u'qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')))
    _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeSetup_Item_rLCMode = ENUM(name=u'rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeSetup_Item_uLConfiguration = SEQ(name=u'uLConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeSetup_Item_duplicationActivation = ENUM(name=u'duplicationActivation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')), opt=True)
    _DRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'mandatory')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeSetup_Item_iE_Extensions._cont = __DRBs_ToBeSetup_Item_iE_Extensions__item_
    _DRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeSetup_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_ToBeSetup_Item_dRBID),
        (u'qoSInformation', _DRBs_ToBeSetup_Item_qoSInformation),
        (u'uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List),
        (u'rLCMode', _DRBs_ToBeSetup_Item_rLCMode),
        (u'uLConfiguration', _DRBs_ToBeSetup_Item_uLConfiguration),
        (u'duplicationActivation', _DRBs_ToBeSetup_Item_duplicationActivation),
        (u'iE-Extensions', _DRBs_ToBeSetup_Item_iE_Extensions),
        ])
    DRBs_ToBeSetup_Item._ext = []
    
    #-----< DRBs-ToBeSetup-ItemExtIEs >-----#
    DRBs_ToBeSetup_ItemExtIEs = CLASS(name=u'DRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    DRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2), (u'presence', u'mandatory')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetupMod-Item >-----#
    DRBs_ToBeSetupMod_Item = SEQ(name=u'DRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _DRBs_ToBeSetupMod_Item_dRBID = INT(name=u'dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeSetupMod_Item_qoSInformation = CHOICE(name=u'qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')))
    _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeSetupMod_Item_rLCMode = ENUM(name=u'rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeSetupMod_Item_uLConfiguration = SEQ(name=u'uLConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeSetupMod_Item_duplicationActivation = ENUM(name=u'duplicationActivation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')), opt=True)
    _DRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeSetupMod_Item_iE_Extensions._cont = __DRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _DRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        (u'dRBID', _DRBs_ToBeSetupMod_Item_dRBID),
        (u'qoSInformation', _DRBs_ToBeSetupMod_Item_qoSInformation),
        (u'uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List),
        (u'rLCMode', _DRBs_ToBeSetupMod_Item_rLCMode),
        (u'uLConfiguration', _DRBs_ToBeSetupMod_Item_uLConfiguration),
        (u'duplicationActivation', _DRBs_ToBeSetupMod_Item_duplicationActivation),
        (u'iE-Extensions', _DRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    DRBs_ToBeSetupMod_Item._ext = []
    
    #-----< DRBs-ToBeSetupMod-ItemExtIEs >-----#
    DRBs_ToBeSetupMod_ItemExtIEs = CLASS(name=u'DRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    DRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 370), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 371), (u'criticality', u'ignore'), (u'Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRXCycle >-----#
    DRXCycle = SEQ(name=u'DRXCycle', mode=MODE_TYPE)
    _DRXCycle_longDRXCycleLength = ENUM(name=u'longDRXCycleLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LongDRXCycleLength')))
    _DRXCycle_shortDRXCycleLength = ENUM(name=u'shortDRXCycleLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ShortDRXCycleLength')), opt=True)
    _DRXCycle_shortDRXCycleTimer = INT(name=u'shortDRXCycleTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ShortDRXCycleTimer')), opt=True)
    _DRXCycle_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRXCycle_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRXCycle_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRXCycle_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__id._const_tab = ____DRXCycle_iE_Extensions__item__id_tab
    ___DRXCycle_iE_Extensions__item__id._const_tab_at = None
    ___DRXCycle_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRXCycle_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRXCycle_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__criticality._const_tab = ____DRXCycle_iE_Extensions__item__criticality_tab
    ___DRXCycle_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRXCycle_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRXCycle_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRXCycle_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab = ____DRXCycle_iE_Extensions__item__extensionValue_tab
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRXCycle_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRXCycle_iE_Extensions__item__id),
        (u'criticality', ___DRXCycle_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRXCycle_iE_Extensions__item__extensionValue),
        ])
    __DRXCycle_iE_Extensions__item_._ext = None
    _DRXCycle_iE_Extensions._cont = __DRXCycle_iE_Extensions__item_
    _DRXCycle_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRXCycle._cont = ASN1Dict([
        (u'longDRXCycleLength', _DRXCycle_longDRXCycleLength),
        (u'shortDRXCycleLength', _DRXCycle_shortDRXCycleLength),
        (u'shortDRXCycleTimer', _DRXCycle_shortDRXCycleTimer),
        (u'iE-Extensions', _DRXCycle_iE_Extensions),
        ])
    DRXCycle._ext = []
    
    #-----< DRXCycle-ExtIEs >-----#
    DRXCycle_ExtIEs = CLASS(name=u'DRXCycle-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRXCycle_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRX-Config >-----#
    DRX_Config = OCT_STR(name=u'DRX-Config', mode=MODE_TYPE)
    
    #-----< DRXConfigurationIndicator >-----#
    DRXConfigurationIndicator = ENUM(name=u'DRXConfigurationIndicator', mode=MODE_TYPE)
    DRXConfigurationIndicator._cont = ASN1Dict([(u'release', 0)])
    DRXConfigurationIndicator._ext = []
    
    #-----< DRX-LongCycleStartOffset >-----#
    DRX_LongCycleStartOffset = INT(name=u'DRX-LongCycleStartOffset', mode=MODE_TYPE)
    DRX_LongCycleStartOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=None, er=[])
    
    #-----< DSInformationList >-----#
    DSInformationList = SEQ_OF(name=u'DSInformationList', mode=MODE_TYPE)
    _DSInformationList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DSCP')))
    DSInformationList._cont = _DSInformationList__item_
    DSInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< DSCP >-----#
    DSCP = BIT_STR(name=u'DSCP', mode=MODE_TYPE)
    DSCP._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< DUtoCURRCContainer >-----#
    DUtoCURRCContainer = OCT_STR(name=u'DUtoCURRCContainer', mode=MODE_TYPE)
    
    #-----< DUCURadioInformationType >-----#
    DUCURadioInformationType = CHOICE(name=u'DUCURadioInformationType', mode=MODE_TYPE)
    _DUCURadioInformationType_rIM = SEQ(name=u'rIM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUCURIMInformation')))
    _DUCURadioInformationType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DUCURadioInformationType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DUCURadioInformationType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_id._const_tab = ___DUCURadioInformationType_choice_extension_id_tab
    __DUCURadioInformationType_choice_extension_id._const_tab_at = None
    __DUCURadioInformationType_choice_extension_id._const_tab_id = u'id'
    __DUCURadioInformationType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DUCURadioInformationType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_criticality._const_tab = ___DUCURadioInformationType_choice_extension_criticality_tab
    __DUCURadioInformationType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __DUCURadioInformationType_choice_extension_criticality._const_tab_id = u'criticality'
    __DUCURadioInformationType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DUCURadioInformationType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_value._const_tab = ___DUCURadioInformationType_choice_extension_value_tab
    __DUCURadioInformationType_choice_extension_value._const_tab_at = ('..', u'id')
    __DUCURadioInformationType_choice_extension_value._const_tab_id = u'Value'
    _DUCURadioInformationType_choice_extension._cont = ASN1Dict([
        (u'id', __DUCURadioInformationType_choice_extension_id),
        (u'criticality', __DUCURadioInformationType_choice_extension_criticality),
        (u'value', __DUCURadioInformationType_choice_extension_value),
        ])
    _DUCURadioInformationType_choice_extension._ext = None
    DUCURadioInformationType._cont = ASN1Dict([
        (u'rIM', _DUCURadioInformationType_rIM),
        (u'choice-extension', _DUCURadioInformationType_choice_extension),
        ])
    DUCURadioInformationType._ext = None
    
    #-----< DUCURadioInformationType-ExtIEs >-----#
    DUCURadioInformationType_ExtIEs = CLASS(name=u'DUCURadioInformationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DUCURadioInformationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUCURIMInformation >-----#
    DUCURIMInformation = SEQ(name=u'DUCURIMInformation', mode=MODE_TYPE)
    _DUCURIMInformation_victimgNBSetID = BIT_STR(name=u'victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _DUCURIMInformation_rIMRSDetectionStatus = ENUM(name=u'rIMRSDetectionStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RIMRSDetectionStatus')))
    _DUCURIMInformation_aggressorCellList = SEQ_OF(name=u'aggressorCellList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AggressorCellList')))
    _DUCURIMInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DUCURIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DUCURIMInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DUCURIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab = ____DUCURIMInformation_iE_Extensions__item__id_tab
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DUCURIMInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DUCURIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab = ____DUCURIMInformation_iE_Extensions__item__criticality_tab
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DUCURIMInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab = ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DUCURIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DUCURIMInformation_iE_Extensions__item__id),
        (u'criticality', ___DUCURIMInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DUCURIMInformation_iE_Extensions__item__extensionValue),
        ])
    __DUCURIMInformation_iE_Extensions__item_._ext = None
    _DUCURIMInformation_iE_Extensions._cont = __DUCURIMInformation_iE_Extensions__item_
    _DUCURIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DUCURIMInformation._cont = ASN1Dict([
        (u'victimgNBSetID', _DUCURIMInformation_victimgNBSetID),
        (u'rIMRSDetectionStatus', _DUCURIMInformation_rIMRSDetectionStatus),
        (u'aggressorCellList', _DUCURIMInformation_aggressorCellList),
        (u'iE-Extensions', _DUCURIMInformation_iE_Extensions),
        ])
    DUCURIMInformation._ext = None
    
    #-----< DUCURIMInformation-ExtIEs >-----#
    DUCURIMInformation_ExtIEs = CLASS(name=u'DUCURIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DUCURIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUF-Slot-Config-Item >-----#
    DUF_Slot_Config_Item = CHOICE(name=u'DUF-Slot-Config-Item', mode=MODE_TYPE)
    _DUF_Slot_Config_Item_explicitFormat = SEQ(name=u'explicitFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExplicitFormat')))
    _DUF_Slot_Config_Item_implicitFormat = SEQ(name=u'implicitFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ImplicitFormat')))
    _DUF_Slot_Config_Item_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DUF_Slot_Config_Item_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DUF_Slot_Config_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_id._const_tab = ___DUF_Slot_Config_Item_choice_extension_id_tab
    __DUF_Slot_Config_Item_choice_extension_id._const_tab_at = None
    __DUF_Slot_Config_Item_choice_extension_id._const_tab_id = u'id'
    __DUF_Slot_Config_Item_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DUF_Slot_Config_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab = ___DUF_Slot_Config_Item_choice_extension_criticality_tab
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab_at = ('..', u'id')
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab_id = u'criticality'
    __DUF_Slot_Config_Item_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DUF_Slot_Config_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_value._const_tab = ___DUF_Slot_Config_Item_choice_extension_value_tab
    __DUF_Slot_Config_Item_choice_extension_value._const_tab_at = ('..', u'id')
    __DUF_Slot_Config_Item_choice_extension_value._const_tab_id = u'Value'
    _DUF_Slot_Config_Item_choice_extension._cont = ASN1Dict([
        (u'id', __DUF_Slot_Config_Item_choice_extension_id),
        (u'criticality', __DUF_Slot_Config_Item_choice_extension_criticality),
        (u'value', __DUF_Slot_Config_Item_choice_extension_value),
        ])
    _DUF_Slot_Config_Item_choice_extension._ext = None
    DUF_Slot_Config_Item._cont = ASN1Dict([
        (u'explicitFormat', _DUF_Slot_Config_Item_explicitFormat),
        (u'implicitFormat', _DUF_Slot_Config_Item_implicitFormat),
        (u'choice-extension', _DUF_Slot_Config_Item_choice_extension),
        ])
    DUF_Slot_Config_Item._ext = None
    
    #-----< DUF-Slot-Config-Item-ExtIEs >-----#
    DUF_Slot_Config_Item_ExtIEs = CLASS(name=u'DUF-Slot-Config-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DUF_Slot_Config_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUF-Slot-Config-List >-----#
    DUF_Slot_Config_List = SEQ_OF(name=u'DUF-Slot-Config-List', mode=MODE_TYPE)
    _DUF_Slot_Config_List__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUF-Slot-Config-Item')))
    DUF_Slot_Config_List._cont = _DUF_Slot_Config_List__item_
    DUF_Slot_Config_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< DUFSlotformatIndex >-----#
    DUFSlotformatIndex = INT(name=u'DUFSlotformatIndex', mode=MODE_TYPE)
    DUFSlotformatIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=254)], ev=None, er=[])
    
    #-----< DUFTransmissionPeriodicity >-----#
    DUFTransmissionPeriodicity = ENUM(name=u'DUFTransmissionPeriodicity', mode=MODE_TYPE)
    DUFTransmissionPeriodicity._cont = ASN1Dict([(u'ms0p5', 0), (u'ms0p625', 1), (u'ms1', 2), (u'ms1p25', 3), (u'ms2', 4), (u'ms2p5', 5), (u'ms5', 6), (u'ms10', 7)])
    DUFTransmissionPeriodicity._ext = []
    
    #-----< DU-RX-MT-RX >-----#
    DU_RX_MT_RX = ENUM(name=u'DU-RX-MT-RX', mode=MODE_TYPE)
    DU_RX_MT_RX._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    DU_RX_MT_RX._ext = None
    
    #-----< DU-TX-MT-TX >-----#
    DU_TX_MT_TX = ENUM(name=u'DU-TX-MT-TX', mode=MODE_TYPE)
    DU_TX_MT_TX._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    DU_TX_MT_TX._ext = None
    
    #-----< DU-RX-MT-TX >-----#
    DU_RX_MT_TX = ENUM(name=u'DU-RX-MT-TX', mode=MODE_TYPE)
    DU_RX_MT_TX._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    DU_RX_MT_TX._ext = None
    
    #-----< DU-TX-MT-RX >-----#
    DU_TX_MT_RX = ENUM(name=u'DU-TX-MT-RX', mode=MODE_TYPE)
    DU_TX_MT_RX._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    DU_TX_MT_RX._ext = None
    
    #-----< DUtoCURRCInformation >-----#
    DUtoCURRCInformation = SEQ(name=u'DUtoCURRCInformation', mode=MODE_TYPE)
    _DUtoCURRCInformation_cellGroupConfig = OCT_STR(name=u'cellGroupConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _DUtoCURRCInformation_measGapConfig = OCT_STR(name=u'measGapConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasGapConfig')), opt=True)
    _DUtoCURRCInformation_requestedP_MaxFR1 = OCT_STR(name=u'requestedP-MaxFR1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DUtoCURRCInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DUtoCURRCInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DUtoCURRCInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DUtoCURRCInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-LongCycleStartOffset')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedBandCombinationIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedFeatureSetEntryIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedBandCombinationIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedFeatureSetEntryIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCCH-BlindDetectionSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Requested-PDCCH-BlindDetectionSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoMCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasGapSharingConfig')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-PHY-MAC-RLC-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-ConfigDedicatedEUTRA-Info')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedP-MaxFR2')))
    ____DUtoCURRCInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 191), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 236), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 341), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 342), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 211), (u'criticality', u'ignore'), (u'Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab_at = None
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DUtoCURRCInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DUtoCURRCInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DUtoCURRCInformation_iE_Extensions__item__id),
        (u'criticality', ___DUtoCURRCInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DUtoCURRCInformation_iE_Extensions__item__extensionValue),
        ])
    __DUtoCURRCInformation_iE_Extensions__item_._ext = None
    _DUtoCURRCInformation_iE_Extensions._cont = __DUtoCURRCInformation_iE_Extensions__item_
    _DUtoCURRCInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DUtoCURRCInformation._cont = ASN1Dict([
        (u'cellGroupConfig', _DUtoCURRCInformation_cellGroupConfig),
        (u'measGapConfig', _DUtoCURRCInformation_measGapConfig),
        (u'requestedP-MaxFR1', _DUtoCURRCInformation_requestedP_MaxFR1),
        (u'iE-Extensions', _DUtoCURRCInformation_iE_Extensions),
        ])
    DUtoCURRCInformation._ext = []
    
    #-----< DUtoCURRCInformation-ExtIEs >-----#
    DUtoCURRCInformation_ExtIEs = CLASS(name=u'DUtoCURRCInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-LongCycleStartOffset')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedBandCombinationIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedFeatureSetEntryIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedBandCombinationIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedFeatureSetEntryIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_7 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCCH-BlindDetectionSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_8 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Requested-PDCCH-BlindDetectionSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoMCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_10 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasGapSharingConfig')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_11 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-PHY-MAC-RLC-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_12 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-ConfigDedicatedEUTRA-Info')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_13 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedP-MaxFR2')))
    DUtoCURRCInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 191), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 236), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 341), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 342), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 211), (u'criticality', u'ignore'), (u'Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_13), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DuplicationActivation >-----#
    DuplicationActivation = ENUM(name=u'DuplicationActivation', mode=MODE_TYPE)
    DuplicationActivation._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    DuplicationActivation._ext = []
    
    #-----< DuplicationIndication >-----#
    DuplicationIndication = ENUM(name=u'DuplicationIndication', mode=MODE_TYPE)
    DuplicationIndication._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    DuplicationIndication._ext = [u'false']
    
    #-----< DuplicationState >-----#
    DuplicationState = ENUM(name=u'DuplicationState', mode=MODE_TYPE)
    DuplicationState._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    DuplicationState._ext = []
    
    #-----< Dynamic5QIDescriptor >-----#
    Dynamic5QIDescriptor = SEQ(name=u'Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Dynamic5QIDescriptor_qoSPriorityLevel = INT(name=u'qoSPriorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Dynamic5QIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _Dynamic5QIDescriptor_packetDelayBudget = INT(name=u'packetDelayBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')))
    _Dynamic5QIDescriptor_packetErrorRate = SEQ(name=u'packetErrorRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')))
    _Dynamic5QIDescriptor_fiveQI = INT(name=u'fiveQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _Dynamic5QIDescriptor_delayCritical = ENUM(name=u'delayCritical', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_delayCritical._cont = ASN1Dict([(u'delay-critical', 0), (u'non-delay-critical', 1)])
    _Dynamic5QIDescriptor_delayCritical._ext = None
    _Dynamic5QIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _Dynamic5QIDescriptor_maxDataBurstVolume = INT(name=u'maxDataBurstVolume', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 363), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 362), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 369), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Dynamic5QIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Dynamic5QIDescriptor_iE_Extensions._cont = __Dynamic5QIDescriptor_iE_Extensions__item_
    _Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dynamic5QIDescriptor._cont = ASN1Dict([
        (u'qoSPriorityLevel', _Dynamic5QIDescriptor_qoSPriorityLevel),
        (u'packetDelayBudget', _Dynamic5QIDescriptor_packetDelayBudget),
        (u'packetErrorRate', _Dynamic5QIDescriptor_packetErrorRate),
        (u'fiveQI', _Dynamic5QIDescriptor_fiveQI),
        (u'delayCritical', _Dynamic5QIDescriptor_delayCritical),
        (u'averagingWindow', _Dynamic5QIDescriptor_averagingWindow),
        (u'maxDataBurstVolume', _Dynamic5QIDescriptor_maxDataBurstVolume),
        (u'iE-Extensions', _Dynamic5QIDescriptor_iE_Extensions),
        ])
    Dynamic5QIDescriptor._ext = None
    
    #-----< Dynamic5QIDescriptor-ExtIEs >-----#
    Dynamic5QIDescriptor_ExtIEs = CLASS(name=u'Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 363), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 362), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 369), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DynamicPQIDescriptor >-----#
    DynamicPQIDescriptor = SEQ(name=u'DynamicPQIDescriptor', mode=MODE_TYPE)
    _DynamicPQIDescriptor_resourceType = ENUM(name=u'resourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicPQIDescriptor_resourceType._cont = ASN1Dict([(u'gbr', 0), (u'non-gbr', 1), (u'delay-critical-grb', 2)])
    _DynamicPQIDescriptor_resourceType._ext = []
    _DynamicPQIDescriptor_qoSPriorityLevel = INT(name=u'qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DynamicPQIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _DynamicPQIDescriptor_packetDelayBudget = INT(name=u'packetDelayBudget', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')))
    _DynamicPQIDescriptor_packetErrorRate = SEQ(name=u'packetErrorRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')))
    _DynamicPQIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _DynamicPQIDescriptor_maxDataBurstVolume = INT(name=u'maxDataBurstVolume', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _DynamicPQIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DynamicPQIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DynamicPQIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DynamicPQIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__id_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DynamicPQIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DynamicPQIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___DynamicPQIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __DynamicPQIDescriptor_iE_Extensions__item_._ext = None
    _DynamicPQIDescriptor_iE_Extensions._cont = __DynamicPQIDescriptor_iE_Extensions__item_
    _DynamicPQIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DynamicPQIDescriptor._cont = ASN1Dict([
        (u'resourceType', _DynamicPQIDescriptor_resourceType),
        (u'qoSPriorityLevel', _DynamicPQIDescriptor_qoSPriorityLevel),
        (u'packetDelayBudget', _DynamicPQIDescriptor_packetDelayBudget),
        (u'packetErrorRate', _DynamicPQIDescriptor_packetErrorRate),
        (u'averagingWindow', _DynamicPQIDescriptor_averagingWindow),
        (u'maxDataBurstVolume', _DynamicPQIDescriptor_maxDataBurstVolume),
        (u'iE-Extensions', _DynamicPQIDescriptor_iE_Extensions),
        ])
    DynamicPQIDescriptor._ext = None
    
    #-----< DynamicPQIDescriptor-ExtIEs >-----#
    DynamicPQIDescriptor_ExtIEs = CLASS(name=u'DynamicPQIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DynamicPQIDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementQuantities >-----#
    E_CID_MeasurementQuantities = SEQ_OF(name=u'E-CID-MeasurementQuantities', mode=MODE_TYPE)
    _E_CID_MeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_CID_MeasurementQuantities__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___E_CID_MeasurementQuantities__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities-Item')))
    ___E_CID_MeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 415), (u'criticality', u'reject'), (u'Value', ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_CID_MeasurementQuantities__item__id._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__id._const_tab_at = None
    __E_CID_MeasurementQuantities__item__id._const_tab_id = u'id'
    __E_CID_MeasurementQuantities__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __E_CID_MeasurementQuantities__item__criticality._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__criticality._const_tab_at = ('..', u'id')
    __E_CID_MeasurementQuantities__item__criticality._const_tab_id = u'criticality'
    __E_CID_MeasurementQuantities__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __E_CID_MeasurementQuantities__item__value._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__value._const_tab_at = ('..', u'id')
    __E_CID_MeasurementQuantities__item__value._const_tab_id = u'Value'
    _E_CID_MeasurementQuantities__item_._cont = ASN1Dict([
        (u'id', __E_CID_MeasurementQuantities__item__id),
        (u'criticality', __E_CID_MeasurementQuantities__item__criticality),
        (u'value', __E_CID_MeasurementQuantities__item__value),
        ])
    _E_CID_MeasurementQuantities__item_._ext = None
    E_CID_MeasurementQuantities._cont = _E_CID_MeasurementQuantities__item_
    E_CID_MeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-CID-MeasurementQuantities-ItemIEs >-----#
    E_CID_MeasurementQuantities_ItemIEs = CLASS(name=u'E-CID-MeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CID_MeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities-Item')))
    E_CID_MeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 415), (u'criticality', u'reject'), (u'Value', _E_CID_MeasurementQuantities_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-CID-MeasurementQuantities-Item >-----#
    E_CID_MeasurementQuantities_Item = SEQ(name=u'E-CID-MeasurementQuantities-Item', mode=MODE_TYPE)
    _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue = ENUM(name=u'e-CIDmeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantitiesValue')))
    _E_CID_MeasurementQuantities_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id),
        (u'criticality', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _E_CID_MeasurementQuantities_Item_iE_Extensions._cont = __E_CID_MeasurementQuantities_Item_iE_Extensions__item_
    _E_CID_MeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementQuantities_Item._cont = ASN1Dict([
        (u'e-CIDmeasurementQuantitiesValue', _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue),
        (u'iE-Extensions', _E_CID_MeasurementQuantities_Item_iE_Extensions),
        ])
    E_CID_MeasurementQuantities_Item._ext = None
    
    #-----< E-CID-MeasurementQuantitiesValue-ExtIEs >-----#
    E_CID_MeasurementQuantitiesValue_ExtIEs = CLASS(name=u'E-CID-MeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementQuantitiesValue >-----#
    E_CID_MeasurementQuantitiesValue = ENUM(name=u'E-CID-MeasurementQuantitiesValue', mode=MODE_TYPE)
    E_CID_MeasurementQuantitiesValue._cont = ASN1Dict([(u'default', 0), (u'angleOfArrivalNR', 1)])
    E_CID_MeasurementQuantitiesValue._ext = []
    
    #-----< E-CID-MeasurementResult >-----#
    E_CID_MeasurementResult = SEQ(name=u'E-CID-MeasurementResult', mode=MODE_TYPE)
    _E_CID_MeasurementResult_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GeographicalCoordinates')), opt=True)
    _E_CID_MeasurementResult_measuredResults_List = SEQ_OF(name=u'measuredResults-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-List')), opt=True)
    _E_CID_MeasurementResult_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementResult_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_CID_MeasurementResult_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_CID_MeasurementResult_iE_Extensions__item__id),
        (u'criticality', ___E_CID_MeasurementResult_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementResult_iE_Extensions__item_._ext = None
    _E_CID_MeasurementResult_iE_Extensions._cont = __E_CID_MeasurementResult_iE_Extensions__item_
    _E_CID_MeasurementResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementResult._cont = ASN1Dict([
        (u'geographicalCoordinates', _E_CID_MeasurementResult_geographicalCoordinates),
        (u'measuredResults-List', _E_CID_MeasurementResult_measuredResults_List),
        (u'iE-Extensions', _E_CID_MeasurementResult_iE_Extensions),
        ])
    E_CID_MeasurementResult._ext = None
    
    #-----< E-CID-MeasurementResult-ExtIEs >-----#
    E_CID_MeasurementResult_ExtIEs = CLASS(name=u'E-CID-MeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasurementResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasuredResults-List >-----#
    E_CID_MeasuredResults_List = SEQ_OF(name=u'E-CID-MeasuredResults-List', mode=MODE_TYPE)
    _E_CID_MeasuredResults_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-Item')))
    E_CID_MeasuredResults_List._cont = _E_CID_MeasuredResults_List__item_
    E_CID_MeasuredResults_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-CID-MeasuredResults-Item >-----#
    E_CID_MeasuredResults_Item = SEQ(name=u'E-CID-MeasuredResults-Item', mode=MODE_TYPE)
    _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value = CHOICE(name=u'e-CID-MeasuredResults-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-Value')))
    _E_CID_MeasuredResults_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasuredResults_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_CID_MeasuredResults_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_CID_MeasuredResults_Item_iE_Extensions__item__id),
        (u'criticality', ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasuredResults_Item_iE_Extensions__item_._ext = None
    _E_CID_MeasuredResults_Item_iE_Extensions._cont = __E_CID_MeasuredResults_Item_iE_Extensions__item_
    _E_CID_MeasuredResults_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasuredResults_Item._cont = ASN1Dict([
        (u'e-CID-MeasuredResults-Value', _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value),
        (u'iE-Extensions', _E_CID_MeasuredResults_Item_iE_Extensions),
        ])
    E_CID_MeasuredResults_Item._ext = None
    
    #-----< E-CID-MeasuredResults-Item-ExtIEs >-----#
    E_CID_MeasuredResults_Item_ExtIEs = CLASS(name=u'E-CID-MeasuredResults-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasuredResults_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasuredResults-Value >-----#
    E_CID_MeasuredResults_Value = CHOICE(name=u'E-CID-MeasuredResults-Value', mode=MODE_TYPE)
    _E_CID_MeasuredResults_Value_valueAngleofArrivalNR = SEQ(name=u'valueAngleofArrivalNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-AoA')))
    _E_CID_MeasuredResults_Value_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_CID_MeasuredResults_Value_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___E_CID_MeasuredResults_Value_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___E_CID_MeasuredResults_Value_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_id_tab
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab_at = None
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab_id = u'id'
    __E_CID_MeasuredResults_Value_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CID_MeasuredResults_Value_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___E_CID_MeasuredResults_Value_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_criticality_tab
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab_at = ('..', u'id')
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab_id = u'criticality'
    __E_CID_MeasuredResults_Value_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CID_MeasuredResults_Value_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___E_CID_MeasuredResults_Value_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_value_tab
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab_at = ('..', u'id')
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab_id = u'Value'
    _E_CID_MeasuredResults_Value_choice_extension._cont = ASN1Dict([
        (u'id', __E_CID_MeasuredResults_Value_choice_extension_id),
        (u'criticality', __E_CID_MeasuredResults_Value_choice_extension_criticality),
        (u'value', __E_CID_MeasuredResults_Value_choice_extension_value),
        ])
    _E_CID_MeasuredResults_Value_choice_extension._ext = None
    E_CID_MeasuredResults_Value._cont = ASN1Dict([
        (u'valueAngleofArrivalNR', _E_CID_MeasuredResults_Value_valueAngleofArrivalNR),
        (u'choice-extension', _E_CID_MeasuredResults_Value_choice_extension),
        ])
    E_CID_MeasuredResults_Value._ext = None
    
    #-----< E-CID-MeasuredResults-Value-ExtIEs >-----#
    E_CID_MeasuredResults_Value_ExtIEs = CLASS(name=u'E-CID-MeasuredResults-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    E_CID_MeasuredResults_Value_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-ReportCharacteristics >-----#
    E_CID_ReportCharacteristics = ENUM(name=u'E-CID-ReportCharacteristics', mode=MODE_TYPE)
    E_CID_ReportCharacteristics._cont = ASN1Dict([(u'onDemand', 0), (u'periodic', 1)])
    E_CID_ReportCharacteristics._ext = []
    
    #-----< EgressBHRLCCHList >-----#
    EgressBHRLCCHList = SEQ_OF(name=u'EgressBHRLCCHList', mode=MODE_TYPE)
    _EgressBHRLCCHList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EgressBHRLCCHItem')))
    EgressBHRLCCHList._cont = _EgressBHRLCCHList__item_
    EgressBHRLCCHList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< EgressBHRLCCHItem >-----#
    EgressBHRLCCHItem = SEQ(name=u'EgressBHRLCCHItem', mode=MODE_TYPE)
    _EgressBHRLCCHItem_nextHopBAPAddress = BIT_STR(name=u'nextHopBAPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _EgressBHRLCCHItem_bHRLCChannelID = BIT_STR(name=u'bHRLCChannelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _EgressBHRLCCHItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EgressBHRLCCHItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EgressBHRLCCHItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EgressBHRLCCHItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__id_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab_at = None
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EgressBHRLCCHItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EgressBHRLCCHItem_iE_Extensions__item__id),
        (u'criticality', ___EgressBHRLCCHItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue),
        ])
    __EgressBHRLCCHItem_iE_Extensions__item_._ext = None
    _EgressBHRLCCHItem_iE_Extensions._cont = __EgressBHRLCCHItem_iE_Extensions__item_
    _EgressBHRLCCHItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EgressBHRLCCHItem._cont = ASN1Dict([
        (u'nextHopBAPAddress', _EgressBHRLCCHItem_nextHopBAPAddress),
        (u'bHRLCChannelID', _EgressBHRLCCHItem_bHRLCChannelID),
        (u'iE-Extensions', _EgressBHRLCCHItem_iE_Extensions),
        ])
    EgressBHRLCCHItem._ext = None
    
    #-----< EgressBHRLCCHItemExtIEs >-----#
    EgressBHRLCCHItemExtIEs = CLASS(name=u'EgressBHRLCCHItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EgressBHRLCCHItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Endpoint-IP-address-and-port >-----#
    Endpoint_IP_address_and_port = SEQ(name=u'Endpoint-IP-address-and-port', mode=MODE_TYPE)
    _Endpoint_IP_address_and_port_endpointIPAddress = BIT_STR(name=u'endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Endpoint_IP_address_and_port_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Endpoint_IP_address_and_port_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PortNumber')))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 230), (u'criticality', u'reject'), (u'Extension', _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_at = None
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_id = u'id'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Endpoint_IP_address_and_port_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Endpoint_IP_address_and_port_iE_Extensions__item__id),
        (u'criticality', ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality),
        (u'extensionValue', ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue),
        ])
    __Endpoint_IP_address_and_port_iE_Extensions__item_._ext = None
    _Endpoint_IP_address_and_port_iE_Extensions._cont = __Endpoint_IP_address_and_port_iE_Extensions__item_
    _Endpoint_IP_address_and_port_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Endpoint_IP_address_and_port._cont = ASN1Dict([
        (u'endpointIPAddress', _Endpoint_IP_address_and_port_endpointIPAddress),
        (u'iE-Extensions', _Endpoint_IP_address_and_port_iE_Extensions),
        ])
    Endpoint_IP_address_and_port._ext = None
    
    #-----< Endpoint-IP-address-and-port-ExtIEs >-----#
    Endpoint_IP_address_and_port_ExtIEs = CLASS(name=u'Endpoint-IP-address-and-port-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PortNumber')))
    Endpoint_IP_address_and_port_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 230), (u'criticality', u'reject'), (u'Extension', _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedAvailablePLMN-List >-----#
    ExtendedAvailablePLMN_List = SEQ_OF(name=u'ExtendedAvailablePLMN-List', mode=MODE_TYPE)
    _ExtendedAvailablePLMN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-Item')))
    ExtendedAvailablePLMN_List._cont = _ExtendedAvailablePLMN_List__item_
    ExtendedAvailablePLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ExtendedAvailablePLMN-Item >-----#
    ExtendedAvailablePLMN_Item = SEQ(name=u'ExtendedAvailablePLMN-Item', mode=MODE_TYPE)
    _ExtendedAvailablePLMN_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ExtendedAvailablePLMN_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id),
        (u'criticality', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_._ext = None
    _ExtendedAvailablePLMN_Item_iE_Extensions._cont = __ExtendedAvailablePLMN_Item_iE_Extensions__item_
    _ExtendedAvailablePLMN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedAvailablePLMN_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _ExtendedAvailablePLMN_Item_pLMNIdentity),
        (u'iE-Extensions', _ExtendedAvailablePLMN_Item_iE_Extensions),
        ])
    ExtendedAvailablePLMN_Item._ext = None
    
    #-----< ExplicitFormat >-----#
    ExplicitFormat = SEQ(name=u'ExplicitFormat', mode=MODE_TYPE)
    _ExplicitFormat_permutation = ENUM(name=u'permutation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Permutation')))
    _ExplicitFormat_noofDownlinkSymbols = INT(name=u'noofDownlinkSymbols', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NoofDownlinkSymbols')), opt=True)
    _ExplicitFormat_noofUplinkSymbols = INT(name=u'noofUplinkSymbols', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NoofUplinkSymbols')), opt=True)
    _ExplicitFormat_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExplicitFormat_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExplicitFormat_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExplicitFormat_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__id._const_tab = ____ExplicitFormat_iE_Extensions__item__id_tab
    ___ExplicitFormat_iE_Extensions__item__id._const_tab_at = None
    ___ExplicitFormat_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExplicitFormat_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExplicitFormat_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab = ____ExplicitFormat_iE_Extensions__item__criticality_tab
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExplicitFormat_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExplicitFormat_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab = ____ExplicitFormat_iE_Extensions__item__extensionValue_tab
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExplicitFormat_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExplicitFormat_iE_Extensions__item__id),
        (u'criticality', ___ExplicitFormat_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExplicitFormat_iE_Extensions__item__extensionValue),
        ])
    __ExplicitFormat_iE_Extensions__item_._ext = None
    _ExplicitFormat_iE_Extensions._cont = __ExplicitFormat_iE_Extensions__item_
    _ExplicitFormat_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExplicitFormat._cont = ASN1Dict([
        (u'permutation', _ExplicitFormat_permutation),
        (u'noofDownlinkSymbols', _ExplicitFormat_noofDownlinkSymbols),
        (u'noofUplinkSymbols', _ExplicitFormat_noofUplinkSymbols),
        (u'iE-Extensions', _ExplicitFormat_iE_Extensions),
        ])
    ExplicitFormat._ext = None
    
    #-----< ExplicitFormat-ExtIEs >-----#
    ExplicitFormat_ExtIEs = CLASS(name=u'ExplicitFormat-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ExplicitFormat_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedAvailablePLMN-Item-ExtIEs >-----#
    ExtendedAvailablePLMN_Item_ExtIEs = CLASS(name=u'ExtendedAvailablePLMN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ExtendedAvailablePLMN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedServedPLMNs-List >-----#
    ExtendedServedPLMNs_List = SEQ_OF(name=u'ExtendedServedPLMNs-List', mode=MODE_TYPE)
    _ExtendedServedPLMNs_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-Item')))
    ExtendedServedPLMNs_List._cont = _ExtendedServedPLMNs_List__item_
    ExtendedServedPLMNs_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ExtendedServedPLMNs-Item >-----#
    ExtendedServedPLMNs_Item = SEQ(name=u'ExtendedServedPLMNs-Item', mode=MODE_TYPE)
    _ExtendedServedPLMNs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ExtendedServedPLMNs_Item_tAISliceSupportList = SEQ_OF(name=u'tAISliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')), opt=True)
    _ExtendedServedPLMNs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedServedPLMNs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 384), (u'criticality', u'reject'), (u'Extension', _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 390), (u'criticality', u'reject'), (u'Extension', _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExtendedServedPLMNs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExtendedServedPLMNs_Item_iE_Extensions__item__id),
        (u'criticality', ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedServedPLMNs_Item_iE_Extensions__item_._ext = None
    _ExtendedServedPLMNs_Item_iE_Extensions._cont = __ExtendedServedPLMNs_Item_iE_Extensions__item_
    _ExtendedServedPLMNs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedServedPLMNs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ExtendedServedPLMNs_Item_pLMN_Identity),
        (u'tAISliceSupportList', _ExtendedServedPLMNs_Item_tAISliceSupportList),
        (u'iE-Extensions', _ExtendedServedPLMNs_Item_iE_Extensions),
        ])
    ExtendedServedPLMNs_Item._ext = []
    
    #-----< ExtendedServedPLMNs-ItemExtIEs >-----#
    ExtendedServedPLMNs_ItemExtIEs = CLASS(name=u'ExtendedServedPLMNs-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    ExtendedServedPLMNs_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 384), (u'criticality', u'reject'), (u'Extension', _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 390), (u'criticality', u'reject'), (u'Extension', _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedSliceSupportList >-----#
    ExtendedSliceSupportList = SEQ_OF(name=u'ExtendedSliceSupportList', mode=MODE_TYPE)
    _ExtendedSliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportItem')))
    ExtendedSliceSupportList._cont = _ExtendedSliceSupportList__item_
    ExtendedSliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EUTRACells-List >-----#
    EUTRACells_List = SEQ_OF(name=u'EUTRACells-List', mode=MODE_TYPE)
    _EUTRACells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRACells-List-item')))
    EUTRACells_List._cont = _EUTRACells_List__item_
    EUTRACells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRACells-List-item >-----#
    EUTRACells_List_item = SEQ(name=u'EUTRACells-List-item', mode=MODE_TYPE)
    _EUTRACells_List_item_eUTRA_Cell_ID = BIT_STR(name=u'eUTRA-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Cell-ID')))
    _EUTRACells_List_item_served_EUTRA_Cells_Information = SEQ(name=u'served-EUTRA-Cells-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-EUTRA-Cells-Information')))
    _EUTRACells_List_item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRACells_List_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRACells_List_item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRACells_List_item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab = ____EUTRACells_List_item_iE_Extensions__item__id_tab
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab_at = None
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRACells_List_item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRACells_List_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab = ____EUTRACells_List_item_iE_Extensions__item__criticality_tab
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab = ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRACells_List_item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRACells_List_item_iE_Extensions__item__id),
        (u'criticality', ___EUTRACells_List_item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRACells_List_item_iE_Extensions__item__extensionValue),
        ])
    __EUTRACells_List_item_iE_Extensions__item_._ext = None
    _EUTRACells_List_item_iE_Extensions._cont = __EUTRACells_List_item_iE_Extensions__item_
    _EUTRACells_List_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRACells_List_item._cont = ASN1Dict([
        (u'eUTRA-Cell-ID', _EUTRACells_List_item_eUTRA_Cell_ID),
        (u'served-EUTRA-Cells-Information', _EUTRACells_List_item_served_EUTRA_Cells_Information),
        (u'iE-Extensions', _EUTRACells_List_item_iE_Extensions),
        ])
    EUTRACells_List_item._ext = None
    
    #-----< EUTRACells-List-itemExtIEs >-----#
    EUTRACells_List_itemExtIEs = CLASS(name=u'EUTRACells-List-itemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRACells_List_itemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Cell-ID >-----#
    EUTRA_Cell_ID = BIT_STR(name=u'EUTRA-Cell-ID', mode=MODE_TYPE)
    EUTRA_Cell_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRA-Coex-FDD-Info >-----#
    EUTRA_Coex_FDD_Info = SEQ(name=u'EUTRA-Coex-FDD-Info', mode=MODE_TYPE)
    _EUTRA_Coex_FDD_Info_uL_EARFCN = INT(name=u'uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')), opt=True)
    _EUTRA_Coex_FDD_Info_dL_EARFCN = INT(name=u'dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')))
    _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth = ENUM(name=u'uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')), opt=True)
    _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth = ENUM(name=u'dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')))
    _EUTRA_Coex_FDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_Coex_FDD_Info_iE_Extensions._cont = __EUTRA_Coex_FDD_Info_iE_Extensions__item_
    _EUTRA_Coex_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_Coex_FDD_Info._cont = ASN1Dict([
        (u'uL-EARFCN', _EUTRA_Coex_FDD_Info_uL_EARFCN),
        (u'dL-EARFCN', _EUTRA_Coex_FDD_Info_dL_EARFCN),
        (u'uL-Transmission-Bandwidth', _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth),
        (u'dL-Transmission-Bandwidth', _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth),
        (u'iE-Extensions', _EUTRA_Coex_FDD_Info_iE_Extensions),
        ])
    EUTRA_Coex_FDD_Info._ext = []
    
    #-----< EUTRA-Coex-FDD-Info-ExtIEs >-----#
    EUTRA_Coex_FDD_Info_ExtIEs = CLASS(name=u'EUTRA-Coex-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_Coex_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Coex-Mode-Info >-----#
    EUTRA_Coex_Mode_Info = CHOICE(name=u'EUTRA-Coex-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Coex_Mode_Info_fDD = SEQ(name=u'fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-FDD-Info')))
    _EUTRA_Coex_Mode_Info_tDD = SEQ(name=u'tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-TDD-Info')))
    EUTRA_Coex_Mode_Info._cont = ASN1Dict([
        (u'fDD', _EUTRA_Coex_Mode_Info_fDD),
        (u'tDD', _EUTRA_Coex_Mode_Info_tDD),
        ])
    EUTRA_Coex_Mode_Info._ext = []
    
    #-----< EUTRA-Coex-TDD-Info >-----#
    EUTRA_Coex_TDD_Info = SEQ(name=u'EUTRA-Coex-TDD-Info', mode=MODE_TYPE)
    _EUTRA_Coex_TDD_Info_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')))
    _EUTRA_Coex_TDD_Info_transmission_Bandwidth = ENUM(name=u'transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')))
    _EUTRA_Coex_TDD_Info_subframeAssignment = ENUM(name=u'subframeAssignment', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SubframeAssignment')))
    _EUTRA_Coex_TDD_Info_specialSubframe_Info = SEQ(name=u'specialSubframe-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SpecialSubframe-Info')))
    _EUTRA_Coex_TDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_Coex_TDD_Info_iE_Extensions._cont = __EUTRA_Coex_TDD_Info_iE_Extensions__item_
    _EUTRA_Coex_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_Coex_TDD_Info._cont = ASN1Dict([
        (u'eARFCN', _EUTRA_Coex_TDD_Info_eARFCN),
        (u'transmission-Bandwidth', _EUTRA_Coex_TDD_Info_transmission_Bandwidth),
        (u'subframeAssignment', _EUTRA_Coex_TDD_Info_subframeAssignment),
        (u'specialSubframe-Info', _EUTRA_Coex_TDD_Info_specialSubframe_Info),
        (u'iE-Extensions', _EUTRA_Coex_TDD_Info_iE_Extensions),
        ])
    EUTRA_Coex_TDD_Info._ext = []
    
    #-----< EUTRA-Coex-TDD-Info-ExtIEs >-----#
    EUTRA_Coex_TDD_Info_ExtIEs = CLASS(name=u'EUTRA-Coex-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_Coex_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-CyclicPrefixDL >-----#
    EUTRA_CyclicPrefixDL = ENUM(name=u'EUTRA-CyclicPrefixDL', mode=MODE_TYPE)
    EUTRA_CyclicPrefixDL._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    EUTRA_CyclicPrefixDL._ext = []
    
    #-----< EUTRA-CyclicPrefixUL >-----#
    EUTRA_CyclicPrefixUL = ENUM(name=u'EUTRA-CyclicPrefixUL', mode=MODE_TYPE)
    EUTRA_CyclicPrefixUL._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    EUTRA_CyclicPrefixUL._ext = []
    
    #-----< EUTRA-PRACH-Configuration >-----#
    EUTRA_PRACH_Configuration = SEQ(name=u'EUTRA-PRACH-Configuration', mode=MODE_TYPE)
    _EUTRA_PRACH_Configuration_rootSequenceIndex = INT(name=u'rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_zeroCorrelationIndex = INT(name=u'zeroCorrelationIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_zeroCorrelationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_highSpeedFlag = BOOL(name=u'highSpeedFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_prach_FreqOffset = INT(name=u'prach-FreqOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_prach_FreqOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=94)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_prach_ConfigIndex = INT(name=u'prach-ConfigIndex', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EUTRA_PRACH_Configuration_prach_ConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_PRACH_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_PRACH_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_PRACH_Configuration_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_PRACH_Configuration_iE_Extensions__item_._ext = None
    _EUTRA_PRACH_Configuration_iE_Extensions._cont = __EUTRA_PRACH_Configuration_iE_Extensions__item_
    _EUTRA_PRACH_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_PRACH_Configuration._cont = ASN1Dict([
        (u'rootSequenceIndex', _EUTRA_PRACH_Configuration_rootSequenceIndex),
        (u'zeroCorrelationIndex', _EUTRA_PRACH_Configuration_zeroCorrelationIndex),
        (u'highSpeedFlag', _EUTRA_PRACH_Configuration_highSpeedFlag),
        (u'prach-FreqOffset', _EUTRA_PRACH_Configuration_prach_FreqOffset),
        (u'prach-ConfigIndex', _EUTRA_PRACH_Configuration_prach_ConfigIndex),
        (u'iE-Extensions', _EUTRA_PRACH_Configuration_iE_Extensions),
        ])
    EUTRA_PRACH_Configuration._ext = []
    
    #-----< EUTRA-PRACH-Configuration-ExtIEs >-----#
    EUTRA_PRACH_Configuration_ExtIEs = CLASS(name=u'EUTRA-PRACH-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_PRACH_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-SpecialSubframe-Info >-----#
    EUTRA_SpecialSubframe_Info = SEQ(name=u'EUTRA-SpecialSubframe-Info', mode=MODE_TYPE)
    _EUTRA_SpecialSubframe_Info_specialSubframePatterns = ENUM(name=u'specialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SpecialSubframePatterns')))
    _EUTRA_SpecialSubframe_Info_cyclicPrefixDL = ENUM(name=u'cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-CyclicPrefixDL')))
    _EUTRA_SpecialSubframe_Info_cyclicPrefixUL = ENUM(name=u'cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-CyclicPrefixUL')))
    _EUTRA_SpecialSubframe_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_._ext = None
    _EUTRA_SpecialSubframe_Info_iE_Extensions._cont = __EUTRA_SpecialSubframe_Info_iE_Extensions__item_
    _EUTRA_SpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_SpecialSubframe_Info._cont = ASN1Dict([
        (u'specialSubframePatterns', _EUTRA_SpecialSubframe_Info_specialSubframePatterns),
        (u'cyclicPrefixDL', _EUTRA_SpecialSubframe_Info_cyclicPrefixDL),
        (u'cyclicPrefixUL', _EUTRA_SpecialSubframe_Info_cyclicPrefixUL),
        (u'iE-Extensions', _EUTRA_SpecialSubframe_Info_iE_Extensions),
        ])
    EUTRA_SpecialSubframe_Info._ext = []
    
    #-----< EUTRA-SpecialSubframe-Info-ExtIEs >-----#
    EUTRA_SpecialSubframe_Info_ExtIEs = CLASS(name=u'EUTRA-SpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_SpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-SpecialSubframePatterns >-----#
    EUTRA_SpecialSubframePatterns = ENUM(name=u'EUTRA-SpecialSubframePatterns', mode=MODE_TYPE)
    EUTRA_SpecialSubframePatterns._cont = ASN1Dict([(u'ssp0', 0), (u'ssp1', 1), (u'ssp2', 2), (u'ssp3', 3), (u'ssp4', 4), (u'ssp5', 5), (u'ssp6', 6), (u'ssp7', 7), (u'ssp8', 8), (u'ssp9', 9), (u'ssp10', 10)])
    EUTRA_SpecialSubframePatterns._ext = []
    
    #-----< EUTRA-SubframeAssignment >-----#
    EUTRA_SubframeAssignment = ENUM(name=u'EUTRA-SubframeAssignment', mode=MODE_TYPE)
    EUTRA_SubframeAssignment._cont = ASN1Dict([(u'sa0', 0), (u'sa1', 1), (u'sa2', 2), (u'sa3', 3), (u'sa4', 4), (u'sa5', 5), (u'sa6', 6)])
    EUTRA_SubframeAssignment._ext = []
    
    #-----< EUTRA-Transmission-Bandwidth >-----#
    EUTRA_Transmission_Bandwidth = ENUM(name=u'EUTRA-Transmission-Bandwidth', mode=MODE_TYPE)
    EUTRA_Transmission_Bandwidth._cont = ASN1Dict([(u'bw6', 0), (u'bw15', 1), (u'bw25', 2), (u'bw50', 3), (u'bw75', 4), (u'bw100', 5)])
    EUTRA_Transmission_Bandwidth._ext = []
    
    #-----< EUTRANQoS >-----#
    EUTRANQoS = SEQ(name=u'EUTRANQoS', mode=MODE_TYPE)
    _EUTRANQoS_qCI = INT(name=u'qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QCI')))
    _EUTRANQoS_allocationAndRetentionPriority = SEQ(name=u'allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AllocationAndRetentionPriority')))
    _EUTRANQoS_gbrQosInformation = SEQ(name=u'gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GBR-QosInformation')), opt=True)
    _EUTRANQoS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRANQoS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRANQoS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRANQoS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    ____EUTRANQoS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 437), (u'criticality', u'ignore'), (u'Extension', _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EUTRANQoS_iE_Extensions__item__id._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__id._const_tab_at = None
    ___EUTRANQoS_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRANQoS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRANQoS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRANQoS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRANQoS_iE_Extensions__item__id),
        (u'criticality', ___EUTRANQoS_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRANQoS_iE_Extensions__item__extensionValue),
        ])
    __EUTRANQoS_iE_Extensions__item_._ext = None
    _EUTRANQoS_iE_Extensions._cont = __EUTRANQoS_iE_Extensions__item_
    _EUTRANQoS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRANQoS._cont = ASN1Dict([
        (u'qCI', _EUTRANQoS_qCI),
        (u'allocationAndRetentionPriority', _EUTRANQoS_allocationAndRetentionPriority),
        (u'gbrQosInformation', _EUTRANQoS_gbrQosInformation),
        (u'iE-Extensions', _EUTRANQoS_iE_Extensions),
        ])
    EUTRANQoS._ext = []
    
    #-----< EUTRANQoS-ExtIEs >-----#
    EUTRANQoS_ExtIEs = CLASS(name=u'EUTRANQoS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _EUTRANQoS_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    EUTRANQoS_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 437), (u'criticality', u'ignore'), (u'Extension', _EUTRANQoS_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExecuteDuplication >-----#
    ExecuteDuplication = ENUM(name=u'ExecuteDuplication', mode=MODE_TYPE)
    ExecuteDuplication._cont = ASN1Dict([(u'true', 0)])
    ExecuteDuplication._ext = []
    
    #-----< ExtendedEARFCN >-----#
    ExtendedEARFCN = INT(name=u'ExtendedEARFCN', mode=MODE_TYPE)
    ExtendedEARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< EUTRA-Mode-Info >-----#
    EUTRA_Mode_Info = CHOICE(name=u'EUTRA-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Mode_Info_eUTRAFDD = SEQ(name=u'eUTRAFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-FDD-Info')))
    _EUTRA_Mode_Info_eUTRATDD = SEQ(name=u'eUTRATDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-TDD-Info')))
    _EUTRA_Mode_Info_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __EUTRA_Mode_Info_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___EUTRA_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_id._const_tab = ___EUTRA_Mode_Info_choice_extension_id_tab
    __EUTRA_Mode_Info_choice_extension_id._const_tab_at = None
    __EUTRA_Mode_Info_choice_extension_id._const_tab_id = u'id'
    __EUTRA_Mode_Info_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___EUTRA_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab = ___EUTRA_Mode_Info_choice_extension_criticality_tab
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab_at = ('..', u'id')
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab_id = u'criticality'
    __EUTRA_Mode_Info_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___EUTRA_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_value._const_tab = ___EUTRA_Mode_Info_choice_extension_value_tab
    __EUTRA_Mode_Info_choice_extension_value._const_tab_at = ('..', u'id')
    __EUTRA_Mode_Info_choice_extension_value._const_tab_id = u'Value'
    _EUTRA_Mode_Info_choice_extension._cont = ASN1Dict([
        (u'id', __EUTRA_Mode_Info_choice_extension_id),
        (u'criticality', __EUTRA_Mode_Info_choice_extension_criticality),
        (u'value', __EUTRA_Mode_Info_choice_extension_value),
        ])
    _EUTRA_Mode_Info_choice_extension._ext = None
    EUTRA_Mode_Info._cont = ASN1Dict([
        (u'eUTRAFDD', _EUTRA_Mode_Info_eUTRAFDD),
        (u'eUTRATDD', _EUTRA_Mode_Info_eUTRATDD),
        (u'choice-extension', _EUTRA_Mode_Info_choice_extension),
        ])
    EUTRA_Mode_Info._ext = None
    
    #-----< EUTRA-Mode-Info-ExtIEs >-----#
    EUTRA_Mode_Info_ExtIEs = CLASS(name=u'EUTRA-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    EUTRA_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-NR-CellResourceCoordinationReq-Container >-----#
    EUTRA_NR_CellResourceCoordinationReq_Container = OCT_STR(name=u'EUTRA-NR-CellResourceCoordinationReq-Container', mode=MODE_TYPE)
    
    #-----< EUTRA-NR-CellResourceCoordinationReqAck-Container >-----#
    EUTRA_NR_CellResourceCoordinationReqAck_Container = OCT_STR(name=u'EUTRA-NR-CellResourceCoordinationReqAck-Container', mode=MODE_TYPE)
    
    #-----< EUTRA-FDD-Info >-----#
    EUTRA_FDD_Info = SEQ(name=u'EUTRA-FDD-Info', mode=MODE_TYPE)
    _EUTRA_FDD_Info_uL_offsetToPointA = INT(name=u'uL-offsetToPointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_FDD_Info_dL_offsetToPointA = INT(name=u'dL-offsetToPointA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_FDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_FDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_FDD_Info_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_FDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_FDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_FDD_Info_iE_Extensions._cont = __EUTRA_FDD_Info_iE_Extensions__item_
    _EUTRA_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_FDD_Info._cont = ASN1Dict([
        (u'uL-offsetToPointA', _EUTRA_FDD_Info_uL_offsetToPointA),
        (u'dL-offsetToPointA', _EUTRA_FDD_Info_dL_offsetToPointA),
        (u'iE-Extensions', _EUTRA_FDD_Info_iE_Extensions),
        ])
    EUTRA_FDD_Info._ext = []
    
    #-----< EUTRA-FDD-Info-ExtIEs >-----#
    EUTRA_FDD_Info_ExtIEs = CLASS(name=u'EUTRA-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-TDD-Info >-----#
    EUTRA_TDD_Info = SEQ(name=u'EUTRA-TDD-Info', mode=MODE_TYPE)
    _EUTRA_TDD_Info_offsetToPointA = INT(name=u'offsetToPointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_TDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_TDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_TDD_Info_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_TDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_TDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_TDD_Info_iE_Extensions._cont = __EUTRA_TDD_Info_iE_Extensions__item_
    _EUTRA_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_TDD_Info._cont = ASN1Dict([
        (u'offsetToPointA', _EUTRA_TDD_Info_offsetToPointA),
        (u'iE-Extensions', _EUTRA_TDD_Info_iE_Extensions),
        ])
    EUTRA_TDD_Info._ext = []
    
    #-----< EUTRA-TDD-Info-ExtIEs >-----#
    EUTRA_TDD_Info_ExtIEs = CLASS(name=u'EUTRA-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name=u'EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([(u'on-demand', 0), (u'periodic', 1), (u'stop', 2)])
    EventType._ext = []
    
    #-----< ExtendedPacketDelayBudget >-----#
    ExtendedPacketDelayBudget = INT(name=u'ExtendedPacketDelayBudget', mode=MODE_TYPE)
    ExtendedPacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< F1CPathNSA >-----#
    F1CPathNSA = ENUM(name=u'F1CPathNSA', mode=MODE_TYPE)
    F1CPathNSA._cont = ASN1Dict([(u'lte', 0), (u'nr', 1), (u'both', 2)])
    F1CPathNSA._ext = None
    
    #-----< F1CTransferPath >-----#
    F1CTransferPath = SEQ(name=u'F1CTransferPath', mode=MODE_TYPE)
    _F1CTransferPath_f1CPathNSA = ENUM(name=u'f1CPathNSA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'F1CPathNSA')))
    _F1CTransferPath_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F1CTransferPath_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___F1CTransferPath_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____F1CTransferPath_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__id._const_tab = ____F1CTransferPath_iE_Extensions__item__id_tab
    ___F1CTransferPath_iE_Extensions__item__id._const_tab_at = None
    ___F1CTransferPath_iE_Extensions__item__id._const_tab_id = u'id'
    ___F1CTransferPath_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____F1CTransferPath_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab = ____F1CTransferPath_iE_Extensions__item__criticality_tab
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___F1CTransferPath_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____F1CTransferPath_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab = ____F1CTransferPath_iE_Extensions__item__extensionValue_tab
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __F1CTransferPath_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___F1CTransferPath_iE_Extensions__item__id),
        (u'criticality', ___F1CTransferPath_iE_Extensions__item__criticality),
        (u'extensionValue', ___F1CTransferPath_iE_Extensions__item__extensionValue),
        ])
    __F1CTransferPath_iE_Extensions__item_._ext = None
    _F1CTransferPath_iE_Extensions._cont = __F1CTransferPath_iE_Extensions__item_
    _F1CTransferPath_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F1CTransferPath._cont = ASN1Dict([
        (u'f1CPathNSA', _F1CTransferPath_f1CPathNSA),
        (u'iE-Extensions', _F1CTransferPath_iE_Extensions),
        ])
    F1CTransferPath._ext = []
    
    #-----< F1CTransferPath-ExtIEs >-----#
    F1CTransferPath_ExtIEs = CLASS(name=u'F1CTransferPath-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    F1CTransferPath_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-Info >-----#
    FDD_Info = SEQ(name=u'FDD-Info', mode=MODE_TYPE)
    _FDD_Info_uL_NRFreqInfo = SEQ(name=u'uL-NRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _FDD_Info_dL_NRFreqInfo = SEQ(name=u'dL-NRFreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _FDD_Info_uL_Transmission_Bandwidth = SEQ(name=u'uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_dL_Transmission_Bandwidth = SEQ(name=u'dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 355), (u'criticality', u'ignore'), (u'Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 389), (u'criticality', u'ignore'), (u'Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___FDD_Info_iE_Extensions__item__id._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___FDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___FDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___FDD_Info_iE_Extensions__item__criticality._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FDD_Info_iE_Extensions__item__id),
        (u'criticality', ___FDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __FDD_Info_iE_Extensions__item_._ext = None
    _FDD_Info_iE_Extensions._cont = __FDD_Info_iE_Extensions__item_
    _FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_Info._cont = ASN1Dict([
        (u'uL-NRFreqInfo', _FDD_Info_uL_NRFreqInfo),
        (u'dL-NRFreqInfo', _FDD_Info_dL_NRFreqInfo),
        (u'uL-Transmission-Bandwidth', _FDD_Info_uL_Transmission_Bandwidth),
        (u'dL-Transmission-Bandwidth', _FDD_Info_dL_Transmission_Bandwidth),
        (u'iE-Extensions', _FDD_Info_iE_Extensions),
        ])
    FDD_Info._ext = []
    
    #-----< FDD-Info-ExtIEs >-----#
    FDD_Info_ExtIEs = CLASS(name=u'FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _FDD_Info_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _FDD_Info_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    FDD_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 355), (u'criticality', u'ignore'), (u'Extension', _FDD_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 389), (u'criticality', u'ignore'), (u'Extension', _FDD_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Flows-Mapped-To-DRB-List >-----#
    Flows_Mapped_To_DRB_List = SEQ_OF(name=u'Flows-Mapped-To-DRB-List', mode=MODE_TYPE)
    _Flows_Mapped_To_DRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Flows-Mapped-To-DRB-Item')))
    Flows_Mapped_To_DRB_List._cont = _Flows_Mapped_To_DRB_List__item_
    Flows_Mapped_To_DRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Flows-Mapped-To-DRB-Item >-----#
    Flows_Mapped_To_DRB_Item = SEQ(name=u'Flows-Mapped-To-DRB-Item', mode=MODE_TYPE)
    _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier = INT(name=u'qoSFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowIdentifier')))
    _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters = SEQ(name=u'qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _Flows_Mapped_To_DRB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowMappingIndication')))
    _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TSCTrafficCharacteristics')))
    ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 364), (u'criticality', u'ignore'), (u'Extension', _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id),
        (u'criticality', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue),
        ])
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_._ext = None
    _Flows_Mapped_To_DRB_Item_iE_Extensions._cont = __Flows_Mapped_To_DRB_Item_iE_Extensions__item_
    _Flows_Mapped_To_DRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Flows_Mapped_To_DRB_Item._cont = ASN1Dict([
        (u'qoSFlowIdentifier', _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier),
        (u'qoSFlowLevelQoSParameters', _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters),
        (u'iE-Extensions', _Flows_Mapped_To_DRB_Item_iE_Extensions),
        ])
    Flows_Mapped_To_DRB_Item._ext = None
    
    #-----< Flows-Mapped-To-DRB-ItemExtIEs >-----#
    Flows_Mapped_To_DRB_ItemExtIEs = CLASS(name=u'Flows-Mapped-To-DRB-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowMappingIndication')))
    _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TSCTrafficCharacteristics')))
    Flows_Mapped_To_DRB_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 364), (u'criticality', u'ignore'), (u'Extension', _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< FR1-Bandwidth >-----#
    FR1_Bandwidth = ENUM(name=u'FR1-Bandwidth', mode=MODE_TYPE)
    FR1_Bandwidth._cont = ASN1Dict([(u'bw5', 0), (u'bw10', 1), (u'bw20', 2), (u'bw40', 3), (u'bw50', 4), (u'bw80', 5), (u'bw100', 6)])
    FR1_Bandwidth._ext = []
    
    #-----< FR2-Bandwidth >-----#
    FR2_Bandwidth = ENUM(name=u'FR2-Bandwidth', mode=MODE_TYPE)
    FR2_Bandwidth._cont = ASN1Dict([(u'bw50', 0), (u'bw100', 1), (u'bw200', 2), (u'bw400', 3)])
    FR2_Bandwidth._ext = []
    
    #-----< FreqBandNrItem >-----#
    FreqBandNrItem = SEQ(name=u'FreqBandNrItem', mode=MODE_TYPE)
    _FreqBandNrItem_freqBandIndicatorNr = INT(name=u'freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FreqBandNrItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _FreqBandNrItem_supportedSULBandList = SEQ_OF(name=u'supportedSULBandList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FreqBandNrItem_supportedSULBandList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SupportedSULFreqBandItem')))
    _FreqBandNrItem_supportedSULBandList._cont = __FreqBandNrItem_supportedSULBandList__item_
    _FreqBandNrItem_supportedSULBandList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _FreqBandNrItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FreqBandNrItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FreqBandNrItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____FreqBandNrItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab = ____FreqBandNrItem_iE_Extensions__item__id_tab
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_at = None
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FreqBandNrItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab = ____FreqBandNrItem_iE_Extensions__item__criticality_tab
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FreqBandNrItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab = ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FreqBandNrItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FreqBandNrItem_iE_Extensions__item__id),
        (u'criticality', ___FreqBandNrItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FreqBandNrItem_iE_Extensions__item__extensionValue),
        ])
    __FreqBandNrItem_iE_Extensions__item_._ext = None
    _FreqBandNrItem_iE_Extensions._cont = __FreqBandNrItem_iE_Extensions__item_
    _FreqBandNrItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FreqBandNrItem._cont = ASN1Dict([
        (u'freqBandIndicatorNr', _FreqBandNrItem_freqBandIndicatorNr),
        (u'supportedSULBandList', _FreqBandNrItem_supportedSULBandList),
        (u'iE-Extensions', _FreqBandNrItem_iE_Extensions),
        ])
    FreqBandNrItem._ext = []
    
    #-----< FreqBandNrItem-ExtIEs >-----#
    FreqBandNrItem_ExtIEs = CLASS(name=u'FreqBandNrItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FreqBandNrItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FreqDomainLength >-----#
    FreqDomainLength = CHOICE(name=u'FreqDomainLength', mode=MODE_TYPE)
    _FreqDomainLength_l839 = SEQ(name=u'l839', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'L839Info')))
    _FreqDomainLength_l139 = SEQ(name=u'l139', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'L139Info')))
    _FreqDomainLength_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __FreqDomainLength_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___FreqDomainLength_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___FreqDomainLength_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FreqDomainLength_choice_extension_id._const_tab = ___FreqDomainLength_choice_extension_id_tab
    __FreqDomainLength_choice_extension_id._const_tab_at = None
    __FreqDomainLength_choice_extension_id._const_tab_id = u'id'
    __FreqDomainLength_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___FreqDomainLength_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___FreqDomainLength_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FreqDomainLength_choice_extension_criticality._const_tab = ___FreqDomainLength_choice_extension_criticality_tab
    __FreqDomainLength_choice_extension_criticality._const_tab_at = ('..', u'id')
    __FreqDomainLength_choice_extension_criticality._const_tab_id = u'criticality'
    __FreqDomainLength_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___FreqDomainLength_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___FreqDomainLength_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FreqDomainLength_choice_extension_value._const_tab = ___FreqDomainLength_choice_extension_value_tab
    __FreqDomainLength_choice_extension_value._const_tab_at = ('..', u'id')
    __FreqDomainLength_choice_extension_value._const_tab_id = u'Value'
    _FreqDomainLength_choice_extension._cont = ASN1Dict([
        (u'id', __FreqDomainLength_choice_extension_id),
        (u'criticality', __FreqDomainLength_choice_extension_criticality),
        (u'value', __FreqDomainLength_choice_extension_value),
        ])
    _FreqDomainLength_choice_extension._ext = None
    FreqDomainLength._cont = ASN1Dict([
        (u'l839', _FreqDomainLength_l839),
        (u'l139', _FreqDomainLength_l139),
        (u'choice-extension', _FreqDomainLength_choice_extension),
        ])
    FreqDomainLength._ext = None
    
    #-----< FreqDomainLength-ExtIEs >-----#
    FreqDomainLength_ExtIEs = CLASS(name=u'FreqDomainLength-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    FreqDomainLength_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyShift7p5khz >-----#
    FrequencyShift7p5khz = ENUM(name=u'FrequencyShift7p5khz', mode=MODE_TYPE)
    FrequencyShift7p5khz._cont = ASN1Dict([(u'false', 0), (u'true', 1)])
    FrequencyShift7p5khz._ext = []
    
    #-----< FullConfiguration >-----#
    FullConfiguration = ENUM(name=u'FullConfiguration', mode=MODE_TYPE)
    FullConfiguration._cont = ASN1Dict([(u'full', 0)])
    FullConfiguration._ext = []
    
    #-----< FlowsMappedToSLDRB-List >-----#
    FlowsMappedToSLDRB_List = SEQ_OF(name=u'FlowsMappedToSLDRB-List', mode=MODE_TYPE)
    _FlowsMappedToSLDRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FlowsMappedToSLDRB-Item')))
    FlowsMappedToSLDRB_List._cont = _FlowsMappedToSLDRB_List__item_
    FlowsMappedToSLDRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< FlowsMappedToSLDRB-Item >-----#
    FlowsMappedToSLDRB_Item = SEQ(name=u'FlowsMappedToSLDRB-Item', mode=MODE_TYPE)
    _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier = INT(name=u'pc5QoSFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5QoSFlowIdentifier')))
    _FlowsMappedToSLDRB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id),
        (u'criticality', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue),
        ])
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_._ext = None
    _FlowsMappedToSLDRB_Item_iE_Extensions._cont = __FlowsMappedToSLDRB_Item_iE_Extensions__item_
    _FlowsMappedToSLDRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FlowsMappedToSLDRB_Item._cont = ASN1Dict([
        (u'pc5QoSFlowIdentifier', _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier),
        (u'iE-Extensions', _FlowsMappedToSLDRB_Item_iE_Extensions),
        ])
    FlowsMappedToSLDRB_Item._ext = []
    
    #-----< FlowsMappedToSLDRB-Item-ExtIEs >-----#
    FlowsMappedToSLDRB_Item_ExtIEs = CLASS(name=u'FlowsMappedToSLDRB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FlowsMappedToSLDRB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name=u'GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name=u'e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name=u'e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name=u'e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name=u'e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__criticality_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QosInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        (u'e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        (u'e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        (u'e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        (u'e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        (u'iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name=u'GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QoSFlowInformation >-----#
    GBR_QoSFlowInformation = SEQ(name=u'GBR-QoSFlowInformation', mode=MODE_TYPE)
    _GBR_QoSFlowInformation_maxFlowBitRateDownlink = INT(name=u'maxFlowBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxFlowBitRateUplink = INT(name=u'maxFlowBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink = INT(name=u'guaranteedFlowBitRateDownlink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink = INT(name=u'guaranteedFlowBitRateUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxPacketLossRateDownlink = INT(name=u'maxPacketLossRateDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_maxPacketLossRateUplink = INT(name=u'maxPacketLossRateUplink', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QoSFlowInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QoSFlowInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetList')))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 343), (u'criticality', u'ignore'), (u'Extension', _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QoSFlowInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QoSFlowInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QoSFlowInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QoSFlowInformation_iE_Extensions__item_._ext = None
    _GBR_QoSFlowInformation_iE_Extensions._cont = __GBR_QoSFlowInformation_iE_Extensions__item_
    _GBR_QoSFlowInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QoSFlowInformation._cont = ASN1Dict([
        (u'maxFlowBitRateDownlink', _GBR_QoSFlowInformation_maxFlowBitRateDownlink),
        (u'maxFlowBitRateUplink', _GBR_QoSFlowInformation_maxFlowBitRateUplink),
        (u'guaranteedFlowBitRateDownlink', _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink),
        (u'guaranteedFlowBitRateUplink', _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink),
        (u'maxPacketLossRateDownlink', _GBR_QoSFlowInformation_maxPacketLossRateDownlink),
        (u'maxPacketLossRateUplink', _GBR_QoSFlowInformation_maxPacketLossRateUplink),
        (u'iE-Extensions', _GBR_QoSFlowInformation_iE_Extensions),
        ])
    GBR_QoSFlowInformation._ext = []
    
    #-----< GBR-QosFlowInformation-ExtIEs >-----#
    GBR_QosFlowInformation_ExtIEs = CLASS(name=u'GBR-QosFlowInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GBR_QosFlowInformation_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetList')))
    GBR_QosFlowInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 343), (u'criticality', u'ignore'), (u'Extension', _GBR_QosFlowInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CG-Config >-----#
    CG_Config = OCT_STR(name=u'CG-Config', mode=MODE_TYPE)
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_tRPPositionDefinitionType = CHOICE(name=u'tRPPositionDefinitionType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDefinitionType')))
    _GeographicalCoordinates_dLPRSResourceCoordinates = SEQ(name=u'dLPRSResourceCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceCoordinates')), opt=True)
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeographicalCoordinates_iE_Extensions__item__id),
        (u'criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'tRPPositionDefinitionType', _GeographicalCoordinates_tRPPositionDefinitionType),
        (u'dLPRSResourceCoordinates', _GeographicalCoordinates_dLPRSResourceCoordinates),
        (u'iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = None
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name=u'GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBCUMeasurementID >-----#
    GNBCUMeasurementID = INT(name=u'GNBCUMeasurementID', mode=MODE_TYPE)
    GNBCUMeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< GNBDUMeasurementID >-----#
    GNBDUMeasurementID = INT(name=u'GNBDUMeasurementID', mode=MODE_TYPE)
    GNBDUMeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< GNB-CUSystemInformation >-----#
    GNB_CUSystemInformation = SEQ(name=u'GNB-CUSystemInformation', mode=MODE_TYPE)
    _GNB_CUSystemInformation_sibtypetobeupdatedlist = SEQ_OF(name=u'sibtypetobeupdatedlist', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SibtypetobeupdatedListItem')))
    _GNB_CUSystemInformation_sibtypetobeupdatedlist._cont = __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_
    _GNB_CUSystemInformation_sibtypetobeupdatedlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _GNB_CUSystemInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CUSystemInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CUSystemInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CUSystemInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemInformationAreaID')))
    ____GNB_CUSystemInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CUSystemInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CUSystemInformation_iE_Extensions__item__id),
        (u'criticality', ___GNB_CUSystemInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue),
        ])
    __GNB_CUSystemInformation_iE_Extensions__item_._ext = None
    _GNB_CUSystemInformation_iE_Extensions._cont = __GNB_CUSystemInformation_iE_Extensions__item_
    _GNB_CUSystemInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CUSystemInformation._cont = ASN1Dict([
        (u'sibtypetobeupdatedlist', _GNB_CUSystemInformation_sibtypetobeupdatedlist),
        (u'iE-Extensions', _GNB_CUSystemInformation_iE_Extensions),
        ])
    GNB_CUSystemInformation._ext = []
    
    #-----< GNB-CUSystemInformation-ExtIEs >-----#
    GNB_CUSystemInformation_ExtIEs = CLASS(name=u'GNB-CUSystemInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_CUSystemInformation_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemInformationAreaID')))
    GNB_CUSystemInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _GNB_CUSystemInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-Item >-----#
    GNB_CU_TNL_Association_Setup_Item = SEQ(name=u'GNB-CU-TNL-Association-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_Setup_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress),
        (u'iE-Extensions', _GNB_CU_TNL_Association_Setup_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_Setup_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-Setup-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_Setup_Item_ExtIEs = CLASS(name=u'GNB-CU-TNL-Association-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-Item >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_Item = SEQ(name=u'GNB-CU-TNL-Association-Failed-To-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_Failed_To_Setup_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress),
        (u'cause', _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause),
        (u'iE-Extensions', _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_Failed_To_Setup_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs = CLASS(name=u'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-Item >-----#
    GNB_CU_TNL_Association_To_Add_Item = SEQ(name=u'GNB-CU-TNL-Association-To-Add-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage = ENUM(name=u'tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TNLAssociationUsage')))
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Add_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress),
        (u'tNLAssociationUsage', _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage),
        (u'iE-Extensions', _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Add_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Add-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Add_Item_ExtIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Add-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_To_Add_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-Item >-----#
    GNB_CU_TNL_Association_To_Remove_Item = SEQ(name=u'GNB-CU-TNL-Association-To-Remove-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 229), (u'criticality', u'reject'), (u'Extension', _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Remove_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress),
        (u'iE-Extensions', _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Remove_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Remove-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Remove_Item_ExtIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    GNB_CU_TNL_Association_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 229), (u'criticality', u'reject'), (u'Extension', _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-Item >-----#
    GNB_CU_TNL_Association_To_Update_Item = SEQ(name=u'GNB-CU-TNL-Association-To-Update-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage = ENUM(name=u'tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TNLAssociationUsage')), opt=True)
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Update_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress),
        (u'tNLAssociationUsage', _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage),
        (u'iE-Extensions', _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Update_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Update-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Update_Item_ExtIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Update-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_To_Update_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UE-F1AP-ID >-----#
    GNB_CU_UE_F1AP_ID = INT(name=u'GNB-CU-UE-F1AP-ID', mode=MODE_TYPE)
    GNB_CU_UE_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-DU-Cell-Resource-Configuration >-----#
    GNB_DU_Cell_Resource_Configuration = SEQ(name=u'GNB-DU-Cell-Resource-Configuration', mode=MODE_TYPE)
    _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SubcarrierSpacing')))
    _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity = ENUM(name=u'dUFTransmissionPeriodicity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUFTransmissionPeriodicity')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List = SEQ_OF(name=u'dUF-Slot-Config-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUF-Slot-Config-List')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity = ENUM(name=u'hSNATransmissionPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNATransmissionPeriodicity')))
    _GNB_DU_Cell_Resource_Configuration_hNSASlotConfigList = SEQ_OF(name=u'hNSASlotConfigList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNASlotConfigList')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id),
        (u'criticality', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_._ext = None
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions._cont = __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_Cell_Resource_Configuration._cont = ASN1Dict([
        (u'subcarrierSpacing', _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing),
        (u'dUFTransmissionPeriodicity', _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity),
        (u'dUF-Slot-Config-List', _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List),
        (u'hSNATransmissionPeriodicity', _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity),
        (u'hNSASlotConfigList', _GNB_DU_Cell_Resource_Configuration_hNSASlotConfigList),
        (u'iE-Extensions', _GNB_DU_Cell_Resource_Configuration_iE_Extensions),
        ])
    GNB_DU_Cell_Resource_Configuration._ext = None
    
    #-----< GNB-DU-Cell-Resource-Configuration-ExtIEs >-----#
    GNB_DU_Cell_Resource_Configuration_ExtIEs = CLASS(name=u'GNB-DU-Cell-Resource-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_DU_Cell_Resource_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-UE-F1AP-ID >-----#
    GNB_DU_UE_F1AP_ID = INT(name=u'GNB-DU-UE-F1AP-ID', mode=MODE_TYPE)
    GNB_DU_UE_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-DU-ID >-----#
    GNB_DU_ID = INT(name=u'GNB-DU-ID', mode=MODE_TYPE)
    GNB_DU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< GNB-CU-Name >-----#
    GNB_CU_Name = STR_PRINT(name=u'GNB-CU-Name', mode=MODE_TYPE)
    GNB_CU_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-Name >-----#
    GNB_DU_Name = STR_PRINT(name=u'GNB-DU-Name', mode=MODE_TYPE)
    GNB_DU_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-CU-Name >-----#
    Extended_GNB_CU_Name = SEQ(name=u'Extended-GNB-CU-Name', mode=MODE_TYPE)
    _Extended_GNB_CU_Name_gNB_CU_NameVisibleString = STR_VIS(name=u'gNB-CU-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-NameVisibleString')), opt=True)
    _Extended_GNB_CU_Name_gNB_CU_NameUTF8String = STR_UTF8(name=u'gNB-CU-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-NameUTF8String')), opt=True)
    _Extended_GNB_CU_Name_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_CU_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_CU_Name_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extended_GNB_CU_Name_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extended_GNB_CU_Name_iE_Extensions__item__id),
        (u'criticality', ___Extended_GNB_CU_Name_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_CU_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_CU_Name_iE_Extensions._cont = __Extended_GNB_CU_Name_iE_Extensions__item_
    _Extended_GNB_CU_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_CU_Name._cont = ASN1Dict([
        (u'gNB-CU-NameVisibleString', _Extended_GNB_CU_Name_gNB_CU_NameVisibleString),
        (u'gNB-CU-NameUTF8String', _Extended_GNB_CU_Name_gNB_CU_NameUTF8String),
        (u'iE-Extensions', _Extended_GNB_CU_Name_iE_Extensions),
        ])
    Extended_GNB_CU_Name._ext = []
    
    #-----< Extended-GNB-CU-Name-ExtIEs >-----#
    Extended_GNB_CU_Name_ExtIEs = CLASS(name=u'Extended-GNB-CU-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_CU_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-NameVisibleString >-----#
    GNB_CU_NameVisibleString = STR_VIS(name=u'GNB-CU-NameVisibleString', mode=MODE_TYPE)
    GNB_CU_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-NameUTF8String >-----#
    GNB_CU_NameUTF8String = STR_UTF8(name=u'GNB-CU-NameUTF8String', mode=MODE_TYPE)
    GNB_CU_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-DU-Name >-----#
    Extended_GNB_DU_Name = SEQ(name=u'Extended-GNB-DU-Name', mode=MODE_TYPE)
    _Extended_GNB_DU_Name_gNB_DU_NameVisibleString = STR_VIS(name=u'gNB-DU-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-NameVisibleString')), opt=True)
    _Extended_GNB_DU_Name_gNB_DU_NameUTF8String = STR_UTF8(name=u'gNB-DU-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-NameUTF8String')), opt=True)
    _Extended_GNB_DU_Name_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_DU_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_DU_Name_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extended_GNB_DU_Name_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extended_GNB_DU_Name_iE_Extensions__item__id),
        (u'criticality', ___Extended_GNB_DU_Name_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_DU_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_DU_Name_iE_Extensions._cont = __Extended_GNB_DU_Name_iE_Extensions__item_
    _Extended_GNB_DU_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_DU_Name._cont = ASN1Dict([
        (u'gNB-DU-NameVisibleString', _Extended_GNB_DU_Name_gNB_DU_NameVisibleString),
        (u'gNB-DU-NameUTF8String', _Extended_GNB_DU_Name_gNB_DU_NameUTF8String),
        (u'iE-Extensions', _Extended_GNB_DU_Name_iE_Extensions),
        ])
    Extended_GNB_DU_Name._ext = []
    
    #-----< Extended-GNB-DU-Name-ExtIEs >-----#
    Extended_GNB_DU_Name_ExtIEs = CLASS(name=u'Extended-GNB-DU-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_DU_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-NameVisibleString >-----#
    GNB_DU_NameVisibleString = STR_VIS(name=u'GNB-DU-NameVisibleString', mode=MODE_TYPE)
    GNB_DU_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-NameUTF8String >-----#
    GNB_DU_NameUTF8String = STR_UTF8(name=u'GNB-DU-NameUTF8String', mode=MODE_TYPE)
    GNB_DU_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-Served-Cells-Item >-----#
    GNB_DU_Served_Cells_Item = SEQ(name=u'GNB-DU-Served-Cells-Item', mode=MODE_TYPE)
    _GNB_DU_Served_Cells_Item_served_Cell_Information = SEQ(name=u'served-Cell-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _GNB_DU_Served_Cells_Item_gNB_DU_System_Information = SEQ(name=u'gNB-DU-System-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _GNB_DU_Served_Cells_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_._ext = None
    _GNB_DU_Served_Cells_Item_iE_Extensions._cont = __GNB_DU_Served_Cells_Item_iE_Extensions__item_
    _GNB_DU_Served_Cells_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_Served_Cells_Item._cont = ASN1Dict([
        (u'served-Cell-Information', _GNB_DU_Served_Cells_Item_served_Cell_Information),
        (u'gNB-DU-System-Information', _GNB_DU_Served_Cells_Item_gNB_DU_System_Information),
        (u'iE-Extensions', _GNB_DU_Served_Cells_Item_iE_Extensions),
        ])
    GNB_DU_Served_Cells_Item._ext = []
    
    #-----< GNB-DU-Served-Cells-ItemExtIEs >-----#
    GNB_DU_Served_Cells_ItemExtIEs = CLASS(name=u'GNB-DU-Served-Cells-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_DU_Served_Cells_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-System-Information >-----#
    GNB_DU_System_Information = SEQ(name=u'GNB-DU-System-Information', mode=MODE_TYPE)
    _GNB_DU_System_Information_mIB_message = OCT_STR(name=u'mIB-message', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MIB-message')))
    _GNB_DU_System_Information_sIB1_message = OCT_STR(name=u'sIB1-message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SIB1-message')))
    _GNB_DU_System_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_System_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_System_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_DU_System_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB12-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB13-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB14-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB10-message')))
    ____GNB_DU_System_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'ignore'), (u'Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 387), (u'criticality', u'ignore'), (u'Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_DU_System_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_DU_System_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_DU_System_Information_iE_Extensions__item__id),
        (u'criticality', ___GNB_DU_System_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_DU_System_Information_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_System_Information_iE_Extensions__item_._ext = None
    _GNB_DU_System_Information_iE_Extensions._cont = __GNB_DU_System_Information_iE_Extensions__item_
    _GNB_DU_System_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_System_Information._cont = ASN1Dict([
        (u'mIB-message', _GNB_DU_System_Information_mIB_message),
        (u'sIB1-message', _GNB_DU_System_Information_sIB1_message),
        (u'iE-Extensions', _GNB_DU_System_Information_iE_Extensions),
        ])
    GNB_DU_System_Information._ext = []
    
    #-----< GNB-DU-System-Information-ExtIEs >-----#
    GNB_DU_System_Information_ExtIEs = CLASS(name=u'GNB-DU-System-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB12-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB13-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB14-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB10-message')))
    GNB_DU_System_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'ignore'), (u'Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 387), (u'criticality', u'ignore'), (u'Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DUConfigurationQuery >-----#
    GNB_DUConfigurationQuery = ENUM(name=u'GNB-DUConfigurationQuery', mode=MODE_TYPE)
    GNB_DUConfigurationQuery._cont = ASN1Dict([(u'true', 0)])
    GNB_DUConfigurationQuery._ext = []
    
    #-----< GNBDUOverloadInformation >-----#
    GNBDUOverloadInformation = ENUM(name=u'GNBDUOverloadInformation', mode=MODE_TYPE)
    GNBDUOverloadInformation._cont = ASN1Dict([(u'overloaded', 0), (u'not-overloaded', 1)])
    GNBDUOverloadInformation._ext = None
    
    #-----< GNB-DU-TNL-Association-To-Remove-Item >-----#
    GNB_DU_TNL_Association_To_Remove_Item = SEQ(name=u'GNB-DU-TNL-Association-To-Remove-Item', mode=MODE_TYPE)
    _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU = CHOICE(name=u'tNLAssociationTransportLayerAddressgNBCU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')), opt=True)
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id),
        (u'criticality', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions._cont = __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_TNL_Association_To_Remove_Item._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress),
        (u'tNLAssociationTransportLayerAddressgNBCU', _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU),
        (u'iE-Extensions', _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions),
        ])
    GNB_DU_TNL_Association_To_Remove_Item._ext = None
    
    #-----< GNB-DU-TNL-Association-To-Remove-Item-ExtIEs >-----#
    GNB_DU_TNL_Association_To_Remove_Item_ExtIEs = CLASS(name=u'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_DU_TNL_Association_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-RxTxTimeDiff >-----#
    GNB_RxTxTimeDiff = SEQ(name=u'GNB-RxTxTimeDiff', mode=MODE_TYPE)
    _GNB_RxTxTimeDiff_rxTxTimeDiff = CHOICE(name=u'rxTxTimeDiff', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBRxTxTimeDiffMeas')))
    _GNB_RxTxTimeDiff_additionalPath_List = SEQ_OF(name=u'additionalPath-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-List')), opt=True)
    _GNB_RxTxTimeDiff_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_RxTxTimeDiff_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_at = None
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_RxTxTimeDiff_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_RxTxTimeDiff_iE_Extensions__item__id),
        (u'criticality', ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue),
        ])
    __GNB_RxTxTimeDiff_iE_Extensions__item_._ext = None
    _GNB_RxTxTimeDiff_iE_Extensions._cont = __GNB_RxTxTimeDiff_iE_Extensions__item_
    _GNB_RxTxTimeDiff_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_RxTxTimeDiff._cont = ASN1Dict([
        (u'rxTxTimeDiff', _GNB_RxTxTimeDiff_rxTxTimeDiff),
        (u'additionalPath-List', _GNB_RxTxTimeDiff_additionalPath_List),
        (u'iE-Extensions', _GNB_RxTxTimeDiff_iE_Extensions),
        ])
    GNB_RxTxTimeDiff._ext = None
    
    #-----< GNB-RxTxTimeDiff-ExtIEs >-----#
    GNB_RxTxTimeDiff_ExtIEs = CLASS(name=u'GNB-RxTxTimeDiff-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_RxTxTimeDiff_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBRxTxTimeDiffMeas >-----#
    GNBRxTxTimeDiffMeas = CHOICE(name=u'GNBRxTxTimeDiffMeas', mode=MODE_TYPE)
    _GNBRxTxTimeDiffMeas_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNBRxTxTimeDiffMeas_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_id_tab
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_at = None
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_id = u'id'
    __GNBRxTxTimeDiffMeas_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_at = ('..', u'id')
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_id = u'criticality'
    __GNBRxTxTimeDiffMeas_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_value_tab
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_at = ('..', u'id')
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_id = u'Value'
    _GNBRxTxTimeDiffMeas_choice_extension._cont = ASN1Dict([
        (u'id', __GNBRxTxTimeDiffMeas_choice_extension_id),
        (u'criticality', __GNBRxTxTimeDiffMeas_choice_extension_criticality),
        (u'value', __GNBRxTxTimeDiffMeas_choice_extension_value),
        ])
    _GNBRxTxTimeDiffMeas_choice_extension._ext = None
    GNBRxTxTimeDiffMeas._cont = ASN1Dict([
        (u'k0', _GNBRxTxTimeDiffMeas_k0),
        (u'k1', _GNBRxTxTimeDiffMeas_k1),
        (u'k2', _GNBRxTxTimeDiffMeas_k2),
        (u'k3', _GNBRxTxTimeDiffMeas_k3),
        (u'k4', _GNBRxTxTimeDiffMeas_k4),
        (u'k5', _GNBRxTxTimeDiffMeas_k5),
        (u'choice-extension', _GNBRxTxTimeDiffMeas_choice_extension),
        ])
    GNBRxTxTimeDiffMeas._ext = None
    
    #-----< GNBRxTxTimeDiffMeas-ExtIEs >-----#
    GNBRxTxTimeDiffMeas_ExtIEs = CLASS(name=u'GNBRxTxTimeDiffMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    GNBRxTxTimeDiffMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBSetID >-----#
    GNBSetID = BIT_STR(name=u'GNBSetID', mode=MODE_TYPE)
    GNBSetID._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name=u'GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GTPTLAs >-----#
    GTPTLAs = SEQ_OF(name=u'GTPTLAs', mode=MODE_TYPE)
    _GTPTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GTPTLA-Item')))
    GTPTLAs._cont = _GTPTLAs__item_
    GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GTPTLA-Item >-----#
    GTPTLA_Item = SEQ(name=u'GTPTLA-Item', mode=MODE_TYPE)
    _GTPTLA_Item_gTPTransportLayerAddress = BIT_STR(name=u'gTPTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _GTPTLA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTLA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GTPTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab = ____GTPTLA_Item_iE_Extensions__item__id_tab
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GTPTLA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab = ____GTPTLA_Item_iE_Extensions__item__criticality_tab
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GTPTLA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GTPTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GTPTLA_Item_iE_Extensions__item__id),
        (u'criticality', ___GTPTLA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GTPTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __GTPTLA_Item_iE_Extensions__item_._ext = None
    _GTPTLA_Item_iE_Extensions._cont = __GTPTLA_Item_iE_Extensions__item_
    _GTPTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTLA_Item._cont = ASN1Dict([
        (u'gTPTransportLayerAddress', _GTPTLA_Item_gTPTransportLayerAddress),
        (u'iE-Extensions', _GTPTLA_Item_iE_Extensions),
        ])
    GTPTLA_Item._ext = None
    
    #-----< GTPTLA-Item-ExtIEs >-----#
    GTPTLA_Item_ExtIEs = CLASS(name=u'GTPTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GTPTLA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPTunnel >-----#
    GTPTunnel = SEQ(name=u'GTPTunnel', mode=MODE_TYPE)
    _GTPTunnel_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _GTPTunnel_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTP-TEID')))
    _GTPTunnel_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTunnel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTunnel_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GTPTunnel_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__id._const_tab = ____GTPTunnel_iE_Extensions__item__id_tab
    ___GTPTunnel_iE_Extensions__item__id._const_tab_at = None
    ___GTPTunnel_iE_Extensions__item__id._const_tab_id = u'id'
    ___GTPTunnel_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GTPTunnel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab = ____GTPTunnel_iE_Extensions__item__criticality_tab
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GTPTunnel_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab = ____GTPTunnel_iE_Extensions__item__extensionValue_tab
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GTPTunnel_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GTPTunnel_iE_Extensions__item__id),
        (u'criticality', ___GTPTunnel_iE_Extensions__item__criticality),
        (u'extensionValue', ___GTPTunnel_iE_Extensions__item__extensionValue),
        ])
    __GTPTunnel_iE_Extensions__item_._ext = None
    _GTPTunnel_iE_Extensions._cont = __GTPTunnel_iE_Extensions__item_
    _GTPTunnel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTunnel._cont = ASN1Dict([
        (u'transportLayerAddress', _GTPTunnel_transportLayerAddress),
        (u'gTP-TEID', _GTPTunnel_gTP_TEID),
        (u'iE-Extensions', _GTPTunnel_iE_Extensions),
        ])
    GTPTunnel._ext = []
    
    #-----< GTPTunnel-ExtIEs >-----#
    GTPTunnel_ExtIEs = CLASS(name=u'GTPTunnel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GTPTunnel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationInformation >-----#
    HandoverPreparationInformation = OCT_STR(name=u'HandoverPreparationInformation', mode=MODE_TYPE)
    
    #-----< HardwareLoadIndicator >-----#
    HardwareLoadIndicator = SEQ(name=u'HardwareLoadIndicator', mode=MODE_TYPE)
    _HardwareLoadIndicator_dLHardwareLoadIndicator = INT(name=u'dLHardwareLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HardwareLoadIndicator_dLHardwareLoadIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _HardwareLoadIndicator_uLHardwareLoadIndicator = INT(name=u'uLHardwareLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HardwareLoadIndicator_uLHardwareLoadIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _HardwareLoadIndicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HardwareLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___HardwareLoadIndicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____HardwareLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__id_tab
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___HardwareLoadIndicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HardwareLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HardwareLoadIndicator_iE_Extensions__item__id),
        (u'criticality', ___HardwareLoadIndicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___HardwareLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __HardwareLoadIndicator_iE_Extensions__item_._ext = None
    _HardwareLoadIndicator_iE_Extensions._cont = __HardwareLoadIndicator_iE_Extensions__item_
    _HardwareLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HardwareLoadIndicator._cont = ASN1Dict([
        (u'dLHardwareLoadIndicator', _HardwareLoadIndicator_dLHardwareLoadIndicator),
        (u'uLHardwareLoadIndicator', _HardwareLoadIndicator_uLHardwareLoadIndicator),
        (u'iE-Extensions', _HardwareLoadIndicator_iE_Extensions),
        ])
    HardwareLoadIndicator._ext = []
    
    #-----< HardwareLoadIndicator-ExtIEs >-----#
    HardwareLoadIndicator_ExtIEs = CLASS(name=u'HardwareLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    HardwareLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSNASlotConfigList >-----#
    HSNASlotConfigList = SEQ_OF(name=u'HSNASlotConfigList', mode=MODE_TYPE)
    _HSNASlotConfigList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HSNASlotConfigItem')))
    HSNASlotConfigList._cont = _HSNASlotConfigList__item_
    HSNASlotConfigList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< HSNASlotConfigItem >-----#
    HSNASlotConfigItem = SEQ(name=u'HSNASlotConfigItem', mode=MODE_TYPE)
    _HSNASlotConfigItem_hSNADownlink = ENUM(name=u'hSNADownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNADownlink')), opt=True)
    _HSNASlotConfigItem_hSNAUplink = ENUM(name=u'hSNAUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAUplink')), opt=True)
    _HSNASlotConfigItem_hSNAFlexible = ENUM(name=u'hSNAFlexible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAFlexible')), opt=True)
    _HSNASlotConfigItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSNASlotConfigItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___HSNASlotConfigItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSNASlotConfigItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__id_tab
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab_at = None
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSNASlotConfigItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSNASlotConfigItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSNASlotConfigItem_iE_Extensions__item__id),
        (u'criticality', ___HSNASlotConfigItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSNASlotConfigItem_iE_Extensions__item__extensionValue),
        ])
    __HSNASlotConfigItem_iE_Extensions__item_._ext = None
    _HSNASlotConfigItem_iE_Extensions._cont = __HSNASlotConfigItem_iE_Extensions__item_
    _HSNASlotConfigItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSNASlotConfigItem._cont = ASN1Dict([
        (u'hSNADownlink', _HSNASlotConfigItem_hSNADownlink),
        (u'hSNAUplink', _HSNASlotConfigItem_hSNAUplink),
        (u'hSNAFlexible', _HSNASlotConfigItem_hSNAFlexible),
        (u'iE-Extensions', _HSNASlotConfigItem_iE_Extensions),
        ])
    HSNASlotConfigItem._ext = None
    
    #-----< HSNASlotConfigItem-ExtIEs >-----#
    HSNASlotConfigItem_ExtIEs = CLASS(name=u'HSNASlotConfigItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    HSNASlotConfigItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSNADownlink >-----#
    HSNADownlink = ENUM(name=u'HSNADownlink', mode=MODE_TYPE)
    HSNADownlink._cont = ASN1Dict([(u'hard', 0), (u'soft', 1), (u'notavailable', 2)])
    HSNADownlink._ext = None
    
    #-----< HSNAFlexible >-----#
    HSNAFlexible = ENUM(name=u'HSNAFlexible', mode=MODE_TYPE)
    HSNAFlexible._cont = ASN1Dict([(u'hard', 0), (u'soft', 1), (u'notavailable', 2)])
    HSNAFlexible._ext = None
    
    #-----< HSNAUplink >-----#
    HSNAUplink = ENUM(name=u'HSNAUplink', mode=MODE_TYPE)
    HSNAUplink._cont = ASN1Dict([(u'hard', 0), (u'soft', 1), (u'notavailable', 2)])
    HSNAUplink._ext = None
    
    #-----< HSNATransmissionPeriodicity >-----#
    HSNATransmissionPeriodicity = ENUM(name=u'HSNATransmissionPeriodicity', mode=MODE_TYPE)
    HSNATransmissionPeriodicity._cont = ASN1Dict([(u'ms0p5', 0), (u'ms0p625', 1), (u'ms1', 2), (u'ms1p25', 3), (u'ms2', 4), (u'ms2p5', 5), (u'ms5', 6), (u'ms10', 7), (u'ms20', 8), (u'ms40', 9), (u'ms80', 10), (u'ms160', 11)])
    HSNATransmissionPeriodicity._ext = []
    
    #-----< IAB-Barred >-----#
    IAB_Barred = ENUM(name=u'IAB-Barred', mode=MODE_TYPE)
    IAB_Barred._cont = ASN1Dict([(u'barred', 0), (u'not-barred', 1)])
    IAB_Barred._ext = []
    
    #-----< IAB-Info-IAB-donor-CU >-----#
    IAB_Info_IAB_donor_CU = SEQ(name=u'IAB-Info-IAB-donor-CU', mode=MODE_TYPE)
    _IAB_Info_IAB_donor_CU_iAB_STC_Info = SEQ(name=u'iAB-STC-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _IAB_Info_IAB_donor_CU_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id),
        (u'criticality', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue),
        ])
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_._ext = None
    _IAB_Info_IAB_donor_CU_iE_Extensions._cont = __IAB_Info_IAB_donor_CU_iE_Extensions__item_
    _IAB_Info_IAB_donor_CU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Info_IAB_donor_CU._cont = ASN1Dict([
        (u'iAB-STC-Info', _IAB_Info_IAB_donor_CU_iAB_STC_Info),
        (u'iE-Extensions', _IAB_Info_IAB_donor_CU_iE_Extensions),
        ])
    IAB_Info_IAB_donor_CU._ext = None
    
    #-----< IAB-Info-IAB-donor-CU-ExtIEs >-----#
    IAB_Info_IAB_donor_CU_ExtIEs = CLASS(name=u'IAB-Info-IAB-donor-CU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Info_IAB_donor_CU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Info-IAB-DU >-----#
    IAB_Info_IAB_DU = SEQ(name=u'IAB-Info-IAB-DU', mode=MODE_TYPE)
    _IAB_Info_IAB_DU_multiplexingInfo = SEQ(name=u'multiplexingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultiplexingInfo')), opt=True)
    _IAB_Info_IAB_DU_iAB_STC_Info = SEQ(name=u'iAB-STC-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _IAB_Info_IAB_DU_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Info_IAB_DU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Info_IAB_DU_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_Info_IAB_DU_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_Info_IAB_DU_iE_Extensions__item__id),
        (u'criticality', ___IAB_Info_IAB_DU_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue),
        ])
    __IAB_Info_IAB_DU_iE_Extensions__item_._ext = None
    _IAB_Info_IAB_DU_iE_Extensions._cont = __IAB_Info_IAB_DU_iE_Extensions__item_
    _IAB_Info_IAB_DU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Info_IAB_DU._cont = ASN1Dict([
        (u'multiplexingInfo', _IAB_Info_IAB_DU_multiplexingInfo),
        (u'iAB-STC-Info', _IAB_Info_IAB_DU_iAB_STC_Info),
        (u'iE-Extensions', _IAB_Info_IAB_DU_iE_Extensions),
        ])
    IAB_Info_IAB_DU._ext = None
    
    #-----< IAB-Info-IAB-DU-ExtIEs >-----#
    IAB_Info_IAB_DU_ExtIEs = CLASS(name=u'IAB-Info-IAB-DU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Info_IAB_DU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-MT-Cell-List >-----#
    IAB_MT_Cell_List = SEQ_OF(name=u'IAB-MT-Cell-List', mode=MODE_TYPE)
    _IAB_MT_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-List-Item')))
    IAB_MT_Cell_List._cont = _IAB_MT_Cell_List__item_
    IAB_MT_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< IAB-MT-Cell-List-Item >-----#
    IAB_MT_Cell_List_Item = SEQ(name=u'IAB-MT-Cell-List-Item', mode=MODE_TYPE)
    _IAB_MT_Cell_List_Item_nRCellIdentity = BIT_STR(name=u'nRCellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _IAB_MT_Cell_List_Item_dU_RX_MT_RX = ENUM(name=u'dU-RX-MT-RX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-RX')))
    _IAB_MT_Cell_List_Item_dU_TX_MT_TX = ENUM(name=u'dU-TX-MT-TX', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-TX')))
    _IAB_MT_Cell_List_Item_dU_RX_MT_TX = ENUM(name=u'dU-RX-MT-TX', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-TX')))
    _IAB_MT_Cell_List_Item_dU_TX_MT_RX = ENUM(name=u'dU-TX-MT-RX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-RX')))
    _IAB_MT_Cell_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_MT_Cell_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__criticality_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_MT_Cell_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_MT_Cell_List_Item_iE_Extensions__item__id),
        (u'criticality', ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_MT_Cell_List_Item_iE_Extensions__item_._ext = None
    _IAB_MT_Cell_List_Item_iE_Extensions._cont = __IAB_MT_Cell_List_Item_iE_Extensions__item_
    _IAB_MT_Cell_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_MT_Cell_List_Item._cont = ASN1Dict([
        (u'nRCellIdentity', _IAB_MT_Cell_List_Item_nRCellIdentity),
        (u'dU-RX-MT-RX', _IAB_MT_Cell_List_Item_dU_RX_MT_RX),
        (u'dU-TX-MT-TX', _IAB_MT_Cell_List_Item_dU_TX_MT_TX),
        (u'dU-RX-MT-TX', _IAB_MT_Cell_List_Item_dU_RX_MT_TX),
        (u'dU-TX-MT-RX', _IAB_MT_Cell_List_Item_dU_TX_MT_RX),
        (u'iE-Extensions', _IAB_MT_Cell_List_Item_iE_Extensions),
        ])
    IAB_MT_Cell_List_Item._ext = None
    
    #-----< IAB-MT-Cell-List-Item-ExtIEs >-----#
    IAB_MT_Cell_List_Item_ExtIEs = CLASS(name=u'IAB-MT-Cell-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_MT_Cell_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-STC-Info >-----#
    IAB_STC_Info = SEQ(name=u'IAB-STC-Info', mode=MODE_TYPE)
    _IAB_STC_Info_iAB_STC_Info_List = SEQ_OF(name=u'iAB-STC-Info-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info-List')))
    _IAB_STC_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_STC_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_STC_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_STC_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab = ____IAB_STC_Info_iE_Extensions__item__id_tab
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_STC_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_STC_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab = ____IAB_STC_Info_iE_Extensions__item__criticality_tab
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_STC_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_STC_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_STC_Info_iE_Extensions__item__id),
        (u'criticality', ___IAB_STC_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_STC_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_STC_Info_iE_Extensions__item_._ext = None
    _IAB_STC_Info_iE_Extensions._cont = __IAB_STC_Info_iE_Extensions__item_
    _IAB_STC_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_STC_Info._cont = ASN1Dict([
        (u'iAB-STC-Info-List', _IAB_STC_Info_iAB_STC_Info_List),
        (u'iE-Extensions', _IAB_STC_Info_iE_Extensions),
        ])
    IAB_STC_Info._ext = None
    
    #-----< IAB-STC-Info-ExtIEs >-----#
    IAB_STC_Info_ExtIEs = CLASS(name=u'IAB-STC-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_STC_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-STC-Info-List >-----#
    IAB_STC_Info_List = SEQ_OF(name=u'IAB-STC-Info-List', mode=MODE_TYPE)
    _IAB_STC_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info-Item')))
    IAB_STC_Info_List._cont = _IAB_STC_Info_List__item_
    IAB_STC_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=45)], ev=None, er=[])
    
    #-----< IAB-STC-Info-Item >-----#
    IAB_STC_Info_Item = SEQ(name=u'IAB-STC-Info-Item', mode=MODE_TYPE)
    _IAB_STC_Info_Item_sSB_freqInfo = INT(name=u'sSB-freqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-freqInfo')))
    _IAB_STC_Info_Item_sSB_subcarrierSpacing = ENUM(name=u'sSB-subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-subcarrierSpacing')))
    _IAB_STC_Info_Item_sSB_transmissionPeriodicity = ENUM(name=u'sSB-transmissionPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionPeriodicity')))
    _IAB_STC_Info_Item_sSB_transmissionTimingOffset = INT(name=u'sSB-transmissionTimingOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionTimingOffset')))
    _IAB_STC_Info_Item_sSB_transmissionBitmap = CHOICE(name=u'sSB-transmissionBitmap', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionBitmap')))
    _IAB_STC_Info_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_STC_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_STC_Info_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_STC_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__id_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_STC_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_STC_Info_Item_iE_Extensions__item__id),
        (u'criticality', ___IAB_STC_Info_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_STC_Info_Item_iE_Extensions__item_._ext = None
    _IAB_STC_Info_Item_iE_Extensions._cont = __IAB_STC_Info_Item_iE_Extensions__item_
    _IAB_STC_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_STC_Info_Item._cont = ASN1Dict([
        (u'sSB-freqInfo', _IAB_STC_Info_Item_sSB_freqInfo),
        (u'sSB-subcarrierSpacing', _IAB_STC_Info_Item_sSB_subcarrierSpacing),
        (u'sSB-transmissionPeriodicity', _IAB_STC_Info_Item_sSB_transmissionPeriodicity),
        (u'sSB-transmissionTimingOffset', _IAB_STC_Info_Item_sSB_transmissionTimingOffset),
        (u'sSB-transmissionBitmap', _IAB_STC_Info_Item_sSB_transmissionBitmap),
        (u'iE-Extensions', _IAB_STC_Info_Item_iE_Extensions),
        ])
    IAB_STC_Info_Item._ext = None
    
    #-----< IAB-STC-Info-Item-ExtIEs >-----#
    IAB_STC_Info_Item_ExtIEs = CLASS(name=u'IAB-STC-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_STC_Info_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Allocated-TNL-Address-Item >-----#
    IAB_Allocated_TNL_Address_Item = SEQ(name=u'IAB-Allocated-TNL-Address-Item', mode=MODE_TYPE)
    _IAB_Allocated_TNL_Address_Item_iABTNLAddress = CHOICE(name=u'iABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage = ENUM(name=u'iABTNLAddressUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressUsage')), opt=True)
    _IAB_Allocated_TNL_Address_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id),
        (u'criticality', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_._ext = None
    _IAB_Allocated_TNL_Address_Item_iE_Extensions._cont = __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_
    _IAB_Allocated_TNL_Address_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Allocated_TNL_Address_Item._cont = ASN1Dict([
        (u'iABTNLAddress', _IAB_Allocated_TNL_Address_Item_iABTNLAddress),
        (u'iABTNLAddressUsage', _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage),
        (u'iE-Extensions', _IAB_Allocated_TNL_Address_Item_iE_Extensions),
        ])
    IAB_Allocated_TNL_Address_Item._ext = None
    
    #-----< IAB-Allocated-TNL-Address-Item-ExtIEs >-----#
    IAB_Allocated_TNL_Address_Item_ExtIEs = CLASS(name=u'IAB-Allocated-TNL-Address-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Allocated_TNL_Address_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-Mode-Info >-----#
    IAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name=u'IAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD = SEQ(name=u'fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-FDD-Info')))
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD = SEQ(name=u'tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-TDD-Info')))
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_at = None
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_id = u'id'
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_at = ('..', u'id')
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_id = u'criticality'
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_at = ('..', u'id')
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_id = u'Value'
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension._cont = ASN1Dict([
        (u'id', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id),
        (u'criticality', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality),
        (u'value', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value),
        ])
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension._ext = None
    IAB_DU_Cell_Resource_Configuration_Mode_Info._cont = ASN1Dict([
        (u'fDD', _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD),
        (u'tDD', _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD),
        (u'choice-extension', _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension),
        ])
    IAB_DU_Cell_Resource_Configuration_Mode_Info._ext = None
    
    #-----< IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs = CLASS(name=u'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-FDD-Info >-----#
    IAB_DU_Cell_Resource_Configuration_FDD_Info = SEQ(name=u'IAB-DU-Cell-Resource-Configuration-FDD-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL = SEQ(name=u'gNB-DU-Cell-Resource-Configuration-FDD-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL = SEQ(name=u'gNB-DU-Cell-Resource-Configuration-FDD-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id),
        (u'criticality', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_._ext = None
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions._cont = __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_DU_Cell_Resource_Configuration_FDD_Info._cont = ASN1Dict([
        (u'gNB-DU-Cell-Resource-Configuration-FDD-UL', _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL),
        (u'gNB-DU-Cell-Resource-Configuration-FDD-DL', _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL),
        (u'iE-Extensions', _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions),
        ])
    IAB_DU_Cell_Resource_Configuration_FDD_Info._ext = []
    
    #-----< IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs = CLASS(name=u'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-TDD-Info >-----#
    IAB_DU_Cell_Resource_Configuration_TDD_Info = SEQ(name=u'IAB-DU-Cell-Resource-Configuration-TDD-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD = SEQ(name=u'gNB-DU-Cell-Resourc-Configuration-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id),
        (u'criticality', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_._ext = None
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions._cont = __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_DU_Cell_Resource_Configuration_TDD_Info._cont = ASN1Dict([
        (u'gNB-DU-Cell-Resourc-Configuration-TDD', _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD),
        (u'iE-Extensions', _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions),
        ])
    IAB_DU_Cell_Resource_Configuration_TDD_Info._ext = []
    
    #-----< IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs = CLASS(name=u'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABIPv6RequestType >-----#
    IABIPv6RequestType = CHOICE(name=u'IABIPv6RequestType', mode=MODE_TYPE)
    _IABIPv6RequestType_iPv6Address = SEQ(name=u'iPv6Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABIPv6RequestType_iPv6Prefix = SEQ(name=u'iPv6Prefix', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABIPv6RequestType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IABIPv6RequestType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___IABIPv6RequestType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_id._const_tab = ___IABIPv6RequestType_choice_extension_id_tab
    __IABIPv6RequestType_choice_extension_id._const_tab_at = None
    __IABIPv6RequestType_choice_extension_id._const_tab_id = u'id'
    __IABIPv6RequestType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABIPv6RequestType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_criticality._const_tab = ___IABIPv6RequestType_choice_extension_criticality_tab
    __IABIPv6RequestType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __IABIPv6RequestType_choice_extension_criticality._const_tab_id = u'criticality'
    __IABIPv6RequestType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABIPv6RequestType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_value._const_tab = ___IABIPv6RequestType_choice_extension_value_tab
    __IABIPv6RequestType_choice_extension_value._const_tab_at = ('..', u'id')
    __IABIPv6RequestType_choice_extension_value._const_tab_id = u'Value'
    _IABIPv6RequestType_choice_extension._cont = ASN1Dict([
        (u'id', __IABIPv6RequestType_choice_extension_id),
        (u'criticality', __IABIPv6RequestType_choice_extension_criticality),
        (u'value', __IABIPv6RequestType_choice_extension_value),
        ])
    _IABIPv6RequestType_choice_extension._ext = None
    IABIPv6RequestType._cont = ASN1Dict([
        (u'iPv6Address', _IABIPv6RequestType_iPv6Address),
        (u'iPv6Prefix', _IABIPv6RequestType_iPv6Prefix),
        (u'choice-extension', _IABIPv6RequestType_choice_extension),
        ])
    IABIPv6RequestType._ext = None
    
    #-----< IABIPv6RequestType-ExtIEs >-----#
    IABIPv6RequestType_ExtIEs = CLASS(name=u'IABIPv6RequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IABIPv6RequestType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddress >-----#
    IABTNLAddress = CHOICE(name=u'IABTNLAddress', mode=MODE_TYPE)
    _IABTNLAddress_iPv4Address = BIT_STR(name=u'iPv4Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv4Address._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _IABTNLAddress_iPv6Address = BIT_STR(name=u'iPv6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv6Address._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _IABTNLAddress_iPv6Prefix = BIT_STR(name=u'iPv6Prefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv6Prefix._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _IABTNLAddress_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IABTNLAddress_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___IABTNLAddress_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_id._const_tab = ___IABTNLAddress_choice_extension_id_tab
    __IABTNLAddress_choice_extension_id._const_tab_at = None
    __IABTNLAddress_choice_extension_id._const_tab_id = u'id'
    __IABTNLAddress_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABTNLAddress_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_criticality._const_tab = ___IABTNLAddress_choice_extension_criticality_tab
    __IABTNLAddress_choice_extension_criticality._const_tab_at = ('..', u'id')
    __IABTNLAddress_choice_extension_criticality._const_tab_id = u'criticality'
    __IABTNLAddress_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABTNLAddress_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_value._const_tab = ___IABTNLAddress_choice_extension_value_tab
    __IABTNLAddress_choice_extension_value._const_tab_at = ('..', u'id')
    __IABTNLAddress_choice_extension_value._const_tab_id = u'Value'
    _IABTNLAddress_choice_extension._cont = ASN1Dict([
        (u'id', __IABTNLAddress_choice_extension_id),
        (u'criticality', __IABTNLAddress_choice_extension_criticality),
        (u'value', __IABTNLAddress_choice_extension_value),
        ])
    _IABTNLAddress_choice_extension._ext = None
    IABTNLAddress._cont = ASN1Dict([
        (u'iPv4Address', _IABTNLAddress_iPv4Address),
        (u'iPv6Address', _IABTNLAddress_iPv6Address),
        (u'iPv6Prefix', _IABTNLAddress_iPv6Prefix),
        (u'choice-extension', _IABTNLAddress_choice_extension),
        ])
    IABTNLAddress._ext = None
    
    #-----< IABTNLAddress-ExtIEs >-----#
    IABTNLAddress_ExtIEs = CLASS(name=u'IABTNLAddress-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IABTNLAddress_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressesRequested >-----#
    IABTNLAddressesRequested = SEQ(name=u'IABTNLAddressesRequested', mode=MODE_TYPE)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic = INT(name=u'tNLAddressesOrPrefixesRequestedAllTraffic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C = INT(name=u'tNLAddressesOrPrefixesRequestedF1-C', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U = INT(name=u'tNLAddressesOrPrefixesRequestedF1-U', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1 = INT(name=u'tNLAddressesOrPrefixesRequestedNoNF1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABTNLAddressesRequested_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABTNLAddressesRequested_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IABTNLAddressesRequested_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__id_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab_at = None
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab_id = u'id'
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IABTNLAddressesRequested_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IABTNLAddressesRequested_iE_Extensions__item__id),
        (u'criticality', ___IABTNLAddressesRequested_iE_Extensions__item__criticality),
        (u'extensionValue', ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue),
        ])
    __IABTNLAddressesRequested_iE_Extensions__item_._ext = None
    _IABTNLAddressesRequested_iE_Extensions._cont = __IABTNLAddressesRequested_iE_Extensions__item_
    _IABTNLAddressesRequested_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABTNLAddressesRequested._cont = ASN1Dict([
        (u'tNLAddressesOrPrefixesRequestedAllTraffic', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic),
        (u'tNLAddressesOrPrefixesRequestedF1-C', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C),
        (u'tNLAddressesOrPrefixesRequestedF1-U', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U),
        (u'tNLAddressesOrPrefixesRequestedNoNF1', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1),
        (u'iE-Extensions', _IABTNLAddressesRequested_iE_Extensions),
        ])
    IABTNLAddressesRequested._ext = None
    
    #-----< IABTNLAddressesRequested-ExtIEs >-----#
    IABTNLAddressesRequested_ExtIEs = CLASS(name=u'IABTNLAddressesRequested-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IABTNLAddressesRequested_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-Item >-----#
    IAB_TNL_Addresses_To_Remove_Item = SEQ(name=u'IAB-TNL-Addresses-To-Remove-Item', mode=MODE_TYPE)
    _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress = CHOICE(name=u'iABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id),
        (u'criticality', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_._ext = None
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions._cont = __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_TNL_Addresses_To_Remove_Item._cont = ASN1Dict([
        (u'iABTNLAddress', _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress),
        (u'iE-Extensions', _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions),
        ])
    IAB_TNL_Addresses_To_Remove_Item._ext = None
    
    #-----< IAB-TNL-Addresses-To-Remove-Item-ExtIEs >-----#
    IAB_TNL_Addresses_To_Remove_Item_ExtIEs = CLASS(name=u'IAB-TNL-Addresses-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_TNL_Addresses_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressUsage >-----#
    IABTNLAddressUsage = ENUM(name=u'IABTNLAddressUsage', mode=MODE_TYPE)
    IABTNLAddressUsage._cont = ASN1Dict([(u'f1-c', 0), (u'f1-u', 1), (u'non-f1', 2)])
    IABTNLAddressUsage._ext = []
    
    #-----< IABv4AddressesRequested >-----#
    IABv4AddressesRequested = SEQ(name=u'IABv4AddressesRequested', mode=MODE_TYPE)
    _IABv4AddressesRequested_iABv4AddressesRequested = SEQ(name=u'iABv4AddressesRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABv4AddressesRequested_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABv4AddressesRequested_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABv4AddressesRequested_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IABv4AddressesRequested_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__id_tab
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab_at = None
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab_id = u'id'
    ___IABv4AddressesRequested_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IABv4AddressesRequested_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IABv4AddressesRequested_iE_Extensions__item__id),
        (u'criticality', ___IABv4AddressesRequested_iE_Extensions__item__criticality),
        (u'extensionValue', ___IABv4AddressesRequested_iE_Extensions__item__extensionValue),
        ])
    __IABv4AddressesRequested_iE_Extensions__item_._ext = None
    _IABv4AddressesRequested_iE_Extensions._cont = __IABv4AddressesRequested_iE_Extensions__item_
    _IABv4AddressesRequested_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABv4AddressesRequested._cont = ASN1Dict([
        (u'iABv4AddressesRequested', _IABv4AddressesRequested_iABv4AddressesRequested),
        (u'iE-Extensions', _IABv4AddressesRequested_iE_Extensions),
        ])
    IABv4AddressesRequested._ext = None
    
    #-----< IABv4AddressesRequested-ExtIEs >-----#
    IABv4AddressesRequested_ExtIEs = CLASS(name=u'IABv4AddressesRequested-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IABv4AddressesRequested_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ImplicitFormat >-----#
    ImplicitFormat = SEQ(name=u'ImplicitFormat', mode=MODE_TYPE)
    _ImplicitFormat_dUFSlotformatIndex = INT(name=u'dUFSlotformatIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUFSlotformatIndex')))
    _ImplicitFormat_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImplicitFormat_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ImplicitFormat_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ImplicitFormat_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__id._const_tab = ____ImplicitFormat_iE_Extensions__item__id_tab
    ___ImplicitFormat_iE_Extensions__item__id._const_tab_at = None
    ___ImplicitFormat_iE_Extensions__item__id._const_tab_id = u'id'
    ___ImplicitFormat_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ImplicitFormat_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab = ____ImplicitFormat_iE_Extensions__item__criticality_tab
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ImplicitFormat_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ImplicitFormat_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab = ____ImplicitFormat_iE_Extensions__item__extensionValue_tab
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ImplicitFormat_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ImplicitFormat_iE_Extensions__item__id),
        (u'criticality', ___ImplicitFormat_iE_Extensions__item__criticality),
        (u'extensionValue', ___ImplicitFormat_iE_Extensions__item__extensionValue),
        ])
    __ImplicitFormat_iE_Extensions__item_._ext = None
    _ImplicitFormat_iE_Extensions._cont = __ImplicitFormat_iE_Extensions__item_
    _ImplicitFormat_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImplicitFormat._cont = ASN1Dict([
        (u'dUFSlotformatIndex', _ImplicitFormat_dUFSlotformatIndex),
        (u'iE-Extensions', _ImplicitFormat_iE_Extensions),
        ])
    ImplicitFormat._ext = None
    
    #-----< ImplicitFormat-ExtIEs >-----#
    ImplicitFormat_ExtIEs = CLASS(name=u'ImplicitFormat-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ImplicitFormat_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IgnorePRACHConfiguration >-----#
    IgnorePRACHConfiguration = ENUM(name=u'IgnorePRACHConfiguration', mode=MODE_TYPE)
    IgnorePRACHConfiguration._cont = ASN1Dict([(u'true', 0)])
    IgnorePRACHConfiguration._ext = []
    
    #-----< IgnoreResourceCoordinationContainer >-----#
    IgnoreResourceCoordinationContainer = ENUM(name=u'IgnoreResourceCoordinationContainer', mode=MODE_TYPE)
    IgnoreResourceCoordinationContainer._cont = ASN1Dict([(u'yes', 0)])
    IgnoreResourceCoordinationContainer._ext = []
    
    #-----< InactivityMonitoringRequest >-----#
    InactivityMonitoringRequest = ENUM(name=u'InactivityMonitoringRequest', mode=MODE_TYPE)
    InactivityMonitoringRequest._cont = ASN1Dict([(u'true', 0)])
    InactivityMonitoringRequest._ext = []
    
    #-----< InactivityMonitoringResponse >-----#
    InactivityMonitoringResponse = ENUM(name=u'InactivityMonitoringResponse', mode=MODE_TYPE)
    InactivityMonitoringResponse._cont = ASN1Dict([(u'not-supported', 0)])
    InactivityMonitoringResponse._ext = []
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name=u'InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IntendedTDD-DL-ULConfig >-----#
    IntendedTDD_DL_ULConfig = SEQ(name=u'IntendedTDD-DL-ULConfig', mode=MODE_TYPE)
    _IntendedTDD_DL_ULConfig_nRSCS = ENUM(name=u'nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRSCS._cont = ASN1Dict([(u'scs15', 0), (u'scs30', 1), (u'scs60', 2), (u'scs120', 3)])
    _IntendedTDD_DL_ULConfig_nRSCS._ext = []
    _IntendedTDD_DL_ULConfig_nRCP = ENUM(name=u'nRCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRCP._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    _IntendedTDD_DL_ULConfig_nRCP._ext = []
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity = ENUM(name=u'nRDLULTxPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity._cont = ASN1Dict([(u'ms0p5', 0), (u'ms0p625', 1), (u'ms1', 2), (u'ms1p25', 3), (u'ms2', 4), (u'ms2p5', 5), (u'ms3', 6), (u'ms4', 7), (u'ms5', 8), (u'ms10', 9), (u'ms20', 10), (u'ms40', 11), (u'ms60', 12), (u'ms80', 13), (u'ms100', 14), (u'ms120', 15), (u'ms140', 16), (u'ms160', 17)])
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity._ext = []
    _IntendedTDD_DL_ULConfig_slot_Configuration_List = SEQ_OF(name=u'slot-Configuration-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Slot-Configuration-List')))
    _IntendedTDD_DL_ULConfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab_at = None
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id),
        (u'criticality', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue),
        ])
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_._ext = None
    _IntendedTDD_DL_ULConfig_iE_Extensions._cont = __IntendedTDD_DL_ULConfig_iE_Extensions__item_
    _IntendedTDD_DL_ULConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntendedTDD_DL_ULConfig._cont = ASN1Dict([
        (u'nRSCS', _IntendedTDD_DL_ULConfig_nRSCS),
        (u'nRCP', _IntendedTDD_DL_ULConfig_nRCP),
        (u'nRDLULTxPeriodicity', _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity),
        (u'slot-Configuration-List', _IntendedTDD_DL_ULConfig_slot_Configuration_List),
        (u'iE-Extensions', _IntendedTDD_DL_ULConfig_iE_Extensions),
        ])
    IntendedTDD_DL_ULConfig._ext = None
    
    #-----< IntendedTDD-DL-ULConfig-ExtIEs >-----#
    IntendedTDD_DL_ULConfig_ExtIEs = CLASS(name=u'IntendedTDD-DL-ULConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IntendedTDD_DL_ULConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPHeaderInformation >-----#
    IPHeaderInformation = SEQ(name=u'IPHeaderInformation', mode=MODE_TYPE)
    _IPHeaderInformation_destinationIABTNLAddress = CHOICE(name=u'destinationIABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IPHeaderInformation_dsInformationList = SEQ_OF(name=u'dsInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DSInformationList')), opt=True)
    _IPHeaderInformation_iPv6FlowLabel = BIT_STR(name=u'iPv6FlowLabel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPHeaderInformation_iPv6FlowLabel._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _IPHeaderInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPHeaderInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPHeaderInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPHeaderInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab = ____IPHeaderInformation_iE_Extensions__item__id_tab
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab_at = None
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPHeaderInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPHeaderInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab = ____IPHeaderInformation_iE_Extensions__item__criticality_tab
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPHeaderInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab = ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPHeaderInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPHeaderInformation_iE_Extensions__item__id),
        (u'criticality', ___IPHeaderInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPHeaderInformation_iE_Extensions__item__extensionValue),
        ])
    __IPHeaderInformation_iE_Extensions__item_._ext = None
    _IPHeaderInformation_iE_Extensions._cont = __IPHeaderInformation_iE_Extensions__item_
    _IPHeaderInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPHeaderInformation._cont = ASN1Dict([
        (u'destinationIABTNLAddress', _IPHeaderInformation_destinationIABTNLAddress),
        (u'dsInformationList', _IPHeaderInformation_dsInformationList),
        (u'iPv6FlowLabel', _IPHeaderInformation_iPv6FlowLabel),
        (u'iE-Extensions', _IPHeaderInformation_iE_Extensions),
        ])
    IPHeaderInformation._ext = []
    
    #-----< IPHeaderInformation-ItemExtIEs >-----#
    IPHeaderInformation_ItemExtIEs = CLASS(name=u'IPHeaderInformation-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IPHeaderInformation_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPtolayer2TrafficMappingInfo >-----#
    IPtolayer2TrafficMappingInfo = SEQ(name=u'IPtolayer2TrafficMappingInfo', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd = SEQ_OF(name=u'iPtolayer2TrafficMappingInfoToAdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfoList')), opt=True)
    _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove = SEQ_OF(name=u'iPtolayer2TrafficMappingInfoToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationtoRemove')), opt=True)
    _IPtolayer2TrafficMappingInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab_at = None
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id),
        (u'criticality', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue),
        ])
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_._ext = None
    _IPtolayer2TrafficMappingInfo_iE_Extensions._cont = __IPtolayer2TrafficMappingInfo_iE_Extensions__item_
    _IPtolayer2TrafficMappingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPtolayer2TrafficMappingInfo._cont = ASN1Dict([
        (u'iPtolayer2TrafficMappingInfoToAdd', _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd),
        (u'iPtolayer2TrafficMappingInfoToRemove', _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove),
        (u'iE-Extensions', _IPtolayer2TrafficMappingInfo_iE_Extensions),
        ])
    IPtolayer2TrafficMappingInfo._ext = []
    
    #-----< IPtolayer2TrafficMappingInfoList >-----#
    IPtolayer2TrafficMappingInfoList = SEQ_OF(name=u'IPtolayer2TrafficMappingInfoList', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfo-Item')))
    IPtolayer2TrafficMappingInfoList._cont = _IPtolayer2TrafficMappingInfoList__item_
    IPtolayer2TrafficMappingInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< IPtolayer2TrafficMappingInfo-Item >-----#
    IPtolayer2TrafficMappingInfo_Item = SEQ(name=u'IPtolayer2TrafficMappingInfo-Item', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex = BIT_STR(name=u'mappingInformationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation = SEQ(name=u'iPHeaderInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPHeaderInformation')))
    _IPtolayer2TrafficMappingInfo_Item_bHInfo = SEQ(name=u'bHInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id),
        (u'criticality', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_._ext = None
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions._cont = __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPtolayer2TrafficMappingInfo_Item._cont = ASN1Dict([
        (u'mappingInformationIndex', _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex),
        (u'iPHeaderInformation', _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation),
        (u'bHInfo', _IPtolayer2TrafficMappingInfo_Item_bHInfo),
        (u'iE-Extensions', _IPtolayer2TrafficMappingInfo_Item_iE_Extensions),
        ])
    IPtolayer2TrafficMappingInfo_Item._ext = []
    
    #-----< IPtolayer2TrafficMappingInfo-ItemExtIEs >-----#
    IPtolayer2TrafficMappingInfo_ItemExtIEs = CLASS(name=u'IPtolayer2TrafficMappingInfo-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IPtolayer2TrafficMappingInfo_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L139Info >-----#
    L139Info = SEQ(name=u'L139Info', mode=MODE_TYPE)
    _L139Info_msg1SCS = ENUM(name=u'msg1SCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L139Info_msg1SCS._cont = ASN1Dict([(u'scs15', 0), (u'scs30', 1), (u'scs60', 2), (u'scs120', 3)])
    _L139Info_msg1SCS._ext = []
    _L139Info_rootSequenceIndex = INT(name=u'rootSequenceIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _L139Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=137)], ev=None, er=[])
    _L139Info_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L139Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L139Info_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____L139Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__id._const_tab = ____L139Info_iE_Extension__item__id_tab
    ___L139Info_iE_Extension__item__id._const_tab_at = None
    ___L139Info_iE_Extension__item__id._const_tab_id = u'id'
    ___L139Info_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____L139Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__criticality._const_tab = ____L139Info_iE_Extension__item__criticality_tab
    ___L139Info_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___L139Info_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___L139Info_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____L139Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__extensionValue._const_tab = ____L139Info_iE_Extension__item__extensionValue_tab
    ___L139Info_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___L139Info_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __L139Info_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___L139Info_iE_Extension__item__id),
        (u'criticality', ___L139Info_iE_Extension__item__criticality),
        (u'extensionValue', ___L139Info_iE_Extension__item__extensionValue),
        ])
    __L139Info_iE_Extension__item_._ext = None
    _L139Info_iE_Extension._cont = __L139Info_iE_Extension__item_
    _L139Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L139Info._cont = ASN1Dict([
        (u'msg1SCS', _L139Info_msg1SCS),
        (u'rootSequenceIndex', _L139Info_rootSequenceIndex),
        (u'iE-Extension', _L139Info_iE_Extension),
        ])
    L139Info._ext = []
    
    #-----< L139Info-ExtIEs >-----#
    L139Info_ExtIEs = CLASS(name=u'L139Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L139Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L839Info >-----#
    L839Info = SEQ(name=u'L839Info', mode=MODE_TYPE)
    _L839Info_rootSequenceIndex = INT(name=u'rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L839Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _L839Info_restrictedSetConfig = ENUM(name=u'restrictedSetConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L839Info_restrictedSetConfig._cont = ASN1Dict([(u'unrestrictedSet', 0), (u'restrictedSetTypeA', 1), (u'restrictedSetTypeB', 2)])
    _L839Info_restrictedSetConfig._ext = []
    _L839Info_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L839Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L839Info_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____L839Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__id._const_tab = ____L839Info_iE_Extension__item__id_tab
    ___L839Info_iE_Extension__item__id._const_tab_at = None
    ___L839Info_iE_Extension__item__id._const_tab_id = u'id'
    ___L839Info_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____L839Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__criticality._const_tab = ____L839Info_iE_Extension__item__criticality_tab
    ___L839Info_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___L839Info_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___L839Info_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____L839Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__extensionValue._const_tab = ____L839Info_iE_Extension__item__extensionValue_tab
    ___L839Info_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___L839Info_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __L839Info_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___L839Info_iE_Extension__item__id),
        (u'criticality', ___L839Info_iE_Extension__item__criticality),
        (u'extensionValue', ___L839Info_iE_Extension__item__extensionValue),
        ])
    __L839Info_iE_Extension__item_._ext = None
    _L839Info_iE_Extension._cont = __L839Info_iE_Extension__item_
    _L839Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L839Info._cont = ASN1Dict([
        (u'rootSequenceIndex', _L839Info_rootSequenceIndex),
        (u'restrictedSetConfig', _L839Info_restrictedSetConfig),
        (u'iE-Extension', _L839Info_iE_Extension),
        ])
    L839Info._ext = []
    
    #-----< L839Info-ExtIEs >-----#
    L839Info_ExtIEs = CLASS(name=u'L839Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L839Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCID >-----#
    LCID = INT(name=u'LCID', mode=MODE_TYPE)
    LCID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< LCS-to-GCS-TranslationAoA >-----#
    LCS_to_GCS_TranslationAoA = SEQ(name=u'LCS-to-GCS-TranslationAoA', mode=MODE_TYPE)
    _LCS_to_GCS_TranslationAoA_alpha = INT(name=u'alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_beta = INT(name=u'beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_gamma = INT(name=u'gamma', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab_id = u'id'
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id),
        (u'criticality', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality),
        (u'extensionValue', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_._ext = None
    _LCS_to_GCS_TranslationAoA_iE_Extensions._cont = __LCS_to_GCS_TranslationAoA_iE_Extensions__item_
    _LCS_to_GCS_TranslationAoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_TranslationAoA._cont = ASN1Dict([
        (u'alpha', _LCS_to_GCS_TranslationAoA_alpha),
        (u'beta', _LCS_to_GCS_TranslationAoA_beta),
        (u'gamma', _LCS_to_GCS_TranslationAoA_gamma),
        (u'iE-Extensions', _LCS_to_GCS_TranslationAoA_iE_Extensions),
        ])
    LCS_to_GCS_TranslationAoA._ext = []
    
    #-----< LCS-to-GCS-TranslationAoA-ExtIEs >-----#
    LCS_to_GCS_TranslationAoA_ExtIEs = CLASS(name=u'LCS-to-GCS-TranslationAoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LCS_to_GCS_TranslationAoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCStoGCSTranslationList >-----#
    LCStoGCSTranslationList = SEQ_OF(name=u'LCStoGCSTranslationList', mode=MODE_TYPE)
    _LCStoGCSTranslationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LCStoGCSTranslation')))
    LCStoGCSTranslationList._cont = _LCStoGCSTranslationList__item_
    LCStoGCSTranslationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< LCStoGCSTranslation >-----#
    LCStoGCSTranslation = SEQ(name=u'LCStoGCSTranslation', mode=MODE_TYPE)
    _LCStoGCSTranslation_alpha = INT(name=u'alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_alpha_fine = INT(name=u'alpha-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_alpha_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_beta = INT(name=u'beta', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_beta_fine = INT(name=u'beta-fine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_beta_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_gamma = INT(name=u'gamma', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_gamma_fine = INT(name=u'gamma-fine', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_gamma_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCStoGCSTranslation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LCStoGCSTranslation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LCStoGCSTranslation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__id_tab
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab_at = None
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LCStoGCSTranslation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LCStoGCSTranslation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LCStoGCSTranslation_iE_Extensions__item__id),
        (u'criticality', ___LCStoGCSTranslation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LCStoGCSTranslation_iE_Extensions__item__extensionValue),
        ])
    __LCStoGCSTranslation_iE_Extensions__item_._ext = None
    _LCStoGCSTranslation_iE_Extensions._cont = __LCStoGCSTranslation_iE_Extensions__item_
    _LCStoGCSTranslation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCStoGCSTranslation._cont = ASN1Dict([
        (u'alpha', _LCStoGCSTranslation_alpha),
        (u'alpha-fine', _LCStoGCSTranslation_alpha_fine),
        (u'beta', _LCStoGCSTranslation_beta),
        (u'beta-fine', _LCStoGCSTranslation_beta_fine),
        (u'gamma', _LCStoGCSTranslation_gamma),
        (u'gamma-fine', _LCStoGCSTranslation_gamma_fine),
        (u'iE-Extensions', _LCStoGCSTranslation_iE_Extensions),
        ])
    LCStoGCSTranslation._ext = None
    
    #-----< LCStoGCSTranslation-ExtIEs >-----#
    LCStoGCSTranslation_ExtIEs = CLASS(name=u'LCStoGCSTranslation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LCStoGCSTranslation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LMF-MeasurementID >-----#
    LMF_MeasurementID = INT(name=u'LMF-MeasurementID', mode=MODE_TYPE)
    LMF_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< LMF-UE-MeasurementID >-----#
    LMF_UE_MeasurementID = INT(name=u'LMF-UE-MeasurementID', mode=MODE_TYPE)
    LMF_UE_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< LocationMeasurementInformation >-----#
    LocationMeasurementInformation = OCT_STR(name=u'LocationMeasurementInformation', mode=MODE_TYPE)
    
    #-----< LocationUncertainty >-----#
    LocationUncertainty = SEQ(name=u'LocationUncertainty', mode=MODE_TYPE)
    _LocationUncertainty_horizontalUncertainty = INT(name=u'horizontalUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_horizontalConfidence = INT(name=u'horizontalConfidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_verticalUncertainty = INT(name=u'verticalUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_verticalConfidence = INT(name=u'verticalConfidence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LocationUncertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__id._const_tab = ____LocationUncertainty_iE_Extensions__item__id_tab
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___LocationUncertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab = ____LocationUncertainty_iE_Extensions__item__criticality_tab
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LocationUncertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab = ____LocationUncertainty_iE_Extensions__item__extensionValue_tab
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LocationUncertainty_iE_Extensions__item__id),
        (u'criticality', ___LocationUncertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___LocationUncertainty_iE_Extensions__item__extensionValue),
        ])
    __LocationUncertainty_iE_Extensions__item_._ext = None
    _LocationUncertainty_iE_Extensions._cont = __LocationUncertainty_iE_Extensions__item_
    _LocationUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationUncertainty._cont = ASN1Dict([
        (u'horizontalUncertainty', _LocationUncertainty_horizontalUncertainty),
        (u'horizontalConfidence', _LocationUncertainty_horizontalConfidence),
        (u'verticalUncertainty', _LocationUncertainty_verticalUncertainty),
        (u'verticalConfidence', _LocationUncertainty_verticalConfidence),
        (u'iE-Extensions', _LocationUncertainty_iE_Extensions),
        ])
    LocationUncertainty._ext = None
    
    #-----< LocationUncertainty-ExtIEs >-----#
    LocationUncertainty_ExtIEs = CLASS(name=u'LocationUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LocationUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LongDRXCycleLength >-----#
    LongDRXCycleLength = ENUM(name=u'LongDRXCycleLength', mode=MODE_TYPE)
    LongDRXCycleLength._cont = ASN1Dict([(u'ms10', 0), (u'ms20', 1), (u'ms32', 2), (u'ms40', 3), (u'ms60', 4), (u'ms64', 5), (u'ms70', 6), (u'ms80', 7), (u'ms128', 8), (u'ms160', 9), (u'ms256', 10), (u'ms320', 11), (u'ms512', 12), (u'ms640', 13), (u'ms1024', 14), (u'ms1280', 15), (u'ms2048', 16), (u'ms2560', 17), (u'ms5120', 18), (u'ms10240', 19)])
    LongDRXCycleLength._ext = []
    
    #-----< LowerLayerPresenceStatusChange >-----#
    LowerLayerPresenceStatusChange = ENUM(name=u'LowerLayerPresenceStatusChange', mode=MODE_TYPE)
    LowerLayerPresenceStatusChange._cont = ASN1Dict([(u'suspend-lower-layers', 0), (u'resume-lower-layers', 1)])
    LowerLayerPresenceStatusChange._ext = []
    
    #-----< LTEUESidelinkAggregateMaximumBitrate >-----#
    LTEUESidelinkAggregateMaximumBitrate = SEQ(name=u'LTEUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate = INT(name=u'uELTESidelinkAggregateMaximumBitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uELTESidelinkAggregateMaximumBitrate', _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate),
        (u'iE-Extensions', _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    LTEUESidelinkAggregateMaximumBitrate._ext = None
    
    #-----< LTEUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    LTEUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name=u'LTEUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LTEUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEV2XServicesAuthorized >-----#
    LTEV2XServicesAuthorized = SEQ(name=u'LTEV2XServicesAuthorized', mode=MODE_TYPE)
    _LTEV2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'VehicleUE')), opt=True)
    _LTEV2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PedestrianUE')), opt=True)
    _LTEV2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LTEV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LTEV2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __LTEV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _LTEV2XServicesAuthorized_iE_Extensions._cont = __LTEV2XServicesAuthorized_iE_Extensions__item_
    _LTEV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEV2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _LTEV2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _LTEV2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _LTEV2XServicesAuthorized_iE_Extensions),
        ])
    LTEV2XServicesAuthorized._ext = None
    
    #-----< LTEV2XServicesAuthorized-ExtIEs >-----#
    LTEV2XServicesAuthorized_ExtIEs = CLASS(name=u'LTEV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LTEV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MappingInformationIndex >-----#
    MappingInformationIndex = BIT_STR(name=u'MappingInformationIndex', mode=MODE_TYPE)
    MappingInformationIndex._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    
    #-----< MappingInformationtoRemove >-----#
    MappingInformationtoRemove = SEQ_OF(name=u'MappingInformationtoRemove', mode=MODE_TYPE)
    _MappingInformationtoRemove__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    MappingInformationtoRemove._cont = _MappingInformationtoRemove__item_
    MappingInformationtoRemove._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< MaskedIMEISV >-----#
    MaskedIMEISV = BIT_STR(name=u'MaskedIMEISV', mode=MODE_TYPE)
    MaskedIMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MaxDataBurstVolume >-----#
    MaxDataBurstVolume = INT(name=u'MaxDataBurstVolume', mode=MODE_TYPE)
    MaxDataBurstVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[ASN1RangeInt(lb=4096, ub=2000000)])
    
    #-----< MaxPacketLossRate >-----#
    MaxPacketLossRate = INT(name=u'MaxPacketLossRate', mode=MODE_TYPE)
    MaxPacketLossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< MIB-message >-----#
    MIB_message = OCT_STR(name=u'MIB-message', mode=MODE_TYPE)
    
    #-----< MeasConfig >-----#
    MeasConfig = OCT_STR(name=u'MeasConfig', mode=MODE_TYPE)
    
    #-----< MeasGapConfig >-----#
    MeasGapConfig = OCT_STR(name=u'MeasGapConfig', mode=MODE_TYPE)
    
    #-----< MeasGapSharingConfig >-----#
    MeasGapSharingConfig = OCT_STR(name=u'MeasGapSharingConfig', mode=MODE_TYPE)
    
    #-----< MeasurementBeamInfoRequest >-----#
    MeasurementBeamInfoRequest = ENUM(name=u'MeasurementBeamInfoRequest', mode=MODE_TYPE)
    MeasurementBeamInfoRequest._cont = ASN1Dict([(u'true', 0)])
    MeasurementBeamInfoRequest._ext = []
    
    #-----< MeasurementBeamInfo >-----#
    MeasurementBeamInfo = SEQ(name=u'MeasurementBeamInfo', mode=MODE_TYPE)
    _MeasurementBeamInfo_pRS_Resource_ID = INT(name=u'pRS-Resource-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _MeasurementBeamInfo_pRS_Resource_Set_ID = INT(name=u'pRS-Resource-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _MeasurementBeamInfo_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _MeasurementBeamInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementBeamInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementBeamInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__id_tab
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementBeamInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementBeamInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementBeamInfo_iE_Extensions__item__id),
        (u'criticality', ___MeasurementBeamInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementBeamInfo_iE_Extensions__item__extensionValue),
        ])
    __MeasurementBeamInfo_iE_Extensions__item_._ext = None
    _MeasurementBeamInfo_iE_Extensions._cont = __MeasurementBeamInfo_iE_Extensions__item_
    _MeasurementBeamInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementBeamInfo._cont = ASN1Dict([
        (u'pRS-Resource-ID', _MeasurementBeamInfo_pRS_Resource_ID),
        (u'pRS-Resource-Set-ID', _MeasurementBeamInfo_pRS_Resource_Set_ID),
        (u'sSB-Index', _MeasurementBeamInfo_sSB_Index),
        (u'iE-Extensions', _MeasurementBeamInfo_iE_Extensions),
        ])
    MeasurementBeamInfo._ext = None
    
    #-----< MeasurementBeamInfo-ExtIEs >-----#
    MeasurementBeamInfo_ExtIEs = CLASS(name=u'MeasurementBeamInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MeasurementBeamInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementTimingConfiguration >-----#
    MeasurementTimingConfiguration = OCT_STR(name=u'MeasurementTimingConfiguration', mode=MODE_TYPE)
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name=u'MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MultiplexingInfo >-----#
    MultiplexingInfo = SEQ(name=u'MultiplexingInfo', mode=MODE_TYPE)
    _MultiplexingInfo_iAB_MT_Cell_List = SEQ_OF(name=u'iAB-MT-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-List')))
    _MultiplexingInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultiplexingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MultiplexingInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MultiplexingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab = ____MultiplexingInfo_iE_Extensions__item__id_tab
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab_at = None
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MultiplexingInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MultiplexingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab = ____MultiplexingInfo_iE_Extensions__item__criticality_tab
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MultiplexingInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab = ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MultiplexingInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MultiplexingInfo_iE_Extensions__item__id),
        (u'criticality', ___MultiplexingInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MultiplexingInfo_iE_Extensions__item__extensionValue),
        ])
    __MultiplexingInfo_iE_Extensions__item_._ext = None
    _MultiplexingInfo_iE_Extensions._cont = __MultiplexingInfo_iE_Extensions__item_
    _MultiplexingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultiplexingInfo._cont = ASN1Dict([
        (u'iAB-MT-Cell-List', _MultiplexingInfo_iAB_MT_Cell_List),
        (u'iE-Extensions', _MultiplexingInfo_iE_Extensions),
        ])
    MultiplexingInfo._ext = None
    
    #-----< MultiplexingInfo-ExtIEs >-----#
    MultiplexingInfo_ExtIEs = CLASS(name=u'MultiplexingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MultiplexingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M2Configuration >-----#
    M2Configuration = ENUM(name=u'M2Configuration', mode=MODE_TYPE)
    M2Configuration._cont = ASN1Dict([(u'true', 0)])
    M2Configuration._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name=u'M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name=u'm5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name=u'm5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5-Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M5Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__criticality_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__extensionValue_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M5Configuration_iE_Extensions__item__id),
        (u'criticality', ___M5Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        (u'm5period', _M5Configuration_m5period),
        (u'm5-links-to-log', _M5Configuration_m5_links_to_log),
        (u'iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name=u'M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name=u'M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M5period._ext = []
    
    #-----< M5-Links-to-log >-----#
    M5_Links_to_log = ENUM(name=u'M5-Links-to-log', mode=MODE_TYPE)
    M5_Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    M5_Links_to_log._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name=u'M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name=u'm6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6report-Interval')))
    _M6Configuration_m6_links_to_log = ENUM(name=u'm6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6-Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M6Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__criticality_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__extensionValue_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M6Configuration_iE_Extensions__item__id),
        (u'criticality', ___M6Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        (u'm6report-Interval', _M6Configuration_m6report_Interval),
        (u'm6-links-to-log', _M6Configuration_m6_links_to_log),
        (u'iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name=u'M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name=u'M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms640', 2), (u'ms1024', 3), (u'ms2048', 4), (u'ms5120', 5), (u'ms10240', 6), (u'ms20480', 7), (u'ms40960', 8), (u'min1', 9), (u'min6', 10), (u'min12', 11), (u'min30', 12)])
    M6report_Interval._ext = []
    
    #-----< M6-Links-to-log >-----#
    M6_Links_to_log = ENUM(name=u'M6-Links-to-log', mode=MODE_TYPE)
    M6_Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    M6_Links_to_log._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name=u'M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name=u'm7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name=u'm7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7-Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M7Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__criticality_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__extensionValue_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M7Configuration_iE_Extensions__item__id),
        (u'criticality', ___M7Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        (u'm7period', _M7Configuration_m7period),
        (u'm7-links-to-log', _M7Configuration_m7_links_to_log),
        (u'iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name=u'M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name=u'M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< M7-Links-to-log >-----#
    M7_Links_to_log = ENUM(name=u'M7-Links-to-log', mode=MODE_TYPE)
    M7_Links_to_log._cont = ASN1Dict([(u'downlink', 0)])
    M7_Links_to_log._ext = []
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'immediate-MDT-and-Trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDTConfiguration >-----#
    MDTConfiguration = SEQ(name=u'MDTConfiguration', mode=MODE_TYPE)
    _MDTConfiguration_mdt_Activation = ENUM(name=u'mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MDT-Activation')))
    _MDTConfiguration_measurementsToActivate = BIT_STR(name=u'measurementsToActivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasurementsToActivate')))
    _MDTConfiguration_m2Configuration = ENUM(name=u'm2Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M2Configuration')), opt=True)
    _MDTConfiguration_m5Configuration = SEQ(name=u'm5Configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5Configuration')), opt=True)
    _MDTConfiguration_m6Configuration = SEQ(name=u'm6Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6Configuration')), opt=True)
    _MDTConfiguration_m7Configuration = SEQ(name=u'm7Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7Configuration')), opt=True)
    _MDTConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDTConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MDTConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDTConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__id._const_tab = ____MDTConfiguration_iE_Extensions__item__id_tab
    ___MDTConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___MDTConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDTConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDTConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab = ____MDTConfiguration_iE_Extensions__item__criticality_tab
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDTConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDTConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab = ____MDTConfiguration_iE_Extensions__item__extensionValue_tab
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDTConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDTConfiguration_iE_Extensions__item__id),
        (u'criticality', ___MDTConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDTConfiguration_iE_Extensions__item__extensionValue),
        ])
    __MDTConfiguration_iE_Extensions__item_._ext = None
    _MDTConfiguration_iE_Extensions._cont = __MDTConfiguration_iE_Extensions__item_
    _MDTConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDTConfiguration._cont = ASN1Dict([
        (u'mdt-Activation', _MDTConfiguration_mdt_Activation),
        (u'measurementsToActivate', _MDTConfiguration_measurementsToActivate),
        (u'm2Configuration', _MDTConfiguration_m2Configuration),
        (u'm5Configuration', _MDTConfiguration_m5Configuration),
        (u'm6Configuration', _MDTConfiguration_m6Configuration),
        (u'm7Configuration', _MDTConfiguration_m7Configuration),
        (u'iE-Extensions', _MDTConfiguration_iE_Extensions),
        ])
    MDTConfiguration._ext = []
    
    #-----< MDTConfiguration-ExtIEs >-----#
    MDTConfiguration_ExtIEs = CLASS(name=u'MDTConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MDTConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name=u'MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MeasuredResultsValue >-----#
    MeasuredResultsValue = CHOICE(name=u'MeasuredResultsValue', mode=MODE_TYPE)
    _MeasuredResultsValue_uL_AngleOfArrival = SEQ(name=u'uL-AngleOfArrival', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-AoA')))
    _MeasuredResultsValue_uL_SRS_RSRP = INT(name=u'uL-SRS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRP')))
    _MeasuredResultsValue_uL_RTOA = SEQ(name=u'uL-RTOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-RTOA-Measurement')))
    _MeasuredResultsValue_gNB_RxTxTimeDiff = SEQ(name=u'gNB-RxTxTimeDiff', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-RxTxTimeDiff')))
    _MeasuredResultsValue_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasuredResultsValue_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___MeasuredResultsValue_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MeasuredResultsValue_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_extension_id._const_tab = ___MeasuredResultsValue_choice_extension_id_tab
    __MeasuredResultsValue_choice_extension_id._const_tab_at = None
    __MeasuredResultsValue_choice_extension_id._const_tab_id = u'id'
    __MeasuredResultsValue_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___MeasuredResultsValue_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MeasuredResultsValue_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_extension_criticality._const_tab = ___MeasuredResultsValue_choice_extension_criticality_tab
    __MeasuredResultsValue_choice_extension_criticality._const_tab_at = ('..', u'id')
    __MeasuredResultsValue_choice_extension_criticality._const_tab_id = u'criticality'
    __MeasuredResultsValue_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___MeasuredResultsValue_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MeasuredResultsValue_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_extension_value._const_tab = ___MeasuredResultsValue_choice_extension_value_tab
    __MeasuredResultsValue_choice_extension_value._const_tab_at = ('..', u'id')
    __MeasuredResultsValue_choice_extension_value._const_tab_id = u'Value'
    _MeasuredResultsValue_choice_extension._cont = ASN1Dict([
        (u'id', __MeasuredResultsValue_choice_extension_id),
        (u'criticality', __MeasuredResultsValue_choice_extension_criticality),
        (u'value', __MeasuredResultsValue_choice_extension_value),
        ])
    _MeasuredResultsValue_choice_extension._ext = None
    MeasuredResultsValue._cont = ASN1Dict([
        (u'uL-AngleOfArrival', _MeasuredResultsValue_uL_AngleOfArrival),
        (u'uL-SRS-RSRP', _MeasuredResultsValue_uL_SRS_RSRP),
        (u'uL-RTOA', _MeasuredResultsValue_uL_RTOA),
        (u'gNB-RxTxTimeDiff', _MeasuredResultsValue_gNB_RxTxTimeDiff),
        (u'choice-extension', _MeasuredResultsValue_choice_extension),
        ])
    MeasuredResultsValue._ext = None
    
    #-----< MeasuredResultsValue-ExtIEs >-----#
    MeasuredResultsValue_ExtIEs = CLASS(name=u'MeasuredResultsValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    MeasuredResultsValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name=u'MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< NeedforGap >-----#
    NeedforGap = ENUM(name=u'NeedforGap', mode=MODE_TYPE)
    NeedforGap._cont = ASN1Dict([(u'true', 0)])
    NeedforGap._ext = []
    
    #-----< Neighbour-Cell-Information-Item >-----#
    Neighbour_Cell_Information_Item = SEQ(name=u'Neighbour-Cell-Information-Item', mode=MODE_TYPE)
    _Neighbour_Cell_Information_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig = SEQ(name=u'intendedTDD-DL-ULConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')), opt=True)
    _Neighbour_Cell_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbour_Cell_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbour_Cell_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbour_Cell_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Neighbour_Cell_Information_Item_iE_Extensions__item_._ext = None
    _Neighbour_Cell_Information_Item_iE_Extensions._cont = __Neighbour_Cell_Information_Item_iE_Extensions__item_
    _Neighbour_Cell_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbour_Cell_Information_Item._cont = ASN1Dict([
        (u'nRCGI', _Neighbour_Cell_Information_Item_nRCGI),
        (u'intendedTDD-DL-ULConfig', _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig),
        (u'iE-Extensions', _Neighbour_Cell_Information_Item_iE_Extensions),
        ])
    Neighbour_Cell_Information_Item._ext = None
    
    #-----< Neighbour-Cell-Information-ItemExtIEs >-----#
    Neighbour_Cell_Information_ItemExtIEs = CLASS(name=u'Neighbour-Cell-Information-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Neighbour_Cell_Information_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANAllocationAndRetentionPriority >-----#
    NGRANAllocationAndRetentionPriority = SEQ(name=u'NGRANAllocationAndRetentionPriority', mode=MODE_TYPE)
    _NGRANAllocationAndRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PriorityLevel')))
    _NGRANAllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionCapability')))
    _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionVulnerability')))
    _NGRANAllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _NGRANAllocationAndRetentionPriority_iE_Extensions._cont = __NGRANAllocationAndRetentionPriority_iE_Extensions__item_
    _NGRANAllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANAllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _NGRANAllocationAndRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _NGRANAllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _NGRANAllocationAndRetentionPriority_iE_Extensions),
        ])
    NGRANAllocationAndRetentionPriority._ext = None
    
    #-----< NGRANAllocationAndRetentionPriority-ExtIEs >-----#
    NGRANAllocationAndRetentionPriority_ExtIEs = CLASS(name=u'NGRANAllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NGRANAllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANHighAccuracyAccessPointPosition >-----#
    NGRANHighAccuracyAccessPointPosition = SEQ(name=u'NGRANHighAccuracyAccessPointPosition', mode=MODE_TYPE)
    _NGRANHighAccuracyAccessPointPosition_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64000, ub=1280000)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence = INT(name=u'horizontalConfidence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence = INT(name=u'verticalConfidence', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_id = u'id'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id),
        (u'criticality', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality),
        (u'extensionValue', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._ext = None
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._cont = __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANHighAccuracyAccessPointPosition._cont = ASN1Dict([
        (u'latitude', _NGRANHighAccuracyAccessPointPosition_latitude),
        (u'longitude', _NGRANHighAccuracyAccessPointPosition_longitude),
        (u'altitude', _NGRANHighAccuracyAccessPointPosition_altitude),
        (u'uncertaintySemi-major', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis),
        (u'horizontalConfidence', _NGRANHighAccuracyAccessPointPosition_horizontalConfidence),
        (u'uncertaintyAltitude', _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude),
        (u'verticalConfidence', _NGRANHighAccuracyAccessPointPosition_verticalConfidence),
        (u'iE-Extensions', _NGRANHighAccuracyAccessPointPosition_iE_Extensions),
        ])
    NGRANHighAccuracyAccessPointPosition._ext = None
    
    #-----< NGRANHighAccuracyAccessPointPosition-ExtIEs >-----#
    NGRANHighAccuracyAccessPointPosition_ExtIEs = CLASS(name=u'NGRANHighAccuracyAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NGRANHighAccuracyAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NID >-----#
    NID = BIT_STR(name=u'NID', mode=MODE_TYPE)
    NID._const_sz = ASN1Set(rv=[44], rr=[], ev=None, er=[])
    
    #-----< NR-CGI-List-For-Restart-Item >-----#
    NR_CGI_List_For_Restart_Item = SEQ(name=u'NR-CGI-List-For-Restart-Item', mode=MODE_TYPE)
    _NR_CGI_List_For_Restart_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _NR_CGI_List_For_Restart_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id),
        (u'criticality', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_._ext = None
    _NR_CGI_List_For_Restart_Item_iE_Extensions._cont = __NR_CGI_List_For_Restart_Item_iE_Extensions__item_
    _NR_CGI_List_For_Restart_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI_List_For_Restart_Item._cont = ASN1Dict([
        (u'nRCGI', _NR_CGI_List_For_Restart_Item_nRCGI),
        (u'iE-Extensions', _NR_CGI_List_For_Restart_Item_iE_Extensions),
        ])
    NR_CGI_List_For_Restart_Item._ext = []
    
    #-----< NR-CGI-List-For-Restart-ItemExtIEs >-----#
    NR_CGI_List_For_Restart_ItemExtIEs = CLASS(name=u'NR-CGI-List-For-Restart-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_CGI_List_For_Restart_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRSBeamInformation >-----#
    NR_PRSBeamInformation = SEQ(name=u'NR-PRSBeamInformation', mode=MODE_TYPE)
    _NR_PRSBeamInformation_nR_PRSBeamInformationList = SEQ_OF(name=u'nR-PRSBeamInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformationList')))
    _NR_PRSBeamInformation_lCStoGCSTranslationList = SEQ_OF(name=u'lCStoGCSTranslationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCStoGCSTranslationList')), opt=True)
    _NR_PRSBeamInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRSBeamInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_PRSBeamInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_PRSBeamInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__id_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_PRSBeamInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_PRSBeamInformation_iE_Extensions__item__id),
        (u'criticality', ___NR_PRSBeamInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue),
        ])
    __NR_PRSBeamInformation_iE_Extensions__item_._ext = None
    _NR_PRSBeamInformation_iE_Extensions._cont = __NR_PRSBeamInformation_iE_Extensions__item_
    _NR_PRSBeamInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRSBeamInformation._cont = ASN1Dict([
        (u'nR-PRSBeamInformationList', _NR_PRSBeamInformation_nR_PRSBeamInformationList),
        (u'lCStoGCSTranslationList', _NR_PRSBeamInformation_lCStoGCSTranslationList),
        (u'iE-Extensions', _NR_PRSBeamInformation_iE_Extensions),
        ])
    NR_PRSBeamInformation._ext = None
    
    #-----< NR-PRSBeamInformation-ExtIEs >-----#
    NR_PRSBeamInformation_ExtIEs = CLASS(name=u'NR-PRSBeamInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_PRSBeamInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRSBeamInformationList >-----#
    NR_PRSBeamInformationList = SEQ_OF(name=u'NR-PRSBeamInformationList', mode=MODE_TYPE)
    _NR_PRSBeamInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformationItem')))
    NR_PRSBeamInformationList._cont = _NR_PRSBeamInformationList__item_
    NR_PRSBeamInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< NR-PRSBeamInformationItem >-----#
    NR_PRSBeamInformationItem = SEQ(name=u'NR-PRSBeamInformationItem', mode=MODE_TYPE)
    _NR_PRSBeamInformationItem_pRSResourceSetID = INT(name=u'pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _NR_PRSBeamInformationItem_pRSAngleList = SEQ_OF(name=u'pRSAngleList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSAngleList')))
    _NR_PRSBeamInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRSBeamInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_PRSBeamInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_PRSBeamInformationItem_iE_Extensions__item__id),
        (u'criticality', ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue),
        ])
    __NR_PRSBeamInformationItem_iE_Extensions__item_._ext = None
    _NR_PRSBeamInformationItem_iE_Extensions._cont = __NR_PRSBeamInformationItem_iE_Extensions__item_
    _NR_PRSBeamInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRSBeamInformationItem._cont = ASN1Dict([
        (u'pRSResourceSetID', _NR_PRSBeamInformationItem_pRSResourceSetID),
        (u'pRSAngleList', _NR_PRSBeamInformationItem_pRSAngleList),
        (u'iE-Extensions', _NR_PRSBeamInformationItem_iE_Extensions),
        ])
    NR_PRSBeamInformationItem._ext = None
    
    #-----< NR-PRSBeamInformationItem-ExtIEs >-----#
    NR_PRSBeamInformationItem_ExtIEs = CLASS(name=u'NR-PRSBeamInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_PRSBeamInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NonDynamic5QIDescriptor >-----#
    NonDynamic5QIDescriptor = SEQ(name=u'NonDynamic5QIDescriptor', mode=MODE_TYPE)
    _NonDynamic5QIDescriptor_fiveQI = INT(name=u'fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonDynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _NonDynamic5QIDescriptor_qoSPriorityLevel = INT(name=u'qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NonDynamic5QIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _NonDynamic5QIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamic5QIDescriptor_maxDataBurstVolume = INT(name=u'maxDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _NonDynamic5QIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 362), (u'criticality', u'ignore'), (u'Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 369), (u'criticality', u'ignore'), (u'Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonDynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonDynamic5QIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamic5QIDescriptor_iE_Extensions._cont = __NonDynamic5QIDescriptor_iE_Extensions__item_
    _NonDynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamic5QIDescriptor._cont = ASN1Dict([
        (u'fiveQI', _NonDynamic5QIDescriptor_fiveQI),
        (u'qoSPriorityLevel', _NonDynamic5QIDescriptor_qoSPriorityLevel),
        (u'averagingWindow', _NonDynamic5QIDescriptor_averagingWindow),
        (u'maxDataBurstVolume', _NonDynamic5QIDescriptor_maxDataBurstVolume),
        (u'iE-Extensions', _NonDynamic5QIDescriptor_iE_Extensions),
        ])
    NonDynamic5QIDescriptor._ext = None
    
    #-----< NonDynamic5QIDescriptor-ExtIEs >-----#
    NonDynamic5QIDescriptor_ExtIEs = CLASS(name=u'NonDynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    NonDynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 362), (u'criticality', u'ignore'), (u'Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 369), (u'criticality', u'ignore'), (u'Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonDynamicPQIDescriptor >-----#
    NonDynamicPQIDescriptor = SEQ(name=u'NonDynamicPQIDescriptor', mode=MODE_TYPE)
    _NonDynamicPQIDescriptor_fiveQI = INT(name=u'fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonDynamicPQIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _NonDynamicPQIDescriptor_qoSPriorityLevel = INT(name=u'qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NonDynamicPQIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _NonDynamicPQIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamicPQIDescriptor_maxDataBurstVolume = INT(name=u'maxDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _NonDynamicPQIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamicPQIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonDynamicPQIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonDynamicPQIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamicPQIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamicPQIDescriptor_iE_Extensions._cont = __NonDynamicPQIDescriptor_iE_Extensions__item_
    _NonDynamicPQIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamicPQIDescriptor._cont = ASN1Dict([
        (u'fiveQI', _NonDynamicPQIDescriptor_fiveQI),
        (u'qoSPriorityLevel', _NonDynamicPQIDescriptor_qoSPriorityLevel),
        (u'averagingWindow', _NonDynamicPQIDescriptor_averagingWindow),
        (u'maxDataBurstVolume', _NonDynamicPQIDescriptor_maxDataBurstVolume),
        (u'iE-Extensions', _NonDynamicPQIDescriptor_iE_Extensions),
        ])
    NonDynamicPQIDescriptor._ext = None
    
    #-----< NonDynamicPQIDescriptor-ExtIEs >-----#
    NonDynamicPQIDescriptor_ExtIEs = CLASS(name=u'NonDynamicPQIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NonDynamicPQIDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NonUPTrafficType >-----#
    NonUPTrafficType = ENUM(name=u'NonUPTrafficType', mode=MODE_TYPE)
    NonUPTrafficType._cont = ASN1Dict([(u'ue-associated', 0), (u'non-ue-associated', 1), (u'non-f1', 2), (u'bap-control-pdu', 3)])
    NonUPTrafficType._ext = []
    
    #-----< NoofDownlinkSymbols >-----#
    NoofDownlinkSymbols = INT(name=u'NoofDownlinkSymbols', mode=MODE_TYPE)
    NoofDownlinkSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< NoofUplinkSymbols >-----#
    NoofUplinkSymbols = INT(name=u'NoofUplinkSymbols', mode=MODE_TYPE)
    NoofUplinkSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< Notification-Cause >-----#
    Notification_Cause = ENUM(name=u'Notification-Cause', mode=MODE_TYPE)
    Notification_Cause._cont = ASN1Dict([(u'fulfilled', 0), (u'not-fulfilled', 1)])
    Notification_Cause._ext = []
    
    #-----< NotificationControl >-----#
    NotificationControl = ENUM(name=u'NotificationControl', mode=MODE_TYPE)
    NotificationControl._cont = ASN1Dict([(u'active', 0), (u'not-active', 1)])
    NotificationControl._ext = []
    
    #-----< NotificationInformation >-----#
    NotificationInformation = SEQ(name=u'NotificationInformation', mode=MODE_TYPE)
    _NotificationInformation_message_Identifier = BIT_STR(name=u'message-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MessageIdentifier')))
    _NotificationInformation_serialNumber = BIT_STR(name=u'serialNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SerialNumber')))
    _NotificationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NotificationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NotificationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NotificationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__id._const_tab = ____NotificationInformation_iE_Extensions__item__id_tab
    ___NotificationInformation_iE_Extensions__item__id._const_tab_at = None
    ___NotificationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___NotificationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NotificationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab = ____NotificationInformation_iE_Extensions__item__criticality_tab
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NotificationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NotificationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab = ____NotificationInformation_iE_Extensions__item__extensionValue_tab
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NotificationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NotificationInformation_iE_Extensions__item__id),
        (u'criticality', ___NotificationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___NotificationInformation_iE_Extensions__item__extensionValue),
        ])
    __NotificationInformation_iE_Extensions__item_._ext = None
    _NotificationInformation_iE_Extensions._cont = __NotificationInformation_iE_Extensions__item_
    _NotificationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NotificationInformation._cont = ASN1Dict([
        (u'message-Identifier', _NotificationInformation_message_Identifier),
        (u'serialNumber', _NotificationInformation_serialNumber),
        (u'iE-Extensions', _NotificationInformation_iE_Extensions),
        ])
    NotificationInformation._ext = []
    
    #-----< NotificationInformationExtIEs >-----#
    NotificationInformationExtIEs = CLASS(name=u'NotificationInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NotificationInformationExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNBroadcastInformation >-----#
    NPNBroadcastInformation = CHOICE(name=u'NPNBroadcastInformation', mode=MODE_TYPE)
    _NPNBroadcastInformation_sNPN_Broadcast_Information = SEQ(name=u'sNPN-Broadcast-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NPN-Broadcast-Information-SNPN')))
    _NPNBroadcastInformation_pNI_NPN_Broadcast_Information = SEQ(name=u'pNI-NPN-Broadcast-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NPN-Broadcast-Information-PNI-NPN')))
    _NPNBroadcastInformation_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNBroadcastInformation_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___NPNBroadcastInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_id._const_tab = ___NPNBroadcastInformation_choice_extension_id_tab
    __NPNBroadcastInformation_choice_extension_id._const_tab_at = None
    __NPNBroadcastInformation_choice_extension_id._const_tab_id = u'id'
    __NPNBroadcastInformation_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___NPNBroadcastInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_criticality._const_tab = ___NPNBroadcastInformation_choice_extension_criticality_tab
    __NPNBroadcastInformation_choice_extension_criticality._const_tab_at = ('..', u'id')
    __NPNBroadcastInformation_choice_extension_criticality._const_tab_id = u'criticality'
    __NPNBroadcastInformation_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___NPNBroadcastInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_value._const_tab = ___NPNBroadcastInformation_choice_extension_value_tab
    __NPNBroadcastInformation_choice_extension_value._const_tab_at = ('..', u'id')
    __NPNBroadcastInformation_choice_extension_value._const_tab_id = u'Value'
    _NPNBroadcastInformation_choice_extension._cont = ASN1Dict([
        (u'id', __NPNBroadcastInformation_choice_extension_id),
        (u'criticality', __NPNBroadcastInformation_choice_extension_criticality),
        (u'value', __NPNBroadcastInformation_choice_extension_value),
        ])
    _NPNBroadcastInformation_choice_extension._ext = None
    NPNBroadcastInformation._cont = ASN1Dict([
        (u'sNPN-Broadcast-Information', _NPNBroadcastInformation_sNPN_Broadcast_Information),
        (u'pNI-NPN-Broadcast-Information', _NPNBroadcastInformation_pNI_NPN_Broadcast_Information),
        (u'choice-extension', _NPNBroadcastInformation_choice_extension),
        ])
    NPNBroadcastInformation._ext = None
    
    #-----< NPNBroadcastInformation-ExtIEs >-----#
    NPNBroadcastInformation_ExtIEs = CLASS(name=u'NPNBroadcastInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NPNBroadcastInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Broadcast-Information-SNPN >-----#
    NPN_Broadcast_Information_SNPN = SEQ(name=u'NPN-Broadcast-Information-SNPN', mode=MODE_TYPE)
    _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List = SEQ_OF(name=u'broadcastSNPNID-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastSNPN-ID-List')))
    _NPN_Broadcast_Information_SNPN_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab_at = None
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab_id = u'id'
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id),
        (u'criticality', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality),
        (u'extensionValue', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue),
        ])
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_._ext = None
    _NPN_Broadcast_Information_SNPN_iE_Extension._cont = __NPN_Broadcast_Information_SNPN_iE_Extension__item_
    _NPN_Broadcast_Information_SNPN_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPN_Broadcast_Information_SNPN._cont = ASN1Dict([
        (u'broadcastSNPNID-List', _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List),
        (u'iE-Extension', _NPN_Broadcast_Information_SNPN_iE_Extension),
        ])
    NPN_Broadcast_Information_SNPN._ext = []
    
    #-----< NPN-Broadcast-Information-SNPN-ExtIEs >-----#
    NPN_Broadcast_Information_SNPN_ExtIEs = CLASS(name=u'NPN-Broadcast-Information-SNPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NPN_Broadcast_Information_SNPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Broadcast-Information-PNI-NPN >-----#
    NPN_Broadcast_Information_PNI_NPN = SEQ(name=u'NPN-Broadcast-Information-PNI-NPN', mode=MODE_TYPE)
    _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information = SEQ_OF(name=u'broadcastPNI-NPN-ID-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastPNI-NPN-ID-List')))
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab_at = None
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab_id = u'id'
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id),
        (u'criticality', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality),
        (u'extensionValue', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue),
        ])
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_._ext = None
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension._cont = __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPN_Broadcast_Information_PNI_NPN._cont = ASN1Dict([
        (u'broadcastPNI-NPN-ID-Information', _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information),
        (u'iE-Extension', _NPN_Broadcast_Information_PNI_NPN_iE_Extension),
        ])
    NPN_Broadcast_Information_PNI_NPN._ext = []
    
    #-----< NPN-Broadcast-Information-PNI-NPN-ExtIEs >-----#
    NPN_Broadcast_Information_PNI_NPN_ExtIEs = CLASS(name=u'NPN-Broadcast-Information-PNI-NPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NPN_Broadcast_Information_PNI_NPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNSupportInfo >-----#
    NPNSupportInfo = CHOICE(name=u'NPNSupportInfo', mode=MODE_TYPE)
    _NPNSupportInfo_sNPN_Information = BIT_STR(name=u'sNPN-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _NPNSupportInfo_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNSupportInfo_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___NPNSupportInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_id._const_tab = ___NPNSupportInfo_choice_extension_id_tab
    __NPNSupportInfo_choice_extension_id._const_tab_at = None
    __NPNSupportInfo_choice_extension_id._const_tab_id = u'id'
    __NPNSupportInfo_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___NPNSupportInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_criticality._const_tab = ___NPNSupportInfo_choice_extension_criticality_tab
    __NPNSupportInfo_choice_extension_criticality._const_tab_at = ('..', u'id')
    __NPNSupportInfo_choice_extension_criticality._const_tab_id = u'criticality'
    __NPNSupportInfo_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___NPNSupportInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_value._const_tab = ___NPNSupportInfo_choice_extension_value_tab
    __NPNSupportInfo_choice_extension_value._const_tab_at = ('..', u'id')
    __NPNSupportInfo_choice_extension_value._const_tab_id = u'Value'
    _NPNSupportInfo_choice_extension._cont = ASN1Dict([
        (u'id', __NPNSupportInfo_choice_extension_id),
        (u'criticality', __NPNSupportInfo_choice_extension_criticality),
        (u'value', __NPNSupportInfo_choice_extension_value),
        ])
    _NPNSupportInfo_choice_extension._ext = None
    NPNSupportInfo._cont = ASN1Dict([
        (u'sNPN-Information', _NPNSupportInfo_sNPN_Information),
        (u'choice-extension', _NPNSupportInfo_choice_extension),
        ])
    NPNSupportInfo._ext = None
    
    #-----< NPNSupportInfo-ExtIEs >-----#
    NPNSupportInfo_ExtIEs = CLASS(name=u'NPNSupportInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NPNSupportInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCarrierList >-----#
    NRCarrierList = SEQ_OF(name=u'NRCarrierList', mode=MODE_TYPE)
    _NRCarrierList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierItem')))
    NRCarrierList._cont = _NRCarrierList__item_
    NRCarrierList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NRCarrierItem >-----#
    NRCarrierItem = SEQ(name=u'NRCarrierItem', mode=MODE_TYPE)
    _NRCarrierItem_carrierSCS = ENUM(name=u'carrierSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _NRCarrierItem_offsetToCarrier = INT(name=u'offsetToCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _NRCarrierItem_carrierBandwidth = INT(name=u'carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=275)], ev=[], er=[])
    _NRCarrierItem_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCarrierItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRCarrierItem_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRCarrierItem_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__id._const_tab = ____NRCarrierItem_iE_Extension__item__id_tab
    ___NRCarrierItem_iE_Extension__item__id._const_tab_at = None
    ___NRCarrierItem_iE_Extension__item__id._const_tab_id = u'id'
    ___NRCarrierItem_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRCarrierItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab = ____NRCarrierItem_iE_Extension__item__criticality_tab
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NRCarrierItem_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab = ____NRCarrierItem_iE_Extension__item__extensionValue_tab
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NRCarrierItem_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NRCarrierItem_iE_Extension__item__id),
        (u'criticality', ___NRCarrierItem_iE_Extension__item__criticality),
        (u'extensionValue', ___NRCarrierItem_iE_Extension__item__extensionValue),
        ])
    __NRCarrierItem_iE_Extension__item_._ext = None
    _NRCarrierItem_iE_Extension._cont = __NRCarrierItem_iE_Extension__item_
    _NRCarrierItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCarrierItem._cont = ASN1Dict([
        (u'carrierSCS', _NRCarrierItem_carrierSCS),
        (u'offsetToCarrier', _NRCarrierItem_offsetToCarrier),
        (u'carrierBandwidth', _NRCarrierItem_carrierBandwidth),
        (u'iE-Extension', _NRCarrierItem_iE_Extension),
        ])
    NRCarrierItem._ext = []
    
    #-----< NRCarrierItem-ExtIEs >-----#
    NRCarrierItem_ExtIEs = CLASS(name=u'NRCarrierItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRCarrierItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRFreqInfo >-----#
    NRFreqInfo = SEQ(name=u'NRFreqInfo', mode=MODE_TYPE)
    _NRFreqInfo_nRARFCN = INT(name=u'nRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRFreqInfo_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _NRFreqInfo_sul_Information = SEQ(name=u'sul-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SUL-Information')), opt=True)
    _NRFreqInfo_freqBandListNr = SEQ_OF(name=u'freqBandListNr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NRFreqInfo_freqBandListNr__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FreqBandNrItem')))
    _NRFreqInfo_freqBandListNr._cont = __NRFreqInfo_freqBandListNr__item_
    _NRFreqInfo_freqBandListNr._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _NRFreqInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFreqInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRFreqInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRFreqInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    ____NRFreqInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 356), (u'criticality', u'ignore'), (u'Extension', _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NRFreqInfo_iE_Extensions__item__id._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_at = None
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRFreqInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRFreqInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRFreqInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRFreqInfo_iE_Extensions__item__id),
        (u'criticality', ___NRFreqInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRFreqInfo_iE_Extensions__item__extensionValue),
        ])
    __NRFreqInfo_iE_Extensions__item_._ext = None
    _NRFreqInfo_iE_Extensions._cont = __NRFreqInfo_iE_Extensions__item_
    _NRFreqInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFreqInfo._cont = ASN1Dict([
        (u'nRARFCN', _NRFreqInfo_nRARFCN),
        (u'sul-Information', _NRFreqInfo_sul_Information),
        (u'freqBandListNr', _NRFreqInfo_freqBandListNr),
        (u'iE-Extensions', _NRFreqInfo_iE_Extensions),
        ])
    NRFreqInfo._ext = []
    
    #-----< NRFreqInfoExtIEs >-----#
    NRFreqInfoExtIEs = CLASS(name=u'NRFreqInfoExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _NRFreqInfoExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    NRFreqInfoExtIEs._val = ASN1Set(rv=[dict([(u'id', 356), (u'criticality', u'ignore'), (u'Extension', _NRFreqInfoExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NRCGI >-----#
    NRCGI = SEQ(name=u'NRCGI', mode=MODE_TYPE)
    _NRCGI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _NRCGI_nRCellIdentity = BIT_STR(name=u'nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _NRCGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRCGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRCGI_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__id._const_tab = ____NRCGI_iE_Extensions__item__id_tab
    ___NRCGI_iE_Extensions__item__id._const_tab_at = None
    ___NRCGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRCGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRCGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__criticality._const_tab = ____NRCGI_iE_Extensions__item__criticality_tab
    ___NRCGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRCGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRCGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRCGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab = ____NRCGI_iE_Extensions__item__extensionValue_tab
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRCGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRCGI_iE_Extensions__item__id),
        (u'criticality', ___NRCGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRCGI_iE_Extensions__item__extensionValue),
        ])
    __NRCGI_iE_Extensions__item_._ext = None
    _NRCGI_iE_Extensions._cont = __NRCGI_iE_Extensions__item_
    _NRCGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCGI._cont = ASN1Dict([
        (u'pLMN-Identity', _NRCGI_pLMN_Identity),
        (u'nRCellIdentity', _NRCGI_nRCellIdentity),
        (u'iE-Extensions', _NRCGI_iE_Extensions),
        ])
    NRCGI._ext = []
    
    #-----< NRCGI-ExtIEs >-----#
    NRCGI_ExtIEs = CLASS(name=u'NRCGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRCGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-Mode-Info >-----#
    NR_Mode_Info = CHOICE(name=u'NR-Mode-Info', mode=MODE_TYPE)
    _NR_Mode_Info_fDD = SEQ(name=u'fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FDD-Info')))
    _NR_Mode_Info_tDD = SEQ(name=u'tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TDD-Info')))
    _NR_Mode_Info_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NR_Mode_Info_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___NR_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_Mode_Info_choice_extension_id._const_tab = ___NR_Mode_Info_choice_extension_id_tab
    __NR_Mode_Info_choice_extension_id._const_tab_at = None
    __NR_Mode_Info_choice_extension_id._const_tab_id = u'id'
    __NR_Mode_Info_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___NR_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_Mode_Info_choice_extension_criticality._const_tab = ___NR_Mode_Info_choice_extension_criticality_tab
    __NR_Mode_Info_choice_extension_criticality._const_tab_at = ('..', u'id')
    __NR_Mode_Info_choice_extension_criticality._const_tab_id = u'criticality'
    __NR_Mode_Info_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___NR_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_Mode_Info_choice_extension_value._const_tab = ___NR_Mode_Info_choice_extension_value_tab
    __NR_Mode_Info_choice_extension_value._const_tab_at = ('..', u'id')
    __NR_Mode_Info_choice_extension_value._const_tab_id = u'Value'
    _NR_Mode_Info_choice_extension._cont = ASN1Dict([
        (u'id', __NR_Mode_Info_choice_extension_id),
        (u'criticality', __NR_Mode_Info_choice_extension_criticality),
        (u'value', __NR_Mode_Info_choice_extension_value),
        ])
    _NR_Mode_Info_choice_extension._ext = None
    NR_Mode_Info._cont = ASN1Dict([
        (u'fDD', _NR_Mode_Info_fDD),
        (u'tDD', _NR_Mode_Info_tDD),
        (u'choice-extension', _NR_Mode_Info_choice_extension),
        ])
    NR_Mode_Info._ext = None
    
    #-----< NR-Mode-Info-ExtIEs >-----#
    NR_Mode_Info_ExtIEs = CLASS(name=u'NR-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NR_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRPRACHConfig >-----#
    NRPRACHConfig = SEQ(name=u'NRPRACHConfig', mode=MODE_TYPE)
    _NRPRACHConfig_ulPRACHConfigList = SEQ_OF(name=u'ulPRACHConfigList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigList')), opt=True)
    _NRPRACHConfig_sulPRACHConfigList = SEQ_OF(name=u'sulPRACHConfigList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigList')), opt=True)
    _NRPRACHConfig_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPRACHConfig_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPRACHConfig_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRPRACHConfig_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__id._const_tab = ____NRPRACHConfig_iE_Extension__item__id_tab
    ___NRPRACHConfig_iE_Extension__item__id._const_tab_at = None
    ___NRPRACHConfig_iE_Extension__item__id._const_tab_id = u'id'
    ___NRPRACHConfig_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRPRACHConfig_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab = ____NRPRACHConfig_iE_Extension__item__criticality_tab
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NRPRACHConfig_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRPRACHConfig_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab = ____NRPRACHConfig_iE_Extension__item__extensionValue_tab
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NRPRACHConfig_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NRPRACHConfig_iE_Extension__item__id),
        (u'criticality', ___NRPRACHConfig_iE_Extension__item__criticality),
        (u'extensionValue', ___NRPRACHConfig_iE_Extension__item__extensionValue),
        ])
    __NRPRACHConfig_iE_Extension__item_._ext = None
    _NRPRACHConfig_iE_Extension._cont = __NRPRACHConfig_iE_Extension__item_
    _NRPRACHConfig_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPRACHConfig._cont = ASN1Dict([
        (u'ulPRACHConfigList', _NRPRACHConfig_ulPRACHConfigList),
        (u'sulPRACHConfigList', _NRPRACHConfig_sulPRACHConfigList),
        (u'iE-Extension', _NRPRACHConfig_iE_Extension),
        ])
    NRPRACHConfig._ext = []
    
    #-----< NRPRACHConfig-ExtIEs >-----#
    NRPRACHConfig_ExtIEs = CLASS(name=u'NRPRACHConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPRACHConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name=u'NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NRNRB >-----#
    NRNRB = ENUM(name=u'NRNRB', mode=MODE_TYPE)
    NRNRB._cont = ASN1Dict([(u'nrb11', 0), (u'nrb18', 1), (u'nrb24', 2), (u'nrb25', 3), (u'nrb31', 4), (u'nrb32', 5), (u'nrb38', 6), (u'nrb51', 7), (u'nrb52', 8), (u'nrb65', 9), (u'nrb66', 10), (u'nrb78', 11), (u'nrb79', 12), (u'nrb93', 13), (u'nrb106', 14), (u'nrb107', 15), (u'nrb121', 16), (u'nrb132', 17), (u'nrb133', 18), (u'nrb135', 19), (u'nrb160', 20), (u'nrb162', 21), (u'nrb189', 22), (u'nrb216', 23), (u'nrb217', 24), (u'nrb245', 25), (u'nrb264', 26), (u'nrb270', 27), (u'nrb273', 28)])
    NRNRB._ext = []
    
    #-----< NRPCI >-----#
    NRPCI = INT(name=u'NRPCI', mode=MODE_TYPE)
    NRPCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    
    #-----< NRPRACHConfigList >-----#
    NRPRACHConfigList = SEQ_OF(name=u'NRPRACHConfigList', mode=MODE_TYPE)
    _NRPRACHConfigList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigItem')))
    NRPRACHConfigList._cont = _NRPRACHConfigList__item_
    NRPRACHConfigList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< NRPRACHConfigItem >-----#
    NRPRACHConfigItem = SEQ(name=u'NRPRACHConfigItem', mode=MODE_TYPE)
    _NRPRACHConfigItem_nRSCS = ENUM(name=u'nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _NRPRACHConfigItem_prachFreqStartfromCarrier = INT(name=u'prachFreqStartfromCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_prachFreqStartfromCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=274)], ev=[], er=[])
    _NRPRACHConfigItem_msg1FDM = ENUM(name=u'msg1FDM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_msg1FDM._cont = ASN1Dict([(u'one', 0), (u'two', 1), (u'four', 2), (u'eight', 3)])
    _NRPRACHConfigItem_msg1FDM._ext = []
    _NRPRACHConfigItem_parchConfigIndex = INT(name=u'parchConfigIndex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_parchConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[ASN1RangeInt(lb=256, ub=262)])
    _NRPRACHConfigItem_ssb_perRACH_Occasion = ENUM(name=u'ssb-perRACH-Occasion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_ssb_perRACH_Occasion._cont = ASN1Dict([(u'oneEighth', 0), (u'oneFourth', 1), (u'oneHalf', 2), (u'one', 3), (u'two', 4), (u'four', 5), (u'eight', 6), (u'sixteen', 7)])
    _NRPRACHConfigItem_ssb_perRACH_Occasion._ext = []
    _NRPRACHConfigItem_freqDomainLength = CHOICE(name=u'freqDomainLength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqDomainLength')))
    _NRPRACHConfigItem_zeroCorrelZoneConfig = INT(name=u'zeroCorrelZoneConfig', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_zeroCorrelZoneConfig._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _NRPRACHConfigItem_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPRACHConfigItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPRACHConfigItem_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRPRACHConfigItem_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab = ____NRPRACHConfigItem_iE_Extension__item__id_tab
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab_at = None
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab_id = u'id'
    ___NRPRACHConfigItem_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRPRACHConfigItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab = ____NRPRACHConfigItem_iE_Extension__item__criticality_tab
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab = ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NRPRACHConfigItem_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NRPRACHConfigItem_iE_Extension__item__id),
        (u'criticality', ___NRPRACHConfigItem_iE_Extension__item__criticality),
        (u'extensionValue', ___NRPRACHConfigItem_iE_Extension__item__extensionValue),
        ])
    __NRPRACHConfigItem_iE_Extension__item_._ext = None
    _NRPRACHConfigItem_iE_Extension._cont = __NRPRACHConfigItem_iE_Extension__item_
    _NRPRACHConfigItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPRACHConfigItem._cont = ASN1Dict([
        (u'nRSCS', _NRPRACHConfigItem_nRSCS),
        (u'prachFreqStartfromCarrier', _NRPRACHConfigItem_prachFreqStartfromCarrier),
        (u'msg1FDM', _NRPRACHConfigItem_msg1FDM),
        (u'parchConfigIndex', _NRPRACHConfigItem_parchConfigIndex),
        (u'ssb-perRACH-Occasion', _NRPRACHConfigItem_ssb_perRACH_Occasion),
        (u'freqDomainLength', _NRPRACHConfigItem_freqDomainLength),
        (u'zeroCorrelZoneConfig', _NRPRACHConfigItem_zeroCorrelZoneConfig),
        (u'iE-Extension', _NRPRACHConfigItem_iE_Extension),
        ])
    NRPRACHConfigItem._ext = []
    
    #-----< NRPRACHConfigItem-ExtIEs >-----#
    NRPRACHConfigItem_ExtIEs = CLASS(name=u'NRPRACHConfigItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPRACHConfigItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRSCS >-----#
    NRSCS = ENUM(name=u'NRSCS', mode=MODE_TYPE)
    NRSCS._cont = ASN1Dict([(u'scs15', 0), (u'scs30', 1), (u'scs60', 2), (u'scs120', 3)])
    NRSCS._ext = []
    
    #-----< NRUERLFReportContainer >-----#
    NRUERLFReportContainer = OCT_STR(name=u'NRUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< NumberofActiveUEs >-----#
    NumberofActiveUEs = INT(name=u'NumberofActiveUEs', mode=MODE_TYPE)
    NumberofActiveUEs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[])
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name=u'NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberofBroadcastRequest >-----#
    NumberofBroadcastRequest = INT(name=u'NumberofBroadcastRequest', mode=MODE_TYPE)
    NumberofBroadcastRequest._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumDLULSymbols >-----#
    NumDLULSymbols = SEQ(name=u'NumDLULSymbols', mode=MODE_TYPE)
    _NumDLULSymbols_numDLSymbols = INT(name=u'numDLSymbols', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NumDLULSymbols_numDLSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=[], er=[])
    _NumDLULSymbols_numULSymbols = INT(name=u'numULSymbols', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NumDLULSymbols_numULSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=[], er=[])
    _NumDLULSymbols_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NumDLULSymbols_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NumDLULSymbols_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NumDLULSymbols_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NumDLULSymbols_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab = ____NumDLULSymbols_iE_Extensions__item__id_tab
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab_at = None
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab_id = u'id'
    ___NumDLULSymbols_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NumDLULSymbols_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NumDLULSymbols_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab = ____NumDLULSymbols_iE_Extensions__item__criticality_tab
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NumDLULSymbols_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NumDLULSymbols_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NumDLULSymbols_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab = ____NumDLULSymbols_iE_Extensions__item__extensionValue_tab
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NumDLULSymbols_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NumDLULSymbols_iE_Extensions__item__id),
        (u'criticality', ___NumDLULSymbols_iE_Extensions__item__criticality),
        (u'extensionValue', ___NumDLULSymbols_iE_Extensions__item__extensionValue),
        ])
    __NumDLULSymbols_iE_Extensions__item_._ext = None
    _NumDLULSymbols_iE_Extensions._cont = __NumDLULSymbols_iE_Extensions__item_
    _NumDLULSymbols_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NumDLULSymbols._cont = ASN1Dict([
        (u'numDLSymbols', _NumDLULSymbols_numDLSymbols),
        (u'numULSymbols', _NumDLULSymbols_numULSymbols),
        (u'iE-Extensions', _NumDLULSymbols_iE_Extensions),
        ])
    NumDLULSymbols._ext = None
    
    #-----< NumDLULSymbols-ExtIEs >-----#
    NumDLULSymbols_ExtIEs = CLASS(name=u'NumDLULSymbols-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NumDLULSymbols_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name=u'NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = None
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name=u'NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name=u'NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate = INT(name=u'uENRSidelinkAggregateMaximumBitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uENRSidelinkAggregateMaximumBitrate', _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate),
        (u'iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = None
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name=u'NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NZP-CSI-RS-ResourceID >-----#
    NZP_CSI_RS_ResourceID = INT(name=u'NZP-CSI-RS-ResourceID', mode=MODE_TYPE)
    NZP_CSI_RS_ResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=191)], ev=None, er=[])
    
    #-----< OffsetToPointA >-----#
    OffsetToPointA = INT(name=u'OffsetToPointA', mode=MODE_TYPE)
    OffsetToPointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    
    #-----< PacketDelayBudget >-----#
    PacketDelayBudget = INT(name=u'PacketDelayBudget', mode=MODE_TYPE)
    PacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< PacketErrorRate >-----#
    PacketErrorRate = SEQ(name=u'PacketErrorRate', mode=MODE_TYPE)
    _PacketErrorRate_pER_Scalar = INT(name=u'pER-Scalar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PER-Scalar')))
    _PacketErrorRate_pER_Exponent = INT(name=u'pER-Exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PER-Exponent')))
    _PacketErrorRate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PacketErrorRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PacketErrorRate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PacketErrorRate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__id._const_tab = ____PacketErrorRate_iE_Extensions__item__id_tab
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_at = None
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_id = u'id'
    ___PacketErrorRate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab = ____PacketErrorRate_iE_Extensions__item__criticality_tab
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PacketErrorRate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab = ____PacketErrorRate_iE_Extensions__item__extensionValue_tab
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PacketErrorRate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PacketErrorRate_iE_Extensions__item__id),
        (u'criticality', ___PacketErrorRate_iE_Extensions__item__criticality),
        (u'extensionValue', ___PacketErrorRate_iE_Extensions__item__extensionValue),
        ])
    __PacketErrorRate_iE_Extensions__item_._ext = None
    _PacketErrorRate_iE_Extensions._cont = __PacketErrorRate_iE_Extensions__item_
    _PacketErrorRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PacketErrorRate._cont = ASN1Dict([
        (u'pER-Scalar', _PacketErrorRate_pER_Scalar),
        (u'pER-Exponent', _PacketErrorRate_pER_Exponent),
        (u'iE-Extensions', _PacketErrorRate_iE_Extensions),
        ])
    PacketErrorRate._ext = []
    
    #-----< PacketErrorRate-ExtIEs >-----#
    PacketErrorRate_ExtIEs = CLASS(name=u'PacketErrorRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PacketErrorRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PER-Scalar >-----#
    PER_Scalar = INT(name=u'PER-Scalar', mode=MODE_TYPE)
    PER_Scalar._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PER-Exponent >-----#
    PER_Exponent = INT(name=u'PER-Exponent', mode=MODE_TYPE)
    PER_Exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PagingCell-Item >-----#
    PagingCell_Item = SEQ(name=u'PagingCell-Item', mode=MODE_TYPE)
    _PagingCell_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _PagingCell_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PagingCell_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PagingCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingCell_Item_iE_Extensions__item__id._const_tab = ____PagingCell_Item_iE_Extensions__item__id_tab
    ___PagingCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___PagingCell_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PagingCell_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PagingCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PagingCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab = ____PagingCell_Item_iE_Extensions__item__criticality_tab
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PagingCell_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PagingCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PagingCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab = ____PagingCell_Item_iE_Extensions__item__extensionValue_tab
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PagingCell_Item_iE_Extensions__item__id),
        (u'criticality', ___PagingCell_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PagingCell_Item_iE_Extensions__item__extensionValue),
        ])
    __PagingCell_Item_iE_Extensions__item_._ext = None
    _PagingCell_Item_iE_Extensions._cont = __PagingCell_Item_iE_Extensions__item_
    _PagingCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingCell_Item._cont = ASN1Dict([
        (u'nRCGI', _PagingCell_Item_nRCGI),
        (u'iE-Extensions', _PagingCell_Item_iE_Extensions),
        ])
    PagingCell_Item._ext = None
    
    #-----< PagingCell-ItemExtIEs >-----#
    PagingCell_ItemExtIEs = CLASS(name=u'PagingCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PagingCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name=u'PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([(u'v32', 0), (u'v64', 1), (u'v128', 2), (u'v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingIdentity >-----#
    PagingIdentity = CHOICE(name=u'PagingIdentity', mode=MODE_TYPE)
    _PagingIdentity_rANUEPagingIdentity = SEQ(name=u'rANUEPagingIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RANUEPagingIdentity')))
    _PagingIdentity_cNUEPagingIdentity = CHOICE(name=u'cNUEPagingIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CNUEPagingIdentity')))
    _PagingIdentity_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PagingIdentity_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PagingIdentity_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_id._const_tab = ___PagingIdentity_choice_extension_id_tab
    __PagingIdentity_choice_extension_id._const_tab_at = None
    __PagingIdentity_choice_extension_id._const_tab_id = u'id'
    __PagingIdentity_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PagingIdentity_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_criticality._const_tab = ___PagingIdentity_choice_extension_criticality_tab
    __PagingIdentity_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PagingIdentity_choice_extension_criticality._const_tab_id = u'criticality'
    __PagingIdentity_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PagingIdentity_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_value._const_tab = ___PagingIdentity_choice_extension_value_tab
    __PagingIdentity_choice_extension_value._const_tab_at = ('..', u'id')
    __PagingIdentity_choice_extension_value._const_tab_id = u'Value'
    _PagingIdentity_choice_extension._cont = ASN1Dict([
        (u'id', __PagingIdentity_choice_extension_id),
        (u'criticality', __PagingIdentity_choice_extension_criticality),
        (u'value', __PagingIdentity_choice_extension_value),
        ])
    _PagingIdentity_choice_extension._ext = None
    PagingIdentity._cont = ASN1Dict([
        (u'rANUEPagingIdentity', _PagingIdentity_rANUEPagingIdentity),
        (u'cNUEPagingIdentity', _PagingIdentity_cNUEPagingIdentity),
        (u'choice-extension', _PagingIdentity_choice_extension),
        ])
    PagingIdentity._ext = None
    
    #-----< PagingIdentity-ExtIEs >-----#
    PagingIdentity_ExtIEs = CLASS(name=u'PagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingOrigin >-----#
    PagingOrigin = ENUM(name=u'PagingOrigin', mode=MODE_TYPE)
    PagingOrigin._cont = ASN1Dict([(u'non-3gpp', 0)])
    PagingOrigin._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name=u'PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([(u'priolevel1', 0), (u'priolevel2', 1), (u'priolevel3', 2), (u'priolevel4', 3), (u'priolevel5', 4), (u'priolevel6', 5), (u'priolevel7', 6), (u'priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< RelativePathDelay >-----#
    RelativePathDelay = CHOICE(name=u'RelativePathDelay', mode=MODE_TYPE)
    _RelativePathDelay_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16351)], ev=None, er=[])
    _RelativePathDelay_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8176)], ev=None, er=[])
    _RelativePathDelay_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4088)], ev=None, er=[])
    _RelativePathDelay_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2044)], ev=None, er=[])
    _RelativePathDelay_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _RelativePathDelay_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _RelativePathDelay_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RelativePathDelay_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___RelativePathDelay_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_id._const_tab = ___RelativePathDelay_choice_extension_id_tab
    __RelativePathDelay_choice_extension_id._const_tab_at = None
    __RelativePathDelay_choice_extension_id._const_tab_id = u'id'
    __RelativePathDelay_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___RelativePathDelay_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_criticality._const_tab = ___RelativePathDelay_choice_extension_criticality_tab
    __RelativePathDelay_choice_extension_criticality._const_tab_at = ('..', u'id')
    __RelativePathDelay_choice_extension_criticality._const_tab_id = u'criticality'
    __RelativePathDelay_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___RelativePathDelay_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_value._const_tab = ___RelativePathDelay_choice_extension_value_tab
    __RelativePathDelay_choice_extension_value._const_tab_at = ('..', u'id')
    __RelativePathDelay_choice_extension_value._const_tab_id = u'Value'
    _RelativePathDelay_choice_extension._cont = ASN1Dict([
        (u'id', __RelativePathDelay_choice_extension_id),
        (u'criticality', __RelativePathDelay_choice_extension_criticality),
        (u'value', __RelativePathDelay_choice_extension_value),
        ])
    _RelativePathDelay_choice_extension._ext = None
    RelativePathDelay._cont = ASN1Dict([
        (u'k0', _RelativePathDelay_k0),
        (u'k1', _RelativePathDelay_k1),
        (u'k2', _RelativePathDelay_k2),
        (u'k3', _RelativePathDelay_k3),
        (u'k4', _RelativePathDelay_k4),
        (u'k5', _RelativePathDelay_k5),
        (u'choice-extension', _RelativePathDelay_choice_extension),
        ])
    RelativePathDelay._ext = None
    
    #-----< RelativePathDelay-ExtIEs >-----#
    RelativePathDelay_ExtIEs = CLASS(name=u'RelativePathDelay-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    RelativePathDelay_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceInfo >-----#
    PathlossReferenceInfo = SEQ(name=u'PathlossReferenceInfo', mode=MODE_TYPE)
    _PathlossReferenceInfo_pathlossReferenceSignal = CHOICE(name=u'pathlossReferenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PathlossReferenceSignal')))
    _PathlossReferenceInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathlossReferenceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PathlossReferenceInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PathlossReferenceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__id_tab
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab_at = None
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathlossReferenceInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathlossReferenceInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathlossReferenceInfo_iE_Extensions__item__id),
        (u'criticality', ___PathlossReferenceInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathlossReferenceInfo_iE_Extensions__item__extensionValue),
        ])
    __PathlossReferenceInfo_iE_Extensions__item_._ext = None
    _PathlossReferenceInfo_iE_Extensions._cont = __PathlossReferenceInfo_iE_Extensions__item_
    _PathlossReferenceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathlossReferenceInfo._cont = ASN1Dict([
        (u'pathlossReferenceSignal', _PathlossReferenceInfo_pathlossReferenceSignal),
        (u'iE-Extensions', _PathlossReferenceInfo_iE_Extensions),
        ])
    PathlossReferenceInfo._ext = None
    
    #-----< PathlossReferenceInfo-ExtIEs >-----#
    PathlossReferenceInfo_ExtIEs = CLASS(name=u'PathlossReferenceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PathlossReferenceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceSignal >-----#
    PathlossReferenceSignal = CHOICE(name=u'PathlossReferenceSignal', mode=MODE_TYPE)
    _PathlossReferenceSignal_sSB = SEQ(name=u'sSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _PathlossReferenceSignal_dL_PRS = SEQ(name=u'dL-PRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRS')))
    _PathlossReferenceSignal_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PathlossReferenceSignal_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PathlossReferenceSignal_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_id._const_tab = ___PathlossReferenceSignal_choice_extension_id_tab
    __PathlossReferenceSignal_choice_extension_id._const_tab_at = None
    __PathlossReferenceSignal_choice_extension_id._const_tab_id = u'id'
    __PathlossReferenceSignal_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PathlossReferenceSignal_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_criticality._const_tab = ___PathlossReferenceSignal_choice_extension_criticality_tab
    __PathlossReferenceSignal_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PathlossReferenceSignal_choice_extension_criticality._const_tab_id = u'criticality'
    __PathlossReferenceSignal_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PathlossReferenceSignal_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_value._const_tab = ___PathlossReferenceSignal_choice_extension_value_tab
    __PathlossReferenceSignal_choice_extension_value._const_tab_at = ('..', u'id')
    __PathlossReferenceSignal_choice_extension_value._const_tab_id = u'Value'
    _PathlossReferenceSignal_choice_extension._cont = ASN1Dict([
        (u'id', __PathlossReferenceSignal_choice_extension_id),
        (u'criticality', __PathlossReferenceSignal_choice_extension_criticality),
        (u'value', __PathlossReferenceSignal_choice_extension_value),
        ])
    _PathlossReferenceSignal_choice_extension._ext = None
    PathlossReferenceSignal._cont = ASN1Dict([
        (u'sSB', _PathlossReferenceSignal_sSB),
        (u'dL-PRS', _PathlossReferenceSignal_dL_PRS),
        (u'choice-extension', _PathlossReferenceSignal_choice_extension),
        ])
    PathlossReferenceSignal._ext = None
    
    #-----< PathlossReferenceSignal-ExtIEs >-----#
    PathlossReferenceSignal_ExtIEs = CLASS(name=u'PathlossReferenceSignal-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PathlossReferenceSignal_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowIdentifier >-----#
    PC5QoSFlowIdentifier = INT(name=u'PC5QoSFlowIdentifier', mode=MODE_TYPE)
    PC5QoSFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5-QoS-Characteristics >-----#
    PC5_QoS_Characteristics = CHOICE(name=u'PC5-QoS-Characteristics', mode=MODE_TYPE)
    _PC5_QoS_Characteristics_non_Dynamic_PQI = SEQ(name=u'non-Dynamic-PQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonDynamicPQIDescriptor')))
    _PC5_QoS_Characteristics_dynamic_PQI = SEQ(name=u'dynamic-PQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DynamicPQIDescriptor')))
    _PC5_QoS_Characteristics_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PC5_QoS_Characteristics_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PC5_QoS_Characteristics_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_id._const_tab = ___PC5_QoS_Characteristics_choice_extension_id_tab
    __PC5_QoS_Characteristics_choice_extension_id._const_tab_at = None
    __PC5_QoS_Characteristics_choice_extension_id._const_tab_id = u'id'
    __PC5_QoS_Characteristics_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PC5_QoS_Characteristics_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab = ___PC5_QoS_Characteristics_choice_extension_criticality_tab
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab_id = u'criticality'
    __PC5_QoS_Characteristics_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PC5_QoS_Characteristics_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_value._const_tab = ___PC5_QoS_Characteristics_choice_extension_value_tab
    __PC5_QoS_Characteristics_choice_extension_value._const_tab_at = ('..', u'id')
    __PC5_QoS_Characteristics_choice_extension_value._const_tab_id = u'Value'
    _PC5_QoS_Characteristics_choice_extension._cont = ASN1Dict([
        (u'id', __PC5_QoS_Characteristics_choice_extension_id),
        (u'criticality', __PC5_QoS_Characteristics_choice_extension_criticality),
        (u'value', __PC5_QoS_Characteristics_choice_extension_value),
        ])
    _PC5_QoS_Characteristics_choice_extension._ext = None
    PC5_QoS_Characteristics._cont = ASN1Dict([
        (u'non-Dynamic-PQI', _PC5_QoS_Characteristics_non_Dynamic_PQI),
        (u'dynamic-PQI', _PC5_QoS_Characteristics_dynamic_PQI),
        (u'choice-extension', _PC5_QoS_Characteristics_choice_extension),
        ])
    PC5_QoS_Characteristics._ext = None
    
    #-----< PC5-QoS-Characteristics-ExtIEs >-----#
    PC5_QoS_Characteristics_ExtIEs = CLASS(name=u'PC5-QoS-Characteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PC5_QoS_Characteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name=u'PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pC5_QoS_Characteristics = CHOICE(name=u'pC5-QoS-Characteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5-QoS-Characteristics')))
    _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates = SEQ(name=u'pC5-QoS-Flow-Bit-Rates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5QoSParameters_iE_Extensions__item__id),
        (u'criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        (u'pC5-QoS-Characteristics', _PC5QoSParameters_pC5_QoS_Characteristics),
        (u'pC5-QoS-Flow-Bit-Rates', _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates),
        (u'iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name=u'PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name=u'PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name=u'guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name=u'maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5FlowBitRates_iE_Extensions__item__id),
        (u'criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        (u'guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        (u'maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        (u'iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name=u'PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCCH-BlindDetectionSCG >-----#
    PDCCH_BlindDetectionSCG = OCT_STR(name=u'PDCCH-BlindDetectionSCG', mode=MODE_TYPE)
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name=u'PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCPSNLength >-----#
    PDCPSNLength = ENUM(name=u'PDCPSNLength', mode=MODE_TYPE)
    PDCPSNLength._cont = ASN1Dict([(u'twelve-bits', 0), (u'eighteen-bits', 1)])
    PDCPSNLength._ext = []
    
    #-----< PDUSessionID >-----#
    PDUSessionID = INT(name=u'PDUSessionID', mode=MODE_TYPE)
    PDUSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ReportingPeriodicityValue >-----#
    ReportingPeriodicityValue = INT(name=u'ReportingPeriodicityValue', mode=MODE_TYPE)
    ReportingPeriodicityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=[], er=[])
    
    #-----< Periodicity >-----#
    Periodicity = INT(name=u'Periodicity', mode=MODE_TYPE)
    Periodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=640000)], ev=[], er=[])
    
    #-----< PeriodicitySRS >-----#
    PeriodicitySRS = ENUM(name=u'PeriodicitySRS', mode=MODE_TYPE)
    PeriodicitySRS._cont = ASN1Dict([(u'ms0p125', 0), (u'ms0p25', 1), (u'ms0p5', 2), (u'ms0p625', 3), (u'ms1', 4), (u'ms1p25', 5), (u'ms2', 6), (u'ms2p5', 7), (u'ms4', 8), (u'ms5', 9), (u'ms8', 10), (u'ms10', 11), (u'ms16', 12), (u'ms20', 13), (u'ms32', 14), (u'ms40', 15), (u'ms64', 16), (u'ms80', 17), (u'ms160', 18), (u'ms320', 19), (u'ms640', 20), (u'ms1280', 21), (u'ms2560', 22), (u'ms5120', 23), (u'ms10240', 24)])
    PeriodicitySRS._ext = []
    
    #-----< PeriodicityList >-----#
    PeriodicityList = SEQ_OF(name=u'PeriodicityList', mode=MODE_TYPE)
    _PeriodicityList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PeriodicityList-Item')))
    PeriodicityList._cont = _PeriodicityList__item_
    PeriodicityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodicityList-Item >-----#
    PeriodicityList_Item = SEQ(name=u'PeriodicityList-Item', mode=MODE_TYPE)
    _PeriodicityList_Item_periodicitySRS = ENUM(name=u'periodicitySRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PeriodicitySRS')))
    _PeriodicityList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicityList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PeriodicityList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PeriodicityList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab = ____PeriodicityList_Item_iE_Extensions__item__id_tab
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PeriodicityList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PeriodicityList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab = ____PeriodicityList_Item_iE_Extensions__item__criticality_tab
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab = ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PeriodicityList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PeriodicityList_Item_iE_Extensions__item__id),
        (u'criticality', ___PeriodicityList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PeriodicityList_Item_iE_Extensions__item__extensionValue),
        ])
    __PeriodicityList_Item_iE_Extensions__item_._ext = None
    _PeriodicityList_Item_iE_Extensions._cont = __PeriodicityList_Item_iE_Extensions__item_
    _PeriodicityList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicityList_Item._cont = ASN1Dict([
        (u'periodicitySRS', _PeriodicityList_Item_periodicitySRS),
        (u'iE-Extensions', _PeriodicityList_Item_iE_Extensions),
        ])
    PeriodicityList_Item._ext = None
    
    #-----< PeriodicityList-ItemExtIEs >-----#
    PeriodicityList_ItemExtIEs = CLASS(name=u'PeriodicityList-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PeriodicityList_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Permutation >-----#
    Permutation = ENUM(name=u'Permutation', mode=MODE_TYPE)
    Permutation._cont = ASN1Dict([(u'dfu', 0), (u'ufd', 1)])
    Permutation._ext = []
    
    #-----< Ph-InfoMCG >-----#
    Ph_InfoMCG = OCT_STR(name=u'Ph-InfoMCG', mode=MODE_TYPE)
    
    #-----< Ph-InfoSCG >-----#
    Ph_InfoSCG = OCT_STR(name=u'Ph-InfoSCG', mode=MODE_TYPE)
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name=u'PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PortNumber >-----#
    PortNumber = BIT_STR(name=u'PortNumber', mode=MODE_TYPE)
    PortNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PosAssistance-Information >-----#
    PosAssistance_Information = OCT_STR(name=u'PosAssistance-Information', mode=MODE_TYPE)
    
    #-----< PosAssistanceInformationFailureList >-----#
    PosAssistanceInformationFailureList = OCT_STR(name=u'PosAssistanceInformationFailureList', mode=MODE_TYPE)
    
    #-----< PosBroadcast >-----#
    PosBroadcast = ENUM(name=u'PosBroadcast', mode=MODE_TYPE)
    PosBroadcast._cont = ASN1Dict([(u'start', 0), (u'stop', 1)])
    PosBroadcast._ext = []
    
    #-----< PositioningBroadcastCells >-----#
    PositioningBroadcastCells = SEQ_OF(name=u'PositioningBroadcastCells', mode=MODE_TYPE)
    _PositioningBroadcastCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    PositioningBroadcastCells._cont = _PositioningBroadcastCells__item_
    PositioningBroadcastCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< MeasurementPeriodicity >-----#
    MeasurementPeriodicity = ENUM(name=u'MeasurementPeriodicity', mode=MODE_TYPE)
    MeasurementPeriodicity._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'min1', 8), (u'min6', 9), (u'min12', 10), (u'min30', 11), (u'ms20480', 12), (u'ms40960', 13), (u'extended', 14)])
    MeasurementPeriodicity._ext = [u'ms20480', u'ms40960', u'extended']
    
    #-----< MeasurementPeriodicityExtended >-----#
    MeasurementPeriodicityExtended = ENUM(name=u'MeasurementPeriodicityExtended', mode=MODE_TYPE)
    MeasurementPeriodicityExtended._cont = ASN1Dict([(u'ms160', 0), (u'ms320', 1), (u'ms1280', 2), (u'ms2560', 3), (u'ms61440', 4), (u'ms81920', 5), (u'ms368640', 6), (u'ms737280', 7), (u'ms1843200', 8)])
    MeasurementPeriodicityExtended._ext = []
    
    #-----< PosMeasurementQuantities >-----#
    PosMeasurementQuantities = SEQ_OF(name=u'PosMeasurementQuantities', mode=MODE_TYPE)
    _PosMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities-Item')))
    PosMeasurementQuantities._cont = _PosMeasurementQuantities__item_
    PosMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< PosMeasurementQuantities-Item >-----#
    PosMeasurementQuantities_Item = SEQ(name=u'PosMeasurementQuantities-Item', mode=MODE_TYPE)
    _PosMeasurementQuantities_Item_posMeasurementType = ENUM(name=u'posMeasurementType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementType')))
    _PosMeasurementQuantities_Item_timingReportingGranularityFactor = INT(name=u'timingReportingGranularityFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PosMeasurementQuantities_Item_timingReportingGranularityFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _PosMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosMeasurementQuantities_Item_iE_Extensions__item__id),
        (u'criticality', ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _PosMeasurementQuantities_Item_iE_Extensions._cont = __PosMeasurementQuantities_Item_iE_Extensions__item_
    _PosMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementQuantities_Item._cont = ASN1Dict([
        (u'posMeasurementType', _PosMeasurementQuantities_Item_posMeasurementType),
        (u'timingReportingGranularityFactor', _PosMeasurementQuantities_Item_timingReportingGranularityFactor),
        (u'iE-Extensions', _PosMeasurementQuantities_Item_iE_Extensions),
        ])
    PosMeasurementQuantities_Item._ext = None
    
    #-----< PosMeasurementQuantities-ItemExtIEs >-----#
    PosMeasurementQuantities_ItemExtIEs = CLASS(name=u'PosMeasurementQuantities-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosMeasurementQuantities_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementResult >-----#
    PosMeasurementResult = SEQ_OF(name=u'PosMeasurementResult', mode=MODE_TYPE)
    _PosMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultItem')))
    PosMeasurementResult._cont = _PosMeasurementResult__item_
    PosMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< PosMeasurementResultItem >-----#
    PosMeasurementResultItem = SEQ(name=u'PosMeasurementResultItem', mode=MODE_TYPE)
    _PosMeasurementResultItem_measuredResultsValue = CHOICE(name=u'measuredResultsValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasuredResultsValue')))
    _PosMeasurementResultItem_timeStamp = SEQ(name=u'timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeStamp')))
    _PosMeasurementResultItem_measurementQuality = SEQ(name=u'measurementQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality')), opt=True)
    _PosMeasurementResultItem_measurementBeamInfo = SEQ(name=u'measurementBeamInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfo')), opt=True)
    _PosMeasurementResultItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementResultItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__id_tab
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosMeasurementResultItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementResultItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__criticality_tab
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosMeasurementResultItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementResultItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__extensionValue_tab
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosMeasurementResultItem_iE_Extensions__item__id),
        (u'criticality', ___PosMeasurementResultItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementResultItem_iE_Extensions__item_._ext = None
    _PosMeasurementResultItem_iE_Extensions._cont = __PosMeasurementResultItem_iE_Extensions__item_
    _PosMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementResultItem._cont = ASN1Dict([
        (u'measuredResultsValue', _PosMeasurementResultItem_measuredResultsValue),
        (u'timeStamp', _PosMeasurementResultItem_timeStamp),
        (u'measurementQuality', _PosMeasurementResultItem_measurementQuality),
        (u'measurementBeamInfo', _PosMeasurementResultItem_measurementBeamInfo),
        (u'iE-Extensions', _PosMeasurementResultItem_iE_Extensions),
        ])
    PosMeasurementResultItem._ext = None
    
    #-----< PosMeasurementResultItemExtIEs >-----#
    PosMeasurementResultItemExtIEs = CLASS(name=u'PosMeasurementResultItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosMeasurementResultItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementResultList >-----#
    PosMeasurementResultList = SEQ_OF(name=u'PosMeasurementResultList', mode=MODE_TYPE)
    _PosMeasurementResultList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList-Item')))
    PosMeasurementResultList._cont = _PosMeasurementResultList__item_
    PosMeasurementResultList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosMeasurementResultList-Item >-----#
    PosMeasurementResultList_Item = SEQ(name=u'PosMeasurementResultList-Item', mode=MODE_TYPE)
    _PosMeasurementResultList_Item_posMeasurementResult = SEQ_OF(name=u'posMeasurementResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResult')))
    _PosMeasurementResultList_Item_tRPID = INT(name=u'tRPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _PosMeasurementResultList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementResultList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementResultList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosMeasurementResultList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosMeasurementResultList_Item_iE_Extensions__item__id),
        (u'criticality', ___PosMeasurementResultList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementResultList_Item_iE_Extensions__item_._ext = None
    _PosMeasurementResultList_Item_iE_Extensions._cont = __PosMeasurementResultList_Item_iE_Extensions__item_
    _PosMeasurementResultList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementResultList_Item._cont = ASN1Dict([
        (u'posMeasurementResult', _PosMeasurementResultList_Item_posMeasurementResult),
        (u'tRPID', _PosMeasurementResultList_Item_tRPID),
        (u'iE-Extensions', _PosMeasurementResultList_Item_iE_Extensions),
        ])
    PosMeasurementResultList_Item._ext = None
    
    #-----< PosMeasurementResultList-ItemExtIEs >-----#
    PosMeasurementResultList_ItemExtIEs = CLASS(name=u'PosMeasurementResultList-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PosMeasurementResultList_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    PosMeasurementResultList_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _PosMeasurementResultList_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementType >-----#
    PosMeasurementType = ENUM(name=u'PosMeasurementType', mode=MODE_TYPE)
    PosMeasurementType._cont = ASN1Dict([(u'gnb-rx-tx', 0), (u'ul-srs-rsrp', 1), (u'ul-aoa', 2), (u'ul-rtoa', 3)])
    PosMeasurementType._ext = []
    
    #-----< PosReportCharacteristics >-----#
    PosReportCharacteristics = ENUM(name=u'PosReportCharacteristics', mode=MODE_TYPE)
    PosReportCharacteristics._cont = ASN1Dict([(u'ondemand', 0), (u'periodic', 1)])
    PosReportCharacteristics._ext = []
    
    #-----< PosResourceSetType >-----#
    PosResourceSetType = CHOICE(name=u'PosResourceSetType', mode=MODE_TYPE)
    _PosResourceSetType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypePR')))
    _PosResourceSetType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypeSP')))
    _PosResourceSetType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypeAP')))
    _PosResourceSetType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PosResourceSetType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PosResourceSetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_id._const_tab = ___PosResourceSetType_choice_extension_id_tab
    __PosResourceSetType_choice_extension_id._const_tab_at = None
    __PosResourceSetType_choice_extension_id._const_tab_id = u'id'
    __PosResourceSetType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PosResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_criticality._const_tab = ___PosResourceSetType_choice_extension_criticality_tab
    __PosResourceSetType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PosResourceSetType_choice_extension_criticality._const_tab_id = u'criticality'
    __PosResourceSetType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PosResourceSetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_value._const_tab = ___PosResourceSetType_choice_extension_value_tab
    __PosResourceSetType_choice_extension_value._const_tab_at = ('..', u'id')
    __PosResourceSetType_choice_extension_value._const_tab_id = u'Value'
    _PosResourceSetType_choice_extension._cont = ASN1Dict([
        (u'id', __PosResourceSetType_choice_extension_id),
        (u'criticality', __PosResourceSetType_choice_extension_criticality),
        (u'value', __PosResourceSetType_choice_extension_value),
        ])
    _PosResourceSetType_choice_extension._ext = None
    PosResourceSetType._cont = ASN1Dict([
        (u'periodic', _PosResourceSetType_periodic),
        (u'semi-persistent', _PosResourceSetType_semi_persistent),
        (u'aperiodic', _PosResourceSetType_aperiodic),
        (u'choice-extension', _PosResourceSetType_choice_extension),
        ])
    PosResourceSetType._ext = None
    
    #-----< PosResourceSetType-ExtIEs >-----#
    PosResourceSetType_ExtIEs = CLASS(name=u'PosResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PosResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypePR >-----#
    PosResourceSetTypePR = SEQ(name=u'PosResourceSetTypePR', mode=MODE_TYPE)
    _PosResourceSetTypePR_posperiodicSet = ENUM(name=u'posperiodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypePR_posperiodicSet._cont = ASN1Dict([(u'true', 0)])
    _PosResourceSetTypePR_posperiodicSet._ext = []
    _PosResourceSetTypePR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypePR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypePR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypePR_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__id_tab
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypePR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypePR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypePR_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypePR_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypePR_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypePR_iE_Extensions__item_._ext = None
    _PosResourceSetTypePR_iE_Extensions._cont = __PosResourceSetTypePR_iE_Extensions__item_
    _PosResourceSetTypePR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypePR._cont = ASN1Dict([
        (u'posperiodicSet', _PosResourceSetTypePR_posperiodicSet),
        (u'iE-Extensions', _PosResourceSetTypePR_iE_Extensions),
        ])
    PosResourceSetTypePR._ext = None
    
    #-----< PosResourceSetTypePR-ExtIEs >-----#
    PosResourceSetTypePR_ExtIEs = CLASS(name=u'PosResourceSetTypePR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypePR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeSP >-----#
    PosResourceSetTypeSP = SEQ(name=u'PosResourceSetTypeSP', mode=MODE_TYPE)
    _PosResourceSetTypeSP_possemi_persistentSet = ENUM(name=u'possemi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeSP_possemi_persistentSet._cont = ASN1Dict([(u'true', 0)])
    _PosResourceSetTypeSP_possemi_persistentSet._ext = []
    _PosResourceSetTypeSP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeSP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeSP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypeSP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__id_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypeSP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypeSP_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypeSP_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeSP_iE_Extensions__item_._ext = None
    _PosResourceSetTypeSP_iE_Extensions._cont = __PosResourceSetTypeSP_iE_Extensions__item_
    _PosResourceSetTypeSP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeSP._cont = ASN1Dict([
        (u'possemi-persistentSet', _PosResourceSetTypeSP_possemi_persistentSet),
        (u'iE-Extensions', _PosResourceSetTypeSP_iE_Extensions),
        ])
    PosResourceSetTypeSP._ext = None
    
    #-----< PosResourceSetTypeSP-ExtIEs >-----#
    PosResourceSetTypeSP_ExtIEs = CLASS(name=u'PosResourceSetTypeSP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypeSP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeAP >-----#
    PosResourceSetTypeAP = SEQ(name=u'PosResourceSetTypeAP', mode=MODE_TYPE)
    _PosResourceSetTypeAP_sRSResourceTrigger_List = INT(name=u'sRSResourceTrigger-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeAP_sRSResourceTrigger_List._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _PosResourceSetTypeAP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeAP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeAP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypeAP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__id_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypeAP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypeAP_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypeAP_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeAP_iE_Extensions__item_._ext = None
    _PosResourceSetTypeAP_iE_Extensions._cont = __PosResourceSetTypeAP_iE_Extensions__item_
    _PosResourceSetTypeAP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeAP._cont = ASN1Dict([
        (u'sRSResourceTrigger-List', _PosResourceSetTypeAP_sRSResourceTrigger_List),
        (u'iE-Extensions', _PosResourceSetTypeAP_iE_Extensions),
        ])
    PosResourceSetTypeAP._ext = None
    
    #-----< PosResourceSetTypeAP-ExtIEs >-----#
    PosResourceSetTypeAP_ExtIEs = CLASS(name=u'PosResourceSetTypeAP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypeAP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResourceID-List >-----#
    PosSRSResourceID_List = SEQ_OF(name=u'PosSRSResourceID-List', mode=MODE_TYPE)
    _PosSRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    PosSRSResourceID_List._cont = _PosSRSResourceID_List__item_
    PosSRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResource-Item >-----#
    PosSRSResource_Item = SEQ(name=u'PosSRSResource-Item', mode=MODE_TYPE)
    _PosSRSResource_Item_srs_PosResourceId = INT(name=u'srs-PosResourceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    _PosSRSResource_Item_transmissionCombPos = CHOICE(name=u'transmissionCombPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransmissionCombPos')))
    _PosSRSResource_Item_startPosition = INT(name=u'startPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _PosSRSResource_Item_nrofSymbols = ENUM(name=u'nrofSymbols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_nrofSymbols._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3), (u'n12', 4)])
    _PosSRSResource_Item_nrofSymbols._ext = None
    _PosSRSResource_Item_freqDomainShift = INT(name=u'freqDomainShift', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _PosSRSResource_Item_c_SRS = INT(name=u'c-SRS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PosSRSResource_Item_groupOrSequenceHopping = ENUM(name=u'groupOrSequenceHopping', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_groupOrSequenceHopping._cont = ASN1Dict([(u'neither', 0), (u'groupHopping', 1), (u'sequenceHopping', 2)])
    _PosSRSResource_Item_groupOrSequenceHopping._ext = None
    _PosSRSResource_Item_resourceTypePos = CHOICE(name=u'resourceTypePos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePos')))
    _PosSRSResource_Item_sequenceId = INT(name=u'sequenceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PosSRSResource_Item_spatialRelationPos = CHOICE(name=u'spatialRelationPos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPos')), opt=True)
    _PosSRSResource_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosSRSResource_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab = ____PosSRSResource_Item_iE_Extensions__item__id_tab
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosSRSResource_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResource_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosSRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosSRSResource_Item_iE_Extensions__item__id),
        (u'criticality', ___PosSRSResource_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosSRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResource_Item_iE_Extensions__item_._ext = None
    _PosSRSResource_Item_iE_Extensions._cont = __PosSRSResource_Item_iE_Extensions__item_
    _PosSRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResource_Item._cont = ASN1Dict([
        (u'srs-PosResourceId', _PosSRSResource_Item_srs_PosResourceId),
        (u'transmissionCombPos', _PosSRSResource_Item_transmissionCombPos),
        (u'startPosition', _PosSRSResource_Item_startPosition),
        (u'nrofSymbols', _PosSRSResource_Item_nrofSymbols),
        (u'freqDomainShift', _PosSRSResource_Item_freqDomainShift),
        (u'c-SRS', _PosSRSResource_Item_c_SRS),
        (u'groupOrSequenceHopping', _PosSRSResource_Item_groupOrSequenceHopping),
        (u'resourceTypePos', _PosSRSResource_Item_resourceTypePos),
        (u'sequenceId', _PosSRSResource_Item_sequenceId),
        (u'spatialRelationPos', _PosSRSResource_Item_spatialRelationPos),
        (u'iE-Extensions', _PosSRSResource_Item_iE_Extensions),
        ])
    PosSRSResource_Item._ext = None
    
    #-----< PosSRSResource-Item-ExtIEs >-----#
    PosSRSResource_Item_ExtIEs = CLASS(name=u'PosSRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosSRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResource-List >-----#
    PosSRSResource_List = SEQ_OF(name=u'PosSRSResource-List', mode=MODE_TYPE)
    _PosSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResource-Item')))
    PosSRSResource_List._cont = _PosSRSResource_List__item_
    PosSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSRSResourceSet-Item >-----#
    PosSRSResourceSet_Item = SEQ(name=u'PosSRSResourceSet-Item', mode=MODE_TYPE)
    _PosSRSResourceSet_Item_possrsResourceSetID = INT(name=u'possrsResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResourceSet_Item_possrsResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PosSRSResourceSet_Item_possRSResourceID_List = SEQ_OF(name=u'possRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceID-List')))
    _PosSRSResourceSet_Item_posresourceSetType = CHOICE(name=u'posresourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetType')))
    _PosSRSResourceSet_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosSRSResourceSet_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosSRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosSRSResourceSet_Item_iE_Extensions__item__id),
        (u'criticality', ___PosSRSResourceSet_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PosSRSResourceSet_Item_iE_Extensions._cont = __PosSRSResourceSet_Item_iE_Extensions__item_
    _PosSRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResourceSet_Item._cont = ASN1Dict([
        (u'possrsResourceSetID', _PosSRSResourceSet_Item_possrsResourceSetID),
        (u'possRSResourceID-List', _PosSRSResourceSet_Item_possRSResourceID_List),
        (u'posresourceSetType', _PosSRSResourceSet_Item_posresourceSetType),
        (u'iE-Extensions', _PosSRSResourceSet_Item_iE_Extensions),
        ])
    PosSRSResourceSet_Item._ext = None
    
    #-----< PosSRSResourceSet-Item-ExtIEs >-----#
    PosSRSResourceSet_Item_ExtIEs = CLASS(name=u'PosSRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosSRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResourceSet-List >-----#
    PosSRSResourceSet_List = SEQ_OF(name=u'PosSRSResourceSet-List', mode=MODE_TYPE)
    _PosSRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceSet-Item')))
    PosSRSResourceSet_List._cont = _PosSRSResourceSet_List__item_
    PosSRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PrimaryPathIndication >-----#
    PrimaryPathIndication = ENUM(name=u'PrimaryPathIndication', mode=MODE_TYPE)
    PrimaryPathIndication._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    PrimaryPathIndication._ext = []
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProtectedEUTRAResourceIndication >-----#
    ProtectedEUTRAResourceIndication = OCT_STR(name=u'ProtectedEUTRAResourceIndication', mode=MODE_TYPE)
    
    #-----< Protected-EUTRA-Resources-Item >-----#
    Protected_EUTRA_Resources_Item = SEQ(name=u'Protected-EUTRA-Resources-Item', mode=MODE_TYPE)
    _Protected_EUTRA_Resources_Item_spectrumSharingGroupID = INT(name=u'spectrumSharingGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpectrumSharingGroupID')))
    _Protected_EUTRA_Resources_Item_eUTRACells_List = SEQ_OF(name=u'eUTRACells-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRACells-List')))
    _Protected_EUTRA_Resources_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab_at = None
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id),
        (u'criticality', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue),
        ])
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_._ext = None
    _Protected_EUTRA_Resources_Item_iE_Extensions._cont = __Protected_EUTRA_Resources_Item_iE_Extensions__item_
    _Protected_EUTRA_Resources_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Protected_EUTRA_Resources_Item._cont = ASN1Dict([
        (u'spectrumSharingGroupID', _Protected_EUTRA_Resources_Item_spectrumSharingGroupID),
        (u'eUTRACells-List', _Protected_EUTRA_Resources_Item_eUTRACells_List),
        (u'iE-Extensions', _Protected_EUTRA_Resources_Item_iE_Extensions),
        ])
    Protected_EUTRA_Resources_Item._ext = None
    
    #-----< Protected-EUTRA-Resources-ItemExtIEs >-----#
    Protected_EUTRA_Resources_ItemExtIEs = CLASS(name=u'Protected-EUTRA-Resources-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Protected_EUTRA_Resources_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSConfiguration >-----#
    PRSConfiguration = SEQ(name=u'PRSConfiguration', mode=MODE_TYPE)
    _PRSConfiguration_pRSResourceSet_List = SEQ_OF(name=u'pRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResourceSet-List')))
    _PRSConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__id._const_tab = ____PRSConfiguration_iE_Extensions__item__id_tab
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab = ____PRSConfiguration_iE_Extensions__item__criticality_tab
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____PRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSConfiguration_iE_Extensions__item__id),
        (u'criticality', ___PRSConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __PRSConfiguration_iE_Extensions__item_._ext = None
    _PRSConfiguration_iE_Extensions._cont = __PRSConfiguration_iE_Extensions__item_
    _PRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSConfiguration._cont = ASN1Dict([
        (u'pRSResourceSet-List', _PRSConfiguration_pRSResourceSet_List),
        (u'iE-Extensions', _PRSConfiguration_iE_Extensions),
        ])
    PRSConfiguration._ext = None
    
    #-----< PRSConfiguration-ExtIEs >-----#
    PRSConfiguration_ExtIEs = CLASS(name=u'PRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSInformationPos >-----#
    PRSInformationPos = SEQ(name=u'PRSInformationPos', mode=MODE_TYPE)
    _PRSInformationPos_pRS_IDPos = INT(name=u'pRS-IDPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_Set_IDPos = INT(name=u'pRS-Resource-Set-IDPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_Resource_Set_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_IDPos = INT(name=u'pRS-Resource-IDPos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSInformationPos_pRS_Resource_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRSInformationPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSInformationPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSInformationPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSInformationPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__id._const_tab = ____PRSInformationPos_iE_Extensions__item__id_tab
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_at = None
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSInformationPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab = ____PRSInformationPos_iE_Extensions__item__criticality_tab
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSInformationPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab = ____PRSInformationPos_iE_Extensions__item__extensionValue_tab
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSInformationPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSInformationPos_iE_Extensions__item__id),
        (u'criticality', ___PRSInformationPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSInformationPos_iE_Extensions__item__extensionValue),
        ])
    __PRSInformationPos_iE_Extensions__item_._ext = None
    _PRSInformationPos_iE_Extensions._cont = __PRSInformationPos_iE_Extensions__item_
    _PRSInformationPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSInformationPos._cont = ASN1Dict([
        (u'pRS-IDPos', _PRSInformationPos_pRS_IDPos),
        (u'pRS-Resource-Set-IDPos', _PRSInformationPos_pRS_Resource_Set_IDPos),
        (u'pRS-Resource-IDPos', _PRSInformationPos_pRS_Resource_IDPos),
        (u'iE-Extensions', _PRSInformationPos_iE_Extensions),
        ])
    PRSInformationPos._ext = None
    
    #-----< PRSInformationPos-ExtIEs >-----#
    PRSInformationPos_ExtIEs = CLASS(name=u'PRSInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Potential-SpCell-Item >-----#
    Potential_SpCell_Item = SEQ(name=u'Potential-SpCell-Item', mode=MODE_TYPE)
    _Potential_SpCell_Item_potential_SpCell_ID = SEQ(name=u'potential-SpCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Potential_SpCell_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Potential_SpCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Potential_SpCell_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Potential_SpCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__id_tab
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Potential_SpCell_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Potential_SpCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Potential_SpCell_Item_iE_Extensions__item__id),
        (u'criticality', ___Potential_SpCell_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Potential_SpCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Potential_SpCell_Item_iE_Extensions__item_._ext = None
    _Potential_SpCell_Item_iE_Extensions._cont = __Potential_SpCell_Item_iE_Extensions__item_
    _Potential_SpCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Potential_SpCell_Item._cont = ASN1Dict([
        (u'potential-SpCell-ID', _Potential_SpCell_Item_potential_SpCell_ID),
        (u'iE-Extensions', _Potential_SpCell_Item_iE_Extensions),
        ])
    Potential_SpCell_Item._ext = []
    
    #-----< Potential-SpCell-ItemExtIEs >-----#
    Potential_SpCell_ItemExtIEs = CLASS(name=u'Potential-SpCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Potential_SpCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSAngleList >-----#
    PRSAngleList = SEQ_OF(name=u'PRSAngleList', mode=MODE_TYPE)
    _PRSAngleList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSAngleItem')))
    PRSAngleList._cont = _PRSAngleList__item_
    PRSAngleList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSAngleItem >-----#
    PRSAngleItem = SEQ(name=u'PRSAngleItem', mode=MODE_TYPE)
    _PRSAngleItem_nR_PRS_Azimuth = INT(name=u'nR-PRS-Azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Azimuth_fine = INT(name=u'nR-PRS-Azimuth-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Azimuth_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Elevation = INT(name=u'nR-PRS-Elevation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Elevation_fine = INT(name=u'nR-PRS-Elevation-fine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Elevation_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSAngleItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSAngleItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSAngleItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    ____PRSAngleItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 439), (u'criticality', u'ignore'), (u'Extension', _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PRSAngleItem_iE_Extensions__item__id._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSAngleItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSAngleItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSAngleItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSAngleItem_iE_Extensions__item__id),
        (u'criticality', ___PRSAngleItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSAngleItem_iE_Extensions__item__extensionValue),
        ])
    __PRSAngleItem_iE_Extensions__item_._ext = None
    _PRSAngleItem_iE_Extensions._cont = __PRSAngleItem_iE_Extensions__item_
    _PRSAngleItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSAngleItem._cont = ASN1Dict([
        (u'nR-PRS-Azimuth', _PRSAngleItem_nR_PRS_Azimuth),
        (u'nR-PRS-Azimuth-fine', _PRSAngleItem_nR_PRS_Azimuth_fine),
        (u'nR-PRS-Elevation', _PRSAngleItem_nR_PRS_Elevation),
        (u'nR-PRS-Elevation-fine', _PRSAngleItem_nR_PRS_Elevation_fine),
        (u'iE-Extensions', _PRSAngleItem_iE_Extensions),
        ])
    PRSAngleItem._ext = None
    
    #-----< PRSAngleItem-ItemExtIEs >-----#
    PRSAngleItem_ItemExtIEs = CLASS(name=u'PRSAngleItem-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PRSAngleItem_ItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    PRSAngleItem_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 439), (u'criticality', u'ignore'), (u'Extension', _PRSAngleItem_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSMuting >-----#
    PRSMuting = SEQ(name=u'PRSMuting', mode=MODE_TYPE)
    _PRSMuting_pRSMutingOption1 = SEQ(name=u'pRSMutingOption1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMutingOption1')), opt=True)
    _PRSMuting_pRSMutingOption2 = SEQ(name=u'pRSMutingOption2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMutingOption2')), opt=True)
    _PRSMuting_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMuting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMuting_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMuting_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__id._const_tab = ____PRSMuting_iE_Extensions__item__id_tab
    ___PRSMuting_iE_Extensions__item__id._const_tab_at = None
    ___PRSMuting_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMuting_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMuting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__criticality._const_tab = ____PRSMuting_iE_Extensions__item__criticality_tab
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMuting_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab = ____PRSMuting_iE_Extensions__item__extensionValue_tab
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMuting_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMuting_iE_Extensions__item__id),
        (u'criticality', ___PRSMuting_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMuting_iE_Extensions__item__extensionValue),
        ])
    __PRSMuting_iE_Extensions__item_._ext = None
    _PRSMuting_iE_Extensions._cont = __PRSMuting_iE_Extensions__item_
    _PRSMuting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMuting._cont = ASN1Dict([
        (u'pRSMutingOption1', _PRSMuting_pRSMutingOption1),
        (u'pRSMutingOption2', _PRSMuting_pRSMutingOption2),
        (u'iE-Extensions', _PRSMuting_iE_Extensions),
        ])
    PRSMuting._ext = None
    
    #-----< PRSMuting-ExtIEs >-----#
    PRSMuting_ExtIEs = CLASS(name=u'PRSMuting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMuting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption1 >-----#
    PRSMutingOption1 = SEQ(name=u'PRSMutingOption1', mode=MODE_TYPE)
    _PRSMutingOption1_mutingPattern = CHOICE(name=u'mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption1_mutingBitRepetitionFactor = ENUM(name=u'mutingBitRepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingOption1_mutingBitRepetitionFactor._cont = ASN1Dict([(u'rf1', 0), (u'rf2', 1), (u'rf4', 2), (u'rf8', 3)])
    _PRSMutingOption1_mutingBitRepetitionFactor._ext = []
    _PRSMutingOption1_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption1_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMutingOption1_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab = ____PRSMutingOption1_iE_Extensions__item__id_tab
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMutingOption1_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption1_iE_Extensions__item__criticality_tab
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMutingOption1_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMutingOption1_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMutingOption1_iE_Extensions__item__id),
        (u'criticality', ___PRSMutingOption1_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMutingOption1_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption1_iE_Extensions__item_._ext = None
    _PRSMutingOption1_iE_Extensions._cont = __PRSMutingOption1_iE_Extensions__item_
    _PRSMutingOption1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption1._cont = ASN1Dict([
        (u'mutingPattern', _PRSMutingOption1_mutingPattern),
        (u'mutingBitRepetitionFactor', _PRSMutingOption1_mutingBitRepetitionFactor),
        (u'iE-Extensions', _PRSMutingOption1_iE_Extensions),
        ])
    PRSMutingOption1._ext = None
    
    #-----< PRSMutingOption1-ExtIEs >-----#
    PRSMutingOption1_ExtIEs = CLASS(name=u'PRSMutingOption1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMutingOption1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption2 >-----#
    PRSMutingOption2 = SEQ(name=u'PRSMutingOption2', mode=MODE_TYPE)
    _PRSMutingOption2_mutingPattern = CHOICE(name=u'mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMutingOption2_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab = ____PRSMutingOption2_iE_Extensions__item__id_tab
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMutingOption2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption2_iE_Extensions__item__criticality_tab
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMutingOption2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMutingOption2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMutingOption2_iE_Extensions__item__id),
        (u'criticality', ___PRSMutingOption2_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMutingOption2_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption2_iE_Extensions__item_._ext = None
    _PRSMutingOption2_iE_Extensions._cont = __PRSMutingOption2_iE_Extensions__item_
    _PRSMutingOption2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption2._cont = ASN1Dict([
        (u'mutingPattern', _PRSMutingOption2_mutingPattern),
        (u'iE-Extensions', _PRSMutingOption2_iE_Extensions),
        ])
    PRSMutingOption2._ext = None
    
    #-----< PRSMutingOption2-ExtIEs >-----#
    PRSMutingOption2_ExtIEs = CLASS(name=u'PRSMutingOption2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMutingOption2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-ID >-----#
    PRS_Resource_ID = INT(name=u'PRS-Resource-ID', mode=MODE_TYPE)
    PRS_Resource_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< PRSResource-List >-----#
    PRSResource_List = SEQ_OF(name=u'PRSResource-List', mode=MODE_TYPE)
    _PRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-Item')))
    PRSResource_List._cont = _PRSResource_List__item_
    PRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSResource-Item >-----#
    PRSResource_Item = SEQ(name=u'PRSResource-Item', mode=MODE_TYPE)
    _PRSResource_Item_pRSResourceID = INT(name=u'pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _PRSResource_Item_sequenceID = INT(name=u'sequenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_sequenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _PRSResource_Item_rEOffset = INT(name=u'rEOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_rEOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=[], er=[])
    _PRSResource_Item_resourceSlotOffset = INT(name=u'resourceSlotOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _PRSResource_Item_resourceSymbolOffset = INT(name=u'resourceSymbolOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSymbolOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    _PRSResource_Item_qCLInfo = CHOICE(name=u'qCLInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLInfo')), opt=True)
    _PRSResource_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__id._const_tab = ____PRSResource_Item_iE_Extensions__item__id_tab
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSResource_Item_iE_Extensions__item__criticality_tab
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_Item_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_Item_iE_Extensions__item_._ext = None
    _PRSResource_Item_iE_Extensions._cont = __PRSResource_Item_iE_Extensions__item_
    _PRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_Item._cont = ASN1Dict([
        (u'pRSResourceID', _PRSResource_Item_pRSResourceID),
        (u'sequenceID', _PRSResource_Item_sequenceID),
        (u'rEOffset', _PRSResource_Item_rEOffset),
        (u'resourceSlotOffset', _PRSResource_Item_resourceSlotOffset),
        (u'resourceSymbolOffset', _PRSResource_Item_resourceSymbolOffset),
        (u'qCLInfo', _PRSResource_Item_qCLInfo),
        (u'iE-Extensions', _PRSResource_Item_iE_Extensions),
        ])
    PRSResource_Item._ext = None
    
    #-----< PRSResource-Item-ExtIEs >-----#
    PRSResource_Item_ExtIEs = CLASS(name=u'PRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLInfo >-----#
    PRSResource_QCLInfo = CHOICE(name=u'PRSResource-QCLInfo', mode=MODE_TYPE)
    _PRSResource_QCLInfo_qCLSourceSSB = SEQ(name=u'qCLSourceSSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLSourceSSB')))
    _PRSResource_QCLInfo_qCLSourcePRS = SEQ(name=u'qCLSourcePRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLSourcePRS')))
    _PRSResource_QCLInfo_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PRSResource_QCLInfo_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PRSResource_QCLInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_id._const_tab = ___PRSResource_QCLInfo_choice_extension_id_tab
    __PRSResource_QCLInfo_choice_extension_id._const_tab_at = None
    __PRSResource_QCLInfo_choice_extension_id._const_tab_id = u'id'
    __PRSResource_QCLInfo_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PRSResource_QCLInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab = ___PRSResource_QCLInfo_choice_extension_criticality_tab
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab_id = u'criticality'
    __PRSResource_QCLInfo_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PRSResource_QCLInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_value._const_tab = ___PRSResource_QCLInfo_choice_extension_value_tab
    __PRSResource_QCLInfo_choice_extension_value._const_tab_at = ('..', u'id')
    __PRSResource_QCLInfo_choice_extension_value._const_tab_id = u'Value'
    _PRSResource_QCLInfo_choice_extension._cont = ASN1Dict([
        (u'id', __PRSResource_QCLInfo_choice_extension_id),
        (u'criticality', __PRSResource_QCLInfo_choice_extension_criticality),
        (u'value', __PRSResource_QCLInfo_choice_extension_value),
        ])
    _PRSResource_QCLInfo_choice_extension._ext = None
    PRSResource_QCLInfo._cont = ASN1Dict([
        (u'qCLSourceSSB', _PRSResource_QCLInfo_qCLSourceSSB),
        (u'qCLSourcePRS', _PRSResource_QCLInfo_qCLSourcePRS),
        (u'choice-extension', _PRSResource_QCLInfo_choice_extension),
        ])
    PRSResource_QCLInfo._ext = None
    
    #-----< PRSResource-QCLInfo-ExtIEs >-----#
    PRSResource_QCLInfo_ExtIEs = CLASS(name=u'PRSResource-QCLInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PRSResource_QCLInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourceSSB >-----#
    PRSResource_QCLSourceSSB = SEQ(name=u'PRSResource-QCLSourceSSB', mode=MODE_TYPE)
    _PRSResource_QCLSourceSSB_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_QCLSourceSSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _PRSResource_QCLSourceSSB_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _PRSResource_QCLSourceSSB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourceSSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_QCLSourceSSB_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourceSSB_iE_Extensions._cont = __PRSResource_QCLSourceSSB_iE_Extensions__item_
    _PRSResource_QCLSourceSSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourceSSB._cont = ASN1Dict([
        (u'pCI-NR', _PRSResource_QCLSourceSSB_pCI_NR),
        (u'sSB-Index', _PRSResource_QCLSourceSSB_sSB_Index),
        (u'iE-Extensions', _PRSResource_QCLSourceSSB_iE_Extensions),
        ])
    PRSResource_QCLSourceSSB._ext = []
    
    #-----< PRSResource-QCLSourceSSB-ExtIEs >-----#
    PRSResource_QCLSourceSSB_ExtIEs = CLASS(name=u'PRSResource-QCLSourceSSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourceSSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourcePRS >-----#
    PRSResource_QCLSourcePRS = SEQ(name=u'PRSResource-QCLSourcePRS', mode=MODE_TYPE)
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID = INT(name=u'qCLSourcePRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID = INT(name=u'qCLSourcePRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _PRSResource_QCLSourcePRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourcePRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_QCLSourcePRS_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourcePRS_iE_Extensions._cont = __PRSResource_QCLSourcePRS_iE_Extensions__item_
    _PRSResource_QCLSourcePRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourcePRS._cont = ASN1Dict([
        (u'qCLSourcePRSResourceSetID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID),
        (u'qCLSourcePRSResourceID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID),
        (u'iE-Extensions', _PRSResource_QCLSourcePRS_iE_Extensions),
        ])
    PRSResource_QCLSourcePRS._ext = None
    
    #-----< PRSResource-QCLSourcePRS-ExtIEs >-----#
    PRSResource_QCLSourcePRS_ExtIEs = CLASS(name=u'PRSResource-QCLSourcePRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourcePRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-Set-ID >-----#
    PRS_Resource_Set_ID = INT(name=u'PRS-Resource-Set-ID', mode=MODE_TYPE)
    PRS_Resource_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PRSResourceSet-List >-----#
    PRSResourceSet_List = SEQ_OF(name=u'PRSResourceSet-List', mode=MODE_TYPE)
    _PRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSResourceSet-Item')))
    PRSResourceSet_List._cont = _PRSResourceSet_List__item_
    PRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSResourceSet-Item >-----#
    PRSResourceSet_Item = SEQ(name=u'PRSResourceSet-Item', mode=MODE_TYPE)
    _PRSResourceSet_Item_pRSResourceSetID = INT(name=u'pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSResourceSet_Item_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _PRSResourceSet_Item_subcarrierSpacing._ext = []
    _PRSResourceSet_Item_pRSbandwidth = INT(name=u'pRSbandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _PRSResourceSet_Item_startPRB = INT(name=u'startPRB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_startPRB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2176)], ev=None, er=[])
    _PRSResourceSet_Item_pointA = INT(name=u'pointA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRSResourceSet_Item_combSize = ENUM(name=u'combSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_combSize._cont = ASN1Dict([(u'n2', 0), (u'n4', 1), (u'n6', 2), (u'n12', 3)])
    _PRSResourceSet_Item_combSize._ext = []
    _PRSResourceSet_Item_cPType = ENUM(name=u'cPType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_cPType._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    _PRSResourceSet_Item_cPType._ext = []
    _PRSResourceSet_Item_resourceSetPeriodicity = ENUM(name=u'resourceSetPeriodicity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([(u'n4', 0), (u'n5', 1), (u'n8', 2), (u'n10', 3), (u'n16', 4), (u'n20', 5), (u'n32', 6), (u'n40', 7), (u'n64', 8), (u'n80', 9), (u'n160', 10), (u'n320', 11), (u'n640', 12), (u'n1280', 13), (u'n2560', 14), (u'n5120', 15), (u'n10240', 16), (u'n20480', 17), (u'n40960', 18), (u'n81920', 19)])
    _PRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _PRSResourceSet_Item_resourceSetSlotOffset = INT(name=u'resourceSetSlotOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _PRSResourceSet_Item_resourceRepetitionFactor = ENUM(name=u'resourceRepetitionFactor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([(u'rf1', 0), (u'rf2', 1), (u'rf4', 2), (u'rf6', 3), (u'rf8', 4), (u'rf16', 5), (u'rf32', 6)])
    _PRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _PRSResourceSet_Item_resourceTimeGap = ENUM(name=u'resourceTimeGap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceTimeGap._cont = ASN1Dict([(u'tg1', 0), (u'tg2', 1), (u'tg4', 2), (u'tg8', 3), (u'tg16', 4), (u'tg32', 5)])
    _PRSResourceSet_Item_resourceTimeGap._ext = []
    _PRSResourceSet_Item_resourceNumberofSymbols = ENUM(name=u'resourceNumberofSymbols', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([(u'n2', 0), (u'n4', 1), (u'n6', 2), (u'n12', 3)])
    _PRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _PRSResourceSet_Item_pRSMuting = SEQ(name=u'pRSMuting', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMuting')), opt=True)
    _PRSResourceSet_Item_pRSResourceTransmitPower = INT(name=u'pRSResourceTransmitPower', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSResourceTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _PRSResourceSet_Item_pRSResource_List = SEQ_OF(name=u'pRSResource-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-List')))
    _PRSResourceSet_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResourceSet_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResourceSet_Item_iE_Extensions__item__id),
        (u'criticality', ___PRSResourceSet_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSResourceSet_Item_iE_Extensions._cont = __PRSResourceSet_Item_iE_Extensions__item_
    _PRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResourceSet_Item._cont = ASN1Dict([
        (u'pRSResourceSetID', _PRSResourceSet_Item_pRSResourceSetID),
        (u'subcarrierSpacing', _PRSResourceSet_Item_subcarrierSpacing),
        (u'pRSbandwidth', _PRSResourceSet_Item_pRSbandwidth),
        (u'startPRB', _PRSResourceSet_Item_startPRB),
        (u'pointA', _PRSResourceSet_Item_pointA),
        (u'combSize', _PRSResourceSet_Item_combSize),
        (u'cPType', _PRSResourceSet_Item_cPType),
        (u'resourceSetPeriodicity', _PRSResourceSet_Item_resourceSetPeriodicity),
        (u'resourceSetSlotOffset', _PRSResourceSet_Item_resourceSetSlotOffset),
        (u'resourceRepetitionFactor', _PRSResourceSet_Item_resourceRepetitionFactor),
        (u'resourceTimeGap', _PRSResourceSet_Item_resourceTimeGap),
        (u'resourceNumberofSymbols', _PRSResourceSet_Item_resourceNumberofSymbols),
        (u'pRSMuting', _PRSResourceSet_Item_pRSMuting),
        (u'pRSResourceTransmitPower', _PRSResourceSet_Item_pRSResourceTransmitPower),
        (u'pRSResource-List', _PRSResourceSet_Item_pRSResource_List),
        (u'iE-Extensions', _PRSResourceSet_Item_iE_Extensions),
        ])
    PRSResourceSet_Item._ext = None
    
    #-----< PRSResourceSet-Item-ExtIEs >-----#
    PRSResourceSet_Item_ExtIEs = CLASS(name=u'PRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PWS-Failed-NR-CGI-Item >-----#
    PWS_Failed_NR_CGI_Item = SEQ(name=u'PWS-Failed-NR-CGI-Item', mode=MODE_TYPE)
    _PWS_Failed_NR_CGI_Item_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _PWS_Failed_NR_CGI_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberOfBroadcasts')))
    _PWS_Failed_NR_CGI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab_at = None
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id),
        (u'criticality', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue),
        ])
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_._ext = None
    _PWS_Failed_NR_CGI_Item_iE_Extensions._cont = __PWS_Failed_NR_CGI_Item_iE_Extensions__item_
    _PWS_Failed_NR_CGI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PWS_Failed_NR_CGI_Item._cont = ASN1Dict([
        (u'nRCGI', _PWS_Failed_NR_CGI_Item_nRCGI),
        (u'numberOfBroadcasts', _PWS_Failed_NR_CGI_Item_numberOfBroadcasts),
        (u'iE-Extensions', _PWS_Failed_NR_CGI_Item_iE_Extensions),
        ])
    PWS_Failed_NR_CGI_Item._ext = []
    
    #-----< PWS-Failed-NR-CGI-ItemExtIEs >-----#
    PWS_Failed_NR_CGI_ItemExtIEs = CLASS(name=u'PWS-Failed-NR-CGI-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PWS_Failed_NR_CGI_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PWSSystemInformation >-----#
    PWSSystemInformation = SEQ(name=u'PWSSystemInformation', mode=MODE_TYPE)
    _PWSSystemInformation_sIBtype = INT(name=u'sIBtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SIBType-PWS')))
    _PWSSystemInformation_sIBmessage = OCT_STR(name=u'sIBmessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PWSSystemInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PWSSystemInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PWSSystemInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PWSSystemInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList')))
    ____PWSSystemInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'reject'), (u'Extension', _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab_at = None
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PWSSystemInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PWSSystemInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PWSSystemInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PWSSystemInformation_iE_Extensions__item__id),
        (u'criticality', ___PWSSystemInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PWSSystemInformation_iE_Extensions__item__extensionValue),
        ])
    __PWSSystemInformation_iE_Extensions__item_._ext = None
    _PWSSystemInformation_iE_Extensions._cont = __PWSSystemInformation_iE_Extensions__item_
    _PWSSystemInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PWSSystemInformation._cont = ASN1Dict([
        (u'sIBtype', _PWSSystemInformation_sIBtype),
        (u'sIBmessage', _PWSSystemInformation_sIBmessage),
        (u'iE-Extensions', _PWSSystemInformation_iE_Extensions),
        ])
    PWSSystemInformation._ext = []
    
    #-----< PWSSystemInformationExtIEs >-----#
    PWSSystemInformationExtIEs = CLASS(name=u'PWSSystemInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PWSSystemInformationExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    _PWSSystemInformationExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList')))
    PWSSystemInformationExtIEs._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _PWSSystemInformationExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'reject'), (u'Extension', _PWSSystemInformationExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name=u'PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([(u'immediate-MDT', 0), (u'logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< QCI >-----#
    QCI = INT(name=u'QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< QoS-Characteristics >-----#
    QoS_Characteristics = CHOICE(name=u'QoS-Characteristics', mode=MODE_TYPE)
    _QoS_Characteristics_non_Dynamic_5QI = SEQ(name=u'non-Dynamic-5QI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonDynamic5QIDescriptor')))
    _QoS_Characteristics_dynamic_5QI = SEQ(name=u'dynamic-5QI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Dynamic5QIDescriptor')))
    _QoS_Characteristics_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __QoS_Characteristics_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___QoS_Characteristics_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_id._const_tab = ___QoS_Characteristics_choice_extension_id_tab
    __QoS_Characteristics_choice_extension_id._const_tab_at = None
    __QoS_Characteristics_choice_extension_id._const_tab_id = u'id'
    __QoS_Characteristics_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___QoS_Characteristics_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_criticality._const_tab = ___QoS_Characteristics_choice_extension_criticality_tab
    __QoS_Characteristics_choice_extension_criticality._const_tab_at = ('..', u'id')
    __QoS_Characteristics_choice_extension_criticality._const_tab_id = u'criticality'
    __QoS_Characteristics_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___QoS_Characteristics_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_value._const_tab = ___QoS_Characteristics_choice_extension_value_tab
    __QoS_Characteristics_choice_extension_value._const_tab_at = ('..', u'id')
    __QoS_Characteristics_choice_extension_value._const_tab_id = u'Value'
    _QoS_Characteristics_choice_extension._cont = ASN1Dict([
        (u'id', __QoS_Characteristics_choice_extension_id),
        (u'criticality', __QoS_Characteristics_choice_extension_criticality),
        (u'value', __QoS_Characteristics_choice_extension_value),
        ])
    _QoS_Characteristics_choice_extension._ext = None
    QoS_Characteristics._cont = ASN1Dict([
        (u'non-Dynamic-5QI', _QoS_Characteristics_non_Dynamic_5QI),
        (u'dynamic-5QI', _QoS_Characteristics_dynamic_5QI),
        (u'choice-extension', _QoS_Characteristics_choice_extension),
        ])
    QoS_Characteristics._ext = None
    
    #-----< QoS-Characteristics-ExtIEs >-----#
    QoS_Characteristics_ExtIEs = CLASS(name=u'QoS-Characteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    QoS_Characteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoSFlowIdentifier >-----#
    QoSFlowIdentifier = INT(name=u'QoSFlowIdentifier', mode=MODE_TYPE)
    QoSFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< QoSFlowLevelQoSParameters >-----#
    QoSFlowLevelQoSParameters = SEQ(name=u'QoSFlowLevelQoSParameters', mode=MODE_TYPE)
    _QoSFlowLevelQoSParameters_qoS_Characteristics = CHOICE(name=u'qoS-Characteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoS-Characteristics')))
    _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority = SEQ(name=u'nGRANallocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANAllocationAndRetentionPriority')))
    _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information = SEQ(name=u'gBR-QoS-Flow-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GBR-QoSFlowInformation')), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute = ENUM(name=u'reflective-QoS-Attribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._cont = ASN1Dict([(u'subject-to', 0)])
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._ext = []
    _QoSFlowLevelQoSParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoSFlowLevelQoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDUSessionID')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QosMonitoringRequest')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 436), (u'criticality', u'ignore'), (u'Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QoSFlowLevelQoSParameters_iE_Extensions__item__id),
        (u'criticality', ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue),
        ])
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._ext = None
    _QoSFlowLevelQoSParameters_iE_Extensions._cont = __QoSFlowLevelQoSParameters_iE_Extensions__item_
    _QoSFlowLevelQoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoSFlowLevelQoSParameters._cont = ASN1Dict([
        (u'qoS-Characteristics', _QoSFlowLevelQoSParameters_qoS_Characteristics),
        (u'nGRANallocationRetentionPriority', _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority),
        (u'gBR-QoS-Flow-Information', _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information),
        (u'reflective-QoS-Attribute', _QoSFlowLevelQoSParameters_reflective_QoS_Attribute),
        (u'iE-Extensions', _QoSFlowLevelQoSParameters_iE_Extensions),
        ])
    QoSFlowLevelQoSParameters._ext = None
    
    #-----< QoSFlowLevelQoSParameters-ExtIEs >-----#
    QoSFlowLevelQoSParameters_ExtIEs = CLASS(name=u'QoSFlowLevelQoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDUSessionID')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QosMonitoringRequest')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    QoSFlowLevelQoSParameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 436), (u'criticality', u'ignore'), (u'Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QoSFlowMappingIndication >-----#
    QoSFlowMappingIndication = ENUM(name=u'QoSFlowMappingIndication', mode=MODE_TYPE)
    QoSFlowMappingIndication._cont = ASN1Dict([(u'ul', 0), (u'dl', 1)])
    QoSFlowMappingIndication._ext = []
    
    #-----< QoSInformation >-----#
    QoSInformation = CHOICE(name=u'QoSInformation', mode=MODE_TYPE)
    _QoSInformation_eUTRANQoS = SEQ(name=u'eUTRANQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRANQoS')))
    _QoSInformation_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __QoSInformation_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___QoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____QoSInformation_choice_extension_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Information')))
    ___QoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 164), (u'criticality', u'ignore'), (u'Value', ____QoSInformation_choice_extension_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __QoSInformation_choice_extension_id._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_id._const_tab_at = None
    __QoSInformation_choice_extension_id._const_tab_id = u'id'
    __QoSInformation_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __QoSInformation_choice_extension_criticality._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_criticality._const_tab_at = ('..', u'id')
    __QoSInformation_choice_extension_criticality._const_tab_id = u'criticality'
    __QoSInformation_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __QoSInformation_choice_extension_value._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_value._const_tab_at = ('..', u'id')
    __QoSInformation_choice_extension_value._const_tab_id = u'Value'
    _QoSInformation_choice_extension._cont = ASN1Dict([
        (u'id', __QoSInformation_choice_extension_id),
        (u'criticality', __QoSInformation_choice_extension_criticality),
        (u'value', __QoSInformation_choice_extension_value),
        ])
    _QoSInformation_choice_extension._ext = None
    QoSInformation._cont = ASN1Dict([
        (u'eUTRANQoS', _QoSInformation_eUTRANQoS),
        (u'choice-extension', _QoSInformation_choice_extension),
        ])
    QoSInformation._ext = None
    
    #-----< QoSInformation-ExtIEs >-----#
    QoSInformation_ExtIEs = CLASS(name=u'QoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _QoSInformation_ExtIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Information')))
    QoSInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 164), (u'criticality', u'ignore'), (u'Value', _QoSInformation_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< QosMonitoringRequest >-----#
    QosMonitoringRequest = ENUM(name=u'QosMonitoringRequest', mode=MODE_TYPE)
    QosMonitoringRequest._cont = ASN1Dict([(u'ul', 0), (u'dl', 1), (u'both', 2), (u'stop', 3)])
    QosMonitoringRequest._ext = [u'stop']
    
    #-----< QoSParaSetIndex >-----#
    QoSParaSetIndex = INT(name=u'QoSParaSetIndex', mode=MODE_TYPE)
    QoSParaSetIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< QoSParaSetNotifyIndex >-----#
    QoSParaSetNotifyIndex = INT(name=u'QoSParaSetNotifyIndex', mode=MODE_TYPE)
    QoSParaSetNotifyIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[])
    
    #-----< RACH-Config-Common >-----#
    RACH_Config_Common = OCT_STR(name=u'RACH-Config-Common', mode=MODE_TYPE)
    
    #-----< RACH-Config-Common-IAB >-----#
    RACH_Config_Common_IAB = OCT_STR(name=u'RACH-Config-Common-IAB', mode=MODE_TYPE)
    
    #-----< RACHReportContainer >-----#
    RACHReportContainer = OCT_STR(name=u'RACHReportContainer', mode=MODE_TYPE)
    
    #-----< RACHReportInformationList >-----#
    RACHReportInformationList = SEQ_OF(name=u'RACHReportInformationList', mode=MODE_TYPE)
    _RACHReportInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationItem')))
    RACHReportInformationList._cont = _RACHReportInformationList__item_
    RACHReportInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RACHReportInformationItem >-----#
    RACHReportInformationItem = SEQ(name=u'RACHReportInformationItem', mode=MODE_TYPE)
    _RACHReportInformationItem_rACHReportContainer = OCT_STR(name=u'rACHReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACHReportContainer')))
    _RACHReportInformationItem_uEAssitantIdentifier = INT(name=u'uEAssitantIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _RACHReportInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACHReportInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RACHReportInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RACHReportInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab = ____RACHReportInformationItem_iE_Extensions__item__id_tab
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RACHReportInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RACHReportInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab = ____RACHReportInformationItem_iE_Extensions__item__criticality_tab
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab = ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RACHReportInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RACHReportInformationItem_iE_Extensions__item__id),
        (u'criticality', ___RACHReportInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RACHReportInformationItem_iE_Extensions__item__extensionValue),
        ])
    __RACHReportInformationItem_iE_Extensions__item_._ext = None
    _RACHReportInformationItem_iE_Extensions._cont = __RACHReportInformationItem_iE_Extensions__item_
    _RACHReportInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACHReportInformationItem._cont = ASN1Dict([
        (u'rACHReportContainer', _RACHReportInformationItem_rACHReportContainer),
        (u'uEAssitantIdentifier', _RACHReportInformationItem_uEAssitantIdentifier),
        (u'iE-Extensions', _RACHReportInformationItem_iE_Extensions),
        ])
    RACHReportInformationItem._ext = []
    
    #-----< RACHReportInformationItem-ExtIEs >-----#
    RACHReportInformationItem_ExtIEs = CLASS(name=u'RACHReportInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RACHReportInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioResourceStatus >-----#
    RadioResourceStatus = SEQ(name=u'RadioResourceStatus', mode=MODE_TYPE)
    _RadioResourceStatus_sSBAreaRadioResourceStatusList = SEQ_OF(name=u'sSBAreaRadioResourceStatusList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaRadioResourceStatusList')))
    _RadioResourceStatus_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RadioResourceStatus_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_id = u'id'
    ___RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioResourceStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RadioResourceStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____RadioResourceStatus_iE_Extensions__item__criticality_tab
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioResourceStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RadioResourceStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____RadioResourceStatus_iE_Extensions__item__extensionValue_tab
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RadioResourceStatus_iE_Extensions__item__id),
        (u'criticality', ___RadioResourceStatus_iE_Extensions__item__criticality),
        (u'extensionValue', ___RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __RadioResourceStatus_iE_Extensions__item_._ext = None
    _RadioResourceStatus_iE_Extensions._cont = __RadioResourceStatus_iE_Extensions__item_
    _RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioResourceStatus._cont = ASN1Dict([
        (u'sSBAreaRadioResourceStatusList', _RadioResourceStatus_sSBAreaRadioResourceStatusList),
        (u'iE-Extensions', _RadioResourceStatus_iE_Extensions),
        ])
    RadioResourceStatus._ext = None
    
    #-----< RadioResourceStatus-ExtIEs >-----#
    RadioResourceStatus_ExtIEs = CLASS(name=u'RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAC >-----#
    RANAC = INT(name=u'RANAC', mode=MODE_TYPE)
    RANAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RAN-MeasurementID >-----#
    RAN_MeasurementID = INT(name=u'RAN-MeasurementID', mode=MODE_TYPE)
    RAN_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< RAN-UE-MeasurementID >-----#
    RAN_UE_MeasurementID = INT(name=u'RAN-UE-MeasurementID', mode=MODE_TYPE)
    RAN_UE_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< RANUEID >-----#
    RANUEID = OCT_STR(name=u'RANUEID', mode=MODE_TYPE)
    RANUEID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RANUEPagingIdentity >-----#
    RANUEPagingIdentity = SEQ(name=u'RANUEPagingIdentity', mode=MODE_TYPE)
    _RANUEPagingIdentity_iRNTI = BIT_STR(name=u'iRNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RANUEPagingIdentity_iRNTI._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _RANUEPagingIdentity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANUEPagingIdentity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RANUEPagingIdentity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RANUEPagingIdentity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__id_tab
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab_at = None
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab_id = u'id'
    ___RANUEPagingIdentity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RANUEPagingIdentity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RANUEPagingIdentity_iE_Extensions__item__id),
        (u'criticality', ___RANUEPagingIdentity_iE_Extensions__item__criticality),
        (u'extensionValue', ___RANUEPagingIdentity_iE_Extensions__item__extensionValue),
        ])
    __RANUEPagingIdentity_iE_Extensions__item_._ext = None
    _RANUEPagingIdentity_iE_Extensions._cont = __RANUEPagingIdentity_iE_Extensions__item_
    _RANUEPagingIdentity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANUEPagingIdentity._cont = ASN1Dict([
        (u'iRNTI', _RANUEPagingIdentity_iRNTI),
        (u'iE-Extensions', _RANUEPagingIdentity_iE_Extensions),
        ])
    RANUEPagingIdentity._ext = None
    
    #-----< RANUEPagingIdentity-ExtIEs >-----#
    RANUEPagingIdentity_ExtIEs = CLASS(name=u'RANUEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RANUEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAT-FrequencyPriorityInformation >-----#
    RAT_FrequencyPriorityInformation = CHOICE(name=u'RAT-FrequencyPriorityInformation', mode=MODE_TYPE)
    _RAT_FrequencyPriorityInformation_eNDC = INT(name=u'eNDC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SubscriberProfileIDforRFP')))
    _RAT_FrequencyPriorityInformation_nGRAN = INT(name=u'nGRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencySelectionPriority')))
    _RAT_FrequencyPriorityInformation_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RAT_FrequencyPriorityInformation_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___RAT_FrequencyPriorityInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_id_tab
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab_at = None
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab_id = u'id'
    __RAT_FrequencyPriorityInformation_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab_at = ('..', u'id')
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab_id = u'criticality'
    __RAT_FrequencyPriorityInformation_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___RAT_FrequencyPriorityInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_value_tab
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab_at = ('..', u'id')
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab_id = u'Value'
    _RAT_FrequencyPriorityInformation_choice_extension._cont = ASN1Dict([
        (u'id', __RAT_FrequencyPriorityInformation_choice_extension_id),
        (u'criticality', __RAT_FrequencyPriorityInformation_choice_extension_criticality),
        (u'value', __RAT_FrequencyPriorityInformation_choice_extension_value),
        ])
    _RAT_FrequencyPriorityInformation_choice_extension._ext = None
    RAT_FrequencyPriorityInformation._cont = ASN1Dict([
        (u'eNDC', _RAT_FrequencyPriorityInformation_eNDC),
        (u'nGRAN', _RAT_FrequencyPriorityInformation_nGRAN),
        (u'choice-extension', _RAT_FrequencyPriorityInformation_choice_extension),
        ])
    RAT_FrequencyPriorityInformation._ext = None
    
    #-----< RAT-FrequencyPriorityInformation-ExtIEs >-----#
    RAT_FrequencyPriorityInformation_ExtIEs = CLASS(name=u'RAT-FrequencyPriorityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    RAT_FrequencyPriorityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAT-FrequencySelectionPriority >-----#
    RAT_FrequencySelectionPriority = INT(name=u'RAT-FrequencySelectionPriority', mode=MODE_TYPE)
    RAT_FrequencySelectionPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Reestablishment-Indication >-----#
    Reestablishment_Indication = ENUM(name=u'Reestablishment-Indication', mode=MODE_TYPE)
    Reestablishment_Indication._cont = ASN1Dict([(u'reestablished', 0)])
    Reestablishment_Indication._ext = []
    
    #-----< ReferencePoint >-----#
    ReferencePoint = CHOICE(name=u'ReferencePoint', mode=MODE_TYPE)
    _ReferencePoint_coordinateID = INT(name=u'coordinateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CoordinateID')))
    _ReferencePoint_referencePointCoordinate = SEQ(name=u'referencePointCoordinate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AccessPointPosition')))
    _ReferencePoint_referencePointCoordinateHA = SEQ(name=u'referencePointCoordinateHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _ReferencePoint_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ReferencePoint_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ReferencePoint_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_id._const_tab = ___ReferencePoint_choice_Extension_id_tab
    __ReferencePoint_choice_Extension_id._const_tab_at = None
    __ReferencePoint_choice_Extension_id._const_tab_id = u'id'
    __ReferencePoint_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ReferencePoint_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_criticality._const_tab = ___ReferencePoint_choice_Extension_criticality_tab
    __ReferencePoint_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __ReferencePoint_choice_Extension_criticality._const_tab_id = u'criticality'
    __ReferencePoint_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ReferencePoint_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_value._const_tab = ___ReferencePoint_choice_Extension_value_tab
    __ReferencePoint_choice_Extension_value._const_tab_at = ('..', u'id')
    __ReferencePoint_choice_Extension_value._const_tab_id = u'Value'
    _ReferencePoint_choice_Extension._cont = ASN1Dict([
        (u'id', __ReferencePoint_choice_Extension_id),
        (u'criticality', __ReferencePoint_choice_Extension_criticality),
        (u'value', __ReferencePoint_choice_Extension_value),
        ])
    _ReferencePoint_choice_Extension._ext = None
    ReferencePoint._cont = ASN1Dict([
        (u'coordinateID', _ReferencePoint_coordinateID),
        (u'referencePointCoordinate', _ReferencePoint_referencePointCoordinate),
        (u'referencePointCoordinateHA', _ReferencePoint_referencePointCoordinateHA),
        (u'choice-Extension', _ReferencePoint_choice_Extension),
        ])
    ReferencePoint._ext = None
    
    #-----< ReferencePoint-ExtIEs >-----#
    ReferencePoint_ExtIEs = CLASS(name=u'ReferencePoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ReferencePoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferenceSFN >-----#
    ReferenceSFN = INT(name=u'ReferenceSFN', mode=MODE_TYPE)
    ReferenceSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< ReferenceSignal >-----#
    ReferenceSignal = CHOICE(name=u'ReferenceSignal', mode=MODE_TYPE)
    _ReferenceSignal_nZP_CSI_RS = INT(name=u'nZP-CSI-RS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NZP-CSI-RS-ResourceID')))
    _ReferenceSignal_sSB = SEQ(name=u'sSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _ReferenceSignal_sRS = INT(name=u'sRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    _ReferenceSignal_positioningSRS = INT(name=u'positioningSRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    _ReferenceSignal_dL_PRS = SEQ(name=u'dL-PRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRS')))
    _ReferenceSignal_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ReferenceSignal_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ReferenceSignal_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_id._const_tab = ___ReferenceSignal_choice_extension_id_tab
    __ReferenceSignal_choice_extension_id._const_tab_at = None
    __ReferenceSignal_choice_extension_id._const_tab_id = u'id'
    __ReferenceSignal_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ReferenceSignal_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_criticality._const_tab = ___ReferenceSignal_choice_extension_criticality_tab
    __ReferenceSignal_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ReferenceSignal_choice_extension_criticality._const_tab_id = u'criticality'
    __ReferenceSignal_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ReferenceSignal_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_value._const_tab = ___ReferenceSignal_choice_extension_value_tab
    __ReferenceSignal_choice_extension_value._const_tab_at = ('..', u'id')
    __ReferenceSignal_choice_extension_value._const_tab_id = u'Value'
    _ReferenceSignal_choice_extension._cont = ASN1Dict([
        (u'id', __ReferenceSignal_choice_extension_id),
        (u'criticality', __ReferenceSignal_choice_extension_criticality),
        (u'value', __ReferenceSignal_choice_extension_value),
        ])
    _ReferenceSignal_choice_extension._ext = None
    ReferenceSignal._cont = ASN1Dict([
        (u'nZP-CSI-RS', _ReferenceSignal_nZP_CSI_RS),
        (u'sSB', _ReferenceSignal_sSB),
        (u'sRS', _ReferenceSignal_sRS),
        (u'positioningSRS', _ReferenceSignal_positioningSRS),
        (u'dL-PRS', _ReferenceSignal_dL_PRS),
        (u'choice-extension', _ReferenceSignal_choice_extension),
        ])
    ReferenceSignal._ext = None
    
    #-----< ReferenceSignal-ExtIEs >-----#
    ReferenceSignal_ExtIEs = CLASS(name=u'ReferenceSignal-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ReferenceSignal_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeCartesianLocation >-----#
    RelativeCartesianLocation = SEQ(name=u'RelativeCartesianLocation', mode=MODE_TYPE)
    _RelativeCartesianLocation_xYZunit = ENUM(name=u'xYZunit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xYZunit._cont = ASN1Dict([(u'mm', 0), (u'cm', 1), (u'dm', 2)])
    _RelativeCartesianLocation_xYZunit._ext = []
    _RelativeCartesianLocation_xvalue = INT(name=u'xvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_yvalue = INT(name=u'yvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_yvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_zvalue = INT(name=u'zvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_zvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _RelativeCartesianLocation_locationUncertainty = SEQ(name=u'locationUncertainty', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LocationUncertainty')))
    _RelativeCartesianLocation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeCartesianLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RelativeCartesianLocation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__id_tab
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_at = None
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RelativeCartesianLocation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RelativeCartesianLocation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RelativeCartesianLocation_iE_Extensions__item__id),
        (u'criticality', ___RelativeCartesianLocation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RelativeCartesianLocation_iE_Extensions__item__extensionValue),
        ])
    __RelativeCartesianLocation_iE_Extensions__item_._ext = None
    _RelativeCartesianLocation_iE_Extensions._cont = __RelativeCartesianLocation_iE_Extensions__item_
    _RelativeCartesianLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeCartesianLocation._cont = ASN1Dict([
        (u'xYZunit', _RelativeCartesianLocation_xYZunit),
        (u'xvalue', _RelativeCartesianLocation_xvalue),
        (u'yvalue', _RelativeCartesianLocation_yvalue),
        (u'zvalue', _RelativeCartesianLocation_zvalue),
        (u'locationUncertainty', _RelativeCartesianLocation_locationUncertainty),
        (u'iE-Extensions', _RelativeCartesianLocation_iE_Extensions),
        ])
    RelativeCartesianLocation._ext = None
    
    #-----< RelativeCartesianLocation-ExtIEs >-----#
    RelativeCartesianLocation_ExtIEs = CLASS(name=u'RelativeCartesianLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RelativeCartesianLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeGeodeticLocation >-----#
    RelativeGeodeticLocation = SEQ(name=u'RelativeGeodeticLocation', mode=MODE_TYPE)
    _RelativeGeodeticLocation_milli_Arc_SecondUnits = ENUM(name=u'milli-Arc-SecondUnits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._cont = ASN1Dict([(u'zerodot03', 0), (u'zerodot3', 1), (u'three', 2)])
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._ext = []
    _RelativeGeodeticLocation_heightUnits = ENUM(name=u'heightUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_heightUnits._cont = ASN1Dict([(u'mm', 0), (u'cm', 1), (u'm', 2)])
    _RelativeGeodeticLocation_heightUnits._ext = []
    _RelativeGeodeticLocation_deltaLatitude = INT(name=u'deltaLatitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaLongitude = INT(name=u'deltaLongitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaHeight = INT(name=u'deltaHeight', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_locationUncertainty = SEQ(name=u'locationUncertainty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LocationUncertainty')))
    _RelativeGeodeticLocation_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeGeodeticLocation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RelativeGeodeticLocation_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__id_tab
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_at = None
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_id = u'id'
    ___RelativeGeodeticLocation_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __RelativeGeodeticLocation_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___RelativeGeodeticLocation_iE_extensions__item__id),
        (u'criticality', ___RelativeGeodeticLocation_iE_extensions__item__criticality),
        (u'extensionValue', ___RelativeGeodeticLocation_iE_extensions__item__extensionValue),
        ])
    __RelativeGeodeticLocation_iE_extensions__item_._ext = None
    _RelativeGeodeticLocation_iE_extensions._cont = __RelativeGeodeticLocation_iE_extensions__item_
    _RelativeGeodeticLocation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeGeodeticLocation._cont = ASN1Dict([
        (u'milli-Arc-SecondUnits', _RelativeGeodeticLocation_milli_Arc_SecondUnits),
        (u'heightUnits', _RelativeGeodeticLocation_heightUnits),
        (u'deltaLatitude', _RelativeGeodeticLocation_deltaLatitude),
        (u'deltaLongitude', _RelativeGeodeticLocation_deltaLongitude),
        (u'deltaHeight', _RelativeGeodeticLocation_deltaHeight),
        (u'locationUncertainty', _RelativeGeodeticLocation_locationUncertainty),
        (u'iE-extensions', _RelativeGeodeticLocation_iE_extensions),
        ])
    RelativeGeodeticLocation._ext = None
    
    #-----< RelativeGeodeticLocation-ExtIEs >-----#
    RelativeGeodeticLocation_ExtIEs = CLASS(name=u'RelativeGeodeticLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RelativeGeodeticLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferenceTime >-----#
    ReferenceTime = OCT_STR(name=u'ReferenceTime', mode=MODE_TYPE)
    
    #-----< RegistrationRequest >-----#
    RegistrationRequest = ENUM(name=u'RegistrationRequest', mode=MODE_TYPE)
    RegistrationRequest._cont = ASN1Dict([(u'start', 0), (u'stop', 1), (u'add', 2)])
    RegistrationRequest._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name=u'ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name=u'ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([(u'ms500', 0), (u'ms1000', 1), (u'ms2000', 2), (u'ms5000', 3), (u'ms10000', 4)])
    ReportingPeriodicity._ext = []
    
    #-----< RequestedBandCombinationIndex >-----#
    RequestedBandCombinationIndex = OCT_STR(name=u'RequestedBandCombinationIndex', mode=MODE_TYPE)
    
    #-----< RequestedFeatureSetEntryIndex >-----#
    RequestedFeatureSetEntryIndex = OCT_STR(name=u'RequestedFeatureSetEntryIndex', mode=MODE_TYPE)
    
    #-----< RequestedP-MaxFR2 >-----#
    RequestedP_MaxFR2 = OCT_STR(name=u'RequestedP-MaxFR2', mode=MODE_TYPE)
    
    #-----< Requested-PDCCH-BlindDetectionSCG >-----#
    Requested_PDCCH_BlindDetectionSCG = OCT_STR(name=u'Requested-PDCCH-BlindDetectionSCG', mode=MODE_TYPE)
    
    #-----< RequestedSRSTransmissionCharacteristics >-----#
    RequestedSRSTransmissionCharacteristics = SEQ(name=u'RequestedSRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions = INT(name=u'numberOfTransmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=[], er=[])
    _RequestedSRSTransmissionCharacteristics_resourceType = ENUM(name=u'resourceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedSRSTransmissionCharacteristics_resourceType._cont = ASN1Dict([(u'periodic', 0), (u'semi-persistent', 1), (u'aperiodic', 2)])
    _RequestedSRSTransmissionCharacteristics_resourceType._ext = []
    _RequestedSRSTransmissionCharacteristics_bandwidthSRS = CHOICE(name=u'bandwidthSRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BandwidthSRS')))
    _RequestedSRSTransmissionCharacteristics_sRSResourceSetList = SEQ_OF(name=u'sRSResourceSetList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetList')), opt=True)
    _RequestedSRSTransmissionCharacteristics_sSBInformation = SEQ(name=u'sSBInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformation')), opt=True)
    _RequestedSRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SrsFrequency')))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 431), (u'criticality', u'ignore'), (u'Extension', _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = u'id'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id),
        (u'criticality', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        (u'extensionValue', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedSRSTransmissionCharacteristics._cont = ASN1Dict([
        (u'numberOfTransmissions', _RequestedSRSTransmissionCharacteristics_numberOfTransmissions),
        (u'resourceType', _RequestedSRSTransmissionCharacteristics_resourceType),
        (u'bandwidthSRS', _RequestedSRSTransmissionCharacteristics_bandwidthSRS),
        (u'sRSResourceSetList', _RequestedSRSTransmissionCharacteristics_sRSResourceSetList),
        (u'sSBInformation', _RequestedSRSTransmissionCharacteristics_sSBInformation),
        (u'iE-Extensions', _RequestedSRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedSRSTransmissionCharacteristics._ext = None
    
    #-----< RequestedSRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedSRSTransmissionCharacteristics_ExtIEs = CLASS(name=u'RequestedSRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SrsFrequency')))
    RequestedSRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 431), (u'criticality', u'ignore'), (u'Extension', _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestType >-----#
    RequestType = ENUM(name=u'RequestType', mode=MODE_TYPE)
    RequestType._cont = ASN1Dict([(u'offer', 0), (u'execution', 1)])
    RequestType._ext = []
    
    #-----< ResourceCoordinationEUTRACellInfo >-----#
    ResourceCoordinationEUTRACellInfo = SEQ(name=u'ResourceCoordinationEUTRACellInfo', mode=MODE_TYPE)
    _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info = CHOICE(name=u'eUTRA-Mode-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-Mode-Info')))
    _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration = SEQ(name=u'eUTRA-PRACH-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-PRACH-Configuration')))
    _ResourceCoordinationEUTRACellInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnorePRACHConfiguration')))
    ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab_at = None
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id),
        (u'criticality', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue),
        ])
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_._ext = None
    _ResourceCoordinationEUTRACellInfo_iE_Extensions._cont = __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_
    _ResourceCoordinationEUTRACellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceCoordinationEUTRACellInfo._cont = ASN1Dict([
        (u'eUTRA-Mode-Info', _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info),
        (u'eUTRA-PRACH-Configuration', _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration),
        (u'iE-Extensions', _ResourceCoordinationEUTRACellInfo_iE_Extensions),
        ])
    ResourceCoordinationEUTRACellInfo._ext = []
    
    #-----< ResourceCoordinationEUTRACellInfo-ExtIEs >-----#
    ResourceCoordinationEUTRACellInfo_ExtIEs = CLASS(name=u'ResourceCoordinationEUTRACellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnorePRACHConfiguration')))
    ResourceCoordinationEUTRACellInfo_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceCoordinationTransferInformation >-----#
    ResourceCoordinationTransferInformation = SEQ(name=u'ResourceCoordinationTransferInformation', mode=MODE_TYPE)
    _ResourceCoordinationTransferInformation_meNB_Cell_ID = BIT_STR(name=u'meNB-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Cell-ID')))
    _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo = SEQ(name=u'resourceCoordinationEUTRACellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationEUTRACellInfo')), opt=True)
    _ResourceCoordinationTransferInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceCoordinationTransferInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab_at = None
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceCoordinationTransferInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceCoordinationTransferInformation_iE_Extensions__item__id),
        (u'criticality', ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue),
        ])
    __ResourceCoordinationTransferInformation_iE_Extensions__item_._ext = None
    _ResourceCoordinationTransferInformation_iE_Extensions._cont = __ResourceCoordinationTransferInformation_iE_Extensions__item_
    _ResourceCoordinationTransferInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceCoordinationTransferInformation._cont = ASN1Dict([
        (u'meNB-Cell-ID', _ResourceCoordinationTransferInformation_meNB_Cell_ID),
        (u'resourceCoordinationEUTRACellInfo', _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo),
        (u'iE-Extensions', _ResourceCoordinationTransferInformation_iE_Extensions),
        ])
    ResourceCoordinationTransferInformation._ext = []
    
    #-----< ResourceCoordinationTransferInformation-ExtIEs >-----#
    ResourceCoordinationTransferInformation_ExtIEs = CLASS(name=u'ResourceCoordinationTransferInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceCoordinationTransferInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceCoordinationTransferContainer >-----#
    ResourceCoordinationTransferContainer = OCT_STR(name=u'ResourceCoordinationTransferContainer', mode=MODE_TYPE)
    
    #-----< ResourceSetType >-----#
    ResourceSetType = CHOICE(name=u'ResourceSetType', mode=MODE_TYPE)
    _ResourceSetType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypePeriodic')))
    _ResourceSetType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypeSemi-persistent')))
    _ResourceSetType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypeAperiodic')))
    _ResourceSetType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceSetType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ResourceSetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_id._const_tab = ___ResourceSetType_choice_extension_id_tab
    __ResourceSetType_choice_extension_id._const_tab_at = None
    __ResourceSetType_choice_extension_id._const_tab_id = u'id'
    __ResourceSetType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_criticality._const_tab = ___ResourceSetType_choice_extension_criticality_tab
    __ResourceSetType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceSetType_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceSetType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceSetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_value._const_tab = ___ResourceSetType_choice_extension_value_tab
    __ResourceSetType_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceSetType_choice_extension_value._const_tab_id = u'Value'
    _ResourceSetType_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceSetType_choice_extension_id),
        (u'criticality', __ResourceSetType_choice_extension_criticality),
        (u'value', __ResourceSetType_choice_extension_value),
        ])
    _ResourceSetType_choice_extension._ext = None
    ResourceSetType._cont = ASN1Dict([
        (u'periodic', _ResourceSetType_periodic),
        (u'semi-persistent', _ResourceSetType_semi_persistent),
        (u'aperiodic', _ResourceSetType_aperiodic),
        (u'choice-extension', _ResourceSetType_choice_extension),
        ])
    ResourceSetType._ext = None
    
    #-----< ResourceSetType-ExtIEs >-----#
    ResourceSetType_ExtIEs = CLASS(name=u'ResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypePeriodic >-----#
    ResourceSetTypePeriodic = SEQ(name=u'ResourceSetTypePeriodic', mode=MODE_TYPE)
    _ResourceSetTypePeriodic_periodicSet = ENUM(name=u'periodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypePeriodic_periodicSet._cont = ASN1Dict([(u'true', 0)])
    _ResourceSetTypePeriodic_periodicSet._ext = []
    _ResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypePeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypePeriodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypePeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceSetTypePeriodic_iE_Extensions._cont = __ResourceSetTypePeriodic_iE_Extensions__item_
    _ResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypePeriodic._cont = ASN1Dict([
        (u'periodicSet', _ResourceSetTypePeriodic_periodicSet),
        (u'iE-Extensions', _ResourceSetTypePeriodic_iE_Extensions),
        ])
    ResourceSetTypePeriodic._ext = None
    
    #-----< ResourceSetTypePeriodic-ExtIEs >-----#
    ResourceSetTypePeriodic_ExtIEs = CLASS(name=u'ResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeSemi-persistent >-----#
    ResourceSetTypeSemi_persistent = SEQ(name=u'ResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceSetTypeSemi_persistent_semi_persistentSet = ENUM(name=u'semi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeSemi_persistent_semi_persistentSet._cont = ASN1Dict([(u'true', 0)])
    _ResourceSetTypeSemi_persistent_semi_persistentSet._ext = []
    _ResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceSetTypeSemi_persistent_iE_Extensions._cont = __ResourceSetTypeSemi_persistent_iE_Extensions__item_
    _ResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeSemi_persistent._cont = ASN1Dict([
        (u'semi-persistentSet', _ResourceSetTypeSemi_persistent_semi_persistentSet),
        (u'iE-Extensions', _ResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    ResourceSetTypeSemi_persistent._ext = None
    
    #-----< ResourceSetTypeSemi-persistent-ExtIEs >-----#
    ResourceSetTypeSemi_persistent_ExtIEs = CLASS(name=u'ResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeAperiodic >-----#
    ResourceSetTypeAperiodic = SEQ(name=u'ResourceSetTypeAperiodic', mode=MODE_TYPE)
    _ResourceSetTypeAperiodic_sRSResourceTrigger_List = INT(name=u'sRSResourceTrigger-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_sRSResourceTrigger_List._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ResourceSetTypeAperiodic_slotoffset = INT(name=u'slotoffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_slotoffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypeAperiodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceSetTypeAperiodic_iE_Extensions._cont = __ResourceSetTypeAperiodic_iE_Extensions__item_
    _ResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeAperiodic._cont = ASN1Dict([
        (u'sRSResourceTrigger-List', _ResourceSetTypeAperiodic_sRSResourceTrigger_List),
        (u'slotoffset', _ResourceSetTypeAperiodic_slotoffset),
        (u'iE-Extensions', _ResourceSetTypeAperiodic_iE_Extensions),
        ])
    ResourceSetTypeAperiodic._ext = None
    
    #-----< ResourceSetTypeAperiodic-ExtIEs >-----#
    ResourceSetTypeAperiodic_ExtIEs = CLASS(name=u'ResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name=u'RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=[], er=[])
    
    #-----< ReportingRequestType >-----#
    ReportingRequestType = SEQ(name=u'ReportingRequestType', mode=MODE_TYPE)
    _ReportingRequestType_eventType = ENUM(name=u'eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EventType')))
    _ReportingRequestType_reportingPeriodicityValue = INT(name=u'reportingPeriodicityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicityValue')), opt=True)
    _ReportingRequestType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportingRequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ReportingRequestType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ReportingRequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__id._const_tab = ____ReportingRequestType_iE_Extensions__item__id_tab
    ___ReportingRequestType_iE_Extensions__item__id._const_tab_at = None
    ___ReportingRequestType_iE_Extensions__item__id._const_tab_id = u'id'
    ___ReportingRequestType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ReportingRequestType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab = ____ReportingRequestType_iE_Extensions__item__criticality_tab
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ReportingRequestType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ReportingRequestType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab = ____ReportingRequestType_iE_Extensions__item__extensionValue_tab
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ReportingRequestType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ReportingRequestType_iE_Extensions__item__id),
        (u'criticality', ___ReportingRequestType_iE_Extensions__item__criticality),
        (u'extensionValue', ___ReportingRequestType_iE_Extensions__item__extensionValue),
        ])
    __ReportingRequestType_iE_Extensions__item_._ext = None
    _ReportingRequestType_iE_Extensions._cont = __ReportingRequestType_iE_Extensions__item_
    _ReportingRequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportingRequestType._cont = ASN1Dict([
        (u'eventType', _ReportingRequestType_eventType),
        (u'reportingPeriodicityValue', _ReportingRequestType_reportingPeriodicityValue),
        (u'iE-Extensions', _ReportingRequestType_iE_Extensions),
        ])
    ReportingRequestType._ext = None
    
    #-----< ReportingRequestType-ExtIEs >-----#
    ReportingRequestType_ExtIEs = CLASS(name=u'ReportingRequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ReportingRequestType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceType >-----#
    ResourceType = CHOICE(name=u'ResourceType', mode=MODE_TYPE)
    _ResourceType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePeriodic')))
    _ResourceType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeSemi-persistent')))
    _ResourceType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeAperiodic')))
    _ResourceType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ResourceType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_id._const_tab = ___ResourceType_choice_extension_id_tab
    __ResourceType_choice_extension_id._const_tab_at = None
    __ResourceType_choice_extension_id._const_tab_id = u'id'
    __ResourceType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_criticality._const_tab = ___ResourceType_choice_extension_criticality_tab
    __ResourceType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceType_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_value._const_tab = ___ResourceType_choice_extension_value_tab
    __ResourceType_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceType_choice_extension_value._const_tab_id = u'Value'
    _ResourceType_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceType_choice_extension_id),
        (u'criticality', __ResourceType_choice_extension_criticality),
        (u'value', __ResourceType_choice_extension_value),
        ])
    _ResourceType_choice_extension._ext = None
    ResourceType._cont = ASN1Dict([
        (u'periodic', _ResourceType_periodic),
        (u'semi-persistent', _ResourceType_semi_persistent),
        (u'aperiodic', _ResourceType_aperiodic),
        (u'choice-extension', _ResourceType_choice_extension),
        ])
    ResourceType._ext = None
    
    #-----< ResourceType-ExtIEs >-----#
    ResourceType_ExtIEs = CLASS(name=u'ResourceType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodic >-----#
    ResourceTypePeriodic = SEQ(name=u'ResourceTypePeriodic', mode=MODE_TYPE)
    _ResourceTypePeriodic_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16)])
    _ResourceTypePeriodic_periodicity._ext = []
    _ResourceTypePeriodic_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypePeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypePeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypePeriodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypePeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceTypePeriodic_iE_Extensions._cont = __ResourceTypePeriodic_iE_Extensions__item_
    _ResourceTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodic._cont = ASN1Dict([
        (u'periodicity', _ResourceTypePeriodic_periodicity),
        (u'offset', _ResourceTypePeriodic_offset),
        (u'iE-Extensions', _ResourceTypePeriodic_iE_Extensions),
        ])
    ResourceTypePeriodic._ext = None
    
    #-----< ResourceTypePeriodic-ExtIEs >-----#
    ResourceTypePeriodic_ExtIEs = CLASS(name=u'ResourceTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistent >-----#
    ResourceTypeSemi_persistent = SEQ(name=u'ResourceTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceTypeSemi_persistent_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16)])
    _ResourceTypeSemi_persistent_periodicity._ext = []
    _ResourceTypeSemi_persistent_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypeSemi_persistent_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeSemi_persistent_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistent_iE_Extensions._cont = __ResourceTypeSemi_persistent_iE_Extensions__item_
    _ResourceTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistent._cont = ASN1Dict([
        (u'periodicity', _ResourceTypeSemi_persistent_periodicity),
        (u'offset', _ResourceTypeSemi_persistent_offset),
        (u'iE-Extensions', _ResourceTypeSemi_persistent_iE_Extensions),
        ])
    ResourceTypeSemi_persistent._ext = None
    
    #-----< ResourceTypeSemi-persistent-ExtIEs >-----#
    ResourceTypeSemi_persistent_ExtIEs = CLASS(name=u'ResourceTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodic >-----#
    ResourceTypeAperiodic = SEQ(name=u'ResourceTypeAperiodic', mode=MODE_TYPE)
    _ResourceTypeAperiodic_aperiodicResourceType = ENUM(name=u'aperiodicResourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodic_aperiodicResourceType._cont = ASN1Dict([(u'true', 0)])
    _ResourceTypeAperiodic_aperiodicResourceType._ext = []
    _ResourceTypeAperiodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeAperiodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeAperiodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodic_iE_Extensions._cont = __ResourceTypeAperiodic_iE_Extensions__item_
    _ResourceTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodic._cont = ASN1Dict([
        (u'aperiodicResourceType', _ResourceTypeAperiodic_aperiodicResourceType),
        (u'iE-Extensions', _ResourceTypeAperiodic_iE_Extensions),
        ])
    ResourceTypeAperiodic._ext = None
    
    #-----< ResourceTypeAperiodic-ExtIEs >-----#
    ResourceTypeAperiodic_ExtIEs = CLASS(name=u'ResourceTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePos >-----#
    ResourceTypePos = CHOICE(name=u'ResourceTypePos', mode=MODE_TYPE)
    _ResourceTypePos_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePeriodicPos')))
    _ResourceTypePos_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeSemi-persistentPos')))
    _ResourceTypePos_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeAperiodicPos')))
    _ResourceTypePos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceTypePos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ResourceTypePos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_id._const_tab = ___ResourceTypePos_choice_extension_id_tab
    __ResourceTypePos_choice_extension_id._const_tab_at = None
    __ResourceTypePos_choice_extension_id._const_tab_id = u'id'
    __ResourceTypePos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceTypePos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_criticality._const_tab = ___ResourceTypePos_choice_extension_criticality_tab
    __ResourceTypePos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceTypePos_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceTypePos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceTypePos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_value._const_tab = ___ResourceTypePos_choice_extension_value_tab
    __ResourceTypePos_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceTypePos_choice_extension_value._const_tab_id = u'Value'
    _ResourceTypePos_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceTypePos_choice_extension_id),
        (u'criticality', __ResourceTypePos_choice_extension_criticality),
        (u'value', __ResourceTypePos_choice_extension_value),
        ])
    _ResourceTypePos_choice_extension._ext = None
    ResourceTypePos._cont = ASN1Dict([
        (u'periodic', _ResourceTypePos_periodic),
        (u'semi-persistent', _ResourceTypePos_semi_persistent),
        (u'aperiodic', _ResourceTypePos_aperiodic),
        (u'choice-extension', _ResourceTypePos_choice_extension),
        ])
    ResourceTypePos._ext = None
    
    #-----< ResourceTypePos-ExtIEs >-----#
    ResourceTypePos_ExtIEs = CLASS(name=u'ResourceTypePos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceTypePos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodicPos >-----#
    ResourceTypePeriodicPos = SEQ(name=u'ResourceTypePeriodicPos', mode=MODE_TYPE)
    _ResourceTypePeriodicPos_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16), (u'slot5120', 17), (u'slot10240', 18), (u'slot40960', 19), (u'slot81920', 20)])
    _ResourceTypePeriodicPos_periodicity._ext = []
    _ResourceTypePeriodicPos_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypePeriodicPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodicPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypePeriodicPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypePeriodicPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypePeriodicPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodicPos_iE_Extensions__item_._ext = None
    _ResourceTypePeriodicPos_iE_Extensions._cont = __ResourceTypePeriodicPos_iE_Extensions__item_
    _ResourceTypePeriodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodicPos._cont = ASN1Dict([
        (u'periodicity', _ResourceTypePeriodicPos_periodicity),
        (u'offset', _ResourceTypePeriodicPos_offset),
        (u'iE-Extensions', _ResourceTypePeriodicPos_iE_Extensions),
        ])
    ResourceTypePeriodicPos._ext = None
    
    #-----< ResourceTypePeriodicPos-ExtIEs >-----#
    ResourceTypePeriodicPos_ExtIEs = CLASS(name=u'ResourceTypePeriodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypePeriodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistentPos >-----#
    ResourceTypeSemi_persistentPos = SEQ(name=u'ResourceTypeSemi-persistentPos', mode=MODE_TYPE)
    _ResourceTypeSemi_persistentPos_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16), (u'slot5120', 17), (u'slot10240', 18), (u'slot40960', 19), (u'slot81920', 20)])
    _ResourceTypeSemi_persistentPos_periodicity._ext = []
    _ResourceTypeSemi_persistentPos_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypeSemi_persistentPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistentPos_iE_Extensions._cont = __ResourceTypeSemi_persistentPos_iE_Extensions__item_
    _ResourceTypeSemi_persistentPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistentPos._cont = ASN1Dict([
        (u'periodicity', _ResourceTypeSemi_persistentPos_periodicity),
        (u'offset', _ResourceTypeSemi_persistentPos_offset),
        (u'iE-Extensions', _ResourceTypeSemi_persistentPos_iE_Extensions),
        ])
    ResourceTypeSemi_persistentPos._ext = None
    
    #-----< ResourceTypeSemi-persistentPos-ExtIEs >-----#
    ResourceTypeSemi_persistentPos_ExtIEs = CLASS(name=u'ResourceTypeSemi-persistentPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistentPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodicPos >-----#
    ResourceTypeAperiodicPos = SEQ(name=u'ResourceTypeAperiodicPos', mode=MODE_TYPE)
    _ResourceTypeAperiodicPos_slotOffset = INT(name=u'slotOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodicPos_slotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceTypeAperiodicPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeAperiodicPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeAperiodicPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodicPos_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodicPos_iE_Extensions._cont = __ResourceTypeAperiodicPos_iE_Extensions__item_
    _ResourceTypeAperiodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodicPos._cont = ASN1Dict([
        (u'slotOffset', _ResourceTypeAperiodicPos_slotOffset),
        (u'iE-Extensions', _ResourceTypeAperiodicPos_iE_Extensions),
        ])
    ResourceTypeAperiodicPos._ext = None
    
    #-----< ResourceTypeAperiodicPos-ExtIEs >-----#
    ResourceTypeAperiodicPos_ExtIEs = CLASS(name=u'ResourceTypeAperiodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCDuplicationInformation >-----#
    RLCDuplicationInformation = SEQ(name=u'RLCDuplicationInformation', mode=MODE_TYPE)
    _RLCDuplicationInformation_rLCDuplicationStateList = SEQ_OF(name=u'rLCDuplicationStateList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationStateList')))
    _RLCDuplicationInformation_primaryPathIndication = ENUM(name=u'primaryPathIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PrimaryPathIndication')), opt=True)
    _RLCDuplicationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCDuplicationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCDuplicationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLCDuplicationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__id_tab
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab_at = None
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLCDuplicationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLCDuplicationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLCDuplicationInformation_iE_Extensions__item__id),
        (u'criticality', ___RLCDuplicationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLCDuplicationInformation_iE_Extensions__item__extensionValue),
        ])
    __RLCDuplicationInformation_iE_Extensions__item_._ext = None
    _RLCDuplicationInformation_iE_Extensions._cont = __RLCDuplicationInformation_iE_Extensions__item_
    _RLCDuplicationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCDuplicationInformation._cont = ASN1Dict([
        (u'rLCDuplicationStateList', _RLCDuplicationInformation_rLCDuplicationStateList),
        (u'primaryPathIndication', _RLCDuplicationInformation_primaryPathIndication),
        (u'iE-Extensions', _RLCDuplicationInformation_iE_Extensions),
        ])
    RLCDuplicationInformation._ext = None
    
    #-----< RLCDuplicationInformation-ExtIEs >-----#
    RLCDuplicationInformation_ExtIEs = CLASS(name=u'RLCDuplicationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCDuplicationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCDuplicationStateList >-----#
    RLCDuplicationStateList = SEQ_OF(name=u'RLCDuplicationStateList', mode=MODE_TYPE)
    _RLCDuplicationStateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationState-Item')))
    RLCDuplicationStateList._cont = _RLCDuplicationStateList__item_
    RLCDuplicationStateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< RLCDuplicationState-Item >-----#
    RLCDuplicationState_Item = SEQ(name=u'RLCDuplicationState-Item', mode=MODE_TYPE)
    _RLCDuplicationState_Item_duplicationState = ENUM(name=u'duplicationState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationState')))
    _RLCDuplicationState_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCDuplicationState_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCDuplicationState_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLCDuplicationState_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__id_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab_at = None
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLCDuplicationState_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLCDuplicationState_Item_iE_Extensions__item__id),
        (u'criticality', ___RLCDuplicationState_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue),
        ])
    __RLCDuplicationState_Item_iE_Extensions__item_._ext = None
    _RLCDuplicationState_Item_iE_Extensions._cont = __RLCDuplicationState_Item_iE_Extensions__item_
    _RLCDuplicationState_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCDuplicationState_Item._cont = ASN1Dict([
        (u'duplicationState', _RLCDuplicationState_Item_duplicationState),
        (u'iE-Extensions', _RLCDuplicationState_Item_iE_Extensions),
        ])
    RLCDuplicationState_Item._ext = []
    
    #-----< RLCDuplicationState-Item-ExtIEs >-----#
    RLCDuplicationState_Item_ExtIEs = CLASS(name=u'RLCDuplicationState-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCDuplicationState_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCFailureIndication >-----#
    RLCFailureIndication = SEQ(name=u'RLCFailureIndication', mode=MODE_TYPE)
    _RLCFailureIndication_assocatedLCID = INT(name=u'assocatedLCID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _RLCFailureIndication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCFailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCFailureIndication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLCFailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab = ____RLCFailureIndication_iE_Extensions__item__id_tab
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLCFailureIndication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLCFailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab = ____RLCFailureIndication_iE_Extensions__item__criticality_tab
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLCFailureIndication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab = ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLCFailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLCFailureIndication_iE_Extensions__item__id),
        (u'criticality', ___RLCFailureIndication_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLCFailureIndication_iE_Extensions__item__extensionValue),
        ])
    __RLCFailureIndication_iE_Extensions__item_._ext = None
    _RLCFailureIndication_iE_Extensions._cont = __RLCFailureIndication_iE_Extensions__item_
    _RLCFailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCFailureIndication._cont = ASN1Dict([
        (u'assocatedLCID', _RLCFailureIndication_assocatedLCID),
        (u'iE-Extensions', _RLCFailureIndication_iE_Extensions),
        ])
    RLCFailureIndication._ext = None
    
    #-----< RLCFailureIndication-ExtIEs >-----#
    RLCFailureIndication_ExtIEs = CLASS(name=u'RLCFailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCFailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCMode >-----#
    RLCMode = ENUM(name=u'RLCMode', mode=MODE_TYPE)
    RLCMode._cont = ASN1Dict([(u'rlc-am', 0), (u'rlc-um-bidirectional', 1), (u'rlc-um-unidirectional-ul', 2), (u'rlc-um-unidirectional-dl', 3)])
    RLCMode._ext = []
    
    #-----< RLC-Status >-----#
    RLC_Status = SEQ(name=u'RLC-Status', mode=MODE_TYPE)
    _RLC_Status_reestablishment_Indication = ENUM(name=u'reestablishment-Indication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Reestablishment-Indication')))
    _RLC_Status_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLC_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLC_Status_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLC_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__id._const_tab = ____RLC_Status_iE_Extensions__item__id_tab
    ___RLC_Status_iE_Extensions__item__id._const_tab_at = None
    ___RLC_Status_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLC_Status_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLC_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__criticality._const_tab = ____RLC_Status_iE_Extensions__item__criticality_tab
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLC_Status_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab = ____RLC_Status_iE_Extensions__item__extensionValue_tab
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLC_Status_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLC_Status_iE_Extensions__item__id),
        (u'criticality', ___RLC_Status_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLC_Status_iE_Extensions__item__extensionValue),
        ])
    __RLC_Status_iE_Extensions__item_._ext = None
    _RLC_Status_iE_Extensions._cont = __RLC_Status_iE_Extensions__item_
    _RLC_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLC_Status._cont = ASN1Dict([
        (u'reestablishment-Indication', _RLC_Status_reestablishment_Indication),
        (u'iE-Extensions', _RLC_Status_iE_Extensions),
        ])
    RLC_Status._ext = []
    
    #-----< RLC-Status-ExtIEs >-----#
    RLC_Status_ExtIEs = CLASS(name=u'RLC-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLC_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLFReportInformationList >-----#
    RLFReportInformationList = SEQ_OF(name=u'RLFReportInformationList', mode=MODE_TYPE)
    _RLFReportInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationItem')))
    RLFReportInformationList._cont = _RLFReportInformationList__item_
    RLFReportInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RLFReportInformationItem >-----#
    RLFReportInformationItem = SEQ(name=u'RLFReportInformationItem', mode=MODE_TYPE)
    _RLFReportInformationItem_nRUERLFReportContainer = OCT_STR(name=u'nRUERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRUERLFReportContainer')))
    _RLFReportInformationItem_uEAssitantIdentifier = INT(name=u'uEAssitantIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _RLFReportInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLFReportInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLFReportInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLFReportInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab = ____RLFReportInformationItem_iE_Extensions__item__id_tab
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLFReportInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLFReportInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab = ____RLFReportInformationItem_iE_Extensions__item__criticality_tab
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab = ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLFReportInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLFReportInformationItem_iE_Extensions__item__id),
        (u'criticality', ___RLFReportInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLFReportInformationItem_iE_Extensions__item__extensionValue),
        ])
    __RLFReportInformationItem_iE_Extensions__item_._ext = None
    _RLFReportInformationItem_iE_Extensions._cont = __RLFReportInformationItem_iE_Extensions__item_
    _RLFReportInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLFReportInformationItem._cont = ASN1Dict([
        (u'nRUERLFReportContainer', _RLFReportInformationItem_nRUERLFReportContainer),
        (u'uEAssitantIdentifier', _RLFReportInformationItem_uEAssitantIdentifier),
        (u'iE-Extensions', _RLFReportInformationItem_iE_Extensions),
        ])
    RLFReportInformationItem._ext = []
    
    #-----< RLFReportInformationItem-ExtIEs >-----#
    RLFReportInformationItem_ExtIEs = CLASS(name=u'RLFReportInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLFReportInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMRSDetectionStatus >-----#
    RIMRSDetectionStatus = ENUM(name=u'RIMRSDetectionStatus', mode=MODE_TYPE)
    RIMRSDetectionStatus._cont = ASN1Dict([(u'rs-detected', 0), (u'rs-disappeared', 1)])
    RIMRSDetectionStatus._ext = []
    
    #-----< RRCContainer >-----#
    RRCContainer = OCT_STR(name=u'RRCContainer', mode=MODE_TYPE)
    
    #-----< RRCContainer-RRCSetupComplete >-----#
    RRCContainer_RRCSetupComplete = OCT_STR(name=u'RRCContainer-RRCSetupComplete', mode=MODE_TYPE)
    
    #-----< RRCDeliveryStatus >-----#
    RRCDeliveryStatus = SEQ(name=u'RRCDeliveryStatus', mode=MODE_TYPE)
    _RRCDeliveryStatus_delivery_status = INT(name=u'delivery-status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCP-SN')))
    _RRCDeliveryStatus_triggering_message = INT(name=u'triggering-message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCP-SN')))
    _RRCDeliveryStatus_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RRCDeliveryStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RRCDeliveryStatus_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RRCDeliveryStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__id_tab
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab_at = None
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab_id = u'id'
    ___RRCDeliveryStatus_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RRCDeliveryStatus_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RRCDeliveryStatus_iE_Extensions__item__id),
        (u'criticality', ___RRCDeliveryStatus_iE_Extensions__item__criticality),
        (u'extensionValue', ___RRCDeliveryStatus_iE_Extensions__item__extensionValue),
        ])
    __RRCDeliveryStatus_iE_Extensions__item_._ext = None
    _RRCDeliveryStatus_iE_Extensions._cont = __RRCDeliveryStatus_iE_Extensions__item_
    _RRCDeliveryStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RRCDeliveryStatus._cont = ASN1Dict([
        (u'delivery-status', _RRCDeliveryStatus_delivery_status),
        (u'triggering-message', _RRCDeliveryStatus_triggering_message),
        (u'iE-Extensions', _RRCDeliveryStatus_iE_Extensions),
        ])
    RRCDeliveryStatus._ext = None
    
    #-----< RRCDeliveryStatus-ExtIEs >-----#
    RRCDeliveryStatus_ExtIEs = CLASS(name=u'RRCDeliveryStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RRCDeliveryStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RRCDeliveryStatusRequest >-----#
    RRCDeliveryStatusRequest = ENUM(name=u'RRCDeliveryStatusRequest', mode=MODE_TYPE)
    RRCDeliveryStatusRequest._cont = ASN1Dict([(u'true', 0)])
    RRCDeliveryStatusRequest._ext = []
    
    #-----< RRCReconfigurationCompleteIndicator >-----#
    RRCReconfigurationCompleteIndicator = ENUM(name=u'RRCReconfigurationCompleteIndicator', mode=MODE_TYPE)
    RRCReconfigurationCompleteIndicator._cont = ASN1Dict([(u'true', 0), (u'failure', 1)])
    RRCReconfigurationCompleteIndicator._ext = [u'failure']
    
    #-----< RRC-Version >-----#
    RRC_Version = SEQ(name=u'RRC-Version', mode=MODE_TYPE)
    _RRC_Version_latest_RRC_Version = BIT_STR(name=u'latest-RRC-Version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RRC_Version_latest_RRC_Version._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _RRC_Version_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RRC_Version_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RRC_Version_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RRC_Version_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE)
    _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    ____RRC_Version_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 199), (u'criticality', u'ignore'), (u'Extension', _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RRC_Version_iE_Extensions__item__id._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__id._const_tab_at = None
    ___RRC_Version_iE_Extensions__item__id._const_tab_id = u'id'
    ___RRC_Version_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RRC_Version_iE_Extensions__item__criticality._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RRC_Version_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RRC_Version_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RRC_Version_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RRC_Version_iE_Extensions__item__id),
        (u'criticality', ___RRC_Version_iE_Extensions__item__criticality),
        (u'extensionValue', ___RRC_Version_iE_Extensions__item__extensionValue),
        ])
    __RRC_Version_iE_Extensions__item_._ext = None
    _RRC_Version_iE_Extensions._cont = __RRC_Version_iE_Extensions__item_
    _RRC_Version_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RRC_Version._cont = ASN1Dict([
        (u'latest-RRC-Version', _RRC_Version_latest_RRC_Version),
        (u'iE-Extensions', _RRC_Version_iE_Extensions),
        ])
    RRC_Version._ext = None
    
    #-----< RRC-Version-ExtIEs >-----#
    RRC_Version_ExtIEs = CLASS(name=u'RRC-Version-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _RRC_Version_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE)
    _RRC_Version_ExtIEs_val_Extension_0._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    RRC_Version_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 199), (u'criticality', u'ignore'), (u'Extension', _RRC_Version_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RoutingID >-----#
    RoutingID = OCT_STR(name=u'RoutingID', mode=MODE_TYPE)
    
    #-----< SCell-FailedtoSetup-Item >-----#
    SCell_FailedtoSetup_Item = SEQ(name=u'SCell-FailedtoSetup-Item', mode=MODE_TYPE)
    _SCell_FailedtoSetup_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_FailedtoSetup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SCell_FailedtoSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_FailedtoSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCell_FailedtoSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCell_FailedtoSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_FailedtoSetup_Item_iE_Extensions__item_._ext = None
    _SCell_FailedtoSetup_Item_iE_Extensions._cont = __SCell_FailedtoSetup_Item_iE_Extensions__item_
    _SCell_FailedtoSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_FailedtoSetup_Item._cont = ASN1Dict([
        (u'sCell-ID', _SCell_FailedtoSetup_Item_sCell_ID),
        (u'cause', _SCell_FailedtoSetup_Item_cause),
        (u'iE-Extensions', _SCell_FailedtoSetup_Item_iE_Extensions),
        ])
    SCell_FailedtoSetup_Item._ext = []
    
    #-----< SCell-FailedtoSetup-ItemExtIEs >-----#
    SCell_FailedtoSetup_ItemExtIEs = CLASS(name=u'SCell-FailedtoSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_FailedtoSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetupMod-Item >-----#
    SCell_FailedtoSetupMod_Item = SEQ(name=u'SCell-FailedtoSetupMod-Item', mode=MODE_TYPE)
    _SCell_FailedtoSetupMod_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_FailedtoSetupMod_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SCell_FailedtoSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_._ext = None
    _SCell_FailedtoSetupMod_Item_iE_Extensions._cont = __SCell_FailedtoSetupMod_Item_iE_Extensions__item_
    _SCell_FailedtoSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_FailedtoSetupMod_Item._cont = ASN1Dict([
        (u'sCell-ID', _SCell_FailedtoSetupMod_Item_sCell_ID),
        (u'cause', _SCell_FailedtoSetupMod_Item_cause),
        (u'iE-Extensions', _SCell_FailedtoSetupMod_Item_iE_Extensions),
        ])
    SCell_FailedtoSetupMod_Item._ext = []
    
    #-----< SCell-FailedtoSetupMod-ItemExtIEs >-----#
    SCell_FailedtoSetupMod_ItemExtIEs = CLASS(name=u'SCell-FailedtoSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_FailedtoSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeRemoved-Item >-----#
    SCell_ToBeRemoved_Item = SEQ(name=u'SCell-ToBeRemoved-Item', mode=MODE_TYPE)
    _SCell_ToBeRemoved_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeRemoved_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeRemoved_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCell_ToBeRemoved_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCell_ToBeRemoved_Item_iE_Extensions__item__id),
        (u'criticality', ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeRemoved_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeRemoved_Item_iE_Extensions._cont = __SCell_ToBeRemoved_Item_iE_Extensions__item_
    _SCell_ToBeRemoved_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeRemoved_Item._cont = ASN1Dict([
        (u'sCell-ID', _SCell_ToBeRemoved_Item_sCell_ID),
        (u'iE-Extensions', _SCell_ToBeRemoved_Item_iE_Extensions),
        ])
    SCell_ToBeRemoved_Item._ext = []
    
    #-----< SCell-ToBeRemoved-ItemExtIEs >-----#
    SCell_ToBeRemoved_ItemExtIEs = CLASS(name=u'SCell-ToBeRemoved-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_ToBeRemoved_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetup-Item >-----#
    SCell_ToBeSetup_Item = SEQ(name=u'SCell-ToBeSetup-Item', mode=MODE_TYPE)
    _SCell_ToBeSetup_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeSetup_Item_sCellIndex = INT(name=u'sCellIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SCellIndex')))
    _SCell_ToBeSetup_Item_sCellULConfigured = ENUM(name=u'sCellULConfigured', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')), opt=True)
    _SCell_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCell_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCell_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeSetup_Item_iE_Extensions._cont = __SCell_ToBeSetup_Item_iE_Extensions__item_
    _SCell_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeSetup_Item._cont = ASN1Dict([
        (u'sCell-ID', _SCell_ToBeSetup_Item_sCell_ID),
        (u'sCellIndex', _SCell_ToBeSetup_Item_sCellIndex),
        (u'sCellULConfigured', _SCell_ToBeSetup_Item_sCellULConfigured),
        (u'iE-Extensions', _SCell_ToBeSetup_Item_iE_Extensions),
        ])
    SCell_ToBeSetup_Item._ext = []
    
    #-----< SCell-ToBeSetup-ItemExtIEs >-----#
    SCell_ToBeSetup_ItemExtIEs = CLASS(name=u'SCell-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SCell_ToBeSetup_ItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    SCell_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _SCell_ToBeSetup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetupMod-Item >-----#
    SCell_ToBeSetupMod_Item = SEQ(name=u'SCell-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SCell_ToBeSetupMod_Item_sCell_ID = SEQ(name=u'sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeSetupMod_Item_sCellIndex = INT(name=u'sCellIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SCellIndex')))
    _SCell_ToBeSetupMod_Item_sCellULConfigured = ENUM(name=u'sCellULConfigured', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')), opt=True)
    _SCell_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeSetupMod_Item_iE_Extensions._cont = __SCell_ToBeSetupMod_Item_iE_Extensions__item_
    _SCell_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeSetupMod_Item._cont = ASN1Dict([
        (u'sCell-ID', _SCell_ToBeSetupMod_Item_sCell_ID),
        (u'sCellIndex', _SCell_ToBeSetupMod_Item_sCellIndex),
        (u'sCellULConfigured', _SCell_ToBeSetupMod_Item_sCellULConfigured),
        (u'iE-Extensions', _SCell_ToBeSetupMod_Item_iE_Extensions),
        ])
    SCell_ToBeSetupMod_Item._ext = []
    
    #-----< SCell-ToBeSetupMod-ItemExtIEs >-----#
    SCell_ToBeSetupMod_ItemExtIEs = CLASS(name=u'SCell-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    SCell_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCellIndex >-----#
    SCellIndex = INT(name=u'SCellIndex', mode=MODE_TYPE)
    SCellIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=[], er=[])
    
    #-----< SCGIndicator >-----#
    SCGIndicator = ENUM(name=u'SCGIndicator', mode=MODE_TYPE)
    SCGIndicator._cont = ASN1Dict([(u'released', 0)])
    SCGIndicator._ext = []
    
    #-----< SCS-SpecificCarrier >-----#
    SCS_SpecificCarrier = SEQ(name=u'SCS-SpecificCarrier', mode=MODE_TYPE)
    _SCS_SpecificCarrier_offsetToCarrier = INT(name=u'offsetToCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _SCS_SpecificCarrier_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _SCS_SpecificCarrier_subcarrierSpacing._ext = []
    _SCS_SpecificCarrier_carrierBandwidth = INT(name=u'carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=275)], ev=[], er=[])
    _SCS_SpecificCarrier_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCS_SpecificCarrier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCS_SpecificCarrier_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__id_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_at = None
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCS_SpecificCarrier_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCS_SpecificCarrier_iE_Extensions__item__id),
        (u'criticality', ___SCS_SpecificCarrier_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue),
        ])
    __SCS_SpecificCarrier_iE_Extensions__item_._ext = None
    _SCS_SpecificCarrier_iE_Extensions._cont = __SCS_SpecificCarrier_iE_Extensions__item_
    _SCS_SpecificCarrier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCS_SpecificCarrier._cont = ASN1Dict([
        (u'offsetToCarrier', _SCS_SpecificCarrier_offsetToCarrier),
        (u'subcarrierSpacing', _SCS_SpecificCarrier_subcarrierSpacing),
        (u'carrierBandwidth', _SCS_SpecificCarrier_carrierBandwidth),
        (u'iE-Extensions', _SCS_SpecificCarrier_iE_Extensions),
        ])
    SCS_SpecificCarrier._ext = None
    
    #-----< SCS-SpecificCarrier-ExtIEs >-----#
    SCS_SpecificCarrier_ExtIEs = CLASS(name=u'SCS-SpecificCarrier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCS_SpecificCarrier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Search-window-information >-----#
    Search_window_information = SEQ(name=u'Search-window-information', mode=MODE_TYPE)
    _Search_window_information_expectedPropagationDelay = INT(name=u'expectedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_expectedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-3841, ub=3841)], ev=[], er=[])
    _Search_window_information_delayUncertainty = INT(name=u'delayUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_delayUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=246)], ev=[], er=[])
    _Search_window_information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Search_window_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Search_window_information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Search_window_information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__id._const_tab = ____Search_window_information_iE_Extensions__item__id_tab
    ___Search_window_information_iE_Extensions__item__id._const_tab_at = None
    ___Search_window_information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Search_window_information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Search_window_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__criticality._const_tab = ____Search_window_information_iE_Extensions__item__criticality_tab
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Search_window_information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab = ____Search_window_information_iE_Extensions__item__extensionValue_tab
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Search_window_information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Search_window_information_iE_Extensions__item__id),
        (u'criticality', ___Search_window_information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Search_window_information_iE_Extensions__item__extensionValue),
        ])
    __Search_window_information_iE_Extensions__item_._ext = None
    _Search_window_information_iE_Extensions._cont = __Search_window_information_iE_Extensions__item_
    _Search_window_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Search_window_information._cont = ASN1Dict([
        (u'expectedPropagationDelay', _Search_window_information_expectedPropagationDelay),
        (u'delayUncertainty', _Search_window_information_delayUncertainty),
        (u'iE-Extensions', _Search_window_information_iE_Extensions),
        ])
    Search_window_information._ext = None
    
    #-----< Search-window-information-ExtIEs >-----#
    Search_window_information_ExtIEs = CLASS(name=u'Search-window-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Search_window_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name=u'SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SIBType-PWS >-----#
    SIBType_PWS = INT(name=u'SIBType-PWS', mode=MODE_TYPE)
    SIBType_PWS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=[], er=[])
    
    #-----< SelectedBandCombinationIndex >-----#
    SelectedBandCombinationIndex = OCT_STR(name=u'SelectedBandCombinationIndex', mode=MODE_TYPE)
    
    #-----< SelectedFeatureSetEntryIndex >-----#
    SelectedFeatureSetEntryIndex = OCT_STR(name=u'SelectedFeatureSetEntryIndex', mode=MODE_TYPE)
    
    #-----< CG-ConfigInfo >-----#
    CG_ConfigInfo = OCT_STR(name=u'CG-ConfigInfo', mode=MODE_TYPE)
    
    #-----< ServCellIndex >-----#
    ServCellIndex = INT(name=u'ServCellIndex', mode=MODE_TYPE)
    ServCellIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=[], er=[])
    
    #-----< ServingCellMO >-----#
    ServingCellMO = INT(name=u'ServingCellMO', mode=MODE_TYPE)
    ServingCellMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< Served-Cell-Information >-----#
    Served_Cell_Information = SEQ(name=u'Served-Cell-Information', mode=MODE_TYPE)
    _Served_Cell_Information_nRCGI = SEQ(name=u'nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cell_Information_nRPCI = INT(name=u'nRPCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _Served_Cell_Information_fiveGS_TAC = OCT_STR(name=u'fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveGS-TAC')), opt=True)
    _Served_Cell_Information_configured_EPS_TAC = OCT_STR(name=u'configured-EPS-TAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Configured-EPS-TAC')), opt=True)
    _Served_Cell_Information_servedPLMNs = SEQ_OF(name=u'servedPLMNs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ServedPLMNs-List')))
    _Served_Cell_Information_nR_Mode_Info = CHOICE(name=u'nR-Mode-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-Mode-Info')))
    _Served_Cell_Information_measurementTimingConfiguration = OCT_STR(name=u'measurementTimingConfiguration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Served_Cell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Served_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANAC')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-List')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Direction')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-List')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellType')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorgNBSetID')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'VictimgNBSetID')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-DU')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfig')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SFN-Offset')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    ____Served_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 139), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 425), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 357), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 358), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 429), (u'criticality', u'ignore'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 383), (u'criticality', u'reject'), (u'Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Served_Cell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Served_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Served_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Served_Cell_Information_iE_Extensions__item__id),
        (u'criticality', ___Served_Cell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Served_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __Served_Cell_Information_iE_Extensions__item_._ext = None
    _Served_Cell_Information_iE_Extensions._cont = __Served_Cell_Information_iE_Extensions__item_
    _Served_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cell_Information._cont = ASN1Dict([
        (u'nRCGI', _Served_Cell_Information_nRCGI),
        (u'nRPCI', _Served_Cell_Information_nRPCI),
        (u'fiveGS-TAC', _Served_Cell_Information_fiveGS_TAC),
        (u'configured-EPS-TAC', _Served_Cell_Information_configured_EPS_TAC),
        (u'servedPLMNs', _Served_Cell_Information_servedPLMNs),
        (u'nR-Mode-Info', _Served_Cell_Information_nR_Mode_Info),
        (u'measurementTimingConfiguration', _Served_Cell_Information_measurementTimingConfiguration),
        (u'iE-Extensions', _Served_Cell_Information_iE_Extensions),
        ])
    Served_Cell_Information._ext = []
    
    #-----< Served-Cell-Information-ExtIEs >-----#
    Served_Cell_Information_ExtIEs = CLASS(name=u'Served-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Served_Cell_Information_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANAC')))
    _Served_Cell_Information_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-List')))
    _Served_Cell_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Direction')))
    _Served_Cell_Information_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-List')))
    _Served_Cell_Information_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellType')))
    _Served_Cell_Information_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _Served_Cell_Information_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorgNBSetID')))
    _Served_Cell_Information_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'VictimgNBSetID')))
    _Served_Cell_Information_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-DU')))
    _Served_Cell_Information_ExtIEs_val_Extension_9 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')))
    _Served_Cell_Information_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfig')))
    _Served_Cell_Information_ExtIEs_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SFN-Offset')))
    _Served_Cell_Information_ExtIEs_val_Extension_12 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    Served_Cell_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 139), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 425), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 357), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 358), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 429), (u'criticality', u'ignore'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 383), (u'criticality', u'reject'), (u'Extension', _Served_Cell_Information_ExtIEs_val_Extension_12), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SFN-Offset >-----#
    SFN_Offset = SEQ(name=u'SFN-Offset', mode=MODE_TYPE)
    _SFN_Offset_sFN_Time_Offset = BIT_STR(name=u'sFN-Time-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SFN_Offset_sFN_Time_Offset._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SFN_Offset_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFN_Offset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SFN_Offset_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SFN_Offset_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__id._const_tab = ____SFN_Offset_iE_Extensions__item__id_tab
    ___SFN_Offset_iE_Extensions__item__id._const_tab_at = None
    ___SFN_Offset_iE_Extensions__item__id._const_tab_id = u'id'
    ___SFN_Offset_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SFN_Offset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab = ____SFN_Offset_iE_Extensions__item__criticality_tab
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SFN_Offset_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab = ____SFN_Offset_iE_Extensions__item__extensionValue_tab
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SFN_Offset_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SFN_Offset_iE_Extensions__item__id),
        (u'criticality', ___SFN_Offset_iE_Extensions__item__criticality),
        (u'extensionValue', ___SFN_Offset_iE_Extensions__item__extensionValue),
        ])
    __SFN_Offset_iE_Extensions__item_._ext = None
    _SFN_Offset_iE_Extensions._cont = __SFN_Offset_iE_Extensions__item_
    _SFN_Offset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFN_Offset._cont = ASN1Dict([
        (u'sFN-Time-Offset', _SFN_Offset_sFN_Time_Offset),
        (u'iE-Extensions', _SFN_Offset_iE_Extensions),
        ])
    SFN_Offset._ext = []
    
    #-----< SFN-Offset-ExtIEs >-----#
    SFN_Offset_ExtIEs = CLASS(name=u'SFN-Offset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SFN_Offset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Add-Item >-----#
    Served_Cells_To_Add_Item = SEQ(name=u'Served-Cells-To-Add-Item', mode=MODE_TYPE)
    _Served_Cells_To_Add_Item_served_Cell_Information = SEQ(name=u'served-Cell-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _Served_Cells_To_Add_Item_gNB_DU_System_Information = SEQ(name=u'gNB-DU-System-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _Served_Cells_To_Add_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Served_Cells_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Served_Cells_To_Add_Item_iE_Extensions__item__id),
        (u'criticality', ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Add_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Add_Item_iE_Extensions._cont = __Served_Cells_To_Add_Item_iE_Extensions__item_
    _Served_Cells_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Add_Item._cont = ASN1Dict([
        (u'served-Cell-Information', _Served_Cells_To_Add_Item_served_Cell_Information),
        (u'gNB-DU-System-Information', _Served_Cells_To_Add_Item_gNB_DU_System_Information),
        (u'iE-Extensions', _Served_Cells_To_Add_Item_iE_Extensions),
        ])
    Served_Cells_To_Add_Item._ext = []
    
    #-----< Served-Cells-To-Add-ItemExtIEs >-----#
    Served_Cells_To_Add_ItemExtIEs = CLASS(name=u'Served-Cells-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Delete-Item >-----#
    Served_Cells_To_Delete_Item = SEQ(name=u'Served-Cells-To-Delete-Item', mode=MODE_TYPE)
    _Served_Cells_To_Delete_Item_oldNRCGI = SEQ(name=u'oldNRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cells_To_Delete_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Served_Cells_To_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Served_Cells_To_Delete_Item_iE_Extensions__item__id),
        (u'criticality', ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Delete_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Delete_Item_iE_Extensions._cont = __Served_Cells_To_Delete_Item_iE_Extensions__item_
    _Served_Cells_To_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Delete_Item._cont = ASN1Dict([
        (u'oldNRCGI', _Served_Cells_To_Delete_Item_oldNRCGI),
        (u'iE-Extensions', _Served_Cells_To_Delete_Item_iE_Extensions),
        ])
    Served_Cells_To_Delete_Item._ext = []
    
    #-----< Served-Cells-To-Delete-ItemExtIEs >-----#
    Served_Cells_To_Delete_ItemExtIEs = CLASS(name=u'Served-Cells-To-Delete-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Delete_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Modify-Item >-----#
    Served_Cells_To_Modify_Item = SEQ(name=u'Served-Cells-To-Modify-Item', mode=MODE_TYPE)
    _Served_Cells_To_Modify_Item_oldNRCGI = SEQ(name=u'oldNRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cells_To_Modify_Item_served_Cell_Information = SEQ(name=u'served-Cell-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _Served_Cells_To_Modify_Item_gNB_DU_System_Information = SEQ(name=u'gNB-DU-System-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _Served_Cells_To_Modify_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Modify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Served_Cells_To_Modify_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Served_Cells_To_Modify_Item_iE_Extensions__item__id),
        (u'criticality', ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Modify_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Modify_Item_iE_Extensions._cont = __Served_Cells_To_Modify_Item_iE_Extensions__item_
    _Served_Cells_To_Modify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Modify_Item._cont = ASN1Dict([
        (u'oldNRCGI', _Served_Cells_To_Modify_Item_oldNRCGI),
        (u'served-Cell-Information', _Served_Cells_To_Modify_Item_served_Cell_Information),
        (u'gNB-DU-System-Information', _Served_Cells_To_Modify_Item_gNB_DU_System_Information),
        (u'iE-Extensions', _Served_Cells_To_Modify_Item_iE_Extensions),
        ])
    Served_Cells_To_Modify_Item._ext = []
    
    #-----< Served-Cells-To-Modify-ItemExtIEs >-----#
    Served_Cells_To_Modify_ItemExtIEs = CLASS(name=u'Served-Cells-To-Modify-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Modify_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-EUTRA-Cells-Information >-----#
    Served_EUTRA_Cells_Information = SEQ(name=u'Served-EUTRA-Cells-Information', mode=MODE_TYPE)
    _Served_EUTRA_Cells_Information_eUTRA_Mode_Info = CHOICE(name=u'eUTRA-Mode-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Mode-Info')))
    _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication = OCT_STR(name=u'protectedEUTRAResourceIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ProtectedEUTRAResourceIndication')))
    _Served_EUTRA_Cells_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_EUTRA_Cells_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab_at = None
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Served_EUTRA_Cells_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Served_EUTRA_Cells_Information_iE_Extensions__item__id),
        (u'criticality', ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue),
        ])
    __Served_EUTRA_Cells_Information_iE_Extensions__item_._ext = None
    _Served_EUTRA_Cells_Information_iE_Extensions._cont = __Served_EUTRA_Cells_Information_iE_Extensions__item_
    _Served_EUTRA_Cells_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_EUTRA_Cells_Information._cont = ASN1Dict([
        (u'eUTRA-Mode-Info', _Served_EUTRA_Cells_Information_eUTRA_Mode_Info),
        (u'protectedEUTRAResourceIndication', _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication),
        (u'iE-Extensions', _Served_EUTRA_Cells_Information_iE_Extensions),
        ])
    Served_EUTRA_Cells_Information._ext = []
    
    #-----< Served-EUTRA-Cell-Information-ExtIEs >-----#
    Served_EUTRA_Cell_Information_ExtIEs = CLASS(name=u'Served-EUTRA-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_EUTRA_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Service-State >-----#
    Service_State = ENUM(name=u'Service-State', mode=MODE_TYPE)
    Service_State._cont = ASN1Dict([(u'in-service', 0), (u'out-of-service', 1)])
    Service_State._ext = []
    
    #-----< Service-Status >-----#
    Service_Status = SEQ(name=u'Service-Status', mode=MODE_TYPE)
    _Service_Status_service_state = ENUM(name=u'service-state', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Service-State')))
    _Service_Status_switchingOffOngoing = ENUM(name=u'switchingOffOngoing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Status_switchingOffOngoing._cont = ASN1Dict([(u'true', 0)])
    _Service_Status_switchingOffOngoing._ext = []
    _Service_Status_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Service_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Service_Status_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Service_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__id._const_tab = ____Service_Status_iE_Extensions__item__id_tab
    ___Service_Status_iE_Extensions__item__id._const_tab_at = None
    ___Service_Status_iE_Extensions__item__id._const_tab_id = u'id'
    ___Service_Status_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Service_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__criticality._const_tab = ____Service_Status_iE_Extensions__item__criticality_tab
    ___Service_Status_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Service_Status_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Service_Status_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Service_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab = ____Service_Status_iE_Extensions__item__extensionValue_tab
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Service_Status_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Service_Status_iE_Extensions__item__id),
        (u'criticality', ___Service_Status_iE_Extensions__item__criticality),
        (u'extensionValue', ___Service_Status_iE_Extensions__item__extensionValue),
        ])
    __Service_Status_iE_Extensions__item_._ext = None
    _Service_Status_iE_Extensions._cont = __Service_Status_iE_Extensions__item_
    _Service_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Service_Status._cont = ASN1Dict([
        (u'service-state', _Service_Status_service_state),
        (u'switchingOffOngoing', _Service_Status_switchingOffOngoing),
        (u'iE-Extensions', _Service_Status_iE_Extensions),
        ])
    Service_Status._ext = []
    
    #-----< Service-Status-ExtIEs >-----#
    Service_Status_ExtIEs = CLASS(name=u'Service-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Service_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeTime1900 >-----#
    RelativeTime1900 = BIT_STR(name=u'RelativeTime1900', mode=MODE_TYPE)
    RelativeTime1900._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< ShortDRXCycleLength >-----#
    ShortDRXCycleLength = ENUM(name=u'ShortDRXCycleLength', mode=MODE_TYPE)
    ShortDRXCycleLength._cont = ASN1Dict([(u'ms2', 0), (u'ms3', 1), (u'ms4', 2), (u'ms5', 3), (u'ms6', 4), (u'ms7', 5), (u'ms8', 6), (u'ms10', 7), (u'ms14', 8), (u'ms16', 9), (u'ms20', 10), (u'ms30', 11), (u'ms32', 12), (u'ms35', 13), (u'ms40', 14), (u'ms64', 15), (u'ms80', 16), (u'ms128', 17), (u'ms160', 18), (u'ms256', 19), (u'ms320', 20), (u'ms512', 21), (u'ms640', 22)])
    ShortDRXCycleLength._ext = []
    
    #-----< ShortDRXCycleTimer >-----#
    ShortDRXCycleTimer = INT(name=u'ShortDRXCycleTimer', mode=MODE_TYPE)
    ShortDRXCycleTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SIB1-message >-----#
    SIB1_message = OCT_STR(name=u'SIB1-message', mode=MODE_TYPE)
    
    #-----< SIB10-message >-----#
    SIB10_message = OCT_STR(name=u'SIB10-message', mode=MODE_TYPE)
    
    #-----< SIB12-message >-----#
    SIB12_message = OCT_STR(name=u'SIB12-message', mode=MODE_TYPE)
    
    #-----< SIB13-message >-----#
    SIB13_message = OCT_STR(name=u'SIB13-message', mode=MODE_TYPE)
    
    #-----< SIB14-message >-----#
    SIB14_message = OCT_STR(name=u'SIB14-message', mode=MODE_TYPE)
    
    #-----< SItype >-----#
    SItype = INT(name=u'SItype', mode=MODE_TYPE)
    SItype._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< SItype-List >-----#
    SItype_List = SEQ_OF(name=u'SItype-List', mode=MODE_TYPE)
    _SItype_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-Item')))
    SItype_List._cont = _SItype_List__item_
    SItype_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SItype-Item >-----#
    SItype_Item = SEQ(name=u'SItype-Item', mode=MODE_TYPE)
    _SItype_Item_sItype = INT(name=u'sItype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SItype')))
    _SItype_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SItype_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SItype_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SItype_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__id._const_tab = ____SItype_Item_iE_Extensions__item__id_tab
    ___SItype_Item_iE_Extensions__item__id._const_tab_at = None
    ___SItype_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SItype_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SItype_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__criticality._const_tab = ____SItype_Item_iE_Extensions__item__criticality_tab
    ___SItype_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SItype_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SItype_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SItype_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab = ____SItype_Item_iE_Extensions__item__extensionValue_tab
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SItype_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SItype_Item_iE_Extensions__item__id),
        (u'criticality', ___SItype_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SItype_Item_iE_Extensions__item__extensionValue),
        ])
    __SItype_Item_iE_Extensions__item_._ext = None
    _SItype_Item_iE_Extensions._cont = __SItype_Item_iE_Extensions__item_
    _SItype_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SItype_Item._cont = ASN1Dict([
        (u'sItype', _SItype_Item_sItype),
        (u'iE-Extensions', _SItype_Item_iE_Extensions),
        ])
    SItype_Item._ext = None
    
    #-----< SItype-ItemExtIEs >-----#
    SItype_ItemExtIEs = CLASS(name=u'SItype-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SItype_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SibtypetobeupdatedListItem >-----#
    SibtypetobeupdatedListItem = SEQ(name=u'SibtypetobeupdatedListItem', mode=MODE_TYPE)
    _SibtypetobeupdatedListItem_sIBtype = INT(name=u'sIBtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_sIBtype._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _SibtypetobeupdatedListItem_sIBmessage = OCT_STR(name=u'sIBmessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_valueTag = INT(name=u'valueTag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_valueTag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=[], er=[])
    _SibtypetobeupdatedListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SibtypetobeupdatedListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AreaScope')))
    ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab_at = None
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SibtypetobeupdatedListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SibtypetobeupdatedListItem_iE_Extensions__item__id),
        (u'criticality', ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue),
        ])
    __SibtypetobeupdatedListItem_iE_Extensions__item_._ext = None
    _SibtypetobeupdatedListItem_iE_Extensions._cont = __SibtypetobeupdatedListItem_iE_Extensions__item_
    _SibtypetobeupdatedListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SibtypetobeupdatedListItem._cont = ASN1Dict([
        (u'sIBtype', _SibtypetobeupdatedListItem_sIBtype),
        (u'sIBmessage', _SibtypetobeupdatedListItem_sIBmessage),
        (u'valueTag', _SibtypetobeupdatedListItem_valueTag),
        (u'iE-Extensions', _SibtypetobeupdatedListItem_iE_Extensions),
        ])
    SibtypetobeupdatedListItem._ext = []
    
    #-----< SibtypetobeupdatedListItem-ExtIEs >-----#
    SibtypetobeupdatedListItem_ExtIEs = CLASS(name=u'SibtypetobeupdatedListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AreaScope')))
    SibtypetobeupdatedListItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBID >-----#
    SLDRBID = INT(name=u'SLDRBID', mode=MODE_TYPE)
    SLDRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< SLDRBInformation >-----#
    SLDRBInformation = SEQ(name=u'SLDRBInformation', mode=MODE_TYPE)
    _SLDRBInformation_sLDRB_QoS = SEQ(name=u'sLDRB-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5QoSParameters')))
    _SLDRBInformation_flowsMappedToSLDRB_List = SEQ_OF(name=u'flowsMappedToSLDRB-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FlowsMappedToSLDRB-List')))
    SLDRBInformation._cont = ASN1Dict([
        (u'sLDRB-QoS', _SLDRBInformation_sLDRB_QoS),
        (u'flowsMappedToSLDRB-List', _SLDRBInformation_flowsMappedToSLDRB_List),
        ])
    SLDRBInformation._ext = []
    
    #-----< SLDRBs-FailedToBeModified-Item >-----#
    SLDRBs_FailedToBeModified_Item = SEQ(name=u'SLDRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeModified_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeModified_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeModified_Item_iE_Extensions._cont = __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeModified_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_FailedToBeModified_Item_sLDRBID),
        (u'cause', _SLDRBs_FailedToBeModified_Item_cause),
        (u'iE-Extensions', _SLDRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeModified_Item._ext = None
    
    #-----< SLDRBs-FailedToBeModified-ItemExtIEs >-----#
    SLDRBs_FailedToBeModified_ItemExtIEs = CLASS(name=u'SLDRBs-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetup-Item >-----#
    SLDRBs_FailedToBeSetup_Item = SEQ(name=u'SLDRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetup_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeSetup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions._cont = __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_FailedToBeSetup_Item_sLDRBID),
        (u'cause', _SLDRBs_FailedToBeSetup_Item_cause),
        (u'iE-Extensions', _SLDRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeSetup_Item._ext = None
    
    #-----< SLDRBs-FailedToBeSetup-ItemExtIEs >-----#
    SLDRBs_FailedToBeSetup_ItemExtIEs = CLASS(name=u'SLDRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-Item >-----#
    SLDRBs_FailedToBeSetupMod_Item = SEQ(name=u'SLDRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetupMod_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeSetupMod_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_FailedToBeSetupMod_Item_sLDRBID),
        (u'cause', _SLDRBs_FailedToBeSetupMod_Item_cause),
        (u'iE-Extensions', _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeSetupMod_Item._ext = None
    
    #-----< SLDRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    SLDRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name=u'SLDRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Modified-Item >-----#
    SLDRBs_Modified_Item = SEQ(name=u'SLDRBs-Modified-Item', mode=MODE_TYPE)
    _SLDRBs_Modified_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Modified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Modified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_Modified_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_Modified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Modified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Modified_Item_iE_Extensions._cont = __SLDRBs_Modified_Item_iE_Extensions__item_
    _SLDRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Modified_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_Modified_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_Modified_Item_iE_Extensions),
        ])
    SLDRBs_Modified_Item._ext = None
    
    #-----< SLDRBs-Modified-ItemExtIEs >-----#
    SLDRBs_Modified_ItemExtIEs = CLASS(name=u'SLDRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ModifiedConf-Item >-----#
    SLDRBs_ModifiedConf_Item = SEQ(name=u'SLDRBs-ModifiedConf-Item', mode=MODE_TYPE)
    _SLDRBs_ModifiedConf_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ModifiedConf_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ModifiedConf_Item_iE_Extensions._cont = __SLDRBs_ModifiedConf_Item_iE_Extensions__item_
    _SLDRBs_ModifiedConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ModifiedConf_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_ModifiedConf_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_ModifiedConf_Item_iE_Extensions),
        ])
    SLDRBs_ModifiedConf_Item._ext = None
    
    #-----< SLDRBs-ModifiedConf-ItemExtIEs >-----#
    SLDRBs_ModifiedConf_ItemExtIEs = CLASS(name=u'SLDRBs-ModifiedConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ModifiedConf_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeModified-Item >-----#
    SLDRBs_Required_ToBeModified_Item = SEQ(name=u'SLDRBs-Required-ToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeModified_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions._cont = __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Required_ToBeModified_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_Required_ToBeModified_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_Required_ToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_Required_ToBeModified_Item._ext = None
    
    #-----< SLDRBs-Required-ToBeModified-ItemExtIEs >-----#
    SLDRBs_Required_ToBeModified_ItemExtIEs = CLASS(name=u'SLDRBs-Required-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Required_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-Item >-----#
    SLDRBs_Required_ToBeReleased_Item = SEQ(name=u'SLDRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeReleased_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_Required_ToBeReleased_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    SLDRBs_Required_ToBeReleased_Item._ext = None
    
    #-----< SLDRBs-Required-ToBeReleased-ItemExtIEs >-----#
    SLDRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name=u'SLDRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Setup-Item >-----#
    SLDRBs_Setup_Item = SEQ(name=u'SLDRBs-Setup-Item', mode=MODE_TYPE)
    _SLDRBs_Setup_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Setup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Setup_Item_iE_Extensions._cont = __SLDRBs_Setup_Item_iE_Extensions__item_
    _SLDRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Setup_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_Setup_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_Setup_Item_iE_Extensions),
        ])
    SLDRBs_Setup_Item._ext = None
    
    #-----< SLDRBs-Setup-ItemExtIEs >-----#
    SLDRBs_Setup_ItemExtIEs = CLASS(name=u'SLDRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-SetupMod-Item >-----#
    SLDRBs_SetupMod_Item = SEQ(name=u'SLDRBs-SetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_SetupMod_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_SetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_SetupMod_Item_iE_Extensions._cont = __SLDRBs_SetupMod_Item_iE_Extensions__item_
    _SLDRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_SetupMod_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_SetupMod_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_SetupMod_Item_iE_Extensions),
        ])
    SLDRBs_SetupMod_Item._ext = None
    
    #-----< SLDRBs-SetupMod-ItemExtIEs >-----#
    SLDRBs_SetupMod_ItemExtIEs = CLASS(name=u'SLDRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeModified-Item >-----#
    SLDRBs_ToBeModified_Item = SEQ(name=u'SLDRBs-ToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeModified_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeModified_Item_sLDRBInformation = SEQ(name=u'sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')), opt=True)
    _SLDRBs_ToBeModified_Item_rLCMode = ENUM(name=u'rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _SLDRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeModified_Item_iE_Extensions._cont = __SLDRBs_ToBeModified_Item_iE_Extensions__item_
    _SLDRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeModified_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_ToBeModified_Item_sLDRBID),
        (u'sLDRBInformation', _SLDRBs_ToBeModified_Item_sLDRBInformation),
        (u'rLCMode', _SLDRBs_ToBeModified_Item_rLCMode),
        (u'iE-Extensions', _SLDRBs_ToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_ToBeModified_Item._ext = None
    
    #-----< SLDRBs-ToBeModified-ItemExtIEs >-----#
    SLDRBs_ToBeModified_ItemExtIEs = CLASS(name=u'SLDRBs-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeReleased-Item >-----#
    SLDRBs_ToBeReleased_Item = SEQ(name=u'SLDRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeReleased_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeReleased_Item_iE_Extensions._cont = __SLDRBs_ToBeReleased_Item_iE_Extensions__item_
    _SLDRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeReleased_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_ToBeReleased_Item_sLDRBID),
        (u'iE-Extensions', _SLDRBs_ToBeReleased_Item_iE_Extensions),
        ])
    SLDRBs_ToBeReleased_Item._ext = None
    
    #-----< SLDRBs-ToBeReleased-ItemExtIEs >-----#
    SLDRBs_ToBeReleased_ItemExtIEs = CLASS(name=u'SLDRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetup-Item >-----#
    SLDRBs_ToBeSetup_Item = SEQ(name=u'SLDRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeSetup_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeSetup_Item_sLDRBInformation = SEQ(name=u'sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')))
    _SLDRBs_ToBeSetup_Item_rLCMode = ENUM(name=u'rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _SLDRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeSetup_Item_iE_Extensions._cont = __SLDRBs_ToBeSetup_Item_iE_Extensions__item_
    _SLDRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeSetup_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_ToBeSetup_Item_sLDRBID),
        (u'sLDRBInformation', _SLDRBs_ToBeSetup_Item_sLDRBInformation),
        (u'rLCMode', _SLDRBs_ToBeSetup_Item_rLCMode),
        (u'iE-Extensions', _SLDRBs_ToBeSetup_Item_iE_Extensions),
        ])
    SLDRBs_ToBeSetup_Item._ext = None
    
    #-----< SLDRBs-ToBeSetup-ItemExtIEs >-----#
    SLDRBs_ToBeSetup_ItemExtIEs = CLASS(name=u'SLDRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetupMod-Item >-----#
    SLDRBs_ToBeSetupMod_Item = SEQ(name=u'SLDRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeSetupMod_Item_sLDRBID = INT(name=u'sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeSetupMod_Item_sLDRBInformation = SEQ(name=u'sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')))
    _SLDRBs_ToBeSetupMod_Item_rLCMode = ENUM(name=u'rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions._cont = __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        (u'sLDRBID', _SLDRBs_ToBeSetupMod_Item_sLDRBID),
        (u'sLDRBInformation', _SLDRBs_ToBeSetupMod_Item_sLDRBInformation),
        (u'rLCMode', _SLDRBs_ToBeSetupMod_Item_rLCMode),
        (u'iE-Extensions', _SLDRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    SLDRBs_ToBeSetupMod_Item._ext = None
    
    #-----< SLDRBs-ToBeSetupMod-ItemExtIEs >-----#
    SLDRBs_ToBeSetupMod_ItemExtIEs = CLASS(name=u'SLDRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SL-PHY-MAC-RLC-Config >-----#
    SL_PHY_MAC_RLC_Config = OCT_STR(name=u'SL-PHY-MAC-RLC-Config', mode=MODE_TYPE)
    
    #-----< SL-ConfigDedicatedEUTRA-Info >-----#
    SL_ConfigDedicatedEUTRA_Info = OCT_STR(name=u'SL-ConfigDedicatedEUTRA-Info', mode=MODE_TYPE)
    
    #-----< SliceAvailableCapacity >-----#
    SliceAvailableCapacity = SEQ(name=u'SliceAvailableCapacity', mode=MODE_TYPE)
    _SliceAvailableCapacity_sliceAvailableCapacityList = SEQ_OF(name=u'sliceAvailableCapacityList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacityList')))
    _SliceAvailableCapacity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceAvailableCapacity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__id_tab
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceAvailableCapacity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceAvailableCapacity_iE_Extensions__item__id),
        (u'criticality', ___SliceAvailableCapacity_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __SliceAvailableCapacity_iE_Extensions__item_._ext = None
    _SliceAvailableCapacity_iE_Extensions._cont = __SliceAvailableCapacity_iE_Extensions__item_
    _SliceAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceAvailableCapacity._cont = ASN1Dict([
        (u'sliceAvailableCapacityList', _SliceAvailableCapacity_sliceAvailableCapacityList),
        (u'iE-Extensions', _SliceAvailableCapacity_iE_Extensions),
        ])
    SliceAvailableCapacity._ext = None
    
    #-----< SliceAvailableCapacity-ExtIEs >-----#
    SliceAvailableCapacity_ExtIEs = CLASS(name=u'SliceAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceAvailableCapacityList >-----#
    SliceAvailableCapacityList = SEQ_OF(name=u'SliceAvailableCapacityList', mode=MODE_TYPE)
    _SliceAvailableCapacityList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacityItem')))
    SliceAvailableCapacityList._cont = _SliceAvailableCapacityList__item_
    SliceAvailableCapacityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SliceAvailableCapacityItem >-----#
    SliceAvailableCapacityItem = SEQ(name=u'SliceAvailableCapacityItem', mode=MODE_TYPE)
    _SliceAvailableCapacityItem_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List = SEQ_OF(name=u'sNSSAIAvailableCapacity-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIAvailableCapacity-List')))
    _SliceAvailableCapacityItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceAvailableCapacityItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceAvailableCapacityItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceAvailableCapacityItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceAvailableCapacityItem_iE_Extensions__item__id),
        (u'criticality', ___SliceAvailableCapacityItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue),
        ])
    __SliceAvailableCapacityItem_iE_Extensions__item_._ext = None
    _SliceAvailableCapacityItem_iE_Extensions._cont = __SliceAvailableCapacityItem_iE_Extensions__item_
    _SliceAvailableCapacityItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceAvailableCapacityItem._cont = ASN1Dict([
        (u'pLMNIdentity', _SliceAvailableCapacityItem_pLMNIdentity),
        (u'sNSSAIAvailableCapacity-List', _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List),
        (u'iE-Extensions', _SliceAvailableCapacityItem_iE_Extensions),
        ])
    SliceAvailableCapacityItem._ext = None
    
    #-----< SliceAvailableCapacityItem-ExtIEs >-----#
    SliceAvailableCapacityItem_ExtIEs = CLASS(name=u'SliceAvailableCapacityItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceAvailableCapacityItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAIAvailableCapacity-List >-----#
    SNSSAIAvailableCapacity_List = SEQ_OF(name=u'SNSSAIAvailableCapacity-List', mode=MODE_TYPE)
    _SNSSAIAvailableCapacity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIAvailableCapacity-Item')))
    SNSSAIAvailableCapacity_List._cont = _SNSSAIAvailableCapacity_List__item_
    SNSSAIAvailableCapacity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SNSSAIAvailableCapacity-Item >-----#
    SNSSAIAvailableCapacity_Item = SEQ(name=u'SNSSAIAvailableCapacity-Item', mode=MODE_TYPE)
    _SNSSAIAvailableCapacity_Item_sNSSAI = SEQ(name=u'sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink = INT(name=u'sliceAvailableCapacityValueDownlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink = INT(name=u'sliceAvailableCapacityValueUplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIAvailableCapacity_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id),
        (u'criticality', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue),
        ])
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_._ext = None
    _SNSSAIAvailableCapacity_Item_iE_Extensions._cont = __SNSSAIAvailableCapacity_Item_iE_Extensions__item_
    _SNSSAIAvailableCapacity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAIAvailableCapacity_Item._cont = ASN1Dict([
        (u'sNSSAI', _SNSSAIAvailableCapacity_Item_sNSSAI),
        (u'sliceAvailableCapacityValueDownlink', _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink),
        (u'sliceAvailableCapacityValueUplink', _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink),
        (u'iE-Extensions', _SNSSAIAvailableCapacity_Item_iE_Extensions),
        ])
    SNSSAIAvailableCapacity_Item._ext = None
    
    #-----< SNSSAIAvailableCapacity-Item-ExtIEs >-----#
    SNSSAIAvailableCapacity_Item_ExtIEs = CLASS(name=u'SNSSAIAvailableCapacity-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAIAvailableCapacity_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceSupportList >-----#
    SliceSupportList = SEQ_OF(name=u'SliceSupportList', mode=MODE_TYPE)
    _SliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportItem')))
    SliceSupportList._cont = _SliceSupportList__item_
    SliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceSupportItem >-----#
    SliceSupportItem = SEQ(name=u'SliceSupportItem', mode=MODE_TYPE)
    _SliceSupportItem_sNSSAI = SEQ(name=u'sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SliceSupportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceSupportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__id._const_tab = ____SliceSupportItem_iE_Extensions__item__id_tab
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceSupportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab = ____SliceSupportItem_iE_Extensions__item__criticality_tab
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceSupportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceSupportItem_iE_Extensions__item__extensionValue_tab
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceSupportItem_iE_Extensions__item__id),
        (u'criticality', ___SliceSupportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceSupportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceSupportItem_iE_Extensions__item_._ext = None
    _SliceSupportItem_iE_Extensions._cont = __SliceSupportItem_iE_Extensions__item_
    _SliceSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceSupportItem._cont = ASN1Dict([
        (u'sNSSAI', _SliceSupportItem_sNSSAI),
        (u'iE-Extensions', _SliceSupportItem_iE_Extensions),
        ])
    SliceSupportItem._ext = None
    
    #-----< SliceSupportItem-ExtIEs >-----#
    SliceSupportItem_ExtIEs = CLASS(name=u'SliceSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceToReportList >-----#
    SliceToReportList = SEQ_OF(name=u'SliceToReportList', mode=MODE_TYPE)
    _SliceToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceToReportItem')))
    SliceToReportList._cont = _SliceToReportList__item_
    SliceToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SliceToReportItem >-----#
    SliceToReportItem = SEQ(name=u'SliceToReportItem', mode=MODE_TYPE)
    _SliceToReportItem_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _SliceToReportItem_sNSSAIlist = SEQ_OF(name=u'sNSSAIlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI-list')))
    _SliceToReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceToReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__id._const_tab = ____SliceToReportItem_iE_Extensions__item__id_tab
    ___SliceToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceToReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceToReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab = ____SliceToReportItem_iE_Extensions__item__criticality_tab
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceToReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceToReportItem_iE_Extensions__item__extensionValue_tab
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceToReportItem_iE_Extensions__item__id),
        (u'criticality', ___SliceToReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceToReportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceToReportItem_iE_Extensions__item_._ext = None
    _SliceToReportItem_iE_Extensions._cont = __SliceToReportItem_iE_Extensions__item_
    _SliceToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceToReportItem._cont = ASN1Dict([
        (u'pLMNIdentity', _SliceToReportItem_pLMNIdentity),
        (u'sNSSAIlist', _SliceToReportItem_sNSSAIlist),
        (u'iE-Extensions', _SliceToReportItem_iE_Extensions),
        ])
    SliceToReportItem._ext = None
    
    #-----< SliceToReportItem-ExtIEs >-----#
    SliceToReportItem_ExtIEs = CLASS(name=u'SliceToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SlotNumber >-----#
    SlotNumber = INT(name=u'SlotNumber', mode=MODE_TYPE)
    SlotNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    
    #-----< SNSSAI-list >-----#
    SNSSAI_list = SEQ_OF(name=u'SNSSAI-list', mode=MODE_TYPE)
    _SNSSAI_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI-Item')))
    SNSSAI_list._cont = _SNSSAI_list__item_
    SNSSAI_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SNSSAI-Item >-----#
    SNSSAI_Item = SEQ(name=u'SNSSAI-Item', mode=MODE_TYPE)
    _SNSSAI_Item_sNSSAI = SEQ(name=u'sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SNSSAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNSSAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab = ____SNSSAI_Item_iE_Extensions__item__id_tab
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNSSAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNSSAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab = ____SNSSAI_Item_iE_Extensions__item__criticality_tab
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNSSAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab = ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNSSAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNSSAI_Item_iE_Extensions__item__id),
        (u'criticality', ___SNSSAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNSSAI_Item_iE_Extensions__item__extensionValue),
        ])
    __SNSSAI_Item_iE_Extensions__item_._ext = None
    _SNSSAI_Item_iE_Extensions._cont = __SNSSAI_Item_iE_Extensions__item_
    _SNSSAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAI_Item._cont = ASN1Dict([
        (u'sNSSAI', _SNSSAI_Item_sNSSAI),
        (u'iE-Extensions', _SNSSAI_Item_iE_Extensions),
        ])
    SNSSAI_Item._ext = None
    
    #-----< SNSSAI-Item-ExtIEs >-----#
    SNSSAI_Item_ExtIEs = CLASS(name=u'SNSSAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Slot-Configuration-List >-----#
    Slot_Configuration_List = SEQ_OF(name=u'Slot-Configuration-List', mode=MODE_TYPE)
    _Slot_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Slot-Configuration-Item')))
    Slot_Configuration_List._cont = _Slot_Configuration_List__item_
    Slot_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< Slot-Configuration-Item >-----#
    Slot_Configuration_Item = SEQ(name=u'Slot-Configuration-Item', mode=MODE_TYPE)
    _Slot_Configuration_Item_slotIndex = INT(name=u'slotIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Slot_Configuration_Item_slotIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5119)], ev=[], er=[])
    _Slot_Configuration_Item_symbolAllocInSlot = CHOICE(name=u'symbolAllocInSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SymbolAllocInSlot')))
    _Slot_Configuration_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Slot_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Slot_Configuration_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Slot_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__id_tab
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Slot_Configuration_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Slot_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Slot_Configuration_Item_iE_Extensions__item__id),
        (u'criticality', ___Slot_Configuration_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Slot_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Slot_Configuration_Item_iE_Extensions__item_._ext = None
    _Slot_Configuration_Item_iE_Extensions._cont = __Slot_Configuration_Item_iE_Extensions__item_
    _Slot_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Slot_Configuration_Item._cont = ASN1Dict([
        (u'slotIndex', _Slot_Configuration_Item_slotIndex),
        (u'symbolAllocInSlot', _Slot_Configuration_Item_symbolAllocInSlot),
        (u'iE-Extensions', _Slot_Configuration_Item_iE_Extensions),
        ])
    Slot_Configuration_Item._ext = None
    
    #-----< Slot-Configuration-ItemExtIEs >-----#
    Slot_Configuration_ItemExtIEs = CLASS(name=u'Slot-Configuration-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Slot_Configuration_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAI >-----#
    SNSSAI = SEQ(name=u'SNSSAI', mode=MODE_TYPE)
    _SNSSAI_sST = OCT_STR(name=u'sST', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAI_sST._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _SNSSAI_sD = OCT_STR(name=u'sD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAI_sD._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _SNSSAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNSSAI_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__id._const_tab = ____SNSSAI_iE_Extensions__item__id_tab
    ___SNSSAI_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNSSAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNSSAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__criticality._const_tab = ____SNSSAI_iE_Extensions__item__criticality_tab
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNSSAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab = ____SNSSAI_iE_Extensions__item__extensionValue_tab
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNSSAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNSSAI_iE_Extensions__item__id),
        (u'criticality', ___SNSSAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNSSAI_iE_Extensions__item__extensionValue),
        ])
    __SNSSAI_iE_Extensions__item_._ext = None
    _SNSSAI_iE_Extensions._cont = __SNSSAI_iE_Extensions__item_
    _SNSSAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAI._cont = ASN1Dict([
        (u'sST', _SNSSAI_sST),
        (u'sD', _SNSSAI_sD),
        (u'iE-Extensions', _SNSSAI_iE_Extensions),
        ])
    SNSSAI._ext = None
    
    #-----< SNSSAI-ExtIEs >-----#
    SNSSAI_ExtIEs = CLASS(name=u'SNSSAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialDirectionInformation >-----#
    SpatialDirectionInformation = SEQ(name=u'SpatialDirectionInformation', mode=MODE_TYPE)
    _SpatialDirectionInformation_nR_PRSBeamInformation = SEQ(name=u'nR-PRSBeamInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformation')))
    _SpatialDirectionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialDirectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialDirectionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__id_tab
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialDirectionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialDirectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialDirectionInformation_iE_Extensions__item__id),
        (u'criticality', ___SpatialDirectionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialDirectionInformation_iE_Extensions__item__extensionValue),
        ])
    __SpatialDirectionInformation_iE_Extensions__item_._ext = None
    _SpatialDirectionInformation_iE_Extensions._cont = __SpatialDirectionInformation_iE_Extensions__item_
    _SpatialDirectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialDirectionInformation._cont = ASN1Dict([
        (u'nR-PRSBeamInformation', _SpatialDirectionInformation_nR_PRSBeamInformation),
        (u'iE-Extensions', _SpatialDirectionInformation_iE_Extensions),
        ])
    SpatialDirectionInformation._ext = None
    
    #-----< SpatialDirectionInformation-ExtIEs >-----#
    SpatialDirectionInformation_ExtIEs = CLASS(name=u'SpatialDirectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialDirectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationInfo >-----#
    SpatialRelationInfo = SEQ(name=u'SpatialRelationInfo', mode=MODE_TYPE)
    _SpatialRelationInfo_spatialRelationforResourceID = SEQ_OF(name=u'spatialRelationforResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationforResourceID')))
    _SpatialRelationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab = ____SpatialRelationInfo_iE_Extensions__item__id_tab
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab = ____SpatialRelationInfo_iE_Extensions__item__criticality_tab
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationInfo_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationInfo_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationInfo_iE_Extensions__item_._ext = None
    _SpatialRelationInfo_iE_Extensions._cont = __SpatialRelationInfo_iE_Extensions__item_
    _SpatialRelationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationInfo._cont = ASN1Dict([
        (u'spatialRelationforResourceID', _SpatialRelationInfo_spatialRelationforResourceID),
        (u'iE-Extensions', _SpatialRelationInfo_iE_Extensions),
        ])
    SpatialRelationInfo._ext = None
    
    #-----< SpatialRelationInfo-ExtIEs >-----#
    SpatialRelationInfo_ExtIEs = CLASS(name=u'SpatialRelationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationforResourceID >-----#
    SpatialRelationforResourceID = SEQ_OF(name=u'SpatialRelationforResourceID', mode=MODE_TYPE)
    _SpatialRelationforResourceID__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationforResourceIDItem')))
    SpatialRelationforResourceID._cont = _SpatialRelationforResourceID__item_
    SpatialRelationforResourceID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SpatialRelationforResourceIDItem >-----#
    SpatialRelationforResourceIDItem = SEQ(name=u'SpatialRelationforResourceIDItem', mode=MODE_TYPE)
    _SpatialRelationforResourceIDItem_referenceSignal = CHOICE(name=u'referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSignal')))
    _SpatialRelationforResourceIDItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationforResourceIDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationforResourceIDItem_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._ext = None
    _SpatialRelationforResourceIDItem_iE_Extensions._cont = __SpatialRelationforResourceIDItem_iE_Extensions__item_
    _SpatialRelationforResourceIDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationforResourceIDItem._cont = ASN1Dict([
        (u'referenceSignal', _SpatialRelationforResourceIDItem_referenceSignal),
        (u'iE-Extensions', _SpatialRelationforResourceIDItem_iE_Extensions),
        ])
    SpatialRelationforResourceIDItem._ext = None
    
    #-----< SpatialRelationforResourceIDItem-ExtIEs >-----#
    SpatialRelationforResourceIDItem_ExtIEs = CLASS(name=u'SpatialRelationforResourceIDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationforResourceIDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource >-----#
    SpatialRelationPerSRSResource = SEQ(name=u'SpatialRelationPerSRSResource', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List = SEQ_OF(name=u'spatialRelationPerSRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource-List')))
    _SpatialRelationPerSRSResource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationPerSRSResource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationPerSRSResource_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResource_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResource_iE_Extensions._cont = __SpatialRelationPerSRSResource_iE_Extensions__item_
    _SpatialRelationPerSRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResource._cont = ASN1Dict([
        (u'spatialRelationPerSRSResource-List', _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List),
        (u'iE-Extensions', _SpatialRelationPerSRSResource_iE_Extensions),
        ])
    SpatialRelationPerSRSResource._ext = []
    
    #-----< SpatialRelationPerSRSResource-ExtIEs >-----#
    SpatialRelationPerSRSResource_ExtIEs = CLASS(name=u'SpatialRelationPerSRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource-List >-----#
    SpatialRelationPerSRSResource_List = SEQ_OF(name=u'SpatialRelationPerSRSResource-List', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResourceItem')))
    SpatialRelationPerSRSResource_List._cont = _SpatialRelationPerSRSResource_List__item_
    SpatialRelationPerSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SpatialRelationPerSRSResourceItem >-----#
    SpatialRelationPerSRSResourceItem = SEQ(name=u'SpatialRelationPerSRSResourceItem', mode=MODE_TYPE)
    _SpatialRelationPerSRSResourceItem_referenceSignal = CHOICE(name=u'referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSignal')))
    _SpatialRelationPerSRSResourceItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResourceItem_iE_Extensions._cont = __SpatialRelationPerSRSResourceItem_iE_Extensions__item_
    _SpatialRelationPerSRSResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResourceItem._cont = ASN1Dict([
        (u'referenceSignal', _SpatialRelationPerSRSResourceItem_referenceSignal),
        (u'iE-Extensions', _SpatialRelationPerSRSResourceItem_iE_Extensions),
        ])
    SpatialRelationPerSRSResourceItem._ext = []
    
    #-----< SpatialRelationPerSRSResourceItem-ExtIEs >-----#
    SpatialRelationPerSRSResourceItem_ExtIEs = CLASS(name=u'SpatialRelationPerSRSResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResourceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPos >-----#
    SpatialRelationPos = CHOICE(name=u'SpatialRelationPos', mode=MODE_TYPE)
    _SpatialRelationPos_sSBPos = SEQ(name=u'sSBPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _SpatialRelationPos_pRSInformationPos = SEQ(name=u'pRSInformationPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSInformationPos')))
    _SpatialRelationPos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SpatialRelationPos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SpatialRelationPos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_id._const_tab = ___SpatialRelationPos_choice_extension_id_tab
    __SpatialRelationPos_choice_extension_id._const_tab_at = None
    __SpatialRelationPos_choice_extension_id._const_tab_id = u'id'
    __SpatialRelationPos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SpatialRelationPos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_criticality._const_tab = ___SpatialRelationPos_choice_extension_criticality_tab
    __SpatialRelationPos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SpatialRelationPos_choice_extension_criticality._const_tab_id = u'criticality'
    __SpatialRelationPos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SpatialRelationPos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_value._const_tab = ___SpatialRelationPos_choice_extension_value_tab
    __SpatialRelationPos_choice_extension_value._const_tab_at = ('..', u'id')
    __SpatialRelationPos_choice_extension_value._const_tab_id = u'Value'
    _SpatialRelationPos_choice_extension._cont = ASN1Dict([
        (u'id', __SpatialRelationPos_choice_extension_id),
        (u'criticality', __SpatialRelationPos_choice_extension_criticality),
        (u'value', __SpatialRelationPos_choice_extension_value),
        ])
    _SpatialRelationPos_choice_extension._ext = None
    SpatialRelationPos._cont = ASN1Dict([
        (u'sSBPos', _SpatialRelationPos_sSBPos),
        (u'pRSInformationPos', _SpatialRelationPos_pRSInformationPos),
        (u'choice-extension', _SpatialRelationPos_choice_extension),
        ])
    SpatialRelationPos._ext = None
    
    #-----< SpatialInformationPos-ExtIEs >-----#
    SpatialInformationPos_ExtIEs = CLASS(name=u'SpatialInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SpatialInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpectrumSharingGroupID >-----#
    SpectrumSharingGroupID = INT(name=u'SpectrumSharingGroupID', mode=MODE_TYPE)
    SpectrumSharingGroupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SRBID >-----#
    SRBID = INT(name=u'SRBID', mode=MODE_TYPE)
    SRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetup-Item >-----#
    SRBs_FailedToBeSetup_Item = SEQ(name=u'SRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _SRBs_FailedToBeSetup_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_FailedToBeSetup_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _SRBs_FailedToBeSetup_Item_iE_Extensions._cont = __SRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _SRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_FailedToBeSetup_Item_sRBID),
        (u'cause', _SRBs_FailedToBeSetup_Item_cause),
        (u'iE-Extensions', _SRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    SRBs_FailedToBeSetup_Item._ext = []
    
    #-----< SRBs-FailedToBeSetup-ItemExtIEs >-----#
    SRBs_FailedToBeSetup_ItemExtIEs = CLASS(name=u'SRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetupMod-Item >-----#
    SRBs_FailedToBeSetupMod_Item = SEQ(name=u'SRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _SRBs_FailedToBeSetupMod_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_FailedToBeSetupMod_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_FailedToBeSetupMod_Item_sRBID),
        (u'cause', _SRBs_FailedToBeSetupMod_Item_cause),
        (u'iE-Extensions', _SRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    SRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< SRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    SRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name=u'SRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Modified-Item >-----#
    SRBs_Modified_Item = SEQ(name=u'SRBs-Modified-Item', mode=MODE_TYPE)
    _SRBs_Modified_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Modified_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_Modified_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Modified_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__id_tab
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_Modified_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_Modified_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Modified_Item_iE_Extensions__item_._ext = None
    _SRBs_Modified_Item_iE_Extensions._cont = __SRBs_Modified_Item_iE_Extensions__item_
    _SRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Modified_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_Modified_Item_sRBID),
        (u'lCID', _SRBs_Modified_Item_lCID),
        (u'iE-Extensions', _SRBs_Modified_Item_iE_Extensions),
        ])
    SRBs_Modified_Item._ext = []
    
    #-----< SRBs-Modified-ItemExtIEs >-----#
    SRBs_Modified_ItemExtIEs = CLASS(name=u'SRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Required-ToBeReleased-Item >-----#
    SRBs_Required_ToBeReleased_Item = SEQ(name=u'SRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _SRBs_Required_ToBeReleased_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _SRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_Required_ToBeReleased_Item_sRBID),
        (u'iE-Extensions', _SRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    SRBs_Required_ToBeReleased_Item._ext = []
    
    #-----< SRBs-Required-ToBeReleased-ItemExtIEs >-----#
    SRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name=u'SRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Setup-Item >-----#
    SRBs_Setup_Item = SEQ(name=u'SRBs-Setup-Item', mode=MODE_TYPE)
    _SRBs_Setup_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Setup_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_Setup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Setup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__id_tab
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_Setup_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_Setup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Setup_Item_iE_Extensions__item_._ext = None
    _SRBs_Setup_Item_iE_Extensions._cont = __SRBs_Setup_Item_iE_Extensions__item_
    _SRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Setup_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_Setup_Item_sRBID),
        (u'lCID', _SRBs_Setup_Item_lCID),
        (u'iE-Extensions', _SRBs_Setup_Item_iE_Extensions),
        ])
    SRBs_Setup_Item._ext = []
    
    #-----< SRBs-Setup-ItemExtIEs >-----#
    SRBs_Setup_ItemExtIEs = CLASS(name=u'SRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-SetupMod-Item >-----#
    SRBs_SetupMod_Item = SEQ(name=u'SRBs-SetupMod-Item', mode=MODE_TYPE)
    _SRBs_SetupMod_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_SetupMod_Item_lCID = INT(name=u'lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_SetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_SetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_SetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_SetupMod_Item_iE_Extensions._cont = __SRBs_SetupMod_Item_iE_Extensions__item_
    _SRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_SetupMod_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_SetupMod_Item_sRBID),
        (u'lCID', _SRBs_SetupMod_Item_lCID),
        (u'iE-Extensions', _SRBs_SetupMod_Item_iE_Extensions),
        ])
    SRBs_SetupMod_Item._ext = []
    
    #-----< SRBs-SetupMod-ItemExtIEs >-----#
    SRBs_SetupMod_ItemExtIEs = CLASS(name=u'SRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeReleased-Item >-----#
    SRBs_ToBeReleased_Item = SEQ(name=u'SRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _SRBs_ToBeReleased_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_ToBeReleased_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeReleased_Item_iE_Extensions._cont = __SRBs_ToBeReleased_Item_iE_Extensions__item_
    _SRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeReleased_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_ToBeReleased_Item_sRBID),
        (u'iE-Extensions', _SRBs_ToBeReleased_Item_iE_Extensions),
        ])
    SRBs_ToBeReleased_Item._ext = []
    
    #-----< SRBs-ToBeReleased-ItemExtIEs >-----#
    SRBs_ToBeReleased_ItemExtIEs = CLASS(name=u'SRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetup-Item >-----#
    SRBs_ToBeSetup_Item = SEQ(name=u'SRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _SRBs_ToBeSetup_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeSetup_Item_duplicationIndication = ENUM(name=u'duplicationIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationIndication')), opt=True)
    _SRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 372), (u'criticality', u'ignore'), (u'Extension', _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeSetup_Item_iE_Extensions._cont = __SRBs_ToBeSetup_Item_iE_Extensions__item_
    _SRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeSetup_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_ToBeSetup_Item_sRBID),
        (u'duplicationIndication', _SRBs_ToBeSetup_Item_duplicationIndication),
        (u'iE-Extensions', _SRBs_ToBeSetup_Item_iE_Extensions),
        ])
    SRBs_ToBeSetup_Item._ext = []
    
    #-----< SRBs-ToBeSetup-ItemExtIEs >-----#
    SRBs_ToBeSetup_ItemExtIEs = CLASS(name=u'SRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    SRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 372), (u'criticality', u'ignore'), (u'Extension', _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetupMod-Item >-----#
    SRBs_ToBeSetupMod_Item = SEQ(name=u'SRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SRBs_ToBeSetupMod_Item_sRBID = INT(name=u'sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeSetupMod_Item_duplicationIndication = ENUM(name=u'duplicationIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationIndication')), opt=True)
    _SRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 372), (u'criticality', u'ignore'), (u'Extension', _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        (u'criticality', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeSetupMod_Item_iE_Extensions._cont = __SRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _SRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        (u'sRBID', _SRBs_ToBeSetupMod_Item_sRBID),
        (u'duplicationIndication', _SRBs_ToBeSetupMod_Item_duplicationIndication),
        (u'iE-Extensions', _SRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    SRBs_ToBeSetupMod_Item._ext = []
    
    #-----< SRBs-ToBeSetupMod-ItemExtIEs >-----#
    SRBs_ToBeSetupMod_ItemExtIEs = CLASS(name=u'SRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    SRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 372), (u'criticality', u'ignore'), (u'Extension', _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSCarrier-List >-----#
    SRSCarrier_List = SEQ_OF(name=u'SRSCarrier-List', mode=MODE_TYPE)
    _SRSCarrier_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSCarrier-List-Item')))
    SRSCarrier_List._cont = _SRSCarrier_List__item_
    SRSCarrier_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRSCarrier-List-Item >-----#
    SRSCarrier_List_Item = SEQ(name=u'SRSCarrier-List-Item', mode=MODE_TYPE)
    _SRSCarrier_List_Item_pointA = INT(name=u'pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSCarrier_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List = SEQ_OF(name=u'uplinkChannelBW-PerSCS-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UplinkChannelBW-PerSCS-List')))
    _SRSCarrier_List_Item_activeULBWP = SEQ(name=u'activeULBWP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ActiveULBWP')))
    _SRSCarrier_List_Item_pci = INT(name=u'pci', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')), opt=True)
    _SRSCarrier_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSCarrier_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSCarrier_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__id_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSCarrier_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSCarrier_List_Item_iE_Extensions__item__id),
        (u'criticality', ___SRSCarrier_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSCarrier_List_Item_iE_Extensions__item_._ext = None
    _SRSCarrier_List_Item_iE_Extensions._cont = __SRSCarrier_List_Item_iE_Extensions__item_
    _SRSCarrier_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSCarrier_List_Item._cont = ASN1Dict([
        (u'pointA', _SRSCarrier_List_Item_pointA),
        (u'uplinkChannelBW-PerSCS-List', _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List),
        (u'activeULBWP', _SRSCarrier_List_Item_activeULBWP),
        (u'pci', _SRSCarrier_List_Item_pci),
        (u'iE-Extensions', _SRSCarrier_List_Item_iE_Extensions),
        ])
    SRSCarrier_List_Item._ext = None
    
    #-----< SRSCarrier-List-Item-ExtIEs >-----#
    SRSCarrier_List_Item_ExtIEs = CLASS(name=u'SRSCarrier-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSCarrier_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfig >-----#
    SRSConfig = SEQ(name=u'SRSConfig', mode=MODE_TYPE)
    _SRSConfig_sRSResource_List = SEQ_OF(name=u'sRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResource-List')), opt=True)
    _SRSConfig_posSRSResource_List = SEQ_OF(name=u'posSRSResource-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResource-List')), opt=True)
    _SRSConfig_sRSResourceSet_List = SEQ_OF(name=u'sRSResourceSet-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSet-List')), opt=True)
    _SRSConfig_posSRSResourceSet_List = SEQ_OF(name=u'posSRSResourceSet-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceSet-List')), opt=True)
    _SRSConfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSConfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__id._const_tab = ____SRSConfig_iE_Extensions__item__id_tab
    ___SRSConfig_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSConfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__criticality._const_tab = ____SRSConfig_iE_Extensions__item__criticality_tab
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSConfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab = ____SRSConfig_iE_Extensions__item__extensionValue_tab
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSConfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSConfig_iE_Extensions__item__id),
        (u'criticality', ___SRSConfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSConfig_iE_Extensions__item__extensionValue),
        ])
    __SRSConfig_iE_Extensions__item_._ext = None
    _SRSConfig_iE_Extensions._cont = __SRSConfig_iE_Extensions__item_
    _SRSConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfig._cont = ASN1Dict([
        (u'sRSResource-List', _SRSConfig_sRSResource_List),
        (u'posSRSResource-List', _SRSConfig_posSRSResource_List),
        (u'sRSResourceSet-List', _SRSConfig_sRSResourceSet_List),
        (u'posSRSResourceSet-List', _SRSConfig_posSRSResourceSet_List),
        (u'iE-Extensions', _SRSConfig_iE_Extensions),
        ])
    SRSConfig._ext = None
    
    #-----< SRSConfig-ExtIEs >-----#
    SRSConfig_ExtIEs = CLASS(name=u'SRSConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfiguration >-----#
    SRSConfiguration = SEQ(name=u'SRSConfiguration', mode=MODE_TYPE)
    _SRSConfiguration_sRSCarrier_List = SEQ_OF(name=u'sRSCarrier-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSCarrier-List')))
    _SRSConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__id._const_tab = ____SRSConfiguration_iE_Extensions__item__id_tab
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab = ____SRSConfiguration_iE_Extensions__item__criticality_tab
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSConfiguration_iE_Extensions__item__id),
        (u'criticality', ___SRSConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SRSConfiguration_iE_Extensions__item_._ext = None
    _SRSConfiguration_iE_Extensions._cont = __SRSConfiguration_iE_Extensions__item_
    _SRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfiguration._cont = ASN1Dict([
        (u'sRSCarrier-List', _SRSConfiguration_sRSCarrier_List),
        (u'iE-Extensions', _SRSConfiguration_iE_Extensions),
        ])
    SRSConfiguration._ext = None
    
    #-----< SRSConfiguration-ExtIEs >-----#
    SRSConfiguration_ExtIEs = CLASS(name=u'SRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SrsFrequency >-----#
    SrsFrequency = INT(name=u'SrsFrequency', mode=MODE_TYPE)
    SrsFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SRSPosResourceID >-----#
    SRSPosResourceID = INT(name=u'SRSPosResourceID', mode=MODE_TYPE)
    SRSPosResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource >-----#
    SRSResource = SEQ(name=u'SRSResource', mode=MODE_TYPE)
    _SRSResource_sRSResourceID = INT(name=u'sRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    _SRSResource_nrofSRS_Ports = ENUM(name=u'nrofSRS-Ports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSRS_Ports._cont = ASN1Dict([(u'port1', 0), (u'ports2', 1), (u'ports4', 2)])
    _SRSResource_nrofSRS_Ports._ext = None
    _SRSResource_transmissionComb = CHOICE(name=u'transmissionComb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransmissionComb')))
    _SRSResource_startPosition = INT(name=u'startPosition', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _SRSResource_nrofSymbols = ENUM(name=u'nrofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSymbols._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2)])
    _SRSResource_nrofSymbols._ext = None
    _SRSResource_repetitionFactor = ENUM(name=u'repetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_repetitionFactor._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2)])
    _SRSResource_repetitionFactor._ext = None
    _SRSResource_freqDomainPosition = INT(name=u'freqDomainPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=67)], ev=None, er=[])
    _SRSResource_freqDomainShift = INT(name=u'freqDomainShift', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _SRSResource_c_SRS = INT(name=u'c-SRS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SRSResource_b_SRS = INT(name=u'b-SRS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_b_hop = INT(name=u'b-hop', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_hop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_groupOrSequenceHopping = ENUM(name=u'groupOrSequenceHopping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_groupOrSequenceHopping._cont = ASN1Dict([(u'neither', 0), (u'groupHopping', 1), (u'sequenceHopping', 2)])
    _SRSResource_groupOrSequenceHopping._ext = None
    _SRSResource_resourceType = CHOICE(name=u'resourceType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceType')))
    _SRSResource_sequenceId = INT(name=u'sequenceId', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _SRSResource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__id._const_tab = ____SRSResource_iE_Extensions__item__id_tab
    ___SRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SRSResource_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__criticality._const_tab = ____SRSResource_iE_Extensions__item__criticality_tab
    ___SRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab = ____SRSResource_iE_Extensions__item__extensionValue_tab
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResource_iE_Extensions__item__id),
        (u'criticality', ___SRSResource_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResource_iE_Extensions__item__extensionValue),
        ])
    __SRSResource_iE_Extensions__item_._ext = None
    _SRSResource_iE_Extensions._cont = __SRSResource_iE_Extensions__item_
    _SRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResource._cont = ASN1Dict([
        (u'sRSResourceID', _SRSResource_sRSResourceID),
        (u'nrofSRS-Ports', _SRSResource_nrofSRS_Ports),
        (u'transmissionComb', _SRSResource_transmissionComb),
        (u'startPosition', _SRSResource_startPosition),
        (u'nrofSymbols', _SRSResource_nrofSymbols),
        (u'repetitionFactor', _SRSResource_repetitionFactor),
        (u'freqDomainPosition', _SRSResource_freqDomainPosition),
        (u'freqDomainShift', _SRSResource_freqDomainShift),
        (u'c-SRS', _SRSResource_c_SRS),
        (u'b-SRS', _SRSResource_b_SRS),
        (u'b-hop', _SRSResource_b_hop),
        (u'groupOrSequenceHopping', _SRSResource_groupOrSequenceHopping),
        (u'resourceType', _SRSResource_resourceType),
        (u'sequenceId', _SRSResource_sequenceId),
        (u'iE-Extensions', _SRSResource_iE_Extensions),
        ])
    SRSResource._ext = None
    
    #-----< SRSResource-ExtIEs >-----#
    SRSResource_ExtIEs = CLASS(name=u'SRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceID >-----#
    SRSResourceID = INT(name=u'SRSResourceID', mode=MODE_TYPE)
    SRSResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResourceID-List >-----#
    SRSResourceID_List = SEQ_OF(name=u'SRSResourceID-List', mode=MODE_TYPE)
    _SRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    SRSResourceID_List._cont = _SRSResourceID_List__item_
    SRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResource-List >-----#
    SRSResource_List = SEQ_OF(name=u'SRSResource-List', mode=MODE_TYPE)
    _SRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResource')))
    SRSResource_List._cont = _SRSResource_List__item_
    SRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRSResourceSet >-----#
    SRSResourceSet = SEQ(name=u'SRSResourceSet', mode=MODE_TYPE)
    _SRSResourceSet_sRSResourceSetID = INT(name=u'sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _SRSResourceSet_sRSResourceID_List = SEQ_OF(name=u'sRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID-List')))
    _SRSResourceSet_resourceSetType = CHOICE(name=u'resourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetType')))
    _SRSResourceSet_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceSet_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__id._const_tab = ____SRSResourceSet_iE_Extensions__item__id_tab
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceSet_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_iE_Extensions__item__criticality_tab
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceSet_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_iE_Extensions__item__extensionValue_tab
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceSet_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceSet_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceSet_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceSet_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_iE_Extensions__item_._ext = None
    _SRSResourceSet_iE_Extensions._cont = __SRSResourceSet_iE_Extensions__item_
    _SRSResourceSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet._cont = ASN1Dict([
        (u'sRSResourceSetID', _SRSResourceSet_sRSResourceSetID),
        (u'sRSResourceID-List', _SRSResourceSet_sRSResourceID_List),
        (u'resourceSetType', _SRSResourceSet_resourceSetType),
        (u'iE-Extensions', _SRSResourceSet_iE_Extensions),
        ])
    SRSResourceSet._ext = None
    
    #-----< SRSResourceSet-ExtIEs >-----#
    SRSResourceSet_ExtIEs = CLASS(name=u'SRSResourceSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResourceSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSetID >-----#
    SRSResourceSetID = INT(name=u'SRSResourceSetID', mode=MODE_TYPE)
    SRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< SRSResourceSetList >-----#
    SRSResourceSetList = SEQ_OF(name=u'SRSResourceSetList', mode=MODE_TYPE)
    _SRSResourceSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetItem')))
    SRSResourceSetList._cont = _SRSResourceSetList__item_
    SRSResourceSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceSetItem >-----#
    SRSResourceSetItem = SEQ(name=u'SRSResourceSetItem', mode=MODE_TYPE)
    _SRSResourceSetItem_numSRSresourcesperset = INT(name=u'numSRSresourcesperset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSResourceSetItem_numSRSresourcesperset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _SRSResourceSetItem_periodicityList = SEQ_OF(name=u'periodicityList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PeriodicityList')), opt=True)
    _SRSResourceSetItem_spatialRelationInfo = SEQ(name=u'spatialRelationInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationInfo')), opt=True)
    _SRSResourceSetItem_pathlossReferenceInfo = SEQ(name=u'pathlossReferenceInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PathlossReferenceInfo')), opt=True)
    _SRSResourceSetItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSetItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    ____SRSResourceSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 435), (u'criticality', u'ignore'), (u'Extension', _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceSetItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceSetItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceSetItem_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceSetItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceSetItem_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSetItem_iE_Extensions__item_._ext = None
    _SRSResourceSetItem_iE_Extensions._cont = __SRSResourceSetItem_iE_Extensions__item_
    _SRSResourceSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSetItem._cont = ASN1Dict([
        (u'numSRSresourcesperset', _SRSResourceSetItem_numSRSresourcesperset),
        (u'periodicityList', _SRSResourceSetItem_periodicityList),
        (u'spatialRelationInfo', _SRSResourceSetItem_spatialRelationInfo),
        (u'pathlossReferenceInfo', _SRSResourceSetItem_pathlossReferenceInfo),
        (u'iE-Extensions', _SRSResourceSetItem_iE_Extensions),
        ])
    SRSResourceSetItem._ext = None
    
    #-----< SRSResourceSetItemExtIEs >-----#
    SRSResourceSetItemExtIEs = CLASS(name=u'SRSResourceSetItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRSResourceSetItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    SRSResourceSetItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 435), (u'criticality', u'ignore'), (u'Extension', _SRSResourceSetItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSet-List >-----#
    SRSResourceSet_List = SEQ_OF(name=u'SRSResourceSet-List', mode=MODE_TYPE)
    _SRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSet')))
    SRSResourceSet_List._cont = _SRSResourceSet_List__item_
    SRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceTrigger >-----#
    SRSResourceTrigger = SEQ(name=u'SRSResourceTrigger', mode=MODE_TYPE)
    _SRSResourceTrigger_aperiodicSRSResourceTriggerList = SEQ_OF(name=u'aperiodicSRSResourceTriggerList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AperiodicSRSResourceTriggerList')))
    _SRSResourceTrigger_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceTrigger_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceTrigger_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab = ____SRSResourceTrigger_iE_Extensions__item__id_tab
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceTrigger_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab = ____SRSResourceTrigger_iE_Extensions__item__criticality_tab
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceTrigger_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceTrigger_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceTrigger_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceTrigger_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceTrigger_iE_Extensions__item_._ext = None
    _SRSResourceTrigger_iE_Extensions._cont = __SRSResourceTrigger_iE_Extensions__item_
    _SRSResourceTrigger_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceTrigger._cont = ASN1Dict([
        (u'aperiodicSRSResourceTriggerList', _SRSResourceTrigger_aperiodicSRSResourceTriggerList),
        (u'iE-Extensions', _SRSResourceTrigger_iE_Extensions),
        ])
    SRSResourceTrigger._ext = None
    
    #-----< SRSResourceTrigger-ExtIEs >-----#
    SRSResourceTrigger_ExtIEs = CLASS(name=u'SRSResourceTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResourceTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB >-----#
    SSB = SEQ(name=u'SSB', mode=MODE_TYPE)
    _SSB_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _SSB_ssb_index = INT(name=u'ssb-index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _SSB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSB_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__id._const_tab = ____SSB_iE_Extensions__item__id_tab
    ___SSB_iE_Extensions__item__id._const_tab_at = None
    ___SSB_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__criticality._const_tab = ____SSB_iE_Extensions__item__criticality_tab
    ___SSB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__extensionValue._const_tab = ____SSB_iE_Extensions__item__extensionValue_tab
    ___SSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSB_iE_Extensions__item__id),
        (u'criticality', ___SSB_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSB_iE_Extensions__item__extensionValue),
        ])
    __SSB_iE_Extensions__item_._ext = None
    _SSB_iE_Extensions._cont = __SSB_iE_Extensions__item_
    _SSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB._cont = ASN1Dict([
        (u'pCI-NR', _SSB_pCI_NR),
        (u'ssb-index', _SSB_ssb_index),
        (u'iE-Extensions', _SSB_iE_Extensions),
        ])
    SSB._ext = None
    
    #-----< SSB-ExtIEs >-----#
    SSB_ExtIEs = CLASS(name=u'SSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-freqInfo >-----#
    SSB_freqInfo = INT(name=u'SSB-freqInfo', mode=MODE_TYPE)
    SSB_freqInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SSB-Index >-----#
    SSB_Index = INT(name=u'SSB-Index', mode=MODE_TYPE)
    SSB_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SSB-subcarrierSpacing >-----#
    SSB_subcarrierSpacing = ENUM(name=u'SSB-subcarrierSpacing', mode=MODE_TYPE)
    SSB_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz120', 2), (u'kHz240', 3), (u'spare3', 4), (u'spare2', 5), (u'spare1', 6)])
    SSB_subcarrierSpacing._ext = []
    
    #-----< SSB-transmissionPeriodicity >-----#
    SSB_transmissionPeriodicity = ENUM(name=u'SSB-transmissionPeriodicity', mode=MODE_TYPE)
    SSB_transmissionPeriodicity._cont = ASN1Dict([(u'sf10', 0), (u'sf20', 1), (u'sf40', 2), (u'sf80', 3), (u'sf160', 4), (u'sf320', 5), (u'sf640', 6)])
    SSB_transmissionPeriodicity._ext = []
    
    #-----< SSB-transmissionTimingOffset >-----#
    SSB_transmissionTimingOffset = INT(name=u'SSB-transmissionTimingOffset', mode=MODE_TYPE)
    SSB_transmissionTimingOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< SSB-transmissionBitmap >-----#
    SSB_transmissionBitmap = CHOICE(name=u'SSB-transmissionBitmap', mode=MODE_TYPE)
    _SSB_transmissionBitmap_shortBitmap = BIT_STR(name=u'shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_mediumBitmap = BIT_STR(name=u'mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_longBitmap = BIT_STR(name=u'longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SSB_transmissionBitmap_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SSB_transmissionBitmap_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_id._const_tab = ___SSB_transmissionBitmap_choice_extension_id_tab
    __SSB_transmissionBitmap_choice_extension_id._const_tab_at = None
    __SSB_transmissionBitmap_choice_extension_id._const_tab_id = u'id'
    __SSB_transmissionBitmap_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SSB_transmissionBitmap_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab = ___SSB_transmissionBitmap_choice_extension_criticality_tab
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab_id = u'criticality'
    __SSB_transmissionBitmap_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SSB_transmissionBitmap_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_value._const_tab = ___SSB_transmissionBitmap_choice_extension_value_tab
    __SSB_transmissionBitmap_choice_extension_value._const_tab_at = ('..', u'id')
    __SSB_transmissionBitmap_choice_extension_value._const_tab_id = u'Value'
    _SSB_transmissionBitmap_choice_extension._cont = ASN1Dict([
        (u'id', __SSB_transmissionBitmap_choice_extension_id),
        (u'criticality', __SSB_transmissionBitmap_choice_extension_criticality),
        (u'value', __SSB_transmissionBitmap_choice_extension_value),
        ])
    _SSB_transmissionBitmap_choice_extension._ext = None
    SSB_transmissionBitmap._cont = ASN1Dict([
        (u'shortBitmap', _SSB_transmissionBitmap_shortBitmap),
        (u'mediumBitmap', _SSB_transmissionBitmap_mediumBitmap),
        (u'longBitmap', _SSB_transmissionBitmap_longBitmap),
        (u'choice-extension', _SSB_transmissionBitmap_choice_extension),
        ])
    SSB_transmissionBitmap._ext = None
    
    #-----< SSB-transmisisonBitmap-ExtIEs >-----#
    SSB_transmisisonBitmap_ExtIEs = CLASS(name=u'SSB-transmisisonBitmap-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SSB_transmisisonBitmap_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBAreaCapacityValueList >-----#
    SSBAreaCapacityValueList = SEQ_OF(name=u'SSBAreaCapacityValueList', mode=MODE_TYPE)
    _SSBAreaCapacityValueList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaCapacityValueItem')))
    SSBAreaCapacityValueList._cont = _SSBAreaCapacityValueList__item_
    SSBAreaCapacityValueList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaCapacityValueItem >-----#
    SSBAreaCapacityValueItem = SEQ(name=u'SSBAreaCapacityValueItem', mode=MODE_TYPE)
    _SSBAreaCapacityValueItem_sSBIndex = INT(name=u'sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaCapacityValueItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBAreaCapacityValueItem_sSBAreaCapacityValue = INT(name=u'sSBAreaCapacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaCapacityValueItem_sSBAreaCapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaCapacityValueItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaCapacityValueItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBAreaCapacityValueItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBAreaCapacityValueItem_iE_Extensions__item__id),
        (u'criticality', ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaCapacityValueItem_iE_Extensions__item_._ext = None
    _SSBAreaCapacityValueItem_iE_Extensions._cont = __SSBAreaCapacityValueItem_iE_Extensions__item_
    _SSBAreaCapacityValueItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaCapacityValueItem._cont = ASN1Dict([
        (u'sSBIndex', _SSBAreaCapacityValueItem_sSBIndex),
        (u'sSBAreaCapacityValue', _SSBAreaCapacityValueItem_sSBAreaCapacityValue),
        (u'iE-Extensions', _SSBAreaCapacityValueItem_iE_Extensions),
        ])
    SSBAreaCapacityValueItem._ext = None
    
    #-----< SSBAreaCapacityValueItem-ExtIEs >-----#
    SSBAreaCapacityValueItem_ExtIEs = CLASS(name=u'SSBAreaCapacityValueItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBAreaCapacityValueItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBAreaRadioResourceStatusList >-----#
    SSBAreaRadioResourceStatusList = SEQ_OF(name=u'SSBAreaRadioResourceStatusList', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatusList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaRadioResourceStatusItem')))
    SSBAreaRadioResourceStatusList._cont = _SSBAreaRadioResourceStatusList__item_
    SSBAreaRadioResourceStatusList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaRadioResourceStatusItem >-----#
    SSBAreaRadioResourceStatusItem = SEQ(name=u'SSBAreaRadioResourceStatusItem', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatusItem_sSBIndex = INT(name=u'sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage = INT(name=u'sSBAreaDLGBRPRBusage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage = INT(name=u'sSBAreaULGBRPRBusage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage = INT(name=u'sSBAreaDLnon-GBRPRBusage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage = INT(name=u'sSBAreaULnon-GBRPRBusage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage = INT(name=u'sSBAreaDLTotalPRBusage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage = INT(name=u'sSBAreaULTotalPRBusage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage = INT(name=u'dLschedulingPDCCHCCEusage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage = INT(name=u'uLschedulingPDCCHCCEusage', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id),
        (u'criticality', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_._ext = None
    _SSBAreaRadioResourceStatusItem_iE_Extensions._cont = __SSBAreaRadioResourceStatusItem_iE_Extensions__item_
    _SSBAreaRadioResourceStatusItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaRadioResourceStatusItem._cont = ASN1Dict([
        (u'sSBIndex', _SSBAreaRadioResourceStatusItem_sSBIndex),
        (u'sSBAreaDLGBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage),
        (u'sSBAreaULGBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage),
        (u'sSBAreaDLnon-GBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage),
        (u'sSBAreaULnon-GBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage),
        (u'sSBAreaDLTotalPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage),
        (u'sSBAreaULTotalPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage),
        (u'dLschedulingPDCCHCCEusage', _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage),
        (u'uLschedulingPDCCHCCEusage', _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage),
        (u'iE-Extensions', _SSBAreaRadioResourceStatusItem_iE_Extensions),
        ])
    SSBAreaRadioResourceStatusItem._ext = None
    
    #-----< SSBAreaRadioResourceStatusItem-ExtIEs >-----#
    SSBAreaRadioResourceStatusItem_ExtIEs = CLASS(name=u'SSBAreaRadioResourceStatusItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBAreaRadioResourceStatusItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInformation >-----#
    SSBInformation = SEQ(name=u'SSBInformation', mode=MODE_TYPE)
    _SSBInformation_sSBInformationList = SEQ_OF(name=u'sSBInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformationList')))
    _SSBInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__id._const_tab = ____SSBInformation_iE_Extensions__item__id_tab
    ___SSBInformation_iE_Extensions__item__id._const_tab_at = None
    ___SSBInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__criticality._const_tab = ____SSBInformation_iE_Extensions__item__criticality_tab
    ___SSBInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab = ____SSBInformation_iE_Extensions__item__extensionValue_tab
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBInformation_iE_Extensions__item__id),
        (u'criticality', ___SSBInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBInformation_iE_Extensions__item__extensionValue),
        ])
    __SSBInformation_iE_Extensions__item_._ext = None
    _SSBInformation_iE_Extensions._cont = __SSBInformation_iE_Extensions__item_
    _SSBInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInformation._cont = ASN1Dict([
        (u'sSBInformationList', _SSBInformation_sSBInformationList),
        (u'iE-Extensions', _SSBInformation_iE_Extensions),
        ])
    SSBInformation._ext = None
    
    #-----< SSBInformation-ExtIEs >-----#
    SSBInformation_ExtIEs = CLASS(name=u'SSBInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInformationList >-----#
    SSBInformationList = SEQ_OF(name=u'SSBInformationList', mode=MODE_TYPE)
    _SSBInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBInformationItem')))
    SSBInformationList._cont = _SSBInformationList__item_
    SSBInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< SSBInformationItem >-----#
    SSBInformationItem = SEQ(name=u'SSBInformationItem', mode=MODE_TYPE)
    _SSBInformationItem_sSB_Configuration = SEQ(name=u'sSB-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-TF-Configuration')))
    _SSBInformationItem_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _SSBInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__id._const_tab = ____SSBInformationItem_iE_Extensions__item__id_tab
    ___SSBInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab = ____SSBInformationItem_iE_Extensions__item__criticality_tab
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab = ____SSBInformationItem_iE_Extensions__item__extensionValue_tab
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBInformationItem_iE_Extensions__item__id),
        (u'criticality', ___SSBInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBInformationItem_iE_Extensions__item__extensionValue),
        ])
    __SSBInformationItem_iE_Extensions__item_._ext = None
    _SSBInformationItem_iE_Extensions._cont = __SSBInformationItem_iE_Extensions__item_
    _SSBInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInformationItem._cont = ASN1Dict([
        (u'sSB-Configuration', _SSBInformationItem_sSB_Configuration),
        (u'pCI-NR', _SSBInformationItem_pCI_NR),
        (u'iE-Extensions', _SSBInformationItem_iE_Extensions),
        ])
    SSBInformationItem._ext = None
    
    #-----< SSBInformationItem-ExtIEs >-----#
    SSBInformationItem_ExtIEs = CLASS(name=u'SSBInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-PositionsInBurst >-----#
    SSB_PositionsInBurst = CHOICE(name=u'SSB-PositionsInBurst', mode=MODE_TYPE)
    _SSB_PositionsInBurst_shortBitmap = BIT_STR(name=u'shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_mediumBitmap = BIT_STR(name=u'mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_longBitmap = BIT_STR(name=u'longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SSB_PositionsInBurst_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SSB_PositionsInBurst_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_id._const_tab = ___SSB_PositionsInBurst_choice_extension_id_tab
    __SSB_PositionsInBurst_choice_extension_id._const_tab_at = None
    __SSB_PositionsInBurst_choice_extension_id._const_tab_id = u'id'
    __SSB_PositionsInBurst_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab = ___SSB_PositionsInBurst_choice_extension_criticality_tab
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_id = u'criticality'
    __SSB_PositionsInBurst_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SSB_PositionsInBurst_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_value._const_tab = ___SSB_PositionsInBurst_choice_extension_value_tab
    __SSB_PositionsInBurst_choice_extension_value._const_tab_at = ('..', u'id')
    __SSB_PositionsInBurst_choice_extension_value._const_tab_id = u'Value'
    _SSB_PositionsInBurst_choice_extension._cont = ASN1Dict([
        (u'id', __SSB_PositionsInBurst_choice_extension_id),
        (u'criticality', __SSB_PositionsInBurst_choice_extension_criticality),
        (u'value', __SSB_PositionsInBurst_choice_extension_value),
        ])
    _SSB_PositionsInBurst_choice_extension._ext = None
    SSB_PositionsInBurst._cont = ASN1Dict([
        (u'shortBitmap', _SSB_PositionsInBurst_shortBitmap),
        (u'mediumBitmap', _SSB_PositionsInBurst_mediumBitmap),
        (u'longBitmap', _SSB_PositionsInBurst_longBitmap),
        (u'choice-extension', _SSB_PositionsInBurst_choice_extension),
        ])
    SSB_PositionsInBurst._ext = None
    
    #-----< SSB-PositionsInBurst-ExtIEs >-----#
    SSB_PositionsInBurst_ExtIEs = CLASS(name=u'SSB-PositionsInBurst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SSB_PositionsInBurst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-TF-Configuration >-----#
    SSB_TF_Configuration = SEQ(name=u'SSB-TF-Configuration', mode=MODE_TYPE)
    _SSB_TF_Configuration_sSB_frequency = INT(name=u'sSB-frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_subcarrier_spacing = ENUM(name=u'sSB-subcarrier-spacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_subcarrier_spacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3), (u'kHz240', 4)])
    _SSB_TF_Configuration_sSB_subcarrier_spacing._ext = []
    _SSB_TF_Configuration_sSB_Transmit_power = INT(name=u'sSB-Transmit-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_Transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_periodicity = ENUM(name=u'sSB-periodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_periodicity._cont = ASN1Dict([(u'ms5', 0), (u'ms10', 1), (u'ms20', 2), (u'ms40', 3), (u'ms80', 4), (u'ms160', 5)])
    _SSB_TF_Configuration_sSB_periodicity._ext = []
    _SSB_TF_Configuration_sSB_half_frame_offset = INT(name=u'sSB-half-frame-offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_half_frame_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_SFN_offset = INT(name=u'sSB-SFN-offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_SFN_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_position_in_burst = CHOICE(name=u'sSB-position-in-burst', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')), opt=True)
    _SSB_TF_Configuration_sFNInitialisationTime = BIT_STR(name=u'sFNInitialisationTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')), opt=True)
    _SSB_TF_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_TF_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSB_TF_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSB_TF_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__id_tab
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSB_TF_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSB_TF_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSB_TF_Configuration_iE_Extensions__item__id),
        (u'criticality', ___SSB_TF_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSB_TF_Configuration_iE_Extensions__item__extensionValue),
        ])
    __SSB_TF_Configuration_iE_Extensions__item_._ext = None
    _SSB_TF_Configuration_iE_Extensions._cont = __SSB_TF_Configuration_iE_Extensions__item_
    _SSB_TF_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB_TF_Configuration._cont = ASN1Dict([
        (u'sSB-frequency', _SSB_TF_Configuration_sSB_frequency),
        (u'sSB-subcarrier-spacing', _SSB_TF_Configuration_sSB_subcarrier_spacing),
        (u'sSB-Transmit-power', _SSB_TF_Configuration_sSB_Transmit_power),
        (u'sSB-periodicity', _SSB_TF_Configuration_sSB_periodicity),
        (u'sSB-half-frame-offset', _SSB_TF_Configuration_sSB_half_frame_offset),
        (u'sSB-SFN-offset', _SSB_TF_Configuration_sSB_SFN_offset),
        (u'sSB-position-in-burst', _SSB_TF_Configuration_sSB_position_in_burst),
        (u'sFNInitialisationTime', _SSB_TF_Configuration_sFNInitialisationTime),
        (u'iE-Extensions', _SSB_TF_Configuration_iE_Extensions),
        ])
    SSB_TF_Configuration._ext = None
    
    #-----< SSB-TF-Configuration-ExtIEs >-----#
    SSB_TF_Configuration_ExtIEs = CLASS(name=u'SSB-TF-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSB_TF_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBToReportList >-----#
    SSBToReportList = SEQ_OF(name=u'SSBToReportList', mode=MODE_TYPE)
    _SSBToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBToReportItem')))
    SSBToReportList._cont = _SSBToReportList__item_
    SSBToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBToReportItem >-----#
    SSBToReportItem = SEQ(name=u'SSBToReportItem', mode=MODE_TYPE)
    _SSBToReportItem_sSBIndex = INT(name=u'sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBToReportItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBToReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBToReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__id._const_tab = ____SSBToReportItem_iE_Extensions__item__id_tab
    ___SSBToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBToReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBToReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab = ____SSBToReportItem_iE_Extensions__item__criticality_tab
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBToReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab = ____SSBToReportItem_iE_Extensions__item__extensionValue_tab
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBToReportItem_iE_Extensions__item__id),
        (u'criticality', ___SSBToReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBToReportItem_iE_Extensions__item__extensionValue),
        ])
    __SSBToReportItem_iE_Extensions__item_._ext = None
    _SSBToReportItem_iE_Extensions._cont = __SSBToReportItem_iE_Extensions__item_
    _SSBToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBToReportItem._cont = ASN1Dict([
        (u'sSBIndex', _SSBToReportItem_sSBIndex),
        (u'iE-Extensions', _SSBToReportItem_iE_Extensions),
        ])
    SSBToReportItem._ext = None
    
    #-----< SSBToReportItem-ExtIEs >-----#
    SSBToReportItem_ExtIEs = CLASS(name=u'SSBToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SUL-Information >-----#
    SUL_Information = SEQ(name=u'SUL-Information', mode=MODE_TYPE)
    _SUL_Information_sUL_NRARFCN = INT(name=u'sUL-NRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SUL_Information_sUL_NRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SUL_Information_sUL_transmission_Bandwidth = SEQ(name=u'sUL-transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _SUL_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SUL_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SUL_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SUL_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    ____SUL_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 356), (u'criticality', u'ignore'), (u'Extension', _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SUL_Information_iE_Extensions__item__id._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__id._const_tab_at = None
    ___SUL_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___SUL_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SUL_Information_iE_Extensions__item__criticality._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SUL_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SUL_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SUL_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SUL_Information_iE_Extensions__item__id),
        (u'criticality', ___SUL_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___SUL_Information_iE_Extensions__item__extensionValue),
        ])
    __SUL_Information_iE_Extensions__item_._ext = None
    _SUL_Information_iE_Extensions._cont = __SUL_Information_iE_Extensions__item_
    _SUL_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SUL_Information._cont = ASN1Dict([
        (u'sUL-NRARFCN', _SUL_Information_sUL_NRARFCN),
        (u'sUL-transmission-Bandwidth', _SUL_Information_sUL_transmission_Bandwidth),
        (u'iE-Extensions', _SUL_Information_iE_Extensions),
        ])
    SUL_Information._ext = []
    
    #-----< SUL-InformationExtIEs >-----#
    SUL_InformationExtIEs = CLASS(name=u'SUL-InformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SUL_InformationExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _SUL_InformationExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    SUL_InformationExtIEs._val = ASN1Set(rv=[dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _SUL_InformationExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 356), (u'criticality', u'ignore'), (u'Extension', _SUL_InformationExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SubcarrierSpacing >-----#
    SubcarrierSpacing = ENUM(name=u'SubcarrierSpacing', mode=MODE_TYPE)
    SubcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3), (u'kHz240', 4), (u'spare3', 5), (u'spare2', 6), (u'spare1', 7)])
    SubcarrierSpacing._ext = []
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name=u'SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< SULAccessIndication >-----#
    SULAccessIndication = ENUM(name=u'SULAccessIndication', mode=MODE_TYPE)
    SULAccessIndication._cont = ASN1Dict([(u'true', 0)])
    SULAccessIndication._ext = []
    
    #-----< SupportedSULFreqBandItem >-----#
    SupportedSULFreqBandItem = SEQ(name=u'SupportedSULFreqBandItem', mode=MODE_TYPE)
    _SupportedSULFreqBandItem_freqBandIndicatorNr = INT(name=u'freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedSULFreqBandItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _SupportedSULFreqBandItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedSULFreqBandItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SupportedSULFreqBandItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_at = None
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SupportedSULFreqBandItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SupportedSULFreqBandItem_iE_Extensions__item__id),
        (u'criticality', ___SupportedSULFreqBandItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue),
        ])
    __SupportedSULFreqBandItem_iE_Extensions__item_._ext = None
    _SupportedSULFreqBandItem_iE_Extensions._cont = __SupportedSULFreqBandItem_iE_Extensions__item_
    _SupportedSULFreqBandItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedSULFreqBandItem._cont = ASN1Dict([
        (u'freqBandIndicatorNr', _SupportedSULFreqBandItem_freqBandIndicatorNr),
        (u'iE-Extensions', _SupportedSULFreqBandItem_iE_Extensions),
        ])
    SupportedSULFreqBandItem._ext = []
    
    #-----< SupportedSULFreqBandItem-ExtIEs >-----#
    SupportedSULFreqBandItem_ExtIEs = CLASS(name=u'SupportedSULFreqBandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SupportedSULFreqBandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SymbolAllocInSlot >-----#
    SymbolAllocInSlot = CHOICE(name=u'SymbolAllocInSlot', mode=MODE_TYPE)
    _SymbolAllocInSlot_all_DL = NULL(name=u'all-DL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SymbolAllocInSlot_all_UL = NULL(name=u'all-UL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SymbolAllocInSlot_both_DL_and_UL = SEQ(name=u'both-DL-and-UL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumDLULSymbols')))
    _SymbolAllocInSlot_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SymbolAllocInSlot_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SymbolAllocInSlot_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_id._const_tab = ___SymbolAllocInSlot_choice_extension_id_tab
    __SymbolAllocInSlot_choice_extension_id._const_tab_at = None
    __SymbolAllocInSlot_choice_extension_id._const_tab_id = u'id'
    __SymbolAllocInSlot_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SymbolAllocInSlot_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_criticality._const_tab = ___SymbolAllocInSlot_choice_extension_criticality_tab
    __SymbolAllocInSlot_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SymbolAllocInSlot_choice_extension_criticality._const_tab_id = u'criticality'
    __SymbolAllocInSlot_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SymbolAllocInSlot_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_value._const_tab = ___SymbolAllocInSlot_choice_extension_value_tab
    __SymbolAllocInSlot_choice_extension_value._const_tab_at = ('..', u'id')
    __SymbolAllocInSlot_choice_extension_value._const_tab_id = u'Value'
    _SymbolAllocInSlot_choice_extension._cont = ASN1Dict([
        (u'id', __SymbolAllocInSlot_choice_extension_id),
        (u'criticality', __SymbolAllocInSlot_choice_extension_criticality),
        (u'value', __SymbolAllocInSlot_choice_extension_value),
        ])
    _SymbolAllocInSlot_choice_extension._ext = None
    SymbolAllocInSlot._cont = ASN1Dict([
        (u'all-DL', _SymbolAllocInSlot_all_DL),
        (u'all-UL', _SymbolAllocInSlot_all_UL),
        (u'both-DL-and-UL', _SymbolAllocInSlot_both_DL_and_UL),
        (u'choice-extension', _SymbolAllocInSlot_choice_extension),
        ])
    SymbolAllocInSlot._ext = None
    
    #-----< SymbolAllocInSlot-ExtIEs >-----#
    SymbolAllocInSlot_ExtIEs = CLASS(name=u'SymbolAllocInSlot-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SymbolAllocInSlot_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemFrameNumber >-----#
    SystemFrameNumber = INT(name=u'SystemFrameNumber', mode=MODE_TYPE)
    SystemFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< SystemInformationAreaID >-----#
    SystemInformationAreaID = BIT_STR(name=u'SystemInformationAreaID', mode=MODE_TYPE)
    SystemInformationAreaID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< FiveGS-TAC >-----#
    FiveGS_TAC = OCT_STR(name=u'FiveGS-TAC', mode=MODE_TYPE)
    FiveGS_TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Configured-EPS-TAC >-----#
    Configured_EPS_TAC = OCT_STR(name=u'Configured-EPS-TAC', mode=MODE_TYPE)
    Configured_EPS_TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TargetCellList >-----#
    TargetCellList = SEQ_OF(name=u'TargetCellList', mode=MODE_TYPE)
    _TargetCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList-Item')))
    TargetCellList._cont = _TargetCellList__item_
    TargetCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TargetCellList-Item >-----#
    TargetCellList_Item = SEQ(name=u'TargetCellList-Item', mode=MODE_TYPE)
    _TargetCellList_Item_target_cell = SEQ(name=u'target-cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _TargetCellList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TargetCellList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab = ____TargetCellList_Item_iE_Extensions__item__id_tab
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetCellList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab = ____TargetCellList_Item_iE_Extensions__item__criticality_tab
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetCellList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetCellList_Item_iE_Extensions__item__id),
        (u'criticality', ___TargetCellList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __TargetCellList_Item_iE_Extensions__item_._ext = None
    _TargetCellList_Item_iE_Extensions._cont = __TargetCellList_Item_iE_Extensions__item_
    _TargetCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetCellList_Item._cont = ASN1Dict([
        (u'target-cell', _TargetCellList_Item_target_cell),
        (u'iE-Extensions', _TargetCellList_Item_iE_Extensions),
        ])
    TargetCellList_Item._ext = None
    
    #-----< TargetCellList-Item-ExtIEs >-----#
    TargetCellList_Item_ExtIEs = CLASS(name=u'TargetCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TargetCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-Info >-----#
    TDD_Info = SEQ(name=u'TDD-Info', mode=MODE_TYPE)
    _TDD_Info_nRFreqInfo = SEQ(name=u'nRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _TDD_Info_transmission_Bandwidth = SEQ(name=u'transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _TDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TDD-UL-DLConfigCommonNR')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 361), (u'criticality', u'ignore'), (u'Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_Info_iE_Extensions__item__id._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_Info_iE_Extensions__item__criticality._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_Info_iE_Extensions__item__id),
        (u'criticality', ___TDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __TDD_Info_iE_Extensions__item_._ext = None
    _TDD_Info_iE_Extensions._cont = __TDD_Info_iE_Extensions__item_
    _TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Info._cont = ASN1Dict([
        (u'nRFreqInfo', _TDD_Info_nRFreqInfo),
        (u'transmission-Bandwidth', _TDD_Info_transmission_Bandwidth),
        (u'iE-Extensions', _TDD_Info_iE_Extensions),
        ])
    TDD_Info._ext = []
    
    #-----< TDD-Info-ExtIEs >-----#
    TDD_Info_ExtIEs = CLASS(name=u'TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TDD_Info_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')))
    _TDD_Info_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TDD-UL-DLConfigCommonNR')))
    _TDD_Info_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    TDD_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _TDD_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 361), (u'criticality', u'ignore'), (u'Extension', _TDD_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _TDD_Info_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-DLConfigCommonNR >-----#
    TDD_UL_DLConfigCommonNR = OCT_STR(name=u'TDD-UL-DLConfigCommonNR', mode=MODE_TYPE)
    
    #-----< TimeReferenceInformation >-----#
    TimeReferenceInformation = SEQ(name=u'TimeReferenceInformation', mode=MODE_TYPE)
    _TimeReferenceInformation_referenceTime = OCT_STR(name=u'referenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceTime')))
    _TimeReferenceInformation_referenceSFN = INT(name=u'referenceSFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSFN')))
    _TimeReferenceInformation_uncertainty = INT(name=u'uncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Uncertainty')))
    _TimeReferenceInformation_timeInformationType = ENUM(name=u'timeInformationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeInformationType')))
    _TimeReferenceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeReferenceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimeReferenceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TimeReferenceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab = ____TimeReferenceInformation_iE_Extensions__item__id_tab
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TimeReferenceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TimeReferenceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab = ____TimeReferenceInformation_iE_Extensions__item__criticality_tab
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab = ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TimeReferenceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TimeReferenceInformation_iE_Extensions__item__id),
        (u'criticality', ___TimeReferenceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TimeReferenceInformation_iE_Extensions__item__extensionValue),
        ])
    __TimeReferenceInformation_iE_Extensions__item_._ext = None
    _TimeReferenceInformation_iE_Extensions._cont = __TimeReferenceInformation_iE_Extensions__item_
    _TimeReferenceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeReferenceInformation._cont = ASN1Dict([
        (u'referenceTime', _TimeReferenceInformation_referenceTime),
        (u'referenceSFN', _TimeReferenceInformation_referenceSFN),
        (u'uncertainty', _TimeReferenceInformation_uncertainty),
        (u'timeInformationType', _TimeReferenceInformation_timeInformationType),
        (u'iE-Extensions', _TimeReferenceInformation_iE_Extensions),
        ])
    TimeReferenceInformation._ext = None
    
    #-----< TimeReferenceInformation-ExtIEs >-----#
    TimeReferenceInformation_ExtIEs = CLASS(name=u'TimeReferenceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimeReferenceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeInformationType >-----#
    TimeInformationType = ENUM(name=u'TimeInformationType', mode=MODE_TYPE)
    TimeInformationType._cont = ASN1Dict([(u'localClock', 0)])
    TimeInformationType._ext = None
    
    #-----< TimeStamp >-----#
    TimeStamp = SEQ(name=u'TimeStamp', mode=MODE_TYPE)
    _TimeStamp_systemFrameNumber = INT(name=u'systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _TimeStamp_slotIndex = CHOICE(name=u'slotIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeStampSlotIndex')))
    _TimeStamp_measurementTime = BIT_STR(name=u'measurementTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')), opt=True)
    _TimeStamp_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeStamp_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimeStamp_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TimeStamp_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__id._const_tab = ____TimeStamp_iE_Extension__item__id_tab
    ___TimeStamp_iE_Extension__item__id._const_tab_at = None
    ___TimeStamp_iE_Extension__item__id._const_tab_id = u'id'
    ___TimeStamp_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TimeStamp_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__criticality._const_tab = ____TimeStamp_iE_Extension__item__criticality_tab
    ___TimeStamp_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___TimeStamp_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___TimeStamp_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TimeStamp_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab = ____TimeStamp_iE_Extension__item__extensionValue_tab
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __TimeStamp_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___TimeStamp_iE_Extension__item__id),
        (u'criticality', ___TimeStamp_iE_Extension__item__criticality),
        (u'extensionValue', ___TimeStamp_iE_Extension__item__extensionValue),
        ])
    __TimeStamp_iE_Extension__item_._ext = None
    _TimeStamp_iE_Extension._cont = __TimeStamp_iE_Extension__item_
    _TimeStamp_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeStamp._cont = ASN1Dict([
        (u'systemFrameNumber', _TimeStamp_systemFrameNumber),
        (u'slotIndex', _TimeStamp_slotIndex),
        (u'measurementTime', _TimeStamp_measurementTime),
        (u'iE-Extension', _TimeStamp_iE_Extension),
        ])
    TimeStamp._ext = None
    
    #-----< TimeStamp-ExtIEs >-----#
    TimeStamp_ExtIEs = CLASS(name=u'TimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStampSlotIndex >-----#
    TimeStampSlotIndex = CHOICE(name=u'TimeStampSlotIndex', mode=MODE_TYPE)
    _TimeStampSlotIndex_sCS_15 = INT(name=u'sCS-15', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_15._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_30 = INT(name=u'sCS-30', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_30._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_60 = INT(name=u'sCS-60', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_60._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_120 = INT(name=u'sCS-120', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_120._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    _TimeStampSlotIndex_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TimeStampSlotIndex_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TimeStampSlotIndex_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_id._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_id._const_tab_at = None
    __TimeStampSlotIndex_choice_extension_id._const_tab_id = u'id'
    __TimeStampSlotIndex_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TimeStampSlotIndex_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_criticality._const_tab = ___TimeStampSlotIndex_choice_extension_criticality_tab
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_id = u'criticality'
    __TimeStampSlotIndex_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TimeStampSlotIndex_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_value._const_tab = ___TimeStampSlotIndex_choice_extension_value_tab
    __TimeStampSlotIndex_choice_extension_value._const_tab_at = ('..', u'id')
    __TimeStampSlotIndex_choice_extension_value._const_tab_id = u'Value'
    _TimeStampSlotIndex_choice_extension._cont = ASN1Dict([
        (u'id', __TimeStampSlotIndex_choice_extension_id),
        (u'criticality', __TimeStampSlotIndex_choice_extension_criticality),
        (u'value', __TimeStampSlotIndex_choice_extension_value),
        ])
    _TimeStampSlotIndex_choice_extension._ext = None
    TimeStampSlotIndex._cont = ASN1Dict([
        (u'sCS-15', _TimeStampSlotIndex_sCS_15),
        (u'sCS-30', _TimeStampSlotIndex_sCS_30),
        (u'sCS-60', _TimeStampSlotIndex_sCS_60),
        (u'sCS-120', _TimeStampSlotIndex_sCS_120),
        (u'choice-extension', _TimeStampSlotIndex_choice_extension),
        ])
    TimeStampSlotIndex._ext = None
    
    #-----< TimeStampSlotIndex-ExtIEs >-----#
    TimeStampSlotIndex_ExtIEs = CLASS(name=u'TimeStampSlotIndex-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TimeStampSlotIndex_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name=u'TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([(u'v1s', 0), (u'v2s', 1), (u'v5s', 2), (u'v10s', 3), (u'v20s', 4), (u'v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TimingMeasurementQuality >-----#
    TimingMeasurementQuality = SEQ(name=u'TimingMeasurementQuality', mode=MODE_TYPE)
    _TimingMeasurementQuality_measurementQuality = INT(name=u'measurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingMeasurementQuality_measurementQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TimingMeasurementQuality_resolution = ENUM(name=u'resolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingMeasurementQuality_resolution._cont = ASN1Dict([(u'm0dot1', 0), (u'm1', 1), (u'm10', 2), (u'm30', 3)])
    _TimingMeasurementQuality_resolution._ext = []
    _TimingMeasurementQuality_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimingMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimingMeasurementQuality_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TimingMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__id_tab
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab_id = u'id'
    ___TimingMeasurementQuality_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TimingMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TimingMeasurementQuality_iE_Extensions__item__id),
        (u'criticality', ___TimingMeasurementQuality_iE_Extensions__item__criticality),
        (u'extensionValue', ___TimingMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __TimingMeasurementQuality_iE_Extensions__item_._ext = None
    _TimingMeasurementQuality_iE_Extensions._cont = __TimingMeasurementQuality_iE_Extensions__item_
    _TimingMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimingMeasurementQuality._cont = ASN1Dict([
        (u'measurementQuality', _TimingMeasurementQuality_measurementQuality),
        (u'resolution', _TimingMeasurementQuality_resolution),
        (u'iE-Extensions', _TimingMeasurementQuality_iE_Extensions),
        ])
    TimingMeasurementQuality._ext = None
    
    #-----< TimingMeasurementQuality-ExtIEs >-----#
    TimingMeasurementQuality_ExtIEs = CLASS(name=u'TimingMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimingMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name=u'TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([(u'ue', 0), (u'non-ue', 1), (u'both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TNLCapacityIndicator >-----#
    TNLCapacityIndicator = SEQ(name=u'TNLCapacityIndicator', mode=MODE_TYPE)
    _TNLCapacityIndicator_dLTNLOfferedCapacity = INT(name=u'dLTNLOfferedCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dLTNLOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_dLTNLAvailableCapacity = INT(name=u'dLTNLAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dLTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_uLTNLOfferedCapacity = INT(name=u'uLTNLOfferedCapacity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_uLTNLOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_uLTNLAvailableCapacity = INT(name=u'uLTNLAvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_uLTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLCapacityIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TNLCapacityIndicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__id_tab
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_at = None
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___TNLCapacityIndicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TNLCapacityIndicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TNLCapacityIndicator_iE_Extensions__item__id),
        (u'criticality', ___TNLCapacityIndicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___TNLCapacityIndicator_iE_Extensions__item__extensionValue),
        ])
    __TNLCapacityIndicator_iE_Extensions__item_._ext = None
    _TNLCapacityIndicator_iE_Extensions._cont = __TNLCapacityIndicator_iE_Extensions__item_
    _TNLCapacityIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLCapacityIndicator._cont = ASN1Dict([
        (u'dLTNLOfferedCapacity', _TNLCapacityIndicator_dLTNLOfferedCapacity),
        (u'dLTNLAvailableCapacity', _TNLCapacityIndicator_dLTNLAvailableCapacity),
        (u'uLTNLOfferedCapacity', _TNLCapacityIndicator_uLTNLOfferedCapacity),
        (u'uLTNLAvailableCapacity', _TNLCapacityIndicator_uLTNLAvailableCapacity),
        (u'iE-Extensions', _TNLCapacityIndicator_iE_Extensions),
        ])
    TNLCapacityIndicator._ext = None
    
    #-----< TNLCapacityIndicator-ExtIEs >-----#
    TNLCapacityIndicator_ExtIEs = CLASS(name=u'TNLCapacityIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TNLCapacityIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name=u'TraceActivation', mode=MODE_TYPE)
    _TraceActivation_traceID = OCT_STR(name=u'traceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name=u'interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name=u'traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name=u'traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTConfiguration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 381), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 380), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceActivation_iE_Extensions__item__id),
        (u'criticality', ___TraceActivation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        (u'traceID', _TraceActivation_traceID),
        (u'interfacesToTrace', _TraceActivation_interfacesToTrace),
        (u'traceDepth', _TraceActivation_traceDepth),
        (u'traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        (u'iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = None
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name=u'TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTConfiguration')))
    _TraceActivation_ExtIEs_val_Extension_1 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 381), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 380), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2), (u'minimumWithoutVendorSpecificExtension', 3), (u'mediumWithoutVendorSpecificExtension', 4), (u'maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< TraceID >-----#
    TraceID = OCT_STR(name=u'TraceID', mode=MODE_TYPE)
    TraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TrafficMappingInfo >-----#
    TrafficMappingInfo = CHOICE(name=u'TrafficMappingInfo', mode=MODE_TYPE)
    _TrafficMappingInfo_iPtolayer2TrafficMappingInfo = SEQ(name=u'iPtolayer2TrafficMappingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfo')))
    _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo = SEQ(name=u'bAPlayerBHRLCchannelMappingInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfo')))
    _TrafficMappingInfo_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TrafficMappingInfo_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TrafficMappingInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_id._const_tab = ___TrafficMappingInfo_choice_extension_id_tab
    __TrafficMappingInfo_choice_extension_id._const_tab_at = None
    __TrafficMappingInfo_choice_extension_id._const_tab_id = u'id'
    __TrafficMappingInfo_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TrafficMappingInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_criticality._const_tab = ___TrafficMappingInfo_choice_extension_criticality_tab
    __TrafficMappingInfo_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TrafficMappingInfo_choice_extension_criticality._const_tab_id = u'criticality'
    __TrafficMappingInfo_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TrafficMappingInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_value._const_tab = ___TrafficMappingInfo_choice_extension_value_tab
    __TrafficMappingInfo_choice_extension_value._const_tab_at = ('..', u'id')
    __TrafficMappingInfo_choice_extension_value._const_tab_id = u'Value'
    _TrafficMappingInfo_choice_extension._cont = ASN1Dict([
        (u'id', __TrafficMappingInfo_choice_extension_id),
        (u'criticality', __TrafficMappingInfo_choice_extension_criticality),
        (u'value', __TrafficMappingInfo_choice_extension_value),
        ])
    _TrafficMappingInfo_choice_extension._ext = None
    TrafficMappingInfo._cont = ASN1Dict([
        (u'iPtolayer2TrafficMappingInfo', _TrafficMappingInfo_iPtolayer2TrafficMappingInfo),
        (u'bAPlayerBHRLCchannelMappingInfo', _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo),
        (u'choice-extension', _TrafficMappingInfo_choice_extension),
        ])
    TrafficMappingInfo._ext = None
    
    #-----< TrafficMappingInfo-ExtIEs >-----#
    TrafficMappingInfo_ExtIEs = CLASS(name=u'TrafficMappingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TrafficMappingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TransactionID >-----#
    TransactionID = INT(name=u'TransactionID', mode=MODE_TYPE)
    TransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< Transmission-Bandwidth >-----#
    Transmission_Bandwidth = SEQ(name=u'Transmission-Bandwidth', mode=MODE_TYPE)
    _Transmission_Bandwidth_nRSCS = ENUM(name=u'nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _Transmission_Bandwidth_nRNRB = ENUM(name=u'nRNRB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRNRB')))
    _Transmission_Bandwidth_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transmission_Bandwidth_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transmission_Bandwidth_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transmission_Bandwidth_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__id_tab
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab_at = None
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transmission_Bandwidth_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transmission_Bandwidth_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transmission_Bandwidth_iE_Extensions__item__id),
        (u'criticality', ___Transmission_Bandwidth_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transmission_Bandwidth_iE_Extensions__item__extensionValue),
        ])
    __Transmission_Bandwidth_iE_Extensions__item_._ext = None
    _Transmission_Bandwidth_iE_Extensions._cont = __Transmission_Bandwidth_iE_Extensions__item_
    _Transmission_Bandwidth_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transmission_Bandwidth._cont = ASN1Dict([
        (u'nRSCS', _Transmission_Bandwidth_nRSCS),
        (u'nRNRB', _Transmission_Bandwidth_nRNRB),
        (u'iE-Extensions', _Transmission_Bandwidth_iE_Extensions),
        ])
    Transmission_Bandwidth._ext = []
    
    #-----< Transmission-Bandwidth-ExtIEs >-----#
    Transmission_Bandwidth_ExtIEs = CLASS(name=u'Transmission-Bandwidth-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transmission_Bandwidth_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionComb >-----#
    TransmissionComb = CHOICE(name=u'TransmissionComb', mode=MODE_TYPE)
    _TransmissionComb_n2 = SEQ(name=u'n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2 = INT(name=u'combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionComb_n2_cyclicShift_n2 = INT(name=u'cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionComb_n2._cont = ASN1Dict([
        (u'combOffset-n2', __TransmissionComb_n2_combOffset_n2),
        (u'cyclicShift-n2', __TransmissionComb_n2_cyclicShift_n2),
        ])
    _TransmissionComb_n2._ext = None
    _TransmissionComb_n4 = SEQ(name=u'n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4 = INT(name=u'combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionComb_n4_cyclicShift_n4 = INT(name=u'cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionComb_n4._cont = ASN1Dict([
        (u'combOffset-n4', __TransmissionComb_n4_combOffset_n4),
        (u'cyclicShift-n4', __TransmissionComb_n4_cyclicShift_n4),
        ])
    _TransmissionComb_n4._ext = None
    _TransmissionComb_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TransmissionComb_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TransmissionComb_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_id._const_tab = ___TransmissionComb_choice_extension_id_tab
    __TransmissionComb_choice_extension_id._const_tab_at = None
    __TransmissionComb_choice_extension_id._const_tab_id = u'id'
    __TransmissionComb_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TransmissionComb_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_criticality._const_tab = ___TransmissionComb_choice_extension_criticality_tab
    __TransmissionComb_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TransmissionComb_choice_extension_criticality._const_tab_id = u'criticality'
    __TransmissionComb_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TransmissionComb_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_value._const_tab = ___TransmissionComb_choice_extension_value_tab
    __TransmissionComb_choice_extension_value._const_tab_at = ('..', u'id')
    __TransmissionComb_choice_extension_value._const_tab_id = u'Value'
    _TransmissionComb_choice_extension._cont = ASN1Dict([
        (u'id', __TransmissionComb_choice_extension_id),
        (u'criticality', __TransmissionComb_choice_extension_criticality),
        (u'value', __TransmissionComb_choice_extension_value),
        ])
    _TransmissionComb_choice_extension._ext = None
    TransmissionComb._cont = ASN1Dict([
        (u'n2', _TransmissionComb_n2),
        (u'n4', _TransmissionComb_n4),
        (u'choice-extension', _TransmissionComb_choice_extension),
        ])
    TransmissionComb._ext = None
    
    #-----< TransmissionComb-ExtIEs >-----#
    TransmissionComb_ExtIEs = CLASS(name=u'TransmissionComb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TransmissionComb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionCombPos >-----#
    TransmissionCombPos = CHOICE(name=u'TransmissionCombPos', mode=MODE_TYPE)
    _TransmissionCombPos_n2 = SEQ(name=u'n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2 = INT(name=u'combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionCombPos_n2_cyclicShift_n2 = INT(name=u'cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionCombPos_n2._cont = ASN1Dict([
        (u'combOffset-n2', __TransmissionCombPos_n2_combOffset_n2),
        (u'cyclicShift-n2', __TransmissionCombPos_n2_cyclicShift_n2),
        ])
    _TransmissionCombPos_n2._ext = None
    _TransmissionCombPos_n4 = SEQ(name=u'n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4 = INT(name=u'combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionCombPos_n4_cyclicShift_n4 = INT(name=u'cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionCombPos_n4._cont = ASN1Dict([
        (u'combOffset-n4', __TransmissionCombPos_n4_combOffset_n4),
        (u'cyclicShift-n4', __TransmissionCombPos_n4_cyclicShift_n4),
        ])
    _TransmissionCombPos_n4._ext = None
    _TransmissionCombPos_n8 = SEQ(name=u'n8', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8 = INT(name=u'combOffset-n8', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    __TransmissionCombPos_n8_cyclicShift_n8 = INT(name=u'cyclicShift-n8', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_cyclicShift_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TransmissionCombPos_n8._cont = ASN1Dict([
        (u'combOffset-n8', __TransmissionCombPos_n8_combOffset_n8),
        (u'cyclicShift-n8', __TransmissionCombPos_n8_cyclicShift_n8),
        ])
    _TransmissionCombPos_n8._ext = None
    _TransmissionCombPos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TransmissionCombPos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TransmissionCombPos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_id._const_tab = ___TransmissionCombPos_choice_extension_id_tab
    __TransmissionCombPos_choice_extension_id._const_tab_at = None
    __TransmissionCombPos_choice_extension_id._const_tab_id = u'id'
    __TransmissionCombPos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TransmissionCombPos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_criticality._const_tab = ___TransmissionCombPos_choice_extension_criticality_tab
    __TransmissionCombPos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TransmissionCombPos_choice_extension_criticality._const_tab_id = u'criticality'
    __TransmissionCombPos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TransmissionCombPos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_value._const_tab = ___TransmissionCombPos_choice_extension_value_tab
    __TransmissionCombPos_choice_extension_value._const_tab_at = ('..', u'id')
    __TransmissionCombPos_choice_extension_value._const_tab_id = u'Value'
    _TransmissionCombPos_choice_extension._cont = ASN1Dict([
        (u'id', __TransmissionCombPos_choice_extension_id),
        (u'criticality', __TransmissionCombPos_choice_extension_criticality),
        (u'value', __TransmissionCombPos_choice_extension_value),
        ])
    _TransmissionCombPos_choice_extension._ext = None
    TransmissionCombPos._cont = ASN1Dict([
        (u'n2', _TransmissionCombPos_n2),
        (u'n4', _TransmissionCombPos_n4),
        (u'n8', _TransmissionCombPos_n8),
        (u'choice-extension', _TransmissionCombPos_choice_extension),
        ])
    TransmissionCombPos._ext = None
    
    #-----< TransmissionCombPos-ExtIEs >-----#
    TransmissionCombPos_ExtIEs = CLASS(name=u'TransmissionCombPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TransmissionCombPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionStopIndicator >-----#
    TransmissionStopIndicator = ENUM(name=u'TransmissionStopIndicator', mode=MODE_TYPE)
    TransmissionStopIndicator._cont = ASN1Dict([(u'true', 0)])
    TransmissionStopIndicator._ext = []
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-List >-----#
    Transport_UP_Layer_Address_Info_To_Add_List = SEQ_OF(name=u'Transport-UP-Layer-Address-Info-To-Add-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Add-Item')))
    Transport_UP_Layer_Address_Info_To_Add_List._cont = _Transport_UP_Layer_Address_Info_To_Add_List__item_
    Transport_UP_Layer_Address_Info_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-Item >-----#
    Transport_UP_Layer_Address_Info_To_Add_Item = SEQ(name=u'Transport-UP-Layer-Address-Info-To-Add-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress = BIT_STR(name=u'iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd = SEQ_OF(name=u'gTPTransportLayerAddressToAdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id),
        (u'criticality', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions._cont = __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Address_Info_To_Add_Item._cont = ASN1Dict([
        (u'iP-SecTransportLayerAddress', _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress),
        (u'gTPTransportLayerAddressToAdd', _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd),
        (u'iE-Extensions', _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Address_Info_To_Add_Item._ext = None
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs >-----#
    Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs = CLASS(name=u'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-List >-----#
    Transport_UP_Layer_Address_Info_To_Remove_List = SEQ_OF(name=u'Transport-UP-Layer-Address-Info-To-Remove-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Remove-Item')))
    Transport_UP_Layer_Address_Info_To_Remove_List._cont = _Transport_UP_Layer_Address_Info_To_Remove_List__item_
    Transport_UP_Layer_Address_Info_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-Item >-----#
    Transport_UP_Layer_Address_Info_To_Remove_Item = SEQ(name=u'Transport-UP-Layer-Address-Info-To-Remove-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress = BIT_STR(name=u'iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove = SEQ_OF(name=u'gTPTransportLayerAddressToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id),
        (u'criticality', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions._cont = __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Address_Info_To_Remove_Item._cont = ASN1Dict([
        (u'iP-SecTransportLayerAddress', _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress),
        (u'gTPTransportLayerAddressToRemove', _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove),
        (u'iE-Extensions', _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Address_Info_To_Remove_Item._ext = None
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs >-----#
    Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs = CLASS(name=u'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionActionIndicator >-----#
    TransmissionActionIndicator = ENUM(name=u'TransmissionActionIndicator', mode=MODE_TYPE)
    TransmissionActionIndicator._cont = ASN1Dict([(u'stop', 0), (u'restart', 1)])
    TransmissionActionIndicator._ext = [u'restart']
    
    #-----< TRPID >-----#
    TRPID = INT(name=u'TRPID', mode=MODE_TYPE)
    TRPID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< TRPInformation >-----#
    TRPInformation = SEQ(name=u'TRPInformation', mode=MODE_TYPE)
    _TRPInformation_tRPID = INT(name=u'tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRPInformation_tRPInformationTypeResponseList = SEQ_OF(name=u'tRPInformationTypeResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeResponseList')))
    _TRPInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__id._const_tab = ____TRPInformation_iE_Extensions__item__id_tab
    ___TRPInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__criticality._const_tab = ____TRPInformation_iE_Extensions__item__criticality_tab
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPInformation_iE_Extensions__item__extensionValue_tab
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPInformation_iE_Extensions__item__id),
        (u'criticality', ___TRPInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPInformation_iE_Extensions__item_._ext = None
    _TRPInformation_iE_Extensions._cont = __TRPInformation_iE_Extensions__item_
    _TRPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformation._cont = ASN1Dict([
        (u'tRPID', _TRPInformation_tRPID),
        (u'tRPInformationTypeResponseList', _TRPInformation_tRPInformationTypeResponseList),
        (u'iE-Extensions', _TRPInformation_iE_Extensions),
        ])
    TRPInformation._ext = None
    
    #-----< TRPInformation-ExtIEs >-----#
    TRPInformation_ExtIEs = CLASS(name=u'TRPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationItem >-----#
    TRPInformationItem = SEQ(name=u'TRPInformationItem', mode=MODE_TYPE)
    _TRPInformationItem_tRPInformation = SEQ(name=u'tRPInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPInformation')))
    _TRPInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__id._const_tab = ____TRPInformationItem_iE_Extensions__item__id_tab
    ___TRPInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab = ____TRPInformationItem_iE_Extensions__item__criticality_tab
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab = ____TRPInformationItem_iE_Extensions__item__extensionValue_tab
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationItem_iE_Extensions__item__id),
        (u'criticality', ___TRPInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPInformationItem_iE_Extensions__item__extensionValue),
        ])
    __TRPInformationItem_iE_Extensions__item_._ext = None
    _TRPInformationItem_iE_Extensions._cont = __TRPInformationItem_iE_Extensions__item_
    _TRPInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformationItem._cont = ASN1Dict([
        (u'tRPInformation', _TRPInformationItem_tRPInformation),
        (u'iE-Extensions', _TRPInformationItem_iE_Extensions),
        ])
    TRPInformationItem._ext = None
    
    #-----< TRPInformationItem-ExtIEs >-----#
    TRPInformationItem_ExtIEs = CLASS(name=u'TRPInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeItem >-----#
    TRPInformationTypeItem = ENUM(name=u'TRPInformationTypeItem', mode=MODE_TYPE)
    TRPInformationTypeItem._cont = ASN1Dict([(u'nrPCI', 0), (u'nG-RAN-CGI', 1), (u'arfcn', 2), (u'pRSConfig', 3), (u'sSBConfig', 4), (u'sFNInitTime', 5), (u'spatialDirectInfo', 6), (u'geoCoord', 7), (u'trp-type', 8)])
    TRPInformationTypeItem._ext = [u'trp-type']
    
    #-----< TRPInformationTypeResponseList >-----#
    TRPInformationTypeResponseList = SEQ_OF(name=u'TRPInformationTypeResponseList', mode=MODE_TYPE)
    _TRPInformationTypeResponseList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeResponseItem')))
    TRPInformationTypeResponseList._cont = _TRPInformationTypeResponseList__item_
    TRPInformationTypeResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeResponseItem >-----#
    TRPInformationTypeResponseItem = CHOICE(name=u'TRPInformationTypeResponseItem', mode=MODE_TYPE)
    _TRPInformationTypeResponseItem_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _TRPInformationTypeResponseItem_nG_RAN_CGI = SEQ(name=u'nG-RAN-CGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _TRPInformationTypeResponseItem_nRARFCN = INT(name=u'nRARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TRPInformationTypeResponseItem_pRSConfiguration = SEQ(name=u'pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSConfiguration')))
    _TRPInformationTypeResponseItem_sSBinformation = SEQ(name=u'sSBinformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformation')))
    _TRPInformationTypeResponseItem_sFNInitialisationTime = BIT_STR(name=u'sFNInitialisationTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _TRPInformationTypeResponseItem_spatialDirectionInformation = SEQ(name=u'spatialDirectionInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialDirectionInformation')))
    _TRPInformationTypeResponseItem_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GeographicalCoordinates')))
    _TRPInformationTypeResponseItem_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationTypeResponseItem_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPType')))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 434), (u'criticality', u'reject'), (u'Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_at = None
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_id = u'id'
    __TRPInformationTypeResponseItem_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPInformationTypeResponseItem_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_id = u'Value'
    _TRPInformationTypeResponseItem_choice_extension._cont = ASN1Dict([
        (u'id', __TRPInformationTypeResponseItem_choice_extension_id),
        (u'criticality', __TRPInformationTypeResponseItem_choice_extension_criticality),
        (u'value', __TRPInformationTypeResponseItem_choice_extension_value),
        ])
    _TRPInformationTypeResponseItem_choice_extension._ext = None
    TRPInformationTypeResponseItem._cont = ASN1Dict([
        (u'pCI-NR', _TRPInformationTypeResponseItem_pCI_NR),
        (u'nG-RAN-CGI', _TRPInformationTypeResponseItem_nG_RAN_CGI),
        (u'nRARFCN', _TRPInformationTypeResponseItem_nRARFCN),
        (u'pRSConfiguration', _TRPInformationTypeResponseItem_pRSConfiguration),
        (u'sSBinformation', _TRPInformationTypeResponseItem_sSBinformation),
        (u'sFNInitialisationTime', _TRPInformationTypeResponseItem_sFNInitialisationTime),
        (u'spatialDirectionInformation', _TRPInformationTypeResponseItem_spatialDirectionInformation),
        (u'geographicalCoordinates', _TRPInformationTypeResponseItem_geographicalCoordinates),
        (u'choice-extension', _TRPInformationTypeResponseItem_choice_extension),
        ])
    TRPInformationTypeResponseItem._ext = None
    
    #-----< TRPInformationTypeResponseItem-ExtIEs >-----#
    TRPInformationTypeResponseItem_ExtIEs = CLASS(name=u'TRPInformationTypeResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPType')))
    TRPInformationTypeResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 434), (u'criticality', u'reject'), (u'Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPList >-----#
    TRPList = SEQ_OF(name=u'TRPList', mode=MODE_TYPE)
    _TRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPListItem')))
    TRPList._cont = _TRPList__item_
    TRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPListItem >-----#
    TRPListItem = SEQ(name=u'TRPListItem', mode=MODE_TYPE)
    _TRPListItem_tRPID = INT(name=u'tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRPListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__id._const_tab = ____TRPListItem_iE_Extensions__item__id_tab
    ___TRPListItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__criticality._const_tab = ____TRPListItem_iE_Extensions__item__criticality_tab
    ___TRPListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab = ____TRPListItem_iE_Extensions__item__extensionValue_tab
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPListItem_iE_Extensions__item__id),
        (u'criticality', ___TRPListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPListItem_iE_Extensions__item__extensionValue),
        ])
    __TRPListItem_iE_Extensions__item_._ext = None
    _TRPListItem_iE_Extensions._cont = __TRPListItem_iE_Extensions__item_
    _TRPListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPListItem._cont = ASN1Dict([
        (u'tRPID', _TRPListItem_tRPID),
        (u'iE-Extensions', _TRPListItem_iE_Extensions),
        ])
    TRPListItem._ext = None
    
    #-----< TRPListItem-ExtIEs >-----#
    TRPListItem_ExtIEs = CLASS(name=u'TRPListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuality >-----#
    TRPMeasurementQuality = SEQ(name=u'TRPMeasurementQuality', mode=MODE_TYPE)
    _TRPMeasurementQuality_tRPmeasurementQuality_Item = CHOICE(name=u'tRPmeasurementQuality-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality-Item')))
    _TRPMeasurementQuality_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPMeasurementQuality_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__id_tab
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPMeasurementQuality_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPMeasurementQuality_iE_Extensions__item__id),
        (u'criticality', ___TRPMeasurementQuality_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __TRPMeasurementQuality_iE_Extensions__item_._ext = None
    _TRPMeasurementQuality_iE_Extensions._cont = __TRPMeasurementQuality_iE_Extensions__item_
    _TRPMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPMeasurementQuality._cont = ASN1Dict([
        (u'tRPmeasurementQuality-Item', _TRPMeasurementQuality_tRPmeasurementQuality_Item),
        (u'iE-Extensions', _TRPMeasurementQuality_iE_Extensions),
        ])
    TRPMeasurementQuality._ext = None
    
    #-----< TRPMeasurementQuality-ExtIEs >-----#
    TRPMeasurementQuality_ExtIEs = CLASS(name=u'TRPMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuality-Item >-----#
    TRPMeasurementQuality_Item = CHOICE(name=u'TRPMeasurementQuality-Item', mode=MODE_TYPE)
    _TRPMeasurementQuality_Item_timingMeasurementQuality = SEQ(name=u'timingMeasurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimingMeasurementQuality')))
    _TRPMeasurementQuality_Item_angleMeasurementQuality = SEQ(name=u'angleMeasurementQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AngleMeasurementQuality')))
    _TRPMeasurementQuality_Item_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPMeasurementQuality_Item_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPMeasurementQuality_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab = ___TRPMeasurementQuality_Item_choice_extension_id_tab
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab_at = None
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab_id = u'id'
    __TRPMeasurementQuality_Item_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPMeasurementQuality_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab = ___TRPMeasurementQuality_Item_choice_extension_criticality_tab
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPMeasurementQuality_Item_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPMeasurementQuality_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab = ___TRPMeasurementQuality_Item_choice_extension_value_tab
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab_id = u'Value'
    _TRPMeasurementQuality_Item_choice_extension._cont = ASN1Dict([
        (u'id', __TRPMeasurementQuality_Item_choice_extension_id),
        (u'criticality', __TRPMeasurementQuality_Item_choice_extension_criticality),
        (u'value', __TRPMeasurementQuality_Item_choice_extension_value),
        ])
    _TRPMeasurementQuality_Item_choice_extension._ext = None
    TRPMeasurementQuality_Item._cont = ASN1Dict([
        (u'timingMeasurementQuality', _TRPMeasurementQuality_Item_timingMeasurementQuality),
        (u'angleMeasurementQuality', _TRPMeasurementQuality_Item_angleMeasurementQuality),
        (u'choice-extension', _TRPMeasurementQuality_Item_choice_extension),
        ])
    TRPMeasurementQuality_Item._ext = None
    
    #-----< TRPMeasurementQuality-Item-ExtIEs >-----#
    TRPMeasurementQuality_Item_ExtIEs = CLASS(name=u'TRPMeasurementQuality-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPMeasurementQuality_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementRequestList >-----#
    TRP_MeasurementRequestList = SEQ_OF(name=u'TRP-MeasurementRequestList', mode=MODE_TYPE)
    _TRP_MeasurementRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestItem')))
    TRP_MeasurementRequestList._cont = _TRP_MeasurementRequestList__item_
    TRP_MeasurementRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementRequestItem >-----#
    TRP_MeasurementRequestItem = SEQ(name=u'TRP-MeasurementRequestItem', mode=MODE_TYPE)
    _TRP_MeasurementRequestItem_tRPID = INT(name=u'tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRP_MeasurementRequestItem_search_window_information = SEQ(name=u'search-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Search-window-information')), opt=True)
    _TRP_MeasurementRequestItem_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementRequestItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementRequestItem_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_id = u'id'
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRP_MeasurementRequestItem_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRP_MeasurementRequestItem_iE_extensions__item__id),
        (u'criticality', ___TRP_MeasurementRequestItem_iE_extensions__item__criticality),
        (u'extensionValue', ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementRequestItem_iE_extensions__item_._ext = None
    _TRP_MeasurementRequestItem_iE_extensions._cont = __TRP_MeasurementRequestItem_iE_extensions__item_
    _TRP_MeasurementRequestItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementRequestItem._cont = ASN1Dict([
        (u'tRPID', _TRP_MeasurementRequestItem_tRPID),
        (u'search-window-information', _TRP_MeasurementRequestItem_search_window_information),
        (u'iE-extensions', _TRP_MeasurementRequestItem_iE_extensions),
        ])
    TRP_MeasurementRequestItem._ext = None
    
    #-----< TRP-MeasurementRequestItem-ExtIEs >-----#
    TRP_MeasurementRequestItem_ExtIEs = CLASS(name=u'TRP-MeasurementRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    TRP_MeasurementRequestItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDefinitionType >-----#
    TRPPositionDefinitionType = CHOICE(name=u'TRPPositionDefinitionType', mode=MODE_TYPE)
    _TRPPositionDefinitionType_direct = SEQ(name=u'direct', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDirect')))
    _TRPPositionDefinitionType_referenced = SEQ(name=u'referenced', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionReferenced')))
    _TRPPositionDefinitionType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPPositionDefinitionType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPPositionDefinitionType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_id._const_tab = ___TRPPositionDefinitionType_choice_extension_id_tab
    __TRPPositionDefinitionType_choice_extension_id._const_tab_at = None
    __TRPPositionDefinitionType_choice_extension_id._const_tab_id = u'id'
    __TRPPositionDefinitionType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab = ___TRPPositionDefinitionType_choice_extension_criticality_tab
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPPositionDefinitionType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPPositionDefinitionType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_value._const_tab = ___TRPPositionDefinitionType_choice_extension_value_tab
    __TRPPositionDefinitionType_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPPositionDefinitionType_choice_extension_value._const_tab_id = u'Value'
    _TRPPositionDefinitionType_choice_extension._cont = ASN1Dict([
        (u'id', __TRPPositionDefinitionType_choice_extension_id),
        (u'criticality', __TRPPositionDefinitionType_choice_extension_criticality),
        (u'value', __TRPPositionDefinitionType_choice_extension_value),
        ])
    _TRPPositionDefinitionType_choice_extension._ext = None
    TRPPositionDefinitionType._cont = ASN1Dict([
        (u'direct', _TRPPositionDefinitionType_direct),
        (u'referenced', _TRPPositionDefinitionType_referenced),
        (u'choice-extension', _TRPPositionDefinitionType_choice_extension),
        ])
    TRPPositionDefinitionType._ext = None
    
    #-----< TRPPositionDefinitionType-ExtIEs >-----#
    TRPPositionDefinitionType_ExtIEs = CLASS(name=u'TRPPositionDefinitionType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPPositionDefinitionType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirect >-----#
    TRPPositionDirect = SEQ(name=u'TRPPositionDirect', mode=MODE_TYPE)
    _TRPPositionDirect_accuracy = CHOICE(name=u'accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDirectAccuracy')))
    _TRPPositionDirect_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionDirect_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPPositionDirect_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPPositionDirect_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__id._const_tab = ____TRPPositionDirect_iE_extensions__item__id_tab
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_id = u'id'
    ___TRPPositionDirect_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab = ____TRPPositionDirect_iE_extensions__item__criticality_tab
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPPositionDirect_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab = ____TRPPositionDirect_iE_extensions__item__extensionValue_tab
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPPositionDirect_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPPositionDirect_iE_extensions__item__id),
        (u'criticality', ___TRPPositionDirect_iE_extensions__item__criticality),
        (u'extensionValue', ___TRPPositionDirect_iE_extensions__item__extensionValue),
        ])
    __TRPPositionDirect_iE_extensions__item_._ext = None
    _TRPPositionDirect_iE_extensions._cont = __TRPPositionDirect_iE_extensions__item_
    _TRPPositionDirect_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionDirect._cont = ASN1Dict([
        (u'accuracy', _TRPPositionDirect_accuracy),
        (u'iE-extensions', _TRPPositionDirect_iE_extensions),
        ])
    TRPPositionDirect._ext = None
    
    #-----< TRPPositionDirect-ExtIEs >-----#
    TRPPositionDirect_ExtIEs = CLASS(name=u'TRPPositionDirect-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPPositionDirect_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirectAccuracy >-----#
    TRPPositionDirectAccuracy = CHOICE(name=u'TRPPositionDirectAccuracy', mode=MODE_TYPE)
    _TRPPositionDirectAccuracy_tRPPosition = SEQ(name=u'tRPPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AccessPointPosition')))
    _TRPPositionDirectAccuracy_tRPHAposition = SEQ(name=u'tRPHAposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _TRPPositionDirectAccuracy_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPPositionDirectAccuracy_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab = ___TRPPositionDirectAccuracy_choice_extension_id_tab
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_at = None
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_id = u'id'
    __TRPPositionDirectAccuracy_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab = ___TRPPositionDirectAccuracy_choice_extension_criticality_tab
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPPositionDirectAccuracy_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab = ___TRPPositionDirectAccuracy_choice_extension_value_tab
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_id = u'Value'
    _TRPPositionDirectAccuracy_choice_extension._cont = ASN1Dict([
        (u'id', __TRPPositionDirectAccuracy_choice_extension_id),
        (u'criticality', __TRPPositionDirectAccuracy_choice_extension_criticality),
        (u'value', __TRPPositionDirectAccuracy_choice_extension_value),
        ])
    _TRPPositionDirectAccuracy_choice_extension._ext = None
    TRPPositionDirectAccuracy._cont = ASN1Dict([
        (u'tRPPosition', _TRPPositionDirectAccuracy_tRPPosition),
        (u'tRPHAposition', _TRPPositionDirectAccuracy_tRPHAposition),
        (u'choice-extension', _TRPPositionDirectAccuracy_choice_extension),
        ])
    TRPPositionDirectAccuracy._ext = None
    
    #-----< TRPPositionDirectAccuracy-ExtIEs >-----#
    TRPPositionDirectAccuracy_ExtIEs = CLASS(name=u'TRPPositionDirectAccuracy-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPPositionDirectAccuracy_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionReferenced >-----#
    TRPPositionReferenced = SEQ(name=u'TRPPositionReferenced', mode=MODE_TYPE)
    _TRPPositionReferenced_referencePoint = CHOICE(name=u'referencePoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferencePoint')))
    _TRPPositionReferenced_referencePointType = CHOICE(name=u'referencePointType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPReferencePointType')))
    _TRPPositionReferenced_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionReferenced_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPPositionReferenced_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPPositionReferenced_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab = ____TRPPositionReferenced_iE_extensions__item__id_tab
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_id = u'id'
    ___TRPPositionReferenced_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab = ____TRPPositionReferenced_iE_extensions__item__criticality_tab
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPPositionReferenced_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab = ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPPositionReferenced_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPPositionReferenced_iE_extensions__item__id),
        (u'criticality', ___TRPPositionReferenced_iE_extensions__item__criticality),
        (u'extensionValue', ___TRPPositionReferenced_iE_extensions__item__extensionValue),
        ])
    __TRPPositionReferenced_iE_extensions__item_._ext = None
    _TRPPositionReferenced_iE_extensions._cont = __TRPPositionReferenced_iE_extensions__item_
    _TRPPositionReferenced_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionReferenced._cont = ASN1Dict([
        (u'referencePoint', _TRPPositionReferenced_referencePoint),
        (u'referencePointType', _TRPPositionReferenced_referencePointType),
        (u'iE-extensions', _TRPPositionReferenced_iE_extensions),
        ])
    TRPPositionReferenced._ext = None
    
    #-----< TRPPositionReferenced-ExtIEs >-----#
    TRPPositionReferenced_ExtIEs = CLASS(name=u'TRPPositionReferenced-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPPositionReferenced_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPReferencePointType >-----#
    TRPReferencePointType = CHOICE(name=u'TRPReferencePointType', mode=MODE_TYPE)
    _TRPReferencePointType_tRPPositionRelativeGeodetic = SEQ(name=u'tRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _TRPReferencePointType_tRPPositionRelativeCartesian = SEQ(name=u'tRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _TRPReferencePointType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPReferencePointType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPReferencePointType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_id._const_tab = ___TRPReferencePointType_choice_extension_id_tab
    __TRPReferencePointType_choice_extension_id._const_tab_at = None
    __TRPReferencePointType_choice_extension_id._const_tab_id = u'id'
    __TRPReferencePointType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPReferencePointType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_criticality._const_tab = ___TRPReferencePointType_choice_extension_criticality_tab
    __TRPReferencePointType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPReferencePointType_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPReferencePointType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPReferencePointType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_value._const_tab = ___TRPReferencePointType_choice_extension_value_tab
    __TRPReferencePointType_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPReferencePointType_choice_extension_value._const_tab_id = u'Value'
    _TRPReferencePointType_choice_extension._cont = ASN1Dict([
        (u'id', __TRPReferencePointType_choice_extension_id),
        (u'criticality', __TRPReferencePointType_choice_extension_criticality),
        (u'value', __TRPReferencePointType_choice_extension_value),
        ])
    _TRPReferencePointType_choice_extension._ext = None
    TRPReferencePointType._cont = ASN1Dict([
        (u'tRPPositionRelativeGeodetic', _TRPReferencePointType_tRPPositionRelativeGeodetic),
        (u'tRPPositionRelativeCartesian', _TRPReferencePointType_tRPPositionRelativeCartesian),
        (u'choice-extension', _TRPReferencePointType_choice_extension),
        ])
    TRPReferencePointType._ext = None
    
    #-----< TRPReferencePointType-ExtIEs >-----#
    TRPReferencePointType_ExtIEs = CLASS(name=u'TRPReferencePointType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPReferencePointType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< Transport-Layer-Address-Info >-----#
    Transport_Layer_Address_Info = SEQ(name=u'Transport-Layer-Address-Info', mode=MODE_TYPE)
    _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List = SEQ_OF(name=u'transport-UP-Layer-Address-Info-To-Add-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Add-List')), opt=True)
    _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List = SEQ_OF(name=u'transport-UP-Layer-Address-Info-To-Remove-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Remove-List')), opt=True)
    _Transport_Layer_Address_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_Layer_Address_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_Layer_Address_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_at = None
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transport_Layer_Address_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transport_Layer_Address_Info_iE_Extensions__item__id),
        (u'criticality', ___Transport_Layer_Address_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue),
        ])
    __Transport_Layer_Address_Info_iE_Extensions__item_._ext = None
    _Transport_Layer_Address_Info_iE_Extensions._cont = __Transport_Layer_Address_Info_iE_Extensions__item_
    _Transport_Layer_Address_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_Layer_Address_Info._cont = ASN1Dict([
        (u'transport-UP-Layer-Address-Info-To-Add-List', _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List),
        (u'transport-UP-Layer-Address-Info-To-Remove-List', _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List),
        (u'iE-Extensions', _Transport_Layer_Address_Info_iE_Extensions),
        ])
    Transport_Layer_Address_Info._ext = None
    
    #-----< Transport-Layer-Address-Info-ExtIEs >-----#
    Transport_Layer_Address_Info_ExtIEs = CLASS(name=u'Transport-Layer-Address-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_Layer_Address_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPType >-----#
    TRPType = ENUM(name=u'TRPType', mode=MODE_TYPE)
    TRPType._cont = ASN1Dict([(u'prsOnlyTP', 0), (u'srsOnlyRP', 1), (u'tp', 2), (u'rp', 3), (u'trp', 4)])
    TRPType._ext = []
    
    #-----< TSCAssistanceInformation >-----#
    TSCAssistanceInformation = SEQ(name=u'TSCAssistanceInformation', mode=MODE_TYPE)
    _TSCAssistanceInformation_periodicity = INT(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Periodicity')))
    _TSCAssistanceInformation_burstArrivalTime = OCT_STR(name=u'burstArrivalTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BurstArrivalTime')), opt=True)
    _TSCAssistanceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCAssistanceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TSCAssistanceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TSCAssistanceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TSCAssistanceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TSCAssistanceInformation_iE_Extensions__item__id),
        (u'criticality', ___TSCAssistanceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TSCAssistanceInformation_iE_Extensions__item__extensionValue),
        ])
    __TSCAssistanceInformation_iE_Extensions__item_._ext = None
    _TSCAssistanceInformation_iE_Extensions._cont = __TSCAssistanceInformation_iE_Extensions__item_
    _TSCAssistanceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCAssistanceInformation._cont = ASN1Dict([
        (u'periodicity', _TSCAssistanceInformation_periodicity),
        (u'burstArrivalTime', _TSCAssistanceInformation_burstArrivalTime),
        (u'iE-Extensions', _TSCAssistanceInformation_iE_Extensions),
        ])
    TSCAssistanceInformation._ext = []
    
    #-----< TSCAssistanceInformation-ExtIEs >-----#
    TSCAssistanceInformation_ExtIEs = CLASS(name=u'TSCAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TSCAssistanceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficCharacteristics >-----#
    TSCTrafficCharacteristics = SEQ(name=u'TSCTrafficCharacteristics', mode=MODE_TYPE)
    _TSCTrafficCharacteristics_tSCAssistanceInformationDL = SEQ(name=u'tSCAssistanceInformationDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_tSCAssistanceInformationUL = SEQ(name=u'tSCAssistanceInformationUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficCharacteristics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_id = u'id'
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TSCTrafficCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TSCTrafficCharacteristics_iE_Extensions__item__id),
        (u'criticality', ___TSCTrafficCharacteristics_iE_Extensions__item__criticality),
        (u'extensionValue', ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficCharacteristics_iE_Extensions__item_._ext = None
    _TSCTrafficCharacteristics_iE_Extensions._cont = __TSCTrafficCharacteristics_iE_Extensions__item_
    _TSCTrafficCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficCharacteristics._cont = ASN1Dict([
        (u'tSCAssistanceInformationDL', _TSCTrafficCharacteristics_tSCAssistanceInformationDL),
        (u'tSCAssistanceInformationUL', _TSCTrafficCharacteristics_tSCAssistanceInformationUL),
        (u'iE-Extensions', _TSCTrafficCharacteristics_iE_Extensions),
        ])
    TSCTrafficCharacteristics._ext = []
    
    #-----< TSCTrafficCharacteristics-ExtIEs >-----#
    TSCTrafficCharacteristics_ExtIEs = CLASS(name=u'TSCTrafficCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TSCTrafficCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UAC-Assistance-Info >-----#
    UAC_Assistance_Info = SEQ(name=u'UAC-Assistance-Info', mode=MODE_TYPE)
    _UAC_Assistance_Info_uACPLMN_List = SEQ_OF(name=u'uACPLMN-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACPLMN-List')))
    _UAC_Assistance_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UAC_Assistance_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UAC_Assistance_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UAC_Assistance_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__id_tab
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab_at = None
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___UAC_Assistance_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UAC_Assistance_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UAC_Assistance_Info_iE_Extensions__item__id),
        (u'criticality', ___UAC_Assistance_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___UAC_Assistance_Info_iE_Extensions__item__extensionValue),
        ])
    __UAC_Assistance_Info_iE_Extensions__item_._ext = None
    _UAC_Assistance_Info_iE_Extensions._cont = __UAC_Assistance_Info_iE_Extensions__item_
    _UAC_Assistance_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UAC_Assistance_Info._cont = ASN1Dict([
        (u'uACPLMN-List', _UAC_Assistance_Info_uACPLMN_List),
        (u'iE-Extensions', _UAC_Assistance_Info_iE_Extensions),
        ])
    UAC_Assistance_Info._ext = None
    
    #-----< UAC-Assistance-InfoExtIEs >-----#
    UAC_Assistance_InfoExtIEs = CLASS(name=u'UAC-Assistance-InfoExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UAC_Assistance_InfoExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACPLMN-List >-----#
    UACPLMN_List = SEQ_OF(name=u'UACPLMN-List', mode=MODE_TYPE)
    _UACPLMN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UACPLMN-Item')))
    UACPLMN_List._cont = _UACPLMN_List__item_
    UACPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< UACPLMN-Item >-----#
    UACPLMN_Item = SEQ(name=u'UACPLMN-Item', mode=MODE_TYPE)
    _UACPLMN_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _UACPLMN_Item_uACType_List = SEQ_OF(name=u'uACType-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACType-List')))
    _UACPLMN_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACPLMN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACPLMN_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UACPLMN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    ____UACPLMN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 385), (u'criticality', u'ignore'), (u'Extension', _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab_at = None
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UACPLMN_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UACPLMN_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UACPLMN_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UACPLMN_Item_iE_Extensions__item__id),
        (u'criticality', ___UACPLMN_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UACPLMN_Item_iE_Extensions__item__extensionValue),
        ])
    __UACPLMN_Item_iE_Extensions__item_._ext = None
    _UACPLMN_Item_iE_Extensions._cont = __UACPLMN_Item_iE_Extensions__item_
    _UACPLMN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACPLMN_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _UACPLMN_Item_pLMNIdentity),
        (u'uACType-List', _UACPLMN_Item_uACType_List),
        (u'iE-Extensions', _UACPLMN_Item_iE_Extensions),
        ])
    UACPLMN_Item._ext = None
    
    #-----< UACPLMN-Item-ExtIEs >-----#
    UACPLMN_Item_ExtIEs = CLASS(name=u'UACPLMN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UACPLMN_Item_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    UACPLMN_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 385), (u'criticality', u'ignore'), (u'Extension', _UACPLMN_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UACType-List >-----#
    UACType_List = SEQ_OF(name=u'UACType-List', mode=MODE_TYPE)
    _UACType_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UACType-Item')))
    UACType_List._cont = _UACType_List__item_
    UACType_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UACType-Item >-----#
    UACType_Item = SEQ(name=u'UACType-Item', mode=MODE_TYPE)
    _UACType_Item_uACReductionIndication = INT(name=u'uACReductionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACReductionIndication')))
    _UACType_Item_uACCategoryType = CHOICE(name=u'uACCategoryType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACCategoryType')))
    _UACType_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACType_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACType_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UACType_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__id._const_tab = ____UACType_Item_iE_Extensions__item__id_tab
    ___UACType_Item_iE_Extensions__item__id._const_tab_at = None
    ___UACType_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UACType_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UACType_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__criticality._const_tab = ____UACType_Item_iE_Extensions__item__criticality_tab
    ___UACType_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UACType_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UACType_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UACType_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab = ____UACType_Item_iE_Extensions__item__extensionValue_tab
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UACType_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UACType_Item_iE_Extensions__item__id),
        (u'criticality', ___UACType_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UACType_Item_iE_Extensions__item__extensionValue),
        ])
    __UACType_Item_iE_Extensions__item_._ext = None
    _UACType_Item_iE_Extensions._cont = __UACType_Item_iE_Extensions__item_
    _UACType_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACType_Item._cont = ASN1Dict([
        (u'uACReductionIndication', _UACType_Item_uACReductionIndication),
        (u'uACCategoryType', _UACType_Item_uACCategoryType),
        (u'iE-Extensions', _UACType_Item_iE_Extensions),
        ])
    UACType_Item._ext = None
    
    #-----< UACType-Item-ExtIEs >-----#
    UACType_Item_ExtIEs = CLASS(name=u'UACType-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UACType_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACCategoryType >-----#
    UACCategoryType = CHOICE(name=u'UACCategoryType', mode=MODE_TYPE)
    _UACCategoryType_uACstandardized = ENUM(name=u'uACstandardized', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACAction')))
    _UACCategoryType_uACOperatorDefined = SEQ(name=u'uACOperatorDefined', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACOperatorDefined')))
    _UACCategoryType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UACCategoryType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UACCategoryType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_id._const_tab = ___UACCategoryType_choice_extension_id_tab
    __UACCategoryType_choice_extension_id._const_tab_at = None
    __UACCategoryType_choice_extension_id._const_tab_id = u'id'
    __UACCategoryType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UACCategoryType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_criticality._const_tab = ___UACCategoryType_choice_extension_criticality_tab
    __UACCategoryType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __UACCategoryType_choice_extension_criticality._const_tab_id = u'criticality'
    __UACCategoryType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UACCategoryType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_value._const_tab = ___UACCategoryType_choice_extension_value_tab
    __UACCategoryType_choice_extension_value._const_tab_at = ('..', u'id')
    __UACCategoryType_choice_extension_value._const_tab_id = u'Value'
    _UACCategoryType_choice_extension._cont = ASN1Dict([
        (u'id', __UACCategoryType_choice_extension_id),
        (u'criticality', __UACCategoryType_choice_extension_criticality),
        (u'value', __UACCategoryType_choice_extension_value),
        ])
    _UACCategoryType_choice_extension._ext = None
    UACCategoryType._cont = ASN1Dict([
        (u'uACstandardized', _UACCategoryType_uACstandardized),
        (u'uACOperatorDefined', _UACCategoryType_uACOperatorDefined),
        (u'choice-extension', _UACCategoryType_choice_extension),
        ])
    UACCategoryType._ext = None
    
    #-----< UACCategoryType-ExtIEs >-----#
    UACCategoryType_ExtIEs = CLASS(name=u'UACCategoryType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UACCategoryType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACOperatorDefined >-----#
    UACOperatorDefined = SEQ(name=u'UACOperatorDefined', mode=MODE_TYPE)
    _UACOperatorDefined_accessCategory = INT(name=u'accessCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UACOperatorDefined_accessCategory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=63)], ev=[], er=[])
    _UACOperatorDefined_accessIdentity = BIT_STR(name=u'accessIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UACOperatorDefined_accessIdentity._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _UACOperatorDefined_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACOperatorDefined_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACOperatorDefined_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UACOperatorDefined_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab = ____UACOperatorDefined_iE_Extensions__item__id_tab
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab_at = None
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab_id = u'id'
    ___UACOperatorDefined_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UACOperatorDefined_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab = ____UACOperatorDefined_iE_Extensions__item__criticality_tab
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UACOperatorDefined_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab = ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UACOperatorDefined_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UACOperatorDefined_iE_Extensions__item__id),
        (u'criticality', ___UACOperatorDefined_iE_Extensions__item__criticality),
        (u'extensionValue', ___UACOperatorDefined_iE_Extensions__item__extensionValue),
        ])
    __UACOperatorDefined_iE_Extensions__item_._ext = None
    _UACOperatorDefined_iE_Extensions._cont = __UACOperatorDefined_iE_Extensions__item_
    _UACOperatorDefined_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACOperatorDefined._cont = ASN1Dict([
        (u'accessCategory', _UACOperatorDefined_accessCategory),
        (u'accessIdentity', _UACOperatorDefined_accessIdentity),
        (u'iE-Extensions', _UACOperatorDefined_iE_Extensions),
        ])
    UACOperatorDefined._ext = None
    
    #-----< UACOperatorDefined-ExtIEs >-----#
    UACOperatorDefined_ExtIEs = CLASS(name=u'UACOperatorDefined-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UACOperatorDefined_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACAction >-----#
    UACAction = ENUM(name=u'UACAction', mode=MODE_TYPE)
    UACAction._cont = ASN1Dict([(u'reject-non-emergency-mo-dt', 0), (u'reject-rrc-cr-signalling', 1), (u'permit-emergency-sessions-and-mobile-terminated-services-only', 2), (u'permit-high-priority-sessions-and-mobile-terminated-services-only', 3)])
    UACAction._ext = []
    
    #-----< UACReductionIndication >-----#
    UACReductionIndication = INT(name=u'UACReductionIndication', mode=MODE_TYPE)
    UACReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItem >-----#
    UE_associatedLogicalF1_ConnectionItem = SEQ(name=u'UE-associatedLogicalF1-ConnectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID = INT(name=u'gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')), opt=True)
    _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID = INT(name=u'gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id),
        (u'criticality', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions._cont = __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalF1_ConnectionItem._cont = ASN1Dict([
        (u'gNB-CU-UE-F1AP-ID', _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID),
        (u'gNB-DU-UE-F1AP-ID', _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID),
        (u'iE-Extensions', _UE_associatedLogicalF1_ConnectionItem_iE_Extensions),
        ])
    UE_associatedLogicalF1_ConnectionItem._ext = []
    
    #-----< UEAssistanceInformation >-----#
    UEAssistanceInformation = OCT_STR(name=u'UEAssistanceInformation', mode=MODE_TYPE)
    
    #-----< UEAssistanceInformationEUTRA >-----#
    UEAssistanceInformationEUTRA = OCT_STR(name=u'UEAssistanceInformationEUTRA', mode=MODE_TYPE)
    
    #-----< UE-associatedLogicalF1-ConnectionItemExtIEs >-----#
    UE_associatedLogicalF1_ConnectionItemExtIEs = CLASS(name=u'UE-associatedLogicalF1-ConnectionItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalF1_ConnectionItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-CapabilityRAT-ContainerList >-----#
    UE_CapabilityRAT_ContainerList = OCT_STR(name=u'UE-CapabilityRAT-ContainerList', mode=MODE_TYPE)
    
    #-----< UEContextNotRetrievable >-----#
    UEContextNotRetrievable = ENUM(name=u'UEContextNotRetrievable', mode=MODE_TYPE)
    UEContextNotRetrievable._cont = ASN1Dict([(u'true', 0)])
    UEContextNotRetrievable._ext = []
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = CHOICE(name=u'UEIdentityIndexValue', mode=MODE_TYPE)
    _UEIdentityIndexValue_indexLength10 = BIT_STR(name=u'indexLength10', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEIdentityIndexValue_indexLength10._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _UEIdentityIndexValue_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UEIdentityIndexValue_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UEIdentityIndexValue_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_id._const_tab = ___UEIdentityIndexValue_choice_extension_id_tab
    __UEIdentityIndexValue_choice_extension_id._const_tab_at = None
    __UEIdentityIndexValue_choice_extension_id._const_tab_id = u'id'
    __UEIdentityIndexValue_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEIdentityIndexValue_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_criticality._const_tab = ___UEIdentityIndexValue_choice_extension_criticality_tab
    __UEIdentityIndexValue_choice_extension_criticality._const_tab_at = ('..', u'id')
    __UEIdentityIndexValue_choice_extension_criticality._const_tab_id = u'criticality'
    __UEIdentityIndexValue_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEIdentityIndexValue_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_value._const_tab = ___UEIdentityIndexValue_choice_extension_value_tab
    __UEIdentityIndexValue_choice_extension_value._const_tab_at = ('..', u'id')
    __UEIdentityIndexValue_choice_extension_value._const_tab_id = u'Value'
    _UEIdentityIndexValue_choice_extension._cont = ASN1Dict([
        (u'id', __UEIdentityIndexValue_choice_extension_id),
        (u'criticality', __UEIdentityIndexValue_choice_extension_criticality),
        (u'value', __UEIdentityIndexValue_choice_extension_value),
        ])
    _UEIdentityIndexValue_choice_extension._ext = None
    UEIdentityIndexValue._cont = ASN1Dict([
        (u'indexLength10', _UEIdentityIndexValue_indexLength10),
        (u'choice-extension', _UEIdentityIndexValue_choice_extension),
        ])
    UEIdentityIndexValue._ext = None
    
    #-----< UEIdentityIndexValueChoice-ExtIEs >-----#
    UEIdentityIndexValueChoice_ExtIEs = CLASS(name=u'UEIdentityIndexValueChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UEIdentityIndexValueChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-AoA >-----#
    UL_AoA = SEQ(name=u'UL-AoA', mode=MODE_TYPE)
    _UL_AoA_azimuthAoA = INT(name=u'azimuthAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_AoA_azimuthAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _UL_AoA_zenithAoA = INT(name=u'zenithAoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_AoA_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _UL_AoA_lCS_to_GCS_TranslationAoA = SEQ(name=u'lCS-to-GCS-TranslationAoA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCS-to-GCS-TranslationAoA')), opt=True)
    _UL_AoA_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_AoA_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__id._const_tab = ____UL_AoA_iE_extensions__item__id_tab
    ___UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___UL_AoA_iE_extensions__item__id._const_tab_id = u'id'
    ___UL_AoA_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__criticality._const_tab = ____UL_AoA_iE_extensions__item__criticality_tab
    ___UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_AoA_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_AoA_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab = ____UL_AoA_iE_extensions__item__extensionValue_tab
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_AoA_iE_extensions__item__id),
        (u'criticality', ___UL_AoA_iE_extensions__item__criticality),
        (u'extensionValue', ___UL_AoA_iE_extensions__item__extensionValue),
        ])
    __UL_AoA_iE_extensions__item_._ext = None
    _UL_AoA_iE_extensions._cont = __UL_AoA_iE_extensions__item_
    _UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_AoA._cont = ASN1Dict([
        (u'azimuthAoA', _UL_AoA_azimuthAoA),
        (u'zenithAoA', _UL_AoA_zenithAoA),
        (u'lCS-to-GCS-TranslationAoA', _UL_AoA_lCS_to_GCS_TranslationAoA),
        (u'iE-extensions', _UL_AoA_iE_extensions),
        ])
    UL_AoA._ext = []
    
    #-----< UL-AoA-ExtIEs >-----#
    UL_AoA_ExtIEs = CLASS(name=u'UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping >-----#
    UL_BH_Non_UP_Traffic_Mapping = SEQ(name=u'UL-BH-Non-UP-Traffic-Mapping', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List = SEQ_OF(name=u'uL-BH-Non-UP-Traffic-Mapping-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping-List')))
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab_at = None
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id),
        (u'criticality', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue),
        ])
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_._ext = None
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions._cont = __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_BH_Non_UP_Traffic_Mapping._cont = ASN1Dict([
        (u'uL-BH-Non-UP-Traffic-Mapping-List', _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List),
        (u'iE-Extensions', _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions),
        ])
    UL_BH_Non_UP_Traffic_Mapping._ext = None
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-ExtIEs >-----#
    UL_BH_Non_UP_Traffic_Mapping_ExtIEs = CLASS(name=u'UL-BH-Non-UP-Traffic-Mapping-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_BH_Non_UP_Traffic_Mapping_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-List >-----#
    UL_BH_Non_UP_Traffic_Mapping_List = SEQ_OF(name=u'UL-BH-Non-UP-Traffic-Mapping-List', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping-Item')))
    UL_BH_Non_UP_Traffic_Mapping_List._cont = _UL_BH_Non_UP_Traffic_Mapping_List__item_
    UL_BH_Non_UP_Traffic_Mapping_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-Item >-----#
    UL_BH_Non_UP_Traffic_Mapping_Item = SEQ(name=u'UL-BH-Non-UP-Traffic-Mapping-Item', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType = ENUM(name=u'nonUPTrafficType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonUPTrafficType')))
    _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo = SEQ(name=u'bHInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id),
        (u'criticality', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_._ext = None
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions._cont = __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_BH_Non_UP_Traffic_Mapping_Item._cont = ASN1Dict([
        (u'nonUPTrafficType', _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType),
        (u'bHInfo', _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo),
        (u'iE-Extensions', _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions),
        ])
    UL_BH_Non_UP_Traffic_Mapping_Item._ext = None
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs >-----#
    UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs = CLASS(name=u'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULConfiguration >-----#
    ULConfiguration = SEQ(name=u'ULConfiguration', mode=MODE_TYPE)
    _ULConfiguration_uLUEConfiguration = ENUM(name=u'uLUEConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUEConfiguration')))
    _ULConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ULConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ULConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__id._const_tab = ____ULConfiguration_iE_Extensions__item__id_tab
    ___ULConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___ULConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___ULConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ULConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab = ____ULConfiguration_iE_Extensions__item__criticality_tab
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ULConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab = ____ULConfiguration_iE_Extensions__item__extensionValue_tab
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ULConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ULConfiguration_iE_Extensions__item__id),
        (u'criticality', ___ULConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___ULConfiguration_iE_Extensions__item__extensionValue),
        ])
    __ULConfiguration_iE_Extensions__item_._ext = None
    _ULConfiguration_iE_Extensions._cont = __ULConfiguration_iE_Extensions__item_
    _ULConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULConfiguration._cont = ASN1Dict([
        (u'uLUEConfiguration', _ULConfiguration_uLUEConfiguration),
        (u'iE-Extensions', _ULConfiguration_iE_Extensions),
        ])
    ULConfiguration._ext = []
    
    #-----< ULConfigurationExtIEs >-----#
    ULConfigurationExtIEs = CLASS(name=u'ULConfigurationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ULConfigurationExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-RTOA-Measurement >-----#
    UL_RTOA_Measurement = SEQ(name=u'UL-RTOA-Measurement', mode=MODE_TYPE)
    _UL_RTOA_Measurement_uL_RTOA_MeasurementItem = CHOICE(name=u'uL-RTOA-MeasurementItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-RTOA-MeasurementItem')))
    _UL_RTOA_Measurement_additionalPath_List = SEQ_OF(name=u'additionalPath-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-List')), opt=True)
    _UL_RTOA_Measurement_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_RTOA_Measurement_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_RTOA_Measurement_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_RTOA_Measurement_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_RTOA_Measurement_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__id_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab_at = None
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_RTOA_Measurement_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_RTOA_Measurement_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__criticality_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_RTOA_Measurement_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_RTOA_Measurement_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__extensionValue_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_RTOA_Measurement_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_RTOA_Measurement_iE_Extensions__item__id),
        (u'criticality', ___UL_RTOA_Measurement_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue),
        ])
    __UL_RTOA_Measurement_iE_Extensions__item_._ext = None
    _UL_RTOA_Measurement_iE_Extensions._cont = __UL_RTOA_Measurement_iE_Extensions__item_
    _UL_RTOA_Measurement_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_RTOA_Measurement._cont = ASN1Dict([
        (u'uL-RTOA-MeasurementItem', _UL_RTOA_Measurement_uL_RTOA_MeasurementItem),
        (u'additionalPath-List', _UL_RTOA_Measurement_additionalPath_List),
        (u'iE-Extensions', _UL_RTOA_Measurement_iE_Extensions),
        ])
    UL_RTOA_Measurement._ext = None
    
    #-----< UL-RTOA-Measurement-ExtIEs >-----#
    UL_RTOA_Measurement_ExtIEs = CLASS(name=u'UL-RTOA-Measurement-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_RTOA_Measurement_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-RTOA-MeasurementItem >-----#
    UL_RTOA_MeasurementItem = CHOICE(name=u'UL-RTOA-MeasurementItem', mode=MODE_TYPE)
    _UL_RTOA_MeasurementItem_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_RTOA_MeasurementItem_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UL_RTOA_MeasurementItem_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_id_tab
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab_at = None
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab_id = u'id'
    __UL_RTOA_MeasurementItem_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab_at = ('..', u'id')
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab_id = u'criticality'
    __UL_RTOA_MeasurementItem_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UL_RTOA_MeasurementItem_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_value_tab
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab_at = ('..', u'id')
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab_id = u'Value'
    _UL_RTOA_MeasurementItem_choice_extension._cont = ASN1Dict([
        (u'id', __UL_RTOA_MeasurementItem_choice_extension_id),
        (u'criticality', __UL_RTOA_MeasurementItem_choice_extension_criticality),
        (u'value', __UL_RTOA_MeasurementItem_choice_extension_value),
        ])
    _UL_RTOA_MeasurementItem_choice_extension._ext = None
    UL_RTOA_MeasurementItem._cont = ASN1Dict([
        (u'k0', _UL_RTOA_MeasurementItem_k0),
        (u'k1', _UL_RTOA_MeasurementItem_k1),
        (u'k2', _UL_RTOA_MeasurementItem_k2),
        (u'k3', _UL_RTOA_MeasurementItem_k3),
        (u'k4', _UL_RTOA_MeasurementItem_k4),
        (u'k5', _UL_RTOA_MeasurementItem_k5),
        (u'choice-extension', _UL_RTOA_MeasurementItem_choice_extension),
        ])
    UL_RTOA_MeasurementItem._ext = None
    
    #-----< UL-RTOA-MeasurementItem-ExtIEs >-----#
    UL_RTOA_MeasurementItem_ExtIEs = CLASS(name=u'UL-RTOA-MeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UL_RTOA_MeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-SRS-RSRP >-----#
    UL_SRS_RSRP = INT(name=u'UL-SRS-RSRP', mode=MODE_TYPE)
    UL_SRS_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< ULUEConfiguration >-----#
    ULUEConfiguration = ENUM(name=u'ULUEConfiguration', mode=MODE_TYPE)
    ULUEConfiguration._cont = ASN1Dict([(u'no-data', 0), (u'shared', 1), (u'only', 2)])
    ULUEConfiguration._ext = []
    
    #-----< UL-UP-TNL-Information-to-Update-List-Item >-----#
    UL_UP_TNL_Information_to_Update_List_Item = SEQ(name=u'UL-UP-TNL-Information-to-Update-List-Item', mode=MODE_TYPE)
    _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation = CHOICE(name=u'uLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation = CHOICE(name=u'newULUPTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')), opt=True)
    _UL_UP_TNL_Information_to_Update_List_Item_bHInfo = SEQ(name=u'bHInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id),
        (u'criticality', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_._ext = None
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions._cont = __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_UP_TNL_Information_to_Update_List_Item._cont = ASN1Dict([
        (u'uLUPTNLInformation', _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation),
        (u'newULUPTNLInformation', _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation),
        (u'bHInfo', _UL_UP_TNL_Information_to_Update_List_Item_bHInfo),
        (u'iE-Extensions', _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions),
        ])
    UL_UP_TNL_Information_to_Update_List_Item._ext = []
    
    #-----< UL-UP-TNL-Information-to-Update-List-ItemExtIEs >-----#
    UL_UP_TNL_Information_to_Update_List_ItemExtIEs = CLASS(name=u'UL-UP-TNL-Information-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_UP_TNL_Information_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List-Item >-----#
    UL_UP_TNL_Address_to_Update_List_Item = SEQ(name=u'UL-UP-TNL-Address-to-Update-List-Item', mode=MODE_TYPE)
    _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress = BIT_STR(name=u'oldIPAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress = BIT_STR(name=u'newIPAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id),
        (u'criticality', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._ext = None
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._cont = __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_UP_TNL_Address_to_Update_List_Item._cont = ASN1Dict([
        (u'oldIPAdress', _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress),
        (u'newIPAdress', _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress),
        (u'iE-Extensions', _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions),
        ])
    UL_UP_TNL_Address_to_Update_List_Item._ext = []
    
    #-----< UL-UP-TNL-Address-to-Update-List-ItemExtIEs >-----#
    UL_UP_TNL_Address_to_Update_List_ItemExtIEs = CLASS(name=u'UL-UP-TNL-Address-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_UP_TNL_Address_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULUPTNLInformation-ToBeSetup-List >-----#
    ULUPTNLInformation_ToBeSetup_List = SEQ_OF(name=u'ULUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE)
    _ULUPTNLInformation_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-Item')))
    ULUPTNLInformation_ToBeSetup_List._cont = _ULUPTNLInformation_ToBeSetup_List__item_
    ULUPTNLInformation_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< ULUPTNLInformation-ToBeSetup-Item >-----#
    ULUPTNLInformation_ToBeSetup_Item = SEQ(name=u'ULUPTNLInformation-ToBeSetup-Item', mode=MODE_TYPE)
    _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation = CHOICE(name=u'uLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions._cont = __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULUPTNLInformation_ToBeSetup_Item._cont = ASN1Dict([
        (u'uLUPTNLInformation', _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation),
        (u'iE-Extensions', _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions),
        ])
    ULUPTNLInformation_ToBeSetup_Item._ext = []
    
    #-----< ULUPTNLInformation-ToBeSetup-ItemExtIEs >-----#
    ULUPTNLInformation_ToBeSetup_ItemExtIEs = CLASS(name=u'ULUPTNLInformation-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    ULUPTNLInformation_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Uncertainty >-----#
    Uncertainty = INT(name=u'Uncertainty', mode=MODE_TYPE)
    Uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=[], er=[])
    
    #-----< UplinkChannelBW-PerSCS-List >-----#
    UplinkChannelBW_PerSCS_List = SEQ_OF(name=u'UplinkChannelBW-PerSCS-List', mode=MODE_TYPE)
    _UplinkChannelBW_PerSCS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-SpecificCarrier')))
    UplinkChannelBW_PerSCS_List._cont = _UplinkChannelBW_PerSCS_List__item_
    UplinkChannelBW_PerSCS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UplinkTxDirectCurrentListInformation >-----#
    UplinkTxDirectCurrentListInformation = OCT_STR(name=u'UplinkTxDirectCurrentListInformation', mode=MODE_TYPE)
    
    #-----< UPTransportLayerInformation >-----#
    UPTransportLayerInformation = CHOICE(name=u'UPTransportLayerInformation', mode=MODE_TYPE)
    _UPTransportLayerInformation_gTPTunnel = SEQ(name=u'gTPTunnel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTunnel')))
    _UPTransportLayerInformation_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UPTransportLayerInformation_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UPTransportLayerInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_id._const_tab = ___UPTransportLayerInformation_choice_extension_id_tab
    __UPTransportLayerInformation_choice_extension_id._const_tab_at = None
    __UPTransportLayerInformation_choice_extension_id._const_tab_id = u'id'
    __UPTransportLayerInformation_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UPTransportLayerInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_criticality._const_tab = ___UPTransportLayerInformation_choice_extension_criticality_tab
    __UPTransportLayerInformation_choice_extension_criticality._const_tab_at = ('..', u'id')
    __UPTransportLayerInformation_choice_extension_criticality._const_tab_id = u'criticality'
    __UPTransportLayerInformation_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UPTransportLayerInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_value._const_tab = ___UPTransportLayerInformation_choice_extension_value_tab
    __UPTransportLayerInformation_choice_extension_value._const_tab_at = ('..', u'id')
    __UPTransportLayerInformation_choice_extension_value._const_tab_id = u'Value'
    _UPTransportLayerInformation_choice_extension._cont = ASN1Dict([
        (u'id', __UPTransportLayerInformation_choice_extension_id),
        (u'criticality', __UPTransportLayerInformation_choice_extension_criticality),
        (u'value', __UPTransportLayerInformation_choice_extension_value),
        ])
    _UPTransportLayerInformation_choice_extension._ext = None
    UPTransportLayerInformation._cont = ASN1Dict([
        (u'gTPTunnel', _UPTransportLayerInformation_gTPTunnel),
        (u'choice-extension', _UPTransportLayerInformation_choice_extension),
        ])
    UPTransportLayerInformation._ext = None
    
    #-----< UPTransportLayerInformation-ExtIEs >-----#
    UPTransportLayerInformation_ExtIEs = CLASS(name=u'UPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< URI-address >-----#
    URI_address = STR_VIS(name=u'URI-address', mode=MODE_TYPE)
    
    #-----< VictimgNBSetID >-----#
    VictimgNBSetID = SEQ(name=u'VictimgNBSetID', mode=MODE_TYPE)
    _VictimgNBSetID_victimgNBSetID = BIT_STR(name=u'victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _VictimgNBSetID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __VictimgNBSetID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___VictimgNBSetID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____VictimgNBSetID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab = ____VictimgNBSetID_iE_Extensions__item__id_tab
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab_at = None
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab_id = u'id'
    ___VictimgNBSetID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____VictimgNBSetID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab = ____VictimgNBSetID_iE_Extensions__item__criticality_tab
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___VictimgNBSetID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab = ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __VictimgNBSetID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___VictimgNBSetID_iE_Extensions__item__id),
        (u'criticality', ___VictimgNBSetID_iE_Extensions__item__criticality),
        (u'extensionValue', ___VictimgNBSetID_iE_Extensions__item__extensionValue),
        ])
    __VictimgNBSetID_iE_Extensions__item_._ext = None
    _VictimgNBSetID_iE_Extensions._cont = __VictimgNBSetID_iE_Extensions__item_
    _VictimgNBSetID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    VictimgNBSetID._cont = ASN1Dict([
        (u'victimgNBSetID', _VictimgNBSetID_victimgNBSetID),
        (u'iE-Extensions', _VictimgNBSetID_iE_Extensions),
        ])
    VictimgNBSetID._ext = None
    
    #-----< VictimgNBSetID-ExtIEs >-----#
    VictimgNBSetID_ExtIEs = CLASS(name=u'VictimgNBSetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    VictimgNBSetID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name=u'VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name=u'PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    PedestrianUE._ext = []
    
    _all_ = [
        _AbortTransmission_sRSResourceSetID,
        _AbortTransmission_releaseALL,
        ___AbortTransmission_choice_extension_id_tab,
        __AbortTransmission_choice_extension_id,
        ___AbortTransmission_choice_extension_criticality_tab,
        __AbortTransmission_choice_extension_criticality,
        ___AbortTransmission_choice_extension_value_tab,
        __AbortTransmission_choice_extension_value,
        _AbortTransmission_choice_extension,
        AbortTransmission,
        AbortTransmission_ExtIEs,
        _AccessPointPosition_latitudeSign,
        _AccessPointPosition_latitude,
        _AccessPointPosition_longitude,
        _AccessPointPosition_directionOfAltitude,
        _AccessPointPosition_altitude,
        _AccessPointPosition_uncertaintySemi_major,
        _AccessPointPosition_uncertaintySemi_minor,
        _AccessPointPosition_orientationOfMajorAxis,
        _AccessPointPosition_uncertaintyAltitude,
        _AccessPointPosition_confidence,
        ____AccessPointPosition_iE_Extensions__item__id_tab,
        ___AccessPointPosition_iE_Extensions__item__id,
        ____AccessPointPosition_iE_Extensions__item__criticality_tab,
        ___AccessPointPosition_iE_Extensions__item__criticality,
        ____AccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___AccessPointPosition_iE_Extensions__item__extensionValue,
        __AccessPointPosition_iE_Extensions__item_,
        _AccessPointPosition_iE_Extensions,
        AccessPointPosition,
        AccessPointPosition_ExtIEs,
        _Activated_Cells_to_be_Updated_List__item_,
        Activated_Cells_to_be_Updated_List,
        _Activated_Cells_to_be_Updated_List_Item_nRCGI,
        _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue,
        __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_,
        _Activated_Cells_to_be_Updated_List_Item_iE_Extensions,
        Activated_Cells_to_be_Updated_List_Item,
        Activated_Cells_to_be_Updated_List_Item_ExtIEs,
        _ActiveULBWP_locationAndBandwidth,
        _ActiveULBWP_subcarrierSpacing,
        _ActiveULBWP_cyclicPrefix,
        _ActiveULBWP_txDirectCurrentLocation,
        _ActiveULBWP_shift7dot5kHz,
        _ActiveULBWP_sRSConfig,
        ____ActiveULBWP_iE_Extensions__item__id_tab,
        ___ActiveULBWP_iE_Extensions__item__id,
        ____ActiveULBWP_iE_Extensions__item__criticality_tab,
        ___ActiveULBWP_iE_Extensions__item__criticality,
        ____ActiveULBWP_iE_Extensions__item__extensionValue_tab,
        ___ActiveULBWP_iE_Extensions__item__extensionValue,
        __ActiveULBWP_iE_Extensions__item_,
        _ActiveULBWP_iE_Extensions,
        ActiveULBWP,
        ActiveULBWP_ExtIEs,
        AdditionalDuplicationIndication,
        _AdditionalPath_List__item_,
        AdditionalPath_List,
        _AdditionalPath_Item_relativePathDelay,
        _AdditionalPath_Item_pathQuality,
        ____AdditionalPath_Item_iE_Extensions__item__id_tab,
        ___AdditionalPath_Item_iE_Extensions__item__id,
        ____AdditionalPath_Item_iE_Extensions__item__criticality_tab,
        ___AdditionalPath_Item_iE_Extensions__item__criticality,
        ____AdditionalPath_Item_iE_Extensions__item__extensionValue_tab,
        ___AdditionalPath_Item_iE_Extensions__item__extensionValue,
        __AdditionalPath_Item_iE_Extensions__item_,
        _AdditionalPath_Item_iE_Extensions,
        AdditionalPath_Item,
        AdditionalPath_Item_ExtIEs,
        _AdditionalPDCPDuplicationTNL_List__item_,
        AdditionalPDCPDuplicationTNL_List,
        _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation,
        ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab,
        _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue,
        __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_,
        _AdditionalPDCPDuplicationTNL_Item_iE_Extensions,
        AdditionalPDCPDuplicationTNL_Item,
        AdditionalPDCPDuplicationTNL_ItemExtIEs,
        _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0,
        _AdditionalSIBMessageList__item_,
        AdditionalSIBMessageList,
        _AdditionalSIBMessageList_Item_additionalSIB,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__id,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue,
        __AdditionalSIBMessageList_Item_iE_Extensions__item_,
        _AdditionalSIBMessageList_Item_iE_Extensions,
        AdditionalSIBMessageList_Item,
        AdditionalSIBMessageList_Item_ExtIEs,
        AdditionalRRMPriorityIndex,
        _AggressorCellList__item_,
        AggressorCellList,
        _AggressorCellList_Item_aggressorCell_ID,
        ____AggressorCellList_Item_iE_Extensions__item__id_tab,
        ___AggressorCellList_Item_iE_Extensions__item__id,
        ____AggressorCellList_Item_iE_Extensions__item__criticality_tab,
        ___AggressorCellList_Item_iE_Extensions__item__criticality,
        ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___AggressorCellList_Item_iE_Extensions__item__extensionValue,
        __AggressorCellList_Item_iE_Extensions__item_,
        _AggressorCellList_Item_iE_Extensions,
        AggressorCellList_Item,
        AggressorCellList_Item_ExtIEs,
        _AggressorgNBSetID_aggressorgNBSetID,
        ____AggressorgNBSetID_iE_Extensions__item__id_tab,
        ___AggressorgNBSetID_iE_Extensions__item__id,
        ____AggressorgNBSetID_iE_Extensions__item__criticality_tab,
        ___AggressorgNBSetID_iE_Extensions__item__criticality,
        ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab,
        ___AggressorgNBSetID_iE_Extensions__item__extensionValue,
        __AggressorgNBSetID_iE_Extensions__item_,
        _AggressorgNBSetID_iE_Extensions,
        AggressorgNBSetID,
        AggressorgNBSetID_ExtIEs,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AlternativeQoSParaSetList__item_,
        AlternativeQoSParaSetList,
        _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL,
        _AlternativeQoSParaSetItem_packetDelayBudget,
        _AlternativeQoSParaSetItem_packetErrorRate,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__id,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue,
        __AlternativeQoSParaSetItem_iE_Extensions__item_,
        _AlternativeQoSParaSetItem_iE_Extensions,
        AlternativeQoSParaSetItem,
        AlternativeQoSParaSetItem_ExtIEs,
        _AngleMeasurementQuality_azimuthQuality,
        _AngleMeasurementQuality_zenithQuality,
        _AngleMeasurementQuality_resolution,
        ____AngleMeasurementQuality_iE_Extensions__item__id_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__id,
        ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__criticality,
        ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__extensionValue,
        __AngleMeasurementQuality_iE_Extensions__item_,
        _AngleMeasurementQuality_iE_Extensions,
        AngleMeasurementQuality,
        AngleMeasurementQuality_ExtIEs,
        _AperiodicSRSResourceTriggerList__item_,
        AperiodicSRSResourceTriggerList,
        AperiodicSRSResourceTrigger,
        _Associated_SCell_Item_sCell_ID,
        ____Associated_SCell_Item_iE_Extensions__item__id_tab,
        ___Associated_SCell_Item_iE_Extensions__item__id,
        ____Associated_SCell_Item_iE_Extensions__item__criticality_tab,
        ___Associated_SCell_Item_iE_Extensions__item__criticality,
        ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Associated_SCell_Item_iE_Extensions__item__extensionValue,
        __Associated_SCell_Item_iE_Extensions__item_,
        _Associated_SCell_Item_iE_Extensions,
        Associated_SCell_Item,
        Associated_SCell_ItemExtIEs,
        _AvailablePLMNList__item_,
        AvailablePLMNList,
        _AvailablePLMNList_Item_pLMNIdentity,
        ____AvailablePLMNList_Item_iE_Extensions__item__id_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__id,
        ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__criticality,
        ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue,
        __AvailablePLMNList_Item_iE_Extensions__item_,
        _AvailablePLMNList_Item_iE_Extensions,
        AvailablePLMNList_Item,
        AvailablePLMNList_Item_ExtIEs,
        _AvailableSNPN_ID_List__item_,
        AvailableSNPN_ID_List,
        _AvailableSNPN_ID_List_Item_pLMN_Identity,
        _AvailableSNPN_ID_List_Item_availableNIDList,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __AvailableSNPN_ID_List_Item_iE_Extensions__item_,
        _AvailableSNPN_ID_List_Item_iE_Extensions,
        AvailableSNPN_ID_List_Item,
        AvailableSNPN_ID_List_ItemExtIEs,
        AveragingWindow,
        AreaScope,
        _BandwidthSRS_fR1,
        _BandwidthSRS_fR2,
        ___BandwidthSRS_choice_extension_id_tab,
        __BandwidthSRS_choice_extension_id,
        ___BandwidthSRS_choice_extension_criticality_tab,
        __BandwidthSRS_choice_extension_criticality,
        ___BandwidthSRS_choice_extension_value_tab,
        __BandwidthSRS_choice_extension_value,
        _BandwidthSRS_choice_extension,
        BandwidthSRS,
        BandwidthSRS_ExtIEs,
        BAPAddress,
        BAPCtrlPDUChannel,
        _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd,
        _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue,
        __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_,
        _BAPlayerBHRLCchannelMappingInfo_iE_Extensions,
        BAPlayerBHRLCchannelMappingInfo,
        BAPlayerBHRLCchannelMappingInfo_ExtIEs,
        _BAPlayerBHRLCchannelMappingInfoList__item_,
        BAPlayerBHRLCchannelMappingInfoList,
        _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex,
        _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress,
        _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID,
        _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress,
        _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID,
        ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id,
        ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality_tab,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality,
        ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue_tab,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue,
        __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_,
        _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions,
        BAPlayerBHRLCchannelMappingInfo_Item,
        BAPlayerBHRLCchannelMappingInfo_ItemExtIEs,
        BAPPathID,
        _BAPRoutingID_bAPAddress,
        _BAPRoutingID_bAPPathID,
        ____BAPRoutingID_iE_Extensions__item__id_tab,
        ___BAPRoutingID_iE_Extensions__item__id,
        ____BAPRoutingID_iE_Extensions__item__criticality_tab,
        ___BAPRoutingID_iE_Extensions__item__criticality,
        ____BAPRoutingID_iE_Extensions__item__extensionValue_tab,
        ___BAPRoutingID_iE_Extensions__item__extensionValue,
        __BAPRoutingID_iE_Extensions__item_,
        _BAPRoutingID_iE_Extensions,
        BAPRoutingID,
        BAPRoutingIDExtIEs,
        BitRate,
        BearerTypeChange,
        BHRLCChannelID,
        _BHChannels_FailedToBeModified_Item_bHRLCChannelID,
        _BHChannels_FailedToBeModified_Item_cause,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeModified_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeModified_Item_iE_Extensions,
        BHChannels_FailedToBeModified_Item,
        BHChannels_FailedToBeModified_ItemExtIEs,
        _BHChannels_FailedToBeSetup_Item_bHRLCChannelID,
        _BHChannels_FailedToBeSetup_Item_cause,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeSetup_Item_iE_Extensions,
        BHChannels_FailedToBeSetup_Item,
        BHChannels_FailedToBeSetup_ItemExtIEs,
        _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID,
        _BHChannels_FailedToBeSetupMod_Item_cause,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeSetupMod_Item_iE_Extensions,
        BHChannels_FailedToBeSetupMod_Item,
        BHChannels_FailedToBeSetupMod_ItemExtIEs,
        _BHChannels_Modified_Item_bHRLCChannelID,
        ____BHChannels_Modified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__id,
        ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__criticality,
        ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Modified_Item_iE_Extensions__item_,
        _BHChannels_Modified_Item_iE_Extensions,
        BHChannels_Modified_Item,
        BHChannels_Modified_ItemExtIEs,
        _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_,
        _BHChannels_Required_ToBeReleased_Item_iE_Extensions,
        BHChannels_Required_ToBeReleased_Item,
        BHChannels_Required_ToBeReleased_ItemExtIEs,
        _BHChannels_Setup_Item_bHRLCChannelID,
        ____BHChannels_Setup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__id,
        ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__criticality,
        ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Setup_Item_iE_Extensions__item_,
        _BHChannels_Setup_Item_iE_Extensions,
        BHChannels_Setup_Item,
        BHChannels_Setup_ItemExtIEs,
        _BHChannels_SetupMod_Item_bHRLCChannelID,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_SetupMod_Item_iE_Extensions__item_,
        _BHChannels_SetupMod_Item_iE_Extensions,
        BHChannels_SetupMod_Item,
        BHChannels_SetupMod_ItemExtIEs,
        _BHChannels_ToBeModified_Item_bHRLCChannelID,
        _BHChannels_ToBeModified_Item_bHQoSInformation,
        _BHChannels_ToBeModified_Item_rLCmode,
        _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeModified_Item_trafficMappingInfo,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeModified_Item_iE_Extensions__item_,
        _BHChannels_ToBeModified_Item_iE_Extensions,
        BHChannels_ToBeModified_Item,
        BHChannels_ToBeModified_ItemExtIEs,
        _BHChannels_ToBeReleased_Item_bHRLCChannelID,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeReleased_Item_iE_Extensions__item_,
        _BHChannels_ToBeReleased_Item_iE_Extensions,
        BHChannels_ToBeReleased_Item,
        BHChannels_ToBeReleased_ItemExtIEs,
        _BHChannels_ToBeSetup_Item_bHRLCChannelID,
        _BHChannels_ToBeSetup_Item_bHQoSInformation,
        _BHChannels_ToBeSetup_Item_rLCmode,
        _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeSetup_Item_trafficMappingInfo,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeSetup_Item_iE_Extensions__item_,
        _BHChannels_ToBeSetup_Item_iE_Extensions,
        BHChannels_ToBeSetup_Item,
        BHChannels_ToBeSetup_ItemExtIEs,
        _BHChannels_ToBeSetupMod_Item_bHRLCChannelID,
        _BHChannels_ToBeSetupMod_Item_bHQoSInformation,
        _BHChannels_ToBeSetupMod_Item_rLCmode,
        _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeSetupMod_Item_trafficMappingInfo,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_,
        _BHChannels_ToBeSetupMod_Item_iE_Extensions,
        BHChannels_ToBeSetupMod_Item,
        BHChannels_ToBeSetupMod_ItemExtIEs,
        _BHInfo_bAProutingID,
        _BHInfo_egressBHRLCCHList,
        ____BHInfo_iE_Extensions__item__id_tab,
        ___BHInfo_iE_Extensions__item__id,
        ____BHInfo_iE_Extensions__item__criticality_tab,
        ___BHInfo_iE_Extensions__item__criticality,
        ____BHInfo_iE_Extensions__item__extensionValue_tab,
        ___BHInfo_iE_Extensions__item__extensionValue,
        __BHInfo_iE_Extensions__item_,
        _BHInfo_iE_Extensions,
        BHInfo,
        BHInfo_ExtIEs,
        _BHQoSInformation_bHRLCCHQoS,
        _BHQoSInformation_eUTRANBHRLCCHQoS,
        _BHQoSInformation_cPTrafficType,
        ___BHQoSInformation_choice_extension_id_tab,
        __BHQoSInformation_choice_extension_id,
        ___BHQoSInformation_choice_extension_criticality_tab,
        __BHQoSInformation_choice_extension_criticality,
        ___BHQoSInformation_choice_extension_value_tab,
        __BHQoSInformation_choice_extension_value,
        _BHQoSInformation_choice_extension,
        BHQoSInformation,
        BHQoSInformation_ExtIEs,
        _BH_Routing_Information_Added_List_Item_bAPRoutingID,
        _BH_Routing_Information_Added_List_Item_nextHopBAPAddress,
        ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id,
        ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality_tab,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality,
        ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue,
        __BH_Routing_Information_Added_List_Item_iE_Extensions__item_,
        _BH_Routing_Information_Added_List_Item_iE_Extensions,
        BH_Routing_Information_Added_List_Item,
        BH_Routing_Information_Added_List_ItemExtIEs,
        _BH_Routing_Information_Removed_List_Item_bAPRoutingID,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue,
        __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_,
        _BH_Routing_Information_Removed_List_Item_iE_Extensions,
        BH_Routing_Information_Removed_List_Item,
        BH_Routing_Information_Removed_List_ItemExtIEs,
        _BPLMN_ID_Info_List__item_,
        BPLMN_ID_Info_List,
        _BPLMN_ID_Info_Item_pLMN_Identity_List,
        _BPLMN_ID_Info_Item_extended_PLMN_Identity_List,
        _BPLMN_ID_Info_Item_fiveGS_TAC,
        _BPLMN_ID_Info_Item_nr_cell_ID,
        _BPLMN_ID_Info_Item_ranac,
        ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab,
        _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__id,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue,
        __BPLMN_ID_Info_Item_iE_Extensions__item_,
        _BPLMN_ID_Info_Item_iE_Extensions,
        BPLMN_ID_Info_Item,
        BPLMN_ID_Info_ItemExtIEs,
        _BPLMN_ID_Info_ItemExtIEs_val_Extension_0,
        _BPLMN_ID_Info_ItemExtIEs_val_Extension_1,
        _ServedPLMNs_List__item_,
        ServedPLMNs_List,
        _ServedPLMNs_Item_pLMN_Identity,
        ____ServedPLMNs_Item_iE_Extensions__item__id_tab,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___ServedPLMNs_Item_iE_Extensions__item__id,
        ___ServedPLMNs_Item_iE_Extensions__item__criticality,
        ___ServedPLMNs_Item_iE_Extensions__item__extensionValue,
        __ServedPLMNs_Item_iE_Extensions__item_,
        _ServedPLMNs_Item_iE_Extensions,
        ServedPLMNs_Item,
        ServedPLMNs_ItemExtIEs,
        _ServedPLMNs_ItemExtIEs_val_Extension_0,
        _ServedPLMNs_ItemExtIEs_val_Extension_1,
        _ServedPLMNs_ItemExtIEs_val_Extension_2,
        _BroadcastCAGList__item_,
        BroadcastCAGList,
        _BroadcastNIDList__item_,
        BroadcastNIDList,
        _BroadcastSNPN_ID_List__item_,
        BroadcastSNPN_ID_List,
        _BroadcastSNPN_ID_List_Item_pLMN_Identity,
        _BroadcastSNPN_ID_List_Item_broadcastNIDList,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __BroadcastSNPN_ID_List_Item_iE_Extensions__item_,
        _BroadcastSNPN_ID_List_Item_iE_Extensions,
        BroadcastSNPN_ID_List_Item,
        BroadcastSNPN_ID_List_ItemExtIEs,
        _BroadcastPNI_NPN_ID_List__item_,
        BroadcastPNI_NPN_ID_List,
        _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity,
        _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_,
        _BroadcastPNI_NPN_ID_List_Item_iE_Extensions,
        BroadcastPNI_NPN_ID_List_Item,
        BroadcastPNI_NPN_ID_List_ItemExtIEs,
        BurstArrivalTime,
        CAGID,
        Cancel_all_Warning_Messages_Indicator,
        _Candidate_SpCell_Item_candidate_SpCell_ID,
        ____Candidate_SpCell_Item_iE_Extensions__item__id_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__id,
        ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__criticality,
        ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue,
        __Candidate_SpCell_Item_iE_Extensions__item_,
        _Candidate_SpCell_Item_iE_Extensions,
        Candidate_SpCell_Item,
        Candidate_SpCell_ItemExtIEs,
        _CapacityValue_capacityValue,
        _CapacityValue_sSBAreaCapacityValueList,
        ____CapacityValue_iE_Extensions__item__id_tab,
        ___CapacityValue_iE_Extensions__item__id,
        ____CapacityValue_iE_Extensions__item__criticality_tab,
        ___CapacityValue_iE_Extensions__item__criticality,
        ____CapacityValue_iE_Extensions__item__extensionValue_tab,
        ___CapacityValue_iE_Extensions__item__extensionValue,
        __CapacityValue_iE_Extensions__item_,
        _CapacityValue_iE_Extensions,
        CapacityValue,
        CapacityValue_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_extension_id_tab,
        __Cause_choice_extension_id,
        ___Cause_choice_extension_criticality_tab,
        __Cause_choice_extension_criticality,
        ___Cause_choice_extension_value_tab,
        __Cause_choice_extension_value,
        _Cause_choice_extension,
        Cause,
        Cause_ExtIEs,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        CellGroupConfig,
        CellCapacityClassValue,
        Cell_Direction,
        _CellMeasurementResultList__item_,
        CellMeasurementResultList,
        _CellMeasurementResultItem_cellID,
        _CellMeasurementResultItem_radioResourceStatus,
        _CellMeasurementResultItem_compositeAvailableCapacityGroup,
        _CellMeasurementResultItem_sliceAvailableCapacity,
        _CellMeasurementResultItem_numberofActiveUEs,
        ____CellMeasurementResultItem_iE_Extensions__item__id_tab,
        ___CellMeasurementResultItem_iE_Extensions__item__id,
        ____CellMeasurementResultItem_iE_Extensions__item__criticality_tab,
        ___CellMeasurementResultItem_iE_Extensions__item__criticality,
        ____CellMeasurementResultItem_iE_Extensions__item__extensionValue_tab,
        ___CellMeasurementResultItem_iE_Extensions__item__extensionValue,
        __CellMeasurementResultItem_iE_Extensions__item_,
        _CellMeasurementResultItem_iE_Extensions,
        CellMeasurementResultItem,
        CellMeasurementResultItem_ExtIEs,
        Cell_Portion_ID,
        _Cells_Failed_to_be_Activated_List_Item_nRCGI,
        _Cells_Failed_to_be_Activated_List_Item_cause,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_,
        _Cells_Failed_to_be_Activated_List_Item_iE_Extensions,
        Cells_Failed_to_be_Activated_List_Item,
        Cells_Failed_to_be_Activated_List_ItemExtIEs,
        _Cells_Status_Item_nRCGI,
        _Cells_Status_Item_service_status,
        ____Cells_Status_Item_iE_Extensions__item__id_tab,
        ___Cells_Status_Item_iE_Extensions__item__id,
        ____Cells_Status_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Status_Item_iE_Extensions__item__criticality,
        ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Status_Item_iE_Extensions__item__extensionValue,
        __Cells_Status_Item_iE_Extensions__item_,
        _Cells_Status_Item_iE_Extensions,
        Cells_Status_Item,
        Cells_Status_ItemExtIEs,
        _Cells_To_Be_Broadcast_Item_nRCGI,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue,
        __Cells_To_Be_Broadcast_Item_iE_Extensions__item_,
        _Cells_To_Be_Broadcast_Item_iE_Extensions,
        Cells_To_Be_Broadcast_Item,
        Cells_To_Be_Broadcast_ItemExtIEs,
        _Cells_Broadcast_Completed_Item_nRCGI,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue,
        __Cells_Broadcast_Completed_Item_iE_Extensions__item_,
        _Cells_Broadcast_Completed_Item_iE_Extensions,
        Cells_Broadcast_Completed_Item,
        Cells_Broadcast_Completed_ItemExtIEs,
        _Broadcast_To_Be_Cancelled_Item_nRCGI,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue,
        __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_,
        _Broadcast_To_Be_Cancelled_Item_iE_Extensions,
        Broadcast_To_Be_Cancelled_Item,
        Broadcast_To_Be_Cancelled_ItemExtIEs,
        _Cells_Broadcast_Cancelled_Item_nRCGI,
        _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue,
        __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_,
        _Cells_Broadcast_Cancelled_Item_iE_Extensions,
        Cells_Broadcast_Cancelled_Item,
        Cells_Broadcast_Cancelled_ItemExtIEs,
        _Cells_to_be_Activated_List_Item_nRCGI,
        _Cells_to_be_Activated_List_Item_nRPCI,
        ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Activated_List_Item_iE_Extensions__item_,
        _Cells_to_be_Activated_List_Item_iE_Extensions,
        Cells_to_be_Activated_List_Item,
        Cells_to_be_Activated_List_ItemExtIEs,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4,
        _Cells_to_be_Deactivated_List_Item_nRCGI,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_,
        _Cells_to_be_Deactivated_List_Item_iE_Extensions,
        Cells_to_be_Deactivated_List_Item,
        Cells_to_be_Deactivated_List_ItemExtIEs,
        _Cells_to_be_Barred_Item_nRCGI,
        _Cells_to_be_Barred_Item_cellBarred,
        ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab,
        _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__id,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Barred_Item_iE_Extensions__item_,
        _Cells_to_be_Barred_Item_iE_Extensions,
        Cells_to_be_Barred_Item,
        Cells_to_be_Barred_Item_ExtIEs,
        _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0,
        CellBarred,
        CellSize,
        _CellToReportList__item_,
        CellToReportList,
        _CellToReportItem_cellID,
        _CellToReportItem_sSBToReportList,
        _CellToReportItem_sliceToReportList,
        ____CellToReportItem_iE_Extensions__item__id_tab,
        ___CellToReportItem_iE_Extensions__item__id,
        ____CellToReportItem_iE_Extensions__item__criticality_tab,
        ___CellToReportItem_iE_Extensions__item__criticality,
        ____CellToReportItem_iE_Extensions__item__extensionValue_tab,
        ___CellToReportItem_iE_Extensions__item__extensionValue,
        __CellToReportItem_iE_Extensions__item_,
        _CellToReportItem_iE_Extensions,
        CellToReportItem,
        CellToReportItem_ExtIEs,
        _CellType_cellSize,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        CellULConfigured,
        _Child_Node_Cells_List__item_,
        Child_Node_Cells_List,
        _Child_Node_Cells_List_Item_nRCGI,
        _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info,
        _Child_Node_Cells_List_Item_iAB_STC_Info,
        _Child_Node_Cells_List_Item_rACH_Config_Common,
        _Child_Node_Cells_List_Item_rACH_Config_Common_IAB,
        _Child_Node_Cells_List_Item_cSI_RS_Configuration,
        _Child_Node_Cells_List_Item_sR_Configuration,
        _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1,
        _Child_Node_Cells_List_Item_sCS_Common,
        _Child_Node_Cells_List_Item_multiplexingInfo,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__id,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue,
        __Child_Node_Cells_List_Item_iE_Extensions__item_,
        _Child_Node_Cells_List_Item_iE_Extensions,
        Child_Node_Cells_List_Item,
        Child_Node_Cells_List_Item_ExtIEs,
        _Child_Nodes_List__item_,
        Child_Nodes_List,
        _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID,
        _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID,
        _Child_Nodes_List_Item_child_Node_Cells_List,
        ____Child_Nodes_List_Item_iE_Extensions__item__id_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__id,
        ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__criticality,
        ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue,
        __Child_Nodes_List_Item_iE_Extensions__item_,
        _Child_Nodes_List_Item_iE_Extensions,
        Child_Nodes_List_Item,
        Child_Nodes_List_Item_ExtIEs,
        CHOtrigger_InterDU,
        CHOtrigger_IntraDU,
        _CNUEPagingIdentity_fiveG_S_TMSI,
        ___CNUEPagingIdentity_choice_extension_id_tab,
        __CNUEPagingIdentity_choice_extension_id,
        ___CNUEPagingIdentity_choice_extension_criticality_tab,
        __CNUEPagingIdentity_choice_extension_criticality,
        ___CNUEPagingIdentity_choice_extension_value_tab,
        __CNUEPagingIdentity_choice_extension_value,
        _CNUEPagingIdentity_choice_extension,
        CNUEPagingIdentity,
        CNUEPagingIdentity_ExtIEs,
        _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink,
        _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacityGroup_iE_Extensions__item_,
        _CompositeAvailableCapacityGroup_iE_Extensions,
        CompositeAvailableCapacityGroup,
        CompositeAvailableCapacityGroup_ExtIEs,
        _CompositeAvailableCapacity_cellCapacityClassValue,
        _CompositeAvailableCapacity_capacityValue,
        ____CompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__id,
        ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacity_iE_Extensions__item_,
        _CompositeAvailableCapacity_iE_Extensions,
        CompositeAvailableCapacity,
        CompositeAvailableCapacity_ExtIEs,
        CHO_Probability,
        _ConditionalInterDUMobilityInformation_cho_trigger,
        _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID,
        ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab,
        _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue,
        __ConditionalInterDUMobilityInformation_iE_Extensions__item_,
        _ConditionalInterDUMobilityInformation_iE_Extensions,
        ConditionalInterDUMobilityInformation,
        ConditionalInterDUMobilityInformation_ExtIEs,
        _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0,
        _ConditionalIntraDUMobilityInformation_cho_trigger,
        _ConditionalIntraDUMobilityInformation_targetCellsTocancel,
        ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab,
        _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue,
        __ConditionalIntraDUMobilityInformation_iE_Extensions__item_,
        _ConditionalIntraDUMobilityInformation_iE_Extensions,
        ConditionalIntraDUMobilityInformation,
        ConditionalIntraDUMobilityInformation_ExtIEs,
        _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0,
        ConfiguredTACIndication,
        CoordinateID,
        _CP_TransportLayerAddress_endpoint_IP_address,
        _CP_TransportLayerAddress_endpoint_IP_address_and_port,
        ___CP_TransportLayerAddress_choice_extension_id_tab,
        __CP_TransportLayerAddress_choice_extension_id,
        ___CP_TransportLayerAddress_choice_extension_criticality_tab,
        __CP_TransportLayerAddress_choice_extension_criticality,
        ___CP_TransportLayerAddress_choice_extension_value_tab,
        __CP_TransportLayerAddress_choice_extension_value,
        _CP_TransportLayerAddress_choice_extension,
        CP_TransportLayerAddress,
        CP_TransportLayerAddress_ExtIEs,
        CPTrafficType,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        C_RNTI,
        _CUDURadioInformationType_rIM,
        ___CUDURadioInformationType_choice_extension_id_tab,
        __CUDURadioInformationType_choice_extension_id,
        ___CUDURadioInformationType_choice_extension_criticality_tab,
        __CUDURadioInformationType_choice_extension_criticality,
        ___CUDURadioInformationType_choice_extension_value_tab,
        __CUDURadioInformationType_choice_extension_value,
        _CUDURadioInformationType_choice_extension,
        CUDURadioInformationType,
        CUDURadioInformationType_ExtIEs,
        _CUDURIMInformation_victimgNBSetID,
        _CUDURIMInformation_rIMRSDetectionStatus,
        ____CUDURIMInformation_iE_Extensions__item__id_tab,
        ___CUDURIMInformation_iE_Extensions__item__id,
        ____CUDURIMInformation_iE_Extensions__item__criticality_tab,
        ___CUDURIMInformation_iE_Extensions__item__criticality,
        ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab,
        ___CUDURIMInformation_iE_Extensions__item__extensionValue,
        __CUDURIMInformation_iE_Extensions__item_,
        _CUDURIMInformation_iE_Extensions,
        CUDURIMInformation,
        CUDURIMInformation_ExtIEs,
        _CUtoDURRCInformation_cG_ConfigInfo,
        _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList,
        _CUtoDURRCInformation_measConfig,
        ____CUtoDURRCInformation_iE_Extensions__item__id_tab,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6,
        ___CUtoDURRCInformation_iE_Extensions__item__id,
        ___CUtoDURRCInformation_iE_Extensions__item__criticality,
        ___CUtoDURRCInformation_iE_Extensions__item__extensionValue,
        __CUtoDURRCInformation_iE_Extensions__item_,
        _CUtoDURRCInformation_iE_Extensions,
        CUtoDURRCInformation,
        CUtoDURRCInformation_ExtIEs,
        _CUtoDURRCInformation_ExtIEs_val_Extension_0,
        _CUtoDURRCInformation_ExtIEs_val_Extension_1,
        _CUtoDURRCInformation_ExtIEs_val_Extension_2,
        _CUtoDURRCInformation_ExtIEs_val_Extension_3,
        _CUtoDURRCInformation_ExtIEs_val_Extension_4,
        _CUtoDURRCInformation_ExtIEs_val_Extension_5,
        _CUtoDURRCInformation_ExtIEs_val_Extension_6,
        DCBasedDuplicationConfigured,
        _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID,
        _Dedicated_SIDelivery_NeededUE_Item_nRCGI,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue,
        __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_,
        _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions,
        Dedicated_SIDelivery_NeededUE_Item,
        DedicatedSIDeliveryNeededUE_Item_ExtIEs,
        _DL_PRS_prsid,
        _DL_PRS_dl_PRSResourceSetID,
        _DL_PRS_dl_PRSResourceID,
        ____DL_PRS_iE_Extensions__item__id_tab,
        ___DL_PRS_iE_Extensions__item__id,
        ____DL_PRS_iE_Extensions__item__criticality_tab,
        ___DL_PRS_iE_Extensions__item__criticality,
        ____DL_PRS_iE_Extensions__item__extensionValue_tab,
        ___DL_PRS_iE_Extensions__item__extensionValue,
        __DL_PRS_iE_Extensions__item_,
        _DL_PRS_iE_Extensions,
        DL_PRS,
        DL_PRS_ExtIEs,
        _DL_PRSMutingPattern_two,
        _DL_PRSMutingPattern_four,
        _DL_PRSMutingPattern_six,
        _DL_PRSMutingPattern_eight,
        _DL_PRSMutingPattern_sixteen,
        _DL_PRSMutingPattern_thirty_two,
        ___DL_PRSMutingPattern_choice_extension_id_tab,
        __DL_PRSMutingPattern_choice_extension_id,
        ___DL_PRSMutingPattern_choice_extension_criticality_tab,
        __DL_PRSMutingPattern_choice_extension_criticality,
        ___DL_PRSMutingPattern_choice_extension_value_tab,
        __DL_PRSMutingPattern_choice_extension_value,
        _DL_PRSMutingPattern_choice_extension,
        DL_PRSMutingPattern,
        DL_PRSMutingPattern_ExtIEs,
        __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_,
        _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP,
        ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__id,
        ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__criticality,
        ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue,
        __DLPRSResourceCoordinates_iE_Extensions__item_,
        _DLPRSResourceCoordinates_iE_Extensions,
        DLPRSResourceCoordinates,
        DLPRSResourceCoordinates_ExtIEs,
        _DLPRSResourceSetARP_dl_PRSResourceSetID,
        _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation,
        __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_,
        _DLPRSResourceSetARP_listofDL_PRSResourceARP,
        ____DLPRSResourceSetARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__id,
        ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__criticality,
        ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceSetARP_iE_Extensions__item_,
        _DLPRSResourceSetARP_iE_Extensions,
        DLPRSResourceSetARP,
        DLPRSResourceSetARP_ExtIEs,
        _DL_PRSResourceSetARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceSetARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_id,
        ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_value,
        _DL_PRSResourceSetARPLocation_choice_Extension,
        DL_PRSResourceSetARPLocation,
        DL_PRSResourceSetARPLocation_ExtIEs,
        _DLPRSResourceARP_dl_PRSResourceID,
        _DLPRSResourceARP_dL_PRSResourceARPLocation,
        ____DLPRSResourceARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceARP_iE_Extensions__item__id,
        ____DLPRSResourceARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceARP_iE_Extensions__item__criticality,
        ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceARP_iE_Extensions__item_,
        _DLPRSResourceARP_iE_Extensions,
        DLPRSResourceARP,
        DLPRSResourceARP_ExtIEs,
        _DL_PRSResourceARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceARPLocation_choice_Extension_id,
        ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceARPLocation_choice_Extension_value,
        _DL_PRSResourceARPLocation_choice_Extension,
        DL_PRSResourceARPLocation,
        DL_PRSResourceARPLocation_ExtIEs,
        _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress,
        _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_,
        _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions,
        DL_UP_TNL_Address_to_Update_List_Item,
        DL_UP_TNL_Address_to_Update_List_ItemExtIEs,
        _DLUPTNLInformation_ToBeSetup_List__item_,
        DLUPTNLInformation_ToBeSetup_List,
        _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_,
        _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions,
        DLUPTNLInformation_ToBeSetup_Item,
        DLUPTNLInformation_ToBeSetup_ItemExtIEs,
        _DRB_Activity_Item_dRBID,
        _DRB_Activity_Item_dRB_Activity,
        ____DRB_Activity_Item_iE_Extensions__item__id_tab,
        ___DRB_Activity_Item_iE_Extensions__item__id,
        ____DRB_Activity_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Activity_Item_iE_Extensions__item__criticality,
        ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Activity_Item_iE_Extensions__item__extensionValue,
        __DRB_Activity_Item_iE_Extensions__item_,
        _DRB_Activity_Item_iE_Extensions,
        DRB_Activity_Item,
        DRB_Activity_ItemExtIEs,
        DRB_Activity,
        DRBID,
        _DRBs_FailedToBeModified_Item_dRBID,
        _DRBs_FailedToBeModified_Item_cause,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _DRBs_FailedToBeModified_Item_iE_Extensions,
        DRBs_FailedToBeModified_Item,
        DRBs_FailedToBeModified_ItemExtIEs,
        _DRBs_FailedToBeSetup_Item_dRBID,
        _DRBs_FailedToBeSetup_Item_cause,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _DRBs_FailedToBeSetup_Item_iE_Extensions,
        DRBs_FailedToBeSetup_Item,
        DRBs_FailedToBeSetup_ItemExtIEs,
        _DRBs_FailedToBeSetupMod_Item_dRBID,
        _DRBs_FailedToBeSetupMod_Item_cause,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _DRBs_FailedToBeSetupMod_Item_iE_Extensions,
        DRBs_FailedToBeSetupMod_Item,
        DRBs_FailedToBeSetupMod_ItemExtIEs,
        _DRB_Information_dRB_QoS,
        _DRB_Information_sNSSAI,
        _DRB_Information_notificationControl,
        _DRB_Information_flows_Mapped_To_DRB_List,
        ____DRB_Information_iE_Extensions__item__id_tab,
        ___DRB_Information_iE_Extensions__item__id,
        ____DRB_Information_iE_Extensions__item__criticality_tab,
        ___DRB_Information_iE_Extensions__item__criticality,
        ____DRB_Information_iE_Extensions__item__extensionValue_tab,
        ___DRB_Information_iE_Extensions__item__extensionValue,
        __DRB_Information_iE_Extensions__item_,
        _DRB_Information_iE_Extensions,
        DRB_Information,
        DRB_Information_ItemExtIEs,
        _DRBs_Modified_Item_dRBID,
        _DRBs_Modified_Item_lCID,
        _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Modified_Item_iE_Extensions__item__id_tab,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___DRBs_Modified_Item_iE_Extensions__item__id,
        ___DRBs_Modified_Item_iE_Extensions__item__criticality,
        ___DRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __DRBs_Modified_Item_iE_Extensions__item_,
        _DRBs_Modified_Item_iE_Extensions,
        DRBs_Modified_Item,
        DRBs_Modified_ItemExtIEs,
        _DRBs_Modified_ItemExtIEs_val_Extension_0,
        _DRBs_Modified_ItemExtIEs_val_Extension_1,
        _DRBs_Modified_ItemExtIEs_val_Extension_2,
        _DRBs_ModifiedConf_Item_dRBID,
        _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List,
        ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab,
        _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__id,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue,
        __DRBs_ModifiedConf_Item_iE_Extensions__item_,
        _DRBs_ModifiedConf_Item_iE_Extensions,
        DRBs_ModifiedConf_Item,
        DRBs_ModifiedConf_ItemExtIEs,
        _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0,
        _DRB_Notify_Item_dRBID,
        _DRB_Notify_Item_notification_Cause,
        ____DRB_Notify_Item_iE_Extensions__item__id_tab,
        _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRB_Notify_Item_iE_Extensions__item__id,
        ___DRB_Notify_Item_iE_Extensions__item__criticality,
        ___DRB_Notify_Item_iE_Extensions__item__extensionValue,
        __DRB_Notify_Item_iE_Extensions__item_,
        _DRB_Notify_Item_iE_Extensions,
        DRB_Notify_Item,
        DRB_Notify_ItemExtIEs,
        _DRB_Notify_ItemExtIEs_val_Extension_0,
        _DRBs_Required_ToBeModified_Item_dRBID,
        _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab,
        _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_Required_ToBeModified_Item_iE_Extensions__item_,
        _DRBs_Required_ToBeModified_Item_iE_Extensions,
        DRBs_Required_ToBeModified_Item,
        DRBs_Required_ToBeModified_ItemExtIEs,
        _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0,
        _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1,
        _DRBs_Required_ToBeReleased_Item_dRBID,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _DRBs_Required_ToBeReleased_Item_iE_Extensions,
        DRBs_Required_ToBeReleased_Item,
        DRBs_Required_ToBeReleased_ItemExtIEs,
        _DRBs_Setup_Item_dRBID,
        _DRBs_Setup_Item_lCID,
        _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Setup_Item_iE_Extensions__item__id_tab,
        _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_Setup_Item_iE_Extensions__item__id,
        ___DRBs_Setup_Item_iE_Extensions__item__criticality,
        ___DRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __DRBs_Setup_Item_iE_Extensions__item_,
        _DRBs_Setup_Item_iE_Extensions,
        DRBs_Setup_Item,
        DRBs_Setup_ItemExtIEs,
        _DRBs_Setup_ItemExtIEs_val_Extension_0,
        _DRBs_Setup_ItemExtIEs_val_Extension_1,
        _DRBs_SetupMod_Item_dRBID,
        _DRBs_SetupMod_Item_lCID,
        _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_SetupMod_Item_iE_Extensions__item__id,
        ___DRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_SetupMod_Item_iE_Extensions__item_,
        _DRBs_SetupMod_Item_iE_Extensions,
        DRBs_SetupMod_Item,
        DRBs_SetupMod_ItemExtIEs,
        _DRBs_SetupMod_ItemExtIEs_val_Extension_0,
        _DRBs_SetupMod_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeModified_Item_dRBID,
        _DRBs_ToBeModified_Item_qoSInformation,
        _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeModified_Item_uLConfiguration,
        ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__id,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeModified_Item_iE_Extensions__item_,
        _DRBs_ToBeModified_Item_iE_Extensions,
        DRBs_ToBeModified_Item,
        DRBs_ToBeModified_ItemExtIEs,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_5,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_6,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_7,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_8,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_9,
        _DRBs_ToBeReleased_Item_dRBID,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeReleased_Item_iE_Extensions__item_,
        _DRBs_ToBeReleased_Item_iE_Extensions,
        DRBs_ToBeReleased_Item,
        DRBs_ToBeReleased_ItemExtIEs,
        _DRBs_ToBeSetup_Item_dRBID,
        _DRBs_ToBeSetup_Item_qoSInformation,
        _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeSetup_Item_rLCMode,
        _DRBs_ToBeSetup_Item_uLConfiguration,
        _DRBs_ToBeSetup_Item_duplicationActivation,
        ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeSetup_Item_iE_Extensions__item_,
        _DRBs_ToBeSetup_Item_iE_Extensions,
        DRBs_ToBeSetup_Item,
        DRBs_ToBeSetup_ItemExtIEs,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5,
        _DRBs_ToBeSetupMod_Item_dRBID,
        _DRBs_ToBeSetupMod_Item_qoSInformation,
        _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeSetupMod_Item_rLCMode,
        _DRBs_ToBeSetupMod_Item_uLConfiguration,
        _DRBs_ToBeSetupMod_Item_duplicationActivation,
        ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _DRBs_ToBeSetupMod_Item_iE_Extensions,
        DRBs_ToBeSetupMod_Item,
        DRBs_ToBeSetupMod_ItemExtIEs,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5,
        _DRXCycle_longDRXCycleLength,
        _DRXCycle_shortDRXCycleLength,
        _DRXCycle_shortDRXCycleTimer,
        ____DRXCycle_iE_Extensions__item__id_tab,
        ___DRXCycle_iE_Extensions__item__id,
        ____DRXCycle_iE_Extensions__item__criticality_tab,
        ___DRXCycle_iE_Extensions__item__criticality,
        ____DRXCycle_iE_Extensions__item__extensionValue_tab,
        ___DRXCycle_iE_Extensions__item__extensionValue,
        __DRXCycle_iE_Extensions__item_,
        _DRXCycle_iE_Extensions,
        DRXCycle,
        DRXCycle_ExtIEs,
        DRX_Config,
        DRXConfigurationIndicator,
        DRX_LongCycleStartOffset,
        _DSInformationList__item_,
        DSInformationList,
        DSCP,
        DUtoCURRCContainer,
        _DUCURadioInformationType_rIM,
        ___DUCURadioInformationType_choice_extension_id_tab,
        __DUCURadioInformationType_choice_extension_id,
        ___DUCURadioInformationType_choice_extension_criticality_tab,
        __DUCURadioInformationType_choice_extension_criticality,
        ___DUCURadioInformationType_choice_extension_value_tab,
        __DUCURadioInformationType_choice_extension_value,
        _DUCURadioInformationType_choice_extension,
        DUCURadioInformationType,
        DUCURadioInformationType_ExtIEs,
        _DUCURIMInformation_victimgNBSetID,
        _DUCURIMInformation_rIMRSDetectionStatus,
        _DUCURIMInformation_aggressorCellList,
        ____DUCURIMInformation_iE_Extensions__item__id_tab,
        ___DUCURIMInformation_iE_Extensions__item__id,
        ____DUCURIMInformation_iE_Extensions__item__criticality_tab,
        ___DUCURIMInformation_iE_Extensions__item__criticality,
        ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab,
        ___DUCURIMInformation_iE_Extensions__item__extensionValue,
        __DUCURIMInformation_iE_Extensions__item_,
        _DUCURIMInformation_iE_Extensions,
        DUCURIMInformation,
        DUCURIMInformation_ExtIEs,
        _DUF_Slot_Config_Item_explicitFormat,
        _DUF_Slot_Config_Item_implicitFormat,
        ___DUF_Slot_Config_Item_choice_extension_id_tab,
        __DUF_Slot_Config_Item_choice_extension_id,
        ___DUF_Slot_Config_Item_choice_extension_criticality_tab,
        __DUF_Slot_Config_Item_choice_extension_criticality,
        ___DUF_Slot_Config_Item_choice_extension_value_tab,
        __DUF_Slot_Config_Item_choice_extension_value,
        _DUF_Slot_Config_Item_choice_extension,
        DUF_Slot_Config_Item,
        DUF_Slot_Config_Item_ExtIEs,
        _DUF_Slot_Config_List__item_,
        DUF_Slot_Config_List,
        DUFSlotformatIndex,
        DUFTransmissionPeriodicity,
        DU_RX_MT_RX,
        DU_TX_MT_TX,
        DU_RX_MT_TX,
        DU_TX_MT_RX,
        _DUtoCURRCInformation_cellGroupConfig,
        _DUtoCURRCInformation_measGapConfig,
        _DUtoCURRCInformation_requestedP_MaxFR1,
        ____DUtoCURRCInformation_iE_Extensions__item__id_tab,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13,
        ___DUtoCURRCInformation_iE_Extensions__item__id,
        ___DUtoCURRCInformation_iE_Extensions__item__criticality,
        ___DUtoCURRCInformation_iE_Extensions__item__extensionValue,
        __DUtoCURRCInformation_iE_Extensions__item_,
        _DUtoCURRCInformation_iE_Extensions,
        DUtoCURRCInformation,
        DUtoCURRCInformation_ExtIEs,
        _DUtoCURRCInformation_ExtIEs_val_Extension_0,
        _DUtoCURRCInformation_ExtIEs_val_Extension_1,
        _DUtoCURRCInformation_ExtIEs_val_Extension_2,
        _DUtoCURRCInformation_ExtIEs_val_Extension_3,
        _DUtoCURRCInformation_ExtIEs_val_Extension_4,
        _DUtoCURRCInformation_ExtIEs_val_Extension_5,
        _DUtoCURRCInformation_ExtIEs_val_Extension_6,
        _DUtoCURRCInformation_ExtIEs_val_Extension_7,
        _DUtoCURRCInformation_ExtIEs_val_Extension_8,
        _DUtoCURRCInformation_ExtIEs_val_Extension_9,
        _DUtoCURRCInformation_ExtIEs_val_Extension_10,
        _DUtoCURRCInformation_ExtIEs_val_Extension_11,
        _DUtoCURRCInformation_ExtIEs_val_Extension_12,
        _DUtoCURRCInformation_ExtIEs_val_Extension_13,
        DuplicationActivation,
        DuplicationIndication,
        DuplicationState,
        _Dynamic5QIDescriptor_qoSPriorityLevel,
        _Dynamic5QIDescriptor_packetDelayBudget,
        _Dynamic5QIDescriptor_packetErrorRate,
        _Dynamic5QIDescriptor_fiveQI,
        _Dynamic5QIDescriptor_delayCritical,
        _Dynamic5QIDescriptor_averagingWindow,
        _Dynamic5QIDescriptor_maxDataBurstVolume,
        ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2,
        ___Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Dynamic5QIDescriptor_iE_Extensions__item_,
        _Dynamic5QIDescriptor_iE_Extensions,
        Dynamic5QIDescriptor,
        Dynamic5QIDescriptor_ExtIEs,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_2,
        _DynamicPQIDescriptor_resourceType,
        _DynamicPQIDescriptor_qoSPriorityLevel,
        _DynamicPQIDescriptor_packetDelayBudget,
        _DynamicPQIDescriptor_packetErrorRate,
        _DynamicPQIDescriptor_averagingWindow,
        _DynamicPQIDescriptor_maxDataBurstVolume,
        ____DynamicPQIDescriptor_iE_Extensions__item__id_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__id,
        ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__criticality,
        ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue,
        __DynamicPQIDescriptor_iE_Extensions__item_,
        _DynamicPQIDescriptor_iE_Extensions,
        DynamicPQIDescriptor,
        DynamicPQIDescriptor_ExtIEs,
        ___E_CID_MeasurementQuantities__item__id_tab,
        ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0,
        __E_CID_MeasurementQuantities__item__id,
        __E_CID_MeasurementQuantities__item__criticality,
        __E_CID_MeasurementQuantities__item__value,
        _E_CID_MeasurementQuantities__item_,
        E_CID_MeasurementQuantities,
        E_CID_MeasurementQuantities_ItemIEs,
        _E_CID_MeasurementQuantities_ItemIEs_val_Value_0,
        _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementQuantities_Item_iE_Extensions__item_,
        _E_CID_MeasurementQuantities_Item_iE_Extensions,
        E_CID_MeasurementQuantities_Item,
        E_CID_MeasurementQuantitiesValue_ExtIEs,
        E_CID_MeasurementQuantitiesValue,
        _E_CID_MeasurementResult_geographicalCoordinates,
        _E_CID_MeasurementResult_measuredResults_List,
        ____E_CID_MeasurementResult_iE_Extensions__item__id_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__id,
        ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__criticality,
        ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementResult_iE_Extensions__item_,
        _E_CID_MeasurementResult_iE_Extensions,
        E_CID_MeasurementResult,
        E_CID_MeasurementResult_ExtIEs,
        _E_CID_MeasuredResults_List__item_,
        E_CID_MeasuredResults_List,
        _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__id,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue,
        __E_CID_MeasuredResults_Item_iE_Extensions__item_,
        _E_CID_MeasuredResults_Item_iE_Extensions,
        E_CID_MeasuredResults_Item,
        E_CID_MeasuredResults_Item_ExtIEs,
        _E_CID_MeasuredResults_Value_valueAngleofArrivalNR,
        ___E_CID_MeasuredResults_Value_choice_extension_id_tab,
        __E_CID_MeasuredResults_Value_choice_extension_id,
        ___E_CID_MeasuredResults_Value_choice_extension_criticality_tab,
        __E_CID_MeasuredResults_Value_choice_extension_criticality,
        ___E_CID_MeasuredResults_Value_choice_extension_value_tab,
        __E_CID_MeasuredResults_Value_choice_extension_value,
        _E_CID_MeasuredResults_Value_choice_extension,
        E_CID_MeasuredResults_Value,
        E_CID_MeasuredResults_Value_ExtIEs,
        E_CID_ReportCharacteristics,
        _EgressBHRLCCHList__item_,
        EgressBHRLCCHList,
        _EgressBHRLCCHItem_nextHopBAPAddress,
        _EgressBHRLCCHItem_bHRLCChannelID,
        ____EgressBHRLCCHItem_iE_Extensions__item__id_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__id,
        ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__criticality,
        ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue,
        __EgressBHRLCCHItem_iE_Extensions__item_,
        _EgressBHRLCCHItem_iE_Extensions,
        EgressBHRLCCHItem,
        EgressBHRLCCHItemExtIEs,
        _Endpoint_IP_address_and_port_endpointIPAddress,
        ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab,
        _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__id,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue,
        __Endpoint_IP_address_and_port_iE_Extensions__item_,
        _Endpoint_IP_address_and_port_iE_Extensions,
        Endpoint_IP_address_and_port,
        Endpoint_IP_address_and_port_ExtIEs,
        _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0,
        _ExtendedAvailablePLMN_List__item_,
        ExtendedAvailablePLMN_List,
        _ExtendedAvailablePLMN_Item_pLMNIdentity,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue,
        __ExtendedAvailablePLMN_Item_iE_Extensions__item_,
        _ExtendedAvailablePLMN_Item_iE_Extensions,
        ExtendedAvailablePLMN_Item,
        _ExplicitFormat_permutation,
        _ExplicitFormat_noofDownlinkSymbols,
        _ExplicitFormat_noofUplinkSymbols,
        ____ExplicitFormat_iE_Extensions__item__id_tab,
        ___ExplicitFormat_iE_Extensions__item__id,
        ____ExplicitFormat_iE_Extensions__item__criticality_tab,
        ___ExplicitFormat_iE_Extensions__item__criticality,
        ____ExplicitFormat_iE_Extensions__item__extensionValue_tab,
        ___ExplicitFormat_iE_Extensions__item__extensionValue,
        __ExplicitFormat_iE_Extensions__item_,
        _ExplicitFormat_iE_Extensions,
        ExplicitFormat,
        ExplicitFormat_ExtIEs,
        ExtendedAvailablePLMN_Item_ExtIEs,
        _ExtendedServedPLMNs_List__item_,
        ExtendedServedPLMNs_List,
        _ExtendedServedPLMNs_Item_pLMN_Identity,
        _ExtendedServedPLMNs_Item_tAISliceSupportList,
        ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab,
        _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__id,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue,
        __ExtendedServedPLMNs_Item_iE_Extensions__item_,
        _ExtendedServedPLMNs_Item_iE_Extensions,
        ExtendedServedPLMNs_Item,
        ExtendedServedPLMNs_ItemExtIEs,
        _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0,
        _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1,
        _ExtendedSliceSupportList__item_,
        ExtendedSliceSupportList,
        _EUTRACells_List__item_,
        EUTRACells_List,
        _EUTRACells_List_item_eUTRA_Cell_ID,
        _EUTRACells_List_item_served_EUTRA_Cells_Information,
        ____EUTRACells_List_item_iE_Extensions__item__id_tab,
        ___EUTRACells_List_item_iE_Extensions__item__id,
        ____EUTRACells_List_item_iE_Extensions__item__criticality_tab,
        ___EUTRACells_List_item_iE_Extensions__item__criticality,
        ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab,
        ___EUTRACells_List_item_iE_Extensions__item__extensionValue,
        __EUTRACells_List_item_iE_Extensions__item_,
        _EUTRACells_List_item_iE_Extensions,
        EUTRACells_List_item,
        EUTRACells_List_itemExtIEs,
        EUTRA_Cell_ID,
        _EUTRA_Coex_FDD_Info_uL_EARFCN,
        _EUTRA_Coex_FDD_Info_dL_EARFCN,
        _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth,
        _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_Coex_FDD_Info_iE_Extensions__item_,
        _EUTRA_Coex_FDD_Info_iE_Extensions,
        EUTRA_Coex_FDD_Info,
        EUTRA_Coex_FDD_Info_ExtIEs,
        _EUTRA_Coex_Mode_Info_fDD,
        _EUTRA_Coex_Mode_Info_tDD,
        EUTRA_Coex_Mode_Info,
        _EUTRA_Coex_TDD_Info_eARFCN,
        _EUTRA_Coex_TDD_Info_transmission_Bandwidth,
        _EUTRA_Coex_TDD_Info_subframeAssignment,
        _EUTRA_Coex_TDD_Info_specialSubframe_Info,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_Coex_TDD_Info_iE_Extensions__item_,
        _EUTRA_Coex_TDD_Info_iE_Extensions,
        EUTRA_Coex_TDD_Info,
        EUTRA_Coex_TDD_Info_ExtIEs,
        EUTRA_CyclicPrefixDL,
        EUTRA_CyclicPrefixUL,
        _EUTRA_PRACH_Configuration_rootSequenceIndex,
        _EUTRA_PRACH_Configuration_zeroCorrelationIndex,
        _EUTRA_PRACH_Configuration_highSpeedFlag,
        _EUTRA_PRACH_Configuration_prach_FreqOffset,
        _EUTRA_PRACH_Configuration_prach_ConfigIndex,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__id,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue,
        __EUTRA_PRACH_Configuration_iE_Extensions__item_,
        _EUTRA_PRACH_Configuration_iE_Extensions,
        EUTRA_PRACH_Configuration,
        EUTRA_PRACH_Configuration_ExtIEs,
        _EUTRA_SpecialSubframe_Info_specialSubframePatterns,
        _EUTRA_SpecialSubframe_Info_cyclicPrefixDL,
        _EUTRA_SpecialSubframe_Info_cyclicPrefixUL,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __EUTRA_SpecialSubframe_Info_iE_Extensions__item_,
        _EUTRA_SpecialSubframe_Info_iE_Extensions,
        EUTRA_SpecialSubframe_Info,
        EUTRA_SpecialSubframe_Info_ExtIEs,
        EUTRA_SpecialSubframePatterns,
        EUTRA_SubframeAssignment,
        EUTRA_Transmission_Bandwidth,
        _EUTRANQoS_qCI,
        _EUTRANQoS_allocationAndRetentionPriority,
        _EUTRANQoS_gbrQosInformation,
        ____EUTRANQoS_iE_Extensions__item__id_tab,
        _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0,
        ___EUTRANQoS_iE_Extensions__item__id,
        ___EUTRANQoS_iE_Extensions__item__criticality,
        ___EUTRANQoS_iE_Extensions__item__extensionValue,
        __EUTRANQoS_iE_Extensions__item_,
        _EUTRANQoS_iE_Extensions,
        EUTRANQoS,
        EUTRANQoS_ExtIEs,
        _EUTRANQoS_ExtIEs_val_Extension_0,
        ExecuteDuplication,
        ExtendedEARFCN,
        _EUTRA_Mode_Info_eUTRAFDD,
        _EUTRA_Mode_Info_eUTRATDD,
        ___EUTRA_Mode_Info_choice_extension_id_tab,
        __EUTRA_Mode_Info_choice_extension_id,
        ___EUTRA_Mode_Info_choice_extension_criticality_tab,
        __EUTRA_Mode_Info_choice_extension_criticality,
        ___EUTRA_Mode_Info_choice_extension_value_tab,
        __EUTRA_Mode_Info_choice_extension_value,
        _EUTRA_Mode_Info_choice_extension,
        EUTRA_Mode_Info,
        EUTRA_Mode_Info_ExtIEs,
        EUTRA_NR_CellResourceCoordinationReq_Container,
        EUTRA_NR_CellResourceCoordinationReqAck_Container,
        _EUTRA_FDD_Info_uL_offsetToPointA,
        _EUTRA_FDD_Info_dL_offsetToPointA,
        ____EUTRA_FDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__id,
        ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_FDD_Info_iE_Extensions__item_,
        _EUTRA_FDD_Info_iE_Extensions,
        EUTRA_FDD_Info,
        EUTRA_FDD_Info_ExtIEs,
        _EUTRA_TDD_Info_offsetToPointA,
        ____EUTRA_TDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__id,
        ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_TDD_Info_iE_Extensions__item_,
        _EUTRA_TDD_Info_iE_Extensions,
        EUTRA_TDD_Info,
        EUTRA_TDD_Info_ExtIEs,
        EventType,
        ExtendedPacketDelayBudget,
        F1CPathNSA,
        _F1CTransferPath_f1CPathNSA,
        ____F1CTransferPath_iE_Extensions__item__id_tab,
        ___F1CTransferPath_iE_Extensions__item__id,
        ____F1CTransferPath_iE_Extensions__item__criticality_tab,
        ___F1CTransferPath_iE_Extensions__item__criticality,
        ____F1CTransferPath_iE_Extensions__item__extensionValue_tab,
        ___F1CTransferPath_iE_Extensions__item__extensionValue,
        __F1CTransferPath_iE_Extensions__item_,
        _F1CTransferPath_iE_Extensions,
        F1CTransferPath,
        F1CTransferPath_ExtIEs,
        _FDD_Info_uL_NRFreqInfo,
        _FDD_Info_dL_NRFreqInfo,
        _FDD_Info_uL_Transmission_Bandwidth,
        _FDD_Info_dL_Transmission_Bandwidth,
        ____FDD_Info_iE_Extensions__item__id_tab,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___FDD_Info_iE_Extensions__item__id,
        ___FDD_Info_iE_Extensions__item__criticality,
        ___FDD_Info_iE_Extensions__item__extensionValue,
        __FDD_Info_iE_Extensions__item_,
        _FDD_Info_iE_Extensions,
        FDD_Info,
        FDD_Info_ExtIEs,
        _FDD_Info_ExtIEs_val_Extension_0,
        _FDD_Info_ExtIEs_val_Extension_1,
        _Flows_Mapped_To_DRB_List__item_,
        Flows_Mapped_To_DRB_List,
        _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier,
        _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters,
        ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab,
        _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue,
        __Flows_Mapped_To_DRB_Item_iE_Extensions__item_,
        _Flows_Mapped_To_DRB_Item_iE_Extensions,
        Flows_Mapped_To_DRB_Item,
        Flows_Mapped_To_DRB_ItemExtIEs,
        _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0,
        _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1,
        FR1_Bandwidth,
        FR2_Bandwidth,
        _FreqBandNrItem_freqBandIndicatorNr,
        __FreqBandNrItem_supportedSULBandList__item_,
        _FreqBandNrItem_supportedSULBandList,
        ____FreqBandNrItem_iE_Extensions__item__id_tab,
        ___FreqBandNrItem_iE_Extensions__item__id,
        ____FreqBandNrItem_iE_Extensions__item__criticality_tab,
        ___FreqBandNrItem_iE_Extensions__item__criticality,
        ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab,
        ___FreqBandNrItem_iE_Extensions__item__extensionValue,
        __FreqBandNrItem_iE_Extensions__item_,
        _FreqBandNrItem_iE_Extensions,
        FreqBandNrItem,
        FreqBandNrItem_ExtIEs,
        _FreqDomainLength_l839,
        _FreqDomainLength_l139,
        ___FreqDomainLength_choice_extension_id_tab,
        __FreqDomainLength_choice_extension_id,
        ___FreqDomainLength_choice_extension_criticality_tab,
        __FreqDomainLength_choice_extension_criticality,
        ___FreqDomainLength_choice_extension_value_tab,
        __FreqDomainLength_choice_extension_value,
        _FreqDomainLength_choice_extension,
        FreqDomainLength,
        FreqDomainLength_ExtIEs,
        FrequencyShift7p5khz,
        FullConfiguration,
        _FlowsMappedToSLDRB_List__item_,
        FlowsMappedToSLDRB_List,
        _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue,
        __FlowsMappedToSLDRB_Item_iE_Extensions__item_,
        _FlowsMappedToSLDRB_Item_iE_Extensions,
        FlowsMappedToSLDRB_Item,
        FlowsMappedToSLDRB_Item_ExtIEs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ____GBR_QosInformation_iE_Extensions__item__criticality_tab,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QoSFlowInformation_maxFlowBitRateDownlink,
        _GBR_QoSFlowInformation_maxFlowBitRateUplink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink,
        _GBR_QoSFlowInformation_maxPacketLossRateDownlink,
        _GBR_QoSFlowInformation_maxPacketLossRateUplink,
        ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab,
        _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GBR_QoSFlowInformation_iE_Extensions__item__id,
        ___GBR_QoSFlowInformation_iE_Extensions__item__criticality,
        ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue,
        __GBR_QoSFlowInformation_iE_Extensions__item_,
        _GBR_QoSFlowInformation_iE_Extensions,
        GBR_QoSFlowInformation,
        GBR_QosFlowInformation_ExtIEs,
        _GBR_QosFlowInformation_ExtIEs_val_Extension_0,
        CG_Config,
        _GeographicalCoordinates_tRPPositionDefinitionType,
        _GeographicalCoordinates_dLPRSResourceCoordinates,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        GNBCUMeasurementID,
        GNBDUMeasurementID,
        __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_,
        _GNB_CUSystemInformation_sibtypetobeupdatedlist,
        ____GNB_CUSystemInformation_iE_Extensions__item__id_tab,
        _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GNB_CUSystemInformation_iE_Extensions__item__id,
        ___GNB_CUSystemInformation_iE_Extensions__item__criticality,
        ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue,
        __GNB_CUSystemInformation_iE_Extensions__item_,
        _GNB_CUSystemInformation_iE_Extensions,
        GNB_CUSystemInformation,
        GNB_CUSystemInformation_ExtIEs,
        _GNB_CUSystemInformation_ExtIEs_val_Extension_0,
        _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_Setup_Item_iE_Extensions,
        GNB_CU_TNL_Association_Setup_Item,
        GNB_CU_TNL_Association_Setup_Item_ExtIEs,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions,
        GNB_CU_TNL_Association_Failed_To_Setup_Item,
        GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Add_Item,
        GNB_CU_TNL_Association_To_Add_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab,
        _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Remove_Item,
        GNB_CU_TNL_Association_To_Remove_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0,
        _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Update_Item,
        GNB_CU_TNL_Association_To_Update_Item_ExtIEs,
        GNB_CU_UE_F1AP_ID,
        _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing,
        _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity,
        _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List,
        _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity,
        _GNB_DU_Cell_Resource_Configuration_hNSASlotConfigList,
        ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id,
        ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality_tab,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality,
        ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue_tab,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue,
        __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_,
        _GNB_DU_Cell_Resource_Configuration_iE_Extensions,
        GNB_DU_Cell_Resource_Configuration,
        GNB_DU_Cell_Resource_Configuration_ExtIEs,
        GNB_DU_UE_F1AP_ID,
        GNB_DU_ID,
        GNB_CU_Name,
        GNB_DU_Name,
        _Extended_GNB_CU_Name_gNB_CU_NameVisibleString,
        _Extended_GNB_CU_Name_gNB_CU_NameUTF8String,
        ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__id,
        ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_CU_Name_iE_Extensions__item_,
        _Extended_GNB_CU_Name_iE_Extensions,
        Extended_GNB_CU_Name,
        Extended_GNB_CU_Name_ExtIEs,
        GNB_CU_NameVisibleString,
        GNB_CU_NameUTF8String,
        _Extended_GNB_DU_Name_gNB_DU_NameVisibleString,
        _Extended_GNB_DU_Name_gNB_DU_NameUTF8String,
        ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__id,
        ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_DU_Name_iE_Extensions__item_,
        _Extended_GNB_DU_Name_iE_Extensions,
        Extended_GNB_DU_Name,
        Extended_GNB_DU_Name_ExtIEs,
        GNB_DU_NameVisibleString,
        GNB_DU_NameUTF8String,
        _GNB_DU_Served_Cells_Item_served_Cell_Information,
        _GNB_DU_Served_Cells_Item_gNB_DU_System_Information,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue,
        __GNB_DU_Served_Cells_Item_iE_Extensions__item_,
        _GNB_DU_Served_Cells_Item_iE_Extensions,
        GNB_DU_Served_Cells_Item,
        GNB_DU_Served_Cells_ItemExtIEs,
        _GNB_DU_System_Information_mIB_message,
        _GNB_DU_System_Information_sIB1_message,
        ____GNB_DU_System_Information_iE_Extensions__item__id_tab,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3,
        ___GNB_DU_System_Information_iE_Extensions__item__id,
        ___GNB_DU_System_Information_iE_Extensions__item__criticality,
        ___GNB_DU_System_Information_iE_Extensions__item__extensionValue,
        __GNB_DU_System_Information_iE_Extensions__item_,
        _GNB_DU_System_Information_iE_Extensions,
        GNB_DU_System_Information,
        GNB_DU_System_Information_ExtIEs,
        _GNB_DU_System_Information_ExtIEs_val_Extension_0,
        _GNB_DU_System_Information_ExtIEs_val_Extension_1,
        _GNB_DU_System_Information_ExtIEs_val_Extension_2,
        _GNB_DU_System_Information_ExtIEs_val_Extension_3,
        GNB_DUConfigurationQuery,
        GNBDUOverloadInformation,
        _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress,
        _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_,
        _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions,
        GNB_DU_TNL_Association_To_Remove_Item,
        GNB_DU_TNL_Association_To_Remove_Item_ExtIEs,
        _GNB_RxTxTimeDiff_rxTxTimeDiff,
        _GNB_RxTxTimeDiff_additionalPath_List,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__id,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue,
        __GNB_RxTxTimeDiff_iE_Extensions__item_,
        _GNB_RxTxTimeDiff_iE_Extensions,
        GNB_RxTxTimeDiff,
        GNB_RxTxTimeDiff_ExtIEs,
        _GNBRxTxTimeDiffMeas_k0,
        _GNBRxTxTimeDiffMeas_k1,
        _GNBRxTxTimeDiffMeas_k2,
        _GNBRxTxTimeDiffMeas_k3,
        _GNBRxTxTimeDiffMeas_k4,
        _GNBRxTxTimeDiffMeas_k5,
        ___GNBRxTxTimeDiffMeas_choice_extension_id_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_id,
        ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_criticality,
        ___GNBRxTxTimeDiffMeas_choice_extension_value_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_value,
        _GNBRxTxTimeDiffMeas_choice_extension,
        GNBRxTxTimeDiffMeas,
        GNBRxTxTimeDiffMeas_ExtIEs,
        GNBSetID,
        GTP_TEID,
        _GTPTLAs__item_,
        GTPTLAs,
        _GTPTLA_Item_gTPTransportLayerAddress,
        ____GTPTLA_Item_iE_Extensions__item__id_tab,
        ___GTPTLA_Item_iE_Extensions__item__id,
        ____GTPTLA_Item_iE_Extensions__item__criticality_tab,
        ___GTPTLA_Item_iE_Extensions__item__criticality,
        ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab,
        ___GTPTLA_Item_iE_Extensions__item__extensionValue,
        __GTPTLA_Item_iE_Extensions__item_,
        _GTPTLA_Item_iE_Extensions,
        GTPTLA_Item,
        GTPTLA_Item_ExtIEs,
        _GTPTunnel_transportLayerAddress,
        _GTPTunnel_gTP_TEID,
        ____GTPTunnel_iE_Extensions__item__id_tab,
        ___GTPTunnel_iE_Extensions__item__id,
        ____GTPTunnel_iE_Extensions__item__criticality_tab,
        ___GTPTunnel_iE_Extensions__item__criticality,
        ____GTPTunnel_iE_Extensions__item__extensionValue_tab,
        ___GTPTunnel_iE_Extensions__item__extensionValue,
        __GTPTunnel_iE_Extensions__item_,
        _GTPTunnel_iE_Extensions,
        GTPTunnel,
        GTPTunnel_ExtIEs,
        HandoverPreparationInformation,
        _HardwareLoadIndicator_dLHardwareLoadIndicator,
        _HardwareLoadIndicator_uLHardwareLoadIndicator,
        ____HardwareLoadIndicator_iE_Extensions__item__id_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__id,
        ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__criticality,
        ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__extensionValue,
        __HardwareLoadIndicator_iE_Extensions__item_,
        _HardwareLoadIndicator_iE_Extensions,
        HardwareLoadIndicator,
        HardwareLoadIndicator_ExtIEs,
        _HSNASlotConfigList__item_,
        HSNASlotConfigList,
        _HSNASlotConfigItem_hSNADownlink,
        _HSNASlotConfigItem_hSNAUplink,
        _HSNASlotConfigItem_hSNAFlexible,
        ____HSNASlotConfigItem_iE_Extensions__item__id_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__id,
        ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__criticality,
        ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__extensionValue,
        __HSNASlotConfigItem_iE_Extensions__item_,
        _HSNASlotConfigItem_iE_Extensions,
        HSNASlotConfigItem,
        HSNASlotConfigItem_ExtIEs,
        HSNADownlink,
        HSNAFlexible,
        HSNAUplink,
        HSNATransmissionPeriodicity,
        IAB_Barred,
        _IAB_Info_IAB_donor_CU_iAB_STC_Info,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue,
        __IAB_Info_IAB_donor_CU_iE_Extensions__item_,
        _IAB_Info_IAB_donor_CU_iE_Extensions,
        IAB_Info_IAB_donor_CU,
        IAB_Info_IAB_donor_CU_ExtIEs,
        _IAB_Info_IAB_DU_multiplexingInfo,
        _IAB_Info_IAB_DU_iAB_STC_Info,
        ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__id,
        ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__criticality,
        ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue,
        __IAB_Info_IAB_DU_iE_Extensions__item_,
        _IAB_Info_IAB_DU_iE_Extensions,
        IAB_Info_IAB_DU,
        IAB_Info_IAB_DU_ExtIEs,
        _IAB_MT_Cell_List__item_,
        IAB_MT_Cell_List,
        _IAB_MT_Cell_List_Item_nRCellIdentity,
        _IAB_MT_Cell_List_Item_dU_RX_MT_RX,
        _IAB_MT_Cell_List_Item_dU_TX_MT_TX,
        _IAB_MT_Cell_List_Item_dU_RX_MT_TX,
        _IAB_MT_Cell_List_Item_dU_TX_MT_RX,
        ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__id,
        ____IAB_MT_Cell_List_Item_iE_Extensions__item__criticality_tab,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality,
        ____IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue,
        __IAB_MT_Cell_List_Item_iE_Extensions__item_,
        _IAB_MT_Cell_List_Item_iE_Extensions,
        IAB_MT_Cell_List_Item,
        IAB_MT_Cell_List_Item_ExtIEs,
        _IAB_STC_Info_iAB_STC_Info_List,
        ____IAB_STC_Info_iE_Extensions__item__id_tab,
        ___IAB_STC_Info_iE_Extensions__item__id,
        ____IAB_STC_Info_iE_Extensions__item__criticality_tab,
        ___IAB_STC_Info_iE_Extensions__item__criticality,
        ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_STC_Info_iE_Extensions__item__extensionValue,
        __IAB_STC_Info_iE_Extensions__item_,
        _IAB_STC_Info_iE_Extensions,
        IAB_STC_Info,
        IAB_STC_Info_ExtIEs,
        _IAB_STC_Info_List__item_,
        IAB_STC_Info_List,
        _IAB_STC_Info_Item_sSB_freqInfo,
        _IAB_STC_Info_Item_sSB_subcarrierSpacing,
        _IAB_STC_Info_Item_sSB_transmissionPeriodicity,
        _IAB_STC_Info_Item_sSB_transmissionTimingOffset,
        _IAB_STC_Info_Item_sSB_transmissionBitmap,
        ____IAB_STC_Info_Item_iE_Extensions__item__id_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__id,
        ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__criticality,
        ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue,
        __IAB_STC_Info_Item_iE_Extensions__item_,
        _IAB_STC_Info_Item_iE_Extensions,
        IAB_STC_Info_Item,
        IAB_STC_Info_Item_ExtIEs,
        _IAB_Allocated_TNL_Address_Item_iABTNLAddress,
        _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue,
        __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_,
        _IAB_Allocated_TNL_Address_Item_iE_Extensions,
        IAB_Allocated_TNL_Address_Item,
        IAB_Allocated_TNL_Address_Item_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension,
        IAB_DU_Cell_Resource_Configuration_Mode_Info,
        IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL,
        ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id,
        ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality,
        ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue,
        __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions,
        IAB_DU_Cell_Resource_Configuration_FDD_Info,
        IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD,
        ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id,
        ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality,
        ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue,
        __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions,
        IAB_DU_Cell_Resource_Configuration_TDD_Info,
        IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs,
        _IABIPv6RequestType_iPv6Address,
        _IABIPv6RequestType_iPv6Prefix,
        ___IABIPv6RequestType_choice_extension_id_tab,
        __IABIPv6RequestType_choice_extension_id,
        ___IABIPv6RequestType_choice_extension_criticality_tab,
        __IABIPv6RequestType_choice_extension_criticality,
        ___IABIPv6RequestType_choice_extension_value_tab,
        __IABIPv6RequestType_choice_extension_value,
        _IABIPv6RequestType_choice_extension,
        IABIPv6RequestType,
        IABIPv6RequestType_ExtIEs,
        _IABTNLAddress_iPv4Address,
        _IABTNLAddress_iPv6Address,
        _IABTNLAddress_iPv6Prefix,
        ___IABTNLAddress_choice_extension_id_tab,
        __IABTNLAddress_choice_extension_id,
        ___IABTNLAddress_choice_extension_criticality_tab,
        __IABTNLAddress_choice_extension_criticality,
        ___IABTNLAddress_choice_extension_value_tab,
        __IABTNLAddress_choice_extension_value,
        _IABTNLAddress_choice_extension,
        IABTNLAddress,
        IABTNLAddress_ExtIEs,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1,
        ____IABTNLAddressesRequested_iE_Extensions__item__id_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__id,
        ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__criticality,
        ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue,
        __IABTNLAddressesRequested_iE_Extensions__item_,
        _IABTNLAddressesRequested_iE_Extensions,
        IABTNLAddressesRequested,
        IABTNLAddressesRequested_ExtIEs,
        _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue,
        __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_,
        _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions,
        IAB_TNL_Addresses_To_Remove_Item,
        IAB_TNL_Addresses_To_Remove_Item_ExtIEs,
        IABTNLAddressUsage,
        _IABv4AddressesRequested_iABv4AddressesRequested,
        ____IABv4AddressesRequested_iE_Extensions__item__id_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__id,
        ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__criticality,
        ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__extensionValue,
        __IABv4AddressesRequested_iE_Extensions__item_,
        _IABv4AddressesRequested_iE_Extensions,
        IABv4AddressesRequested,
        IABv4AddressesRequested_ExtIEs,
        _ImplicitFormat_dUFSlotformatIndex,
        ____ImplicitFormat_iE_Extensions__item__id_tab,
        ___ImplicitFormat_iE_Extensions__item__id,
        ____ImplicitFormat_iE_Extensions__item__criticality_tab,
        ___ImplicitFormat_iE_Extensions__item__criticality,
        ____ImplicitFormat_iE_Extensions__item__extensionValue_tab,
        ___ImplicitFormat_iE_Extensions__item__extensionValue,
        __ImplicitFormat_iE_Extensions__item_,
        _ImplicitFormat_iE_Extensions,
        ImplicitFormat,
        ImplicitFormat_ExtIEs,
        IgnorePRACHConfiguration,
        IgnoreResourceCoordinationContainer,
        InactivityMonitoringRequest,
        InactivityMonitoringResponse,
        InterfacesToTrace,
        _IntendedTDD_DL_ULConfig_nRSCS,
        _IntendedTDD_DL_ULConfig_nRCP,
        _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity,
        _IntendedTDD_DL_ULConfig_slot_Configuration_List,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue,
        __IntendedTDD_DL_ULConfig_iE_Extensions__item_,
        _IntendedTDD_DL_ULConfig_iE_Extensions,
        IntendedTDD_DL_ULConfig,
        IntendedTDD_DL_ULConfig_ExtIEs,
        _IPHeaderInformation_destinationIABTNLAddress,
        _IPHeaderInformation_dsInformationList,
        _IPHeaderInformation_iPv6FlowLabel,
        ____IPHeaderInformation_iE_Extensions__item__id_tab,
        ___IPHeaderInformation_iE_Extensions__item__id,
        ____IPHeaderInformation_iE_Extensions__item__criticality_tab,
        ___IPHeaderInformation_iE_Extensions__item__criticality,
        ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab,
        ___IPHeaderInformation_iE_Extensions__item__extensionValue,
        __IPHeaderInformation_iE_Extensions__item_,
        _IPHeaderInformation_iE_Extensions,
        IPHeaderInformation,
        IPHeaderInformation_ItemExtIEs,
        _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd,
        _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue,
        __IPtolayer2TrafficMappingInfo_iE_Extensions__item_,
        _IPtolayer2TrafficMappingInfo_iE_Extensions,
        IPtolayer2TrafficMappingInfo,
        _IPtolayer2TrafficMappingInfoList__item_,
        IPtolayer2TrafficMappingInfoList,
        _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex,
        _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation,
        _IPtolayer2TrafficMappingInfo_Item_bHInfo,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue,
        __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_,
        _IPtolayer2TrafficMappingInfo_Item_iE_Extensions,
        IPtolayer2TrafficMappingInfo_Item,
        IPtolayer2TrafficMappingInfo_ItemExtIEs,
        _L139Info_msg1SCS,
        _L139Info_rootSequenceIndex,
        ____L139Info_iE_Extension__item__id_tab,
        ___L139Info_iE_Extension__item__id,
        ____L139Info_iE_Extension__item__criticality_tab,
        ___L139Info_iE_Extension__item__criticality,
        ____L139Info_iE_Extension__item__extensionValue_tab,
        ___L139Info_iE_Extension__item__extensionValue,
        __L139Info_iE_Extension__item_,
        _L139Info_iE_Extension,
        L139Info,
        L139Info_ExtIEs,
        _L839Info_rootSequenceIndex,
        _L839Info_restrictedSetConfig,
        ____L839Info_iE_Extension__item__id_tab,
        ___L839Info_iE_Extension__item__id,
        ____L839Info_iE_Extension__item__criticality_tab,
        ___L839Info_iE_Extension__item__criticality,
        ____L839Info_iE_Extension__item__extensionValue_tab,
        ___L839Info_iE_Extension__item__extensionValue,
        __L839Info_iE_Extension__item_,
        _L839Info_iE_Extension,
        L839Info,
        L839Info_ExtIEs,
        LCID,
        _LCS_to_GCS_TranslationAoA_alpha,
        _LCS_to_GCS_TranslationAoA_beta,
        _LCS_to_GCS_TranslationAoA_gamma,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_TranslationAoA_iE_Extensions__item_,
        _LCS_to_GCS_TranslationAoA_iE_Extensions,
        LCS_to_GCS_TranslationAoA,
        LCS_to_GCS_TranslationAoA_ExtIEs,
        _LCStoGCSTranslationList__item_,
        LCStoGCSTranslationList,
        _LCStoGCSTranslation_alpha,
        _LCStoGCSTranslation_alpha_fine,
        _LCStoGCSTranslation_beta,
        _LCStoGCSTranslation_beta_fine,
        _LCStoGCSTranslation_gamma,
        _LCStoGCSTranslation_gamma_fine,
        ____LCStoGCSTranslation_iE_Extensions__item__id_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__id,
        ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__criticality,
        ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__extensionValue,
        __LCStoGCSTranslation_iE_Extensions__item_,
        _LCStoGCSTranslation_iE_Extensions,
        LCStoGCSTranslation,
        LCStoGCSTranslation_ExtIEs,
        LMF_MeasurementID,
        LMF_UE_MeasurementID,
        LocationMeasurementInformation,
        _LocationUncertainty_horizontalUncertainty,
        _LocationUncertainty_horizontalConfidence,
        _LocationUncertainty_verticalUncertainty,
        _LocationUncertainty_verticalConfidence,
        ____LocationUncertainty_iE_Extensions__item__id_tab,
        ___LocationUncertainty_iE_Extensions__item__id,
        ____LocationUncertainty_iE_Extensions__item__criticality_tab,
        ___LocationUncertainty_iE_Extensions__item__criticality,
        ____LocationUncertainty_iE_Extensions__item__extensionValue_tab,
        ___LocationUncertainty_iE_Extensions__item__extensionValue,
        __LocationUncertainty_iE_Extensions__item_,
        _LocationUncertainty_iE_Extensions,
        LocationUncertainty,
        LocationUncertainty_ExtIEs,
        LongDRXCycleLength,
        LowerLayerPresenceStatusChange,
        _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions,
        LTEUESidelinkAggregateMaximumBitrate,
        LTEUESidelinkAggregateMaximumBitrate_ExtIEs,
        _LTEV2XServicesAuthorized_vehicleUE,
        _LTEV2XServicesAuthorized_pedestrianUE,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__id,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __LTEV2XServicesAuthorized_iE_Extensions__item_,
        _LTEV2XServicesAuthorized_iE_Extensions,
        LTEV2XServicesAuthorized,
        LTEV2XServicesAuthorized_ExtIEs,
        MappingInformationIndex,
        _MappingInformationtoRemove__item_,
        MappingInformationtoRemove,
        MaskedIMEISV,
        MaxDataBurstVolume,
        MaxPacketLossRate,
        MIB_message,
        MeasConfig,
        MeasGapConfig,
        MeasGapSharingConfig,
        MeasurementBeamInfoRequest,
        _MeasurementBeamInfo_pRS_Resource_ID,
        _MeasurementBeamInfo_pRS_Resource_Set_ID,
        _MeasurementBeamInfo_sSB_Index,
        ____MeasurementBeamInfo_iE_Extensions__item__id_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__id,
        ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__criticality,
        ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__extensionValue,
        __MeasurementBeamInfo_iE_Extensions__item_,
        _MeasurementBeamInfo_iE_Extensions,
        MeasurementBeamInfo,
        MeasurementBeamInfo_ExtIEs,
        MeasurementTimingConfiguration,
        MessageIdentifier,
        _MultiplexingInfo_iAB_MT_Cell_List,
        ____MultiplexingInfo_iE_Extensions__item__id_tab,
        ___MultiplexingInfo_iE_Extensions__item__id,
        ____MultiplexingInfo_iE_Extensions__item__criticality_tab,
        ___MultiplexingInfo_iE_Extensions__item__criticality,
        ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab,
        ___MultiplexingInfo_iE_Extensions__item__extensionValue,
        __MultiplexingInfo_iE_Extensions__item_,
        _MultiplexingInfo_iE_Extensions,
        MultiplexingInfo,
        MultiplexingInfo_ExtIEs,
        M2Configuration,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ____M5Configuration_iE_Extensions__item__criticality_tab,
        ___M5Configuration_iE_Extensions__item__criticality,
        ____M5Configuration_iE_Extensions__item__extensionValue_tab,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        M5_Links_to_log,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ____M6Configuration_iE_Extensions__item__criticality_tab,
        ___M6Configuration_iE_Extensions__item__criticality,
        ____M6Configuration_iE_Extensions__item__extensionValue_tab,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_Interval,
        M6_Links_to_log,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ____M7Configuration_iE_Extensions__item__criticality_tab,
        ___M7Configuration_iE_Extensions__item__criticality,
        ____M7Configuration_iE_Extensions__item__extensionValue_tab,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        M7_Links_to_log,
        MDT_Activation,
        _MDTConfiguration_mdt_Activation,
        _MDTConfiguration_measurementsToActivate,
        _MDTConfiguration_m2Configuration,
        _MDTConfiguration_m5Configuration,
        _MDTConfiguration_m6Configuration,
        _MDTConfiguration_m7Configuration,
        ____MDTConfiguration_iE_Extensions__item__id_tab,
        ___MDTConfiguration_iE_Extensions__item__id,
        ____MDTConfiguration_iE_Extensions__item__criticality_tab,
        ___MDTConfiguration_iE_Extensions__item__criticality,
        ____MDTConfiguration_iE_Extensions__item__extensionValue_tab,
        ___MDTConfiguration_iE_Extensions__item__extensionValue,
        __MDTConfiguration_iE_Extensions__item_,
        _MDTConfiguration_iE_Extensions,
        MDTConfiguration,
        MDTConfiguration_ExtIEs,
        _MDTPLMNList__item_,
        MDTPLMNList,
        _MeasuredResultsValue_uL_AngleOfArrival,
        _MeasuredResultsValue_uL_SRS_RSRP,
        _MeasuredResultsValue_uL_RTOA,
        _MeasuredResultsValue_gNB_RxTxTimeDiff,
        ___MeasuredResultsValue_choice_extension_id_tab,
        __MeasuredResultsValue_choice_extension_id,
        ___MeasuredResultsValue_choice_extension_criticality_tab,
        __MeasuredResultsValue_choice_extension_criticality,
        ___MeasuredResultsValue_choice_extension_value_tab,
        __MeasuredResultsValue_choice_extension_value,
        _MeasuredResultsValue_choice_extension,
        MeasuredResultsValue,
        MeasuredResultsValue_ExtIEs,
        MeasurementsToActivate,
        NeedforGap,
        _Neighbour_Cell_Information_Item_nRCGI,
        _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__id,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue,
        __Neighbour_Cell_Information_Item_iE_Extensions__item_,
        _Neighbour_Cell_Information_Item_iE_Extensions,
        Neighbour_Cell_Information_Item,
        Neighbour_Cell_Information_ItemExtIEs,
        _NGRANAllocationAndRetentionPriority_priorityLevel,
        _NGRANAllocationAndRetentionPriority_pre_emptionCapability,
        _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __NGRANAllocationAndRetentionPriority_iE_Extensions__item_,
        _NGRANAllocationAndRetentionPriority_iE_Extensions,
        NGRANAllocationAndRetentionPriority,
        NGRANAllocationAndRetentionPriority_ExtIEs,
        _NGRANHighAccuracyAccessPointPosition_latitude,
        _NGRANHighAccuracyAccessPointPosition_longitude,
        _NGRANHighAccuracyAccessPointPosition_altitude,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor,
        _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis,
        _NGRANHighAccuracyAccessPointPosition_horizontalConfidence,
        _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude,
        _NGRANHighAccuracyAccessPointPosition_verticalConfidence,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue,
        __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_,
        _NGRANHighAccuracyAccessPointPosition_iE_Extensions,
        NGRANHighAccuracyAccessPointPosition,
        NGRANHighAccuracyAccessPointPosition_ExtIEs,
        NID,
        _NR_CGI_List_For_Restart_Item_nRCGI,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue,
        __NR_CGI_List_For_Restart_Item_iE_Extensions__item_,
        _NR_CGI_List_For_Restart_Item_iE_Extensions,
        NR_CGI_List_For_Restart_Item,
        NR_CGI_List_For_Restart_ItemExtIEs,
        _NR_PRSBeamInformation_nR_PRSBeamInformationList,
        _NR_PRSBeamInformation_lCStoGCSTranslationList,
        ____NR_PRSBeamInformation_iE_Extensions__item__id_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__id,
        ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__criticality,
        ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue,
        __NR_PRSBeamInformation_iE_Extensions__item_,
        _NR_PRSBeamInformation_iE_Extensions,
        NR_PRSBeamInformation,
        NR_PRSBeamInformation_ExtIEs,
        _NR_PRSBeamInformationList__item_,
        NR_PRSBeamInformationList,
        _NR_PRSBeamInformationItem_pRSResourceSetID,
        _NR_PRSBeamInformationItem_pRSAngleList,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__id,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue,
        __NR_PRSBeamInformationItem_iE_Extensions__item_,
        _NR_PRSBeamInformationItem_iE_Extensions,
        NR_PRSBeamInformationItem,
        NR_PRSBeamInformationItem_ExtIEs,
        _NonDynamic5QIDescriptor_fiveQI,
        _NonDynamic5QIDescriptor_qoSPriorityLevel,
        _NonDynamic5QIDescriptor_averagingWindow,
        _NonDynamic5QIDescriptor_maxDataBurstVolume,
        ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__id,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamic5QIDescriptor_iE_Extensions__item_,
        _NonDynamic5QIDescriptor_iE_Extensions,
        NonDynamic5QIDescriptor,
        NonDynamic5QIDescriptor_ExtIEs,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _NonDynamicPQIDescriptor_fiveQI,
        _NonDynamicPQIDescriptor_qoSPriorityLevel,
        _NonDynamicPQIDescriptor_averagingWindow,
        _NonDynamicPQIDescriptor_maxDataBurstVolume,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__id,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamicPQIDescriptor_iE_Extensions__item_,
        _NonDynamicPQIDescriptor_iE_Extensions,
        NonDynamicPQIDescriptor,
        NonDynamicPQIDescriptor_ExtIEs,
        NonUPTrafficType,
        NoofDownlinkSymbols,
        NoofUplinkSymbols,
        Notification_Cause,
        NotificationControl,
        _NotificationInformation_message_Identifier,
        _NotificationInformation_serialNumber,
        ____NotificationInformation_iE_Extensions__item__id_tab,
        ___NotificationInformation_iE_Extensions__item__id,
        ____NotificationInformation_iE_Extensions__item__criticality_tab,
        ___NotificationInformation_iE_Extensions__item__criticality,
        ____NotificationInformation_iE_Extensions__item__extensionValue_tab,
        ___NotificationInformation_iE_Extensions__item__extensionValue,
        __NotificationInformation_iE_Extensions__item_,
        _NotificationInformation_iE_Extensions,
        NotificationInformation,
        NotificationInformationExtIEs,
        _NPNBroadcastInformation_sNPN_Broadcast_Information,
        _NPNBroadcastInformation_pNI_NPN_Broadcast_Information,
        ___NPNBroadcastInformation_choice_extension_id_tab,
        __NPNBroadcastInformation_choice_extension_id,
        ___NPNBroadcastInformation_choice_extension_criticality_tab,
        __NPNBroadcastInformation_choice_extension_criticality,
        ___NPNBroadcastInformation_choice_extension_value_tab,
        __NPNBroadcastInformation_choice_extension_value,
        _NPNBroadcastInformation_choice_extension,
        NPNBroadcastInformation,
        NPNBroadcastInformation_ExtIEs,
        _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue,
        __NPN_Broadcast_Information_SNPN_iE_Extension__item_,
        _NPN_Broadcast_Information_SNPN_iE_Extension,
        NPN_Broadcast_Information_SNPN,
        NPN_Broadcast_Information_SNPN_ExtIEs,
        _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue,
        __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_,
        _NPN_Broadcast_Information_PNI_NPN_iE_Extension,
        NPN_Broadcast_Information_PNI_NPN,
        NPN_Broadcast_Information_PNI_NPN_ExtIEs,
        _NPNSupportInfo_sNPN_Information,
        ___NPNSupportInfo_choice_extension_id_tab,
        __NPNSupportInfo_choice_extension_id,
        ___NPNSupportInfo_choice_extension_criticality_tab,
        __NPNSupportInfo_choice_extension_criticality,
        ___NPNSupportInfo_choice_extension_value_tab,
        __NPNSupportInfo_choice_extension_value,
        _NPNSupportInfo_choice_extension,
        NPNSupportInfo,
        NPNSupportInfo_ExtIEs,
        _NRCarrierList__item_,
        NRCarrierList,
        _NRCarrierItem_carrierSCS,
        _NRCarrierItem_offsetToCarrier,
        _NRCarrierItem_carrierBandwidth,
        ____NRCarrierItem_iE_Extension__item__id_tab,
        ___NRCarrierItem_iE_Extension__item__id,
        ____NRCarrierItem_iE_Extension__item__criticality_tab,
        ___NRCarrierItem_iE_Extension__item__criticality,
        ____NRCarrierItem_iE_Extension__item__extensionValue_tab,
        ___NRCarrierItem_iE_Extension__item__extensionValue,
        __NRCarrierItem_iE_Extension__item_,
        _NRCarrierItem_iE_Extension,
        NRCarrierItem,
        NRCarrierItem_ExtIEs,
        _NRFreqInfo_nRARFCN,
        _NRFreqInfo_sul_Information,
        __NRFreqInfo_freqBandListNr__item_,
        _NRFreqInfo_freqBandListNr,
        ____NRFreqInfo_iE_Extensions__item__id_tab,
        _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___NRFreqInfo_iE_Extensions__item__id,
        ___NRFreqInfo_iE_Extensions__item__criticality,
        ___NRFreqInfo_iE_Extensions__item__extensionValue,
        __NRFreqInfo_iE_Extensions__item_,
        _NRFreqInfo_iE_Extensions,
        NRFreqInfo,
        NRFreqInfoExtIEs,
        _NRFreqInfoExtIEs_val_Extension_0,
        _NRCGI_pLMN_Identity,
        _NRCGI_nRCellIdentity,
        ____NRCGI_iE_Extensions__item__id_tab,
        ___NRCGI_iE_Extensions__item__id,
        ____NRCGI_iE_Extensions__item__criticality_tab,
        ___NRCGI_iE_Extensions__item__criticality,
        ____NRCGI_iE_Extensions__item__extensionValue_tab,
        ___NRCGI_iE_Extensions__item__extensionValue,
        __NRCGI_iE_Extensions__item_,
        _NRCGI_iE_Extensions,
        NRCGI,
        NRCGI_ExtIEs,
        _NR_Mode_Info_fDD,
        _NR_Mode_Info_tDD,
        ___NR_Mode_Info_choice_extension_id_tab,
        __NR_Mode_Info_choice_extension_id,
        ___NR_Mode_Info_choice_extension_criticality_tab,
        __NR_Mode_Info_choice_extension_criticality,
        ___NR_Mode_Info_choice_extension_value_tab,
        __NR_Mode_Info_choice_extension_value,
        _NR_Mode_Info_choice_extension,
        NR_Mode_Info,
        NR_Mode_Info_ExtIEs,
        _NRPRACHConfig_ulPRACHConfigList,
        _NRPRACHConfig_sulPRACHConfigList,
        ____NRPRACHConfig_iE_Extension__item__id_tab,
        ___NRPRACHConfig_iE_Extension__item__id,
        ____NRPRACHConfig_iE_Extension__item__criticality_tab,
        ___NRPRACHConfig_iE_Extension__item__criticality,
        ____NRPRACHConfig_iE_Extension__item__extensionValue_tab,
        ___NRPRACHConfig_iE_Extension__item__extensionValue,
        __NRPRACHConfig_iE_Extension__item_,
        _NRPRACHConfig_iE_Extension,
        NRPRACHConfig,
        NRPRACHConfig_ExtIEs,
        NRCellIdentity,
        NRNRB,
        NRPCI,
        _NRPRACHConfigList__item_,
        NRPRACHConfigList,
        _NRPRACHConfigItem_nRSCS,
        _NRPRACHConfigItem_prachFreqStartfromCarrier,
        _NRPRACHConfigItem_msg1FDM,
        _NRPRACHConfigItem_parchConfigIndex,
        _NRPRACHConfigItem_ssb_perRACH_Occasion,
        _NRPRACHConfigItem_freqDomainLength,
        _NRPRACHConfigItem_zeroCorrelZoneConfig,
        ____NRPRACHConfigItem_iE_Extension__item__id_tab,
        ___NRPRACHConfigItem_iE_Extension__item__id,
        ____NRPRACHConfigItem_iE_Extension__item__criticality_tab,
        ___NRPRACHConfigItem_iE_Extension__item__criticality,
        ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab,
        ___NRPRACHConfigItem_iE_Extension__item__extensionValue,
        __NRPRACHConfigItem_iE_Extension__item_,
        _NRPRACHConfigItem_iE_Extension,
        NRPRACHConfigItem,
        NRPRACHConfigItem_ExtIEs,
        NRSCS,
        NRUERLFReportContainer,
        NumberofActiveUEs,
        NumberOfBroadcasts,
        NumberofBroadcastRequest,
        _NumDLULSymbols_numDLSymbols,
        _NumDLULSymbols_numULSymbols,
        ____NumDLULSymbols_iE_Extensions__item__id_tab,
        ___NumDLULSymbols_iE_Extensions__item__id,
        ____NumDLULSymbols_iE_Extensions__item__criticality_tab,
        ___NumDLULSymbols_iE_Extensions__item__criticality,
        ____NumDLULSymbols_iE_Extensions__item__extensionValue_tab,
        ___NumDLULSymbols_iE_Extensions__item__extensionValue,
        __NumDLULSymbols_iE_Extensions__item_,
        _NumDLULSymbols_iE_Extensions,
        NumDLULSymbols,
        NumDLULSymbols_ExtIEs,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        NZP_CSI_RS_ResourceID,
        OffsetToPointA,
        PacketDelayBudget,
        _PacketErrorRate_pER_Scalar,
        _PacketErrorRate_pER_Exponent,
        ____PacketErrorRate_iE_Extensions__item__id_tab,
        ___PacketErrorRate_iE_Extensions__item__id,
        ____PacketErrorRate_iE_Extensions__item__criticality_tab,
        ___PacketErrorRate_iE_Extensions__item__criticality,
        ____PacketErrorRate_iE_Extensions__item__extensionValue_tab,
        ___PacketErrorRate_iE_Extensions__item__extensionValue,
        __PacketErrorRate_iE_Extensions__item_,
        _PacketErrorRate_iE_Extensions,
        PacketErrorRate,
        PacketErrorRate_ExtIEs,
        PER_Scalar,
        PER_Exponent,
        _PagingCell_Item_nRCGI,
        ____PagingCell_Item_iE_Extensions__item__id_tab,
        ___PagingCell_Item_iE_Extensions__item__id,
        ____PagingCell_Item_iE_Extensions__item__criticality_tab,
        ___PagingCell_Item_iE_Extensions__item__criticality,
        ____PagingCell_Item_iE_Extensions__item__extensionValue_tab,
        ___PagingCell_Item_iE_Extensions__item__extensionValue,
        __PagingCell_Item_iE_Extensions__item_,
        _PagingCell_Item_iE_Extensions,
        PagingCell_Item,
        PagingCell_ItemExtIEs,
        PagingDRX,
        _PagingIdentity_rANUEPagingIdentity,
        _PagingIdentity_cNUEPagingIdentity,
        ___PagingIdentity_choice_extension_id_tab,
        __PagingIdentity_choice_extension_id,
        ___PagingIdentity_choice_extension_criticality_tab,
        __PagingIdentity_choice_extension_criticality,
        ___PagingIdentity_choice_extension_value_tab,
        __PagingIdentity_choice_extension_value,
        _PagingIdentity_choice_extension,
        PagingIdentity,
        PagingIdentity_ExtIEs,
        PagingOrigin,
        PagingPriority,
        _RelativePathDelay_k0,
        _RelativePathDelay_k1,
        _RelativePathDelay_k2,
        _RelativePathDelay_k3,
        _RelativePathDelay_k4,
        _RelativePathDelay_k5,
        ___RelativePathDelay_choice_extension_id_tab,
        __RelativePathDelay_choice_extension_id,
        ___RelativePathDelay_choice_extension_criticality_tab,
        __RelativePathDelay_choice_extension_criticality,
        ___RelativePathDelay_choice_extension_value_tab,
        __RelativePathDelay_choice_extension_value,
        _RelativePathDelay_choice_extension,
        RelativePathDelay,
        RelativePathDelay_ExtIEs,
        _PathlossReferenceInfo_pathlossReferenceSignal,
        ____PathlossReferenceInfo_iE_Extensions__item__id_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__id,
        ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__criticality,
        ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__extensionValue,
        __PathlossReferenceInfo_iE_Extensions__item_,
        _PathlossReferenceInfo_iE_Extensions,
        PathlossReferenceInfo,
        PathlossReferenceInfo_ExtIEs,
        _PathlossReferenceSignal_sSB,
        _PathlossReferenceSignal_dL_PRS,
        ___PathlossReferenceSignal_choice_extension_id_tab,
        __PathlossReferenceSignal_choice_extension_id,
        ___PathlossReferenceSignal_choice_extension_criticality_tab,
        __PathlossReferenceSignal_choice_extension_criticality,
        ___PathlossReferenceSignal_choice_extension_value_tab,
        __PathlossReferenceSignal_choice_extension_value,
        _PathlossReferenceSignal_choice_extension,
        PathlossReferenceSignal,
        PathlossReferenceSignal_ExtIEs,
        PC5QoSFlowIdentifier,
        _PC5_QoS_Characteristics_non_Dynamic_PQI,
        _PC5_QoS_Characteristics_dynamic_PQI,
        ___PC5_QoS_Characteristics_choice_extension_id_tab,
        __PC5_QoS_Characteristics_choice_extension_id,
        ___PC5_QoS_Characteristics_choice_extension_criticality_tab,
        __PC5_QoS_Characteristics_choice_extension_criticality,
        ___PC5_QoS_Characteristics_choice_extension_value_tab,
        __PC5_QoS_Characteristics_choice_extension_value,
        _PC5_QoS_Characteristics_choice_extension,
        PC5_QoS_Characteristics,
        PC5_QoS_Characteristics_ExtIEs,
        _PC5QoSParameters_pC5_QoS_Characteristics,
        _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        PDCCH_BlindDetectionSCG,
        PDCP_SN,
        PDCPSNLength,
        PDUSessionID,
        ReportingPeriodicityValue,
        Periodicity,
        PeriodicitySRS,
        _PeriodicityList__item_,
        PeriodicityList,
        _PeriodicityList_Item_periodicitySRS,
        ____PeriodicityList_Item_iE_Extensions__item__id_tab,
        ___PeriodicityList_Item_iE_Extensions__item__id,
        ____PeriodicityList_Item_iE_Extensions__item__criticality_tab,
        ___PeriodicityList_Item_iE_Extensions__item__criticality,
        ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab,
        ___PeriodicityList_Item_iE_Extensions__item__extensionValue,
        __PeriodicityList_Item_iE_Extensions__item_,
        _PeriodicityList_Item_iE_Extensions,
        PeriodicityList_Item,
        PeriodicityList_ItemExtIEs,
        Permutation,
        Ph_InfoMCG,
        Ph_InfoSCG,
        PLMN_Identity,
        PortNumber,
        PosAssistance_Information,
        PosAssistanceInformationFailureList,
        PosBroadcast,
        _PositioningBroadcastCells__item_,
        PositioningBroadcastCells,
        MeasurementPeriodicity,
        MeasurementPeriodicityExtended,
        _PosMeasurementQuantities__item_,
        PosMeasurementQuantities,
        _PosMeasurementQuantities_Item_posMeasurementType,
        _PosMeasurementQuantities_Item_timingReportingGranularityFactor,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__id,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __PosMeasurementQuantities_Item_iE_Extensions__item_,
        _PosMeasurementQuantities_Item_iE_Extensions,
        PosMeasurementQuantities_Item,
        PosMeasurementQuantities_ItemExtIEs,
        _PosMeasurementResult__item_,
        PosMeasurementResult,
        _PosMeasurementResultItem_measuredResultsValue,
        _PosMeasurementResultItem_timeStamp,
        _PosMeasurementResultItem_measurementQuality,
        _PosMeasurementResultItem_measurementBeamInfo,
        ____PosMeasurementResultItem_iE_Extensions__item__id_tab,
        ___PosMeasurementResultItem_iE_Extensions__item__id,
        ____PosMeasurementResultItem_iE_Extensions__item__criticality_tab,
        ___PosMeasurementResultItem_iE_Extensions__item__criticality,
        ____PosMeasurementResultItem_iE_Extensions__item__extensionValue_tab,
        ___PosMeasurementResultItem_iE_Extensions__item__extensionValue,
        __PosMeasurementResultItem_iE_Extensions__item_,
        _PosMeasurementResultItem_iE_Extensions,
        PosMeasurementResultItem,
        PosMeasurementResultItemExtIEs,
        _PosMeasurementResultList__item_,
        PosMeasurementResultList,
        _PosMeasurementResultList_Item_posMeasurementResult,
        _PosMeasurementResultList_Item_tRPID,
        ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab,
        _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PosMeasurementResultList_Item_iE_Extensions__item__id,
        ___PosMeasurementResultList_Item_iE_Extensions__item__criticality,
        ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue,
        __PosMeasurementResultList_Item_iE_Extensions__item_,
        _PosMeasurementResultList_Item_iE_Extensions,
        PosMeasurementResultList_Item,
        PosMeasurementResultList_ItemExtIEs,
        _PosMeasurementResultList_ItemExtIEs_val_Extension_0,
        PosMeasurementType,
        PosReportCharacteristics,
        _PosResourceSetType_periodic,
        _PosResourceSetType_semi_persistent,
        _PosResourceSetType_aperiodic,
        ___PosResourceSetType_choice_extension_id_tab,
        __PosResourceSetType_choice_extension_id,
        ___PosResourceSetType_choice_extension_criticality_tab,
        __PosResourceSetType_choice_extension_criticality,
        ___PosResourceSetType_choice_extension_value_tab,
        __PosResourceSetType_choice_extension_value,
        _PosResourceSetType_choice_extension,
        PosResourceSetType,
        PosResourceSetType_ExtIEs,
        _PosResourceSetTypePR_posperiodicSet,
        ____PosResourceSetTypePR_iE_Extensions__item__id_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__id,
        ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__criticality,
        ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__extensionValue,
        __PosResourceSetTypePR_iE_Extensions__item_,
        _PosResourceSetTypePR_iE_Extensions,
        PosResourceSetTypePR,
        PosResourceSetTypePR_ExtIEs,
        _PosResourceSetTypeSP_possemi_persistentSet,
        ____PosResourceSetTypeSP_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__id,
        ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__criticality,
        ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeSP_iE_Extensions__item_,
        _PosResourceSetTypeSP_iE_Extensions,
        PosResourceSetTypeSP,
        PosResourceSetTypeSP_ExtIEs,
        _PosResourceSetTypeAP_sRSResourceTrigger_List,
        ____PosResourceSetTypeAP_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__id,
        ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__criticality,
        ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeAP_iE_Extensions__item_,
        _PosResourceSetTypeAP_iE_Extensions,
        PosResourceSetTypeAP,
        PosResourceSetTypeAP_ExtIEs,
        _PosSRSResourceID_List__item_,
        PosSRSResourceID_List,
        _PosSRSResource_Item_srs_PosResourceId,
        _PosSRSResource_Item_transmissionCombPos,
        _PosSRSResource_Item_startPosition,
        _PosSRSResource_Item_nrofSymbols,
        _PosSRSResource_Item_freqDomainShift,
        _PosSRSResource_Item_c_SRS,
        _PosSRSResource_Item_groupOrSequenceHopping,
        _PosSRSResource_Item_resourceTypePos,
        _PosSRSResource_Item_sequenceId,
        _PosSRSResource_Item_spatialRelationPos,
        ____PosSRSResource_Item_iE_Extensions__item__id_tab,
        ___PosSRSResource_Item_iE_Extensions__item__id,
        ____PosSRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResource_Item_iE_Extensions__item__criticality,
        ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResource_Item_iE_Extensions__item__extensionValue,
        __PosSRSResource_Item_iE_Extensions__item_,
        _PosSRSResource_Item_iE_Extensions,
        PosSRSResource_Item,
        PosSRSResource_Item_ExtIEs,
        _PosSRSResource_List__item_,
        PosSRSResource_List,
        _PosSRSResourceSet_Item_possrsResourceSetID,
        _PosSRSResourceSet_Item_possRSResourceID_List,
        _PosSRSResourceSet_Item_posresourceSetType,
        ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__id,
        ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PosSRSResourceSet_Item_iE_Extensions__item_,
        _PosSRSResourceSet_Item_iE_Extensions,
        PosSRSResourceSet_Item,
        PosSRSResourceSet_Item_ExtIEs,
        _PosSRSResourceSet_List__item_,
        PosSRSResourceSet_List,
        PrimaryPathIndication,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        ProtectedEUTRAResourceIndication,
        _Protected_EUTRA_Resources_Item_spectrumSharingGroupID,
        _Protected_EUTRA_Resources_Item_eUTRACells_List,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue,
        __Protected_EUTRA_Resources_Item_iE_Extensions__item_,
        _Protected_EUTRA_Resources_Item_iE_Extensions,
        Protected_EUTRA_Resources_Item,
        Protected_EUTRA_Resources_ItemExtIEs,
        _PRSConfiguration_pRSResourceSet_List,
        ____PRSConfiguration_iE_Extensions__item__id_tab,
        ___PRSConfiguration_iE_Extensions__item__id,
        ____PRSConfiguration_iE_Extensions__item__criticality_tab,
        ___PRSConfiguration_iE_Extensions__item__criticality,
        ____PRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___PRSConfiguration_iE_Extensions__item__extensionValue,
        __PRSConfiguration_iE_Extensions__item_,
        _PRSConfiguration_iE_Extensions,
        PRSConfiguration,
        PRSConfiguration_ExtIEs,
        _PRSInformationPos_pRS_IDPos,
        _PRSInformationPos_pRS_Resource_Set_IDPos,
        _PRSInformationPos_pRS_Resource_IDPos,
        ____PRSInformationPos_iE_Extensions__item__id_tab,
        ___PRSInformationPos_iE_Extensions__item__id,
        ____PRSInformationPos_iE_Extensions__item__criticality_tab,
        ___PRSInformationPos_iE_Extensions__item__criticality,
        ____PRSInformationPos_iE_Extensions__item__extensionValue_tab,
        ___PRSInformationPos_iE_Extensions__item__extensionValue,
        __PRSInformationPos_iE_Extensions__item_,
        _PRSInformationPos_iE_Extensions,
        PRSInformationPos,
        PRSInformationPos_ExtIEs,
        _Potential_SpCell_Item_potential_SpCell_ID,
        ____Potential_SpCell_Item_iE_Extensions__item__id_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__id,
        ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__criticality,
        ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__extensionValue,
        __Potential_SpCell_Item_iE_Extensions__item_,
        _Potential_SpCell_Item_iE_Extensions,
        Potential_SpCell_Item,
        Potential_SpCell_ItemExtIEs,
        _PRSAngleList__item_,
        PRSAngleList,
        _PRSAngleItem_nR_PRS_Azimuth,
        _PRSAngleItem_nR_PRS_Azimuth_fine,
        _PRSAngleItem_nR_PRS_Elevation,
        _PRSAngleItem_nR_PRS_Elevation_fine,
        ____PRSAngleItem_iE_Extensions__item__id_tab,
        _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRSAngleItem_iE_Extensions__item__id,
        ___PRSAngleItem_iE_Extensions__item__criticality,
        ___PRSAngleItem_iE_Extensions__item__extensionValue,
        __PRSAngleItem_iE_Extensions__item_,
        _PRSAngleItem_iE_Extensions,
        PRSAngleItem,
        PRSAngleItem_ItemExtIEs,
        _PRSAngleItem_ItemExtIEs_val_Extension_0,
        _PRSMuting_pRSMutingOption1,
        _PRSMuting_pRSMutingOption2,
        ____PRSMuting_iE_Extensions__item__id_tab,
        ___PRSMuting_iE_Extensions__item__id,
        ____PRSMuting_iE_Extensions__item__criticality_tab,
        ___PRSMuting_iE_Extensions__item__criticality,
        ____PRSMuting_iE_Extensions__item__extensionValue_tab,
        ___PRSMuting_iE_Extensions__item__extensionValue,
        __PRSMuting_iE_Extensions__item_,
        _PRSMuting_iE_Extensions,
        PRSMuting,
        PRSMuting_ExtIEs,
        _PRSMutingOption1_mutingPattern,
        _PRSMutingOption1_mutingBitRepetitionFactor,
        ____PRSMutingOption1_iE_Extensions__item__id_tab,
        ___PRSMutingOption1_iE_Extensions__item__id,
        ____PRSMutingOption1_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption1_iE_Extensions__item__criticality,
        ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption1_iE_Extensions__item__extensionValue,
        __PRSMutingOption1_iE_Extensions__item_,
        _PRSMutingOption1_iE_Extensions,
        PRSMutingOption1,
        PRSMutingOption1_ExtIEs,
        _PRSMutingOption2_mutingPattern,
        ____PRSMutingOption2_iE_Extensions__item__id_tab,
        ___PRSMutingOption2_iE_Extensions__item__id,
        ____PRSMutingOption2_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption2_iE_Extensions__item__criticality,
        ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption2_iE_Extensions__item__extensionValue,
        __PRSMutingOption2_iE_Extensions__item_,
        _PRSMutingOption2_iE_Extensions,
        PRSMutingOption2,
        PRSMutingOption2_ExtIEs,
        PRS_Resource_ID,
        _PRSResource_List__item_,
        PRSResource_List,
        _PRSResource_Item_pRSResourceID,
        _PRSResource_Item_sequenceID,
        _PRSResource_Item_rEOffset,
        _PRSResource_Item_resourceSlotOffset,
        _PRSResource_Item_resourceSymbolOffset,
        _PRSResource_Item_qCLInfo,
        ____PRSResource_Item_iE_Extensions__item__id_tab,
        ___PRSResource_Item_iE_Extensions__item__id,
        ____PRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSResource_Item_iE_Extensions__item__criticality,
        ____PRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_Item_iE_Extensions__item__extensionValue,
        __PRSResource_Item_iE_Extensions__item_,
        _PRSResource_Item_iE_Extensions,
        PRSResource_Item,
        PRSResource_Item_ExtIEs,
        _PRSResource_QCLInfo_qCLSourceSSB,
        _PRSResource_QCLInfo_qCLSourcePRS,
        ___PRSResource_QCLInfo_choice_extension_id_tab,
        __PRSResource_QCLInfo_choice_extension_id,
        ___PRSResource_QCLInfo_choice_extension_criticality_tab,
        __PRSResource_QCLInfo_choice_extension_criticality,
        ___PRSResource_QCLInfo_choice_extension_value_tab,
        __PRSResource_QCLInfo_choice_extension_value,
        _PRSResource_QCLInfo_choice_extension,
        PRSResource_QCLInfo,
        PRSResource_QCLInfo_ExtIEs,
        _PRSResource_QCLSourceSSB_pCI_NR,
        _PRSResource_QCLSourceSSB_sSB_Index,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__id,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourceSSB_iE_Extensions__item_,
        _PRSResource_QCLSourceSSB_iE_Extensions,
        PRSResource_QCLSourceSSB,
        PRSResource_QCLSourceSSB_ExtIEs,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__id,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourcePRS_iE_Extensions__item_,
        _PRSResource_QCLSourcePRS_iE_Extensions,
        PRSResource_QCLSourcePRS,
        PRSResource_QCLSourcePRS_ExtIEs,
        PRS_Resource_Set_ID,
        _PRSResourceSet_List__item_,
        PRSResourceSet_List,
        _PRSResourceSet_Item_pRSResourceSetID,
        _PRSResourceSet_Item_subcarrierSpacing,
        _PRSResourceSet_Item_pRSbandwidth,
        _PRSResourceSet_Item_startPRB,
        _PRSResourceSet_Item_pointA,
        _PRSResourceSet_Item_combSize,
        _PRSResourceSet_Item_cPType,
        _PRSResourceSet_Item_resourceSetPeriodicity,
        _PRSResourceSet_Item_resourceSetSlotOffset,
        _PRSResourceSet_Item_resourceRepetitionFactor,
        _PRSResourceSet_Item_resourceTimeGap,
        _PRSResourceSet_Item_resourceNumberofSymbols,
        _PRSResourceSet_Item_pRSMuting,
        _PRSResourceSet_Item_pRSResourceTransmitPower,
        _PRSResourceSet_Item_pRSResource_List,
        ____PRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__id,
        ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSResourceSet_Item_iE_Extensions__item_,
        _PRSResourceSet_Item_iE_Extensions,
        PRSResourceSet_Item,
        PRSResourceSet_Item_ExtIEs,
        _PWS_Failed_NR_CGI_Item_nRCGI,
        _PWS_Failed_NR_CGI_Item_numberOfBroadcasts,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue,
        __PWS_Failed_NR_CGI_Item_iE_Extensions__item_,
        _PWS_Failed_NR_CGI_Item_iE_Extensions,
        PWS_Failed_NR_CGI_Item,
        PWS_Failed_NR_CGI_ItemExtIEs,
        _PWSSystemInformation_sIBtype,
        _PWSSystemInformation_sIBmessage,
        ____PWSSystemInformation_iE_Extensions__item__id_tab,
        _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___PWSSystemInformation_iE_Extensions__item__id,
        ___PWSSystemInformation_iE_Extensions__item__criticality,
        ___PWSSystemInformation_iE_Extensions__item__extensionValue,
        __PWSSystemInformation_iE_Extensions__item_,
        _PWSSystemInformation_iE_Extensions,
        PWSSystemInformation,
        PWSSystemInformationExtIEs,
        _PWSSystemInformationExtIEs_val_Extension_0,
        _PWSSystemInformationExtIEs_val_Extension_1,
        PrivacyIndicator,
        QCI,
        _QoS_Characteristics_non_Dynamic_5QI,
        _QoS_Characteristics_dynamic_5QI,
        ___QoS_Characteristics_choice_extension_id_tab,
        __QoS_Characteristics_choice_extension_id,
        ___QoS_Characteristics_choice_extension_criticality_tab,
        __QoS_Characteristics_choice_extension_criticality,
        ___QoS_Characteristics_choice_extension_value_tab,
        __QoS_Characteristics_choice_extension_value,
        _QoS_Characteristics_choice_extension,
        QoS_Characteristics,
        QoS_Characteristics_ExtIEs,
        QoSFlowIdentifier,
        _QoSFlowLevelQoSParameters_qoS_Characteristics,
        _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority,
        _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information,
        _QoSFlowLevelQoSParameters_reflective_QoS_Attribute,
        ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__id,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue,
        __QoSFlowLevelQoSParameters_iE_Extensions__item_,
        _QoSFlowLevelQoSParameters_iE_Extensions,
        QoSFlowLevelQoSParameters,
        QoSFlowLevelQoSParameters_ExtIEs,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3,
        QoSFlowMappingIndication,
        _QoSInformation_eUTRANQoS,
        ___QoSInformation_choice_extension_id_tab,
        ____QoSInformation_choice_extension_id_tab_val_Value_0,
        __QoSInformation_choice_extension_id,
        __QoSInformation_choice_extension_criticality,
        __QoSInformation_choice_extension_value,
        _QoSInformation_choice_extension,
        QoSInformation,
        QoSInformation_ExtIEs,
        _QoSInformation_ExtIEs_val_Value_0,
        QosMonitoringRequest,
        QoSParaSetIndex,
        QoSParaSetNotifyIndex,
        RACH_Config_Common,
        RACH_Config_Common_IAB,
        RACHReportContainer,
        _RACHReportInformationList__item_,
        RACHReportInformationList,
        _RACHReportInformationItem_rACHReportContainer,
        _RACHReportInformationItem_uEAssitantIdentifier,
        ____RACHReportInformationItem_iE_Extensions__item__id_tab,
        ___RACHReportInformationItem_iE_Extensions__item__id,
        ____RACHReportInformationItem_iE_Extensions__item__criticality_tab,
        ___RACHReportInformationItem_iE_Extensions__item__criticality,
        ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab,
        ___RACHReportInformationItem_iE_Extensions__item__extensionValue,
        __RACHReportInformationItem_iE_Extensions__item_,
        _RACHReportInformationItem_iE_Extensions,
        RACHReportInformationItem,
        RACHReportInformationItem_ExtIEs,
        _RadioResourceStatus_sSBAreaRadioResourceStatusList,
        ____RadioResourceStatus_iE_Extensions__item__id_tab,
        ___RadioResourceStatus_iE_Extensions__item__id,
        ____RadioResourceStatus_iE_Extensions__item__criticality_tab,
        ___RadioResourceStatus_iE_Extensions__item__criticality,
        ____RadioResourceStatus_iE_Extensions__item__extensionValue_tab,
        ___RadioResourceStatus_iE_Extensions__item__extensionValue,
        __RadioResourceStatus_iE_Extensions__item_,
        _RadioResourceStatus_iE_Extensions,
        RadioResourceStatus,
        RadioResourceStatus_ExtIEs,
        RANAC,
        RAN_MeasurementID,
        RAN_UE_MeasurementID,
        RANUEID,
        _RANUEPagingIdentity_iRNTI,
        ____RANUEPagingIdentity_iE_Extensions__item__id_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__id,
        ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__criticality,
        ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__extensionValue,
        __RANUEPagingIdentity_iE_Extensions__item_,
        _RANUEPagingIdentity_iE_Extensions,
        RANUEPagingIdentity,
        RANUEPagingIdentity_ExtIEs,
        _RAT_FrequencyPriorityInformation_eNDC,
        _RAT_FrequencyPriorityInformation_nGRAN,
        ___RAT_FrequencyPriorityInformation_choice_extension_id_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_id,
        ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_criticality,
        ___RAT_FrequencyPriorityInformation_choice_extension_value_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_value,
        _RAT_FrequencyPriorityInformation_choice_extension,
        RAT_FrequencyPriorityInformation,
        RAT_FrequencyPriorityInformation_ExtIEs,
        RAT_FrequencySelectionPriority,
        Reestablishment_Indication,
        _ReferencePoint_coordinateID,
        _ReferencePoint_referencePointCoordinate,
        _ReferencePoint_referencePointCoordinateHA,
        ___ReferencePoint_choice_Extension_id_tab,
        __ReferencePoint_choice_Extension_id,
        ___ReferencePoint_choice_Extension_criticality_tab,
        __ReferencePoint_choice_Extension_criticality,
        ___ReferencePoint_choice_Extension_value_tab,
        __ReferencePoint_choice_Extension_value,
        _ReferencePoint_choice_Extension,
        ReferencePoint,
        ReferencePoint_ExtIEs,
        ReferenceSFN,
        _ReferenceSignal_nZP_CSI_RS,
        _ReferenceSignal_sSB,
        _ReferenceSignal_sRS,
        _ReferenceSignal_positioningSRS,
        _ReferenceSignal_dL_PRS,
        ___ReferenceSignal_choice_extension_id_tab,
        __ReferenceSignal_choice_extension_id,
        ___ReferenceSignal_choice_extension_criticality_tab,
        __ReferenceSignal_choice_extension_criticality,
        ___ReferenceSignal_choice_extension_value_tab,
        __ReferenceSignal_choice_extension_value,
        _ReferenceSignal_choice_extension,
        ReferenceSignal,
        ReferenceSignal_ExtIEs,
        _RelativeCartesianLocation_xYZunit,
        _RelativeCartesianLocation_xvalue,
        _RelativeCartesianLocation_yvalue,
        _RelativeCartesianLocation_zvalue,
        _RelativeCartesianLocation_locationUncertainty,
        ____RelativeCartesianLocation_iE_Extensions__item__id_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__id,
        ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__criticality,
        ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__extensionValue,
        __RelativeCartesianLocation_iE_Extensions__item_,
        _RelativeCartesianLocation_iE_Extensions,
        RelativeCartesianLocation,
        RelativeCartesianLocation_ExtIEs,
        _RelativeGeodeticLocation_milli_Arc_SecondUnits,
        _RelativeGeodeticLocation_heightUnits,
        _RelativeGeodeticLocation_deltaLatitude,
        _RelativeGeodeticLocation_deltaLongitude,
        _RelativeGeodeticLocation_deltaHeight,
        _RelativeGeodeticLocation_locationUncertainty,
        ____RelativeGeodeticLocation_iE_extensions__item__id_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__id,
        ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__criticality,
        ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__extensionValue,
        __RelativeGeodeticLocation_iE_extensions__item_,
        _RelativeGeodeticLocation_iE_extensions,
        RelativeGeodeticLocation,
        RelativeGeodeticLocation_ExtIEs,
        ReferenceTime,
        RegistrationRequest,
        ReportCharacteristics,
        ReportingPeriodicity,
        RequestedBandCombinationIndex,
        RequestedFeatureSetEntryIndex,
        RequestedP_MaxFR2,
        Requested_PDCCH_BlindDetectionSCG,
        _RequestedSRSTransmissionCharacteristics_numberOfTransmissions,
        _RequestedSRSTransmissionCharacteristics_resourceType,
        _RequestedSRSTransmissionCharacteristics_bandwidthSRS,
        _RequestedSRSTransmissionCharacteristics_sRSResourceSetList,
        _RequestedSRSTransmissionCharacteristics_sSBInformation,
        ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedSRSTransmissionCharacteristics_iE_Extensions,
        RequestedSRSTransmissionCharacteristics,
        RequestedSRSTransmissionCharacteristics_ExtIEs,
        _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0,
        RequestType,
        _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info,
        _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration,
        ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab,
        _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue,
        __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_,
        _ResourceCoordinationEUTRACellInfo_iE_Extensions,
        ResourceCoordinationEUTRACellInfo,
        ResourceCoordinationEUTRACellInfo_ExtIEs,
        _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0,
        _ResourceCoordinationTransferInformation_meNB_Cell_ID,
        _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__id,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue,
        __ResourceCoordinationTransferInformation_iE_Extensions__item_,
        _ResourceCoordinationTransferInformation_iE_Extensions,
        ResourceCoordinationTransferInformation,
        ResourceCoordinationTransferInformation_ExtIEs,
        ResourceCoordinationTransferContainer,
        _ResourceSetType_periodic,
        _ResourceSetType_semi_persistent,
        _ResourceSetType_aperiodic,
        ___ResourceSetType_choice_extension_id_tab,
        __ResourceSetType_choice_extension_id,
        ___ResourceSetType_choice_extension_criticality_tab,
        __ResourceSetType_choice_extension_criticality,
        ___ResourceSetType_choice_extension_value_tab,
        __ResourceSetType_choice_extension_value,
        _ResourceSetType_choice_extension,
        ResourceSetType,
        ResourceSetType_ExtIEs,
        _ResourceSetTypePeriodic_periodicSet,
        ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__id,
        ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypePeriodic_iE_Extensions__item_,
        _ResourceSetTypePeriodic_iE_Extensions,
        ResourceSetTypePeriodic,
        ResourceSetTypePeriodic_ExtIEs,
        _ResourceSetTypeSemi_persistent_semi_persistentSet,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _ResourceSetTypeSemi_persistent_iE_Extensions,
        ResourceSetTypeSemi_persistent,
        ResourceSetTypeSemi_persistent_ExtIEs,
        _ResourceSetTypeAperiodic_sRSResourceTrigger_List,
        _ResourceSetTypeAperiodic_slotoffset,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypeAperiodic_iE_Extensions__item_,
        _ResourceSetTypeAperiodic_iE_Extensions,
        ResourceSetTypeAperiodic,
        ResourceSetTypeAperiodic_ExtIEs,
        RepetitionPeriod,
        _ReportingRequestType_eventType,
        _ReportingRequestType_reportingPeriodicityValue,
        ____ReportingRequestType_iE_Extensions__item__id_tab,
        ___ReportingRequestType_iE_Extensions__item__id,
        ____ReportingRequestType_iE_Extensions__item__criticality_tab,
        ___ReportingRequestType_iE_Extensions__item__criticality,
        ____ReportingRequestType_iE_Extensions__item__extensionValue_tab,
        ___ReportingRequestType_iE_Extensions__item__extensionValue,
        __ReportingRequestType_iE_Extensions__item_,
        _ReportingRequestType_iE_Extensions,
        ReportingRequestType,
        ReportingRequestType_ExtIEs,
        _ResourceType_periodic,
        _ResourceType_semi_persistent,
        _ResourceType_aperiodic,
        ___ResourceType_choice_extension_id_tab,
        __ResourceType_choice_extension_id,
        ___ResourceType_choice_extension_criticality_tab,
        __ResourceType_choice_extension_criticality,
        ___ResourceType_choice_extension_value_tab,
        __ResourceType_choice_extension_value,
        _ResourceType_choice_extension,
        ResourceType,
        ResourceType_ExtIEs,
        _ResourceTypePeriodic_periodicity,
        _ResourceTypePeriodic_offset,
        ____ResourceTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__id,
        ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodic_iE_Extensions__item_,
        _ResourceTypePeriodic_iE_Extensions,
        ResourceTypePeriodic,
        ResourceTypePeriodic_ExtIEs,
        _ResourceTypeSemi_persistent_periodicity,
        _ResourceTypeSemi_persistent_offset,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistent_iE_Extensions__item_,
        _ResourceTypeSemi_persistent_iE_Extensions,
        ResourceTypeSemi_persistent,
        ResourceTypeSemi_persistent_ExtIEs,
        _ResourceTypeAperiodic_aperiodicResourceType,
        ____ResourceTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__id,
        ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodic_iE_Extensions__item_,
        _ResourceTypeAperiodic_iE_Extensions,
        ResourceTypeAperiodic,
        ResourceTypeAperiodic_ExtIEs,
        _ResourceTypePos_periodic,
        _ResourceTypePos_semi_persistent,
        _ResourceTypePos_aperiodic,
        ___ResourceTypePos_choice_extension_id_tab,
        __ResourceTypePos_choice_extension_id,
        ___ResourceTypePos_choice_extension_criticality_tab,
        __ResourceTypePos_choice_extension_criticality,
        ___ResourceTypePos_choice_extension_value_tab,
        __ResourceTypePos_choice_extension_value,
        _ResourceTypePos_choice_extension,
        ResourceTypePos,
        ResourceTypePos_ExtIEs,
        _ResourceTypePeriodicPos_periodicity,
        _ResourceTypePeriodicPos_offset,
        ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__id,
        ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__criticality,
        ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodicPos_iE_Extensions__item_,
        _ResourceTypePeriodicPos_iE_Extensions,
        ResourceTypePeriodicPos,
        ResourceTypePeriodicPos_ExtIEs,
        _ResourceTypeSemi_persistentPos_periodicity,
        _ResourceTypeSemi_persistentPos_offset,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistentPos_iE_Extensions__item_,
        _ResourceTypeSemi_persistentPos_iE_Extensions,
        ResourceTypeSemi_persistentPos,
        ResourceTypeSemi_persistentPos_ExtIEs,
        _ResourceTypeAperiodicPos_slotOffset,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__id,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodicPos_iE_Extensions__item_,
        _ResourceTypeAperiodicPos_iE_Extensions,
        ResourceTypeAperiodicPos,
        ResourceTypeAperiodicPos_ExtIEs,
        _RLCDuplicationInformation_rLCDuplicationStateList,
        _RLCDuplicationInformation_primaryPathIndication,
        ____RLCDuplicationInformation_iE_Extensions__item__id_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__id,
        ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__criticality,
        ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__extensionValue,
        __RLCDuplicationInformation_iE_Extensions__item_,
        _RLCDuplicationInformation_iE_Extensions,
        RLCDuplicationInformation,
        RLCDuplicationInformation_ExtIEs,
        _RLCDuplicationStateList__item_,
        RLCDuplicationStateList,
        _RLCDuplicationState_Item_duplicationState,
        ____RLCDuplicationState_Item_iE_Extensions__item__id_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__id,
        ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__criticality,
        ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue,
        __RLCDuplicationState_Item_iE_Extensions__item_,
        _RLCDuplicationState_Item_iE_Extensions,
        RLCDuplicationState_Item,
        RLCDuplicationState_Item_ExtIEs,
        _RLCFailureIndication_assocatedLCID,
        ____RLCFailureIndication_iE_Extensions__item__id_tab,
        ___RLCFailureIndication_iE_Extensions__item__id,
        ____RLCFailureIndication_iE_Extensions__item__criticality_tab,
        ___RLCFailureIndication_iE_Extensions__item__criticality,
        ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab,
        ___RLCFailureIndication_iE_Extensions__item__extensionValue,
        __RLCFailureIndication_iE_Extensions__item_,
        _RLCFailureIndication_iE_Extensions,
        RLCFailureIndication,
        RLCFailureIndication_ExtIEs,
        RLCMode,
        _RLC_Status_reestablishment_Indication,
        ____RLC_Status_iE_Extensions__item__id_tab,
        ___RLC_Status_iE_Extensions__item__id,
        ____RLC_Status_iE_Extensions__item__criticality_tab,
        ___RLC_Status_iE_Extensions__item__criticality,
        ____RLC_Status_iE_Extensions__item__extensionValue_tab,
        ___RLC_Status_iE_Extensions__item__extensionValue,
        __RLC_Status_iE_Extensions__item_,
        _RLC_Status_iE_Extensions,
        RLC_Status,
        RLC_Status_ExtIEs,
        _RLFReportInformationList__item_,
        RLFReportInformationList,
        _RLFReportInformationItem_nRUERLFReportContainer,
        _RLFReportInformationItem_uEAssitantIdentifier,
        ____RLFReportInformationItem_iE_Extensions__item__id_tab,
        ___RLFReportInformationItem_iE_Extensions__item__id,
        ____RLFReportInformationItem_iE_Extensions__item__criticality_tab,
        ___RLFReportInformationItem_iE_Extensions__item__criticality,
        ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab,
        ___RLFReportInformationItem_iE_Extensions__item__extensionValue,
        __RLFReportInformationItem_iE_Extensions__item_,
        _RLFReportInformationItem_iE_Extensions,
        RLFReportInformationItem,
        RLFReportInformationItem_ExtIEs,
        RIMRSDetectionStatus,
        RRCContainer,
        RRCContainer_RRCSetupComplete,
        _RRCDeliveryStatus_delivery_status,
        _RRCDeliveryStatus_triggering_message,
        ____RRCDeliveryStatus_iE_Extensions__item__id_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__id,
        ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__criticality,
        ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__extensionValue,
        __RRCDeliveryStatus_iE_Extensions__item_,
        _RRCDeliveryStatus_iE_Extensions,
        RRCDeliveryStatus,
        RRCDeliveryStatus_ExtIEs,
        RRCDeliveryStatusRequest,
        RRCReconfigurationCompleteIndicator,
        _RRC_Version_latest_RRC_Version,
        ____RRC_Version_iE_Extensions__item__id_tab,
        _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0,
        ___RRC_Version_iE_Extensions__item__id,
        ___RRC_Version_iE_Extensions__item__criticality,
        ___RRC_Version_iE_Extensions__item__extensionValue,
        __RRC_Version_iE_Extensions__item_,
        _RRC_Version_iE_Extensions,
        RRC_Version,
        RRC_Version_ExtIEs,
        _RRC_Version_ExtIEs_val_Extension_0,
        RoutingID,
        _SCell_FailedtoSetup_Item_sCell_ID,
        _SCell_FailedtoSetup_Item_cause,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__id,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue,
        __SCell_FailedtoSetup_Item_iE_Extensions__item_,
        _SCell_FailedtoSetup_Item_iE_Extensions,
        SCell_FailedtoSetup_Item,
        SCell_FailedtoSetup_ItemExtIEs,
        _SCell_FailedtoSetupMod_Item_sCell_ID,
        _SCell_FailedtoSetupMod_Item_cause,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue,
        __SCell_FailedtoSetupMod_Item_iE_Extensions__item_,
        _SCell_FailedtoSetupMod_Item_iE_Extensions,
        SCell_FailedtoSetupMod_Item,
        SCell_FailedtoSetupMod_ItemExtIEs,
        _SCell_ToBeRemoved_Item_sCell_ID,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__id,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeRemoved_Item_iE_Extensions__item_,
        _SCell_ToBeRemoved_Item_iE_Extensions,
        SCell_ToBeRemoved_Item,
        SCell_ToBeRemoved_ItemExtIEs,
        _SCell_ToBeSetup_Item_sCell_ID,
        _SCell_ToBeSetup_Item_sCellIndex,
        _SCell_ToBeSetup_Item_sCellULConfigured,
        ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__id,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeSetup_Item_iE_Extensions__item_,
        _SCell_ToBeSetup_Item_iE_Extensions,
        SCell_ToBeSetup_Item,
        SCell_ToBeSetup_ItemExtIEs,
        _SCell_ToBeSetup_ItemExtIEs_val_Extension_0,
        _SCell_ToBeSetupMod_Item_sCell_ID,
        _SCell_ToBeSetupMod_Item_sCellIndex,
        _SCell_ToBeSetupMod_Item_sCellULConfigured,
        ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeSetupMod_Item_iE_Extensions__item_,
        _SCell_ToBeSetupMod_Item_iE_Extensions,
        SCell_ToBeSetupMod_Item,
        SCell_ToBeSetupMod_ItemExtIEs,
        _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        SCellIndex,
        SCGIndicator,
        _SCS_SpecificCarrier_offsetToCarrier,
        _SCS_SpecificCarrier_subcarrierSpacing,
        _SCS_SpecificCarrier_carrierBandwidth,
        ____SCS_SpecificCarrier_iE_Extensions__item__id_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__id,
        ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__criticality,
        ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue,
        __SCS_SpecificCarrier_iE_Extensions__item_,
        _SCS_SpecificCarrier_iE_Extensions,
        SCS_SpecificCarrier,
        SCS_SpecificCarrier_ExtIEs,
        _Search_window_information_expectedPropagationDelay,
        _Search_window_information_delayUncertainty,
        ____Search_window_information_iE_Extensions__item__id_tab,
        ___Search_window_information_iE_Extensions__item__id,
        ____Search_window_information_iE_Extensions__item__criticality_tab,
        ___Search_window_information_iE_Extensions__item__criticality,
        ____Search_window_information_iE_Extensions__item__extensionValue_tab,
        ___Search_window_information_iE_Extensions__item__extensionValue,
        __Search_window_information_iE_Extensions__item_,
        _Search_window_information_iE_Extensions,
        Search_window_information,
        Search_window_information_ExtIEs,
        SerialNumber,
        SIBType_PWS,
        SelectedBandCombinationIndex,
        SelectedFeatureSetEntryIndex,
        CG_ConfigInfo,
        ServCellIndex,
        ServingCellMO,
        _Served_Cell_Information_nRCGI,
        _Served_Cell_Information_nRPCI,
        _Served_Cell_Information_fiveGS_TAC,
        _Served_Cell_Information_configured_EPS_TAC,
        _Served_Cell_Information_servedPLMNs,
        _Served_Cell_Information_nR_Mode_Info,
        _Served_Cell_Information_measurementTimingConfiguration,
        ____Served_Cell_Information_iE_Extensions__item__id_tab,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12,
        ___Served_Cell_Information_iE_Extensions__item__id,
        ___Served_Cell_Information_iE_Extensions__item__criticality,
        ___Served_Cell_Information_iE_Extensions__item__extensionValue,
        __Served_Cell_Information_iE_Extensions__item_,
        _Served_Cell_Information_iE_Extensions,
        Served_Cell_Information,
        Served_Cell_Information_ExtIEs,
        _Served_Cell_Information_ExtIEs_val_Extension_0,
        _Served_Cell_Information_ExtIEs_val_Extension_1,
        _Served_Cell_Information_ExtIEs_val_Extension_2,
        _Served_Cell_Information_ExtIEs_val_Extension_3,
        _Served_Cell_Information_ExtIEs_val_Extension_4,
        _Served_Cell_Information_ExtIEs_val_Extension_5,
        _Served_Cell_Information_ExtIEs_val_Extension_6,
        _Served_Cell_Information_ExtIEs_val_Extension_7,
        _Served_Cell_Information_ExtIEs_val_Extension_8,
        _Served_Cell_Information_ExtIEs_val_Extension_9,
        _Served_Cell_Information_ExtIEs_val_Extension_10,
        _Served_Cell_Information_ExtIEs_val_Extension_11,
        _Served_Cell_Information_ExtIEs_val_Extension_12,
        _SFN_Offset_sFN_Time_Offset,
        ____SFN_Offset_iE_Extensions__item__id_tab,
        ___SFN_Offset_iE_Extensions__item__id,
        ____SFN_Offset_iE_Extensions__item__criticality_tab,
        ___SFN_Offset_iE_Extensions__item__criticality,
        ____SFN_Offset_iE_Extensions__item__extensionValue_tab,
        ___SFN_Offset_iE_Extensions__item__extensionValue,
        __SFN_Offset_iE_Extensions__item_,
        _SFN_Offset_iE_Extensions,
        SFN_Offset,
        SFN_Offset_ExtIEs,
        _Served_Cells_To_Add_Item_served_Cell_Information,
        _Served_Cells_To_Add_Item_gNB_DU_System_Information,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Add_Item_iE_Extensions__item_,
        _Served_Cells_To_Add_Item_iE_Extensions,
        Served_Cells_To_Add_Item,
        Served_Cells_To_Add_ItemExtIEs,
        _Served_Cells_To_Delete_Item_oldNRCGI,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Delete_Item_iE_Extensions__item_,
        _Served_Cells_To_Delete_Item_iE_Extensions,
        Served_Cells_To_Delete_Item,
        Served_Cells_To_Delete_ItemExtIEs,
        _Served_Cells_To_Modify_Item_oldNRCGI,
        _Served_Cells_To_Modify_Item_served_Cell_Information,
        _Served_Cells_To_Modify_Item_gNB_DU_System_Information,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Modify_Item_iE_Extensions__item_,
        _Served_Cells_To_Modify_Item_iE_Extensions,
        Served_Cells_To_Modify_Item,
        Served_Cells_To_Modify_ItemExtIEs,
        _Served_EUTRA_Cells_Information_eUTRA_Mode_Info,
        _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__id,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue,
        __Served_EUTRA_Cells_Information_iE_Extensions__item_,
        _Served_EUTRA_Cells_Information_iE_Extensions,
        Served_EUTRA_Cells_Information,
        Served_EUTRA_Cell_Information_ExtIEs,
        Service_State,
        _Service_Status_service_state,
        _Service_Status_switchingOffOngoing,
        ____Service_Status_iE_Extensions__item__id_tab,
        ___Service_Status_iE_Extensions__item__id,
        ____Service_Status_iE_Extensions__item__criticality_tab,
        ___Service_Status_iE_Extensions__item__criticality,
        ____Service_Status_iE_Extensions__item__extensionValue_tab,
        ___Service_Status_iE_Extensions__item__extensionValue,
        __Service_Status_iE_Extensions__item_,
        _Service_Status_iE_Extensions,
        Service_Status,
        Service_Status_ExtIEs,
        RelativeTime1900,
        ShortDRXCycleLength,
        ShortDRXCycleTimer,
        SIB1_message,
        SIB10_message,
        SIB12_message,
        SIB13_message,
        SIB14_message,
        SItype,
        _SItype_List__item_,
        SItype_List,
        _SItype_Item_sItype,
        ____SItype_Item_iE_Extensions__item__id_tab,
        ___SItype_Item_iE_Extensions__item__id,
        ____SItype_Item_iE_Extensions__item__criticality_tab,
        ___SItype_Item_iE_Extensions__item__criticality,
        ____SItype_Item_iE_Extensions__item__extensionValue_tab,
        ___SItype_Item_iE_Extensions__item__extensionValue,
        __SItype_Item_iE_Extensions__item_,
        _SItype_Item_iE_Extensions,
        SItype_Item,
        SItype_ItemExtIEs,
        _SibtypetobeupdatedListItem_sIBtype,
        _SibtypetobeupdatedListItem_sIBmessage,
        _SibtypetobeupdatedListItem_valueTag,
        ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab,
        _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__id,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue,
        __SibtypetobeupdatedListItem_iE_Extensions__item_,
        _SibtypetobeupdatedListItem_iE_Extensions,
        SibtypetobeupdatedListItem,
        SibtypetobeupdatedListItem_ExtIEs,
        _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0,
        SLDRBID,
        _SLDRBInformation_sLDRB_QoS,
        _SLDRBInformation_flowsMappedToSLDRB_List,
        SLDRBInformation,
        _SLDRBs_FailedToBeModified_Item_sLDRBID,
        _SLDRBs_FailedToBeModified_Item_cause,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeModified_Item_iE_Extensions,
        SLDRBs_FailedToBeModified_Item,
        SLDRBs_FailedToBeModified_ItemExtIEs,
        _SLDRBs_FailedToBeSetup_Item_sLDRBID,
        _SLDRBs_FailedToBeSetup_Item_cause,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeSetup_Item_iE_Extensions,
        SLDRBs_FailedToBeSetup_Item,
        SLDRBs_FailedToBeSetup_ItemExtIEs,
        _SLDRBs_FailedToBeSetupMod_Item_sLDRBID,
        _SLDRBs_FailedToBeSetupMod_Item_cause,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions,
        SLDRBs_FailedToBeSetupMod_Item,
        SLDRBs_FailedToBeSetupMod_ItemExtIEs,
        _SLDRBs_Modified_Item_sLDRBID,
        ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__id,
        ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Modified_Item_iE_Extensions__item_,
        _SLDRBs_Modified_Item_iE_Extensions,
        SLDRBs_Modified_Item,
        SLDRBs_Modified_ItemExtIEs,
        _SLDRBs_ModifiedConf_Item_sLDRBID,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ModifiedConf_Item_iE_Extensions__item_,
        _SLDRBs_ModifiedConf_Item_iE_Extensions,
        SLDRBs_ModifiedConf_Item,
        SLDRBs_ModifiedConf_ItemExtIEs,
        _SLDRBs_Required_ToBeModified_Item_sLDRBID,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_Required_ToBeModified_Item_iE_Extensions,
        SLDRBs_Required_ToBeModified_Item,
        SLDRBs_Required_ToBeModified_ItemExtIEs,
        _SLDRBs_Required_ToBeReleased_Item_sLDRBID,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _SLDRBs_Required_ToBeReleased_Item_iE_Extensions,
        SLDRBs_Required_ToBeReleased_Item,
        SLDRBs_Required_ToBeReleased_ItemExtIEs,
        _SLDRBs_Setup_Item_sLDRBID,
        ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__id,
        ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Setup_Item_iE_Extensions__item_,
        _SLDRBs_Setup_Item_iE_Extensions,
        SLDRBs_Setup_Item,
        SLDRBs_Setup_ItemExtIEs,
        _SLDRBs_SetupMod_Item_sLDRBID,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_SetupMod_Item_iE_Extensions__item_,
        _SLDRBs_SetupMod_Item_iE_Extensions,
        SLDRBs_SetupMod_Item,
        SLDRBs_SetupMod_ItemExtIEs,
        _SLDRBs_ToBeModified_Item_sLDRBID,
        _SLDRBs_ToBeModified_Item_sLDRBInformation,
        _SLDRBs_ToBeModified_Item_rLCMode,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_ToBeModified_Item_iE_Extensions,
        SLDRBs_ToBeModified_Item,
        SLDRBs_ToBeModified_ItemExtIEs,
        _SLDRBs_ToBeReleased_Item_sLDRBID,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeReleased_Item_iE_Extensions__item_,
        _SLDRBs_ToBeReleased_Item_iE_Extensions,
        SLDRBs_ToBeReleased_Item,
        SLDRBs_ToBeReleased_ItemExtIEs,
        _SLDRBs_ToBeSetup_Item_sLDRBID,
        _SLDRBs_ToBeSetup_Item_sLDRBInformation,
        _SLDRBs_ToBeSetup_Item_rLCMode,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeSetup_Item_iE_Extensions__item_,
        _SLDRBs_ToBeSetup_Item_iE_Extensions,
        SLDRBs_ToBeSetup_Item,
        SLDRBs_ToBeSetup_ItemExtIEs,
        _SLDRBs_ToBeSetupMod_Item_sLDRBID,
        _SLDRBs_ToBeSetupMod_Item_sLDRBInformation,
        _SLDRBs_ToBeSetupMod_Item_rLCMode,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _SLDRBs_ToBeSetupMod_Item_iE_Extensions,
        SLDRBs_ToBeSetupMod_Item,
        SLDRBs_ToBeSetupMod_ItemExtIEs,
        SL_PHY_MAC_RLC_Config,
        SL_ConfigDedicatedEUTRA_Info,
        _SliceAvailableCapacity_sliceAvailableCapacityList,
        ____SliceAvailableCapacity_iE_Extensions__item__id_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__id,
        ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__criticality,
        ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__extensionValue,
        __SliceAvailableCapacity_iE_Extensions__item_,
        _SliceAvailableCapacity_iE_Extensions,
        SliceAvailableCapacity,
        SliceAvailableCapacity_ExtIEs,
        _SliceAvailableCapacityList__item_,
        SliceAvailableCapacityList,
        _SliceAvailableCapacityItem_pLMNIdentity,
        _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List,
        ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__id,
        ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__criticality,
        ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue,
        __SliceAvailableCapacityItem_iE_Extensions__item_,
        _SliceAvailableCapacityItem_iE_Extensions,
        SliceAvailableCapacityItem,
        SliceAvailableCapacityItem_ExtIEs,
        _SNSSAIAvailableCapacity_List__item_,
        SNSSAIAvailableCapacity_List,
        _SNSSAIAvailableCapacity_Item_sNSSAI,
        _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink,
        _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue,
        __SNSSAIAvailableCapacity_Item_iE_Extensions__item_,
        _SNSSAIAvailableCapacity_Item_iE_Extensions,
        SNSSAIAvailableCapacity_Item,
        SNSSAIAvailableCapacity_Item_ExtIEs,
        _SliceSupportList__item_,
        SliceSupportList,
        _SliceSupportItem_sNSSAI,
        ____SliceSupportItem_iE_Extensions__item__id_tab,
        ___SliceSupportItem_iE_Extensions__item__id,
        ____SliceSupportItem_iE_Extensions__item__criticality_tab,
        ___SliceSupportItem_iE_Extensions__item__criticality,
        ____SliceSupportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceSupportItem_iE_Extensions__item__extensionValue,
        __SliceSupportItem_iE_Extensions__item_,
        _SliceSupportItem_iE_Extensions,
        SliceSupportItem,
        SliceSupportItem_ExtIEs,
        _SliceToReportList__item_,
        SliceToReportList,
        _SliceToReportItem_pLMNIdentity,
        _SliceToReportItem_sNSSAIlist,
        ____SliceToReportItem_iE_Extensions__item__id_tab,
        ___SliceToReportItem_iE_Extensions__item__id,
        ____SliceToReportItem_iE_Extensions__item__criticality_tab,
        ___SliceToReportItem_iE_Extensions__item__criticality,
        ____SliceToReportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceToReportItem_iE_Extensions__item__extensionValue,
        __SliceToReportItem_iE_Extensions__item_,
        _SliceToReportItem_iE_Extensions,
        SliceToReportItem,
        SliceToReportItem_ExtIEs,
        SlotNumber,
        _SNSSAI_list__item_,
        SNSSAI_list,
        _SNSSAI_Item_sNSSAI,
        ____SNSSAI_Item_iE_Extensions__item__id_tab,
        ___SNSSAI_Item_iE_Extensions__item__id,
        ____SNSSAI_Item_iE_Extensions__item__criticality_tab,
        ___SNSSAI_Item_iE_Extensions__item__criticality,
        ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab,
        ___SNSSAI_Item_iE_Extensions__item__extensionValue,
        __SNSSAI_Item_iE_Extensions__item_,
        _SNSSAI_Item_iE_Extensions,
        SNSSAI_Item,
        SNSSAI_Item_ExtIEs,
        _Slot_Configuration_List__item_,
        Slot_Configuration_List,
        _Slot_Configuration_Item_slotIndex,
        _Slot_Configuration_Item_symbolAllocInSlot,
        ____Slot_Configuration_Item_iE_Extensions__item__id_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__id,
        ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__criticality,
        ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__extensionValue,
        __Slot_Configuration_Item_iE_Extensions__item_,
        _Slot_Configuration_Item_iE_Extensions,
        Slot_Configuration_Item,
        Slot_Configuration_ItemExtIEs,
        _SNSSAI_sST,
        _SNSSAI_sD,
        ____SNSSAI_iE_Extensions__item__id_tab,
        ___SNSSAI_iE_Extensions__item__id,
        ____SNSSAI_iE_Extensions__item__criticality_tab,
        ___SNSSAI_iE_Extensions__item__criticality,
        ____SNSSAI_iE_Extensions__item__extensionValue_tab,
        ___SNSSAI_iE_Extensions__item__extensionValue,
        __SNSSAI_iE_Extensions__item_,
        _SNSSAI_iE_Extensions,
        SNSSAI,
        SNSSAI_ExtIEs,
        _SpatialDirectionInformation_nR_PRSBeamInformation,
        ____SpatialDirectionInformation_iE_Extensions__item__id_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__id,
        ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__criticality,
        ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__extensionValue,
        __SpatialDirectionInformation_iE_Extensions__item_,
        _SpatialDirectionInformation_iE_Extensions,
        SpatialDirectionInformation,
        SpatialDirectionInformation_ExtIEs,
        _SpatialRelationInfo_spatialRelationforResourceID,
        ____SpatialRelationInfo_iE_Extensions__item__id_tab,
        ___SpatialRelationInfo_iE_Extensions__item__id,
        ____SpatialRelationInfo_iE_Extensions__item__criticality_tab,
        ___SpatialRelationInfo_iE_Extensions__item__criticality,
        ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationInfo_iE_Extensions__item__extensionValue,
        __SpatialRelationInfo_iE_Extensions__item_,
        _SpatialRelationInfo_iE_Extensions,
        SpatialRelationInfo,
        SpatialRelationInfo_ExtIEs,
        _SpatialRelationforResourceID__item_,
        SpatialRelationforResourceID,
        _SpatialRelationforResourceIDItem_referenceSignal,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__id,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue,
        __SpatialRelationforResourceIDItem_iE_Extensions__item_,
        _SpatialRelationforResourceIDItem_iE_Extensions,
        SpatialRelationforResourceIDItem,
        SpatialRelationforResourceIDItem_ExtIEs,
        _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResource_iE_Extensions__item_,
        _SpatialRelationPerSRSResource_iE_Extensions,
        SpatialRelationPerSRSResource,
        SpatialRelationPerSRSResource_ExtIEs,
        _SpatialRelationPerSRSResource_List__item_,
        SpatialRelationPerSRSResource_List,
        _SpatialRelationPerSRSResourceItem_referenceSignal,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResourceItem_iE_Extensions__item_,
        _SpatialRelationPerSRSResourceItem_iE_Extensions,
        SpatialRelationPerSRSResourceItem,
        SpatialRelationPerSRSResourceItem_ExtIEs,
        _SpatialRelationPos_sSBPos,
        _SpatialRelationPos_pRSInformationPos,
        ___SpatialRelationPos_choice_extension_id_tab,
        __SpatialRelationPos_choice_extension_id,
        ___SpatialRelationPos_choice_extension_criticality_tab,
        __SpatialRelationPos_choice_extension_criticality,
        ___SpatialRelationPos_choice_extension_value_tab,
        __SpatialRelationPos_choice_extension_value,
        _SpatialRelationPos_choice_extension,
        SpatialRelationPos,
        SpatialInformationPos_ExtIEs,
        SpectrumSharingGroupID,
        SRBID,
        _SRBs_FailedToBeSetup_Item_sRBID,
        _SRBs_FailedToBeSetup_Item_cause,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _SRBs_FailedToBeSetup_Item_iE_Extensions,
        SRBs_FailedToBeSetup_Item,
        SRBs_FailedToBeSetup_ItemExtIEs,
        _SRBs_FailedToBeSetupMod_Item_sRBID,
        _SRBs_FailedToBeSetupMod_Item_cause,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _SRBs_FailedToBeSetupMod_Item_iE_Extensions,
        SRBs_FailedToBeSetupMod_Item,
        SRBs_FailedToBeSetupMod_ItemExtIEs,
        _SRBs_Modified_Item_sRBID,
        _SRBs_Modified_Item_lCID,
        ____SRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__id,
        ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__criticality,
        ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __SRBs_Modified_Item_iE_Extensions__item_,
        _SRBs_Modified_Item_iE_Extensions,
        SRBs_Modified_Item,
        SRBs_Modified_ItemExtIEs,
        _SRBs_Required_ToBeReleased_Item_sRBID,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _SRBs_Required_ToBeReleased_Item_iE_Extensions,
        SRBs_Required_ToBeReleased_Item,
        SRBs_Required_ToBeReleased_ItemExtIEs,
        _SRBs_Setup_Item_sRBID,
        _SRBs_Setup_Item_lCID,
        ____SRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__id,
        ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__criticality,
        ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __SRBs_Setup_Item_iE_Extensions__item_,
        _SRBs_Setup_Item_iE_Extensions,
        SRBs_Setup_Item,
        SRBs_Setup_ItemExtIEs,
        _SRBs_SetupMod_Item_sRBID,
        _SRBs_SetupMod_Item_lCID,
        ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__id,
        ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_SetupMod_Item_iE_Extensions__item_,
        _SRBs_SetupMod_Item_iE_Extensions,
        SRBs_SetupMod_Item,
        SRBs_SetupMod_ItemExtIEs,
        _SRBs_ToBeReleased_Item_sRBID,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeReleased_Item_iE_Extensions__item_,
        _SRBs_ToBeReleased_Item_iE_Extensions,
        SRBs_ToBeReleased_Item,
        SRBs_ToBeReleased_ItemExtIEs,
        _SRBs_ToBeSetup_Item_sRBID,
        _SRBs_ToBeSetup_Item_duplicationIndication,
        ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeSetup_Item_iE_Extensions__item_,
        _SRBs_ToBeSetup_Item_iE_Extensions,
        SRBs_ToBeSetup_Item,
        SRBs_ToBeSetup_ItemExtIEs,
        _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0,
        _SRBs_ToBeSetupMod_Item_sRBID,
        _SRBs_ToBeSetupMod_Item_duplicationIndication,
        ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _SRBs_ToBeSetupMod_Item_iE_Extensions,
        SRBs_ToBeSetupMod_Item,
        SRBs_ToBeSetupMod_ItemExtIEs,
        _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        _SRSCarrier_List__item_,
        SRSCarrier_List,
        _SRSCarrier_List_Item_pointA,
        _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List,
        _SRSCarrier_List_Item_activeULBWP,
        _SRSCarrier_List_Item_pci,
        ____SRSCarrier_List_Item_iE_Extensions__item__id_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__id,
        ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__criticality,
        ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue,
        __SRSCarrier_List_Item_iE_Extensions__item_,
        _SRSCarrier_List_Item_iE_Extensions,
        SRSCarrier_List_Item,
        SRSCarrier_List_Item_ExtIEs,
        _SRSConfig_sRSResource_List,
        _SRSConfig_posSRSResource_List,
        _SRSConfig_sRSResourceSet_List,
        _SRSConfig_posSRSResourceSet_List,
        ____SRSConfig_iE_Extensions__item__id_tab,
        ___SRSConfig_iE_Extensions__item__id,
        ____SRSConfig_iE_Extensions__item__criticality_tab,
        ___SRSConfig_iE_Extensions__item__criticality,
        ____SRSConfig_iE_Extensions__item__extensionValue_tab,
        ___SRSConfig_iE_Extensions__item__extensionValue,
        __SRSConfig_iE_Extensions__item_,
        _SRSConfig_iE_Extensions,
        SRSConfig,
        SRSConfig_ExtIEs,
        _SRSConfiguration_sRSCarrier_List,
        ____SRSConfiguration_iE_Extensions__item__id_tab,
        ___SRSConfiguration_iE_Extensions__item__id,
        ____SRSConfiguration_iE_Extensions__item__criticality_tab,
        ___SRSConfiguration_iE_Extensions__item__criticality,
        ____SRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SRSConfiguration_iE_Extensions__item__extensionValue,
        __SRSConfiguration_iE_Extensions__item_,
        _SRSConfiguration_iE_Extensions,
        SRSConfiguration,
        SRSConfiguration_ExtIEs,
        SrsFrequency,
        SRSPosResourceID,
        _SRSResource_sRSResourceID,
        _SRSResource_nrofSRS_Ports,
        _SRSResource_transmissionComb,
        _SRSResource_startPosition,
        _SRSResource_nrofSymbols,
        _SRSResource_repetitionFactor,
        _SRSResource_freqDomainPosition,
        _SRSResource_freqDomainShift,
        _SRSResource_c_SRS,
        _SRSResource_b_SRS,
        _SRSResource_b_hop,
        _SRSResource_groupOrSequenceHopping,
        _SRSResource_resourceType,
        _SRSResource_sequenceId,
        ____SRSResource_iE_Extensions__item__id_tab,
        ___SRSResource_iE_Extensions__item__id,
        ____SRSResource_iE_Extensions__item__criticality_tab,
        ___SRSResource_iE_Extensions__item__criticality,
        ____SRSResource_iE_Extensions__item__extensionValue_tab,
        ___SRSResource_iE_Extensions__item__extensionValue,
        __SRSResource_iE_Extensions__item_,
        _SRSResource_iE_Extensions,
        SRSResource,
        SRSResource_ExtIEs,
        SRSResourceID,
        _SRSResourceID_List__item_,
        SRSResourceID_List,
        _SRSResource_List__item_,
        SRSResource_List,
        _SRSResourceSet_sRSResourceSetID,
        _SRSResourceSet_sRSResourceID_List,
        _SRSResourceSet_resourceSetType,
        ____SRSResourceSet_iE_Extensions__item__id_tab,
        ___SRSResourceSet_iE_Extensions__item__id,
        ____SRSResourceSet_iE_Extensions__item__criticality_tab,
        ___SRSResourceSet_iE_Extensions__item__criticality,
        ____SRSResourceSet_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceSet_iE_Extensions__item__extensionValue,
        __SRSResourceSet_iE_Extensions__item_,
        _SRSResourceSet_iE_Extensions,
        SRSResourceSet,
        SRSResourceSet_ExtIEs,
        SRSResourceSetID,
        _SRSResourceSetList__item_,
        SRSResourceSetList,
        _SRSResourceSetItem_numSRSresourcesperset,
        _SRSResourceSetItem_periodicityList,
        _SRSResourceSetItem_spatialRelationInfo,
        _SRSResourceSetItem_pathlossReferenceInfo,
        ____SRSResourceSetItem_iE_Extensions__item__id_tab,
        _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourceSetItem_iE_Extensions__item__id,
        ___SRSResourceSetItem_iE_Extensions__item__criticality,
        ___SRSResourceSetItem_iE_Extensions__item__extensionValue,
        __SRSResourceSetItem_iE_Extensions__item_,
        _SRSResourceSetItem_iE_Extensions,
        SRSResourceSetItem,
        SRSResourceSetItemExtIEs,
        _SRSResourceSetItemExtIEs_val_Extension_0,
        _SRSResourceSet_List__item_,
        SRSResourceSet_List,
        _SRSResourceTrigger_aperiodicSRSResourceTriggerList,
        ____SRSResourceTrigger_iE_Extensions__item__id_tab,
        ___SRSResourceTrigger_iE_Extensions__item__id,
        ____SRSResourceTrigger_iE_Extensions__item__criticality_tab,
        ___SRSResourceTrigger_iE_Extensions__item__criticality,
        ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceTrigger_iE_Extensions__item__extensionValue,
        __SRSResourceTrigger_iE_Extensions__item_,
        _SRSResourceTrigger_iE_Extensions,
        SRSResourceTrigger,
        SRSResourceTrigger_ExtIEs,
        _SSB_pCI_NR,
        _SSB_ssb_index,
        ____SSB_iE_Extensions__item__id_tab,
        ___SSB_iE_Extensions__item__id,
        ____SSB_iE_Extensions__item__criticality_tab,
        ___SSB_iE_Extensions__item__criticality,
        ____SSB_iE_Extensions__item__extensionValue_tab,
        ___SSB_iE_Extensions__item__extensionValue,
        __SSB_iE_Extensions__item_,
        _SSB_iE_Extensions,
        SSB,
        SSB_ExtIEs,
        SSB_freqInfo,
        SSB_Index,
        SSB_subcarrierSpacing,
        SSB_transmissionPeriodicity,
        SSB_transmissionTimingOffset,
        _SSB_transmissionBitmap_shortBitmap,
        _SSB_transmissionBitmap_mediumBitmap,
        _SSB_transmissionBitmap_longBitmap,
        ___SSB_transmissionBitmap_choice_extension_id_tab,
        __SSB_transmissionBitmap_choice_extension_id,
        ___SSB_transmissionBitmap_choice_extension_criticality_tab,
        __SSB_transmissionBitmap_choice_extension_criticality,
        ___SSB_transmissionBitmap_choice_extension_value_tab,
        __SSB_transmissionBitmap_choice_extension_value,
        _SSB_transmissionBitmap_choice_extension,
        SSB_transmissionBitmap,
        SSB_transmisisonBitmap_ExtIEs,
        _SSBAreaCapacityValueList__item_,
        SSBAreaCapacityValueList,
        _SSBAreaCapacityValueItem_sSBIndex,
        _SSBAreaCapacityValueItem_sSBAreaCapacityValue,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__id,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue,
        __SSBAreaCapacityValueItem_iE_Extensions__item_,
        _SSBAreaCapacityValueItem_iE_Extensions,
        SSBAreaCapacityValueItem,
        SSBAreaCapacityValueItem_ExtIEs,
        _SSBAreaRadioResourceStatusList__item_,
        SSBAreaRadioResourceStatusList,
        _SSBAreaRadioResourceStatusItem_sSBIndex,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage,
        _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage,
        _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue,
        __SSBAreaRadioResourceStatusItem_iE_Extensions__item_,
        _SSBAreaRadioResourceStatusItem_iE_Extensions,
        SSBAreaRadioResourceStatusItem,
        SSBAreaRadioResourceStatusItem_ExtIEs,
        _SSBInformation_sSBInformationList,
        ____SSBInformation_iE_Extensions__item__id_tab,
        ___SSBInformation_iE_Extensions__item__id,
        ____SSBInformation_iE_Extensions__item__criticality_tab,
        ___SSBInformation_iE_Extensions__item__criticality,
        ____SSBInformation_iE_Extensions__item__extensionValue_tab,
        ___SSBInformation_iE_Extensions__item__extensionValue,
        __SSBInformation_iE_Extensions__item_,
        _SSBInformation_iE_Extensions,
        SSBInformation,
        SSBInformation_ExtIEs,
        _SSBInformationList__item_,
        SSBInformationList,
        _SSBInformationItem_sSB_Configuration,
        _SSBInformationItem_pCI_NR,
        ____SSBInformationItem_iE_Extensions__item__id_tab,
        ___SSBInformationItem_iE_Extensions__item__id,
        ____SSBInformationItem_iE_Extensions__item__criticality_tab,
        ___SSBInformationItem_iE_Extensions__item__criticality,
        ____SSBInformationItem_iE_Extensions__item__extensionValue_tab,
        ___SSBInformationItem_iE_Extensions__item__extensionValue,
        __SSBInformationItem_iE_Extensions__item_,
        _SSBInformationItem_iE_Extensions,
        SSBInformationItem,
        SSBInformationItem_ExtIEs,
        _SSB_PositionsInBurst_shortBitmap,
        _SSB_PositionsInBurst_mediumBitmap,
        _SSB_PositionsInBurst_longBitmap,
        ___SSB_PositionsInBurst_choice_extension_id_tab,
        __SSB_PositionsInBurst_choice_extension_id,
        ___SSB_PositionsInBurst_choice_extension_criticality_tab,
        __SSB_PositionsInBurst_choice_extension_criticality,
        ___SSB_PositionsInBurst_choice_extension_value_tab,
        __SSB_PositionsInBurst_choice_extension_value,
        _SSB_PositionsInBurst_choice_extension,
        SSB_PositionsInBurst,
        SSB_PositionsInBurst_ExtIEs,
        _SSB_TF_Configuration_sSB_frequency,
        _SSB_TF_Configuration_sSB_subcarrier_spacing,
        _SSB_TF_Configuration_sSB_Transmit_power,
        _SSB_TF_Configuration_sSB_periodicity,
        _SSB_TF_Configuration_sSB_half_frame_offset,
        _SSB_TF_Configuration_sSB_SFN_offset,
        _SSB_TF_Configuration_sSB_position_in_burst,
        _SSB_TF_Configuration_sFNInitialisationTime,
        ____SSB_TF_Configuration_iE_Extensions__item__id_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__id,
        ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__criticality,
        ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__extensionValue,
        __SSB_TF_Configuration_iE_Extensions__item_,
        _SSB_TF_Configuration_iE_Extensions,
        SSB_TF_Configuration,
        SSB_TF_Configuration_ExtIEs,
        _SSBToReportList__item_,
        SSBToReportList,
        _SSBToReportItem_sSBIndex,
        ____SSBToReportItem_iE_Extensions__item__id_tab,
        ___SSBToReportItem_iE_Extensions__item__id,
        ____SSBToReportItem_iE_Extensions__item__criticality_tab,
        ___SSBToReportItem_iE_Extensions__item__criticality,
        ____SSBToReportItem_iE_Extensions__item__extensionValue_tab,
        ___SSBToReportItem_iE_Extensions__item__extensionValue,
        __SSBToReportItem_iE_Extensions__item_,
        _SSBToReportItem_iE_Extensions,
        SSBToReportItem,
        SSBToReportItem_ExtIEs,
        _SUL_Information_sUL_NRARFCN,
        _SUL_Information_sUL_transmission_Bandwidth,
        ____SUL_Information_iE_Extensions__item__id_tab,
        _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___SUL_Information_iE_Extensions__item__id,
        ___SUL_Information_iE_Extensions__item__criticality,
        ___SUL_Information_iE_Extensions__item__extensionValue,
        __SUL_Information_iE_Extensions__item_,
        _SUL_Information_iE_Extensions,
        SUL_Information,
        SUL_InformationExtIEs,
        _SUL_InformationExtIEs_val_Extension_0,
        _SUL_InformationExtIEs_val_Extension_1,
        SubcarrierSpacing,
        SubscriberProfileIDforRFP,
        SULAccessIndication,
        _SupportedSULFreqBandItem_freqBandIndicatorNr,
        ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__id,
        ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__criticality,
        ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue,
        __SupportedSULFreqBandItem_iE_Extensions__item_,
        _SupportedSULFreqBandItem_iE_Extensions,
        SupportedSULFreqBandItem,
        SupportedSULFreqBandItem_ExtIEs,
        _SymbolAllocInSlot_all_DL,
        _SymbolAllocInSlot_all_UL,
        _SymbolAllocInSlot_both_DL_and_UL,
        ___SymbolAllocInSlot_choice_extension_id_tab,
        __SymbolAllocInSlot_choice_extension_id,
        ___SymbolAllocInSlot_choice_extension_criticality_tab,
        __SymbolAllocInSlot_choice_extension_criticality,
        ___SymbolAllocInSlot_choice_extension_value_tab,
        __SymbolAllocInSlot_choice_extension_value,
        _SymbolAllocInSlot_choice_extension,
        SymbolAllocInSlot,
        SymbolAllocInSlot_ExtIEs,
        SystemFrameNumber,
        SystemInformationAreaID,
        FiveGS_TAC,
        Configured_EPS_TAC,
        _TargetCellList__item_,
        TargetCellList,
        _TargetCellList_Item_target_cell,
        ____TargetCellList_Item_iE_Extensions__item__id_tab,
        ___TargetCellList_Item_iE_Extensions__item__id,
        ____TargetCellList_Item_iE_Extensions__item__criticality_tab,
        ___TargetCellList_Item_iE_Extensions__item__criticality,
        ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___TargetCellList_Item_iE_Extensions__item__extensionValue,
        __TargetCellList_Item_iE_Extensions__item_,
        _TargetCellList_Item_iE_Extensions,
        TargetCellList_Item,
        TargetCellList_Item_ExtIEs,
        _TDD_Info_nRFreqInfo,
        _TDD_Info_transmission_Bandwidth,
        ____TDD_Info_iE_Extensions__item__id_tab,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        ___TDD_Info_iE_Extensions__item__id,
        ___TDD_Info_iE_Extensions__item__criticality,
        ___TDD_Info_iE_Extensions__item__extensionValue,
        __TDD_Info_iE_Extensions__item_,
        _TDD_Info_iE_Extensions,
        TDD_Info,
        TDD_Info_ExtIEs,
        _TDD_Info_ExtIEs_val_Extension_0,
        _TDD_Info_ExtIEs_val_Extension_1,
        _TDD_Info_ExtIEs_val_Extension_2,
        TDD_UL_DLConfigCommonNR,
        _TimeReferenceInformation_referenceTime,
        _TimeReferenceInformation_referenceSFN,
        _TimeReferenceInformation_uncertainty,
        _TimeReferenceInformation_timeInformationType,
        ____TimeReferenceInformation_iE_Extensions__item__id_tab,
        ___TimeReferenceInformation_iE_Extensions__item__id,
        ____TimeReferenceInformation_iE_Extensions__item__criticality_tab,
        ___TimeReferenceInformation_iE_Extensions__item__criticality,
        ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab,
        ___TimeReferenceInformation_iE_Extensions__item__extensionValue,
        __TimeReferenceInformation_iE_Extensions__item_,
        _TimeReferenceInformation_iE_Extensions,
        TimeReferenceInformation,
        TimeReferenceInformation_ExtIEs,
        TimeInformationType,
        _TimeStamp_systemFrameNumber,
        _TimeStamp_slotIndex,
        _TimeStamp_measurementTime,
        ____TimeStamp_iE_Extension__item__id_tab,
        ___TimeStamp_iE_Extension__item__id,
        ____TimeStamp_iE_Extension__item__criticality_tab,
        ___TimeStamp_iE_Extension__item__criticality,
        ____TimeStamp_iE_Extension__item__extensionValue_tab,
        ___TimeStamp_iE_Extension__item__extensionValue,
        __TimeStamp_iE_Extension__item_,
        _TimeStamp_iE_Extension,
        TimeStamp,
        TimeStamp_ExtIEs,
        _TimeStampSlotIndex_sCS_15,
        _TimeStampSlotIndex_sCS_30,
        _TimeStampSlotIndex_sCS_60,
        _TimeStampSlotIndex_sCS_120,
        ___TimeStampSlotIndex_choice_extension_id_tab,
        __TimeStampSlotIndex_choice_extension_id,
        ___TimeStampSlotIndex_choice_extension_criticality_tab,
        __TimeStampSlotIndex_choice_extension_criticality,
        ___TimeStampSlotIndex_choice_extension_value_tab,
        __TimeStampSlotIndex_choice_extension_value,
        _TimeStampSlotIndex_choice_extension,
        TimeStampSlotIndex,
        TimeStampSlotIndex_ExtIEs,
        TimeToWait,
        _TimingMeasurementQuality_measurementQuality,
        _TimingMeasurementQuality_resolution,
        ____TimingMeasurementQuality_iE_Extensions__item__id_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__id,
        ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__criticality,
        ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__extensionValue,
        __TimingMeasurementQuality_iE_Extensions__item_,
        _TimingMeasurementQuality_iE_Extensions,
        TimingMeasurementQuality,
        TimingMeasurementQuality_ExtIEs,
        TNLAssociationUsage,
        _TNLCapacityIndicator_dLTNLOfferedCapacity,
        _TNLCapacityIndicator_dLTNLAvailableCapacity,
        _TNLCapacityIndicator_uLTNLOfferedCapacity,
        _TNLCapacityIndicator_uLTNLAvailableCapacity,
        ____TNLCapacityIndicator_iE_Extensions__item__id_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__id,
        ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__criticality,
        ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__extensionValue,
        __TNLCapacityIndicator_iE_Extensions__item_,
        _TNLCapacityIndicator_iE_Extensions,
        TNLCapacityIndicator,
        TNLCapacityIndicator_ExtIEs,
        _TraceActivation_traceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        TraceDepth,
        TraceID,
        _TrafficMappingInfo_iPtolayer2TrafficMappingInfo,
        _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo,
        ___TrafficMappingInfo_choice_extension_id_tab,
        __TrafficMappingInfo_choice_extension_id,
        ___TrafficMappingInfo_choice_extension_criticality_tab,
        __TrafficMappingInfo_choice_extension_criticality,
        ___TrafficMappingInfo_choice_extension_value_tab,
        __TrafficMappingInfo_choice_extension_value,
        _TrafficMappingInfo_choice_extension,
        TrafficMappingInfo,
        TrafficMappingInfo_ExtIEs,
        TransportLayerAddress,
        TransactionID,
        _Transmission_Bandwidth_nRSCS,
        _Transmission_Bandwidth_nRNRB,
        ____Transmission_Bandwidth_iE_Extensions__item__id_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__id,
        ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__criticality,
        ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__extensionValue,
        __Transmission_Bandwidth_iE_Extensions__item_,
        _Transmission_Bandwidth_iE_Extensions,
        Transmission_Bandwidth,
        Transmission_Bandwidth_ExtIEs,
        __TransmissionComb_n2_combOffset_n2,
        __TransmissionComb_n2_cyclicShift_n2,
        _TransmissionComb_n2,
        __TransmissionComb_n4_combOffset_n4,
        __TransmissionComb_n4_cyclicShift_n4,
        _TransmissionComb_n4,
        ___TransmissionComb_choice_extension_id_tab,
        __TransmissionComb_choice_extension_id,
        ___TransmissionComb_choice_extension_criticality_tab,
        __TransmissionComb_choice_extension_criticality,
        ___TransmissionComb_choice_extension_value_tab,
        __TransmissionComb_choice_extension_value,
        _TransmissionComb_choice_extension,
        TransmissionComb,
        TransmissionComb_ExtIEs,
        __TransmissionCombPos_n2_combOffset_n2,
        __TransmissionCombPos_n2_cyclicShift_n2,
        _TransmissionCombPos_n2,
        __TransmissionCombPos_n4_combOffset_n4,
        __TransmissionCombPos_n4_cyclicShift_n4,
        _TransmissionCombPos_n4,
        __TransmissionCombPos_n8_combOffset_n8,
        __TransmissionCombPos_n8_cyclicShift_n8,
        _TransmissionCombPos_n8,
        ___TransmissionCombPos_choice_extension_id_tab,
        __TransmissionCombPos_choice_extension_id,
        ___TransmissionCombPos_choice_extension_criticality_tab,
        __TransmissionCombPos_choice_extension_criticality,
        ___TransmissionCombPos_choice_extension_value_tab,
        __TransmissionCombPos_choice_extension_value,
        _TransmissionCombPos_choice_extension,
        TransmissionCombPos,
        TransmissionCombPos_ExtIEs,
        TransmissionStopIndicator,
        _Transport_UP_Layer_Address_Info_To_Add_List__item_,
        Transport_UP_Layer_Address_Info_To_Add_List,
        _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions,
        Transport_UP_Layer_Address_Info_To_Add_Item,
        Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs,
        _Transport_UP_Layer_Address_Info_To_Remove_List__item_,
        Transport_UP_Layer_Address_Info_To_Remove_List,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions,
        Transport_UP_Layer_Address_Info_To_Remove_Item,
        Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs,
        TransmissionActionIndicator,
        TRPID,
        _TRPInformation_tRPID,
        _TRPInformation_tRPInformationTypeResponseList,
        ____TRPInformation_iE_Extensions__item__id_tab,
        ___TRPInformation_iE_Extensions__item__id,
        ____TRPInformation_iE_Extensions__item__criticality_tab,
        ___TRPInformation_iE_Extensions__item__criticality,
        ____TRPInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPInformation_iE_Extensions__item__extensionValue,
        __TRPInformation_iE_Extensions__item_,
        _TRPInformation_iE_Extensions,
        TRPInformation,
        TRPInformation_ExtIEs,
        _TRPInformationItem_tRPInformation,
        ____TRPInformationItem_iE_Extensions__item__id_tab,
        ___TRPInformationItem_iE_Extensions__item__id,
        ____TRPInformationItem_iE_Extensions__item__criticality_tab,
        ___TRPInformationItem_iE_Extensions__item__criticality,
        ____TRPInformationItem_iE_Extensions__item__extensionValue_tab,
        ___TRPInformationItem_iE_Extensions__item__extensionValue,
        __TRPInformationItem_iE_Extensions__item_,
        _TRPInformationItem_iE_Extensions,
        TRPInformationItem,
        TRPInformationItem_ExtIEs,
        TRPInformationTypeItem,
        _TRPInformationTypeResponseList__item_,
        TRPInformationTypeResponseList,
        _TRPInformationTypeResponseItem_pCI_NR,
        _TRPInformationTypeResponseItem_nG_RAN_CGI,
        _TRPInformationTypeResponseItem_nRARFCN,
        _TRPInformationTypeResponseItem_pRSConfiguration,
        _TRPInformationTypeResponseItem_sSBinformation,
        _TRPInformationTypeResponseItem_sFNInitialisationTime,
        _TRPInformationTypeResponseItem_spatialDirectionInformation,
        _TRPInformationTypeResponseItem_geographicalCoordinates,
        ___TRPInformationTypeResponseItem_choice_extension_id_tab,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0,
        __TRPInformationTypeResponseItem_choice_extension_id,
        __TRPInformationTypeResponseItem_choice_extension_criticality,
        __TRPInformationTypeResponseItem_choice_extension_value,
        _TRPInformationTypeResponseItem_choice_extension,
        TRPInformationTypeResponseItem,
        TRPInformationTypeResponseItem_ExtIEs,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_0,
        _TRPList__item_,
        TRPList,
        _TRPListItem_tRPID,
        ____TRPListItem_iE_Extensions__item__id_tab,
        ___TRPListItem_iE_Extensions__item__id,
        ____TRPListItem_iE_Extensions__item__criticality_tab,
        ___TRPListItem_iE_Extensions__item__criticality,
        ____TRPListItem_iE_Extensions__item__extensionValue_tab,
        ___TRPListItem_iE_Extensions__item__extensionValue,
        __TRPListItem_iE_Extensions__item_,
        _TRPListItem_iE_Extensions,
        TRPListItem,
        TRPListItem_ExtIEs,
        _TRPMeasurementQuality_tRPmeasurementQuality_Item,
        ____TRPMeasurementQuality_iE_Extensions__item__id_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__id,
        ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__criticality,
        ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__extensionValue,
        __TRPMeasurementQuality_iE_Extensions__item_,
        _TRPMeasurementQuality_iE_Extensions,
        TRPMeasurementQuality,
        TRPMeasurementQuality_ExtIEs,
        _TRPMeasurementQuality_Item_timingMeasurementQuality,
        _TRPMeasurementQuality_Item_angleMeasurementQuality,
        ___TRPMeasurementQuality_Item_choice_extension_id_tab,
        __TRPMeasurementQuality_Item_choice_extension_id,
        ___TRPMeasurementQuality_Item_choice_extension_criticality_tab,
        __TRPMeasurementQuality_Item_choice_extension_criticality,
        ___TRPMeasurementQuality_Item_choice_extension_value_tab,
        __TRPMeasurementQuality_Item_choice_extension_value,
        _TRPMeasurementQuality_Item_choice_extension,
        TRPMeasurementQuality_Item,
        TRPMeasurementQuality_Item_ExtIEs,
        _TRP_MeasurementRequestList__item_,
        TRP_MeasurementRequestList,
        _TRP_MeasurementRequestItem_tRPID,
        _TRP_MeasurementRequestItem_search_window_information,
        ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0,
        ___TRP_MeasurementRequestItem_iE_extensions__item__id,
        ___TRP_MeasurementRequestItem_iE_extensions__item__criticality,
        ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementRequestItem_iE_extensions__item_,
        _TRP_MeasurementRequestItem_iE_extensions,
        TRP_MeasurementRequestItem,
        TRP_MeasurementRequestItem_ExtIEs,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0,
        _TRPPositionDefinitionType_direct,
        _TRPPositionDefinitionType_referenced,
        ___TRPPositionDefinitionType_choice_extension_id_tab,
        __TRPPositionDefinitionType_choice_extension_id,
        ___TRPPositionDefinitionType_choice_extension_criticality_tab,
        __TRPPositionDefinitionType_choice_extension_criticality,
        ___TRPPositionDefinitionType_choice_extension_value_tab,
        __TRPPositionDefinitionType_choice_extension_value,
        _TRPPositionDefinitionType_choice_extension,
        TRPPositionDefinitionType,
        TRPPositionDefinitionType_ExtIEs,
        _TRPPositionDirect_accuracy,
        ____TRPPositionDirect_iE_extensions__item__id_tab,
        ___TRPPositionDirect_iE_extensions__item__id,
        ____TRPPositionDirect_iE_extensions__item__criticality_tab,
        ___TRPPositionDirect_iE_extensions__item__criticality,
        ____TRPPositionDirect_iE_extensions__item__extensionValue_tab,
        ___TRPPositionDirect_iE_extensions__item__extensionValue,
        __TRPPositionDirect_iE_extensions__item_,
        _TRPPositionDirect_iE_extensions,
        TRPPositionDirect,
        TRPPositionDirect_ExtIEs,
        _TRPPositionDirectAccuracy_tRPPosition,
        _TRPPositionDirectAccuracy_tRPHAposition,
        ___TRPPositionDirectAccuracy_choice_extension_id_tab,
        __TRPPositionDirectAccuracy_choice_extension_id,
        ___TRPPositionDirectAccuracy_choice_extension_criticality_tab,
        __TRPPositionDirectAccuracy_choice_extension_criticality,
        ___TRPPositionDirectAccuracy_choice_extension_value_tab,
        __TRPPositionDirectAccuracy_choice_extension_value,
        _TRPPositionDirectAccuracy_choice_extension,
        TRPPositionDirectAccuracy,
        TRPPositionDirectAccuracy_ExtIEs,
        _TRPPositionReferenced_referencePoint,
        _TRPPositionReferenced_referencePointType,
        ____TRPPositionReferenced_iE_extensions__item__id_tab,
        ___TRPPositionReferenced_iE_extensions__item__id,
        ____TRPPositionReferenced_iE_extensions__item__criticality_tab,
        ___TRPPositionReferenced_iE_extensions__item__criticality,
        ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab,
        ___TRPPositionReferenced_iE_extensions__item__extensionValue,
        __TRPPositionReferenced_iE_extensions__item_,
        _TRPPositionReferenced_iE_extensions,
        TRPPositionReferenced,
        TRPPositionReferenced_ExtIEs,
        _TRPReferencePointType_tRPPositionRelativeGeodetic,
        _TRPReferencePointType_tRPPositionRelativeCartesian,
        ___TRPReferencePointType_choice_extension_id_tab,
        __TRPReferencePointType_choice_extension_id,
        ___TRPReferencePointType_choice_extension_criticality_tab,
        __TRPReferencePointType_choice_extension_criticality,
        ___TRPReferencePointType_choice_extension_value_tab,
        __TRPReferencePointType_choice_extension_value,
        _TRPReferencePointType_choice_extension,
        TRPReferencePointType,
        TRPReferencePointType_ExtIEs,
        TypeOfError,
        _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List,
        _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List,
        ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__id,
        ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__criticality,
        ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue,
        __Transport_Layer_Address_Info_iE_Extensions__item_,
        _Transport_Layer_Address_Info_iE_Extensions,
        Transport_Layer_Address_Info,
        Transport_Layer_Address_Info_ExtIEs,
        TRPType,
        _TSCAssistanceInformation_periodicity,
        _TSCAssistanceInformation_burstArrivalTime,
        ____TSCAssistanceInformation_iE_Extensions__item__id_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__id,
        ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__criticality,
        ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__extensionValue,
        __TSCAssistanceInformation_iE_Extensions__item_,
        _TSCAssistanceInformation_iE_Extensions,
        TSCAssistanceInformation,
        TSCAssistanceInformation_ExtIEs,
        _TSCTrafficCharacteristics_tSCAssistanceInformationDL,
        _TSCTrafficCharacteristics_tSCAssistanceInformationUL,
        ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__id,
        ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__criticality,
        ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue,
        __TSCTrafficCharacteristics_iE_Extensions__item_,
        _TSCTrafficCharacteristics_iE_Extensions,
        TSCTrafficCharacteristics,
        TSCTrafficCharacteristics_ExtIEs,
        _UAC_Assistance_Info_uACPLMN_List,
        ____UAC_Assistance_Info_iE_Extensions__item__id_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__id,
        ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__criticality,
        ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__extensionValue,
        __UAC_Assistance_Info_iE_Extensions__item_,
        _UAC_Assistance_Info_iE_Extensions,
        UAC_Assistance_Info,
        UAC_Assistance_InfoExtIEs,
        _UACPLMN_List__item_,
        UACPLMN_List,
        _UACPLMN_Item_pLMNIdentity,
        _UACPLMN_Item_uACType_List,
        ____UACPLMN_Item_iE_Extensions__item__id_tab,
        _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___UACPLMN_Item_iE_Extensions__item__id,
        ___UACPLMN_Item_iE_Extensions__item__criticality,
        ___UACPLMN_Item_iE_Extensions__item__extensionValue,
        __UACPLMN_Item_iE_Extensions__item_,
        _UACPLMN_Item_iE_Extensions,
        UACPLMN_Item,
        UACPLMN_Item_ExtIEs,
        _UACPLMN_Item_ExtIEs_val_Extension_0,
        _UACType_List__item_,
        UACType_List,
        _UACType_Item_uACReductionIndication,
        _UACType_Item_uACCategoryType,
        ____UACType_Item_iE_Extensions__item__id_tab,
        ___UACType_Item_iE_Extensions__item__id,
        ____UACType_Item_iE_Extensions__item__criticality_tab,
        ___UACType_Item_iE_Extensions__item__criticality,
        ____UACType_Item_iE_Extensions__item__extensionValue_tab,
        ___UACType_Item_iE_Extensions__item__extensionValue,
        __UACType_Item_iE_Extensions__item_,
        _UACType_Item_iE_Extensions,
        UACType_Item,
        UACType_Item_ExtIEs,
        _UACCategoryType_uACstandardized,
        _UACCategoryType_uACOperatorDefined,
        ___UACCategoryType_choice_extension_id_tab,
        __UACCategoryType_choice_extension_id,
        ___UACCategoryType_choice_extension_criticality_tab,
        __UACCategoryType_choice_extension_criticality,
        ___UACCategoryType_choice_extension_value_tab,
        __UACCategoryType_choice_extension_value,
        _UACCategoryType_choice_extension,
        UACCategoryType,
        UACCategoryType_ExtIEs,
        _UACOperatorDefined_accessCategory,
        _UACOperatorDefined_accessIdentity,
        ____UACOperatorDefined_iE_Extensions__item__id_tab,
        ___UACOperatorDefined_iE_Extensions__item__id,
        ____UACOperatorDefined_iE_Extensions__item__criticality_tab,
        ___UACOperatorDefined_iE_Extensions__item__criticality,
        ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab,
        ___UACOperatorDefined_iE_Extensions__item__extensionValue,
        __UACOperatorDefined_iE_Extensions__item_,
        _UACOperatorDefined_iE_Extensions,
        UACOperatorDefined,
        UACOperatorDefined_ExtIEs,
        UACAction,
        UACReductionIndication,
        _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID,
        _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_,
        _UE_associatedLogicalF1_ConnectionItem_iE_Extensions,
        UE_associatedLogicalF1_ConnectionItem,
        UEAssistanceInformation,
        UEAssistanceInformationEUTRA,
        UE_associatedLogicalF1_ConnectionItemExtIEs,
        UE_CapabilityRAT_ContainerList,
        UEContextNotRetrievable,
        _UEIdentityIndexValue_indexLength10,
        ___UEIdentityIndexValue_choice_extension_id_tab,
        __UEIdentityIndexValue_choice_extension_id,
        ___UEIdentityIndexValue_choice_extension_criticality_tab,
        __UEIdentityIndexValue_choice_extension_criticality,
        ___UEIdentityIndexValue_choice_extension_value_tab,
        __UEIdentityIndexValue_choice_extension_value,
        _UEIdentityIndexValue_choice_extension,
        UEIdentityIndexValue,
        UEIdentityIndexValueChoice_ExtIEs,
        _UL_AoA_azimuthAoA,
        _UL_AoA_zenithAoA,
        _UL_AoA_lCS_to_GCS_TranslationAoA,
        ____UL_AoA_iE_extensions__item__id_tab,
        ___UL_AoA_iE_extensions__item__id,
        ____UL_AoA_iE_extensions__item__criticality_tab,
        ___UL_AoA_iE_extensions__item__criticality,
        ____UL_AoA_iE_extensions__item__extensionValue_tab,
        ___UL_AoA_iE_extensions__item__extensionValue,
        __UL_AoA_iE_extensions__item_,
        _UL_AoA_iE_extensions,
        UL_AoA,
        UL_AoA_ExtIEs,
        _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue,
        __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_,
        _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions,
        UL_BH_Non_UP_Traffic_Mapping,
        UL_BH_Non_UP_Traffic_Mapping_ExtIEs,
        _UL_BH_Non_UP_Traffic_Mapping_List__item_,
        UL_BH_Non_UP_Traffic_Mapping_List,
        _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType,
        _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue,
        __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_,
        _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions,
        UL_BH_Non_UP_Traffic_Mapping_Item,
        UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs,
        _ULConfiguration_uLUEConfiguration,
        ____ULConfiguration_iE_Extensions__item__id_tab,
        ___ULConfiguration_iE_Extensions__item__id,
        ____ULConfiguration_iE_Extensions__item__criticality_tab,
        ___ULConfiguration_iE_Extensions__item__criticality,
        ____ULConfiguration_iE_Extensions__item__extensionValue_tab,
        ___ULConfiguration_iE_Extensions__item__extensionValue,
        __ULConfiguration_iE_Extensions__item_,
        _ULConfiguration_iE_Extensions,
        ULConfiguration,
        ULConfigurationExtIEs,
        _UL_RTOA_Measurement_uL_RTOA_MeasurementItem,
        _UL_RTOA_Measurement_additionalPath_List,
        ____UL_RTOA_Measurement_iE_Extensions__item__id_tab,
        ___UL_RTOA_Measurement_iE_Extensions__item__id,
        ____UL_RTOA_Measurement_iE_Extensions__item__criticality_tab,
        ___UL_RTOA_Measurement_iE_Extensions__item__criticality,
        ____UL_RTOA_Measurement_iE_Extensions__item__extensionValue_tab,
        ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue,
        __UL_RTOA_Measurement_iE_Extensions__item_,
        _UL_RTOA_Measurement_iE_Extensions,
        UL_RTOA_Measurement,
        UL_RTOA_Measurement_ExtIEs,
        _UL_RTOA_MeasurementItem_k0,
        _UL_RTOA_MeasurementItem_k1,
        _UL_RTOA_MeasurementItem_k2,
        _UL_RTOA_MeasurementItem_k3,
        _UL_RTOA_MeasurementItem_k4,
        _UL_RTOA_MeasurementItem_k5,
        ___UL_RTOA_MeasurementItem_choice_extension_id_tab,
        __UL_RTOA_MeasurementItem_choice_extension_id,
        ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab,
        __UL_RTOA_MeasurementItem_choice_extension_criticality,
        ___UL_RTOA_MeasurementItem_choice_extension_value_tab,
        __UL_RTOA_MeasurementItem_choice_extension_value,
        _UL_RTOA_MeasurementItem_choice_extension,
        UL_RTOA_MeasurementItem,
        UL_RTOA_MeasurementItem_ExtIEs,
        UL_SRS_RSRP,
        ULUEConfiguration,
        _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation,
        _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation,
        _UL_UP_TNL_Information_to_Update_List_Item_bHInfo,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_,
        _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions,
        UL_UP_TNL_Information_to_Update_List_Item,
        UL_UP_TNL_Information_to_Update_List_ItemExtIEs,
        _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress,
        _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_,
        _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions,
        UL_UP_TNL_Address_to_Update_List_Item,
        UL_UP_TNL_Address_to_Update_List_ItemExtIEs,
        _ULUPTNLInformation_ToBeSetup_List__item_,
        ULUPTNLInformation_ToBeSetup_List,
        _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation,
        ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_,
        _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions,
        ULUPTNLInformation_ToBeSetup_Item,
        ULUPTNLInformation_ToBeSetup_ItemExtIEs,
        _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0,
        Uncertainty,
        _UplinkChannelBW_PerSCS_List__item_,
        UplinkChannelBW_PerSCS_List,
        UplinkTxDirectCurrentListInformation,
        _UPTransportLayerInformation_gTPTunnel,
        ___UPTransportLayerInformation_choice_extension_id_tab,
        __UPTransportLayerInformation_choice_extension_id,
        ___UPTransportLayerInformation_choice_extension_criticality_tab,
        __UPTransportLayerInformation_choice_extension_criticality,
        ___UPTransportLayerInformation_choice_extension_value_tab,
        __UPTransportLayerInformation_choice_extension_value,
        _UPTransportLayerInformation_choice_extension,
        UPTransportLayerInformation,
        UPTransportLayerInformation_ExtIEs,
        URI_address,
        _VictimgNBSetID_victimgNBSetID,
        ____VictimgNBSetID_iE_Extensions__item__id_tab,
        ___VictimgNBSetID_iE_Extensions__item__id,
        ____VictimgNBSetID_iE_Extensions__item__criticality_tab,
        ___VictimgNBSetID_iE_Extensions__item__criticality,
        ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab,
        ___VictimgNBSetID_iE_Extensions__item__extensionValue,
        __VictimgNBSetID_iE_Extensions__item_,
        _VictimgNBSetID_iE_Extensions,
        VictimgNBSetID,
        VictimgNBSetID_ExtIEs,
        VehicleUE,
        PedestrianUE,
    ]

class F1AP_PDU_Contents:

    _name_  = u'F1AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 1]
    
    _obj_ = [
        u'Reset',
        u'ResetIEs',
        u'ResetType',
        u'ResetType-ExtIEs',
        u'ResetAll',
        u'UE-associatedLogicalF1-ConnectionListRes',
        u'UE-associatedLogicalF1-ConnectionItemRes',
        u'ResetAcknowledge',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalF1-ConnectionListResAck',
        u'UE-associatedLogicalF1-ConnectionItemResAck',
        u'ErrorIndication',
        u'ErrorIndicationIEs',
        u'F1SetupRequest',
        u'F1SetupRequestIEs',
        u'GNB-DU-Served-Cells-List',
        u'GNB-DU-Served-Cells-ItemIEs',
        u'F1SetupResponse',
        u'F1SetupResponseIEs',
        u'Cells-to-be-Activated-List',
        u'Cells-to-be-Activated-List-ItemIEs',
        u'F1SetupFailure',
        u'F1SetupFailureIEs',
        u'GNBDUConfigurationUpdate',
        u'GNBDUConfigurationUpdateIEs',
        u'Served-Cells-To-Add-List',
        u'Served-Cells-To-Modify-List',
        u'Served-Cells-To-Delete-List',
        u'Cells-Status-List',
        u'Dedicated-SIDelivery-NeededUE-List',
        u'GNB-DU-TNL-Association-To-Remove-List',
        u'Served-Cells-To-Add-ItemIEs',
        u'Served-Cells-To-Modify-ItemIEs',
        u'Served-Cells-To-Delete-ItemIEs',
        u'Cells-Status-ItemIEs',
        u'Dedicated-SIDelivery-NeededUE-ItemIEs',
        u'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        u'GNBDUConfigurationUpdateAcknowledge',
        u'GNBDUConfigurationUpdateAcknowledgeIEs',
        u'GNBDUConfigurationUpdateFailure',
        u'GNBDUConfigurationUpdateFailureIEs',
        u'GNBCUConfigurationUpdate',
        u'GNBCUConfigurationUpdateIEs',
        u'Cells-to-be-Deactivated-List',
        u'GNB-CU-TNL-Association-To-Add-List',
        u'GNB-CU-TNL-Association-To-Remove-List',
        u'GNB-CU-TNL-Association-To-Update-List',
        u'Cells-to-be-Barred-List',
        u'Cells-to-be-Deactivated-List-ItemIEs',
        u'GNB-CU-TNL-Association-To-Add-ItemIEs',
        u'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        u'GNB-CU-TNL-Association-To-Update-ItemIEs',
        u'Cells-to-be-Barred-ItemIEs',
        u'Protected-EUTRA-Resources-List',
        u'Protected-EUTRA-Resources-ItemIEs',
        u'Neighbour-Cell-Information-List',
        u'Neighbour-Cell-Information-ItemIEs',
        u'GNBCUConfigurationUpdateAcknowledge',
        u'GNBCUConfigurationUpdateAcknowledgeIEs',
        u'Cells-Failed-to-be-Activated-List',
        u'GNB-CU-TNL-Association-Setup-List',
        u'GNB-CU-TNL-Association-Failed-To-Setup-List',
        u'Cells-Failed-to-be-Activated-List-ItemIEs',
        u'GNB-CU-TNL-Association-Setup-ItemIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        u'GNBCUConfigurationUpdateFailure',
        u'GNBCUConfigurationUpdateFailureIEs',
        u'GNBDUResourceCoordinationRequest',
        u'GNBDUResourceCoordinationRequest-IEs',
        u'GNBDUResourceCoordinationResponse',
        u'GNBDUResourceCoordinationResponse-IEs',
        u'UEContextSetupRequest',
        u'UEContextSetupRequestIEs',
        u'Candidate-SpCell-List',
        u'SCell-ToBeSetup-List',
        u'SRBs-ToBeSetup-List',
        u'DRBs-ToBeSetup-List',
        u'BHChannels-ToBeSetup-List',
        u'SLDRBs-ToBeSetup-List',
        u'Candidate-SpCell-ItemIEs',
        u'SCell-ToBeSetup-ItemIEs',
        u'SRBs-ToBeSetup-ItemIEs',
        u'DRBs-ToBeSetup-ItemIEs',
        u'BHChannels-ToBeSetup-ItemIEs',
        u'SLDRBs-ToBeSetup-ItemIEs',
        u'UEContextSetupResponse',
        u'UEContextSetupResponseIEs',
        u'DRBs-Setup-List',
        u'SRBs-FailedToBeSetup-List',
        u'DRBs-FailedToBeSetup-List',
        u'SCell-FailedtoSetup-List',
        u'SRBs-Setup-List',
        u'BHChannels-Setup-List',
        u'BHChannels-FailedToBeSetup-List',
        u'DRBs-Setup-ItemIEs',
        u'SRBs-Setup-ItemIEs',
        u'SRBs-FailedToBeSetup-ItemIEs',
        u'DRBs-FailedToBeSetup-ItemIEs',
        u'SCell-FailedtoSetup-ItemIEs',
        u'BHChannels-Setup-ItemIEs',
        u'BHChannels-FailedToBeSetup-ItemIEs',
        u'SLDRBs-Setup-List',
        u'SLDRBs-FailedToBeSetup-List',
        u'SLDRBs-Setup-ItemIEs',
        u'SLDRBs-FailedToBeSetup-ItemIEs',
        u'UEContextSetupFailure',
        u'UEContextSetupFailureIEs',
        u'Potential-SpCell-List',
        u'Potential-SpCell-ItemIEs',
        u'UEContextReleaseRequest',
        u'UEContextReleaseRequestIEs',
        u'UEContextReleaseCommand',
        u'UEContextReleaseCommandIEs',
        u'UEContextReleaseComplete',
        u'UEContextReleaseCompleteIEs',
        u'UEContextModificationRequest',
        u'UEContextModificationRequestIEs',
        u'SCell-ToBeSetupMod-List',
        u'SCell-ToBeRemoved-List',
        u'SRBs-ToBeSetupMod-List',
        u'DRBs-ToBeSetupMod-List',
        u'BHChannels-ToBeSetupMod-List',
        u'DRBs-ToBeModified-List',
        u'BHChannels-ToBeModified-List',
        u'SRBs-ToBeReleased-List',
        u'DRBs-ToBeReleased-List',
        u'BHChannels-ToBeReleased-List',
        u'SCell-ToBeSetupMod-ItemIEs',
        u'SCell-ToBeRemoved-ItemIEs',
        u'SRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeModified-ItemIEs',
        u'SRBs-ToBeReleased-ItemIEs',
        u'DRBs-ToBeReleased-ItemIEs',
        u'BHChannels-ToBeSetupMod-ItemIEs',
        u'BHChannels-ToBeModified-ItemIEs',
        u'BHChannels-ToBeReleased-ItemIEs',
        u'SLDRBs-ToBeSetupMod-List',
        u'SLDRBs-ToBeModified-List',
        u'SLDRBs-ToBeReleased-List',
        u'SLDRBs-ToBeSetupMod-ItemIEs',
        u'SLDRBs-ToBeModified-ItemIEs',
        u'SLDRBs-ToBeReleased-ItemIEs',
        u'UEContextModificationResponse',
        u'UEContextModificationResponseIEs',
        u'DRBs-SetupMod-List',
        u'DRBs-Modified-List',
        u'SRBs-SetupMod-List',
        u'SRBs-Modified-List',
        u'DRBs-FailedToBeModified-List',
        u'SRBs-FailedToBeSetupMod-List',
        u'DRBs-FailedToBeSetupMod-List',
        u'SCell-FailedtoSetupMod-List',
        u'BHChannels-SetupMod-List',
        u'BHChannels-Modified-List',
        u'BHChannels-FailedToBeModified-List',
        u'BHChannels-FailedToBeSetupMod-List',
        u'Associated-SCell-List',
        u'DRBs-SetupMod-ItemIEs',
        u'DRBs-Modified-ItemIEs',
        u'SRBs-SetupMod-ItemIEs',
        u'SRBs-Modified-ItemIEs',
        u'SRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeModified-ItemIEs',
        u'SCell-FailedtoSetupMod-ItemIEs',
        u'Associated-SCell-ItemIEs',
        u'BHChannels-SetupMod-ItemIEs',
        u'BHChannels-Modified-ItemIEs',
        u'BHChannels-FailedToBeSetupMod-ItemIEs',
        u'BHChannels-FailedToBeModified-ItemIEs',
        u'SLDRBs-SetupMod-List',
        u'SLDRBs-Modified-List',
        u'SLDRBs-FailedToBeModified-List',
        u'SLDRBs-FailedToBeSetupMod-List',
        u'SLDRBs-SetupMod-ItemIEs',
        u'SLDRBs-Modified-ItemIEs',
        u'SLDRBs-FailedToBeSetupMod-ItemIEs',
        u'SLDRBs-FailedToBeModified-ItemIEs',
        u'UEContextModificationFailure',
        u'UEContextModificationFailureIEs',
        u'UEContextModificationRequired',
        u'UEContextModificationRequiredIEs',
        u'DRBs-Required-ToBeModified-List',
        u'DRBs-Required-ToBeReleased-List',
        u'SRBs-Required-ToBeReleased-List',
        u'BHChannels-Required-ToBeReleased-List',
        u'DRBs-Required-ToBeModified-ItemIEs',
        u'DRBs-Required-ToBeReleased-ItemIEs',
        u'SRBs-Required-ToBeReleased-ItemIEs',
        u'BHChannels-Required-ToBeReleased-ItemIEs',
        u'SLDRBs-Required-ToBeModified-List',
        u'SLDRBs-Required-ToBeReleased-List',
        u'SLDRBs-Required-ToBeModified-ItemIEs',
        u'SLDRBs-Required-ToBeReleased-ItemIEs',
        u'UEContextModificationConfirm',
        u'UEContextModificationConfirmIEs',
        u'DRBs-ModifiedConf-List',
        u'DRBs-ModifiedConf-ItemIEs',
        u'SLDRBs-ModifiedConf-List',
        u'SLDRBs-ModifiedConf-ItemIEs',
        u'UEContextModificationRefuse',
        u'UEContextModificationRefuseIEs',
        u'WriteReplaceWarningRequest',
        u'WriteReplaceWarningRequestIEs',
        u'Cells-To-Be-Broadcast-List',
        u'Cells-To-Be-Broadcast-List-ItemIEs',
        u'WriteReplaceWarningResponse',
        u'WriteReplaceWarningResponseIEs',
        u'Cells-Broadcast-Completed-List',
        u'Cells-Broadcast-Completed-List-ItemIEs',
        u'PWSCancelRequest',
        u'PWSCancelRequestIEs',
        u'Broadcast-To-Be-Cancelled-List',
        u'Broadcast-To-Be-Cancelled-List-ItemIEs',
        u'PWSCancelResponse',
        u'PWSCancelResponseIEs',
        u'Cells-Broadcast-Cancelled-List',
        u'Cells-Broadcast-Cancelled-List-ItemIEs',
        u'UEInactivityNotification',
        u'UEInactivityNotificationIEs',
        u'DRB-Activity-List',
        u'DRB-Activity-ItemIEs',
        u'InitialULRRCMessageTransfer',
        u'InitialULRRCMessageTransferIEs',
        u'DLRRCMessageTransfer',
        u'DLRRCMessageTransferIEs',
        u'ULRRCMessageTransfer',
        u'ULRRCMessageTransferIEs',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'SystemInformationDeliveryCommand',
        u'SystemInformationDeliveryCommandIEs',
        u'Paging',
        u'PagingIEs',
        u'PagingCell-list',
        u'PagingCell-ItemIEs',
        u'Notify',
        u'NotifyIEs',
        u'DRB-Notify-List',
        u'DRB-Notify-ItemIEs',
        u'NetworkAccessRateReduction',
        u'NetworkAccessRateReductionIEs',
        u'PWSRestartIndication',
        u'PWSRestartIndicationIEs',
        u'NR-CGI-List-For-Restart-List',
        u'NR-CGI-List-For-Restart-List-ItemIEs',
        u'PWSFailureIndication',
        u'PWSFailureIndicationIEs',
        u'PWS-Failed-NR-CGI-List',
        u'PWS-Failed-NR-CGI-List-ItemIEs',
        u'GNBDUStatusIndication',
        u'GNBDUStatusIndicationIEs',
        u'RRCDeliveryReport',
        u'RRCDeliveryReportIEs',
        u'F1RemovalRequest',
        u'F1RemovalRequestIEs',
        u'F1RemovalResponse',
        u'F1RemovalResponseIEs',
        u'F1RemovalFailure',
        u'F1RemovalFailureIEs',
        u'TraceStart',
        u'TraceStartIEs',
        u'DeactivateTrace',
        u'DeactivateTraceIEs',
        u'CellTrafficTrace',
        u'CellTrafficTraceIEs',
        u'DUCURadioInformationTransfer',
        u'DUCURadioInformationTransferIEs',
        u'CUDURadioInformationTransfer',
        u'CUDURadioInformationTransferIEs',
        u'BAPMappingConfiguration',
        u'BAPMappingConfiguration-IEs',
        u'BH-Routing-Information-Added-List',
        u'BH-Routing-Information-Removed-List',
        u'BH-Routing-Information-Added-List-ItemIEs',
        u'BH-Routing-Information-Removed-List-ItemIEs',
        u'BAPMappingConfigurationAcknowledge',
        u'BAPMappingConfigurationAcknowledge-IEs',
        u'BAPMappingConfigurationFailure',
        u'BAPMappingConfigurationFailureIEs',
        u'GNBDUResourceConfiguration',
        u'GNBDUResourceConfigurationIEs',
        u'GNBDUResourceConfigurationAcknowledge',
        u'GNBDUResourceConfigurationAcknowledgeIEs',
        u'GNBDUResourceConfigurationFailure',
        u'GNBDUResourceConfigurationFailureIEs',
        u'IABTNLAddressRequest',
        u'IABTNLAddressRequestIEs',
        u'IAB-TNL-Addresses-To-Remove-List',
        u'IAB-TNL-Addresses-To-Remove-ItemIEs',
        u'IABTNLAddressResponse',
        u'IABTNLAddressResponseIEs',
        u'IAB-Allocated-TNL-Address-List',
        u'IAB-Allocated-TNL-Address-List-ItemIEs',
        u'IABTNLAddressFailure',
        u'IABTNLAddressFailureIEs',
        u'IABUPConfigurationUpdateRequest',
        u'IABUPConfigurationUpdateRequestIEs',
        u'UL-UP-TNL-Information-to-Update-List',
        u'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        u'UL-UP-TNL-Address-to-Update-List',
        u'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateResponse',
        u'IABUPConfigurationUpdateResponseIEs',
        u'DL-UP-TNL-Address-to-Update-List',
        u'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateFailure',
        u'IABUPConfigurationUpdateFailureIEs',
        u'ResourceStatusRequest',
        u'ResourceStatusRequestIEs',
        u'ResourceStatusResponse',
        u'ResourceStatusResponseIEs',
        u'ResourceStatusFailure',
        u'ResourceStatusFailureIEs',
        u'ResourceStatusUpdate',
        u'ResourceStatusUpdateIEs',
        u'AccessAndMobilityIndication',
        u'AccessAndMobilityIndicationIEs',
        u'ReferenceTimeInformationReportingControl',
        u'ReferenceTimeInformationReportingControlIEs',
        u'ReferenceTimeInformationReport',
        u'ReferenceTimeInformationReportIEs',
        u'AccessSuccess',
        u'AccessSuccessIEs',
        u'PositioningAssistanceInformationControl',
        u'PositioningAssistanceInformationControlIEs',
        u'PositioningAssistanceInformationFeedback',
        u'PositioningAssistanceInformationFeedbackIEs',
        u'PositioningMeasurementRequest',
        u'PositioningMeasurementRequestIEs',
        u'PositioningMeasurementResponse',
        u'PositioningMeasurementResponseIEs',
        u'PositioningMeasurementFailure',
        u'PositioningMeasurementFailureIEs',
        u'PositioningMeasurementReport',
        u'PositioningMeasurementReportIEs',
        u'PositioningMeasurementAbort',
        u'PositioningMeasurementAbortIEs',
        u'PositioningMeasurementFailureIndication',
        u'PositioningMeasurementFailureIndicationIEs',
        u'PositioningMeasurementUpdate',
        u'PositioningMeasurementUpdateIEs',
        u'TRPInformationRequest',
        u'TRPInformationRequestIEs',
        u'TRPInformationTypeListTRPReq',
        u'TRPInformationTypeItemTRPReq',
        u'TRPInformationResponse',
        u'TRPInformationResponseIEs',
        u'TRPInformationListTRPResp',
        u'TRPInformationItemTRPResp',
        u'TRPInformationFailure',
        u'TRPInformationFailureIEs',
        u'PositioningInformationRequest',
        u'PositioningInformationRequestIEs',
        u'PositioningInformationResponse',
        u'PositioningInformationResponseIEs',
        u'PositioningInformationFailure',
        u'PositioningInformationFailureIEs',
        u'PositioningActivationRequest',
        u'PositioningActivationRequestIEs',
        u'SRSType',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponse',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailure',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivation',
        u'PositioningDeactivationIEs',
        u'PositioningInformationUpdate',
        u'PositioningInformationUpdateIEs',
        u'E-CIDMeasurementInitiationRequest',
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand',
        u'E-CIDMeasurementTerminationCommand-IEs',
        ]
    _type_ = [
        u'Reset',
        u'ResetType',
        u'ResetAll',
        u'UE-associatedLogicalF1-ConnectionListRes',
        u'ResetAcknowledge',
        u'UE-associatedLogicalF1-ConnectionListResAck',
        u'ErrorIndication',
        u'F1SetupRequest',
        u'GNB-DU-Served-Cells-List',
        u'F1SetupResponse',
        u'Cells-to-be-Activated-List',
        u'F1SetupFailure',
        u'GNBDUConfigurationUpdate',
        u'Served-Cells-To-Add-List',
        u'Served-Cells-To-Modify-List',
        u'Served-Cells-To-Delete-List',
        u'Cells-Status-List',
        u'Dedicated-SIDelivery-NeededUE-List',
        u'GNB-DU-TNL-Association-To-Remove-List',
        u'GNBDUConfigurationUpdateAcknowledge',
        u'GNBDUConfigurationUpdateFailure',
        u'GNBCUConfigurationUpdate',
        u'Cells-to-be-Deactivated-List',
        u'GNB-CU-TNL-Association-To-Add-List',
        u'GNB-CU-TNL-Association-To-Remove-List',
        u'GNB-CU-TNL-Association-To-Update-List',
        u'Cells-to-be-Barred-List',
        u'Protected-EUTRA-Resources-List',
        u'Neighbour-Cell-Information-List',
        u'GNBCUConfigurationUpdateAcknowledge',
        u'Cells-Failed-to-be-Activated-List',
        u'GNB-CU-TNL-Association-Setup-List',
        u'GNB-CU-TNL-Association-Failed-To-Setup-List',
        u'GNBCUConfigurationUpdateFailure',
        u'GNBDUResourceCoordinationRequest',
        u'GNBDUResourceCoordinationResponse',
        u'UEContextSetupRequest',
        u'Candidate-SpCell-List',
        u'SCell-ToBeSetup-List',
        u'SRBs-ToBeSetup-List',
        u'DRBs-ToBeSetup-List',
        u'BHChannels-ToBeSetup-List',
        u'SLDRBs-ToBeSetup-List',
        u'UEContextSetupResponse',
        u'DRBs-Setup-List',
        u'SRBs-FailedToBeSetup-List',
        u'DRBs-FailedToBeSetup-List',
        u'SCell-FailedtoSetup-List',
        u'SRBs-Setup-List',
        u'BHChannels-Setup-List',
        u'BHChannels-FailedToBeSetup-List',
        u'SLDRBs-Setup-List',
        u'SLDRBs-FailedToBeSetup-List',
        u'UEContextSetupFailure',
        u'Potential-SpCell-List',
        u'UEContextReleaseRequest',
        u'UEContextReleaseCommand',
        u'UEContextReleaseComplete',
        u'UEContextModificationRequest',
        u'SCell-ToBeSetupMod-List',
        u'SCell-ToBeRemoved-List',
        u'SRBs-ToBeSetupMod-List',
        u'DRBs-ToBeSetupMod-List',
        u'BHChannels-ToBeSetupMod-List',
        u'DRBs-ToBeModified-List',
        u'BHChannels-ToBeModified-List',
        u'SRBs-ToBeReleased-List',
        u'DRBs-ToBeReleased-List',
        u'BHChannels-ToBeReleased-List',
        u'SLDRBs-ToBeSetupMod-List',
        u'SLDRBs-ToBeModified-List',
        u'SLDRBs-ToBeReleased-List',
        u'UEContextModificationResponse',
        u'DRBs-SetupMod-List',
        u'DRBs-Modified-List',
        u'SRBs-SetupMod-List',
        u'SRBs-Modified-List',
        u'DRBs-FailedToBeModified-List',
        u'SRBs-FailedToBeSetupMod-List',
        u'DRBs-FailedToBeSetupMod-List',
        u'SCell-FailedtoSetupMod-List',
        u'BHChannels-SetupMod-List',
        u'BHChannels-Modified-List',
        u'BHChannels-FailedToBeModified-List',
        u'BHChannels-FailedToBeSetupMod-List',
        u'Associated-SCell-List',
        u'SLDRBs-SetupMod-List',
        u'SLDRBs-Modified-List',
        u'SLDRBs-FailedToBeModified-List',
        u'SLDRBs-FailedToBeSetupMod-List',
        u'UEContextModificationFailure',
        u'UEContextModificationRequired',
        u'DRBs-Required-ToBeModified-List',
        u'DRBs-Required-ToBeReleased-List',
        u'SRBs-Required-ToBeReleased-List',
        u'BHChannels-Required-ToBeReleased-List',
        u'SLDRBs-Required-ToBeModified-List',
        u'SLDRBs-Required-ToBeReleased-List',
        u'UEContextModificationConfirm',
        u'DRBs-ModifiedConf-List',
        u'SLDRBs-ModifiedConf-List',
        u'UEContextModificationRefuse',
        u'WriteReplaceWarningRequest',
        u'Cells-To-Be-Broadcast-List',
        u'WriteReplaceWarningResponse',
        u'Cells-Broadcast-Completed-List',
        u'PWSCancelRequest',
        u'Broadcast-To-Be-Cancelled-List',
        u'PWSCancelResponse',
        u'Cells-Broadcast-Cancelled-List',
        u'UEInactivityNotification',
        u'DRB-Activity-List',
        u'InitialULRRCMessageTransfer',
        u'DLRRCMessageTransfer',
        u'ULRRCMessageTransfer',
        u'PrivateMessage',
        u'SystemInformationDeliveryCommand',
        u'Paging',
        u'PagingCell-list',
        u'Notify',
        u'DRB-Notify-List',
        u'NetworkAccessRateReduction',
        u'PWSRestartIndication',
        u'NR-CGI-List-For-Restart-List',
        u'PWSFailureIndication',
        u'PWS-Failed-NR-CGI-List',
        u'GNBDUStatusIndication',
        u'RRCDeliveryReport',
        u'F1RemovalRequest',
        u'F1RemovalResponse',
        u'F1RemovalFailure',
        u'TraceStart',
        u'DeactivateTrace',
        u'CellTrafficTrace',
        u'DUCURadioInformationTransfer',
        u'CUDURadioInformationTransfer',
        u'BAPMappingConfiguration',
        u'BH-Routing-Information-Added-List',
        u'BH-Routing-Information-Removed-List',
        u'BAPMappingConfigurationAcknowledge',
        u'BAPMappingConfigurationFailure',
        u'GNBDUResourceConfiguration',
        u'GNBDUResourceConfigurationAcknowledge',
        u'GNBDUResourceConfigurationFailure',
        u'IABTNLAddressRequest',
        u'IAB-TNL-Addresses-To-Remove-List',
        u'IABTNLAddressResponse',
        u'IAB-Allocated-TNL-Address-List',
        u'IABTNLAddressFailure',
        u'IABUPConfigurationUpdateRequest',
        u'UL-UP-TNL-Information-to-Update-List',
        u'UL-UP-TNL-Address-to-Update-List',
        u'IABUPConfigurationUpdateResponse',
        u'DL-UP-TNL-Address-to-Update-List',
        u'IABUPConfigurationUpdateFailure',
        u'ResourceStatusRequest',
        u'ResourceStatusResponse',
        u'ResourceStatusFailure',
        u'ResourceStatusUpdate',
        u'AccessAndMobilityIndication',
        u'ReferenceTimeInformationReportingControl',
        u'ReferenceTimeInformationReport',
        u'AccessSuccess',
        u'PositioningAssistanceInformationControl',
        u'PositioningAssistanceInformationFeedback',
        u'PositioningMeasurementRequest',
        u'PositioningMeasurementResponse',
        u'PositioningMeasurementFailure',
        u'PositioningMeasurementReport',
        u'PositioningMeasurementAbort',
        u'PositioningMeasurementFailureIndication',
        u'PositioningMeasurementUpdate',
        u'TRPInformationRequest',
        u'TRPInformationTypeListTRPReq',
        u'TRPInformationResponse',
        u'TRPInformationListTRPResp',
        u'TRPInformationFailure',
        u'PositioningInformationRequest',
        u'PositioningInformationResponse',
        u'PositioningInformationFailure',
        u'PositioningActivationRequest',
        u'SRSType',
        u'SemipersistentSRS',
        u'AperiodicSRS',
        u'PositioningActivationResponse',
        u'PositioningActivationFailure',
        u'PositioningDeactivation',
        u'PositioningInformationUpdate',
        u'E-CIDMeasurementInitiationRequest',
        u'E-CIDMeasurementInitiationResponse',
        u'E-CIDMeasurementInitiationFailure',
        u'E-CIDMeasurementFailureIndication',
        u'E-CIDMeasurementReport',
        u'E-CIDMeasurementTerminationCommand',
        ]
    _set_ = [
        u'ResetIEs',
        u'ResetType-ExtIEs',
        u'UE-associatedLogicalF1-ConnectionItemRes',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalF1-ConnectionItemResAck',
        u'ErrorIndicationIEs',
        u'F1SetupRequestIEs',
        u'GNB-DU-Served-Cells-ItemIEs',
        u'F1SetupResponseIEs',
        u'Cells-to-be-Activated-List-ItemIEs',
        u'F1SetupFailureIEs',
        u'GNBDUConfigurationUpdateIEs',
        u'Served-Cells-To-Add-ItemIEs',
        u'Served-Cells-To-Modify-ItemIEs',
        u'Served-Cells-To-Delete-ItemIEs',
        u'Cells-Status-ItemIEs',
        u'Dedicated-SIDelivery-NeededUE-ItemIEs',
        u'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        u'GNBDUConfigurationUpdateAcknowledgeIEs',
        u'GNBDUConfigurationUpdateFailureIEs',
        u'GNBCUConfigurationUpdateIEs',
        u'Cells-to-be-Deactivated-List-ItemIEs',
        u'GNB-CU-TNL-Association-To-Add-ItemIEs',
        u'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        u'GNB-CU-TNL-Association-To-Update-ItemIEs',
        u'Cells-to-be-Barred-ItemIEs',
        u'Protected-EUTRA-Resources-ItemIEs',
        u'Neighbour-Cell-Information-ItemIEs',
        u'GNBCUConfigurationUpdateAcknowledgeIEs',
        u'Cells-Failed-to-be-Activated-List-ItemIEs',
        u'GNB-CU-TNL-Association-Setup-ItemIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        u'GNBCUConfigurationUpdateFailureIEs',
        u'GNBDUResourceCoordinationRequest-IEs',
        u'GNBDUResourceCoordinationResponse-IEs',
        u'UEContextSetupRequestIEs',
        u'Candidate-SpCell-ItemIEs',
        u'SCell-ToBeSetup-ItemIEs',
        u'SRBs-ToBeSetup-ItemIEs',
        u'DRBs-ToBeSetup-ItemIEs',
        u'BHChannels-ToBeSetup-ItemIEs',
        u'SLDRBs-ToBeSetup-ItemIEs',
        u'UEContextSetupResponseIEs',
        u'DRBs-Setup-ItemIEs',
        u'SRBs-Setup-ItemIEs',
        u'SRBs-FailedToBeSetup-ItemIEs',
        u'DRBs-FailedToBeSetup-ItemIEs',
        u'SCell-FailedtoSetup-ItemIEs',
        u'BHChannels-Setup-ItemIEs',
        u'BHChannels-FailedToBeSetup-ItemIEs',
        u'SLDRBs-Setup-ItemIEs',
        u'SLDRBs-FailedToBeSetup-ItemIEs',
        u'UEContextSetupFailureIEs',
        u'Potential-SpCell-ItemIEs',
        u'UEContextReleaseRequestIEs',
        u'UEContextReleaseCommandIEs',
        u'UEContextReleaseCompleteIEs',
        u'UEContextModificationRequestIEs',
        u'SCell-ToBeSetupMod-ItemIEs',
        u'SCell-ToBeRemoved-ItemIEs',
        u'SRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeModified-ItemIEs',
        u'SRBs-ToBeReleased-ItemIEs',
        u'DRBs-ToBeReleased-ItemIEs',
        u'BHChannels-ToBeSetupMod-ItemIEs',
        u'BHChannels-ToBeModified-ItemIEs',
        u'BHChannels-ToBeReleased-ItemIEs',
        u'SLDRBs-ToBeSetupMod-ItemIEs',
        u'SLDRBs-ToBeModified-ItemIEs',
        u'SLDRBs-ToBeReleased-ItemIEs',
        u'UEContextModificationResponseIEs',
        u'DRBs-SetupMod-ItemIEs',
        u'DRBs-Modified-ItemIEs',
        u'SRBs-SetupMod-ItemIEs',
        u'SRBs-Modified-ItemIEs',
        u'SRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeModified-ItemIEs',
        u'SCell-FailedtoSetupMod-ItemIEs',
        u'Associated-SCell-ItemIEs',
        u'BHChannels-SetupMod-ItemIEs',
        u'BHChannels-Modified-ItemIEs',
        u'BHChannels-FailedToBeSetupMod-ItemIEs',
        u'BHChannels-FailedToBeModified-ItemIEs',
        u'SLDRBs-SetupMod-ItemIEs',
        u'SLDRBs-Modified-ItemIEs',
        u'SLDRBs-FailedToBeSetupMod-ItemIEs',
        u'SLDRBs-FailedToBeModified-ItemIEs',
        u'UEContextModificationFailureIEs',
        u'UEContextModificationRequiredIEs',
        u'DRBs-Required-ToBeModified-ItemIEs',
        u'DRBs-Required-ToBeReleased-ItemIEs',
        u'SRBs-Required-ToBeReleased-ItemIEs',
        u'BHChannels-Required-ToBeReleased-ItemIEs',
        u'SLDRBs-Required-ToBeModified-ItemIEs',
        u'SLDRBs-Required-ToBeReleased-ItemIEs',
        u'UEContextModificationConfirmIEs',
        u'DRBs-ModifiedConf-ItemIEs',
        u'SLDRBs-ModifiedConf-ItemIEs',
        u'UEContextModificationRefuseIEs',
        u'WriteReplaceWarningRequestIEs',
        u'Cells-To-Be-Broadcast-List-ItemIEs',
        u'WriteReplaceWarningResponseIEs',
        u'Cells-Broadcast-Completed-List-ItemIEs',
        u'PWSCancelRequestIEs',
        u'Broadcast-To-Be-Cancelled-List-ItemIEs',
        u'PWSCancelResponseIEs',
        u'Cells-Broadcast-Cancelled-List-ItemIEs',
        u'UEInactivityNotificationIEs',
        u'DRB-Activity-ItemIEs',
        u'InitialULRRCMessageTransferIEs',
        u'DLRRCMessageTransferIEs',
        u'ULRRCMessageTransferIEs',
        u'PrivateMessage-IEs',
        u'SystemInformationDeliveryCommandIEs',
        u'PagingIEs',
        u'PagingCell-ItemIEs',
        u'NotifyIEs',
        u'DRB-Notify-ItemIEs',
        u'NetworkAccessRateReductionIEs',
        u'PWSRestartIndicationIEs',
        u'NR-CGI-List-For-Restart-List-ItemIEs',
        u'PWSFailureIndicationIEs',
        u'PWS-Failed-NR-CGI-List-ItemIEs',
        u'GNBDUStatusIndicationIEs',
        u'RRCDeliveryReportIEs',
        u'F1RemovalRequestIEs',
        u'F1RemovalResponseIEs',
        u'F1RemovalFailureIEs',
        u'TraceStartIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'DUCURadioInformationTransferIEs',
        u'CUDURadioInformationTransferIEs',
        u'BAPMappingConfiguration-IEs',
        u'BH-Routing-Information-Added-List-ItemIEs',
        u'BH-Routing-Information-Removed-List-ItemIEs',
        u'BAPMappingConfigurationAcknowledge-IEs',
        u'BAPMappingConfigurationFailureIEs',
        u'GNBDUResourceConfigurationIEs',
        u'GNBDUResourceConfigurationAcknowledgeIEs',
        u'GNBDUResourceConfigurationFailureIEs',
        u'IABTNLAddressRequestIEs',
        u'IAB-TNL-Addresses-To-Remove-ItemIEs',
        u'IABTNLAddressResponseIEs',
        u'IAB-Allocated-TNL-Address-List-ItemIEs',
        u'IABTNLAddressFailureIEs',
        u'IABUPConfigurationUpdateRequestIEs',
        u'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        u'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateResponseIEs',
        u'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateFailureIEs',
        u'ResourceStatusRequestIEs',
        u'ResourceStatusResponseIEs',
        u'ResourceStatusFailureIEs',
        u'ResourceStatusUpdateIEs',
        u'AccessAndMobilityIndicationIEs',
        u'ReferenceTimeInformationReportingControlIEs',
        u'ReferenceTimeInformationReportIEs',
        u'AccessSuccessIEs',
        u'PositioningAssistanceInformationControlIEs',
        u'PositioningAssistanceInformationFeedbackIEs',
        u'PositioningMeasurementRequestIEs',
        u'PositioningMeasurementResponseIEs',
        u'PositioningMeasurementFailureIEs',
        u'PositioningMeasurementReportIEs',
        u'PositioningMeasurementAbortIEs',
        u'PositioningMeasurementFailureIndicationIEs',
        u'PositioningMeasurementUpdateIEs',
        u'TRPInformationRequestIEs',
        u'TRPInformationTypeItemTRPReq',
        u'TRPInformationResponseIEs',
        u'TRPInformationItemTRPResp',
        u'TRPInformationFailureIEs',
        u'PositioningInformationRequestIEs',
        u'PositioningInformationResponseIEs',
        u'PositioningInformationFailureIEs',
        u'PositioningActivationRequestIEs',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivationIEs',
        u'PositioningInformationUpdateIEs',
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'ResetIEs',
        u'ResetType-ExtIEs',
        u'UE-associatedLogicalF1-ConnectionItemRes',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalF1-ConnectionItemResAck',
        u'ErrorIndicationIEs',
        u'F1SetupRequestIEs',
        u'GNB-DU-Served-Cells-ItemIEs',
        u'F1SetupResponseIEs',
        u'Cells-to-be-Activated-List-ItemIEs',
        u'F1SetupFailureIEs',
        u'GNBDUConfigurationUpdateIEs',
        u'Served-Cells-To-Add-ItemIEs',
        u'Served-Cells-To-Modify-ItemIEs',
        u'Served-Cells-To-Delete-ItemIEs',
        u'Cells-Status-ItemIEs',
        u'Dedicated-SIDelivery-NeededUE-ItemIEs',
        u'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        u'GNBDUConfigurationUpdateAcknowledgeIEs',
        u'GNBDUConfigurationUpdateFailureIEs',
        u'GNBCUConfigurationUpdateIEs',
        u'Cells-to-be-Deactivated-List-ItemIEs',
        u'GNB-CU-TNL-Association-To-Add-ItemIEs',
        u'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        u'GNB-CU-TNL-Association-To-Update-ItemIEs',
        u'Cells-to-be-Barred-ItemIEs',
        u'Protected-EUTRA-Resources-ItemIEs',
        u'Neighbour-Cell-Information-ItemIEs',
        u'GNBCUConfigurationUpdateAcknowledgeIEs',
        u'Cells-Failed-to-be-Activated-List-ItemIEs',
        u'GNB-CU-TNL-Association-Setup-ItemIEs',
        u'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        u'GNBCUConfigurationUpdateFailureIEs',
        u'GNBDUResourceCoordinationRequest-IEs',
        u'GNBDUResourceCoordinationResponse-IEs',
        u'UEContextSetupRequestIEs',
        u'Candidate-SpCell-ItemIEs',
        u'SCell-ToBeSetup-ItemIEs',
        u'SRBs-ToBeSetup-ItemIEs',
        u'DRBs-ToBeSetup-ItemIEs',
        u'BHChannels-ToBeSetup-ItemIEs',
        u'SLDRBs-ToBeSetup-ItemIEs',
        u'UEContextSetupResponseIEs',
        u'DRBs-Setup-ItemIEs',
        u'SRBs-Setup-ItemIEs',
        u'SRBs-FailedToBeSetup-ItemIEs',
        u'DRBs-FailedToBeSetup-ItemIEs',
        u'SCell-FailedtoSetup-ItemIEs',
        u'BHChannels-Setup-ItemIEs',
        u'BHChannels-FailedToBeSetup-ItemIEs',
        u'SLDRBs-Setup-ItemIEs',
        u'SLDRBs-FailedToBeSetup-ItemIEs',
        u'UEContextSetupFailureIEs',
        u'Potential-SpCell-ItemIEs',
        u'UEContextReleaseRequestIEs',
        u'UEContextReleaseCommandIEs',
        u'UEContextReleaseCompleteIEs',
        u'UEContextModificationRequestIEs',
        u'SCell-ToBeSetupMod-ItemIEs',
        u'SCell-ToBeRemoved-ItemIEs',
        u'SRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeSetupMod-ItemIEs',
        u'DRBs-ToBeModified-ItemIEs',
        u'SRBs-ToBeReleased-ItemIEs',
        u'DRBs-ToBeReleased-ItemIEs',
        u'BHChannels-ToBeSetupMod-ItemIEs',
        u'BHChannels-ToBeModified-ItemIEs',
        u'BHChannels-ToBeReleased-ItemIEs',
        u'SLDRBs-ToBeSetupMod-ItemIEs',
        u'SLDRBs-ToBeModified-ItemIEs',
        u'SLDRBs-ToBeReleased-ItemIEs',
        u'UEContextModificationResponseIEs',
        u'DRBs-SetupMod-ItemIEs',
        u'DRBs-Modified-ItemIEs',
        u'SRBs-SetupMod-ItemIEs',
        u'SRBs-Modified-ItemIEs',
        u'SRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeSetupMod-ItemIEs',
        u'DRBs-FailedToBeModified-ItemIEs',
        u'SCell-FailedtoSetupMod-ItemIEs',
        u'Associated-SCell-ItemIEs',
        u'BHChannels-SetupMod-ItemIEs',
        u'BHChannels-Modified-ItemIEs',
        u'BHChannels-FailedToBeSetupMod-ItemIEs',
        u'BHChannels-FailedToBeModified-ItemIEs',
        u'SLDRBs-SetupMod-ItemIEs',
        u'SLDRBs-Modified-ItemIEs',
        u'SLDRBs-FailedToBeSetupMod-ItemIEs',
        u'SLDRBs-FailedToBeModified-ItemIEs',
        u'UEContextModificationFailureIEs',
        u'UEContextModificationRequiredIEs',
        u'DRBs-Required-ToBeModified-ItemIEs',
        u'DRBs-Required-ToBeReleased-ItemIEs',
        u'SRBs-Required-ToBeReleased-ItemIEs',
        u'BHChannels-Required-ToBeReleased-ItemIEs',
        u'SLDRBs-Required-ToBeModified-ItemIEs',
        u'SLDRBs-Required-ToBeReleased-ItemIEs',
        u'UEContextModificationConfirmIEs',
        u'DRBs-ModifiedConf-ItemIEs',
        u'SLDRBs-ModifiedConf-ItemIEs',
        u'UEContextModificationRefuseIEs',
        u'WriteReplaceWarningRequestIEs',
        u'Cells-To-Be-Broadcast-List-ItemIEs',
        u'WriteReplaceWarningResponseIEs',
        u'Cells-Broadcast-Completed-List-ItemIEs',
        u'PWSCancelRequestIEs',
        u'Broadcast-To-Be-Cancelled-List-ItemIEs',
        u'PWSCancelResponseIEs',
        u'Cells-Broadcast-Cancelled-List-ItemIEs',
        u'UEInactivityNotificationIEs',
        u'DRB-Activity-ItemIEs',
        u'InitialULRRCMessageTransferIEs',
        u'DLRRCMessageTransferIEs',
        u'ULRRCMessageTransferIEs',
        u'PrivateMessage-IEs',
        u'SystemInformationDeliveryCommandIEs',
        u'PagingIEs',
        u'PagingCell-ItemIEs',
        u'NotifyIEs',
        u'DRB-Notify-ItemIEs',
        u'NetworkAccessRateReductionIEs',
        u'PWSRestartIndicationIEs',
        u'NR-CGI-List-For-Restart-List-ItemIEs',
        u'PWSFailureIndicationIEs',
        u'PWS-Failed-NR-CGI-List-ItemIEs',
        u'GNBDUStatusIndicationIEs',
        u'RRCDeliveryReportIEs',
        u'F1RemovalRequestIEs',
        u'F1RemovalResponseIEs',
        u'F1RemovalFailureIEs',
        u'TraceStartIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'DUCURadioInformationTransferIEs',
        u'CUDURadioInformationTransferIEs',
        u'BAPMappingConfiguration-IEs',
        u'BH-Routing-Information-Added-List-ItemIEs',
        u'BH-Routing-Information-Removed-List-ItemIEs',
        u'BAPMappingConfigurationAcknowledge-IEs',
        u'BAPMappingConfigurationFailureIEs',
        u'GNBDUResourceConfigurationIEs',
        u'GNBDUResourceConfigurationAcknowledgeIEs',
        u'GNBDUResourceConfigurationFailureIEs',
        u'IABTNLAddressRequestIEs',
        u'IAB-TNL-Addresses-To-Remove-ItemIEs',
        u'IABTNLAddressResponseIEs',
        u'IAB-Allocated-TNL-Address-List-ItemIEs',
        u'IABTNLAddressFailureIEs',
        u'IABUPConfigurationUpdateRequestIEs',
        u'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        u'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateResponseIEs',
        u'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        u'IABUPConfigurationUpdateFailureIEs',
        u'ResourceStatusRequestIEs',
        u'ResourceStatusResponseIEs',
        u'ResourceStatusFailureIEs',
        u'ResourceStatusUpdateIEs',
        u'AccessAndMobilityIndicationIEs',
        u'ReferenceTimeInformationReportingControlIEs',
        u'ReferenceTimeInformationReportIEs',
        u'AccessSuccessIEs',
        u'PositioningAssistanceInformationControlIEs',
        u'PositioningAssistanceInformationFeedbackIEs',
        u'PositioningMeasurementRequestIEs',
        u'PositioningMeasurementResponseIEs',
        u'PositioningMeasurementFailureIEs',
        u'PositioningMeasurementReportIEs',
        u'PositioningMeasurementAbortIEs',
        u'PositioningMeasurementFailureIndicationIEs',
        u'PositioningMeasurementUpdateIEs',
        u'TRPInformationRequestIEs',
        u'TRPInformationTypeItemTRPReq',
        u'TRPInformationResponseIEs',
        u'TRPInformationItemTRPResp',
        u'TRPInformationFailureIEs',
        u'PositioningInformationRequestIEs',
        u'PositioningInformationResponseIEs',
        u'PositioningInformationFailureIEs',
        u'PositioningActivationRequestIEs',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivationIEs',
        u'PositioningInformationUpdateIEs',
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand-IEs',
        ]
    _param_ = [
        ]
    
    #-----< Reset >-----#
    Reset = SEQ(name=u'Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetType')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = u'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__value._const_tab_id = u'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Reset_protocolIEs__item__id),
        (u'criticality', ___Reset_protocolIEs__item__criticality),
        (u'value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        (u'protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name=u'ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResetIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ResetIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetType')))
    ResetIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResetIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ResetIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _ResetIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name=u'ResetType', mode=MODE_TYPE)
    _ResetType_f1_Interface = ENUM(name=u'f1-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAll')))
    _ResetType_partOfF1_Interface = SEQ_OF(name=u'partOfF1-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListRes')))
    _ResetType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResetType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___ResetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_id._const_tab = ___ResetType_choice_extension_id_tab
    __ResetType_choice_extension_id._const_tab_at = None
    __ResetType_choice_extension_id._const_tab_id = u'id'
    __ResetType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_criticality._const_tab = ___ResetType_choice_extension_criticality_tab
    __ResetType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResetType_choice_extension_criticality._const_tab_id = u'criticality'
    __ResetType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_value._const_tab = ___ResetType_choice_extension_value_tab
    __ResetType_choice_extension_value._const_tab_at = ('..', u'id')
    __ResetType_choice_extension_value._const_tab_id = u'Value'
    _ResetType_choice_extension._cont = ASN1Dict([
        (u'id', __ResetType_choice_extension_id),
        (u'criticality', __ResetType_choice_extension_criticality),
        (u'value', __ResetType_choice_extension_value),
        ])
    _ResetType_choice_extension._ext = None
    ResetType._cont = ASN1Dict([
        (u'f1-Interface', _ResetType_f1_Interface),
        (u'partOfF1-Interface', _ResetType_partOfF1_Interface),
        (u'choice-extension', _ResetType_choice_extension),
        ])
    ResetType._ext = None
    
    #-----< ResetType-ExtIEs >-----#
    ResetType_ExtIEs = CLASS(name=u'ResetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name=u'ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([(u'reset-all', 0)])
    ResetAll._ext = []
    
    #-----< UE-associatedLogicalF1-ConnectionListRes >-----#
    UE_associatedLogicalF1_ConnectionListRes = SEQ_OF(name=u'UE-associatedLogicalF1-ConnectionListRes', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionListRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalF1_ConnectionListRes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab_at = None
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab_id = u'id'
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab_at = ('..', u'id')
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab_id = u'criticality'
    __UE_associatedLogicalF1_ConnectionListRes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab_at = ('..', u'id')
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab_id = u'Value'
    _UE_associatedLogicalF1_ConnectionListRes__item_._cont = ASN1Dict([
        (u'id', __UE_associatedLogicalF1_ConnectionListRes__item__id),
        (u'criticality', __UE_associatedLogicalF1_ConnectionListRes__item__criticality),
        (u'value', __UE_associatedLogicalF1_ConnectionListRes__item__value),
        ])
    _UE_associatedLogicalF1_ConnectionListRes__item_._ext = None
    UE_associatedLogicalF1_ConnectionListRes._cont = _UE_associatedLogicalF1_ConnectionListRes__item_
    UE_associatedLogicalF1_ConnectionListRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItemRes >-----#
    UE_associatedLogicalF1_ConnectionItemRes = CLASS(name=u'UE-associatedLogicalF1-ConnectionItemRes', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    UE_associatedLogicalF1_ConnectionItemRes._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name=u'ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListResAck')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ResetAcknowledge_protocolIEs),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name=u'ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListResAck')))
    _ResetAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResetAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionListResAck >-----#
    UE_associatedLogicalF1_ConnectionListResAck = SEQ_OF(name=u'UE-associatedLogicalF1-ConnectionListResAck', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionListResAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalF1_ConnectionListResAck__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab_at = None
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab_id = u'id'
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab_at = ('..', u'id')
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab_id = u'criticality'
    __UE_associatedLogicalF1_ConnectionListResAck__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab_at = ('..', u'id')
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab_id = u'Value'
    _UE_associatedLogicalF1_ConnectionListResAck__item_._cont = ASN1Dict([
        (u'id', __UE_associatedLogicalF1_ConnectionListResAck__item__id),
        (u'criticality', __UE_associatedLogicalF1_ConnectionListResAck__item__criticality),
        (u'value', __UE_associatedLogicalF1_ConnectionListResAck__item__value),
        ])
    _UE_associatedLogicalF1_ConnectionListResAck__item_._ext = None
    UE_associatedLogicalF1_ConnectionListResAck._cont = _UE_associatedLogicalF1_ConnectionListResAck__item_
    UE_associatedLogicalF1_ConnectionListResAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItemResAck >-----#
    UE_associatedLogicalF1_ConnectionItemResAck = CLASS(name=u'UE-associatedLogicalF1-ConnectionItemResAck', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    UE_associatedLogicalF1_ConnectionItemResAck._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name=u'ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _ErrorIndicationIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _ErrorIndicationIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ErrorIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupRequest >-----#
    F1SetupRequest = SEQ(name=u'F1SetupRequest', mode=MODE_TYPE)
    _F1SetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-Served-Cells-List')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    ____F1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 427), (u'criticality', u'ignore'), (u'Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F1SetupRequest_protocolIEs__item__id._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___F1SetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___F1SetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1SetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1SetupRequest_protocolIEs__item__value._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1SetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __F1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1SetupRequest_protocolIEs__item__id),
        (u'criticality', ___F1SetupRequest_protocolIEs__item__criticality),
        (u'value', ___F1SetupRequest_protocolIEs__item__value),
        ])
    __F1SetupRequest_protocolIEs__item_._ext = None
    _F1SetupRequest_protocolIEs._cont = __F1SetupRequest_protocolIEs__item_
    _F1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _F1SetupRequest_protocolIEs),
        ])
    F1SetupRequest._ext = []
    
    #-----< F1SetupRequestIEs >-----#
    F1SetupRequestIEs = CLASS(name=u'F1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _F1SetupRequestIEs_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _F1SetupRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-Served-Cells-List')))
    _F1SetupRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _F1SetupRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _F1SetupRequestIEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _F1SetupRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    F1SetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1SetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _F1SetupRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _F1SetupRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _F1SetupRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Value', _F1SetupRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _F1SetupRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _F1SetupRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 427), (u'criticality', u'ignore'), (u'Value', _F1SetupRequestIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-Served-Cells-List >-----#
    GNB_DU_Served_Cells_List = SEQ_OF(name=u'GNB-DU-Served-Cells-List', mode=MODE_TYPE)
    _GNB_DU_Served_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_DU_Served_Cells_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_DU_Served_Cells_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Served-Cells-Item')))
    ___GNB_DU_Served_Cells_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_DU_Served_Cells_List__item__id._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__id._const_tab_at = None
    __GNB_DU_Served_Cells_List__item__id._const_tab_id = u'id'
    __GNB_DU_Served_Cells_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_DU_Served_Cells_List__item__criticality._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_DU_Served_Cells_List__item__criticality._const_tab_id = u'criticality'
    __GNB_DU_Served_Cells_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_DU_Served_Cells_List__item__value._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__value._const_tab_at = ('..', u'id')
    __GNB_DU_Served_Cells_List__item__value._const_tab_id = u'Value'
    _GNB_DU_Served_Cells_List__item_._cont = ASN1Dict([
        (u'id', __GNB_DU_Served_Cells_List__item__id),
        (u'criticality', __GNB_DU_Served_Cells_List__item__criticality),
        (u'value', __GNB_DU_Served_Cells_List__item__value),
        ])
    _GNB_DU_Served_Cells_List__item_._ext = None
    GNB_DU_Served_Cells_List._cont = _GNB_DU_Served_Cells_List__item_
    GNB_DU_Served_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-DU-Served-Cells-ItemIEs >-----#
    GNB_DU_Served_Cells_ItemIEs = CLASS(name=u'GNB-DU-Served-Cells-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_DU_Served_Cells_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Served-Cells-Item')))
    GNB_DU_Served_Cells_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _GNB_DU_Served_Cells_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupResponse >-----#
    F1SetupResponse = SEQ(name=u'F1SetupResponse', mode=MODE_TYPE)
    _F1SetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    ____F1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'reject'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 426), (u'criticality', u'ignore'), (u'Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F1SetupResponse_protocolIEs__item__id._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___F1SetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___F1SetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1SetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1SetupResponse_protocolIEs__item__value._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1SetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __F1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1SetupResponse_protocolIEs__item__id),
        (u'criticality', ___F1SetupResponse_protocolIEs__item__criticality),
        (u'value', ___F1SetupResponse_protocolIEs__item__value),
        ])
    __F1SetupResponse_protocolIEs__item_._ext = None
    _F1SetupResponse_protocolIEs._cont = __F1SetupResponse_protocolIEs__item_
    _F1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _F1SetupResponse_protocolIEs),
        ])
    F1SetupResponse._ext = []
    
    #-----< F1SetupResponseIEs >-----#
    F1SetupResponseIEs = CLASS(name=u'F1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupResponseIEs_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _F1SetupResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _F1SetupResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _F1SetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _F1SetupResponseIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _F1SetupResponseIEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _F1SetupResponseIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    F1SetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1SetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _F1SetupResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _F1SetupResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'reject'), (u'Value', _F1SetupResponseIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _F1SetupResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _F1SetupResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _F1SetupResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 426), (u'criticality', u'ignore'), (u'Value', _F1SetupResponseIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Activated-List >-----#
    Cells_to_be_Activated_List = SEQ_OF(name=u'Cells-to-be-Activated-List', mode=MODE_TYPE)
    _Cells_to_be_Activated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Activated_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_to_be_Activated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Activated_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Activated-List-Item')))
    ___Cells_to_be_Activated_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', ____Cells_to_be_Activated_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Activated_List__item__id._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__id._const_tab_at = None
    __Cells_to_be_Activated_List__item__id._const_tab_id = u'id'
    __Cells_to_be_Activated_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_to_be_Activated_List__item__criticality._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_to_be_Activated_List__item__criticality._const_tab_id = u'criticality'
    __Cells_to_be_Activated_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_to_be_Activated_List__item__value._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__value._const_tab_at = ('..', u'id')
    __Cells_to_be_Activated_List__item__value._const_tab_id = u'Value'
    _Cells_to_be_Activated_List__item_._cont = ASN1Dict([
        (u'id', __Cells_to_be_Activated_List__item__id),
        (u'criticality', __Cells_to_be_Activated_List__item__criticality),
        (u'value', __Cells_to_be_Activated_List__item__value),
        ])
    _Cells_to_be_Activated_List__item_._ext = None
    Cells_to_be_Activated_List._cont = _Cells_to_be_Activated_List__item_
    Cells_to_be_Activated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-to-be-Activated-List-ItemIEs >-----#
    Cells_to_be_Activated_List_ItemIEs = CLASS(name=u'Cells-to-be-Activated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Activated_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Activated-List-Item')))
    Cells_to_be_Activated_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _Cells_to_be_Activated_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupFailure >-----#
    F1SetupFailure = SEQ(name=u'F1SetupFailure', mode=MODE_TYPE)
    _F1SetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F1SetupFailure_protocolIEs__item__id._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___F1SetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___F1SetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1SetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1SetupFailure_protocolIEs__item__value._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1SetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __F1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1SetupFailure_protocolIEs__item__id),
        (u'criticality', ___F1SetupFailure_protocolIEs__item__criticality),
        (u'value', ___F1SetupFailure_protocolIEs__item__value),
        ])
    __F1SetupFailure_protocolIEs__item_._ext = None
    _F1SetupFailure_protocolIEs._cont = __F1SetupFailure_protocolIEs__item_
    _F1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _F1SetupFailure_protocolIEs),
        ])
    F1SetupFailure._ext = []
    
    #-----< F1SetupFailureIEs >-----#
    F1SetupFailureIEs = CLASS(name=u'F1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _F1SetupFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _F1SetupFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1SetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1SetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _F1SetupFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _F1SetupFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _F1SetupFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdate >-----#
    GNBDUConfigurationUpdate = SEQ(name=u'GNBDUConfigurationUpdate', mode=MODE_TYPE)
    _GNBDUConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Add-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Modify-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Delete-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Status-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-TNL-Association-To-Remove-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 427), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___GNBDUConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___GNBDUConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdate_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdate_protocolIEs._cont = __GNBDUConfigurationUpdate_protocolIEs__item_
    _GNBDUConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUConfigurationUpdate_protocolIEs),
        ])
    GNBDUConfigurationUpdate._ext = []
    
    #-----< GNBDUConfigurationUpdateIEs >-----#
    GNBDUConfigurationUpdateIEs = CLASS(name=u'GNBDUConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Add-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Modify-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Delete-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Status-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _GNBDUConfigurationUpdateIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-TNL-Association-To-Remove-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBDUConfigurationUpdateIEs_val_Value_9 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _GNBDUConfigurationUpdateIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    GNBDUConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 427), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateIEs_val_Value_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Add-List >-----#
    Served_Cells_To_Add_List = SEQ_OF(name=u'Served-Cells-To-Add-List', mode=MODE_TYPE)
    _Served_Cells_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Add_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Served_Cells_To_Add_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Add_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Add-Item')))
    ___Served_Cells_To_Add_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', ____Served_Cells_To_Add_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Add_List__item__id._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__id._const_tab_at = None
    __Served_Cells_To_Add_List__item__id._const_tab_id = u'id'
    __Served_Cells_To_Add_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Served_Cells_To_Add_List__item__criticality._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__criticality._const_tab_at = ('..', u'id')
    __Served_Cells_To_Add_List__item__criticality._const_tab_id = u'criticality'
    __Served_Cells_To_Add_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Served_Cells_To_Add_List__item__value._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__value._const_tab_at = ('..', u'id')
    __Served_Cells_To_Add_List__item__value._const_tab_id = u'Value'
    _Served_Cells_To_Add_List__item_._cont = ASN1Dict([
        (u'id', __Served_Cells_To_Add_List__item__id),
        (u'criticality', __Served_Cells_To_Add_List__item__criticality),
        (u'value', __Served_Cells_To_Add_List__item__value),
        ])
    _Served_Cells_To_Add_List__item_._ext = None
    Served_Cells_To_Add_List._cont = _Served_Cells_To_Add_List__item_
    Served_Cells_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Served-Cells-To-Modify-List >-----#
    Served_Cells_To_Modify_List = SEQ_OF(name=u'Served-Cells-To-Modify-List', mode=MODE_TYPE)
    _Served_Cells_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Modify_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Served_Cells_To_Modify_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Modify-Item')))
    ___Served_Cells_To_Modify_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Modify_List__item__id._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__id._const_tab_at = None
    __Served_Cells_To_Modify_List__item__id._const_tab_id = u'id'
    __Served_Cells_To_Modify_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Served_Cells_To_Modify_List__item__criticality._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__criticality._const_tab_at = ('..', u'id')
    __Served_Cells_To_Modify_List__item__criticality._const_tab_id = u'criticality'
    __Served_Cells_To_Modify_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Served_Cells_To_Modify_List__item__value._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__value._const_tab_at = ('..', u'id')
    __Served_Cells_To_Modify_List__item__value._const_tab_id = u'Value'
    _Served_Cells_To_Modify_List__item_._cont = ASN1Dict([
        (u'id', __Served_Cells_To_Modify_List__item__id),
        (u'criticality', __Served_Cells_To_Modify_List__item__criticality),
        (u'value', __Served_Cells_To_Modify_List__item__value),
        ])
    _Served_Cells_To_Modify_List__item_._ext = None
    Served_Cells_To_Modify_List._cont = _Served_Cells_To_Modify_List__item_
    Served_Cells_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Served-Cells-To-Delete-List >-----#
    Served_Cells_To_Delete_List = SEQ_OF(name=u'Served-Cells-To-Delete-List', mode=MODE_TYPE)
    _Served_Cells_To_Delete_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Delete_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Served_Cells_To_Delete_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Delete-Item')))
    ___Served_Cells_To_Delete_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Delete_List__item__id._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__id._const_tab_at = None
    __Served_Cells_To_Delete_List__item__id._const_tab_id = u'id'
    __Served_Cells_To_Delete_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Served_Cells_To_Delete_List__item__criticality._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__criticality._const_tab_at = ('..', u'id')
    __Served_Cells_To_Delete_List__item__criticality._const_tab_id = u'criticality'
    __Served_Cells_To_Delete_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Served_Cells_To_Delete_List__item__value._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__value._const_tab_at = ('..', u'id')
    __Served_Cells_To_Delete_List__item__value._const_tab_id = u'Value'
    _Served_Cells_To_Delete_List__item_._cont = ASN1Dict([
        (u'id', __Served_Cells_To_Delete_List__item__id),
        (u'criticality', __Served_Cells_To_Delete_List__item__criticality),
        (u'value', __Served_Cells_To_Delete_List__item__value),
        ])
    _Served_Cells_To_Delete_List__item_._ext = None
    Served_Cells_To_Delete_List._cont = _Served_Cells_To_Delete_List__item_
    Served_Cells_To_Delete_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Status-List >-----#
    Cells_Status_List = SEQ_OF(name=u'Cells-Status-List', mode=MODE_TYPE)
    _Cells_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Status_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_Status_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Status_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Status-Item')))
    ___Cells_Status_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', ____Cells_Status_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Status_List__item__id._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__id._const_tab_at = None
    __Cells_Status_List__item__id._const_tab_id = u'id'
    __Cells_Status_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_Status_List__item__criticality._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_Status_List__item__criticality._const_tab_id = u'criticality'
    __Cells_Status_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_Status_List__item__value._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__value._const_tab_at = ('..', u'id')
    __Cells_Status_List__item__value._const_tab_id = u'Value'
    _Cells_Status_List__item_._cont = ASN1Dict([
        (u'id', __Cells_Status_List__item__id),
        (u'criticality', __Cells_Status_List__item__criticality),
        (u'value', __Cells_Status_List__item__value),
        ])
    _Cells_Status_List__item_._ext = None
    Cells_Status_List._cont = _Cells_Status_List__item_
    Cells_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< Dedicated-SIDelivery-NeededUE-List >-----#
    Dedicated_SIDelivery_NeededUE_List = SEQ_OF(name=u'Dedicated-SIDelivery-NeededUE-List', mode=MODE_TYPE)
    _Dedicated_SIDelivery_NeededUE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Dedicated_SIDelivery_NeededUE_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Dedicated_SIDelivery_NeededUE_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Dedicated-SIDelivery-NeededUE-Item')))
    ___Dedicated_SIDelivery_NeededUE_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab_at = None
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab_id = u'id'
    __Dedicated_SIDelivery_NeededUE_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab_at = ('..', u'id')
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab_id = u'criticality'
    __Dedicated_SIDelivery_NeededUE_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab_at = ('..', u'id')
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab_id = u'Value'
    _Dedicated_SIDelivery_NeededUE_List__item_._cont = ASN1Dict([
        (u'id', __Dedicated_SIDelivery_NeededUE_List__item__id),
        (u'criticality', __Dedicated_SIDelivery_NeededUE_List__item__criticality),
        (u'value', __Dedicated_SIDelivery_NeededUE_List__item__value),
        ])
    _Dedicated_SIDelivery_NeededUE_List__item_._ext = None
    Dedicated_SIDelivery_NeededUE_List._cont = _Dedicated_SIDelivery_NeededUE_List__item_
    Dedicated_SIDelivery_NeededUE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< GNB-DU-TNL-Association-To-Remove-List >-----#
    GNB_DU_TNL_Association_To_Remove_List = SEQ_OF(name=u'GNB-DU-TNL-Association-To-Remove-List', mode=MODE_TYPE)
    _GNB_DU_TNL_Association_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_DU_TNL_Association_To_Remove_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-TNL-Association-To-Remove-Item')))
    ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab_at = None
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab_id = u'id'
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab_id = u'criticality'
    __GNB_DU_TNL_Association_To_Remove_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab_at = ('..', u'id')
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab_id = u'Value'
    _GNB_DU_TNL_Association_To_Remove_List__item_._cont = ASN1Dict([
        (u'id', __GNB_DU_TNL_Association_To_Remove_List__item__id),
        (u'criticality', __GNB_DU_TNL_Association_To_Remove_List__item__criticality),
        (u'value', __GNB_DU_TNL_Association_To_Remove_List__item__value),
        ])
    _GNB_DU_TNL_Association_To_Remove_List__item_._ext = None
    GNB_DU_TNL_Association_To_Remove_List._cont = _GNB_DU_TNL_Association_To_Remove_List__item_
    GNB_DU_TNL_Association_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Served-Cells-To-Add-ItemIEs >-----#
    Served_Cells_To_Add_ItemIEs = CLASS(name=u'Served-Cells-To-Add-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Add_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Add-Item')))
    Served_Cells_To_Add_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', _Served_Cells_To_Add_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Modify-ItemIEs >-----#
    Served_Cells_To_Modify_ItemIEs = CLASS(name=u'Served-Cells-To-Modify-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Modify_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Modify-Item')))
    Served_Cells_To_Modify_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _Served_Cells_To_Modify_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Delete-ItemIEs >-----#
    Served_Cells_To_Delete_ItemIEs = CLASS(name=u'Served-Cells-To-Delete-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Delete_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Delete-Item')))
    Served_Cells_To_Delete_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _Served_Cells_To_Delete_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Status-ItemIEs >-----#
    Cells_Status_ItemIEs = CLASS(name=u'Cells-Status-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Status_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Status-Item')))
    Cells_Status_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', _Cells_Status_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Dedicated-SIDelivery-NeededUE-ItemIEs >-----#
    Dedicated_SIDelivery_NeededUE_ItemIEs = CLASS(name=u'Dedicated-SIDelivery-NeededUE-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Dedicated-SIDelivery-NeededUE-Item')))
    Dedicated_SIDelivery_NeededUE_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-TNL-Association-To-Remove-ItemIEs >-----#
    GNB_DU_TNL_Association_To_Remove_ItemIEs = CLASS(name=u'GNB-DU-TNL-Association-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-TNL-Association-To-Remove-Item')))
    GNB_DU_TNL_Association_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdateAcknowledge >-----#
    GNBDUConfigurationUpdateAcknowledge = SEQ(name=u'GNBDUConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs._cont = __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNBDUConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNBDUConfigurationUpdateAcknowledgeIEs >-----#
    GNBDUConfigurationUpdateAcknowledgeIEs = CLASS(name=u'GNBDUConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    GNBDUConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdateFailure >-----#
    GNBDUConfigurationUpdateFailure = SEQ(name=u'GNBDUConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNBDUConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdateFailure_protocolIEs._cont = __GNBDUConfigurationUpdateFailure_protocolIEs__item_
    _GNBDUConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUConfigurationUpdateFailure_protocolIEs),
        ])
    GNBDUConfigurationUpdateFailure._ext = []
    
    #-----< GNBDUConfigurationUpdateFailureIEs >-----#
    GNBDUConfigurationUpdateFailureIEs = CLASS(name=u'GNBDUConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdate >-----#
    GNBCUConfigurationUpdate = SEQ(name=u'GNBCUConfigurationUpdate', mode=MODE_TYPE)
    _GNBCUConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Add-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Remove-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Update-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Barred-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Protected-EUTRA-Resources-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Neighbour-Cell-Information-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 426), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBCUConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBCUConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBCUConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___GNBCUConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___GNBCUConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdate_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdate_protocolIEs._cont = __GNBCUConfigurationUpdate_protocolIEs__item_
    _GNBCUConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _GNBCUConfigurationUpdate_protocolIEs),
        ])
    GNBCUConfigurationUpdate._ext = []
    
    #-----< GNBCUConfigurationUpdateIEs >-----#
    GNBCUConfigurationUpdateIEs = CLASS(name=u'GNBCUConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Add-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Remove-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Update-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Barred-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Protected-EUTRA-Resources-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Neighbour-Cell-Information-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBCUConfigurationUpdateIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _GNBCUConfigurationUpdateIEs_val_Value_11 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _GNBCUConfigurationUpdateIEs_val_Value_12 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _GNBCUConfigurationUpdateIEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    GNBCUConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 426), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateIEs_val_Value_13), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Deactivated-List >-----#
    Cells_to_be_Deactivated_List = SEQ_OF(name=u'Cells-to-be-Deactivated-List', mode=MODE_TYPE)
    _Cells_to_be_Deactivated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Deactivated_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_to_be_Deactivated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Deactivated-List-Item')))
    ___Cells_to_be_Deactivated_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Deactivated_List__item__id._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__id._const_tab_at = None
    __Cells_to_be_Deactivated_List__item__id._const_tab_id = u'id'
    __Cells_to_be_Deactivated_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_to_be_Deactivated_List__item__criticality._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_to_be_Deactivated_List__item__criticality._const_tab_id = u'criticality'
    __Cells_to_be_Deactivated_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_to_be_Deactivated_List__item__value._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__value._const_tab_at = ('..', u'id')
    __Cells_to_be_Deactivated_List__item__value._const_tab_id = u'Value'
    _Cells_to_be_Deactivated_List__item_._cont = ASN1Dict([
        (u'id', __Cells_to_be_Deactivated_List__item__id),
        (u'criticality', __Cells_to_be_Deactivated_List__item__criticality),
        (u'value', __Cells_to_be_Deactivated_List__item__value),
        ])
    _Cells_to_be_Deactivated_List__item_._ext = None
    Cells_to_be_Deactivated_List._cont = _Cells_to_be_Deactivated_List__item_
    Cells_to_be_Deactivated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-List >-----#
    GNB_CU_TNL_Association_To_Add_List = SEQ_OF(name=u'GNB-CU-TNL-Association-To-Add-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Add_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_CU_TNL_Association_To_Add_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Add-Item')))
    ___GNB_CU_TNL_Association_To_Add_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab_id = u'id'
    __GNB_CU_TNL_Association_To_Add_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab_id = u'criticality'
    __GNB_CU_TNL_Association_To_Add_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab_id = u'Value'
    _GNB_CU_TNL_Association_To_Add_List__item_._cont = ASN1Dict([
        (u'id', __GNB_CU_TNL_Association_To_Add_List__item__id),
        (u'criticality', __GNB_CU_TNL_Association_To_Add_List__item__criticality),
        (u'value', __GNB_CU_TNL_Association_To_Add_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Add_List__item_._ext = None
    GNB_CU_TNL_Association_To_Add_List._cont = _GNB_CU_TNL_Association_To_Add_List__item_
    GNB_CU_TNL_Association_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-List >-----#
    GNB_CU_TNL_Association_To_Remove_List = SEQ_OF(name=u'GNB-CU-TNL-Association-To-Remove-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Remove_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Remove-Item')))
    ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab_id = u'id'
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab_id = u'criticality'
    __GNB_CU_TNL_Association_To_Remove_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab_id = u'Value'
    _GNB_CU_TNL_Association_To_Remove_List__item_._cont = ASN1Dict([
        (u'id', __GNB_CU_TNL_Association_To_Remove_List__item__id),
        (u'criticality', __GNB_CU_TNL_Association_To_Remove_List__item__criticality),
        (u'value', __GNB_CU_TNL_Association_To_Remove_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Remove_List__item_._ext = None
    GNB_CU_TNL_Association_To_Remove_List._cont = _GNB_CU_TNL_Association_To_Remove_List__item_
    GNB_CU_TNL_Association_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-List >-----#
    GNB_CU_TNL_Association_To_Update_List = SEQ_OF(name=u'GNB-CU-TNL-Association-To-Update-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Update_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_CU_TNL_Association_To_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Update-Item')))
    ___GNB_CU_TNL_Association_To_Update_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab_id = u'id'
    __GNB_CU_TNL_Association_To_Update_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab_id = u'criticality'
    __GNB_CU_TNL_Association_To_Update_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab_id = u'Value'
    _GNB_CU_TNL_Association_To_Update_List__item_._cont = ASN1Dict([
        (u'id', __GNB_CU_TNL_Association_To_Update_List__item__id),
        (u'criticality', __GNB_CU_TNL_Association_To_Update_List__item__criticality),
        (u'value', __GNB_CU_TNL_Association_To_Update_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Update_List__item_._ext = None
    GNB_CU_TNL_Association_To_Update_List._cont = _GNB_CU_TNL_Association_To_Update_List__item_
    GNB_CU_TNL_Association_To_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cells-to-be-Barred-List >-----#
    Cells_to_be_Barred_List = SEQ_OF(name=u'Cells-to-be-Barred-List', mode=MODE_TYPE)
    _Cells_to_be_Barred_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Barred_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_to_be_Barred_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Barred_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Barred-Item')))
    ___Cells_to_be_Barred_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', ____Cells_to_be_Barred_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Barred_List__item__id._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__id._const_tab_at = None
    __Cells_to_be_Barred_List__item__id._const_tab_id = u'id'
    __Cells_to_be_Barred_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_to_be_Barred_List__item__criticality._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_to_be_Barred_List__item__criticality._const_tab_id = u'criticality'
    __Cells_to_be_Barred_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_to_be_Barred_List__item__value._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__value._const_tab_at = ('..', u'id')
    __Cells_to_be_Barred_List__item__value._const_tab_id = u'Value'
    _Cells_to_be_Barred_List__item_._cont = ASN1Dict([
        (u'id', __Cells_to_be_Barred_List__item__id),
        (u'criticality', __Cells_to_be_Barred_List__item__criticality),
        (u'value', __Cells_to_be_Barred_List__item__value),
        ])
    _Cells_to_be_Barred_List__item_._ext = None
    Cells_to_be_Barred_List._cont = _Cells_to_be_Barred_List__item_
    Cells_to_be_Barred_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-to-be-Deactivated-List-ItemIEs >-----#
    Cells_to_be_Deactivated_List_ItemIEs = CLASS(name=u'Cells-to-be-Deactivated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Deactivated-List-Item')))
    Cells_to_be_Deactivated_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Add_ItemIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Add-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Add-Item')))
    GNB_CU_TNL_Association_To_Add_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Remove_ItemIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Remove-Item')))
    GNB_CU_TNL_Association_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Update_ItemIEs = CLASS(name=u'GNB-CU-TNL-Association-To-Update-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Update-Item')))
    GNB_CU_TNL_Association_To_Update_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Barred-ItemIEs >-----#
    Cells_to_be_Barred_ItemIEs = CLASS(name=u'Cells-to-be-Barred-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Barred_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Barred-Item')))
    Cells_to_be_Barred_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _Cells_to_be_Barred_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Protected-EUTRA-Resources-List >-----#
    Protected_EUTRA_Resources_List = SEQ_OF(name=u'Protected-EUTRA-Resources-List', mode=MODE_TYPE)
    _Protected_EUTRA_Resources_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Protected_EUTRA_Resources_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Protected_EUTRA_Resources_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Protected-EUTRA-Resources-Item')))
    ___Protected_EUTRA_Resources_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 168), (u'criticality', u'reject'), (u'Value', ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Protected_EUTRA_Resources_List__item__id._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__id._const_tab_at = None
    __Protected_EUTRA_Resources_List__item__id._const_tab_id = u'id'
    __Protected_EUTRA_Resources_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Protected_EUTRA_Resources_List__item__criticality._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__criticality._const_tab_at = ('..', u'id')
    __Protected_EUTRA_Resources_List__item__criticality._const_tab_id = u'criticality'
    __Protected_EUTRA_Resources_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Protected_EUTRA_Resources_List__item__value._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__value._const_tab_at = ('..', u'id')
    __Protected_EUTRA_Resources_List__item__value._const_tab_id = u'Value'
    _Protected_EUTRA_Resources_List__item_._cont = ASN1Dict([
        (u'id', __Protected_EUTRA_Resources_List__item__id),
        (u'criticality', __Protected_EUTRA_Resources_List__item__criticality),
        (u'value', __Protected_EUTRA_Resources_List__item__value),
        ])
    _Protected_EUTRA_Resources_List__item_._ext = None
    Protected_EUTRA_Resources_List._cont = _Protected_EUTRA_Resources_List__item_
    Protected_EUTRA_Resources_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Protected-EUTRA-Resources-ItemIEs >-----#
    Protected_EUTRA_Resources_ItemIEs = CLASS(name=u'Protected-EUTRA-Resources-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Protected_EUTRA_Resources_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Protected-EUTRA-Resources-Item')))
    Protected_EUTRA_Resources_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 168), (u'criticality', u'reject'), (u'Value', _Protected_EUTRA_Resources_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Neighbour-Cell-Information-List >-----#
    Neighbour_Cell_Information_List = SEQ_OF(name=u'Neighbour-Cell-Information-List', mode=MODE_TYPE)
    _Neighbour_Cell_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Neighbour_Cell_Information_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Neighbour_Cell_Information_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Cell-Information-Item')))
    ___Neighbour_Cell_Information_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Value', ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Neighbour_Cell_Information_List__item__id._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__id._const_tab_at = None
    __Neighbour_Cell_Information_List__item__id._const_tab_id = u'id'
    __Neighbour_Cell_Information_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Neighbour_Cell_Information_List__item__criticality._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__criticality._const_tab_at = ('..', u'id')
    __Neighbour_Cell_Information_List__item__criticality._const_tab_id = u'criticality'
    __Neighbour_Cell_Information_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Neighbour_Cell_Information_List__item__value._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__value._const_tab_at = ('..', u'id')
    __Neighbour_Cell_Information_List__item__value._const_tab_id = u'Value'
    _Neighbour_Cell_Information_List__item_._cont = ASN1Dict([
        (u'id', __Neighbour_Cell_Information_List__item__id),
        (u'criticality', __Neighbour_Cell_Information_List__item__criticality),
        (u'value', __Neighbour_Cell_Information_List__item__value),
        ])
    _Neighbour_Cell_Information_List__item_._ext = None
    Neighbour_Cell_Information_List._cont = _Neighbour_Cell_Information_List__item_
    Neighbour_Cell_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Neighbour-Cell-Information-ItemIEs >-----#
    Neighbour_Cell_Information_ItemIEs = CLASS(name=u'Neighbour-Cell-Information-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Neighbour_Cell_Information_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Cell-Information-Item')))
    Neighbour_Cell_Information_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Value', _Neighbour_Cell_Information_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdateAcknowledge >-----#
    GNBCUConfigurationUpdateAcknowledge = SEQ(name=u'GNBCUConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Failed-to-be-Activated-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Setup-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Failed-To-Setup-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs._cont = __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _GNBCUConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNBCUConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNBCUConfigurationUpdateAcknowledgeIEs >-----#
    GNBCUConfigurationUpdateAcknowledgeIEs = CLASS(name=u'GNBCUConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Failed-to-be-Activated-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Setup-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Failed-To-Setup-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    GNBCUConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Failed-to-be-Activated-List >-----#
    Cells_Failed_to_be_Activated_List = SEQ_OF(name=u'Cells-Failed-to-be-Activated-List', mode=MODE_TYPE)
    _Cells_Failed_to_be_Activated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Failed_to_be_Activated_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_Failed_to_be_Activated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Failed-to-be-Activated-List-Item')))
    ___Cells_Failed_to_be_Activated_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Failed_to_be_Activated_List__item__id._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__id._const_tab_at = None
    __Cells_Failed_to_be_Activated_List__item__id._const_tab_id = u'id'
    __Cells_Failed_to_be_Activated_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab_id = u'criticality'
    __Cells_Failed_to_be_Activated_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_Failed_to_be_Activated_List__item__value._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__value._const_tab_at = ('..', u'id')
    __Cells_Failed_to_be_Activated_List__item__value._const_tab_id = u'Value'
    _Cells_Failed_to_be_Activated_List__item_._cont = ASN1Dict([
        (u'id', __Cells_Failed_to_be_Activated_List__item__id),
        (u'criticality', __Cells_Failed_to_be_Activated_List__item__criticality),
        (u'value', __Cells_Failed_to_be_Activated_List__item__value),
        ])
    _Cells_Failed_to_be_Activated_List__item_._ext = None
    Cells_Failed_to_be_Activated_List._cont = _Cells_Failed_to_be_Activated_List__item_
    Cells_Failed_to_be_Activated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-List >-----#
    GNB_CU_TNL_Association_Setup_List = SEQ_OF(name=u'GNB-CU-TNL-Association-Setup-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_CU_TNL_Association_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Setup-Item')))
    ___GNB_CU_TNL_Association_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab_id = u'id'
    __GNB_CU_TNL_Association_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab_id = u'criticality'
    __GNB_CU_TNL_Association_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab_id = u'Value'
    _GNB_CU_TNL_Association_Setup_List__item_._cont = ASN1Dict([
        (u'id', __GNB_CU_TNL_Association_Setup_List__item__id),
        (u'criticality', __GNB_CU_TNL_Association_Setup_List__item__criticality),
        (u'value', __GNB_CU_TNL_Association_Setup_List__item__value),
        ])
    _GNB_CU_TNL_Association_Setup_List__item_._ext = None
    GNB_CU_TNL_Association_Setup_List._cont = _GNB_CU_TNL_Association_Setup_List__item_
    GNB_CU_TNL_Association_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-List >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_List = SEQ_OF(name=u'GNB-CU-TNL-Association-Failed-To-Setup-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Failed-To-Setup-Item')))
    ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab_id = u'id'
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab_id = u'criticality'
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab_at = ('..', u'id')
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab_id = u'Value'
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_._cont = ASN1Dict([
        (u'id', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id),
        (u'criticality', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality),
        (u'value', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value),
        ])
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_._ext = None
    GNB_CU_TNL_Association_Failed_To_Setup_List._cont = _GNB_CU_TNL_Association_Failed_To_Setup_List__item_
    GNB_CU_TNL_Association_Failed_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cells-Failed-to-be-Activated-List-ItemIEs >-----#
    Cells_Failed_to_be_Activated_List_ItemIEs = CLASS(name=u'Cells-Failed-to-be-Activated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Failed-to-be-Activated-List-Item')))
    Cells_Failed_to_be_Activated_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-ItemIEs >-----#
    GNB_CU_TNL_Association_Setup_ItemIEs = CLASS(name=u'GNB-CU-TNL-Association-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Setup-Item')))
    GNB_CU_TNL_Association_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs = CLASS(name=u'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Failed-To-Setup-Item')))
    GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdateFailure >-----#
    GNBCUConfigurationUpdateFailure = SEQ(name=u'GNBCUConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNBCUConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdateFailure_protocolIEs._cont = __GNBCUConfigurationUpdateFailure_protocolIEs__item_
    _GNBCUConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _GNBCUConfigurationUpdateFailure_protocolIEs),
        ])
    GNBCUConfigurationUpdateFailure._ext = []
    
    #-----< GNBCUConfigurationUpdateFailureIEs >-----#
    GNBCUConfigurationUpdateFailureIEs = CLASS(name=u'GNBCUConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBCUConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceCoordinationRequest >-----#
    GNBDUResourceCoordinationRequest = SEQ(name=u'GNBDUResourceCoordinationRequest', mode=MODE_TYPE)
    _GNBDUResourceCoordinationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceCoordinationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestType')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReq-Container')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnoreResourceCoordinationContainer')))
    ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUResourceCoordinationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUResourceCoordinationRequest_protocolIEs__item__id),
        (u'criticality', ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality),
        (u'value', ___GNBDUResourceCoordinationRequest_protocolIEs__item__value),
        ])
    __GNBDUResourceCoordinationRequest_protocolIEs__item_._ext = None
    _GNBDUResourceCoordinationRequest_protocolIEs._cont = __GNBDUResourceCoordinationRequest_protocolIEs__item_
    _GNBDUResourceCoordinationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceCoordinationRequest._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUResourceCoordinationRequest_protocolIEs),
        ])
    GNBDUResourceCoordinationRequest._ext = []
    
    #-----< GNBDUResourceCoordinationRequest-IEs >-----#
    GNBDUResourceCoordinationRequest_IEs = CLASS(name=u'GNBDUResourceCoordinationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestType')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReq-Container')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnoreResourceCoordinationContainer')))
    GNBDUResourceCoordinationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceCoordinationResponse >-----#
    GNBDUResourceCoordinationResponse = SEQ(name=u'GNBDUResourceCoordinationResponse', mode=MODE_TYPE)
    _GNBDUResourceCoordinationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceCoordinationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReqAck-Container')))
    ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUResourceCoordinationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUResourceCoordinationResponse_protocolIEs__item__id),
        (u'criticality', ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality),
        (u'value', ___GNBDUResourceCoordinationResponse_protocolIEs__item__value),
        ])
    __GNBDUResourceCoordinationResponse_protocolIEs__item_._ext = None
    _GNBDUResourceCoordinationResponse_protocolIEs._cont = __GNBDUResourceCoordinationResponse_protocolIEs__item_
    _GNBDUResourceCoordinationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceCoordinationResponse._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUResourceCoordinationResponse_protocolIEs),
        ])
    GNBDUResourceCoordinationResponse._ext = []
    
    #-----< GNBDUResourceCoordinationResponse-IEs >-----#
    GNBDUResourceCoordinationResponse_IEs = CLASS(name=u'GNBDUResourceCoordinationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceCoordinationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceCoordinationResponse_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReqAck-Container')))
    GNBDUResourceCoordinationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _GNBDUResourceCoordinationResponse_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupRequest >-----#
    UEContextSetupRequest = SEQ(name=u'UEContextSetupRequest', mode=MODE_TYPE)
    _UEContextSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Candidate-SpCell-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MaskedIMEISV')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalInterDUMobilityInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    ____UEContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'conditional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 258), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 330), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 373), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 377), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 382), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 428), (u'criticality', u'reject'), (u'Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSetupRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextSetupRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextSetupRequest_protocolIEs__item__value),
        ])
    __UEContextSetupRequest_protocolIEs__item_._ext = None
    _UEContextSetupRequest_protocolIEs._cont = __UEContextSetupRequest_protocolIEs__item_
    _UEContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSetupRequest_protocolIEs),
        ])
    UEContextSetupRequest._ext = []
    
    #-----< UEContextSetupRequestIEs >-----#
    UEContextSetupRequestIEs = CLASS(name=u'UEContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextSetupRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _UEContextSetupRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _UEContextSetupRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _UEContextSetupRequestIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Candidate-SpCell-List')))
    _UEContextSetupRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _UEContextSetupRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextSetupRequestIEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _UEContextSetupRequestIEs_val_Value_13 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _UEContextSetupRequestIEs_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextSetupRequestIEs_val_Value_15 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MaskedIMEISV')))
    _UEContextSetupRequestIEs_val_Value_16 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _UEContextSetupRequestIEs_val_Value_17 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextSetupRequestIEs_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextSetupRequestIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextSetupRequestIEs_val_Value_20 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _UEContextSetupRequestIEs_val_Value_21 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _UEContextSetupRequestIEs_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    _UEContextSetupRequestIEs_val_Value_24 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextSetupRequestIEs_val_Value_25 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_26 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _UEContextSetupRequestIEs_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextSetupRequestIEs_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextSetupRequestIEs_val_Value_29 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextSetupRequestIEs_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextSetupRequestIEs_val_Value_31 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextSetupRequestIEs_val_Value_32 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalInterDUMobilityInformation')))
    _UEContextSetupRequestIEs_val_Value_34 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNList')))
    _UEContextSetupRequestIEs_val_Value_35 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _UEContextSetupRequestIEs_val_Value_36 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    UEContextSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_17), (u'presence', u'conditional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 258), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 330), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 373), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 377), (u'criticality', u'ignore'), (u'Value', _UEContextSetupRequestIEs_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 382), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 428), (u'criticality', u'reject'), (u'Value', _UEContextSetupRequestIEs_val_Value_36), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Candidate-SpCell-List >-----#
    Candidate_SpCell_List = SEQ_OF(name=u'Candidate-SpCell-List', mode=MODE_TYPE)
    _Candidate_SpCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Candidate_SpCell_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Candidate_SpCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Candidate_SpCell_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Candidate-SpCell-Item')))
    ___Candidate_SpCell_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', ____Candidate_SpCell_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Candidate_SpCell_List__item__id._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__id._const_tab_at = None
    __Candidate_SpCell_List__item__id._const_tab_id = u'id'
    __Candidate_SpCell_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Candidate_SpCell_List__item__criticality._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__criticality._const_tab_at = ('..', u'id')
    __Candidate_SpCell_List__item__criticality._const_tab_id = u'criticality'
    __Candidate_SpCell_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Candidate_SpCell_List__item__value._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__value._const_tab_at = ('..', u'id')
    __Candidate_SpCell_List__item__value._const_tab_id = u'Value'
    _Candidate_SpCell_List__item_._cont = ASN1Dict([
        (u'id', __Candidate_SpCell_List__item__id),
        (u'criticality', __Candidate_SpCell_List__item__criticality),
        (u'value', __Candidate_SpCell_List__item__value),
        ])
    _Candidate_SpCell_List__item_._ext = None
    Candidate_SpCell_List._cont = _Candidate_SpCell_List__item_
    Candidate_SpCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-ToBeSetup-List >-----#
    SCell_ToBeSetup_List = SEQ_OF(name=u'SCell-ToBeSetup-List', mode=MODE_TYPE)
    _SCell_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SCell_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetup-Item')))
    ___SCell_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', ____SCell_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeSetup_List__item__id._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__id._const_tab_at = None
    __SCell_ToBeSetup_List__item__id._const_tab_id = u'id'
    __SCell_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SCell_ToBeSetup_List__item__criticality._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SCell_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __SCell_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SCell_ToBeSetup_List__item__value._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __SCell_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _SCell_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __SCell_ToBeSetup_List__item__id),
        (u'criticality', __SCell_ToBeSetup_List__item__criticality),
        (u'value', __SCell_ToBeSetup_List__item__value),
        ])
    _SCell_ToBeSetup_List__item_._ext = None
    SCell_ToBeSetup_List._cont = _SCell_ToBeSetup_List__item_
    SCell_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-ToBeSetup-List >-----#
    SRBs_ToBeSetup_List = SEQ_OF(name=u'SRBs-ToBeSetup-List', mode=MODE_TYPE)
    _SRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetup-Item')))
    ___SRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeSetup_List__item__id._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__id._const_tab_at = None
    __SRBs_ToBeSetup_List__item__id._const_tab_id = u'id'
    __SRBs_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_ToBeSetup_List__item__criticality._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_ToBeSetup_List__item__value._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _SRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_ToBeSetup_List__item__id),
        (u'criticality', __SRBs_ToBeSetup_List__item__criticality),
        (u'value', __SRBs_ToBeSetup_List__item__value),
        ])
    _SRBs_ToBeSetup_List__item_._ext = None
    SRBs_ToBeSetup_List._cont = _SRBs_ToBeSetup_List__item_
    SRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeSetup-List >-----#
    DRBs_ToBeSetup_List = SEQ_OF(name=u'DRBs-ToBeSetup-List', mode=MODE_TYPE)
    _DRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetup-Item')))
    ___DRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeSetup_List__item__id._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__id._const_tab_at = None
    __DRBs_ToBeSetup_List__item__id._const_tab_id = u'id'
    __DRBs_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_ToBeSetup_List__item__criticality._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_ToBeSetup_List__item__value._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _DRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_ToBeSetup_List__item__id),
        (u'criticality', __DRBs_ToBeSetup_List__item__criticality),
        (u'value', __DRBs_ToBeSetup_List__item__value),
        ])
    _DRBs_ToBeSetup_List__item_._ext = None
    DRBs_ToBeSetup_List._cont = _DRBs_ToBeSetup_List__item_
    DRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeSetup-List >-----#
    BHChannels_ToBeSetup_List = SEQ_OF(name=u'BHChannels-ToBeSetup-List', mode=MODE_TYPE)
    _BHChannels_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetup-Item')))
    ___BHChannels_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeSetup_List__item__id._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__id._const_tab_at = None
    __BHChannels_ToBeSetup_List__item__id._const_tab_id = u'id'
    __BHChannels_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_ToBeSetup_List__item__criticality._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_ToBeSetup_List__item__value._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _BHChannels_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_ToBeSetup_List__item__id),
        (u'criticality', __BHChannels_ToBeSetup_List__item__criticality),
        (u'value', __BHChannels_ToBeSetup_List__item__value),
        ])
    _BHChannels_ToBeSetup_List__item_._ext = None
    BHChannels_ToBeSetup_List._cont = _BHChannels_ToBeSetup_List__item_
    BHChannels_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeSetup-List >-----#
    SLDRBs_ToBeSetup_List = SEQ_OF(name=u'SLDRBs-ToBeSetup-List', mode=MODE_TYPE)
    _SLDRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetup-Item')))
    ___SLDRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 329), (u'criticality', u'reject'), (u'Value', ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeSetup_List__item__id._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__id._const_tab_at = None
    __SLDRBs_ToBeSetup_List__item__id._const_tab_id = u'id'
    __SLDRBs_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_ToBeSetup_List__item__value._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _SLDRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_ToBeSetup_List__item__id),
        (u'criticality', __SLDRBs_ToBeSetup_List__item__criticality),
        (u'value', __SLDRBs_ToBeSetup_List__item__value),
        ])
    _SLDRBs_ToBeSetup_List__item_._ext = None
    SLDRBs_ToBeSetup_List._cont = _SLDRBs_ToBeSetup_List__item_
    SLDRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Candidate-SpCell-ItemIEs >-----#
    Candidate_SpCell_ItemIEs = CLASS(name=u'Candidate-SpCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Candidate_SpCell_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Candidate-SpCell-Item')))
    Candidate_SpCell_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _Candidate_SpCell_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetup-ItemIEs >-----#
    SCell_ToBeSetup_ItemIEs = CLASS(name=u'SCell-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetup-Item')))
    SCell_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _SCell_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetup-ItemIEs >-----#
    SRBs_ToBeSetup_ItemIEs = CLASS(name=u'SRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetup-Item')))
    SRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _SRBs_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetup-ItemIEs >-----#
    DRBs_ToBeSetup_ItemIEs = CLASS(name=u'DRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetup-Item')))
    DRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', _DRBs_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetup-ItemIEs >-----#
    BHChannels_ToBeSetup_ItemIEs = CLASS(name=u'BHChannels-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetup-Item')))
    BHChannels_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', _BHChannels_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetup-ItemIEs >-----#
    SLDRBs_ToBeSetup_ItemIEs = CLASS(name=u'SLDRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetup-Item')))
    SLDRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 329), (u'criticality', u'reject'), (u'Value', _SLDRBs_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupResponse >-----#
    UEContextSetupResponse = SEQ(name=u'UEContextSetupResponse', mode=MODE_TYPE)
    _UEContextSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 324), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 316), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSetupResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextSetupResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextSetupResponse_protocolIEs__item__value),
        ])
    __UEContextSetupResponse_protocolIEs__item_._ext = None
    _UEContextSetupResponse_protocolIEs._cont = __UEContextSetupResponse_protocolIEs__item_
    _UEContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSetupResponse_protocolIEs),
        ])
    UEContextSetupResponse._ext = []
    
    #-----< UEContextSetupResponseIEs >-----#
    UEContextSetupResponseIEs = CLASS(name=u'UEContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextSetupResponseIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _UEContextSetupResponseIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextSetupResponseIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextSetupResponseIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetup-List')))
    _UEContextSetupResponseIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _UEContextSetupResponseIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSetupResponseIEs_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_16 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 324), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 316), (u'criticality', u'ignore'), (u'Value', _UEContextSetupResponseIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _UEContextSetupResponseIEs_val_Value_17), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Setup-List >-----#
    DRBs_Setup_List = SEQ_OF(name=u'DRBs-Setup-List', mode=MODE_TYPE)
    _DRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Setup-Item')))
    ___DRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', ____DRBs_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Setup_List__item__id._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__id._const_tab_at = None
    __DRBs_Setup_List__item__id._const_tab_id = u'id'
    __DRBs_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_Setup_List__item__criticality._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_Setup_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_Setup_List__item__value._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_Setup_List__item__value._const_tab_id = u'Value'
    _DRBs_Setup_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_Setup_List__item__id),
        (u'criticality', __DRBs_Setup_List__item__criticality),
        (u'value', __DRBs_Setup_List__item__value),
        ])
    _DRBs_Setup_List__item_._ext = None
    DRBs_Setup_List._cont = _DRBs_Setup_List__item_
    DRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-FailedToBeSetup-List >-----#
    SRBs_FailedToBeSetup_List = SEQ_OF(name=u'SRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _SRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_FailedToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetup-Item')))
    ___SRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_FailedToBeSetup_List__item__id._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __SRBs_FailedToBeSetup_List__item__id._const_tab_id = u'id'
    __SRBs_FailedToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_FailedToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_FailedToBeSetup_List__item__value._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_FailedToBeSetup_List__item__value._const_tab_id = u'Value'
    _SRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_FailedToBeSetup_List__item__id),
        (u'criticality', __SRBs_FailedToBeSetup_List__item__criticality),
        (u'value', __SRBs_FailedToBeSetup_List__item__value),
        ])
    _SRBs_FailedToBeSetup_List__item_._ext = None
    SRBs_FailedToBeSetup_List._cont = _SRBs_FailedToBeSetup_List__item_
    SRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeSetup-List >-----#
    DRBs_FailedToBeSetup_List = SEQ_OF(name=u'DRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _DRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetup-Item')))
    ___DRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeSetup_List__item__id._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __DRBs_FailedToBeSetup_List__item__id._const_tab_id = u'id'
    __DRBs_FailedToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_FailedToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_FailedToBeSetup_List__item__value._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeSetup_List__item__value._const_tab_id = u'Value'
    _DRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_FailedToBeSetup_List__item__id),
        (u'criticality', __DRBs_FailedToBeSetup_List__item__criticality),
        (u'value', __DRBs_FailedToBeSetup_List__item__value),
        ])
    _DRBs_FailedToBeSetup_List__item_._ext = None
    DRBs_FailedToBeSetup_List._cont = _DRBs_FailedToBeSetup_List__item_
    DRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-FailedtoSetup-List >-----#
    SCell_FailedtoSetup_List = SEQ_OF(name=u'SCell-FailedtoSetup-List', mode=MODE_TYPE)
    _SCell_FailedtoSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_FailedtoSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SCell_FailedtoSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetup-Item')))
    ___SCell_FailedtoSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SCell_FailedtoSetup_List__item__id._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__id._const_tab_at = None
    __SCell_FailedtoSetup_List__item__id._const_tab_id = u'id'
    __SCell_FailedtoSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SCell_FailedtoSetup_List__item__criticality._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SCell_FailedtoSetup_List__item__criticality._const_tab_id = u'criticality'
    __SCell_FailedtoSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SCell_FailedtoSetup_List__item__value._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__value._const_tab_at = ('..', u'id')
    __SCell_FailedtoSetup_List__item__value._const_tab_id = u'Value'
    _SCell_FailedtoSetup_List__item_._cont = ASN1Dict([
        (u'id', __SCell_FailedtoSetup_List__item__id),
        (u'criticality', __SCell_FailedtoSetup_List__item__criticality),
        (u'value', __SCell_FailedtoSetup_List__item__value),
        ])
    _SCell_FailedtoSetup_List__item_._ext = None
    SCell_FailedtoSetup_List._cont = _SCell_FailedtoSetup_List__item_
    SCell_FailedtoSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-Setup-List >-----#
    SRBs_Setup_List = SEQ_OF(name=u'SRBs-Setup-List', mode=MODE_TYPE)
    _SRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Setup-Item')))
    ___SRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', ____SRBs_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Setup_List__item__id._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__id._const_tab_at = None
    __SRBs_Setup_List__item__id._const_tab_id = u'id'
    __SRBs_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_Setup_List__item__criticality._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_Setup_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_Setup_List__item__value._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_Setup_List__item__value._const_tab_id = u'Value'
    _SRBs_Setup_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_Setup_List__item__id),
        (u'criticality', __SRBs_Setup_List__item__criticality),
        (u'value', __SRBs_Setup_List__item__value),
        ])
    _SRBs_Setup_List__item_._ext = None
    SRBs_Setup_List._cont = _SRBs_Setup_List__item_
    SRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< BHChannels-Setup-List >-----#
    BHChannels_Setup_List = SEQ_OF(name=u'BHChannels-Setup-List', mode=MODE_TYPE)
    _BHChannels_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Setup-Item')))
    ___BHChannels_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 261), (u'criticality', u'ignore'), (u'Value', ____BHChannels_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Setup_List__item__id._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__id._const_tab_at = None
    __BHChannels_Setup_List__item__id._const_tab_id = u'id'
    __BHChannels_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_Setup_List__item__criticality._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_Setup_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_Setup_List__item__value._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_Setup_List__item__value._const_tab_id = u'Value'
    _BHChannels_Setup_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_Setup_List__item__id),
        (u'criticality', __BHChannels_Setup_List__item__criticality),
        (u'value', __BHChannels_Setup_List__item__value),
        ])
    _BHChannels_Setup_List__item_._ext = None
    BHChannels_Setup_List._cont = _BHChannels_Setup_List__item_
    BHChannels_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeSetup-List >-----#
    BHChannels_FailedToBeSetup_List = SEQ_OF(name=u'BHChannels-FailedToBeSetup-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetup-Item')))
    ___BHChannels_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeSetup_List__item__id._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeSetup_List__item__id._const_tab_id = u'id'
    __BHChannels_FailedToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_FailedToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_FailedToBeSetup_List__item__value._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeSetup_List__item__value._const_tab_id = u'Value'
    _BHChannels_FailedToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_FailedToBeSetup_List__item__id),
        (u'criticality', __BHChannels_FailedToBeSetup_List__item__criticality),
        (u'value', __BHChannels_FailedToBeSetup_List__item__value),
        ])
    _BHChannels_FailedToBeSetup_List__item_._ext = None
    BHChannels_FailedToBeSetup_List._cont = _BHChannels_FailedToBeSetup_List__item_
    BHChannels_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-Setup-ItemIEs >-----#
    DRBs_Setup_ItemIEs = CLASS(name=u'DRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Setup-Item')))
    DRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _DRBs_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Setup-ItemIEs >-----#
    SRBs_Setup_ItemIEs = CLASS(name=u'SRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Setup-Item')))
    SRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', _SRBs_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetup-ItemIEs >-----#
    SRBs_FailedToBeSetup_ItemIEs = CLASS(name=u'SRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetup-Item')))
    SRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _SRBs_FailedToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetup-ItemIEs >-----#
    DRBs_FailedToBeSetup_ItemIEs = CLASS(name=u'DRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetup-Item')))
    DRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _DRBs_FailedToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetup-ItemIEs >-----#
    SCell_FailedtoSetup_ItemIEs = CLASS(name=u'SCell-FailedtoSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_FailedtoSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetup-Item')))
    SCell_FailedtoSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _SCell_FailedtoSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Setup-ItemIEs >-----#
    BHChannels_Setup_ItemIEs = CLASS(name=u'BHChannels-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Setup-Item')))
    BHChannels_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 261), (u'criticality', u'ignore'), (u'Value', _BHChannels_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetup-ItemIEs >-----#
    BHChannels_FailedToBeSetup_ItemIEs = CLASS(name=u'BHChannels-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetup-Item')))
    BHChannels_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Setup-List >-----#
    SLDRBs_Setup_List = SEQ_OF(name=u'SLDRBs-Setup-List', mode=MODE_TYPE)
    _SLDRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Setup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Setup-Item')))
    ___SLDRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 323), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_Setup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Setup_List__item__id._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__id._const_tab_at = None
    __SLDRBs_Setup_List__item__id._const_tab_id = u'id'
    __SLDRBs_Setup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_Setup_List__item__criticality._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_Setup_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_Setup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_Setup_List__item__value._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_Setup_List__item__value._const_tab_id = u'Value'
    _SLDRBs_Setup_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_Setup_List__item__id),
        (u'criticality', __SLDRBs_Setup_List__item__criticality),
        (u'value', __SLDRBs_Setup_List__item__value),
        ])
    _SLDRBs_Setup_List__item_._ext = None
    SLDRBs_Setup_List._cont = _SLDRBs_Setup_List__item_
    SLDRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeSetup-List >-----#
    SLDRBs_FailedToBeSetup_List = SEQ_OF(name=u'SLDRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetup-Item')))
    ___SLDRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab_id = u'id'
    __SLDRBs_FailedToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_FailedToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab_id = u'Value'
    _SLDRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_FailedToBeSetup_List__item__id),
        (u'criticality', __SLDRBs_FailedToBeSetup_List__item__criticality),
        (u'value', __SLDRBs_FailedToBeSetup_List__item__value),
        ])
    _SLDRBs_FailedToBeSetup_List__item_._ext = None
    SLDRBs_FailedToBeSetup_List._cont = _SLDRBs_FailedToBeSetup_List__item_
    SLDRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Setup-ItemIEs >-----#
    SLDRBs_Setup_ItemIEs = CLASS(name=u'SLDRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Setup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Setup-Item')))
    SLDRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 323), (u'criticality', u'ignore'), (u'Value', _SLDRBs_Setup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetup-ItemIEs >-----#
    SLDRBs_FailedToBeSetup_ItemIEs = CLASS(name=u'SLDRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetup-Item')))
    SLDRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupFailure >-----#
    UEContextSetupFailure = SEQ(name=u'UEContextSetupFailure', mode=MODE_TYPE)
    _UEContextSetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Potential-SpCell-List')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSetupFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextSetupFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextSetupFailure_protocolIEs__item__value),
        ])
    __UEContextSetupFailure_protocolIEs__item_._ext = None
    _UEContextSetupFailure_protocolIEs._cont = __UEContextSetupFailure_protocolIEs__item_
    _UEContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSetupFailure_protocolIEs),
        ])
    UEContextSetupFailure._ext = []
    
    #-----< UEContextSetupFailureIEs >-----#
    UEContextSetupFailureIEs = CLASS(name=u'UEContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextSetupFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSetupFailureIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Potential-SpCell-List')))
    _UEContextSetupFailureIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextSetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextSetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _UEContextSetupFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextSetupFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextSetupFailureIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _UEContextSetupFailureIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _UEContextSetupFailureIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Potential-SpCell-List >-----#
    Potential_SpCell_List = SEQ_OF(name=u'Potential-SpCell-List', mode=MODE_TYPE)
    _Potential_SpCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Potential_SpCell_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Potential_SpCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Potential_SpCell_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Potential-SpCell-Item')))
    ___Potential_SpCell_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', ____Potential_SpCell_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Potential_SpCell_List__item__id._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__id._const_tab_at = None
    __Potential_SpCell_List__item__id._const_tab_id = u'id'
    __Potential_SpCell_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Potential_SpCell_List__item__criticality._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__criticality._const_tab_at = ('..', u'id')
    __Potential_SpCell_List__item__criticality._const_tab_id = u'criticality'
    __Potential_SpCell_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Potential_SpCell_List__item__value._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__value._const_tab_at = ('..', u'id')
    __Potential_SpCell_List__item__value._const_tab_id = u'Value'
    _Potential_SpCell_List__item_._cont = ASN1Dict([
        (u'id', __Potential_SpCell_List__item__id),
        (u'criticality', __Potential_SpCell_List__item__criticality),
        (u'value', __Potential_SpCell_List__item__value),
        ])
    _Potential_SpCell_List__item_._ext = None
    Potential_SpCell_List._cont = _Potential_SpCell_List__item_
    Potential_SpCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< Potential-SpCell-ItemIEs >-----#
    Potential_SpCell_ItemIEs = CLASS(name=u'Potential-SpCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Potential_SpCell_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Potential-SpCell-Item')))
    Potential_SpCell_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _Potential_SpCell_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name=u'UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequestIEs >-----#
    UEContextReleaseRequestIEs = CLASS(name=u'UEContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextReleaseRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    UEContextReleaseRequestIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name=u'UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommandIEs >-----#
    UEContextReleaseCommandIEs = CLASS(name=u'UEContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextReleaseCommandIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextReleaseCommandIEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _UEContextReleaseCommandIEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextReleaseCommandIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextReleaseCommandIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    UEContextReleaseCommandIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommandIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCommandIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name=u'UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseComplete_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseCompleteIEs >-----#
    UEContextReleaseCompleteIEs = CLASS(name=u'UEContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseCompleteIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseCompleteIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCompleteIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    UEContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCompleteIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCompleteIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCompleteIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name=u'UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionActionIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCReconfigurationCompleteIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeRemoved-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXConfigurationIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCFailureIndication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentListInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DUConfigurationQuery')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedforGap')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LowerLayerPresenceStatusChange')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalIntraDUMobilityInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGIndicator')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 76), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 37), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 265), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40), (u'presence', u'optional')]), dict([(u'id', 332), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41), (u'presence', u'optional')]), dict([(u'id', 326), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42), (u'presence', u'optional')]), dict([(u'id', 328), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43), (u'presence', u'optional')]), dict([(u'id', 374), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44), (u'presence', u'optional')]), dict([(u'id', 428), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45), (u'presence', u'optional')]), dict([(u'id', 432), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name=u'UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextModificationRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _UEContextModificationRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _UEContextModificationRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _UEContextModificationRequestIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionActionIndicator')))
    _UEContextModificationRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationRequestIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCReconfigurationCompleteIndicator')))
    _UEContextModificationRequestIEs_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextModificationRequestIEs_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeRemoved-List')))
    _UEContextModificationRequestIEs_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_16 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _UEContextModificationRequestIEs_val_Value_19 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _UEContextModificationRequestIEs_val_Value_20 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXConfigurationIndicator')))
    _UEContextModificationRequestIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCFailureIndication')))
    _UEContextModificationRequestIEs_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentListInformation')))
    _UEContextModificationRequestIEs_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DUConfigurationQuery')))
    _UEContextModificationRequestIEs_val_Value_24 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextModificationRequestIEs_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextModificationRequestIEs_val_Value_26 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextModificationRequestIEs_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextModificationRequestIEs_val_Value_28 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _UEContextModificationRequestIEs_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedforGap')))
    _UEContextModificationRequestIEs_val_Value_30 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextModificationRequestIEs_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextModificationRequestIEs_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LowerLayerPresenceStatusChange')))
    _UEContextModificationRequestIEs_val_Value_33 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_34 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_35 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_36 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_37 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_38 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_39 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_40 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextModificationRequestIEs_val_Value_41 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_42 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_43 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_44 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalIntraDUMobilityInformation')))
    _UEContextModificationRequestIEs_val_Value_45 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _UEContextModificationRequestIEs_val_Value_46 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGIndicator')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 76), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 37), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 265), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_36), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_37), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_38), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_39), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_40), (u'presence', u'optional')]), dict([(u'id', 332), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_41), (u'presence', u'optional')]), dict([(u'id', 326), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_42), (u'presence', u'optional')]), dict([(u'id', 328), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_43), (u'presence', u'optional')]), dict([(u'id', 374), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_44), (u'presence', u'optional')]), dict([(u'id', 428), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_45), (u'presence', u'optional')]), dict([(u'id', 432), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_46), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetupMod-List >-----#
    SCell_ToBeSetupMod_List = SEQ_OF(name=u'SCell-ToBeSetupMod-List', mode=MODE_TYPE)
    _SCell_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SCell_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetupMod-Item')))
    ___SCell_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeSetupMod_List__item__id._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__id._const_tab_at = None
    __SCell_ToBeSetupMod_List__item__id._const_tab_id = u'id'
    __SCell_ToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SCell_ToBeSetupMod_List__item__criticality._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SCell_ToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SCell_ToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SCell_ToBeSetupMod_List__item__value._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SCell_ToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _SCell_ToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SCell_ToBeSetupMod_List__item__id),
        (u'criticality', __SCell_ToBeSetupMod_List__item__criticality),
        (u'value', __SCell_ToBeSetupMod_List__item__value),
        ])
    _SCell_ToBeSetupMod_List__item_._ext = None
    SCell_ToBeSetupMod_List._cont = _SCell_ToBeSetupMod_List__item_
    SCell_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SCell-ToBeRemoved-List >-----#
    SCell_ToBeRemoved_List = SEQ_OF(name=u'SCell-ToBeRemoved-List', mode=MODE_TYPE)
    _SCell_ToBeRemoved_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeRemoved_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SCell_ToBeRemoved_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeRemoved-Item')))
    ___SCell_ToBeRemoved_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeRemoved_List__item__id._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__id._const_tab_at = None
    __SCell_ToBeRemoved_List__item__id._const_tab_id = u'id'
    __SCell_ToBeRemoved_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SCell_ToBeRemoved_List__item__criticality._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__criticality._const_tab_at = ('..', u'id')
    __SCell_ToBeRemoved_List__item__criticality._const_tab_id = u'criticality'
    __SCell_ToBeRemoved_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SCell_ToBeRemoved_List__item__value._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__value._const_tab_at = ('..', u'id')
    __SCell_ToBeRemoved_List__item__value._const_tab_id = u'Value'
    _SCell_ToBeRemoved_List__item_._cont = ASN1Dict([
        (u'id', __SCell_ToBeRemoved_List__item__id),
        (u'criticality', __SCell_ToBeRemoved_List__item__criticality),
        (u'value', __SCell_ToBeRemoved_List__item__value),
        ])
    _SCell_ToBeRemoved_List__item_._ext = None
    SCell_ToBeRemoved_List._cont = _SCell_ToBeRemoved_List__item_
    SCell_ToBeRemoved_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-ToBeSetupMod-List >-----#
    SRBs_ToBeSetupMod_List = SEQ_OF(name=u'SRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _SRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetupMod-Item')))
    ___SRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeSetupMod_List__item__id._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __SRBs_ToBeSetupMod_List__item__id._const_tab_id = u'id'
    __SRBs_ToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_ToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_ToBeSetupMod_List__item__value._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_ToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _SRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_ToBeSetupMod_List__item__id),
        (u'criticality', __SRBs_ToBeSetupMod_List__item__criticality),
        (u'value', __SRBs_ToBeSetupMod_List__item__value),
        ])
    _SRBs_ToBeSetupMod_List__item_._ext = None
    SRBs_ToBeSetupMod_List._cont = _SRBs_ToBeSetupMod_List__item_
    SRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeSetupMod-List >-----#
    DRBs_ToBeSetupMod_List = SEQ_OF(name=u'DRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _DRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetupMod-Item')))
    ___DRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeSetupMod_List__item__id._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __DRBs_ToBeSetupMod_List__item__id._const_tab_id = u'id'
    __DRBs_ToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_ToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_ToBeSetupMod_List__item__value._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_ToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _DRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_ToBeSetupMod_List__item__id),
        (u'criticality', __DRBs_ToBeSetupMod_List__item__criticality),
        (u'value', __DRBs_ToBeSetupMod_List__item__value),
        ])
    _DRBs_ToBeSetupMod_List__item_._ext = None
    DRBs_ToBeSetupMod_List._cont = _DRBs_ToBeSetupMod_List__item_
    DRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeSetupMod-List >-----#
    BHChannels_ToBeSetupMod_List = SEQ_OF(name=u'BHChannels-ToBeSetupMod-List', mode=MODE_TYPE)
    _BHChannels_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetupMod-Item')))
    ___BHChannels_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'reject'), (u'Value', ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeSetupMod_List__item__id._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__id._const_tab_at = None
    __BHChannels_ToBeSetupMod_List__item__id._const_tab_id = u'id'
    __BHChannels_ToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_ToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_ToBeSetupMod_List__item__value._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_ToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _BHChannels_ToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_ToBeSetupMod_List__item__id),
        (u'criticality', __BHChannels_ToBeSetupMod_List__item__criticality),
        (u'value', __BHChannels_ToBeSetupMod_List__item__value),
        ])
    _BHChannels_ToBeSetupMod_List__item_._ext = None
    BHChannels_ToBeSetupMod_List._cont = _BHChannels_ToBeSetupMod_List__item_
    BHChannels_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-ToBeModified-List >-----#
    DRBs_ToBeModified_List = SEQ_OF(name=u'DRBs-ToBeModified-List', mode=MODE_TYPE)
    _DRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeModified-Item')))
    ___DRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', ____DRBs_ToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeModified_List__item__id._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__id._const_tab_at = None
    __DRBs_ToBeModified_List__item__id._const_tab_id = u'id'
    __DRBs_ToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_ToBeModified_List__item__criticality._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_ToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_ToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_ToBeModified_List__item__value._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_ToBeModified_List__item__value._const_tab_id = u'Value'
    _DRBs_ToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_ToBeModified_List__item__id),
        (u'criticality', __DRBs_ToBeModified_List__item__criticality),
        (u'value', __DRBs_ToBeModified_List__item__value),
        ])
    _DRBs_ToBeModified_List__item_._ext = None
    DRBs_ToBeModified_List._cont = _DRBs_ToBeModified_List__item_
    DRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeModified-List >-----#
    BHChannels_ToBeModified_List = SEQ_OF(name=u'BHChannels-ToBeModified-List', mode=MODE_TYPE)
    _BHChannels_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeModified-Item')))
    ___BHChannels_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 262), (u'criticality', u'reject'), (u'Value', ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeModified_List__item__id._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__id._const_tab_at = None
    __BHChannels_ToBeModified_List__item__id._const_tab_id = u'id'
    __BHChannels_ToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_ToBeModified_List__item__criticality._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_ToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_ToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_ToBeModified_List__item__value._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_ToBeModified_List__item__value._const_tab_id = u'Value'
    _BHChannels_ToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_ToBeModified_List__item__id),
        (u'criticality', __BHChannels_ToBeModified_List__item__criticality),
        (u'value', __BHChannels_ToBeModified_List__item__value),
        ])
    _BHChannels_ToBeModified_List__item_._ext = None
    BHChannels_ToBeModified_List._cont = _BHChannels_ToBeModified_List__item_
    BHChannels_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SRBs-ToBeReleased-List >-----#
    SRBs_ToBeReleased_List = SEQ_OF(name=u'SRBs-ToBeReleased-List', mode=MODE_TYPE)
    _SRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeReleased-Item')))
    ___SRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeReleased_List__item__id._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__id._const_tab_at = None
    __SRBs_ToBeReleased_List__item__id._const_tab_id = u'id'
    __SRBs_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_ToBeReleased_List__item__criticality._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_ToBeReleased_List__item__value._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _SRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_ToBeReleased_List__item__id),
        (u'criticality', __SRBs_ToBeReleased_List__item__criticality),
        (u'value', __SRBs_ToBeReleased_List__item__value),
        ])
    _SRBs_ToBeReleased_List__item_._ext = None
    SRBs_ToBeReleased_List._cont = _SRBs_ToBeReleased_List__item_
    SRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeReleased-List >-----#
    DRBs_ToBeReleased_List = SEQ_OF(name=u'DRBs-ToBeReleased-List', mode=MODE_TYPE)
    _DRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeReleased-Item')))
    ___DRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeReleased_List__item__id._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__id._const_tab_at = None
    __DRBs_ToBeReleased_List__item__id._const_tab_id = u'id'
    __DRBs_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_ToBeReleased_List__item__criticality._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_ToBeReleased_List__item__value._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _DRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_ToBeReleased_List__item__id),
        (u'criticality', __DRBs_ToBeReleased_List__item__criticality),
        (u'value', __DRBs_ToBeReleased_List__item__value),
        ])
    _DRBs_ToBeReleased_List__item_._ext = None
    DRBs_ToBeReleased_List._cont = _DRBs_ToBeReleased_List__item_
    DRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeReleased-List >-----#
    BHChannels_ToBeReleased_List = SEQ_OF(name=u'BHChannels-ToBeReleased-List', mode=MODE_TYPE)
    _BHChannels_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeReleased-Item')))
    ___BHChannels_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeReleased_List__item__id._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__id._const_tab_at = None
    __BHChannels_ToBeReleased_List__item__id._const_tab_id = u'id'
    __BHChannels_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_ToBeReleased_List__item__criticality._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_ToBeReleased_List__item__value._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _BHChannels_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_ToBeReleased_List__item__id),
        (u'criticality', __BHChannels_ToBeReleased_List__item__criticality),
        (u'value', __BHChannels_ToBeReleased_List__item__value),
        ])
    _BHChannels_ToBeReleased_List__item_._ext = None
    BHChannels_ToBeReleased_List._cont = _BHChannels_ToBeReleased_List__item_
    BHChannels_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SCell-ToBeSetupMod-ItemIEs >-----#
    SCell_ToBeSetupMod_ItemIEs = CLASS(name=u'SCell-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetupMod-Item')))
    SCell_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _SCell_ToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeRemoved-ItemIEs >-----#
    SCell_ToBeRemoved_ItemIEs = CLASS(name=u'SCell-ToBeRemoved-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeRemoved_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeRemoved-Item')))
    SCell_ToBeRemoved_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _SCell_ToBeRemoved_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetupMod-ItemIEs >-----#
    SRBs_ToBeSetupMod_ItemIEs = CLASS(name=u'SRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetupMod-Item')))
    SRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _SRBs_ToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetupMod-ItemIEs >-----#
    DRBs_ToBeSetupMod_ItemIEs = CLASS(name=u'DRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetupMod-Item')))
    DRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', _DRBs_ToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeModified-ItemIEs >-----#
    DRBs_ToBeModified_ItemIEs = CLASS(name=u'DRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeModified-Item')))
    DRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _DRBs_ToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeReleased-ItemIEs >-----#
    SRBs_ToBeReleased_ItemIEs = CLASS(name=u'SRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeReleased-Item')))
    SRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _SRBs_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeReleased-ItemIEs >-----#
    DRBs_ToBeReleased_ItemIEs = CLASS(name=u'DRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeReleased-Item')))
    DRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', _DRBs_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetupMod-ItemIEs >-----#
    BHChannels_ToBeSetupMod_ItemIEs = CLASS(name=u'BHChannels-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetupMod-Item')))
    BHChannels_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'reject'), (u'Value', _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeModified-ItemIEs >-----#
    BHChannels_ToBeModified_ItemIEs = CLASS(name=u'BHChannels-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeModified-Item')))
    BHChannels_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 262), (u'criticality', u'reject'), (u'Value', _BHChannels_ToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeReleased-ItemIEs >-----#
    BHChannels_ToBeReleased_ItemIEs = CLASS(name=u'BHChannels-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeReleased-Item')))
    BHChannels_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _BHChannels_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetupMod-List >-----#
    SLDRBs_ToBeSetupMod_List = SEQ_OF(name=u'SLDRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _SLDRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetupMod-Item')))
    ___SLDRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 331), (u'criticality', u'reject'), (u'Value', ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab_id = u'id'
    __SLDRBs_ToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_ToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _SLDRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_ToBeSetupMod_List__item__id),
        (u'criticality', __SLDRBs_ToBeSetupMod_List__item__criticality),
        (u'value', __SLDRBs_ToBeSetupMod_List__item__value),
        ])
    _SLDRBs_ToBeSetupMod_List__item_._ext = None
    SLDRBs_ToBeSetupMod_List._cont = _SLDRBs_ToBeSetupMod_List__item_
    SLDRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeModified-List >-----#
    SLDRBs_ToBeModified_List = SEQ_OF(name=u'SLDRBs-ToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeModified-Item')))
    ___SLDRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 325), (u'criticality', u'reject'), (u'Value', ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeModified_List__item__id._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_ToBeModified_List__item__id._const_tab_id = u'id'
    __SLDRBs_ToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_ToBeModified_List__item__criticality._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_ToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_ToBeModified_List__item__value._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeModified_List__item__value._const_tab_id = u'Value'
    _SLDRBs_ToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_ToBeModified_List__item__id),
        (u'criticality', __SLDRBs_ToBeModified_List__item__criticality),
        (u'value', __SLDRBs_ToBeModified_List__item__value),
        ])
    _SLDRBs_ToBeModified_List__item_._ext = None
    SLDRBs_ToBeModified_List._cont = _SLDRBs_ToBeModified_List__item_
    SLDRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeReleased-List >-----#
    SLDRBs_ToBeReleased_List = SEQ_OF(name=u'SLDRBs-ToBeReleased-List', mode=MODE_TYPE)
    _SLDRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeReleased-Item')))
    ___SLDRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 327), (u'criticality', u'reject'), (u'Value', ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeReleased_List__item__id._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__id._const_tab_at = None
    __SLDRBs_ToBeReleased_List__item__id._const_tab_id = u'id'
    __SLDRBs_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_ToBeReleased_List__item__value._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _SLDRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_ToBeReleased_List__item__id),
        (u'criticality', __SLDRBs_ToBeReleased_List__item__criticality),
        (u'value', __SLDRBs_ToBeReleased_List__item__value),
        ])
    _SLDRBs_ToBeReleased_List__item_._ext = None
    SLDRBs_ToBeReleased_List._cont = _SLDRBs_ToBeReleased_List__item_
    SLDRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeSetupMod-ItemIEs >-----#
    SLDRBs_ToBeSetupMod_ItemIEs = CLASS(name=u'SLDRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetupMod-Item')))
    SLDRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 331), (u'criticality', u'reject'), (u'Value', _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeModified-ItemIEs >-----#
    SLDRBs_ToBeModified_ItemIEs = CLASS(name=u'SLDRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeModified-Item')))
    SLDRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 325), (u'criticality', u'reject'), (u'Value', _SLDRBs_ToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeReleased-ItemIEs >-----#
    SLDRBs_ToBeReleased_ItemIEs = CLASS(name=u'SLDRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeReleased-Item')))
    SLDRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 327), (u'criticality', u'reject'), (u'Value', _SLDRBs_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name=u'UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Associated-SCell-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 333), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 318), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 334), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name=u'UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextModificationResponseIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _UEContextModificationResponseIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationResponseIEs_val_Value_12 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _UEContextModificationResponseIEs_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Associated-SCell-List')))
    _UEContextModificationResponseIEs_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextModificationResponseIEs_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_18 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_19 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_20 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_21 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_22 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_23 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_24 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_25 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 333), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 318), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 334), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _UEContextModificationResponseIEs_val_Value_25), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-SetupMod-List >-----#
    DRBs_SetupMod_List = SEQ_OF(name=u'DRBs-SetupMod-List', mode=MODE_TYPE)
    _DRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_SetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-SetupMod-Item')))
    ___DRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', ____DRBs_SetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_SetupMod_List__item__id._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__id._const_tab_at = None
    __DRBs_SetupMod_List__item__id._const_tab_id = u'id'
    __DRBs_SetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_SetupMod_List__item__criticality._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_SetupMod_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_SetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_SetupMod_List__item__value._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_SetupMod_List__item__value._const_tab_id = u'Value'
    _DRBs_SetupMod_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_SetupMod_List__item__id),
        (u'criticality', __DRBs_SetupMod_List__item__criticality),
        (u'value', __DRBs_SetupMod_List__item__value),
        ])
    _DRBs_SetupMod_List__item_._ext = None
    DRBs_SetupMod_List._cont = _DRBs_SetupMod_List__item_
    DRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-Modified-List >-----#
    DRBs_Modified_List = SEQ_OF(name=u'DRBs-Modified-List', mode=MODE_TYPE)
    _DRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Modified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Modified-Item')))
    ___DRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', ____DRBs_Modified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Modified_List__item__id._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__id._const_tab_at = None
    __DRBs_Modified_List__item__id._const_tab_id = u'id'
    __DRBs_Modified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_Modified_List__item__criticality._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_Modified_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_Modified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_Modified_List__item__value._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_Modified_List__item__value._const_tab_id = u'Value'
    _DRBs_Modified_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_Modified_List__item__id),
        (u'criticality', __DRBs_Modified_List__item__criticality),
        (u'value', __DRBs_Modified_List__item__value),
        ])
    _DRBs_Modified_List__item_._ext = None
    DRBs_Modified_List._cont = _DRBs_Modified_List__item_
    DRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-SetupMod-List >-----#
    SRBs_SetupMod_List = SEQ_OF(name=u'SRBs-SetupMod-List', mode=MODE_TYPE)
    _SRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_SetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-SetupMod-Item')))
    ___SRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', ____SRBs_SetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_SetupMod_List__item__id._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__id._const_tab_at = None
    __SRBs_SetupMod_List__item__id._const_tab_id = u'id'
    __SRBs_SetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_SetupMod_List__item__criticality._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_SetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_SetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_SetupMod_List__item__value._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_SetupMod_List__item__value._const_tab_id = u'Value'
    _SRBs_SetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_SetupMod_List__item__id),
        (u'criticality', __SRBs_SetupMod_List__item__criticality),
        (u'value', __SRBs_SetupMod_List__item__value),
        ])
    _SRBs_SetupMod_List__item_._ext = None
    SRBs_SetupMod_List._cont = _SRBs_SetupMod_List__item_
    SRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SRBs-Modified-List >-----#
    SRBs_Modified_List = SEQ_OF(name=u'SRBs-Modified-List', mode=MODE_TYPE)
    _SRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Modified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Modified-Item')))
    ___SRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', ____SRBs_Modified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Modified_List__item__id._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__id._const_tab_at = None
    __SRBs_Modified_List__item__id._const_tab_id = u'id'
    __SRBs_Modified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_Modified_List__item__criticality._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_Modified_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_Modified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_Modified_List__item__value._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_Modified_List__item__value._const_tab_id = u'Value'
    _SRBs_Modified_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_Modified_List__item__id),
        (u'criticality', __SRBs_Modified_List__item__criticality),
        (u'value', __SRBs_Modified_List__item__value),
        ])
    _SRBs_Modified_List__item_._ext = None
    SRBs_Modified_List._cont = _SRBs_Modified_List__item_
    SRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeModified-List >-----#
    DRBs_FailedToBeModified_List = SEQ_OF(name=u'DRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _DRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeModified-Item')))
    ___DRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeModified_List__item__id._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __DRBs_FailedToBeModified_List__item__id._const_tab_id = u'id'
    __DRBs_FailedToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_FailedToBeModified_List__item__criticality._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_FailedToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_FailedToBeModified_List__item__value._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeModified_List__item__value._const_tab_id = u'Value'
    _DRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_FailedToBeModified_List__item__id),
        (u'criticality', __DRBs_FailedToBeModified_List__item__criticality),
        (u'value', __DRBs_FailedToBeModified_List__item__value),
        ])
    _DRBs_FailedToBeModified_List__item_._ext = None
    DRBs_FailedToBeModified_List._cont = _DRBs_FailedToBeModified_List__item_
    DRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-FailedToBeSetupMod-List >-----#
    SRBs_FailedToBeSetupMod_List = SEQ_OF(name=u'SRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _SRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_FailedToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetupMod-Item')))
    ___SRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab_id = u'id'
    __SRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_FailedToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _SRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_FailedToBeSetupMod_List__item__id),
        (u'criticality', __SRBs_FailedToBeSetupMod_List__item__criticality),
        (u'value', __SRBs_FailedToBeSetupMod_List__item__value),
        ])
    _SRBs_FailedToBeSetupMod_List__item_._ext = None
    SRBs_FailedToBeSetupMod_List._cont = _SRBs_FailedToBeSetupMod_List__item_
    SRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeSetupMod-List >-----#
    DRBs_FailedToBeSetupMod_List = SEQ_OF(name=u'DRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _DRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetupMod-Item')))
    ___DRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab_id = u'id'
    __DRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_FailedToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _DRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_FailedToBeSetupMod_List__item__id),
        (u'criticality', __DRBs_FailedToBeSetupMod_List__item__criticality),
        (u'value', __DRBs_FailedToBeSetupMod_List__item__value),
        ])
    _DRBs_FailedToBeSetupMod_List__item_._ext = None
    DRBs_FailedToBeSetupMod_List._cont = _DRBs_FailedToBeSetupMod_List__item_
    DRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-FailedtoSetupMod-List >-----#
    SCell_FailedtoSetupMod_List = SEQ_OF(name=u'SCell-FailedtoSetupMod-List', mode=MODE_TYPE)
    _SCell_FailedtoSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_FailedtoSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SCell_FailedtoSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetupMod-Item')))
    ___SCell_FailedtoSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SCell_FailedtoSetupMod_List__item__id._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__id._const_tab_at = None
    __SCell_FailedtoSetupMod_List__item__id._const_tab_id = u'id'
    __SCell_FailedtoSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SCell_FailedtoSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SCell_FailedtoSetupMod_List__item__value._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SCell_FailedtoSetupMod_List__item__value._const_tab_id = u'Value'
    _SCell_FailedtoSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SCell_FailedtoSetupMod_List__item__id),
        (u'criticality', __SCell_FailedtoSetupMod_List__item__criticality),
        (u'value', __SCell_FailedtoSetupMod_List__item__value),
        ])
    _SCell_FailedtoSetupMod_List__item_._ext = None
    SCell_FailedtoSetupMod_List._cont = _SCell_FailedtoSetupMod_List__item_
    SCell_FailedtoSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BHChannels-SetupMod-List >-----#
    BHChannels_SetupMod_List = SEQ_OF(name=u'BHChannels-SetupMod-List', mode=MODE_TYPE)
    _BHChannels_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_SetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-SetupMod-Item')))
    ___BHChannels_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', ____BHChannels_SetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_SetupMod_List__item__id._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__id._const_tab_at = None
    __BHChannels_SetupMod_List__item__id._const_tab_id = u'id'
    __BHChannels_SetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_SetupMod_List__item__criticality._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_SetupMod_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_SetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_SetupMod_List__item__value._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_SetupMod_List__item__value._const_tab_id = u'Value'
    _BHChannels_SetupMod_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_SetupMod_List__item__id),
        (u'criticality', __BHChannels_SetupMod_List__item__criticality),
        (u'value', __BHChannels_SetupMod_List__item__value),
        ])
    _BHChannels_SetupMod_List__item_._ext = None
    BHChannels_SetupMod_List._cont = _BHChannels_SetupMod_List__item_
    BHChannels_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-Modified-List >-----#
    BHChannels_Modified_List = SEQ_OF(name=u'BHChannels-Modified-List', mode=MODE_TYPE)
    _BHChannels_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Modified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Modified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Modified-Item')))
    ___BHChannels_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 272), (u'criticality', u'ignore'), (u'Value', ____BHChannels_Modified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Modified_List__item__id._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__id._const_tab_at = None
    __BHChannels_Modified_List__item__id._const_tab_id = u'id'
    __BHChannels_Modified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_Modified_List__item__criticality._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_Modified_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_Modified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_Modified_List__item__value._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_Modified_List__item__value._const_tab_id = u'Value'
    _BHChannels_Modified_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_Modified_List__item__id),
        (u'criticality', __BHChannels_Modified_List__item__criticality),
        (u'value', __BHChannels_Modified_List__item__value),
        ])
    _BHChannels_Modified_List__item_._ext = None
    BHChannels_Modified_List._cont = _BHChannels_Modified_List__item_
    BHChannels_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeModified-List >-----#
    BHChannels_FailedToBeModified_List = SEQ_OF(name=u'BHChannels-FailedToBeModified-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeModified-Item')))
    ___BHChannels_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 268), (u'criticality', u'ignore'), (u'Value', ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeModified_List__item__id._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeModified_List__item__id._const_tab_id = u'id'
    __BHChannels_FailedToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_FailedToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_FailedToBeModified_List__item__value._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeModified_List__item__value._const_tab_id = u'Value'
    _BHChannels_FailedToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_FailedToBeModified_List__item__id),
        (u'criticality', __BHChannels_FailedToBeModified_List__item__criticality),
        (u'value', __BHChannels_FailedToBeModified_List__item__value),
        ])
    _BHChannels_FailedToBeModified_List__item_._ext = None
    BHChannels_FailedToBeModified_List._cont = _BHChannels_FailedToBeModified_List__item_
    BHChannels_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-List >-----#
    BHChannels_FailedToBeSetupMod_List = SEQ_OF(name=u'BHChannels-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetupMod-Item')))
    ___BHChannels_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 270), (u'criticality', u'ignore'), (u'Value', ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab_id = u'id'
    __BHChannels_FailedToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_FailedToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _BHChannels_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_FailedToBeSetupMod_List__item__id),
        (u'criticality', __BHChannels_FailedToBeSetupMod_List__item__criticality),
        (u'value', __BHChannels_FailedToBeSetupMod_List__item__value),
        ])
    _BHChannels_FailedToBeSetupMod_List__item_._ext = None
    BHChannels_FailedToBeSetupMod_List._cont = _BHChannels_FailedToBeSetupMod_List__item_
    BHChannels_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< Associated-SCell-List >-----#
    Associated_SCell_List = SEQ_OF(name=u'Associated-SCell-List', mode=MODE_TYPE)
    _Associated_SCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Associated_SCell_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Associated_SCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Associated_SCell_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Associated-SCell-Item')))
    ___Associated_SCell_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', ____Associated_SCell_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Associated_SCell_List__item__id._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__id._const_tab_at = None
    __Associated_SCell_List__item__id._const_tab_id = u'id'
    __Associated_SCell_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Associated_SCell_List__item__criticality._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__criticality._const_tab_at = ('..', u'id')
    __Associated_SCell_List__item__criticality._const_tab_id = u'criticality'
    __Associated_SCell_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Associated_SCell_List__item__value._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__value._const_tab_at = ('..', u'id')
    __Associated_SCell_List__item__value._const_tab_id = u'Value'
    _Associated_SCell_List__item_._cont = ASN1Dict([
        (u'id', __Associated_SCell_List__item__id),
        (u'criticality', __Associated_SCell_List__item__criticality),
        (u'value', __Associated_SCell_List__item__value),
        ])
    _Associated_SCell_List__item_._ext = None
    Associated_SCell_List._cont = _Associated_SCell_List__item_
    Associated_SCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBs-SetupMod-ItemIEs >-----#
    DRBs_SetupMod_ItemIEs = CLASS(name=u'DRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-SetupMod-Item')))
    DRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _DRBs_SetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Modified-ItemIEs >-----#
    DRBs_Modified_ItemIEs = CLASS(name=u'DRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Modified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Modified-Item')))
    DRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _DRBs_Modified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-SetupMod-ItemIEs >-----#
    SRBs_SetupMod_ItemIEs = CLASS(name=u'SRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-SetupMod-Item')))
    SRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _SRBs_SetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Modified-ItemIEs >-----#
    SRBs_Modified_ItemIEs = CLASS(name=u'SRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Modified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Modified-Item')))
    SRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _SRBs_Modified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetupMod-ItemIEs >-----#
    SRBs_FailedToBeSetupMod_ItemIEs = CLASS(name=u'SRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetupMod-Item')))
    SRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetupMod-ItemIEs >-----#
    DRBs_FailedToBeSetupMod_ItemIEs = CLASS(name=u'DRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetupMod-Item')))
    DRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeModified-ItemIEs >-----#
    DRBs_FailedToBeModified_ItemIEs = CLASS(name=u'DRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeModified-Item')))
    DRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _DRBs_FailedToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetupMod-ItemIEs >-----#
    SCell_FailedtoSetupMod_ItemIEs = CLASS(name=u'SCell-FailedtoSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_FailedtoSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetupMod-Item')))
    SCell_FailedtoSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _SCell_FailedtoSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Associated-SCell-ItemIEs >-----#
    Associated_SCell_ItemIEs = CLASS(name=u'Associated-SCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Associated_SCell_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Associated-SCell-Item')))
    Associated_SCell_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', _Associated_SCell_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-SetupMod-ItemIEs >-----#
    BHChannels_SetupMod_ItemIEs = CLASS(name=u'BHChannels-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_SetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-SetupMod-Item')))
    BHChannels_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', _BHChannels_SetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Modified-ItemIEs >-----#
    BHChannels_Modified_ItemIEs = CLASS(name=u'BHChannels-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Modified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Modified-Item')))
    BHChannels_Modified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 272), (u'criticality', u'ignore'), (u'Value', _BHChannels_Modified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-ItemIEs >-----#
    BHChannels_FailedToBeSetupMod_ItemIEs = CLASS(name=u'BHChannels-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetupMod-Item')))
    BHChannels_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 270), (u'criticality', u'ignore'), (u'Value', _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeModified-ItemIEs >-----#
    BHChannels_FailedToBeModified_ItemIEs = CLASS(name=u'BHChannels-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeModified-Item')))
    BHChannels_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 268), (u'criticality', u'ignore'), (u'Value', _BHChannels_FailedToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-SetupMod-List >-----#
    SLDRBs_SetupMod_List = SEQ_OF(name=u'SLDRBs-SetupMod-List', mode=MODE_TYPE)
    _SLDRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_SetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-SetupMod-Item')))
    ___SLDRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 335), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_SetupMod_List__item__id._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__id._const_tab_at = None
    __SLDRBs_SetupMod_List__item__id._const_tab_id = u'id'
    __SLDRBs_SetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_SetupMod_List__item__criticality._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_SetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_SetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_SetupMod_List__item__value._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_SetupMod_List__item__value._const_tab_id = u'Value'
    _SLDRBs_SetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_SetupMod_List__item__id),
        (u'criticality', __SLDRBs_SetupMod_List__item__criticality),
        (u'value', __SLDRBs_SetupMod_List__item__value),
        ])
    _SLDRBs_SetupMod_List__item_._ext = None
    SLDRBs_SetupMod_List._cont = _SLDRBs_SetupMod_List__item_
    SLDRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Modified-List >-----#
    SLDRBs_Modified_List = SEQ_OF(name=u'SLDRBs-Modified-List', mode=MODE_TYPE)
    _SLDRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Modified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Modified-Item')))
    ___SLDRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 317), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_Modified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Modified_List__item__id._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__id._const_tab_at = None
    __SLDRBs_Modified_List__item__id._const_tab_id = u'id'
    __SLDRBs_Modified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_Modified_List__item__criticality._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_Modified_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_Modified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_Modified_List__item__value._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_Modified_List__item__value._const_tab_id = u'Value'
    _SLDRBs_Modified_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_Modified_List__item__id),
        (u'criticality', __SLDRBs_Modified_List__item__criticality),
        (u'value', __SLDRBs_Modified_List__item__value),
        ])
    _SLDRBs_Modified_List__item_._ext = None
    SLDRBs_Modified_List._cont = _SLDRBs_Modified_List__item_
    SLDRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeModified-List >-----#
    SLDRBs_FailedToBeModified_List = SEQ_OF(name=u'SLDRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeModified-Item')))
    ___SLDRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeModified_List__item__id._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeModified_List__item__id._const_tab_id = u'id'
    __SLDRBs_FailedToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_FailedToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_FailedToBeModified_List__item__value._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeModified_List__item__value._const_tab_id = u'Value'
    _SLDRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_FailedToBeModified_List__item__id),
        (u'criticality', __SLDRBs_FailedToBeModified_List__item__criticality),
        (u'value', __SLDRBs_FailedToBeModified_List__item__value),
        ])
    _SLDRBs_FailedToBeModified_List__item_._ext = None
    SLDRBs_FailedToBeModified_List._cont = _SLDRBs_FailedToBeModified_List__item_
    SLDRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-List >-----#
    SLDRBs_FailedToBeSetupMod_List = SEQ_OF(name=u'SLDRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeSetupMod_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetupMod-Item')))
    ___SLDRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 336), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab_id = u'id'
    __SLDRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_FailedToBeSetupMod_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab_id = u'Value'
    _SLDRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_FailedToBeSetupMod_List__item__id),
        (u'criticality', __SLDRBs_FailedToBeSetupMod_List__item__criticality),
        (u'value', __SLDRBs_FailedToBeSetupMod_List__item__value),
        ])
    _SLDRBs_FailedToBeSetupMod_List__item_._ext = None
    SLDRBs_FailedToBeSetupMod_List._cont = _SLDRBs_FailedToBeSetupMod_List__item_
    SLDRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-SetupMod-ItemIEs >-----#
    SLDRBs_SetupMod_ItemIEs = CLASS(name=u'SLDRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-SetupMod-Item')))
    SLDRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 335), (u'criticality', u'ignore'), (u'Value', _SLDRBs_SetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Modified-ItemIEs >-----#
    SLDRBs_Modified_ItemIEs = CLASS(name=u'SLDRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Modified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Modified-Item')))
    SLDRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 317), (u'criticality', u'ignore'), (u'Value', _SLDRBs_Modified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-ItemIEs >-----#
    SLDRBs_FailedToBeSetupMod_ItemIEs = CLASS(name=u'SLDRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetupMod-Item')))
    SLDRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 336), (u'criticality', u'ignore'), (u'Value', _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeModified-ItemIEs >-----#
    SLDRBs_FailedToBeModified_ItemIEs = CLASS(name=u'SLDRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeModified-Item')))
    SLDRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Value', _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name=u'UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name=u'UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 376), (u'criticality', u'reject'), (u'Value', _UEContextModificationFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequired >-----#
    UEContextModificationRequired = SEQ(name=u'UEContextModificationRequired', mode=MODE_TYPE)
    _UEContextModificationRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeModified-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeModified-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    ____UEContextModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 277), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 320), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 322), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationRequired_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationRequired_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationRequired_protocolIEs__item__value),
        ])
    __UEContextModificationRequired_protocolIEs__item_._ext = None
    _UEContextModificationRequired_protocolIEs._cont = __UEContextModificationRequired_protocolIEs__item_
    _UEContextModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequired._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationRequired_protocolIEs),
        ])
    UEContextModificationRequired._ext = []
    
    #-----< UEContextModificationRequiredIEs >-----#
    UEContextModificationRequiredIEs = CLASS(name=u'UEContextModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRequiredIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRequiredIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRequiredIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationRequiredIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextModificationRequiredIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeModified-List')))
    _UEContextModificationRequiredIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_7 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationRequiredIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeModified-List')))
    _UEContextModificationRequiredIEs_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    UEContextModificationRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequiredIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequiredIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 277), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 320), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 322), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 375), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequiredIEs_val_Value_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeModified-List >-----#
    DRBs_Required_ToBeModified_List = SEQ_OF(name=u'DRBs-Required-ToBeModified-List', mode=MODE_TYPE)
    _DRBs_Required_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Required_ToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_Required_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeModified-Item')))
    ___DRBs_Required_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Required_ToBeModified_List__item__id._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__id._const_tab_at = None
    __DRBs_Required_ToBeModified_List__item__id._const_tab_id = u'id'
    __DRBs_Required_ToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_Required_ToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_Required_ToBeModified_List__item__value._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_Required_ToBeModified_List__item__value._const_tab_id = u'Value'
    _DRBs_Required_ToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_Required_ToBeModified_List__item__id),
        (u'criticality', __DRBs_Required_ToBeModified_List__item__criticality),
        (u'value', __DRBs_Required_ToBeModified_List__item__value),
        ])
    _DRBs_Required_ToBeModified_List__item_._ext = None
    DRBs_Required_ToBeModified_List._cont = _DRBs_Required_ToBeModified_List__item_
    DRBs_Required_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-Required-ToBeReleased-List >-----#
    DRBs_Required_ToBeReleased_List = SEQ_OF(name=u'DRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _DRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Required_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeReleased-Item')))
    ___DRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Required_ToBeReleased_List__item__id._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __DRBs_Required_ToBeReleased_List__item__id._const_tab_id = u'id'
    __DRBs_Required_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_Required_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_Required_ToBeReleased_List__item__value._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_Required_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _DRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_Required_ToBeReleased_List__item__id),
        (u'criticality', __DRBs_Required_ToBeReleased_List__item__criticality),
        (u'value', __DRBs_Required_ToBeReleased_List__item__value),
        ])
    _DRBs_Required_ToBeReleased_List__item_._ext = None
    DRBs_Required_ToBeReleased_List._cont = _DRBs_Required_ToBeReleased_List__item_
    DRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-Required-ToBeReleased-List >-----#
    SRBs_Required_ToBeReleased_List = SEQ_OF(name=u'SRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _SRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Required_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Required-ToBeReleased-Item')))
    ___SRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'reject'), (u'Value', ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Required_ToBeReleased_List__item__id._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __SRBs_Required_ToBeReleased_List__item__id._const_tab_id = u'id'
    __SRBs_Required_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __SRBs_Required_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SRBs_Required_ToBeReleased_List__item__value._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __SRBs_Required_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _SRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __SRBs_Required_ToBeReleased_List__item__id),
        (u'criticality', __SRBs_Required_ToBeReleased_List__item__criticality),
        (u'value', __SRBs_Required_ToBeReleased_List__item__value),
        ])
    _SRBs_Required_ToBeReleased_List__item_._ext = None
    SRBs_Required_ToBeReleased_List._cont = _SRBs_Required_ToBeReleased_List__item_
    SRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< BHChannels-Required-ToBeReleased-List >-----#
    BHChannels_Required_ToBeReleased_List = SEQ_OF(name=u'BHChannels-Required-ToBeReleased-List', mode=MODE_TYPE)
    _BHChannels_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Required_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BHChannels_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Required-ToBeReleased-Item')))
    ___BHChannels_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 276), (u'criticality', u'reject'), (u'Value', ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab_at = None
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab_id = u'id'
    __BHChannels_Required_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __BHChannels_Required_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _BHChannels_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __BHChannels_Required_ToBeReleased_List__item__id),
        (u'criticality', __BHChannels_Required_ToBeReleased_List__item__criticality),
        (u'value', __BHChannels_Required_ToBeReleased_List__item__value),
        ])
    _BHChannels_Required_ToBeReleased_List__item_._ext = None
    BHChannels_Required_ToBeReleased_List._cont = _BHChannels_Required_ToBeReleased_List__item_
    BHChannels_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-Required-ToBeModified-ItemIEs >-----#
    DRBs_Required_ToBeModified_ItemIEs = CLASS(name=u'DRBs-Required-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Required_ToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeModified-Item')))
    DRBs_Required_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', _DRBs_Required_ToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeReleased-ItemIEs >-----#
    DRBs_Required_ToBeReleased_ItemIEs = CLASS(name=u'DRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeReleased-Item')))
    DRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Required-ToBeReleased-ItemIEs >-----#
    SRBs_Required_ToBeReleased_ItemIEs = CLASS(name=u'SRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Required-ToBeReleased-Item')))
    SRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'reject'), (u'Value', _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Required-ToBeReleased-ItemIEs >-----#
    BHChannels_Required_ToBeReleased_ItemIEs = CLASS(name=u'BHChannels-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Required-ToBeReleased-Item')))
    BHChannels_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 276), (u'criticality', u'reject'), (u'Value', _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeModified-List >-----#
    SLDRBs_Required_ToBeModified_List = SEQ_OF(name=u'SLDRBs-Required-ToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Required_ToBeModified_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_Required_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeModified-Item')))
    ___SLDRBs_Required_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'reject'), (u'Value', ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab_id = u'id'
    __SLDRBs_Required_ToBeModified_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_Required_ToBeModified_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab_id = u'Value'
    _SLDRBs_Required_ToBeModified_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_Required_ToBeModified_List__item__id),
        (u'criticality', __SLDRBs_Required_ToBeModified_List__item__criticality),
        (u'value', __SLDRBs_Required_ToBeModified_List__item__value),
        ])
    _SLDRBs_Required_ToBeModified_List__item_._ext = None
    SLDRBs_Required_ToBeModified_List._cont = _SLDRBs_Required_ToBeModified_List__item_
    SLDRBs_Required_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-List >-----#
    SLDRBs_Required_ToBeReleased_List = SEQ_OF(name=u'SLDRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Required_ToBeReleased_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeReleased-Item')))
    ___SLDRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab_id = u'id'
    __SLDRBs_Required_ToBeReleased_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_Required_ToBeReleased_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab_id = u'Value'
    _SLDRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_Required_ToBeReleased_List__item__id),
        (u'criticality', __SLDRBs_Required_ToBeReleased_List__item__criticality),
        (u'value', __SLDRBs_Required_ToBeReleased_List__item__value),
        ])
    _SLDRBs_Required_ToBeReleased_List__item_._ext = None
    SLDRBs_Required_ToBeReleased_List._cont = _SLDRBs_Required_ToBeReleased_List__item_
    SLDRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Required-ToBeModified-ItemIEs >-----#
    SLDRBs_Required_ToBeModified_ItemIEs = CLASS(name=u'SLDRBs-Required-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeModified-Item')))
    SLDRBs_Required_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'reject'), (u'Value', _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-ItemIEs >-----#
    SLDRBs_Required_ToBeReleased_ItemIEs = CLASS(name=u'SLDRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeReleased-Item')))
    SLDRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationConfirm >-----#
    UEContextModificationConfirm = SEQ(name=u'UEContextModificationConfirm', mode=MODE_TYPE)
    _UEContextModificationConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ModifiedConf-List')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ModifiedConf-List')))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 337), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationConfirm_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationConfirm_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationConfirm_protocolIEs__item__value),
        ])
    __UEContextModificationConfirm_protocolIEs__item_._ext = None
    _UEContextModificationConfirm_protocolIEs._cont = __UEContextModificationConfirm_protocolIEs__item_
    _UEContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationConfirm._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationConfirm_protocolIEs),
        ])
    UEContextModificationConfirm._ext = []
    
    #-----< UEContextModificationConfirmIEs >-----#
    UEContextModificationConfirmIEs = CLASS(name=u'UEContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationConfirmIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationConfirmIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ModifiedConf-List')))
    _UEContextModificationConfirmIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextModificationConfirmIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationConfirmIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextModificationConfirmIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextModificationConfirmIEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ModifiedConf-List')))
    UEContextModificationConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 337), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ModifiedConf-List >-----#
    DRBs_ModifiedConf_List = SEQ_OF(name=u'DRBs-ModifiedConf-List', mode=MODE_TYPE)
    _DRBs_ModifiedConf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ModifiedConf_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRBs_ModifiedConf_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ModifiedConf-Item')))
    ___DRBs_ModifiedConf_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ModifiedConf_List__item__id._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__id._const_tab_at = None
    __DRBs_ModifiedConf_List__item__id._const_tab_id = u'id'
    __DRBs_ModifiedConf_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRBs_ModifiedConf_List__item__criticality._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__criticality._const_tab_at = ('..', u'id')
    __DRBs_ModifiedConf_List__item__criticality._const_tab_id = u'criticality'
    __DRBs_ModifiedConf_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRBs_ModifiedConf_List__item__value._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__value._const_tab_at = ('..', u'id')
    __DRBs_ModifiedConf_List__item__value._const_tab_id = u'Value'
    _DRBs_ModifiedConf_List__item_._cont = ASN1Dict([
        (u'id', __DRBs_ModifiedConf_List__item__id),
        (u'criticality', __DRBs_ModifiedConf_List__item__criticality),
        (u'value', __DRBs_ModifiedConf_List__item__value),
        ])
    _DRBs_ModifiedConf_List__item_._ext = None
    DRBs_ModifiedConf_List._cont = _DRBs_ModifiedConf_List__item_
    DRBs_ModifiedConf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-ModifiedConf-ItemIEs >-----#
    DRBs_ModifiedConf_ItemIEs = CLASS(name=u'DRBs-ModifiedConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ModifiedConf_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ModifiedConf-Item')))
    DRBs_ModifiedConf_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _DRBs_ModifiedConf_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ModifiedConf-List >-----#
    SLDRBs_ModifiedConf_List = SEQ_OF(name=u'SLDRBs-ModifiedConf-List', mode=MODE_TYPE)
    _SLDRBs_ModifiedConf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ModifiedConf_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SLDRBs_ModifiedConf_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ModifiedConf-Item')))
    ___SLDRBs_ModifiedConf_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 338), (u'criticality', u'ignore'), (u'Value', ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ModifiedConf_List__item__id._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__id._const_tab_at = None
    __SLDRBs_ModifiedConf_List__item__id._const_tab_id = u'id'
    __SLDRBs_ModifiedConf_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab_at = ('..', u'id')
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab_id = u'criticality'
    __SLDRBs_ModifiedConf_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __SLDRBs_ModifiedConf_List__item__value._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__value._const_tab_at = ('..', u'id')
    __SLDRBs_ModifiedConf_List__item__value._const_tab_id = u'Value'
    _SLDRBs_ModifiedConf_List__item_._cont = ASN1Dict([
        (u'id', __SLDRBs_ModifiedConf_List__item__id),
        (u'criticality', __SLDRBs_ModifiedConf_List__item__criticality),
        (u'value', __SLDRBs_ModifiedConf_List__item__value),
        ])
    _SLDRBs_ModifiedConf_List__item_._ext = None
    SLDRBs_ModifiedConf_List._cont = _SLDRBs_ModifiedConf_List__item_
    SLDRBs_ModifiedConf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ModifiedConf-ItemIEs >-----#
    SLDRBs_ModifiedConf_ItemIEs = CLASS(name=u'SLDRBs-ModifiedConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ModifiedConf_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ModifiedConf-Item')))
    SLDRBs_ModifiedConf_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 338), (u'criticality', u'ignore'), (u'Value', _SLDRBs_ModifiedConf_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRefuse >-----#
    UEContextModificationRefuse = SEQ(name=u'UEContextModificationRefuse', mode=MODE_TYPE)
    _UEContextModificationRefuse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRefuse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationRefuse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationRefuse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationRefuse_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationRefuse_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationRefuse_protocolIEs__item__value),
        ])
    __UEContextModificationRefuse_protocolIEs__item_._ext = None
    _UEContextModificationRefuse_protocolIEs._cont = __UEContextModificationRefuse_protocolIEs__item_
    _UEContextModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRefuse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationRefuse_protocolIEs),
        ])
    UEContextModificationRefuse._ext = []
    
    #-----< UEContextModificationRefuseIEs >-----#
    UEContextModificationRefuseIEs = CLASS(name=u'UEContextModificationRefuseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRefuseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRefuseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRefuseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationRefuseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationRefuseIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationRefuseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEContextModificationRefuseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRefuseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRefuseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name=u'WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWSSystemInformation')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-To-Be-Broadcast-List')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name=u'WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWSSystemInformation')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-To-Be-Broadcast-List')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-To-Be-Broadcast-List >-----#
    Cells_To_Be_Broadcast_List = SEQ_OF(name=u'Cells-To-Be-Broadcast-List', mode=MODE_TYPE)
    _Cells_To_Be_Broadcast_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_To_Be_Broadcast_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_To_Be_Broadcast_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-To-Be-Broadcast-Item')))
    ___Cells_To_Be_Broadcast_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_To_Be_Broadcast_List__item__id._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__id._const_tab_at = None
    __Cells_To_Be_Broadcast_List__item__id._const_tab_id = u'id'
    __Cells_To_Be_Broadcast_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab_id = u'criticality'
    __Cells_To_Be_Broadcast_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_To_Be_Broadcast_List__item__value._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__value._const_tab_at = ('..', u'id')
    __Cells_To_Be_Broadcast_List__item__value._const_tab_id = u'Value'
    _Cells_To_Be_Broadcast_List__item_._cont = ASN1Dict([
        (u'id', __Cells_To_Be_Broadcast_List__item__id),
        (u'criticality', __Cells_To_Be_Broadcast_List__item__criticality),
        (u'value', __Cells_To_Be_Broadcast_List__item__value),
        ])
    _Cells_To_Be_Broadcast_List__item_._ext = None
    Cells_To_Be_Broadcast_List._cont = _Cells_To_Be_Broadcast_List__item_
    Cells_To_Be_Broadcast_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-To-Be-Broadcast-List-ItemIEs >-----#
    Cells_To_Be_Broadcast_List_ItemIEs = CLASS(name=u'Cells-To-Be-Broadcast-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-To-Be-Broadcast-Item')))
    Cells_To_Be_Broadcast_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name=u'WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Completed-List')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name=u'WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Completed-List')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Completed-List >-----#
    Cells_Broadcast_Completed_List = SEQ_OF(name=u'Cells-Broadcast-Completed-List', mode=MODE_TYPE)
    _Cells_Broadcast_Completed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Broadcast_Completed_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_Broadcast_Completed_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Completed-Item')))
    ___Cells_Broadcast_Completed_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Broadcast_Completed_List__item__id._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__id._const_tab_at = None
    __Cells_Broadcast_Completed_List__item__id._const_tab_id = u'id'
    __Cells_Broadcast_Completed_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_Broadcast_Completed_List__item__criticality._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_Broadcast_Completed_List__item__criticality._const_tab_id = u'criticality'
    __Cells_Broadcast_Completed_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_Broadcast_Completed_List__item__value._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__value._const_tab_at = ('..', u'id')
    __Cells_Broadcast_Completed_List__item__value._const_tab_id = u'Value'
    _Cells_Broadcast_Completed_List__item_._cont = ASN1Dict([
        (u'id', __Cells_Broadcast_Completed_List__item__id),
        (u'criticality', __Cells_Broadcast_Completed_List__item__criticality),
        (u'value', __Cells_Broadcast_Completed_List__item__value),
        ])
    _Cells_Broadcast_Completed_List__item_._ext = None
    Cells_Broadcast_Completed_List._cont = _Cells_Broadcast_Completed_List__item_
    Cells_Broadcast_Completed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Broadcast-Completed-List-ItemIEs >-----#
    Cells_Broadcast_Completed_List_ItemIEs = CLASS(name=u'Cells-Broadcast-Completed-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Completed-Item')))
    Cells_Broadcast_Completed_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelRequest >-----#
    PWSCancelRequest = SEQ(name=u'PWSCancelRequest', mode=MODE_TYPE)
    _PWSCancelRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSCancelRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PWSCancelRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Broadcast-To-Be-Cancelled-List')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cancel-all-Warning-Messages-Indicator')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    ____PWSCancelRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelRequest_protocolIEs__item__id._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSCancelRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSCancelRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSCancelRequest_protocolIEs__item__value._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSCancelRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSCancelRequest_protocolIEs__item__id),
        (u'criticality', ___PWSCancelRequest_protocolIEs__item__criticality),
        (u'value', ___PWSCancelRequest_protocolIEs__item__value),
        ])
    __PWSCancelRequest_protocolIEs__item_._ext = None
    _PWSCancelRequest_protocolIEs._cont = __PWSCancelRequest_protocolIEs__item_
    _PWSCancelRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelRequest._cont = ASN1Dict([
        (u'protocolIEs', _PWSCancelRequest_protocolIEs),
        ])
    PWSCancelRequest._ext = []
    
    #-----< PWSCancelRequestIEs >-----#
    PWSCancelRequestIEs = CLASS(name=u'PWSCancelRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSCancelRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSCancelRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _PWSCancelRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Broadcast-To-Be-Cancelled-List')))
    _PWSCancelRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cancel-all-Warning-Messages-Indicator')))
    _PWSCancelRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    PWSCancelRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Broadcast-To-Be-Cancelled-List >-----#
    Broadcast_To_Be_Cancelled_List = SEQ_OF(name=u'Broadcast-To-Be-Cancelled-List', mode=MODE_TYPE)
    _Broadcast_To_Be_Cancelled_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Broadcast_To_Be_Cancelled_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Broadcast_To_Be_Cancelled_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Broadcast-To-Be-Cancelled-Item')))
    ___Broadcast_To_Be_Cancelled_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'reject'), (u'Value', ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab_at = None
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab_id = u'id'
    __Broadcast_To_Be_Cancelled_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab_at = ('..', u'id')
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab_id = u'criticality'
    __Broadcast_To_Be_Cancelled_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab_at = ('..', u'id')
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab_id = u'Value'
    _Broadcast_To_Be_Cancelled_List__item_._cont = ASN1Dict([
        (u'id', __Broadcast_To_Be_Cancelled_List__item__id),
        (u'criticality', __Broadcast_To_Be_Cancelled_List__item__criticality),
        (u'value', __Broadcast_To_Be_Cancelled_List__item__value),
        ])
    _Broadcast_To_Be_Cancelled_List__item_._ext = None
    Broadcast_To_Be_Cancelled_List._cont = _Broadcast_To_Be_Cancelled_List__item_
    Broadcast_To_Be_Cancelled_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Broadcast-To-Be-Cancelled-List-ItemIEs >-----#
    Broadcast_To_Be_Cancelled_List_ItemIEs = CLASS(name=u'Broadcast-To-Be-Cancelled-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Broadcast-To-Be-Cancelled-Item')))
    Broadcast_To_Be_Cancelled_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'reject'), (u'Value', _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelResponse >-----#
    PWSCancelResponse = SEQ(name=u'PWSCancelResponse', mode=MODE_TYPE)
    _PWSCancelResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSCancelResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PWSCancelResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Cancelled-List')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PWSCancelResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 150), (u'criticality', u'reject'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelResponse_protocolIEs__item__id._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSCancelResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSCancelResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSCancelResponse_protocolIEs__item__value._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSCancelResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSCancelResponse_protocolIEs__item__id),
        (u'criticality', ___PWSCancelResponse_protocolIEs__item__criticality),
        (u'value', ___PWSCancelResponse_protocolIEs__item__value),
        ])
    __PWSCancelResponse_protocolIEs__item_._ext = None
    _PWSCancelResponse_protocolIEs._cont = __PWSCancelResponse_protocolIEs__item_
    _PWSCancelResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelResponse._cont = ASN1Dict([
        (u'protocolIEs', _PWSCancelResponse_protocolIEs),
        ])
    PWSCancelResponse._ext = []
    
    #-----< PWSCancelResponseIEs >-----#
    PWSCancelResponseIEs = CLASS(name=u'PWSCancelResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSCancelResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSCancelResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Cancelled-List')))
    _PWSCancelResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PWSCancelResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PWSCancelResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 150), (u'criticality', u'reject'), (u'Value', _PWSCancelResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PWSCancelResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Cancelled-List >-----#
    Cells_Broadcast_Cancelled_List = SEQ_OF(name=u'Cells-Broadcast-Cancelled-List', mode=MODE_TYPE)
    _Cells_Broadcast_Cancelled_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Broadcast_Cancelled_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___Cells_Broadcast_Cancelled_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Cancelled-Item')))
    ___Cells_Broadcast_Cancelled_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'reject'), (u'Value', ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Broadcast_Cancelled_List__item__id._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__id._const_tab_at = None
    __Cells_Broadcast_Cancelled_List__item__id._const_tab_id = u'id'
    __Cells_Broadcast_Cancelled_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab_at = ('..', u'id')
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab_id = u'criticality'
    __Cells_Broadcast_Cancelled_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __Cells_Broadcast_Cancelled_List__item__value._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__value._const_tab_at = ('..', u'id')
    __Cells_Broadcast_Cancelled_List__item__value._const_tab_id = u'Value'
    _Cells_Broadcast_Cancelled_List__item_._cont = ASN1Dict([
        (u'id', __Cells_Broadcast_Cancelled_List__item__id),
        (u'criticality', __Cells_Broadcast_Cancelled_List__item__criticality),
        (u'value', __Cells_Broadcast_Cancelled_List__item__value),
        ])
    _Cells_Broadcast_Cancelled_List__item_._ext = None
    Cells_Broadcast_Cancelled_List._cont = _Cells_Broadcast_Cancelled_List__item_
    Cells_Broadcast_Cancelled_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Broadcast-Cancelled-List-ItemIEs >-----#
    Cells_Broadcast_Cancelled_List_ItemIEs = CLASS(name=u'Cells-Broadcast-Cancelled-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Cancelled-Item')))
    Cells_Broadcast_Cancelled_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'reject'), (u'Value', _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInactivityNotification >-----#
    UEInactivityNotification = SEQ(name=u'UEInactivityNotification', mode=MODE_TYPE)
    _UEInactivityNotification_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEInactivityNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEInactivityNotification_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____UEInactivityNotification_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Activity-List')))
    ____UEInactivityNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'reject'), (u'Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEInactivityNotification_protocolIEs__item__id._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__id._const_tab_at = None
    ___UEInactivityNotification_protocolIEs__item__id._const_tab_id = u'id'
    ___UEInactivityNotification_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEInactivityNotification_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___UEInactivityNotification_protocolIEs__item__value._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEInactivityNotification_protocolIEs__item__value._const_tab_id = u'Value'
    __UEInactivityNotification_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEInactivityNotification_protocolIEs__item__id),
        (u'criticality', ___UEInactivityNotification_protocolIEs__item__criticality),
        (u'value', ___UEInactivityNotification_protocolIEs__item__value),
        ])
    __UEInactivityNotification_protocolIEs__item_._ext = None
    _UEInactivityNotification_protocolIEs._cont = __UEInactivityNotification_protocolIEs__item_
    _UEInactivityNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInactivityNotification._cont = ASN1Dict([
        (u'protocolIEs', _UEInactivityNotification_protocolIEs),
        ])
    UEInactivityNotification._ext = []
    
    #-----< UEInactivityNotificationIEs >-----#
    UEInactivityNotificationIEs = CLASS(name=u'UEInactivityNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEInactivityNotificationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEInactivityNotificationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEInactivityNotificationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Activity-List')))
    UEInactivityNotificationIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEInactivityNotificationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _UEInactivityNotificationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'reject'), (u'Value', _UEInactivityNotificationIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity-List >-----#
    DRB_Activity_List = SEQ_OF(name=u'DRB-Activity-List', mode=MODE_TYPE)
    _DRB_Activity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRB_Activity_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRB_Activity_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRB_Activity_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity-Item')))
    ___DRB_Activity_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'reject'), (u'Value', ____DRB_Activity_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRB_Activity_List__item__id._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__id._const_tab_at = None
    __DRB_Activity_List__item__id._const_tab_id = u'id'
    __DRB_Activity_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRB_Activity_List__item__criticality._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__criticality._const_tab_at = ('..', u'id')
    __DRB_Activity_List__item__criticality._const_tab_id = u'criticality'
    __DRB_Activity_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRB_Activity_List__item__value._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__value._const_tab_at = ('..', u'id')
    __DRB_Activity_List__item__value._const_tab_id = u'Value'
    _DRB_Activity_List__item_._cont = ASN1Dict([
        (u'id', __DRB_Activity_List__item__id),
        (u'criticality', __DRB_Activity_List__item__criticality),
        (u'value', __DRB_Activity_List__item__value),
        ])
    _DRB_Activity_List__item_._ext = None
    DRB_Activity_List._cont = _DRB_Activity_List__item_
    DRB_Activity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRB-Activity-ItemIEs >-----#
    DRB_Activity_ItemIEs = CLASS(name=u'DRB-Activity-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRB_Activity_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity-Item')))
    DRB_Activity_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'reject'), (u'Value', _DRB_Activity_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InitialULRRCMessageTransfer >-----#
    InitialULRRCMessageTransfer = SEQ(name=u'InitialULRRCMessageTransfer', mode=MODE_TYPE)
    _InitialULRRCMessageTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __InitialULRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___InitialULRRCMessageTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCContainer')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SULAccessIndication')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer-RRCSetupComplete')))
    ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'ignore'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialULRRCMessageTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialULRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialULRRCMessageTransfer_protocolIEs__item__id),
        (u'criticality', ___InitialULRRCMessageTransfer_protocolIEs__item__criticality),
        (u'value', ___InitialULRRCMessageTransfer_protocolIEs__item__value),
        ])
    __InitialULRRCMessageTransfer_protocolIEs__item_._ext = None
    _InitialULRRCMessageTransfer_protocolIEs._cont = __InitialULRRCMessageTransfer_protocolIEs__item_
    _InitialULRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialULRRCMessageTransfer._cont = ASN1Dict([
        (u'protocolIEs', _InitialULRRCMessageTransfer_protocolIEs),
        ])
    InitialULRRCMessageTransfer._ext = []
    
    #-----< InitialULRRCMessageTransferIEs >-----#
    InitialULRRCMessageTransferIEs = CLASS(name=u'InitialULRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _InitialULRRCMessageTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _InitialULRRCMessageTransferIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _InitialULRRCMessageTransferIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _InitialULRRCMessageTransferIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _InitialULRRCMessageTransferIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCContainer')))
    _InitialULRRCMessageTransferIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SULAccessIndication')))
    _InitialULRRCMessageTransferIEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _InitialULRRCMessageTransferIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _InitialULRRCMessageTransferIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer-RRCSetupComplete')))
    InitialULRRCMessageTransferIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'ignore'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _InitialULRRCMessageTransferIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DLRRCMessageTransfer >-----#
    DLRRCMessageTransfer = SEQ(name=u'DLRRCMessageTransfer', mode=MODE_TYPE)
    _DLRRCMessageTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DLRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DLRRCMessageTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____DLRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEContextNotRetrievable')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    ____DLRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 221), (u'criticality', u'ignore'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DLRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DLRRCMessageTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DLRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DLRRCMessageTransfer_protocolIEs__item__id),
        (u'criticality', ___DLRRCMessageTransfer_protocolIEs__item__criticality),
        (u'value', ___DLRRCMessageTransfer_protocolIEs__item__value),
        ])
    __DLRRCMessageTransfer_protocolIEs__item_._ext = None
    _DLRRCMessageTransfer_protocolIEs._cont = __DLRRCMessageTransfer_protocolIEs__item_
    _DLRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DLRRCMessageTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DLRRCMessageTransfer_protocolIEs),
        ])
    DLRRCMessageTransfer._ext = []
    
    #-----< DLRRCMessageTransferIEs >-----#
    DLRRCMessageTransferIEs = CLASS(name=u'DLRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DLRRCMessageTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _DLRRCMessageTransferIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _DLRRCMessageTransferIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _DLRRCMessageTransferIEs_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _DLRRCMessageTransferIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _DLRRCMessageTransferIEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEContextNotRetrievable')))
    _DLRRCMessageTransferIEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _DLRRCMessageTransferIEs_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _DLRRCMessageTransferIEs_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    DLRRCMessageTransferIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _DLRRCMessageTransferIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _DLRRCMessageTransferIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 221), (u'criticality', u'ignore'), (u'Value', _DLRRCMessageTransferIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _DLRRCMessageTransferIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _DLRRCMessageTransferIEs_val_Value_12), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ULRRCMessageTransfer >-----#
    ULRRCMessageTransfer = SEQ(name=u'ULRRCMessageTransfer', mode=MODE_TYPE)
    _ULRRCMessageTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ULRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ULRRCMessageTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ULRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ____ULRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'reject'), (u'Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___ULRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ULRRCMessageTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __ULRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ULRRCMessageTransfer_protocolIEs__item__id),
        (u'criticality', ___ULRRCMessageTransfer_protocolIEs__item__criticality),
        (u'value', ___ULRRCMessageTransfer_protocolIEs__item__value),
        ])
    __ULRRCMessageTransfer_protocolIEs__item_._ext = None
    _ULRRCMessageTransfer_protocolIEs._cont = __ULRRCMessageTransfer_protocolIEs__item_
    _ULRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ULRRCMessageTransfer._cont = ASN1Dict([
        (u'protocolIEs', _ULRRCMessageTransfer_protocolIEs),
        ])
    ULRRCMessageTransfer._ext = []
    
    #-----< ULRRCMessageTransferIEs >-----#
    ULRRCMessageTransferIEs = CLASS(name=u'ULRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ULRRCMessageTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _ULRRCMessageTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _ULRRCMessageTransferIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _ULRRCMessageTransferIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _ULRRCMessageTransferIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ULRRCMessageTransferIEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ULRRCMessageTransferIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'reject'), (u'Value', _ULRRCMessageTransferIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemInformationDeliveryCommand >-----#
    SystemInformationDeliveryCommand = SEQ(name=u'SystemInformationDeliveryCommand', mode=MODE_TYPE)
    _SystemInformationDeliveryCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __SystemInformationDeliveryCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___SystemInformationDeliveryCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-List')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'reject'), (u'Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_at = None
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SystemInformationDeliveryCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __SystemInformationDeliveryCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SystemInformationDeliveryCommand_protocolIEs__item__id),
        (u'criticality', ___SystemInformationDeliveryCommand_protocolIEs__item__criticality),
        (u'value', ___SystemInformationDeliveryCommand_protocolIEs__item__value),
        ])
    __SystemInformationDeliveryCommand_protocolIEs__item_._ext = None
    _SystemInformationDeliveryCommand_protocolIEs._cont = __SystemInformationDeliveryCommand_protocolIEs__item_
    _SystemInformationDeliveryCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SystemInformationDeliveryCommand._cont = ASN1Dict([
        (u'protocolIEs', _SystemInformationDeliveryCommand_protocolIEs),
        ])
    SystemInformationDeliveryCommand._ext = []
    
    #-----< SystemInformationDeliveryCommandIEs >-----#
    SystemInformationDeliveryCommandIEs = CLASS(name=u'SystemInformationDeliveryCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SystemInformationDeliveryCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _SystemInformationDeliveryCommandIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SystemInformationDeliveryCommandIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-List')))
    _SystemInformationDeliveryCommandIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    SystemInformationDeliveryCommandIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _SystemInformationDeliveryCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SystemInformationDeliveryCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'reject'), (u'Value', _SystemInformationDeliveryCommandIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _SystemInformationDeliveryCommandIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name=u'Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingIdentity')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PagingCell-list')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingOrigin')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'reject'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 114), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = u'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__value._const_tab_id = u'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Paging_protocolIEs__item__id),
        (u'criticality', ___Paging_protocolIEs__item__criticality),
        (u'value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        (u'protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name=u'PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentityIndexValue')))
    _PagingIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingIdentity')))
    _PagingIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PagingCell-list')))
    _PagingIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingOrigin')))
    PagingIEs._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'reject'), (u'Value', _PagingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _PagingIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 114), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingCell-list >-----#
    PagingCell_list = SEQ_OF(name=u'PagingCell-list', mode=MODE_TYPE)
    _PagingCell_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PagingCell_list__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PagingCell_list__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____PagingCell_list__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCell-Item')))
    ___PagingCell_list__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', ____PagingCell_list__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __PagingCell_list__item__id._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__id._const_tab_at = None
    __PagingCell_list__item__id._const_tab_id = u'id'
    __PagingCell_list__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __PagingCell_list__item__criticality._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__criticality._const_tab_at = ('..', u'id')
    __PagingCell_list__item__criticality._const_tab_id = u'criticality'
    __PagingCell_list__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __PagingCell_list__item__value._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__value._const_tab_at = ('..', u'id')
    __PagingCell_list__item__value._const_tab_id = u'Value'
    _PagingCell_list__item_._cont = ASN1Dict([
        (u'id', __PagingCell_list__item__id),
        (u'criticality', __PagingCell_list__item__criticality),
        (u'value', __PagingCell_list__item__value),
        ])
    _PagingCell_list__item_._ext = None
    PagingCell_list._cont = _PagingCell_list__item_
    PagingCell_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PagingCell-ItemIEs >-----#
    PagingCell_ItemIEs = CLASS(name=u'PagingCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PagingCell_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCell-Item')))
    PagingCell_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _PagingCell_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Notify >-----#
    Notify = SEQ(name=u'Notify', mode=MODE_TYPE)
    _Notify_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Notify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Notify_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____Notify_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Notify_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____Notify_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____Notify_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Notify-List')))
    ____Notify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____Notify_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____Notify_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _____Notify_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Notify_protocolIEs__item__id._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__id._const_tab_at = None
    ___Notify_protocolIEs__item__id._const_tab_id = u'id'
    ___Notify_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___Notify_protocolIEs__item__criticality._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Notify_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Notify_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___Notify_protocolIEs__item__value._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Notify_protocolIEs__item__value._const_tab_id = u'Value'
    __Notify_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Notify_protocolIEs__item__id),
        (u'criticality', ___Notify_protocolIEs__item__criticality),
        (u'value', ___Notify_protocolIEs__item__value),
        ])
    __Notify_protocolIEs__item_._ext = None
    _Notify_protocolIEs._cont = __Notify_protocolIEs__item_
    _Notify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Notify._cont = ASN1Dict([
        (u'protocolIEs', _Notify_protocolIEs),
        ])
    Notify._ext = []
    
    #-----< NotifyIEs >-----#
    NotifyIEs = CLASS(name=u'NotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NotifyIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _NotifyIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _NotifyIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Notify-List')))
    NotifyIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _NotifyIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _NotifyIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _NotifyIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Notify-List >-----#
    DRB_Notify_List = SEQ_OF(name=u'DRB-Notify-List', mode=MODE_TYPE)
    _DRB_Notify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRB_Notify_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DRB_Notify_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRB_Notify_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Notify-Item')))
    ___DRB_Notify_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', ____DRB_Notify_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DRB_Notify_List__item__id._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__id._const_tab_at = None
    __DRB_Notify_List__item__id._const_tab_id = u'id'
    __DRB_Notify_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DRB_Notify_List__item__criticality._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__criticality._const_tab_at = ('..', u'id')
    __DRB_Notify_List__item__criticality._const_tab_id = u'criticality'
    __DRB_Notify_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DRB_Notify_List__item__value._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__value._const_tab_at = ('..', u'id')
    __DRB_Notify_List__item__value._const_tab_id = u'Value'
    _DRB_Notify_List__item_._cont = ASN1Dict([
        (u'id', __DRB_Notify_List__item__id),
        (u'criticality', __DRB_Notify_List__item__criticality),
        (u'value', __DRB_Notify_List__item__value),
        ])
    _DRB_Notify_List__item_._ext = None
    DRB_Notify_List._cont = _DRB_Notify_List__item_
    DRB_Notify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRB-Notify-ItemIEs >-----#
    DRB_Notify_ItemIEs = CLASS(name=u'DRB-Notify-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRB_Notify_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Notify-Item')))
    DRB_Notify_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _DRB_Notify_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NetworkAccessRateReduction >-----#
    NetworkAccessRateReduction = SEQ(name=u'NetworkAccessRateReduction', mode=MODE_TYPE)
    _NetworkAccessRateReduction_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __NetworkAccessRateReduction_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___NetworkAccessRateReduction_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____NetworkAccessRateReduction_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UAC-Assistance-Info')))
    ____NetworkAccessRateReduction_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab_at = None
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab_id = u'id'
    ___NetworkAccessRateReduction_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NetworkAccessRateReduction_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab_id = u'Value'
    __NetworkAccessRateReduction_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NetworkAccessRateReduction_protocolIEs__item__id),
        (u'criticality', ___NetworkAccessRateReduction_protocolIEs__item__criticality),
        (u'value', ___NetworkAccessRateReduction_protocolIEs__item__value),
        ])
    __NetworkAccessRateReduction_protocolIEs__item_._ext = None
    _NetworkAccessRateReduction_protocolIEs._cont = __NetworkAccessRateReduction_protocolIEs__item_
    _NetworkAccessRateReduction_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NetworkAccessRateReduction._cont = ASN1Dict([
        (u'protocolIEs', _NetworkAccessRateReduction_protocolIEs),
        ])
    NetworkAccessRateReduction._ext = []
    
    #-----< NetworkAccessRateReductionIEs >-----#
    NetworkAccessRateReductionIEs = CLASS(name=u'NetworkAccessRateReductionIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NetworkAccessRateReductionIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _NetworkAccessRateReductionIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UAC-Assistance-Info')))
    NetworkAccessRateReductionIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _NetworkAccessRateReductionIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _NetworkAccessRateReductionIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name=u'PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NR-CGI-List-For-Restart-List')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSRestartIndication_protocolIEs__item__id),
        (u'criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        (u'value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name=u'PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSRestartIndicationIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NR-CGI-List-For-Restart-List')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NR-CGI-List-For-Restart-List >-----#
    NR_CGI_List_For_Restart_List = SEQ_OF(name=u'NR-CGI-List-For-Restart-List', mode=MODE_TYPE)
    _NR_CGI_List_For_Restart_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NR_CGI_List_For_Restart_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___NR_CGI_List_For_Restart_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-CGI-List-For-Restart-Item')))
    ___NR_CGI_List_For_Restart_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __NR_CGI_List_For_Restart_List__item__id._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__id._const_tab_at = None
    __NR_CGI_List_For_Restart_List__item__id._const_tab_id = u'id'
    __NR_CGI_List_For_Restart_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab_at = ('..', u'id')
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab_id = u'criticality'
    __NR_CGI_List_For_Restart_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __NR_CGI_List_For_Restart_List__item__value._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__value._const_tab_at = ('..', u'id')
    __NR_CGI_List_For_Restart_List__item__value._const_tab_id = u'Value'
    _NR_CGI_List_For_Restart_List__item_._cont = ASN1Dict([
        (u'id', __NR_CGI_List_For_Restart_List__item__id),
        (u'criticality', __NR_CGI_List_For_Restart_List__item__criticality),
        (u'value', __NR_CGI_List_For_Restart_List__item__value),
        ])
    _NR_CGI_List_For_Restart_List__item_._ext = None
    NR_CGI_List_For_Restart_List._cont = _NR_CGI_List_For_Restart_List__item_
    NR_CGI_List_For_Restart_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< NR-CGI-List-For-Restart-List-ItemIEs >-----#
    NR_CGI_List_For_Restart_List_ItemIEs = CLASS(name=u'NR-CGI-List-For-Restart-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-CGI-List-For-Restart-Item')))
    NR_CGI_List_For_Restart_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name=u'PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWS-Failed-NR-CGI-List')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSFailureIndication_protocolIEs__item__id),
        (u'criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        (u'value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name=u'PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSFailureIndicationIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWS-Failed-NR-CGI-List')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWS-Failed-NR-CGI-List >-----#
    PWS_Failed_NR_CGI_List = SEQ_OF(name=u'PWS-Failed-NR-CGI-List', mode=MODE_TYPE)
    _PWS_Failed_NR_CGI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PWS_Failed_NR_CGI_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___PWS_Failed_NR_CGI_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWS-Failed-NR-CGI-Item')))
    ___PWS_Failed_NR_CGI_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __PWS_Failed_NR_CGI_List__item__id._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__id._const_tab_at = None
    __PWS_Failed_NR_CGI_List__item__id._const_tab_id = u'id'
    __PWS_Failed_NR_CGI_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab_at = ('..', u'id')
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab_id = u'criticality'
    __PWS_Failed_NR_CGI_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __PWS_Failed_NR_CGI_List__item__value._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__value._const_tab_at = ('..', u'id')
    __PWS_Failed_NR_CGI_List__item__value._const_tab_id = u'Value'
    _PWS_Failed_NR_CGI_List__item_._cont = ASN1Dict([
        (u'id', __PWS_Failed_NR_CGI_List__item__id),
        (u'criticality', __PWS_Failed_NR_CGI_List__item__criticality),
        (u'value', __PWS_Failed_NR_CGI_List__item__value),
        ])
    _PWS_Failed_NR_CGI_List__item_._ext = None
    PWS_Failed_NR_CGI_List._cont = _PWS_Failed_NR_CGI_List__item_
    PWS_Failed_NR_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PWS-Failed-NR-CGI-List-ItemIEs >-----#
    PWS_Failed_NR_CGI_List_ItemIEs = CLASS(name=u'PWS-Failed-NR-CGI-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWS-Failed-NR-CGI-Item')))
    PWS_Failed_NR_CGI_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUStatusIndication >-----#
    GNBDUStatusIndication = SEQ(name=u'GNBDUStatusIndication', mode=MODE_TYPE)
    _GNBDUStatusIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUStatusIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUOverloadInformation')))
    ____GNBDUStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Value', _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUStatusIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUStatusIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUStatusIndication_protocolIEs__item__id),
        (u'criticality', ___GNBDUStatusIndication_protocolIEs__item__criticality),
        (u'value', ___GNBDUStatusIndication_protocolIEs__item__value),
        ])
    __GNBDUStatusIndication_protocolIEs__item_._ext = None
    _GNBDUStatusIndication_protocolIEs._cont = __GNBDUStatusIndication_protocolIEs__item_
    _GNBDUStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUStatusIndication._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUStatusIndication_protocolIEs),
        ])
    GNBDUStatusIndication._ext = []
    
    #-----< GNBDUStatusIndicationIEs >-----#
    GNBDUStatusIndicationIEs = CLASS(name=u'GNBDUStatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUStatusIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUStatusIndicationIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUOverloadInformation')))
    GNBDUStatusIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUStatusIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Value', _GNBDUStatusIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RRCDeliveryReport >-----#
    RRCDeliveryReport = SEQ(name=u'RRCDeliveryReport', mode=MODE_TYPE)
    _RRCDeliveryReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __RRCDeliveryReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___RRCDeliveryReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____RRCDeliveryReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatus')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    ____RRCDeliveryReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab_at = None
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab_id = u'id'
    ___RRCDeliveryReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RRCDeliveryReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab_id = u'Value'
    __RRCDeliveryReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RRCDeliveryReport_protocolIEs__item__id),
        (u'criticality', ___RRCDeliveryReport_protocolIEs__item__criticality),
        (u'value', ___RRCDeliveryReport_protocolIEs__item__value),
        ])
    __RRCDeliveryReport_protocolIEs__item_._ext = None
    _RRCDeliveryReport_protocolIEs._cont = __RRCDeliveryReport_protocolIEs__item_
    _RRCDeliveryReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RRCDeliveryReport._cont = ASN1Dict([
        (u'protocolIEs', _RRCDeliveryReport_protocolIEs),
        ])
    RRCDeliveryReport._ext = []
    
    #-----< RRCDeliveryReportIEs >-----#
    RRCDeliveryReportIEs = CLASS(name=u'RRCDeliveryReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _RRCDeliveryReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _RRCDeliveryReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _RRCDeliveryReportIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatus')))
    _RRCDeliveryReportIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    RRCDeliveryReportIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _RRCDeliveryReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _RRCDeliveryReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _RRCDeliveryReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _RRCDeliveryReportIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalRequest >-----#
    F1RemovalRequest = SEQ(name=u'F1RemovalRequest', mode=MODE_TYPE)
    _F1RemovalRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    ____F1RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___F1RemovalRequest_protocolIEs__item__id._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___F1RemovalRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1RemovalRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1RemovalRequest_protocolIEs__item__value._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1RemovalRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __F1RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1RemovalRequest_protocolIEs__item__id),
        (u'criticality', ___F1RemovalRequest_protocolIEs__item__criticality),
        (u'value', ___F1RemovalRequest_protocolIEs__item__value),
        ])
    __F1RemovalRequest_protocolIEs__item_._ext = None
    _F1RemovalRequest_protocolIEs._cont = __F1RemovalRequest_protocolIEs__item_
    _F1RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalRequest._cont = ASN1Dict([
        (u'protocolIEs', _F1RemovalRequest_protocolIEs),
        ])
    F1RemovalRequest._ext = []
    
    #-----< F1RemovalRequestIEs >-----#
    F1RemovalRequestIEs = CLASS(name=u'F1RemovalRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    F1RemovalRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1RemovalRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalResponse >-----#
    F1RemovalResponse = SEQ(name=u'F1RemovalResponse', mode=MODE_TYPE)
    _F1RemovalResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F1RemovalResponse_protocolIEs__item__id._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___F1RemovalResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1RemovalResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1RemovalResponse_protocolIEs__item__value._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1RemovalResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __F1RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1RemovalResponse_protocolIEs__item__id),
        (u'criticality', ___F1RemovalResponse_protocolIEs__item__criticality),
        (u'value', ___F1RemovalResponse_protocolIEs__item__value),
        ])
    __F1RemovalResponse_protocolIEs__item_._ext = None
    _F1RemovalResponse_protocolIEs._cont = __F1RemovalResponse_protocolIEs__item_
    _F1RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalResponse._cont = ASN1Dict([
        (u'protocolIEs', _F1RemovalResponse_protocolIEs),
        ])
    F1RemovalResponse._ext = []
    
    #-----< F1RemovalResponseIEs >-----#
    F1RemovalResponseIEs = CLASS(name=u'F1RemovalResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1RemovalResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1RemovalResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1RemovalResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _F1RemovalResponseIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalFailure >-----#
    F1RemovalFailure = SEQ(name=u'F1RemovalFailure', mode=MODE_TYPE)
    _F1RemovalFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____F1RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F1RemovalFailure_protocolIEs__item__id._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___F1RemovalFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___F1RemovalFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1RemovalFailure_protocolIEs__item__value._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___F1RemovalFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __F1RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___F1RemovalFailure_protocolIEs__item__id),
        (u'criticality', ___F1RemovalFailure_protocolIEs__item__criticality),
        (u'value', ___F1RemovalFailure_protocolIEs__item__value),
        ])
    __F1RemovalFailure_protocolIEs__item_._ext = None
    _F1RemovalFailure_protocolIEs._cont = __F1RemovalFailure_protocolIEs__item_
    _F1RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalFailure._cont = ASN1Dict([
        (u'protocolIEs', _F1RemovalFailure_protocolIEs),
        ])
    F1RemovalFailure._ext = []
    
    #-----< F1RemovalFailureIEs >-----#
    F1RemovalFailureIEs = CLASS(name=u'F1RemovalFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1RemovalFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _F1RemovalFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1RemovalFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _F1RemovalFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _F1RemovalFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _F1RemovalFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name=u'TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = u'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = u'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TraceStart_protocolIEs__item__id),
        (u'criticality', ___TraceStart_protocolIEs__item__criticality),
        (u'value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        (u'protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name=u'TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _TraceStartIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name=u'DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DeactivateTrace_protocolIEs__item__id),
        (u'criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        (u'value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        (u'protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name=u'DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _DeactivateTraceIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name=u'CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = STR_VIS(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 378), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 379), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 380), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellTrafficTrace_protocolIEs__item__id),
        (u'criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        (u'value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        (u'protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name=u'CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _CellTrafficTraceIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_5 = STR_VIS(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 378), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 379), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 380), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DUCURadioInformationTransfer >-----#
    DUCURadioInformationTransfer = SEQ(name=u'DUCURadioInformationTransfer', mode=MODE_TYPE)
    _DUCURadioInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DUCURadioInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DUCURadioInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____DUCURadioInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUCURadioInformationType')))
    ____DUCURadioInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Value', _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DUCURadioInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DUCURadioInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DUCURadioInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___DUCURadioInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___DUCURadioInformationTransfer_protocolIEs__item__value),
        ])
    __DUCURadioInformationTransfer_protocolIEs__item_._ext = None
    _DUCURadioInformationTransfer_protocolIEs._cont = __DUCURadioInformationTransfer_protocolIEs__item_
    _DUCURadioInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DUCURadioInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DUCURadioInformationTransfer_protocolIEs),
        ])
    DUCURadioInformationTransfer._ext = []
    
    #-----< DUCURadioInformationTransferIEs >-----#
    DUCURadioInformationTransferIEs = CLASS(name=u'DUCURadioInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DUCURadioInformationTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _DUCURadioInformationTransferIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUCURadioInformationType')))
    DUCURadioInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _DUCURadioInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Value', _DUCURadioInformationTransferIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CUDURadioInformationTransfer >-----#
    CUDURadioInformationTransfer = SEQ(name=u'CUDURadioInformationTransfer', mode=MODE_TYPE)
    _CUDURadioInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __CUDURadioInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___CUDURadioInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____CUDURadioInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUDURadioInformationType')))
    ____CUDURadioInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CUDURadioInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __CUDURadioInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CUDURadioInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___CUDURadioInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___CUDURadioInformationTransfer_protocolIEs__item__value),
        ])
    __CUDURadioInformationTransfer_protocolIEs__item_._ext = None
    _CUDURadioInformationTransfer_protocolIEs._cont = __CUDURadioInformationTransfer_protocolIEs__item_
    _CUDURadioInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CUDURadioInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _CUDURadioInformationTransfer_protocolIEs),
        ])
    CUDURadioInformationTransfer._ext = []
    
    #-----< CUDURadioInformationTransferIEs >-----#
    CUDURadioInformationTransferIEs = CLASS(name=u'CUDURadioInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _CUDURadioInformationTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _CUDURadioInformationTransferIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUDURadioInformationType')))
    CUDURadioInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _CUDURadioInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _CUDURadioInformationTransferIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfiguration >-----#
    BAPMappingConfiguration = SEQ(name=u'BAPMappingConfiguration', mode=MODE_TYPE)
    _BAPMappingConfiguration_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfiguration_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfiguration_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____BAPMappingConfiguration_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Added-List')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Removed-List')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')))
    ____BAPMappingConfiguration_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab_id = u'id'
    ___BAPMappingConfiguration_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___BAPMappingConfiguration_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab_id = u'Value'
    __BAPMappingConfiguration_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___BAPMappingConfiguration_protocolIEs__item__id),
        (u'criticality', ___BAPMappingConfiguration_protocolIEs__item__criticality),
        (u'value', ___BAPMappingConfiguration_protocolIEs__item__value),
        ])
    __BAPMappingConfiguration_protocolIEs__item_._ext = None
    _BAPMappingConfiguration_protocolIEs._cont = __BAPMappingConfiguration_protocolIEs__item_
    _BAPMappingConfiguration_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfiguration._cont = ASN1Dict([
        (u'protocolIEs', _BAPMappingConfiguration_protocolIEs),
        ])
    BAPMappingConfiguration._ext = []
    
    #-----< BAPMappingConfiguration-IEs >-----#
    BAPMappingConfiguration_IEs = CLASS(name=u'BAPMappingConfiguration-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfiguration_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfiguration_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Added-List')))
    _BAPMappingConfiguration_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Removed-List')))
    _BAPMappingConfiguration_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')))
    BAPMappingConfiguration_IEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _BAPMappingConfiguration_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfiguration_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfiguration_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfiguration_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Added-List >-----#
    BH_Routing_Information_Added_List = SEQ_OF(name=u'BH-Routing-Information-Added-List', mode=MODE_TYPE)
    _BH_Routing_Information_Added_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BH_Routing_Information_Added_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BH_Routing_Information_Added_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Added-List-Item')))
    ___BH_Routing_Information_Added_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Value', ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __BH_Routing_Information_Added_List__item__id._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__id._const_tab_at = None
    __BH_Routing_Information_Added_List__item__id._const_tab_id = u'id'
    __BH_Routing_Information_Added_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BH_Routing_Information_Added_List__item__criticality._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__criticality._const_tab_at = ('..', u'id')
    __BH_Routing_Information_Added_List__item__criticality._const_tab_id = u'criticality'
    __BH_Routing_Information_Added_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BH_Routing_Information_Added_List__item__value._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__value._const_tab_at = ('..', u'id')
    __BH_Routing_Information_Added_List__item__value._const_tab_id = u'Value'
    _BH_Routing_Information_Added_List__item_._cont = ASN1Dict([
        (u'id', __BH_Routing_Information_Added_List__item__id),
        (u'criticality', __BH_Routing_Information_Added_List__item__criticality),
        (u'value', __BH_Routing_Information_Added_List__item__value),
        ])
    _BH_Routing_Information_Added_List__item_._ext = None
    BH_Routing_Information_Added_List._cont = _BH_Routing_Information_Added_List__item_
    BH_Routing_Information_Added_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BH-Routing-Information-Removed-List >-----#
    BH_Routing_Information_Removed_List = SEQ_OF(name=u'BH-Routing-Information-Removed-List', mode=MODE_TYPE)
    _BH_Routing_Information_Removed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BH_Routing_Information_Removed_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___BH_Routing_Information_Removed_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Removed-List-Item')))
    ___BH_Routing_Information_Removed_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __BH_Routing_Information_Removed_List__item__id._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__id._const_tab_at = None
    __BH_Routing_Information_Removed_List__item__id._const_tab_id = u'id'
    __BH_Routing_Information_Removed_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __BH_Routing_Information_Removed_List__item__criticality._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__criticality._const_tab_at = ('..', u'id')
    __BH_Routing_Information_Removed_List__item__criticality._const_tab_id = u'criticality'
    __BH_Routing_Information_Removed_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __BH_Routing_Information_Removed_List__item__value._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__value._const_tab_at = ('..', u'id')
    __BH_Routing_Information_Removed_List__item__value._const_tab_id = u'Value'
    _BH_Routing_Information_Removed_List__item_._cont = ASN1Dict([
        (u'id', __BH_Routing_Information_Removed_List__item__id),
        (u'criticality', __BH_Routing_Information_Removed_List__item__criticality),
        (u'value', __BH_Routing_Information_Removed_List__item__value),
        ])
    _BH_Routing_Information_Removed_List__item_._ext = None
    BH_Routing_Information_Removed_List._cont = _BH_Routing_Information_Removed_List__item_
    BH_Routing_Information_Removed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BH-Routing-Information-Added-List-ItemIEs >-----#
    BH_Routing_Information_Added_List_ItemIEs = CLASS(name=u'BH-Routing-Information-Added-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BH_Routing_Information_Added_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Added-List-Item')))
    BH_Routing_Information_Added_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Value', _BH_Routing_Information_Added_List_ItemIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Removed-List-ItemIEs >-----#
    BH_Routing_Information_Removed_List_ItemIEs = CLASS(name=u'BH-Routing-Information-Removed-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Removed-List-Item')))
    BH_Routing_Information_Removed_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfigurationAcknowledge >-----#
    BAPMappingConfigurationAcknowledge = SEQ(name=u'BAPMappingConfigurationAcknowledge', mode=MODE_TYPE)
    _BAPMappingConfigurationAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id),
        (u'criticality', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality),
        (u'value', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value),
        ])
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_._ext = None
    _BAPMappingConfigurationAcknowledge_protocolIEs._cont = __BAPMappingConfigurationAcknowledge_protocolIEs__item_
    _BAPMappingConfigurationAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfigurationAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _BAPMappingConfigurationAcknowledge_protocolIEs),
        ])
    BAPMappingConfigurationAcknowledge._ext = []
    
    #-----< BAPMappingConfigurationAcknowledge-IEs >-----#
    BAPMappingConfigurationAcknowledge_IEs = CLASS(name=u'BAPMappingConfigurationAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfigurationAcknowledge_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfigurationAcknowledge_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BAPMappingConfigurationAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _BAPMappingConfigurationAcknowledge_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfigurationAcknowledge_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfigurationFailure >-----#
    BAPMappingConfigurationFailure = SEQ(name=u'BAPMappingConfigurationFailure', mode=MODE_TYPE)
    _BAPMappingConfigurationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfigurationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___BAPMappingConfigurationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __BAPMappingConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___BAPMappingConfigurationFailure_protocolIEs__item__id),
        (u'criticality', ___BAPMappingConfigurationFailure_protocolIEs__item__criticality),
        (u'value', ___BAPMappingConfigurationFailure_protocolIEs__item__value),
        ])
    __BAPMappingConfigurationFailure_protocolIEs__item_._ext = None
    _BAPMappingConfigurationFailure_protocolIEs._cont = __BAPMappingConfigurationFailure_protocolIEs__item_
    _BAPMappingConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfigurationFailure._cont = ASN1Dict([
        (u'protocolIEs', _BAPMappingConfigurationFailure_protocolIEs),
        ])
    BAPMappingConfigurationFailure._ext = []
    
    #-----< BAPMappingConfigurationFailureIEs >-----#
    BAPMappingConfigurationFailureIEs = CLASS(name=u'BAPMappingConfigurationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfigurationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfigurationFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _BAPMappingConfigurationFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _BAPMappingConfigurationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BAPMappingConfigurationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _BAPMappingConfigurationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfigurationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfigurationFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _BAPMappingConfigurationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfiguration >-----#
    GNBDUResourceConfiguration = SEQ(name=u'GNBDUResourceConfiguration', mode=MODE_TYPE)
    _GNBDUResourceConfiguration_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfiguration_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfiguration_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUResourceConfiguration_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List')))
    ____GNBDUResourceConfiguration_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUResourceConfiguration_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUResourceConfiguration_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUResourceConfiguration_protocolIEs__item__id),
        (u'criticality', ___GNBDUResourceConfiguration_protocolIEs__item__criticality),
        (u'value', ___GNBDUResourceConfiguration_protocolIEs__item__value),
        ])
    __GNBDUResourceConfiguration_protocolIEs__item_._ext = None
    _GNBDUResourceConfiguration_protocolIEs._cont = __GNBDUResourceConfiguration_protocolIEs__item_
    _GNBDUResourceConfiguration_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfiguration._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUResourceConfiguration_protocolIEs),
        ])
    GNBDUResourceConfiguration._ext = []
    
    #-----< GNBDUResourceConfigurationIEs >-----#
    GNBDUResourceConfigurationIEs = CLASS(name=u'GNBDUResourceConfigurationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List')))
    _GNBDUResourceConfigurationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List')))
    GNBDUResourceConfigurationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUResourceConfigurationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'reject'), (u'Value', _GNBDUResourceConfigurationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'reject'), (u'Value', _GNBDUResourceConfigurationIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfigurationAcknowledge >-----#
    GNBDUResourceConfigurationAcknowledge = SEQ(name=u'GNBDUResourceConfigurationAcknowledge', mode=MODE_TYPE)
    _GNBDUResourceConfigurationAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id),
        (u'criticality', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality),
        (u'value', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value),
        ])
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_._ext = None
    _GNBDUResourceConfigurationAcknowledge_protocolIEs._cont = __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_
    _GNBDUResourceConfigurationAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfigurationAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUResourceConfigurationAcknowledge_protocolIEs),
        ])
    GNBDUResourceConfigurationAcknowledge._ext = []
    
    #-----< GNBDUResourceConfigurationAcknowledgeIEs >-----#
    GNBDUResourceConfigurationAcknowledgeIEs = CLASS(name=u'GNBDUResourceConfigurationAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUResourceConfigurationAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfigurationFailure >-----#
    GNBDUResourceConfigurationFailure = SEQ(name=u'GNBDUResourceConfigurationFailure', mode=MODE_TYPE)
    _GNBDUResourceConfigurationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __GNBDUResourceConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GNBDUResourceConfigurationFailure_protocolIEs__item__id),
        (u'criticality', ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality),
        (u'value', ___GNBDUResourceConfigurationFailure_protocolIEs__item__value),
        ])
    __GNBDUResourceConfigurationFailure_protocolIEs__item_._ext = None
    _GNBDUResourceConfigurationFailure_protocolIEs._cont = __GNBDUResourceConfigurationFailure_protocolIEs__item_
    _GNBDUResourceConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfigurationFailure._cont = ASN1Dict([
        (u'protocolIEs', _GNBDUResourceConfigurationFailure_protocolIEs),
        ])
    GNBDUResourceConfigurationFailure._ext = []
    
    #-----< GNBDUResourceConfigurationFailureIEs >-----#
    GNBDUResourceConfigurationFailureIEs = CLASS(name=u'GNBDUResourceConfigurationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUResourceConfigurationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _GNBDUResourceConfigurationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _GNBDUResourceConfigurationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _GNBDUResourceConfigurationFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _GNBDUResourceConfigurationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressRequest >-----#
    IABTNLAddressRequest = SEQ(name=u'IABTNLAddressRequest', mode=MODE_TYPE)
    _IABTNLAddressRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABTNLAddressRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABv4AddressesRequested')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABIPv6RequestType')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-TNL-Addresses-To-Remove-List')))
    ____IABTNLAddressRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 297), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___IABTNLAddressRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABTNLAddressRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __IABTNLAddressRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABTNLAddressRequest_protocolIEs__item__id),
        (u'criticality', ___IABTNLAddressRequest_protocolIEs__item__criticality),
        (u'value', ___IABTNLAddressRequest_protocolIEs__item__value),
        ])
    __IABTNLAddressRequest_protocolIEs__item_._ext = None
    _IABTNLAddressRequest_protocolIEs._cont = __IABTNLAddressRequest_protocolIEs__item_
    _IABTNLAddressRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressRequest._cont = ASN1Dict([
        (u'protocolIEs', _IABTNLAddressRequest_protocolIEs),
        ])
    IABTNLAddressRequest._ext = []
    
    #-----< IABTNLAddressRequestIEs >-----#
    IABTNLAddressRequestIEs = CLASS(name=u'IABTNLAddressRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressRequestIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABv4AddressesRequested')))
    _IABTNLAddressRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABIPv6RequestType')))
    _IABTNLAddressRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-TNL-Addresses-To-Remove-List')))
    IABTNLAddressRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABTNLAddressRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 297), (u'criticality', u'reject'), (u'Value', _IABTNLAddressRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'reject'), (u'Value', _IABTNLAddressRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'reject'), (u'Value', _IABTNLAddressRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-List >-----#
    IAB_TNL_Addresses_To_Remove_List = SEQ_OF(name=u'IAB-TNL-Addresses-To-Remove-List', mode=MODE_TYPE)
    _IAB_TNL_Addresses_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_TNL_Addresses_To_Remove_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___IAB_TNL_Addresses_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-To-Remove-Item')))
    ___IAB_TNL_Addresses_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab_at = None
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab_id = u'id'
    __IAB_TNL_Addresses_To_Remove_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab_at = ('..', u'id')
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab_id = u'criticality'
    __IAB_TNL_Addresses_To_Remove_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab_at = ('..', u'id')
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab_id = u'Value'
    _IAB_TNL_Addresses_To_Remove_List__item_._cont = ASN1Dict([
        (u'id', __IAB_TNL_Addresses_To_Remove_List__item__id),
        (u'criticality', __IAB_TNL_Addresses_To_Remove_List__item__criticality),
        (u'value', __IAB_TNL_Addresses_To_Remove_List__item__value),
        ])
    _IAB_TNL_Addresses_To_Remove_List__item_._ext = None
    IAB_TNL_Addresses_To_Remove_List._cont = _IAB_TNL_Addresses_To_Remove_List__item_
    IAB_TNL_Addresses_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-ItemIEs >-----#
    IAB_TNL_Addresses_To_Remove_ItemIEs = CLASS(name=u'IAB-TNL-Addresses-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-To-Remove-Item')))
    IAB_TNL_Addresses_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressResponse >-----#
    IABTNLAddressResponse = SEQ(name=u'IABTNLAddressResponse', mode=MODE_TYPE)
    _IABTNLAddressResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABTNLAddressResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-Allocated-TNL-Address-List')))
    ____IABTNLAddressResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 294), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___IABTNLAddressResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABTNLAddressResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __IABTNLAddressResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABTNLAddressResponse_protocolIEs__item__id),
        (u'criticality', ___IABTNLAddressResponse_protocolIEs__item__criticality),
        (u'value', ___IABTNLAddressResponse_protocolIEs__item__value),
        ])
    __IABTNLAddressResponse_protocolIEs__item_._ext = None
    _IABTNLAddressResponse_protocolIEs._cont = __IABTNLAddressResponse_protocolIEs__item_
    _IABTNLAddressResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressResponse._cont = ASN1Dict([
        (u'protocolIEs', _IABTNLAddressResponse_protocolIEs),
        ])
    IABTNLAddressResponse._ext = []
    
    #-----< IABTNLAddressResponseIEs >-----#
    IABTNLAddressResponseIEs = CLASS(name=u'IABTNLAddressResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-Allocated-TNL-Address-List')))
    IABTNLAddressResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABTNLAddressResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 294), (u'criticality', u'reject'), (u'Value', _IABTNLAddressResponseIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IAB-Allocated-TNL-Address-List >-----#
    IAB_Allocated_TNL_Address_List = SEQ_OF(name=u'IAB-Allocated-TNL-Address-List', mode=MODE_TYPE)
    _IAB_Allocated_TNL_Address_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_Allocated_TNL_Address_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___IAB_Allocated_TNL_Address_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Allocated-TNL-Address-Item')))
    ___IAB_Allocated_TNL_Address_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 295), (u'criticality', u'reject'), (u'Value', ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __IAB_Allocated_TNL_Address_List__item__id._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__id._const_tab_at = None
    __IAB_Allocated_TNL_Address_List__item__id._const_tab_id = u'id'
    __IAB_Allocated_TNL_Address_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab_at = ('..', u'id')
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab_id = u'criticality'
    __IAB_Allocated_TNL_Address_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __IAB_Allocated_TNL_Address_List__item__value._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__value._const_tab_at = ('..', u'id')
    __IAB_Allocated_TNL_Address_List__item__value._const_tab_id = u'Value'
    _IAB_Allocated_TNL_Address_List__item_._cont = ASN1Dict([
        (u'id', __IAB_Allocated_TNL_Address_List__item__id),
        (u'criticality', __IAB_Allocated_TNL_Address_List__item__criticality),
        (u'value', __IAB_Allocated_TNL_Address_List__item__value),
        ])
    _IAB_Allocated_TNL_Address_List__item_._ext = None
    IAB_Allocated_TNL_Address_List._cont = _IAB_Allocated_TNL_Address_List__item_
    IAB_Allocated_TNL_Address_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IAB-Allocated-TNL-Address-List-ItemIEs >-----#
    IAB_Allocated_TNL_Address_List_ItemIEs = CLASS(name=u'IAB-Allocated-TNL-Address-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Allocated-TNL-Address-Item')))
    IAB_Allocated_TNL_Address_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 295), (u'criticality', u'reject'), (u'Value', _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressFailure >-----#
    IABTNLAddressFailure = SEQ(name=u'IABTNLAddressFailure', mode=MODE_TYPE)
    _IABTNLAddressFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABTNLAddressFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____IABTNLAddressFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___IABTNLAddressFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABTNLAddressFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __IABTNLAddressFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABTNLAddressFailure_protocolIEs__item__id),
        (u'criticality', ___IABTNLAddressFailure_protocolIEs__item__criticality),
        (u'value', ___IABTNLAddressFailure_protocolIEs__item__value),
        ])
    __IABTNLAddressFailure_protocolIEs__item_._ext = None
    _IABTNLAddressFailure_protocolIEs._cont = __IABTNLAddressFailure_protocolIEs__item_
    _IABTNLAddressFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressFailure._cont = ASN1Dict([
        (u'protocolIEs', _IABTNLAddressFailure_protocolIEs),
        ])
    IABTNLAddressFailure._ext = []
    
    #-----< IABTNLAddressFailureIEs >-----#
    IABTNLAddressFailureIEs = CLASS(name=u'IABTNLAddressFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _IABTNLAddressFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _IABTNLAddressFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    IABTNLAddressFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABTNLAddressFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _IABTNLAddressFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _IABTNLAddressFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _IABTNLAddressFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateRequest >-----#
    IABUPConfigurationUpdateRequest = SEQ(name=u'IABUPConfigurationUpdateRequest', mode=MODE_TYPE)
    _IABUPConfigurationUpdateRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Information-to-Update-List')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Address-to-Update-List')))
    ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __IABUPConfigurationUpdateRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABUPConfigurationUpdateRequest_protocolIEs__item__id),
        (u'criticality', ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality),
        (u'value', ___IABUPConfigurationUpdateRequest_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateRequest_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateRequest_protocolIEs._cont = __IABUPConfigurationUpdateRequest_protocolIEs__item_
    _IABUPConfigurationUpdateRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateRequest._cont = ASN1Dict([
        (u'protocolIEs', _IABUPConfigurationUpdateRequest_protocolIEs),
        ])
    IABUPConfigurationUpdateRequest._ext = []
    
    #-----< IABUPConfigurationUpdateRequestIEs >-----#
    IABUPConfigurationUpdateRequestIEs = CLASS(name=u'IABUPConfigurationUpdateRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Information-to-Update-List')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Address-to-Update-List')))
    IABUPConfigurationUpdateRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABUPConfigurationUpdateRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateRequestIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Information-to-Update-List >-----#
    UL_UP_TNL_Information_to_Update_List = SEQ_OF(name=u'UL-UP-TNL-Information-to-Update-List', mode=MODE_TYPE)
    _UL_UP_TNL_Information_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_UP_TNL_Information_to_Update_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UL_UP_TNL_Information_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Information-to-Update-List-Item')))
    ___UL_UP_TNL_Information_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab_at = None
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab_id = u'id'
    __UL_UP_TNL_Information_to_Update_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab_at = ('..', u'id')
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab_id = u'criticality'
    __UL_UP_TNL_Information_to_Update_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab_at = ('..', u'id')
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab_id = u'Value'
    _UL_UP_TNL_Information_to_Update_List__item_._cont = ASN1Dict([
        (u'id', __UL_UP_TNL_Information_to_Update_List__item__id),
        (u'criticality', __UL_UP_TNL_Information_to_Update_List__item__criticality),
        (u'value', __UL_UP_TNL_Information_to_Update_List__item__value),
        ])
    _UL_UP_TNL_Information_to_Update_List__item_._ext = None
    UL_UP_TNL_Information_to_Update_List._cont = _UL_UP_TNL_Information_to_Update_List__item_
    UL_UP_TNL_Information_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32678)], ev=None, er=[])
    
    #-----< UL-UP-TNL-Information-to-Update-List-ItemIEs >-----#
    UL_UP_TNL_Information_to_Update_List_ItemIEs = CLASS(name=u'UL-UP-TNL-Information-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Information-to-Update-List-Item')))
    UL_UP_TNL_Information_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List >-----#
    UL_UP_TNL_Address_to_Update_List = SEQ_OF(name=u'UL-UP-TNL-Address-to-Update-List', mode=MODE_TYPE)
    _UL_UP_TNL_Address_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_UP_TNL_Address_to_Update_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___UL_UP_TNL_Address_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Address-to-Update-List-Item')))
    ___UL_UP_TNL_Address_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab_at = None
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab_id = u'id'
    __UL_UP_TNL_Address_to_Update_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_at = ('..', u'id')
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_id = u'criticality'
    __UL_UP_TNL_Address_to_Update_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab_at = ('..', u'id')
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab_id = u'Value'
    _UL_UP_TNL_Address_to_Update_List__item_._cont = ASN1Dict([
        (u'id', __UL_UP_TNL_Address_to_Update_List__item__id),
        (u'criticality', __UL_UP_TNL_Address_to_Update_List__item__criticality),
        (u'value', __UL_UP_TNL_Address_to_Update_List__item__value),
        ])
    _UL_UP_TNL_Address_to_Update_List__item_._ext = None
    UL_UP_TNL_Address_to_Update_List._cont = _UL_UP_TNL_Address_to_Update_List__item_
    UL_UP_TNL_Address_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List-ItemIEs >-----#
    UL_UP_TNL_Address_to_Update_List_ItemIEs = CLASS(name=u'UL-UP-TNL-Address-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Address-to-Update-List-Item')))
    UL_UP_TNL_Address_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateResponse >-----#
    IABUPConfigurationUpdateResponse = SEQ(name=u'IABUPConfigurationUpdateResponse', mode=MODE_TYPE)
    _IABUPConfigurationUpdateResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DL-UP-TNL-Address-to-Update-List')))
    ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 304), (u'criticality', u'reject'), (u'Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __IABUPConfigurationUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABUPConfigurationUpdateResponse_protocolIEs__item__id),
        (u'criticality', ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality),
        (u'value', ___IABUPConfigurationUpdateResponse_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateResponse_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateResponse_protocolIEs._cont = __IABUPConfigurationUpdateResponse_protocolIEs__item_
    _IABUPConfigurationUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateResponse._cont = ASN1Dict([
        (u'protocolIEs', _IABUPConfigurationUpdateResponse_protocolIEs),
        ])
    IABUPConfigurationUpdateResponse._ext = []
    
    #-----< IABUPConfigurationUpdateResponseIEs >-----#
    IABUPConfigurationUpdateResponseIEs = CLASS(name=u'IABUPConfigurationUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DL-UP-TNL-Address-to-Update-List')))
    IABUPConfigurationUpdateResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABUPConfigurationUpdateResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 304), (u'criticality', u'reject'), (u'Value', _IABUPConfigurationUpdateResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List >-----#
    DL_UP_TNL_Address_to_Update_List = SEQ_OF(name=u'DL-UP-TNL-Address-to-Update-List', mode=MODE_TYPE)
    _DL_UP_TNL_Address_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_UP_TNL_Address_to_Update_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___DL_UP_TNL_Address_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DL-UP-TNL-Address-to-Update-List-Item')))
    ___DL_UP_TNL_Address_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 305), (u'criticality', u'ignore'), (u'Value', ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab_at = None
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab_id = u'id'
    __DL_UP_TNL_Address_to_Update_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_at = ('..', u'id')
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_id = u'criticality'
    __DL_UP_TNL_Address_to_Update_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab_at = ('..', u'id')
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab_id = u'Value'
    _DL_UP_TNL_Address_to_Update_List__item_._cont = ASN1Dict([
        (u'id', __DL_UP_TNL_Address_to_Update_List__item__id),
        (u'criticality', __DL_UP_TNL_Address_to_Update_List__item__criticality),
        (u'value', __DL_UP_TNL_Address_to_Update_List__item__value),
        ])
    _DL_UP_TNL_Address_to_Update_List__item_._ext = None
    DL_UP_TNL_Address_to_Update_List._cont = _DL_UP_TNL_Address_to_Update_List__item_
    DL_UP_TNL_Address_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List-ItemIEs >-----#
    DL_UP_TNL_Address_to_Update_List_ItemIEs = CLASS(name=u'DL-UP-TNL-Address-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DL-UP-TNL-Address-to-Update-List-Item')))
    DL_UP_TNL_Address_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 305), (u'criticality', u'ignore'), (u'Value', _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateFailure >-----#
    IABUPConfigurationUpdateFailure = SEQ(name=u'IABUPConfigurationUpdateFailure', mode=MODE_TYPE)
    _IABUPConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __IABUPConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IABUPConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___IABUPConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateFailure_protocolIEs._cont = __IABUPConfigurationUpdateFailure_protocolIEs__item_
    _IABUPConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _IABUPConfigurationUpdateFailure_protocolIEs),
        ])
    IABUPConfigurationUpdateFailure._ext = []
    
    #-----< IABUPConfigurationUpdateFailureIEs >-----#
    IABUPConfigurationUpdateFailureIEs = CLASS(name=u'IABUPConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    IABUPConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _IABUPConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _IABUPConfigurationUpdateFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusRequest >-----#
    ResourceStatusRequest = SEQ(name=u'ResourceStatusRequest', mode=MODE_TYPE)
    _ResourceStatusRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RegistrationRequest')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportCharacteristics')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportList')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicity')))
    ____ResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 347), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 348), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 349), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 352), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusRequest_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusRequest_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusRequest_protocolIEs__item__value),
        ])
    __ResourceStatusRequest_protocolIEs__item_._ext = None
    _ResourceStatusRequest_protocolIEs._cont = __ResourceStatusRequest_protocolIEs__item_
    _ResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusRequest._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusRequest_protocolIEs),
        ])
    ResourceStatusRequest._ext = []
    
    #-----< ResourceStatusRequestIEs >-----#
    ResourceStatusRequestIEs = CLASS(name=u'ResourceStatusRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RegistrationRequest')))
    _ResourceStatusRequestIEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportCharacteristics')))
    _ResourceStatusRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportList')))
    _ResourceStatusRequestIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicity')))
    ResourceStatusRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResourceStatusRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _ResourceStatusRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequestIEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 347), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 348), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequestIEs_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 349), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 352), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusResponse >-----#
    ResourceStatusResponse = SEQ(name=u'ResourceStatusResponse', mode=MODE_TYPE)
    _ResourceStatusResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusResponse_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusResponse_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusResponse_protocolIEs__item__value),
        ])
    __ResourceStatusResponse_protocolIEs__item_._ext = None
    _ResourceStatusResponse_protocolIEs._cont = __ResourceStatusResponse_protocolIEs__item_
    _ResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusResponse._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusResponse_protocolIEs),
        ])
    ResourceStatusResponse._ext = []
    
    #-----< ResourceStatusResponseIEs >-----#
    ResourceStatusResponseIEs = CLASS(name=u'ResourceStatusResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResourceStatusResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _ResourceStatusResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _ResourceStatusResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ResourceStatusResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusFailure >-----#
    ResourceStatusFailure = SEQ(name=u'ResourceStatusFailure', mode=MODE_TYPE)
    _ResourceStatusFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusFailure_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusFailure_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusFailure_protocolIEs__item__value),
        ])
    __ResourceStatusFailure_protocolIEs__item_._ext = None
    _ResourceStatusFailure_protocolIEs._cont = __ResourceStatusFailure_protocolIEs__item_
    _ResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusFailure._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusFailure_protocolIEs),
        ])
    ResourceStatusFailure._ext = []
    
    #-----< ResourceStatusFailureIEs >-----#
    ResourceStatusFailureIEs = CLASS(name=u'ResourceStatusFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusFailureIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusFailureIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ResourceStatusFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResourceStatusFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _ResourceStatusFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailureIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusUpdate >-----#
    ResourceStatusUpdate = SEQ(name=u'ResourceStatusUpdate', mode=MODE_TYPE)
    _ResourceStatusUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HardwareLoadIndicator')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TNLCapacityIndicator')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultList')))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 351), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 353), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 350), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusUpdate_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusUpdate_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ResourceStatusUpdate_protocolIEs__item_._ext = None
    _ResourceStatusUpdate_protocolIEs._cont = __ResourceStatusUpdate_protocolIEs__item_
    _ResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusUpdate._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusUpdate_protocolIEs),
        ])
    ResourceStatusUpdate._ext = []
    
    #-----< ResourceStatusUpdateIEs >-----#
    ResourceStatusUpdateIEs = CLASS(name=u'ResourceStatusUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusUpdateIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusUpdateIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusUpdateIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HardwareLoadIndicator')))
    _ResourceStatusUpdateIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TNLCapacityIndicator')))
    _ResourceStatusUpdateIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultList')))
    ResourceStatusUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResourceStatusUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 345), (u'criticality', u'reject'), (u'Value', _ResourceStatusUpdateIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 346), (u'criticality', u'ignore'), (u'Value', _ResourceStatusUpdateIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 351), (u'criticality', u'ignore'), (u'Value', _ResourceStatusUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 353), (u'criticality', u'ignore'), (u'Value', _ResourceStatusUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 350), (u'criticality', u'ignore'), (u'Value', _ResourceStatusUpdateIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AccessAndMobilityIndication >-----#
    AccessAndMobilityIndication = SEQ(name=u'AccessAndMobilityIndication', mode=MODE_TYPE)
    _AccessAndMobilityIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __AccessAndMobilityIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___AccessAndMobilityIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationList')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationList')))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 359), (u'criticality', u'ignore'), (u'Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 360), (u'criticality', u'ignore'), (u'Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_at = None
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___AccessAndMobilityIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AccessAndMobilityIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __AccessAndMobilityIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AccessAndMobilityIndication_protocolIEs__item__id),
        (u'criticality', ___AccessAndMobilityIndication_protocolIEs__item__criticality),
        (u'value', ___AccessAndMobilityIndication_protocolIEs__item__value),
        ])
    __AccessAndMobilityIndication_protocolIEs__item_._ext = None
    _AccessAndMobilityIndication_protocolIEs._cont = __AccessAndMobilityIndication_protocolIEs__item_
    _AccessAndMobilityIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AccessAndMobilityIndication._cont = ASN1Dict([
        (u'protocolIEs', _AccessAndMobilityIndication_protocolIEs),
        ])
    AccessAndMobilityIndication._ext = []
    
    #-----< AccessAndMobilityIndicationIEs >-----#
    AccessAndMobilityIndicationIEs = CLASS(name=u'AccessAndMobilityIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _AccessAndMobilityIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _AccessAndMobilityIndicationIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationList')))
    _AccessAndMobilityIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationList')))
    AccessAndMobilityIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _AccessAndMobilityIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 359), (u'criticality', u'ignore'), (u'Value', _AccessAndMobilityIndicationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 360), (u'criticality', u'ignore'), (u'Value', _AccessAndMobilityIndicationIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceTimeInformationReportingControl >-----#
    ReferenceTimeInformationReportingControl = SEQ(name=u'ReferenceTimeInformationReportingControl', mode=MODE_TYPE)
    _ReferenceTimeInformationReportingControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ReferenceTimeInformationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingRequestType')))
    ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 365), (u'criticality', u'reject'), (u'Value', _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab_id = u'id'
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab_id = u'Value'
    __ReferenceTimeInformationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ReferenceTimeInformationReportingControl_protocolIEs__item__id),
        (u'criticality', ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality),
        (u'value', ___ReferenceTimeInformationReportingControl_protocolIEs__item__value),
        ])
    __ReferenceTimeInformationReportingControl_protocolIEs__item_._ext = None
    _ReferenceTimeInformationReportingControl_protocolIEs._cont = __ReferenceTimeInformationReportingControl_protocolIEs__item_
    _ReferenceTimeInformationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ReferenceTimeInformationReportingControl._cont = ASN1Dict([
        (u'protocolIEs', _ReferenceTimeInformationReportingControl_protocolIEs),
        ])
    ReferenceTimeInformationReportingControl._ext = []
    
    #-----< ReferenceTimeInformationReportingControlIEs >-----#
    ReferenceTimeInformationReportingControlIEs = CLASS(name=u'ReferenceTimeInformationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ReferenceTimeInformationReportingControlIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ReferenceTimeInformationReportingControlIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingRequestType')))
    ReferenceTimeInformationReportingControlIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ReferenceTimeInformationReportingControlIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 365), (u'criticality', u'reject'), (u'Value', _ReferenceTimeInformationReportingControlIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceTimeInformationReport >-----#
    ReferenceTimeInformationReport = SEQ(name=u'ReferenceTimeInformationReport', mode=MODE_TYPE)
    _ReferenceTimeInformationReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ReferenceTimeInformationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ReferenceTimeInformationReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____ReferenceTimeInformationReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeReferenceInformation')))
    ____ReferenceTimeInformationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 366), (u'criticality', u'ignore'), (u'Value', _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab_at = None
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab_id = u'id'
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ReferenceTimeInformationReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab_id = u'Value'
    __ReferenceTimeInformationReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ReferenceTimeInformationReport_protocolIEs__item__id),
        (u'criticality', ___ReferenceTimeInformationReport_protocolIEs__item__criticality),
        (u'value', ___ReferenceTimeInformationReport_protocolIEs__item__value),
        ])
    __ReferenceTimeInformationReport_protocolIEs__item_._ext = None
    _ReferenceTimeInformationReport_protocolIEs._cont = __ReferenceTimeInformationReport_protocolIEs__item_
    _ReferenceTimeInformationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ReferenceTimeInformationReport._cont = ASN1Dict([
        (u'protocolIEs', _ReferenceTimeInformationReport_protocolIEs),
        ])
    ReferenceTimeInformationReport._ext = []
    
    #-----< ReferenceTimeInformationReportIEs >-----#
    ReferenceTimeInformationReportIEs = CLASS(name=u'ReferenceTimeInformationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ReferenceTimeInformationReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ReferenceTimeInformationReportIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeReferenceInformation')))
    ReferenceTimeInformationReportIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _ReferenceTimeInformationReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 366), (u'criticality', u'ignore'), (u'Value', _ReferenceTimeInformationReportIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< AccessSuccess >-----#
    AccessSuccess = SEQ(name=u'AccessSuccess', mode=MODE_TYPE)
    _AccessSuccess_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __AccessSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___AccessSuccess_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____AccessSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____AccessSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___AccessSuccess_protocolIEs__item__id._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__id._const_tab_at = None
    ___AccessSuccess_protocolIEs__item__id._const_tab_id = u'id'
    ___AccessSuccess_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___AccessSuccess_protocolIEs__item__criticality._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AccessSuccess_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AccessSuccess_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___AccessSuccess_protocolIEs__item__value._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AccessSuccess_protocolIEs__item__value._const_tab_id = u'Value'
    __AccessSuccess_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AccessSuccess_protocolIEs__item__id),
        (u'criticality', ___AccessSuccess_protocolIEs__item__criticality),
        (u'value', ___AccessSuccess_protocolIEs__item__value),
        ])
    __AccessSuccess_protocolIEs__item_._ext = None
    _AccessSuccess_protocolIEs._cont = __AccessSuccess_protocolIEs__item_
    _AccessSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AccessSuccess._cont = ASN1Dict([
        (u'protocolIEs', _AccessSuccess_protocolIEs),
        ])
    AccessSuccess._ext = []
    
    #-----< AccessSuccessIEs >-----#
    AccessSuccessIEs = CLASS(name=u'AccessSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _AccessSuccessIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _AccessSuccessIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _AccessSuccessIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    AccessSuccessIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _AccessSuccessIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _AccessSuccessIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _AccessSuccessIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningAssistanceInformationControl >-----#
    PositioningAssistanceInformationControl = SEQ(name=u'PositioningAssistanceInformationControl', mode=MODE_TYPE)
    _PositioningAssistanceInformationControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningAssistanceInformationControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningAssistanceInformationControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistance-Information')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosBroadcast')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 392), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 393), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 406), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 394), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab_at = None
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningAssistanceInformationControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningAssistanceInformationControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningAssistanceInformationControl_protocolIEs__item__id),
        (u'criticality', ___PositioningAssistanceInformationControl_protocolIEs__item__criticality),
        (u'value', ___PositioningAssistanceInformationControl_protocolIEs__item__value),
        ])
    __PositioningAssistanceInformationControl_protocolIEs__item_._ext = None
    _PositioningAssistanceInformationControl_protocolIEs._cont = __PositioningAssistanceInformationControl_protocolIEs__item_
    _PositioningAssistanceInformationControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningAssistanceInformationControl._cont = ASN1Dict([
        (u'protocolIEs', _PositioningAssistanceInformationControl_protocolIEs),
        ])
    PositioningAssistanceInformationControl._ext = []
    
    #-----< PositioningAssistanceInformationControlIEs >-----#
    PositioningAssistanceInformationControlIEs = CLASS(name=u'PositioningAssistanceInformationControlIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningAssistanceInformationControlIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningAssistanceInformationControlIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistance-Information')))
    _PositioningAssistanceInformationControlIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosBroadcast')))
    _PositioningAssistanceInformationControlIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _PositioningAssistanceInformationControlIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    PositioningAssistanceInformationControlIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationControlIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 392), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationControlIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 393), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationControlIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 406), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationControlIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 394), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationControlIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningAssistanceInformationFeedback >-----#
    PositioningAssistanceInformationFeedback = SEQ(name=u'PositioningAssistanceInformationFeedback', mode=MODE_TYPE)
    _PositioningAssistanceInformationFeedback_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningAssistanceInformationFeedback_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistanceInformationFailureList')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 395), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 406), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 394), (u'criticality', u'reject'), (u'Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab_at = None
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningAssistanceInformationFeedback_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningAssistanceInformationFeedback_protocolIEs__item__id),
        (u'criticality', ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality),
        (u'value', ___PositioningAssistanceInformationFeedback_protocolIEs__item__value),
        ])
    __PositioningAssistanceInformationFeedback_protocolIEs__item_._ext = None
    _PositioningAssistanceInformationFeedback_protocolIEs._cont = __PositioningAssistanceInformationFeedback_protocolIEs__item_
    _PositioningAssistanceInformationFeedback_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningAssistanceInformationFeedback._cont = ASN1Dict([
        (u'protocolIEs', _PositioningAssistanceInformationFeedback_protocolIEs),
        ])
    PositioningAssistanceInformationFeedback._ext = []
    
    #-----< PositioningAssistanceInformationFeedbackIEs >-----#
    PositioningAssistanceInformationFeedbackIEs = CLASS(name=u'PositioningAssistanceInformationFeedbackIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistanceInformationFailureList')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningAssistanceInformationFeedbackIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 395), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 406), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 394), (u'criticality', u'reject'), (u'Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementRequest >-----#
    PositioningMeasurementRequest = SEQ(name=u'PositioningMeasurementRequest', mode=MODE_TYPE)
    _PositioningMeasurementRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestList')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosReportCharacteristics')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfoRequest')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicityExtended')))
    ____PositioningMeasurementRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 422), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 408), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 409), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 396), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 423), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 420), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 421), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 438), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementRequest_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementRequest_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementRequest_protocolIEs__item__value),
        ])
    __PositioningMeasurementRequest_protocolIEs__item_._ext = None
    _PositioningMeasurementRequest_protocolIEs._cont = __PositioningMeasurementRequest_protocolIEs__item_
    _PositioningMeasurementRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementRequest._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementRequest_protocolIEs),
        ])
    PositioningMeasurementRequest._ext = []
    
    #-----< PositioningMeasurementRequestIEs >-----#
    PositioningMeasurementRequestIEs = CLASS(name=u'PositioningMeasurementRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestList')))
    _PositioningMeasurementRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosReportCharacteristics')))
    _PositioningMeasurementRequestIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _PositioningMeasurementRequestIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities')))
    _PositioningMeasurementRequestIEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _PositioningMeasurementRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningMeasurementRequestIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfoRequest')))
    _PositioningMeasurementRequestIEs_val_Value_10 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _PositioningMeasurementRequestIEs_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _PositioningMeasurementRequestIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicityExtended')))
    PositioningMeasurementRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 422), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 408), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 409), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 396), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 423), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 420), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 421), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 438), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementRequestIEs_val_Value_12), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementResponse >-----#
    PositioningMeasurementResponse = SEQ(name=u'PositioningMeasurementResponse', mode=MODE_TYPE)
    _PositioningMeasurementResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningMeasurementResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 397), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementResponse_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementResponse_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementResponse_protocolIEs__item__value),
        ])
    __PositioningMeasurementResponse_protocolIEs__item_._ext = None
    _PositioningMeasurementResponse_protocolIEs._cont = __PositioningMeasurementResponse_protocolIEs__item_
    _PositioningMeasurementResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementResponse._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementResponse_protocolIEs),
        ])
    PositioningMeasurementResponse._ext = []
    
    #-----< PositioningMeasurementResponseIEs >-----#
    PositioningMeasurementResponseIEs = CLASS(name=u'PositioningMeasurementResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    _PositioningMeasurementResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningMeasurementResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 397), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementFailure >-----#
    PositioningMeasurementFailure = SEQ(name=u'PositioningMeasurementFailure', mode=MODE_TYPE)
    _PositioningMeasurementFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningMeasurementFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementFailure_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementFailure_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementFailure_protocolIEs__item__value),
        ])
    __PositioningMeasurementFailure_protocolIEs__item_._ext = None
    _PositioningMeasurementFailure_protocolIEs._cont = __PositioningMeasurementFailure_protocolIEs__item_
    _PositioningMeasurementFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementFailure._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementFailure_protocolIEs),
        ])
    PositioningMeasurementFailure._ext = []
    
    #-----< PositioningMeasurementFailureIEs >-----#
    PositioningMeasurementFailureIEs = CLASS(name=u'PositioningMeasurementFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementFailureIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementFailureIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningMeasurementFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningMeasurementFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementFailureIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementReport >-----#
    PositioningMeasurementReport = SEQ(name=u'PositioningMeasurementReport', mode=MODE_TYPE)
    _PositioningMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    ____PositioningMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 397), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementReport_protocolIEs__item__value),
        ])
    __PositioningMeasurementReport_protocolIEs__item_._ext = None
    _PositioningMeasurementReport_protocolIEs._cont = __PositioningMeasurementReport_protocolIEs__item_
    _PositioningMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementReport_protocolIEs),
        ])
    PositioningMeasurementReport._ext = []
    
    #-----< PositioningMeasurementReportIEs >-----#
    PositioningMeasurementReportIEs = CLASS(name=u'PositioningMeasurementReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementReportIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementReportIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    PositioningMeasurementReportIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 397), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementReportIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementAbort >-----#
    PositioningMeasurementAbort = SEQ(name=u'PositioningMeasurementAbort', mode=MODE_TYPE)
    _PositioningMeasurementAbort_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementAbort_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementAbort_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementAbort_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    ____PositioningMeasurementAbort_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementAbort_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementAbort_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementAbort_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementAbort_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementAbort_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementAbort_protocolIEs__item__value),
        ])
    __PositioningMeasurementAbort_protocolIEs__item_._ext = None
    _PositioningMeasurementAbort_protocolIEs._cont = __PositioningMeasurementAbort_protocolIEs__item_
    _PositioningMeasurementAbort_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementAbort._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementAbort_protocolIEs),
        ])
    PositioningMeasurementAbort._ext = []
    
    #-----< PositioningMeasurementAbortIEs >-----#
    PositioningMeasurementAbortIEs = CLASS(name=u'PositioningMeasurementAbortIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementAbortIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementAbortIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementAbortIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    PositioningMeasurementAbortIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementAbortIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementAbortIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementAbortIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementFailureIndication >-----#
    PositioningMeasurementFailureIndication = SEQ(name=u'PositioningMeasurementFailureIndication', mode=MODE_TYPE)
    _PositioningMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __PositioningMeasurementFailureIndication_protocolIEs__item_._ext = None
    _PositioningMeasurementFailureIndication_protocolIEs._cont = __PositioningMeasurementFailureIndication_protocolIEs__item_
    _PositioningMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementFailureIndication_protocolIEs),
        ])
    PositioningMeasurementFailureIndication._ext = []
    
    #-----< PositioningMeasurementFailureIndicationIEs >-----#
    PositioningMeasurementFailureIndicationIEs = CLASS(name=u'PositioningMeasurementFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    PositioningMeasurementFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementFailureIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementFailureIndicationIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementUpdate >-----#
    PositioningMeasurementUpdate = SEQ(name=u'PositioningMeasurementUpdate', mode=MODE_TYPE)
    _PositioningMeasurementUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningMeasurementUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    ____PositioningMeasurementUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningMeasurementUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningMeasurementUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningMeasurementUpdate_protocolIEs__item__id),
        (u'criticality', ___PositioningMeasurementUpdate_protocolIEs__item__criticality),
        (u'value', ___PositioningMeasurementUpdate_protocolIEs__item__value),
        ])
    __PositioningMeasurementUpdate_protocolIEs__item_._ext = None
    _PositioningMeasurementUpdate_protocolIEs._cont = __PositioningMeasurementUpdate_protocolIEs__item_
    _PositioningMeasurementUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementUpdate._cont = ASN1Dict([
        (u'protocolIEs', _PositioningMeasurementUpdate_protocolIEs),
        ])
    PositioningMeasurementUpdate._ext = []
    
    #-----< PositioningMeasurementUpdateIEs >-----#
    PositioningMeasurementUpdateIEs = CLASS(name=u'PositioningMeasurementUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementUpdateIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementUpdateIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementUpdateIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    PositioningMeasurementUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 402), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementUpdateIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 411), (u'criticality', u'reject'), (u'Value', _PositioningMeasurementUpdateIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _PositioningMeasurementUpdateIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationRequest >-----#
    TRPInformationRequest = SEQ(name=u'TRPInformationRequest', mode=MODE_TYPE)
    _TRPInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____TRPInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPList')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationTypeListTRPReq')))
    ____TRPInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 410), (u'criticality', u'ignore'), (u'Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 398), (u'criticality', u'reject'), (u'Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TRPInformationRequest_protocolIEs__item__id._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationRequest_protocolIEs__item__value._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationRequest_protocolIEs__item__id),
        (u'criticality', ___TRPInformationRequest_protocolIEs__item__criticality),
        (u'value', ___TRPInformationRequest_protocolIEs__item__value),
        ])
    __TRPInformationRequest_protocolIEs__item_._ext = None
    _TRPInformationRequest_protocolIEs._cont = __TRPInformationRequest_protocolIEs__item_
    _TRPInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationRequest_protocolIEs),
        ])
    TRPInformationRequest._ext = []
    
    #-----< TRPInformationRequestIEs >-----#
    TRPInformationRequestIEs = CLASS(name=u'TRPInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationRequestIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPList')))
    _TRPInformationRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationTypeListTRPReq')))
    TRPInformationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _TRPInformationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 410), (u'criticality', u'ignore'), (u'Value', _TRPInformationRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 398), (u'criticality', u'reject'), (u'Value', _TRPInformationRequestIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeListTRPReq >-----#
    TRPInformationTypeListTRPReq = SEQ_OF(name=u'TRPInformationTypeListTRPReq', mode=MODE_TYPE)
    _TRPInformationTypeListTRPReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationTypeListTRPReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPInformationTypeListTRPReq__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeItem')))
    ___TRPInformationTypeListTRPReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 399), (u'criticality', u'reject'), (u'Value', ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeListTRPReq__item__id._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__id._const_tab_at = None
    __TRPInformationTypeListTRPReq__item__id._const_tab_id = u'id'
    __TRPInformationTypeListTRPReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __TRPInformationTypeListTRPReq__item__criticality._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_at = ('..', u'id')
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_id = u'criticality'
    __TRPInformationTypeListTRPReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __TRPInformationTypeListTRPReq__item__value._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__value._const_tab_at = ('..', u'id')
    __TRPInformationTypeListTRPReq__item__value._const_tab_id = u'Value'
    _TRPInformationTypeListTRPReq__item_._cont = ASN1Dict([
        (u'id', __TRPInformationTypeListTRPReq__item__id),
        (u'criticality', __TRPInformationTypeListTRPReq__item__criticality),
        (u'value', __TRPInformationTypeListTRPReq__item__value),
        ])
    _TRPInformationTypeListTRPReq__item_._ext = None
    TRPInformationTypeListTRPReq._cont = _TRPInformationTypeListTRPReq__item_
    TRPInformationTypeListTRPReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeItemTRPReq >-----#
    TRPInformationTypeItemTRPReq = CLASS(name=u'TRPInformationTypeItemTRPReq', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationTypeItemTRPReq_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeItem')))
    TRPInformationTypeItemTRPReq._val = ASN1Set(rv=[dict([(u'id', 399), (u'criticality', u'reject'), (u'Value', _TRPInformationTypeItemTRPReq_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationResponse >-----#
    TRPInformationResponse = SEQ(name=u'TRPInformationResponse', mode=MODE_TYPE)
    _TRPInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____TRPInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationListTRPResp')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 400), (u'criticality', u'ignore'), (u'Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationResponse_protocolIEs__item__id._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationResponse_protocolIEs__item__value._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationResponse_protocolIEs__item__id),
        (u'criticality', ___TRPInformationResponse_protocolIEs__item__criticality),
        (u'value', ___TRPInformationResponse_protocolIEs__item__value),
        ])
    __TRPInformationResponse_protocolIEs__item_._ext = None
    _TRPInformationResponse_protocolIEs._cont = __TRPInformationResponse_protocolIEs__item_
    _TRPInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationResponse_protocolIEs),
        ])
    TRPInformationResponse._ext = []
    
    #-----< TRPInformationResponseIEs >-----#
    TRPInformationResponseIEs = CLASS(name=u'TRPInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationListTRPResp')))
    _TRPInformationResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    TRPInformationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _TRPInformationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 400), (u'criticality', u'ignore'), (u'Value', _TRPInformationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _TRPInformationResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationListTRPResp >-----#
    TRPInformationListTRPResp = SEQ_OF(name=u'TRPInformationListTRPResp', mode=MODE_TYPE)
    _TRPInformationListTRPResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationListTRPResp__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___TRPInformationListTRPResp__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationListTRPResp__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationItem')))
    ___TRPInformationListTRPResp__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 401), (u'criticality', u'ignore'), (u'Value', ____TRPInformationListTRPResp__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationListTRPResp__item__id._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__id._const_tab_at = None
    __TRPInformationListTRPResp__item__id._const_tab_id = u'id'
    __TRPInformationListTRPResp__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    __TRPInformationListTRPResp__item__criticality._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__criticality._const_tab_at = ('..', u'id')
    __TRPInformationListTRPResp__item__criticality._const_tab_id = u'criticality'
    __TRPInformationListTRPResp__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    __TRPInformationListTRPResp__item__value._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__value._const_tab_at = ('..', u'id')
    __TRPInformationListTRPResp__item__value._const_tab_id = u'Value'
    _TRPInformationListTRPResp__item_._cont = ASN1Dict([
        (u'id', __TRPInformationListTRPResp__item__id),
        (u'criticality', __TRPInformationListTRPResp__item__criticality),
        (u'value', __TRPInformationListTRPResp__item__value),
        ])
    _TRPInformationListTRPResp__item_._ext = None
    TRPInformationListTRPResp._cont = _TRPInformationListTRPResp__item_
    TRPInformationListTRPResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPInformationItemTRPResp >-----#
    TRPInformationItemTRPResp = CLASS(name=u'TRPInformationItemTRPResp', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationItemTRPResp_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationItem')))
    TRPInformationItemTRPResp._val = ASN1Set(rv=[dict([(u'id', 401), (u'criticality', u'ignore'), (u'Value', _TRPInformationItemTRPResp_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationFailure >-----#
    TRPInformationFailure = SEQ(name=u'TRPInformationFailure', mode=MODE_TYPE)
    _TRPInformationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____TRPInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationFailure_protocolIEs__item__id._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationFailure_protocolIEs__item__value._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationFailure_protocolIEs__item__id),
        (u'criticality', ___TRPInformationFailure_protocolIEs__item__criticality),
        (u'value', ___TRPInformationFailure_protocolIEs__item__value),
        ])
    __TRPInformationFailure_protocolIEs__item_._ext = None
    _TRPInformationFailure_protocolIEs._cont = __TRPInformationFailure_protocolIEs__item_
    _TRPInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationFailure._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationFailure_protocolIEs),
        ])
    TRPInformationFailure._ext = []
    
    #-----< TRPInformationFailureIEs >-----#
    TRPInformationFailureIEs = CLASS(name=u'TRPInformationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _TRPInformationFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    TRPInformationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _TRPInformationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _TRPInformationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _TRPInformationFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationRequest >-----#
    PositioningInformationRequest = SEQ(name=u'PositioningInformationRequest', mode=MODE_TYPE)
    _PositioningInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedSRSTransmissionCharacteristics')))
    ____PositioningInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 391), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationRequest_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationRequest_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationRequest_protocolIEs__item__value),
        ])
    __PositioningInformationRequest_protocolIEs__item_._ext = None
    _PositioningInformationRequest_protocolIEs._cont = __PositioningInformationRequest_protocolIEs__item_
    _PositioningInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationRequest_protocolIEs),
        ])
    PositioningInformationRequest._ext = []
    
    #-----< PositioningInformationRequestIEs >-----#
    PositioningInformationRequestIEs = CLASS(name=u'PositioningInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedSRSTransmissionCharacteristics')))
    PositioningInformationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningInformationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningInformationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 391), (u'criticality', u'ignore'), (u'Value', _PositioningInformationRequestIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationResponse >-----#
    PositioningInformationResponse = SEQ(name=u'PositioningInformationResponse', mode=MODE_TYPE)
    _PositioningInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationResponse_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationResponse_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationResponse_protocolIEs__item__value),
        ])
    __PositioningInformationResponse_protocolIEs__item_._ext = None
    _PositioningInformationResponse_protocolIEs._cont = __PositioningInformationResponse_protocolIEs__item_
    _PositioningInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationResponse_protocolIEs),
        ])
    PositioningInformationResponse._ext = []
    
    #-----< PositioningInformationResponseIEs >-----#
    PositioningInformationResponseIEs = CLASS(name=u'PositioningInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningInformationResponseIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _PositioningInformationResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningInformationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningInformationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningInformationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationFailure >-----#
    PositioningInformationFailure = SEQ(name=u'PositioningInformationFailure', mode=MODE_TYPE)
    _PositioningInformationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationFailure_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationFailure_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationFailure_protocolIEs__item__value),
        ])
    __PositioningInformationFailure_protocolIEs__item_._ext = None
    _PositioningInformationFailure_protocolIEs._cont = __PositioningInformationFailure_protocolIEs__item_
    _PositioningInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationFailure._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationFailure_protocolIEs),
        ])
    PositioningInformationFailure._ext = []
    
    #-----< PositioningInformationFailureIEs >-----#
    PositioningInformationFailureIEs = CLASS(name=u'PositioningInformationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningInformationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningInformationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningInformationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningInformationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningInformationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningInformationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationRequest >-----#
    PositioningActivationRequest = SEQ(name=u'PositioningActivationRequest', mode=MODE_TYPE)
    _PositioningActivationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRSType')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    ____PositioningActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 403), (u'criticality', u'reject'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 404), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationRequest_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationRequest_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationRequest_protocolIEs__item__value),
        ])
    __PositioningActivationRequest_protocolIEs__item_._ext = None
    _PositioningActivationRequest_protocolIEs._cont = __PositioningActivationRequest_protocolIEs__item_
    _PositioningActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationRequest._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationRequest_protocolIEs),
        ])
    PositioningActivationRequest._ext = []
    
    #-----< PositioningActivationRequestIEs >-----#
    PositioningActivationRequestIEs = CLASS(name=u'PositioningActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRSType')))
    _PositioningActivationRequestIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    PositioningActivationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningActivationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningActivationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 403), (u'criticality', u'reject'), (u'Value', _PositioningActivationRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 404), (u'criticality', u'ignore'), (u'Value', _PositioningActivationRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSType >-----#
    SRSType = CHOICE(name=u'SRSType', mode=MODE_TYPE)
    _SRSType_semipersistentSRS = SEQ(name=u'semipersistentSRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'SemipersistentSRS')))
    _SRSType_aperiodicSRS = SEQ(name=u'aperiodicSRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'AperiodicSRS')))
    _SRSType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRSType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___SRSType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_id._const_tab = ___SRSType_choice_extension_id_tab
    __SRSType_choice_extension_id._const_tab_at = None
    __SRSType_choice_extension_id._const_tab_id = u'id'
    __SRSType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___SRSType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_criticality._const_tab = ___SRSType_choice_extension_criticality_tab
    __SRSType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SRSType_choice_extension_criticality._const_tab_id = u'criticality'
    __SRSType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___SRSType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_value._const_tab = ___SRSType_choice_extension_value_tab
    __SRSType_choice_extension_value._const_tab_at = ('..', u'id')
    __SRSType_choice_extension_value._const_tab_id = u'Value'
    _SRSType_choice_extension._cont = ASN1Dict([
        (u'id', __SRSType_choice_extension_id),
        (u'criticality', __SRSType_choice_extension_criticality),
        (u'value', __SRSType_choice_extension_value),
        ])
    _SRSType_choice_extension._ext = None
    SRSType._cont = ASN1Dict([
        (u'semipersistentSRS', _SRSType_semipersistentSRS),
        (u'aperiodicSRS', _SRSType_aperiodicSRS),
        (u'choice-extension', _SRSType_choice_extension),
        ])
    SRSType._ext = None
    
    #-----< SRSType-ExtIEs >-----#
    SRSType_ExtIEs = CLASS(name=u'SRSType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SRSType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SemipersistentSRS >-----#
    SemipersistentSRS = SEQ(name=u'SemipersistentSRS', mode=MODE_TYPE)
    _SemipersistentSRS_sRSResourceSetID = INT(name=u'sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _SemipersistentSRS_sRSSpatialRelation = SEQ(name=u'sRSSpatialRelation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationInfo')), opt=True)
    _SemipersistentSRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SemipersistentSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SemipersistentSRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SemipersistentSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    ____SemipersistentSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 435), (u'criticality', u'ignore'), (u'Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_at = None
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___SemipersistentSRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SemipersistentSRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SemipersistentSRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SemipersistentSRS_iE_Extensions__item__id),
        (u'criticality', ___SemipersistentSRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___SemipersistentSRS_iE_Extensions__item__extensionValue),
        ])
    __SemipersistentSRS_iE_Extensions__item_._ext = None
    _SemipersistentSRS_iE_Extensions._cont = __SemipersistentSRS_iE_Extensions__item_
    _SemipersistentSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SemipersistentSRS._cont = ASN1Dict([
        (u'sRSResourceSetID', _SemipersistentSRS_sRSResourceSetID),
        (u'sRSSpatialRelation', _SemipersistentSRS_sRSSpatialRelation),
        (u'iE-Extensions', _SemipersistentSRS_iE_Extensions),
        ])
    SemipersistentSRS._ext = []
    
    #-----< SemipersistentSRS-ExtIEs >-----#
    SemipersistentSRS_ExtIEs = CLASS(name=u'SemipersistentSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SemipersistentSRS_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    SemipersistentSRS_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 435), (u'criticality', u'ignore'), (u'Extension', _SemipersistentSRS_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRS >-----#
    AperiodicSRS = SEQ(name=u'AperiodicSRS', mode=MODE_TYPE)
    _AperiodicSRS_aperiodic = ENUM(name=u'aperiodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AperiodicSRS_aperiodic._cont = ASN1Dict([(u'true', 0)])
    _AperiodicSRS_aperiodic._ext = []
    _AperiodicSRS_sRSResourceTrigger = SEQ(name=u'sRSResourceTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceTrigger')), opt=True)
    _AperiodicSRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AperiodicSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AperiodicSRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AperiodicSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__id._const_tab = ____AperiodicSRS_iE_Extensions__item__id_tab
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_at = None
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___AperiodicSRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab = ____AperiodicSRS_iE_Extensions__item__criticality_tab
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AperiodicSRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab = ____AperiodicSRS_iE_Extensions__item__extensionValue_tab
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AperiodicSRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AperiodicSRS_iE_Extensions__item__id),
        (u'criticality', ___AperiodicSRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___AperiodicSRS_iE_Extensions__item__extensionValue),
        ])
    __AperiodicSRS_iE_Extensions__item_._ext = None
    _AperiodicSRS_iE_Extensions._cont = __AperiodicSRS_iE_Extensions__item_
    _AperiodicSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AperiodicSRS._cont = ASN1Dict([
        (u'aperiodic', _AperiodicSRS_aperiodic),
        (u'sRSResourceTrigger', _AperiodicSRS_sRSResourceTrigger),
        (u'iE-Extensions', _AperiodicSRS_iE_Extensions),
        ])
    AperiodicSRS._ext = []
    
    #-----< AperiodicSRS-ExtIEs >-----#
    AperiodicSRS_ExtIEs = CLASS(name=u'AperiodicSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AperiodicSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationResponse >-----#
    PositioningActivationResponse = SEQ(name=u'PositioningActivationResponse', mode=MODE_TYPE)
    _PositioningActivationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 420), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 421), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationResponse_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationResponse_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationResponse_protocolIEs__item__value),
        ])
    __PositioningActivationResponse_protocolIEs__item_._ext = None
    _PositioningActivationResponse_protocolIEs._cont = __PositioningActivationResponse_protocolIEs__item_
    _PositioningActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationResponse._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationResponse_protocolIEs),
        ])
    PositioningActivationResponse._ext = []
    
    #-----< PositioningActivationResponseIEs >-----#
    PositioningActivationResponseIEs = CLASS(name=u'PositioningActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _PositioningActivationResponseIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _PositioningActivationResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningActivationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningActivationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningActivationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 420), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 421), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationFailure >-----#
    PositioningActivationFailure = SEQ(name=u'PositioningActivationFailure', mode=MODE_TYPE)
    _PositioningActivationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationFailure_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationFailure_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationFailure_protocolIEs__item__value),
        ])
    __PositioningActivationFailure_protocolIEs__item_._ext = None
    _PositioningActivationFailure_protocolIEs._cont = __PositioningActivationFailure_protocolIEs__item_
    _PositioningActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationFailure._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationFailure_protocolIEs),
        ])
    PositioningActivationFailure._ext = []
    
    #-----< PositioningActivationFailureIEs >-----#
    PositioningActivationFailureIEs = CLASS(name=u'PositioningActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningActivationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningActivationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningActivationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningActivationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningActivationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _PositioningActivationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningDeactivation >-----#
    PositioningDeactivation = SEQ(name=u'PositioningDeactivation', mode=MODE_TYPE)
    _PositioningDeactivation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningDeactivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningDeactivation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningDeactivation_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AbortTransmission')))
    ____PositioningDeactivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 405), (u'criticality', u'ignore'), (u'Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningDeactivation_protocolIEs__item__id._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_at = None
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningDeactivation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningDeactivation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningDeactivation_protocolIEs__item__value._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningDeactivation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningDeactivation_protocolIEs__item__id),
        (u'criticality', ___PositioningDeactivation_protocolIEs__item__criticality),
        (u'value', ___PositioningDeactivation_protocolIEs__item__value),
        ])
    __PositioningDeactivation_protocolIEs__item_._ext = None
    _PositioningDeactivation_protocolIEs._cont = __PositioningDeactivation_protocolIEs__item_
    _PositioningDeactivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningDeactivation._cont = ASN1Dict([
        (u'protocolIEs', _PositioningDeactivation_protocolIEs),
        ])
    PositioningDeactivation._ext = []
    
    #-----< PositioningDeactivationIEs >-----#
    PositioningDeactivationIEs = CLASS(name=u'PositioningDeactivationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningDeactivationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningDeactivationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningDeactivationIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AbortTransmission')))
    PositioningDeactivationIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningDeactivationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningDeactivationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 405), (u'criticality', u'ignore'), (u'Value', _PositioningDeactivationIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationUpdate >-----#
    PositioningInformationUpdate = SEQ(name=u'PositioningInformationUpdate', mode=MODE_TYPE)
    _PositioningInformationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationUpdate_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationUpdate_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationUpdate_protocolIEs__item__value),
        ])
    __PositioningInformationUpdate_protocolIEs__item_._ext = None
    _PositioningInformationUpdate_protocolIEs._cont = __PositioningInformationUpdate_protocolIEs__item_
    _PositioningInformationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationUpdate_protocolIEs),
        ])
    PositioningInformationUpdate._ext = []
    
    #-----< PositioningInformationUpdateIEs >-----#
    PositioningInformationUpdateIEs = CLASS(name=u'PositioningInformationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationUpdateIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationUpdateIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningInformationUpdateIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    PositioningInformationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PositioningInformationUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PositioningInformationUpdateIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 407), (u'criticality', u'ignore'), (u'Value', _PositioningInformationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 419), (u'criticality', u'ignore'), (u'Value', _PositioningInformationUpdateIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationRequest >-----#
    E_CIDMeasurementInitiationRequest = SEQ(name=u'E-CIDMeasurementInitiationRequest', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-ReportCharacteristics')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities')))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 424), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 416), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 414), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationRequest_protocolIEs._cont = __E_CIDMeasurementInitiationRequest_protocolIEs__item_
    _E_CIDMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationRequest_protocolIEs),
        ])
    E_CIDMeasurementInitiationRequest._ext = []
    
    #-----< E-CIDMeasurementInitiationRequest-IEs >-----#
    E_CIDMeasurementInitiationRequest_IEs = CLASS(name=u'E-CIDMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-ReportCharacteristics')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities')))
    E_CIDMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 424), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 416), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 414), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationResponse >-----#
    E_CIDMeasurementInitiationResponse = SEQ(name=u'E-CIDMeasurementInitiationResponse', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 417), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 418), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationResponse_protocolIEs._cont = __E_CIDMeasurementInitiationResponse_protocolIEs__item_
    _E_CIDMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationResponse_protocolIEs),
        ])
    E_CIDMeasurementInitiationResponse._ext = []
    
    #-----< E-CIDMeasurementInitiationResponse-IEs >-----#
    E_CIDMeasurementInitiationResponse_IEs = CLASS(name=u'E-CIDMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 417), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 418), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationFailure >-----#
    E_CIDMeasurementInitiationFailure = SEQ(name=u'E-CIDMeasurementInitiationFailure', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationFailure_protocolIEs._cont = __E_CIDMeasurementInitiationFailure_protocolIEs__item_
    _E_CIDMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationFailure_protocolIEs),
        ])
    E_CIDMeasurementInitiationFailure._ext = []
    
    #-----< E-CIDMeasurementInitiationFailure-IEs >-----#
    E_CIDMeasurementInitiationFailure_IEs = CLASS(name=u'E-CIDMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementFailureIndication >-----#
    E_CIDMeasurementFailureIndication = SEQ(name=u'E-CIDMeasurementFailureIndication', mode=MODE_TYPE)
    _E_CIDMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._ext = None
    _E_CIDMeasurementFailureIndication_protocolIEs._cont = __E_CIDMeasurementFailureIndication_protocolIEs__item_
    _E_CIDMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementFailureIndication_protocolIEs),
        ])
    E_CIDMeasurementFailureIndication._ext = []
    
    #-----< E-CIDMeasurementFailureIndication-IEs >-----#
    E_CIDMeasurementFailureIndication_IEs = CLASS(name=u'E-CIDMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    E_CIDMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementReport >-----#
    E_CIDMeasurementReport = SEQ(name=u'E-CIDMeasurementReport', mode=MODE_TYPE)
    _E_CIDMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 417), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 418), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementReport_protocolIEs__item__value),
        ])
    __E_CIDMeasurementReport_protocolIEs__item_._ext = None
    _E_CIDMeasurementReport_protocolIEs._cont = __E_CIDMeasurementReport_protocolIEs__item_
    _E_CIDMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementReport_protocolIEs),
        ])
    E_CIDMeasurementReport._ext = []
    
    #-----< E-CIDMeasurementReport-IEs >-----#
    E_CIDMeasurementReport_IEs = CLASS(name=u'E-CIDMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementReport_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementReport_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementReport_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    E_CIDMeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 417), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 418), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementTerminationCommand >-----#
    E_CIDMeasurementTerminationCommand = SEQ(name=u'E-CIDMeasurementTerminationCommand', mode=MODE_TYPE)
    _E_CIDMeasurementTerminationCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value),
        ])
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._ext = None
    _E_CIDMeasurementTerminationCommand_protocolIEs._cont = __E_CIDMeasurementTerminationCommand_protocolIEs__item_
    _E_CIDMeasurementTerminationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementTerminationCommand._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementTerminationCommand_protocolIEs),
        ])
    E_CIDMeasurementTerminationCommand._ext = []
    
    #-----< E-CIDMeasurementTerminationCommand-IEs >-----#
    E_CIDMeasurementTerminationCommand_IEs = CLASS(name=u'E-CIDMeasurementTerminationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    E_CIDMeasurementTerminationCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 412), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 413), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        _____Reset_protocolIEs__item__id_tab_val_Value_2,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetIEs_val_Value_2,
        _ResetType_f1_Interface,
        _ResetType_partOfF1_Interface,
        ___ResetType_choice_extension_id_tab,
        __ResetType_choice_extension_id,
        ___ResetType_choice_extension_criticality_tab,
        __ResetType_choice_extension_criticality,
        ___ResetType_choice_extension_value_tab,
        __ResetType_choice_extension_value,
        _ResetType_choice_extension,
        ResetType,
        ResetType_ExtIEs,
        ResetAll,
        ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab,
        ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0,
        __UE_associatedLogicalF1_ConnectionListRes__item__id,
        __UE_associatedLogicalF1_ConnectionListRes__item__criticality,
        __UE_associatedLogicalF1_ConnectionListRes__item__value,
        _UE_associatedLogicalF1_ConnectionListRes__item_,
        UE_associatedLogicalF1_ConnectionListRes,
        UE_associatedLogicalF1_ConnectionItemRes,
        _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        _ResetAcknowledgeIEs_val_Value_2,
        ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab,
        ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0,
        __UE_associatedLogicalF1_ConnectionListResAck__item__id,
        __UE_associatedLogicalF1_ConnectionListResAck__item__criticality,
        __UE_associatedLogicalF1_ConnectionListResAck__item__value,
        _UE_associatedLogicalF1_ConnectionListResAck__item_,
        UE_associatedLogicalF1_ConnectionListResAck,
        UE_associatedLogicalF1_ConnectionItemResAck,
        _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____F1SetupRequest_protocolIEs__item__id_tab,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7,
        ___F1SetupRequest_protocolIEs__item__id,
        ___F1SetupRequest_protocolIEs__item__criticality,
        ___F1SetupRequest_protocolIEs__item__value,
        __F1SetupRequest_protocolIEs__item_,
        _F1SetupRequest_protocolIEs,
        F1SetupRequest,
        F1SetupRequestIEs,
        _F1SetupRequestIEs_val_Value_0,
        _F1SetupRequestIEs_val_Value_1,
        _F1SetupRequestIEs_val_Value_2,
        _F1SetupRequestIEs_val_Value_3,
        _F1SetupRequestIEs_val_Value_4,
        _F1SetupRequestIEs_val_Value_5,
        _F1SetupRequestIEs_val_Value_6,
        _F1SetupRequestIEs_val_Value_7,
        ___GNB_DU_Served_Cells_List__item__id_tab,
        ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0,
        __GNB_DU_Served_Cells_List__item__id,
        __GNB_DU_Served_Cells_List__item__criticality,
        __GNB_DU_Served_Cells_List__item__value,
        _GNB_DU_Served_Cells_List__item_,
        GNB_DU_Served_Cells_List,
        GNB_DU_Served_Cells_ItemIEs,
        _GNB_DU_Served_Cells_ItemIEs_val_Value_0,
        ____F1SetupResponse_protocolIEs__item__id_tab,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___F1SetupResponse_protocolIEs__item__id,
        ___F1SetupResponse_protocolIEs__item__criticality,
        ___F1SetupResponse_protocolIEs__item__value,
        __F1SetupResponse_protocolIEs__item_,
        _F1SetupResponse_protocolIEs,
        F1SetupResponse,
        F1SetupResponseIEs,
        _F1SetupResponseIEs_val_Value_0,
        _F1SetupResponseIEs_val_Value_1,
        _F1SetupResponseIEs_val_Value_2,
        _F1SetupResponseIEs_val_Value_3,
        _F1SetupResponseIEs_val_Value_4,
        _F1SetupResponseIEs_val_Value_5,
        _F1SetupResponseIEs_val_Value_6,
        _F1SetupResponseIEs_val_Value_7,
        ___Cells_to_be_Activated_List__item__id_tab,
        ____Cells_to_be_Activated_List__item__id_tab_val_Value_0,
        __Cells_to_be_Activated_List__item__id,
        __Cells_to_be_Activated_List__item__criticality,
        __Cells_to_be_Activated_List__item__value,
        _Cells_to_be_Activated_List__item_,
        Cells_to_be_Activated_List,
        Cells_to_be_Activated_List_ItemIEs,
        _Cells_to_be_Activated_List_ItemIEs_val_Value_0,
        ____F1SetupFailure_protocolIEs__item__id_tab,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___F1SetupFailure_protocolIEs__item__id,
        ___F1SetupFailure_protocolIEs__item__criticality,
        ___F1SetupFailure_protocolIEs__item__value,
        __F1SetupFailure_protocolIEs__item_,
        _F1SetupFailure_protocolIEs,
        F1SetupFailure,
        F1SetupFailureIEs,
        _F1SetupFailureIEs_val_Value_0,
        _F1SetupFailureIEs_val_Value_1,
        _F1SetupFailureIEs_val_Value_2,
        _F1SetupFailureIEs_val_Value_3,
        ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10,
        ___GNBDUConfigurationUpdate_protocolIEs__item__id,
        ___GNBDUConfigurationUpdate_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdate_protocolIEs__item__value,
        __GNBDUConfigurationUpdate_protocolIEs__item_,
        _GNBDUConfigurationUpdate_protocolIEs,
        GNBDUConfigurationUpdate,
        GNBDUConfigurationUpdateIEs,
        _GNBDUConfigurationUpdateIEs_val_Value_0,
        _GNBDUConfigurationUpdateIEs_val_Value_1,
        _GNBDUConfigurationUpdateIEs_val_Value_2,
        _GNBDUConfigurationUpdateIEs_val_Value_3,
        _GNBDUConfigurationUpdateIEs_val_Value_4,
        _GNBDUConfigurationUpdateIEs_val_Value_5,
        _GNBDUConfigurationUpdateIEs_val_Value_6,
        _GNBDUConfigurationUpdateIEs_val_Value_7,
        _GNBDUConfigurationUpdateIEs_val_Value_8,
        _GNBDUConfigurationUpdateIEs_val_Value_9,
        _GNBDUConfigurationUpdateIEs_val_Value_10,
        ___Served_Cells_To_Add_List__item__id_tab,
        ____Served_Cells_To_Add_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Add_List__item__id,
        __Served_Cells_To_Add_List__item__criticality,
        __Served_Cells_To_Add_List__item__value,
        _Served_Cells_To_Add_List__item_,
        Served_Cells_To_Add_List,
        ___Served_Cells_To_Modify_List__item__id_tab,
        ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Modify_List__item__id,
        __Served_Cells_To_Modify_List__item__criticality,
        __Served_Cells_To_Modify_List__item__value,
        _Served_Cells_To_Modify_List__item_,
        Served_Cells_To_Modify_List,
        ___Served_Cells_To_Delete_List__item__id_tab,
        ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Delete_List__item__id,
        __Served_Cells_To_Delete_List__item__criticality,
        __Served_Cells_To_Delete_List__item__value,
        _Served_Cells_To_Delete_List__item_,
        Served_Cells_To_Delete_List,
        ___Cells_Status_List__item__id_tab,
        ____Cells_Status_List__item__id_tab_val_Value_0,
        __Cells_Status_List__item__id,
        __Cells_Status_List__item__criticality,
        __Cells_Status_List__item__value,
        _Cells_Status_List__item_,
        Cells_Status_List,
        ___Dedicated_SIDelivery_NeededUE_List__item__id_tab,
        ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0,
        __Dedicated_SIDelivery_NeededUE_List__item__id,
        __Dedicated_SIDelivery_NeededUE_List__item__criticality,
        __Dedicated_SIDelivery_NeededUE_List__item__value,
        _Dedicated_SIDelivery_NeededUE_List__item_,
        Dedicated_SIDelivery_NeededUE_List,
        ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab,
        ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0,
        __GNB_DU_TNL_Association_To_Remove_List__item__id,
        __GNB_DU_TNL_Association_To_Remove_List__item__criticality,
        __GNB_DU_TNL_Association_To_Remove_List__item__value,
        _GNB_DU_TNL_Association_To_Remove_List__item_,
        GNB_DU_TNL_Association_To_Remove_List,
        Served_Cells_To_Add_ItemIEs,
        _Served_Cells_To_Add_ItemIEs_val_Value_0,
        Served_Cells_To_Modify_ItemIEs,
        _Served_Cells_To_Modify_ItemIEs_val_Value_0,
        Served_Cells_To_Delete_ItemIEs,
        _Served_Cells_To_Delete_ItemIEs_val_Value_0,
        Cells_Status_ItemIEs,
        _Cells_Status_ItemIEs_val_Value_0,
        Dedicated_SIDelivery_NeededUE_ItemIEs,
        _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0,
        GNB_DU_TNL_Association_To_Remove_ItemIEs,
        _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0,
        ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNBDUConfigurationUpdateAcknowledge_protocolIEs,
        GNBDUConfigurationUpdateAcknowledge,
        GNBDUConfigurationUpdateAcknowledgeIEs,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6,
        ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value,
        __GNBDUConfigurationUpdateFailure_protocolIEs__item_,
        _GNBDUConfigurationUpdateFailure_protocolIEs,
        GNBDUConfigurationUpdateFailure,
        GNBDUConfigurationUpdateFailureIEs,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_0,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_1,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_2,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_3,
        ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13,
        ___GNBCUConfigurationUpdate_protocolIEs__item__id,
        ___GNBCUConfigurationUpdate_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdate_protocolIEs__item__value,
        __GNBCUConfigurationUpdate_protocolIEs__item_,
        _GNBCUConfigurationUpdate_protocolIEs,
        GNBCUConfigurationUpdate,
        GNBCUConfigurationUpdateIEs,
        _GNBCUConfigurationUpdateIEs_val_Value_0,
        _GNBCUConfigurationUpdateIEs_val_Value_1,
        _GNBCUConfigurationUpdateIEs_val_Value_2,
        _GNBCUConfigurationUpdateIEs_val_Value_3,
        _GNBCUConfigurationUpdateIEs_val_Value_4,
        _GNBCUConfigurationUpdateIEs_val_Value_5,
        _GNBCUConfigurationUpdateIEs_val_Value_6,
        _GNBCUConfigurationUpdateIEs_val_Value_7,
        _GNBCUConfigurationUpdateIEs_val_Value_8,
        _GNBCUConfigurationUpdateIEs_val_Value_9,
        _GNBCUConfigurationUpdateIEs_val_Value_10,
        _GNBCUConfigurationUpdateIEs_val_Value_11,
        _GNBCUConfigurationUpdateIEs_val_Value_12,
        _GNBCUConfigurationUpdateIEs_val_Value_13,
        ___Cells_to_be_Deactivated_List__item__id_tab,
        ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0,
        __Cells_to_be_Deactivated_List__item__id,
        __Cells_to_be_Deactivated_List__item__criticality,
        __Cells_to_be_Deactivated_List__item__value,
        _Cells_to_be_Deactivated_List__item_,
        Cells_to_be_Deactivated_List,
        ___GNB_CU_TNL_Association_To_Add_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Add_List__item__id,
        __GNB_CU_TNL_Association_To_Add_List__item__criticality,
        __GNB_CU_TNL_Association_To_Add_List__item__value,
        _GNB_CU_TNL_Association_To_Add_List__item_,
        GNB_CU_TNL_Association_To_Add_List,
        ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Remove_List__item__id,
        __GNB_CU_TNL_Association_To_Remove_List__item__criticality,
        __GNB_CU_TNL_Association_To_Remove_List__item__value,
        _GNB_CU_TNL_Association_To_Remove_List__item_,
        GNB_CU_TNL_Association_To_Remove_List,
        ___GNB_CU_TNL_Association_To_Update_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Update_List__item__id,
        __GNB_CU_TNL_Association_To_Update_List__item__criticality,
        __GNB_CU_TNL_Association_To_Update_List__item__value,
        _GNB_CU_TNL_Association_To_Update_List__item_,
        GNB_CU_TNL_Association_To_Update_List,
        ___Cells_to_be_Barred_List__item__id_tab,
        ____Cells_to_be_Barred_List__item__id_tab_val_Value_0,
        __Cells_to_be_Barred_List__item__id,
        __Cells_to_be_Barred_List__item__criticality,
        __Cells_to_be_Barred_List__item__value,
        _Cells_to_be_Barred_List__item_,
        Cells_to_be_Barred_List,
        Cells_to_be_Deactivated_List_ItemIEs,
        _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Add_ItemIEs,
        _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Remove_ItemIEs,
        _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Update_ItemIEs,
        _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0,
        Cells_to_be_Barred_ItemIEs,
        _Cells_to_be_Barred_ItemIEs_val_Value_0,
        ___Protected_EUTRA_Resources_List__item__id_tab,
        ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0,
        __Protected_EUTRA_Resources_List__item__id,
        __Protected_EUTRA_Resources_List__item__criticality,
        __Protected_EUTRA_Resources_List__item__value,
        _Protected_EUTRA_Resources_List__item_,
        Protected_EUTRA_Resources_List,
        Protected_EUTRA_Resources_ItemIEs,
        _Protected_EUTRA_Resources_ItemIEs_val_Value_0,
        ___Neighbour_Cell_Information_List__item__id_tab,
        ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0,
        __Neighbour_Cell_Information_List__item__id,
        __Neighbour_Cell_Information_List__item__criticality,
        __Neighbour_Cell_Information_List__item__value,
        _Neighbour_Cell_Information_List__item_,
        Neighbour_Cell_Information_List,
        Neighbour_Cell_Information_ItemIEs,
        _Neighbour_Cell_Information_ItemIEs_val_Value_0,
        ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNBCUConfigurationUpdateAcknowledge_protocolIEs,
        GNBCUConfigurationUpdateAcknowledge,
        GNBCUConfigurationUpdateAcknowledgeIEs,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6,
        ___Cells_Failed_to_be_Activated_List__item__id_tab,
        ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0,
        __Cells_Failed_to_be_Activated_List__item__id,
        __Cells_Failed_to_be_Activated_List__item__criticality,
        __Cells_Failed_to_be_Activated_List__item__value,
        _Cells_Failed_to_be_Activated_List__item_,
        Cells_Failed_to_be_Activated_List,
        ___GNB_CU_TNL_Association_Setup_List__item__id_tab,
        ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_Setup_List__item__id,
        __GNB_CU_TNL_Association_Setup_List__item__criticality,
        __GNB_CU_TNL_Association_Setup_List__item__value,
        _GNB_CU_TNL_Association_Setup_List__item_,
        GNB_CU_TNL_Association_Setup_List,
        ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab,
        ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value,
        _GNB_CU_TNL_Association_Failed_To_Setup_List__item_,
        GNB_CU_TNL_Association_Failed_To_Setup_List,
        Cells_Failed_to_be_Activated_List_ItemIEs,
        _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_Setup_ItemIEs,
        _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs,
        _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0,
        ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value,
        __GNBCUConfigurationUpdateFailure_protocolIEs__item_,
        _GNBCUConfigurationUpdateFailure_protocolIEs,
        GNBCUConfigurationUpdateFailure,
        GNBCUConfigurationUpdateFailureIEs,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_0,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_1,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_2,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_3,
        ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__id,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__value,
        __GNBDUResourceCoordinationRequest_protocolIEs__item_,
        _GNBDUResourceCoordinationRequest_protocolIEs,
        GNBDUResourceCoordinationRequest,
        GNBDUResourceCoordinationRequest_IEs,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_0,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_1,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_2,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_3,
        ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab,
        _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__id,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__value,
        __GNBDUResourceCoordinationResponse_protocolIEs__item_,
        _GNBDUResourceCoordinationResponse_protocolIEs,
        GNBDUResourceCoordinationResponse,
        GNBDUResourceCoordinationResponse_IEs,
        _GNBDUResourceCoordinationResponse_IEs_val_Value_0,
        _GNBDUResourceCoordinationResponse_IEs_val_Value_1,
        ____UEContextSetupRequest_protocolIEs__item__id_tab,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        ___UEContextSetupRequest_protocolIEs__item__id,
        ___UEContextSetupRequest_protocolIEs__item__criticality,
        ___UEContextSetupRequest_protocolIEs__item__value,
        __UEContextSetupRequest_protocolIEs__item_,
        _UEContextSetupRequest_protocolIEs,
        UEContextSetupRequest,
        UEContextSetupRequestIEs,
        _UEContextSetupRequestIEs_val_Value_0,
        _UEContextSetupRequestIEs_val_Value_1,
        _UEContextSetupRequestIEs_val_Value_2,
        _UEContextSetupRequestIEs_val_Value_3,
        _UEContextSetupRequestIEs_val_Value_4,
        _UEContextSetupRequestIEs_val_Value_5,
        _UEContextSetupRequestIEs_val_Value_6,
        _UEContextSetupRequestIEs_val_Value_7,
        _UEContextSetupRequestIEs_val_Value_8,
        _UEContextSetupRequestIEs_val_Value_9,
        _UEContextSetupRequestIEs_val_Value_10,
        _UEContextSetupRequestIEs_val_Value_11,
        _UEContextSetupRequestIEs_val_Value_12,
        _UEContextSetupRequestIEs_val_Value_13,
        _UEContextSetupRequestIEs_val_Value_14,
        _UEContextSetupRequestIEs_val_Value_15,
        _UEContextSetupRequestIEs_val_Value_16,
        _UEContextSetupRequestIEs_val_Value_17,
        _UEContextSetupRequestIEs_val_Value_18,
        _UEContextSetupRequestIEs_val_Value_19,
        _UEContextSetupRequestIEs_val_Value_20,
        _UEContextSetupRequestIEs_val_Value_21,
        _UEContextSetupRequestIEs_val_Value_22,
        _UEContextSetupRequestIEs_val_Value_23,
        _UEContextSetupRequestIEs_val_Value_24,
        _UEContextSetupRequestIEs_val_Value_25,
        _UEContextSetupRequestIEs_val_Value_26,
        _UEContextSetupRequestIEs_val_Value_27,
        _UEContextSetupRequestIEs_val_Value_28,
        _UEContextSetupRequestIEs_val_Value_29,
        _UEContextSetupRequestIEs_val_Value_30,
        _UEContextSetupRequestIEs_val_Value_31,
        _UEContextSetupRequestIEs_val_Value_32,
        _UEContextSetupRequestIEs_val_Value_33,
        _UEContextSetupRequestIEs_val_Value_34,
        _UEContextSetupRequestIEs_val_Value_35,
        _UEContextSetupRequestIEs_val_Value_36,
        ___Candidate_SpCell_List__item__id_tab,
        ____Candidate_SpCell_List__item__id_tab_val_Value_0,
        __Candidate_SpCell_List__item__id,
        __Candidate_SpCell_List__item__criticality,
        __Candidate_SpCell_List__item__value,
        _Candidate_SpCell_List__item_,
        Candidate_SpCell_List,
        ___SCell_ToBeSetup_List__item__id_tab,
        ____SCell_ToBeSetup_List__item__id_tab_val_Value_0,
        __SCell_ToBeSetup_List__item__id,
        __SCell_ToBeSetup_List__item__criticality,
        __SCell_ToBeSetup_List__item__value,
        _SCell_ToBeSetup_List__item_,
        SCell_ToBeSetup_List,
        ___SRBs_ToBeSetup_List__item__id_tab,
        ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __SRBs_ToBeSetup_List__item__id,
        __SRBs_ToBeSetup_List__item__criticality,
        __SRBs_ToBeSetup_List__item__value,
        _SRBs_ToBeSetup_List__item_,
        SRBs_ToBeSetup_List,
        ___DRBs_ToBeSetup_List__item__id_tab,
        ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __DRBs_ToBeSetup_List__item__id,
        __DRBs_ToBeSetup_List__item__criticality,
        __DRBs_ToBeSetup_List__item__value,
        _DRBs_ToBeSetup_List__item_,
        DRBs_ToBeSetup_List,
        ___BHChannels_ToBeSetup_List__item__id_tab,
        ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeSetup_List__item__id,
        __BHChannels_ToBeSetup_List__item__criticality,
        __BHChannels_ToBeSetup_List__item__value,
        _BHChannels_ToBeSetup_List__item_,
        BHChannels_ToBeSetup_List,
        ___SLDRBs_ToBeSetup_List__item__id_tab,
        ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeSetup_List__item__id,
        __SLDRBs_ToBeSetup_List__item__criticality,
        __SLDRBs_ToBeSetup_List__item__value,
        _SLDRBs_ToBeSetup_List__item_,
        SLDRBs_ToBeSetup_List,
        Candidate_SpCell_ItemIEs,
        _Candidate_SpCell_ItemIEs_val_Value_0,
        SCell_ToBeSetup_ItemIEs,
        _SCell_ToBeSetup_ItemIEs_val_Value_0,
        SRBs_ToBeSetup_ItemIEs,
        _SRBs_ToBeSetup_ItemIEs_val_Value_0,
        DRBs_ToBeSetup_ItemIEs,
        _DRBs_ToBeSetup_ItemIEs_val_Value_0,
        BHChannels_ToBeSetup_ItemIEs,
        _BHChannels_ToBeSetup_ItemIEs_val_Value_0,
        SLDRBs_ToBeSetup_ItemIEs,
        _SLDRBs_ToBeSetup_ItemIEs_val_Value_0,
        ____UEContextSetupResponse_protocolIEs__item__id_tab,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17,
        ___UEContextSetupResponse_protocolIEs__item__id,
        ___UEContextSetupResponse_protocolIEs__item__criticality,
        ___UEContextSetupResponse_protocolIEs__item__value,
        __UEContextSetupResponse_protocolIEs__item_,
        _UEContextSetupResponse_protocolIEs,
        UEContextSetupResponse,
        UEContextSetupResponseIEs,
        _UEContextSetupResponseIEs_val_Value_0,
        _UEContextSetupResponseIEs_val_Value_1,
        _UEContextSetupResponseIEs_val_Value_2,
        _UEContextSetupResponseIEs_val_Value_3,
        _UEContextSetupResponseIEs_val_Value_4,
        _UEContextSetupResponseIEs_val_Value_5,
        _UEContextSetupResponseIEs_val_Value_6,
        _UEContextSetupResponseIEs_val_Value_7,
        _UEContextSetupResponseIEs_val_Value_8,
        _UEContextSetupResponseIEs_val_Value_9,
        _UEContextSetupResponseIEs_val_Value_10,
        _UEContextSetupResponseIEs_val_Value_11,
        _UEContextSetupResponseIEs_val_Value_12,
        _UEContextSetupResponseIEs_val_Value_13,
        _UEContextSetupResponseIEs_val_Value_14,
        _UEContextSetupResponseIEs_val_Value_15,
        _UEContextSetupResponseIEs_val_Value_16,
        _UEContextSetupResponseIEs_val_Value_17,
        ___DRBs_Setup_List__item__id_tab,
        ____DRBs_Setup_List__item__id_tab_val_Value_0,
        __DRBs_Setup_List__item__id,
        __DRBs_Setup_List__item__criticality,
        __DRBs_Setup_List__item__value,
        _DRBs_Setup_List__item_,
        DRBs_Setup_List,
        ___SRBs_FailedToBeSetup_List__item__id_tab,
        ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __SRBs_FailedToBeSetup_List__item__id,
        __SRBs_FailedToBeSetup_List__item__criticality,
        __SRBs_FailedToBeSetup_List__item__value,
        _SRBs_FailedToBeSetup_List__item_,
        SRBs_FailedToBeSetup_List,
        ___DRBs_FailedToBeSetup_List__item__id_tab,
        ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeSetup_List__item__id,
        __DRBs_FailedToBeSetup_List__item__criticality,
        __DRBs_FailedToBeSetup_List__item__value,
        _DRBs_FailedToBeSetup_List__item_,
        DRBs_FailedToBeSetup_List,
        ___SCell_FailedtoSetup_List__item__id_tab,
        ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0,
        __SCell_FailedtoSetup_List__item__id,
        __SCell_FailedtoSetup_List__item__criticality,
        __SCell_FailedtoSetup_List__item__value,
        _SCell_FailedtoSetup_List__item_,
        SCell_FailedtoSetup_List,
        ___SRBs_Setup_List__item__id_tab,
        ____SRBs_Setup_List__item__id_tab_val_Value_0,
        __SRBs_Setup_List__item__id,
        __SRBs_Setup_List__item__criticality,
        __SRBs_Setup_List__item__value,
        _SRBs_Setup_List__item_,
        SRBs_Setup_List,
        ___BHChannels_Setup_List__item__id_tab,
        ____BHChannels_Setup_List__item__id_tab_val_Value_0,
        __BHChannels_Setup_List__item__id,
        __BHChannels_Setup_List__item__criticality,
        __BHChannels_Setup_List__item__value,
        _BHChannels_Setup_List__item_,
        BHChannels_Setup_List,
        ___BHChannels_FailedToBeSetup_List__item__id_tab,
        ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeSetup_List__item__id,
        __BHChannels_FailedToBeSetup_List__item__criticality,
        __BHChannels_FailedToBeSetup_List__item__value,
        _BHChannels_FailedToBeSetup_List__item_,
        BHChannels_FailedToBeSetup_List,
        DRBs_Setup_ItemIEs,
        _DRBs_Setup_ItemIEs_val_Value_0,
        SRBs_Setup_ItemIEs,
        _SRBs_Setup_ItemIEs_val_Value_0,
        SRBs_FailedToBeSetup_ItemIEs,
        _SRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        DRBs_FailedToBeSetup_ItemIEs,
        _DRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        SCell_FailedtoSetup_ItemIEs,
        _SCell_FailedtoSetup_ItemIEs_val_Value_0,
        BHChannels_Setup_ItemIEs,
        _BHChannels_Setup_ItemIEs_val_Value_0,
        BHChannels_FailedToBeSetup_ItemIEs,
        _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0,
        ___SLDRBs_Setup_List__item__id_tab,
        ____SLDRBs_Setup_List__item__id_tab_val_Value_0,
        __SLDRBs_Setup_List__item__id,
        __SLDRBs_Setup_List__item__criticality,
        __SLDRBs_Setup_List__item__value,
        _SLDRBs_Setup_List__item_,
        SLDRBs_Setup_List,
        ___SLDRBs_FailedToBeSetup_List__item__id_tab,
        ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeSetup_List__item__id,
        __SLDRBs_FailedToBeSetup_List__item__criticality,
        __SLDRBs_FailedToBeSetup_List__item__value,
        _SLDRBs_FailedToBeSetup_List__item_,
        SLDRBs_FailedToBeSetup_List,
        SLDRBs_Setup_ItemIEs,
        _SLDRBs_Setup_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeSetup_ItemIEs,
        _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        ____UEContextSetupFailure_protocolIEs__item__id_tab,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5,
        ___UEContextSetupFailure_protocolIEs__item__id,
        ___UEContextSetupFailure_protocolIEs__item__criticality,
        ___UEContextSetupFailure_protocolIEs__item__value,
        __UEContextSetupFailure_protocolIEs__item_,
        _UEContextSetupFailure_protocolIEs,
        UEContextSetupFailure,
        UEContextSetupFailureIEs,
        _UEContextSetupFailureIEs_val_Value_0,
        _UEContextSetupFailureIEs_val_Value_1,
        _UEContextSetupFailureIEs_val_Value_2,
        _UEContextSetupFailureIEs_val_Value_3,
        _UEContextSetupFailureIEs_val_Value_4,
        _UEContextSetupFailureIEs_val_Value_5,
        ___Potential_SpCell_List__item__id_tab,
        ____Potential_SpCell_List__item__id_tab_val_Value_0,
        __Potential_SpCell_List__item__id,
        __Potential_SpCell_List__item__criticality,
        __Potential_SpCell_List__item__value,
        _Potential_SpCell_List__item_,
        Potential_SpCell_List,
        Potential_SpCell_ItemIEs,
        _Potential_SpCell_ItemIEs_val_Value_0,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequestIEs,
        _UEContextReleaseRequestIEs_val_Value_0,
        _UEContextReleaseRequestIEs_val_Value_1,
        _UEContextReleaseRequestIEs_val_Value_2,
        _UEContextReleaseRequestIEs_val_Value_3,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommandIEs,
        _UEContextReleaseCommandIEs_val_Value_0,
        _UEContextReleaseCommandIEs_val_Value_1,
        _UEContextReleaseCommandIEs_val_Value_2,
        _UEContextReleaseCommandIEs_val_Value_3,
        _UEContextReleaseCommandIEs_val_Value_4,
        _UEContextReleaseCommandIEs_val_Value_5,
        _UEContextReleaseCommandIEs_val_Value_6,
        _UEContextReleaseCommandIEs_val_Value_7,
        _UEContextReleaseCommandIEs_val_Value_8,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseCompleteIEs,
        _UEContextReleaseCompleteIEs_val_Value_0,
        _UEContextReleaseCompleteIEs_val_Value_1,
        _UEContextReleaseCompleteIEs_val_Value_2,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        _UEContextModificationRequestIEs_val_Value_22,
        _UEContextModificationRequestIEs_val_Value_23,
        _UEContextModificationRequestIEs_val_Value_24,
        _UEContextModificationRequestIEs_val_Value_25,
        _UEContextModificationRequestIEs_val_Value_26,
        _UEContextModificationRequestIEs_val_Value_27,
        _UEContextModificationRequestIEs_val_Value_28,
        _UEContextModificationRequestIEs_val_Value_29,
        _UEContextModificationRequestIEs_val_Value_30,
        _UEContextModificationRequestIEs_val_Value_31,
        _UEContextModificationRequestIEs_val_Value_32,
        _UEContextModificationRequestIEs_val_Value_33,
        _UEContextModificationRequestIEs_val_Value_34,
        _UEContextModificationRequestIEs_val_Value_35,
        _UEContextModificationRequestIEs_val_Value_36,
        _UEContextModificationRequestIEs_val_Value_37,
        _UEContextModificationRequestIEs_val_Value_38,
        _UEContextModificationRequestIEs_val_Value_39,
        _UEContextModificationRequestIEs_val_Value_40,
        _UEContextModificationRequestIEs_val_Value_41,
        _UEContextModificationRequestIEs_val_Value_42,
        _UEContextModificationRequestIEs_val_Value_43,
        _UEContextModificationRequestIEs_val_Value_44,
        _UEContextModificationRequestIEs_val_Value_45,
        _UEContextModificationRequestIEs_val_Value_46,
        ___SCell_ToBeSetupMod_List__item__id_tab,
        ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SCell_ToBeSetupMod_List__item__id,
        __SCell_ToBeSetupMod_List__item__criticality,
        __SCell_ToBeSetupMod_List__item__value,
        _SCell_ToBeSetupMod_List__item_,
        SCell_ToBeSetupMod_List,
        ___SCell_ToBeRemoved_List__item__id_tab,
        ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0,
        __SCell_ToBeRemoved_List__item__id,
        __SCell_ToBeRemoved_List__item__criticality,
        __SCell_ToBeRemoved_List__item__value,
        _SCell_ToBeRemoved_List__item_,
        SCell_ToBeRemoved_List,
        ___SRBs_ToBeSetupMod_List__item__id_tab,
        ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SRBs_ToBeSetupMod_List__item__id,
        __SRBs_ToBeSetupMod_List__item__criticality,
        __SRBs_ToBeSetupMod_List__item__value,
        _SRBs_ToBeSetupMod_List__item_,
        SRBs_ToBeSetupMod_List,
        ___DRBs_ToBeSetupMod_List__item__id_tab,
        ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __DRBs_ToBeSetupMod_List__item__id,
        __DRBs_ToBeSetupMod_List__item__criticality,
        __DRBs_ToBeSetupMod_List__item__value,
        _DRBs_ToBeSetupMod_List__item_,
        DRBs_ToBeSetupMod_List,
        ___BHChannels_ToBeSetupMod_List__item__id_tab,
        ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeSetupMod_List__item__id,
        __BHChannels_ToBeSetupMod_List__item__criticality,
        __BHChannels_ToBeSetupMod_List__item__value,
        _BHChannels_ToBeSetupMod_List__item_,
        BHChannels_ToBeSetupMod_List,
        ___DRBs_ToBeModified_List__item__id_tab,
        ____DRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_ToBeModified_List__item__id,
        __DRBs_ToBeModified_List__item__criticality,
        __DRBs_ToBeModified_List__item__value,
        _DRBs_ToBeModified_List__item_,
        DRBs_ToBeModified_List,
        ___BHChannels_ToBeModified_List__item__id_tab,
        ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeModified_List__item__id,
        __BHChannels_ToBeModified_List__item__criticality,
        __BHChannels_ToBeModified_List__item__value,
        _BHChannels_ToBeModified_List__item_,
        BHChannels_ToBeModified_List,
        ___SRBs_ToBeReleased_List__item__id_tab,
        ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __SRBs_ToBeReleased_List__item__id,
        __SRBs_ToBeReleased_List__item__criticality,
        __SRBs_ToBeReleased_List__item__value,
        _SRBs_ToBeReleased_List__item_,
        SRBs_ToBeReleased_List,
        ___DRBs_ToBeReleased_List__item__id_tab,
        ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __DRBs_ToBeReleased_List__item__id,
        __DRBs_ToBeReleased_List__item__criticality,
        __DRBs_ToBeReleased_List__item__value,
        _DRBs_ToBeReleased_List__item_,
        DRBs_ToBeReleased_List,
        ___BHChannels_ToBeReleased_List__item__id_tab,
        ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeReleased_List__item__id,
        __BHChannels_ToBeReleased_List__item__criticality,
        __BHChannels_ToBeReleased_List__item__value,
        _BHChannels_ToBeReleased_List__item_,
        BHChannels_ToBeReleased_List,
        SCell_ToBeSetupMod_ItemIEs,
        _SCell_ToBeSetupMod_ItemIEs_val_Value_0,
        SCell_ToBeRemoved_ItemIEs,
        _SCell_ToBeRemoved_ItemIEs_val_Value_0,
        SRBs_ToBeSetupMod_ItemIEs,
        _SRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_ToBeSetupMod_ItemIEs,
        _DRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_ToBeModified_ItemIEs,
        _DRBs_ToBeModified_ItemIEs_val_Value_0,
        SRBs_ToBeReleased_ItemIEs,
        _SRBs_ToBeReleased_ItemIEs_val_Value_0,
        DRBs_ToBeReleased_ItemIEs,
        _DRBs_ToBeReleased_ItemIEs_val_Value_0,
        BHChannels_ToBeSetupMod_ItemIEs,
        _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0,
        BHChannels_ToBeModified_ItemIEs,
        _BHChannels_ToBeModified_ItemIEs_val_Value_0,
        BHChannels_ToBeReleased_ItemIEs,
        _BHChannels_ToBeReleased_ItemIEs_val_Value_0,
        ___SLDRBs_ToBeSetupMod_List__item__id_tab,
        ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeSetupMod_List__item__id,
        __SLDRBs_ToBeSetupMod_List__item__criticality,
        __SLDRBs_ToBeSetupMod_List__item__value,
        _SLDRBs_ToBeSetupMod_List__item_,
        SLDRBs_ToBeSetupMod_List,
        ___SLDRBs_ToBeModified_List__item__id_tab,
        ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeModified_List__item__id,
        __SLDRBs_ToBeModified_List__item__criticality,
        __SLDRBs_ToBeModified_List__item__value,
        _SLDRBs_ToBeModified_List__item_,
        SLDRBs_ToBeModified_List,
        ___SLDRBs_ToBeReleased_List__item__id_tab,
        ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeReleased_List__item__id,
        __SLDRBs_ToBeReleased_List__item__criticality,
        __SLDRBs_ToBeReleased_List__item__value,
        _SLDRBs_ToBeReleased_List__item_,
        SLDRBs_ToBeReleased_List,
        SLDRBs_ToBeSetupMod_ItemIEs,
        _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        SLDRBs_ToBeModified_ItemIEs,
        _SLDRBs_ToBeModified_ItemIEs_val_Value_0,
        SLDRBs_ToBeReleased_ItemIEs,
        _SLDRBs_ToBeReleased_ItemIEs_val_Value_0,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        _UEContextModificationResponseIEs_val_Value_3,
        _UEContextModificationResponseIEs_val_Value_4,
        _UEContextModificationResponseIEs_val_Value_5,
        _UEContextModificationResponseIEs_val_Value_6,
        _UEContextModificationResponseIEs_val_Value_7,
        _UEContextModificationResponseIEs_val_Value_8,
        _UEContextModificationResponseIEs_val_Value_9,
        _UEContextModificationResponseIEs_val_Value_10,
        _UEContextModificationResponseIEs_val_Value_11,
        _UEContextModificationResponseIEs_val_Value_12,
        _UEContextModificationResponseIEs_val_Value_13,
        _UEContextModificationResponseIEs_val_Value_14,
        _UEContextModificationResponseIEs_val_Value_15,
        _UEContextModificationResponseIEs_val_Value_16,
        _UEContextModificationResponseIEs_val_Value_17,
        _UEContextModificationResponseIEs_val_Value_18,
        _UEContextModificationResponseIEs_val_Value_19,
        _UEContextModificationResponseIEs_val_Value_20,
        _UEContextModificationResponseIEs_val_Value_21,
        _UEContextModificationResponseIEs_val_Value_22,
        _UEContextModificationResponseIEs_val_Value_23,
        _UEContextModificationResponseIEs_val_Value_24,
        _UEContextModificationResponseIEs_val_Value_25,
        ___DRBs_SetupMod_List__item__id_tab,
        ____DRBs_SetupMod_List__item__id_tab_val_Value_0,
        __DRBs_SetupMod_List__item__id,
        __DRBs_SetupMod_List__item__criticality,
        __DRBs_SetupMod_List__item__value,
        _DRBs_SetupMod_List__item_,
        DRBs_SetupMod_List,
        ___DRBs_Modified_List__item__id_tab,
        ____DRBs_Modified_List__item__id_tab_val_Value_0,
        __DRBs_Modified_List__item__id,
        __DRBs_Modified_List__item__criticality,
        __DRBs_Modified_List__item__value,
        _DRBs_Modified_List__item_,
        DRBs_Modified_List,
        ___SRBs_SetupMod_List__item__id_tab,
        ____SRBs_SetupMod_List__item__id_tab_val_Value_0,
        __SRBs_SetupMod_List__item__id,
        __SRBs_SetupMod_List__item__criticality,
        __SRBs_SetupMod_List__item__value,
        _SRBs_SetupMod_List__item_,
        SRBs_SetupMod_List,
        ___SRBs_Modified_List__item__id_tab,
        ____SRBs_Modified_List__item__id_tab_val_Value_0,
        __SRBs_Modified_List__item__id,
        __SRBs_Modified_List__item__criticality,
        __SRBs_Modified_List__item__value,
        _SRBs_Modified_List__item_,
        SRBs_Modified_List,
        ___DRBs_FailedToBeModified_List__item__id_tab,
        ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeModified_List__item__id,
        __DRBs_FailedToBeModified_List__item__criticality,
        __DRBs_FailedToBeModified_List__item__value,
        _DRBs_FailedToBeModified_List__item_,
        DRBs_FailedToBeModified_List,
        ___SRBs_FailedToBeSetupMod_List__item__id_tab,
        ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __SRBs_FailedToBeSetupMod_List__item__id,
        __SRBs_FailedToBeSetupMod_List__item__criticality,
        __SRBs_FailedToBeSetupMod_List__item__value,
        _SRBs_FailedToBeSetupMod_List__item_,
        SRBs_FailedToBeSetupMod_List,
        ___DRBs_FailedToBeSetupMod_List__item__id_tab,
        ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeSetupMod_List__item__id,
        __DRBs_FailedToBeSetupMod_List__item__criticality,
        __DRBs_FailedToBeSetupMod_List__item__value,
        _DRBs_FailedToBeSetupMod_List__item_,
        DRBs_FailedToBeSetupMod_List,
        ___SCell_FailedtoSetupMod_List__item__id_tab,
        ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0,
        __SCell_FailedtoSetupMod_List__item__id,
        __SCell_FailedtoSetupMod_List__item__criticality,
        __SCell_FailedtoSetupMod_List__item__value,
        _SCell_FailedtoSetupMod_List__item_,
        SCell_FailedtoSetupMod_List,
        ___BHChannels_SetupMod_List__item__id_tab,
        ____BHChannels_SetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_SetupMod_List__item__id,
        __BHChannels_SetupMod_List__item__criticality,
        __BHChannels_SetupMod_List__item__value,
        _BHChannels_SetupMod_List__item_,
        BHChannels_SetupMod_List,
        ___BHChannels_Modified_List__item__id_tab,
        ____BHChannels_Modified_List__item__id_tab_val_Value_0,
        __BHChannels_Modified_List__item__id,
        __BHChannels_Modified_List__item__criticality,
        __BHChannels_Modified_List__item__value,
        _BHChannels_Modified_List__item_,
        BHChannels_Modified_List,
        ___BHChannels_FailedToBeModified_List__item__id_tab,
        ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeModified_List__item__id,
        __BHChannels_FailedToBeModified_List__item__criticality,
        __BHChannels_FailedToBeModified_List__item__value,
        _BHChannels_FailedToBeModified_List__item_,
        BHChannels_FailedToBeModified_List,
        ___BHChannels_FailedToBeSetupMod_List__item__id_tab,
        ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeSetupMod_List__item__id,
        __BHChannels_FailedToBeSetupMod_List__item__criticality,
        __BHChannels_FailedToBeSetupMod_List__item__value,
        _BHChannels_FailedToBeSetupMod_List__item_,
        BHChannels_FailedToBeSetupMod_List,
        ___Associated_SCell_List__item__id_tab,
        ____Associated_SCell_List__item__id_tab_val_Value_0,
        __Associated_SCell_List__item__id,
        __Associated_SCell_List__item__criticality,
        __Associated_SCell_List__item__value,
        _Associated_SCell_List__item_,
        Associated_SCell_List,
        DRBs_SetupMod_ItemIEs,
        _DRBs_SetupMod_ItemIEs_val_Value_0,
        DRBs_Modified_ItemIEs,
        _DRBs_Modified_ItemIEs_val_Value_0,
        SRBs_SetupMod_ItemIEs,
        _SRBs_SetupMod_ItemIEs_val_Value_0,
        SRBs_Modified_ItemIEs,
        _SRBs_Modified_ItemIEs_val_Value_0,
        SRBs_FailedToBeSetupMod_ItemIEs,
        _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_FailedToBeSetupMod_ItemIEs,
        _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_FailedToBeModified_ItemIEs,
        _DRBs_FailedToBeModified_ItemIEs_val_Value_0,
        SCell_FailedtoSetupMod_ItemIEs,
        _SCell_FailedtoSetupMod_ItemIEs_val_Value_0,
        Associated_SCell_ItemIEs,
        _Associated_SCell_ItemIEs_val_Value_0,
        BHChannels_SetupMod_ItemIEs,
        _BHChannels_SetupMod_ItemIEs_val_Value_0,
        BHChannels_Modified_ItemIEs,
        _BHChannels_Modified_ItemIEs_val_Value_0,
        BHChannels_FailedToBeSetupMod_ItemIEs,
        _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0,
        BHChannels_FailedToBeModified_ItemIEs,
        _BHChannels_FailedToBeModified_ItemIEs_val_Value_0,
        ___SLDRBs_SetupMod_List__item__id_tab,
        ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_SetupMod_List__item__id,
        __SLDRBs_SetupMod_List__item__criticality,
        __SLDRBs_SetupMod_List__item__value,
        _SLDRBs_SetupMod_List__item_,
        SLDRBs_SetupMod_List,
        ___SLDRBs_Modified_List__item__id_tab,
        ____SLDRBs_Modified_List__item__id_tab_val_Value_0,
        __SLDRBs_Modified_List__item__id,
        __SLDRBs_Modified_List__item__criticality,
        __SLDRBs_Modified_List__item__value,
        _SLDRBs_Modified_List__item_,
        SLDRBs_Modified_List,
        ___SLDRBs_FailedToBeModified_List__item__id_tab,
        ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeModified_List__item__id,
        __SLDRBs_FailedToBeModified_List__item__criticality,
        __SLDRBs_FailedToBeModified_List__item__value,
        _SLDRBs_FailedToBeModified_List__item_,
        SLDRBs_FailedToBeModified_List,
        ___SLDRBs_FailedToBeSetupMod_List__item__id_tab,
        ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeSetupMod_List__item__id,
        __SLDRBs_FailedToBeSetupMod_List__item__criticality,
        __SLDRBs_FailedToBeSetupMod_List__item__value,
        _SLDRBs_FailedToBeSetupMod_List__item_,
        SLDRBs_FailedToBeSetupMod_List,
        SLDRBs_SetupMod_ItemIEs,
        _SLDRBs_SetupMod_ItemIEs_val_Value_0,
        SLDRBs_Modified_ItemIEs,
        _SLDRBs_Modified_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeSetupMod_ItemIEs,
        _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeModified_ItemIEs,
        _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        _UEContextModificationFailureIEs_val_Value_4,
        ____UEContextModificationRequired_protocolIEs__item__id_tab,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11,
        ___UEContextModificationRequired_protocolIEs__item__id,
        ___UEContextModificationRequired_protocolIEs__item__criticality,
        ___UEContextModificationRequired_protocolIEs__item__value,
        __UEContextModificationRequired_protocolIEs__item_,
        _UEContextModificationRequired_protocolIEs,
        UEContextModificationRequired,
        UEContextModificationRequiredIEs,
        _UEContextModificationRequiredIEs_val_Value_0,
        _UEContextModificationRequiredIEs_val_Value_1,
        _UEContextModificationRequiredIEs_val_Value_2,
        _UEContextModificationRequiredIEs_val_Value_3,
        _UEContextModificationRequiredIEs_val_Value_4,
        _UEContextModificationRequiredIEs_val_Value_5,
        _UEContextModificationRequiredIEs_val_Value_6,
        _UEContextModificationRequiredIEs_val_Value_7,
        _UEContextModificationRequiredIEs_val_Value_8,
        _UEContextModificationRequiredIEs_val_Value_9,
        _UEContextModificationRequiredIEs_val_Value_10,
        _UEContextModificationRequiredIEs_val_Value_11,
        ___DRBs_Required_ToBeModified_List__item__id_tab,
        ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_Required_ToBeModified_List__item__id,
        __DRBs_Required_ToBeModified_List__item__criticality,
        __DRBs_Required_ToBeModified_List__item__value,
        _DRBs_Required_ToBeModified_List__item_,
        DRBs_Required_ToBeModified_List,
        ___DRBs_Required_ToBeReleased_List__item__id_tab,
        ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __DRBs_Required_ToBeReleased_List__item__id,
        __DRBs_Required_ToBeReleased_List__item__criticality,
        __DRBs_Required_ToBeReleased_List__item__value,
        _DRBs_Required_ToBeReleased_List__item_,
        DRBs_Required_ToBeReleased_List,
        ___SRBs_Required_ToBeReleased_List__item__id_tab,
        ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __SRBs_Required_ToBeReleased_List__item__id,
        __SRBs_Required_ToBeReleased_List__item__criticality,
        __SRBs_Required_ToBeReleased_List__item__value,
        _SRBs_Required_ToBeReleased_List__item_,
        SRBs_Required_ToBeReleased_List,
        ___BHChannels_Required_ToBeReleased_List__item__id_tab,
        ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __BHChannels_Required_ToBeReleased_List__item__id,
        __BHChannels_Required_ToBeReleased_List__item__criticality,
        __BHChannels_Required_ToBeReleased_List__item__value,
        _BHChannels_Required_ToBeReleased_List__item_,
        BHChannels_Required_ToBeReleased_List,
        DRBs_Required_ToBeModified_ItemIEs,
        _DRBs_Required_ToBeModified_ItemIEs_val_Value_0,
        DRBs_Required_ToBeReleased_ItemIEs,
        _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        SRBs_Required_ToBeReleased_ItemIEs,
        _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        BHChannels_Required_ToBeReleased_ItemIEs,
        _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0,
        ___SLDRBs_Required_ToBeModified_List__item__id_tab,
        ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_Required_ToBeModified_List__item__id,
        __SLDRBs_Required_ToBeModified_List__item__criticality,
        __SLDRBs_Required_ToBeModified_List__item__value,
        _SLDRBs_Required_ToBeModified_List__item_,
        SLDRBs_Required_ToBeModified_List,
        ___SLDRBs_Required_ToBeReleased_List__item__id_tab,
        ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __SLDRBs_Required_ToBeReleased_List__item__id,
        __SLDRBs_Required_ToBeReleased_List__item__criticality,
        __SLDRBs_Required_ToBeReleased_List__item__value,
        _SLDRBs_Required_ToBeReleased_List__item_,
        SLDRBs_Required_ToBeReleased_List,
        SLDRBs_Required_ToBeModified_ItemIEs,
        _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0,
        SLDRBs_Required_ToBeReleased_ItemIEs,
        _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        ____UEContextModificationConfirm_protocolIEs__item__id_tab,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8,
        ___UEContextModificationConfirm_protocolIEs__item__id,
        ___UEContextModificationConfirm_protocolIEs__item__criticality,
        ___UEContextModificationConfirm_protocolIEs__item__value,
        __UEContextModificationConfirm_protocolIEs__item_,
        _UEContextModificationConfirm_protocolIEs,
        UEContextModificationConfirm,
        UEContextModificationConfirmIEs,
        _UEContextModificationConfirmIEs_val_Value_0,
        _UEContextModificationConfirmIEs_val_Value_1,
        _UEContextModificationConfirmIEs_val_Value_2,
        _UEContextModificationConfirmIEs_val_Value_3,
        _UEContextModificationConfirmIEs_val_Value_4,
        _UEContextModificationConfirmIEs_val_Value_5,
        _UEContextModificationConfirmIEs_val_Value_6,
        _UEContextModificationConfirmIEs_val_Value_7,
        _UEContextModificationConfirmIEs_val_Value_8,
        ___DRBs_ModifiedConf_List__item__id_tab,
        ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0,
        __DRBs_ModifiedConf_List__item__id,
        __DRBs_ModifiedConf_List__item__criticality,
        __DRBs_ModifiedConf_List__item__value,
        _DRBs_ModifiedConf_List__item_,
        DRBs_ModifiedConf_List,
        DRBs_ModifiedConf_ItemIEs,
        _DRBs_ModifiedConf_ItemIEs_val_Value_0,
        ___SLDRBs_ModifiedConf_List__item__id_tab,
        ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0,
        __SLDRBs_ModifiedConf_List__item__id,
        __SLDRBs_ModifiedConf_List__item__criticality,
        __SLDRBs_ModifiedConf_List__item__value,
        _SLDRBs_ModifiedConf_List__item_,
        SLDRBs_ModifiedConf_List,
        SLDRBs_ModifiedConf_ItemIEs,
        _SLDRBs_ModifiedConf_ItemIEs_val_Value_0,
        ____UEContextModificationRefuse_protocolIEs__item__id_tab,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationRefuse_protocolIEs__item__id,
        ___UEContextModificationRefuse_protocolIEs__item__criticality,
        ___UEContextModificationRefuse_protocolIEs__item__value,
        __UEContextModificationRefuse_protocolIEs__item_,
        _UEContextModificationRefuse_protocolIEs,
        UEContextModificationRefuse,
        UEContextModificationRefuseIEs,
        _UEContextModificationRefuseIEs_val_Value_0,
        _UEContextModificationRefuseIEs_val_Value_1,
        _UEContextModificationRefuseIEs_val_Value_2,
        _UEContextModificationRefuseIEs_val_Value_3,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        ___Cells_To_Be_Broadcast_List__item__id_tab,
        ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0,
        __Cells_To_Be_Broadcast_List__item__id,
        __Cells_To_Be_Broadcast_List__item__criticality,
        __Cells_To_Be_Broadcast_List__item__value,
        _Cells_To_Be_Broadcast_List__item_,
        Cells_To_Be_Broadcast_List,
        Cells_To_Be_Broadcast_List_ItemIEs,
        _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ___Cells_Broadcast_Completed_List__item__id_tab,
        ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0,
        __Cells_Broadcast_Completed_List__item__id,
        __Cells_Broadcast_Completed_List__item__criticality,
        __Cells_Broadcast_Completed_List__item__value,
        _Cells_Broadcast_Completed_List__item_,
        Cells_Broadcast_Completed_List,
        Cells_Broadcast_Completed_List_ItemIEs,
        _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0,
        ____PWSCancelRequest_protocolIEs__item__id_tab,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4,
        ___PWSCancelRequest_protocolIEs__item__id,
        ___PWSCancelRequest_protocolIEs__item__criticality,
        ___PWSCancelRequest_protocolIEs__item__value,
        __PWSCancelRequest_protocolIEs__item_,
        _PWSCancelRequest_protocolIEs,
        PWSCancelRequest,
        PWSCancelRequestIEs,
        _PWSCancelRequestIEs_val_Value_0,
        _PWSCancelRequestIEs_val_Value_1,
        _PWSCancelRequestIEs_val_Value_2,
        _PWSCancelRequestIEs_val_Value_3,
        _PWSCancelRequestIEs_val_Value_4,
        ___Broadcast_To_Be_Cancelled_List__item__id_tab,
        ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0,
        __Broadcast_To_Be_Cancelled_List__item__id,
        __Broadcast_To_Be_Cancelled_List__item__criticality,
        __Broadcast_To_Be_Cancelled_List__item__value,
        _Broadcast_To_Be_Cancelled_List__item_,
        Broadcast_To_Be_Cancelled_List,
        Broadcast_To_Be_Cancelled_List_ItemIEs,
        _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0,
        ____PWSCancelResponse_protocolIEs__item__id_tab,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PWSCancelResponse_protocolIEs__item__id,
        ___PWSCancelResponse_protocolIEs__item__criticality,
        ___PWSCancelResponse_protocolIEs__item__value,
        __PWSCancelResponse_protocolIEs__item_,
        _PWSCancelResponse_protocolIEs,
        PWSCancelResponse,
        PWSCancelResponseIEs,
        _PWSCancelResponseIEs_val_Value_0,
        _PWSCancelResponseIEs_val_Value_1,
        _PWSCancelResponseIEs_val_Value_2,
        ___Cells_Broadcast_Cancelled_List__item__id_tab,
        ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0,
        __Cells_Broadcast_Cancelled_List__item__id,
        __Cells_Broadcast_Cancelled_List__item__criticality,
        __Cells_Broadcast_Cancelled_List__item__value,
        _Cells_Broadcast_Cancelled_List__item_,
        Cells_Broadcast_Cancelled_List,
        Cells_Broadcast_Cancelled_List_ItemIEs,
        _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0,
        ____UEInactivityNotification_protocolIEs__item__id_tab,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2,
        ___UEInactivityNotification_protocolIEs__item__id,
        ___UEInactivityNotification_protocolIEs__item__criticality,
        ___UEInactivityNotification_protocolIEs__item__value,
        __UEInactivityNotification_protocolIEs__item_,
        _UEInactivityNotification_protocolIEs,
        UEInactivityNotification,
        UEInactivityNotificationIEs,
        _UEInactivityNotificationIEs_val_Value_0,
        _UEInactivityNotificationIEs_val_Value_1,
        _UEInactivityNotificationIEs_val_Value_2,
        ___DRB_Activity_List__item__id_tab,
        ____DRB_Activity_List__item__id_tab_val_Value_0,
        __DRB_Activity_List__item__id,
        __DRB_Activity_List__item__criticality,
        __DRB_Activity_List__item__value,
        _DRB_Activity_List__item_,
        DRB_Activity_List,
        DRB_Activity_ItemIEs,
        _DRB_Activity_ItemIEs_val_Value_0,
        ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8,
        ___InitialULRRCMessageTransfer_protocolIEs__item__id,
        ___InitialULRRCMessageTransfer_protocolIEs__item__criticality,
        ___InitialULRRCMessageTransfer_protocolIEs__item__value,
        __InitialULRRCMessageTransfer_protocolIEs__item_,
        _InitialULRRCMessageTransfer_protocolIEs,
        InitialULRRCMessageTransfer,
        InitialULRRCMessageTransferIEs,
        _InitialULRRCMessageTransferIEs_val_Value_0,
        _InitialULRRCMessageTransferIEs_val_Value_1,
        _InitialULRRCMessageTransferIEs_val_Value_2,
        _InitialULRRCMessageTransferIEs_val_Value_3,
        _InitialULRRCMessageTransferIEs_val_Value_4,
        _InitialULRRCMessageTransferIEs_val_Value_5,
        _InitialULRRCMessageTransferIEs_val_Value_6,
        _InitialULRRCMessageTransferIEs_val_Value_7,
        _InitialULRRCMessageTransferIEs_val_Value_8,
        ____DLRRCMessageTransfer_protocolIEs__item__id_tab,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12,
        ___DLRRCMessageTransfer_protocolIEs__item__id,
        ___DLRRCMessageTransfer_protocolIEs__item__criticality,
        ___DLRRCMessageTransfer_protocolIEs__item__value,
        __DLRRCMessageTransfer_protocolIEs__item_,
        _DLRRCMessageTransfer_protocolIEs,
        DLRRCMessageTransfer,
        DLRRCMessageTransferIEs,
        _DLRRCMessageTransferIEs_val_Value_0,
        _DLRRCMessageTransferIEs_val_Value_1,
        _DLRRCMessageTransferIEs_val_Value_2,
        _DLRRCMessageTransferIEs_val_Value_3,
        _DLRRCMessageTransferIEs_val_Value_4,
        _DLRRCMessageTransferIEs_val_Value_5,
        _DLRRCMessageTransferIEs_val_Value_6,
        _DLRRCMessageTransferIEs_val_Value_7,
        _DLRRCMessageTransferIEs_val_Value_8,
        _DLRRCMessageTransferIEs_val_Value_9,
        _DLRRCMessageTransferIEs_val_Value_10,
        _DLRRCMessageTransferIEs_val_Value_11,
        _DLRRCMessageTransferIEs_val_Value_12,
        ____ULRRCMessageTransfer_protocolIEs__item__id_tab,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___ULRRCMessageTransfer_protocolIEs__item__id,
        ___ULRRCMessageTransfer_protocolIEs__item__criticality,
        ___ULRRCMessageTransfer_protocolIEs__item__value,
        __ULRRCMessageTransfer_protocolIEs__item_,
        _ULRRCMessageTransfer_protocolIEs,
        ULRRCMessageTransfer,
        ULRRCMessageTransferIEs,
        _ULRRCMessageTransferIEs_val_Value_0,
        _ULRRCMessageTransferIEs_val_Value_1,
        _ULRRCMessageTransferIEs_val_Value_2,
        _ULRRCMessageTransferIEs_val_Value_3,
        _ULRRCMessageTransferIEs_val_Value_4,
        _ULRRCMessageTransferIEs_val_Value_5,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3,
        ___SystemInformationDeliveryCommand_protocolIEs__item__id,
        ___SystemInformationDeliveryCommand_protocolIEs__item__criticality,
        ___SystemInformationDeliveryCommand_protocolIEs__item__value,
        __SystemInformationDeliveryCommand_protocolIEs__item_,
        _SystemInformationDeliveryCommand_protocolIEs,
        SystemInformationDeliveryCommand,
        SystemInformationDeliveryCommandIEs,
        _SystemInformationDeliveryCommandIEs_val_Value_0,
        _SystemInformationDeliveryCommandIEs_val_Value_1,
        _SystemInformationDeliveryCommandIEs_val_Value_2,
        _SystemInformationDeliveryCommandIEs_val_Value_3,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        ___PagingCell_list__item__id_tab,
        ____PagingCell_list__item__id_tab_val_Value_0,
        __PagingCell_list__item__id,
        __PagingCell_list__item__criticality,
        __PagingCell_list__item__value,
        _PagingCell_list__item_,
        PagingCell_list,
        PagingCell_ItemIEs,
        _PagingCell_ItemIEs_val_Value_0,
        ____Notify_protocolIEs__item__id_tab,
        _____Notify_protocolIEs__item__id_tab_val_Value_0,
        _____Notify_protocolIEs__item__id_tab_val_Value_1,
        _____Notify_protocolIEs__item__id_tab_val_Value_2,
        ___Notify_protocolIEs__item__id,
        ___Notify_protocolIEs__item__criticality,
        ___Notify_protocolIEs__item__value,
        __Notify_protocolIEs__item_,
        _Notify_protocolIEs,
        Notify,
        NotifyIEs,
        _NotifyIEs_val_Value_0,
        _NotifyIEs_val_Value_1,
        _NotifyIEs_val_Value_2,
        ___DRB_Notify_List__item__id_tab,
        ____DRB_Notify_List__item__id_tab_val_Value_0,
        __DRB_Notify_List__item__id,
        __DRB_Notify_List__item__criticality,
        __DRB_Notify_List__item__value,
        _DRB_Notify_List__item_,
        DRB_Notify_List,
        DRB_Notify_ItemIEs,
        _DRB_Notify_ItemIEs_val_Value_0,
        ____NetworkAccessRateReduction_protocolIEs__item__id_tab,
        _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0,
        _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1,
        ___NetworkAccessRateReduction_protocolIEs__item__id,
        ___NetworkAccessRateReduction_protocolIEs__item__criticality,
        ___NetworkAccessRateReduction_protocolIEs__item__value,
        __NetworkAccessRateReduction_protocolIEs__item_,
        _NetworkAccessRateReduction_protocolIEs,
        NetworkAccessRateReduction,
        NetworkAccessRateReductionIEs,
        _NetworkAccessRateReductionIEs_val_Value_0,
        _NetworkAccessRateReductionIEs_val_Value_1,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        ___NR_CGI_List_For_Restart_List__item__id_tab,
        ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0,
        __NR_CGI_List_For_Restart_List__item__id,
        __NR_CGI_List_For_Restart_List__item__criticality,
        __NR_CGI_List_For_Restart_List__item__value,
        _NR_CGI_List_For_Restart_List__item_,
        NR_CGI_List_For_Restart_List,
        NR_CGI_List_For_Restart_List_ItemIEs,
        _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ___PWS_Failed_NR_CGI_List__item__id_tab,
        ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0,
        __PWS_Failed_NR_CGI_List__item__id,
        __PWS_Failed_NR_CGI_List__item__criticality,
        __PWS_Failed_NR_CGI_List__item__value,
        _PWS_Failed_NR_CGI_List__item_,
        PWS_Failed_NR_CGI_List,
        PWS_Failed_NR_CGI_List_ItemIEs,
        _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0,
        ____GNBDUStatusIndication_protocolIEs__item__id_tab,
        _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1,
        ___GNBDUStatusIndication_protocolIEs__item__id,
        ___GNBDUStatusIndication_protocolIEs__item__criticality,
        ___GNBDUStatusIndication_protocolIEs__item__value,
        __GNBDUStatusIndication_protocolIEs__item_,
        _GNBDUStatusIndication_protocolIEs,
        GNBDUStatusIndication,
        GNBDUStatusIndicationIEs,
        _GNBDUStatusIndicationIEs_val_Value_0,
        _GNBDUStatusIndicationIEs_val_Value_1,
        ____RRCDeliveryReport_protocolIEs__item__id_tab,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3,
        ___RRCDeliveryReport_protocolIEs__item__id,
        ___RRCDeliveryReport_protocolIEs__item__criticality,
        ___RRCDeliveryReport_protocolIEs__item__value,
        __RRCDeliveryReport_protocolIEs__item_,
        _RRCDeliveryReport_protocolIEs,
        RRCDeliveryReport,
        RRCDeliveryReportIEs,
        _RRCDeliveryReportIEs_val_Value_0,
        _RRCDeliveryReportIEs_val_Value_1,
        _RRCDeliveryReportIEs_val_Value_2,
        _RRCDeliveryReportIEs_val_Value_3,
        ____F1RemovalRequest_protocolIEs__item__id_tab,
        _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        ___F1RemovalRequest_protocolIEs__item__id,
        ___F1RemovalRequest_protocolIEs__item__criticality,
        ___F1RemovalRequest_protocolIEs__item__value,
        __F1RemovalRequest_protocolIEs__item_,
        _F1RemovalRequest_protocolIEs,
        F1RemovalRequest,
        F1RemovalRequestIEs,
        _F1RemovalRequestIEs_val_Value_0,
        ____F1RemovalResponse_protocolIEs__item__id_tab,
        _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___F1RemovalResponse_protocolIEs__item__id,
        ___F1RemovalResponse_protocolIEs__item__criticality,
        ___F1RemovalResponse_protocolIEs__item__value,
        __F1RemovalResponse_protocolIEs__item_,
        _F1RemovalResponse_protocolIEs,
        F1RemovalResponse,
        F1RemovalResponseIEs,
        _F1RemovalResponseIEs_val_Value_0,
        _F1RemovalResponseIEs_val_Value_1,
        ____F1RemovalFailure_protocolIEs__item__id_tab,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2,
        ___F1RemovalFailure_protocolIEs__item__id,
        ___F1RemovalFailure_protocolIEs__item__criticality,
        ___F1RemovalFailure_protocolIEs__item__value,
        __F1RemovalFailure_protocolIEs__item_,
        _F1RemovalFailure_protocolIEs,
        F1RemovalFailure,
        F1RemovalFailureIEs,
        _F1RemovalFailureIEs_val_Value_0,
        _F1RemovalFailureIEs_val_Value_1,
        _F1RemovalFailureIEs_val_Value_2,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____DUCURadioInformationTransfer_protocolIEs__item__id_tab,
        _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___DUCURadioInformationTransfer_protocolIEs__item__id,
        ___DUCURadioInformationTransfer_protocolIEs__item__criticality,
        ___DUCURadioInformationTransfer_protocolIEs__item__value,
        __DUCURadioInformationTransfer_protocolIEs__item_,
        _DUCURadioInformationTransfer_protocolIEs,
        DUCURadioInformationTransfer,
        DUCURadioInformationTransferIEs,
        _DUCURadioInformationTransferIEs_val_Value_0,
        _DUCURadioInformationTransferIEs_val_Value_1,
        ____CUDURadioInformationTransfer_protocolIEs__item__id_tab,
        _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___CUDURadioInformationTransfer_protocolIEs__item__id,
        ___CUDURadioInformationTransfer_protocolIEs__item__criticality,
        ___CUDURadioInformationTransfer_protocolIEs__item__value,
        __CUDURadioInformationTransfer_protocolIEs__item_,
        _CUDURadioInformationTransfer_protocolIEs,
        CUDURadioInformationTransfer,
        CUDURadioInformationTransferIEs,
        _CUDURadioInformationTransferIEs_val_Value_0,
        _CUDURadioInformationTransferIEs_val_Value_1,
        ____BAPMappingConfiguration_protocolIEs__item__id_tab,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3,
        ___BAPMappingConfiguration_protocolIEs__item__id,
        ___BAPMappingConfiguration_protocolIEs__item__criticality,
        ___BAPMappingConfiguration_protocolIEs__item__value,
        __BAPMappingConfiguration_protocolIEs__item_,
        _BAPMappingConfiguration_protocolIEs,
        BAPMappingConfiguration,
        BAPMappingConfiguration_IEs,
        _BAPMappingConfiguration_IEs_val_Value_0,
        _BAPMappingConfiguration_IEs_val_Value_1,
        _BAPMappingConfiguration_IEs_val_Value_2,
        _BAPMappingConfiguration_IEs_val_Value_3,
        ___BH_Routing_Information_Added_List__item__id_tab,
        ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0,
        __BH_Routing_Information_Added_List__item__id,
        __BH_Routing_Information_Added_List__item__criticality,
        __BH_Routing_Information_Added_List__item__value,
        _BH_Routing_Information_Added_List__item_,
        BH_Routing_Information_Added_List,
        ___BH_Routing_Information_Removed_List__item__id_tab,
        ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0,
        __BH_Routing_Information_Removed_List__item__id,
        __BH_Routing_Information_Removed_List__item__criticality,
        __BH_Routing_Information_Removed_List__item__value,
        _BH_Routing_Information_Removed_List__item_,
        BH_Routing_Information_Removed_List,
        BH_Routing_Information_Added_List_ItemIEs,
        _BH_Routing_Information_Added_List_ItemIEs_val_Value_0,
        BH_Routing_Information_Removed_List_ItemIEs,
        _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0,
        ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab,
        _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value,
        __BAPMappingConfigurationAcknowledge_protocolIEs__item_,
        _BAPMappingConfigurationAcknowledge_protocolIEs,
        BAPMappingConfigurationAcknowledge,
        BAPMappingConfigurationAcknowledge_IEs,
        _BAPMappingConfigurationAcknowledge_IEs_val_Value_0,
        _BAPMappingConfigurationAcknowledge_IEs_val_Value_1,
        ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BAPMappingConfigurationFailure_protocolIEs__item__id,
        ___BAPMappingConfigurationFailure_protocolIEs__item__criticality,
        ___BAPMappingConfigurationFailure_protocolIEs__item__value,
        __BAPMappingConfigurationFailure_protocolIEs__item_,
        _BAPMappingConfigurationFailure_protocolIEs,
        BAPMappingConfigurationFailure,
        BAPMappingConfigurationFailureIEs,
        _BAPMappingConfigurationFailureIEs_val_Value_0,
        _BAPMappingConfigurationFailureIEs_val_Value_1,
        _BAPMappingConfigurationFailureIEs_val_Value_2,
        _BAPMappingConfigurationFailureIEs_val_Value_3,
        ____GNBDUResourceConfiguration_protocolIEs__item__id_tab,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2,
        ___GNBDUResourceConfiguration_protocolIEs__item__id,
        ___GNBDUResourceConfiguration_protocolIEs__item__criticality,
        ___GNBDUResourceConfiguration_protocolIEs__item__value,
        __GNBDUResourceConfiguration_protocolIEs__item_,
        _GNBDUResourceConfiguration_protocolIEs,
        GNBDUResourceConfiguration,
        GNBDUResourceConfigurationIEs,
        _GNBDUResourceConfigurationIEs_val_Value_0,
        _GNBDUResourceConfigurationIEs_val_Value_1,
        _GNBDUResourceConfigurationIEs_val_Value_2,
        ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab,
        _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value,
        __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_,
        _GNBDUResourceConfigurationAcknowledge_protocolIEs,
        GNBDUResourceConfigurationAcknowledge,
        GNBDUResourceConfigurationAcknowledgeIEs,
        _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0,
        _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1,
        ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__id,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__value,
        __GNBDUResourceConfigurationFailure_protocolIEs__item_,
        _GNBDUResourceConfigurationFailure_protocolIEs,
        GNBDUResourceConfigurationFailure,
        GNBDUResourceConfigurationFailureIEs,
        _GNBDUResourceConfigurationFailureIEs_val_Value_0,
        _GNBDUResourceConfigurationFailureIEs_val_Value_1,
        _GNBDUResourceConfigurationFailureIEs_val_Value_2,
        _GNBDUResourceConfigurationFailureIEs_val_Value_3,
        ____IABTNLAddressRequest_protocolIEs__item__id_tab,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3,
        ___IABTNLAddressRequest_protocolIEs__item__id,
        ___IABTNLAddressRequest_protocolIEs__item__criticality,
        ___IABTNLAddressRequest_protocolIEs__item__value,
        __IABTNLAddressRequest_protocolIEs__item_,
        _IABTNLAddressRequest_protocolIEs,
        IABTNLAddressRequest,
        IABTNLAddressRequestIEs,
        _IABTNLAddressRequestIEs_val_Value_0,
        _IABTNLAddressRequestIEs_val_Value_1,
        _IABTNLAddressRequestIEs_val_Value_2,
        _IABTNLAddressRequestIEs_val_Value_3,
        ___IAB_TNL_Addresses_To_Remove_List__item__id_tab,
        ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0,
        __IAB_TNL_Addresses_To_Remove_List__item__id,
        __IAB_TNL_Addresses_To_Remove_List__item__criticality,
        __IAB_TNL_Addresses_To_Remove_List__item__value,
        _IAB_TNL_Addresses_To_Remove_List__item_,
        IAB_TNL_Addresses_To_Remove_List,
        IAB_TNL_Addresses_To_Remove_ItemIEs,
        _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0,
        ____IABTNLAddressResponse_protocolIEs__item__id_tab,
        _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1,
        ___IABTNLAddressResponse_protocolIEs__item__id,
        ___IABTNLAddressResponse_protocolIEs__item__criticality,
        ___IABTNLAddressResponse_protocolIEs__item__value,
        __IABTNLAddressResponse_protocolIEs__item_,
        _IABTNLAddressResponse_protocolIEs,
        IABTNLAddressResponse,
        IABTNLAddressResponseIEs,
        _IABTNLAddressResponseIEs_val_Value_0,
        _IABTNLAddressResponseIEs_val_Value_1,
        ___IAB_Allocated_TNL_Address_List__item__id_tab,
        ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0,
        __IAB_Allocated_TNL_Address_List__item__id,
        __IAB_Allocated_TNL_Address_List__item__criticality,
        __IAB_Allocated_TNL_Address_List__item__value,
        _IAB_Allocated_TNL_Address_List__item_,
        IAB_Allocated_TNL_Address_List,
        IAB_Allocated_TNL_Address_List_ItemIEs,
        _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0,
        ____IABTNLAddressFailure_protocolIEs__item__id_tab,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3,
        ___IABTNLAddressFailure_protocolIEs__item__id,
        ___IABTNLAddressFailure_protocolIEs__item__criticality,
        ___IABTNLAddressFailure_protocolIEs__item__value,
        __IABTNLAddressFailure_protocolIEs__item_,
        _IABTNLAddressFailure_protocolIEs,
        IABTNLAddressFailure,
        IABTNLAddressFailureIEs,
        _IABTNLAddressFailureIEs_val_Value_0,
        _IABTNLAddressFailureIEs_val_Value_1,
        _IABTNLAddressFailureIEs_val_Value_2,
        _IABTNLAddressFailureIEs_val_Value_3,
        ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__id,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__value,
        __IABUPConfigurationUpdateRequest_protocolIEs__item_,
        _IABUPConfigurationUpdateRequest_protocolIEs,
        IABUPConfigurationUpdateRequest,
        IABUPConfigurationUpdateRequestIEs,
        _IABUPConfigurationUpdateRequestIEs_val_Value_0,
        _IABUPConfigurationUpdateRequestIEs_val_Value_1,
        _IABUPConfigurationUpdateRequestIEs_val_Value_2,
        ___UL_UP_TNL_Information_to_Update_List__item__id_tab,
        ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0,
        __UL_UP_TNL_Information_to_Update_List__item__id,
        __UL_UP_TNL_Information_to_Update_List__item__criticality,
        __UL_UP_TNL_Information_to_Update_List__item__value,
        _UL_UP_TNL_Information_to_Update_List__item_,
        UL_UP_TNL_Information_to_Update_List,
        UL_UP_TNL_Information_to_Update_List_ItemIEs,
        _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0,
        ___UL_UP_TNL_Address_to_Update_List__item__id_tab,
        ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0,
        __UL_UP_TNL_Address_to_Update_List__item__id,
        __UL_UP_TNL_Address_to_Update_List__item__criticality,
        __UL_UP_TNL_Address_to_Update_List__item__value,
        _UL_UP_TNL_Address_to_Update_List__item_,
        UL_UP_TNL_Address_to_Update_List,
        UL_UP_TNL_Address_to_Update_List_ItemIEs,
        _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0,
        ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__id,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__value,
        __IABUPConfigurationUpdateResponse_protocolIEs__item_,
        _IABUPConfigurationUpdateResponse_protocolIEs,
        IABUPConfigurationUpdateResponse,
        IABUPConfigurationUpdateResponseIEs,
        _IABUPConfigurationUpdateResponseIEs_val_Value_0,
        _IABUPConfigurationUpdateResponseIEs_val_Value_1,
        _IABUPConfigurationUpdateResponseIEs_val_Value_2,
        ___DL_UP_TNL_Address_to_Update_List__item__id_tab,
        ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0,
        __DL_UP_TNL_Address_to_Update_List__item__id,
        __DL_UP_TNL_Address_to_Update_List__item__criticality,
        __DL_UP_TNL_Address_to_Update_List__item__value,
        _DL_UP_TNL_Address_to_Update_List__item_,
        DL_UP_TNL_Address_to_Update_List,
        DL_UP_TNL_Address_to_Update_List_ItemIEs,
        _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0,
        ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__id,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__value,
        __IABUPConfigurationUpdateFailure_protocolIEs__item_,
        _IABUPConfigurationUpdateFailure_protocolIEs,
        IABUPConfigurationUpdateFailure,
        IABUPConfigurationUpdateFailureIEs,
        _IABUPConfigurationUpdateFailureIEs_val_Value_0,
        _IABUPConfigurationUpdateFailureIEs_val_Value_1,
        _IABUPConfigurationUpdateFailureIEs_val_Value_2,
        _IABUPConfigurationUpdateFailureIEs_val_Value_3,
        ____ResourceStatusRequest_protocolIEs__item__id_tab,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        ___ResourceStatusRequest_protocolIEs__item__id,
        ___ResourceStatusRequest_protocolIEs__item__criticality,
        ___ResourceStatusRequest_protocolIEs__item__value,
        __ResourceStatusRequest_protocolIEs__item_,
        _ResourceStatusRequest_protocolIEs,
        ResourceStatusRequest,
        ResourceStatusRequestIEs,
        _ResourceStatusRequestIEs_val_Value_0,
        _ResourceStatusRequestIEs_val_Value_1,
        _ResourceStatusRequestIEs_val_Value_2,
        _ResourceStatusRequestIEs_val_Value_3,
        _ResourceStatusRequestIEs_val_Value_4,
        _ResourceStatusRequestIEs_val_Value_5,
        _ResourceStatusRequestIEs_val_Value_6,
        ____ResourceStatusResponse_protocolIEs__item__id_tab,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ResourceStatusResponse_protocolIEs__item__id,
        ___ResourceStatusResponse_protocolIEs__item__criticality,
        ___ResourceStatusResponse_protocolIEs__item__value,
        __ResourceStatusResponse_protocolIEs__item_,
        _ResourceStatusResponse_protocolIEs,
        ResourceStatusResponse,
        ResourceStatusResponseIEs,
        _ResourceStatusResponseIEs_val_Value_0,
        _ResourceStatusResponseIEs_val_Value_1,
        _ResourceStatusResponseIEs_val_Value_2,
        _ResourceStatusResponseIEs_val_Value_3,
        ____ResourceStatusFailure_protocolIEs__item__id_tab,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusFailure_protocolIEs__item__id,
        ___ResourceStatusFailure_protocolIEs__item__criticality,
        ___ResourceStatusFailure_protocolIEs__item__value,
        __ResourceStatusFailure_protocolIEs__item_,
        _ResourceStatusFailure_protocolIEs,
        ResourceStatusFailure,
        ResourceStatusFailureIEs,
        _ResourceStatusFailureIEs_val_Value_0,
        _ResourceStatusFailureIEs_val_Value_1,
        _ResourceStatusFailureIEs_val_Value_2,
        _ResourceStatusFailureIEs_val_Value_3,
        _ResourceStatusFailureIEs_val_Value_4,
        ____ResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___ResourceStatusUpdate_protocolIEs__item__id,
        ___ResourceStatusUpdate_protocolIEs__item__criticality,
        ___ResourceStatusUpdate_protocolIEs__item__value,
        __ResourceStatusUpdate_protocolIEs__item_,
        _ResourceStatusUpdate_protocolIEs,
        ResourceStatusUpdate,
        ResourceStatusUpdateIEs,
        _ResourceStatusUpdateIEs_val_Value_0,
        _ResourceStatusUpdateIEs_val_Value_1,
        _ResourceStatusUpdateIEs_val_Value_2,
        _ResourceStatusUpdateIEs_val_Value_3,
        _ResourceStatusUpdateIEs_val_Value_4,
        _ResourceStatusUpdateIEs_val_Value_5,
        ____AccessAndMobilityIndication_protocolIEs__item__id_tab,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2,
        ___AccessAndMobilityIndication_protocolIEs__item__id,
        ___AccessAndMobilityIndication_protocolIEs__item__criticality,
        ___AccessAndMobilityIndication_protocolIEs__item__value,
        __AccessAndMobilityIndication_protocolIEs__item_,
        _AccessAndMobilityIndication_protocolIEs,
        AccessAndMobilityIndication,
        AccessAndMobilityIndicationIEs,
        _AccessAndMobilityIndicationIEs_val_Value_0,
        _AccessAndMobilityIndicationIEs_val_Value_1,
        _AccessAndMobilityIndicationIEs_val_Value_2,
        ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab,
        _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__id,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__value,
        __ReferenceTimeInformationReportingControl_protocolIEs__item_,
        _ReferenceTimeInformationReportingControl_protocolIEs,
        ReferenceTimeInformationReportingControl,
        ReferenceTimeInformationReportingControlIEs,
        _ReferenceTimeInformationReportingControlIEs_val_Value_0,
        _ReferenceTimeInformationReportingControlIEs_val_Value_1,
        ____ReferenceTimeInformationReport_protocolIEs__item__id_tab,
        _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0,
        _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1,
        ___ReferenceTimeInformationReport_protocolIEs__item__id,
        ___ReferenceTimeInformationReport_protocolIEs__item__criticality,
        ___ReferenceTimeInformationReport_protocolIEs__item__value,
        __ReferenceTimeInformationReport_protocolIEs__item_,
        _ReferenceTimeInformationReport_protocolIEs,
        ReferenceTimeInformationReport,
        ReferenceTimeInformationReportIEs,
        _ReferenceTimeInformationReportIEs_val_Value_0,
        _ReferenceTimeInformationReportIEs_val_Value_1,
        ____AccessSuccess_protocolIEs__item__id_tab,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2,
        ___AccessSuccess_protocolIEs__item__id,
        ___AccessSuccess_protocolIEs__item__criticality,
        ___AccessSuccess_protocolIEs__item__value,
        __AccessSuccess_protocolIEs__item_,
        _AccessSuccess_protocolIEs,
        AccessSuccess,
        AccessSuccessIEs,
        _AccessSuccessIEs_val_Value_0,
        _AccessSuccessIEs_val_Value_1,
        _AccessSuccessIEs_val_Value_2,
        ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningAssistanceInformationControl_protocolIEs__item__id,
        ___PositioningAssistanceInformationControl_protocolIEs__item__criticality,
        ___PositioningAssistanceInformationControl_protocolIEs__item__value,
        __PositioningAssistanceInformationControl_protocolIEs__item_,
        _PositioningAssistanceInformationControl_protocolIEs,
        PositioningAssistanceInformationControl,
        PositioningAssistanceInformationControlIEs,
        _PositioningAssistanceInformationControlIEs_val_Value_0,
        _PositioningAssistanceInformationControlIEs_val_Value_1,
        _PositioningAssistanceInformationControlIEs_val_Value_2,
        _PositioningAssistanceInformationControlIEs_val_Value_3,
        _PositioningAssistanceInformationControlIEs_val_Value_4,
        ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__id,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__value,
        __PositioningAssistanceInformationFeedback_protocolIEs__item_,
        _PositioningAssistanceInformationFeedback_protocolIEs,
        PositioningAssistanceInformationFeedback,
        PositioningAssistanceInformationFeedbackIEs,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_0,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_1,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_2,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_3,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_4,
        ____PositioningMeasurementRequest_protocolIEs__item__id_tab,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12,
        ___PositioningMeasurementRequest_protocolIEs__item__id,
        ___PositioningMeasurementRequest_protocolIEs__item__criticality,
        ___PositioningMeasurementRequest_protocolIEs__item__value,
        __PositioningMeasurementRequest_protocolIEs__item_,
        _PositioningMeasurementRequest_protocolIEs,
        PositioningMeasurementRequest,
        PositioningMeasurementRequestIEs,
        _PositioningMeasurementRequestIEs_val_Value_0,
        _PositioningMeasurementRequestIEs_val_Value_1,
        _PositioningMeasurementRequestIEs_val_Value_2,
        _PositioningMeasurementRequestIEs_val_Value_3,
        _PositioningMeasurementRequestIEs_val_Value_4,
        _PositioningMeasurementRequestIEs_val_Value_5,
        _PositioningMeasurementRequestIEs_val_Value_6,
        _PositioningMeasurementRequestIEs_val_Value_7,
        _PositioningMeasurementRequestIEs_val_Value_8,
        _PositioningMeasurementRequestIEs_val_Value_9,
        _PositioningMeasurementRequestIEs_val_Value_10,
        _PositioningMeasurementRequestIEs_val_Value_11,
        _PositioningMeasurementRequestIEs_val_Value_12,
        ____PositioningMeasurementResponse_protocolIEs__item__id_tab,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningMeasurementResponse_protocolIEs__item__id,
        ___PositioningMeasurementResponse_protocolIEs__item__criticality,
        ___PositioningMeasurementResponse_protocolIEs__item__value,
        __PositioningMeasurementResponse_protocolIEs__item_,
        _PositioningMeasurementResponse_protocolIEs,
        PositioningMeasurementResponse,
        PositioningMeasurementResponseIEs,
        _PositioningMeasurementResponseIEs_val_Value_0,
        _PositioningMeasurementResponseIEs_val_Value_1,
        _PositioningMeasurementResponseIEs_val_Value_2,
        _PositioningMeasurementResponseIEs_val_Value_3,
        _PositioningMeasurementResponseIEs_val_Value_4,
        ____PositioningMeasurementFailure_protocolIEs__item__id_tab,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningMeasurementFailure_protocolIEs__item__id,
        ___PositioningMeasurementFailure_protocolIEs__item__criticality,
        ___PositioningMeasurementFailure_protocolIEs__item__value,
        __PositioningMeasurementFailure_protocolIEs__item_,
        _PositioningMeasurementFailure_protocolIEs,
        PositioningMeasurementFailure,
        PositioningMeasurementFailureIEs,
        _PositioningMeasurementFailureIEs_val_Value_0,
        _PositioningMeasurementFailureIEs_val_Value_1,
        _PositioningMeasurementFailureIEs_val_Value_2,
        _PositioningMeasurementFailureIEs_val_Value_3,
        _PositioningMeasurementFailureIEs_val_Value_4,
        ____PositioningMeasurementReport_protocolIEs__item__id_tab,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningMeasurementReport_protocolIEs__item__id,
        ___PositioningMeasurementReport_protocolIEs__item__criticality,
        ___PositioningMeasurementReport_protocolIEs__item__value,
        __PositioningMeasurementReport_protocolIEs__item_,
        _PositioningMeasurementReport_protocolIEs,
        PositioningMeasurementReport,
        PositioningMeasurementReportIEs,
        _PositioningMeasurementReportIEs_val_Value_0,
        _PositioningMeasurementReportIEs_val_Value_1,
        _PositioningMeasurementReportIEs_val_Value_2,
        _PositioningMeasurementReportIEs_val_Value_3,
        ____PositioningMeasurementAbort_protocolIEs__item__id_tab,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningMeasurementAbort_protocolIEs__item__id,
        ___PositioningMeasurementAbort_protocolIEs__item__criticality,
        ___PositioningMeasurementAbort_protocolIEs__item__value,
        __PositioningMeasurementAbort_protocolIEs__item_,
        _PositioningMeasurementAbort_protocolIEs,
        PositioningMeasurementAbort,
        PositioningMeasurementAbortIEs,
        _PositioningMeasurementAbortIEs_val_Value_0,
        _PositioningMeasurementAbortIEs_val_Value_1,
        _PositioningMeasurementAbortIEs_val_Value_2,
        ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__id,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__value,
        __PositioningMeasurementFailureIndication_protocolIEs__item_,
        _PositioningMeasurementFailureIndication_protocolIEs,
        PositioningMeasurementFailureIndication,
        PositioningMeasurementFailureIndicationIEs,
        _PositioningMeasurementFailureIndicationIEs_val_Value_0,
        _PositioningMeasurementFailureIndicationIEs_val_Value_1,
        _PositioningMeasurementFailureIndicationIEs_val_Value_2,
        _PositioningMeasurementFailureIndicationIEs_val_Value_3,
        ____PositioningMeasurementUpdate_protocolIEs__item__id_tab,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningMeasurementUpdate_protocolIEs__item__id,
        ___PositioningMeasurementUpdate_protocolIEs__item__criticality,
        ___PositioningMeasurementUpdate_protocolIEs__item__value,
        __PositioningMeasurementUpdate_protocolIEs__item_,
        _PositioningMeasurementUpdate_protocolIEs,
        PositioningMeasurementUpdate,
        PositioningMeasurementUpdateIEs,
        _PositioningMeasurementUpdateIEs_val_Value_0,
        _PositioningMeasurementUpdateIEs_val_Value_1,
        _PositioningMeasurementUpdateIEs_val_Value_2,
        _PositioningMeasurementUpdateIEs_val_Value_3,
        ____TRPInformationRequest_protocolIEs__item__id_tab,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationRequest_protocolIEs__item__id,
        ___TRPInformationRequest_protocolIEs__item__criticality,
        ___TRPInformationRequest_protocolIEs__item__value,
        __TRPInformationRequest_protocolIEs__item_,
        _TRPInformationRequest_protocolIEs,
        TRPInformationRequest,
        TRPInformationRequestIEs,
        _TRPInformationRequestIEs_val_Value_0,
        _TRPInformationRequestIEs_val_Value_1,
        _TRPInformationRequestIEs_val_Value_2,
        ___TRPInformationTypeListTRPReq__item__id_tab,
        ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0,
        __TRPInformationTypeListTRPReq__item__id,
        __TRPInformationTypeListTRPReq__item__criticality,
        __TRPInformationTypeListTRPReq__item__value,
        _TRPInformationTypeListTRPReq__item_,
        TRPInformationTypeListTRPReq,
        TRPInformationTypeItemTRPReq,
        _TRPInformationTypeItemTRPReq_val_Value_0,
        ____TRPInformationResponse_protocolIEs__item__id_tab,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationResponse_protocolIEs__item__id,
        ___TRPInformationResponse_protocolIEs__item__criticality,
        ___TRPInformationResponse_protocolIEs__item__value,
        __TRPInformationResponse_protocolIEs__item_,
        _TRPInformationResponse_protocolIEs,
        TRPInformationResponse,
        TRPInformationResponseIEs,
        _TRPInformationResponseIEs_val_Value_0,
        _TRPInformationResponseIEs_val_Value_1,
        _TRPInformationResponseIEs_val_Value_2,
        ___TRPInformationListTRPResp__item__id_tab,
        ____TRPInformationListTRPResp__item__id_tab_val_Value_0,
        __TRPInformationListTRPResp__item__id,
        __TRPInformationListTRPResp__item__criticality,
        __TRPInformationListTRPResp__item__value,
        _TRPInformationListTRPResp__item_,
        TRPInformationListTRPResp,
        TRPInformationItemTRPResp,
        _TRPInformationItemTRPResp_val_Value_0,
        ____TRPInformationFailure_protocolIEs__item__id_tab,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationFailure_protocolIEs__item__id,
        ___TRPInformationFailure_protocolIEs__item__criticality,
        ___TRPInformationFailure_protocolIEs__item__value,
        __TRPInformationFailure_protocolIEs__item_,
        _TRPInformationFailure_protocolIEs,
        TRPInformationFailure,
        TRPInformationFailureIEs,
        _TRPInformationFailureIEs_val_Value_0,
        _TRPInformationFailureIEs_val_Value_1,
        _TRPInformationFailureIEs_val_Value_2,
        ____PositioningInformationRequest_protocolIEs__item__id_tab,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningInformationRequest_protocolIEs__item__id,
        ___PositioningInformationRequest_protocolIEs__item__criticality,
        ___PositioningInformationRequest_protocolIEs__item__value,
        __PositioningInformationRequest_protocolIEs__item_,
        _PositioningInformationRequest_protocolIEs,
        PositioningInformationRequest,
        PositioningInformationRequestIEs,
        _PositioningInformationRequestIEs_val_Value_0,
        _PositioningInformationRequestIEs_val_Value_1,
        _PositioningInformationRequestIEs_val_Value_2,
        ____PositioningInformationResponse_protocolIEs__item__id_tab,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningInformationResponse_protocolIEs__item__id,
        ___PositioningInformationResponse_protocolIEs__item__criticality,
        ___PositioningInformationResponse_protocolIEs__item__value,
        __PositioningInformationResponse_protocolIEs__item_,
        _PositioningInformationResponse_protocolIEs,
        PositioningInformationResponse,
        PositioningInformationResponseIEs,
        _PositioningInformationResponseIEs_val_Value_0,
        _PositioningInformationResponseIEs_val_Value_1,
        _PositioningInformationResponseIEs_val_Value_2,
        _PositioningInformationResponseIEs_val_Value_3,
        _PositioningInformationResponseIEs_val_Value_4,
        ____PositioningInformationFailure_protocolIEs__item__id_tab,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationFailure_protocolIEs__item__id,
        ___PositioningInformationFailure_protocolIEs__item__criticality,
        ___PositioningInformationFailure_protocolIEs__item__value,
        __PositioningInformationFailure_protocolIEs__item_,
        _PositioningInformationFailure_protocolIEs,
        PositioningInformationFailure,
        PositioningInformationFailureIEs,
        _PositioningInformationFailureIEs_val_Value_0,
        _PositioningInformationFailureIEs_val_Value_1,
        _PositioningInformationFailureIEs_val_Value_2,
        _PositioningInformationFailureIEs_val_Value_3,
        ____PositioningActivationRequest_protocolIEs__item__id_tab,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningActivationRequest_protocolIEs__item__id,
        ___PositioningActivationRequest_protocolIEs__item__criticality,
        ___PositioningActivationRequest_protocolIEs__item__value,
        __PositioningActivationRequest_protocolIEs__item_,
        _PositioningActivationRequest_protocolIEs,
        PositioningActivationRequest,
        PositioningActivationRequestIEs,
        _PositioningActivationRequestIEs_val_Value_0,
        _PositioningActivationRequestIEs_val_Value_1,
        _PositioningActivationRequestIEs_val_Value_2,
        _PositioningActivationRequestIEs_val_Value_3,
        _SRSType_semipersistentSRS,
        _SRSType_aperiodicSRS,
        ___SRSType_choice_extension_id_tab,
        __SRSType_choice_extension_id,
        ___SRSType_choice_extension_criticality_tab,
        __SRSType_choice_extension_criticality,
        ___SRSType_choice_extension_value_tab,
        __SRSType_choice_extension_value,
        _SRSType_choice_extension,
        SRSType,
        SRSType_ExtIEs,
        _SemipersistentSRS_sRSResourceSetID,
        _SemipersistentSRS_sRSSpatialRelation,
        ____SemipersistentSRS_iE_Extensions__item__id_tab,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0,
        ___SemipersistentSRS_iE_Extensions__item__id,
        ___SemipersistentSRS_iE_Extensions__item__criticality,
        ___SemipersistentSRS_iE_Extensions__item__extensionValue,
        __SemipersistentSRS_iE_Extensions__item_,
        _SemipersistentSRS_iE_Extensions,
        SemipersistentSRS,
        SemipersistentSRS_ExtIEs,
        _SemipersistentSRS_ExtIEs_val_Extension_0,
        _AperiodicSRS_aperiodic,
        _AperiodicSRS_sRSResourceTrigger,
        ____AperiodicSRS_iE_Extensions__item__id_tab,
        ___AperiodicSRS_iE_Extensions__item__id,
        ____AperiodicSRS_iE_Extensions__item__criticality_tab,
        ___AperiodicSRS_iE_Extensions__item__criticality,
        ____AperiodicSRS_iE_Extensions__item__extensionValue_tab,
        ___AperiodicSRS_iE_Extensions__item__extensionValue,
        __AperiodicSRS_iE_Extensions__item_,
        _AperiodicSRS_iE_Extensions,
        AperiodicSRS,
        AperiodicSRS_ExtIEs,
        ____PositioningActivationResponse_protocolIEs__item__id_tab,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningActivationResponse_protocolIEs__item__id,
        ___PositioningActivationResponse_protocolIEs__item__criticality,
        ___PositioningActivationResponse_protocolIEs__item__value,
        __PositioningActivationResponse_protocolIEs__item_,
        _PositioningActivationResponse_protocolIEs,
        PositioningActivationResponse,
        PositioningActivationResponseIEs,
        _PositioningActivationResponseIEs_val_Value_0,
        _PositioningActivationResponseIEs_val_Value_1,
        _PositioningActivationResponseIEs_val_Value_2,
        _PositioningActivationResponseIEs_val_Value_3,
        _PositioningActivationResponseIEs_val_Value_4,
        ____PositioningActivationFailure_protocolIEs__item__id_tab,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningActivationFailure_protocolIEs__item__id,
        ___PositioningActivationFailure_protocolIEs__item__criticality,
        ___PositioningActivationFailure_protocolIEs__item__value,
        __PositioningActivationFailure_protocolIEs__item_,
        _PositioningActivationFailure_protocolIEs,
        PositioningActivationFailure,
        PositioningActivationFailureIEs,
        _PositioningActivationFailureIEs_val_Value_0,
        _PositioningActivationFailureIEs_val_Value_1,
        _PositioningActivationFailureIEs_val_Value_2,
        _PositioningActivationFailureIEs_val_Value_3,
        ____PositioningDeactivation_protocolIEs__item__id_tab,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningDeactivation_protocolIEs__item__id,
        ___PositioningDeactivation_protocolIEs__item__criticality,
        ___PositioningDeactivation_protocolIEs__item__value,
        __PositioningDeactivation_protocolIEs__item_,
        _PositioningDeactivation_protocolIEs,
        PositioningDeactivation,
        PositioningDeactivationIEs,
        _PositioningDeactivationIEs_val_Value_0,
        _PositioningDeactivationIEs_val_Value_1,
        _PositioningDeactivationIEs_val_Value_2,
        ____PositioningInformationUpdate_protocolIEs__item__id_tab,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationUpdate_protocolIEs__item__id,
        ___PositioningInformationUpdate_protocolIEs__item__criticality,
        ___PositioningInformationUpdate_protocolIEs__item__value,
        __PositioningInformationUpdate_protocolIEs__item_,
        _PositioningInformationUpdate_protocolIEs,
        PositioningInformationUpdate,
        PositioningInformationUpdateIEs,
        _PositioningInformationUpdateIEs_val_Value_0,
        _PositioningInformationUpdateIEs_val_Value_1,
        _PositioningInformationUpdateIEs_val_Value_2,
        _PositioningInformationUpdateIEs_val_Value_3,
        ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value,
        __E_CIDMeasurementInitiationRequest_protocolIEs__item_,
        _E_CIDMeasurementInitiationRequest_protocolIEs,
        E_CIDMeasurementInitiationRequest,
        E_CIDMeasurementInitiationRequest_IEs,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_0,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_1,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_2,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_3,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_4,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_5,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value,
        __E_CIDMeasurementInitiationResponse_protocolIEs__item_,
        _E_CIDMeasurementInitiationResponse_protocolIEs,
        E_CIDMeasurementInitiationResponse,
        E_CIDMeasurementInitiationResponse_IEs,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_0,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_1,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_2,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_3,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_4,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_5,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value,
        __E_CIDMeasurementInitiationFailure_protocolIEs__item_,
        _E_CIDMeasurementInitiationFailure_protocolIEs,
        E_CIDMeasurementInitiationFailure,
        E_CIDMeasurementInitiationFailure_IEs,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_0,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_1,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_2,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_3,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_4,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_5,
        ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__id,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__value,
        __E_CIDMeasurementFailureIndication_protocolIEs__item_,
        _E_CIDMeasurementFailureIndication_protocolIEs,
        E_CIDMeasurementFailureIndication,
        E_CIDMeasurementFailureIndication_IEs,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_0,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_1,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_2,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_3,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_4,
        ____E_CIDMeasurementReport_protocolIEs__item__id_tab,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5,
        ___E_CIDMeasurementReport_protocolIEs__item__id,
        ___E_CIDMeasurementReport_protocolIEs__item__criticality,
        ___E_CIDMeasurementReport_protocolIEs__item__value,
        __E_CIDMeasurementReport_protocolIEs__item_,
        _E_CIDMeasurementReport_protocolIEs,
        E_CIDMeasurementReport,
        E_CIDMeasurementReport_IEs,
        _E_CIDMeasurementReport_IEs_val_Value_0,
        _E_CIDMeasurementReport_IEs_val_Value_1,
        _E_CIDMeasurementReport_IEs_val_Value_2,
        _E_CIDMeasurementReport_IEs_val_Value_3,
        _E_CIDMeasurementReport_IEs_val_Value_4,
        _E_CIDMeasurementReport_IEs_val_Value_5,
        ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value,
        __E_CIDMeasurementTerminationCommand_protocolIEs__item_,
        _E_CIDMeasurementTerminationCommand_protocolIEs,
        E_CIDMeasurementTerminationCommand,
        E_CIDMeasurementTerminationCommand_IEs,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_0,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_1,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_2,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_3,
    ]

class F1AP_PDU_Descriptions:

    _name_  = u'F1AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 0]
    
    _obj_ = [
        u'F1AP-ELEMENTARY-PROCEDURE',
        u'F1AP-PDU',
        u'F1AP-PDU-ExtIEs',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'F1AP-ELEMENTARY-PROCEDURES',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'reset',
        u'f1Setup',
        u'gNBDUConfigurationUpdate',
        u'gNBCUConfigurationUpdate',
        u'uEContextSetup',
        u'uEContextRelease',
        u'uEContextModification',
        u'uEContextModificationRequired',
        u'writeReplaceWarning',
        u'pWSCancel',
        u'errorIndication',
        u'uEContextReleaseRequest',
        u'initialULRRCMessageTransfer',
        u'dLRRCMessageTransfer',
        u'uLRRCMessageTransfer',
        u'uEInactivityNotification',
        u'gNBDUResourceCoordination',
        u'privateMessage',
        u'systemInformationDelivery',
        u'paging',
        u'notify',
        u'networkAccessRateReduction',
        u'pWSRestartIndication',
        u'pWSFailureIndication',
        u'gNBDUStatusIndication',
        u'rRCDeliveryReport',
        u'f1Removal',
        u'traceStart',
        u'deactivateTrace',
        u'dUCURadioInformationTransfer',
        u'cUDURadioInformationTransfer',
        u'bAPMappingConfiguration',
        u'gNBDUResourceConfiguration',
        u'iABTNLAddressAllocation',
        u'iABUPConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'accessAndMobilityIndication',
        u'referenceTimeInformationReportingControl',
        u'referenceTimeInformationReport',
        u'accessSuccess',
        u'cellTrafficTrace',
        u'positioningAssistanceInformationControl',
        u'positioningAssistanceInformationFeedback',
        u'positioningMeasurementExchange',
        u'positioningMeasurementReport',
        u'positioningMeasurementAbort',
        u'positioningMeasurementFailureIndication',
        u'positioningMeasurementUpdate',
        u'tRPInformationExchange',
        u'positioningInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'positioningInformationUpdate',
        ]
    _type_ = [
        u'F1AP-ELEMENTARY-PROCEDURE',
        u'F1AP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'F1AP-PDU-ExtIEs',
        u'F1AP-ELEMENTARY-PROCEDURES',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'reset',
        u'f1Setup',
        u'gNBDUConfigurationUpdate',
        u'gNBCUConfigurationUpdate',
        u'uEContextSetup',
        u'uEContextRelease',
        u'uEContextModification',
        u'uEContextModificationRequired',
        u'writeReplaceWarning',
        u'pWSCancel',
        u'errorIndication',
        u'uEContextReleaseRequest',
        u'initialULRRCMessageTransfer',
        u'dLRRCMessageTransfer',
        u'uLRRCMessageTransfer',
        u'uEInactivityNotification',
        u'gNBDUResourceCoordination',
        u'privateMessage',
        u'systemInformationDelivery',
        u'paging',
        u'notify',
        u'networkAccessRateReduction',
        u'pWSRestartIndication',
        u'pWSFailureIndication',
        u'gNBDUStatusIndication',
        u'rRCDeliveryReport',
        u'f1Removal',
        u'traceStart',
        u'deactivateTrace',
        u'dUCURadioInformationTransfer',
        u'cUDURadioInformationTransfer',
        u'bAPMappingConfiguration',
        u'gNBDUResourceConfiguration',
        u'iABTNLAddressAllocation',
        u'iABUPConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'accessAndMobilityIndication',
        u'referenceTimeInformationReportingControl',
        u'referenceTimeInformationReport',
        u'accessSuccess',
        u'cellTrafficTrace',
        u'positioningAssistanceInformationControl',
        u'positioningAssistanceInformationFeedback',
        u'positioningMeasurementExchange',
        u'positioningMeasurementReport',
        u'positioningMeasurementAbort',
        u'positioningMeasurementFailureIndication',
        u'positioningMeasurementUpdate',
        u'tRPInformationExchange',
        u'positioningInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'positioningInformationUpdate',
        ]
    _class_ = [
        u'F1AP-ELEMENTARY-PROCEDURE',
        u'F1AP-PDU-ExtIEs',
        u'F1AP-ELEMENTARY-PROCEDURES',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'reset',
        u'f1Setup',
        u'gNBDUConfigurationUpdate',
        u'gNBCUConfigurationUpdate',
        u'uEContextSetup',
        u'uEContextRelease',
        u'uEContextModification',
        u'uEContextModificationRequired',
        u'writeReplaceWarning',
        u'pWSCancel',
        u'errorIndication',
        u'uEContextReleaseRequest',
        u'initialULRRCMessageTransfer',
        u'dLRRCMessageTransfer',
        u'uLRRCMessageTransfer',
        u'uEInactivityNotification',
        u'gNBDUResourceCoordination',
        u'privateMessage',
        u'systemInformationDelivery',
        u'paging',
        u'notify',
        u'networkAccessRateReduction',
        u'pWSRestartIndication',
        u'pWSFailureIndication',
        u'gNBDUStatusIndication',
        u'rRCDeliveryReport',
        u'f1Removal',
        u'traceStart',
        u'deactivateTrace',
        u'dUCURadioInformationTransfer',
        u'cUDURadioInformationTransfer',
        u'bAPMappingConfiguration',
        u'gNBDUResourceConfiguration',
        u'iABTNLAddressAllocation',
        u'iABUPConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'accessAndMobilityIndication',
        u'referenceTimeInformationReportingControl',
        u'referenceTimeInformationReport',
        u'accessSuccess',
        u'cellTrafficTrace',
        u'positioningAssistanceInformationControl',
        u'positioningAssistanceInformationFeedback',
        u'positioningMeasurementExchange',
        u'positioningMeasurementReport',
        u'positioningMeasurementAbort',
        u'positioningMeasurementFailureIndication',
        u'positioningMeasurementUpdate',
        u'tRPInformationExchange',
        u'positioningInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'positioningInformationUpdate',
        ]
    _param_ = [
        ]
    
    #-----< F1AP-ELEMENTARY-PROCEDURE >-----#
    F1AP_ELEMENTARY_PROCEDURE = CLASS(name=u'F1AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _F1AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _F1AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')), default=u'ignore')
    F1AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _F1AP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _F1AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< F1AP-PDU >-----#
    F1AP_PDU = CHOICE(name=u'F1AP-PDU', mode=MODE_TYPE)
    _F1AP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'InitiatingMessage')))
    _F1AP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _F1AP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _F1AP_PDU_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __F1AP_PDU_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'id']))
    ___F1AP_PDU_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_id._const_tab = ___F1AP_PDU_choice_extension_id_tab
    __F1AP_PDU_choice_extension_id._const_tab_at = None
    __F1AP_PDU_choice_extension_id._const_tab_id = u'id'
    __F1AP_PDU_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'criticality']))
    ___F1AP_PDU_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_criticality._const_tab = ___F1AP_PDU_choice_extension_criticality_tab
    __F1AP_PDU_choice_extension_criticality._const_tab_at = ('..', u'id')
    __F1AP_PDU_choice_extension_criticality._const_tab_id = u'criticality'
    __F1AP_PDU_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), [u'Value']))
    ___F1AP_PDU_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_value._const_tab = ___F1AP_PDU_choice_extension_value_tab
    __F1AP_PDU_choice_extension_value._const_tab_at = ('..', u'id')
    __F1AP_PDU_choice_extension_value._const_tab_id = u'Value'
    _F1AP_PDU_choice_extension._cont = ASN1Dict([
        (u'id', __F1AP_PDU_choice_extension_id),
        (u'criticality', __F1AP_PDU_choice_extension_criticality),
        (u'value', __F1AP_PDU_choice_extension_value),
        ])
    _F1AP_PDU_choice_extension._ext = None
    F1AP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _F1AP_PDU_initiatingMessage),
        (u'successfulOutcome', _F1AP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _F1AP_PDU_unsuccessfulOutcome),
        (u'choice-extension', _F1AP_PDU_choice_extension),
        ])
    F1AP_PDU._ext = None
    
    #-----< F1AP-PDU-ExtIEs >-----#
    F1AP_PDU_ExtIEs = CLASS(name=u'F1AP-PDU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    F1AP_PDU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 34), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19), (u'procedureCode', 49), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 58), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 43), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 55), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 56), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 34), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), (u'procedureCode', 49), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 58), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 43), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 55), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 56), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 34), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), (u'procedureCode', 49), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 58), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 43), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 55), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 56), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< F1AP-ELEMENTARY-PROCEDURES >-----#
    F1AP_ELEMENTARY_PROCEDURES = CLASS(name=u'F1AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    F1AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), (u'procedureCode', 34), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19), (u'procedureCode', 49), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), (u'procedureCode', 58), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), (u'procedureCode', 43), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), (u'procedureCode', 55), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), (u'procedureCode', 56), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< F1AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    F1AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'F1AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    F1AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), (u'procedureCode', 34), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), (u'procedureCode', 49), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), (u'SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), (u'UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21), (u'procedureCode', 52), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< F1AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    F1AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'F1AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    F1AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), (u'procedureCode', 58), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), (u'procedureCode', 43), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), (u'procedureCode', 55), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), (u'procedureCode', 56), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< f1Setup >-----#
    f1Setup = CLASS(name=u'f1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _f1Setup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _f1Setup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _f1Setup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    f1Setup._val = dict([(u'InitiatingMessage', _f1Setup_val_InitiatingMessage), (u'SuccessfulOutcome', _f1Setup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _f1Setup_val_UnsuccessfulOutcome), (u'procedureCode', 1), (u'criticality', u'reject')])
    
    #-----< gNBDUConfigurationUpdate >-----#
    gNBDUConfigurationUpdate = CLASS(name=u'gNBDUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _gNBDUConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    gNBDUConfigurationUpdate._val = dict([(u'InitiatingMessage', _gNBDUConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _gNBDUConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 3), (u'criticality', u'reject')])
    
    #-----< gNBCUConfigurationUpdate >-----#
    gNBCUConfigurationUpdate = CLASS(name=u'gNBCUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBCUConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _gNBCUConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    gNBCUConfigurationUpdate._val = dict([(u'InitiatingMessage', _gNBCUConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _gNBCUConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 4), (u'criticality', u'reject')])
    
    #-----< uEContextSetup >-----#
    uEContextSetup = CLASS(name=u'uEContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _uEContextSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _uEContextSetup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    uEContextSetup._val = dict([(u'InitiatingMessage', _uEContextSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextSetup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextSetup_val_UnsuccessfulOutcome), (u'procedureCode', 5), (u'criticality', u'reject')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name=u'uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([(u'InitiatingMessage', _uEContextRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name=u'uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([(u'InitiatingMessage', _uEContextModification_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< uEContextModificationRequired >-----#
    uEContextModificationRequired = CLASS(name=u'uEContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModificationRequired_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _uEContextModificationRequired_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _uEContextModificationRequired_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    uEContextModificationRequired._val = dict([(u'InitiatingMessage', _uEContextModificationRequired_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextModificationRequired_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextModificationRequired_val_UnsuccessfulOutcome), (u'procedureCode', 8), (u'criticality', u'reject')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name=u'writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([(u'InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), (u'SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), (u'procedureCode', 20), (u'criticality', u'reject')])
    
    #-----< pWSCancel >-----#
    pWSCancel = CLASS(name=u'pWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _pWSCancel_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    pWSCancel._val = dict([(u'InitiatingMessage', _pWSCancel_val_InitiatingMessage), (u'SuccessfulOutcome', _pWSCancel_val_SuccessfulOutcome), (u'procedureCode', 21), (u'criticality', u'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 2), (u'criticality', u'ignore')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name=u'uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([(u'InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), (u'procedureCode', 10), (u'criticality', u'ignore')])
    
    #-----< initialULRRCMessageTransfer >-----#
    initialULRRCMessageTransfer = CLASS(name=u'initialULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _initialULRRCMessageTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    initialULRRCMessageTransfer._val = dict([(u'InitiatingMessage', _initialULRRCMessageTransfer_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< dLRRCMessageTransfer >-----#
    dLRRCMessageTransfer = CLASS(name=u'dLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _dLRRCMessageTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    dLRRCMessageTransfer._val = dict([(u'InitiatingMessage', _dLRRCMessageTransfer_val_InitiatingMessage), (u'procedureCode', 12), (u'criticality', u'ignore')])
    
    #-----< uLRRCMessageTransfer >-----#
    uLRRCMessageTransfer = CLASS(name=u'uLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uLRRCMessageTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    uLRRCMessageTransfer._val = dict([(u'InitiatingMessage', _uLRRCMessageTransfer_val_InitiatingMessage), (u'procedureCode', 13), (u'criticality', u'ignore')])
    
    #-----< uEInactivityNotification >-----#
    uEInactivityNotification = CLASS(name=u'uEInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEInactivityNotification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    uEInactivityNotification._val = dict([(u'InitiatingMessage', _uEInactivityNotification_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< gNBDUResourceCoordination >-----#
    gNBDUResourceCoordination = CLASS(name=u'gNBDUResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUResourceCoordination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _gNBDUResourceCoordination_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    gNBDUResourceCoordination._val = dict([(u'InitiatingMessage', _gNBDUResourceCoordination_val_InitiatingMessage), (u'SuccessfulOutcome', _gNBDUResourceCoordination_val_SuccessfulOutcome), (u'procedureCode', 16), (u'criticality', u'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 14), (u'criticality', u'ignore')])
    
    #-----< systemInformationDelivery >-----#
    systemInformationDelivery = CLASS(name=u'systemInformationDelivery', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _systemInformationDelivery_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    systemInformationDelivery._val = dict([(u'InitiatingMessage', _systemInformationDelivery_val_InitiatingMessage), (u'procedureCode', 17), (u'criticality', u'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name=u'paging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    paging._val = dict([(u'InitiatingMessage', _paging_val_InitiatingMessage), (u'procedureCode', 18), (u'criticality', u'ignore')])
    
    #-----< notify >-----#
    notify = CLASS(name=u'notify', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _notify_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    notify._val = dict([(u'InitiatingMessage', _notify_val_InitiatingMessage), (u'procedureCode', 19), (u'criticality', u'ignore')])
    
    #-----< networkAccessRateReduction >-----#
    networkAccessRateReduction = CLASS(name=u'networkAccessRateReduction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _networkAccessRateReduction_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    networkAccessRateReduction._val = dict([(u'InitiatingMessage', _networkAccessRateReduction_val_InitiatingMessage), (u'procedureCode', 27), (u'criticality', u'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name=u'pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([(u'InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), (u'procedureCode', 22), (u'criticality', u'ignore')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name=u'pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([(u'InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), (u'procedureCode', 23), (u'criticality', u'ignore')])
    
    #-----< gNBDUStatusIndication >-----#
    gNBDUStatusIndication = CLASS(name=u'gNBDUStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUStatusIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    gNBDUStatusIndication._val = dict([(u'InitiatingMessage', _gNBDUStatusIndication_val_InitiatingMessage), (u'procedureCode', 24), (u'criticality', u'ignore')])
    
    #-----< rRCDeliveryReport >-----#
    rRCDeliveryReport = CLASS(name=u'rRCDeliveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _rRCDeliveryReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    rRCDeliveryReport._val = dict([(u'InitiatingMessage', _rRCDeliveryReport_val_InitiatingMessage), (u'procedureCode', 25), (u'criticality', u'ignore')])
    
    #-----< f1Removal >-----#
    f1Removal = CLASS(name=u'f1Removal', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _f1Removal_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _f1Removal_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _f1Removal_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    f1Removal._val = dict([(u'InitiatingMessage', _f1Removal_val_InitiatingMessage), (u'SuccessfulOutcome', _f1Removal_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _f1Removal_val_UnsuccessfulOutcome), (u'procedureCode', 26), (u'criticality', u'reject')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name=u'traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([(u'InitiatingMessage', _traceStart_val_InitiatingMessage), (u'procedureCode', 28), (u'criticality', u'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name=u'deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([(u'InitiatingMessage', _deactivateTrace_val_InitiatingMessage), (u'procedureCode', 29), (u'criticality', u'ignore')])
    
    #-----< dUCURadioInformationTransfer >-----#
    dUCURadioInformationTransfer = CLASS(name=u'dUCURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _dUCURadioInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    dUCURadioInformationTransfer._val = dict([(u'InitiatingMessage', _dUCURadioInformationTransfer_val_InitiatingMessage), (u'procedureCode', 30), (u'criticality', u'ignore')])
    
    #-----< cUDURadioInformationTransfer >-----#
    cUDURadioInformationTransfer = CLASS(name=u'cUDURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _cUDURadioInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    cUDURadioInformationTransfer._val = dict([(u'InitiatingMessage', _cUDURadioInformationTransfer_val_InitiatingMessage), (u'procedureCode', 31), (u'criticality', u'ignore')])
    
    #-----< bAPMappingConfiguration >-----#
    bAPMappingConfiguration = CLASS(name=u'bAPMappingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _bAPMappingConfiguration_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _bAPMappingConfiguration_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _bAPMappingConfiguration_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    bAPMappingConfiguration._val = dict([(u'InitiatingMessage', _bAPMappingConfiguration_val_InitiatingMessage), (u'SuccessfulOutcome', _bAPMappingConfiguration_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _bAPMappingConfiguration_val_UnsuccessfulOutcome), (u'procedureCode', 32), (u'criticality', u'reject')])
    
    #-----< gNBDUResourceConfiguration >-----#
    gNBDUResourceConfiguration = CLASS(name=u'gNBDUResourceConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUResourceConfiguration_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _gNBDUResourceConfiguration_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _gNBDUResourceConfiguration_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    gNBDUResourceConfiguration._val = dict([(u'InitiatingMessage', _gNBDUResourceConfiguration_val_InitiatingMessage), (u'SuccessfulOutcome', _gNBDUResourceConfiguration_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _gNBDUResourceConfiguration_val_UnsuccessfulOutcome), (u'procedureCode', 33), (u'criticality', u'reject')])
    
    #-----< iABTNLAddressAllocation >-----#
    iABTNLAddressAllocation = CLASS(name=u'iABTNLAddressAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _iABTNLAddressAllocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _iABTNLAddressAllocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _iABTNLAddressAllocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    iABTNLAddressAllocation._val = dict([(u'InitiatingMessage', _iABTNLAddressAllocation_val_InitiatingMessage), (u'SuccessfulOutcome', _iABTNLAddressAllocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _iABTNLAddressAllocation_val_UnsuccessfulOutcome), (u'procedureCode', 34), (u'criticality', u'reject')])
    
    #-----< iABUPConfigurationUpdate >-----#
    iABUPConfigurationUpdate = CLASS(name=u'iABUPConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _iABUPConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _iABUPConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _iABUPConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    iABUPConfigurationUpdate._val = dict([(u'InitiatingMessage', _iABUPConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _iABUPConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _iABUPConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 35), (u'criticality', u'reject')])
    
    #-----< resourceStatusReportingInitiation >-----#
    resourceStatusReportingInitiation = CLASS(name=u'resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _resourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _resourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    resourceStatusReportingInitiation._val = dict([(u'InitiatingMessage', _resourceStatusReportingInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _resourceStatusReportingInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _resourceStatusReportingInitiation_val_UnsuccessfulOutcome), (u'procedureCode', 36), (u'criticality', u'reject')])
    
    #-----< resourceStatusReporting >-----#
    resourceStatusReporting = CLASS(name=u'resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    resourceStatusReporting._val = dict([(u'InitiatingMessage', _resourceStatusReporting_val_InitiatingMessage), (u'procedureCode', 37), (u'criticality', u'ignore')])
    
    #-----< accessAndMobilityIndication >-----#
    accessAndMobilityIndication = CLASS(name=u'accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _accessAndMobilityIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    accessAndMobilityIndication._val = dict([(u'InitiatingMessage', _accessAndMobilityIndication_val_InitiatingMessage), (u'procedureCode', 38), (u'criticality', u'ignore')])
    
    #-----< referenceTimeInformationReportingControl >-----#
    referenceTimeInformationReportingControl = CLASS(name=u'referenceTimeInformationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _referenceTimeInformationReportingControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    referenceTimeInformationReportingControl._val = dict([(u'InitiatingMessage', _referenceTimeInformationReportingControl_val_InitiatingMessage), (u'procedureCode', 58), (u'criticality', u'ignore')])
    
    #-----< referenceTimeInformationReport >-----#
    referenceTimeInformationReport = CLASS(name=u'referenceTimeInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _referenceTimeInformationReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    referenceTimeInformationReport._val = dict([(u'InitiatingMessage', _referenceTimeInformationReport_val_InitiatingMessage), (u'procedureCode', 57), (u'criticality', u'ignore')])
    
    #-----< accessSuccess >-----#
    accessSuccess = CLASS(name=u'accessSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _accessSuccess_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    accessSuccess._val = dict([(u'InitiatingMessage', _accessSuccess_val_InitiatingMessage), (u'procedureCode', 39), (u'criticality', u'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name=u'cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([(u'InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), (u'procedureCode', 40), (u'criticality', u'ignore')])
    
    #-----< positioningAssistanceInformationControl >-----#
    positioningAssistanceInformationControl = CLASS(name=u'positioningAssistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningAssistanceInformationControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    positioningAssistanceInformationControl._val = dict([(u'InitiatingMessage', _positioningAssistanceInformationControl_val_InitiatingMessage), (u'procedureCode', 42), (u'criticality', u'ignore')])
    
    #-----< positioningAssistanceInformationFeedback >-----#
    positioningAssistanceInformationFeedback = CLASS(name=u'positioningAssistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningAssistanceInformationFeedback_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    positioningAssistanceInformationFeedback._val = dict([(u'InitiatingMessage', _positioningAssistanceInformationFeedback_val_InitiatingMessage), (u'procedureCode', 43), (u'criticality', u'ignore')])
    
    #-----< positioningMeasurementExchange >-----#
    positioningMeasurementExchange = CLASS(name=u'positioningMeasurementExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _positioningMeasurementExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _positioningMeasurementExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    positioningMeasurementExchange._val = dict([(u'InitiatingMessage', _positioningMeasurementExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _positioningMeasurementExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _positioningMeasurementExchange_val_UnsuccessfulOutcome), (u'procedureCode', 41), (u'criticality', u'reject')])
    
    #-----< positioningMeasurementReport >-----#
    positioningMeasurementReport = CLASS(name=u'positioningMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    positioningMeasurementReport._val = dict([(u'InitiatingMessage', _positioningMeasurementReport_val_InitiatingMessage), (u'procedureCode', 44), (u'criticality', u'ignore')])
    
    #-----< positioningMeasurementAbort >-----#
    positioningMeasurementAbort = CLASS(name=u'positioningMeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementAbort_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    positioningMeasurementAbort._val = dict([(u'InitiatingMessage', _positioningMeasurementAbort_val_InitiatingMessage), (u'procedureCode', 45), (u'criticality', u'ignore')])
    
    #-----< positioningMeasurementFailureIndication >-----#
    positioningMeasurementFailureIndication = CLASS(name=u'positioningMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    positioningMeasurementFailureIndication._val = dict([(u'InitiatingMessage', _positioningMeasurementFailureIndication_val_InitiatingMessage), (u'procedureCode', 46), (u'criticality', u'ignore')])
    
    #-----< positioningMeasurementUpdate >-----#
    positioningMeasurementUpdate = CLASS(name=u'positioningMeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    positioningMeasurementUpdate._val = dict([(u'InitiatingMessage', _positioningMeasurementUpdate_val_InitiatingMessage), (u'procedureCode', 47), (u'criticality', u'ignore')])
    
    #-----< tRPInformationExchange >-----#
    tRPInformationExchange = CLASS(name=u'tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _tRPInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _tRPInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _tRPInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    tRPInformationExchange._val = dict([(u'InitiatingMessage', _tRPInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _tRPInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _tRPInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 48), (u'criticality', u'reject')])
    
    #-----< positioningInformationExchange >-----#
    positioningInformationExchange = CLASS(name=u'positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _positioningInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _positioningInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    positioningInformationExchange._val = dict([(u'InitiatingMessage', _positioningInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _positioningInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _positioningInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 49), (u'criticality', u'reject')])
    
    #-----< positioningActivation >-----#
    positioningActivation = CLASS(name=u'positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningActivation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _positioningActivation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _positioningActivation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    positioningActivation._val = dict([(u'InitiatingMessage', _positioningActivation_val_InitiatingMessage), (u'SuccessfulOutcome', _positioningActivation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _positioningActivation_val_UnsuccessfulOutcome), (u'procedureCode', 50), (u'criticality', u'reject')])
    
    #-----< positioningDeactivation >-----#
    positioningDeactivation = CLASS(name=u'positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningDeactivation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    positioningDeactivation._val = dict([(u'InitiatingMessage', _positioningDeactivation_val_InitiatingMessage), (u'procedureCode', 51), (u'criticality', u'ignore')])
    
    #-----< e-CIDMeasurementInitiation >-----#
    e_CIDMeasurementInitiation = CLASS(name=u'e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _e_CIDMeasurementInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    e_CIDMeasurementInitiation._val = dict([(u'InitiatingMessage', _e_CIDMeasurementInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _e_CIDMeasurementInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome), (u'procedureCode', 52), (u'criticality', u'reject')])
    
    #-----< e-CIDMeasurementFailureIndication >-----#
    e_CIDMeasurementFailureIndication = CLASS(name=u'e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    e_CIDMeasurementFailureIndication._val = dict([(u'InitiatingMessage', _e_CIDMeasurementFailureIndication_val_InitiatingMessage), (u'procedureCode', 53), (u'criticality', u'ignore')])
    
    #-----< e-CIDMeasurementReport >-----#
    e_CIDMeasurementReport = CLASS(name=u'e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    e_CIDMeasurementReport._val = dict([(u'InitiatingMessage', _e_CIDMeasurementReport_val_InitiatingMessage), (u'procedureCode', 54), (u'criticality', u'ignore')])
    
    #-----< e-CIDMeasurementTermination >-----#
    e_CIDMeasurementTermination = CLASS(name=u'e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    e_CIDMeasurementTermination._val = dict([(u'InitiatingMessage', _e_CIDMeasurementTermination_val_InitiatingMessage), (u'procedureCode', 55), (u'criticality', u'ignore')])
    
    #-----< positioningInformationUpdate >-----#
    positioningInformationUpdate = CLASS(name=u'positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningInformationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    positioningInformationUpdate._val = dict([(u'InitiatingMessage', _positioningInformationUpdate_val_InitiatingMessage), (u'procedureCode', 56), (u'criticality', u'ignore')])
    
    _all_ = [
        _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _F1AP_ELEMENTARY_PROCEDURE_procedureCode,
        _F1AP_ELEMENTARY_PROCEDURE_criticality,
        F1AP_ELEMENTARY_PROCEDURE,
        _F1AP_PDU_initiatingMessage,
        _F1AP_PDU_successfulOutcome,
        _F1AP_PDU_unsuccessfulOutcome,
        ___F1AP_PDU_choice_extension_id_tab,
        __F1AP_PDU_choice_extension_id,
        ___F1AP_PDU_choice_extension_criticality_tab,
        __F1AP_PDU_choice_extension_criticality,
        ___F1AP_PDU_choice_extension_value_tab,
        __F1AP_PDU_choice_extension_value,
        _F1AP_PDU_choice_extension,
        F1AP_PDU,
        F1AP_PDU_ExtIEs,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        F1AP_ELEMENTARY_PROCEDURES,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        F1AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21,
        F1AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        f1Setup,
        _f1Setup_val_InitiatingMessage,
        _f1Setup_val_SuccessfulOutcome,
        _f1Setup_val_UnsuccessfulOutcome,
        gNBDUConfigurationUpdate,
        _gNBDUConfigurationUpdate_val_InitiatingMessage,
        _gNBDUConfigurationUpdate_val_SuccessfulOutcome,
        _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome,
        gNBCUConfigurationUpdate,
        _gNBCUConfigurationUpdate_val_InitiatingMessage,
        _gNBCUConfigurationUpdate_val_SuccessfulOutcome,
        _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome,
        uEContextSetup,
        _uEContextSetup_val_InitiatingMessage,
        _uEContextSetup_val_SuccessfulOutcome,
        _uEContextSetup_val_UnsuccessfulOutcome,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uEContextModificationRequired,
        _uEContextModificationRequired_val_InitiatingMessage,
        _uEContextModificationRequired_val_SuccessfulOutcome,
        _uEContextModificationRequired_val_UnsuccessfulOutcome,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        pWSCancel,
        _pWSCancel_val_InitiatingMessage,
        _pWSCancel_val_SuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        initialULRRCMessageTransfer,
        _initialULRRCMessageTransfer_val_InitiatingMessage,
        dLRRCMessageTransfer,
        _dLRRCMessageTransfer_val_InitiatingMessage,
        uLRRCMessageTransfer,
        _uLRRCMessageTransfer_val_InitiatingMessage,
        uEInactivityNotification,
        _uEInactivityNotification_val_InitiatingMessage,
        gNBDUResourceCoordination,
        _gNBDUResourceCoordination_val_InitiatingMessage,
        _gNBDUResourceCoordination_val_SuccessfulOutcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        systemInformationDelivery,
        _systemInformationDelivery_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        notify,
        _notify_val_InitiatingMessage,
        networkAccessRateReduction,
        _networkAccessRateReduction_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        gNBDUStatusIndication,
        _gNBDUStatusIndication_val_InitiatingMessage,
        rRCDeliveryReport,
        _rRCDeliveryReport_val_InitiatingMessage,
        f1Removal,
        _f1Removal_val_InitiatingMessage,
        _f1Removal_val_SuccessfulOutcome,
        _f1Removal_val_UnsuccessfulOutcome,
        traceStart,
        _traceStart_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        dUCURadioInformationTransfer,
        _dUCURadioInformationTransfer_val_InitiatingMessage,
        cUDURadioInformationTransfer,
        _cUDURadioInformationTransfer_val_InitiatingMessage,
        bAPMappingConfiguration,
        _bAPMappingConfiguration_val_InitiatingMessage,
        _bAPMappingConfiguration_val_SuccessfulOutcome,
        _bAPMappingConfiguration_val_UnsuccessfulOutcome,
        gNBDUResourceConfiguration,
        _gNBDUResourceConfiguration_val_InitiatingMessage,
        _gNBDUResourceConfiguration_val_SuccessfulOutcome,
        _gNBDUResourceConfiguration_val_UnsuccessfulOutcome,
        iABTNLAddressAllocation,
        _iABTNLAddressAllocation_val_InitiatingMessage,
        _iABTNLAddressAllocation_val_SuccessfulOutcome,
        _iABTNLAddressAllocation_val_UnsuccessfulOutcome,
        iABUPConfigurationUpdate,
        _iABUPConfigurationUpdate_val_InitiatingMessage,
        _iABUPConfigurationUpdate_val_SuccessfulOutcome,
        _iABUPConfigurationUpdate_val_UnsuccessfulOutcome,
        resourceStatusReportingInitiation,
        _resourceStatusReportingInitiation_val_InitiatingMessage,
        _resourceStatusReportingInitiation_val_SuccessfulOutcome,
        _resourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        resourceStatusReporting,
        _resourceStatusReporting_val_InitiatingMessage,
        accessAndMobilityIndication,
        _accessAndMobilityIndication_val_InitiatingMessage,
        referenceTimeInformationReportingControl,
        _referenceTimeInformationReportingControl_val_InitiatingMessage,
        referenceTimeInformationReport,
        _referenceTimeInformationReport_val_InitiatingMessage,
        accessSuccess,
        _accessSuccess_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        positioningAssistanceInformationControl,
        _positioningAssistanceInformationControl_val_InitiatingMessage,
        positioningAssistanceInformationFeedback,
        _positioningAssistanceInformationFeedback_val_InitiatingMessage,
        positioningMeasurementExchange,
        _positioningMeasurementExchange_val_InitiatingMessage,
        _positioningMeasurementExchange_val_SuccessfulOutcome,
        _positioningMeasurementExchange_val_UnsuccessfulOutcome,
        positioningMeasurementReport,
        _positioningMeasurementReport_val_InitiatingMessage,
        positioningMeasurementAbort,
        _positioningMeasurementAbort_val_InitiatingMessage,
        positioningMeasurementFailureIndication,
        _positioningMeasurementFailureIndication_val_InitiatingMessage,
        positioningMeasurementUpdate,
        _positioningMeasurementUpdate_val_InitiatingMessage,
        tRPInformationExchange,
        _tRPInformationExchange_val_InitiatingMessage,
        _tRPInformationExchange_val_SuccessfulOutcome,
        _tRPInformationExchange_val_UnsuccessfulOutcome,
        positioningInformationExchange,
        _positioningInformationExchange_val_InitiatingMessage,
        _positioningInformationExchange_val_SuccessfulOutcome,
        _positioningInformationExchange_val_UnsuccessfulOutcome,
        positioningActivation,
        _positioningActivation_val_InitiatingMessage,
        _positioningActivation_val_SuccessfulOutcome,
        _positioningActivation_val_UnsuccessfulOutcome,
        positioningDeactivation,
        _positioningDeactivation_val_InitiatingMessage,
        e_CIDMeasurementInitiation,
        _e_CIDMeasurementInitiation_val_InitiatingMessage,
        _e_CIDMeasurementInitiation_val_SuccessfulOutcome,
        _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome,
        e_CIDMeasurementFailureIndication,
        _e_CIDMeasurementFailureIndication_val_InitiatingMessage,
        e_CIDMeasurementReport,
        _e_CIDMeasurementReport_val_InitiatingMessage,
        e_CIDMeasurementTermination,
        _e_CIDMeasurementTermination_val_InitiatingMessage,
        positioningInformationUpdate,
        _positioningInformationUpdate_val_InitiatingMessage,
    ]

init_modules(F1AP_CommonDataTypes, F1AP_Constants, F1AP_Containers, F1AP_IEs, F1AP_PDU_Contents, F1AP_PDU_Descriptions)
