# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class NGAP_CommonDataTypes:

    _name_  = u'NGAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 3]
    
    _obj_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name=u'ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessfull-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class NGAP_Constants:

    _name_  = u'NGAP-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 4]
    
    _obj_ = [
        u'id-AMFConfigurationUpdate',
        u'id-AMFStatusIndication',
        u'id-CellTrafficTrace',
        u'id-DeactivateTrace',
        u'id-DownlinkNASTransport',
        u'id-DownlinkNonUEAssociatedNRPPaTransport',
        u'id-DownlinkRANConfigurationTransfer',
        u'id-DownlinkRANStatusTransfer',
        u'id-DownlinkUEAssociatedNRPPaTransport',
        u'id-ErrorIndication',
        u'id-HandoverCancel',
        u'id-HandoverNotification',
        u'id-HandoverPreparation',
        u'id-HandoverResourceAllocation',
        u'id-InitialContextSetup',
        u'id-InitialUEMessage',
        u'id-LocationReportingControl',
        u'id-LocationReportingFailureIndication',
        u'id-LocationReport',
        u'id-NASNonDeliveryIndication',
        u'id-NGReset',
        u'id-NGSetup',
        u'id-OverloadStart',
        u'id-OverloadStop',
        u'id-Paging',
        u'id-PathSwitchRequest',
        u'id-PDUSessionResourceModify',
        u'id-PDUSessionResourceModifyIndication',
        u'id-PDUSessionResourceRelease',
        u'id-PDUSessionResourceSetup',
        u'id-PDUSessionResourceNotify',
        u'id-PrivateMessage',
        u'id-PWSCancel',
        u'id-PWSFailureIndication',
        u'id-PWSRestartIndication',
        u'id-RANConfigurationUpdate',
        u'id-RerouteNASRequest',
        u'id-RRCInactiveTransitionReport',
        u'id-TraceFailureIndication',
        u'id-TraceStart',
        u'id-UEContextModification',
        u'id-UEContextRelease',
        u'id-UEContextReleaseRequest',
        u'id-UERadioCapabilityCheck',
        u'id-UERadioCapabilityInfoIndication',
        u'id-UETNLABindingRelease',
        u'id-UplinkNASTransport',
        u'id-UplinkNonUEAssociatedNRPPaTransport',
        u'id-UplinkRANConfigurationTransfer',
        u'id-UplinkRANStatusTransfer',
        u'id-UplinkUEAssociatedNRPPaTransport',
        u'id-WriteReplaceWarning',
        u'id-SecondaryRATDataUsageReport',
        u'id-UplinkRIMInformationTransfer',
        u'id-DownlinkRIMInformationTransfer',
        u'id-RetrieveUEInformation',
        u'id-UEInformationTransfer',
        u'id-RANCPRelocationIndication',
        u'id-UEContextResume',
        u'id-UEContextSuspend',
        u'id-UERadioCapabilityIDMapping',
        u'id-HandoverSuccess',
        u'id-UplinkRANEarlyStatusTransfer',
        u'id-DownlinkRANEarlyStatusTransfer',
        u'id-AMFCPRelocationIndication',
        u'id-ConnectionEstablishmentIndication',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofAllowedAreas',
        u'maxnoofAllowedCAGsperPLMN',
        u'maxnoofAllowedS-NSSAIs',
        u'maxnoofBluetoothName',
        u'maxnoofBPLMNs',
        u'maxnoofCAGSperCell',
        u'maxnoofCellIDforMDT',
        u'maxnoofCellIDforWarning',
        u'maxnoofCellinAoI',
        u'maxnoofCellinEAI',
        u'maxnoofCellinTAI',
        u'maxnoofCellsingNB',
        u'maxnoofCellsinngeNB',
        u'maxnoofCellsinUEHistoryInfo',
        u'maxnoofCellsUEMovingTrajectory',
        u'maxnoofDRBs',
        u'maxnoofEmergencyAreaID',
        u'maxnoofEAIforRestart',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofE-RABs',
        u'maxnoofErrors',
        u'maxnoofExtSliceItems',
        u'maxnoofForbTACs',
        u'maxnoofFreqforMDT',
        u'maxnoofMDTPLMNs',
        u'maxnoofMultiConnectivity',
        u'maxnoofMultiConnectivityMinusOne',
        u'maxnoofNeighPCIforMDT',
        u'maxnoofNGConnectionsToReset',
        u'maxnoofNRCellBands',
        u'maxnoofPC5QoSFlows',
        u'maxnoofPDUSessions',
        u'maxnoofPLMNs',
        u'maxnoofQosFlows',
        u'maxnoofQosParaSets',
        u'maxnoofRANNodeinAoI',
        u'maxnoofRecommendedCells',
        u'maxnoofRecommendedRANNodes',
        u'maxnoofAoI',
        u'maxnoofSensorName',
        u'maxnoofServedGUAMIs',
        u'maxnoofSliceItems',
        u'maxnoofTACs',
        u'maxnoofTAforMDT',
        u'maxnoofTAIforInactive',
        u'maxnoofTAIforPaging',
        u'maxnoofTAIforRestart',
        u'maxnoofTAIforWarning',
        u'maxnoofTAIinAoI',
        u'maxnoofTimePeriods',
        u'maxnoofTNLAssociations',
        u'maxnoofWLANName',
        u'maxnoofXnExtTLAs',
        u'maxnoofXnGTP-TLAs',
        u'maxnoofXnTLAs',
        u'maxnoofCandidateCells',
        u'maxNRARFCN',
        u'id-AllowedNSSAI',
        u'id-AMFName',
        u'id-AMFOverloadResponse',
        u'id-AMFSetID',
        u'id-AMF-TNLAssociationFailedToSetupList',
        u'id-AMF-TNLAssociationSetupList',
        u'id-AMF-TNLAssociationToAddList',
        u'id-AMF-TNLAssociationToRemoveList',
        u'id-AMF-TNLAssociationToUpdateList',
        u'id-AMFTrafficLoadReductionIndication',
        u'id-AMF-UE-NGAP-ID',
        u'id-AssistanceDataForPaging',
        u'id-BroadcastCancelledAreaList',
        u'id-BroadcastCompletedAreaList',
        u'id-CancelAllWarningMessages',
        u'id-Cause',
        u'id-CellIDListForRestart',
        u'id-ConcurrentWarningMessageInd',
        u'id-CoreNetworkAssistanceInformationForInactive',
        u'id-CriticalityDiagnostics',
        u'id-DataCodingScheme',
        u'id-DefaultPagingDRX',
        u'id-DirectForwardingPathAvailability',
        u'id-EmergencyAreaIDListForRestart',
        u'id-EmergencyFallbackIndicator',
        u'id-EUTRA-CGI',
        u'id-FiveG-S-TMSI',
        u'id-GlobalRANNodeID',
        u'id-GUAMI',
        u'id-HandoverType',
        u'id-IMSVoiceSupportIndicator',
        u'id-IndexToRFSP',
        u'id-InfoOnRecommendedCellsAndRANNodesForPaging',
        u'id-LocationReportingRequestType',
        u'id-MaskedIMEISV',
        u'id-MessageIdentifier',
        u'id-MobilityRestrictionList',
        u'id-NASC',
        u'id-NAS-PDU',
        u'id-NASSecurityParametersFromNGRAN',
        u'id-NewAMF-UE-NGAP-ID',
        u'id-NewSecurityContextInd',
        u'id-NGAP-Message',
        u'id-NGRAN-CGI',
        u'id-NGRANTraceID',
        u'id-NR-CGI',
        u'id-NRPPa-PDU',
        u'id-NumberOfBroadcastsRequested',
        u'id-OldAMF',
        u'id-OverloadStartNSSAIList',
        u'id-PagingDRX',
        u'id-PagingOrigin',
        u'id-PagingPriority',
        u'id-PDUSessionResourceAdmittedList',
        u'id-PDUSessionResourceFailedToModifyListModRes',
        u'id-PDUSessionResourceFailedToSetupListCxtRes',
        u'id-PDUSessionResourceFailedToSetupListHOAck',
        u'id-PDUSessionResourceFailedToSetupListPSReq',
        u'id-PDUSessionResourceFailedToSetupListSURes',
        u'id-PDUSessionResourceHandoverList',
        u'id-PDUSessionResourceListCxtRelCpl',
        u'id-PDUSessionResourceListHORqd',
        u'id-PDUSessionResourceModifyListModCfm',
        u'id-PDUSessionResourceModifyListModInd',
        u'id-PDUSessionResourceModifyListModReq',
        u'id-PDUSessionResourceModifyListModRes',
        u'id-PDUSessionResourceNotifyList',
        u'id-PDUSessionResourceReleasedListNot',
        u'id-PDUSessionResourceReleasedListPSAck',
        u'id-PDUSessionResourceReleasedListPSFail',
        u'id-PDUSessionResourceReleasedListRelRes',
        u'id-PDUSessionResourceSetupListCxtReq',
        u'id-PDUSessionResourceSetupListCxtRes',
        u'id-PDUSessionResourceSetupListHOReq',
        u'id-PDUSessionResourceSetupListSUReq',
        u'id-PDUSessionResourceSetupListSURes',
        u'id-PDUSessionResourceToBeSwitchedDLList',
        u'id-PDUSessionResourceSwitchedList',
        u'id-PDUSessionResourceToReleaseListHOCmd',
        u'id-PDUSessionResourceToReleaseListRelCmd',
        u'id-PLMNSupportList',
        u'id-PWSFailedCellIDList',
        u'id-RANNodeName',
        u'id-RANPagingPriority',
        u'id-RANStatusTransfer-TransparentContainer',
        u'id-RAN-UE-NGAP-ID',
        u'id-RelativeAMFCapacity',
        u'id-RepetitionPeriod',
        u'id-ResetType',
        u'id-RoutingID',
        u'id-RRCEstablishmentCause',
        u'id-RRCInactiveTransitionReportRequest',
        u'id-RRCState',
        u'id-SecurityContext',
        u'id-SecurityKey',
        u'id-SerialNumber',
        u'id-ServedGUAMIList',
        u'id-SliceSupportList',
        u'id-SONConfigurationTransferDL',
        u'id-SONConfigurationTransferUL',
        u'id-SourceAMF-UE-NGAP-ID',
        u'id-SourceToTarget-TransparentContainer',
        u'id-SupportedTAList',
        u'id-TAIListForPaging',
        u'id-TAIListForRestart',
        u'id-TargetID',
        u'id-TargetToSource-TransparentContainer',
        u'id-TimeToWait',
        u'id-TraceActivation',
        u'id-TraceCollectionEntityIPAddress',
        u'id-UEAggregateMaximumBitRate',
        u'id-UE-associatedLogicalNG-connectionList',
        u'id-UEContextRequest',
        u'id-UE-NGAP-IDs',
        u'id-UEPagingIdentity',
        u'id-UEPresenceInAreaOfInterestList',
        u'id-UERadioCapability',
        u'id-UERadioCapabilityForPaging',
        u'id-UESecurityCapabilities',
        u'id-UnavailableGUAMIList',
        u'id-UserLocationInformation',
        u'id-WarningAreaList',
        u'id-WarningMessageContents',
        u'id-WarningSecurityInfo',
        u'id-WarningType',
        u'id-AdditionalUL-NGU-UP-TNLInformation',
        u'id-DataForwardingNotPossible',
        u'id-DL-NGU-UP-TNLInformation',
        u'id-NetworkInstance',
        u'id-PDUSessionAggregateMaximumBitRate',
        u'id-PDUSessionResourceFailedToModifyListModCfm',
        u'id-PDUSessionResourceFailedToSetupListCxtFail',
        u'id-PDUSessionResourceListCxtRelReq',
        u'id-PDUSessionType',
        u'id-QosFlowAddOrModifyRequestList',
        u'id-QosFlowSetupRequestList',
        u'id-QosFlowToReleaseList',
        u'id-SecurityIndication',
        u'id-UL-NGU-UP-TNLInformation',
        u'id-UL-NGU-UP-TNLModifyList',
        u'id-WarningAreaCoordinates',
        u'id-PDUSessionResourceSecondaryRATUsageList',
        u'id-HandoverFlag',
        u'id-SecondaryRATUsageInformation',
        u'id-PDUSessionResourceReleaseResponseTransfer',
        u'id-RedirectionVoiceFallback',
        u'id-UERetentionInformation',
        u'id-S-NSSAI',
        u'id-PSCellInformation',
        u'id-LastEUTRAN-PLMNIdentity',
        u'id-MaximumIntegrityProtectedDataRate-DL',
        u'id-AdditionalDLForwardingUPTNLInformation',
        u'id-AdditionalDLUPTNLInformationForHOList',
        u'id-AdditionalNGU-UP-TNLInformation',
        u'id-AdditionalDLQosFlowPerTNLInformation',
        u'id-SecurityResult',
        u'id-ENDC-SONConfigurationTransferDL',
        u'id-ENDC-SONConfigurationTransferUL',
        u'id-OldAssociatedQosFlowList-ULendmarkerexpected',
        u'id-CNTypeRestrictionsForEquivalent',
        u'id-CNTypeRestrictionsForServing',
        u'id-NewGUAMI',
        u'id-ULForwarding',
        u'id-ULForwardingUP-TNLInformation',
        u'id-CNAssistedRANTuning',
        u'id-CommonNetworkInstance',
        u'id-NGRAN-TNLAssociationToRemoveList',
        u'id-TNLAssociationTransportLayerAddressNGRAN',
        u'id-EndpointIPAddressAndPort',
        u'id-LocationReportingAdditionalInfo',
        u'id-SourceToTarget-AMFInformationReroute',
        u'id-AdditionalULForwardingUPTNLInformation',
        u'id-SCTP-TLAs',
        u'id-SelectedPLMNIdentity',
        u'id-RIMInformationTransfer',
        u'id-GUAMIType',
        u'id-SRVCCOperationPossible',
        u'id-TargetRNC-ID',
        u'id-RAT-Information',
        u'id-ExtendedRATRestrictionInformation',
        u'id-QosMonitoringRequest',
        u'id-SgNB-UE-X2AP-ID',
        u'id-AdditionalRedundantDL-NGU-UP-TNLInformation',
        u'id-AdditionalRedundantDLQosFlowPerTNLInformation',
        u'id-AdditionalRedundantNGU-UP-TNLInformation',
        u'id-AdditionalRedundantUL-NGU-UP-TNLInformation',
        u'id-CNPacketDelayBudgetDL',
        u'id-CNPacketDelayBudgetUL',
        u'id-ExtendedPacketDelayBudget',
        u'id-RedundantCommonNetworkInstance',
        u'id-RedundantDL-NGU-TNLInformationReused',
        u'id-RedundantDL-NGU-UP-TNLInformation',
        u'id-RedundantDLQosFlowPerTNLInformation',
        u'id-RedundantQosFlowIndicator',
        u'id-RedundantUL-NGU-UP-TNLInformation',
        u'id-TSCTrafficCharacteristics',
        u'id-RedundantPDUSessionInformation',
        u'id-UsedRSNInformation',
        u'id-IAB-Authorized',
        u'id-IAB-Supported',
        u'id-IABNodeIndication',
        u'id-NB-IoT-PagingDRX',
        u'id-NB-IoT-Paging-eDRXInfo',
        u'id-NB-IoT-DefaultPagingDRX',
        u'id-Enhanced-CoverageRestriction',
        u'id-Extended-ConnectedTime',
        u'id-PagingAssisDataforCEcapabUE',
        u'id-WUS-Assistance-Information',
        u'id-UE-DifferentiationInfo',
        u'id-NB-IoT-UEPriority',
        u'id-UL-CP-SecurityInformation',
        u'id-DL-CP-SecurityInformation',
        u'id-TAI',
        u'id-UERadioCapabilityForPagingOfNB-IoT',
        u'id-LTEV2XServicesAuthorized',
        u'id-NRV2XServicesAuthorized',
        u'id-LTEUESidelinkAggregateMaximumBitrate',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-PC5QoSParameters',
        u'id-AlternativeQoSParaSetList',
        u'id-CurrentQoSParaSetIndex',
        u'id-CEmodeBrestricted',
        u'id-PagingeDRXInformation',
        u'id-CEmodeBSupport-Indicator',
        u'id-LTEM-Indication',
        u'id-EndIndication',
        u'id-EDT-Session',
        u'id-UECapabilityInfoRequest',
        u'id-PDUSessionResourceFailedToResumeListRESReq',
        u'id-PDUSessionResourceFailedToResumeListRESRes',
        u'id-PDUSessionResourceSuspendListSUSReq',
        u'id-PDUSessionResourceResumeListRESReq',
        u'id-PDUSessionResourceResumeListRESRes',
        u'id-UE-UP-CIoT-Support',
        u'id-Suspend-Request-Indication',
        u'id-Suspend-Response-Indication',
        u'id-RRC-Resume-Cause',
        u'id-RGLevelWirelineAccessCharacteristics',
        u'id-W-AGFIdentityInformation',
        u'id-GlobalTNGF-ID',
        u'id-GlobalTWIF-ID',
        u'id-GlobalW-AGF-ID',
        u'id-UserLocationInformationW-AGF',
        u'id-UserLocationInformationTNGF',
        u'id-AuthenticatedIndication',
        u'id-TNGFIdentityInformation',
        u'id-TWIFIdentityInformation',
        u'id-UserLocationInformationTWIF',
        u'id-DataForwardingResponseERABList',
        u'id-IntersystemSONConfigurationTransferDL',
        u'id-IntersystemSONConfigurationTransferUL',
        u'id-SONInformationReport',
        u'id-UEHistoryInformationFromTheUE',
        u'id-ManagementBasedMDTPLMNList',
        u'id-MDTConfiguration',
        u'id-PrivacyIndicator',
        u'id-TraceCollectionEntityURI',
        u'id-NPN-Support',
        u'id-NPN-AccessInformation',
        u'id-NPN-PagingAssistanceInformation',
        u'id-NPN-MobilityInformation',
        u'id-TargettoSource-Failure-TransparentContainer',
        u'id-NID',
        u'id-UERadioCapabilityID',
        u'id-UERadioCapability-EUTRA-Format',
        u'id-DAPSRequestInfo',
        u'id-DAPSResponseInfoList',
        u'id-EarlyStatusTransfer-TransparentContainer',
        u'id-NotifySourceNGRANNode',
        u'id-ExtendedSliceSupportList',
        u'id-ExtendedTAISliceSupportList',
        u'id-ConfiguredTACIndication',
        u'id-Extended-RANNodeName',
        u'id-Extended-AMFName',
        u'id-GlobalCable-ID',
        u'id-QosMonitoringReportingFrequency',
        u'id-QosFlowParametersList',
        u'id-QosFlowFeedbackList',
        u'id-BurstArrivalTimeDownlink',
        u'id-ExtendedUEIdentityIndexValue',
        u'id-PduSessionExpectedUEActivityBehaviour',
        u'id-MicoAllPLMN',
        u'id-QosFlowFailedToSetupList',
        u'id-SourceTNLAddrInfo',
        u'id-ExtendedReportIntervalMDT',
        u'id-SourceNodeID',
        u'id-SourceNodeTNLAddrInfo',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-AMFConfigurationUpdate',
        u'id-AMFStatusIndication',
        u'id-CellTrafficTrace',
        u'id-DeactivateTrace',
        u'id-DownlinkNASTransport',
        u'id-DownlinkNonUEAssociatedNRPPaTransport',
        u'id-DownlinkRANConfigurationTransfer',
        u'id-DownlinkRANStatusTransfer',
        u'id-DownlinkUEAssociatedNRPPaTransport',
        u'id-ErrorIndication',
        u'id-HandoverCancel',
        u'id-HandoverNotification',
        u'id-HandoverPreparation',
        u'id-HandoverResourceAllocation',
        u'id-InitialContextSetup',
        u'id-InitialUEMessage',
        u'id-LocationReportingControl',
        u'id-LocationReportingFailureIndication',
        u'id-LocationReport',
        u'id-NASNonDeliveryIndication',
        u'id-NGReset',
        u'id-NGSetup',
        u'id-OverloadStart',
        u'id-OverloadStop',
        u'id-Paging',
        u'id-PathSwitchRequest',
        u'id-PDUSessionResourceModify',
        u'id-PDUSessionResourceModifyIndication',
        u'id-PDUSessionResourceRelease',
        u'id-PDUSessionResourceSetup',
        u'id-PDUSessionResourceNotify',
        u'id-PrivateMessage',
        u'id-PWSCancel',
        u'id-PWSFailureIndication',
        u'id-PWSRestartIndication',
        u'id-RANConfigurationUpdate',
        u'id-RerouteNASRequest',
        u'id-RRCInactiveTransitionReport',
        u'id-TraceFailureIndication',
        u'id-TraceStart',
        u'id-UEContextModification',
        u'id-UEContextRelease',
        u'id-UEContextReleaseRequest',
        u'id-UERadioCapabilityCheck',
        u'id-UERadioCapabilityInfoIndication',
        u'id-UETNLABindingRelease',
        u'id-UplinkNASTransport',
        u'id-UplinkNonUEAssociatedNRPPaTransport',
        u'id-UplinkRANConfigurationTransfer',
        u'id-UplinkRANStatusTransfer',
        u'id-UplinkUEAssociatedNRPPaTransport',
        u'id-WriteReplaceWarning',
        u'id-SecondaryRATDataUsageReport',
        u'id-UplinkRIMInformationTransfer',
        u'id-DownlinkRIMInformationTransfer',
        u'id-RetrieveUEInformation',
        u'id-UEInformationTransfer',
        u'id-RANCPRelocationIndication',
        u'id-UEContextResume',
        u'id-UEContextSuspend',
        u'id-UERadioCapabilityIDMapping',
        u'id-HandoverSuccess',
        u'id-UplinkRANEarlyStatusTransfer',
        u'id-DownlinkRANEarlyStatusTransfer',
        u'id-AMFCPRelocationIndication',
        u'id-ConnectionEstablishmentIndication',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofAllowedAreas',
        u'maxnoofAllowedCAGsperPLMN',
        u'maxnoofAllowedS-NSSAIs',
        u'maxnoofBluetoothName',
        u'maxnoofBPLMNs',
        u'maxnoofCAGSperCell',
        u'maxnoofCellIDforMDT',
        u'maxnoofCellIDforWarning',
        u'maxnoofCellinAoI',
        u'maxnoofCellinEAI',
        u'maxnoofCellinTAI',
        u'maxnoofCellsingNB',
        u'maxnoofCellsinngeNB',
        u'maxnoofCellsinUEHistoryInfo',
        u'maxnoofCellsUEMovingTrajectory',
        u'maxnoofDRBs',
        u'maxnoofEmergencyAreaID',
        u'maxnoofEAIforRestart',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofE-RABs',
        u'maxnoofErrors',
        u'maxnoofExtSliceItems',
        u'maxnoofForbTACs',
        u'maxnoofFreqforMDT',
        u'maxnoofMDTPLMNs',
        u'maxnoofMultiConnectivity',
        u'maxnoofMultiConnectivityMinusOne',
        u'maxnoofNeighPCIforMDT',
        u'maxnoofNGConnectionsToReset',
        u'maxnoofNRCellBands',
        u'maxnoofPC5QoSFlows',
        u'maxnoofPDUSessions',
        u'maxnoofPLMNs',
        u'maxnoofQosFlows',
        u'maxnoofQosParaSets',
        u'maxnoofRANNodeinAoI',
        u'maxnoofRecommendedCells',
        u'maxnoofRecommendedRANNodes',
        u'maxnoofAoI',
        u'maxnoofSensorName',
        u'maxnoofServedGUAMIs',
        u'maxnoofSliceItems',
        u'maxnoofTACs',
        u'maxnoofTAforMDT',
        u'maxnoofTAIforInactive',
        u'maxnoofTAIforPaging',
        u'maxnoofTAIforRestart',
        u'maxnoofTAIforWarning',
        u'maxnoofTAIinAoI',
        u'maxnoofTimePeriods',
        u'maxnoofTNLAssociations',
        u'maxnoofWLANName',
        u'maxnoofXnExtTLAs',
        u'maxnoofXnGTP-TLAs',
        u'maxnoofXnTLAs',
        u'maxnoofCandidateCells',
        u'maxNRARFCN',
        u'id-AllowedNSSAI',
        u'id-AMFName',
        u'id-AMFOverloadResponse',
        u'id-AMFSetID',
        u'id-AMF-TNLAssociationFailedToSetupList',
        u'id-AMF-TNLAssociationSetupList',
        u'id-AMF-TNLAssociationToAddList',
        u'id-AMF-TNLAssociationToRemoveList',
        u'id-AMF-TNLAssociationToUpdateList',
        u'id-AMFTrafficLoadReductionIndication',
        u'id-AMF-UE-NGAP-ID',
        u'id-AssistanceDataForPaging',
        u'id-BroadcastCancelledAreaList',
        u'id-BroadcastCompletedAreaList',
        u'id-CancelAllWarningMessages',
        u'id-Cause',
        u'id-CellIDListForRestart',
        u'id-ConcurrentWarningMessageInd',
        u'id-CoreNetworkAssistanceInformationForInactive',
        u'id-CriticalityDiagnostics',
        u'id-DataCodingScheme',
        u'id-DefaultPagingDRX',
        u'id-DirectForwardingPathAvailability',
        u'id-EmergencyAreaIDListForRestart',
        u'id-EmergencyFallbackIndicator',
        u'id-EUTRA-CGI',
        u'id-FiveG-S-TMSI',
        u'id-GlobalRANNodeID',
        u'id-GUAMI',
        u'id-HandoverType',
        u'id-IMSVoiceSupportIndicator',
        u'id-IndexToRFSP',
        u'id-InfoOnRecommendedCellsAndRANNodesForPaging',
        u'id-LocationReportingRequestType',
        u'id-MaskedIMEISV',
        u'id-MessageIdentifier',
        u'id-MobilityRestrictionList',
        u'id-NASC',
        u'id-NAS-PDU',
        u'id-NASSecurityParametersFromNGRAN',
        u'id-NewAMF-UE-NGAP-ID',
        u'id-NewSecurityContextInd',
        u'id-NGAP-Message',
        u'id-NGRAN-CGI',
        u'id-NGRANTraceID',
        u'id-NR-CGI',
        u'id-NRPPa-PDU',
        u'id-NumberOfBroadcastsRequested',
        u'id-OldAMF',
        u'id-OverloadStartNSSAIList',
        u'id-PagingDRX',
        u'id-PagingOrigin',
        u'id-PagingPriority',
        u'id-PDUSessionResourceAdmittedList',
        u'id-PDUSessionResourceFailedToModifyListModRes',
        u'id-PDUSessionResourceFailedToSetupListCxtRes',
        u'id-PDUSessionResourceFailedToSetupListHOAck',
        u'id-PDUSessionResourceFailedToSetupListPSReq',
        u'id-PDUSessionResourceFailedToSetupListSURes',
        u'id-PDUSessionResourceHandoverList',
        u'id-PDUSessionResourceListCxtRelCpl',
        u'id-PDUSessionResourceListHORqd',
        u'id-PDUSessionResourceModifyListModCfm',
        u'id-PDUSessionResourceModifyListModInd',
        u'id-PDUSessionResourceModifyListModReq',
        u'id-PDUSessionResourceModifyListModRes',
        u'id-PDUSessionResourceNotifyList',
        u'id-PDUSessionResourceReleasedListNot',
        u'id-PDUSessionResourceReleasedListPSAck',
        u'id-PDUSessionResourceReleasedListPSFail',
        u'id-PDUSessionResourceReleasedListRelRes',
        u'id-PDUSessionResourceSetupListCxtReq',
        u'id-PDUSessionResourceSetupListCxtRes',
        u'id-PDUSessionResourceSetupListHOReq',
        u'id-PDUSessionResourceSetupListSUReq',
        u'id-PDUSessionResourceSetupListSURes',
        u'id-PDUSessionResourceToBeSwitchedDLList',
        u'id-PDUSessionResourceSwitchedList',
        u'id-PDUSessionResourceToReleaseListHOCmd',
        u'id-PDUSessionResourceToReleaseListRelCmd',
        u'id-PLMNSupportList',
        u'id-PWSFailedCellIDList',
        u'id-RANNodeName',
        u'id-RANPagingPriority',
        u'id-RANStatusTransfer-TransparentContainer',
        u'id-RAN-UE-NGAP-ID',
        u'id-RelativeAMFCapacity',
        u'id-RepetitionPeriod',
        u'id-ResetType',
        u'id-RoutingID',
        u'id-RRCEstablishmentCause',
        u'id-RRCInactiveTransitionReportRequest',
        u'id-RRCState',
        u'id-SecurityContext',
        u'id-SecurityKey',
        u'id-SerialNumber',
        u'id-ServedGUAMIList',
        u'id-SliceSupportList',
        u'id-SONConfigurationTransferDL',
        u'id-SONConfigurationTransferUL',
        u'id-SourceAMF-UE-NGAP-ID',
        u'id-SourceToTarget-TransparentContainer',
        u'id-SupportedTAList',
        u'id-TAIListForPaging',
        u'id-TAIListForRestart',
        u'id-TargetID',
        u'id-TargetToSource-TransparentContainer',
        u'id-TimeToWait',
        u'id-TraceActivation',
        u'id-TraceCollectionEntityIPAddress',
        u'id-UEAggregateMaximumBitRate',
        u'id-UE-associatedLogicalNG-connectionList',
        u'id-UEContextRequest',
        u'id-UE-NGAP-IDs',
        u'id-UEPagingIdentity',
        u'id-UEPresenceInAreaOfInterestList',
        u'id-UERadioCapability',
        u'id-UERadioCapabilityForPaging',
        u'id-UESecurityCapabilities',
        u'id-UnavailableGUAMIList',
        u'id-UserLocationInformation',
        u'id-WarningAreaList',
        u'id-WarningMessageContents',
        u'id-WarningSecurityInfo',
        u'id-WarningType',
        u'id-AdditionalUL-NGU-UP-TNLInformation',
        u'id-DataForwardingNotPossible',
        u'id-DL-NGU-UP-TNLInformation',
        u'id-NetworkInstance',
        u'id-PDUSessionAggregateMaximumBitRate',
        u'id-PDUSessionResourceFailedToModifyListModCfm',
        u'id-PDUSessionResourceFailedToSetupListCxtFail',
        u'id-PDUSessionResourceListCxtRelReq',
        u'id-PDUSessionType',
        u'id-QosFlowAddOrModifyRequestList',
        u'id-QosFlowSetupRequestList',
        u'id-QosFlowToReleaseList',
        u'id-SecurityIndication',
        u'id-UL-NGU-UP-TNLInformation',
        u'id-UL-NGU-UP-TNLModifyList',
        u'id-WarningAreaCoordinates',
        u'id-PDUSessionResourceSecondaryRATUsageList',
        u'id-HandoverFlag',
        u'id-SecondaryRATUsageInformation',
        u'id-PDUSessionResourceReleaseResponseTransfer',
        u'id-RedirectionVoiceFallback',
        u'id-UERetentionInformation',
        u'id-S-NSSAI',
        u'id-PSCellInformation',
        u'id-LastEUTRAN-PLMNIdentity',
        u'id-MaximumIntegrityProtectedDataRate-DL',
        u'id-AdditionalDLForwardingUPTNLInformation',
        u'id-AdditionalDLUPTNLInformationForHOList',
        u'id-AdditionalNGU-UP-TNLInformation',
        u'id-AdditionalDLQosFlowPerTNLInformation',
        u'id-SecurityResult',
        u'id-ENDC-SONConfigurationTransferDL',
        u'id-ENDC-SONConfigurationTransferUL',
        u'id-OldAssociatedQosFlowList-ULendmarkerexpected',
        u'id-CNTypeRestrictionsForEquivalent',
        u'id-CNTypeRestrictionsForServing',
        u'id-NewGUAMI',
        u'id-ULForwarding',
        u'id-ULForwardingUP-TNLInformation',
        u'id-CNAssistedRANTuning',
        u'id-CommonNetworkInstance',
        u'id-NGRAN-TNLAssociationToRemoveList',
        u'id-TNLAssociationTransportLayerAddressNGRAN',
        u'id-EndpointIPAddressAndPort',
        u'id-LocationReportingAdditionalInfo',
        u'id-SourceToTarget-AMFInformationReroute',
        u'id-AdditionalULForwardingUPTNLInformation',
        u'id-SCTP-TLAs',
        u'id-SelectedPLMNIdentity',
        u'id-RIMInformationTransfer',
        u'id-GUAMIType',
        u'id-SRVCCOperationPossible',
        u'id-TargetRNC-ID',
        u'id-RAT-Information',
        u'id-ExtendedRATRestrictionInformation',
        u'id-QosMonitoringRequest',
        u'id-SgNB-UE-X2AP-ID',
        u'id-AdditionalRedundantDL-NGU-UP-TNLInformation',
        u'id-AdditionalRedundantDLQosFlowPerTNLInformation',
        u'id-AdditionalRedundantNGU-UP-TNLInformation',
        u'id-AdditionalRedundantUL-NGU-UP-TNLInformation',
        u'id-CNPacketDelayBudgetDL',
        u'id-CNPacketDelayBudgetUL',
        u'id-ExtendedPacketDelayBudget',
        u'id-RedundantCommonNetworkInstance',
        u'id-RedundantDL-NGU-TNLInformationReused',
        u'id-RedundantDL-NGU-UP-TNLInformation',
        u'id-RedundantDLQosFlowPerTNLInformation',
        u'id-RedundantQosFlowIndicator',
        u'id-RedundantUL-NGU-UP-TNLInformation',
        u'id-TSCTrafficCharacteristics',
        u'id-RedundantPDUSessionInformation',
        u'id-UsedRSNInformation',
        u'id-IAB-Authorized',
        u'id-IAB-Supported',
        u'id-IABNodeIndication',
        u'id-NB-IoT-PagingDRX',
        u'id-NB-IoT-Paging-eDRXInfo',
        u'id-NB-IoT-DefaultPagingDRX',
        u'id-Enhanced-CoverageRestriction',
        u'id-Extended-ConnectedTime',
        u'id-PagingAssisDataforCEcapabUE',
        u'id-WUS-Assistance-Information',
        u'id-UE-DifferentiationInfo',
        u'id-NB-IoT-UEPriority',
        u'id-UL-CP-SecurityInformation',
        u'id-DL-CP-SecurityInformation',
        u'id-TAI',
        u'id-UERadioCapabilityForPagingOfNB-IoT',
        u'id-LTEV2XServicesAuthorized',
        u'id-NRV2XServicesAuthorized',
        u'id-LTEUESidelinkAggregateMaximumBitrate',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-PC5QoSParameters',
        u'id-AlternativeQoSParaSetList',
        u'id-CurrentQoSParaSetIndex',
        u'id-CEmodeBrestricted',
        u'id-PagingeDRXInformation',
        u'id-CEmodeBSupport-Indicator',
        u'id-LTEM-Indication',
        u'id-EndIndication',
        u'id-EDT-Session',
        u'id-UECapabilityInfoRequest',
        u'id-PDUSessionResourceFailedToResumeListRESReq',
        u'id-PDUSessionResourceFailedToResumeListRESRes',
        u'id-PDUSessionResourceSuspendListSUSReq',
        u'id-PDUSessionResourceResumeListRESReq',
        u'id-PDUSessionResourceResumeListRESRes',
        u'id-UE-UP-CIoT-Support',
        u'id-Suspend-Request-Indication',
        u'id-Suspend-Response-Indication',
        u'id-RRC-Resume-Cause',
        u'id-RGLevelWirelineAccessCharacteristics',
        u'id-W-AGFIdentityInformation',
        u'id-GlobalTNGF-ID',
        u'id-GlobalTWIF-ID',
        u'id-GlobalW-AGF-ID',
        u'id-UserLocationInformationW-AGF',
        u'id-UserLocationInformationTNGF',
        u'id-AuthenticatedIndication',
        u'id-TNGFIdentityInformation',
        u'id-TWIFIdentityInformation',
        u'id-UserLocationInformationTWIF',
        u'id-DataForwardingResponseERABList',
        u'id-IntersystemSONConfigurationTransferDL',
        u'id-IntersystemSONConfigurationTransferUL',
        u'id-SONInformationReport',
        u'id-UEHistoryInformationFromTheUE',
        u'id-ManagementBasedMDTPLMNList',
        u'id-MDTConfiguration',
        u'id-PrivacyIndicator',
        u'id-TraceCollectionEntityURI',
        u'id-NPN-Support',
        u'id-NPN-AccessInformation',
        u'id-NPN-PagingAssistanceInformation',
        u'id-NPN-MobilityInformation',
        u'id-TargettoSource-Failure-TransparentContainer',
        u'id-NID',
        u'id-UERadioCapabilityID',
        u'id-UERadioCapability-EUTRA-Format',
        u'id-DAPSRequestInfo',
        u'id-DAPSResponseInfoList',
        u'id-EarlyStatusTransfer-TransparentContainer',
        u'id-NotifySourceNGRANNode',
        u'id-ExtendedSliceSupportList',
        u'id-ExtendedTAISliceSupportList',
        u'id-ConfiguredTACIndication',
        u'id-Extended-RANNodeName',
        u'id-Extended-AMFName',
        u'id-GlobalCable-ID',
        u'id-QosMonitoringReportingFrequency',
        u'id-QosFlowParametersList',
        u'id-QosFlowFeedbackList',
        u'id-BurstArrivalTimeDownlink',
        u'id-ExtendedUEIdentityIndexValue',
        u'id-PduSessionExpectedUEActivityBehaviour',
        u'id-MicoAllPLMN',
        u'id-QosFlowFailedToSetupList',
        u'id-SourceTNLAddrInfo',
        u'id-ExtendedReportIntervalMDT',
        u'id-SourceNodeID',
        u'id-SourceNodeTNLAddrInfo',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-AMFConfigurationUpdate >-----#
    id_AMFConfigurationUpdate = INT(name=u'id-AMFConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFConfigurationUpdate._val = 0
    
    #-----< id-AMFStatusIndication >-----#
    id_AMFStatusIndication = INT(name=u'id-AMFStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFStatusIndication._val = 1
    
    #-----< id-CellTrafficTrace >-----#
    id_CellTrafficTrace = INT(name=u'id-CellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_CellTrafficTrace._val = 2
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name=u'id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 3
    
    #-----< id-DownlinkNASTransport >-----#
    id_DownlinkNASTransport = INT(name=u'id-DownlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkNASTransport._val = 4
    
    #-----< id-DownlinkNonUEAssociatedNRPPaTransport >-----#
    id_DownlinkNonUEAssociatedNRPPaTransport = INT(name=u'id-DownlinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkNonUEAssociatedNRPPaTransport._val = 5
    
    #-----< id-DownlinkRANConfigurationTransfer >-----#
    id_DownlinkRANConfigurationTransfer = INT(name=u'id-DownlinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANConfigurationTransfer._val = 6
    
    #-----< id-DownlinkRANStatusTransfer >-----#
    id_DownlinkRANStatusTransfer = INT(name=u'id-DownlinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANStatusTransfer._val = 7
    
    #-----< id-DownlinkUEAssociatedNRPPaTransport >-----#
    id_DownlinkUEAssociatedNRPPaTransport = INT(name=u'id-DownlinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkUEAssociatedNRPPaTransport._val = 8
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name=u'id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 9
    
    #-----< id-HandoverCancel >-----#
    id_HandoverCancel = INT(name=u'id-HandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverCancel._val = 10
    
    #-----< id-HandoverNotification >-----#
    id_HandoverNotification = INT(name=u'id-HandoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverNotification._val = 11
    
    #-----< id-HandoverPreparation >-----#
    id_HandoverPreparation = INT(name=u'id-HandoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverPreparation._val = 12
    
    #-----< id-HandoverResourceAllocation >-----#
    id_HandoverResourceAllocation = INT(name=u'id-HandoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverResourceAllocation._val = 13
    
    #-----< id-InitialContextSetup >-----#
    id_InitialContextSetup = INT(name=u'id-InitialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_InitialContextSetup._val = 14
    
    #-----< id-InitialUEMessage >-----#
    id_InitialUEMessage = INT(name=u'id-InitialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_InitialUEMessage._val = 15
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name=u'id-LocationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingControl._val = 16
    
    #-----< id-LocationReportingFailureIndication >-----#
    id_LocationReportingFailureIndication = INT(name=u'id-LocationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingFailureIndication._val = 17
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name=u'id-LocationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReport._val = 18
    
    #-----< id-NASNonDeliveryIndication >-----#
    id_NASNonDeliveryIndication = INT(name=u'id-NASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NASNonDeliveryIndication._val = 19
    
    #-----< id-NGReset >-----#
    id_NGReset = INT(name=u'id-NGReset', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NGReset._val = 20
    
    #-----< id-NGSetup >-----#
    id_NGSetup = INT(name=u'id-NGSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NGSetup._val = 21
    
    #-----< id-OverloadStart >-----#
    id_OverloadStart = INT(name=u'id-OverloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStart._val = 22
    
    #-----< id-OverloadStop >-----#
    id_OverloadStop = INT(name=u'id-OverloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStop._val = 23
    
    #-----< id-Paging >-----#
    id_Paging = INT(name=u'id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 24
    
    #-----< id-PathSwitchRequest >-----#
    id_PathSwitchRequest = INT(name=u'id-PathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PathSwitchRequest._val = 25
    
    #-----< id-PDUSessionResourceModify >-----#
    id_PDUSessionResourceModify = INT(name=u'id-PDUSessionResourceModify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceModify._val = 26
    
    #-----< id-PDUSessionResourceModifyIndication >-----#
    id_PDUSessionResourceModifyIndication = INT(name=u'id-PDUSessionResourceModifyIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceModifyIndication._val = 27
    
    #-----< id-PDUSessionResourceRelease >-----#
    id_PDUSessionResourceRelease = INT(name=u'id-PDUSessionResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceRelease._val = 28
    
    #-----< id-PDUSessionResourceSetup >-----#
    id_PDUSessionResourceSetup = INT(name=u'id-PDUSessionResourceSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceSetup._val = 29
    
    #-----< id-PDUSessionResourceNotify >-----#
    id_PDUSessionResourceNotify = INT(name=u'id-PDUSessionResourceNotify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceNotify._val = 30
    
    #-----< id-PrivateMessage >-----#
    id_PrivateMessage = INT(name=u'id-PrivateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PrivateMessage._val = 31
    
    #-----< id-PWSCancel >-----#
    id_PWSCancel = INT(name=u'id-PWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSCancel._val = 32
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name=u'id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 33
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name=u'id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 34
    
    #-----< id-RANConfigurationUpdate >-----#
    id_RANConfigurationUpdate = INT(name=u'id-RANConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RANConfigurationUpdate._val = 35
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name=u'id-RerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RerouteNASRequest._val = 36
    
    #-----< id-RRCInactiveTransitionReport >-----#
    id_RRCInactiveTransitionReport = INT(name=u'id-RRCInactiveTransitionReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RRCInactiveTransitionReport._val = 37
    
    #-----< id-TraceFailureIndication >-----#
    id_TraceFailureIndication = INT(name=u'id-TraceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_TraceFailureIndication._val = 38
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name=u'id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 39
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name=u'id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 40
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name=u'id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 41
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name=u'id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 42
    
    #-----< id-UERadioCapabilityCheck >-----#
    id_UERadioCapabilityCheck = INT(name=u'id-UERadioCapabilityCheck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityCheck._val = 43
    
    #-----< id-UERadioCapabilityInfoIndication >-----#
    id_UERadioCapabilityInfoIndication = INT(name=u'id-UERadioCapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityInfoIndication._val = 44
    
    #-----< id-UETNLABindingRelease >-----#
    id_UETNLABindingRelease = INT(name=u'id-UETNLABindingRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UETNLABindingRelease._val = 45
    
    #-----< id-UplinkNASTransport >-----#
    id_UplinkNASTransport = INT(name=u'id-UplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkNASTransport._val = 46
    
    #-----< id-UplinkNonUEAssociatedNRPPaTransport >-----#
    id_UplinkNonUEAssociatedNRPPaTransport = INT(name=u'id-UplinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkNonUEAssociatedNRPPaTransport._val = 47
    
    #-----< id-UplinkRANConfigurationTransfer >-----#
    id_UplinkRANConfigurationTransfer = INT(name=u'id-UplinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANConfigurationTransfer._val = 48
    
    #-----< id-UplinkRANStatusTransfer >-----#
    id_UplinkRANStatusTransfer = INT(name=u'id-UplinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANStatusTransfer._val = 49
    
    #-----< id-UplinkUEAssociatedNRPPaTransport >-----#
    id_UplinkUEAssociatedNRPPaTransport = INT(name=u'id-UplinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkUEAssociatedNRPPaTransport._val = 50
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name=u'id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 51
    
    #-----< id-SecondaryRATDataUsageReport >-----#
    id_SecondaryRATDataUsageReport = INT(name=u'id-SecondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_SecondaryRATDataUsageReport._val = 52
    
    #-----< id-UplinkRIMInformationTransfer >-----#
    id_UplinkRIMInformationTransfer = INT(name=u'id-UplinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRIMInformationTransfer._val = 53
    
    #-----< id-DownlinkRIMInformationTransfer >-----#
    id_DownlinkRIMInformationTransfer = INT(name=u'id-DownlinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRIMInformationTransfer._val = 54
    
    #-----< id-RetrieveUEInformation >-----#
    id_RetrieveUEInformation = INT(name=u'id-RetrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RetrieveUEInformation._val = 55
    
    #-----< id-UEInformationTransfer >-----#
    id_UEInformationTransfer = INT(name=u'id-UEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEInformationTransfer._val = 56
    
    #-----< id-RANCPRelocationIndication >-----#
    id_RANCPRelocationIndication = INT(name=u'id-RANCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RANCPRelocationIndication._val = 57
    
    #-----< id-UEContextResume >-----#
    id_UEContextResume = INT(name=u'id-UEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextResume._val = 58
    
    #-----< id-UEContextSuspend >-----#
    id_UEContextSuspend = INT(name=u'id-UEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSuspend._val = 59
    
    #-----< id-UERadioCapabilityIDMapping >-----#
    id_UERadioCapabilityIDMapping = INT(name=u'id-UERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityIDMapping._val = 60
    
    #-----< id-HandoverSuccess >-----#
    id_HandoverSuccess = INT(name=u'id-HandoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverSuccess._val = 61
    
    #-----< id-UplinkRANEarlyStatusTransfer >-----#
    id_UplinkRANEarlyStatusTransfer = INT(name=u'id-UplinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANEarlyStatusTransfer._val = 62
    
    #-----< id-DownlinkRANEarlyStatusTransfer >-----#
    id_DownlinkRANEarlyStatusTransfer = INT(name=u'id-DownlinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANEarlyStatusTransfer._val = 63
    
    #-----< id-AMFCPRelocationIndication >-----#
    id_AMFCPRelocationIndication = INT(name=u'id-AMFCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFCPRelocationIndication._val = 64
    
    #-----< id-ConnectionEstablishmentIndication >-----#
    id_ConnectionEstablishmentIndication = INT(name=u'id-ConnectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionEstablishmentIndication._val = 65
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofAllowedAreas >-----#
    maxnoofAllowedAreas = INT(name=u'maxnoofAllowedAreas', mode=MODE_VALUE)
    maxnoofAllowedAreas._val = 16
    
    #-----< maxnoofAllowedCAGsperPLMN >-----#
    maxnoofAllowedCAGsperPLMN = INT(name=u'maxnoofAllowedCAGsperPLMN', mode=MODE_VALUE)
    maxnoofAllowedCAGsperPLMN._val = 256
    
    #-----< maxnoofAllowedS-NSSAIs >-----#
    maxnoofAllowedS_NSSAIs = INT(name=u'maxnoofAllowedS-NSSAIs', mode=MODE_VALUE)
    maxnoofAllowedS_NSSAIs._val = 8
    
    #-----< maxnoofBluetoothName >-----#
    maxnoofBluetoothName = INT(name=u'maxnoofBluetoothName', mode=MODE_VALUE)
    maxnoofBluetoothName._val = 4
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name=u'maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 12
    
    #-----< maxnoofCAGSperCell >-----#
    maxnoofCAGSperCell = INT(name=u'maxnoofCAGSperCell', mode=MODE_VALUE)
    maxnoofCAGSperCell._val = 64
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name=u'maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofCellIDforWarning >-----#
    maxnoofCellIDforWarning = INT(name=u'maxnoofCellIDforWarning', mode=MODE_VALUE)
    maxnoofCellIDforWarning._val = 65535
    
    #-----< maxnoofCellinAoI >-----#
    maxnoofCellinAoI = INT(name=u'maxnoofCellinAoI', mode=MODE_VALUE)
    maxnoofCellinAoI._val = 256
    
    #-----< maxnoofCellinEAI >-----#
    maxnoofCellinEAI = INT(name=u'maxnoofCellinEAI', mode=MODE_VALUE)
    maxnoofCellinEAI._val = 65535
    
    #-----< maxnoofCellinTAI >-----#
    maxnoofCellinTAI = INT(name=u'maxnoofCellinTAI', mode=MODE_VALUE)
    maxnoofCellinTAI._val = 65535
    
    #-----< maxnoofCellsingNB >-----#
    maxnoofCellsingNB = INT(name=u'maxnoofCellsingNB', mode=MODE_VALUE)
    maxnoofCellsingNB._val = 16384
    
    #-----< maxnoofCellsinngeNB >-----#
    maxnoofCellsinngeNB = INT(name=u'maxnoofCellsinngeNB', mode=MODE_VALUE)
    maxnoofCellsinngeNB._val = 256
    
    #-----< maxnoofCellsinUEHistoryInfo >-----#
    maxnoofCellsinUEHistoryInfo = INT(name=u'maxnoofCellsinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofCellsinUEHistoryInfo._val = 16
    
    #-----< maxnoofCellsUEMovingTrajectory >-----#
    maxnoofCellsUEMovingTrajectory = INT(name=u'maxnoofCellsUEMovingTrajectory', mode=MODE_VALUE)
    maxnoofCellsUEMovingTrajectory._val = 16
    
    #-----< maxnoofDRBs >-----#
    maxnoofDRBs = INT(name=u'maxnoofDRBs', mode=MODE_VALUE)
    maxnoofDRBs._val = 32
    
    #-----< maxnoofEmergencyAreaID >-----#
    maxnoofEmergencyAreaID = INT(name=u'maxnoofEmergencyAreaID', mode=MODE_VALUE)
    maxnoofEmergencyAreaID._val = 65535
    
    #-----< maxnoofEAIforRestart >-----#
    maxnoofEAIforRestart = INT(name=u'maxnoofEAIforRestart', mode=MODE_VALUE)
    maxnoofEAIforRestart._val = 256
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name=u'maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name=u'maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofE-RABs >-----#
    maxnoofE_RABs = INT(name=u'maxnoofE-RABs', mode=MODE_VALUE)
    maxnoofE_RABs._val = 256
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name=u'maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofExtSliceItems >-----#
    maxnoofExtSliceItems = INT(name=u'maxnoofExtSliceItems', mode=MODE_VALUE)
    maxnoofExtSliceItems._val = 65535
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name=u'maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofFreqforMDT >-----#
    maxnoofFreqforMDT = INT(name=u'maxnoofFreqforMDT', mode=MODE_VALUE)
    maxnoofFreqforMDT._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name=u'maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofMultiConnectivity >-----#
    maxnoofMultiConnectivity = INT(name=u'maxnoofMultiConnectivity', mode=MODE_VALUE)
    maxnoofMultiConnectivity._val = 4
    
    #-----< maxnoofMultiConnectivityMinusOne >-----#
    maxnoofMultiConnectivityMinusOne = INT(name=u'maxnoofMultiConnectivityMinusOne', mode=MODE_VALUE)
    maxnoofMultiConnectivityMinusOne._val = 3
    
    #-----< maxnoofNeighPCIforMDT >-----#
    maxnoofNeighPCIforMDT = INT(name=u'maxnoofNeighPCIforMDT', mode=MODE_VALUE)
    maxnoofNeighPCIforMDT._val = 32
    
    #-----< maxnoofNGConnectionsToReset >-----#
    maxnoofNGConnectionsToReset = INT(name=u'maxnoofNGConnectionsToReset', mode=MODE_VALUE)
    maxnoofNGConnectionsToReset._val = 65536
    
    #-----< maxnoofNRCellBands >-----#
    maxnoofNRCellBands = INT(name=u'maxnoofNRCellBands', mode=MODE_VALUE)
    maxnoofNRCellBands._val = 32
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name=u'maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnoofPDUSessions >-----#
    maxnoofPDUSessions = INT(name=u'maxnoofPDUSessions', mode=MODE_VALUE)
    maxnoofPDUSessions._val = 256
    
    #-----< maxnoofPLMNs >-----#
    maxnoofPLMNs = INT(name=u'maxnoofPLMNs', mode=MODE_VALUE)
    maxnoofPLMNs._val = 12
    
    #-----< maxnoofQosFlows >-----#
    maxnoofQosFlows = INT(name=u'maxnoofQosFlows', mode=MODE_VALUE)
    maxnoofQosFlows._val = 64
    
    #-----< maxnoofQosParaSets >-----#
    maxnoofQosParaSets = INT(name=u'maxnoofQosParaSets', mode=MODE_VALUE)
    maxnoofQosParaSets._val = 8
    
    #-----< maxnoofRANNodeinAoI >-----#
    maxnoofRANNodeinAoI = INT(name=u'maxnoofRANNodeinAoI', mode=MODE_VALUE)
    maxnoofRANNodeinAoI._val = 64
    
    #-----< maxnoofRecommendedCells >-----#
    maxnoofRecommendedCells = INT(name=u'maxnoofRecommendedCells', mode=MODE_VALUE)
    maxnoofRecommendedCells._val = 16
    
    #-----< maxnoofRecommendedRANNodes >-----#
    maxnoofRecommendedRANNodes = INT(name=u'maxnoofRecommendedRANNodes', mode=MODE_VALUE)
    maxnoofRecommendedRANNodes._val = 16
    
    #-----< maxnoofAoI >-----#
    maxnoofAoI = INT(name=u'maxnoofAoI', mode=MODE_VALUE)
    maxnoofAoI._val = 64
    
    #-----< maxnoofSensorName >-----#
    maxnoofSensorName = INT(name=u'maxnoofSensorName', mode=MODE_VALUE)
    maxnoofSensorName._val = 3
    
    #-----< maxnoofServedGUAMIs >-----#
    maxnoofServedGUAMIs = INT(name=u'maxnoofServedGUAMIs', mode=MODE_VALUE)
    maxnoofServedGUAMIs._val = 256
    
    #-----< maxnoofSliceItems >-----#
    maxnoofSliceItems = INT(name=u'maxnoofSliceItems', mode=MODE_VALUE)
    maxnoofSliceItems._val = 1024
    
    #-----< maxnoofTACs >-----#
    maxnoofTACs = INT(name=u'maxnoofTACs', mode=MODE_VALUE)
    maxnoofTACs._val = 256
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name=u'maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofTAIforInactive >-----#
    maxnoofTAIforInactive = INT(name=u'maxnoofTAIforInactive', mode=MODE_VALUE)
    maxnoofTAIforInactive._val = 16
    
    #-----< maxnoofTAIforPaging >-----#
    maxnoofTAIforPaging = INT(name=u'maxnoofTAIforPaging', mode=MODE_VALUE)
    maxnoofTAIforPaging._val = 16
    
    #-----< maxnoofTAIforRestart >-----#
    maxnoofTAIforRestart = INT(name=u'maxnoofTAIforRestart', mode=MODE_VALUE)
    maxnoofTAIforRestart._val = 2048
    
    #-----< maxnoofTAIforWarning >-----#
    maxnoofTAIforWarning = INT(name=u'maxnoofTAIforWarning', mode=MODE_VALUE)
    maxnoofTAIforWarning._val = 65535
    
    #-----< maxnoofTAIinAoI >-----#
    maxnoofTAIinAoI = INT(name=u'maxnoofTAIinAoI', mode=MODE_VALUE)
    maxnoofTAIinAoI._val = 16
    
    #-----< maxnoofTimePeriods >-----#
    maxnoofTimePeriods = INT(name=u'maxnoofTimePeriods', mode=MODE_VALUE)
    maxnoofTimePeriods._val = 2
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name=u'maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofWLANName >-----#
    maxnoofWLANName = INT(name=u'maxnoofWLANName', mode=MODE_VALUE)
    maxnoofWLANName._val = 4
    
    #-----< maxnoofXnExtTLAs >-----#
    maxnoofXnExtTLAs = INT(name=u'maxnoofXnExtTLAs', mode=MODE_VALUE)
    maxnoofXnExtTLAs._val = 16
    
    #-----< maxnoofXnGTP-TLAs >-----#
    maxnoofXnGTP_TLAs = INT(name=u'maxnoofXnGTP-TLAs', mode=MODE_VALUE)
    maxnoofXnGTP_TLAs._val = 16
    
    #-----< maxnoofXnTLAs >-----#
    maxnoofXnTLAs = INT(name=u'maxnoofXnTLAs', mode=MODE_VALUE)
    maxnoofXnTLAs._val = 2
    
    #-----< maxnoofCandidateCells >-----#
    maxnoofCandidateCells = INT(name=u'maxnoofCandidateCells', mode=MODE_VALUE)
    maxnoofCandidateCells._val = 32
    
    #-----< maxNRARFCN >-----#
    maxNRARFCN = INT(name=u'maxNRARFCN', mode=MODE_VALUE)
    maxNRARFCN._val = 3279165
    
    #-----< id-AllowedNSSAI >-----#
    id_AllowedNSSAI = INT(name=u'id-AllowedNSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AllowedNSSAI._val = 0
    
    #-----< id-AMFName >-----#
    id_AMFName = INT(name=u'id-AMFName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFName._val = 1
    
    #-----< id-AMFOverloadResponse >-----#
    id_AMFOverloadResponse = INT(name=u'id-AMFOverloadResponse', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFOverloadResponse._val = 2
    
    #-----< id-AMFSetID >-----#
    id_AMFSetID = INT(name=u'id-AMFSetID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFSetID._val = 3
    
    #-----< id-AMF-TNLAssociationFailedToSetupList >-----#
    id_AMF_TNLAssociationFailedToSetupList = INT(name=u'id-AMF-TNLAssociationFailedToSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationFailedToSetupList._val = 4
    
    #-----< id-AMF-TNLAssociationSetupList >-----#
    id_AMF_TNLAssociationSetupList = INT(name=u'id-AMF-TNLAssociationSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationSetupList._val = 5
    
    #-----< id-AMF-TNLAssociationToAddList >-----#
    id_AMF_TNLAssociationToAddList = INT(name=u'id-AMF-TNLAssociationToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToAddList._val = 6
    
    #-----< id-AMF-TNLAssociationToRemoveList >-----#
    id_AMF_TNLAssociationToRemoveList = INT(name=u'id-AMF-TNLAssociationToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToRemoveList._val = 7
    
    #-----< id-AMF-TNLAssociationToUpdateList >-----#
    id_AMF_TNLAssociationToUpdateList = INT(name=u'id-AMF-TNLAssociationToUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToUpdateList._val = 8
    
    #-----< id-AMFTrafficLoadReductionIndication >-----#
    id_AMFTrafficLoadReductionIndication = INT(name=u'id-AMFTrafficLoadReductionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFTrafficLoadReductionIndication._val = 9
    
    #-----< id-AMF-UE-NGAP-ID >-----#
    id_AMF_UE_NGAP_ID = INT(name=u'id-AMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_UE_NGAP_ID._val = 10
    
    #-----< id-AssistanceDataForPaging >-----#
    id_AssistanceDataForPaging = INT(name=u'id-AssistanceDataForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceDataForPaging._val = 11
    
    #-----< id-BroadcastCancelledAreaList >-----#
    id_BroadcastCancelledAreaList = INT(name=u'id-BroadcastCancelledAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCancelledAreaList._val = 12
    
    #-----< id-BroadcastCompletedAreaList >-----#
    id_BroadcastCompletedAreaList = INT(name=u'id-BroadcastCompletedAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCompletedAreaList._val = 13
    
    #-----< id-CancelAllWarningMessages >-----#
    id_CancelAllWarningMessages = INT(name=u'id-CancelAllWarningMessages', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CancelAllWarningMessages._val = 14
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 15
    
    #-----< id-CellIDListForRestart >-----#
    id_CellIDListForRestart = INT(name=u'id-CellIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIDListForRestart._val = 16
    
    #-----< id-ConcurrentWarningMessageInd >-----#
    id_ConcurrentWarningMessageInd = INT(name=u'id-ConcurrentWarningMessageInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConcurrentWarningMessageInd._val = 17
    
    #-----< id-CoreNetworkAssistanceInformationForInactive >-----#
    id_CoreNetworkAssistanceInformationForInactive = INT(name=u'id-CoreNetworkAssistanceInformationForInactive', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoreNetworkAssistanceInformationForInactive._val = 18
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 19
    
    #-----< id-DataCodingScheme >-----#
    id_DataCodingScheme = INT(name=u'id-DataCodingScheme', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataCodingScheme._val = 20
    
    #-----< id-DefaultPagingDRX >-----#
    id_DefaultPagingDRX = INT(name=u'id-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DefaultPagingDRX._val = 21
    
    #-----< id-DirectForwardingPathAvailability >-----#
    id_DirectForwardingPathAvailability = INT(name=u'id-DirectForwardingPathAvailability', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DirectForwardingPathAvailability._val = 22
    
    #-----< id-EmergencyAreaIDListForRestart >-----#
    id_EmergencyAreaIDListForRestart = INT(name=u'id-EmergencyAreaIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyAreaIDListForRestart._val = 23
    
    #-----< id-EmergencyFallbackIndicator >-----#
    id_EmergencyFallbackIndicator = INT(name=u'id-EmergencyFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyFallbackIndicator._val = 24
    
    #-----< id-EUTRA-CGI >-----#
    id_EUTRA_CGI = INT(name=u'id-EUTRA-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_CGI._val = 25
    
    #-----< id-FiveG-S-TMSI >-----#
    id_FiveG_S_TMSI = INT(name=u'id-FiveG-S-TMSI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_S_TMSI._val = 26
    
    #-----< id-GlobalRANNodeID >-----#
    id_GlobalRANNodeID = INT(name=u'id-GlobalRANNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalRANNodeID._val = 27
    
    #-----< id-GUAMI >-----#
    id_GUAMI = INT(name=u'id-GUAMI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUAMI._val = 28
    
    #-----< id-HandoverType >-----#
    id_HandoverType = INT(name=u'id-HandoverType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverType._val = 29
    
    #-----< id-IMSVoiceSupportIndicator >-----#
    id_IMSVoiceSupportIndicator = INT(name=u'id-IMSVoiceSupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSVoiceSupportIndicator._val = 30
    
    #-----< id-IndexToRFSP >-----#
    id_IndexToRFSP = INT(name=u'id-IndexToRFSP', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IndexToRFSP._val = 31
    
    #-----< id-InfoOnRecommendedCellsAndRANNodesForPaging >-----#
    id_InfoOnRecommendedCellsAndRANNodesForPaging = INT(name=u'id-InfoOnRecommendedCellsAndRANNodesForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InfoOnRecommendedCellsAndRANNodesForPaging._val = 32
    
    #-----< id-LocationReportingRequestType >-----#
    id_LocationReportingRequestType = INT(name=u'id-LocationReportingRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationReportingRequestType._val = 33
    
    #-----< id-MaskedIMEISV >-----#
    id_MaskedIMEISV = INT(name=u'id-MaskedIMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaskedIMEISV._val = 34
    
    #-----< id-MessageIdentifier >-----#
    id_MessageIdentifier = INT(name=u'id-MessageIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageIdentifier._val = 35
    
    #-----< id-MobilityRestrictionList >-----#
    id_MobilityRestrictionList = INT(name=u'id-MobilityRestrictionList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityRestrictionList._val = 36
    
    #-----< id-NASC >-----#
    id_NASC = INT(name=u'id-NASC', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASC._val = 37
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name=u'id-NAS-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_PDU._val = 38
    
    #-----< id-NASSecurityParametersFromNGRAN >-----#
    id_NASSecurityParametersFromNGRAN = INT(name=u'id-NASSecurityParametersFromNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParametersFromNGRAN._val = 39
    
    #-----< id-NewAMF-UE-NGAP-ID >-----#
    id_NewAMF_UE_NGAP_ID = INT(name=u'id-NewAMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewAMF_UE_NGAP_ID._val = 40
    
    #-----< id-NewSecurityContextInd >-----#
    id_NewSecurityContextInd = INT(name=u'id-NewSecurityContextInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewSecurityContextInd._val = 41
    
    #-----< id-NGAP-Message >-----#
    id_NGAP_Message = INT(name=u'id-NGAP-Message', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGAP_Message._val = 42
    
    #-----< id-NGRAN-CGI >-----#
    id_NGRAN_CGI = INT(name=u'id-NGRAN-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRAN_CGI._val = 43
    
    #-----< id-NGRANTraceID >-----#
    id_NGRANTraceID = INT(name=u'id-NGRANTraceID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRANTraceID._val = 44
    
    #-----< id-NR-CGI >-----#
    id_NR_CGI = INT(name=u'id-NR-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI._val = 45
    
    #-----< id-NRPPa-PDU >-----#
    id_NRPPa_PDU = INT(name=u'id-NRPPa-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPPa_PDU._val = 46
    
    #-----< id-NumberOfBroadcastsRequested >-----#
    id_NumberOfBroadcastsRequested = INT(name=u'id-NumberOfBroadcastsRequested', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfBroadcastsRequested._val = 47
    
    #-----< id-OldAMF >-----#
    id_OldAMF = INT(name=u'id-OldAMF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OldAMF._val = 48
    
    #-----< id-OverloadStartNSSAIList >-----#
    id_OverloadStartNSSAIList = INT(name=u'id-OverloadStartNSSAIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OverloadStartNSSAIList._val = 49
    
    #-----< id-PagingDRX >-----#
    id_PagingDRX = INT(name=u'id-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingDRX._val = 50
    
    #-----< id-PagingOrigin >-----#
    id_PagingOrigin = INT(name=u'id-PagingOrigin', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingOrigin._val = 51
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name=u'id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 52
    
    #-----< id-PDUSessionResourceAdmittedList >-----#
    id_PDUSessionResourceAdmittedList = INT(name=u'id-PDUSessionResourceAdmittedList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceAdmittedList._val = 53
    
    #-----< id-PDUSessionResourceFailedToModifyListModRes >-----#
    id_PDUSessionResourceFailedToModifyListModRes = INT(name=u'id-PDUSessionResourceFailedToModifyListModRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToModifyListModRes._val = 54
    
    #-----< id-PDUSessionResourceFailedToSetupListCxtRes >-----#
    id_PDUSessionResourceFailedToSetupListCxtRes = INT(name=u'id-PDUSessionResourceFailedToSetupListCxtRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListCxtRes._val = 55
    
    #-----< id-PDUSessionResourceFailedToSetupListHOAck >-----#
    id_PDUSessionResourceFailedToSetupListHOAck = INT(name=u'id-PDUSessionResourceFailedToSetupListHOAck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListHOAck._val = 56
    
    #-----< id-PDUSessionResourceFailedToSetupListPSReq >-----#
    id_PDUSessionResourceFailedToSetupListPSReq = INT(name=u'id-PDUSessionResourceFailedToSetupListPSReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListPSReq._val = 57
    
    #-----< id-PDUSessionResourceFailedToSetupListSURes >-----#
    id_PDUSessionResourceFailedToSetupListSURes = INT(name=u'id-PDUSessionResourceFailedToSetupListSURes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListSURes._val = 58
    
    #-----< id-PDUSessionResourceHandoverList >-----#
    id_PDUSessionResourceHandoverList = INT(name=u'id-PDUSessionResourceHandoverList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceHandoverList._val = 59
    
    #-----< id-PDUSessionResourceListCxtRelCpl >-----#
    id_PDUSessionResourceListCxtRelCpl = INT(name=u'id-PDUSessionResourceListCxtRelCpl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListCxtRelCpl._val = 60
    
    #-----< id-PDUSessionResourceListHORqd >-----#
    id_PDUSessionResourceListHORqd = INT(name=u'id-PDUSessionResourceListHORqd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListHORqd._val = 61
    
    #-----< id-PDUSessionResourceModifyListModCfm >-----#
    id_PDUSessionResourceModifyListModCfm = INT(name=u'id-PDUSessionResourceModifyListModCfm', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModCfm._val = 62
    
    #-----< id-PDUSessionResourceModifyListModInd >-----#
    id_PDUSessionResourceModifyListModInd = INT(name=u'id-PDUSessionResourceModifyListModInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModInd._val = 63
    
    #-----< id-PDUSessionResourceModifyListModReq >-----#
    id_PDUSessionResourceModifyListModReq = INT(name=u'id-PDUSessionResourceModifyListModReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModReq._val = 64
    
    #-----< id-PDUSessionResourceModifyListModRes >-----#
    id_PDUSessionResourceModifyListModRes = INT(name=u'id-PDUSessionResourceModifyListModRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModRes._val = 65
    
    #-----< id-PDUSessionResourceNotifyList >-----#
    id_PDUSessionResourceNotifyList = INT(name=u'id-PDUSessionResourceNotifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceNotifyList._val = 66
    
    #-----< id-PDUSessionResourceReleasedListNot >-----#
    id_PDUSessionResourceReleasedListNot = INT(name=u'id-PDUSessionResourceReleasedListNot', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListNot._val = 67
    
    #-----< id-PDUSessionResourceReleasedListPSAck >-----#
    id_PDUSessionResourceReleasedListPSAck = INT(name=u'id-PDUSessionResourceReleasedListPSAck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListPSAck._val = 68
    
    #-----< id-PDUSessionResourceReleasedListPSFail >-----#
    id_PDUSessionResourceReleasedListPSFail = INT(name=u'id-PDUSessionResourceReleasedListPSFail', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListPSFail._val = 69
    
    #-----< id-PDUSessionResourceReleasedListRelRes >-----#
    id_PDUSessionResourceReleasedListRelRes = INT(name=u'id-PDUSessionResourceReleasedListRelRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListRelRes._val = 70
    
    #-----< id-PDUSessionResourceSetupListCxtReq >-----#
    id_PDUSessionResourceSetupListCxtReq = INT(name=u'id-PDUSessionResourceSetupListCxtReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListCxtReq._val = 71
    
    #-----< id-PDUSessionResourceSetupListCxtRes >-----#
    id_PDUSessionResourceSetupListCxtRes = INT(name=u'id-PDUSessionResourceSetupListCxtRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListCxtRes._val = 72
    
    #-----< id-PDUSessionResourceSetupListHOReq >-----#
    id_PDUSessionResourceSetupListHOReq = INT(name=u'id-PDUSessionResourceSetupListHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListHOReq._val = 73
    
    #-----< id-PDUSessionResourceSetupListSUReq >-----#
    id_PDUSessionResourceSetupListSUReq = INT(name=u'id-PDUSessionResourceSetupListSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListSUReq._val = 74
    
    #-----< id-PDUSessionResourceSetupListSURes >-----#
    id_PDUSessionResourceSetupListSURes = INT(name=u'id-PDUSessionResourceSetupListSURes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListSURes._val = 75
    
    #-----< id-PDUSessionResourceToBeSwitchedDLList >-----#
    id_PDUSessionResourceToBeSwitchedDLList = INT(name=u'id-PDUSessionResourceToBeSwitchedDLList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToBeSwitchedDLList._val = 76
    
    #-----< id-PDUSessionResourceSwitchedList >-----#
    id_PDUSessionResourceSwitchedList = INT(name=u'id-PDUSessionResourceSwitchedList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSwitchedList._val = 77
    
    #-----< id-PDUSessionResourceToReleaseListHOCmd >-----#
    id_PDUSessionResourceToReleaseListHOCmd = INT(name=u'id-PDUSessionResourceToReleaseListHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToReleaseListHOCmd._val = 78
    
    #-----< id-PDUSessionResourceToReleaseListRelCmd >-----#
    id_PDUSessionResourceToReleaseListRelCmd = INT(name=u'id-PDUSessionResourceToReleaseListRelCmd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToReleaseListRelCmd._val = 79
    
    #-----< id-PLMNSupportList >-----#
    id_PLMNSupportList = INT(name=u'id-PLMNSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMNSupportList._val = 80
    
    #-----< id-PWSFailedCellIDList >-----#
    id_PWSFailedCellIDList = INT(name=u'id-PWSFailedCellIDList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSFailedCellIDList._val = 81
    
    #-----< id-RANNodeName >-----#
    id_RANNodeName = INT(name=u'id-RANNodeName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANNodeName._val = 82
    
    #-----< id-RANPagingPriority >-----#
    id_RANPagingPriority = INT(name=u'id-RANPagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANPagingPriority._val = 83
    
    #-----< id-RANStatusTransfer-TransparentContainer >-----#
    id_RANStatusTransfer_TransparentContainer = INT(name=u'id-RANStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANStatusTransfer_TransparentContainer._val = 84
    
    #-----< id-RAN-UE-NGAP-ID >-----#
    id_RAN_UE_NGAP_ID = INT(name=u'id-RAN-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_NGAP_ID._val = 85
    
    #-----< id-RelativeAMFCapacity >-----#
    id_RelativeAMFCapacity = INT(name=u'id-RelativeAMFCapacity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelativeAMFCapacity._val = 86
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name=u'id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 87
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name=u'id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 88
    
    #-----< id-RoutingID >-----#
    id_RoutingID = INT(name=u'id-RoutingID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RoutingID._val = 89
    
    #-----< id-RRCEstablishmentCause >-----#
    id_RRCEstablishmentCause = INT(name=u'id-RRCEstablishmentCause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCEstablishmentCause._val = 90
    
    #-----< id-RRCInactiveTransitionReportRequest >-----#
    id_RRCInactiveTransitionReportRequest = INT(name=u'id-RRCInactiveTransitionReportRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCInactiveTransitionReportRequest._val = 91
    
    #-----< id-RRCState >-----#
    id_RRCState = INT(name=u'id-RRCState', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCState._val = 92
    
    #-----< id-SecurityContext >-----#
    id_SecurityContext = INT(name=u'id-SecurityContext', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityContext._val = 93
    
    #-----< id-SecurityKey >-----#
    id_SecurityKey = INT(name=u'id-SecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityKey._val = 94
    
    #-----< id-SerialNumber >-----#
    id_SerialNumber = INT(name=u'id-SerialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SerialNumber._val = 95
    
    #-----< id-ServedGUAMIList >-----#
    id_ServedGUAMIList = INT(name=u'id-ServedGUAMIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedGUAMIList._val = 96
    
    #-----< id-SliceSupportList >-----#
    id_SliceSupportList = INT(name=u'id-SliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SliceSupportList._val = 97
    
    #-----< id-SONConfigurationTransferDL >-----#
    id_SONConfigurationTransferDL = INT(name=u'id-SONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferDL._val = 98
    
    #-----< id-SONConfigurationTransferUL >-----#
    id_SONConfigurationTransferUL = INT(name=u'id-SONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferUL._val = 99
    
    #-----< id-SourceAMF-UE-NGAP-ID >-----#
    id_SourceAMF_UE_NGAP_ID = INT(name=u'id-SourceAMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceAMF_UE_NGAP_ID._val = 100
    
    #-----< id-SourceToTarget-TransparentContainer >-----#
    id_SourceToTarget_TransparentContainer = INT(name=u'id-SourceToTarget-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceToTarget_TransparentContainer._val = 101
    
    #-----< id-SupportedTAList >-----#
    id_SupportedTAList = INT(name=u'id-SupportedTAList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SupportedTAList._val = 102
    
    #-----< id-TAIListForPaging >-----#
    id_TAIListForPaging = INT(name=u'id-TAIListForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForPaging._val = 103
    
    #-----< id-TAIListForRestart >-----#
    id_TAIListForRestart = INT(name=u'id-TAIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForRestart._val = 104
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name=u'id-TargetID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetID._val = 105
    
    #-----< id-TargetToSource-TransparentContainer >-----#
    id_TargetToSource_TransparentContainer = INT(name=u'id-TargetToSource-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetToSource_TransparentContainer._val = 106
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name=u'id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 107
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name=u'id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 108
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name=u'id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 109
    
    #-----< id-UEAggregateMaximumBitRate >-----#
    id_UEAggregateMaximumBitRate = INT(name=u'id-UEAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAggregateMaximumBitRate._val = 110
    
    #-----< id-UE-associatedLogicalNG-connectionList >-----#
    id_UE_associatedLogicalNG_connectionList = INT(name=u'id-UE-associatedLogicalNG-connectionList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalNG_connectionList._val = 111
    
    #-----< id-UEContextRequest >-----#
    id_UEContextRequest = INT(name=u'id-UEContextRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextRequest._val = 112
    
    #-----< id-UE-NGAP-IDs >-----#
    id_UE_NGAP_IDs = INT(name=u'id-UE-NGAP-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_NGAP_IDs._val = 114
    
    #-----< id-UEPagingIdentity >-----#
    id_UEPagingIdentity = INT(name=u'id-UEPagingIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPagingIdentity._val = 115
    
    #-----< id-UEPresenceInAreaOfInterestList >-----#
    id_UEPresenceInAreaOfInterestList = INT(name=u'id-UEPresenceInAreaOfInterestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPresenceInAreaOfInterestList._val = 116
    
    #-----< id-UERadioCapability >-----#
    id_UERadioCapability = INT(name=u'id-UERadioCapability', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability._val = 117
    
    #-----< id-UERadioCapabilityForPaging >-----#
    id_UERadioCapabilityForPaging = INT(name=u'id-UERadioCapabilityForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging._val = 118
    
    #-----< id-UESecurityCapabilities >-----#
    id_UESecurityCapabilities = INT(name=u'id-UESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESecurityCapabilities._val = 119
    
    #-----< id-UnavailableGUAMIList >-----#
    id_UnavailableGUAMIList = INT(name=u'id-UnavailableGUAMIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnavailableGUAMIList._val = 120
    
    #-----< id-UserLocationInformation >-----#
    id_UserLocationInformation = INT(name=u'id-UserLocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformation._val = 121
    
    #-----< id-WarningAreaList >-----#
    id_WarningAreaList = INT(name=u'id-WarningAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaList._val = 122
    
    #-----< id-WarningMessageContents >-----#
    id_WarningMessageContents = INT(name=u'id-WarningMessageContents', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningMessageContents._val = 123
    
    #-----< id-WarningSecurityInfo >-----#
    id_WarningSecurityInfo = INT(name=u'id-WarningSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningSecurityInfo._val = 124
    
    #-----< id-WarningType >-----#
    id_WarningType = INT(name=u'id-WarningType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningType._val = 125
    
    #-----< id-AdditionalUL-NGU-UP-TNLInformation >-----#
    id_AdditionalUL_NGU_UP_TNLInformation = INT(name=u'id-AdditionalUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalUL_NGU_UP_TNLInformation._val = 126
    
    #-----< id-DataForwardingNotPossible >-----#
    id_DataForwardingNotPossible = INT(name=u'id-DataForwardingNotPossible', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingNotPossible._val = 127
    
    #-----< id-DL-NGU-UP-TNLInformation >-----#
    id_DL_NGU_UP_TNLInformation = INT(name=u'id-DL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_NGU_UP_TNLInformation._val = 128
    
    #-----< id-NetworkInstance >-----#
    id_NetworkInstance = INT(name=u'id-NetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NetworkInstance._val = 129
    
    #-----< id-PDUSessionAggregateMaximumBitRate >-----#
    id_PDUSessionAggregateMaximumBitRate = INT(name=u'id-PDUSessionAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionAggregateMaximumBitRate._val = 130
    
    #-----< id-PDUSessionResourceFailedToModifyListModCfm >-----#
    id_PDUSessionResourceFailedToModifyListModCfm = INT(name=u'id-PDUSessionResourceFailedToModifyListModCfm', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToModifyListModCfm._val = 131
    
    #-----< id-PDUSessionResourceFailedToSetupListCxtFail >-----#
    id_PDUSessionResourceFailedToSetupListCxtFail = INT(name=u'id-PDUSessionResourceFailedToSetupListCxtFail', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListCxtFail._val = 132
    
    #-----< id-PDUSessionResourceListCxtRelReq >-----#
    id_PDUSessionResourceListCxtRelReq = INT(name=u'id-PDUSessionResourceListCxtRelReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListCxtRelReq._val = 133
    
    #-----< id-PDUSessionType >-----#
    id_PDUSessionType = INT(name=u'id-PDUSessionType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionType._val = 134
    
    #-----< id-QosFlowAddOrModifyRequestList >-----#
    id_QosFlowAddOrModifyRequestList = INT(name=u'id-QosFlowAddOrModifyRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowAddOrModifyRequestList._val = 135
    
    #-----< id-QosFlowSetupRequestList >-----#
    id_QosFlowSetupRequestList = INT(name=u'id-QosFlowSetupRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowSetupRequestList._val = 136
    
    #-----< id-QosFlowToReleaseList >-----#
    id_QosFlowToReleaseList = INT(name=u'id-QosFlowToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowToReleaseList._val = 137
    
    #-----< id-SecurityIndication >-----#
    id_SecurityIndication = INT(name=u'id-SecurityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndication._val = 138
    
    #-----< id-UL-NGU-UP-TNLInformation >-----#
    id_UL_NGU_UP_TNLInformation = INT(name=u'id-UL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_NGU_UP_TNLInformation._val = 139
    
    #-----< id-UL-NGU-UP-TNLModifyList >-----#
    id_UL_NGU_UP_TNLModifyList = INT(name=u'id-UL-NGU-UP-TNLModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_NGU_UP_TNLModifyList._val = 140
    
    #-----< id-WarningAreaCoordinates >-----#
    id_WarningAreaCoordinates = INT(name=u'id-WarningAreaCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaCoordinates._val = 141
    
    #-----< id-PDUSessionResourceSecondaryRATUsageList >-----#
    id_PDUSessionResourceSecondaryRATUsageList = INT(name=u'id-PDUSessionResourceSecondaryRATUsageList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSecondaryRATUsageList._val = 142
    
    #-----< id-HandoverFlag >-----#
    id_HandoverFlag = INT(name=u'id-HandoverFlag', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverFlag._val = 143
    
    #-----< id-SecondaryRATUsageInformation >-----#
    id_SecondaryRATUsageInformation = INT(name=u'id-SecondaryRATUsageInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATUsageInformation._val = 144
    
    #-----< id-PDUSessionResourceReleaseResponseTransfer >-----#
    id_PDUSessionResourceReleaseResponseTransfer = INT(name=u'id-PDUSessionResourceReleaseResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleaseResponseTransfer._val = 145
    
    #-----< id-RedirectionVoiceFallback >-----#
    id_RedirectionVoiceFallback = INT(name=u'id-RedirectionVoiceFallback', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedirectionVoiceFallback._val = 146
    
    #-----< id-UERetentionInformation >-----#
    id_UERetentionInformation = INT(name=u'id-UERetentionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERetentionInformation._val = 147
    
    #-----< id-S-NSSAI >-----#
    id_S_NSSAI = INT(name=u'id-S-NSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_NSSAI._val = 148
    
    #-----< id-PSCellInformation >-----#
    id_PSCellInformation = INT(name=u'id-PSCellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellInformation._val = 149
    
    #-----< id-LastEUTRAN-PLMNIdentity >-----#
    id_LastEUTRAN_PLMNIdentity = INT(name=u'id-LastEUTRAN-PLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastEUTRAN_PLMNIdentity._val = 150
    
    #-----< id-MaximumIntegrityProtectedDataRate-DL >-----#
    id_MaximumIntegrityProtectedDataRate_DL = INT(name=u'id-MaximumIntegrityProtectedDataRate-DL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumIntegrityProtectedDataRate_DL._val = 151
    
    #-----< id-AdditionalDLForwardingUPTNLInformation >-----#
    id_AdditionalDLForwardingUPTNLInformation = INT(name=u'id-AdditionalDLForwardingUPTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLForwardingUPTNLInformation._val = 152
    
    #-----< id-AdditionalDLUPTNLInformationForHOList >-----#
    id_AdditionalDLUPTNLInformationForHOList = INT(name=u'id-AdditionalDLUPTNLInformationForHOList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLUPTNLInformationForHOList._val = 153
    
    #-----< id-AdditionalNGU-UP-TNLInformation >-----#
    id_AdditionalNGU_UP_TNLInformation = INT(name=u'id-AdditionalNGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalNGU_UP_TNLInformation._val = 154
    
    #-----< id-AdditionalDLQosFlowPerTNLInformation >-----#
    id_AdditionalDLQosFlowPerTNLInformation = INT(name=u'id-AdditionalDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLQosFlowPerTNLInformation._val = 155
    
    #-----< id-SecurityResult >-----#
    id_SecurityResult = INT(name=u'id-SecurityResult', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityResult._val = 156
    
    #-----< id-ENDC-SONConfigurationTransferDL >-----#
    id_ENDC_SONConfigurationTransferDL = INT(name=u'id-ENDC-SONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENDC_SONConfigurationTransferDL._val = 157
    
    #-----< id-ENDC-SONConfigurationTransferUL >-----#
    id_ENDC_SONConfigurationTransferUL = INT(name=u'id-ENDC-SONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENDC_SONConfigurationTransferUL._val = 158
    
    #-----< id-OldAssociatedQosFlowList-ULendmarkerexpected >-----#
    id_OldAssociatedQosFlowList_ULendmarkerexpected = INT(name=u'id-OldAssociatedQosFlowList-ULendmarkerexpected', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OldAssociatedQosFlowList_ULendmarkerexpected._val = 159
    
    #-----< id-CNTypeRestrictionsForEquivalent >-----#
    id_CNTypeRestrictionsForEquivalent = INT(name=u'id-CNTypeRestrictionsForEquivalent', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictionsForEquivalent._val = 160
    
    #-----< id-CNTypeRestrictionsForServing >-----#
    id_CNTypeRestrictionsForServing = INT(name=u'id-CNTypeRestrictionsForServing', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictionsForServing._val = 161
    
    #-----< id-NewGUAMI >-----#
    id_NewGUAMI = INT(name=u'id-NewGUAMI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewGUAMI._val = 162
    
    #-----< id-ULForwarding >-----#
    id_ULForwarding = INT(name=u'id-ULForwarding', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULForwarding._val = 163
    
    #-----< id-ULForwardingUP-TNLInformation >-----#
    id_ULForwardingUP_TNLInformation = INT(name=u'id-ULForwardingUP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULForwardingUP_TNLInformation._val = 164
    
    #-----< id-CNAssistedRANTuning >-----#
    id_CNAssistedRANTuning = INT(name=u'id-CNAssistedRANTuning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNAssistedRANTuning._val = 165
    
    #-----< id-CommonNetworkInstance >-----#
    id_CommonNetworkInstance = INT(name=u'id-CommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonNetworkInstance._val = 166
    
    #-----< id-NGRAN-TNLAssociationToRemoveList >-----#
    id_NGRAN_TNLAssociationToRemoveList = INT(name=u'id-NGRAN-TNLAssociationToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRAN_TNLAssociationToRemoveList._val = 167
    
    #-----< id-TNLAssociationTransportLayerAddressNGRAN >-----#
    id_TNLAssociationTransportLayerAddressNGRAN = INT(name=u'id-TNLAssociationTransportLayerAddressNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLAssociationTransportLayerAddressNGRAN._val = 168
    
    #-----< id-EndpointIPAddressAndPort >-----#
    id_EndpointIPAddressAndPort = INT(name=u'id-EndpointIPAddressAndPort', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndpointIPAddressAndPort._val = 169
    
    #-----< id-LocationReportingAdditionalInfo >-----#
    id_LocationReportingAdditionalInfo = INT(name=u'id-LocationReportingAdditionalInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationReportingAdditionalInfo._val = 170
    
    #-----< id-SourceToTarget-AMFInformationReroute >-----#
    id_SourceToTarget_AMFInformationReroute = INT(name=u'id-SourceToTarget-AMFInformationReroute', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceToTarget_AMFInformationReroute._val = 171
    
    #-----< id-AdditionalULForwardingUPTNLInformation >-----#
    id_AdditionalULForwardingUPTNLInformation = INT(name=u'id-AdditionalULForwardingUPTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalULForwardingUPTNLInformation._val = 172
    
    #-----< id-SCTP-TLAs >-----#
    id_SCTP_TLAs = INT(name=u'id-SCTP-TLAs', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCTP_TLAs._val = 173
    
    #-----< id-SelectedPLMNIdentity >-----#
    id_SelectedPLMNIdentity = INT(name=u'id-SelectedPLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedPLMNIdentity._val = 174
    
    #-----< id-RIMInformationTransfer >-----#
    id_RIMInformationTransfer = INT(name=u'id-RIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RIMInformationTransfer._val = 175
    
    #-----< id-GUAMIType >-----#
    id_GUAMIType = INT(name=u'id-GUAMIType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUAMIType._val = 176
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name=u'id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 177
    
    #-----< id-TargetRNC-ID >-----#
    id_TargetRNC_ID = INT(name=u'id-TargetRNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetRNC_ID._val = 178
    
    #-----< id-RAT-Information >-----#
    id_RAT_Information = INT(name=u'id-RAT-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Information._val = 179
    
    #-----< id-ExtendedRATRestrictionInformation >-----#
    id_ExtendedRATRestrictionInformation = INT(name=u'id-ExtendedRATRestrictionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedRATRestrictionInformation._val = 180
    
    #-----< id-QosMonitoringRequest >-----#
    id_QosMonitoringRequest = INT(name=u'id-QosMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringRequest._val = 181
    
    #-----< id-SgNB-UE-X2AP-ID >-----#
    id_SgNB_UE_X2AP_ID = INT(name=u'id-SgNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNB_UE_X2AP_ID._val = 182
    
    #-----< id-AdditionalRedundantDL-NGU-UP-TNLInformation >-----#
    id_AdditionalRedundantDL_NGU_UP_TNLInformation = INT(name=u'id-AdditionalRedundantDL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantDL_NGU_UP_TNLInformation._val = 183
    
    #-----< id-AdditionalRedundantDLQosFlowPerTNLInformation >-----#
    id_AdditionalRedundantDLQosFlowPerTNLInformation = INT(name=u'id-AdditionalRedundantDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantDLQosFlowPerTNLInformation._val = 184
    
    #-----< id-AdditionalRedundantNGU-UP-TNLInformation >-----#
    id_AdditionalRedundantNGU_UP_TNLInformation = INT(name=u'id-AdditionalRedundantNGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantNGU_UP_TNLInformation._val = 185
    
    #-----< id-AdditionalRedundantUL-NGU-UP-TNLInformation >-----#
    id_AdditionalRedundantUL_NGU_UP_TNLInformation = INT(name=u'id-AdditionalRedundantUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantUL_NGU_UP_TNLInformation._val = 186
    
    #-----< id-CNPacketDelayBudgetDL >-----#
    id_CNPacketDelayBudgetDL = INT(name=u'id-CNPacketDelayBudgetDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetDL._val = 187
    
    #-----< id-CNPacketDelayBudgetUL >-----#
    id_CNPacketDelayBudgetUL = INT(name=u'id-CNPacketDelayBudgetUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetUL._val = 188
    
    #-----< id-ExtendedPacketDelayBudget >-----#
    id_ExtendedPacketDelayBudget = INT(name=u'id-ExtendedPacketDelayBudget', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPacketDelayBudget._val = 189
    
    #-----< id-RedundantCommonNetworkInstance >-----#
    id_RedundantCommonNetworkInstance = INT(name=u'id-RedundantCommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantCommonNetworkInstance._val = 190
    
    #-----< id-RedundantDL-NGU-TNLInformationReused >-----#
    id_RedundantDL_NGU_TNLInformationReused = INT(name=u'id-RedundantDL-NGU-TNLInformationReused', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDL_NGU_TNLInformationReused._val = 191
    
    #-----< id-RedundantDL-NGU-UP-TNLInformation >-----#
    id_RedundantDL_NGU_UP_TNLInformation = INT(name=u'id-RedundantDL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDL_NGU_UP_TNLInformation._val = 192
    
    #-----< id-RedundantDLQosFlowPerTNLInformation >-----#
    id_RedundantDLQosFlowPerTNLInformation = INT(name=u'id-RedundantDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDLQosFlowPerTNLInformation._val = 193
    
    #-----< id-RedundantQosFlowIndicator >-----#
    id_RedundantQosFlowIndicator = INT(name=u'id-RedundantQosFlowIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantQosFlowIndicator._val = 194
    
    #-----< id-RedundantUL-NGU-UP-TNLInformation >-----#
    id_RedundantUL_NGU_UP_TNLInformation = INT(name=u'id-RedundantUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantUL_NGU_UP_TNLInformation._val = 195
    
    #-----< id-TSCTrafficCharacteristics >-----#
    id_TSCTrafficCharacteristics = INT(name=u'id-TSCTrafficCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSCTrafficCharacteristics._val = 196
    
    #-----< id-RedundantPDUSessionInformation >-----#
    id_RedundantPDUSessionInformation = INT(name=u'id-RedundantPDUSessionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantPDUSessionInformation._val = 197
    
    #-----< id-UsedRSNInformation >-----#
    id_UsedRSNInformation = INT(name=u'id-UsedRSNInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UsedRSNInformation._val = 198
    
    #-----< id-IAB-Authorized >-----#
    id_IAB_Authorized = INT(name=u'id-IAB-Authorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Authorized._val = 199
    
    #-----< id-IAB-Supported >-----#
    id_IAB_Supported = INT(name=u'id-IAB-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Supported._val = 200
    
    #-----< id-IABNodeIndication >-----#
    id_IABNodeIndication = INT(name=u'id-IABNodeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABNodeIndication._val = 201
    
    #-----< id-NB-IoT-PagingDRX >-----#
    id_NB_IoT_PagingDRX = INT(name=u'id-NB-IoT-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_PagingDRX._val = 202
    
    #-----< id-NB-IoT-Paging-eDRXInfo >-----#
    id_NB_IoT_Paging_eDRXInfo = INT(name=u'id-NB-IoT-Paging-eDRXInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_Paging_eDRXInfo._val = 203
    
    #-----< id-NB-IoT-DefaultPagingDRX >-----#
    id_NB_IoT_DefaultPagingDRX = INT(name=u'id-NB-IoT-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_DefaultPagingDRX._val = 204
    
    #-----< id-Enhanced-CoverageRestriction >-----#
    id_Enhanced_CoverageRestriction = INT(name=u'id-Enhanced-CoverageRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_CoverageRestriction._val = 205
    
    #-----< id-Extended-ConnectedTime >-----#
    id_Extended_ConnectedTime = INT(name=u'id-Extended-ConnectedTime', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_ConnectedTime._val = 206
    
    #-----< id-PagingAssisDataforCEcapabUE >-----#
    id_PagingAssisDataforCEcapabUE = INT(name=u'id-PagingAssisDataforCEcapabUE', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingAssisDataforCEcapabUE._val = 207
    
    #-----< id-WUS-Assistance-Information >-----#
    id_WUS_Assistance_Information = INT(name=u'id-WUS-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WUS_Assistance_Information._val = 208
    
    #-----< id-UE-DifferentiationInfo >-----#
    id_UE_DifferentiationInfo = INT(name=u'id-UE-DifferentiationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_DifferentiationInfo._val = 209
    
    #-----< id-NB-IoT-UEPriority >-----#
    id_NB_IoT_UEPriority = INT(name=u'id-NB-IoT-UEPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_UEPriority._val = 210
    
    #-----< id-UL-CP-SecurityInformation >-----#
    id_UL_CP_SecurityInformation = INT(name=u'id-UL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CP_SecurityInformation._val = 211
    
    #-----< id-DL-CP-SecurityInformation >-----#
    id_DL_CP_SecurityInformation = INT(name=u'id-DL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CP_SecurityInformation._val = 212
    
    #-----< id-TAI >-----#
    id_TAI = INT(name=u'id-TAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAI._val = 213
    
    #-----< id-UERadioCapabilityForPagingOfNB-IoT >-----#
    id_UERadioCapabilityForPagingOfNB_IoT = INT(name=u'id-UERadioCapabilityForPagingOfNB-IoT', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPagingOfNB_IoT._val = 214
    
    #-----< id-LTEV2XServicesAuthorized >-----#
    id_LTEV2XServicesAuthorized = INT(name=u'id-LTEV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEV2XServicesAuthorized._val = 215
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name=u'id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 216
    
    #-----< id-LTEUESidelinkAggregateMaximumBitrate >-----#
    id_LTEUESidelinkAggregateMaximumBitrate = INT(name=u'id-LTEUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEUESidelinkAggregateMaximumBitrate._val = 217
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name=u'id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 218
    
    #-----< id-PC5QoSParameters >-----#
    id_PC5QoSParameters = INT(name=u'id-PC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5QoSParameters._val = 219
    
    #-----< id-AlternativeQoSParaSetList >-----#
    id_AlternativeQoSParaSetList = INT(name=u'id-AlternativeQoSParaSetList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeQoSParaSetList._val = 220
    
    #-----< id-CurrentQoSParaSetIndex >-----#
    id_CurrentQoSParaSetIndex = INT(name=u'id-CurrentQoSParaSetIndex', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CurrentQoSParaSetIndex._val = 221
    
    #-----< id-CEmodeBrestricted >-----#
    id_CEmodeBrestricted = INT(name=u'id-CEmodeBrestricted', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CEmodeBrestricted._val = 222
    
    #-----< id-PagingeDRXInformation >-----#
    id_PagingeDRXInformation = INT(name=u'id-PagingeDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingeDRXInformation._val = 223
    
    #-----< id-CEmodeBSupport-Indicator >-----#
    id_CEmodeBSupport_Indicator = INT(name=u'id-CEmodeBSupport-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CEmodeBSupport_Indicator._val = 224
    
    #-----< id-LTEM-Indication >-----#
    id_LTEM_Indication = INT(name=u'id-LTEM-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEM_Indication._val = 225
    
    #-----< id-EndIndication >-----#
    id_EndIndication = INT(name=u'id-EndIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndIndication._val = 226
    
    #-----< id-EDT-Session >-----#
    id_EDT_Session = INT(name=u'id-EDT-Session', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDT_Session._val = 227
    
    #-----< id-UECapabilityInfoRequest >-----#
    id_UECapabilityInfoRequest = INT(name=u'id-UECapabilityInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UECapabilityInfoRequest._val = 228
    
    #-----< id-PDUSessionResourceFailedToResumeListRESReq >-----#
    id_PDUSessionResourceFailedToResumeListRESReq = INT(name=u'id-PDUSessionResourceFailedToResumeListRESReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToResumeListRESReq._val = 229
    
    #-----< id-PDUSessionResourceFailedToResumeListRESRes >-----#
    id_PDUSessionResourceFailedToResumeListRESRes = INT(name=u'id-PDUSessionResourceFailedToResumeListRESRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToResumeListRESRes._val = 230
    
    #-----< id-PDUSessionResourceSuspendListSUSReq >-----#
    id_PDUSessionResourceSuspendListSUSReq = INT(name=u'id-PDUSessionResourceSuspendListSUSReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSuspendListSUSReq._val = 231
    
    #-----< id-PDUSessionResourceResumeListRESReq >-----#
    id_PDUSessionResourceResumeListRESReq = INT(name=u'id-PDUSessionResourceResumeListRESReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceResumeListRESReq._val = 232
    
    #-----< id-PDUSessionResourceResumeListRESRes >-----#
    id_PDUSessionResourceResumeListRESRes = INT(name=u'id-PDUSessionResourceResumeListRESRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceResumeListRESRes._val = 233
    
    #-----< id-UE-UP-CIoT-Support >-----#
    id_UE_UP_CIoT_Support = INT(name=u'id-UE-UP-CIoT-Support', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_UP_CIoT_Support._val = 234
    
    #-----< id-Suspend-Request-Indication >-----#
    id_Suspend_Request_Indication = INT(name=u'id-Suspend-Request-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Suspend_Request_Indication._val = 235
    
    #-----< id-Suspend-Response-Indication >-----#
    id_Suspend_Response_Indication = INT(name=u'id-Suspend-Response-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Suspend_Response_Indication._val = 236
    
    #-----< id-RRC-Resume-Cause >-----#
    id_RRC_Resume_Cause = INT(name=u'id-RRC-Resume-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Resume_Cause._val = 237
    
    #-----< id-RGLevelWirelineAccessCharacteristics >-----#
    id_RGLevelWirelineAccessCharacteristics = INT(name=u'id-RGLevelWirelineAccessCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RGLevelWirelineAccessCharacteristics._val = 238
    
    #-----< id-W-AGFIdentityInformation >-----#
    id_W_AGFIdentityInformation = INT(name=u'id-W-AGFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_W_AGFIdentityInformation._val = 239
    
    #-----< id-GlobalTNGF-ID >-----#
    id_GlobalTNGF_ID = INT(name=u'id-GlobalTNGF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalTNGF_ID._val = 240
    
    #-----< id-GlobalTWIF-ID >-----#
    id_GlobalTWIF_ID = INT(name=u'id-GlobalTWIF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalTWIF_ID._val = 241
    
    #-----< id-GlobalW-AGF-ID >-----#
    id_GlobalW_AGF_ID = INT(name=u'id-GlobalW-AGF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalW_AGF_ID._val = 242
    
    #-----< id-UserLocationInformationW-AGF >-----#
    id_UserLocationInformationW_AGF = INT(name=u'id-UserLocationInformationW-AGF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationW_AGF._val = 243
    
    #-----< id-UserLocationInformationTNGF >-----#
    id_UserLocationInformationTNGF = INT(name=u'id-UserLocationInformationTNGF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationTNGF._val = 244
    
    #-----< id-AuthenticatedIndication >-----#
    id_AuthenticatedIndication = INT(name=u'id-AuthenticatedIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AuthenticatedIndication._val = 245
    
    #-----< id-TNGFIdentityInformation >-----#
    id_TNGFIdentityInformation = INT(name=u'id-TNGFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNGFIdentityInformation._val = 246
    
    #-----< id-TWIFIdentityInformation >-----#
    id_TWIFIdentityInformation = INT(name=u'id-TWIFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TWIFIdentityInformation._val = 247
    
    #-----< id-UserLocationInformationTWIF >-----#
    id_UserLocationInformationTWIF = INT(name=u'id-UserLocationInformationTWIF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationTWIF._val = 248
    
    #-----< id-DataForwardingResponseERABList >-----#
    id_DataForwardingResponseERABList = INT(name=u'id-DataForwardingResponseERABList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingResponseERABList._val = 249
    
    #-----< id-IntersystemSONConfigurationTransferDL >-----#
    id_IntersystemSONConfigurationTransferDL = INT(name=u'id-IntersystemSONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferDL._val = 250
    
    #-----< id-IntersystemSONConfigurationTransferUL >-----#
    id_IntersystemSONConfigurationTransferUL = INT(name=u'id-IntersystemSONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferUL._val = 251
    
    #-----< id-SONInformationReport >-----#
    id_SONInformationReport = INT(name=u'id-SONInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONInformationReport._val = 252
    
    #-----< id-UEHistoryInformationFromTheUE >-----#
    id_UEHistoryInformationFromTheUE = INT(name=u'id-UEHistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEHistoryInformationFromTheUE._val = 253
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name=u'id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 254
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name=u'id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 255
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name=u'id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 256
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name=u'id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 257
    
    #-----< id-NPN-Support >-----#
    id_NPN_Support = INT(name=u'id-NPN-Support', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_Support._val = 258
    
    #-----< id-NPN-AccessInformation >-----#
    id_NPN_AccessInformation = INT(name=u'id-NPN-AccessInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_AccessInformation._val = 259
    
    #-----< id-NPN-PagingAssistanceInformation >-----#
    id_NPN_PagingAssistanceInformation = INT(name=u'id-NPN-PagingAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_PagingAssistanceInformation._val = 260
    
    #-----< id-NPN-MobilityInformation >-----#
    id_NPN_MobilityInformation = INT(name=u'id-NPN-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_MobilityInformation._val = 261
    
    #-----< id-TargettoSource-Failure-TransparentContainer >-----#
    id_TargettoSource_Failure_TransparentContainer = INT(name=u'id-TargettoSource-Failure-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargettoSource_Failure_TransparentContainer._val = 262
    
    #-----< id-NID >-----#
    id_NID = INT(name=u'id-NID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NID._val = 263
    
    #-----< id-UERadioCapabilityID >-----#
    id_UERadioCapabilityID = INT(name=u'id-UERadioCapabilityID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityID._val = 264
    
    #-----< id-UERadioCapability-EUTRA-Format >-----#
    id_UERadioCapability_EUTRA_Format = INT(name=u'id-UERadioCapability-EUTRA-Format', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability_EUTRA_Format._val = 265
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name=u'id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 266
    
    #-----< id-DAPSResponseInfoList >-----#
    id_DAPSResponseInfoList = INT(name=u'id-DAPSResponseInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoList._val = 267
    
    #-----< id-EarlyStatusTransfer-TransparentContainer >-----#
    id_EarlyStatusTransfer_TransparentContainer = INT(name=u'id-EarlyStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyStatusTransfer_TransparentContainer._val = 268
    
    #-----< id-NotifySourceNGRANNode >-----#
    id_NotifySourceNGRANNode = INT(name=u'id-NotifySourceNGRANNode', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotifySourceNGRANNode._val = 269
    
    #-----< id-ExtendedSliceSupportList >-----#
    id_ExtendedSliceSupportList = INT(name=u'id-ExtendedSliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedSliceSupportList._val = 270
    
    #-----< id-ExtendedTAISliceSupportList >-----#
    id_ExtendedTAISliceSupportList = INT(name=u'id-ExtendedTAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedTAISliceSupportList._val = 271
    
    #-----< id-ConfiguredTACIndication >-----#
    id_ConfiguredTACIndication = INT(name=u'id-ConfiguredTACIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredTACIndication._val = 272
    
    #-----< id-Extended-RANNodeName >-----#
    id_Extended_RANNodeName = INT(name=u'id-Extended-RANNodeName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_RANNodeName._val = 273
    
    #-----< id-Extended-AMFName >-----#
    id_Extended_AMFName = INT(name=u'id-Extended-AMFName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_AMFName._val = 274
    
    #-----< id-GlobalCable-ID >-----#
    id_GlobalCable_ID = INT(name=u'id-GlobalCable-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalCable_ID._val = 275
    
    #-----< id-QosMonitoringReportingFrequency >-----#
    id_QosMonitoringReportingFrequency = INT(name=u'id-QosMonitoringReportingFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringReportingFrequency._val = 276
    
    #-----< id-QosFlowParametersList >-----#
    id_QosFlowParametersList = INT(name=u'id-QosFlowParametersList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowParametersList._val = 277
    
    #-----< id-QosFlowFeedbackList >-----#
    id_QosFlowFeedbackList = INT(name=u'id-QosFlowFeedbackList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowFeedbackList._val = 278
    
    #-----< id-BurstArrivalTimeDownlink >-----#
    id_BurstArrivalTimeDownlink = INT(name=u'id-BurstArrivalTimeDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BurstArrivalTimeDownlink._val = 279
    
    #-----< id-ExtendedUEIdentityIndexValue >-----#
    id_ExtendedUEIdentityIndexValue = INT(name=u'id-ExtendedUEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedUEIdentityIndexValue._val = 280
    
    #-----< id-PduSessionExpectedUEActivityBehaviour >-----#
    id_PduSessionExpectedUEActivityBehaviour = INT(name=u'id-PduSessionExpectedUEActivityBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PduSessionExpectedUEActivityBehaviour._val = 281
    
    #-----< id-MicoAllPLMN >-----#
    id_MicoAllPLMN = INT(name=u'id-MicoAllPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MicoAllPLMN._val = 282
    
    #-----< id-QosFlowFailedToSetupList >-----#
    id_QosFlowFailedToSetupList = INT(name=u'id-QosFlowFailedToSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowFailedToSetupList._val = 283
    
    #-----< id-SourceTNLAddrInfo >-----#
    id_SourceTNLAddrInfo = INT(name=u'id-SourceTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceTNLAddrInfo._val = 284
    
    #-----< id-ExtendedReportIntervalMDT >-----#
    id_ExtendedReportIntervalMDT = INT(name=u'id-ExtendedReportIntervalMDT', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedReportIntervalMDT._val = 285
    
    #-----< id-SourceNodeID >-----#
    id_SourceNodeID = INT(name=u'id-SourceNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeID._val = 286
    
    #-----< id-SourceNodeTNLAddrInfo >-----#
    id_SourceNodeTNLAddrInfo = INT(name=u'id-SourceNodeTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeTNLAddrInfo._val = 354
    
    _all_ = [
        id_AMFConfigurationUpdate,
        id_AMFStatusIndication,
        id_CellTrafficTrace,
        id_DeactivateTrace,
        id_DownlinkNASTransport,
        id_DownlinkNonUEAssociatedNRPPaTransport,
        id_DownlinkRANConfigurationTransfer,
        id_DownlinkRANStatusTransfer,
        id_DownlinkUEAssociatedNRPPaTransport,
        id_ErrorIndication,
        id_HandoverCancel,
        id_HandoverNotification,
        id_HandoverPreparation,
        id_HandoverResourceAllocation,
        id_InitialContextSetup,
        id_InitialUEMessage,
        id_LocationReportingControl,
        id_LocationReportingFailureIndication,
        id_LocationReport,
        id_NASNonDeliveryIndication,
        id_NGReset,
        id_NGSetup,
        id_OverloadStart,
        id_OverloadStop,
        id_Paging,
        id_PathSwitchRequest,
        id_PDUSessionResourceModify,
        id_PDUSessionResourceModifyIndication,
        id_PDUSessionResourceRelease,
        id_PDUSessionResourceSetup,
        id_PDUSessionResourceNotify,
        id_PrivateMessage,
        id_PWSCancel,
        id_PWSFailureIndication,
        id_PWSRestartIndication,
        id_RANConfigurationUpdate,
        id_RerouteNASRequest,
        id_RRCInactiveTransitionReport,
        id_TraceFailureIndication,
        id_TraceStart,
        id_UEContextModification,
        id_UEContextRelease,
        id_UEContextReleaseRequest,
        id_UERadioCapabilityCheck,
        id_UERadioCapabilityInfoIndication,
        id_UETNLABindingRelease,
        id_UplinkNASTransport,
        id_UplinkNonUEAssociatedNRPPaTransport,
        id_UplinkRANConfigurationTransfer,
        id_UplinkRANStatusTransfer,
        id_UplinkUEAssociatedNRPPaTransport,
        id_WriteReplaceWarning,
        id_SecondaryRATDataUsageReport,
        id_UplinkRIMInformationTransfer,
        id_DownlinkRIMInformationTransfer,
        id_RetrieveUEInformation,
        id_UEInformationTransfer,
        id_RANCPRelocationIndication,
        id_UEContextResume,
        id_UEContextSuspend,
        id_UERadioCapabilityIDMapping,
        id_HandoverSuccess,
        id_UplinkRANEarlyStatusTransfer,
        id_DownlinkRANEarlyStatusTransfer,
        id_AMFCPRelocationIndication,
        id_ConnectionEstablishmentIndication,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxnoofAllowedAreas,
        maxnoofAllowedCAGsperPLMN,
        maxnoofAllowedS_NSSAIs,
        maxnoofBluetoothName,
        maxnoofBPLMNs,
        maxnoofCAGSperCell,
        maxnoofCellIDforMDT,
        maxnoofCellIDforWarning,
        maxnoofCellinAoI,
        maxnoofCellinEAI,
        maxnoofCellinTAI,
        maxnoofCellsingNB,
        maxnoofCellsinngeNB,
        maxnoofCellsinUEHistoryInfo,
        maxnoofCellsUEMovingTrajectory,
        maxnoofDRBs,
        maxnoofEmergencyAreaID,
        maxnoofEAIforRestart,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofE_RABs,
        maxnoofErrors,
        maxnoofExtSliceItems,
        maxnoofForbTACs,
        maxnoofFreqforMDT,
        maxnoofMDTPLMNs,
        maxnoofMultiConnectivity,
        maxnoofMultiConnectivityMinusOne,
        maxnoofNeighPCIforMDT,
        maxnoofNGConnectionsToReset,
        maxnoofNRCellBands,
        maxnoofPC5QoSFlows,
        maxnoofPDUSessions,
        maxnoofPLMNs,
        maxnoofQosFlows,
        maxnoofQosParaSets,
        maxnoofRANNodeinAoI,
        maxnoofRecommendedCells,
        maxnoofRecommendedRANNodes,
        maxnoofAoI,
        maxnoofSensorName,
        maxnoofServedGUAMIs,
        maxnoofSliceItems,
        maxnoofTACs,
        maxnoofTAforMDT,
        maxnoofTAIforInactive,
        maxnoofTAIforPaging,
        maxnoofTAIforRestart,
        maxnoofTAIforWarning,
        maxnoofTAIinAoI,
        maxnoofTimePeriods,
        maxnoofTNLAssociations,
        maxnoofWLANName,
        maxnoofXnExtTLAs,
        maxnoofXnGTP_TLAs,
        maxnoofXnTLAs,
        maxnoofCandidateCells,
        maxNRARFCN,
        id_AllowedNSSAI,
        id_AMFName,
        id_AMFOverloadResponse,
        id_AMFSetID,
        id_AMF_TNLAssociationFailedToSetupList,
        id_AMF_TNLAssociationSetupList,
        id_AMF_TNLAssociationToAddList,
        id_AMF_TNLAssociationToRemoveList,
        id_AMF_TNLAssociationToUpdateList,
        id_AMFTrafficLoadReductionIndication,
        id_AMF_UE_NGAP_ID,
        id_AssistanceDataForPaging,
        id_BroadcastCancelledAreaList,
        id_BroadcastCompletedAreaList,
        id_CancelAllWarningMessages,
        id_Cause,
        id_CellIDListForRestart,
        id_ConcurrentWarningMessageInd,
        id_CoreNetworkAssistanceInformationForInactive,
        id_CriticalityDiagnostics,
        id_DataCodingScheme,
        id_DefaultPagingDRX,
        id_DirectForwardingPathAvailability,
        id_EmergencyAreaIDListForRestart,
        id_EmergencyFallbackIndicator,
        id_EUTRA_CGI,
        id_FiveG_S_TMSI,
        id_GlobalRANNodeID,
        id_GUAMI,
        id_HandoverType,
        id_IMSVoiceSupportIndicator,
        id_IndexToRFSP,
        id_InfoOnRecommendedCellsAndRANNodesForPaging,
        id_LocationReportingRequestType,
        id_MaskedIMEISV,
        id_MessageIdentifier,
        id_MobilityRestrictionList,
        id_NASC,
        id_NAS_PDU,
        id_NASSecurityParametersFromNGRAN,
        id_NewAMF_UE_NGAP_ID,
        id_NewSecurityContextInd,
        id_NGAP_Message,
        id_NGRAN_CGI,
        id_NGRANTraceID,
        id_NR_CGI,
        id_NRPPa_PDU,
        id_NumberOfBroadcastsRequested,
        id_OldAMF,
        id_OverloadStartNSSAIList,
        id_PagingDRX,
        id_PagingOrigin,
        id_PagingPriority,
        id_PDUSessionResourceAdmittedList,
        id_PDUSessionResourceFailedToModifyListModRes,
        id_PDUSessionResourceFailedToSetupListCxtRes,
        id_PDUSessionResourceFailedToSetupListHOAck,
        id_PDUSessionResourceFailedToSetupListPSReq,
        id_PDUSessionResourceFailedToSetupListSURes,
        id_PDUSessionResourceHandoverList,
        id_PDUSessionResourceListCxtRelCpl,
        id_PDUSessionResourceListHORqd,
        id_PDUSessionResourceModifyListModCfm,
        id_PDUSessionResourceModifyListModInd,
        id_PDUSessionResourceModifyListModReq,
        id_PDUSessionResourceModifyListModRes,
        id_PDUSessionResourceNotifyList,
        id_PDUSessionResourceReleasedListNot,
        id_PDUSessionResourceReleasedListPSAck,
        id_PDUSessionResourceReleasedListPSFail,
        id_PDUSessionResourceReleasedListRelRes,
        id_PDUSessionResourceSetupListCxtReq,
        id_PDUSessionResourceSetupListCxtRes,
        id_PDUSessionResourceSetupListHOReq,
        id_PDUSessionResourceSetupListSUReq,
        id_PDUSessionResourceSetupListSURes,
        id_PDUSessionResourceToBeSwitchedDLList,
        id_PDUSessionResourceSwitchedList,
        id_PDUSessionResourceToReleaseListHOCmd,
        id_PDUSessionResourceToReleaseListRelCmd,
        id_PLMNSupportList,
        id_PWSFailedCellIDList,
        id_RANNodeName,
        id_RANPagingPriority,
        id_RANStatusTransfer_TransparentContainer,
        id_RAN_UE_NGAP_ID,
        id_RelativeAMFCapacity,
        id_RepetitionPeriod,
        id_ResetType,
        id_RoutingID,
        id_RRCEstablishmentCause,
        id_RRCInactiveTransitionReportRequest,
        id_RRCState,
        id_SecurityContext,
        id_SecurityKey,
        id_SerialNumber,
        id_ServedGUAMIList,
        id_SliceSupportList,
        id_SONConfigurationTransferDL,
        id_SONConfigurationTransferUL,
        id_SourceAMF_UE_NGAP_ID,
        id_SourceToTarget_TransparentContainer,
        id_SupportedTAList,
        id_TAIListForPaging,
        id_TAIListForRestart,
        id_TargetID,
        id_TargetToSource_TransparentContainer,
        id_TimeToWait,
        id_TraceActivation,
        id_TraceCollectionEntityIPAddress,
        id_UEAggregateMaximumBitRate,
        id_UE_associatedLogicalNG_connectionList,
        id_UEContextRequest,
        id_UE_NGAP_IDs,
        id_UEPagingIdentity,
        id_UEPresenceInAreaOfInterestList,
        id_UERadioCapability,
        id_UERadioCapabilityForPaging,
        id_UESecurityCapabilities,
        id_UnavailableGUAMIList,
        id_UserLocationInformation,
        id_WarningAreaList,
        id_WarningMessageContents,
        id_WarningSecurityInfo,
        id_WarningType,
        id_AdditionalUL_NGU_UP_TNLInformation,
        id_DataForwardingNotPossible,
        id_DL_NGU_UP_TNLInformation,
        id_NetworkInstance,
        id_PDUSessionAggregateMaximumBitRate,
        id_PDUSessionResourceFailedToModifyListModCfm,
        id_PDUSessionResourceFailedToSetupListCxtFail,
        id_PDUSessionResourceListCxtRelReq,
        id_PDUSessionType,
        id_QosFlowAddOrModifyRequestList,
        id_QosFlowSetupRequestList,
        id_QosFlowToReleaseList,
        id_SecurityIndication,
        id_UL_NGU_UP_TNLInformation,
        id_UL_NGU_UP_TNLModifyList,
        id_WarningAreaCoordinates,
        id_PDUSessionResourceSecondaryRATUsageList,
        id_HandoverFlag,
        id_SecondaryRATUsageInformation,
        id_PDUSessionResourceReleaseResponseTransfer,
        id_RedirectionVoiceFallback,
        id_UERetentionInformation,
        id_S_NSSAI,
        id_PSCellInformation,
        id_LastEUTRAN_PLMNIdentity,
        id_MaximumIntegrityProtectedDataRate_DL,
        id_AdditionalDLForwardingUPTNLInformation,
        id_AdditionalDLUPTNLInformationForHOList,
        id_AdditionalNGU_UP_TNLInformation,
        id_AdditionalDLQosFlowPerTNLInformation,
        id_SecurityResult,
        id_ENDC_SONConfigurationTransferDL,
        id_ENDC_SONConfigurationTransferUL,
        id_OldAssociatedQosFlowList_ULendmarkerexpected,
        id_CNTypeRestrictionsForEquivalent,
        id_CNTypeRestrictionsForServing,
        id_NewGUAMI,
        id_ULForwarding,
        id_ULForwardingUP_TNLInformation,
        id_CNAssistedRANTuning,
        id_CommonNetworkInstance,
        id_NGRAN_TNLAssociationToRemoveList,
        id_TNLAssociationTransportLayerAddressNGRAN,
        id_EndpointIPAddressAndPort,
        id_LocationReportingAdditionalInfo,
        id_SourceToTarget_AMFInformationReroute,
        id_AdditionalULForwardingUPTNLInformation,
        id_SCTP_TLAs,
        id_SelectedPLMNIdentity,
        id_RIMInformationTransfer,
        id_GUAMIType,
        id_SRVCCOperationPossible,
        id_TargetRNC_ID,
        id_RAT_Information,
        id_ExtendedRATRestrictionInformation,
        id_QosMonitoringRequest,
        id_SgNB_UE_X2AP_ID,
        id_AdditionalRedundantDL_NGU_UP_TNLInformation,
        id_AdditionalRedundantDLQosFlowPerTNLInformation,
        id_AdditionalRedundantNGU_UP_TNLInformation,
        id_AdditionalRedundantUL_NGU_UP_TNLInformation,
        id_CNPacketDelayBudgetDL,
        id_CNPacketDelayBudgetUL,
        id_ExtendedPacketDelayBudget,
        id_RedundantCommonNetworkInstance,
        id_RedundantDL_NGU_TNLInformationReused,
        id_RedundantDL_NGU_UP_TNLInformation,
        id_RedundantDLQosFlowPerTNLInformation,
        id_RedundantQosFlowIndicator,
        id_RedundantUL_NGU_UP_TNLInformation,
        id_TSCTrafficCharacteristics,
        id_RedundantPDUSessionInformation,
        id_UsedRSNInformation,
        id_IAB_Authorized,
        id_IAB_Supported,
        id_IABNodeIndication,
        id_NB_IoT_PagingDRX,
        id_NB_IoT_Paging_eDRXInfo,
        id_NB_IoT_DefaultPagingDRX,
        id_Enhanced_CoverageRestriction,
        id_Extended_ConnectedTime,
        id_PagingAssisDataforCEcapabUE,
        id_WUS_Assistance_Information,
        id_UE_DifferentiationInfo,
        id_NB_IoT_UEPriority,
        id_UL_CP_SecurityInformation,
        id_DL_CP_SecurityInformation,
        id_TAI,
        id_UERadioCapabilityForPagingOfNB_IoT,
        id_LTEV2XServicesAuthorized,
        id_NRV2XServicesAuthorized,
        id_LTEUESidelinkAggregateMaximumBitrate,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_PC5QoSParameters,
        id_AlternativeQoSParaSetList,
        id_CurrentQoSParaSetIndex,
        id_CEmodeBrestricted,
        id_PagingeDRXInformation,
        id_CEmodeBSupport_Indicator,
        id_LTEM_Indication,
        id_EndIndication,
        id_EDT_Session,
        id_UECapabilityInfoRequest,
        id_PDUSessionResourceFailedToResumeListRESReq,
        id_PDUSessionResourceFailedToResumeListRESRes,
        id_PDUSessionResourceSuspendListSUSReq,
        id_PDUSessionResourceResumeListRESReq,
        id_PDUSessionResourceResumeListRESRes,
        id_UE_UP_CIoT_Support,
        id_Suspend_Request_Indication,
        id_Suspend_Response_Indication,
        id_RRC_Resume_Cause,
        id_RGLevelWirelineAccessCharacteristics,
        id_W_AGFIdentityInformation,
        id_GlobalTNGF_ID,
        id_GlobalTWIF_ID,
        id_GlobalW_AGF_ID,
        id_UserLocationInformationW_AGF,
        id_UserLocationInformationTNGF,
        id_AuthenticatedIndication,
        id_TNGFIdentityInformation,
        id_TWIFIdentityInformation,
        id_UserLocationInformationTWIF,
        id_DataForwardingResponseERABList,
        id_IntersystemSONConfigurationTransferDL,
        id_IntersystemSONConfigurationTransferUL,
        id_SONInformationReport,
        id_UEHistoryInformationFromTheUE,
        id_ManagementBasedMDTPLMNList,
        id_MDTConfiguration,
        id_PrivacyIndicator,
        id_TraceCollectionEntityURI,
        id_NPN_Support,
        id_NPN_AccessInformation,
        id_NPN_PagingAssistanceInformation,
        id_NPN_MobilityInformation,
        id_TargettoSource_Failure_TransparentContainer,
        id_NID,
        id_UERadioCapabilityID,
        id_UERadioCapability_EUTRA_Format,
        id_DAPSRequestInfo,
        id_DAPSResponseInfoList,
        id_EarlyStatusTransfer_TransparentContainer,
        id_NotifySourceNGRANNode,
        id_ExtendedSliceSupportList,
        id_ExtendedTAISliceSupportList,
        id_ConfiguredTACIndication,
        id_Extended_RANNodeName,
        id_Extended_AMFName,
        id_GlobalCable_ID,
        id_QosMonitoringReportingFrequency,
        id_QosFlowParametersList,
        id_QosFlowFeedbackList,
        id_BurstArrivalTimeDownlink,
        id_ExtendedUEIdentityIndexValue,
        id_PduSessionExpectedUEActivityBehaviour,
        id_MicoAllPLMN,
        id_QosFlowFailedToSetupList,
        id_SourceTNLAddrInfo,
        id_ExtendedReportIntervalMDT,
        id_SourceNodeID,
        id_SourceNodeTNLAddrInfo,
    ]

class NGAP_Containers:

    _name_  = u'NGAP-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 5]
    
    _obj_ = [
        u'NGAP-PROTOCOL-IES',
        u'NGAP-PROTOCOL-IES-PAIR',
        u'NGAP-PROTOCOL-EXTENSION',
        u'NGAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'NGAP-PROTOCOL-IES',
        u'NGAP-PROTOCOL-IES-PAIR',
        u'NGAP-PROTOCOL-EXTENSION',
        u'NGAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'NGAP-PROTOCOL-IES',
        u'NGAP-PROTOCOL-IES-PAIR',
        u'NGAP-PROTOCOL-EXTENSION',
        u'NGAP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< NGAP-PROTOCOL-IES >-----#
    NGAP_PROTOCOL_IES = CLASS(name=u'NGAP-PROTOCOL-IES', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NGAP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _NGAP_PROTOCOL_IES_id),
        (u'criticality', _NGAP_PROTOCOL_IES_criticality),
        (u'Value', _NGAP_PROTOCOL_IES_Value),
        (u'presence', _NGAP_PROTOCOL_IES_presence),
        ])
    
    #-----< NGAP-PROTOCOL-IES-PAIR >-----#
    NGAP_PROTOCOL_IES_PAIR = CLASS(name=u'NGAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NGAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _NGAP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _NGAP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _NGAP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _NGAP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _NGAP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _NGAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< NGAP-PROTOCOL-EXTENSION >-----#
    NGAP_PROTOCOL_EXTENSION = CLASS(name=u'NGAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _NGAP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _NGAP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _NGAP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _NGAP_PROTOCOL_EXTENSION_id),
        (u'criticality', _NGAP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _NGAP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _NGAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< NGAP-PRIVATE-IES >-----#
    NGAP_PRIVATE_IES = CLASS(name=u'NGAP-PRIVATE-IES', mode=MODE_TYPE)
    _NGAP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'PrivateIE-ID')))
    _NGAP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _NGAP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _NGAP_PRIVATE_IES_id),
        (u'criticality', _NGAP_PRIVATE_IES_criticality),
        (u'Value', _NGAP_PRIVATE_IES_Value),
        (u'presence', _NGAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name=u'ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _NGAP_PROTOCOL_IES_id,
        _NGAP_PROTOCOL_IES_criticality,
        _NGAP_PROTOCOL_IES_Value,
        _NGAP_PROTOCOL_IES_presence,
        NGAP_PROTOCOL_IES,
        _NGAP_PROTOCOL_IES_PAIR_id,
        _NGAP_PROTOCOL_IES_PAIR_firstCriticality,
        _NGAP_PROTOCOL_IES_PAIR_FirstValue,
        _NGAP_PROTOCOL_IES_PAIR_secondCriticality,
        _NGAP_PROTOCOL_IES_PAIR_SecondValue,
        _NGAP_PROTOCOL_IES_PAIR_presence,
        NGAP_PROTOCOL_IES_PAIR,
        _NGAP_PROTOCOL_EXTENSION_id,
        _NGAP_PROTOCOL_EXTENSION_criticality,
        _NGAP_PROTOCOL_EXTENSION_Extension,
        _NGAP_PROTOCOL_EXTENSION_presence,
        NGAP_PROTOCOL_EXTENSION,
        _NGAP_PRIVATE_IES_id,
        _NGAP_PRIVATE_IES_criticality,
        _NGAP_PRIVATE_IES_Value,
        _NGAP_PRIVATE_IES_presence,
        NGAP_PRIVATE_IES,
    ]

class NGAP_IEs:

    _name_  = u'NGAP-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 2]
    
    _obj_ = [
        u'AdditionalDLUPTNLInformationForHOList',
        u'AdditionalDLUPTNLInformationForHOItem',
        u'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        u'AdditionalQosFlowInformation',
        u'AllocationAndRetentionPriority',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'Allowed-CAG-List-per-PLMN',
        u'AllowedNSSAI',
        u'AllowedNSSAI-Item',
        u'AllowedNSSAI-Item-ExtIEs',
        u'Allowed-PNI-NPN-List',
        u'Allowed-PNI-NPN-Item',
        u'Allowed-PNI-NPN-Item-ExtIEs',
        u'AllowedTACs',
        u'AlternativeQoSParaSetIndex',
        u'AlternativeQoSParaSetNotifyIndex',
        u'AlternativeQoSParaSetList',
        u'AlternativeQoSParaSetItem',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AMFName',
        u'AMFNameVisibleString',
        u'AMFNameUTF8String',
        u'AMFPagingTarget',
        u'AMFPagingTarget-ExtIEs',
        u'AMFPointer',
        u'AMFRegionID',
        u'AMFSetID',
        u'AMF-TNLAssociationSetupList',
        u'AMF-TNLAssociationSetupItem',
        u'AMF-TNLAssociationSetupItem-ExtIEs',
        u'AMF-TNLAssociationToAddList',
        u'AMF-TNLAssociationToAddItem',
        u'AMF-TNLAssociationToAddItem-ExtIEs',
        u'AMF-TNLAssociationToRemoveList',
        u'AMF-TNLAssociationToRemoveItem',
        u'AMF-TNLAssociationToRemoveItem-ExtIEs',
        u'AMF-TNLAssociationToUpdateList',
        u'AMF-TNLAssociationToUpdateItem',
        u'AMF-TNLAssociationToUpdateItem-ExtIEs',
        u'AMF-UE-NGAP-ID',
        u'AreaOfInterest',
        u'AreaOfInterest-ExtIEs',
        u'AreaOfInterestCellList',
        u'AreaOfInterestCellItem',
        u'AreaOfInterestCellItem-ExtIEs',
        u'AreaOfInterestList',
        u'AreaOfInterestItem',
        u'AreaOfInterestItem-ExtIEs',
        u'AreaOfInterestRANNodeList',
        u'AreaOfInterestRANNodeItem',
        u'AreaOfInterestRANNodeItem-ExtIEs',
        u'AreaOfInterestTAIList',
        u'AreaOfInterestTAIItem',
        u'AreaOfInterestTAIItem-ExtIEs',
        u'AssistanceDataForPaging',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'AssociatedQosFlowList',
        u'AssociatedQosFlowItem',
        u'AssociatedQosFlowItem-ExtIEs',
        u'AuthenticatedIndication',
        u'AveragingWindow',
        u'AreaScopeOfMDT-NR',
        u'AreaScopeOfMDT-NR-ExtIEs',
        u'AreaScopeOfMDT-EUTRA',
        u'AreaScopeOfMDT-EUTRA-ExtIEs',
        u'AreaScopeOfNeighCellsList',
        u'AreaScopeOfNeighCellsItem',
        u'AreaScopeOfNeighCellsItem-ExtIEs',
        u'BitRate',
        u'BroadcastCancelledAreaList',
        u'BroadcastCancelledAreaList-ExtIEs',
        u'BroadcastCompletedAreaList',
        u'BroadcastCompletedAreaList-ExtIEs',
        u'BroadcastPLMNList',
        u'BroadcastPLMNItem',
        u'BroadcastPLMNItem-ExtIEs',
        u'BluetoothMeasurementConfiguration',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'BluetoothMeasConfigNameList',
        u'BluetoothMeasConfigNameItem',
        u'BluetoothMeasConfigNameItem-ExtIEs',
        u'BluetoothMeasConfig',
        u'BluetoothName',
        u'BurstArrivalTime',
        u'CAG-ID',
        u'CancelAllWarningMessages',
        u'CancelledCellsInEAI-EUTRA',
        u'CancelledCellsInEAI-EUTRA-Item',
        u'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInEAI-NR',
        u'CancelledCellsInEAI-NR-Item',
        u'CancelledCellsInEAI-NR-Item-ExtIEs',
        u'CancelledCellsInTAI-EUTRA',
        u'CancelledCellsInTAI-EUTRA-Item',
        u'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInTAI-NR',
        u'CancelledCellsInTAI-NR-Item',
        u'CancelledCellsInTAI-NR-Item-ExtIEs',
        u'CandidateCellList',
        u'CandidateCellItem',
        u'CandidateCellItem-ExtIEs',
        u'CandidateCell',
        u'CandidateCell-ExtIEs',
        u'CandidateCellID',
        u'CandidateCellID-ExtIEs',
        u'CandidatePCI',
        u'CandidatePCI-ExtIEs',
        u'Cause',
        u'Cause-ExtIEs',
        u'CauseMisc',
        u'CauseNas',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'Cell-CAGInformation',
        u'Cell-CAGInformation-ExtIEs',
        u'CellCAGList',
        u'CellIDBroadcastEUTRA',
        u'CellIDBroadcastEUTRA-Item',
        u'CellIDBroadcastEUTRA-Item-ExtIEs',
        u'CellIDBroadcastNR',
        u'CellIDBroadcastNR-Item',
        u'CellIDBroadcastNR-Item-ExtIEs',
        u'CellIDCancelledEUTRA',
        u'CellIDCancelledEUTRA-Item',
        u'CellIDCancelledEUTRA-Item-ExtIEs',
        u'CellIDCancelledNR',
        u'CellIDCancelledNR-Item',
        u'CellIDCancelledNR-Item-ExtIEs',
        u'CellIDListForRestart',
        u'CellIDListForRestart-ExtIEs',
        u'CellSize',
        u'CellType',
        u'CellType-ExtIEs',
        u'CEmodeBSupport-Indicator',
        u'CEmodeBrestricted',
        u'CNAssistedRANTuning',
        u'CNAssistedRANTuning-ExtIEs',
        u'CNTypeRestrictionsForEquivalent',
        u'CNTypeRestrictionsForEquivalentItem',
        u'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        u'CNTypeRestrictionsForServing',
        u'CommonNetworkInstance',
        u'CompletedCellsInEAI-EUTRA',
        u'CompletedCellsInEAI-EUTRA-Item',
        u'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInEAI-NR',
        u'CompletedCellsInEAI-NR-Item',
        u'CompletedCellsInEAI-NR-Item-ExtIEs',
        u'CompletedCellsInTAI-EUTRA',
        u'CompletedCellsInTAI-EUTRA-Item',
        u'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInTAI-NR',
        u'CompletedCellsInTAI-NR-Item',
        u'CompletedCellsInTAI-NR-Item-ExtIEs',
        u'ConcurrentWarningMessageInd',
        u'ConfidentialityProtectionIndication',
        u'ConfidentialityProtectionResult',
        u'ConfiguredTACIndication',
        u'CoreNetworkAssistanceInformationForInactive',
        u'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        u'COUNTValueForPDCP-SN12',
        u'COUNTValueForPDCP-SN12-ExtIEs',
        u'COUNTValueForPDCP-SN18',
        u'COUNTValueForPDCP-SN18-ExtIEs',
        u'CoverageEnhancementLevel',
        u'CPTransportLayerInformation',
        u'CPTransportLayerInformation-ExtIEs',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'CellBasedMDT-NR',
        u'CellBasedMDT-NR-ExtIEs',
        u'CellIdListforMDT-NR',
        u'CellBasedMDT-EUTRA',
        u'CellBasedMDT-EUTRA-ExtIEs',
        u'CellIdListforMDT-EUTRA',
        u'DataCodingScheme',
        u'DataForwardingAccepted',
        u'DataForwardingNotPossible',
        u'DataForwardingResponseDRBList',
        u'DataForwardingResponseDRBItem',
        u'DataForwardingResponseDRBItem-ExtIEs',
        u'DAPSRequestInfo',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoList',
        u'DAPSResponseInfoItem',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo',
        u'DAPSResponseInfo-ExtIEs',
        u'DataForwardingResponseERABList',
        u'DataForwardingResponseERABListItem',
        u'DataForwardingResponseERABListItem-ExtIEs',
        u'DelayCritical',
        u'DL-CP-SecurityInformation',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'DL-NAS-MAC',
        u'DLForwarding',
        u'DL-NGU-TNLInformationReused',
        u'DirectForwardingPathAvailability',
        u'DRB-ID',
        u'DRBsSubjectToStatusTransferList',
        u'DRBsSubjectToStatusTransferItem',
        u'DRBsSubjectToStatusTransferItem-ExtIEs',
        u'DRBStatusDL',
        u'DRBStatusDL-ExtIEs',
        u'DRBStatusDL12',
        u'DRBStatusDL12-ExtIEs',
        u'DRBStatusDL18',
        u'DRBStatusDL18-ExtIEs',
        u'DRBStatusUL',
        u'DRBStatusUL-ExtIEs',
        u'DRBStatusUL12',
        u'DRBStatusUL12-ExtIEs',
        u'DRBStatusUL18',
        u'DRBStatusUL18-ExtIEs',
        u'DRBsToQosFlowsMappingList',
        u'DRBsToQosFlowsMappingItem',
        u'DRBsToQosFlowsMappingItem-ExtIEs',
        u'Dynamic5QIDescriptor',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'EarlyStatusTransfer-TransparentContainer',
        u'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'ProcedureStageChoice',
        u'ProcedureStageChoice-ExtIEs',
        u'FirstDLCount',
        u'FirstDLCount-ExtIEs',
        u'DRBsSubjectToEarlyStatusTransfer-List',
        u'DRBsSubjectToEarlyStatusTransfer-Item',
        u'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        u'EDT-Session',
        u'EmergencyAreaID',
        u'EmergencyAreaIDBroadcastEUTRA',
        u'EmergencyAreaIDBroadcastEUTRA-Item',
        u'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDBroadcastNR',
        u'EmergencyAreaIDBroadcastNR-Item',
        u'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        u'EmergencyAreaIDCancelledEUTRA',
        u'EmergencyAreaIDCancelledEUTRA-Item',
        u'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDCancelledNR',
        u'EmergencyAreaIDCancelledNR-Item',
        u'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        u'EmergencyAreaIDList',
        u'EmergencyAreaIDListForRestart',
        u'EmergencyFallbackIndicator',
        u'EmergencyFallbackIndicator-ExtIEs',
        u'EmergencyFallbackRequestIndicator',
        u'EmergencyServiceTargetCN',
        u'ENB-ID',
        u'ENB-ID-ExtIEs',
        u'Enhanced-CoverageRestriction',
        u'Extended-ConnectedTime',
        u'EN-DCSONConfigurationTransfer',
        u'EndpointIPAddressAndPort',
        u'EndIndication',
        u'EndpointIPAddressAndPort-ExtIEs',
        u'EquivalentPLMNs',
        u'EPS-TAC',
        u'EPS-TAI',
        u'EPS-TAI-ExtIEs',
        u'E-RAB-ID',
        u'E-RABInformationList',
        u'E-RABInformationItem',
        u'E-RABInformationItem-ExtIEs',
        u'EUTRACellIdentity',
        u'EUTRA-CGI',
        u'EUTRA-CGI-ExtIEs',
        u'EUTRA-CGIList',
        u'EUTRA-CGIListForWarning',
        u'EUTRAencryptionAlgorithms',
        u'EUTRAintegrityProtectionAlgorithms',
        u'EventType',
        u'ExpectedActivityPeriod',
        u'ExpectedHOInterval',
        u'ExpectedIdlePeriod',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExpectedUEBehaviour',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEMobility',
        u'ExpectedUEMovingTrajectory',
        u'ExpectedUEMovingTrajectoryItem',
        u'ExpectedUEMovingTrajectoryItem-ExtIEs',
        u'Extended-AMFName',
        u'Extended-AMFName-ExtIEs',
        u'ExtendedPacketDelayBudget',
        u'Extended-RANNodeName',
        u'Extended-RANNodeName-ExtIEs',
        u'ExtendedRATRestrictionInformation',
        u'ExtendedRATRestrictionInformation-ExtIEs',
        u'ExtendedRNC-ID',
        u'ExtendedSliceSupportList',
        u'ExtendedUEIdentityIndexValue',
        u'EventTrigger',
        u'EventTrigger-ExtIEs',
        u'EventL1LoggedMDTConfig',
        u'EventL1LoggedMDTConfig-ExtIEs',
        u'MeasurementThresholdL1LoggedMDT',
        u'MeasurementThresholdL1LoggedMDT-ExtIEs',
        u'FailureIndication',
        u'FailureIndication-ExtIEs',
        u'FiveG-S-TMSI',
        u'FiveG-S-TMSI-ExtIEs',
        u'FiveG-TMSI',
        u'FiveQI',
        u'ForbiddenAreaInformation',
        u'ForbiddenAreaInformation-Item',
        u'ForbiddenAreaInformation-Item-ExtIEs',
        u'ForbiddenTACs',
        u'FromEUTRANtoNGRAN',
        u'FromEUTRANtoNGRAN-ExtIEs',
        u'FromNGRANtoEUTRAN',
        u'FromNGRANtoEUTRAN-ExtIEs',
        u'GBR-QosInformation',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalCable-ID',
        u'GlobalENB-ID',
        u'GlobalENB-ID-ExtIEs',
        u'GlobalGNB-ID',
        u'GlobalGNB-ID-ExtIEs',
        u'GlobalN3IWF-ID',
        u'GlobalN3IWF-ID-ExtIEs',
        u'GlobalLine-ID',
        u'GlobalLine-ID-ExtIEs',
        u'GlobalLineIdentity',
        u'GlobalNgENB-ID',
        u'GlobalNgENB-ID-ExtIEs',
        u'GlobalRANNodeID',
        u'GlobalRANNodeID-ExtIEs',
        u'GlobalTNGF-ID',
        u'GlobalTNGF-ID-ExtIEs',
        u'GlobalTWIF-ID',
        u'GlobalTWIF-ID-ExtIEs',
        u'GlobalW-AGF-ID',
        u'GlobalW-AGF-ID-ExtIEs',
        u'GNB-ID',
        u'GNB-ID-ExtIEs',
        u'GTP-TEID',
        u'GTPTunnel',
        u'GTPTunnel-ExtIEs',
        u'GUAMI',
        u'GUAMI-ExtIEs',
        u'GUAMIType',
        u'HandoverCommandTransfer',
        u'HandoverCommandTransfer-ExtIEs',
        u'HandoverFlag',
        u'HandoverPreparationUnsuccessfulTransfer',
        u'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        u'HandoverRequestAcknowledgeTransfer',
        u'HandoverRequestAcknowledgeTransfer-ExtIEs',
        u'HandoverRequiredTransfer',
        u'HandoverRequiredTransfer-ExtIEs',
        u'HandoverResourceAllocationUnsuccessfulTransfer',
        u'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        u'HandoverType',
        u'HFCNode-ID',
        u'HOReport',
        u'HOReport-ExtIEs',
        u'Hysteresis',
        u'IAB-Authorized',
        u'IAB-Supported',
        u'IABNodeIndication',
        u'IMSVoiceSupportIndicator',
        u'IndexToRFSP',
        u'InfoOnRecommendedCellsAndRANNodesForPaging',
        u'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        u'IntegrityProtectionIndication',
        u'IntegrityProtectionResult',
        u'IntendedNumberOfPagingAttempts',
        u'InterfacesToTrace',
        u'ImmediateMDTNr',
        u'ImmediateMDTNr-ExtIEs',
        u'InterSystemFailureIndication',
        u'InterSystemFailureIndication-ExtIEs',
        u'IntersystemSONConfigurationTransfer',
        u'IntersystemSONConfigurationTransfer-ExtIEs',
        u'IntersystemSONTransferType',
        u'IntersystemSONTransferType-ExtIEs',
        u'IntersystemSONeNBID',
        u'IntersystemSONeNBID-ExtIEs',
        u'IntersystemSONNGRANnodeID',
        u'IntersystemSONNGRANnodeID-ExtIEs',
        u'IntersystemSONInformation',
        u'IntersystemSONInformation-ExtIEs',
        u'IntersystemSONInformationReport',
        u'IntersystemSONInformationReport-ExtIEs',
        u'InterSystemHOReport',
        u'InterSystemHOReport-ExtIEs',
        u'InterSystemHandoverReportType',
        u'InterSystemHandoverReportType-ExtIEs',
        u'IntersystemUnnecessaryHO',
        u'IntersystemUnnecessaryHO-ExtIEs',
        u'LAC',
        u'LAI',
        u'LAI-ExtIEs',
        u'LastVisitedCellInformation',
        u'LastVisitedCellInformation-ExtIEs',
        u'LastVisitedCellItem',
        u'LastVisitedCellItem-ExtIEs',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedGERANCellInformation',
        u'LastVisitedNGRANCellInformation',
        u'LastVisitedNGRANCellInformation-ExtIEs',
        u'LastVisitedUTRANCellInformation',
        u'LineType',
        u'LocationReportingAdditionalInfo',
        u'LocationReportingReferenceID',
        u'LocationReportingRequestType',
        u'LocationReportingRequestType-ExtIEs',
        u'LoggedMDTNr',
        u'LoggedMDTNr-ExtIEs',
        u'LoggingInterval',
        u'LoggingDuration',
        u'Links-to-log',
        u'LoggedMDTTrigger',
        u'LoggedMDTTrigger-ExtIEs',
        u'LTEM-Indication',
        u'LTEUERLFReportContainer',
        u'LTEV2XServicesAuthorized',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'LTEUESidelinkAggregateMaximumBitrate',
        u'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'MaskedIMEISV',
        u'MaximumDataBurstVolume',
        u'MessageIdentifier',
        u'MaximumIntegrityProtectedDataRate',
        u'MicoAllPLMN',
        u'MICOModeIndication',
        u'MobilityInformation',
        u'MobilityRestrictionList',
        u'MobilityRestrictionList-ExtIEs',
        u'MDTPLMNList',
        u'MDT-Configuration',
        u'MDT-Configuration-ExtIEs',
        u'MDT-Configuration-NR',
        u'MDT-Configuration-NR-ExtIEs',
        u'MDT-Configuration-EUTRA',
        u'MDT-Configuration-EUTRA-ExtIEs',
        u'MDT-Activation',
        u'MDTModeNr',
        u'MDTModeNr-ExtIEs',
        u'MDTModeEutra',
        u'MeasurementsToActivate',
        u'M1Configuration',
        u'M1Configuration-ExtIEs',
        u'M1ReportingTrigger',
        u'M1ThresholdEventA2',
        u'M1ThresholdEventA2-ExtIEs',
        u'M1ThresholdType',
        u'M1ThresholdType-ExtIEs',
        u'M1PeriodicReporting',
        u'M1PeriodicReporting-ExtIEs',
        u'M4Configuration',
        u'M4Configuration-ExtIEs',
        u'M4period',
        u'M5Configuration',
        u'M5Configuration-ExtIEs',
        u'M5period',
        u'M6Configuration',
        u'M6Configuration-ExtIEs',
        u'M6report-Interval',
        u'M7Configuration',
        u'M7Configuration-ExtIEs',
        u'M7period',
        u'MDT-Location-Info',
        u'MDT-Location-Info-ExtIEs',
        u'MDT-Location-Information',
        u'N3IWF-ID',
        u'N3IWF-ID-ExtIEs',
        u'NAS-PDU',
        u'NASSecurityParametersFromNGRAN',
        u'NB-IoT-DefaultPagingDRX',
        u'NB-IoT-PagingDRX',
        u'NB-IoT-Paging-eDRXCycle',
        u'NB-IoT-Paging-TimeWindow',
        u'NB-IoT-Paging-eDRXInfo',
        u'NB-IoT-Paging-eDRXInfo-ExtIEs',
        u'NB-IoT-UEPriority',
        u'NetworkInstance',
        u'NewSecurityContextInd',
        u'NextHopChainingCount',
        u'NextPagingAreaScope',
        u'NgENB-ID',
        u'NgENB-ID-ExtIEs',
        u'NotifySourceNGRANNode',
        u'NGRAN-CGI',
        u'NGRAN-CGI-ExtIEs',
        u'NGRAN-TNLAssociationToRemoveList',
        u'NGRAN-TNLAssociationToRemoveItem',
        u'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        u'NGRANTraceID',
        u'NID',
        u'NonDynamic5QIDescriptor',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NotAllowedTACs',
        u'NotificationCause',
        u'NotificationControl',
        u'NPN-AccessInformation',
        u'NPN-AccessInformation-ExtIEs',
        u'NPN-MobilityInformation',
        u'NPN-MobilityInformation-ExtIEs',
        u'NPN-PagingAssistanceInformation',
        u'NPN-PagingAssistanceInformation-ExtIEs',
        u'NPN-Support',
        u'NPN-Support-ExtIEs',
        u'NRCellIdentity',
        u'NR-CGI',
        u'NR-CGI-ExtIEs',
        u'NR-CGIList',
        u'NR-CGIListForWarning',
        u'NRencryptionAlgorithms',
        u'NRintegrityProtectionAlgorithms',
        u'NRMobilityHistoryReport',
        u'NRPPa-PDU',
        u'NRUERLFReportContainer',
        u'NumberOfBroadcasts',
        u'NumberOfBroadcastsRequested',
        u'NRARFCN',
        u'NRFrequencyBand',
        u'NRFrequencyBand-List',
        u'NRFrequencyBandItem',
        u'NRFrequencyBandItem-ExtIEs',
        u'NRFrequencyInfo',
        u'NRFrequencyInfo-ExtIEs',
        u'NR-PCI',
        u'NRV2XServicesAuthorized',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'VehicleUE',
        u'PedestrianUE',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'OverloadAction',
        u'OverloadResponse',
        u'OverloadResponse-ExtIEs',
        u'OverloadStartNSSAIList',
        u'OverloadStartNSSAIItem',
        u'OverloadStartNSSAIItem-ExtIEs',
        u'PacketDelayBudget',
        u'PacketErrorRate',
        u'PacketErrorRate-ExtIEs',
        u'PacketLossRate',
        u'PagingAssisDataforCEcapabUE',
        u'PagingAssisDataforCEcapabUE-ExtIEs',
        u'PagingAttemptInformation',
        u'PagingAttemptInformation-ExtIEs',
        u'PagingAttemptCount',
        u'PagingDRX',
        u'PagingOrigin',
        u'PagingPriority',
        u'PagingeDRXInformation',
        u'PagingeDRXInformation-ExtIEs',
        u'Paging-eDRX-Cycle',
        u'Paging-Time-Window',
        u'PagingProbabilityInformation',
        u'PathSwitchRequestAcknowledgeTransfer',
        u'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        u'PathSwitchRequestSetupFailedTransfer',
        u'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        u'PathSwitchRequestTransfer',
        u'PathSwitchRequestTransfer-ExtIEs',
        u'PathSwitchRequestUnsuccessfulTransfer',
        u'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        u'PC5QoSParameters',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowList',
        u'PC5QoSFlowItem',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates',
        u'PC5FlowBitRates-ExtIEs',
        u'PCIListForMDT',
        u'PrivacyIndicator',
        u'PDUSessionAggregateMaximumBitRate',
        u'PDUSessionAggregateMaximumBitRate-ExtIEs',
        u'PDUSessionID',
        u'PDUSessionResourceAdmittedList',
        u'PDUSessionResourceAdmittedItem',
        u'PDUSessionResourceAdmittedItem-ExtIEs',
        u'PDUSessionResourceFailedToModifyListModCfm',
        u'PDUSessionResourceFailedToModifyItemModCfm',
        u'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceFailedToModifyListModRes',
        u'PDUSessionResourceFailedToModifyItemModRes',
        u'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        u'PDUSessionResourceFailedToResumeListRESReq',
        u'PDUSessionResourceFailedToResumeItemRESReq',
        u'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceFailedToResumeListRESRes',
        u'PDUSessionResourceFailedToResumeItemRESRes',
        u'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupListCxtFail',
        u'PDUSessionResourceFailedToSetupItemCxtFail',
        u'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        u'PDUSessionResourceFailedToSetupListCxtRes',
        u'PDUSessionResourceFailedToSetupItemCxtRes',
        u'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupListHOAck',
        u'PDUSessionResourceFailedToSetupItemHOAck',
        u'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        u'PDUSessionResourceFailedToSetupListPSReq',
        u'PDUSessionResourceFailedToSetupItemPSReq',
        u'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        u'PDUSessionResourceFailedToSetupListSURes',
        u'PDUSessionResourceFailedToSetupItemSURes',
        u'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        u'PDUSessionResourceHandoverList',
        u'PDUSessionResourceHandoverItem',
        u'PDUSessionResourceHandoverItem-ExtIEs',
        u'PDUSessionResourceInformationList',
        u'PDUSessionResourceInformationItem',
        u'PDUSessionResourceInformationItem-ExtIEs',
        u'PDUSessionResourceListCxtRelCpl',
        u'PDUSessionResourceItemCxtRelCpl',
        u'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        u'PDUSessionResourceListCxtRelReq',
        u'PDUSessionResourceItemCxtRelReq',
        u'PDUSessionResourceItemCxtRelReq-ExtIEs',
        u'PDUSessionResourceListHORqd',
        u'PDUSessionResourceItemHORqd',
        u'PDUSessionResourceItemHORqd-ExtIEs',
        u'PDUSessionResourceModifyConfirmTransfer',
        u'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer',
        u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceModifyRequestTransfer',
        u'PDUSessionResourceModifyRequestTransferIEs',
        u'PDUSessionResourceModifyResponseTransfer',
        u'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationTransfer',
        u'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        u'PDUSessionResourceModifyListModCfm',
        u'PDUSessionResourceModifyItemModCfm',
        u'PDUSessionResourceModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceModifyListModInd',
        u'PDUSessionResourceModifyItemModInd',
        u'PDUSessionResourceModifyItemModInd-ExtIEs',
        u'PDUSessionResourceModifyListModReq',
        u'PDUSessionResourceModifyItemModReq',
        u'PDUSessionResourceModifyItemModReq-ExtIEs',
        u'PDUSessionResourceModifyListModRes',
        u'PDUSessionResourceModifyItemModRes',
        u'PDUSessionResourceModifyItemModRes-ExtIEs',
        u'PDUSessionResourceModifyUnsuccessfulTransfer',
        u'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceNotifyList',
        u'PDUSessionResourceNotifyItem',
        u'PDUSessionResourceNotifyItem-ExtIEs',
        u'PDUSessionResourceNotifyReleasedTransfer',
        u'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        u'PDUSessionResourceNotifyTransfer',
        u'PDUSessionResourceNotifyTransfer-ExtIEs',
        u'PDUSessionResourceReleaseCommandTransfer',
        u'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        u'PDUSessionResourceReleasedListNot',
        u'PDUSessionResourceReleasedItemNot',
        u'PDUSessionResourceReleasedItemNot-ExtIEs',
        u'PDUSessionResourceReleasedListPSAck',
        u'PDUSessionResourceReleasedItemPSAck',
        u'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        u'PDUSessionResourceReleasedListPSFail',
        u'PDUSessionResourceReleasedItemPSFail',
        u'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        u'PDUSessionResourceReleasedListRelRes',
        u'PDUSessionResourceReleasedItemRelRes',
        u'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        u'PDUSessionResourceReleaseResponseTransfer',
        u'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        u'PDUSessionResourceResumeListRESReq',
        u'PDUSessionResourceResumeItemRESReq',
        u'PDUSessionResourceResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceResumeListRESRes',
        u'PDUSessionResourceResumeItemRESRes',
        u'PDUSessionResourceResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceSecondaryRATUsageList',
        u'PDUSessionResourceSecondaryRATUsageItem',
        u'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        u'PDUSessionResourceSetupListCxtReq',
        u'PDUSessionResourceSetupItemCxtReq',
        u'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        u'PDUSessionResourceSetupListCxtRes',
        u'PDUSessionResourceSetupItemCxtRes',
        u'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceSetupListHOReq',
        u'PDUSessionResourceSetupItemHOReq',
        u'PDUSessionResourceSetupItemHOReq-ExtIEs',
        u'PDUSessionResourceSetupListSUReq',
        u'PDUSessionResourceSetupItemSUReq',
        u'PDUSessionResourceSetupItemSUReq-ExtIEs',
        u'PDUSessionResourceSetupListSURes',
        u'PDUSessionResourceSetupItemSURes',
        u'PDUSessionResourceSetupItemSURes-ExtIEs',
        u'PDUSessionResourceSetupRequestTransfer',
        u'PDUSessionResourceSetupRequestTransferIEs',
        u'PDUSessionResourceSetupResponseTransfer',
        u'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        u'PDUSessionResourceSetupUnsuccessfulTransfer',
        u'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceSuspendListSUSReq',
        u'PDUSessionResourceSuspendItemSUSReq',
        u'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        u'PDUSessionResourceSwitchedList',
        u'PDUSessionResourceSwitchedItem',
        u'PDUSessionResourceSwitchedItem-ExtIEs',
        u'PDUSessionResourceToBeSwitchedDLList',
        u'PDUSessionResourceToBeSwitchedDLItem',
        u'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        u'PDUSessionResourceToReleaseListHOCmd',
        u'PDUSessionResourceToReleaseItemHOCmd',
        u'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        u'PDUSessionResourceToReleaseListRelCmd',
        u'PDUSessionResourceToReleaseItemRelCmd',
        u'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        u'PDUSessionType',
        u'PDUSessionUsageReport',
        u'PDUSessionUsageReport-ExtIEs',
        u'Periodicity',
        u'PeriodicRegistrationUpdateTimer',
        u'PLMNIdentity',
        u'PLMNSupportList',
        u'PLMNSupportItem',
        u'PLMNSupportItem-ExtIEs',
        u'PNI-NPN-MobilityInformation',
        u'PNI-NPN-MobilityInformation-ExtIEs',
        u'PortNumber',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevelARP',
        u'PriorityLevelQos',
        u'PWSFailedCellIDList',
        u'PWSFailedCellIDList-ExtIEs',
        u'QosCharacteristics',
        u'QosCharacteristics-ExtIEs',
        u'QosFlowAcceptedList',
        u'QosFlowAcceptedItem',
        u'QosFlowAcceptedItem-ExtIEs',
        u'QosFlowAddOrModifyRequestList',
        u'QosFlowAddOrModifyRequestItem',
        u'QosFlowAddOrModifyRequestItem-ExtIEs',
        u'QosFlowAddOrModifyResponseList',
        u'QosFlowAddOrModifyResponseItem',
        u'QosFlowAddOrModifyResponseItem-ExtIEs',
        u'QosFlowFeedbackList',
        u'QosFlowFeedbackItem',
        u'QosFlowFeedbackItem-ExtIEs',
        u'QosFlowIdentifier',
        u'QosFlowInformationList',
        u'QosFlowInformationItem',
        u'QosFlowInformationItem-ExtIEs',
        u'QosFlowLevelQosParameters',
        u'QosFlowLevelQosParameters-ExtIEs',
        u'QosMonitoringRequest',
        u'QosMonitoringReportingFrequency',
        u'QosFlowListWithCause',
        u'QosFlowWithCauseItem',
        u'QosFlowWithCauseItem-ExtIEs',
        u'QosFlowModifyConfirmList',
        u'QosFlowModifyConfirmItem',
        u'QosFlowModifyConfirmItem-ExtIEs',
        u'QosFlowNotifyList',
        u'QosFlowNotifyItem',
        u'QosFlowNotifyItem-ExtIEs',
        u'QosFlowParametersList',
        u'QosFlowParametersItem',
        u'QosFlowParametersItem-ExtIEs',
        u'QosFlowPerTNLInformation',
        u'QosFlowPerTNLInformation-ExtIEs',
        u'QosFlowPerTNLInformationList',
        u'QosFlowPerTNLInformationItem',
        u'QosFlowPerTNLInformationItem-ExtIEs',
        u'QosFlowSetupRequestList',
        u'QosFlowSetupRequestItem',
        u'QosFlowSetupRequestItem-ExtIEs',
        u'QosFlowListWithDataForwarding',
        u'QosFlowItemWithDataForwarding',
        u'QosFlowItemWithDataForwarding-ExtIEs',
        u'QosFlowToBeForwardedList',
        u'QosFlowToBeForwardedItem',
        u'QosFlowToBeForwardedItem-ExtIEs',
        u'QoSFlowsUsageReportList',
        u'QoSFlowsUsageReport-Item',
        u'QoSFlowsUsageReport-Item-ExtIEs',
        u'Range',
        u'RANNodeName',
        u'RANNodeNameVisibleString',
        u'RANNodeNameUTF8String',
        u'RANPagingPriority',
        u'RANStatusTransfer-TransparentContainer',
        u'RANStatusTransfer-TransparentContainer-ExtIEs',
        u'RAN-UE-NGAP-ID',
        u'RAT-Information',
        u'RATRestrictions',
        u'RATRestrictions-Item',
        u'RATRestrictions-Item-ExtIEs',
        u'RATRestrictionInformation',
        u'RecommendedCellsForPaging',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellList',
        u'RecommendedCellItem',
        u'RecommendedCellItem-ExtIEs',
        u'RecommendedRANNodesForPaging',
        u'RecommendedRANNodesForPaging-ExtIEs',
        u'RecommendedRANNodeList',
        u'RecommendedRANNodeItem',
        u'RecommendedRANNodeItem-ExtIEs',
        u'RedirectionVoiceFallback',
        u'RedundantPDUSessionInformation',
        u'RedundantPDUSessionInformation-ExtIEs',
        u'RedundantQosFlowIndicator',
        u'ReflectiveQosAttribute',
        u'RelativeAMFCapacity',
        u'ReportArea',
        u'RepetitionPeriod',
        u'ResetAll',
        u'ReportAmountMDT',
        u'ReportIntervalMDT',
        u'ExtendedReportIntervalMDT',
        u'ResetType',
        u'ResetType-ExtIEs',
        u'RGLevelWirelineAccessCharacteristics',
        u'RNC-ID',
        u'RoutingID',
        u'RRCContainer',
        u'RRCEstablishmentCause',
        u'RRCInactiveTransitionReportRequest',
        u'RRCState',
        u'RSN',
        u'RIMInformationTransfer',
        u'RIMInformationTransfer-ExtIEs',
        u'RIMInformation',
        u'RIMInformation-ExtIEs',
        u'GNBSetID',
        u'ScheduledCommunicationTime',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SCTP-TLAs',
        u'SD',
        u'SecondaryRATUsageInformation',
        u'SecondaryRATUsageInformation-ExtIEs',
        u'SecondaryRATDataUsageReportTransfer',
        u'SecondaryRATDataUsageReportTransfer-ExtIEs',
        u'SecurityContext',
        u'SecurityContext-ExtIEs',
        u'SecurityIndication',
        u'SecurityIndication-ExtIEs',
        u'SecurityKey',
        u'SecurityResult',
        u'SecurityResult-ExtIEs',
        u'SensorMeasurementConfiguration',
        u'SensorMeasurementConfiguration-ExtIEs',
        u'SensorMeasConfigNameList',
        u'SensorMeasConfigNameItem',
        u'SensorMeasConfigNameItem-ExtIEs',
        u'SensorMeasConfig',
        u'SensorNameConfig',
        u'SensorNameConfig-ExtIEs',
        u'SerialNumber',
        u'ServedGUAMIList',
        u'ServedGUAMIItem',
        u'ServedGUAMIItem-ExtIEs',
        u'ServiceAreaInformation',
        u'ServiceAreaInformation-Item',
        u'ServiceAreaInformation-Item-ExtIEs',
        u'SgNB-UE-X2AP-ID',
        u'SliceOverloadList',
        u'SliceOverloadItem',
        u'SliceOverloadItem-ExtIEs',
        u'SliceSupportList',
        u'SliceSupportItem',
        u'SliceSupportItem-ExtIEs',
        u'SNPN-MobilityInformation',
        u'SNPN-MobilityInformation-ExtIEs',
        u'S-NSSAI',
        u'S-NSSAI-ExtIEs',
        u'SONConfigurationTransfer',
        u'SONConfigurationTransfer-ExtIEs',
        u'SONInformation',
        u'SONInformation-ExtIEs',
        u'SONInformationReply',
        u'SONInformationReply-ExtIEs',
        u'SONInformationReport',
        u'SONInformationReport-ExtIEs',
        u'SONInformationRequest',
        u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer',
        u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        u'SourceNodeID',
        u'SourceNodeID-ExtIEs',
        u'SourceOfUEActivityBehaviourInformation',
        u'SourceRANNodeID',
        u'SourceRANNodeID-ExtIEs',
        u'SourceToTarget-TransparentContainer',
        u'SourceToTarget-AMFInformationReroute',
        u'SourceToTarget-AMFInformationReroute-ExtIEs',
        u'SRVCCOperationPossible',
        u'ConfiguredNSSAI',
        u'RejectedNSSAIinPLMN',
        u'RejectedNSSAIinTA',
        u'SST',
        u'SupportedTAList',
        u'SupportedTAItem',
        u'SupportedTAItem-ExtIEs',
        u'SuspendIndicator',
        u'Suspend-Request-Indication',
        u'Suspend-Response-Indication',
        u'TAC',
        u'TAI',
        u'TAI-ExtIEs',
        u'TAIBroadcastEUTRA',
        u'TAIBroadcastEUTRA-Item',
        u'TAIBroadcastEUTRA-Item-ExtIEs',
        u'TAIBroadcastNR',
        u'TAIBroadcastNR-Item',
        u'TAIBroadcastNR-Item-ExtIEs',
        u'TAICancelledEUTRA',
        u'TAICancelledEUTRA-Item',
        u'TAICancelledEUTRA-Item-ExtIEs',
        u'TAICancelledNR',
        u'TAICancelledNR-Item',
        u'TAICancelledNR-Item-ExtIEs',
        u'TAIListForInactive',
        u'TAIListForInactiveItem',
        u'TAIListForInactiveItem-ExtIEs',
        u'TAIListForPaging',
        u'TAIListForPagingItem',
        u'TAIListForPagingItem-ExtIEs',
        u'TAIListForRestart',
        u'TAIListForWarning',
        u'TargeteNB-ID',
        u'TargeteNB-ID-ExtIEs',
        u'TargetID',
        u'TargetID-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer',
        u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer',
        u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        u'TargetRANNodeID',
        u'TargetRANNodeID-ExtIEs',
        u'TargetRNC-ID',
        u'TargetRNC-ID-ExtIEs',
        u'TargetToSource-TransparentContainer',
        u'TargettoSource-Failure-TransparentContainer',
        u'TimerApproachForGUAMIRemoval',
        u'TimeStamp',
        u'TimeToWait',
        u'TimeUEStayedInCell',
        u'TimeUEStayedInCellEnhancedGranularity',
        u'TNAP-ID',
        u'TNGF-ID',
        u'TNGF-ID-ExtIEs',
        u'TNLAddressWeightFactor',
        u'TNLAssociationList',
        u'TNLAssociationItem',
        u'TNLAssociationItem-ExtIEs',
        u'TNLAssociationUsage',
        u'TooearlyIntersystemHO',
        u'TooearlyIntersystemHO-ExtIEs',
        u'TraceActivation',
        u'TraceActivation-ExtIEs',
        u'TraceDepth',
        u'TrafficLoadReductionIndication',
        u'TransportLayerAddress',
        u'TypeOfError',
        u'TAIBasedMDT',
        u'TAIBasedMDT-ExtIEs',
        u'TAIListforMDT',
        u'TABasedMDT',
        u'TABasedMDT-ExtIEs',
        u'TAListforMDT',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'Threshold-SINR',
        u'TimeToTrigger',
        u'TWAP-ID',
        u'TWIF-ID',
        u'TWIF-ID-ExtIEs',
        u'TSCAssistanceInformation',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UEAggregateMaximumBitRate',
        u'UEAggregateMaximumBitRate-ExtIEs',
        u'UE-associatedLogicalNG-connectionList',
        u'UE-associatedLogicalNG-connectionItem',
        u'UE-associatedLogicalNG-connectionItem-ExtIEs',
        u'UECapabilityInfoRequest',
        u'UEContextRequest',
        u'UEContextResumeRequestTransfer',
        u'UEContextResumeRequestTransfer-ExtIEs',
        u'UEContextResumeResponseTransfer',
        u'UEContextResumeResponseTransfer-ExtIEs',
        u'UEContextSuspendRequestTransfer',
        u'UEContextSuspendRequestTransfer-ExtIEs',
        u'UE-DifferentiationInfo',
        u'UE-DifferentiationInfo-ExtIEs',
        u'UEHistoryInformation',
        u'UEHistoryInformationFromTheUE',
        u'UEHistoryInformationFromTheUE-ExtIEs',
        u'UEIdentityIndexValue',
        u'UEIdentityIndexValue-ExtIEs',
        u'UE-NGAP-IDs',
        u'UE-NGAP-IDs-ExtIEs',
        u'UE-NGAP-ID-pair',
        u'UE-NGAP-ID-pair-ExtIEs',
        u'UEPagingIdentity',
        u'UEPagingIdentity-ExtIEs',
        u'UEPresence',
        u'UEPresenceInAreaOfInterestList',
        u'UEPresenceInAreaOfInterestItem',
        u'UEPresenceInAreaOfInterestItem-ExtIEs',
        u'UERadioCapability',
        u'UERadioCapabilityForPaging',
        u'UERadioCapabilityForPaging-ExtIEs',
        u'UERadioCapabilityForPagingOfNB-IoT',
        u'UERadioCapabilityForPagingOfNR',
        u'UERadioCapabilityForPagingOfEUTRA',
        u'UERadioCapabilityID',
        u'UERetentionInformation',
        u'UERLFReportContainer',
        u'UERLFReportContainer-ExtIEs',
        u'UESecurityCapabilities',
        u'UESecurityCapabilities-ExtIEs',
        u'UE-UP-CIoT-Support',
        u'UL-CP-SecurityInformation',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UL-NAS-MAC',
        u'UL-NAS-Count',
        u'UL-NGU-UP-TNLModifyList',
        u'UL-NGU-UP-TNLModifyItem',
        u'UL-NGU-UP-TNLModifyItem-ExtIEs',
        u'UnavailableGUAMIList',
        u'UnavailableGUAMIItem',
        u'UnavailableGUAMIItem-ExtIEs',
        u'ULForwarding',
        u'UpdateFeedback',
        u'UPTransportLayerInformation',
        u'UPTransportLayerInformation-ExtIEs',
        u'UPTransportLayerInformationList',
        u'UPTransportLayerInformationItem',
        u'UPTransportLayerInformationItem-ExtIEs',
        u'UPTransportLayerInformationPairList',
        u'UPTransportLayerInformationPairItem',
        u'UPTransportLayerInformationPairItem-ExtIEs',
        u'URI-address',
        u'UserLocationInformation',
        u'UserLocationInformation-ExtIEs',
        u'UserLocationInformationEUTRA',
        u'UserLocationInformationEUTRA-ExtIEs',
        u'UserLocationInformationN3IWF',
        u'UserLocationInformationN3IWF-ExtIEs',
        u'UserLocationInformationTNGF',
        u'UserLocationInformationTNGF-ExtIEs',
        u'UserLocationInformationTWIF',
        u'UserLocationInformationTWIF-ExtIEs',
        u'UserLocationInformationW-AGF',
        u'UserLocationInformationW-AGF-ExtIEs',
        u'UserLocationInformationNR',
        u'UserLocationInformationNR-ExtIEs',
        u'UserPlaneSecurityInformation',
        u'UserPlaneSecurityInformation-ExtIEs',
        u'VolumeTimedReportList',
        u'VolumeTimedReport-Item',
        u'VolumeTimedReport-Item-ExtIEs',
        u'W-AGF-ID',
        u'W-AGF-ID-ExtIEs',
        u'WarningAreaCoordinates',
        u'WarningAreaList',
        u'WarningAreaList-ExtIEs',
        u'WarningMessageContents',
        u'WarningSecurityInfo',
        u'WarningType',
        u'WLANMeasurementConfiguration',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WLANMeasConfigNameList',
        u'WLANMeasConfigNameItem',
        u'WLANMeasConfigNameItem-ExtIEs',
        u'WLANMeasConfig',
        u'WLANName',
        u'WUS-Assistance-Information',
        u'WUS-Assistance-Information-ExtIEs',
        u'XnExtTLAs',
        u'XnExtTLA-Item',
        u'XnExtTLA-Item-ExtIEs',
        u'XnGTP-TLAs',
        u'XnTLAs',
        u'XnTNLConfigurationInfo',
        u'XnTNLConfigurationInfo-ExtIEs',
        ]
    _type_ = [
        u'AdditionalDLUPTNLInformationForHOList',
        u'AdditionalDLUPTNLInformationForHOItem',
        u'AdditionalQosFlowInformation',
        u'AllocationAndRetentionPriority',
        u'Allowed-CAG-List-per-PLMN',
        u'AllowedNSSAI',
        u'AllowedNSSAI-Item',
        u'Allowed-PNI-NPN-List',
        u'Allowed-PNI-NPN-Item',
        u'AllowedTACs',
        u'AlternativeQoSParaSetIndex',
        u'AlternativeQoSParaSetNotifyIndex',
        u'AlternativeQoSParaSetList',
        u'AlternativeQoSParaSetItem',
        u'AMFName',
        u'AMFNameVisibleString',
        u'AMFNameUTF8String',
        u'AMFPagingTarget',
        u'AMFPointer',
        u'AMFRegionID',
        u'AMFSetID',
        u'AMF-TNLAssociationSetupList',
        u'AMF-TNLAssociationSetupItem',
        u'AMF-TNLAssociationToAddList',
        u'AMF-TNLAssociationToAddItem',
        u'AMF-TNLAssociationToRemoveList',
        u'AMF-TNLAssociationToRemoveItem',
        u'AMF-TNLAssociationToUpdateList',
        u'AMF-TNLAssociationToUpdateItem',
        u'AMF-UE-NGAP-ID',
        u'AreaOfInterest',
        u'AreaOfInterestCellList',
        u'AreaOfInterestCellItem',
        u'AreaOfInterestList',
        u'AreaOfInterestItem',
        u'AreaOfInterestRANNodeList',
        u'AreaOfInterestRANNodeItem',
        u'AreaOfInterestTAIList',
        u'AreaOfInterestTAIItem',
        u'AssistanceDataForPaging',
        u'AssistanceDataForRecommendedCells',
        u'AssociatedQosFlowList',
        u'AssociatedQosFlowItem',
        u'AuthenticatedIndication',
        u'AveragingWindow',
        u'AreaScopeOfMDT-NR',
        u'AreaScopeOfMDT-EUTRA',
        u'AreaScopeOfNeighCellsList',
        u'AreaScopeOfNeighCellsItem',
        u'BitRate',
        u'BroadcastCancelledAreaList',
        u'BroadcastCompletedAreaList',
        u'BroadcastPLMNList',
        u'BroadcastPLMNItem',
        u'BluetoothMeasurementConfiguration',
        u'BluetoothMeasConfigNameList',
        u'BluetoothMeasConfigNameItem',
        u'BluetoothMeasConfig',
        u'BluetoothName',
        u'BurstArrivalTime',
        u'CAG-ID',
        u'CancelAllWarningMessages',
        u'CancelledCellsInEAI-EUTRA',
        u'CancelledCellsInEAI-EUTRA-Item',
        u'CancelledCellsInEAI-NR',
        u'CancelledCellsInEAI-NR-Item',
        u'CancelledCellsInTAI-EUTRA',
        u'CancelledCellsInTAI-EUTRA-Item',
        u'CancelledCellsInTAI-NR',
        u'CancelledCellsInTAI-NR-Item',
        u'CandidateCellList',
        u'CandidateCellItem',
        u'CandidateCell',
        u'CandidateCellID',
        u'CandidatePCI',
        u'Cause',
        u'CauseMisc',
        u'CauseNas',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'Cell-CAGInformation',
        u'CellCAGList',
        u'CellIDBroadcastEUTRA',
        u'CellIDBroadcastEUTRA-Item',
        u'CellIDBroadcastNR',
        u'CellIDBroadcastNR-Item',
        u'CellIDCancelledEUTRA',
        u'CellIDCancelledEUTRA-Item',
        u'CellIDCancelledNR',
        u'CellIDCancelledNR-Item',
        u'CellIDListForRestart',
        u'CellSize',
        u'CellType',
        u'CEmodeBSupport-Indicator',
        u'CEmodeBrestricted',
        u'CNAssistedRANTuning',
        u'CNTypeRestrictionsForEquivalent',
        u'CNTypeRestrictionsForEquivalentItem',
        u'CNTypeRestrictionsForServing',
        u'CommonNetworkInstance',
        u'CompletedCellsInEAI-EUTRA',
        u'CompletedCellsInEAI-EUTRA-Item',
        u'CompletedCellsInEAI-NR',
        u'CompletedCellsInEAI-NR-Item',
        u'CompletedCellsInTAI-EUTRA',
        u'CompletedCellsInTAI-EUTRA-Item',
        u'CompletedCellsInTAI-NR',
        u'CompletedCellsInTAI-NR-Item',
        u'ConcurrentWarningMessageInd',
        u'ConfidentialityProtectionIndication',
        u'ConfidentialityProtectionResult',
        u'ConfiguredTACIndication',
        u'CoreNetworkAssistanceInformationForInactive',
        u'COUNTValueForPDCP-SN12',
        u'COUNTValueForPDCP-SN18',
        u'CoverageEnhancementLevel',
        u'CPTransportLayerInformation',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'CellBasedMDT-NR',
        u'CellIdListforMDT-NR',
        u'CellBasedMDT-EUTRA',
        u'CellIdListforMDT-EUTRA',
        u'DataCodingScheme',
        u'DataForwardingAccepted',
        u'DataForwardingNotPossible',
        u'DataForwardingResponseDRBList',
        u'DataForwardingResponseDRBItem',
        u'DAPSRequestInfo',
        u'DAPSResponseInfoList',
        u'DAPSResponseInfoItem',
        u'DAPSResponseInfo',
        u'DataForwardingResponseERABList',
        u'DataForwardingResponseERABListItem',
        u'DelayCritical',
        u'DL-CP-SecurityInformation',
        u'DL-NAS-MAC',
        u'DLForwarding',
        u'DL-NGU-TNLInformationReused',
        u'DirectForwardingPathAvailability',
        u'DRB-ID',
        u'DRBsSubjectToStatusTransferList',
        u'DRBsSubjectToStatusTransferItem',
        u'DRBStatusDL',
        u'DRBStatusDL12',
        u'DRBStatusDL18',
        u'DRBStatusUL',
        u'DRBStatusUL12',
        u'DRBStatusUL18',
        u'DRBsToQosFlowsMappingList',
        u'DRBsToQosFlowsMappingItem',
        u'Dynamic5QIDescriptor',
        u'EarlyStatusTransfer-TransparentContainer',
        u'ProcedureStageChoice',
        u'FirstDLCount',
        u'DRBsSubjectToEarlyStatusTransfer-List',
        u'DRBsSubjectToEarlyStatusTransfer-Item',
        u'EDT-Session',
        u'EmergencyAreaID',
        u'EmergencyAreaIDBroadcastEUTRA',
        u'EmergencyAreaIDBroadcastEUTRA-Item',
        u'EmergencyAreaIDBroadcastNR',
        u'EmergencyAreaIDBroadcastNR-Item',
        u'EmergencyAreaIDCancelledEUTRA',
        u'EmergencyAreaIDCancelledEUTRA-Item',
        u'EmergencyAreaIDCancelledNR',
        u'EmergencyAreaIDCancelledNR-Item',
        u'EmergencyAreaIDList',
        u'EmergencyAreaIDListForRestart',
        u'EmergencyFallbackIndicator',
        u'EmergencyFallbackRequestIndicator',
        u'EmergencyServiceTargetCN',
        u'ENB-ID',
        u'Enhanced-CoverageRestriction',
        u'Extended-ConnectedTime',
        u'EN-DCSONConfigurationTransfer',
        u'EndpointIPAddressAndPort',
        u'EndIndication',
        u'EquivalentPLMNs',
        u'EPS-TAC',
        u'EPS-TAI',
        u'E-RAB-ID',
        u'E-RABInformationList',
        u'E-RABInformationItem',
        u'EUTRACellIdentity',
        u'EUTRA-CGI',
        u'EUTRA-CGIList',
        u'EUTRA-CGIListForWarning',
        u'EUTRAencryptionAlgorithms',
        u'EUTRAintegrityProtectionAlgorithms',
        u'EventType',
        u'ExpectedActivityPeriod',
        u'ExpectedHOInterval',
        u'ExpectedIdlePeriod',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedUEBehaviour',
        u'ExpectedUEMobility',
        u'ExpectedUEMovingTrajectory',
        u'ExpectedUEMovingTrajectoryItem',
        u'Extended-AMFName',
        u'ExtendedPacketDelayBudget',
        u'Extended-RANNodeName',
        u'ExtendedRATRestrictionInformation',
        u'ExtendedRNC-ID',
        u'ExtendedSliceSupportList',
        u'ExtendedUEIdentityIndexValue',
        u'EventTrigger',
        u'EventL1LoggedMDTConfig',
        u'MeasurementThresholdL1LoggedMDT',
        u'FailureIndication',
        u'FiveG-S-TMSI',
        u'FiveG-TMSI',
        u'FiveQI',
        u'ForbiddenAreaInformation',
        u'ForbiddenAreaInformation-Item',
        u'ForbiddenTACs',
        u'FromEUTRANtoNGRAN',
        u'FromNGRANtoEUTRAN',
        u'GBR-QosInformation',
        u'GlobalCable-ID',
        u'GlobalENB-ID',
        u'GlobalGNB-ID',
        u'GlobalN3IWF-ID',
        u'GlobalLine-ID',
        u'GlobalLineIdentity',
        u'GlobalNgENB-ID',
        u'GlobalRANNodeID',
        u'GlobalTNGF-ID',
        u'GlobalTWIF-ID',
        u'GlobalW-AGF-ID',
        u'GNB-ID',
        u'GTP-TEID',
        u'GTPTunnel',
        u'GUAMI',
        u'GUAMIType',
        u'HandoverCommandTransfer',
        u'HandoverFlag',
        u'HandoverPreparationUnsuccessfulTransfer',
        u'HandoverRequestAcknowledgeTransfer',
        u'HandoverRequiredTransfer',
        u'HandoverResourceAllocationUnsuccessfulTransfer',
        u'HandoverType',
        u'HFCNode-ID',
        u'HOReport',
        u'Hysteresis',
        u'IAB-Authorized',
        u'IAB-Supported',
        u'IABNodeIndication',
        u'IMSVoiceSupportIndicator',
        u'IndexToRFSP',
        u'InfoOnRecommendedCellsAndRANNodesForPaging',
        u'IntegrityProtectionIndication',
        u'IntegrityProtectionResult',
        u'IntendedNumberOfPagingAttempts',
        u'InterfacesToTrace',
        u'ImmediateMDTNr',
        u'InterSystemFailureIndication',
        u'IntersystemSONConfigurationTransfer',
        u'IntersystemSONTransferType',
        u'IntersystemSONeNBID',
        u'IntersystemSONNGRANnodeID',
        u'IntersystemSONInformation',
        u'IntersystemSONInformationReport',
        u'InterSystemHOReport',
        u'InterSystemHandoverReportType',
        u'IntersystemUnnecessaryHO',
        u'LAC',
        u'LAI',
        u'LastVisitedCellInformation',
        u'LastVisitedCellItem',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedGERANCellInformation',
        u'LastVisitedNGRANCellInformation',
        u'LastVisitedUTRANCellInformation',
        u'LineType',
        u'LocationReportingAdditionalInfo',
        u'LocationReportingReferenceID',
        u'LocationReportingRequestType',
        u'LoggedMDTNr',
        u'LoggingInterval',
        u'LoggingDuration',
        u'Links-to-log',
        u'LoggedMDTTrigger',
        u'LTEM-Indication',
        u'LTEUERLFReportContainer',
        u'LTEV2XServicesAuthorized',
        u'LTEUESidelinkAggregateMaximumBitrate',
        u'MaskedIMEISV',
        u'MaximumDataBurstVolume',
        u'MessageIdentifier',
        u'MaximumIntegrityProtectedDataRate',
        u'MicoAllPLMN',
        u'MICOModeIndication',
        u'MobilityInformation',
        u'MobilityRestrictionList',
        u'MDTPLMNList',
        u'MDT-Configuration',
        u'MDT-Configuration-NR',
        u'MDT-Configuration-EUTRA',
        u'MDT-Activation',
        u'MDTModeNr',
        u'MDTModeEutra',
        u'MeasurementsToActivate',
        u'M1Configuration',
        u'M1ReportingTrigger',
        u'M1ThresholdEventA2',
        u'M1ThresholdType',
        u'M1PeriodicReporting',
        u'M4Configuration',
        u'M4period',
        u'M5Configuration',
        u'M5period',
        u'M6Configuration',
        u'M6report-Interval',
        u'M7Configuration',
        u'M7period',
        u'MDT-Location-Info',
        u'MDT-Location-Information',
        u'N3IWF-ID',
        u'NAS-PDU',
        u'NASSecurityParametersFromNGRAN',
        u'NB-IoT-DefaultPagingDRX',
        u'NB-IoT-PagingDRX',
        u'NB-IoT-Paging-eDRXCycle',
        u'NB-IoT-Paging-TimeWindow',
        u'NB-IoT-Paging-eDRXInfo',
        u'NB-IoT-UEPriority',
        u'NetworkInstance',
        u'NewSecurityContextInd',
        u'NextHopChainingCount',
        u'NextPagingAreaScope',
        u'NgENB-ID',
        u'NotifySourceNGRANNode',
        u'NGRAN-CGI',
        u'NGRAN-TNLAssociationToRemoveList',
        u'NGRAN-TNLAssociationToRemoveItem',
        u'NGRANTraceID',
        u'NID',
        u'NonDynamic5QIDescriptor',
        u'NotAllowedTACs',
        u'NotificationCause',
        u'NotificationControl',
        u'NPN-AccessInformation',
        u'NPN-MobilityInformation',
        u'NPN-PagingAssistanceInformation',
        u'NPN-Support',
        u'NRCellIdentity',
        u'NR-CGI',
        u'NR-CGIList',
        u'NR-CGIListForWarning',
        u'NRencryptionAlgorithms',
        u'NRintegrityProtectionAlgorithms',
        u'NRMobilityHistoryReport',
        u'NRPPa-PDU',
        u'NRUERLFReportContainer',
        u'NumberOfBroadcasts',
        u'NumberOfBroadcastsRequested',
        u'NRARFCN',
        u'NRFrequencyBand',
        u'NRFrequencyBand-List',
        u'NRFrequencyBandItem',
        u'NRFrequencyInfo',
        u'NR-PCI',
        u'NRV2XServicesAuthorized',
        u'VehicleUE',
        u'PedestrianUE',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'OverloadAction',
        u'OverloadResponse',
        u'OverloadStartNSSAIList',
        u'OverloadStartNSSAIItem',
        u'PacketDelayBudget',
        u'PacketErrorRate',
        u'PacketLossRate',
        u'PagingAssisDataforCEcapabUE',
        u'PagingAttemptInformation',
        u'PagingAttemptCount',
        u'PagingDRX',
        u'PagingOrigin',
        u'PagingPriority',
        u'PagingeDRXInformation',
        u'Paging-eDRX-Cycle',
        u'Paging-Time-Window',
        u'PagingProbabilityInformation',
        u'PathSwitchRequestAcknowledgeTransfer',
        u'PathSwitchRequestSetupFailedTransfer',
        u'PathSwitchRequestTransfer',
        u'PathSwitchRequestUnsuccessfulTransfer',
        u'PC5QoSParameters',
        u'PC5QoSFlowList',
        u'PC5QoSFlowItem',
        u'PC5FlowBitRates',
        u'PCIListForMDT',
        u'PrivacyIndicator',
        u'PDUSessionAggregateMaximumBitRate',
        u'PDUSessionID',
        u'PDUSessionResourceAdmittedList',
        u'PDUSessionResourceAdmittedItem',
        u'PDUSessionResourceFailedToModifyListModCfm',
        u'PDUSessionResourceFailedToModifyItemModCfm',
        u'PDUSessionResourceFailedToModifyListModRes',
        u'PDUSessionResourceFailedToModifyItemModRes',
        u'PDUSessionResourceFailedToResumeListRESReq',
        u'PDUSessionResourceFailedToResumeItemRESReq',
        u'PDUSessionResourceFailedToResumeListRESRes',
        u'PDUSessionResourceFailedToResumeItemRESRes',
        u'PDUSessionResourceFailedToSetupListCxtFail',
        u'PDUSessionResourceFailedToSetupItemCxtFail',
        u'PDUSessionResourceFailedToSetupListCxtRes',
        u'PDUSessionResourceFailedToSetupItemCxtRes',
        u'PDUSessionResourceFailedToSetupListHOAck',
        u'PDUSessionResourceFailedToSetupItemHOAck',
        u'PDUSessionResourceFailedToSetupListPSReq',
        u'PDUSessionResourceFailedToSetupItemPSReq',
        u'PDUSessionResourceFailedToSetupListSURes',
        u'PDUSessionResourceFailedToSetupItemSURes',
        u'PDUSessionResourceHandoverList',
        u'PDUSessionResourceHandoverItem',
        u'PDUSessionResourceInformationList',
        u'PDUSessionResourceInformationItem',
        u'PDUSessionResourceListCxtRelCpl',
        u'PDUSessionResourceItemCxtRelCpl',
        u'PDUSessionResourceListCxtRelReq',
        u'PDUSessionResourceItemCxtRelReq',
        u'PDUSessionResourceListHORqd',
        u'PDUSessionResourceItemHORqd',
        u'PDUSessionResourceModifyConfirmTransfer',
        u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer',
        u'PDUSessionResourceModifyRequestTransfer',
        u'PDUSessionResourceModifyResponseTransfer',
        u'PDUSessionResourceModifyIndicationTransfer',
        u'PDUSessionResourceModifyListModCfm',
        u'PDUSessionResourceModifyItemModCfm',
        u'PDUSessionResourceModifyListModInd',
        u'PDUSessionResourceModifyItemModInd',
        u'PDUSessionResourceModifyListModReq',
        u'PDUSessionResourceModifyItemModReq',
        u'PDUSessionResourceModifyListModRes',
        u'PDUSessionResourceModifyItemModRes',
        u'PDUSessionResourceModifyUnsuccessfulTransfer',
        u'PDUSessionResourceNotifyList',
        u'PDUSessionResourceNotifyItem',
        u'PDUSessionResourceNotifyReleasedTransfer',
        u'PDUSessionResourceNotifyTransfer',
        u'PDUSessionResourceReleaseCommandTransfer',
        u'PDUSessionResourceReleasedListNot',
        u'PDUSessionResourceReleasedItemNot',
        u'PDUSessionResourceReleasedListPSAck',
        u'PDUSessionResourceReleasedItemPSAck',
        u'PDUSessionResourceReleasedListPSFail',
        u'PDUSessionResourceReleasedItemPSFail',
        u'PDUSessionResourceReleasedListRelRes',
        u'PDUSessionResourceReleasedItemRelRes',
        u'PDUSessionResourceReleaseResponseTransfer',
        u'PDUSessionResourceResumeListRESReq',
        u'PDUSessionResourceResumeItemRESReq',
        u'PDUSessionResourceResumeListRESRes',
        u'PDUSessionResourceResumeItemRESRes',
        u'PDUSessionResourceSecondaryRATUsageList',
        u'PDUSessionResourceSecondaryRATUsageItem',
        u'PDUSessionResourceSetupListCxtReq',
        u'PDUSessionResourceSetupItemCxtReq',
        u'PDUSessionResourceSetupListCxtRes',
        u'PDUSessionResourceSetupItemCxtRes',
        u'PDUSessionResourceSetupListHOReq',
        u'PDUSessionResourceSetupItemHOReq',
        u'PDUSessionResourceSetupListSUReq',
        u'PDUSessionResourceSetupItemSUReq',
        u'PDUSessionResourceSetupListSURes',
        u'PDUSessionResourceSetupItemSURes',
        u'PDUSessionResourceSetupRequestTransfer',
        u'PDUSessionResourceSetupResponseTransfer',
        u'PDUSessionResourceSetupUnsuccessfulTransfer',
        u'PDUSessionResourceSuspendListSUSReq',
        u'PDUSessionResourceSuspendItemSUSReq',
        u'PDUSessionResourceSwitchedList',
        u'PDUSessionResourceSwitchedItem',
        u'PDUSessionResourceToBeSwitchedDLList',
        u'PDUSessionResourceToBeSwitchedDLItem',
        u'PDUSessionResourceToReleaseListHOCmd',
        u'PDUSessionResourceToReleaseItemHOCmd',
        u'PDUSessionResourceToReleaseListRelCmd',
        u'PDUSessionResourceToReleaseItemRelCmd',
        u'PDUSessionType',
        u'PDUSessionUsageReport',
        u'Periodicity',
        u'PeriodicRegistrationUpdateTimer',
        u'PLMNIdentity',
        u'PLMNSupportList',
        u'PLMNSupportItem',
        u'PNI-NPN-MobilityInformation',
        u'PortNumber',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevelARP',
        u'PriorityLevelQos',
        u'PWSFailedCellIDList',
        u'QosCharacteristics',
        u'QosFlowAcceptedList',
        u'QosFlowAcceptedItem',
        u'QosFlowAddOrModifyRequestList',
        u'QosFlowAddOrModifyRequestItem',
        u'QosFlowAddOrModifyResponseList',
        u'QosFlowAddOrModifyResponseItem',
        u'QosFlowFeedbackList',
        u'QosFlowFeedbackItem',
        u'QosFlowIdentifier',
        u'QosFlowInformationList',
        u'QosFlowInformationItem',
        u'QosFlowLevelQosParameters',
        u'QosMonitoringRequest',
        u'QosMonitoringReportingFrequency',
        u'QosFlowListWithCause',
        u'QosFlowWithCauseItem',
        u'QosFlowModifyConfirmList',
        u'QosFlowModifyConfirmItem',
        u'QosFlowNotifyList',
        u'QosFlowNotifyItem',
        u'QosFlowParametersList',
        u'QosFlowParametersItem',
        u'QosFlowPerTNLInformation',
        u'QosFlowPerTNLInformationList',
        u'QosFlowPerTNLInformationItem',
        u'QosFlowSetupRequestList',
        u'QosFlowSetupRequestItem',
        u'QosFlowListWithDataForwarding',
        u'QosFlowItemWithDataForwarding',
        u'QosFlowToBeForwardedList',
        u'QosFlowToBeForwardedItem',
        u'QoSFlowsUsageReportList',
        u'QoSFlowsUsageReport-Item',
        u'Range',
        u'RANNodeName',
        u'RANNodeNameVisibleString',
        u'RANNodeNameUTF8String',
        u'RANPagingPriority',
        u'RANStatusTransfer-TransparentContainer',
        u'RAN-UE-NGAP-ID',
        u'RAT-Information',
        u'RATRestrictions',
        u'RATRestrictions-Item',
        u'RATRestrictionInformation',
        u'RecommendedCellsForPaging',
        u'RecommendedCellList',
        u'RecommendedCellItem',
        u'RecommendedRANNodesForPaging',
        u'RecommendedRANNodeList',
        u'RecommendedRANNodeItem',
        u'RedirectionVoiceFallback',
        u'RedundantPDUSessionInformation',
        u'RedundantQosFlowIndicator',
        u'ReflectiveQosAttribute',
        u'RelativeAMFCapacity',
        u'ReportArea',
        u'RepetitionPeriod',
        u'ResetAll',
        u'ReportAmountMDT',
        u'ReportIntervalMDT',
        u'ExtendedReportIntervalMDT',
        u'ResetType',
        u'RGLevelWirelineAccessCharacteristics',
        u'RNC-ID',
        u'RoutingID',
        u'RRCContainer',
        u'RRCEstablishmentCause',
        u'RRCInactiveTransitionReportRequest',
        u'RRCState',
        u'RSN',
        u'RIMInformationTransfer',
        u'RIMInformation',
        u'GNBSetID',
        u'ScheduledCommunicationTime',
        u'SCTP-TLAs',
        u'SD',
        u'SecondaryRATUsageInformation',
        u'SecondaryRATDataUsageReportTransfer',
        u'SecurityContext',
        u'SecurityIndication',
        u'SecurityKey',
        u'SecurityResult',
        u'SensorMeasurementConfiguration',
        u'SensorMeasConfigNameList',
        u'SensorMeasConfigNameItem',
        u'SensorMeasConfig',
        u'SensorNameConfig',
        u'SerialNumber',
        u'ServedGUAMIList',
        u'ServedGUAMIItem',
        u'ServiceAreaInformation',
        u'ServiceAreaInformation-Item',
        u'SgNB-UE-X2AP-ID',
        u'SliceOverloadList',
        u'SliceOverloadItem',
        u'SliceSupportList',
        u'SliceSupportItem',
        u'SNPN-MobilityInformation',
        u'S-NSSAI',
        u'SONConfigurationTransfer',
        u'SONInformation',
        u'SONInformationReply',
        u'SONInformationReport',
        u'SONInformationRequest',
        u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer',
        u'SourceNodeID',
        u'SourceOfUEActivityBehaviourInformation',
        u'SourceRANNodeID',
        u'SourceToTarget-TransparentContainer',
        u'SourceToTarget-AMFInformationReroute',
        u'SRVCCOperationPossible',
        u'ConfiguredNSSAI',
        u'RejectedNSSAIinPLMN',
        u'RejectedNSSAIinTA',
        u'SST',
        u'SupportedTAList',
        u'SupportedTAItem',
        u'SuspendIndicator',
        u'Suspend-Request-Indication',
        u'Suspend-Response-Indication',
        u'TAC',
        u'TAI',
        u'TAIBroadcastEUTRA',
        u'TAIBroadcastEUTRA-Item',
        u'TAIBroadcastNR',
        u'TAIBroadcastNR-Item',
        u'TAICancelledEUTRA',
        u'TAICancelledEUTRA-Item',
        u'TAICancelledNR',
        u'TAICancelledNR-Item',
        u'TAIListForInactive',
        u'TAIListForInactiveItem',
        u'TAIListForPaging',
        u'TAIListForPagingItem',
        u'TAIListForRestart',
        u'TAIListForWarning',
        u'TargeteNB-ID',
        u'TargetID',
        u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer',
        u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer',
        u'TargetRANNodeID',
        u'TargetRNC-ID',
        u'TargetToSource-TransparentContainer',
        u'TargettoSource-Failure-TransparentContainer',
        u'TimerApproachForGUAMIRemoval',
        u'TimeStamp',
        u'TimeToWait',
        u'TimeUEStayedInCell',
        u'TimeUEStayedInCellEnhancedGranularity',
        u'TNAP-ID',
        u'TNGF-ID',
        u'TNLAddressWeightFactor',
        u'TNLAssociationList',
        u'TNLAssociationItem',
        u'TNLAssociationUsage',
        u'TooearlyIntersystemHO',
        u'TraceActivation',
        u'TraceDepth',
        u'TrafficLoadReductionIndication',
        u'TransportLayerAddress',
        u'TypeOfError',
        u'TAIBasedMDT',
        u'TAIListforMDT',
        u'TABasedMDT',
        u'TAListforMDT',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'Threshold-SINR',
        u'TimeToTrigger',
        u'TWAP-ID',
        u'TWIF-ID',
        u'TSCAssistanceInformation',
        u'TSCTrafficCharacteristics',
        u'UEAggregateMaximumBitRate',
        u'UE-associatedLogicalNG-connectionList',
        u'UE-associatedLogicalNG-connectionItem',
        u'UECapabilityInfoRequest',
        u'UEContextRequest',
        u'UEContextResumeRequestTransfer',
        u'UEContextResumeResponseTransfer',
        u'UEContextSuspendRequestTransfer',
        u'UE-DifferentiationInfo',
        u'UEHistoryInformation',
        u'UEHistoryInformationFromTheUE',
        u'UEIdentityIndexValue',
        u'UE-NGAP-IDs',
        u'UE-NGAP-ID-pair',
        u'UEPagingIdentity',
        u'UEPresence',
        u'UEPresenceInAreaOfInterestList',
        u'UEPresenceInAreaOfInterestItem',
        u'UERadioCapability',
        u'UERadioCapabilityForPaging',
        u'UERadioCapabilityForPagingOfNB-IoT',
        u'UERadioCapabilityForPagingOfNR',
        u'UERadioCapabilityForPagingOfEUTRA',
        u'UERadioCapabilityID',
        u'UERetentionInformation',
        u'UERLFReportContainer',
        u'UESecurityCapabilities',
        u'UE-UP-CIoT-Support',
        u'UL-CP-SecurityInformation',
        u'UL-NAS-MAC',
        u'UL-NAS-Count',
        u'UL-NGU-UP-TNLModifyList',
        u'UL-NGU-UP-TNLModifyItem',
        u'UnavailableGUAMIList',
        u'UnavailableGUAMIItem',
        u'ULForwarding',
        u'UpdateFeedback',
        u'UPTransportLayerInformation',
        u'UPTransportLayerInformationList',
        u'UPTransportLayerInformationItem',
        u'UPTransportLayerInformationPairList',
        u'UPTransportLayerInformationPairItem',
        u'URI-address',
        u'UserLocationInformation',
        u'UserLocationInformationEUTRA',
        u'UserLocationInformationN3IWF',
        u'UserLocationInformationTNGF',
        u'UserLocationInformationTWIF',
        u'UserLocationInformationW-AGF',
        u'UserLocationInformationNR',
        u'UserPlaneSecurityInformation',
        u'VolumeTimedReportList',
        u'VolumeTimedReport-Item',
        u'W-AGF-ID',
        u'WarningAreaCoordinates',
        u'WarningAreaList',
        u'WarningMessageContents',
        u'WarningSecurityInfo',
        u'WarningType',
        u'WLANMeasurementConfiguration',
        u'WLANMeasConfigNameList',
        u'WLANMeasConfigNameItem',
        u'WLANMeasConfig',
        u'WLANName',
        u'WUS-Assistance-Information',
        u'XnExtTLAs',
        u'XnExtTLA-Item',
        u'XnGTP-TLAs',
        u'XnTLAs',
        u'XnTNLConfigurationInfo',
        ]
    _set_ = [
        u'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AllowedNSSAI-Item-ExtIEs',
        u'Allowed-PNI-NPN-Item-ExtIEs',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AMFPagingTarget-ExtIEs',
        u'AMF-TNLAssociationSetupItem-ExtIEs',
        u'AMF-TNLAssociationToAddItem-ExtIEs',
        u'AMF-TNLAssociationToRemoveItem-ExtIEs',
        u'AMF-TNLAssociationToUpdateItem-ExtIEs',
        u'AreaOfInterest-ExtIEs',
        u'AreaOfInterestCellItem-ExtIEs',
        u'AreaOfInterestItem-ExtIEs',
        u'AreaOfInterestRANNodeItem-ExtIEs',
        u'AreaOfInterestTAIItem-ExtIEs',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'AssociatedQosFlowItem-ExtIEs',
        u'AreaScopeOfMDT-NR-ExtIEs',
        u'AreaScopeOfMDT-EUTRA-ExtIEs',
        u'AreaScopeOfNeighCellsItem-ExtIEs',
        u'BroadcastCancelledAreaList-ExtIEs',
        u'BroadcastCompletedAreaList-ExtIEs',
        u'BroadcastPLMNItem-ExtIEs',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'BluetoothMeasConfigNameItem-ExtIEs',
        u'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInEAI-NR-Item-ExtIEs',
        u'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInTAI-NR-Item-ExtIEs',
        u'CandidateCellItem-ExtIEs',
        u'CandidateCell-ExtIEs',
        u'CandidateCellID-ExtIEs',
        u'CandidatePCI-ExtIEs',
        u'Cause-ExtIEs',
        u'Cell-CAGInformation-ExtIEs',
        u'CellIDBroadcastEUTRA-Item-ExtIEs',
        u'CellIDBroadcastNR-Item-ExtIEs',
        u'CellIDCancelledEUTRA-Item-ExtIEs',
        u'CellIDCancelledNR-Item-ExtIEs',
        u'CellIDListForRestart-ExtIEs',
        u'CellType-ExtIEs',
        u'CNAssistedRANTuning-ExtIEs',
        u'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        u'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInEAI-NR-Item-ExtIEs',
        u'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInTAI-NR-Item-ExtIEs',
        u'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        u'COUNTValueForPDCP-SN12-ExtIEs',
        u'COUNTValueForPDCP-SN18-ExtIEs',
        u'CPTransportLayerInformation-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'CellBasedMDT-NR-ExtIEs',
        u'CellBasedMDT-EUTRA-ExtIEs',
        u'DataForwardingResponseDRBItem-ExtIEs',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo-ExtIEs',
        u'DataForwardingResponseERABListItem-ExtIEs',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'DRBsSubjectToStatusTransferItem-ExtIEs',
        u'DRBStatusDL-ExtIEs',
        u'DRBStatusDL12-ExtIEs',
        u'DRBStatusDL18-ExtIEs',
        u'DRBStatusUL-ExtIEs',
        u'DRBStatusUL12-ExtIEs',
        u'DRBStatusUL18-ExtIEs',
        u'DRBsToQosFlowsMappingItem-ExtIEs',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'ProcedureStageChoice-ExtIEs',
        u'FirstDLCount-ExtIEs',
        u'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        u'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        u'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        u'EmergencyFallbackIndicator-ExtIEs',
        u'ENB-ID-ExtIEs',
        u'EndpointIPAddressAndPort-ExtIEs',
        u'EPS-TAI-ExtIEs',
        u'E-RABInformationItem-ExtIEs',
        u'EUTRA-CGI-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEMovingTrajectoryItem-ExtIEs',
        u'Extended-AMFName-ExtIEs',
        u'Extended-RANNodeName-ExtIEs',
        u'ExtendedRATRestrictionInformation-ExtIEs',
        u'EventTrigger-ExtIEs',
        u'EventL1LoggedMDTConfig-ExtIEs',
        u'MeasurementThresholdL1LoggedMDT-ExtIEs',
        u'FailureIndication-ExtIEs',
        u'FiveG-S-TMSI-ExtIEs',
        u'ForbiddenAreaInformation-Item-ExtIEs',
        u'FromEUTRANtoNGRAN-ExtIEs',
        u'FromNGRANtoEUTRAN-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GlobalGNB-ID-ExtIEs',
        u'GlobalN3IWF-ID-ExtIEs',
        u'GlobalLine-ID-ExtIEs',
        u'GlobalNgENB-ID-ExtIEs',
        u'GlobalRANNodeID-ExtIEs',
        u'GlobalTNGF-ID-ExtIEs',
        u'GlobalTWIF-ID-ExtIEs',
        u'GlobalW-AGF-ID-ExtIEs',
        u'GNB-ID-ExtIEs',
        u'GTPTunnel-ExtIEs',
        u'GUAMI-ExtIEs',
        u'HandoverCommandTransfer-ExtIEs',
        u'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        u'HandoverRequestAcknowledgeTransfer-ExtIEs',
        u'HandoverRequiredTransfer-ExtIEs',
        u'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        u'HOReport-ExtIEs',
        u'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        u'ImmediateMDTNr-ExtIEs',
        u'InterSystemFailureIndication-ExtIEs',
        u'IntersystemSONConfigurationTransfer-ExtIEs',
        u'IntersystemSONTransferType-ExtIEs',
        u'IntersystemSONeNBID-ExtIEs',
        u'IntersystemSONNGRANnodeID-ExtIEs',
        u'IntersystemSONInformation-ExtIEs',
        u'IntersystemSONInformationReport-ExtIEs',
        u'InterSystemHOReport-ExtIEs',
        u'InterSystemHandoverReportType-ExtIEs',
        u'IntersystemUnnecessaryHO-ExtIEs',
        u'LAI-ExtIEs',
        u'LastVisitedCellInformation-ExtIEs',
        u'LastVisitedCellItem-ExtIEs',
        u'LastVisitedNGRANCellInformation-ExtIEs',
        u'LocationReportingRequestType-ExtIEs',
        u'LoggedMDTNr-ExtIEs',
        u'LoggedMDTTrigger-ExtIEs',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'MobilityRestrictionList-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MDT-Configuration-NR-ExtIEs',
        u'MDT-Configuration-EUTRA-ExtIEs',
        u'MDTModeNr-ExtIEs',
        u'M1Configuration-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'M1ThresholdType-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Location-Info-ExtIEs',
        u'N3IWF-ID-ExtIEs',
        u'NB-IoT-Paging-eDRXInfo-ExtIEs',
        u'NgENB-ID-ExtIEs',
        u'NGRAN-CGI-ExtIEs',
        u'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NPN-AccessInformation-ExtIEs',
        u'NPN-MobilityInformation-ExtIEs',
        u'NPN-PagingAssistanceInformation-ExtIEs',
        u'NPN-Support-ExtIEs',
        u'NR-CGI-ExtIEs',
        u'NRFrequencyBandItem-ExtIEs',
        u'NRFrequencyInfo-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'OverloadResponse-ExtIEs',
        u'OverloadStartNSSAIItem-ExtIEs',
        u'PacketErrorRate-ExtIEs',
        u'PagingAssisDataforCEcapabUE-ExtIEs',
        u'PagingAttemptInformation-ExtIEs',
        u'PagingeDRXInformation-ExtIEs',
        u'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        u'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        u'PathSwitchRequestTransfer-ExtIEs',
        u'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'PDUSessionAggregateMaximumBitRate-ExtIEs',
        u'PDUSessionResourceAdmittedItem-ExtIEs',
        u'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        u'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        u'PDUSessionResourceHandoverItem-ExtIEs',
        u'PDUSessionResourceInformationItem-ExtIEs',
        u'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        u'PDUSessionResourceItemCxtRelReq-ExtIEs',
        u'PDUSessionResourceItemHORqd-ExtIEs',
        u'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceModifyRequestTransferIEs',
        u'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        u'PDUSessionResourceModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceModifyItemModInd-ExtIEs',
        u'PDUSessionResourceModifyItemModReq-ExtIEs',
        u'PDUSessionResourceModifyItemModRes-ExtIEs',
        u'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceNotifyItem-ExtIEs',
        u'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        u'PDUSessionResourceNotifyTransfer-ExtIEs',
        u'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        u'PDUSessionResourceReleasedItemNot-ExtIEs',
        u'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        u'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        u'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        u'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        u'PDUSessionResourceResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        u'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        u'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceSetupItemHOReq-ExtIEs',
        u'PDUSessionResourceSetupItemSUReq-ExtIEs',
        u'PDUSessionResourceSetupItemSURes-ExtIEs',
        u'PDUSessionResourceSetupRequestTransferIEs',
        u'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        u'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        u'PDUSessionResourceSwitchedItem-ExtIEs',
        u'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        u'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        u'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        u'PDUSessionUsageReport-ExtIEs',
        u'PLMNSupportItem-ExtIEs',
        u'PNI-NPN-MobilityInformation-ExtIEs',
        u'PWSFailedCellIDList-ExtIEs',
        u'QosCharacteristics-ExtIEs',
        u'QosFlowAcceptedItem-ExtIEs',
        u'QosFlowAddOrModifyRequestItem-ExtIEs',
        u'QosFlowAddOrModifyResponseItem-ExtIEs',
        u'QosFlowFeedbackItem-ExtIEs',
        u'QosFlowInformationItem-ExtIEs',
        u'QosFlowLevelQosParameters-ExtIEs',
        u'QosFlowWithCauseItem-ExtIEs',
        u'QosFlowModifyConfirmItem-ExtIEs',
        u'QosFlowNotifyItem-ExtIEs',
        u'QosFlowParametersItem-ExtIEs',
        u'QosFlowPerTNLInformation-ExtIEs',
        u'QosFlowPerTNLInformationItem-ExtIEs',
        u'QosFlowSetupRequestItem-ExtIEs',
        u'QosFlowItemWithDataForwarding-ExtIEs',
        u'QosFlowToBeForwardedItem-ExtIEs',
        u'QoSFlowsUsageReport-Item-ExtIEs',
        u'RANStatusTransfer-TransparentContainer-ExtIEs',
        u'RATRestrictions-Item-ExtIEs',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellItem-ExtIEs',
        u'RecommendedRANNodesForPaging-ExtIEs',
        u'RecommendedRANNodeItem-ExtIEs',
        u'RedundantPDUSessionInformation-ExtIEs',
        u'ResetType-ExtIEs',
        u'RIMInformationTransfer-ExtIEs',
        u'RIMInformation-ExtIEs',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SecondaryRATUsageInformation-ExtIEs',
        u'SecondaryRATDataUsageReportTransfer-ExtIEs',
        u'SecurityContext-ExtIEs',
        u'SecurityIndication-ExtIEs',
        u'SecurityResult-ExtIEs',
        u'SensorMeasurementConfiguration-ExtIEs',
        u'SensorMeasConfigNameItem-ExtIEs',
        u'SensorNameConfig-ExtIEs',
        u'ServedGUAMIItem-ExtIEs',
        u'ServiceAreaInformation-Item-ExtIEs',
        u'SliceOverloadItem-ExtIEs',
        u'SliceSupportItem-ExtIEs',
        u'SNPN-MobilityInformation-ExtIEs',
        u'S-NSSAI-ExtIEs',
        u'SONConfigurationTransfer-ExtIEs',
        u'SONInformation-ExtIEs',
        u'SONInformationReply-ExtIEs',
        u'SONInformationReport-ExtIEs',
        u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        u'SourceNodeID-ExtIEs',
        u'SourceRANNodeID-ExtIEs',
        u'SourceToTarget-AMFInformationReroute-ExtIEs',
        u'SupportedTAItem-ExtIEs',
        u'TAI-ExtIEs',
        u'TAIBroadcastEUTRA-Item-ExtIEs',
        u'TAIBroadcastNR-Item-ExtIEs',
        u'TAICancelledEUTRA-Item-ExtIEs',
        u'TAICancelledNR-Item-ExtIEs',
        u'TAIListForInactiveItem-ExtIEs',
        u'TAIListForPagingItem-ExtIEs',
        u'TargeteNB-ID-ExtIEs',
        u'TargetID-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        u'TargetRANNodeID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TNGF-ID-ExtIEs',
        u'TNLAssociationItem-ExtIEs',
        u'TooearlyIntersystemHO-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TWIF-ID-ExtIEs',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UEAggregateMaximumBitRate-ExtIEs',
        u'UE-associatedLogicalNG-connectionItem-ExtIEs',
        u'UEContextResumeRequestTransfer-ExtIEs',
        u'UEContextResumeResponseTransfer-ExtIEs',
        u'UEContextSuspendRequestTransfer-ExtIEs',
        u'UE-DifferentiationInfo-ExtIEs',
        u'UEHistoryInformationFromTheUE-ExtIEs',
        u'UEIdentityIndexValue-ExtIEs',
        u'UE-NGAP-IDs-ExtIEs',
        u'UE-NGAP-ID-pair-ExtIEs',
        u'UEPagingIdentity-ExtIEs',
        u'UEPresenceInAreaOfInterestItem-ExtIEs',
        u'UERadioCapabilityForPaging-ExtIEs',
        u'UERLFReportContainer-ExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UL-NGU-UP-TNLModifyItem-ExtIEs',
        u'UnavailableGUAMIItem-ExtIEs',
        u'UPTransportLayerInformation-ExtIEs',
        u'UPTransportLayerInformationItem-ExtIEs',
        u'UPTransportLayerInformationPairItem-ExtIEs',
        u'UserLocationInformation-ExtIEs',
        u'UserLocationInformationEUTRA-ExtIEs',
        u'UserLocationInformationN3IWF-ExtIEs',
        u'UserLocationInformationTNGF-ExtIEs',
        u'UserLocationInformationTWIF-ExtIEs',
        u'UserLocationInformationW-AGF-ExtIEs',
        u'UserLocationInformationNR-ExtIEs',
        u'UserPlaneSecurityInformation-ExtIEs',
        u'VolumeTimedReport-Item-ExtIEs',
        u'W-AGF-ID-ExtIEs',
        u'WarningAreaList-ExtIEs',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WLANMeasConfigNameItem-ExtIEs',
        u'WUS-Assistance-Information-ExtIEs',
        u'XnExtTLA-Item-ExtIEs',
        u'XnTNLConfigurationInfo-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AllowedNSSAI-Item-ExtIEs',
        u'Allowed-PNI-NPN-Item-ExtIEs',
        u'AlternativeQoSParaSetItem-ExtIEs',
        u'AMFPagingTarget-ExtIEs',
        u'AMF-TNLAssociationSetupItem-ExtIEs',
        u'AMF-TNLAssociationToAddItem-ExtIEs',
        u'AMF-TNLAssociationToRemoveItem-ExtIEs',
        u'AMF-TNLAssociationToUpdateItem-ExtIEs',
        u'AreaOfInterest-ExtIEs',
        u'AreaOfInterestCellItem-ExtIEs',
        u'AreaOfInterestItem-ExtIEs',
        u'AreaOfInterestRANNodeItem-ExtIEs',
        u'AreaOfInterestTAIItem-ExtIEs',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'AssociatedQosFlowItem-ExtIEs',
        u'AreaScopeOfMDT-NR-ExtIEs',
        u'AreaScopeOfMDT-EUTRA-ExtIEs',
        u'AreaScopeOfNeighCellsItem-ExtIEs',
        u'BroadcastCancelledAreaList-ExtIEs',
        u'BroadcastCompletedAreaList-ExtIEs',
        u'BroadcastPLMNItem-ExtIEs',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'BluetoothMeasConfigNameItem-ExtIEs',
        u'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInEAI-NR-Item-ExtIEs',
        u'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        u'CancelledCellsInTAI-NR-Item-ExtIEs',
        u'CandidateCellItem-ExtIEs',
        u'CandidateCell-ExtIEs',
        u'CandidateCellID-ExtIEs',
        u'CandidatePCI-ExtIEs',
        u'Cause-ExtIEs',
        u'Cell-CAGInformation-ExtIEs',
        u'CellIDBroadcastEUTRA-Item-ExtIEs',
        u'CellIDBroadcastNR-Item-ExtIEs',
        u'CellIDCancelledEUTRA-Item-ExtIEs',
        u'CellIDCancelledNR-Item-ExtIEs',
        u'CellIDListForRestart-ExtIEs',
        u'CellType-ExtIEs',
        u'CNAssistedRANTuning-ExtIEs',
        u'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        u'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInEAI-NR-Item-ExtIEs',
        u'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        u'CompletedCellsInTAI-NR-Item-ExtIEs',
        u'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        u'COUNTValueForPDCP-SN12-ExtIEs',
        u'COUNTValueForPDCP-SN18-ExtIEs',
        u'CPTransportLayerInformation-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'CellBasedMDT-NR-ExtIEs',
        u'CellBasedMDT-EUTRA-ExtIEs',
        u'DataForwardingResponseDRBItem-ExtIEs',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo-ExtIEs',
        u'DataForwardingResponseERABListItem-ExtIEs',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'DRBsSubjectToStatusTransferItem-ExtIEs',
        u'DRBStatusDL-ExtIEs',
        u'DRBStatusDL12-ExtIEs',
        u'DRBStatusDL18-ExtIEs',
        u'DRBStatusUL-ExtIEs',
        u'DRBStatusUL12-ExtIEs',
        u'DRBStatusUL18-ExtIEs',
        u'DRBsToQosFlowsMappingItem-ExtIEs',
        u'Dynamic5QIDescriptor-ExtIEs',
        u'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'ProcedureStageChoice-ExtIEs',
        u'FirstDLCount-ExtIEs',
        u'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        u'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        u'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        u'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        u'EmergencyFallbackIndicator-ExtIEs',
        u'ENB-ID-ExtIEs',
        u'EndpointIPAddressAndPort-ExtIEs',
        u'EPS-TAI-ExtIEs',
        u'E-RABInformationItem-ExtIEs',
        u'EUTRA-CGI-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEMovingTrajectoryItem-ExtIEs',
        u'Extended-AMFName-ExtIEs',
        u'Extended-RANNodeName-ExtIEs',
        u'ExtendedRATRestrictionInformation-ExtIEs',
        u'EventTrigger-ExtIEs',
        u'EventL1LoggedMDTConfig-ExtIEs',
        u'MeasurementThresholdL1LoggedMDT-ExtIEs',
        u'FailureIndication-ExtIEs',
        u'FiveG-S-TMSI-ExtIEs',
        u'ForbiddenAreaInformation-Item-ExtIEs',
        u'FromEUTRANtoNGRAN-ExtIEs',
        u'FromNGRANtoEUTRAN-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GlobalGNB-ID-ExtIEs',
        u'GlobalN3IWF-ID-ExtIEs',
        u'GlobalLine-ID-ExtIEs',
        u'GlobalNgENB-ID-ExtIEs',
        u'GlobalRANNodeID-ExtIEs',
        u'GlobalTNGF-ID-ExtIEs',
        u'GlobalTWIF-ID-ExtIEs',
        u'GlobalW-AGF-ID-ExtIEs',
        u'GNB-ID-ExtIEs',
        u'GTPTunnel-ExtIEs',
        u'GUAMI-ExtIEs',
        u'HandoverCommandTransfer-ExtIEs',
        u'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        u'HandoverRequestAcknowledgeTransfer-ExtIEs',
        u'HandoverRequiredTransfer-ExtIEs',
        u'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        u'HOReport-ExtIEs',
        u'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        u'ImmediateMDTNr-ExtIEs',
        u'InterSystemFailureIndication-ExtIEs',
        u'IntersystemSONConfigurationTransfer-ExtIEs',
        u'IntersystemSONTransferType-ExtIEs',
        u'IntersystemSONeNBID-ExtIEs',
        u'IntersystemSONNGRANnodeID-ExtIEs',
        u'IntersystemSONInformation-ExtIEs',
        u'IntersystemSONInformationReport-ExtIEs',
        u'InterSystemHOReport-ExtIEs',
        u'InterSystemHandoverReportType-ExtIEs',
        u'IntersystemUnnecessaryHO-ExtIEs',
        u'LAI-ExtIEs',
        u'LastVisitedCellInformation-ExtIEs',
        u'LastVisitedCellItem-ExtIEs',
        u'LastVisitedNGRANCellInformation-ExtIEs',
        u'LocationReportingRequestType-ExtIEs',
        u'LoggedMDTNr-ExtIEs',
        u'LoggedMDTTrigger-ExtIEs',
        u'LTEV2XServicesAuthorized-ExtIEs',
        u'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'MobilityRestrictionList-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MDT-Configuration-NR-ExtIEs',
        u'MDT-Configuration-EUTRA-ExtIEs',
        u'MDTModeNr-ExtIEs',
        u'M1Configuration-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'M1ThresholdType-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Location-Info-ExtIEs',
        u'N3IWF-ID-ExtIEs',
        u'NB-IoT-Paging-eDRXInfo-ExtIEs',
        u'NgENB-ID-ExtIEs',
        u'NGRAN-CGI-ExtIEs',
        u'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        u'NonDynamic5QIDescriptor-ExtIEs',
        u'NPN-AccessInformation-ExtIEs',
        u'NPN-MobilityInformation-ExtIEs',
        u'NPN-PagingAssistanceInformation-ExtIEs',
        u'NPN-Support-ExtIEs',
        u'NR-CGI-ExtIEs',
        u'NRFrequencyBandItem-ExtIEs',
        u'NRFrequencyInfo-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'OverloadResponse-ExtIEs',
        u'OverloadStartNSSAIItem-ExtIEs',
        u'PacketErrorRate-ExtIEs',
        u'PagingAssisDataforCEcapabUE-ExtIEs',
        u'PagingAttemptInformation-ExtIEs',
        u'PagingeDRXInformation-ExtIEs',
        u'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        u'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        u'PathSwitchRequestTransfer-ExtIEs',
        u'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'PDUSessionAggregateMaximumBitRate-ExtIEs',
        u'PDUSessionResourceAdmittedItem-ExtIEs',
        u'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        u'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        u'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        u'PDUSessionResourceHandoverItem-ExtIEs',
        u'PDUSessionResourceInformationItem-ExtIEs',
        u'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        u'PDUSessionResourceItemCxtRelReq-ExtIEs',
        u'PDUSessionResourceItemHORqd-ExtIEs',
        u'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceModifyRequestTransferIEs',
        u'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        u'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        u'PDUSessionResourceModifyItemModCfm-ExtIEs',
        u'PDUSessionResourceModifyItemModInd-ExtIEs',
        u'PDUSessionResourceModifyItemModReq-ExtIEs',
        u'PDUSessionResourceModifyItemModRes-ExtIEs',
        u'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceNotifyItem-ExtIEs',
        u'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        u'PDUSessionResourceNotifyTransfer-ExtIEs',
        u'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        u'PDUSessionResourceReleasedItemNot-ExtIEs',
        u'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        u'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        u'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        u'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        u'PDUSessionResourceResumeItemRESReq-ExtIEs',
        u'PDUSessionResourceResumeItemRESRes-ExtIEs',
        u'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        u'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        u'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        u'PDUSessionResourceSetupItemHOReq-ExtIEs',
        u'PDUSessionResourceSetupItemSUReq-ExtIEs',
        u'PDUSessionResourceSetupItemSURes-ExtIEs',
        u'PDUSessionResourceSetupRequestTransferIEs',
        u'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        u'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        u'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        u'PDUSessionResourceSwitchedItem-ExtIEs',
        u'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        u'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        u'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        u'PDUSessionUsageReport-ExtIEs',
        u'PLMNSupportItem-ExtIEs',
        u'PNI-NPN-MobilityInformation-ExtIEs',
        u'PWSFailedCellIDList-ExtIEs',
        u'QosCharacteristics-ExtIEs',
        u'QosFlowAcceptedItem-ExtIEs',
        u'QosFlowAddOrModifyRequestItem-ExtIEs',
        u'QosFlowAddOrModifyResponseItem-ExtIEs',
        u'QosFlowFeedbackItem-ExtIEs',
        u'QosFlowInformationItem-ExtIEs',
        u'QosFlowLevelQosParameters-ExtIEs',
        u'QosFlowWithCauseItem-ExtIEs',
        u'QosFlowModifyConfirmItem-ExtIEs',
        u'QosFlowNotifyItem-ExtIEs',
        u'QosFlowParametersItem-ExtIEs',
        u'QosFlowPerTNLInformation-ExtIEs',
        u'QosFlowPerTNLInformationItem-ExtIEs',
        u'QosFlowSetupRequestItem-ExtIEs',
        u'QosFlowItemWithDataForwarding-ExtIEs',
        u'QosFlowToBeForwardedItem-ExtIEs',
        u'QoSFlowsUsageReport-Item-ExtIEs',
        u'RANStatusTransfer-TransparentContainer-ExtIEs',
        u'RATRestrictions-Item-ExtIEs',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellItem-ExtIEs',
        u'RecommendedRANNodesForPaging-ExtIEs',
        u'RecommendedRANNodeItem-ExtIEs',
        u'RedundantPDUSessionInformation-ExtIEs',
        u'ResetType-ExtIEs',
        u'RIMInformationTransfer-ExtIEs',
        u'RIMInformation-ExtIEs',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SecondaryRATUsageInformation-ExtIEs',
        u'SecondaryRATDataUsageReportTransfer-ExtIEs',
        u'SecurityContext-ExtIEs',
        u'SecurityIndication-ExtIEs',
        u'SecurityResult-ExtIEs',
        u'SensorMeasurementConfiguration-ExtIEs',
        u'SensorMeasConfigNameItem-ExtIEs',
        u'SensorNameConfig-ExtIEs',
        u'ServedGUAMIItem-ExtIEs',
        u'ServiceAreaInformation-Item-ExtIEs',
        u'SliceOverloadItem-ExtIEs',
        u'SliceSupportItem-ExtIEs',
        u'SNPN-MobilityInformation-ExtIEs',
        u'S-NSSAI-ExtIEs',
        u'SONConfigurationTransfer-ExtIEs',
        u'SONInformation-ExtIEs',
        u'SONInformationReply-ExtIEs',
        u'SONInformationReport-ExtIEs',
        u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        u'SourceNodeID-ExtIEs',
        u'SourceRANNodeID-ExtIEs',
        u'SourceToTarget-AMFInformationReroute-ExtIEs',
        u'SupportedTAItem-ExtIEs',
        u'TAI-ExtIEs',
        u'TAIBroadcastEUTRA-Item-ExtIEs',
        u'TAIBroadcastNR-Item-ExtIEs',
        u'TAICancelledEUTRA-Item-ExtIEs',
        u'TAICancelledNR-Item-ExtIEs',
        u'TAIListForInactiveItem-ExtIEs',
        u'TAIListForPagingItem-ExtIEs',
        u'TargeteNB-ID-ExtIEs',
        u'TargetID-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        u'TargetRANNodeID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TNGF-ID-ExtIEs',
        u'TNLAssociationItem-ExtIEs',
        u'TooearlyIntersystemHO-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TWIF-ID-ExtIEs',
        u'TSCAssistanceInformation-ExtIEs',
        u'TSCTrafficCharacteristics-ExtIEs',
        u'UEAggregateMaximumBitRate-ExtIEs',
        u'UE-associatedLogicalNG-connectionItem-ExtIEs',
        u'UEContextResumeRequestTransfer-ExtIEs',
        u'UEContextResumeResponseTransfer-ExtIEs',
        u'UEContextSuspendRequestTransfer-ExtIEs',
        u'UE-DifferentiationInfo-ExtIEs',
        u'UEHistoryInformationFromTheUE-ExtIEs',
        u'UEIdentityIndexValue-ExtIEs',
        u'UE-NGAP-IDs-ExtIEs',
        u'UE-NGAP-ID-pair-ExtIEs',
        u'UEPagingIdentity-ExtIEs',
        u'UEPresenceInAreaOfInterestItem-ExtIEs',
        u'UERadioCapabilityForPaging-ExtIEs',
        u'UERLFReportContainer-ExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UL-NGU-UP-TNLModifyItem-ExtIEs',
        u'UnavailableGUAMIItem-ExtIEs',
        u'UPTransportLayerInformation-ExtIEs',
        u'UPTransportLayerInformationItem-ExtIEs',
        u'UPTransportLayerInformationPairItem-ExtIEs',
        u'UserLocationInformation-ExtIEs',
        u'UserLocationInformationEUTRA-ExtIEs',
        u'UserLocationInformationN3IWF-ExtIEs',
        u'UserLocationInformationTNGF-ExtIEs',
        u'UserLocationInformationTWIF-ExtIEs',
        u'UserLocationInformationW-AGF-ExtIEs',
        u'UserLocationInformationNR-ExtIEs',
        u'UserPlaneSecurityInformation-ExtIEs',
        u'VolumeTimedReport-Item-ExtIEs',
        u'W-AGF-ID-ExtIEs',
        u'WarningAreaList-ExtIEs',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WLANMeasConfigNameItem-ExtIEs',
        u'WUS-Assistance-Information-ExtIEs',
        u'XnExtTLA-Item-ExtIEs',
        u'XnTNLConfigurationInfo-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AdditionalDLUPTNLInformationForHOList >-----#
    AdditionalDLUPTNLInformationForHOList = SEQ_OF(name=u'AdditionalDLUPTNLInformationForHOList', mode=MODE_TYPE)
    _AdditionalDLUPTNLInformationForHOList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOItem')))
    AdditionalDLUPTNLInformationForHOList._cont = _AdditionalDLUPTNLInformationForHOList__item_
    AdditionalDLUPTNLInformationForHOList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AdditionalDLUPTNLInformationForHOItem >-----#
    AdditionalDLUPTNLInformationForHOItem = SEQ(name=u'AdditionalDLUPTNLInformationForHOItem', mode=MODE_TYPE)
    _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation = CHOICE(name=u'additionalDL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList = SEQ_OF(name=u'additionalQosFlowSetupResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithDataForwarding')))
    _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation = CHOICE(name=u'additionalDLForwardingUPTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id),
        (u'criticality', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue),
        ])
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_._ext = None
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions._cont = __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalDLUPTNLInformationForHOItem._cont = ASN1Dict([
        (u'additionalDL-NGU-UP-TNLInformation', _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation),
        (u'additionalQosFlowSetupResponseList', _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList),
        (u'additionalDLForwardingUPTNLInformation', _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation),
        (u'iE-Extensions', _AdditionalDLUPTNLInformationForHOItem_iE_Extensions),
        ])
    AdditionalDLUPTNLInformationForHOItem._ext = []
    
    #-----< AdditionalDLUPTNLInformationForHOItem-ExtIEs >-----#
    AdditionalDLUPTNLInformationForHOItem_ExtIEs = CLASS(name=u'AdditionalDLUPTNLInformationForHOItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    AdditionalDLUPTNLInformationForHOItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AdditionalQosFlowInformation >-----#
    AdditionalQosFlowInformation = ENUM(name=u'AdditionalQosFlowInformation', mode=MODE_TYPE)
    AdditionalQosFlowInformation._cont = ASN1Dict([(u'more-likely', 0)])
    AdditionalQosFlowInformation._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name=u'AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevelARP = INT(name=u'priorityLevelARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelARP')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevelARP', _AllocationAndRetentionPriority_priorityLevelARP),
        (u'pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name=u'AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-CAG-List-per-PLMN >-----#
    Allowed_CAG_List_per_PLMN = SEQ_OF(name=u'Allowed-CAG-List-per-PLMN', mode=MODE_TYPE)
    _Allowed_CAG_List_per_PLMN__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CAG-ID')))
    Allowed_CAG_List_per_PLMN._cont = _Allowed_CAG_List_per_PLMN__item_
    Allowed_CAG_List_per_PLMN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AllowedNSSAI >-----#
    AllowedNSSAI = SEQ_OF(name=u'AllowedNSSAI', mode=MODE_TYPE)
    _AllowedNSSAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI-Item')))
    AllowedNSSAI._cont = _AllowedNSSAI__item_
    AllowedNSSAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AllowedNSSAI-Item >-----#
    AllowedNSSAI_Item = SEQ(name=u'AllowedNSSAI-Item', mode=MODE_TYPE)
    _AllowedNSSAI_Item_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _AllowedNSSAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllowedNSSAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AllowedNSSAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllowedNSSAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__id_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllowedNSSAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllowedNSSAI_Item_iE_Extensions__item__id),
        (u'criticality', ___AllowedNSSAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue),
        ])
    __AllowedNSSAI_Item_iE_Extensions__item_._ext = None
    _AllowedNSSAI_Item_iE_Extensions._cont = __AllowedNSSAI_Item_iE_Extensions__item_
    _AllowedNSSAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllowedNSSAI_Item._cont = ASN1Dict([
        (u's-NSSAI', _AllowedNSSAI_Item_s_NSSAI),
        (u'iE-Extensions', _AllowedNSSAI_Item_iE_Extensions),
        ])
    AllowedNSSAI_Item._ext = []
    
    #-----< AllowedNSSAI-Item-ExtIEs >-----#
    AllowedNSSAI_Item_ExtIEs = CLASS(name=u'AllowedNSSAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AllowedNSSAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-PNI-NPN-List >-----#
    Allowed_PNI_NPN_List = SEQ_OF(name=u'Allowed-PNI-NPN-List', mode=MODE_TYPE)
    _Allowed_PNI_NPN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-Item')))
    Allowed_PNI_NPN_List._cont = _Allowed_PNI_NPN_List__item_
    Allowed_PNI_NPN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Allowed-PNI-NPN-Item >-----#
    Allowed_PNI_NPN_Item = SEQ(name=u'Allowed-PNI-NPN-Item', mode=MODE_TYPE)
    _Allowed_PNI_NPN_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted = ENUM(name=u'pNI-NPN-restricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted._cont = ASN1Dict([(u'restricted', 0), (u'not-restricted', 1)])
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted._ext = []
    _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN = SEQ_OF(name=u'allowed-CAG-List-per-PLMN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-CAG-List-per-PLMN')))
    _Allowed_PNI_NPN_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Allowed_PNI_NPN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab_at = None
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Allowed_PNI_NPN_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Allowed_PNI_NPN_Item_iE_Extensions__item__id),
        (u'criticality', ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue),
        ])
    __Allowed_PNI_NPN_Item_iE_Extensions__item_._ext = None
    _Allowed_PNI_NPN_Item_iE_Extensions._cont = __Allowed_PNI_NPN_Item_iE_Extensions__item_
    _Allowed_PNI_NPN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Allowed_PNI_NPN_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _Allowed_PNI_NPN_Item_pLMNIdentity),
        (u'pNI-NPN-restricted', _Allowed_PNI_NPN_Item_pNI_NPN_restricted),
        (u'allowed-CAG-List-per-PLMN', _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN),
        (u'iE-Extensions', _Allowed_PNI_NPN_Item_iE_Extensions),
        ])
    Allowed_PNI_NPN_Item._ext = []
    
    #-----< Allowed-PNI-NPN-Item-ExtIEs >-----#
    Allowed_PNI_NPN_Item_ExtIEs = CLASS(name=u'Allowed-PNI-NPN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Allowed_PNI_NPN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllowedTACs >-----#
    AllowedTACs = SEQ_OF(name=u'AllowedTACs', mode=MODE_TYPE)
    _AllowedTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    AllowedTACs._cont = _AllowedTACs__item_
    AllowedTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetIndex >-----#
    AlternativeQoSParaSetIndex = INT(name=u'AlternativeQoSParaSetIndex', mode=MODE_TYPE)
    AlternativeQoSParaSetIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetNotifyIndex >-----#
    AlternativeQoSParaSetNotifyIndex = INT(name=u'AlternativeQoSParaSetNotifyIndex', mode=MODE_TYPE)
    AlternativeQoSParaSetNotifyIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetList >-----#
    AlternativeQoSParaSetList = SEQ_OF(name=u'AlternativeQoSParaSetList', mode=MODE_TYPE)
    _AlternativeQoSParaSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetItem')))
    AlternativeQoSParaSetList._cont = _AlternativeQoSParaSetList__item_
    AlternativeQoSParaSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetItem >-----#
    AlternativeQoSParaSetItem = SEQ(name=u'AlternativeQoSParaSetItem', mode=MODE_TYPE)
    _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex = INT(name=u'alternativeQoSParaSetIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL = INT(name=u'guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL = INT(name=u'guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_packetDelayBudget = INT(name=u'packetDelayBudget', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketDelayBudget')), opt=True)
    _AlternativeQoSParaSetItem_packetErrorRate = SEQ(name=u'packetErrorRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketErrorRate')), opt=True)
    _AlternativeQoSParaSetItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlternativeQoSParaSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_at = None
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AlternativeQoSParaSetItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AlternativeQoSParaSetItem_iE_Extensions__item__id),
        (u'criticality', ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue),
        ])
    __AlternativeQoSParaSetItem_iE_Extensions__item_._ext = None
    _AlternativeQoSParaSetItem_iE_Extensions._cont = __AlternativeQoSParaSetItem_iE_Extensions__item_
    _AlternativeQoSParaSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlternativeQoSParaSetItem._cont = ASN1Dict([
        (u'alternativeQoSParaSetIndex', _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex),
        (u'guaranteedFlowBitRateDL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL),
        (u'guaranteedFlowBitRateUL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL),
        (u'packetDelayBudget', _AlternativeQoSParaSetItem_packetDelayBudget),
        (u'packetErrorRate', _AlternativeQoSParaSetItem_packetErrorRate),
        (u'iE-Extensions', _AlternativeQoSParaSetItem_iE_Extensions),
        ])
    AlternativeQoSParaSetItem._ext = []
    
    #-----< AlternativeQoSParaSetItem-ExtIEs >-----#
    AlternativeQoSParaSetItem_ExtIEs = CLASS(name=u'AlternativeQoSParaSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AlternativeQoSParaSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMFName >-----#
    AMFName = STR_PRINT(name=u'AMFName', mode=MODE_TYPE)
    AMFName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFNameVisibleString >-----#
    AMFNameVisibleString = STR_VIS(name=u'AMFNameVisibleString', mode=MODE_TYPE)
    AMFNameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFNameUTF8String >-----#
    AMFNameUTF8String = STR_UTF8(name=u'AMFNameUTF8String', mode=MODE_TYPE)
    AMFNameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFPagingTarget >-----#
    AMFPagingTarget = CHOICE(name=u'AMFPagingTarget', mode=MODE_TYPE)
    _AMFPagingTarget_globalRANNodeID = CHOICE(name=u'globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _AMFPagingTarget_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _AMFPagingTarget_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AMFPagingTarget_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___AMFPagingTarget_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_id._const_tab = ___AMFPagingTarget_choice_Extensions_id_tab
    __AMFPagingTarget_choice_Extensions_id._const_tab_at = None
    __AMFPagingTarget_choice_Extensions_id._const_tab_id = u'id'
    __AMFPagingTarget_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFPagingTarget_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_criticality._const_tab = ___AMFPagingTarget_choice_Extensions_criticality_tab
    __AMFPagingTarget_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __AMFPagingTarget_choice_Extensions_criticality._const_tab_id = u'criticality'
    __AMFPagingTarget_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFPagingTarget_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_value._const_tab = ___AMFPagingTarget_choice_Extensions_value_tab
    __AMFPagingTarget_choice_Extensions_value._const_tab_at = ('..', u'id')
    __AMFPagingTarget_choice_Extensions_value._const_tab_id = u'Value'
    _AMFPagingTarget_choice_Extensions._cont = ASN1Dict([
        (u'id', __AMFPagingTarget_choice_Extensions_id),
        (u'criticality', __AMFPagingTarget_choice_Extensions_criticality),
        (u'value', __AMFPagingTarget_choice_Extensions_value),
        ])
    _AMFPagingTarget_choice_Extensions._ext = None
    AMFPagingTarget._cont = ASN1Dict([
        (u'globalRANNodeID', _AMFPagingTarget_globalRANNodeID),
        (u'tAI', _AMFPagingTarget_tAI),
        (u'choice-Extensions', _AMFPagingTarget_choice_Extensions),
        ])
    AMFPagingTarget._ext = None
    
    #-----< AMFPagingTarget-ExtIEs >-----#
    AMFPagingTarget_ExtIEs = CLASS(name=u'AMFPagingTarget-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AMFPagingTarget_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMFPointer >-----#
    AMFPointer = BIT_STR(name=u'AMFPointer', mode=MODE_TYPE)
    AMFPointer._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< AMFRegionID >-----#
    AMFRegionID = BIT_STR(name=u'AMFRegionID', mode=MODE_TYPE)
    AMFRegionID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< AMFSetID >-----#
    AMFSetID = BIT_STR(name=u'AMFSetID', mode=MODE_TYPE)
    AMFSetID._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< AMF-TNLAssociationSetupList >-----#
    AMF_TNLAssociationSetupList = SEQ_OF(name=u'AMF-TNLAssociationSetupList', mode=MODE_TYPE)
    _AMF_TNLAssociationSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupItem')))
    AMF_TNLAssociationSetupList._cont = _AMF_TNLAssociationSetupList__item_
    AMF_TNLAssociationSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationSetupItem >-----#
    AMF_TNLAssociationSetupItem = SEQ(name=u'AMF-TNLAssociationSetupItem', mode=MODE_TYPE)
    _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress = CHOICE(name=u'aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationSetupItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id),
        (u'criticality', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationSetupItem_iE_Extensions._cont = __AMF_TNLAssociationSetupItem_iE_Extensions__item_
    _AMF_TNLAssociationSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationSetupItem._cont = ASN1Dict([
        (u'aMF-TNLAssociationAddress', _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress),
        (u'iE-Extensions', _AMF_TNLAssociationSetupItem_iE_Extensions),
        ])
    AMF_TNLAssociationSetupItem._ext = []
    
    #-----< AMF-TNLAssociationSetupItem-ExtIEs >-----#
    AMF_TNLAssociationSetupItem_ExtIEs = CLASS(name=u'AMF-TNLAssociationSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToAddList >-----#
    AMF_TNLAssociationToAddList = SEQ_OF(name=u'AMF-TNLAssociationToAddList', mode=MODE_TYPE)
    _AMF_TNLAssociationToAddList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddItem')))
    AMF_TNLAssociationToAddList._cont = _AMF_TNLAssociationToAddList__item_
    AMF_TNLAssociationToAddList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToAddItem >-----#
    AMF_TNLAssociationToAddItem = SEQ(name=u'AMF-TNLAssociationToAddItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress = CHOICE(name=u'aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToAddItem_tNLAssociationUsage = ENUM(name=u'tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationUsage')), opt=True)
    _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor = INT(name=u'tNLAddressWeightFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAddressWeightFactor')))
    _AMF_TNLAssociationToAddItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id),
        (u'criticality', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToAddItem_iE_Extensions._cont = __AMF_TNLAssociationToAddItem_iE_Extensions__item_
    _AMF_TNLAssociationToAddItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToAddItem._cont = ASN1Dict([
        (u'aMF-TNLAssociationAddress', _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress),
        (u'tNLAssociationUsage', _AMF_TNLAssociationToAddItem_tNLAssociationUsage),
        (u'tNLAddressWeightFactor', _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor),
        (u'iE-Extensions', _AMF_TNLAssociationToAddItem_iE_Extensions),
        ])
    AMF_TNLAssociationToAddItem._ext = []
    
    #-----< AMF-TNLAssociationToAddItem-ExtIEs >-----#
    AMF_TNLAssociationToAddItem_ExtIEs = CLASS(name=u'AMF-TNLAssociationToAddItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationToAddItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToRemoveList >-----#
    AMF_TNLAssociationToRemoveList = SEQ_OF(name=u'AMF-TNLAssociationToRemoveList', mode=MODE_TYPE)
    _AMF_TNLAssociationToRemoveList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveItem')))
    AMF_TNLAssociationToRemoveList._cont = _AMF_TNLAssociationToRemoveList__item_
    AMF_TNLAssociationToRemoveList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToRemoveItem >-----#
    AMF_TNLAssociationToRemoveItem = SEQ(name=u'AMF-TNLAssociationToRemoveItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress = CHOICE(name=u'aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToRemoveItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 168), (u'criticality', u'reject'), (u'Extension', _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id),
        (u'criticality', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToRemoveItem_iE_Extensions._cont = __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_
    _AMF_TNLAssociationToRemoveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToRemoveItem._cont = ASN1Dict([
        (u'aMF-TNLAssociationAddress', _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress),
        (u'iE-Extensions', _AMF_TNLAssociationToRemoveItem_iE_Extensions),
        ])
    AMF_TNLAssociationToRemoveItem._ext = []
    
    #-----< AMF-TNLAssociationToRemoveItem-ExtIEs >-----#
    AMF_TNLAssociationToRemoveItem_ExtIEs = CLASS(name=u'AMF-TNLAssociationToRemoveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    AMF_TNLAssociationToRemoveItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 168), (u'criticality', u'reject'), (u'Extension', _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToUpdateList >-----#
    AMF_TNLAssociationToUpdateList = SEQ_OF(name=u'AMF-TNLAssociationToUpdateList', mode=MODE_TYPE)
    _AMF_TNLAssociationToUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateItem')))
    AMF_TNLAssociationToUpdateList._cont = _AMF_TNLAssociationToUpdateList__item_
    AMF_TNLAssociationToUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToUpdateItem >-----#
    AMF_TNLAssociationToUpdateItem = SEQ(name=u'AMF-TNLAssociationToUpdateItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress = CHOICE(name=u'aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage = ENUM(name=u'tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationUsage')), opt=True)
    _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor = INT(name=u'tNLAddressWeightFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAddressWeightFactor')), opt=True)
    _AMF_TNLAssociationToUpdateItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id),
        (u'criticality', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToUpdateItem_iE_Extensions._cont = __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_
    _AMF_TNLAssociationToUpdateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToUpdateItem._cont = ASN1Dict([
        (u'aMF-TNLAssociationAddress', _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress),
        (u'tNLAssociationUsage', _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage),
        (u'tNLAddressWeightFactor', _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor),
        (u'iE-Extensions', _AMF_TNLAssociationToUpdateItem_iE_Extensions),
        ])
    AMF_TNLAssociationToUpdateItem._ext = []
    
    #-----< AMF-TNLAssociationToUpdateItem-ExtIEs >-----#
    AMF_TNLAssociationToUpdateItem_ExtIEs = CLASS(name=u'AMF-TNLAssociationToUpdateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationToUpdateItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-UE-NGAP-ID >-----#
    AMF_UE_NGAP_ID = INT(name=u'AMF-UE-NGAP-ID', mode=MODE_TYPE)
    AMF_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1099511627775)], ev=None, er=[])
    
    #-----< AreaOfInterest >-----#
    AreaOfInterest = SEQ(name=u'AreaOfInterest', mode=MODE_TYPE)
    _AreaOfInterest_areaOfInterestTAIList = SEQ_OF(name=u'areaOfInterestTAIList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestTAIList')), opt=True)
    _AreaOfInterest_areaOfInterestCellList = SEQ_OF(name=u'areaOfInterestCellList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestCellList')), opt=True)
    _AreaOfInterest_areaOfInterestRANNodeList = SEQ_OF(name=u'areaOfInterestRANNodeList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestRANNodeList')), opt=True)
    _AreaOfInterest_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterest_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaOfInterest_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__id._const_tab = ____AreaOfInterest_iE_Extensions__item__id_tab
    ___AreaOfInterest_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterest_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaOfInterest_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaOfInterest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab = ____AreaOfInterest_iE_Extensions__item__criticality_tab
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaOfInterest_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaOfInterest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterest_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaOfInterest_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaOfInterest_iE_Extensions__item__id),
        (u'criticality', ___AreaOfInterest_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaOfInterest_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterest_iE_Extensions__item_._ext = None
    _AreaOfInterest_iE_Extensions._cont = __AreaOfInterest_iE_Extensions__item_
    _AreaOfInterest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterest._cont = ASN1Dict([
        (u'areaOfInterestTAIList', _AreaOfInterest_areaOfInterestTAIList),
        (u'areaOfInterestCellList', _AreaOfInterest_areaOfInterestCellList),
        (u'areaOfInterestRANNodeList', _AreaOfInterest_areaOfInterestRANNodeList),
        (u'iE-Extensions', _AreaOfInterest_iE_Extensions),
        ])
    AreaOfInterest._ext = []
    
    #-----< AreaOfInterest-ExtIEs >-----#
    AreaOfInterest_ExtIEs = CLASS(name=u'AreaOfInterest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestCellList >-----#
    AreaOfInterestCellList = SEQ_OF(name=u'AreaOfInterestCellList', mode=MODE_TYPE)
    _AreaOfInterestCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestCellItem')))
    AreaOfInterestCellList._cont = _AreaOfInterestCellList__item_
    AreaOfInterestCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AreaOfInterestCellItem >-----#
    AreaOfInterestCellItem = SEQ(name=u'AreaOfInterestCellItem', mode=MODE_TYPE)
    _AreaOfInterestCellItem_nGRAN_CGI = CHOICE(name=u'nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _AreaOfInterestCellItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestCellItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaOfInterestCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__id_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaOfInterestCellItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaOfInterestCellItem_iE_Extensions__item__id),
        (u'criticality', ___AreaOfInterestCellItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestCellItem_iE_Extensions__item_._ext = None
    _AreaOfInterestCellItem_iE_Extensions._cont = __AreaOfInterestCellItem_iE_Extensions__item_
    _AreaOfInterestCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestCellItem._cont = ASN1Dict([
        (u'nGRAN-CGI', _AreaOfInterestCellItem_nGRAN_CGI),
        (u'iE-Extensions', _AreaOfInterestCellItem_iE_Extensions),
        ])
    AreaOfInterestCellItem._ext = []
    
    #-----< AreaOfInterestCellItem-ExtIEs >-----#
    AreaOfInterestCellItem_ExtIEs = CLASS(name=u'AreaOfInterestCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestList >-----#
    AreaOfInterestList = SEQ_OF(name=u'AreaOfInterestList', mode=MODE_TYPE)
    _AreaOfInterestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestItem')))
    AreaOfInterestList._cont = _AreaOfInterestList__item_
    AreaOfInterestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AreaOfInterestItem >-----#
    AreaOfInterestItem = SEQ(name=u'AreaOfInterestItem', mode=MODE_TYPE)
    _AreaOfInterestItem_areaOfInterest = SEQ(name=u'areaOfInterest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterest')))
    _AreaOfInterestItem_locationReportingReferenceID = INT(name=u'locationReportingReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')))
    _AreaOfInterestItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaOfInterestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestItem_iE_Extensions__item__id_tab
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaOfInterestItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaOfInterestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaOfInterestItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaOfInterestItem_iE_Extensions__item__id),
        (u'criticality', ___AreaOfInterestItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaOfInterestItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestItem_iE_Extensions__item_._ext = None
    _AreaOfInterestItem_iE_Extensions._cont = __AreaOfInterestItem_iE_Extensions__item_
    _AreaOfInterestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestItem._cont = ASN1Dict([
        (u'areaOfInterest', _AreaOfInterestItem_areaOfInterest),
        (u'locationReportingReferenceID', _AreaOfInterestItem_locationReportingReferenceID),
        (u'iE-Extensions', _AreaOfInterestItem_iE_Extensions),
        ])
    AreaOfInterestItem._ext = []
    
    #-----< AreaOfInterestItem-ExtIEs >-----#
    AreaOfInterestItem_ExtIEs = CLASS(name=u'AreaOfInterestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestRANNodeList >-----#
    AreaOfInterestRANNodeList = SEQ_OF(name=u'AreaOfInterestRANNodeList', mode=MODE_TYPE)
    _AreaOfInterestRANNodeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestRANNodeItem')))
    AreaOfInterestRANNodeList._cont = _AreaOfInterestRANNodeList__item_
    AreaOfInterestRANNodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AreaOfInterestRANNodeItem >-----#
    AreaOfInterestRANNodeItem = SEQ(name=u'AreaOfInterestRANNodeItem', mode=MODE_TYPE)
    _AreaOfInterestRANNodeItem_globalRANNodeID = CHOICE(name=u'globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _AreaOfInterestRANNodeItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestRANNodeItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaOfInterestRANNodeItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaOfInterestRANNodeItem_iE_Extensions__item__id),
        (u'criticality', ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestRANNodeItem_iE_Extensions__item_._ext = None
    _AreaOfInterestRANNodeItem_iE_Extensions._cont = __AreaOfInterestRANNodeItem_iE_Extensions__item_
    _AreaOfInterestRANNodeItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestRANNodeItem._cont = ASN1Dict([
        (u'globalRANNodeID', _AreaOfInterestRANNodeItem_globalRANNodeID),
        (u'iE-Extensions', _AreaOfInterestRANNodeItem_iE_Extensions),
        ])
    AreaOfInterestRANNodeItem._ext = []
    
    #-----< AreaOfInterestRANNodeItem-ExtIEs >-----#
    AreaOfInterestRANNodeItem_ExtIEs = CLASS(name=u'AreaOfInterestRANNodeItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestRANNodeItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestTAIList >-----#
    AreaOfInterestTAIList = SEQ_OF(name=u'AreaOfInterestTAIList', mode=MODE_TYPE)
    _AreaOfInterestTAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestTAIItem')))
    AreaOfInterestTAIList._cont = _AreaOfInterestTAIList__item_
    AreaOfInterestTAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AreaOfInterestTAIItem >-----#
    AreaOfInterestTAIItem = SEQ(name=u'AreaOfInterestTAIItem', mode=MODE_TYPE)
    _AreaOfInterestTAIItem_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _AreaOfInterestTAIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestTAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestTAIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaOfInterestTAIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaOfInterestTAIItem_iE_Extensions__item__id),
        (u'criticality', ___AreaOfInterestTAIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestTAIItem_iE_Extensions__item_._ext = None
    _AreaOfInterestTAIItem_iE_Extensions._cont = __AreaOfInterestTAIItem_iE_Extensions__item_
    _AreaOfInterestTAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestTAIItem._cont = ASN1Dict([
        (u'tAI', _AreaOfInterestTAIItem_tAI),
        (u'iE-Extensions', _AreaOfInterestTAIItem_iE_Extensions),
        ])
    AreaOfInterestTAIItem._ext = []
    
    #-----< AreaOfInterestTAIItem-ExtIEs >-----#
    AreaOfInterestTAIItem_ExtIEs = CLASS(name=u'AreaOfInterestTAIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestTAIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForPaging >-----#
    AssistanceDataForPaging = SEQ(name=u'AssistanceDataForPaging', mode=MODE_TYPE)
    _AssistanceDataForPaging_assistanceDataForRecommendedCells = SEQ(name=u'assistanceDataForRecommendedCells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForRecommendedCells')), opt=True)
    _AssistanceDataForPaging_pagingAttemptInformation = SEQ(name=u'pagingAttemptInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingAttemptInformation')), opt=True)
    _AssistanceDataForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-PagingAssistanceInformation')))
    _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 260), (u'criticality', u'ignore'), (u'Extension', _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Extension', _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceDataForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceDataForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceDataForPaging_iE_Extensions__item__id),
        (u'criticality', ___AssistanceDataForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceDataForPaging_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForPaging_iE_Extensions__item_._ext = None
    _AssistanceDataForPaging_iE_Extensions._cont = __AssistanceDataForPaging_iE_Extensions__item_
    _AssistanceDataForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForPaging._cont = ASN1Dict([
        (u'assistanceDataForRecommendedCells', _AssistanceDataForPaging_assistanceDataForRecommendedCells),
        (u'pagingAttemptInformation', _AssistanceDataForPaging_pagingAttemptInformation),
        (u'iE-Extensions', _AssistanceDataForPaging_iE_Extensions),
        ])
    AssistanceDataForPaging._ext = []
    
    #-----< AssistanceDataForPaging-ExtIEs >-----#
    AssistanceDataForPaging_ExtIEs = CLASS(name=u'AssistanceDataForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AssistanceDataForPaging_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-PagingAssistanceInformation')))
    _AssistanceDataForPaging_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    AssistanceDataForPaging_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 260), (u'criticality', u'ignore'), (u'Extension', _AssistanceDataForPaging_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Extension', _AssistanceDataForPaging_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForRecommendedCells >-----#
    AssistanceDataForRecommendedCells = SEQ(name=u'AssistanceDataForRecommendedCells', mode=MODE_TYPE)
    _AssistanceDataForRecommendedCells_recommendedCellsForPaging = SEQ(name=u'recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellsForPaging')))
    _AssistanceDataForRecommendedCells_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForRecommendedCells_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceDataForRecommendedCells_iE_Extensions__item__id),
        (u'criticality', ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._ext = None
    _AssistanceDataForRecommendedCells_iE_Extensions._cont = __AssistanceDataForRecommendedCells_iE_Extensions__item_
    _AssistanceDataForRecommendedCells_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForRecommendedCells._cont = ASN1Dict([
        (u'recommendedCellsForPaging', _AssistanceDataForRecommendedCells_recommendedCellsForPaging),
        (u'iE-Extensions', _AssistanceDataForRecommendedCells_iE_Extensions),
        ])
    AssistanceDataForRecommendedCells._ext = []
    
    #-----< AssistanceDataForRecommendedCells-ExtIEs >-----#
    AssistanceDataForRecommendedCells_ExtIEs = CLASS(name=u'AssistanceDataForRecommendedCells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AssistanceDataForRecommendedCells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssociatedQosFlowList >-----#
    AssociatedQosFlowList = SEQ_OF(name=u'AssociatedQosFlowList', mode=MODE_TYPE)
    _AssociatedQosFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowItem')))
    AssociatedQosFlowList._cont = _AssociatedQosFlowList__item_
    AssociatedQosFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AssociatedQosFlowItem >-----#
    AssociatedQosFlowItem = SEQ(name=u'AssociatedQosFlowItem', mode=MODE_TYPE)
    _AssociatedQosFlowItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedQosFlowItem_qosFlowMappingIndication = ENUM(name=u'qosFlowMappingIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssociatedQosFlowItem_qosFlowMappingIndication._cont = ASN1Dict([(u'ul', 0), (u'dl', 1)])
    _AssociatedQosFlowItem_qosFlowMappingIndication._ext = []
    _AssociatedQosFlowItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssociatedQosFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssociatedQosFlowItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssociatedQosFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____AssociatedQosFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssociatedQosFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssociatedQosFlowItem_iE_Extensions__item__id),
        (u'criticality', ___AssociatedQosFlowItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue),
        ])
    __AssociatedQosFlowItem_iE_Extensions__item_._ext = None
    _AssociatedQosFlowItem_iE_Extensions._cont = __AssociatedQosFlowItem_iE_Extensions__item_
    _AssociatedQosFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssociatedQosFlowItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _AssociatedQosFlowItem_qosFlowIdentifier),
        (u'qosFlowMappingIndication', _AssociatedQosFlowItem_qosFlowMappingIndication),
        (u'iE-Extensions', _AssociatedQosFlowItem_iE_Extensions),
        ])
    AssociatedQosFlowItem._ext = []
    
    #-----< AssociatedQosFlowItem-ExtIEs >-----#
    AssociatedQosFlowItem_ExtIEs = CLASS(name=u'AssociatedQosFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AssociatedQosFlowItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    AssociatedQosFlowItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _AssociatedQosFlowItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AuthenticatedIndication >-----#
    AuthenticatedIndication = ENUM(name=u'AuthenticatedIndication', mode=MODE_TYPE)
    AuthenticatedIndication._cont = ASN1Dict([(u'true', 0)])
    AuthenticatedIndication._ext = []
    
    #-----< AveragingWindow >-----#
    AveragingWindow = INT(name=u'AveragingWindow', mode=MODE_TYPE)
    AveragingWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< AreaScopeOfMDT-NR >-----#
    AreaScopeOfMDT_NR = CHOICE(name=u'AreaScopeOfMDT-NR', mode=MODE_TYPE)
    _AreaScopeOfMDT_NR_cellBased = SEQ(name=u'cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellBasedMDT-NR')))
    _AreaScopeOfMDT_NR_tABased = SEQ(name=u'tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_NR_pLMNWide = NULL(name=u'pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_NR_tAIBased = SEQ(name=u'tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBasedMDT')))
    _AreaScopeOfMDT_NR_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AreaScopeOfMDT_NR_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___AreaScopeOfMDT_NR_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_id_tab
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab_at = None
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab_id = u'id'
    __AreaScopeOfMDT_NR_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab_id = u'criticality'
    __AreaScopeOfMDT_NR_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AreaScopeOfMDT_NR_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_value_tab
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab_at = ('..', u'id')
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab_id = u'Value'
    _AreaScopeOfMDT_NR_choice_Extensions._cont = ASN1Dict([
        (u'id', __AreaScopeOfMDT_NR_choice_Extensions_id),
        (u'criticality', __AreaScopeOfMDT_NR_choice_Extensions_criticality),
        (u'value', __AreaScopeOfMDT_NR_choice_Extensions_value),
        ])
    _AreaScopeOfMDT_NR_choice_Extensions._ext = None
    AreaScopeOfMDT_NR._cont = ASN1Dict([
        (u'cellBased', _AreaScopeOfMDT_NR_cellBased),
        (u'tABased', _AreaScopeOfMDT_NR_tABased),
        (u'pLMNWide', _AreaScopeOfMDT_NR_pLMNWide),
        (u'tAIBased', _AreaScopeOfMDT_NR_tAIBased),
        (u'choice-Extensions', _AreaScopeOfMDT_NR_choice_Extensions),
        ])
    AreaScopeOfMDT_NR._ext = None
    
    #-----< AreaScopeOfMDT-NR-ExtIEs >-----#
    AreaScopeOfMDT_NR_ExtIEs = CLASS(name=u'AreaScopeOfMDT-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AreaScopeOfMDT_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfMDT-EUTRA >-----#
    AreaScopeOfMDT_EUTRA = CHOICE(name=u'AreaScopeOfMDT-EUTRA', mode=MODE_TYPE)
    _AreaScopeOfMDT_EUTRA_cellBased = SEQ(name=u'cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellBasedMDT-EUTRA')))
    _AreaScopeOfMDT_EUTRA_tABased = SEQ(name=u'tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_EUTRA_pLMNWide = NULL(name=u'pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_EUTRA_tAIBased = SEQ(name=u'tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBasedMDT')))
    _AreaScopeOfMDT_EUTRA_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab_at = None
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab_id = u'id'
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab_id = u'criticality'
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab_at = ('..', u'id')
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab_id = u'Value'
    _AreaScopeOfMDT_EUTRA_choice_Extensions._cont = ASN1Dict([
        (u'id', __AreaScopeOfMDT_EUTRA_choice_Extensions_id),
        (u'criticality', __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality),
        (u'value', __AreaScopeOfMDT_EUTRA_choice_Extensions_value),
        ])
    _AreaScopeOfMDT_EUTRA_choice_Extensions._ext = None
    AreaScopeOfMDT_EUTRA._cont = ASN1Dict([
        (u'cellBased', _AreaScopeOfMDT_EUTRA_cellBased),
        (u'tABased', _AreaScopeOfMDT_EUTRA_tABased),
        (u'pLMNWide', _AreaScopeOfMDT_EUTRA_pLMNWide),
        (u'tAIBased', _AreaScopeOfMDT_EUTRA_tAIBased),
        (u'choice-Extensions', _AreaScopeOfMDT_EUTRA_choice_Extensions),
        ])
    AreaScopeOfMDT_EUTRA._ext = None
    
    #-----< AreaScopeOfMDT-EUTRA-ExtIEs >-----#
    AreaScopeOfMDT_EUTRA_ExtIEs = CLASS(name=u'AreaScopeOfMDT-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AreaScopeOfMDT_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfNeighCellsList >-----#
    AreaScopeOfNeighCellsList = SEQ_OF(name=u'AreaScopeOfNeighCellsList', mode=MODE_TYPE)
    _AreaScopeOfNeighCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfNeighCellsItem')))
    AreaScopeOfNeighCellsList._cont = _AreaScopeOfNeighCellsList__item_
    AreaScopeOfNeighCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AreaScopeOfNeighCellsItem >-----#
    AreaScopeOfNeighCellsItem = SEQ(name=u'AreaScopeOfNeighCellsItem', mode=MODE_TYPE)
    _AreaScopeOfNeighCellsItem_nrFrequencyInfo = SEQ(name=u'nrFrequencyInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyInfo')))
    _AreaScopeOfNeighCellsItem_pciListForMDT = SEQ_OF(name=u'pciListForMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PCIListForMDT')), opt=True)
    _AreaScopeOfNeighCellsItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id),
        (u'criticality', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue),
        ])
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_._ext = None
    _AreaScopeOfNeighCellsItem_iE_Extensions._cont = __AreaScopeOfNeighCellsItem_iE_Extensions__item_
    _AreaScopeOfNeighCellsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaScopeOfNeighCellsItem._cont = ASN1Dict([
        (u'nrFrequencyInfo', _AreaScopeOfNeighCellsItem_nrFrequencyInfo),
        (u'pciListForMDT', _AreaScopeOfNeighCellsItem_pciListForMDT),
        (u'iE-Extensions', _AreaScopeOfNeighCellsItem_iE_Extensions),
        ])
    AreaScopeOfNeighCellsItem._ext = []
    
    #-----< AreaScopeOfNeighCellsItem-ExtIEs >-----#
    AreaScopeOfNeighCellsItem_ExtIEs = CLASS(name=u'AreaScopeOfNeighCellsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaScopeOfNeighCellsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name=u'BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4000000000000)], ev=[], er=[])
    
    #-----< BroadcastCancelledAreaList >-----#
    BroadcastCancelledAreaList = CHOICE(name=u'BroadcastCancelledAreaList', mode=MODE_TYPE)
    _BroadcastCancelledAreaList_cellIDCancelledEUTRA = SEQ_OF(name=u'cellIDCancelledEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledEUTRA')))
    _BroadcastCancelledAreaList_tAICancelledEUTRA = SEQ_OF(name=u'tAICancelledEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledEUTRA')))
    _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA = SEQ_OF(name=u'emergencyAreaIDCancelledEUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledEUTRA')))
    _BroadcastCancelledAreaList_cellIDCancelledNR = SEQ_OF(name=u'cellIDCancelledNR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledNR')))
    _BroadcastCancelledAreaList_tAICancelledNR = SEQ_OF(name=u'tAICancelledNR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledNR')))
    _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR = SEQ_OF(name=u'emergencyAreaIDCancelledNR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledNR')))
    _BroadcastCancelledAreaList_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastCancelledAreaList_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___BroadcastCancelledAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_id_tab
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab_at = None
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab_id = u'id'
    __BroadcastCancelledAreaList_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab_id = u'criticality'
    __BroadcastCancelledAreaList_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___BroadcastCancelledAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_value_tab
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab_at = ('..', u'id')
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab_id = u'Value'
    _BroadcastCancelledAreaList_choice_Extensions._cont = ASN1Dict([
        (u'id', __BroadcastCancelledAreaList_choice_Extensions_id),
        (u'criticality', __BroadcastCancelledAreaList_choice_Extensions_criticality),
        (u'value', __BroadcastCancelledAreaList_choice_Extensions_value),
        ])
    _BroadcastCancelledAreaList_choice_Extensions._ext = None
    BroadcastCancelledAreaList._cont = ASN1Dict([
        (u'cellIDCancelledEUTRA', _BroadcastCancelledAreaList_cellIDCancelledEUTRA),
        (u'tAICancelledEUTRA', _BroadcastCancelledAreaList_tAICancelledEUTRA),
        (u'emergencyAreaIDCancelledEUTRA', _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA),
        (u'cellIDCancelledNR', _BroadcastCancelledAreaList_cellIDCancelledNR),
        (u'tAICancelledNR', _BroadcastCancelledAreaList_tAICancelledNR),
        (u'emergencyAreaIDCancelledNR', _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR),
        (u'choice-Extensions', _BroadcastCancelledAreaList_choice_Extensions),
        ])
    BroadcastCancelledAreaList._ext = None
    
    #-----< BroadcastCancelledAreaList-ExtIEs >-----#
    BroadcastCancelledAreaList_ExtIEs = CLASS(name=u'BroadcastCancelledAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    BroadcastCancelledAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastCompletedAreaList >-----#
    BroadcastCompletedAreaList = CHOICE(name=u'BroadcastCompletedAreaList', mode=MODE_TYPE)
    _BroadcastCompletedAreaList_cellIDBroadcastEUTRA = SEQ_OF(name=u'cellIDBroadcastEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastEUTRA')))
    _BroadcastCompletedAreaList_tAIBroadcastEUTRA = SEQ_OF(name=u'tAIBroadcastEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastEUTRA')))
    _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA = SEQ_OF(name=u'emergencyAreaIDBroadcastEUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastEUTRA')))
    _BroadcastCompletedAreaList_cellIDBroadcastNR = SEQ_OF(name=u'cellIDBroadcastNR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastNR')))
    _BroadcastCompletedAreaList_tAIBroadcastNR = SEQ_OF(name=u'tAIBroadcastNR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastNR')))
    _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR = SEQ_OF(name=u'emergencyAreaIDBroadcastNR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastNR')))
    _BroadcastCompletedAreaList_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastCompletedAreaList_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___BroadcastCompletedAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_id_tab
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab_at = None
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab_id = u'id'
    __BroadcastCompletedAreaList_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab_id = u'criticality'
    __BroadcastCompletedAreaList_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___BroadcastCompletedAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_value_tab
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab_at = ('..', u'id')
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab_id = u'Value'
    _BroadcastCompletedAreaList_choice_Extensions._cont = ASN1Dict([
        (u'id', __BroadcastCompletedAreaList_choice_Extensions_id),
        (u'criticality', __BroadcastCompletedAreaList_choice_Extensions_criticality),
        (u'value', __BroadcastCompletedAreaList_choice_Extensions_value),
        ])
    _BroadcastCompletedAreaList_choice_Extensions._ext = None
    BroadcastCompletedAreaList._cont = ASN1Dict([
        (u'cellIDBroadcastEUTRA', _BroadcastCompletedAreaList_cellIDBroadcastEUTRA),
        (u'tAIBroadcastEUTRA', _BroadcastCompletedAreaList_tAIBroadcastEUTRA),
        (u'emergencyAreaIDBroadcastEUTRA', _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA),
        (u'cellIDBroadcastNR', _BroadcastCompletedAreaList_cellIDBroadcastNR),
        (u'tAIBroadcastNR', _BroadcastCompletedAreaList_tAIBroadcastNR),
        (u'emergencyAreaIDBroadcastNR', _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR),
        (u'choice-Extensions', _BroadcastCompletedAreaList_choice_Extensions),
        ])
    BroadcastCompletedAreaList._ext = None
    
    #-----< BroadcastCompletedAreaList-ExtIEs >-----#
    BroadcastCompletedAreaList_ExtIEs = CLASS(name=u'BroadcastCompletedAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    BroadcastCompletedAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastPLMNList >-----#
    BroadcastPLMNList = SEQ_OF(name=u'BroadcastPLMNList', mode=MODE_TYPE)
    _BroadcastPLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastPLMNItem')))
    BroadcastPLMNList._cont = _BroadcastPLMNList__item_
    BroadcastPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastPLMNItem >-----#
    BroadcastPLMNItem = SEQ(name=u'BroadcastPLMNItem', mode=MODE_TYPE)
    _BroadcastPLMNItem_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _BroadcastPLMNItem_tAISliceSupportList = SEQ_OF(name=u'tAISliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportList')))
    _BroadcastPLMNItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastPLMNItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BroadcastPLMNItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BroadcastPLMNItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    ____BroadcastPLMNItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Extension', _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'reject'), (u'Extension', _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___BroadcastPLMNItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BroadcastPLMNItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BroadcastPLMNItem_iE_Extensions__item__id),
        (u'criticality', ___BroadcastPLMNItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___BroadcastPLMNItem_iE_Extensions__item__extensionValue),
        ])
    __BroadcastPLMNItem_iE_Extensions__item_._ext = None
    _BroadcastPLMNItem_iE_Extensions._cont = __BroadcastPLMNItem_iE_Extensions__item_
    _BroadcastPLMNItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastPLMNItem._cont = ASN1Dict([
        (u'pLMNIdentity', _BroadcastPLMNItem_pLMNIdentity),
        (u'tAISliceSupportList', _BroadcastPLMNItem_tAISliceSupportList),
        (u'iE-Extensions', _BroadcastPLMNItem_iE_Extensions),
        ])
    BroadcastPLMNItem._ext = []
    
    #-----< BroadcastPLMNItem-ExtIEs >-----#
    BroadcastPLMNItem_ExtIEs = CLASS(name=u'BroadcastPLMNItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _BroadcastPLMNItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _BroadcastPLMNItem_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    BroadcastPLMNItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Extension', _BroadcastPLMNItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'reject'), (u'Extension', _BroadcastPLMNItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasurementConfiguration >-----#
    BluetoothMeasurementConfiguration = SEQ(name=u'BluetoothMeasurementConfiguration', mode=MODE_TYPE)
    _BluetoothMeasurementConfiguration_bluetoothMeasConfig = ENUM(name=u'bluetoothMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfig')))
    _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList = SEQ_OF(name=u'bluetoothMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfigNameList')), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi = ENUM(name=u'bt-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi._cont = ASN1Dict([(u'true', 0)])
    _BluetoothMeasurementConfiguration_bt_rssi._ext = []
    _BluetoothMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BluetoothMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._ext = None
    _BluetoothMeasurementConfiguration_iE_Extensions._cont = __BluetoothMeasurementConfiguration_iE_Extensions__item_
    _BluetoothMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasurementConfiguration._cont = ASN1Dict([
        (u'bluetoothMeasConfig', _BluetoothMeasurementConfiguration_bluetoothMeasConfig),
        (u'bluetoothMeasConfigNameList', _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList),
        (u'bt-rssi', _BluetoothMeasurementConfiguration_bt_rssi),
        (u'iE-Extensions', _BluetoothMeasurementConfiguration_iE_Extensions),
        ])
    BluetoothMeasurementConfiguration._ext = []
    
    #-----< BluetoothMeasurementConfiguration-ExtIEs >-----#
    BluetoothMeasurementConfiguration_ExtIEs = CLASS(name=u'BluetoothMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BluetoothMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfigNameList >-----#
    BluetoothMeasConfigNameList = SEQ_OF(name=u'BluetoothMeasConfigNameList', mode=MODE_TYPE)
    _BluetoothMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfigNameItem')))
    BluetoothMeasConfigNameList._cont = _BluetoothMeasConfigNameList__item_
    BluetoothMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BluetoothMeasConfigNameItem >-----#
    BluetoothMeasConfigNameItem = SEQ(name=u'BluetoothMeasConfigNameItem', mode=MODE_TYPE)
    _BluetoothMeasConfigNameItem_bluetoothName = OCT_STR(name=u'bluetoothName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothName')))
    _BluetoothMeasConfigNameItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BluetoothMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BluetoothMeasConfigNameItem_iE_Extensions__item__id),
        (u'criticality', ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasConfigNameItem_iE_Extensions__item_._ext = None
    _BluetoothMeasConfigNameItem_iE_Extensions._cont = __BluetoothMeasConfigNameItem_iE_Extensions__item_
    _BluetoothMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasConfigNameItem._cont = ASN1Dict([
        (u'bluetoothName', _BluetoothMeasConfigNameItem_bluetoothName),
        (u'iE-Extensions', _BluetoothMeasConfigNameItem_iE_Extensions),
        ])
    BluetoothMeasConfigNameItem._ext = []
    
    #-----< BluetoothMeasConfigNameItem-ExtIEs >-----#
    BluetoothMeasConfigNameItem_ExtIEs = CLASS(name=u'BluetoothMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BluetoothMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfig >-----#
    BluetoothMeasConfig = ENUM(name=u'BluetoothMeasConfig', mode=MODE_TYPE)
    BluetoothMeasConfig._cont = ASN1Dict([(u'setup', 0)])
    BluetoothMeasConfig._ext = []
    
    #-----< BluetoothName >-----#
    BluetoothName = OCT_STR(name=u'BluetoothName', mode=MODE_TYPE)
    BluetoothName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< BurstArrivalTime >-----#
    BurstArrivalTime = OCT_STR(name=u'BurstArrivalTime', mode=MODE_TYPE)
    
    #-----< CAG-ID >-----#
    CAG_ID = BIT_STR(name=u'CAG-ID', mode=MODE_TYPE)
    CAG_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CancelAllWarningMessages >-----#
    CancelAllWarningMessages = ENUM(name=u'CancelAllWarningMessages', mode=MODE_TYPE)
    CancelAllWarningMessages._cont = ASN1Dict([(u'true', 0)])
    CancelAllWarningMessages._ext = []
    
    #-----< CancelledCellsInEAI-EUTRA >-----#
    CancelledCellsInEAI_EUTRA = SEQ_OF(name=u'CancelledCellsInEAI-EUTRA', mode=MODE_TYPE)
    _CancelledCellsInEAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-EUTRA-Item')))
    CancelledCellsInEAI_EUTRA._cont = _CancelledCellsInEAI_EUTRA__item_
    CancelledCellsInEAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInEAI-EUTRA-Item >-----#
    CancelledCellsInEAI_EUTRA_Item = SEQ(name=u'CancelledCellsInEAI-EUTRA-Item', mode=MODE_TYPE)
    _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions._cont = __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInEAI_EUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI),
        (u'numberOfBroadcasts', _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellsInEAI_EUTRA_Item_iE_Extensions),
        ])
    CancelledCellsInEAI_EUTRA_Item._ext = []
    
    #-----< CancelledCellsInEAI-EUTRA-Item-ExtIEs >-----#
    CancelledCellsInEAI_EUTRA_Item_ExtIEs = CLASS(name=u'CancelledCellsInEAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInEAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInEAI-NR >-----#
    CancelledCellsInEAI_NR = SEQ_OF(name=u'CancelledCellsInEAI-NR', mode=MODE_TYPE)
    _CancelledCellsInEAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-NR-Item')))
    CancelledCellsInEAI_NR._cont = _CancelledCellsInEAI_NR__item_
    CancelledCellsInEAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInEAI-NR-Item >-----#
    CancelledCellsInEAI_NR_Item = SEQ(name=u'CancelledCellsInEAI-NR-Item', mode=MODE_TYPE)
    _CancelledCellsInEAI_NR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CancelledCellsInEAI_NR_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInEAI_NR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInEAI_NR_Item_iE_Extensions._cont = __CancelledCellsInEAI_NR_Item_iE_Extensions__item_
    _CancelledCellsInEAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInEAI_NR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CancelledCellsInEAI_NR_Item_nR_CGI),
        (u'numberOfBroadcasts', _CancelledCellsInEAI_NR_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellsInEAI_NR_Item_iE_Extensions),
        ])
    CancelledCellsInEAI_NR_Item._ext = []
    
    #-----< CancelledCellsInEAI-NR-Item-ExtIEs >-----#
    CancelledCellsInEAI_NR_Item_ExtIEs = CLASS(name=u'CancelledCellsInEAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInEAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInTAI-EUTRA >-----#
    CancelledCellsInTAI_EUTRA = SEQ_OF(name=u'CancelledCellsInTAI-EUTRA', mode=MODE_TYPE)
    _CancelledCellsInTAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-EUTRA-Item')))
    CancelledCellsInTAI_EUTRA._cont = _CancelledCellsInTAI_EUTRA__item_
    CancelledCellsInTAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInTAI-EUTRA-Item >-----#
    CancelledCellsInTAI_EUTRA_Item = SEQ(name=u'CancelledCellsInTAI-EUTRA-Item', mode=MODE_TYPE)
    _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions._cont = __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInTAI_EUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI),
        (u'numberOfBroadcasts', _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellsInTAI_EUTRA_Item_iE_Extensions),
        ])
    CancelledCellsInTAI_EUTRA_Item._ext = []
    
    #-----< CancelledCellsInTAI-EUTRA-Item-ExtIEs >-----#
    CancelledCellsInTAI_EUTRA_Item_ExtIEs = CLASS(name=u'CancelledCellsInTAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInTAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInTAI-NR >-----#
    CancelledCellsInTAI_NR = SEQ_OF(name=u'CancelledCellsInTAI-NR', mode=MODE_TYPE)
    _CancelledCellsInTAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-NR-Item')))
    CancelledCellsInTAI_NR._cont = _CancelledCellsInTAI_NR__item_
    CancelledCellsInTAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInTAI-NR-Item >-----#
    CancelledCellsInTAI_NR_Item = SEQ(name=u'CancelledCellsInTAI-NR-Item', mode=MODE_TYPE)
    _CancelledCellsInTAI_NR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CancelledCellsInTAI_NR_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInTAI_NR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInTAI_NR_Item_iE_Extensions._cont = __CancelledCellsInTAI_NR_Item_iE_Extensions__item_
    _CancelledCellsInTAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInTAI_NR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CancelledCellsInTAI_NR_Item_nR_CGI),
        (u'numberOfBroadcasts', _CancelledCellsInTAI_NR_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellsInTAI_NR_Item_iE_Extensions),
        ])
    CancelledCellsInTAI_NR_Item._ext = []
    
    #-----< CancelledCellsInTAI-NR-Item-ExtIEs >-----#
    CancelledCellsInTAI_NR_Item_ExtIEs = CLASS(name=u'CancelledCellsInTAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInTAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCellList >-----#
    CandidateCellList = SEQ_OF(name=u'CandidateCellList', mode=MODE_TYPE)
    _CandidateCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellItem')))
    CandidateCellList._cont = _CandidateCellList__item_
    CandidateCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CandidateCellItem >-----#
    CandidateCellItem = SEQ(name=u'CandidateCellItem', mode=MODE_TYPE)
    _CandidateCellItem_candidateCell = CHOICE(name=u'candidateCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCell')))
    _CandidateCellItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidateCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidateCellItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CandidateCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__id._const_tab = ____CandidateCellItem_iE_Extensions__item__id_tab
    ___CandidateCellItem_iE_Extensions__item__id._const_tab_at = None
    ___CandidateCellItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___CandidateCellItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CandidateCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab = ____CandidateCellItem_iE_Extensions__item__criticality_tab
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CandidateCellItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CandidateCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab = ____CandidateCellItem_iE_Extensions__item__extensionValue_tab
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CandidateCellItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CandidateCellItem_iE_Extensions__item__id),
        (u'criticality', ___CandidateCellItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___CandidateCellItem_iE_Extensions__item__extensionValue),
        ])
    __CandidateCellItem_iE_Extensions__item_._ext = None
    _CandidateCellItem_iE_Extensions._cont = __CandidateCellItem_iE_Extensions__item_
    _CandidateCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidateCellItem._cont = ASN1Dict([
        (u'candidateCell', _CandidateCellItem_candidateCell),
        (u'iE-Extensions', _CandidateCellItem_iE_Extensions),
        ])
    CandidateCellItem._ext = []
    
    #-----< CandidateCellItem-ExtIEs >-----#
    CandidateCellItem_ExtIEs = CLASS(name=u'CandidateCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidateCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCell >-----#
    CandidateCell = CHOICE(name=u'CandidateCell', mode=MODE_TYPE)
    _CandidateCell_candidateCGI = SEQ(name=u'candidateCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellID')))
    _CandidateCell_candidatePCI = SEQ(name=u'candidatePCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidatePCI')))
    _CandidateCell_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CandidateCell_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___CandidateCell_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_id._const_tab = ___CandidateCell_choice_Extensions_id_tab
    __CandidateCell_choice_Extensions_id._const_tab_at = None
    __CandidateCell_choice_Extensions_id._const_tab_id = u'id'
    __CandidateCell_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___CandidateCell_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_criticality._const_tab = ___CandidateCell_choice_Extensions_criticality_tab
    __CandidateCell_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __CandidateCell_choice_Extensions_criticality._const_tab_id = u'criticality'
    __CandidateCell_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___CandidateCell_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_value._const_tab = ___CandidateCell_choice_Extensions_value_tab
    __CandidateCell_choice_Extensions_value._const_tab_at = ('..', u'id')
    __CandidateCell_choice_Extensions_value._const_tab_id = u'Value'
    _CandidateCell_choice_Extensions._cont = ASN1Dict([
        (u'id', __CandidateCell_choice_Extensions_id),
        (u'criticality', __CandidateCell_choice_Extensions_criticality),
        (u'value', __CandidateCell_choice_Extensions_value),
        ])
    _CandidateCell_choice_Extensions._ext = None
    CandidateCell._cont = ASN1Dict([
        (u'candidateCGI', _CandidateCell_candidateCGI),
        (u'candidatePCI', _CandidateCell_candidatePCI),
        (u'choice-Extensions', _CandidateCell_choice_Extensions),
        ])
    CandidateCell._ext = None
    
    #-----< CandidateCell-ExtIEs >-----#
    CandidateCell_ExtIEs = CLASS(name=u'CandidateCell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    CandidateCell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCellID >-----#
    CandidateCellID = SEQ(name=u'CandidateCellID', mode=MODE_TYPE)
    _CandidateCellID_candidateCellID = SEQ(name=u'candidateCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CandidateCellID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidateCellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidateCellID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CandidateCellID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__id._const_tab = ____CandidateCellID_iE_Extensions__item__id_tab
    ___CandidateCellID_iE_Extensions__item__id._const_tab_at = None
    ___CandidateCellID_iE_Extensions__item__id._const_tab_id = u'id'
    ___CandidateCellID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CandidateCellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab = ____CandidateCellID_iE_Extensions__item__criticality_tab
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CandidateCellID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CandidateCellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab = ____CandidateCellID_iE_Extensions__item__extensionValue_tab
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CandidateCellID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CandidateCellID_iE_Extensions__item__id),
        (u'criticality', ___CandidateCellID_iE_Extensions__item__criticality),
        (u'extensionValue', ___CandidateCellID_iE_Extensions__item__extensionValue),
        ])
    __CandidateCellID_iE_Extensions__item_._ext = None
    _CandidateCellID_iE_Extensions._cont = __CandidateCellID_iE_Extensions__item_
    _CandidateCellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidateCellID._cont = ASN1Dict([
        (u'candidateCellID', _CandidateCellID_candidateCellID),
        (u'iE-Extensions', _CandidateCellID_iE_Extensions),
        ])
    CandidateCellID._ext = []
    
    #-----< CandidateCellID-ExtIEs >-----#
    CandidateCellID_ExtIEs = CLASS(name=u'CandidateCellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidateCellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidatePCI >-----#
    CandidatePCI = SEQ(name=u'CandidatePCI', mode=MODE_TYPE)
    _CandidatePCI_candidatePCI = INT(name=u'candidatePCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_candidatePCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=[], er=[])
    _CandidatePCI_candidateNRARFCN = INT(name=u'candidateNRARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_candidateNRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _CandidatePCI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidatePCI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidatePCI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CandidatePCI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__id._const_tab = ____CandidatePCI_iE_Extensions__item__id_tab
    ___CandidatePCI_iE_Extensions__item__id._const_tab_at = None
    ___CandidatePCI_iE_Extensions__item__id._const_tab_id = u'id'
    ___CandidatePCI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CandidatePCI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab = ____CandidatePCI_iE_Extensions__item__criticality_tab
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CandidatePCI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CandidatePCI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab = ____CandidatePCI_iE_Extensions__item__extensionValue_tab
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CandidatePCI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CandidatePCI_iE_Extensions__item__id),
        (u'criticality', ___CandidatePCI_iE_Extensions__item__criticality),
        (u'extensionValue', ___CandidatePCI_iE_Extensions__item__extensionValue),
        ])
    __CandidatePCI_iE_Extensions__item_._ext = None
    _CandidatePCI_iE_Extensions._cont = __CandidatePCI_iE_Extensions__item_
    _CandidatePCI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidatePCI._cont = ASN1Dict([
        (u'candidatePCI', _CandidatePCI_candidatePCI),
        (u'candidateNRARFCN', _CandidatePCI_candidateNRARFCN),
        (u'iE-Extensions', _CandidatePCI_iE_Extensions),
        ])
    CandidatePCI._ext = []
    
    #-----< CandidatePCI-ExtIEs >-----#
    CandidatePCI_ExtIEs = CLASS(name=u'CandidatePCI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidatePCI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseTransport')))
    _Cause_nas = ENUM(name=u'nas', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseNas')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseMisc')))
    _Cause_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __Cause_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___Cause_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_id._const_tab = ___Cause_choice_Extensions_id_tab
    __Cause_choice_Extensions_id._const_tab_at = None
    __Cause_choice_Extensions_id._const_tab_id = u'id'
    __Cause_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___Cause_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_criticality._const_tab = ___Cause_choice_Extensions_criticality_tab
    __Cause_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __Cause_choice_Extensions_criticality._const_tab_id = u'criticality'
    __Cause_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___Cause_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_value._const_tab = ___Cause_choice_Extensions_value_tab
    __Cause_choice_Extensions_value._const_tab_at = ('..', u'id')
    __Cause_choice_Extensions_value._const_tab_id = u'Value'
    _Cause_choice_Extensions._cont = ASN1Dict([
        (u'id', __Cause_choice_Extensions_id),
        (u'criticality', __Cause_choice_Extensions_criticality),
        (u'value', __Cause_choice_Extensions_value),
        ])
    _Cause_choice_Extensions._ext = None
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'nas', _Cause_nas),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        (u'choice-Extensions', _Cause_choice_Extensions),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtIEs >-----#
    Cause_ExtIEs = CLASS(name=u'Cause-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    Cause_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'not-enough-user-plane-processing-resources', 1), (u'hardware-failure', 2), (u'om-intervention', 3), (u'unknown-PLMN-or-SNPN', 4), (u'unspecified', 5)])
    CauseMisc._ext = []
    
    #-----< CauseNas >-----#
    CauseNas = ENUM(name=u'CauseNas', mode=MODE_TYPE)
    CauseNas._cont = ASN1Dict([(u'normal-release', 0), (u'authentication-failure', 1), (u'deregister', 2), (u'unspecified', 3)])
    CauseNas._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'abstract-syntax-error-falsely-constructed-message', 5), (u'unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unspecified', 0), (u'txnrelocoverall-expiry', 1), (u'successful-handover', 2), (u'release-due-to-ngran-generated-reason', 3), (u'release-due-to-5gc-generated-reason', 4), (u'handover-cancelled', 5), (u'partial-handover', 6), (u'ho-failure-in-target-5GC-ngran-node-or-target-system', 7), (u'ho-target-not-allowed', 8), (u'tngrelocoverall-expiry', 9), (u'tngrelocprep-expiry', 10), (u'cell-not-available', 11), (u'unknown-targetID', 12), (u'no-radio-resources-available-in-target-cell', 13), (u'unknown-local-UE-NGAP-ID', 14), (u'inconsistent-remote-UE-NGAP-ID', 15), (u'handover-desirable-for-radio-reason', 16), (u'time-critical-handover', 17), (u'resource-optimisation-handover', 18), (u'reduce-load-in-serving-cell', 19), (u'user-inactivity', 20), (u'radio-connection-with-ue-lost', 21), (u'radio-resources-not-available', 22), (u'invalid-qos-combination', 23), (u'failure-in-radio-interface-procedure', 24), (u'interaction-with-other-procedure', 25), (u'unknown-PDU-session-ID', 26), (u'unkown-qos-flow-ID', 27), (u'multiple-PDU-session-ID-instances', 28), (u'multiple-qos-flow-ID-instances', 29), (u'encryption-and-or-integrity-protection-algorithms-not-supported', 30), (u'ng-intra-system-handover-triggered', 31), (u'ng-inter-system-handover-triggered', 32), (u'xn-handover-triggered', 33), (u'not-supported-5QI-value', 34), (u'ue-context-transfer', 35), (u'ims-voice-eps-fallback-or-rat-fallback-triggered', 36), (u'up-integrity-protection-not-possible', 37), (u'up-confidentiality-protection-not-possible', 38), (u'slice-not-supported', 39), (u'ue-in-rrc-inactive-state-not-reachable', 40), (u'redirection', 41), (u'resources-not-available-for-the-slice', 42), (u'ue-max-integrity-protected-data-rate-reason', 43), (u'release-due-to-cn-detected-mobility', 44), (u'n26-interface-not-available', 45), (u'release-due-to-pre-emption', 46), (u'multiple-location-reporting-reference-ID-instances', 47), (u'rsn-not-available-for-the-up', 48), (u'npn-access-denied', 49), (u'cag-only-access-denied', 50), (u'insufficient-ue-capabilities', 51)])
    CauseRadioNetwork._ext = [u'n26-interface-not-available', u'release-due-to-pre-emption', u'multiple-location-reporting-reference-ID-instances', u'rsn-not-available-for-the-up', u'npn-access-denied', u'cag-only-access-denied', u'insufficient-ue-capabilities']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'transport-resource-unavailable', 0), (u'unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< Cell-CAGInformation >-----#
    Cell_CAGInformation = SEQ(name=u'Cell-CAGInformation', mode=MODE_TYPE)
    _Cell_CAGInformation_nGRAN_CGI = CHOICE(name=u'nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _Cell_CAGInformation_cellCAGList = SEQ_OF(name=u'cellCAGList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellCAGList')))
    _Cell_CAGInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CAGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CAGInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_CAGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab = ____Cell_CAGInformation_iE_Extensions__item__id_tab
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_CAGInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_CAGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab = ____Cell_CAGInformation_iE_Extensions__item__criticality_tab
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab = ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_CAGInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_CAGInformation_iE_Extensions__item__id),
        (u'criticality', ___Cell_CAGInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_CAGInformation_iE_Extensions__item__extensionValue),
        ])
    __Cell_CAGInformation_iE_Extensions__item_._ext = None
    _Cell_CAGInformation_iE_Extensions._cont = __Cell_CAGInformation_iE_Extensions__item_
    _Cell_CAGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CAGInformation._cont = ASN1Dict([
        (u'nGRAN-CGI', _Cell_CAGInformation_nGRAN_CGI),
        (u'cellCAGList', _Cell_CAGInformation_cellCAGList),
        (u'iE-Extensions', _Cell_CAGInformation_iE_Extensions),
        ])
    Cell_CAGInformation._ext = []
    
    #-----< Cell-CAGInformation-ExtIEs >-----#
    Cell_CAGInformation_ExtIEs = CLASS(name=u'Cell-CAGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Cell_CAGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellCAGList >-----#
    CellCAGList = SEQ_OF(name=u'CellCAGList', mode=MODE_TYPE)
    _CellCAGList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CAG-ID')))
    CellCAGList._cont = _CellCAGList__item_
    CellCAGList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CellIDBroadcastEUTRA >-----#
    CellIDBroadcastEUTRA = SEQ_OF(name=u'CellIDBroadcastEUTRA', mode=MODE_TYPE)
    _CellIDBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastEUTRA-Item')))
    CellIDBroadcastEUTRA._cont = _CellIDBroadcastEUTRA__item_
    CellIDBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDBroadcastEUTRA-Item >-----#
    CellIDBroadcastEUTRA_Item = SEQ(name=u'CellIDBroadcastEUTRA-Item', mode=MODE_TYPE)
    _CellIDBroadcastEUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CellIDBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _CellIDBroadcastEUTRA_Item_iE_Extensions._cont = __CellIDBroadcastEUTRA_Item_iE_Extensions__item_
    _CellIDBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDBroadcastEUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CellIDBroadcastEUTRA_Item_eUTRA_CGI),
        (u'iE-Extensions', _CellIDBroadcastEUTRA_Item_iE_Extensions),
        ])
    CellIDBroadcastEUTRA_Item._ext = []
    
    #-----< CellIDBroadcastEUTRA-Item-ExtIEs >-----#
    CellIDBroadcastEUTRA_Item_ExtIEs = CLASS(name=u'CellIDBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDBroadcastNR >-----#
    CellIDBroadcastNR = SEQ_OF(name=u'CellIDBroadcastNR', mode=MODE_TYPE)
    _CellIDBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastNR-Item')))
    CellIDBroadcastNR._cont = _CellIDBroadcastNR__item_
    CellIDBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDBroadcastNR-Item >-----#
    CellIDBroadcastNR_Item = SEQ(name=u'CellIDBroadcastNR-Item', mode=MODE_TYPE)
    _CellIDBroadcastNR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CellIDBroadcastNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellIDBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellIDBroadcastNR_Item_iE_Extensions__item__id),
        (u'criticality', ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDBroadcastNR_Item_iE_Extensions__item_._ext = None
    _CellIDBroadcastNR_Item_iE_Extensions._cont = __CellIDBroadcastNR_Item_iE_Extensions__item_
    _CellIDBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDBroadcastNR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CellIDBroadcastNR_Item_nR_CGI),
        (u'iE-Extensions', _CellIDBroadcastNR_Item_iE_Extensions),
        ])
    CellIDBroadcastNR_Item._ext = []
    
    #-----< CellIDBroadcastNR-Item-ExtIEs >-----#
    CellIDBroadcastNR_Item_ExtIEs = CLASS(name=u'CellIDBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDCancelledEUTRA >-----#
    CellIDCancelledEUTRA = SEQ_OF(name=u'CellIDCancelledEUTRA', mode=MODE_TYPE)
    _CellIDCancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledEUTRA-Item')))
    CellIDCancelledEUTRA._cont = _CellIDCancelledEUTRA__item_
    CellIDCancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDCancelledEUTRA-Item >-----#
    CellIDCancelledEUTRA_Item = SEQ(name=u'CellIDCancelledEUTRA-Item', mode=MODE_TYPE)
    _CellIDCancelledEUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CellIDCancelledEUTRA_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CellIDCancelledEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _CellIDCancelledEUTRA_Item_iE_Extensions._cont = __CellIDCancelledEUTRA_Item_iE_Extensions__item_
    _CellIDCancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDCancelledEUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CellIDCancelledEUTRA_Item_eUTRA_CGI),
        (u'numberOfBroadcasts', _CellIDCancelledEUTRA_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CellIDCancelledEUTRA_Item_iE_Extensions),
        ])
    CellIDCancelledEUTRA_Item._ext = []
    
    #-----< CellIDCancelledEUTRA-Item-ExtIEs >-----#
    CellIDCancelledEUTRA_Item_ExtIEs = CLASS(name=u'CellIDCancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDCancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDCancelledNR >-----#
    CellIDCancelledNR = SEQ_OF(name=u'CellIDCancelledNR', mode=MODE_TYPE)
    _CellIDCancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledNR-Item')))
    CellIDCancelledNR._cont = _CellIDCancelledNR__item_
    CellIDCancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDCancelledNR-Item >-----#
    CellIDCancelledNR_Item = SEQ(name=u'CellIDCancelledNR-Item', mode=MODE_TYPE)
    _CellIDCancelledNR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CellIDCancelledNR_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CellIDCancelledNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDCancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDCancelledNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellIDCancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellIDCancelledNR_Item_iE_Extensions__item__id),
        (u'criticality', ___CellIDCancelledNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDCancelledNR_Item_iE_Extensions__item_._ext = None
    _CellIDCancelledNR_Item_iE_Extensions._cont = __CellIDCancelledNR_Item_iE_Extensions__item_
    _CellIDCancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDCancelledNR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CellIDCancelledNR_Item_nR_CGI),
        (u'numberOfBroadcasts', _CellIDCancelledNR_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CellIDCancelledNR_Item_iE_Extensions),
        ])
    CellIDCancelledNR_Item._ext = []
    
    #-----< CellIDCancelledNR-Item-ExtIEs >-----#
    CellIDCancelledNR_Item_ExtIEs = CLASS(name=u'CellIDCancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDCancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDListForRestart >-----#
    CellIDListForRestart = CHOICE(name=u'CellIDListForRestart', mode=MODE_TYPE)
    _CellIDListForRestart_eUTRA_CGIListforRestart = SEQ_OF(name=u'eUTRA-CGIListforRestart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIList')))
    _CellIDListForRestart_nR_CGIListforRestart = SEQ_OF(name=u'nR-CGIListforRestart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIList')))
    _CellIDListForRestart_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CellIDListForRestart_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___CellIDListForRestart_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_id._const_tab = ___CellIDListForRestart_choice_Extensions_id_tab
    __CellIDListForRestart_choice_Extensions_id._const_tab_at = None
    __CellIDListForRestart_choice_Extensions_id._const_tab_id = u'id'
    __CellIDListForRestart_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___CellIDListForRestart_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_criticality._const_tab = ___CellIDListForRestart_choice_Extensions_criticality_tab
    __CellIDListForRestart_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __CellIDListForRestart_choice_Extensions_criticality._const_tab_id = u'criticality'
    __CellIDListForRestart_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___CellIDListForRestart_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_value._const_tab = ___CellIDListForRestart_choice_Extensions_value_tab
    __CellIDListForRestart_choice_Extensions_value._const_tab_at = ('..', u'id')
    __CellIDListForRestart_choice_Extensions_value._const_tab_id = u'Value'
    _CellIDListForRestart_choice_Extensions._cont = ASN1Dict([
        (u'id', __CellIDListForRestart_choice_Extensions_id),
        (u'criticality', __CellIDListForRestart_choice_Extensions_criticality),
        (u'value', __CellIDListForRestart_choice_Extensions_value),
        ])
    _CellIDListForRestart_choice_Extensions._ext = None
    CellIDListForRestart._cont = ASN1Dict([
        (u'eUTRA-CGIListforRestart', _CellIDListForRestart_eUTRA_CGIListforRestart),
        (u'nR-CGIListforRestart', _CellIDListForRestart_nR_CGIListforRestart),
        (u'choice-Extensions', _CellIDListForRestart_choice_Extensions),
        ])
    CellIDListForRestart._ext = None
    
    #-----< CellIDListForRestart-ExtIEs >-----#
    CellIDListForRestart_ExtIEs = CLASS(name=u'CellIDListForRestart-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    CellIDListForRestart_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSize >-----#
    CellSize = ENUM(name=u'CellSize', mode=MODE_TYPE)
    CellSize._cont = ASN1Dict([(u'verysmall', 0), (u'small', 1), (u'medium', 2), (u'large', 3)])
    CellSize._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name=u'CellType', mode=MODE_TYPE)
    _CellType_cellSize = ENUM(name=u'cellSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellSize')))
    _CellType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellType_iE_Extensions__item__id),
        (u'criticality', ___CellType_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        (u'cellSize', _CellType_cellSize),
        (u'iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name=u'CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CEmodeBSupport-Indicator >-----#
    CEmodeBSupport_Indicator = ENUM(name=u'CEmodeBSupport-Indicator', mode=MODE_TYPE)
    CEmodeBSupport_Indicator._cont = ASN1Dict([(u'supported', 0)])
    CEmodeBSupport_Indicator._ext = []
    
    #-----< CEmodeBrestricted >-----#
    CEmodeBrestricted = ENUM(name=u'CEmodeBrestricted', mode=MODE_TYPE)
    CEmodeBrestricted._cont = ASN1Dict([(u'restricted', 0), (u'not-restricted', 1)])
    CEmodeBrestricted._ext = []
    
    #-----< CNAssistedRANTuning >-----#
    CNAssistedRANTuning = SEQ(name=u'CNAssistedRANTuning', mode=MODE_TYPE)
    _CNAssistedRANTuning_expectedUEBehaviour = SEQ(name=u'expectedUEBehaviour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEBehaviour')), opt=True)
    _CNAssistedRANTuning_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNAssistedRANTuning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CNAssistedRANTuning_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CNAssistedRANTuning_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__id_tab
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab_at = None
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab_id = u'id'
    ___CNAssistedRANTuning_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CNAssistedRANTuning_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CNAssistedRANTuning_iE_Extensions__item__id),
        (u'criticality', ___CNAssistedRANTuning_iE_Extensions__item__criticality),
        (u'extensionValue', ___CNAssistedRANTuning_iE_Extensions__item__extensionValue),
        ])
    __CNAssistedRANTuning_iE_Extensions__item_._ext = None
    _CNAssistedRANTuning_iE_Extensions._cont = __CNAssistedRANTuning_iE_Extensions__item_
    _CNAssistedRANTuning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNAssistedRANTuning._cont = ASN1Dict([
        (u'expectedUEBehaviour', _CNAssistedRANTuning_expectedUEBehaviour),
        (u'iE-Extensions', _CNAssistedRANTuning_iE_Extensions),
        ])
    CNAssistedRANTuning._ext = []
    
    #-----< CNAssistedRANTuning-ExtIEs >-----#
    CNAssistedRANTuning_ExtIEs = CLASS(name=u'CNAssistedRANTuning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CNAssistedRANTuning_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNTypeRestrictionsForEquivalent >-----#
    CNTypeRestrictionsForEquivalent = SEQ_OF(name=u'CNTypeRestrictionsForEquivalent', mode=MODE_TYPE)
    _CNTypeRestrictionsForEquivalent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalentItem')))
    CNTypeRestrictionsForEquivalent._cont = _CNTypeRestrictionsForEquivalent__item_
    CNTypeRestrictionsForEquivalent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< CNTypeRestrictionsForEquivalentItem >-----#
    CNTypeRestrictionsForEquivalentItem = SEQ(name=u'CNTypeRestrictionsForEquivalentItem', mode=MODE_TYPE)
    _CNTypeRestrictionsForEquivalentItem_plmnIdentity = OCT_STR(name=u'plmnIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _CNTypeRestrictionsForEquivalentItem_cn_Type = ENUM(name=u'cn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNTypeRestrictionsForEquivalentItem_cn_Type._cont = ASN1Dict([(u'epc-forbidden', 0), (u'fiveGC-forbidden', 1)])
    _CNTypeRestrictionsForEquivalentItem_cn_Type._ext = []
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab_at = None
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id),
        (u'criticality', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue),
        ])
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_._ext = None
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions._cont = __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNTypeRestrictionsForEquivalentItem._cont = ASN1Dict([
        (u'plmnIdentity', _CNTypeRestrictionsForEquivalentItem_plmnIdentity),
        (u'cn-Type', _CNTypeRestrictionsForEquivalentItem_cn_Type),
        (u'iE-Extensions', _CNTypeRestrictionsForEquivalentItem_iE_Extensions),
        ])
    CNTypeRestrictionsForEquivalentItem._ext = []
    
    #-----< CNTypeRestrictionsForEquivalentItem-ExtIEs >-----#
    CNTypeRestrictionsForEquivalentItem_ExtIEs = CLASS(name=u'CNTypeRestrictionsForEquivalentItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CNTypeRestrictionsForEquivalentItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNTypeRestrictionsForServing >-----#
    CNTypeRestrictionsForServing = ENUM(name=u'CNTypeRestrictionsForServing', mode=MODE_TYPE)
    CNTypeRestrictionsForServing._cont = ASN1Dict([(u'epc-forbidden', 0)])
    CNTypeRestrictionsForServing._ext = []
    
    #-----< CommonNetworkInstance >-----#
    CommonNetworkInstance = OCT_STR(name=u'CommonNetworkInstance', mode=MODE_TYPE)
    
    #-----< CompletedCellsInEAI-EUTRA >-----#
    CompletedCellsInEAI_EUTRA = SEQ_OF(name=u'CompletedCellsInEAI-EUTRA', mode=MODE_TYPE)
    _CompletedCellsInEAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-EUTRA-Item')))
    CompletedCellsInEAI_EUTRA._cont = _CompletedCellsInEAI_EUTRA__item_
    CompletedCellsInEAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInEAI-EUTRA-Item >-----#
    CompletedCellsInEAI_EUTRA_Item = SEQ(name=u'CompletedCellsInEAI-EUTRA-Item', mode=MODE_TYPE)
    _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions._cont = __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInEAI_EUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI),
        (u'iE-Extensions', _CompletedCellsInEAI_EUTRA_Item_iE_Extensions),
        ])
    CompletedCellsInEAI_EUTRA_Item._ext = []
    
    #-----< CompletedCellsInEAI-EUTRA-Item-ExtIEs >-----#
    CompletedCellsInEAI_EUTRA_Item_ExtIEs = CLASS(name=u'CompletedCellsInEAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInEAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInEAI-NR >-----#
    CompletedCellsInEAI_NR = SEQ_OF(name=u'CompletedCellsInEAI-NR', mode=MODE_TYPE)
    _CompletedCellsInEAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-NR-Item')))
    CompletedCellsInEAI_NR._cont = _CompletedCellsInEAI_NR__item_
    CompletedCellsInEAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInEAI-NR-Item >-----#
    CompletedCellsInEAI_NR_Item = SEQ(name=u'CompletedCellsInEAI-NR-Item', mode=MODE_TYPE)
    _CompletedCellsInEAI_NR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CompletedCellsInEAI_NR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInEAI_NR_Item_iE_Extensions._cont = __CompletedCellsInEAI_NR_Item_iE_Extensions__item_
    _CompletedCellsInEAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInEAI_NR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CompletedCellsInEAI_NR_Item_nR_CGI),
        (u'iE-Extensions', _CompletedCellsInEAI_NR_Item_iE_Extensions),
        ])
    CompletedCellsInEAI_NR_Item._ext = []
    
    #-----< CompletedCellsInEAI-NR-Item-ExtIEs >-----#
    CompletedCellsInEAI_NR_Item_ExtIEs = CLASS(name=u'CompletedCellsInEAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInEAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInTAI-EUTRA >-----#
    CompletedCellsInTAI_EUTRA = SEQ_OF(name=u'CompletedCellsInTAI-EUTRA', mode=MODE_TYPE)
    _CompletedCellsInTAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-EUTRA-Item')))
    CompletedCellsInTAI_EUTRA._cont = _CompletedCellsInTAI_EUTRA__item_
    CompletedCellsInTAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInTAI-EUTRA-Item >-----#
    CompletedCellsInTAI_EUTRA_Item = SEQ(name=u'CompletedCellsInTAI-EUTRA-Item', mode=MODE_TYPE)
    _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions._cont = __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInTAI_EUTRA_Item._cont = ASN1Dict([
        (u'eUTRA-CGI', _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI),
        (u'iE-Extensions', _CompletedCellsInTAI_EUTRA_Item_iE_Extensions),
        ])
    CompletedCellsInTAI_EUTRA_Item._ext = []
    
    #-----< CompletedCellsInTAI-EUTRA-Item-ExtIEs >-----#
    CompletedCellsInTAI_EUTRA_Item_ExtIEs = CLASS(name=u'CompletedCellsInTAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInTAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInTAI-NR >-----#
    CompletedCellsInTAI_NR = SEQ_OF(name=u'CompletedCellsInTAI-NR', mode=MODE_TYPE)
    _CompletedCellsInTAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-NR-Item')))
    CompletedCellsInTAI_NR._cont = _CompletedCellsInTAI_NR__item_
    CompletedCellsInTAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInTAI-NR-Item >-----#
    CompletedCellsInTAI_NR_Item = SEQ(name=u'CompletedCellsInTAI-NR-Item', mode=MODE_TYPE)
    _CompletedCellsInTAI_NR_Item_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CompletedCellsInTAI_NR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInTAI_NR_Item_iE_Extensions._cont = __CompletedCellsInTAI_NR_Item_iE_Extensions__item_
    _CompletedCellsInTAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInTAI_NR_Item._cont = ASN1Dict([
        (u'nR-CGI', _CompletedCellsInTAI_NR_Item_nR_CGI),
        (u'iE-Extensions', _CompletedCellsInTAI_NR_Item_iE_Extensions),
        ])
    CompletedCellsInTAI_NR_Item._ext = []
    
    #-----< CompletedCellsInTAI-NR-Item-ExtIEs >-----#
    CompletedCellsInTAI_NR_Item_ExtIEs = CLASS(name=u'CompletedCellsInTAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInTAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ConcurrentWarningMessageInd >-----#
    ConcurrentWarningMessageInd = ENUM(name=u'ConcurrentWarningMessageInd', mode=MODE_TYPE)
    ConcurrentWarningMessageInd._cont = ASN1Dict([(u'true', 0)])
    ConcurrentWarningMessageInd._ext = []
    
    #-----< ConfidentialityProtectionIndication >-----#
    ConfidentialityProtectionIndication = ENUM(name=u'ConfidentialityProtectionIndication', mode=MODE_TYPE)
    ConfidentialityProtectionIndication._cont = ASN1Dict([(u'required', 0), (u'preferred', 1), (u'not-needed', 2)])
    ConfidentialityProtectionIndication._ext = []
    
    #-----< ConfidentialityProtectionResult >-----#
    ConfidentialityProtectionResult = ENUM(name=u'ConfidentialityProtectionResult', mode=MODE_TYPE)
    ConfidentialityProtectionResult._cont = ASN1Dict([(u'performed', 0), (u'not-performed', 1)])
    ConfidentialityProtectionResult._ext = []
    
    #-----< ConfiguredTACIndication >-----#
    ConfiguredTACIndication = ENUM(name=u'ConfiguredTACIndication', mode=MODE_TYPE)
    ConfiguredTACIndication._cont = ASN1Dict([(u'true', 0)])
    ConfiguredTACIndication._ext = []
    
    #-----< CoreNetworkAssistanceInformationForInactive >-----#
    CoreNetworkAssistanceInformationForInactive = SEQ(name=u'CoreNetworkAssistanceInformationForInactive', mode=MODE_TYPE)
    _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue = CHOICE(name=u'uEIdentityIndexValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEIdentityIndexValue')))
    _CoreNetworkAssistanceInformationForInactive_uESpecificDRX = ENUM(name=u'uESpecificDRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer = BIT_STR(name=u'periodicRegistrationUpdateTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PeriodicRegistrationUpdateTimer')))
    _CoreNetworkAssistanceInformationForInactive_mICOModeIndication = ENUM(name=u'mICOModeIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MICOModeIndication')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_tAIListForInactive = SEQ_OF(name=u'tAIListForInactive', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListForInactive')))
    _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour = SEQ(name=u'expectedUEBehaviour', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEBehaviour')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingeDRXInformation')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedUEIdentityIndexValue')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MicoAllPLMN')))
    ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 223), (u'criticality', u'ignore'), (u'Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab_at = None
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab_id = u'id'
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id),
        (u'criticality', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality),
        (u'extensionValue', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue),
        ])
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_._ext = None
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions._cont = __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoreNetworkAssistanceInformationForInactive._cont = ASN1Dict([
        (u'uEIdentityIndexValue', _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue),
        (u'uESpecificDRX', _CoreNetworkAssistanceInformationForInactive_uESpecificDRX),
        (u'periodicRegistrationUpdateTimer', _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer),
        (u'mICOModeIndication', _CoreNetworkAssistanceInformationForInactive_mICOModeIndication),
        (u'tAIListForInactive', _CoreNetworkAssistanceInformationForInactive_tAIListForInactive),
        (u'expectedUEBehaviour', _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour),
        (u'iE-Extensions', _CoreNetworkAssistanceInformationForInactive_iE_Extensions),
        ])
    CoreNetworkAssistanceInformationForInactive._ext = []
    
    #-----< CoreNetworkAssistanceInformationForInactive-ExtIEs >-----#
    CoreNetworkAssistanceInformationForInactive_ExtIEs = CLASS(name=u'CoreNetworkAssistanceInformationForInactive-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingeDRXInformation')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedUEIdentityIndexValue')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MicoAllPLMN')))
    CoreNetworkAssistanceInformationForInactive_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 223), (u'criticality', u'ignore'), (u'Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< COUNTValueForPDCP-SN12 >-----#
    COUNTValueForPDCP_SN12 = SEQ(name=u'COUNTValueForPDCP-SN12', mode=MODE_TYPE)
    _COUNTValueForPDCP_SN12_pDCP_SN12 = INT(name=u'pDCP-SN12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN12_pDCP_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _COUNTValueForPDCP_SN12_hFN_PDCP_SN12 = INT(name=u'hFN-PDCP-SN12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN12_hFN_PDCP_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    _COUNTValueForPDCP_SN12_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueForPDCP_SN12_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTValueForPDCP_SN12_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTValueForPDCP_SN12_iE_Extensions__item__id),
        (u'criticality', ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueForPDCP_SN12_iE_Extensions__item_._ext = None
    _COUNTValueForPDCP_SN12_iE_Extensions._cont = __COUNTValueForPDCP_SN12_iE_Extensions__item_
    _COUNTValueForPDCP_SN12_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueForPDCP_SN12._cont = ASN1Dict([
        (u'pDCP-SN12', _COUNTValueForPDCP_SN12_pDCP_SN12),
        (u'hFN-PDCP-SN12', _COUNTValueForPDCP_SN12_hFN_PDCP_SN12),
        (u'iE-Extensions', _COUNTValueForPDCP_SN12_iE_Extensions),
        ])
    COUNTValueForPDCP_SN12._ext = []
    
    #-----< COUNTValueForPDCP-SN12-ExtIEs >-----#
    COUNTValueForPDCP_SN12_ExtIEs = CLASS(name=u'COUNTValueForPDCP-SN12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    COUNTValueForPDCP_SN12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueForPDCP-SN18 >-----#
    COUNTValueForPDCP_SN18 = SEQ(name=u'COUNTValueForPDCP-SN18', mode=MODE_TYPE)
    _COUNTValueForPDCP_SN18_pDCP_SN18 = INT(name=u'pDCP-SN18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN18_pDCP_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _COUNTValueForPDCP_SN18_hFN_PDCP_SN18 = INT(name=u'hFN-PDCP-SN18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN18_hFN_PDCP_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _COUNTValueForPDCP_SN18_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueForPDCP_SN18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTValueForPDCP_SN18_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTValueForPDCP_SN18_iE_Extensions__item__id),
        (u'criticality', ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueForPDCP_SN18_iE_Extensions__item_._ext = None
    _COUNTValueForPDCP_SN18_iE_Extensions._cont = __COUNTValueForPDCP_SN18_iE_Extensions__item_
    _COUNTValueForPDCP_SN18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueForPDCP_SN18._cont = ASN1Dict([
        (u'pDCP-SN18', _COUNTValueForPDCP_SN18_pDCP_SN18),
        (u'hFN-PDCP-SN18', _COUNTValueForPDCP_SN18_hFN_PDCP_SN18),
        (u'iE-Extensions', _COUNTValueForPDCP_SN18_iE_Extensions),
        ])
    COUNTValueForPDCP_SN18._ext = []
    
    #-----< COUNTValueForPDCP-SN18-ExtIEs >-----#
    COUNTValueForPDCP_SN18_ExtIEs = CLASS(name=u'COUNTValueForPDCP-SN18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    COUNTValueForPDCP_SN18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoverageEnhancementLevel >-----#
    CoverageEnhancementLevel = OCT_STR(name=u'CoverageEnhancementLevel', mode=MODE_TYPE)
    
    #-----< CPTransportLayerInformation >-----#
    CPTransportLayerInformation = CHOICE(name=u'CPTransportLayerInformation', mode=MODE_TYPE)
    _CPTransportLayerInformation_endpointIPAddress = BIT_STR(name=u'endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _CPTransportLayerInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CPTransportLayerInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___CPTransportLayerInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndpointIPAddressAndPort')))
    ___CPTransportLayerInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CPTransportLayerInformation_choice_Extensions_id._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_id._const_tab_at = None
    __CPTransportLayerInformation_choice_Extensions_id._const_tab_id = u'id'
    __CPTransportLayerInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __CPTransportLayerInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __CPTransportLayerInformation_choice_Extensions_value._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __CPTransportLayerInformation_choice_Extensions_value._const_tab_id = u'Value'
    _CPTransportLayerInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __CPTransportLayerInformation_choice_Extensions_id),
        (u'criticality', __CPTransportLayerInformation_choice_Extensions_criticality),
        (u'value', __CPTransportLayerInformation_choice_Extensions_value),
        ])
    _CPTransportLayerInformation_choice_Extensions._ext = None
    CPTransportLayerInformation._cont = ASN1Dict([
        (u'endpointIPAddress', _CPTransportLayerInformation_endpointIPAddress),
        (u'choice-Extensions', _CPTransportLayerInformation_choice_Extensions),
        ])
    CPTransportLayerInformation._ext = None
    
    #-----< CPTransportLayerInformation-ExtIEs >-----#
    CPTransportLayerInformation_ExtIEs = CLASS(name=u'CPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _CPTransportLayerInformation_ExtIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndpointIPAddressAndPort')))
    CPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', _CPTransportLayerInformation_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name=u'CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        (u'iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        (u'iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        (u'typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        (u'iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedMDT-NR >-----#
    CellBasedMDT_NR = SEQ(name=u'CellBasedMDT-NR', mode=MODE_TYPE)
    _CellBasedMDT_NR_cellIdListforMDT = SEQ_OF(name=u'cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIdListforMDT-NR')))
    _CellBasedMDT_NR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_NR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBasedMDT_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__id_tab
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBasedMDT_NR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBasedMDT_NR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBasedMDT_NR_iE_Extensions__item__id),
        (u'criticality', ___CellBasedMDT_NR_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBasedMDT_NR_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_NR_iE_Extensions__item_._ext = None
    _CellBasedMDT_NR_iE_Extensions._cont = __CellBasedMDT_NR_iE_Extensions__item_
    _CellBasedMDT_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT_NR._cont = ASN1Dict([
        (u'cellIdListforMDT', _CellBasedMDT_NR_cellIdListforMDT),
        (u'iE-Extensions', _CellBasedMDT_NR_iE_Extensions),
        ])
    CellBasedMDT_NR._ext = []
    
    #-----< CellBasedMDT-NR-ExtIEs >-----#
    CellBasedMDT_NR_ExtIEs = CLASS(name=u'CellBasedMDT-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellBasedMDT_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforMDT-NR >-----#
    CellIdListforMDT_NR = SEQ_OF(name=u'CellIdListforMDT-NR', mode=MODE_TYPE)
    _CellIdListforMDT_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    CellIdListforMDT_NR._cont = _CellIdListforMDT_NR__item_
    CellIdListforMDT_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellBasedMDT-EUTRA >-----#
    CellBasedMDT_EUTRA = SEQ(name=u'CellBasedMDT-EUTRA', mode=MODE_TYPE)
    _CellBasedMDT_EUTRA_cellIdListforMDT = SEQ_OF(name=u'cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIdListforMDT-EUTRA')))
    _CellBasedMDT_EUTRA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBasedMDT_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBasedMDT_EUTRA_iE_Extensions__item__id),
        (u'criticality', ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_EUTRA_iE_Extensions__item_._ext = None
    _CellBasedMDT_EUTRA_iE_Extensions._cont = __CellBasedMDT_EUTRA_iE_Extensions__item_
    _CellBasedMDT_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT_EUTRA._cont = ASN1Dict([
        (u'cellIdListforMDT', _CellBasedMDT_EUTRA_cellIdListforMDT),
        (u'iE-Extensions', _CellBasedMDT_EUTRA_iE_Extensions),
        ])
    CellBasedMDT_EUTRA._ext = []
    
    #-----< CellBasedMDT-EUTRA-ExtIEs >-----#
    CellBasedMDT_EUTRA_ExtIEs = CLASS(name=u'CellBasedMDT-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellBasedMDT_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforMDT-EUTRA >-----#
    CellIdListforMDT_EUTRA = SEQ_OF(name=u'CellIdListforMDT-EUTRA', mode=MODE_TYPE)
    _CellIdListforMDT_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    CellIdListforMDT_EUTRA._cont = _CellIdListforMDT_EUTRA__item_
    CellIdListforMDT_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DataCodingScheme >-----#
    DataCodingScheme = BIT_STR(name=u'DataCodingScheme', mode=MODE_TYPE)
    DataCodingScheme._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DataForwardingAccepted >-----#
    DataForwardingAccepted = ENUM(name=u'DataForwardingAccepted', mode=MODE_TYPE)
    DataForwardingAccepted._cont = ASN1Dict([(u'data-forwarding-accepted', 0)])
    DataForwardingAccepted._ext = []
    
    #-----< DataForwardingNotPossible >-----#
    DataForwardingNotPossible = ENUM(name=u'DataForwardingNotPossible', mode=MODE_TYPE)
    DataForwardingNotPossible._cont = ASN1Dict([(u'data-forwarding-not-possible', 0)])
    DataForwardingNotPossible._ext = []
    
    #-----< DataForwardingResponseDRBList >-----#
    DataForwardingResponseDRBList = SEQ_OF(name=u'DataForwardingResponseDRBList', mode=MODE_TYPE)
    _DataForwardingResponseDRBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBItem')))
    DataForwardingResponseDRBList._cont = _DataForwardingResponseDRBList__item_
    DataForwardingResponseDRBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DataForwardingResponseDRBItem >-----#
    DataForwardingResponseDRBItem = SEQ(name=u'DataForwardingResponseDRBItem', mode=MODE_TYPE)
    _DataForwardingResponseDRBItem_dRB_ID = INT(name=u'dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation = CHOICE(name=u'dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation = CHOICE(name=u'uLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _DataForwardingResponseDRBItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingResponseDRBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DataForwardingResponseDRBItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DataForwardingResponseDRBItem_iE_Extensions__item__id),
        (u'criticality', ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingResponseDRBItem_iE_Extensions__item_._ext = None
    _DataForwardingResponseDRBItem_iE_Extensions._cont = __DataForwardingResponseDRBItem_iE_Extensions__item_
    _DataForwardingResponseDRBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingResponseDRBItem._cont = ASN1Dict([
        (u'dRB-ID', _DataForwardingResponseDRBItem_dRB_ID),
        (u'dLForwardingUP-TNLInformation', _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation),
        (u'uLForwardingUP-TNLInformation', _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation),
        (u'iE-Extensions', _DataForwardingResponseDRBItem_iE_Extensions),
        ])
    DataForwardingResponseDRBItem._ext = []
    
    #-----< DataForwardingResponseDRBItem-ExtIEs >-----#
    DataForwardingResponseDRBItem_ExtIEs = CLASS(name=u'DataForwardingResponseDRBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DataForwardingResponseDRBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name=u'DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dAPSIndicator = ENUM(name=u'dAPSIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dAPSIndicator._cont = ASN1Dict([(u'daps-ho-required', 0)])
    _DAPSRequestInfo_dAPSIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DAPSRequestInfo_iE_Extensions__item__id),
        (u'criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        (u'dAPSIndicator', _DAPSRequestInfo_dAPSIndicator),
        (u'iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name=u'DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoList >-----#
    DAPSResponseInfoList = SEQ_OF(name=u'DAPSResponseInfoList', mode=MODE_TYPE)
    _DAPSResponseInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoItem')))
    DAPSResponseInfoList._cont = _DAPSResponseInfoList__item_
    DAPSResponseInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DAPSResponseInfoItem >-----#
    DAPSResponseInfoItem = SEQ(name=u'DAPSResponseInfoItem', mode=MODE_TYPE)
    _DAPSResponseInfoItem_dRB_ID = INT(name=u'dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DAPSResponseInfoItem_dAPSResponseInfo = SEQ(name=u'dAPSResponseInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfo')))
    _DAPSResponseInfoItem_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfoItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfoItem_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSResponseInfoItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__id_tab
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab_at = None
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab_id = u'id'
    ___DAPSResponseInfoItem_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DAPSResponseInfoItem_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DAPSResponseInfoItem_iE_Extension__item__id),
        (u'criticality', ___DAPSResponseInfoItem_iE_Extension__item__criticality),
        (u'extensionValue', ___DAPSResponseInfoItem_iE_Extension__item__extensionValue),
        ])
    __DAPSResponseInfoItem_iE_Extension__item_._ext = None
    _DAPSResponseInfoItem_iE_Extension._cont = __DAPSResponseInfoItem_iE_Extension__item_
    _DAPSResponseInfoItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfoItem._cont = ASN1Dict([
        (u'dRB-ID', _DAPSResponseInfoItem_dRB_ID),
        (u'dAPSResponseInfo', _DAPSResponseInfoItem_dAPSResponseInfo),
        (u'iE-Extension', _DAPSResponseInfoItem_iE_Extension),
        ])
    DAPSResponseInfoItem._ext = []
    
    #-----< DAPSResponseInfoItem-ExtIEs >-----#
    DAPSResponseInfoItem_ExtIEs = CLASS(name=u'DAPSResponseInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSResponseInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfo >-----#
    DAPSResponseInfo = SEQ(name=u'DAPSResponseInfo', mode=MODE_TYPE)
    _DAPSResponseInfo_dapsresponseindicator = ENUM(name=u'dapsresponseindicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSResponseInfo_dapsresponseindicator._cont = ASN1Dict([(u'daps-ho-accepted', 0), (u'daps-ho-not-accepted', 1)])
    _DAPSResponseInfo_dapsresponseindicator._ext = []
    _DAPSResponseInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab = ____DAPSResponseInfo_iE_Extensions__item__id_tab
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___DAPSResponseInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfo_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DAPSResponseInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DAPSResponseInfo_iE_Extensions__item__id),
        (u'criticality', ___DAPSResponseInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___DAPSResponseInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfo_iE_Extensions__item_._ext = None
    _DAPSResponseInfo_iE_Extensions._cont = __DAPSResponseInfo_iE_Extensions__item_
    _DAPSResponseInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfo._cont = ASN1Dict([
        (u'dapsresponseindicator', _DAPSResponseInfo_dapsresponseindicator),
        (u'iE-Extensions', _DAPSResponseInfo_iE_Extensions),
        ])
    DAPSResponseInfo._ext = []
    
    #-----< DAPSResponseInfo-ExtIEs >-----#
    DAPSResponseInfo_ExtIEs = CLASS(name=u'DAPSResponseInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSResponseInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataForwardingResponseERABList >-----#
    DataForwardingResponseERABList = SEQ_OF(name=u'DataForwardingResponseERABList', mode=MODE_TYPE)
    _DataForwardingResponseERABList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABListItem')))
    DataForwardingResponseERABList._cont = _DataForwardingResponseERABList__item_
    DataForwardingResponseERABList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DataForwardingResponseERABListItem >-----#
    DataForwardingResponseERABListItem = SEQ(name=u'DataForwardingResponseERABListItem', mode=MODE_TYPE)
    _DataForwardingResponseERABListItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')))
    _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation = CHOICE(name=u'dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _DataForwardingResponseERABListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingResponseERABListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DataForwardingResponseERABListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DataForwardingResponseERABListItem_iE_Extensions__item__id),
        (u'criticality', ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingResponseERABListItem_iE_Extensions__item_._ext = None
    _DataForwardingResponseERABListItem_iE_Extensions._cont = __DataForwardingResponseERABListItem_iE_Extensions__item_
    _DataForwardingResponseERABListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingResponseERABListItem._cont = ASN1Dict([
        (u'e-RAB-ID', _DataForwardingResponseERABListItem_e_RAB_ID),
        (u'dLForwardingUP-TNLInformation', _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation),
        (u'iE-Extensions', _DataForwardingResponseERABListItem_iE_Extensions),
        ])
    DataForwardingResponseERABListItem._ext = []
    
    #-----< DataForwardingResponseERABListItem-ExtIEs >-----#
    DataForwardingResponseERABListItem_ExtIEs = CLASS(name=u'DataForwardingResponseERABListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DataForwardingResponseERABListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayCritical >-----#
    DelayCritical = ENUM(name=u'DelayCritical', mode=MODE_TYPE)
    DelayCritical._cont = ASN1Dict([(u'delay-critical', 0), (u'non-delay-critical', 1)])
    DelayCritical._ext = []
    
    #-----< DL-CP-SecurityInformation >-----#
    DL_CP_SecurityInformation = SEQ(name=u'DL-CP-SecurityInformation', mode=MODE_TYPE)
    _DL_CP_SecurityInformation_dl_NAS_MAC = BIT_STR(name=u'dl-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DL-NAS-MAC')))
    _DL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DL_CP_SecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CP_SecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___DL_CP_SecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __DL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _DL_CP_SecurityInformation_iE_Extensions._cont = __DL_CP_SecurityInformation_iE_Extensions__item_
    _DL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CP_SecurityInformation._cont = ASN1Dict([
        (u'dl-NAS-MAC', _DL_CP_SecurityInformation_dl_NAS_MAC),
        (u'iE-Extensions', _DL_CP_SecurityInformation_iE_Extensions),
        ])
    DL_CP_SecurityInformation._ext = []
    
    #-----< DL-CP-SecurityInformation-ExtIEs >-----#
    DL_CP_SecurityInformation_ExtIEs = CLASS(name=u'DL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-NAS-MAC >-----#
    DL_NAS_MAC = BIT_STR(name=u'DL-NAS-MAC', mode=MODE_TYPE)
    DL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< DLForwarding >-----#
    DLForwarding = ENUM(name=u'DLForwarding', mode=MODE_TYPE)
    DLForwarding._cont = ASN1Dict([(u'dl-forwarding-proposed', 0)])
    DLForwarding._ext = []
    
    #-----< DL-NGU-TNLInformationReused >-----#
    DL_NGU_TNLInformationReused = ENUM(name=u'DL-NGU-TNLInformationReused', mode=MODE_TYPE)
    DL_NGU_TNLInformationReused._cont = ASN1Dict([(u'true', 0)])
    DL_NGU_TNLInformationReused._ext = []
    
    #-----< DirectForwardingPathAvailability >-----#
    DirectForwardingPathAvailability = ENUM(name=u'DirectForwardingPathAvailability', mode=MODE_TYPE)
    DirectForwardingPathAvailability._cont = ASN1Dict([(u'direct-path-available', 0)])
    DirectForwardingPathAvailability._ext = []
    
    #-----< DRB-ID >-----#
    DRB_ID = INT(name=u'DRB-ID', mode=MODE_TYPE)
    DRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< DRBsSubjectToStatusTransferList >-----#
    DRBsSubjectToStatusTransferList = SEQ_OF(name=u'DRBsSubjectToStatusTransferList', mode=MODE_TYPE)
    _DRBsSubjectToStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToStatusTransferItem')))
    DRBsSubjectToStatusTransferList._cont = _DRBsSubjectToStatusTransferList__item_
    DRBsSubjectToStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsSubjectToStatusTransferItem >-----#
    DRBsSubjectToStatusTransferItem = SEQ(name=u'DRBsSubjectToStatusTransferItem', mode=MODE_TYPE)
    _DRBsSubjectToStatusTransferItem_dRB_ID = INT(name=u'dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsSubjectToStatusTransferItem_dRBStatusUL = CHOICE(name=u'dRBStatusUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL')))
    _DRBsSubjectToStatusTransferItem_dRBStatusDL = CHOICE(name=u'dRBStatusDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL')))
    _DRBsSubjectToStatusTransferItem_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Extension', _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab_at = None
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id),
        (u'criticality', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue),
        ])
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_._ext = None
    _DRBsSubjectToStatusTransferItem_iE_Extension._cont = __DRBsSubjectToStatusTransferItem_iE_Extension__item_
    _DRBsSubjectToStatusTransferItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsSubjectToStatusTransferItem._cont = ASN1Dict([
        (u'dRB-ID', _DRBsSubjectToStatusTransferItem_dRB_ID),
        (u'dRBStatusUL', _DRBsSubjectToStatusTransferItem_dRBStatusUL),
        (u'dRBStatusDL', _DRBsSubjectToStatusTransferItem_dRBStatusDL),
        (u'iE-Extension', _DRBsSubjectToStatusTransferItem_iE_Extension),
        ])
    DRBsSubjectToStatusTransferItem._ext = []
    
    #-----< DRBsSubjectToStatusTransferItem-ExtIEs >-----#
    DRBsSubjectToStatusTransferItem_ExtIEs = CLASS(name=u'DRBsSubjectToStatusTransferItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    DRBsSubjectToStatusTransferItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Extension', _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL >-----#
    DRBStatusDL = CHOICE(name=u'DRBStatusDL', mode=MODE_TYPE)
    _DRBStatusDL_dRBStatusDL12 = SEQ(name=u'dRBStatusDL12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL12')))
    _DRBStatusDL_dRBStatusDL18 = SEQ(name=u'dRBStatusDL18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL18')))
    _DRBStatusDL_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBStatusDL_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___DRBStatusDL_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_id._const_tab = ___DRBStatusDL_choice_Extensions_id_tab
    __DRBStatusDL_choice_Extensions_id._const_tab_at = None
    __DRBStatusDL_choice_Extensions_id._const_tab_id = u'id'
    __DRBStatusDL_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DRBStatusDL_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_criticality._const_tab = ___DRBStatusDL_choice_Extensions_criticality_tab
    __DRBStatusDL_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __DRBStatusDL_choice_Extensions_criticality._const_tab_id = u'criticality'
    __DRBStatusDL_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DRBStatusDL_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_value._const_tab = ___DRBStatusDL_choice_Extensions_value_tab
    __DRBStatusDL_choice_Extensions_value._const_tab_at = ('..', u'id')
    __DRBStatusDL_choice_Extensions_value._const_tab_id = u'Value'
    _DRBStatusDL_choice_Extensions._cont = ASN1Dict([
        (u'id', __DRBStatusDL_choice_Extensions_id),
        (u'criticality', __DRBStatusDL_choice_Extensions_criticality),
        (u'value', __DRBStatusDL_choice_Extensions_value),
        ])
    _DRBStatusDL_choice_Extensions._ext = None
    DRBStatusDL._cont = ASN1Dict([
        (u'dRBStatusDL12', _DRBStatusDL_dRBStatusDL12),
        (u'dRBStatusDL18', _DRBStatusDL_dRBStatusDL18),
        (u'choice-Extensions', _DRBStatusDL_choice_Extensions),
        ])
    DRBStatusDL._ext = None
    
    #-----< DRBStatusDL-ExtIEs >-----#
    DRBStatusDL_ExtIEs = CLASS(name=u'DRBStatusDL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    DRBStatusDL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL12 >-----#
    DRBStatusDL12 = SEQ(name=u'DRBStatusDL12', mode=MODE_TYPE)
    _DRBStatusDL12_dL_COUNTValue = SEQ(name=u'dL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN12')))
    _DRBStatusDL12_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusDL12_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusDL12_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBStatusDL12_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__id._const_tab = ____DRBStatusDL12_iE_Extension__item__id_tab
    ___DRBStatusDL12_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusDL12_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBStatusDL12_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBStatusDL12_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab = ____DRBStatusDL12_iE_Extension__item__criticality_tab
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBStatusDL12_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBStatusDL12_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab = ____DRBStatusDL12_iE_Extension__item__extensionValue_tab
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBStatusDL12_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBStatusDL12_iE_Extension__item__id),
        (u'criticality', ___DRBStatusDL12_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBStatusDL12_iE_Extension__item__extensionValue),
        ])
    __DRBStatusDL12_iE_Extension__item_._ext = None
    _DRBStatusDL12_iE_Extension._cont = __DRBStatusDL12_iE_Extension__item_
    _DRBStatusDL12_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusDL12._cont = ASN1Dict([
        (u'dL-COUNTValue', _DRBStatusDL12_dL_COUNTValue),
        (u'iE-Extension', _DRBStatusDL12_iE_Extension),
        ])
    DRBStatusDL12._ext = []
    
    #-----< DRBStatusDL12-ExtIEs >-----#
    DRBStatusDL12_ExtIEs = CLASS(name=u'DRBStatusDL12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusDL12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL18 >-----#
    DRBStatusDL18 = SEQ(name=u'DRBStatusDL18', mode=MODE_TYPE)
    _DRBStatusDL18_dL_COUNTValue = SEQ(name=u'dL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN18')))
    _DRBStatusDL18_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusDL18_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusDL18_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBStatusDL18_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__id._const_tab = ____DRBStatusDL18_iE_Extension__item__id_tab
    ___DRBStatusDL18_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusDL18_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBStatusDL18_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBStatusDL18_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab = ____DRBStatusDL18_iE_Extension__item__criticality_tab
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBStatusDL18_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBStatusDL18_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab = ____DRBStatusDL18_iE_Extension__item__extensionValue_tab
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBStatusDL18_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBStatusDL18_iE_Extension__item__id),
        (u'criticality', ___DRBStatusDL18_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBStatusDL18_iE_Extension__item__extensionValue),
        ])
    __DRBStatusDL18_iE_Extension__item_._ext = None
    _DRBStatusDL18_iE_Extension._cont = __DRBStatusDL18_iE_Extension__item_
    _DRBStatusDL18_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusDL18._cont = ASN1Dict([
        (u'dL-COUNTValue', _DRBStatusDL18_dL_COUNTValue),
        (u'iE-Extension', _DRBStatusDL18_iE_Extension),
        ])
    DRBStatusDL18._ext = []
    
    #-----< DRBStatusDL18-ExtIEs >-----#
    DRBStatusDL18_ExtIEs = CLASS(name=u'DRBStatusDL18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusDL18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL >-----#
    DRBStatusUL = CHOICE(name=u'DRBStatusUL', mode=MODE_TYPE)
    _DRBStatusUL_dRBStatusUL12 = SEQ(name=u'dRBStatusUL12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL12')))
    _DRBStatusUL_dRBStatusUL18 = SEQ(name=u'dRBStatusUL18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL18')))
    _DRBStatusUL_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBStatusUL_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___DRBStatusUL_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_id._const_tab = ___DRBStatusUL_choice_Extensions_id_tab
    __DRBStatusUL_choice_Extensions_id._const_tab_at = None
    __DRBStatusUL_choice_Extensions_id._const_tab_id = u'id'
    __DRBStatusUL_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DRBStatusUL_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_criticality._const_tab = ___DRBStatusUL_choice_Extensions_criticality_tab
    __DRBStatusUL_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __DRBStatusUL_choice_Extensions_criticality._const_tab_id = u'criticality'
    __DRBStatusUL_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DRBStatusUL_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_value._const_tab = ___DRBStatusUL_choice_Extensions_value_tab
    __DRBStatusUL_choice_Extensions_value._const_tab_at = ('..', u'id')
    __DRBStatusUL_choice_Extensions_value._const_tab_id = u'Value'
    _DRBStatusUL_choice_Extensions._cont = ASN1Dict([
        (u'id', __DRBStatusUL_choice_Extensions_id),
        (u'criticality', __DRBStatusUL_choice_Extensions_criticality),
        (u'value', __DRBStatusUL_choice_Extensions_value),
        ])
    _DRBStatusUL_choice_Extensions._ext = None
    DRBStatusUL._cont = ASN1Dict([
        (u'dRBStatusUL12', _DRBStatusUL_dRBStatusUL12),
        (u'dRBStatusUL18', _DRBStatusUL_dRBStatusUL18),
        (u'choice-Extensions', _DRBStatusUL_choice_Extensions),
        ])
    DRBStatusUL._ext = None
    
    #-----< DRBStatusUL-ExtIEs >-----#
    DRBStatusUL_ExtIEs = CLASS(name=u'DRBStatusUL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    DRBStatusUL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL12 >-----#
    DRBStatusUL12 = SEQ(name=u'DRBStatusUL12', mode=MODE_TYPE)
    _DRBStatusUL12_uL_COUNTValue = SEQ(name=u'uL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN12')))
    _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs = BIT_STR(name=u'receiveStatusOfUL-PDCP-SDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _DRBStatusUL12_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusUL12_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusUL12_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBStatusUL12_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__id._const_tab = ____DRBStatusUL12_iE_Extension__item__id_tab
    ___DRBStatusUL12_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusUL12_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBStatusUL12_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBStatusUL12_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab = ____DRBStatusUL12_iE_Extension__item__criticality_tab
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBStatusUL12_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBStatusUL12_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab = ____DRBStatusUL12_iE_Extension__item__extensionValue_tab
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBStatusUL12_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBStatusUL12_iE_Extension__item__id),
        (u'criticality', ___DRBStatusUL12_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBStatusUL12_iE_Extension__item__extensionValue),
        ])
    __DRBStatusUL12_iE_Extension__item_._ext = None
    _DRBStatusUL12_iE_Extension._cont = __DRBStatusUL12_iE_Extension__item_
    _DRBStatusUL12_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusUL12._cont = ASN1Dict([
        (u'uL-COUNTValue', _DRBStatusUL12_uL_COUNTValue),
        (u'receiveStatusOfUL-PDCP-SDUs', _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs),
        (u'iE-Extension', _DRBStatusUL12_iE_Extension),
        ])
    DRBStatusUL12._ext = []
    
    #-----< DRBStatusUL12-ExtIEs >-----#
    DRBStatusUL12_ExtIEs = CLASS(name=u'DRBStatusUL12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusUL12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL18 >-----#
    DRBStatusUL18 = SEQ(name=u'DRBStatusUL18', mode=MODE_TYPE)
    _DRBStatusUL18_uL_COUNTValue = SEQ(name=u'uL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN18')))
    _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs = BIT_STR(name=u'receiveStatusOfUL-PDCP-SDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    _DRBStatusUL18_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusUL18_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusUL18_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBStatusUL18_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__id._const_tab = ____DRBStatusUL18_iE_Extension__item__id_tab
    ___DRBStatusUL18_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusUL18_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBStatusUL18_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBStatusUL18_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab = ____DRBStatusUL18_iE_Extension__item__criticality_tab
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBStatusUL18_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBStatusUL18_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab = ____DRBStatusUL18_iE_Extension__item__extensionValue_tab
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBStatusUL18_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBStatusUL18_iE_Extension__item__id),
        (u'criticality', ___DRBStatusUL18_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBStatusUL18_iE_Extension__item__extensionValue),
        ])
    __DRBStatusUL18_iE_Extension__item_._ext = None
    _DRBStatusUL18_iE_Extension._cont = __DRBStatusUL18_iE_Extension__item_
    _DRBStatusUL18_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusUL18._cont = ASN1Dict([
        (u'uL-COUNTValue', _DRBStatusUL18_uL_COUNTValue),
        (u'receiveStatusOfUL-PDCP-SDUs', _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs),
        (u'iE-Extension', _DRBStatusUL18_iE_Extension),
        ])
    DRBStatusUL18._ext = []
    
    #-----< DRBStatusUL18-ExtIEs >-----#
    DRBStatusUL18_ExtIEs = CLASS(name=u'DRBStatusUL18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusUL18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBsToQosFlowsMappingList >-----#
    DRBsToQosFlowsMappingList = SEQ_OF(name=u'DRBsToQosFlowsMappingList', mode=MODE_TYPE)
    _DRBsToQosFlowsMappingList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsToQosFlowsMappingItem')))
    DRBsToQosFlowsMappingList._cont = _DRBsToQosFlowsMappingList__item_
    DRBsToQosFlowsMappingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsToQosFlowsMappingItem >-----#
    DRBsToQosFlowsMappingItem = SEQ(name=u'DRBsToQosFlowsMappingItem', mode=MODE_TYPE)
    _DRBsToQosFlowsMappingItem_dRB_ID = INT(name=u'dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsToQosFlowsMappingItem_associatedQosFlowList = SEQ_OF(name=u'associatedQosFlowList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    _DRBsToQosFlowsMappingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSRequestInfo')))
    ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'ignore'), (u'Extension', _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab_at = None
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id),
        (u'criticality', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue),
        ])
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_._ext = None
    _DRBsToQosFlowsMappingItem_iE_Extensions._cont = __DRBsToQosFlowsMappingItem_iE_Extensions__item_
    _DRBsToQosFlowsMappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsToQosFlowsMappingItem._cont = ASN1Dict([
        (u'dRB-ID', _DRBsToQosFlowsMappingItem_dRB_ID),
        (u'associatedQosFlowList', _DRBsToQosFlowsMappingItem_associatedQosFlowList),
        (u'iE-Extensions', _DRBsToQosFlowsMappingItem_iE_Extensions),
        ])
    DRBsToQosFlowsMappingItem._ext = []
    
    #-----< DRBsToQosFlowsMappingItem-ExtIEs >-----#
    DRBsToQosFlowsMappingItem_ExtIEs = CLASS(name=u'DRBsToQosFlowsMappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSRequestInfo')))
    DRBsToQosFlowsMappingItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'ignore'), (u'Extension', _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Dynamic5QIDescriptor >-----#
    Dynamic5QIDescriptor = SEQ(name=u'Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Dynamic5QIDescriptor_priorityLevelQos = INT(name=u'priorityLevelQos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelQos')))
    _Dynamic5QIDescriptor_packetDelayBudget = INT(name=u'packetDelayBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketDelayBudget')))
    _Dynamic5QIDescriptor_packetErrorRate = SEQ(name=u'packetErrorRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketErrorRate')))
    _Dynamic5QIDescriptor_fiveQI = INT(name=u'fiveQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')), opt=True)
    _Dynamic5QIDescriptor_delayCritical = ENUM(name=u'delayCritical', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DelayCritical')), opt=True)
    _Dynamic5QIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AveragingWindow')), opt=True)
    _Dynamic5QIDescriptor_maximumDataBurstVolume = INT(name=u'maximumDataBurstVolume', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumDataBurstVolume')), opt=True)
    _Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Dynamic5QIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Dynamic5QIDescriptor_iE_Extensions._cont = __Dynamic5QIDescriptor_iE_Extensions__item_
    _Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dynamic5QIDescriptor._cont = ASN1Dict([
        (u'priorityLevelQos', _Dynamic5QIDescriptor_priorityLevelQos),
        (u'packetDelayBudget', _Dynamic5QIDescriptor_packetDelayBudget),
        (u'packetErrorRate', _Dynamic5QIDescriptor_packetErrorRate),
        (u'fiveQI', _Dynamic5QIDescriptor_fiveQI),
        (u'delayCritical', _Dynamic5QIDescriptor_delayCritical),
        (u'averagingWindow', _Dynamic5QIDescriptor_averagingWindow),
        (u'maximumDataBurstVolume', _Dynamic5QIDescriptor_maximumDataBurstVolume),
        (u'iE-Extensions', _Dynamic5QIDescriptor_iE_Extensions),
        ])
    Dynamic5QIDescriptor._ext = []
    
    #-----< Dynamic5QIDescriptor-ExtIEs >-----#
    Dynamic5QIDescriptor_ExtIEs = CLASS(name=u'Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EarlyStatusTransfer-TransparentContainer >-----#
    EarlyStatusTransfer_TransparentContainer = SEQ(name=u'EarlyStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _EarlyStatusTransfer_TransparentContainer_procedureStage = CHOICE(name=u'procedureStage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ProcedureStageChoice')))
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions._cont = __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EarlyStatusTransfer_TransparentContainer._cont = ASN1Dict([
        (u'procedureStage', _EarlyStatusTransfer_TransparentContainer_procedureStage),
        (u'iE-Extensions', _EarlyStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    EarlyStatusTransfer_TransparentContainer._ext = []
    
    #-----< EarlyStatusTransfer-TransparentContainer-ExtIEs >-----#
    EarlyStatusTransfer_TransparentContainer_ExtIEs = CLASS(name=u'EarlyStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EarlyStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ProcedureStageChoice >-----#
    ProcedureStageChoice = CHOICE(name=u'ProcedureStageChoice', mode=MODE_TYPE)
    _ProcedureStageChoice_first_dl_count = SEQ(name=u'first-dl-count', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FirstDLCount')))
    _ProcedureStageChoice_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ProcedureStageChoice_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___ProcedureStageChoice_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_id._const_tab = ___ProcedureStageChoice_choice_Extensions_id_tab
    __ProcedureStageChoice_choice_Extensions_id._const_tab_at = None
    __ProcedureStageChoice_choice_Extensions_id._const_tab_id = u'id'
    __ProcedureStageChoice_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___ProcedureStageChoice_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab = ___ProcedureStageChoice_choice_Extensions_criticality_tab
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab_id = u'criticality'
    __ProcedureStageChoice_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___ProcedureStageChoice_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_value._const_tab = ___ProcedureStageChoice_choice_Extensions_value_tab
    __ProcedureStageChoice_choice_Extensions_value._const_tab_at = ('..', u'id')
    __ProcedureStageChoice_choice_Extensions_value._const_tab_id = u'Value'
    _ProcedureStageChoice_choice_Extensions._cont = ASN1Dict([
        (u'id', __ProcedureStageChoice_choice_Extensions_id),
        (u'criticality', __ProcedureStageChoice_choice_Extensions_criticality),
        (u'value', __ProcedureStageChoice_choice_Extensions_value),
        ])
    _ProcedureStageChoice_choice_Extensions._ext = None
    ProcedureStageChoice._cont = ASN1Dict([
        (u'first-dl-count', _ProcedureStageChoice_first_dl_count),
        (u'choice-Extensions', _ProcedureStageChoice_choice_Extensions),
        ])
    ProcedureStageChoice._ext = None
    
    #-----< ProcedureStageChoice-ExtIEs >-----#
    ProcedureStageChoice_ExtIEs = CLASS(name=u'ProcedureStageChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ProcedureStageChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FirstDLCount >-----#
    FirstDLCount = SEQ(name=u'FirstDLCount', mode=MODE_TYPE)
    _FirstDLCount_dRBsSubjectToEarlyStatusTransfer = SEQ_OF(name=u'dRBsSubjectToEarlyStatusTransfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToEarlyStatusTransfer-List')))
    _FirstDLCount_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FirstDLCount_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FirstDLCount_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FirstDLCount_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__id._const_tab = ____FirstDLCount_iE_Extension__item__id_tab
    ___FirstDLCount_iE_Extension__item__id._const_tab_at = None
    ___FirstDLCount_iE_Extension__item__id._const_tab_id = u'id'
    ___FirstDLCount_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FirstDLCount_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__criticality._const_tab = ____FirstDLCount_iE_Extension__item__criticality_tab
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___FirstDLCount_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab = ____FirstDLCount_iE_Extension__item__extensionValue_tab
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __FirstDLCount_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___FirstDLCount_iE_Extension__item__id),
        (u'criticality', ___FirstDLCount_iE_Extension__item__criticality),
        (u'extensionValue', ___FirstDLCount_iE_Extension__item__extensionValue),
        ])
    __FirstDLCount_iE_Extension__item_._ext = None
    _FirstDLCount_iE_Extension._cont = __FirstDLCount_iE_Extension__item_
    _FirstDLCount_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FirstDLCount._cont = ASN1Dict([
        (u'dRBsSubjectToEarlyStatusTransfer', _FirstDLCount_dRBsSubjectToEarlyStatusTransfer),
        (u'iE-Extension', _FirstDLCount_iE_Extension),
        ])
    FirstDLCount._ext = []
    
    #-----< FirstDLCount-ExtIEs >-----#
    FirstDLCount_ExtIEs = CLASS(name=u'FirstDLCount-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FirstDLCount_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBsSubjectToEarlyStatusTransfer-List >-----#
    DRBsSubjectToEarlyStatusTransfer_List = SEQ_OF(name=u'DRBsSubjectToEarlyStatusTransfer-List', mode=MODE_TYPE)
    _DRBsSubjectToEarlyStatusTransfer_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToEarlyStatusTransfer-Item')))
    DRBsSubjectToEarlyStatusTransfer_List._cont = _DRBsSubjectToEarlyStatusTransfer_List__item_
    DRBsSubjectToEarlyStatusTransfer_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsSubjectToEarlyStatusTransfer-Item >-----#
    DRBsSubjectToEarlyStatusTransfer_Item = SEQ(name=u'DRBsSubjectToEarlyStatusTransfer-Item', mode=MODE_TYPE)
    _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID = INT(name=u'dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT = CHOICE(name=u'firstDLCOUNT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL')))
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_at = None
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_id = u'id'
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id),
        (u'criticality', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality),
        (u'extensionValue', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue),
        ])
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._ext = None
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension._cont = __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsSubjectToEarlyStatusTransfer_Item._cont = ASN1Dict([
        (u'dRB-ID', _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID),
        (u'firstDLCOUNT', _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT),
        (u'iE-Extension', _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension),
        ])
    DRBsSubjectToEarlyStatusTransfer_Item._ext = []
    
    #-----< DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs >-----#
    DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs = CLASS(name=u'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDT-Session >-----#
    EDT_Session = ENUM(name=u'EDT-Session', mode=MODE_TYPE)
    EDT_Session._cont = ASN1Dict([(u'true', 0)])
    EDT_Session._ext = []
    
    #-----< EmergencyAreaID >-----#
    EmergencyAreaID = OCT_STR(name=u'EmergencyAreaID', mode=MODE_TYPE)
    EmergencyAreaID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastEUTRA >-----#
    EmergencyAreaIDBroadcastEUTRA = SEQ_OF(name=u'EmergencyAreaIDBroadcastEUTRA', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastEUTRA-Item')))
    EmergencyAreaIDBroadcastEUTRA._cont = _EmergencyAreaIDBroadcastEUTRA__item_
    EmergencyAreaIDBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastEUTRA-Item >-----#
    EmergencyAreaIDBroadcastEUTRA_Item = SEQ(name=u'EmergencyAreaIDBroadcastEUTRA-Item', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA = SEQ_OF(name=u'completedCellsInEAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-EUTRA')))
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions._cont = __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDBroadcastEUTRA_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID),
        (u'completedCellsInEAI-EUTRA', _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA),
        (u'iE-Extensions', _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions),
        ])
    EmergencyAreaIDBroadcastEUTRA_Item._ext = []
    
    #-----< EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs >-----#
    EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs = CLASS(name=u'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDBroadcastNR >-----#
    EmergencyAreaIDBroadcastNR = SEQ_OF(name=u'EmergencyAreaIDBroadcastNR', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastNR-Item')))
    EmergencyAreaIDBroadcastNR._cont = _EmergencyAreaIDBroadcastNR__item_
    EmergencyAreaIDBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastNR-Item >-----#
    EmergencyAreaIDBroadcastNR_Item = SEQ(name=u'EmergencyAreaIDBroadcastNR-Item', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR = SEQ_OF(name=u'completedCellsInEAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-NR')))
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions._cont = __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDBroadcastNR_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID),
        (u'completedCellsInEAI-NR', _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR),
        (u'iE-Extensions', _EmergencyAreaIDBroadcastNR_Item_iE_Extensions),
        ])
    EmergencyAreaIDBroadcastNR_Item._ext = []
    
    #-----< EmergencyAreaIDBroadcastNR-Item-ExtIEs >-----#
    EmergencyAreaIDBroadcastNR_Item_ExtIEs = CLASS(name=u'EmergencyAreaIDBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDCancelledEUTRA >-----#
    EmergencyAreaIDCancelledEUTRA = SEQ_OF(name=u'EmergencyAreaIDCancelledEUTRA', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledEUTRA-Item')))
    EmergencyAreaIDCancelledEUTRA._cont = _EmergencyAreaIDCancelledEUTRA__item_
    EmergencyAreaIDCancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDCancelledEUTRA-Item >-----#
    EmergencyAreaIDCancelledEUTRA_Item = SEQ(name=u'EmergencyAreaIDCancelledEUTRA-Item', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA = SEQ_OF(name=u'cancelledCellsInEAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-EUTRA')))
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions._cont = __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDCancelledEUTRA_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID),
        (u'cancelledCellsInEAI-EUTRA', _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA),
        (u'iE-Extensions', _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions),
        ])
    EmergencyAreaIDCancelledEUTRA_Item._ext = []
    
    #-----< EmergencyAreaIDCancelledEUTRA-Item-ExtIEs >-----#
    EmergencyAreaIDCancelledEUTRA_Item_ExtIEs = CLASS(name=u'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDCancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDCancelledNR >-----#
    EmergencyAreaIDCancelledNR = SEQ_OF(name=u'EmergencyAreaIDCancelledNR', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledNR-Item')))
    EmergencyAreaIDCancelledNR._cont = _EmergencyAreaIDCancelledNR__item_
    EmergencyAreaIDCancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDCancelledNR-Item >-----#
    EmergencyAreaIDCancelledNR_Item = SEQ(name=u'EmergencyAreaIDCancelledNR-Item', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledNR_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR = SEQ_OF(name=u'cancelledCellsInEAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-NR')))
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions._cont = __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDCancelledNR_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaIDCancelledNR_Item_emergencyAreaID),
        (u'cancelledCellsInEAI-NR', _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR),
        (u'iE-Extensions', _EmergencyAreaIDCancelledNR_Item_iE_Extensions),
        ])
    EmergencyAreaIDCancelledNR_Item._ext = []
    
    #-----< EmergencyAreaIDCancelledNR-Item-ExtIEs >-----#
    EmergencyAreaIDCancelledNR_Item_ExtIEs = CLASS(name=u'EmergencyAreaIDCancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDCancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDList >-----#
    EmergencyAreaIDList = SEQ_OF(name=u'EmergencyAreaIDList', mode=MODE_TYPE)
    _EmergencyAreaIDList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDList._cont = _EmergencyAreaIDList__item_
    EmergencyAreaIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDListForRestart >-----#
    EmergencyAreaIDListForRestart = SEQ_OF(name=u'EmergencyAreaIDListForRestart', mode=MODE_TYPE)
    _EmergencyAreaIDListForRestart__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDListForRestart._cont = _EmergencyAreaIDListForRestart__item_
    EmergencyAreaIDListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyFallbackIndicator >-----#
    EmergencyFallbackIndicator = SEQ(name=u'EmergencyFallbackIndicator', mode=MODE_TYPE)
    _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator = ENUM(name=u'emergencyFallbackRequestIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackRequestIndicator')))
    _EmergencyFallbackIndicator_emergencyServiceTargetCN = ENUM(name=u'emergencyServiceTargetCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyServiceTargetCN')), opt=True)
    _EmergencyFallbackIndicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyFallbackIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyFallbackIndicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyFallbackIndicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyFallbackIndicator_iE_Extensions__item__id),
        (u'criticality', ___EmergencyFallbackIndicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue),
        ])
    __EmergencyFallbackIndicator_iE_Extensions__item_._ext = None
    _EmergencyFallbackIndicator_iE_Extensions._cont = __EmergencyFallbackIndicator_iE_Extensions__item_
    _EmergencyFallbackIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyFallbackIndicator._cont = ASN1Dict([
        (u'emergencyFallbackRequestIndicator', _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator),
        (u'emergencyServiceTargetCN', _EmergencyFallbackIndicator_emergencyServiceTargetCN),
        (u'iE-Extensions', _EmergencyFallbackIndicator_iE_Extensions),
        ])
    EmergencyFallbackIndicator._ext = []
    
    #-----< EmergencyFallbackIndicator-ExtIEs >-----#
    EmergencyFallbackIndicator_ExtIEs = CLASS(name=u'EmergencyFallbackIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyFallbackIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyFallbackRequestIndicator >-----#
    EmergencyFallbackRequestIndicator = ENUM(name=u'EmergencyFallbackRequestIndicator', mode=MODE_TYPE)
    EmergencyFallbackRequestIndicator._cont = ASN1Dict([(u'emergency-fallback-requested', 0)])
    EmergencyFallbackRequestIndicator._ext = []
    
    #-----< EmergencyServiceTargetCN >-----#
    EmergencyServiceTargetCN = ENUM(name=u'EmergencyServiceTargetCN', mode=MODE_TYPE)
    EmergencyServiceTargetCN._cont = ASN1Dict([(u'fiveGC', 0), (u'epc', 1)])
    EmergencyServiceTargetCN._ext = []
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name=u'ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name=u'macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name=u'homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name=u'short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name=u'long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _ENB_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ENB_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___ENB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_id._const_tab = ___ENB_ID_choice_Extensions_id_tab
    __ENB_ID_choice_Extensions_id._const_tab_at = None
    __ENB_ID_choice_Extensions_id._const_tab_id = u'id'
    __ENB_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___ENB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_criticality._const_tab = ___ENB_ID_choice_Extensions_criticality_tab
    __ENB_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __ENB_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __ENB_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___ENB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_value._const_tab = ___ENB_ID_choice_Extensions_value_tab
    __ENB_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __ENB_ID_choice_Extensions_value._const_tab_id = u'Value'
    _ENB_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __ENB_ID_choice_Extensions_id),
        (u'criticality', __ENB_ID_choice_Extensions_criticality),
        (u'value', __ENB_ID_choice_Extensions_value),
        ])
    _ENB_ID_choice_Extensions._ext = None
    ENB_ID._cont = ASN1Dict([
        (u'macroENB-ID', _ENB_ID_macroENB_ID),
        (u'homeENB-ID', _ENB_ID_homeENB_ID),
        (u'short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        (u'long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        (u'choice-Extensions', _ENB_ID_choice_Extensions),
        ])
    ENB_ID._ext = None
    
    #-----< ENB-ID-ExtIEs >-----#
    ENB_ID_ExtIEs = CLASS(name=u'ENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-CoverageRestriction >-----#
    Enhanced_CoverageRestriction = ENUM(name=u'Enhanced-CoverageRestriction', mode=MODE_TYPE)
    Enhanced_CoverageRestriction._cont = ASN1Dict([(u'restricted', 0)])
    Enhanced_CoverageRestriction._ext = []
    
    #-----< Extended-ConnectedTime >-----#
    Extended_ConnectedTime = INT(name=u'Extended-ConnectedTime', mode=MODE_TYPE)
    Extended_ConnectedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< EN-DCSONConfigurationTransfer >-----#
    EN_DCSONConfigurationTransfer = OCT_STR(name=u'EN-DCSONConfigurationTransfer', mode=MODE_TYPE)
    
    #-----< EndpointIPAddressAndPort >-----#
    EndpointIPAddressAndPort = SEQ(name=u'EndpointIPAddressAndPort', mode=MODE_TYPE)
    _EndpointIPAddressAndPort_endpointIPAddress = BIT_STR(name=u'endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _EndpointIPAddressAndPort_portNumber = OCT_STR(name=u'portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')))
    _EndpointIPAddressAndPort_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EndpointIPAddressAndPort_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EndpointIPAddressAndPort_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab_at = None
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab_id = u'id'
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EndpointIPAddressAndPort_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EndpointIPAddressAndPort_iE_Extensions__item__id),
        (u'criticality', ___EndpointIPAddressAndPort_iE_Extensions__item__criticality),
        (u'extensionValue', ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue),
        ])
    __EndpointIPAddressAndPort_iE_Extensions__item_._ext = None
    _EndpointIPAddressAndPort_iE_Extensions._cont = __EndpointIPAddressAndPort_iE_Extensions__item_
    _EndpointIPAddressAndPort_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EndpointIPAddressAndPort._cont = ASN1Dict([
        (u'endpointIPAddress', _EndpointIPAddressAndPort_endpointIPAddress),
        (u'portNumber', _EndpointIPAddressAndPort_portNumber),
        (u'iE-Extensions', _EndpointIPAddressAndPort_iE_Extensions),
        ])
    EndpointIPAddressAndPort._ext = None
    
    #-----< EndIndication >-----#
    EndIndication = ENUM(name=u'EndIndication', mode=MODE_TYPE)
    EndIndication._cont = ASN1Dict([(u'no-further-data', 0), (u'further-data-exists', 1)])
    EndIndication._ext = []
    
    #-----< EndpointIPAddressAndPort-ExtIEs >-----#
    EndpointIPAddressAndPort_ExtIEs = CLASS(name=u'EndpointIPAddressAndPort-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EndpointIPAddressAndPort_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EquivalentPLMNs >-----#
    EquivalentPLMNs = SEQ_OF(name=u'EquivalentPLMNs', mode=MODE_TYPE)
    _EquivalentPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    EquivalentPLMNs._cont = _EquivalentPLMNs__item_
    EquivalentPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< EPS-TAC >-----#
    EPS_TAC = OCT_STR(name=u'EPS-TAC', mode=MODE_TYPE)
    EPS_TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< EPS-TAI >-----#
    EPS_TAI = SEQ(name=u'EPS-TAI', mode=MODE_TYPE)
    _EPS_TAI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _EPS_TAI_ePS_TAC = OCT_STR(name=u'ePS-TAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAC')))
    _EPS_TAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EPS_TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EPS_TAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EPS_TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__id._const_tab = ____EPS_TAI_iE_Extensions__item__id_tab
    ___EPS_TAI_iE_Extensions__item__id._const_tab_at = None
    ___EPS_TAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___EPS_TAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EPS_TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab = ____EPS_TAI_iE_Extensions__item__criticality_tab
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EPS_TAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EPS_TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab = ____EPS_TAI_iE_Extensions__item__extensionValue_tab
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EPS_TAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EPS_TAI_iE_Extensions__item__id),
        (u'criticality', ___EPS_TAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___EPS_TAI_iE_Extensions__item__extensionValue),
        ])
    __EPS_TAI_iE_Extensions__item_._ext = None
    _EPS_TAI_iE_Extensions._cont = __EPS_TAI_iE_Extensions__item_
    _EPS_TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EPS_TAI._cont = ASN1Dict([
        (u'pLMNIdentity', _EPS_TAI_pLMNIdentity),
        (u'ePS-TAC', _EPS_TAI_ePS_TAC),
        (u'iE-Extensions', _EPS_TAI_iE_Extensions),
        ])
    EPS_TAI._ext = []
    
    #-----< EPS-TAI-ExtIEs >-----#
    EPS_TAI_ExtIEs = CLASS(name=u'EPS-TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EPS_TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name=u'E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RABInformationList >-----#
    E_RABInformationList = SEQ_OF(name=u'E-RABInformationList', mode=MODE_TYPE)
    _E_RABInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'E-RABInformationItem')))
    E_RABInformationList._cont = _E_RABInformationList__item_
    E_RABInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABInformationItem >-----#
    E_RABInformationItem = SEQ(name=u'E-RABInformationItem', mode=MODE_TYPE)
    _E_RABInformationItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')))
    _E_RABInformationItem_dLForwarding = ENUM(name=u'dLForwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DLForwarding')), opt=True)
    _E_RABInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___E_RABInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    ____E_RABInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABInformationItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABInformationItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABInformationItem_iE_Extensions__item_._ext = None
    _E_RABInformationItem_iE_Extensions._cont = __E_RABInformationItem_iE_Extensions__item_
    _E_RABInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABInformationItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABInformationItem_e_RAB_ID),
        (u'dLForwarding', _E_RABInformationItem_dLForwarding),
        (u'iE-Extensions', _E_RABInformationItem_iE_Extensions),
        ])
    E_RABInformationItem._ext = []
    
    #-----< E-RABInformationItem-ExtIEs >-----#
    E_RABInformationItem_ExtIEs = CLASS(name=u'E-RABInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _E_RABInformationItem_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _E_RABInformationItem_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    E_RABInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _E_RABInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _E_RABInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EUTRACellIdentity >-----#
    EUTRACellIdentity = BIT_STR(name=u'EUTRACellIdentity', mode=MODE_TYPE)
    EUTRACellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRA-CGI >-----#
    EUTRA_CGI = SEQ(name=u'EUTRA-CGI', mode=MODE_TYPE)
    _EUTRA_CGI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _EUTRA_CGI_eUTRACellIdentity = BIT_STR(name=u'eUTRACellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRACellIdentity')))
    _EUTRA_CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRA_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab = ____EUTRA_CGI_iE_Extensions__item__id_tab
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRA_CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRA_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab = ____EUTRA_CGI_iE_Extensions__item__criticality_tab
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRA_CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRA_CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRA_CGI_iE_Extensions__item__id),
        (u'criticality', ___EUTRA_CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRA_CGI_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_CGI_iE_Extensions__item_._ext = None
    _EUTRA_CGI_iE_Extensions._cont = __EUTRA_CGI_iE_Extensions__item_
    _EUTRA_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_CGI._cont = ASN1Dict([
        (u'pLMNIdentity', _EUTRA_CGI_pLMNIdentity),
        (u'eUTRACellIdentity', _EUTRA_CGI_eUTRACellIdentity),
        (u'iE-Extensions', _EUTRA_CGI_iE_Extensions),
        ])
    EUTRA_CGI._ext = []
    
    #-----< EUTRA-CGI-ExtIEs >-----#
    EUTRA_CGI_ExtIEs = CLASS(name=u'EUTRA-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRA_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-CGIList >-----#
    EUTRA_CGIList = SEQ_OF(name=u'EUTRA-CGIList', mode=MODE_TYPE)
    _EUTRA_CGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    EUTRA_CGIList._cont = _EUTRA_CGIList__item_
    EUTRA_CGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRA-CGIListForWarning >-----#
    EUTRA_CGIListForWarning = SEQ_OF(name=u'EUTRA-CGIListForWarning', mode=MODE_TYPE)
    _EUTRA_CGIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    EUTRA_CGIListForWarning._cont = _EUTRA_CGIListForWarning__item_
    EUTRA_CGIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EUTRAencryptionAlgorithms >-----#
    EUTRAencryptionAlgorithms = BIT_STR(name=u'EUTRAencryptionAlgorithms', mode=MODE_TYPE)
    EUTRAencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EUTRAintegrityProtectionAlgorithms >-----#
    EUTRAintegrityProtectionAlgorithms = BIT_STR(name=u'EUTRAintegrityProtectionAlgorithms', mode=MODE_TYPE)
    EUTRAintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name=u'EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([(u'direct', 0), (u'change-of-serve-cell', 1), (u'ue-presence-in-area-of-interest', 2), (u'stop-change-of-serve-cell', 3), (u'stop-ue-presence-in-area-of-interest', 4), (u'cancel-location-reporting-for-the-ue', 5)])
    EventType._ext = []
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name=u'ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name=u'ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([(u'sec15', 0), (u'sec30', 1), (u'sec60', 2), (u'sec90', 3), (u'sec120', 4), (u'sec180', 5), (u'long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name=u'ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name=u'ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name=u'expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name=u'expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation = ENUM(name=u'sourceOfUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        (u'expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        (u'expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        (u'sourceOfUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation),
        (u'iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name=u'ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name=u'ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedUEActivityBehaviour = SEQ(name=u'expectedUEActivityBehaviour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name=u'expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_expectedUEMobility = ENUM(name=u'expectedUEMobility', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMobility')), opt=True)
    _ExpectedUEBehaviour_expectedUEMovingTrajectory = SEQ_OF(name=u'expectedUEMovingTrajectory', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMovingTrajectory')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        (u'expectedUEActivityBehaviour', _ExpectedUEBehaviour_expectedUEActivityBehaviour),
        (u'expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        (u'expectedUEMobility', _ExpectedUEBehaviour_expectedUEMobility),
        (u'expectedUEMovingTrajectory', _ExpectedUEBehaviour_expectedUEMovingTrajectory),
        (u'iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name=u'ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEMobility >-----#
    ExpectedUEMobility = ENUM(name=u'ExpectedUEMobility', mode=MODE_TYPE)
    ExpectedUEMobility._cont = ASN1Dict([(u'stationary', 0), (u'mobile', 1)])
    ExpectedUEMobility._ext = []
    
    #-----< ExpectedUEMovingTrajectory >-----#
    ExpectedUEMovingTrajectory = SEQ_OF(name=u'ExpectedUEMovingTrajectory', mode=MODE_TYPE)
    _ExpectedUEMovingTrajectory__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMovingTrajectoryItem')))
    ExpectedUEMovingTrajectory._cont = _ExpectedUEMovingTrajectory__item_
    ExpectedUEMovingTrajectory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ExpectedUEMovingTrajectoryItem >-----#
    ExpectedUEMovingTrajectoryItem = SEQ(name=u'ExpectedUEMovingTrajectoryItem', mode=MODE_TYPE)
    _ExpectedUEMovingTrajectoryItem_nGRAN_CGI = CHOICE(name=u'nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _ExpectedUEMovingTrajectoryItem_timeStayedInCell = INT(name=u'timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExpectedUEMovingTrajectoryItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _ExpectedUEMovingTrajectoryItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_._ext = None
    _ExpectedUEMovingTrajectoryItem_iE_Extensions._cont = __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_
    _ExpectedUEMovingTrajectoryItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEMovingTrajectoryItem._cont = ASN1Dict([
        (u'nGRAN-CGI', _ExpectedUEMovingTrajectoryItem_nGRAN_CGI),
        (u'timeStayedInCell', _ExpectedUEMovingTrajectoryItem_timeStayedInCell),
        (u'iE-Extensions', _ExpectedUEMovingTrajectoryItem_iE_Extensions),
        ])
    ExpectedUEMovingTrajectoryItem._ext = []
    
    #-----< ExpectedUEMovingTrajectoryItem-ExtIEs >-----#
    ExpectedUEMovingTrajectoryItem_ExtIEs = CLASS(name=u'ExpectedUEMovingTrajectoryItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEMovingTrajectoryItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extended-AMFName >-----#
    Extended_AMFName = SEQ(name=u'Extended-AMFName', mode=MODE_TYPE)
    _Extended_AMFName_aMFNameVisibleString = STR_VIS(name=u'aMFNameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFNameVisibleString')), opt=True)
    _Extended_AMFName_aMFNameUTF8String = STR_UTF8(name=u'aMFNameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFNameUTF8String')), opt=True)
    _Extended_AMFName_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_AMFName_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Extended_AMFName_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extended_AMFName_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__id._const_tab = ____Extended_AMFName_iE_Extensions__item__id_tab
    ___Extended_AMFName_iE_Extensions__item__id._const_tab_at = None
    ___Extended_AMFName_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extended_AMFName_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extended_AMFName_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab = ____Extended_AMFName_iE_Extensions__item__criticality_tab
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extended_AMFName_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extended_AMFName_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab = ____Extended_AMFName_iE_Extensions__item__extensionValue_tab
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extended_AMFName_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extended_AMFName_iE_Extensions__item__id),
        (u'criticality', ___Extended_AMFName_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extended_AMFName_iE_Extensions__item__extensionValue),
        ])
    __Extended_AMFName_iE_Extensions__item_._ext = None
    _Extended_AMFName_iE_Extensions._cont = __Extended_AMFName_iE_Extensions__item_
    _Extended_AMFName_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_AMFName._cont = ASN1Dict([
        (u'aMFNameVisibleString', _Extended_AMFName_aMFNameVisibleString),
        (u'aMFNameUTF8String', _Extended_AMFName_aMFNameUTF8String),
        (u'iE-Extensions', _Extended_AMFName_iE_Extensions),
        ])
    Extended_AMFName._ext = []
    
    #-----< Extended-AMFName-ExtIEs >-----#
    Extended_AMFName_ExtIEs = CLASS(name=u'Extended-AMFName-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Extended_AMFName_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedPacketDelayBudget >-----#
    ExtendedPacketDelayBudget = INT(name=u'ExtendedPacketDelayBudget', mode=MODE_TYPE)
    ExtendedPacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< Extended-RANNodeName >-----#
    Extended_RANNodeName = SEQ(name=u'Extended-RANNodeName', mode=MODE_TYPE)
    _Extended_RANNodeName_rANNodeNameVisibleString = STR_VIS(name=u'rANNodeNameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RANNodeNameVisibleString')), opt=True)
    _Extended_RANNodeName_rANNodeNameUTF8String = STR_UTF8(name=u'rANNodeNameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RANNodeNameUTF8String')), opt=True)
    _Extended_RANNodeName_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_RANNodeName_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Extended_RANNodeName_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extended_RANNodeName_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab = ____Extended_RANNodeName_iE_Extensions__item__id_tab
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab_at = None
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extended_RANNodeName_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extended_RANNodeName_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab = ____Extended_RANNodeName_iE_Extensions__item__criticality_tab
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab = ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extended_RANNodeName_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extended_RANNodeName_iE_Extensions__item__id),
        (u'criticality', ___Extended_RANNodeName_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extended_RANNodeName_iE_Extensions__item__extensionValue),
        ])
    __Extended_RANNodeName_iE_Extensions__item_._ext = None
    _Extended_RANNodeName_iE_Extensions._cont = __Extended_RANNodeName_iE_Extensions__item_
    _Extended_RANNodeName_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_RANNodeName._cont = ASN1Dict([
        (u'rANNodeNameVisibleString', _Extended_RANNodeName_rANNodeNameVisibleString),
        (u'rANNodeNameUTF8String', _Extended_RANNodeName_rANNodeNameUTF8String),
        (u'iE-Extensions', _Extended_RANNodeName_iE_Extensions),
        ])
    Extended_RANNodeName._ext = []
    
    #-----< Extended-RANNodeName-ExtIEs >-----#
    Extended_RANNodeName_ExtIEs = CLASS(name=u'Extended-RANNodeName-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Extended_RANNodeName_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedRATRestrictionInformation >-----#
    ExtendedRATRestrictionInformation = SEQ(name=u'ExtendedRATRestrictionInformation', mode=MODE_TYPE)
    _ExtendedRATRestrictionInformation_primaryRATRestriction = BIT_STR(name=u'primaryRATRestriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedRATRestrictionInformation_primaryRATRestriction._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _ExtendedRATRestrictionInformation_secondaryRATRestriction = BIT_STR(name=u'secondaryRATRestriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedRATRestrictionInformation_secondaryRATRestriction._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _ExtendedRATRestrictionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedRATRestrictionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExtendedRATRestrictionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExtendedRATRestrictionInformation_iE_Extensions__item__id),
        (u'criticality', ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue),
        ])
    __ExtendedRATRestrictionInformation_iE_Extensions__item_._ext = None
    _ExtendedRATRestrictionInformation_iE_Extensions._cont = __ExtendedRATRestrictionInformation_iE_Extensions__item_
    _ExtendedRATRestrictionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedRATRestrictionInformation._cont = ASN1Dict([
        (u'primaryRATRestriction', _ExtendedRATRestrictionInformation_primaryRATRestriction),
        (u'secondaryRATRestriction', _ExtendedRATRestrictionInformation_secondaryRATRestriction),
        (u'iE-Extensions', _ExtendedRATRestrictionInformation_iE_Extensions),
        ])
    ExtendedRATRestrictionInformation._ext = []
    
    #-----< ExtendedRATRestrictionInformation-ExtIEs >-----#
    ExtendedRATRestrictionInformation_ExtIEs = CLASS(name=u'ExtendedRATRestrictionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExtendedRATRestrictionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name=u'ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedSliceSupportList >-----#
    ExtendedSliceSupportList = SEQ_OF(name=u'ExtendedSliceSupportList', mode=MODE_TYPE)
    _ExtendedSliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportItem')))
    ExtendedSliceSupportList._cont = _ExtendedSliceSupportList__item_
    ExtendedSliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedUEIdentityIndexValue >-----#
    ExtendedUEIdentityIndexValue = BIT_STR(name=u'ExtendedUEIdentityIndexValue', mode=MODE_TYPE)
    ExtendedUEIdentityIndexValue._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< EventTrigger >-----#
    EventTrigger = CHOICE(name=u'EventTrigger', mode=MODE_TYPE)
    _EventTrigger_outOfCoverage = ENUM(name=u'outOfCoverage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventTrigger_outOfCoverage._cont = ASN1Dict([(u'true', 0)])
    _EventTrigger_outOfCoverage._ext = []
    _EventTrigger_eventL1LoggedMDTConfig = SEQ(name=u'eventL1LoggedMDTConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventL1LoggedMDTConfig')))
    _EventTrigger_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __EventTrigger_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___EventTrigger_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_id._const_tab = ___EventTrigger_choice_Extensions_id_tab
    __EventTrigger_choice_Extensions_id._const_tab_at = None
    __EventTrigger_choice_Extensions_id._const_tab_id = u'id'
    __EventTrigger_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___EventTrigger_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_criticality._const_tab = ___EventTrigger_choice_Extensions_criticality_tab
    __EventTrigger_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __EventTrigger_choice_Extensions_criticality._const_tab_id = u'criticality'
    __EventTrigger_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___EventTrigger_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_value._const_tab = ___EventTrigger_choice_Extensions_value_tab
    __EventTrigger_choice_Extensions_value._const_tab_at = ('..', u'id')
    __EventTrigger_choice_Extensions_value._const_tab_id = u'Value'
    _EventTrigger_choice_Extensions._cont = ASN1Dict([
        (u'id', __EventTrigger_choice_Extensions_id),
        (u'criticality', __EventTrigger_choice_Extensions_criticality),
        (u'value', __EventTrigger_choice_Extensions_value),
        ])
    _EventTrigger_choice_Extensions._ext = None
    EventTrigger._cont = ASN1Dict([
        (u'outOfCoverage', _EventTrigger_outOfCoverage),
        (u'eventL1LoggedMDTConfig', _EventTrigger_eventL1LoggedMDTConfig),
        (u'choice-Extensions', _EventTrigger_choice_Extensions),
        ])
    EventTrigger._ext = None
    
    #-----< EventTrigger-ExtIEs >-----#
    EventTrigger_ExtIEs = CLASS(name=u'EventTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    EventTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventL1LoggedMDTConfig >-----#
    EventL1LoggedMDTConfig = SEQ(name=u'EventL1LoggedMDTConfig', mode=MODE_TYPE)
    _EventL1LoggedMDTConfig_l1Threshold = CHOICE(name=u'l1Threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MeasurementThresholdL1LoggedMDT')))
    _EventL1LoggedMDTConfig_hysteresis = INT(name=u'hysteresis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Hysteresis')))
    _EventL1LoggedMDTConfig_timeToTrigger = ENUM(name=u'timeToTrigger', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeToTrigger')))
    _EventL1LoggedMDTConfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventL1LoggedMDTConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_at = None
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventL1LoggedMDTConfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventL1LoggedMDTConfig_iE_Extensions__item__id),
        (u'criticality', ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue),
        ])
    __EventL1LoggedMDTConfig_iE_Extensions__item_._ext = None
    _EventL1LoggedMDTConfig_iE_Extensions._cont = __EventL1LoggedMDTConfig_iE_Extensions__item_
    _EventL1LoggedMDTConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventL1LoggedMDTConfig._cont = ASN1Dict([
        (u'l1Threshold', _EventL1LoggedMDTConfig_l1Threshold),
        (u'hysteresis', _EventL1LoggedMDTConfig_hysteresis),
        (u'timeToTrigger', _EventL1LoggedMDTConfig_timeToTrigger),
        (u'iE-Extensions', _EventL1LoggedMDTConfig_iE_Extensions),
        ])
    EventL1LoggedMDTConfig._ext = []
    
    #-----< EventL1LoggedMDTConfig-ExtIEs >-----#
    EventL1LoggedMDTConfig_ExtIEs = CLASS(name=u'EventL1LoggedMDTConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EventL1LoggedMDTConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementThresholdL1LoggedMDT >-----#
    MeasurementThresholdL1LoggedMDT = CHOICE(name=u'MeasurementThresholdL1LoggedMDT', mode=MODE_TYPE)
    _MeasurementThresholdL1LoggedMDT_threshold_RSRP = INT(name=u'threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdL1LoggedMDT_threshold_RSRQ = INT(name=u'threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRQ')))
    _MeasurementThresholdL1LoggedMDT_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_at = None
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_id = u'id'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_id = u'criticality'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_at = ('..', u'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_id = u'Value'
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._cont = ASN1Dict([
        (u'id', __MeasurementThresholdL1LoggedMDT_choice_Extensions_id),
        (u'criticality', __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality),
        (u'value', __MeasurementThresholdL1LoggedMDT_choice_Extensions_value),
        ])
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._ext = None
    MeasurementThresholdL1LoggedMDT._cont = ASN1Dict([
        (u'threshold-RSRP', _MeasurementThresholdL1LoggedMDT_threshold_RSRP),
        (u'threshold-RSRQ', _MeasurementThresholdL1LoggedMDT_threshold_RSRQ),
        (u'choice-Extensions', _MeasurementThresholdL1LoggedMDT_choice_Extensions),
        ])
    MeasurementThresholdL1LoggedMDT._ext = None
    
    #-----< MeasurementThresholdL1LoggedMDT-ExtIEs >-----#
    MeasurementThresholdL1LoggedMDT_ExtIEs = CLASS(name=u'MeasurementThresholdL1LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MeasurementThresholdL1LoggedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FailureIndication >-----#
    FailureIndication = SEQ(name=u'FailureIndication', mode=MODE_TYPE)
    _FailureIndication_uERLFReportContainer = CHOICE(name=u'uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')))
    _FailureIndication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FailureIndication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__id._const_tab = ____FailureIndication_iE_Extensions__item__id_tab
    ___FailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___FailureIndication_iE_Extensions__item__id._const_tab_id = u'id'
    ___FailureIndication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__criticality._const_tab = ____FailureIndication_iE_Extensions__item__criticality_tab
    ___FailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FailureIndication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FailureIndication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab = ____FailureIndication_iE_Extensions__item__extensionValue_tab
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FailureIndication_iE_Extensions__item__id),
        (u'criticality', ___FailureIndication_iE_Extensions__item__criticality),
        (u'extensionValue', ___FailureIndication_iE_Extensions__item__extensionValue),
        ])
    __FailureIndication_iE_Extensions__item_._ext = None
    _FailureIndication_iE_Extensions._cont = __FailureIndication_iE_Extensions__item_
    _FailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FailureIndication._cont = ASN1Dict([
        (u'uERLFReportContainer', _FailureIndication_uERLFReportContainer),
        (u'iE-Extensions', _FailureIndication_iE_Extensions),
        ])
    FailureIndication._ext = []
    
    #-----< FailureIndication-ExtIEs >-----#
    FailureIndication_ExtIEs = CLASS(name=u'FailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-S-TMSI >-----#
    FiveG_S_TMSI = SEQ(name=u'FiveG-S-TMSI', mode=MODE_TYPE)
    _FiveG_S_TMSI_aMFSetID = BIT_STR(name=u'aMFSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _FiveG_S_TMSI_aMFPointer = BIT_STR(name=u'aMFPointer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPointer')))
    _FiveG_S_TMSI_fiveG_TMSI = OCT_STR(name=u'fiveG-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveG-TMSI')))
    _FiveG_S_TMSI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveG_S_TMSI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveG_S_TMSI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FiveG_S_TMSI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__id_tab
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab_at = None
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab_id = u'id'
    ___FiveG_S_TMSI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FiveG_S_TMSI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FiveG_S_TMSI_iE_Extensions__item__id),
        (u'criticality', ___FiveG_S_TMSI_iE_Extensions__item__criticality),
        (u'extensionValue', ___FiveG_S_TMSI_iE_Extensions__item__extensionValue),
        ])
    __FiveG_S_TMSI_iE_Extensions__item_._ext = None
    _FiveG_S_TMSI_iE_Extensions._cont = __FiveG_S_TMSI_iE_Extensions__item_
    _FiveG_S_TMSI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveG_S_TMSI._cont = ASN1Dict([
        (u'aMFSetID', _FiveG_S_TMSI_aMFSetID),
        (u'aMFPointer', _FiveG_S_TMSI_aMFPointer),
        (u'fiveG-TMSI', _FiveG_S_TMSI_fiveG_TMSI),
        (u'iE-Extensions', _FiveG_S_TMSI_iE_Extensions),
        ])
    FiveG_S_TMSI._ext = []
    
    #-----< FiveG-S-TMSI-ExtIEs >-----#
    FiveG_S_TMSI_ExtIEs = CLASS(name=u'FiveG-S-TMSI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveG_S_TMSI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-TMSI >-----#
    FiveG_TMSI = OCT_STR(name=u'FiveG-TMSI', mode=MODE_TYPE)
    FiveG_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< FiveQI >-----#
    FiveQI = INT(name=u'FiveQI', mode=MODE_TYPE)
    FiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ForbiddenAreaInformation >-----#
    ForbiddenAreaInformation = SEQ_OF(name=u'ForbiddenAreaInformation', mode=MODE_TYPE)
    _ForbiddenAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenAreaInformation-Item')))
    ForbiddenAreaInformation._cont = _ForbiddenAreaInformation__item_
    ForbiddenAreaInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenAreaInformation-Item >-----#
    ForbiddenAreaInformation_Item = SEQ(name=u'ForbiddenAreaInformation-Item', mode=MODE_TYPE)
    _ForbiddenAreaInformation_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _ForbiddenAreaInformation_Item_forbiddenTACs = SEQ_OF(name=u'forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenTACs')))
    _ForbiddenAreaInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenAreaInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ForbiddenAreaInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ForbiddenAreaInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenAreaInformation_Item_iE_Extensions__item_._ext = None
    _ForbiddenAreaInformation_Item_iE_Extensions._cont = __ForbiddenAreaInformation_Item_iE_Extensions__item_
    _ForbiddenAreaInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenAreaInformation_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _ForbiddenAreaInformation_Item_pLMNIdentity),
        (u'forbiddenTACs', _ForbiddenAreaInformation_Item_forbiddenTACs),
        (u'iE-Extensions', _ForbiddenAreaInformation_Item_iE_Extensions),
        ])
    ForbiddenAreaInformation_Item._ext = []
    
    #-----< ForbiddenAreaInformation-Item-ExtIEs >-----#
    ForbiddenAreaInformation_Item_ExtIEs = CLASS(name=u'ForbiddenAreaInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ForbiddenAreaInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name=u'ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< FromEUTRANtoNGRAN >-----#
    FromEUTRANtoNGRAN = SEQ(name=u'FromEUTRANtoNGRAN', mode=MODE_TYPE)
    _FromEUTRANtoNGRAN_sourceeNBID = SEQ(name=u'sourceeNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONeNBID')))
    _FromEUTRANtoNGRAN_targetNGRANnodeID = SEQ(name=u'targetNGRANnodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONNGRANnodeID')))
    _FromEUTRANtoNGRAN_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FromEUTRANtoNGRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab_at = None
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab_id = u'id'
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FromEUTRANtoNGRAN_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FromEUTRANtoNGRAN_iE_Extensions__item__id),
        (u'criticality', ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality),
        (u'extensionValue', ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue),
        ])
    __FromEUTRANtoNGRAN_iE_Extensions__item_._ext = None
    _FromEUTRANtoNGRAN_iE_Extensions._cont = __FromEUTRANtoNGRAN_iE_Extensions__item_
    _FromEUTRANtoNGRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FromEUTRANtoNGRAN._cont = ASN1Dict([
        (u'sourceeNBID', _FromEUTRANtoNGRAN_sourceeNBID),
        (u'targetNGRANnodeID', _FromEUTRANtoNGRAN_targetNGRANnodeID),
        (u'iE-Extensions', _FromEUTRANtoNGRAN_iE_Extensions),
        ])
    FromEUTRANtoNGRAN._ext = None
    
    #-----< FromEUTRANtoNGRAN-ExtIEs >-----#
    FromEUTRANtoNGRAN_ExtIEs = CLASS(name=u'FromEUTRANtoNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FromEUTRANtoNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FromNGRANtoEUTRAN >-----#
    FromNGRANtoEUTRAN = SEQ(name=u'FromNGRANtoEUTRAN', mode=MODE_TYPE)
    _FromNGRANtoEUTRAN_sourceNGRANnodeID = SEQ(name=u'sourceNGRANnodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONNGRANnodeID')))
    _FromNGRANtoEUTRAN_targeteNBID = SEQ(name=u'targeteNBID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONeNBID')))
    _FromNGRANtoEUTRAN_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FromNGRANtoEUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab_id = u'id'
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FromNGRANtoEUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FromNGRANtoEUTRAN_iE_Extensions__item__id),
        (u'criticality', ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality),
        (u'extensionValue', ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue),
        ])
    __FromNGRANtoEUTRAN_iE_Extensions__item_._ext = None
    _FromNGRANtoEUTRAN_iE_Extensions._cont = __FromNGRANtoEUTRAN_iE_Extensions__item_
    _FromNGRANtoEUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FromNGRANtoEUTRAN._cont = ASN1Dict([
        (u'sourceNGRANnodeID', _FromNGRANtoEUTRAN_sourceNGRANnodeID),
        (u'targeteNBID', _FromNGRANtoEUTRAN_targeteNBID),
        (u'iE-Extensions', _FromNGRANtoEUTRAN_iE_Extensions),
        ])
    FromNGRANtoEUTRAN._ext = None
    
    #-----< FromNGRANtoEUTRAN-ExtIEs >-----#
    FromNGRANtoEUTRAN_ExtIEs = CLASS(name=u'FromNGRANtoEUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FromNGRANtoEUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name=u'GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_maximumFlowBitRateDL = INT(name=u'maximumFlowBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_maximumFlowBitRateUL = INT(name=u'maximumFlowBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_guaranteedFlowBitRateDL = INT(name=u'guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_guaranteedFlowBitRateUL = INT(name=u'guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_notificationControl = ENUM(name=u'notificationControl', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotificationControl')), opt=True)
    _GBR_QosInformation_maximumPacketLossRateDL = INT(name=u'maximumPacketLossRateDL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketLossRate')), opt=True)
    _GBR_QosInformation_maximumPacketLossRateUL = INT(name=u'maximumPacketLossRateUL', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketLossRate')), opt=True)
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QosInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        (u'maximumFlowBitRateDL', _GBR_QosInformation_maximumFlowBitRateDL),
        (u'maximumFlowBitRateUL', _GBR_QosInformation_maximumFlowBitRateUL),
        (u'guaranteedFlowBitRateDL', _GBR_QosInformation_guaranteedFlowBitRateDL),
        (u'guaranteedFlowBitRateUL', _GBR_QosInformation_guaranteedFlowBitRateUL),
        (u'notificationControl', _GBR_QosInformation_notificationControl),
        (u'maximumPacketLossRateDL', _GBR_QosInformation_maximumPacketLossRateDL),
        (u'maximumPacketLossRateUL', _GBR_QosInformation_maximumPacketLossRateUL),
        (u'iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name=u'GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _GBR_QosInformation_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _GBR_QosInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GlobalCable-ID >-----#
    GlobalCable_ID = OCT_STR(name=u'GlobalCable-ID', mode=MODE_TYPE)
    
    #-----< GlobalENB-ID >-----#
    GlobalENB_ID = SEQ(name=u'GlobalENB-ID', mode=MODE_TYPE)
    _GlobalENB_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalENB_ID_eNB_ID = CHOICE(name=u'eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ENB-ID')))
    _GlobalENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalENB_ID_iE_Extensions__item__criticality_tab
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalENB_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalENB_ID_iE_Extensions__item_._ext = None
    _GlobalENB_ID_iE_Extensions._cont = __GlobalENB_ID_iE_Extensions__item_
    _GlobalENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalENB_ID._cont = ASN1Dict([
        (u'pLMNidentity', _GlobalENB_ID_pLMNidentity),
        (u'eNB-ID', _GlobalENB_ID_eNB_ID),
        (u'iE-Extensions', _GlobalENB_ID_iE_Extensions),
        ])
    GlobalENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name=u'GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalGNB-ID >-----#
    GlobalGNB_ID = SEQ(name=u'GlobalGNB-ID', mode=MODE_TYPE)
    _GlobalGNB_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalGNB_ID_gNB_ID = CHOICE(name=u'gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GNB-ID')))
    _GlobalGNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalGNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalGNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab = ____GlobalGNB_ID_iE_Extensions__item__id_tab
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalGNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalGNB_ID_iE_Extensions__item__criticality_tab
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalGNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalGNB_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalGNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalGNB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalGNB_ID_iE_Extensions__item_._ext = None
    _GlobalGNB_ID_iE_Extensions._cont = __GlobalGNB_ID_iE_Extensions__item_
    _GlobalGNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalGNB_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalGNB_ID_pLMNIdentity),
        (u'gNB-ID', _GlobalGNB_ID_gNB_ID),
        (u'iE-Extensions', _GlobalGNB_ID_iE_Extensions),
        ])
    GlobalGNB_ID._ext = []
    
    #-----< GlobalGNB-ID-ExtIEs >-----#
    GlobalGNB_ID_ExtIEs = CLASS(name=u'GlobalGNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalGNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalN3IWF-ID >-----#
    GlobalN3IWF_ID = SEQ(name=u'GlobalN3IWF-ID', mode=MODE_TYPE)
    _GlobalN3IWF_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalN3IWF_ID_n3IWF_ID = CHOICE(name=u'n3IWF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'N3IWF-ID')))
    _GlobalN3IWF_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalN3IWF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalN3IWF_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalN3IWF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__id_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalN3IWF_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalN3IWF_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalN3IWF_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalN3IWF_ID_iE_Extensions__item_._ext = None
    _GlobalN3IWF_ID_iE_Extensions._cont = __GlobalN3IWF_ID_iE_Extensions__item_
    _GlobalN3IWF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalN3IWF_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalN3IWF_ID_pLMNIdentity),
        (u'n3IWF-ID', _GlobalN3IWF_ID_n3IWF_ID),
        (u'iE-Extensions', _GlobalN3IWF_ID_iE_Extensions),
        ])
    GlobalN3IWF_ID._ext = []
    
    #-----< GlobalN3IWF-ID-ExtIEs >-----#
    GlobalN3IWF_ID_ExtIEs = CLASS(name=u'GlobalN3IWF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalN3IWF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalLine-ID >-----#
    GlobalLine_ID = SEQ(name=u'GlobalLine-ID', mode=MODE_TYPE)
    _GlobalLine_ID_globalLineIdentity = OCT_STR(name=u'globalLineIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalLineIdentity')))
    _GlobalLine_ID_lineType = ENUM(name=u'lineType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LineType')), opt=True)
    _GlobalLine_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalLine_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalLine_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalLine_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalLine_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab = ____GlobalLine_ID_iE_Extensions__item__id_tab
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalLine_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalLine_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalLine_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab = ____GlobalLine_ID_iE_Extensions__item__criticality_tab
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalLine_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalLine_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalLine_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalLine_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalLine_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalLine_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalLine_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalLine_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalLine_ID_iE_Extensions__item_._ext = None
    _GlobalLine_ID_iE_Extensions._cont = __GlobalLine_ID_iE_Extensions__item_
    _GlobalLine_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalLine_ID._cont = ASN1Dict([
        (u'globalLineIdentity', _GlobalLine_ID_globalLineIdentity),
        (u'lineType', _GlobalLine_ID_lineType),
        (u'iE-Extensions', _GlobalLine_ID_iE_Extensions),
        ])
    GlobalLine_ID._ext = []
    
    #-----< GlobalLine-ID-ExtIEs >-----#
    GlobalLine_ID_ExtIEs = CLASS(name=u'GlobalLine-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalLine_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalLineIdentity >-----#
    GlobalLineIdentity = OCT_STR(name=u'GlobalLineIdentity', mode=MODE_TYPE)
    
    #-----< GlobalNgENB-ID >-----#
    GlobalNgENB_ID = SEQ(name=u'GlobalNgENB-ID', mode=MODE_TYPE)
    _GlobalNgENB_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalNgENB_ID_ngENB_ID = CHOICE(name=u'ngENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NgENB-ID')))
    _GlobalNgENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalNgENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalNgENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalNgENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__id_tab
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalNgENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalNgENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalNgENB_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalNgENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalNgENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalNgENB_ID_iE_Extensions__item_._ext = None
    _GlobalNgENB_ID_iE_Extensions._cont = __GlobalNgENB_ID_iE_Extensions__item_
    _GlobalNgENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalNgENB_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalNgENB_ID_pLMNIdentity),
        (u'ngENB-ID', _GlobalNgENB_ID_ngENB_ID),
        (u'iE-Extensions', _GlobalNgENB_ID_iE_Extensions),
        ])
    GlobalNgENB_ID._ext = []
    
    #-----< GlobalNgENB-ID-ExtIEs >-----#
    GlobalNgENB_ID_ExtIEs = CLASS(name=u'GlobalNgENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalNgENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalRANNodeID >-----#
    GlobalRANNodeID = CHOICE(name=u'GlobalRANNodeID', mode=MODE_TYPE)
    _GlobalRANNodeID_globalGNB_ID = SEQ(name=u'globalGNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalGNB-ID')))
    _GlobalRANNodeID_globalNgENB_ID = SEQ(name=u'globalNgENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalNgENB-ID')))
    _GlobalRANNodeID_globalN3IWF_ID = SEQ(name=u'globalN3IWF-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalN3IWF-ID')))
    _GlobalRANNodeID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __GlobalRANNodeID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___GlobalRANNodeID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTNGF-ID')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTWIF-ID')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalW-AGF-ID')))
    ___GlobalRANNodeID_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'reject'), (u'Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 241), (u'criticality', u'reject'), (u'Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'reject'), (u'Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __GlobalRANNodeID_choice_Extensions_id._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_id._const_tab_at = None
    __GlobalRANNodeID_choice_Extensions_id._const_tab_id = u'id'
    __GlobalRANNodeID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __GlobalRANNodeID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __GlobalRANNodeID_choice_Extensions_value._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __GlobalRANNodeID_choice_Extensions_value._const_tab_id = u'Value'
    _GlobalRANNodeID_choice_Extensions._cont = ASN1Dict([
        (u'id', __GlobalRANNodeID_choice_Extensions_id),
        (u'criticality', __GlobalRANNodeID_choice_Extensions_criticality),
        (u'value', __GlobalRANNodeID_choice_Extensions_value),
        ])
    _GlobalRANNodeID_choice_Extensions._ext = None
    GlobalRANNodeID._cont = ASN1Dict([
        (u'globalGNB-ID', _GlobalRANNodeID_globalGNB_ID),
        (u'globalNgENB-ID', _GlobalRANNodeID_globalNgENB_ID),
        (u'globalN3IWF-ID', _GlobalRANNodeID_globalN3IWF_ID),
        (u'choice-Extensions', _GlobalRANNodeID_choice_Extensions),
        ])
    GlobalRANNodeID._ext = None
    
    #-----< GlobalRANNodeID-ExtIEs >-----#
    GlobalRANNodeID_ExtIEs = CLASS(name=u'GlobalRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _GlobalRANNodeID_ExtIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTNGF-ID')))
    _GlobalRANNodeID_ExtIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTWIF-ID')))
    _GlobalRANNodeID_ExtIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalW-AGF-ID')))
    GlobalRANNodeID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'reject'), (u'Value', _GlobalRANNodeID_ExtIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 241), (u'criticality', u'reject'), (u'Value', _GlobalRANNodeID_ExtIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'reject'), (u'Value', _GlobalRANNodeID_ExtIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GlobalTNGF-ID >-----#
    GlobalTNGF_ID = SEQ(name=u'GlobalTNGF-ID', mode=MODE_TYPE)
    _GlobalTNGF_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalTNGF_ID_tNGF_ID = CHOICE(name=u'tNGF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNGF-ID')))
    _GlobalTNGF_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalTNGF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalTNGF_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalTNGF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__id_tab
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalTNGF_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalTNGF_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalTNGF_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalTNGF_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalTNGF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalTNGF_ID_iE_Extensions__item_._ext = None
    _GlobalTNGF_ID_iE_Extensions._cont = __GlobalTNGF_ID_iE_Extensions__item_
    _GlobalTNGF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalTNGF_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalTNGF_ID_pLMNIdentity),
        (u'tNGF-ID', _GlobalTNGF_ID_tNGF_ID),
        (u'iE-Extensions', _GlobalTNGF_ID_iE_Extensions),
        ])
    GlobalTNGF_ID._ext = []
    
    #-----< GlobalTNGF-ID-ExtIEs >-----#
    GlobalTNGF_ID_ExtIEs = CLASS(name=u'GlobalTNGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalTNGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalTWIF-ID >-----#
    GlobalTWIF_ID = SEQ(name=u'GlobalTWIF-ID', mode=MODE_TYPE)
    _GlobalTWIF_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalTWIF_ID_tWIF_ID = CHOICE(name=u'tWIF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TWIF-ID')))
    _GlobalTWIF_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalTWIF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalTWIF_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalTWIF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__id_tab
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalTWIF_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalTWIF_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalTWIF_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalTWIF_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalTWIF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalTWIF_ID_iE_Extensions__item_._ext = None
    _GlobalTWIF_ID_iE_Extensions._cont = __GlobalTWIF_ID_iE_Extensions__item_
    _GlobalTWIF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalTWIF_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalTWIF_ID_pLMNIdentity),
        (u'tWIF-ID', _GlobalTWIF_ID_tWIF_ID),
        (u'iE-Extensions', _GlobalTWIF_ID_iE_Extensions),
        ])
    GlobalTWIF_ID._ext = []
    
    #-----< GlobalTWIF-ID-ExtIEs >-----#
    GlobalTWIF_ID_ExtIEs = CLASS(name=u'GlobalTWIF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalTWIF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalW-AGF-ID >-----#
    GlobalW_AGF_ID = SEQ(name=u'GlobalW-AGF-ID', mode=MODE_TYPE)
    _GlobalW_AGF_ID_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalW_AGF_ID_w_AGF_ID = CHOICE(name=u'w-AGF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'W-AGF-ID')))
    _GlobalW_AGF_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalW_AGF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalW_AGF_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalW_AGF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__id_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalW_AGF_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalW_AGF_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalW_AGF_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalW_AGF_ID_iE_Extensions__item_._ext = None
    _GlobalW_AGF_ID_iE_Extensions._cont = __GlobalW_AGF_ID_iE_Extensions__item_
    _GlobalW_AGF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalW_AGF_ID._cont = ASN1Dict([
        (u'pLMNIdentity', _GlobalW_AGF_ID_pLMNIdentity),
        (u'w-AGF-ID', _GlobalW_AGF_ID_w_AGF_ID),
        (u'iE-Extensions', _GlobalW_AGF_ID_iE_Extensions),
        ])
    GlobalW_AGF_ID._ext = []
    
    #-----< GlobalW-AGF-ID-ExtIEs >-----#
    GlobalW_AGF_ID_ExtIEs = CLASS(name=u'GlobalW-AGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalW_AGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-ID >-----#
    GNB_ID = CHOICE(name=u'GNB-ID', mode=MODE_TYPE)
    _GNB_ID_gNB_ID = BIT_STR(name=u'gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNB_ID_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    _GNB_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___GNB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_id._const_tab = ___GNB_ID_choice_Extensions_id_tab
    __GNB_ID_choice_Extensions_id._const_tab_at = None
    __GNB_ID_choice_Extensions_id._const_tab_id = u'id'
    __GNB_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___GNB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_criticality._const_tab = ___GNB_ID_choice_Extensions_criticality_tab
    __GNB_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __GNB_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __GNB_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___GNB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_value._const_tab = ___GNB_ID_choice_Extensions_value_tab
    __GNB_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __GNB_ID_choice_Extensions_value._const_tab_id = u'Value'
    _GNB_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __GNB_ID_choice_Extensions_id),
        (u'criticality', __GNB_ID_choice_Extensions_criticality),
        (u'value', __GNB_ID_choice_Extensions_value),
        ])
    _GNB_ID_choice_Extensions._ext = None
    GNB_ID._cont = ASN1Dict([
        (u'gNB-ID', _GNB_ID_gNB_ID),
        (u'choice-Extensions', _GNB_ID_choice_Extensions),
        ])
    GNB_ID._ext = None
    
    #-----< GNB-ID-ExtIEs >-----#
    GNB_ID_ExtIEs = CLASS(name=u'GNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    GNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name=u'GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GTPTunnel >-----#
    GTPTunnel = SEQ(name=u'GTPTunnel', mode=MODE_TYPE)
    _GTPTunnel_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _GTPTunnel_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GTP-TEID')))
    _GTPTunnel_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTunnel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GTPTunnel_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GTPTunnel_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__id._const_tab = ____GTPTunnel_iE_Extensions__item__id_tab
    ___GTPTunnel_iE_Extensions__item__id._const_tab_at = None
    ___GTPTunnel_iE_Extensions__item__id._const_tab_id = u'id'
    ___GTPTunnel_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GTPTunnel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab = ____GTPTunnel_iE_Extensions__item__criticality_tab
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GTPTunnel_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab = ____GTPTunnel_iE_Extensions__item__extensionValue_tab
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GTPTunnel_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GTPTunnel_iE_Extensions__item__id),
        (u'criticality', ___GTPTunnel_iE_Extensions__item__criticality),
        (u'extensionValue', ___GTPTunnel_iE_Extensions__item__extensionValue),
        ])
    __GTPTunnel_iE_Extensions__item_._ext = None
    _GTPTunnel_iE_Extensions._cont = __GTPTunnel_iE_Extensions__item_
    _GTPTunnel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTunnel._cont = ASN1Dict([
        (u'transportLayerAddress', _GTPTunnel_transportLayerAddress),
        (u'gTP-TEID', _GTPTunnel_gTP_TEID),
        (u'iE-Extensions', _GTPTunnel_iE_Extensions),
        ])
    GTPTunnel._ext = []
    
    #-----< GTPTunnel-ExtIEs >-----#
    GTPTunnel_ExtIEs = CLASS(name=u'GTPTunnel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GTPTunnel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUAMI >-----#
    GUAMI = SEQ(name=u'GUAMI', mode=MODE_TYPE)
    _GUAMI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GUAMI_aMFRegionID = BIT_STR(name=u'aMFRegionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFRegionID')))
    _GUAMI_aMFSetID = BIT_STR(name=u'aMFSetID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _GUAMI_aMFPointer = BIT_STR(name=u'aMFPointer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPointer')))
    _GUAMI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUAMI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GUAMI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GUAMI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__id._const_tab = ____GUAMI_iE_Extensions__item__id_tab
    ___GUAMI_iE_Extensions__item__id._const_tab_at = None
    ___GUAMI_iE_Extensions__item__id._const_tab_id = u'id'
    ___GUAMI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GUAMI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__criticality._const_tab = ____GUAMI_iE_Extensions__item__criticality_tab
    ___GUAMI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GUAMI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GUAMI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GUAMI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab = ____GUAMI_iE_Extensions__item__extensionValue_tab
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GUAMI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GUAMI_iE_Extensions__item__id),
        (u'criticality', ___GUAMI_iE_Extensions__item__criticality),
        (u'extensionValue', ___GUAMI_iE_Extensions__item__extensionValue),
        ])
    __GUAMI_iE_Extensions__item_._ext = None
    _GUAMI_iE_Extensions._cont = __GUAMI_iE_Extensions__item_
    _GUAMI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUAMI._cont = ASN1Dict([
        (u'pLMNIdentity', _GUAMI_pLMNIdentity),
        (u'aMFRegionID', _GUAMI_aMFRegionID),
        (u'aMFSetID', _GUAMI_aMFSetID),
        (u'aMFPointer', _GUAMI_aMFPointer),
        (u'iE-Extensions', _GUAMI_iE_Extensions),
        ])
    GUAMI._ext = []
    
    #-----< GUAMI-ExtIEs >-----#
    GUAMI_ExtIEs = CLASS(name=u'GUAMI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GUAMI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUAMIType >-----#
    GUAMIType = ENUM(name=u'GUAMIType', mode=MODE_TYPE)
    GUAMIType._cont = ASN1Dict([(u'native', 0), (u'mapped', 1)])
    GUAMIType._ext = []
    
    #-----< HandoverCommandTransfer >-----#
    HandoverCommandTransfer = SEQ(name=u'HandoverCommandTransfer', mode=MODE_TYPE)
    _HandoverCommandTransfer_dLForwardingUP_TNLInformation = CHOICE(name=u'dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _HandoverCommandTransfer_qosFlowToBeForwardedList = SEQ_OF(name=u'qosFlowToBeForwardedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowToBeForwardedList')), opt=True)
    _HandoverCommandTransfer_dataForwardingResponseDRBList = SEQ_OF(name=u'dataForwardingResponseDRBList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBList')), opt=True)
    _HandoverCommandTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverCommandTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverCommandTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverCommandTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    ____HandoverCommandTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverCommandTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverCommandTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverCommandTransfer_iE_Extensions__item__id),
        (u'criticality', ___HandoverCommandTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverCommandTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverCommandTransfer_iE_Extensions__item_._ext = None
    _HandoverCommandTransfer_iE_Extensions._cont = __HandoverCommandTransfer_iE_Extensions__item_
    _HandoverCommandTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverCommandTransfer._cont = ASN1Dict([
        (u'dLForwardingUP-TNLInformation', _HandoverCommandTransfer_dLForwardingUP_TNLInformation),
        (u'qosFlowToBeForwardedList', _HandoverCommandTransfer_qosFlowToBeForwardedList),
        (u'dataForwardingResponseDRBList', _HandoverCommandTransfer_dataForwardingResponseDRBList),
        (u'iE-Extensions', _HandoverCommandTransfer_iE_Extensions),
        ])
    HandoverCommandTransfer._ext = []
    
    #-----< HandoverCommandTransfer-ExtIEs >-----#
    HandoverCommandTransfer_ExtIEs = CLASS(name=u'HandoverCommandTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    HandoverCommandTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverFlag >-----#
    HandoverFlag = ENUM(name=u'HandoverFlag', mode=MODE_TYPE)
    HandoverFlag._cont = ASN1Dict([(u'handover-preparation', 0)])
    HandoverFlag._ext = []
    
    #-----< HandoverPreparationUnsuccessfulTransfer >-----#
    HandoverPreparationUnsuccessfulTransfer = SEQ(name=u'HandoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE)
    _HandoverPreparationUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions._cont = __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverPreparationUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _HandoverPreparationUnsuccessfulTransfer_cause),
        (u'iE-Extensions', _HandoverPreparationUnsuccessfulTransfer_iE_Extensions),
        ])
    HandoverPreparationUnsuccessfulTransfer._ext = []
    
    #-----< HandoverPreparationUnsuccessfulTransfer-ExtIEs >-----#
    HandoverPreparationUnsuccessfulTransfer_ExtIEs = CLASS(name=u'HandoverPreparationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverPreparationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledgeTransfer >-----#
    HandoverRequestAcknowledgeTransfer = SEQ(name=u'HandoverRequestAcknowledgeTransfer', mode=MODE_TYPE)
    _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation = CHOICE(name=u'dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation = CHOICE(name=u'dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _HandoverRequestAcknowledgeTransfer_securityResult = SEQ(name=u'securityResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')), opt=True)
    _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList = SEQ_OF(name=u'qosFlowSetupResponseList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithDataForwarding')))
    _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList = SEQ_OF(name=u'qosFlowFailedToSetupList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList = SEQ_OF(name=u'dataForwardingResponseDRBList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBList')), opt=True)
    _HandoverRequestAcknowledgeTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id),
        (u'criticality', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_._ext = None
    _HandoverRequestAcknowledgeTransfer_iE_Extensions._cont = __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_
    _HandoverRequestAcknowledgeTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledgeTransfer._cont = ASN1Dict([
        (u'dL-NGU-UP-TNLInformation', _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation),
        (u'dLForwardingUP-TNLInformation', _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation),
        (u'securityResult', _HandoverRequestAcknowledgeTransfer_securityResult),
        (u'qosFlowSetupResponseList', _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList),
        (u'qosFlowFailedToSetupList', _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList),
        (u'dataForwardingResponseDRBList', _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList),
        (u'iE-Extensions', _HandoverRequestAcknowledgeTransfer_iE_Extensions),
        ])
    HandoverRequestAcknowledgeTransfer._ext = []
    
    #-----< HandoverRequestAcknowledgeTransfer-ExtIEs >-----#
    HandoverRequestAcknowledgeTransfer_ExtIEs = CLASS(name=u'HandoverRequestAcknowledgeTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    HandoverRequestAcknowledgeTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequiredTransfer >-----#
    HandoverRequiredTransfer = SEQ(name=u'HandoverRequiredTransfer', mode=MODE_TYPE)
    _HandoverRequiredTransfer_directForwardingPathAvailability = ENUM(name=u'directForwardingPathAvailability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')), opt=True)
    _HandoverRequiredTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRequiredTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverRequiredTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverRequiredTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__id_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverRequiredTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequiredTransfer_iE_Extensions__item__id),
        (u'criticality', ___HandoverRequiredTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverRequiredTransfer_iE_Extensions__item_._ext = None
    _HandoverRequiredTransfer_iE_Extensions._cont = __HandoverRequiredTransfer_iE_Extensions__item_
    _HandoverRequiredTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRequiredTransfer._cont = ASN1Dict([
        (u'directForwardingPathAvailability', _HandoverRequiredTransfer_directForwardingPathAvailability),
        (u'iE-Extensions', _HandoverRequiredTransfer_iE_Extensions),
        ])
    HandoverRequiredTransfer._ext = []
    
    #-----< HandoverRequiredTransfer-ExtIEs >-----#
    HandoverRequiredTransfer_ExtIEs = CLASS(name=u'HandoverRequiredTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverRequiredTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverResourceAllocationUnsuccessfulTransfer >-----#
    HandoverResourceAllocationUnsuccessfulTransfer = SEQ(name=u'HandoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE)
    _HandoverResourceAllocationUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name=u'criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions._cont = __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverResourceAllocationUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _HandoverResourceAllocationUnsuccessfulTransfer_cause),
        (u'criticalityDiagnostics', _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics),
        (u'iE-Extensions', _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions),
        ])
    HandoverResourceAllocationUnsuccessfulTransfer._ext = []
    
    #-----< HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs >-----#
    HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs = CLASS(name=u'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverType >-----#
    HandoverType = ENUM(name=u'HandoverType', mode=MODE_TYPE)
    HandoverType._cont = ASN1Dict([(u'intra5gs', 0), (u'fivegs-to-eps', 1), (u'eps-to-5gs', 2), (u'fivegs-to-utran', 3)])
    HandoverType._ext = [u'fivegs-to-utran']
    
    #-----< HFCNode-ID >-----#
    HFCNode_ID = OCT_STR(name=u'HFCNode-ID', mode=MODE_TYPE)
    
    #-----< HOReport >-----#
    HOReport = SEQ(name=u'HOReport', mode=MODE_TYPE)
    _HOReport_handoverReportType = ENUM(name=u'handoverReportType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HOReport_handoverReportType._cont = ASN1Dict([(u'ho-too-early', 0), (u'ho-to-wrong-cell', 1), (u'intersystem-ping-pong', 2)])
    _HOReport_handoverReportType._ext = []
    _HOReport_handoverCause = CHOICE(name=u'handoverCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HOReport_sourcecellCGI = CHOICE(name=u'sourcecellCGI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _HOReport_targetcellCGI = CHOICE(name=u'targetcellCGI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _HOReport_reestablishmentcellCGI = CHOICE(name=u'reestablishmentcellCGI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')), opt=True)
    _HOReport_sourcecellC_RNTI = BIT_STR(name=u'sourcecellC-RNTI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HOReport_sourcecellC_RNTI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _HOReport_targetcellinE_UTRAN = SEQ(name=u'targetcellinE-UTRAN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')), opt=True)
    _HOReport_mobilityInformation = BIT_STR(name=u'mobilityInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MobilityInformation')), opt=True)
    _HOReport_uERLFReportContainer = CHOICE(name=u'uERLFReportContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _HOReport_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HOReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HOReport_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HOReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__id._const_tab = ____HOReport_iE_Extensions__item__id_tab
    ___HOReport_iE_Extensions__item__id._const_tab_at = None
    ___HOReport_iE_Extensions__item__id._const_tab_id = u'id'
    ___HOReport_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HOReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__criticality._const_tab = ____HOReport_iE_Extensions__item__criticality_tab
    ___HOReport_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HOReport_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HOReport_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HOReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__extensionValue._const_tab = ____HOReport_iE_Extensions__item__extensionValue_tab
    ___HOReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HOReport_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HOReport_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HOReport_iE_Extensions__item__id),
        (u'criticality', ___HOReport_iE_Extensions__item__criticality),
        (u'extensionValue', ___HOReport_iE_Extensions__item__extensionValue),
        ])
    __HOReport_iE_Extensions__item_._ext = None
    _HOReport_iE_Extensions._cont = __HOReport_iE_Extensions__item_
    _HOReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HOReport._cont = ASN1Dict([
        (u'handoverReportType', _HOReport_handoverReportType),
        (u'handoverCause', _HOReport_handoverCause),
        (u'sourcecellCGI', _HOReport_sourcecellCGI),
        (u'targetcellCGI', _HOReport_targetcellCGI),
        (u'reestablishmentcellCGI', _HOReport_reestablishmentcellCGI),
        (u'sourcecellC-RNTI', _HOReport_sourcecellC_RNTI),
        (u'targetcellinE-UTRAN', _HOReport_targetcellinE_UTRAN),
        (u'mobilityInformation', _HOReport_mobilityInformation),
        (u'uERLFReportContainer', _HOReport_uERLFReportContainer),
        (u'iE-Extensions', _HOReport_iE_Extensions),
        ])
    HOReport._ext = []
    
    #-----< HOReport-ExtIEs >-----#
    HOReport_ExtIEs = CLASS(name=u'HOReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HOReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Hysteresis >-----#
    Hysteresis = INT(name=u'Hysteresis', mode=MODE_TYPE)
    Hysteresis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    
    #-----< IAB-Authorized >-----#
    IAB_Authorized = ENUM(name=u'IAB-Authorized', mode=MODE_TYPE)
    IAB_Authorized._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    IAB_Authorized._ext = []
    
    #-----< IAB-Supported >-----#
    IAB_Supported = ENUM(name=u'IAB-Supported', mode=MODE_TYPE)
    IAB_Supported._cont = ASN1Dict([(u'true', 0)])
    IAB_Supported._ext = []
    
    #-----< IABNodeIndication >-----#
    IABNodeIndication = ENUM(name=u'IABNodeIndication', mode=MODE_TYPE)
    IABNodeIndication._cont = ASN1Dict([(u'true', 0)])
    IABNodeIndication._ext = []
    
    #-----< IMSVoiceSupportIndicator >-----#
    IMSVoiceSupportIndicator = ENUM(name=u'IMSVoiceSupportIndicator', mode=MODE_TYPE)
    IMSVoiceSupportIndicator._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    IMSVoiceSupportIndicator._ext = []
    
    #-----< IndexToRFSP >-----#
    IndexToRFSP = INT(name=u'IndexToRFSP', mode=MODE_TYPE)
    IndexToRFSP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< InfoOnRecommendedCellsAndRANNodesForPaging >-----#
    InfoOnRecommendedCellsAndRANNodesForPaging = SEQ(name=u'InfoOnRecommendedCellsAndRANNodesForPaging', mode=MODE_TYPE)
    _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging = SEQ(name=u'recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellsForPaging')))
    _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging = SEQ(name=u'recommendRANNodesForPaging', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodesForPaging')))
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab_at = None
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id),
        (u'criticality', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue),
        ])
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_._ext = None
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions._cont = __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InfoOnRecommendedCellsAndRANNodesForPaging._cont = ASN1Dict([
        (u'recommendedCellsForPaging', _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging),
        (u'recommendRANNodesForPaging', _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging),
        (u'iE-Extensions', _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions),
        ])
    InfoOnRecommendedCellsAndRANNodesForPaging._ext = []
    
    #-----< InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs >-----#
    InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs = CLASS(name=u'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionIndication >-----#
    IntegrityProtectionIndication = ENUM(name=u'IntegrityProtectionIndication', mode=MODE_TYPE)
    IntegrityProtectionIndication._cont = ASN1Dict([(u'required', 0), (u'preferred', 1), (u'not-needed', 2)])
    IntegrityProtectionIndication._ext = []
    
    #-----< IntegrityProtectionResult >-----#
    IntegrityProtectionResult = ENUM(name=u'IntegrityProtectionResult', mode=MODE_TYPE)
    IntegrityProtectionResult._cont = ASN1Dict([(u'performed', 0), (u'not-performed', 1)])
    IntegrityProtectionResult._ext = []
    
    #-----< IntendedNumberOfPagingAttempts >-----#
    IntendedNumberOfPagingAttempts = INT(name=u'IntendedNumberOfPagingAttempts', mode=MODE_TYPE)
    IntendedNumberOfPagingAttempts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name=u'InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< ImmediateMDTNr >-----#
    ImmediateMDTNr = SEQ(name=u'ImmediateMDTNr', mode=MODE_TYPE)
    _ImmediateMDTNr_measurementsToActivate = BIT_STR(name=u'measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDTNr_m1Configuration = SEQ(name=u'm1Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1Configuration')), opt=True)
    _ImmediateMDTNr_m4Configuration = SEQ(name=u'm4Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M4Configuration')), opt=True)
    _ImmediateMDTNr_m5Configuration = SEQ(name=u'm5Configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M5Configuration')), opt=True)
    _ImmediateMDTNr_m6Configuration = SEQ(name=u'm6Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M6Configuration')), opt=True)
    _ImmediateMDTNr_m7Configuration = SEQ(name=u'm7Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M7Configuration')), opt=True)
    _ImmediateMDTNr_bluetoothMeasurementConfiguration = SEQ(name=u'bluetoothMeasurementConfiguration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_wLANMeasurementConfiguration = SEQ(name=u'wLANMeasurementConfiguration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_mDT_Location_Info = SEQ(name=u'mDT-Location-Info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Location-Info')), opt=True)
    _ImmediateMDTNr_sensorMeasurementConfiguration = SEQ(name=u'sensorMeasurementConfiguration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDTNr_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDTNr_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ImmediateMDTNr_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab = ____ImmediateMDTNr_iE_Extensions__item__id_tab
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab_id = u'id'
    ___ImmediateMDTNr_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ImmediateMDTNr_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab = ____ImmediateMDTNr_iE_Extensions__item__criticality_tab
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ImmediateMDTNr_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ImmediateMDTNr_iE_Extensions__item__id),
        (u'criticality', ___ImmediateMDTNr_iE_Extensions__item__criticality),
        (u'extensionValue', ___ImmediateMDTNr_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDTNr_iE_Extensions__item_._ext = None
    _ImmediateMDTNr_iE_Extensions._cont = __ImmediateMDTNr_iE_Extensions__item_
    _ImmediateMDTNr_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDTNr._cont = ASN1Dict([
        (u'measurementsToActivate', _ImmediateMDTNr_measurementsToActivate),
        (u'm1Configuration', _ImmediateMDTNr_m1Configuration),
        (u'm4Configuration', _ImmediateMDTNr_m4Configuration),
        (u'm5Configuration', _ImmediateMDTNr_m5Configuration),
        (u'm6Configuration', _ImmediateMDTNr_m6Configuration),
        (u'm7Configuration', _ImmediateMDTNr_m7Configuration),
        (u'bluetoothMeasurementConfiguration', _ImmediateMDTNr_bluetoothMeasurementConfiguration),
        (u'wLANMeasurementConfiguration', _ImmediateMDTNr_wLANMeasurementConfiguration),
        (u'mDT-Location-Info', _ImmediateMDTNr_mDT_Location_Info),
        (u'sensorMeasurementConfiguration', _ImmediateMDTNr_sensorMeasurementConfiguration),
        (u'iE-Extensions', _ImmediateMDTNr_iE_Extensions),
        ])
    ImmediateMDTNr._ext = []
    
    #-----< ImmediateMDTNr-ExtIEs >-----#
    ImmediateMDTNr_ExtIEs = CLASS(name=u'ImmediateMDTNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ImmediateMDTNr_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemFailureIndication >-----#
    InterSystemFailureIndication = SEQ(name=u'InterSystemFailureIndication', mode=MODE_TYPE)
    _InterSystemFailureIndication_uERLFReportContainer = CHOICE(name=u'uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _InterSystemFailureIndication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemFailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemFailureIndication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterSystemFailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__id_tab
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterSystemFailureIndication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterSystemFailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterSystemFailureIndication_iE_Extensions__item__id),
        (u'criticality', ___InterSystemFailureIndication_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterSystemFailureIndication_iE_Extensions__item__extensionValue),
        ])
    __InterSystemFailureIndication_iE_Extensions__item_._ext = None
    _InterSystemFailureIndication_iE_Extensions._cont = __InterSystemFailureIndication_iE_Extensions__item_
    _InterSystemFailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemFailureIndication._cont = ASN1Dict([
        (u'uERLFReportContainer', _InterSystemFailureIndication_uERLFReportContainer),
        (u'iE-Extensions', _InterSystemFailureIndication_iE_Extensions),
        ])
    InterSystemFailureIndication._ext = []
    
    #-----< InterSystemFailureIndication-ExtIEs >-----#
    InterSystemFailureIndication_ExtIEs = CLASS(name=u'InterSystemFailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InterSystemFailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONConfigurationTransfer >-----#
    IntersystemSONConfigurationTransfer = SEQ(name=u'IntersystemSONConfigurationTransfer', mode=MODE_TYPE)
    _IntersystemSONConfigurationTransfer_transferType = CHOICE(name=u'transferType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONTransferType')))
    _IntersystemSONConfigurationTransfer_intersystemSONInformation = CHOICE(name=u'intersystemSONInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformation')))
    _IntersystemSONConfigurationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id),
        (u'criticality', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_._ext = None
    _IntersystemSONConfigurationTransfer_iE_Extensions._cont = __IntersystemSONConfigurationTransfer_iE_Extensions__item_
    _IntersystemSONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONConfigurationTransfer._cont = ASN1Dict([
        (u'transferType', _IntersystemSONConfigurationTransfer_transferType),
        (u'intersystemSONInformation', _IntersystemSONConfigurationTransfer_intersystemSONInformation),
        (u'iE-Extensions', _IntersystemSONConfigurationTransfer_iE_Extensions),
        ])
    IntersystemSONConfigurationTransfer._ext = []
    
    #-----< IntersystemSONConfigurationTransfer-ExtIEs >-----#
    IntersystemSONConfigurationTransfer_ExtIEs = CLASS(name=u'IntersystemSONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONTransferType >-----#
    IntersystemSONTransferType = CHOICE(name=u'IntersystemSONTransferType', mode=MODE_TYPE)
    _IntersystemSONTransferType_fromEUTRANtoNGRAN = SEQ(name=u'fromEUTRANtoNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FromEUTRANtoNGRAN')))
    _IntersystemSONTransferType_fromNGRANtoEUTRAN = SEQ(name=u'fromNGRANtoEUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FromNGRANtoEUTRAN')))
    _IntersystemSONTransferType_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONTransferType_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___IntersystemSONTransferType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_id._const_tab = ___IntersystemSONTransferType_choice_Extensions_id_tab
    __IntersystemSONTransferType_choice_Extensions_id._const_tab_at = None
    __IntersystemSONTransferType_choice_Extensions_id._const_tab_id = u'id'
    __IntersystemSONTransferType_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___IntersystemSONTransferType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab = ___IntersystemSONTransferType_choice_Extensions_criticality_tab
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab_id = u'criticality'
    __IntersystemSONTransferType_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___IntersystemSONTransferType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_value._const_tab = ___IntersystemSONTransferType_choice_Extensions_value_tab
    __IntersystemSONTransferType_choice_Extensions_value._const_tab_at = ('..', u'id')
    __IntersystemSONTransferType_choice_Extensions_value._const_tab_id = u'Value'
    _IntersystemSONTransferType_choice_Extensions._cont = ASN1Dict([
        (u'id', __IntersystemSONTransferType_choice_Extensions_id),
        (u'criticality', __IntersystemSONTransferType_choice_Extensions_criticality),
        (u'value', __IntersystemSONTransferType_choice_Extensions_value),
        ])
    _IntersystemSONTransferType_choice_Extensions._ext = None
    IntersystemSONTransferType._cont = ASN1Dict([
        (u'fromEUTRANtoNGRAN', _IntersystemSONTransferType_fromEUTRANtoNGRAN),
        (u'fromNGRANtoEUTRAN', _IntersystemSONTransferType_fromNGRANtoEUTRAN),
        (u'choice-Extensions', _IntersystemSONTransferType_choice_Extensions),
        ])
    IntersystemSONTransferType._ext = None
    
    #-----< IntersystemSONTransferType-ExtIEs >-----#
    IntersystemSONTransferType_ExtIEs = CLASS(name=u'IntersystemSONTransferType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONTransferType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONeNBID >-----#
    IntersystemSONeNBID = SEQ(name=u'IntersystemSONeNBID', mode=MODE_TYPE)
    _IntersystemSONeNBID_globaleNBID = SEQ(name=u'globaleNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalENB-ID')))
    _IntersystemSONeNBID_selectedEPSTAI = SEQ(name=u'selectedEPSTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAI')))
    _IntersystemSONeNBID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONeNBID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONeNBID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntersystemSONeNBID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__id_tab
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntersystemSONeNBID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntersystemSONeNBID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntersystemSONeNBID_iE_Extensions__item__id),
        (u'criticality', ___IntersystemSONeNBID_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntersystemSONeNBID_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONeNBID_iE_Extensions__item_._ext = None
    _IntersystemSONeNBID_iE_Extensions._cont = __IntersystemSONeNBID_iE_Extensions__item_
    _IntersystemSONeNBID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONeNBID._cont = ASN1Dict([
        (u'globaleNBID', _IntersystemSONeNBID_globaleNBID),
        (u'selectedEPSTAI', _IntersystemSONeNBID_selectedEPSTAI),
        (u'iE-Extensions', _IntersystemSONeNBID_iE_Extensions),
        ])
    IntersystemSONeNBID._ext = []
    
    #-----< IntersystemSONeNBID-ExtIEs >-----#
    IntersystemSONeNBID_ExtIEs = CLASS(name=u'IntersystemSONeNBID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONeNBID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONNGRANnodeID >-----#
    IntersystemSONNGRANnodeID = SEQ(name=u'IntersystemSONNGRANnodeID', mode=MODE_TYPE)
    _IntersystemSONNGRANnodeID_globalRANNodeID = CHOICE(name=u'globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _IntersystemSONNGRANnodeID_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _IntersystemSONNGRANnodeID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONNGRANnodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntersystemSONNGRANnodeID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntersystemSONNGRANnodeID_iE_Extensions__item__id),
        (u'criticality', ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONNGRANnodeID_iE_Extensions__item_._ext = None
    _IntersystemSONNGRANnodeID_iE_Extensions._cont = __IntersystemSONNGRANnodeID_iE_Extensions__item_
    _IntersystemSONNGRANnodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONNGRANnodeID._cont = ASN1Dict([
        (u'globalRANNodeID', _IntersystemSONNGRANnodeID_globalRANNodeID),
        (u'selectedTAI', _IntersystemSONNGRANnodeID_selectedTAI),
        (u'iE-Extensions', _IntersystemSONNGRANnodeID_iE_Extensions),
        ])
    IntersystemSONNGRANnodeID._ext = []
    
    #-----< IntersystemSONNGRANnodeID-ExtIEs >-----#
    IntersystemSONNGRANnodeID_ExtIEs = CLASS(name=u'IntersystemSONNGRANnodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONNGRANnodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONInformation >-----#
    IntersystemSONInformation = CHOICE(name=u'IntersystemSONInformation', mode=MODE_TYPE)
    _IntersystemSONInformation_intersystemSONInformationReport = CHOICE(name=u'intersystemSONInformationReport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationReport')))
    _IntersystemSONInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___IntersystemSONInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformation_choice_Extensions_id._const_tab = ___IntersystemSONInformation_choice_Extensions_id_tab
    __IntersystemSONInformation_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformation_choice_Extensions_id._const_tab_id = u'id'
    __IntersystemSONInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___IntersystemSONInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab = ___IntersystemSONInformation_choice_Extensions_criticality_tab
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __IntersystemSONInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___IntersystemSONInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformation_choice_Extensions_value._const_tab = ___IntersystemSONInformation_choice_Extensions_value_tab
    __IntersystemSONInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __IntersystemSONInformation_choice_Extensions_value._const_tab_id = u'Value'
    _IntersystemSONInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __IntersystemSONInformation_choice_Extensions_id),
        (u'criticality', __IntersystemSONInformation_choice_Extensions_criticality),
        (u'value', __IntersystemSONInformation_choice_Extensions_value),
        ])
    _IntersystemSONInformation_choice_Extensions._ext = None
    IntersystemSONInformation._cont = ASN1Dict([
        (u'intersystemSONInformationReport', _IntersystemSONInformation_intersystemSONInformationReport),
        (u'choice-Extensions', _IntersystemSONInformation_choice_Extensions),
        ])
    IntersystemSONInformation._ext = None
    
    #-----< IntersystemSONInformation-ExtIEs >-----#
    IntersystemSONInformation_ExtIEs = CLASS(name=u'IntersystemSONInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONInformationReport >-----#
    IntersystemSONInformationReport = CHOICE(name=u'IntersystemSONInformationReport', mode=MODE_TYPE)
    _IntersystemSONInformationReport_hOReportInformation = SEQ(name=u'hOReportInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemHOReport')))
    _IntersystemSONInformationReport_failureIndicationInformation = SEQ(name=u'failureIndicationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemFailureIndication')))
    _IntersystemSONInformationReport_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformationReport_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___IntersystemSONInformationReport_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReport_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab = ___IntersystemSONInformationReport_choice_Extensions_id_tab
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab_id = u'id'
    __IntersystemSONInformationReport_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___IntersystemSONInformationReport_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReport_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab = ___IntersystemSONInformationReport_choice_Extensions_criticality_tab
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab_id = u'criticality'
    __IntersystemSONInformationReport_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___IntersystemSONInformationReport_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReport_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab = ___IntersystemSONInformationReport_choice_Extensions_value_tab
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab_at = ('..', u'id')
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab_id = u'Value'
    _IntersystemSONInformationReport_choice_Extensions._cont = ASN1Dict([
        (u'id', __IntersystemSONInformationReport_choice_Extensions_id),
        (u'criticality', __IntersystemSONInformationReport_choice_Extensions_criticality),
        (u'value', __IntersystemSONInformationReport_choice_Extensions_value),
        ])
    _IntersystemSONInformationReport_choice_Extensions._ext = None
    IntersystemSONInformationReport._cont = ASN1Dict([
        (u'hOReportInformation', _IntersystemSONInformationReport_hOReportInformation),
        (u'failureIndicationInformation', _IntersystemSONInformationReport_failureIndicationInformation),
        (u'choice-Extensions', _IntersystemSONInformationReport_choice_Extensions),
        ])
    IntersystemSONInformationReport._ext = None
    
    #-----< IntersystemSONInformationReport-ExtIEs >-----#
    IntersystemSONInformationReport_ExtIEs = CLASS(name=u'IntersystemSONInformationReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONInformationReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemHOReport >-----#
    InterSystemHOReport = SEQ(name=u'InterSystemHOReport', mode=MODE_TYPE)
    _InterSystemHOReport_handoverReportType = CHOICE(name=u'handoverReportType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemHandoverReportType')))
    _InterSystemHOReport_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemHOReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemHOReport_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterSystemHOReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab = ____InterSystemHOReport_iE_Extensions__item__id_tab
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterSystemHOReport_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterSystemHOReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab = ____InterSystemHOReport_iE_Extensions__item__criticality_tab
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterSystemHOReport_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab = ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterSystemHOReport_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterSystemHOReport_iE_Extensions__item__id),
        (u'criticality', ___InterSystemHOReport_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterSystemHOReport_iE_Extensions__item__extensionValue),
        ])
    __InterSystemHOReport_iE_Extensions__item_._ext = None
    _InterSystemHOReport_iE_Extensions._cont = __InterSystemHOReport_iE_Extensions__item_
    _InterSystemHOReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemHOReport._cont = ASN1Dict([
        (u'handoverReportType', _InterSystemHOReport_handoverReportType),
        (u'iE-Extensions', _InterSystemHOReport_iE_Extensions),
        ])
    InterSystemHOReport._ext = []
    
    #-----< InterSystemHOReport-ExtIEs >-----#
    InterSystemHOReport_ExtIEs = CLASS(name=u'InterSystemHOReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InterSystemHOReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemHandoverReportType >-----#
    InterSystemHandoverReportType = CHOICE(name=u'InterSystemHandoverReportType', mode=MODE_TYPE)
    _InterSystemHandoverReportType_tooearlyIntersystemHO = SEQ(name=u'tooearlyIntersystemHO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TooearlyIntersystemHO')))
    _InterSystemHandoverReportType_intersystemUnnecessaryHO = SEQ(name=u'intersystemUnnecessaryHO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemUnnecessaryHO')))
    _InterSystemHandoverReportType_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __InterSystemHandoverReportType_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___InterSystemHandoverReportType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab = ___InterSystemHandoverReportType_choice_Extensions_id_tab
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab_at = None
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab_id = u'id'
    __InterSystemHandoverReportType_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___InterSystemHandoverReportType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab = ___InterSystemHandoverReportType_choice_Extensions_criticality_tab
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab_id = u'criticality'
    __InterSystemHandoverReportType_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___InterSystemHandoverReportType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab = ___InterSystemHandoverReportType_choice_Extensions_value_tab
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab_at = ('..', u'id')
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab_id = u'Value'
    _InterSystemHandoverReportType_choice_Extensions._cont = ASN1Dict([
        (u'id', __InterSystemHandoverReportType_choice_Extensions_id),
        (u'criticality', __InterSystemHandoverReportType_choice_Extensions_criticality),
        (u'value', __InterSystemHandoverReportType_choice_Extensions_value),
        ])
    _InterSystemHandoverReportType_choice_Extensions._ext = None
    InterSystemHandoverReportType._cont = ASN1Dict([
        (u'tooearlyIntersystemHO', _InterSystemHandoverReportType_tooearlyIntersystemHO),
        (u'intersystemUnnecessaryHO', _InterSystemHandoverReportType_intersystemUnnecessaryHO),
        (u'choice-Extensions', _InterSystemHandoverReportType_choice_Extensions),
        ])
    InterSystemHandoverReportType._ext = None
    
    #-----< InterSystemHandoverReportType-ExtIEs >-----#
    InterSystemHandoverReportType_ExtIEs = CLASS(name=u'InterSystemHandoverReportType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    InterSystemHandoverReportType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemUnnecessaryHO >-----#
    IntersystemUnnecessaryHO = SEQ(name=u'IntersystemUnnecessaryHO', mode=MODE_TYPE)
    _IntersystemUnnecessaryHO_sourcecellID = CHOICE(name=u'sourcecellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _IntersystemUnnecessaryHO_targetcellID = SEQ(name=u'targetcellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _IntersystemUnnecessaryHO_earlyIRATHO = ENUM(name=u'earlyIRATHO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntersystemUnnecessaryHO_earlyIRATHO._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    _IntersystemUnnecessaryHO_earlyIRATHO._ext = []
    _IntersystemUnnecessaryHO_candidateCellList = SEQ_OF(name=u'candidateCellList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellList')))
    _IntersystemUnnecessaryHO_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemUnnecessaryHO_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntersystemUnnecessaryHO_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntersystemUnnecessaryHO_iE_Extensions__item__id),
        (u'criticality', ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue),
        ])
    __IntersystemUnnecessaryHO_iE_Extensions__item_._ext = None
    _IntersystemUnnecessaryHO_iE_Extensions._cont = __IntersystemUnnecessaryHO_iE_Extensions__item_
    _IntersystemUnnecessaryHO_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemUnnecessaryHO._cont = ASN1Dict([
        (u'sourcecellID', _IntersystemUnnecessaryHO_sourcecellID),
        (u'targetcellID', _IntersystemUnnecessaryHO_targetcellID),
        (u'earlyIRATHO', _IntersystemUnnecessaryHO_earlyIRATHO),
        (u'candidateCellList', _IntersystemUnnecessaryHO_candidateCellList),
        (u'iE-Extensions', _IntersystemUnnecessaryHO_iE_Extensions),
        ])
    IntersystemUnnecessaryHO._ext = []
    
    #-----< IntersystemUnnecessaryHO-ExtIEs >-----#
    IntersystemUnnecessaryHO_ExtIEs = CLASS(name=u'IntersystemUnnecessaryHO-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemUnnecessaryHO_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name=u'LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _LAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LAI_iE_Extensions__item__id),
        (u'criticality', ___LAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        (u'pLMNidentity', _LAI_pLMNidentity),
        (u'lAC', _LAI_lAC),
        (u'iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = []
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name=u'LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCellInformation >-----#
    LastVisitedCellInformation = CHOICE(name=u'LastVisitedCellInformation', mode=MODE_TYPE)
    _LastVisitedCellInformation_nGRANCell = SEQ(name=u'nGRANCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedNGRANCellInformation')))
    _LastVisitedCellInformation_eUTRANCell = OCT_STR(name=u'eUTRANCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCellInformation_uTRANCell = OCT_STR(name=u'uTRANCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCellInformation_gERANCell = OCT_STR(name=u'gERANCell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedGERANCellInformation')))
    _LastVisitedCellInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __LastVisitedCellInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___LastVisitedCellInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_id._const_tab = ___LastVisitedCellInformation_choice_Extensions_id_tab
    __LastVisitedCellInformation_choice_Extensions_id._const_tab_at = None
    __LastVisitedCellInformation_choice_Extensions_id._const_tab_id = u'id'
    __LastVisitedCellInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___LastVisitedCellInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab = ___LastVisitedCellInformation_choice_Extensions_criticality_tab
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __LastVisitedCellInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___LastVisitedCellInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_value._const_tab = ___LastVisitedCellInformation_choice_Extensions_value_tab
    __LastVisitedCellInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __LastVisitedCellInformation_choice_Extensions_value._const_tab_id = u'Value'
    _LastVisitedCellInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __LastVisitedCellInformation_choice_Extensions_id),
        (u'criticality', __LastVisitedCellInformation_choice_Extensions_criticality),
        (u'value', __LastVisitedCellInformation_choice_Extensions_value),
        ])
    _LastVisitedCellInformation_choice_Extensions._ext = None
    LastVisitedCellInformation._cont = ASN1Dict([
        (u'nGRANCell', _LastVisitedCellInformation_nGRANCell),
        (u'eUTRANCell', _LastVisitedCellInformation_eUTRANCell),
        (u'uTRANCell', _LastVisitedCellInformation_uTRANCell),
        (u'gERANCell', _LastVisitedCellInformation_gERANCell),
        (u'choice-Extensions', _LastVisitedCellInformation_choice_Extensions),
        ])
    LastVisitedCellInformation._ext = None
    
    #-----< LastVisitedCellInformation-ExtIEs >-----#
    LastVisitedCellInformation_ExtIEs = CLASS(name=u'LastVisitedCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    LastVisitedCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCellItem >-----#
    LastVisitedCellItem = SEQ(name=u'LastVisitedCellItem', mode=MODE_TYPE)
    _LastVisitedCellItem_lastVisitedCellInformation = CHOICE(name=u'lastVisitedCellInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedCellInformation')))
    _LastVisitedCellItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedCellItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastVisitedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab = ____LastVisitedCellItem_iE_Extensions__item__id_tab
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastVisitedCellItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LastVisitedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab = ____LastVisitedCellItem_iE_Extensions__item__criticality_tab
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastVisitedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastVisitedCellItem_iE_Extensions__item__id),
        (u'criticality', ___LastVisitedCellItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastVisitedCellItem_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedCellItem_iE_Extensions__item_._ext = None
    _LastVisitedCellItem_iE_Extensions._cont = __LastVisitedCellItem_iE_Extensions__item_
    _LastVisitedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedCellItem._cont = ASN1Dict([
        (u'lastVisitedCellInformation', _LastVisitedCellItem_lastVisitedCellInformation),
        (u'iE-Extensions', _LastVisitedCellItem_iE_Extensions),
        ])
    LastVisitedCellItem._ext = []
    
    #-----< LastVisitedCellItem-ExtIEs >-----#
    LastVisitedCellItem_ExtIEs = CLASS(name=u'LastVisitedCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LastVisitedCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = OCT_STR(name=u'LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = OCT_STR(name=u'LastVisitedGERANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedNGRANCellInformation >-----#
    LastVisitedNGRANCellInformation = SEQ(name=u'LastVisitedNGRANCellInformation', mode=MODE_TYPE)
    _LastVisitedNGRANCellInformation_globalCellID = CHOICE(name=u'globalCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _LastVisitedNGRANCellInformation_cellType = SEQ(name=u'cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellType')))
    _LastVisitedNGRANCellInformation_timeUEStayedInCell = INT(name=u'timeUEStayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeUEStayedInCell')))
    _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity = INT(name=u'timeUEStayedInCellEnhancedGranularity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeUEStayedInCellEnhancedGranularity')), opt=True)
    _LastVisitedNGRANCellInformation_hOCauseValue = CHOICE(name=u'hOCauseValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')), opt=True)
    _LastVisitedNGRANCellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedNGRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__criticality_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastVisitedNGRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastVisitedNGRANCellInformation_iE_Extensions__item__id),
        (u'criticality', ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedNGRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedNGRANCellInformation_iE_Extensions._cont = __LastVisitedNGRANCellInformation_iE_Extensions__item_
    _LastVisitedNGRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedNGRANCellInformation._cont = ASN1Dict([
        (u'globalCellID', _LastVisitedNGRANCellInformation_globalCellID),
        (u'cellType', _LastVisitedNGRANCellInformation_cellType),
        (u'timeUEStayedInCell', _LastVisitedNGRANCellInformation_timeUEStayedInCell),
        (u'timeUEStayedInCellEnhancedGranularity', _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity),
        (u'hOCauseValue', _LastVisitedNGRANCellInformation_hOCauseValue),
        (u'iE-Extensions', _LastVisitedNGRANCellInformation_iE_Extensions),
        ])
    LastVisitedNGRANCellInformation._ext = []
    
    #-----< LastVisitedNGRANCellInformation-ExtIEs >-----#
    LastVisitedNGRANCellInformation_ExtIEs = CLASS(name=u'LastVisitedNGRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LastVisitedNGRANCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name=u'LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LineType >-----#
    LineType = ENUM(name=u'LineType', mode=MODE_TYPE)
    LineType._cont = ASN1Dict([(u'dsl', 0), (u'pon', 1)])
    LineType._ext = []
    
    #-----< LocationReportingAdditionalInfo >-----#
    LocationReportingAdditionalInfo = ENUM(name=u'LocationReportingAdditionalInfo', mode=MODE_TYPE)
    LocationReportingAdditionalInfo._cont = ASN1Dict([(u'includePSCell', 0)])
    LocationReportingAdditionalInfo._ext = []
    
    #-----< LocationReportingReferenceID >-----#
    LocationReportingReferenceID = INT(name=u'LocationReportingReferenceID', mode=MODE_TYPE)
    LocationReportingReferenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< LocationReportingRequestType >-----#
    LocationReportingRequestType = SEQ(name=u'LocationReportingRequestType', mode=MODE_TYPE)
    _LocationReportingRequestType_eventType = ENUM(name=u'eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventType')))
    _LocationReportingRequestType_reportArea = ENUM(name=u'reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportArea')))
    _LocationReportingRequestType_areaOfInterestList = SEQ_OF(name=u'areaOfInterestList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestList')), opt=True)
    _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled = INT(name=u'locationReportingReferenceIDToBeCancelled', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')), opt=True)
    _LocationReportingRequestType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingRequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingRequestType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationReportingRequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingAdditionalInfo')))
    ____LocationReportingRequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab_id = u'id'
    ___LocationReportingRequestType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationReportingRequestType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingRequestType_iE_Extensions__item__id),
        (u'criticality', ___LocationReportingRequestType_iE_Extensions__item__criticality),
        (u'extensionValue', ___LocationReportingRequestType_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingRequestType_iE_Extensions__item_._ext = None
    _LocationReportingRequestType_iE_Extensions._cont = __LocationReportingRequestType_iE_Extensions__item_
    _LocationReportingRequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingRequestType._cont = ASN1Dict([
        (u'eventType', _LocationReportingRequestType_eventType),
        (u'reportArea', _LocationReportingRequestType_reportArea),
        (u'areaOfInterestList', _LocationReportingRequestType_areaOfInterestList),
        (u'locationReportingReferenceIDToBeCancelled', _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled),
        (u'iE-Extensions', _LocationReportingRequestType_iE_Extensions),
        ])
    LocationReportingRequestType._ext = []
    
    #-----< LocationReportingRequestType-ExtIEs >-----#
    LocationReportingRequestType_ExtIEs = CLASS(name=u'LocationReportingRequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _LocationReportingRequestType_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingAdditionalInfo')))
    LocationReportingRequestType_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _LocationReportingRequestType_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoggedMDTNr >-----#
    LoggedMDTNr = SEQ(name=u'LoggedMDTNr', mode=MODE_TYPE)
    _LoggedMDTNr_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggingInterval')))
    _LoggedMDTNr_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggingDuration')))
    _LoggedMDTNr_loggedMDTTrigger = CHOICE(name=u'loggedMDTTrigger', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggedMDTTrigger')))
    _LoggedMDTNr_bluetoothMeasurementConfiguration = SEQ(name=u'bluetoothMeasurementConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_wLANMeasurementConfiguration = SEQ(name=u'wLANMeasurementConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_sensorMeasurementConfiguration = SEQ(name=u'sensorMeasurementConfiguration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_areaScopeOfNeighCellsList = SEQ_OF(name=u'areaScopeOfNeighCellsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfNeighCellsList')), opt=True)
    _LoggedMDTNr_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDTNr_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDTNr_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LoggedMDTNr_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LoggedMDTNr_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab = ____LoggedMDTNr_iE_Extensions__item__id_tab
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab_id = u'id'
    ___LoggedMDTNr_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LoggedMDTNr_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LoggedMDTNr_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab = ____LoggedMDTNr_iE_Extensions__item__criticality_tab
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LoggedMDTNr_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LoggedMDTNr_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LoggedMDTNr_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDTNr_iE_Extensions__item__extensionValue_tab
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LoggedMDTNr_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LoggedMDTNr_iE_Extensions__item__id),
        (u'criticality', ___LoggedMDTNr_iE_Extensions__item__criticality),
        (u'extensionValue', ___LoggedMDTNr_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDTNr_iE_Extensions__item_._ext = None
    _LoggedMDTNr_iE_Extensions._cont = __LoggedMDTNr_iE_Extensions__item_
    _LoggedMDTNr_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDTNr._cont = ASN1Dict([
        (u'loggingInterval', _LoggedMDTNr_loggingInterval),
        (u'loggingDuration', _LoggedMDTNr_loggingDuration),
        (u'loggedMDTTrigger', _LoggedMDTNr_loggedMDTTrigger),
        (u'bluetoothMeasurementConfiguration', _LoggedMDTNr_bluetoothMeasurementConfiguration),
        (u'wLANMeasurementConfiguration', _LoggedMDTNr_wLANMeasurementConfiguration),
        (u'sensorMeasurementConfiguration', _LoggedMDTNr_sensorMeasurementConfiguration),
        (u'areaScopeOfNeighCellsList', _LoggedMDTNr_areaScopeOfNeighCellsList),
        (u'iE-Extensions', _LoggedMDTNr_iE_Extensions),
        ])
    LoggedMDTNr._ext = []
    
    #-----< LoggedMDTNr-ExtIEs >-----#
    LoggedMDTNr_ExtIEs = CLASS(name=u'LoggedMDTNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LoggedMDTNr_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name=u'LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([(u'ms320', 0), (u'ms640', 1), (u'ms1280', 2), (u'ms2560', 3), (u'ms5120', 4), (u'ms10240', 5), (u'ms20480', 6), (u'ms30720', 7), (u'ms40960', 8), (u'ms61440', 9), (u'infinity', 10)])
    LoggingInterval._ext = []
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name=u'LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([(u'm10', 0), (u'm20', 1), (u'm40', 2), (u'm60', 3), (u'm90', 4), (u'm120', 5)])
    LoggingDuration._ext = []
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name=u'Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< LoggedMDTTrigger >-----#
    LoggedMDTTrigger = CHOICE(name=u'LoggedMDTTrigger', mode=MODE_TYPE)
    _LoggedMDTTrigger_periodical = NULL(name=u'periodical', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LoggedMDTTrigger_eventTrigger = CHOICE(name=u'eventTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventTrigger')))
    _LoggedMDTTrigger_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __LoggedMDTTrigger_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___LoggedMDTTrigger_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_id._const_tab = ___LoggedMDTTrigger_choice_Extensions_id_tab
    __LoggedMDTTrigger_choice_Extensions_id._const_tab_at = None
    __LoggedMDTTrigger_choice_Extensions_id._const_tab_id = u'id'
    __LoggedMDTTrigger_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___LoggedMDTTrigger_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab = ___LoggedMDTTrigger_choice_Extensions_criticality_tab
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab_id = u'criticality'
    __LoggedMDTTrigger_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___LoggedMDTTrigger_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_value._const_tab = ___LoggedMDTTrigger_choice_Extensions_value_tab
    __LoggedMDTTrigger_choice_Extensions_value._const_tab_at = ('..', u'id')
    __LoggedMDTTrigger_choice_Extensions_value._const_tab_id = u'Value'
    _LoggedMDTTrigger_choice_Extensions._cont = ASN1Dict([
        (u'id', __LoggedMDTTrigger_choice_Extensions_id),
        (u'criticality', __LoggedMDTTrigger_choice_Extensions_criticality),
        (u'value', __LoggedMDTTrigger_choice_Extensions_value),
        ])
    _LoggedMDTTrigger_choice_Extensions._ext = None
    LoggedMDTTrigger._cont = ASN1Dict([
        (u'periodical', _LoggedMDTTrigger_periodical),
        (u'eventTrigger', _LoggedMDTTrigger_eventTrigger),
        (u'choice-Extensions', _LoggedMDTTrigger_choice_Extensions),
        ])
    LoggedMDTTrigger._ext = None
    
    #-----< LoggedMDTTrigger-ExtIEs >-----#
    LoggedMDTTrigger_ExtIEs = CLASS(name=u'LoggedMDTTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    LoggedMDTTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEM-Indication >-----#
    LTEM_Indication = ENUM(name=u'LTEM-Indication', mode=MODE_TYPE)
    LTEM_Indication._cont = ASN1Dict([(u'lte-m', 0)])
    LTEM_Indication._ext = []
    
    #-----< LTEUERLFReportContainer >-----#
    LTEUERLFReportContainer = OCT_STR(name=u'LTEUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< LTEV2XServicesAuthorized >-----#
    LTEV2XServicesAuthorized = SEQ(name=u'LTEV2XServicesAuthorized', mode=MODE_TYPE)
    _LTEV2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VehicleUE')), opt=True)
    _LTEV2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PedestrianUE')), opt=True)
    _LTEV2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LTEV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LTEV2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __LTEV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _LTEV2XServicesAuthorized_iE_Extensions._cont = __LTEV2XServicesAuthorized_iE_Extensions__item_
    _LTEV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEV2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _LTEV2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _LTEV2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _LTEV2XServicesAuthorized_iE_Extensions),
        ])
    LTEV2XServicesAuthorized._ext = []
    
    #-----< LTEV2XServicesAuthorized-ExtIEs >-----#
    LTEV2XServicesAuthorized_ExtIEs = CLASS(name=u'LTEV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LTEV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEUESidelinkAggregateMaximumBitrate >-----#
    LTEUESidelinkAggregateMaximumBitrate = SEQ(name=u'LTEUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name=u'uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uESidelinkAggregateMaximumBitRate', _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        (u'iE-Extensions', _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    LTEUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs >-----#
    LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs = CLASS(name=u'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MaskedIMEISV >-----#
    MaskedIMEISV = BIT_STR(name=u'MaskedIMEISV', mode=MODE_TYPE)
    MaskedIMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MaximumDataBurstVolume >-----#
    MaximumDataBurstVolume = INT(name=u'MaximumDataBurstVolume', mode=MODE_TYPE)
    MaximumDataBurstVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[ASN1RangeInt(lb=4096, ub=2000000)])
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name=u'MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MaximumIntegrityProtectedDataRate >-----#
    MaximumIntegrityProtectedDataRate = ENUM(name=u'MaximumIntegrityProtectedDataRate', mode=MODE_TYPE)
    MaximumIntegrityProtectedDataRate._cont = ASN1Dict([(u'bitrate64kbs', 0), (u'maximum-UE-rate', 1)])
    MaximumIntegrityProtectedDataRate._ext = []
    
    #-----< MicoAllPLMN >-----#
    MicoAllPLMN = ENUM(name=u'MicoAllPLMN', mode=MODE_TYPE)
    MicoAllPLMN._cont = ASN1Dict([(u'true', 0)])
    MicoAllPLMN._ext = []
    
    #-----< MICOModeIndication >-----#
    MICOModeIndication = ENUM(name=u'MICOModeIndication', mode=MODE_TYPE)
    MICOModeIndication._cont = ASN1Dict([(u'true', 0)])
    MICOModeIndication._ext = []
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name=u'MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MobilityRestrictionList >-----#
    MobilityRestrictionList = SEQ(name=u'MobilityRestrictionList', mode=MODE_TYPE)
    _MobilityRestrictionList_servingPLMN = OCT_STR(name=u'servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _MobilityRestrictionList_equivalentPLMNs = SEQ_OF(name=u'equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EquivalentPLMNs')), opt=True)
    _MobilityRestrictionList_rATRestrictions = SEQ_OF(name=u'rATRestrictions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictions')), opt=True)
    _MobilityRestrictionList_forbiddenAreaInformation = SEQ_OF(name=u'forbiddenAreaInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenAreaInformation')), opt=True)
    _MobilityRestrictionList_serviceAreaInformation = SEQ_OF(name=u'serviceAreaInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ServiceAreaInformation')), opt=True)
    _MobilityRestrictionList_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MobilityRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MobilityRestrictionList_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MobilityRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForServing')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalent')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-MobilityInformation')))
    ____MobilityRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'reject'), (u'Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab_id = u'id'
    ___MobilityRestrictionList_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MobilityRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MobilityRestrictionList_iE_Extensions__item__id),
        (u'criticality', ___MobilityRestrictionList_iE_Extensions__item__criticality),
        (u'extensionValue', ___MobilityRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __MobilityRestrictionList_iE_Extensions__item_._ext = None
    _MobilityRestrictionList_iE_Extensions._cont = __MobilityRestrictionList_iE_Extensions__item_
    _MobilityRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MobilityRestrictionList._cont = ASN1Dict([
        (u'servingPLMN', _MobilityRestrictionList_servingPLMN),
        (u'equivalentPLMNs', _MobilityRestrictionList_equivalentPLMNs),
        (u'rATRestrictions', _MobilityRestrictionList_rATRestrictions),
        (u'forbiddenAreaInformation', _MobilityRestrictionList_forbiddenAreaInformation),
        (u'serviceAreaInformation', _MobilityRestrictionList_serviceAreaInformation),
        (u'iE-Extensions', _MobilityRestrictionList_iE_Extensions),
        ])
    MobilityRestrictionList._ext = []
    
    #-----< MobilityRestrictionList-ExtIEs >-----#
    MobilityRestrictionList_ExtIEs = CLASS(name=u'MobilityRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _MobilityRestrictionList_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _MobilityRestrictionList_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForServing')))
    _MobilityRestrictionList_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalent')))
    _MobilityRestrictionList_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-MobilityInformation')))
    MobilityRestrictionList_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _MobilityRestrictionList_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _MobilityRestrictionList_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _MobilityRestrictionList_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'reject'), (u'Extension', _MobilityRestrictionList_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name=u'MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Config_NR = SEQ(name=u'mdt-Config-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration-NR')), opt=True)
    _MDT_Configuration_mdt_Config_EUTRA = SEQ(name=u'mdt-Config-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration-EUTRA')), opt=True)
    _MDT_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        (u'mdt-Config-NR', _MDT_Configuration_mdt_Config_NR),
        (u'mdt-Config-EUTRA', _MDT_Configuration_mdt_Config_EUTRA),
        (u'iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name=u'MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Configuration-NR >-----#
    MDT_Configuration_NR = SEQ(name=u'MDT-Configuration-NR', mode=MODE_TYPE)
    _MDT_Configuration_NR_mdt_Activation = ENUM(name=u'mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_NR_areaScopeOfMDT = CHOICE(name=u'areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfMDT-NR')))
    _MDT_Configuration_NR_mDTModeNr = CHOICE(name=u'mDTModeNr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTModeNr')))
    _MDT_Configuration_NR_signallingBasedMDTPLMNList = SEQ_OF(name=u'signallingBasedMDTPLMNList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')), opt=True)
    _MDT_Configuration_NR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_NR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__id_tab
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_NR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_NR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_NR_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_NR_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_NR_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_NR_iE_Extensions__item_._ext = None
    _MDT_Configuration_NR_iE_Extensions._cont = __MDT_Configuration_NR_iE_Extensions__item_
    _MDT_Configuration_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration_NR._cont = ASN1Dict([
        (u'mdt-Activation', _MDT_Configuration_NR_mdt_Activation),
        (u'areaScopeOfMDT', _MDT_Configuration_NR_areaScopeOfMDT),
        (u'mDTModeNr', _MDT_Configuration_NR_mDTModeNr),
        (u'signallingBasedMDTPLMNList', _MDT_Configuration_NR_signallingBasedMDTPLMNList),
        (u'iE-Extensions', _MDT_Configuration_NR_iE_Extensions),
        ])
    MDT_Configuration_NR._ext = []
    
    #-----< MDT-Configuration-NR-ExtIEs >-----#
    MDT_Configuration_NR_ExtIEs = CLASS(name=u'MDT-Configuration-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Configuration-EUTRA >-----#
    MDT_Configuration_EUTRA = SEQ(name=u'MDT-Configuration-EUTRA', mode=MODE_TYPE)
    _MDT_Configuration_EUTRA_mdt_Activation = ENUM(name=u'mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_EUTRA_areaScopeOfMDT = CHOICE(name=u'areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfMDT-EUTRA')))
    _MDT_Configuration_EUTRA_mDTMode = OCT_STR(name=u'mDTMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTModeEutra')))
    _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList = SEQ_OF(name=u'signallingBasedMDTPLMNList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')), opt=True)
    _MDT_Configuration_EUTRA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_EUTRA_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_EUTRA_iE_Extensions__item_._ext = None
    _MDT_Configuration_EUTRA_iE_Extensions._cont = __MDT_Configuration_EUTRA_iE_Extensions__item_
    _MDT_Configuration_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration_EUTRA._cont = ASN1Dict([
        (u'mdt-Activation', _MDT_Configuration_EUTRA_mdt_Activation),
        (u'areaScopeOfMDT', _MDT_Configuration_EUTRA_areaScopeOfMDT),
        (u'mDTMode', _MDT_Configuration_EUTRA_mDTMode),
        (u'signallingBasedMDTPLMNList', _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList),
        (u'iE-Extensions', _MDT_Configuration_EUTRA_iE_Extensions),
        ])
    MDT_Configuration_EUTRA._ext = []
    
    #-----< MDT-Configuration-EUTRA-ExtIEs >-----#
    MDT_Configuration_EUTRA_ExtIEs = CLASS(name=u'MDT-Configuration-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'logged-MDT-only', 1), (u'immediate-MDT-and-Trace', 2)])
    MDT_Activation._ext = []
    
    #-----< MDTModeNr >-----#
    MDTModeNr = CHOICE(name=u'MDTModeNr', mode=MODE_TYPE)
    _MDTModeNr_immediateMDTNr = SEQ(name=u'immediateMDTNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ImmediateMDTNr')))
    _MDTModeNr_loggedMDTNr = SEQ(name=u'loggedMDTNr', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggedMDTNr')))
    _MDTModeNr_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MDTModeNr_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___MDTModeNr_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_id._const_tab = ___MDTModeNr_choice_Extensions_id_tab
    __MDTModeNr_choice_Extensions_id._const_tab_at = None
    __MDTModeNr_choice_Extensions_id._const_tab_id = u'id'
    __MDTModeNr_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___MDTModeNr_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_criticality._const_tab = ___MDTModeNr_choice_Extensions_criticality_tab
    __MDTModeNr_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __MDTModeNr_choice_Extensions_criticality._const_tab_id = u'criticality'
    __MDTModeNr_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___MDTModeNr_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_value._const_tab = ___MDTModeNr_choice_Extensions_value_tab
    __MDTModeNr_choice_Extensions_value._const_tab_at = ('..', u'id')
    __MDTModeNr_choice_Extensions_value._const_tab_id = u'Value'
    _MDTModeNr_choice_Extensions._cont = ASN1Dict([
        (u'id', __MDTModeNr_choice_Extensions_id),
        (u'criticality', __MDTModeNr_choice_Extensions_criticality),
        (u'value', __MDTModeNr_choice_Extensions_value),
        ])
    _MDTModeNr_choice_Extensions._ext = None
    MDTModeNr._cont = ASN1Dict([
        (u'immediateMDTNr', _MDTModeNr_immediateMDTNr),
        (u'loggedMDTNr', _MDTModeNr_loggedMDTNr),
        (u'choice-Extensions', _MDTModeNr_choice_Extensions),
        ])
    MDTModeNr._ext = None
    
    #-----< MDTModeNr-ExtIEs >-----#
    MDTModeNr_ExtIEs = CLASS(name=u'MDTModeNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MDTModeNr_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTModeEutra >-----#
    MDTModeEutra = OCT_STR(name=u'MDTModeEutra', mode=MODE_TYPE)
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name=u'MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< M1Configuration >-----#
    M1Configuration = SEQ(name=u'M1Configuration', mode=MODE_TYPE)
    _M1Configuration_m1reportingTrigger = ENUM(name=u'm1reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ReportingTrigger')))
    _M1Configuration_m1thresholdEventA2 = SEQ(name=u'm1thresholdEventA2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ThresholdEventA2')), opt=True)
    _M1Configuration_m1periodicReporting = SEQ(name=u'm1periodicReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1PeriodicReporting')), opt=True)
    _M1Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1Configuration_iE_Extensions__item__id._const_tab = ____M1Configuration_iE_Extensions__item__id_tab
    ___M1Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M1Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M1Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1Configuration_iE_Extensions__item__criticality._const_tab = ____M1Configuration_iE_Extensions__item__criticality_tab
    ___M1Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M1Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab = ____M1Configuration_iE_Extensions__item__extensionValue_tab
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1Configuration_iE_Extensions__item__id),
        (u'criticality', ___M1Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1Configuration_iE_Extensions__item__extensionValue),
        ])
    __M1Configuration_iE_Extensions__item_._ext = None
    _M1Configuration_iE_Extensions._cont = __M1Configuration_iE_Extensions__item_
    _M1Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1Configuration._cont = ASN1Dict([
        (u'm1reportingTrigger', _M1Configuration_m1reportingTrigger),
        (u'm1thresholdEventA2', _M1Configuration_m1thresholdEventA2),
        (u'm1periodicReporting', _M1Configuration_m1periodicReporting),
        (u'iE-Extensions', _M1Configuration_iE_Extensions),
        ])
    M1Configuration._ext = []
    
    #-----< M1Configuration-ExtIEs >-----#
    M1Configuration_ExtIEs = CLASS(name=u'M1Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M1Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name=u'M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([(u'periodic', 0), (u'a2eventtriggered', 1), (u'a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = []
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name=u'M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_m1ThresholdType = CHOICE(name=u'm1ThresholdType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ThresholdType')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        (u'criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        (u'm1ThresholdType', _M1ThresholdEventA2_m1ThresholdType),
        (u'iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name=u'M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1ThresholdType >-----#
    M1ThresholdType = CHOICE(name=u'M1ThresholdType', mode=MODE_TYPE)
    _M1ThresholdType_threshold_RSRP = INT(name=u'threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRP')))
    _M1ThresholdType_threshold_RSRQ = INT(name=u'threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRQ')))
    _M1ThresholdType_threshold_SINR = INT(name=u'threshold-SINR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-SINR')))
    _M1ThresholdType_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __M1ThresholdType_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___M1ThresholdType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_id._const_tab = ___M1ThresholdType_choice_Extensions_id_tab
    __M1ThresholdType_choice_Extensions_id._const_tab_at = None
    __M1ThresholdType_choice_Extensions_id._const_tab_id = u'id'
    __M1ThresholdType_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___M1ThresholdType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_criticality._const_tab = ___M1ThresholdType_choice_Extensions_criticality_tab
    __M1ThresholdType_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __M1ThresholdType_choice_Extensions_criticality._const_tab_id = u'criticality'
    __M1ThresholdType_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___M1ThresholdType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_value._const_tab = ___M1ThresholdType_choice_Extensions_value_tab
    __M1ThresholdType_choice_Extensions_value._const_tab_at = ('..', u'id')
    __M1ThresholdType_choice_Extensions_value._const_tab_id = u'Value'
    _M1ThresholdType_choice_Extensions._cont = ASN1Dict([
        (u'id', __M1ThresholdType_choice_Extensions_id),
        (u'criticality', __M1ThresholdType_choice_Extensions_criticality),
        (u'value', __M1ThresholdType_choice_Extensions_value),
        ])
    _M1ThresholdType_choice_Extensions._ext = None
    M1ThresholdType._cont = ASN1Dict([
        (u'threshold-RSRP', _M1ThresholdType_threshold_RSRP),
        (u'threshold-RSRQ', _M1ThresholdType_threshold_RSRQ),
        (u'threshold-SINR', _M1ThresholdType_threshold_SINR),
        (u'choice-Extensions', _M1ThresholdType_choice_Extensions),
        ])
    M1ThresholdType._ext = None
    
    #-----< M1ThresholdType-ExtIEs >-----#
    M1ThresholdType_ExtIEs = CLASS(name=u'M1ThresholdType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    M1ThresholdType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name=u'M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedReportIntervalMDT')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1PeriodicReporting_iE_Extensions__item__id),
        (u'criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        (u'reportInterval', _M1PeriodicReporting_reportInterval),
        (u'reportAmount', _M1PeriodicReporting_reportAmount),
        (u'iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name=u'M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M1PeriodicReporting_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedReportIntervalMDT')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _M1PeriodicReporting_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name=u'M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name=u'm4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name=u'm4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M4Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__criticality_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__extensionValue_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M4Configuration_iE_Extensions__item__id),
        (u'criticality', ___M4Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        (u'm4period', _M4Configuration_m4period),
        (u'm4-links-to-log', _M4Configuration_m4_links_to_log),
        (u'iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name=u'M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name=u'M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name=u'M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name=u'm5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name=u'm5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M5Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__criticality_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__extensionValue_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M5Configuration_iE_Extensions__item__id),
        (u'criticality', ___M5Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        (u'm5period', _M5Configuration_m5period),
        (u'm5-links-to-log', _M5Configuration_m5_links_to_log),
        (u'iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name=u'M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name=u'M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name=u'M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name=u'm6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M6report-Interval')))
    _M6Configuration_m6_links_to_log = ENUM(name=u'm6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M6Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__criticality_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__extensionValue_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M6Configuration_iE_Extensions__item__id),
        (u'criticality', ___M6Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        (u'm6report-Interval', _M6Configuration_m6report_Interval),
        (u'm6-links-to-log', _M6Configuration_m6_links_to_log),
        (u'iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name=u'M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name=u'M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'ms20480', 8), (u'ms40960', 9), (u'min1', 10), (u'min6', 11), (u'min12', 12), (u'min30', 13)])
    M6report_Interval._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name=u'M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name=u'm7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name=u'm7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M7Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__criticality_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__extensionValue_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M7Configuration_iE_Extensions__item__id),
        (u'criticality', ___M7Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        (u'm7period', _M7Configuration_m7period),
        (u'm7-links-to-log', _M7Configuration_m7_links_to_log),
        (u'iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name=u'M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name=u'M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = SEQ(name=u'MDT-Location-Info', mode=MODE_TYPE)
    _MDT_Location_Info_mDT_Location_Information = BIT_STR(name=u'mDT-Location-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Location-Information')))
    _MDT_Location_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Location_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Location_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Location_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab = ____MDT_Location_Info_iE_Extensions__item__id_tab
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Location_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDT_Location_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab = ____MDT_Location_Info_iE_Extensions__item__criticality_tab
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Location_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab = ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Location_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Location_Info_iE_Extensions__item__id),
        (u'criticality', ___MDT_Location_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Location_Info_iE_Extensions__item__extensionValue),
        ])
    __MDT_Location_Info_iE_Extensions__item_._ext = None
    _MDT_Location_Info_iE_Extensions._cont = __MDT_Location_Info_iE_Extensions__item_
    _MDT_Location_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Location_Info._cont = ASN1Dict([
        (u'mDT-Location-Information', _MDT_Location_Info_mDT_Location_Information),
        (u'iE-Extensions', _MDT_Location_Info_iE_Extensions),
        ])
    MDT_Location_Info._ext = []
    
    #-----< MDT-Location-Info-ExtIEs >-----#
    MDT_Location_Info_ExtIEs = CLASS(name=u'MDT-Location-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Location_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Location-Information >-----#
    MDT_Location_Information = BIT_STR(name=u'MDT-Location-Information', mode=MODE_TYPE)
    MDT_Location_Information._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< N3IWF-ID >-----#
    N3IWF_ID = CHOICE(name=u'N3IWF-ID', mode=MODE_TYPE)
    _N3IWF_ID_n3IWF_ID = BIT_STR(name=u'n3IWF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _N3IWF_ID_n3IWF_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _N3IWF_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __N3IWF_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___N3IWF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_id._const_tab = ___N3IWF_ID_choice_Extensions_id_tab
    __N3IWF_ID_choice_Extensions_id._const_tab_at = None
    __N3IWF_ID_choice_Extensions_id._const_tab_id = u'id'
    __N3IWF_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___N3IWF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_criticality._const_tab = ___N3IWF_ID_choice_Extensions_criticality_tab
    __N3IWF_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __N3IWF_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __N3IWF_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___N3IWF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_value._const_tab = ___N3IWF_ID_choice_Extensions_value_tab
    __N3IWF_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __N3IWF_ID_choice_Extensions_value._const_tab_id = u'Value'
    _N3IWF_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __N3IWF_ID_choice_Extensions_id),
        (u'criticality', __N3IWF_ID_choice_Extensions_criticality),
        (u'value', __N3IWF_ID_choice_Extensions_value),
        ])
    _N3IWF_ID_choice_Extensions._ext = None
    N3IWF_ID._cont = ASN1Dict([
        (u'n3IWF-ID', _N3IWF_ID_n3IWF_ID),
        (u'choice-Extensions', _N3IWF_ID_choice_Extensions),
        ])
    N3IWF_ID._ext = None
    
    #-----< N3IWF-ID-ExtIEs >-----#
    N3IWF_ID_ExtIEs = CLASS(name=u'N3IWF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    N3IWF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name=u'NAS-PDU', mode=MODE_TYPE)
    
    #-----< NASSecurityParametersFromNGRAN >-----#
    NASSecurityParametersFromNGRAN = OCT_STR(name=u'NASSecurityParametersFromNGRAN', mode=MODE_TYPE)
    
    #-----< NB-IoT-DefaultPagingDRX >-----#
    NB_IoT_DefaultPagingDRX = ENUM(name=u'NB-IoT-DefaultPagingDRX', mode=MODE_TYPE)
    NB_IoT_DefaultPagingDRX._cont = ASN1Dict([(u'rf128', 0), (u'rf256', 1), (u'rf512', 2), (u'rf1024', 3)])
    NB_IoT_DefaultPagingDRX._ext = []
    
    #-----< NB-IoT-PagingDRX >-----#
    NB_IoT_PagingDRX = ENUM(name=u'NB-IoT-PagingDRX', mode=MODE_TYPE)
    NB_IoT_PagingDRX._cont = ASN1Dict([(u'rf32', 0), (u'rf64', 1), (u'rf128', 2), (u'rf256', 3), (u'rf512', 4), (u'rf1024', 5)])
    NB_IoT_PagingDRX._ext = []
    
    #-----< NB-IoT-Paging-eDRXCycle >-----#
    NB_IoT_Paging_eDRXCycle = ENUM(name=u'NB-IoT-Paging-eDRXCycle', mode=MODE_TYPE)
    NB_IoT_Paging_eDRXCycle._cont = ASN1Dict([(u'hf2', 0), (u'hf4', 1), (u'hf6', 2), (u'hf8', 3), (u'hf10', 4), (u'hf12', 5), (u'hf14', 6), (u'hf16', 7), (u'hf32', 8), (u'hf64', 9), (u'hf128', 10), (u'hf256', 11), (u'hf512', 12), (u'hf1024', 13)])
    NB_IoT_Paging_eDRXCycle._ext = []
    
    #-----< NB-IoT-Paging-TimeWindow >-----#
    NB_IoT_Paging_TimeWindow = ENUM(name=u'NB-IoT-Paging-TimeWindow', mode=MODE_TYPE)
    NB_IoT_Paging_TimeWindow._cont = ASN1Dict([(u's1', 0), (u's2', 1), (u's3', 2), (u's4', 3), (u's5', 4), (u's6', 5), (u's7', 6), (u's8', 7), (u's9', 8), (u's10', 9), (u's11', 10), (u's12', 11), (u's13', 12), (u's14', 13), (u's15', 14), (u's16', 15)])
    NB_IoT_Paging_TimeWindow._ext = []
    
    #-----< NB-IoT-Paging-eDRXInfo >-----#
    NB_IoT_Paging_eDRXInfo = SEQ(name=u'NB-IoT-Paging-eDRXInfo', mode=MODE_TYPE)
    _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle = ENUM(name=u'nB-IoT-Paging-eDRXCycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXCycle')))
    _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow = ENUM(name=u'nB-IoT-Paging-TimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-TimeWindow')), opt=True)
    _NB_IoT_Paging_eDRXInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab_at = None
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id),
        (u'criticality', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue),
        ])
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_._ext = None
    _NB_IoT_Paging_eDRXInfo_iE_Extensions._cont = __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_
    _NB_IoT_Paging_eDRXInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NB_IoT_Paging_eDRXInfo._cont = ASN1Dict([
        (u'nB-IoT-Paging-eDRXCycle', _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle),
        (u'nB-IoT-Paging-TimeWindow', _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow),
        (u'iE-Extensions', _NB_IoT_Paging_eDRXInfo_iE_Extensions),
        ])
    NB_IoT_Paging_eDRXInfo._ext = []
    
    #-----< NB-IoT-Paging-eDRXInfo-ExtIEs >-----#
    NB_IoT_Paging_eDRXInfo_ExtIEs = CLASS(name=u'NB-IoT-Paging-eDRXInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NB_IoT_Paging_eDRXInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NB-IoT-UEPriority >-----#
    NB_IoT_UEPriority = INT(name=u'NB-IoT-UEPriority', mode=MODE_TYPE)
    NB_IoT_UEPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< NetworkInstance >-----#
    NetworkInstance = INT(name=u'NetworkInstance', mode=MODE_TYPE)
    NetworkInstance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< NewSecurityContextInd >-----#
    NewSecurityContextInd = ENUM(name=u'NewSecurityContextInd', mode=MODE_TYPE)
    NewSecurityContextInd._cont = ASN1Dict([(u'true', 0)])
    NewSecurityContextInd._ext = []
    
    #-----< NextHopChainingCount >-----#
    NextHopChainingCount = INT(name=u'NextHopChainingCount', mode=MODE_TYPE)
    NextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< NextPagingAreaScope >-----#
    NextPagingAreaScope = ENUM(name=u'NextPagingAreaScope', mode=MODE_TYPE)
    NextPagingAreaScope._cont = ASN1Dict([(u'same', 0), (u'changed', 1)])
    NextPagingAreaScope._ext = []
    
    #-----< NgENB-ID >-----#
    NgENB_ID = CHOICE(name=u'NgENB-ID', mode=MODE_TYPE)
    _NgENB_ID_macroNgENB_ID = BIT_STR(name=u'macroNgENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_macroNgENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _NgENB_ID_shortMacroNgENB_ID = BIT_STR(name=u'shortMacroNgENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_shortMacroNgENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NgENB_ID_longMacroNgENB_ID = BIT_STR(name=u'longMacroNgENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_longMacroNgENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _NgENB_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NgENB_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NgENB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_id._const_tab = ___NgENB_ID_choice_Extensions_id_tab
    __NgENB_ID_choice_Extensions_id._const_tab_at = None
    __NgENB_ID_choice_Extensions_id._const_tab_id = u'id'
    __NgENB_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NgENB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_criticality._const_tab = ___NgENB_ID_choice_Extensions_criticality_tab
    __NgENB_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NgENB_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NgENB_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NgENB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_value._const_tab = ___NgENB_ID_choice_Extensions_value_tab
    __NgENB_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NgENB_ID_choice_Extensions_value._const_tab_id = u'Value'
    _NgENB_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __NgENB_ID_choice_Extensions_id),
        (u'criticality', __NgENB_ID_choice_Extensions_criticality),
        (u'value', __NgENB_ID_choice_Extensions_value),
        ])
    _NgENB_ID_choice_Extensions._ext = None
    NgENB_ID._cont = ASN1Dict([
        (u'macroNgENB-ID', _NgENB_ID_macroNgENB_ID),
        (u'shortMacroNgENB-ID', _NgENB_ID_shortMacroNgENB_ID),
        (u'longMacroNgENB-ID', _NgENB_ID_longMacroNgENB_ID),
        (u'choice-Extensions', _NgENB_ID_choice_Extensions),
        ])
    NgENB_ID._ext = None
    
    #-----< NgENB-ID-ExtIEs >-----#
    NgENB_ID_ExtIEs = CLASS(name=u'NgENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NgENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NotifySourceNGRANNode >-----#
    NotifySourceNGRANNode = ENUM(name=u'NotifySourceNGRANNode', mode=MODE_TYPE)
    NotifySourceNGRANNode._cont = ASN1Dict([(u'notifySource', 0)])
    NotifySourceNGRANNode._ext = []
    
    #-----< NGRAN-CGI >-----#
    NGRAN_CGI = CHOICE(name=u'NGRAN-CGI', mode=MODE_TYPE)
    _NGRAN_CGI_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _NGRAN_CGI_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _NGRAN_CGI_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NGRAN_CGI_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NGRAN_CGI_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_id._const_tab = ___NGRAN_CGI_choice_Extensions_id_tab
    __NGRAN_CGI_choice_Extensions_id._const_tab_at = None
    __NGRAN_CGI_choice_Extensions_id._const_tab_id = u'id'
    __NGRAN_CGI_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGRAN_CGI_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_criticality._const_tab = ___NGRAN_CGI_choice_Extensions_criticality_tab
    __NGRAN_CGI_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NGRAN_CGI_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NGRAN_CGI_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGRAN_CGI_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_value._const_tab = ___NGRAN_CGI_choice_Extensions_value_tab
    __NGRAN_CGI_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NGRAN_CGI_choice_Extensions_value._const_tab_id = u'Value'
    _NGRAN_CGI_choice_Extensions._cont = ASN1Dict([
        (u'id', __NGRAN_CGI_choice_Extensions_id),
        (u'criticality', __NGRAN_CGI_choice_Extensions_criticality),
        (u'value', __NGRAN_CGI_choice_Extensions_value),
        ])
    _NGRAN_CGI_choice_Extensions._ext = None
    NGRAN_CGI._cont = ASN1Dict([
        (u'nR-CGI', _NGRAN_CGI_nR_CGI),
        (u'eUTRA-CGI', _NGRAN_CGI_eUTRA_CGI),
        (u'choice-Extensions', _NGRAN_CGI_choice_Extensions),
        ])
    NGRAN_CGI._ext = None
    
    #-----< NGRAN-CGI-ExtIEs >-----#
    NGRAN_CGI_ExtIEs = CLASS(name=u'NGRAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NGRAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-TNLAssociationToRemoveList >-----#
    NGRAN_TNLAssociationToRemoveList = SEQ_OF(name=u'NGRAN-TNLAssociationToRemoveList', mode=MODE_TYPE)
    _NGRAN_TNLAssociationToRemoveList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveItem')))
    NGRAN_TNLAssociationToRemoveList._cont = _NGRAN_TNLAssociationToRemoveList__item_
    NGRAN_TNLAssociationToRemoveList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NGRAN-TNLAssociationToRemoveItem >-----#
    NGRAN_TNLAssociationToRemoveItem = SEQ(name=u'NGRAN-TNLAssociationToRemoveItem', mode=MODE_TYPE)
    _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress = CHOICE(name=u'tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF = CHOICE(name=u'tNLAssociationTransportLayerAddressAMF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')), opt=True)
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id),
        (u'criticality', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_._ext = None
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions._cont = __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_TNLAssociationToRemoveItem._cont = ASN1Dict([
        (u'tNLAssociationTransportLayerAddress', _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress),
        (u'tNLAssociationTransportLayerAddressAMF', _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF),
        (u'iE-Extensions', _NGRAN_TNLAssociationToRemoveItem_iE_Extensions),
        ])
    NGRAN_TNLAssociationToRemoveItem._ext = None
    
    #-----< NGRAN-TNLAssociationToRemoveItem-ExtIEs >-----#
    NGRAN_TNLAssociationToRemoveItem_ExtIEs = CLASS(name=u'NGRAN-TNLAssociationToRemoveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_TNLAssociationToRemoveItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANTraceID >-----#
    NGRANTraceID = OCT_STR(name=u'NGRANTraceID', mode=MODE_TYPE)
    NGRANTraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< NID >-----#
    NID = BIT_STR(name=u'NID', mode=MODE_TYPE)
    NID._const_sz = ASN1Set(rv=[44], rr=[], ev=None, er=[])
    
    #-----< NonDynamic5QIDescriptor >-----#
    NonDynamic5QIDescriptor = SEQ(name=u'NonDynamic5QIDescriptor', mode=MODE_TYPE)
    _NonDynamic5QIDescriptor_fiveQI = INT(name=u'fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _NonDynamic5QIDescriptor_priorityLevelQos = INT(name=u'priorityLevelQos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelQos')), opt=True)
    _NonDynamic5QIDescriptor_averagingWindow = INT(name=u'averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamic5QIDescriptor_maximumDataBurstVolume = INT(name=u'maximumDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumDataBurstVolume')), opt=True)
    _NonDynamic5QIDescriptor_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonDynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonDynamic5QIDescriptor_iE_Extensions__item__id),
        (u'criticality', ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamic5QIDescriptor_iE_Extensions._cont = __NonDynamic5QIDescriptor_iE_Extensions__item_
    _NonDynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamic5QIDescriptor._cont = ASN1Dict([
        (u'fiveQI', _NonDynamic5QIDescriptor_fiveQI),
        (u'priorityLevelQos', _NonDynamic5QIDescriptor_priorityLevelQos),
        (u'averagingWindow', _NonDynamic5QIDescriptor_averagingWindow),
        (u'maximumDataBurstVolume', _NonDynamic5QIDescriptor_maximumDataBurstVolume),
        (u'iE-Extensions', _NonDynamic5QIDescriptor_iE_Extensions),
        ])
    NonDynamic5QIDescriptor._ext = []
    
    #-----< NonDynamic5QIDescriptor-ExtIEs >-----#
    NonDynamic5QIDescriptor_ExtIEs = CLASS(name=u'NonDynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    NonDynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NotAllowedTACs >-----#
    NotAllowedTACs = SEQ_OF(name=u'NotAllowedTACs', mode=MODE_TYPE)
    _NotAllowedTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    NotAllowedTACs._cont = _NotAllowedTACs__item_
    NotAllowedTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NotificationCause >-----#
    NotificationCause = ENUM(name=u'NotificationCause', mode=MODE_TYPE)
    NotificationCause._cont = ASN1Dict([(u'fulfilled', 0), (u'not-fulfilled', 1)])
    NotificationCause._ext = []
    
    #-----< NotificationControl >-----#
    NotificationControl = ENUM(name=u'NotificationControl', mode=MODE_TYPE)
    NotificationControl._cont = ASN1Dict([(u'notification-requested', 0)])
    NotificationControl._ext = []
    
    #-----< NPN-AccessInformation >-----#
    NPN_AccessInformation = CHOICE(name=u'NPN-AccessInformation', mode=MODE_TYPE)
    _NPN_AccessInformation_pNI_NPN_Access_Information = SEQ_OF(name=u'pNI-NPN-Access-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellCAGList')))
    _NPN_AccessInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_AccessInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NPN_AccessInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_id._const_tab = ___NPN_AccessInformation_choice_Extensions_id_tab
    __NPN_AccessInformation_choice_Extensions_id._const_tab_at = None
    __NPN_AccessInformation_choice_Extensions_id._const_tab_id = u'id'
    __NPN_AccessInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NPN_AccessInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab = ___NPN_AccessInformation_choice_Extensions_criticality_tab
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NPN_AccessInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NPN_AccessInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_value._const_tab = ___NPN_AccessInformation_choice_Extensions_value_tab
    __NPN_AccessInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NPN_AccessInformation_choice_Extensions_value._const_tab_id = u'Value'
    _NPN_AccessInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __NPN_AccessInformation_choice_Extensions_id),
        (u'criticality', __NPN_AccessInformation_choice_Extensions_criticality),
        (u'value', __NPN_AccessInformation_choice_Extensions_value),
        ])
    _NPN_AccessInformation_choice_Extensions._ext = None
    NPN_AccessInformation._cont = ASN1Dict([
        (u'pNI-NPN-Access-Information', _NPN_AccessInformation_pNI_NPN_Access_Information),
        (u'choice-Extensions', _NPN_AccessInformation_choice_Extensions),
        ])
    NPN_AccessInformation._ext = None
    
    #-----< NPN-AccessInformation-ExtIEs >-----#
    NPN_AccessInformation_ExtIEs = CLASS(name=u'NPN-AccessInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_AccessInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-MobilityInformation >-----#
    NPN_MobilityInformation = CHOICE(name=u'NPN-MobilityInformation', mode=MODE_TYPE)
    _NPN_MobilityInformation_sNPN_MobilityInformation = SEQ(name=u'sNPN-MobilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SNPN-MobilityInformation')))
    _NPN_MobilityInformation_pNI_NPN_MobilityInformation = SEQ(name=u'pNI-NPN-MobilityInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PNI-NPN-MobilityInformation')))
    _NPN_MobilityInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_MobilityInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NPN_MobilityInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_id._const_tab = ___NPN_MobilityInformation_choice_Extensions_id_tab
    __NPN_MobilityInformation_choice_Extensions_id._const_tab_at = None
    __NPN_MobilityInformation_choice_Extensions_id._const_tab_id = u'id'
    __NPN_MobilityInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NPN_MobilityInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab = ___NPN_MobilityInformation_choice_Extensions_criticality_tab
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NPN_MobilityInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NPN_MobilityInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_value._const_tab = ___NPN_MobilityInformation_choice_Extensions_value_tab
    __NPN_MobilityInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NPN_MobilityInformation_choice_Extensions_value._const_tab_id = u'Value'
    _NPN_MobilityInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __NPN_MobilityInformation_choice_Extensions_id),
        (u'criticality', __NPN_MobilityInformation_choice_Extensions_criticality),
        (u'value', __NPN_MobilityInformation_choice_Extensions_value),
        ])
    _NPN_MobilityInformation_choice_Extensions._ext = None
    NPN_MobilityInformation._cont = ASN1Dict([
        (u'sNPN-MobilityInformation', _NPN_MobilityInformation_sNPN_MobilityInformation),
        (u'pNI-NPN-MobilityInformation', _NPN_MobilityInformation_pNI_NPN_MobilityInformation),
        (u'choice-Extensions', _NPN_MobilityInformation_choice_Extensions),
        ])
    NPN_MobilityInformation._ext = None
    
    #-----< NPN-MobilityInformation-ExtIEs >-----#
    NPN_MobilityInformation_ExtIEs = CLASS(name=u'NPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-PagingAssistanceInformation >-----#
    NPN_PagingAssistanceInformation = CHOICE(name=u'NPN-PagingAssistanceInformation', mode=MODE_TYPE)
    _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance = SEQ_OF(name=u'pNI-NPN-PagingAssistance', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-List')))
    _NPN_PagingAssistanceInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_PagingAssistanceInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab_at = None
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab_id = u'id'
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NPN_PagingAssistanceInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab_id = u'Value'
    _NPN_PagingAssistanceInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __NPN_PagingAssistanceInformation_choice_Extensions_id),
        (u'criticality', __NPN_PagingAssistanceInformation_choice_Extensions_criticality),
        (u'value', __NPN_PagingAssistanceInformation_choice_Extensions_value),
        ])
    _NPN_PagingAssistanceInformation_choice_Extensions._ext = None
    NPN_PagingAssistanceInformation._cont = ASN1Dict([
        (u'pNI-NPN-PagingAssistance', _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance),
        (u'choice-Extensions', _NPN_PagingAssistanceInformation_choice_Extensions),
        ])
    NPN_PagingAssistanceInformation._ext = None
    
    #-----< NPN-PagingAssistanceInformation-ExtIEs >-----#
    NPN_PagingAssistanceInformation_ExtIEs = CLASS(name=u'NPN-PagingAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_PagingAssistanceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Support >-----#
    NPN_Support = CHOICE(name=u'NPN-Support', mode=MODE_TYPE)
    _NPN_Support_sNPN = BIT_STR(name=u'sNPN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _NPN_Support_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_Support_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___NPN_Support_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_id._const_tab = ___NPN_Support_choice_Extensions_id_tab
    __NPN_Support_choice_Extensions_id._const_tab_at = None
    __NPN_Support_choice_Extensions_id._const_tab_id = u'id'
    __NPN_Support_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NPN_Support_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_criticality._const_tab = ___NPN_Support_choice_Extensions_criticality_tab
    __NPN_Support_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __NPN_Support_choice_Extensions_criticality._const_tab_id = u'criticality'
    __NPN_Support_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NPN_Support_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_value._const_tab = ___NPN_Support_choice_Extensions_value_tab
    __NPN_Support_choice_Extensions_value._const_tab_at = ('..', u'id')
    __NPN_Support_choice_Extensions_value._const_tab_id = u'Value'
    _NPN_Support_choice_Extensions._cont = ASN1Dict([
        (u'id', __NPN_Support_choice_Extensions_id),
        (u'criticality', __NPN_Support_choice_Extensions_criticality),
        (u'value', __NPN_Support_choice_Extensions_value),
        ])
    _NPN_Support_choice_Extensions._ext = None
    NPN_Support._cont = ASN1Dict([
        (u'sNPN', _NPN_Support_sNPN),
        (u'choice-Extensions', _NPN_Support_choice_Extensions),
        ])
    NPN_Support._ext = None
    
    #-----< NPN-Support-ExtIEs >-----#
    NPN_Support_ExtIEs = CLASS(name=u'NPN-Support-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_Support_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name=u'NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = SEQ(name=u'NR-CGI', mode=MODE_TYPE)
    _NR_CGI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _NR_CGI_nRCellIdentity = BIT_STR(name=u'nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRCellIdentity')))
    _NR_CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__id._const_tab = ____NR_CGI_iE_Extensions__item__id_tab
    ___NR_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__criticality._const_tab = ____NR_CGI_iE_Extensions__item__criticality_tab
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_CGI_iE_Extensions__item__id),
        (u'criticality', ___NR_CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_CGI_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_iE_Extensions__item_._ext = None
    _NR_CGI_iE_Extensions._cont = __NR_CGI_iE_Extensions__item_
    _NR_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI._cont = ASN1Dict([
        (u'pLMNIdentity', _NR_CGI_pLMNIdentity),
        (u'nRCellIdentity', _NR_CGI_nRCellIdentity),
        (u'iE-Extensions', _NR_CGI_iE_Extensions),
        ])
    NR_CGI._ext = []
    
    #-----< NR-CGI-ExtIEs >-----#
    NR_CGI_ExtIEs = CLASS(name=u'NR-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NR_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-CGIList >-----#
    NR_CGIList = SEQ_OF(name=u'NR-CGIList', mode=MODE_TYPE)
    _NR_CGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    NR_CGIList._cont = _NR_CGIList__item_
    NR_CGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< NR-CGIListForWarning >-----#
    NR_CGIListForWarning = SEQ_OF(name=u'NR-CGIListForWarning', mode=MODE_TYPE)
    _NR_CGIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    NR_CGIListForWarning._cont = _NR_CGIListForWarning__item_
    NR_CGIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< NRencryptionAlgorithms >-----#
    NRencryptionAlgorithms = BIT_STR(name=u'NRencryptionAlgorithms', mode=MODE_TYPE)
    NRencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRintegrityProtectionAlgorithms >-----#
    NRintegrityProtectionAlgorithms = BIT_STR(name=u'NRintegrityProtectionAlgorithms', mode=MODE_TYPE)
    NRintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRMobilityHistoryReport >-----#
    NRMobilityHistoryReport = OCT_STR(name=u'NRMobilityHistoryReport', mode=MODE_TYPE)
    
    #-----< NRPPa-PDU >-----#
    NRPPa_PDU = OCT_STR(name=u'NRPPa-PDU', mode=MODE_TYPE)
    
    #-----< NRUERLFReportContainer >-----#
    NRUERLFReportContainer = OCT_STR(name=u'NRUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name=u'NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberOfBroadcastsRequested >-----#
    NumberOfBroadcastsRequested = INT(name=u'NumberOfBroadcastsRequested', mode=MODE_TYPE)
    NumberOfBroadcastsRequested._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NRARFCN >-----#
    NRARFCN = INT(name=u'NRARFCN', mode=MODE_TYPE)
    NRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< NRFrequencyBand >-----#
    NRFrequencyBand = INT(name=u'NRFrequencyBand', mode=MODE_TYPE)
    NRFrequencyBand._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    
    #-----< NRFrequencyBand-List >-----#
    NRFrequencyBand_List = SEQ_OF(name=u'NRFrequencyBand-List', mode=MODE_TYPE)
    _NRFrequencyBand_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBandItem')))
    NRFrequencyBand_List._cont = _NRFrequencyBand_List__item_
    NRFrequencyBand_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NRFrequencyBandItem >-----#
    NRFrequencyBandItem = SEQ(name=u'NRFrequencyBandItem', mode=MODE_TYPE)
    _NRFrequencyBandItem_nr_frequency_band = INT(name=u'nr-frequency-band', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBand')))
    _NRFrequencyBandItem_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFrequencyBandItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRFrequencyBandItem_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRFrequencyBandItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab = ____NRFrequencyBandItem_iE_Extension__item__id_tab
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab_at = None
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab_id = u'id'
    ___NRFrequencyBandItem_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRFrequencyBandItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab = ____NRFrequencyBandItem_iE_Extension__item__criticality_tab
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab = ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NRFrequencyBandItem_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NRFrequencyBandItem_iE_Extension__item__id),
        (u'criticality', ___NRFrequencyBandItem_iE_Extension__item__criticality),
        (u'extensionValue', ___NRFrequencyBandItem_iE_Extension__item__extensionValue),
        ])
    __NRFrequencyBandItem_iE_Extension__item_._ext = None
    _NRFrequencyBandItem_iE_Extension._cont = __NRFrequencyBandItem_iE_Extension__item_
    _NRFrequencyBandItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFrequencyBandItem._cont = ASN1Dict([
        (u'nr-frequency-band', _NRFrequencyBandItem_nr_frequency_band),
        (u'iE-Extension', _NRFrequencyBandItem_iE_Extension),
        ])
    NRFrequencyBandItem._ext = []
    
    #-----< NRFrequencyBandItem-ExtIEs >-----#
    NRFrequencyBandItem_ExtIEs = CLASS(name=u'NRFrequencyBandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRFrequencyBandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRFrequencyInfo >-----#
    NRFrequencyInfo = SEQ(name=u'NRFrequencyInfo', mode=MODE_TYPE)
    _NRFrequencyInfo_nrARFCN = INT(name=u'nrARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRARFCN')))
    _NRFrequencyInfo_frequencyBand_List = SEQ_OF(name=u'frequencyBand-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBand-List')))
    _NRFrequencyInfo_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFrequencyInfo_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRFrequencyInfo_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRFrequencyInfo_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab = ____NRFrequencyInfo_iE_Extension__item__id_tab
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab_at = None
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab_id = u'id'
    ___NRFrequencyInfo_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRFrequencyInfo_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab = ____NRFrequencyInfo_iE_Extension__item__criticality_tab
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___NRFrequencyInfo_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab = ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __NRFrequencyInfo_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___NRFrequencyInfo_iE_Extension__item__id),
        (u'criticality', ___NRFrequencyInfo_iE_Extension__item__criticality),
        (u'extensionValue', ___NRFrequencyInfo_iE_Extension__item__extensionValue),
        ])
    __NRFrequencyInfo_iE_Extension__item_._ext = None
    _NRFrequencyInfo_iE_Extension._cont = __NRFrequencyInfo_iE_Extension__item_
    _NRFrequencyInfo_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFrequencyInfo._cont = ASN1Dict([
        (u'nrARFCN', _NRFrequencyInfo_nrARFCN),
        (u'frequencyBand-List', _NRFrequencyInfo_frequencyBand_List),
        (u'iE-Extension', _NRFrequencyInfo_iE_Extension),
        ])
    NRFrequencyInfo._ext = []
    
    #-----< NRFrequencyInfo-ExtIEs >-----#
    NRFrequencyInfo_ExtIEs = CLASS(name=u'NRFrequencyInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRFrequencyInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PCI >-----#
    NR_PCI = INT(name=u'NR-PCI', mode=MODE_TYPE)
    NR_PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=[], er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name=u'NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = []
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name=u'NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name=u'VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name=u'PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name=u'NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name=u'uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uESidelinkAggregateMaximumBitRate', _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        (u'iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name=u'NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OverloadAction >-----#
    OverloadAction = ENUM(name=u'OverloadAction', mode=MODE_TYPE)
    OverloadAction._cont = ASN1Dict([(u'reject-non-emergency-mo-dt', 0), (u'reject-rrc-cr-signalling', 1), (u'permit-emergency-sessions-and-mobile-terminated-services-only', 2), (u'permit-high-priority-sessions-and-mobile-terminated-services-only', 3)])
    OverloadAction._ext = []
    
    #-----< OverloadResponse >-----#
    OverloadResponse = CHOICE(name=u'OverloadResponse', mode=MODE_TYPE)
    _OverloadResponse_overloadAction = ENUM(name=u'overloadAction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'OverloadAction')))
    _OverloadResponse_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __OverloadResponse_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___OverloadResponse_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_id._const_tab = ___OverloadResponse_choice_Extensions_id_tab
    __OverloadResponse_choice_Extensions_id._const_tab_at = None
    __OverloadResponse_choice_Extensions_id._const_tab_id = u'id'
    __OverloadResponse_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___OverloadResponse_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_criticality._const_tab = ___OverloadResponse_choice_Extensions_criticality_tab
    __OverloadResponse_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __OverloadResponse_choice_Extensions_criticality._const_tab_id = u'criticality'
    __OverloadResponse_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___OverloadResponse_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_value._const_tab = ___OverloadResponse_choice_Extensions_value_tab
    __OverloadResponse_choice_Extensions_value._const_tab_at = ('..', u'id')
    __OverloadResponse_choice_Extensions_value._const_tab_id = u'Value'
    _OverloadResponse_choice_Extensions._cont = ASN1Dict([
        (u'id', __OverloadResponse_choice_Extensions_id),
        (u'criticality', __OverloadResponse_choice_Extensions_criticality),
        (u'value', __OverloadResponse_choice_Extensions_value),
        ])
    _OverloadResponse_choice_Extensions._ext = None
    OverloadResponse._cont = ASN1Dict([
        (u'overloadAction', _OverloadResponse_overloadAction),
        (u'choice-Extensions', _OverloadResponse_choice_Extensions),
        ])
    OverloadResponse._ext = None
    
    #-----< OverloadResponse-ExtIEs >-----#
    OverloadResponse_ExtIEs = CLASS(name=u'OverloadResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    OverloadResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OverloadStartNSSAIList >-----#
    OverloadStartNSSAIList = SEQ_OF(name=u'OverloadStartNSSAIList', mode=MODE_TYPE)
    _OverloadStartNSSAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIItem')))
    OverloadStartNSSAIList._cont = _OverloadStartNSSAIList__item_
    OverloadStartNSSAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< OverloadStartNSSAIItem >-----#
    OverloadStartNSSAIItem = SEQ(name=u'OverloadStartNSSAIItem', mode=MODE_TYPE)
    _OverloadStartNSSAIItem_sliceOverloadList = SEQ_OF(name=u'sliceOverloadList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceOverloadList')))
    _OverloadStartNSSAIItem_sliceOverloadResponse = CHOICE(name=u'sliceOverloadResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')), opt=True)
    _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication = INT(name=u'sliceTrafficLoadReductionIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')), opt=True)
    _OverloadStartNSSAIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OverloadStartNSSAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___OverloadStartNSSAIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab_at = None
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __OverloadStartNSSAIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___OverloadStartNSSAIItem_iE_Extensions__item__id),
        (u'criticality', ___OverloadStartNSSAIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue),
        ])
    __OverloadStartNSSAIItem_iE_Extensions__item_._ext = None
    _OverloadStartNSSAIItem_iE_Extensions._cont = __OverloadStartNSSAIItem_iE_Extensions__item_
    _OverloadStartNSSAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OverloadStartNSSAIItem._cont = ASN1Dict([
        (u'sliceOverloadList', _OverloadStartNSSAIItem_sliceOverloadList),
        (u'sliceOverloadResponse', _OverloadStartNSSAIItem_sliceOverloadResponse),
        (u'sliceTrafficLoadReductionIndication', _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication),
        (u'iE-Extensions', _OverloadStartNSSAIItem_iE_Extensions),
        ])
    OverloadStartNSSAIItem._ext = []
    
    #-----< OverloadStartNSSAIItem-ExtIEs >-----#
    OverloadStartNSSAIItem_ExtIEs = CLASS(name=u'OverloadStartNSSAIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    OverloadStartNSSAIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PacketDelayBudget >-----#
    PacketDelayBudget = INT(name=u'PacketDelayBudget', mode=MODE_TYPE)
    PacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< PacketErrorRate >-----#
    PacketErrorRate = SEQ(name=u'PacketErrorRate', mode=MODE_TYPE)
    _PacketErrorRate_pERScalar = INT(name=u'pERScalar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketErrorRate_pERScalar._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _PacketErrorRate_pERExponent = INT(name=u'pERExponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketErrorRate_pERExponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _PacketErrorRate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PacketErrorRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PacketErrorRate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PacketErrorRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__id._const_tab = ____PacketErrorRate_iE_Extensions__item__id_tab
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_at = None
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_id = u'id'
    ___PacketErrorRate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab = ____PacketErrorRate_iE_Extensions__item__criticality_tab
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PacketErrorRate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab = ____PacketErrorRate_iE_Extensions__item__extensionValue_tab
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PacketErrorRate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PacketErrorRate_iE_Extensions__item__id),
        (u'criticality', ___PacketErrorRate_iE_Extensions__item__criticality),
        (u'extensionValue', ___PacketErrorRate_iE_Extensions__item__extensionValue),
        ])
    __PacketErrorRate_iE_Extensions__item_._ext = None
    _PacketErrorRate_iE_Extensions._cont = __PacketErrorRate_iE_Extensions__item_
    _PacketErrorRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PacketErrorRate._cont = ASN1Dict([
        (u'pERScalar', _PacketErrorRate_pERScalar),
        (u'pERExponent', _PacketErrorRate_pERExponent),
        (u'iE-Extensions', _PacketErrorRate_iE_Extensions),
        ])
    PacketErrorRate._ext = []
    
    #-----< PacketErrorRate-ExtIEs >-----#
    PacketErrorRate_ExtIEs = CLASS(name=u'PacketErrorRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PacketErrorRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PacketLossRate >-----#
    PacketLossRate = INT(name=u'PacketLossRate', mode=MODE_TYPE)
    PacketLossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=[], er=[])
    
    #-----< PagingAssisDataforCEcapabUE >-----#
    PagingAssisDataforCEcapabUE = SEQ(name=u'PagingAssisDataforCEcapabUE', mode=MODE_TYPE)
    _PagingAssisDataforCEcapabUE_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _PagingAssisDataforCEcapabUE_coverageEnhancementLevel = OCT_STR(name=u'coverageEnhancementLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CoverageEnhancementLevel')))
    _PagingAssisDataforCEcapabUE_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab_at = None
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab_id = u'id'
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id),
        (u'criticality', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality),
        (u'extensionValue', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue),
        ])
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_._ext = None
    _PagingAssisDataforCEcapabUE_iE_Extensions._cont = __PagingAssisDataforCEcapabUE_iE_Extensions__item_
    _PagingAssisDataforCEcapabUE_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAssisDataforCEcapabUE._cont = ASN1Dict([
        (u'eUTRA-CGI', _PagingAssisDataforCEcapabUE_eUTRA_CGI),
        (u'coverageEnhancementLevel', _PagingAssisDataforCEcapabUE_coverageEnhancementLevel),
        (u'iE-Extensions', _PagingAssisDataforCEcapabUE_iE_Extensions),
        ])
    PagingAssisDataforCEcapabUE._ext = []
    
    #-----< PagingAssisDataforCEcapabUE-ExtIEs >-----#
    PagingAssisDataforCEcapabUE_ExtIEs = CLASS(name=u'PagingAssisDataforCEcapabUE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PagingAssisDataforCEcapabUE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptInformation >-----#
    PagingAttemptInformation = SEQ(name=u'PagingAttemptInformation', mode=MODE_TYPE)
    _PagingAttemptInformation_pagingAttemptCount = INT(name=u'pagingAttemptCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingAttemptCount')))
    _PagingAttemptInformation_intendedNumberOfPagingAttempts = INT(name=u'intendedNumberOfPagingAttempts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntendedNumberOfPagingAttempts')))
    _PagingAttemptInformation_nextPagingAreaScope = ENUM(name=u'nextPagingAreaScope', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NextPagingAreaScope')), opt=True)
    _PagingAttemptInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAttemptInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PagingAttemptInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab = ____PagingAttemptInformation_iE_Extensions__item__id_tab
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_at = None
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PagingAttemptInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab = ____PagingAttemptInformation_iE_Extensions__item__criticality_tab
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab = ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingAttemptInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PagingAttemptInformation_iE_Extensions__item__id),
        (u'criticality', ___PagingAttemptInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PagingAttemptInformation_iE_Extensions__item__extensionValue),
        ])
    __PagingAttemptInformation_iE_Extensions__item_._ext = None
    _PagingAttemptInformation_iE_Extensions._cont = __PagingAttemptInformation_iE_Extensions__item_
    _PagingAttemptInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAttemptInformation._cont = ASN1Dict([
        (u'pagingAttemptCount', _PagingAttemptInformation_pagingAttemptCount),
        (u'intendedNumberOfPagingAttempts', _PagingAttemptInformation_intendedNumberOfPagingAttempts),
        (u'nextPagingAreaScope', _PagingAttemptInformation_nextPagingAreaScope),
        (u'iE-Extensions', _PagingAttemptInformation_iE_Extensions),
        ])
    PagingAttemptInformation._ext = []
    
    #-----< PagingAttemptInformation-ExtIEs >-----#
    PagingAttemptInformation_ExtIEs = CLASS(name=u'PagingAttemptInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PagingAttemptInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptCount >-----#
    PagingAttemptCount = INT(name=u'PagingAttemptCount', mode=MODE_TYPE)
    PagingAttemptCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name=u'PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([(u'v32', 0), (u'v64', 1), (u'v128', 2), (u'v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingOrigin >-----#
    PagingOrigin = ENUM(name=u'PagingOrigin', mode=MODE_TYPE)
    PagingOrigin._cont = ASN1Dict([(u'non-3gpp', 0)])
    PagingOrigin._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name=u'PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([(u'priolevel1', 0), (u'priolevel2', 1), (u'priolevel3', 2), (u'priolevel4', 3), (u'priolevel5', 4), (u'priolevel6', 5), (u'priolevel7', 6), (u'priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< PagingeDRXInformation >-----#
    PagingeDRXInformation = SEQ(name=u'PagingeDRXInformation', mode=MODE_TYPE)
    _PagingeDRXInformation_paging_eDRX_Cycle = ENUM(name=u'paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Paging-eDRX-Cycle')))
    _PagingeDRXInformation_paging_Time_Window = ENUM(name=u'paging-Time-Window', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Paging-Time-Window')), opt=True)
    _PagingeDRXInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingeDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PagingeDRXInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingeDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingeDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingeDRXInformation_iE_Extensions__item__id._const_tab = ____PagingeDRXInformation_iE_Extensions__item__id_tab
    ___PagingeDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___PagingeDRXInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PagingeDRXInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PagingeDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingeDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingeDRXInformation_iE_Extensions__item__criticality._const_tab = ____PagingeDRXInformation_iE_Extensions__item__criticality_tab
    ___PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PagingeDRXInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PagingeDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingeDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____PagingeDRXInformation_iE_Extensions__item__extensionValue_tab
    ___PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingeDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PagingeDRXInformation_iE_Extensions__item__id),
        (u'criticality', ___PagingeDRXInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PagingeDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __PagingeDRXInformation_iE_Extensions__item_._ext = None
    _PagingeDRXInformation_iE_Extensions._cont = __PagingeDRXInformation_iE_Extensions__item_
    _PagingeDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingeDRXInformation._cont = ASN1Dict([
        (u'paging-eDRX-Cycle', _PagingeDRXInformation_paging_eDRX_Cycle),
        (u'paging-Time-Window', _PagingeDRXInformation_paging_Time_Window),
        (u'iE-Extensions', _PagingeDRXInformation_iE_Extensions),
        ])
    PagingeDRXInformation._ext = []
    
    #-----< PagingeDRXInformation-ExtIEs >-----#
    PagingeDRXInformation_ExtIEs = CLASS(name=u'PagingeDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PagingeDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging-eDRX-Cycle >-----#
    Paging_eDRX_Cycle = ENUM(name=u'Paging-eDRX-Cycle', mode=MODE_TYPE)
    Paging_eDRX_Cycle._cont = ASN1Dict([(u'hfhalf', 0), (u'hf1', 1), (u'hf2', 2), (u'hf4', 3), (u'hf6', 4), (u'hf8', 5), (u'hf10', 6), (u'hf12', 7), (u'hf14', 8), (u'hf16', 9), (u'hf32', 10), (u'hf64', 11), (u'hf128', 12), (u'hf256', 13)])
    Paging_eDRX_Cycle._ext = []
    
    #-----< Paging-Time-Window >-----#
    Paging_Time_Window = ENUM(name=u'Paging-Time-Window', mode=MODE_TYPE)
    Paging_Time_Window._cont = ASN1Dict([(u's1', 0), (u's2', 1), (u's3', 2), (u's4', 3), (u's5', 4), (u's6', 5), (u's7', 6), (u's8', 7), (u's9', 8), (u's10', 9), (u's11', 10), (u's12', 11), (u's13', 12), (u's14', 13), (u's15', 14), (u's16', 15)])
    Paging_Time_Window._ext = []
    
    #-----< PagingProbabilityInformation >-----#
    PagingProbabilityInformation = ENUM(name=u'PagingProbabilityInformation', mode=MODE_TYPE)
    PagingProbabilityInformation._cont = ASN1Dict([(u'p00', 0), (u'p05', 1), (u'p10', 2), (u'p15', 3), (u'p20', 4), (u'p25', 5), (u'p30', 6), (u'p35', 7), (u'p40', 8), (u'p45', 9), (u'p50', 10), (u'p55', 11), (u'p60', 12), (u'p65', 13), (u'p70', 14), (u'p75', 15), (u'p80', 16), (u'p85', 17), (u'p90', 18), (u'p95', 19), (u'p100', 20)])
    PagingProbabilityInformation._ext = []
    
    #-----< PathSwitchRequestAcknowledgeTransfer >-----#
    PathSwitchRequestAcknowledgeTransfer = SEQ(name=u'PathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation = CHOICE(name=u'uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PathSwitchRequestAcknowledgeTransfer_securityIndication = SEQ(name=u'securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')), opt=True)
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersList')))
    ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id),
        (u'criticality', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions._cont = __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledgeTransfer._cont = ASN1Dict([
        (u'uL-NGU-UP-TNLInformation', _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation),
        (u'securityIndication', _PathSwitchRequestAcknowledgeTransfer_securityIndication),
        (u'iE-Extensions', _PathSwitchRequestAcknowledgeTransfer_iE_Extensions),
        ])
    PathSwitchRequestAcknowledgeTransfer._ext = []
    
    #-----< PathSwitchRequestAcknowledgeTransfer-ExtIEs >-----#
    PathSwitchRequestAcknowledgeTransfer_ExtIEs = CLASS(name=u'PathSwitchRequestAcknowledgeTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersList')))
    PathSwitchRequestAcknowledgeTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestSetupFailedTransfer >-----#
    PathSwitchRequestSetupFailedTransfer = SEQ(name=u'PathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE)
    _PathSwitchRequestSetupFailedTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id),
        (u'criticality', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions._cont = __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestSetupFailedTransfer._cont = ASN1Dict([
        (u'cause', _PathSwitchRequestSetupFailedTransfer_cause),
        (u'iE-Extensions', _PathSwitchRequestSetupFailedTransfer_iE_Extensions),
        ])
    PathSwitchRequestSetupFailedTransfer._ext = []
    
    #-----< PathSwitchRequestSetupFailedTransfer-ExtIEs >-----#
    PathSwitchRequestSetupFailedTransfer_ExtIEs = CLASS(name=u'PathSwitchRequestSetupFailedTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PathSwitchRequestSetupFailedTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestTransfer >-----#
    PathSwitchRequestTransfer = SEQ(name=u'PathSwitchRequestTransfer', mode=MODE_TYPE)
    _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation = CHOICE(name=u'dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused = ENUM(name=u'dL-NGU-TNLInformationReused', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')), opt=True)
    _PathSwitchRequestTransfer_userPlaneSecurityInformation = SEQ(name=u'userPlaneSecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserPlaneSecurityInformation')), opt=True)
    _PathSwitchRequestTransfer_qosFlowAcceptedList = SEQ_OF(name=u'qosFlowAcceptedList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAcceptedList')))
    _PathSwitchRequestTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 191), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathSwitchRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestTransfer_iE_Extensions__item__id),
        (u'criticality', ___PathSwitchRequestTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestTransfer_iE_Extensions._cont = __PathSwitchRequestTransfer_iE_Extensions__item_
    _PathSwitchRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestTransfer._cont = ASN1Dict([
        (u'dL-NGU-UP-TNLInformation', _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation),
        (u'dL-NGU-TNLInformationReused', _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused),
        (u'userPlaneSecurityInformation', _PathSwitchRequestTransfer_userPlaneSecurityInformation),
        (u'qosFlowAcceptedList', _PathSwitchRequestTransfer_qosFlowAcceptedList),
        (u'iE-Extensions', _PathSwitchRequestTransfer_iE_Extensions),
        ])
    PathSwitchRequestTransfer._ext = []
    
    #-----< PathSwitchRequestTransfer-ExtIEs >-----#
    PathSwitchRequestTransfer_ExtIEs = CLASS(name=u'PathSwitchRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_5 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PathSwitchRequestTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 191), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestUnsuccessfulTransfer >-----#
    PathSwitchRequestUnsuccessfulTransfer = SEQ(name=u'PathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE)
    _PathSwitchRequestUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions._cont = __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _PathSwitchRequestUnsuccessfulTransfer_cause),
        (u'iE-Extensions', _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions),
        ])
    PathSwitchRequestUnsuccessfulTransfer._ext = []
    
    #-----< PathSwitchRequestUnsuccessfulTransfer-ExtIEs >-----#
    PathSwitchRequestUnsuccessfulTransfer_ExtIEs = CLASS(name=u'PathSwitchRequestUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PathSwitchRequestUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name=u'PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pc5QoSFlowList = SEQ_OF(name=u'pc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSFlowList')))
    _PC5QoSParameters_pc5LinkAggregateBitRates = INT(name=u'pc5LinkAggregateBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5QoSParameters_iE_Extensions__item__id),
        (u'criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        (u'pc5QoSFlowList', _PC5QoSParameters_pc5QoSFlowList),
        (u'pc5LinkAggregateBitRates', _PC5QoSParameters_pc5LinkAggregateBitRates),
        (u'iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name=u'PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowList >-----#
    PC5QoSFlowList = SEQ_OF(name=u'PC5QoSFlowList', mode=MODE_TYPE)
    _PC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSFlowItem')))
    PC5QoSFlowList._cont = _PC5QoSFlowList__item_
    PC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5QoSFlowItem >-----#
    PC5QoSFlowItem = SEQ(name=u'PC5QoSFlowItem', mode=MODE_TYPE)
    _PC5QoSFlowItem_pQI = INT(name=u'pQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _PC5QoSFlowItem_pc5FlowBitRates = SEQ(name=u'pc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSFlowItem_range = ENUM(name=u'range', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Range')), opt=True)
    _PC5QoSFlowItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSFlowItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__id_tab
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5QoSFlowItem_iE_Extensions__item__id),
        (u'criticality', ___PC5QoSFlowItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSFlowItem_iE_Extensions__item_._ext = None
    _PC5QoSFlowItem_iE_Extensions._cont = __PC5QoSFlowItem_iE_Extensions__item_
    _PC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSFlowItem._cont = ASN1Dict([
        (u'pQI', _PC5QoSFlowItem_pQI),
        (u'pc5FlowBitRates', _PC5QoSFlowItem_pc5FlowBitRates),
        (u'range', _PC5QoSFlowItem_range),
        (u'iE-Extensions', _PC5QoSFlowItem_iE_Extensions),
        ])
    PC5QoSFlowItem._ext = []
    
    #-----< PC5QoSFlowItem-ExtIEs >-----#
    PC5QoSFlowItem_ExtIEs = CLASS(name=u'PC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name=u'PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name=u'guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name=u'maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5FlowBitRates_iE_Extensions__item__id),
        (u'criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        (u'guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        (u'maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        (u'iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name=u'PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCIListForMDT >-----#
    PCIListForMDT = SEQ_OF(name=u'PCIListForMDT', mode=MODE_TYPE)
    _PCIListForMDT__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PCI')))
    PCIListForMDT._cont = _PCIListForMDT__item_
    PCIListForMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name=u'PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([(u'immediate-MDT', 0), (u'logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< PDUSessionAggregateMaximumBitRate >-----#
    PDUSessionAggregateMaximumBitRate = SEQ(name=u'PDUSessionAggregateMaximumBitRate', mode=MODE_TYPE)
    _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL = INT(name=u'pDUSessionAggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL = INT(name=u'pDUSessionAggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PDUSessionAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _PDUSessionAggregateMaximumBitRate_iE_Extensions._cont = __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_
    _PDUSessionAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionAggregateMaximumBitRate._cont = ASN1Dict([
        (u'pDUSessionAggregateMaximumBitRateDL', _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL),
        (u'pDUSessionAggregateMaximumBitRateUL', _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL),
        (u'iE-Extensions', _PDUSessionAggregateMaximumBitRate_iE_Extensions),
        ])
    PDUSessionAggregateMaximumBitRate._ext = []
    
    #-----< PDUSessionAggregateMaximumBitRate-ExtIEs >-----#
    PDUSessionAggregateMaximumBitRate_ExtIEs = CLASS(name=u'PDUSessionAggregateMaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionAggregateMaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionID >-----#
    PDUSessionID = INT(name=u'PDUSessionID', mode=MODE_TYPE)
    PDUSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PDUSessionResourceAdmittedList >-----#
    PDUSessionResourceAdmittedList = SEQ_OF(name=u'PDUSessionResourceAdmittedList', mode=MODE_TYPE)
    _PDUSessionResourceAdmittedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedItem')))
    PDUSessionResourceAdmittedList._cont = _PDUSessionResourceAdmittedList__item_
    PDUSessionResourceAdmittedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceAdmittedItem >-----#
    PDUSessionResourceAdmittedItem = SEQ(name=u'PDUSessionResourceAdmittedItem', mode=MODE_TYPE)
    _PDUSessionResourceAdmittedItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer = OCT_STR(name=u'handoverRequestAcknowledgeTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain = SEQ(name='_cont_handoverRequestAcknowledgeTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverRequestAcknowledgeTransfer')))
    _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer._const_cont = __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain
    _PDUSessionResourceAdmittedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceAdmittedItem_iE_Extensions._cont = __PDUSessionResourceAdmittedItem_iE_Extensions__item_
    _PDUSessionResourceAdmittedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceAdmittedItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceAdmittedItem_pDUSessionID),
        (u'handoverRequestAcknowledgeTransfer', _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer),
        (u'iE-Extensions', _PDUSessionResourceAdmittedItem_iE_Extensions),
        ])
    PDUSessionResourceAdmittedItem._ext = []
    
    #-----< PDUSessionResourceAdmittedItem-ExtIEs >-----#
    PDUSessionResourceAdmittedItem_ExtIEs = CLASS(name=u'PDUSessionResourceAdmittedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceAdmittedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToModifyListModCfm >-----#
    PDUSessionResourceFailedToModifyListModCfm = SEQ_OF(name=u'PDUSessionResourceFailedToModifyListModCfm', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyListModCfm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyItemModCfm')))
    PDUSessionResourceFailedToModifyListModCfm._cont = _PDUSessionResourceFailedToModifyListModCfm__item_
    PDUSessionResourceFailedToModifyListModCfm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToModifyItemModCfm >-----#
    PDUSessionResourceFailedToModifyItemModCfm = SEQ(name=u'PDUSessionResourceFailedToModifyItemModCfm', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer = OCT_STR(name=u'pDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyIndicationUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions._cont = __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToModifyItemModCfm._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID),
        (u'pDUSessionResourceModifyIndicationUnsuccessfulTransfer', _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions),
        ])
    PDUSessionResourceFailedToModifyItemModCfm._ext = []
    
    #-----< PDUSessionResourceFailedToModifyItemModCfm-ExtIEs >-----#
    PDUSessionResourceFailedToModifyItemModCfm_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToModifyItemModCfm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToModifyListModRes >-----#
    PDUSessionResourceFailedToModifyListModRes = SEQ_OF(name=u'PDUSessionResourceFailedToModifyListModRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyListModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyItemModRes')))
    PDUSessionResourceFailedToModifyListModRes._cont = _PDUSessionResourceFailedToModifyListModRes__item_
    PDUSessionResourceFailedToModifyListModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToModifyItemModRes >-----#
    PDUSessionResourceFailedToModifyItemModRes = SEQ(name=u'PDUSessionResourceFailedToModifyItemModRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer = OCT_STR(name=u'pDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions._cont = __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToModifyItemModRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID),
        (u'pDUSessionResourceModifyUnsuccessfulTransfer', _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToModifyItemModRes._ext = []
    
    #-----< PDUSessionResourceFailedToModifyItemModRes-ExtIEs >-----#
    PDUSessionResourceFailedToModifyItemModRes_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToModifyItemModRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToModifyItemModRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToResumeListRESReq >-----#
    PDUSessionResourceFailedToResumeListRESReq = SEQ_OF(name=u'PDUSessionResourceFailedToResumeListRESReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeListRESReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeItemRESReq')))
    PDUSessionResourceFailedToResumeListRESReq._cont = _PDUSessionResourceFailedToResumeListRESReq__item_
    PDUSessionResourceFailedToResumeListRESReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToResumeItemRESReq >-----#
    PDUSessionResourceFailedToResumeItemRESReq = SEQ(name=u'PDUSessionResourceFailedToResumeItemRESReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToResumeItemRESReq_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions._cont = __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToResumeItemRESReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID),
        (u'cause', _PDUSessionResourceFailedToResumeItemRESReq_cause),
        (u'iE-Extensions', _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions),
        ])
    PDUSessionResourceFailedToResumeItemRESReq._ext = []
    
    #-----< PDUSessionResourceFailedToResumeItemRESReq-ExtIEs >-----#
    PDUSessionResourceFailedToResumeItemRESReq_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToResumeItemRESReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToResumeListRESRes >-----#
    PDUSessionResourceFailedToResumeListRESRes = SEQ_OF(name=u'PDUSessionResourceFailedToResumeListRESRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeListRESRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeItemRESRes')))
    PDUSessionResourceFailedToResumeListRESRes._cont = _PDUSessionResourceFailedToResumeListRESRes__item_
    PDUSessionResourceFailedToResumeListRESRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToResumeItemRESRes >-----#
    PDUSessionResourceFailedToResumeItemRESRes = SEQ(name=u'PDUSessionResourceFailedToResumeItemRESRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToResumeItemRESRes_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions._cont = __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToResumeItemRESRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID),
        (u'cause', _PDUSessionResourceFailedToResumeItemRESRes_cause),
        (u'iE-Extensions', _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToResumeItemRESRes._ext = []
    
    #-----< PDUSessionResourceFailedToResumeItemRESRes-ExtIEs >-----#
    PDUSessionResourceFailedToResumeItemRESRes_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToResumeItemRESRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListCxtFail >-----#
    PDUSessionResourceFailedToSetupListCxtFail = SEQ_OF(name=u'PDUSessionResourceFailedToSetupListCxtFail', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListCxtFail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemCxtFail')))
    PDUSessionResourceFailedToSetupListCxtFail._cont = _PDUSessionResourceFailedToSetupListCxtFail__item_
    PDUSessionResourceFailedToSetupListCxtFail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemCxtFail >-----#
    PDUSessionResourceFailedToSetupItemCxtFail = SEQ(name=u'PDUSessionResourceFailedToSetupItemCxtFail', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name=u'pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemCxtFail._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID),
        (u'pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemCxtFail._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListCxtRes >-----#
    PDUSessionResourceFailedToSetupListCxtRes = SEQ_OF(name=u'PDUSessionResourceFailedToSetupListCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListCxtRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemCxtRes')))
    PDUSessionResourceFailedToSetupListCxtRes._cont = _PDUSessionResourceFailedToSetupListCxtRes__item_
    PDUSessionResourceFailedToSetupListCxtRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemCxtRes >-----#
    PDUSessionResourceFailedToSetupItemCxtRes = SEQ(name=u'PDUSessionResourceFailedToSetupItemCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name=u'pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemCxtRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID),
        (u'pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemCxtRes._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListHOAck >-----#
    PDUSessionResourceFailedToSetupListHOAck = SEQ_OF(name=u'PDUSessionResourceFailedToSetupListHOAck', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListHOAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemHOAck')))
    PDUSessionResourceFailedToSetupListHOAck._cont = _PDUSessionResourceFailedToSetupListHOAck__item_
    PDUSessionResourceFailedToSetupListHOAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemHOAck >-----#
    PDUSessionResourceFailedToSetupItemHOAck = SEQ(name=u'PDUSessionResourceFailedToSetupItemHOAck', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer = OCT_STR(name=u'handoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain = SEQ(name='_cont_handoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverResourceAllocationUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemHOAck._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID),
        (u'handoverResourceAllocationUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemHOAck._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemHOAck-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemHOAck_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemHOAck_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListPSReq >-----#
    PDUSessionResourceFailedToSetupListPSReq = SEQ_OF(name=u'PDUSessionResourceFailedToSetupListPSReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListPSReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemPSReq')))
    PDUSessionResourceFailedToSetupListPSReq._cont = _PDUSessionResourceFailedToSetupListPSReq__item_
    PDUSessionResourceFailedToSetupListPSReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemPSReq >-----#
    PDUSessionResourceFailedToSetupItemPSReq = SEQ(name=u'PDUSessionResourceFailedToSetupItemPSReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer = OCT_STR(name=u'pathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain = SEQ(name='_cont_pathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestSetupFailedTransfer')))
    _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer._const_cont = __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemPSReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID),
        (u'pathSwitchRequestSetupFailedTransfer', _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemPSReq._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemPSReq-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemPSReq_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemPSReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListSURes >-----#
    PDUSessionResourceFailedToSetupListSURes = SEQ_OF(name=u'PDUSessionResourceFailedToSetupListSURes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemSURes')))
    PDUSessionResourceFailedToSetupListSURes._cont = _PDUSessionResourceFailedToSetupListSURes__item_
    PDUSessionResourceFailedToSetupListSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemSURes >-----#
    PDUSessionResourceFailedToSetupItemSURes = SEQ(name=u'PDUSessionResourceFailedToSetupItemSURes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name=u'pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemSURes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID),
        (u'pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemSURes._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemSURes-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemSURes_ExtIEs = CLASS(name=u'PDUSessionResourceFailedToSetupItemSURes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemSURes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceHandoverList >-----#
    PDUSessionResourceHandoverList = SEQ_OF(name=u'PDUSessionResourceHandoverList', mode=MODE_TYPE)
    _PDUSessionResourceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverItem')))
    PDUSessionResourceHandoverList._cont = _PDUSessionResourceHandoverList__item_
    PDUSessionResourceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceHandoverItem >-----#
    PDUSessionResourceHandoverItem = SEQ(name=u'PDUSessionResourceHandoverItem', mode=MODE_TYPE)
    _PDUSessionResourceHandoverItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceHandoverItem_handoverCommandTransfer = OCT_STR(name=u'handoverCommandTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain = SEQ(name='_cont_handoverCommandTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverCommandTransfer')))
    _PDUSessionResourceHandoverItem_handoverCommandTransfer._const_cont = __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain
    _PDUSessionResourceHandoverItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceHandoverItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceHandoverItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceHandoverItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceHandoverItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceHandoverItem_iE_Extensions._cont = __PDUSessionResourceHandoverItem_iE_Extensions__item_
    _PDUSessionResourceHandoverItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceHandoverItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceHandoverItem_pDUSessionID),
        (u'handoverCommandTransfer', _PDUSessionResourceHandoverItem_handoverCommandTransfer),
        (u'iE-Extensions', _PDUSessionResourceHandoverItem_iE_Extensions),
        ])
    PDUSessionResourceHandoverItem._ext = []
    
    #-----< PDUSessionResourceHandoverItem-ExtIEs >-----#
    PDUSessionResourceHandoverItem_ExtIEs = CLASS(name=u'PDUSessionResourceHandoverItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceHandoverItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceInformationList >-----#
    PDUSessionResourceInformationList = SEQ_OF(name=u'PDUSessionResourceInformationList', mode=MODE_TYPE)
    _PDUSessionResourceInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceInformationItem')))
    PDUSessionResourceInformationList._cont = _PDUSessionResourceInformationList__item_
    PDUSessionResourceInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceInformationItem >-----#
    PDUSessionResourceInformationItem = SEQ(name=u'PDUSessionResourceInformationItem', mode=MODE_TYPE)
    _PDUSessionResourceInformationItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceInformationItem_qosFlowInformationList = SEQ_OF(name=u'qosFlowInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowInformationList')))
    _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList = SEQ_OF(name=u'dRBsToQosFlowsMappingList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsToQosFlowsMappingList')), opt=True)
    _PDUSessionResourceInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceInformationItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceInformationItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceInformationItem_iE_Extensions._cont = __PDUSessionResourceInformationItem_iE_Extensions__item_
    _PDUSessionResourceInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceInformationItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceInformationItem_pDUSessionID),
        (u'qosFlowInformationList', _PDUSessionResourceInformationItem_qosFlowInformationList),
        (u'dRBsToQosFlowsMappingList', _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList),
        (u'iE-Extensions', _PDUSessionResourceInformationItem_iE_Extensions),
        ])
    PDUSessionResourceInformationItem._ext = []
    
    #-----< PDUSessionResourceInformationItem-ExtIEs >-----#
    PDUSessionResourceInformationItem_ExtIEs = CLASS(name=u'PDUSessionResourceInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListCxtRelCpl >-----#
    PDUSessionResourceListCxtRelCpl = SEQ_OF(name=u'PDUSessionResourceListCxtRelCpl', mode=MODE_TYPE)
    _PDUSessionResourceListCxtRelCpl__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemCxtRelCpl')))
    PDUSessionResourceListCxtRelCpl._cont = _PDUSessionResourceListCxtRelCpl__item_
    PDUSessionResourceListCxtRelCpl._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemCxtRelCpl >-----#
    PDUSessionResourceItemCxtRelCpl = SEQ(name=u'PDUSessionResourceItemCxtRelCpl', mode=MODE_TYPE)
    _PDUSessionResourceItemCxtRelCpl_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE)
    ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain = SEQ(name='_cont_Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0._const_cont = ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain
    ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions._cont = __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemCxtRelCpl._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceItemCxtRelCpl_pDUSessionID),
        (u'iE-Extensions', _PDUSessionResourceItemCxtRelCpl_iE_Extensions),
        ])
    PDUSessionResourceItemCxtRelCpl._ext = []
    
    #-----< PDUSessionResourceItemCxtRelCpl-ExtIEs >-----#
    PDUSessionResourceItemCxtRelCpl_ExtIEs = CLASS(name=u'PDUSessionResourceItemCxtRelCpl-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE)
    __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain = SEQ(name='_cont_Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0._const_cont = __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain
    PDUSessionResourceItemCxtRelCpl_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListCxtRelReq >-----#
    PDUSessionResourceListCxtRelReq = SEQ_OF(name=u'PDUSessionResourceListCxtRelReq', mode=MODE_TYPE)
    _PDUSessionResourceListCxtRelReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemCxtRelReq')))
    PDUSessionResourceListCxtRelReq._cont = _PDUSessionResourceListCxtRelReq__item_
    PDUSessionResourceListCxtRelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemCxtRelReq >-----#
    PDUSessionResourceItemCxtRelReq = SEQ(name=u'PDUSessionResourceItemCxtRelReq', mode=MODE_TYPE)
    _PDUSessionResourceItemCxtRelReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemCxtRelReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemCxtRelReq_iE_Extensions._cont = __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_
    _PDUSessionResourceItemCxtRelReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemCxtRelReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceItemCxtRelReq_pDUSessionID),
        (u'iE-Extensions', _PDUSessionResourceItemCxtRelReq_iE_Extensions),
        ])
    PDUSessionResourceItemCxtRelReq._ext = []
    
    #-----< PDUSessionResourceItemCxtRelReq-ExtIEs >-----#
    PDUSessionResourceItemCxtRelReq_ExtIEs = CLASS(name=u'PDUSessionResourceItemCxtRelReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceItemCxtRelReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListHORqd >-----#
    PDUSessionResourceListHORqd = SEQ_OF(name=u'PDUSessionResourceListHORqd', mode=MODE_TYPE)
    _PDUSessionResourceListHORqd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemHORqd')))
    PDUSessionResourceListHORqd._cont = _PDUSessionResourceListHORqd__item_
    PDUSessionResourceListHORqd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemHORqd >-----#
    PDUSessionResourceItemHORqd = SEQ(name=u'PDUSessionResourceItemHORqd', mode=MODE_TYPE)
    _PDUSessionResourceItemHORqd_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemHORqd_handoverRequiredTransfer = OCT_STR(name=u'handoverRequiredTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain = SEQ(name='_cont_handoverRequiredTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverRequiredTransfer')))
    _PDUSessionResourceItemHORqd_handoverRequiredTransfer._const_cont = __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain
    _PDUSessionResourceItemHORqd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemHORqd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceItemHORqd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceItemHORqd_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemHORqd_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemHORqd_iE_Extensions._cont = __PDUSessionResourceItemHORqd_iE_Extensions__item_
    _PDUSessionResourceItemHORqd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemHORqd._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceItemHORqd_pDUSessionID),
        (u'handoverRequiredTransfer', _PDUSessionResourceItemHORqd_handoverRequiredTransfer),
        (u'iE-Extensions', _PDUSessionResourceItemHORqd_iE_Extensions),
        ])
    PDUSessionResourceItemHORqd._ext = []
    
    #-----< PDUSessionResourceItemHORqd-ExtIEs >-----#
    PDUSessionResourceItemHORqd_ExtIEs = CLASS(name=u'PDUSessionResourceItemHORqd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceItemHORqd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyConfirmTransfer >-----#
    PDUSessionResourceModifyConfirmTransfer = SEQ(name=u'PDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList = SEQ_OF(name=u'qosFlowModifyConfirmList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowModifyConfirmList')))
    _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation = CHOICE(name=u'uLNGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation = SEQ_OF(name=u'additionalNG-UUPTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')), opt=True)
    _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList = SEQ_OF(name=u'qosFlowFailedToModifyList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions._cont = __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyConfirmTransfer._cont = ASN1Dict([
        (u'qosFlowModifyConfirmList', _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList),
        (u'uLNGU-UP-TNLInformation', _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation),
        (u'additionalNG-UUPTNLInformation', _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation),
        (u'qosFlowFailedToModifyList', _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList),
        (u'iE-Extensions', _PDUSessionResourceModifyConfirmTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyConfirmTransfer._ext = []
    
    #-----< PDUSessionResourceModifyConfirmTransfer-ExtIEs >-----#
    PDUSessionResourceModifyConfirmTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceModifyConfirmTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    PDUSessionResourceModifyConfirmTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndicationUnsuccessfulTransfer >-----#
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer = SEQ(name=u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause),
        (u'iE-Extensions', _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyRequestTransfer >-----#
    PDUSessionResourceModifyRequestTransfer = SEQ(name=u'PDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyRequestTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 135), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyRequestTransfer_protocolIEs._cont = __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_
    _PDUSessionResourceModifyRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyRequestTransfer._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceModifyRequestTransfer_protocolIEs),
        ])
    PDUSessionResourceModifyRequestTransfer._ext = []
    
    #-----< PDUSessionResourceModifyRequestTransferIEs >-----#
    PDUSessionResourceModifyRequestTransferIEs = CLASS(name=u'PDUSessionResourceModifyRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_9 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    PDUSessionResourceModifyRequestTransferIEs._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 135), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyResponseTransfer >-----#
    PDUSessionResourceModifyResponseTransfer = SEQ(name=u'PDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation = CHOICE(name=u'dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation = CHOICE(name=u'uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList = SEQ_OF(name=u'qosFlowAddOrModifyResponseList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyResponseList')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name=u'additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList = SEQ_OF(name=u'qosFlowFailedToAddOrModifyList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions._cont = __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyResponseTransfer._cont = ASN1Dict([
        (u'dL-NGU-UP-TNLInformation', _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation),
        (u'uL-NGU-UP-TNLInformation', _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation),
        (u'qosFlowAddOrModifyResponseList', _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList),
        (u'additionalDLQosFlowPerTNLInformation', _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation),
        (u'qosFlowFailedToAddOrModifyList', _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList),
        (u'iE-Extensions', _PDUSessionResourceModifyResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyResponseTransfer._ext = []
    
    #-----< PDUSessionResourceModifyResponseTransfer-ExtIEs >-----#
    PDUSessionResourceModifyResponseTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceModifyResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    PDUSessionResourceModifyResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndicationTransfer >-----#
    PDUSessionResourceModifyIndicationTransfer = SEQ(name=u'PDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation = SEQ(name=u'dLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name=u'additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions._cont = __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndicationTransfer._cont = ASN1Dict([
        (u'dLQosFlowPerTNLInformation', _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation),
        (u'additionalDLQosFlowPerTNLInformation', _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation),
        (u'iE-Extensions', _PDUSessionResourceModifyIndicationTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyIndicationTransfer._ext = []
    
    #-----< PDUSessionResourceModifyIndicationTransfer-ExtIEs >-----#
    PDUSessionResourceModifyIndicationTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceModifyIndicationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PDUSessionResourceModifyIndicationTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModCfm >-----#
    PDUSessionResourceModifyListModCfm = SEQ_OF(name=u'PDUSessionResourceModifyListModCfm', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModCfm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModCfm')))
    PDUSessionResourceModifyListModCfm._cont = _PDUSessionResourceModifyListModCfm__item_
    PDUSessionResourceModifyListModCfm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModCfm >-----#
    PDUSessionResourceModifyItemModCfm = SEQ(name=u'PDUSessionResourceModifyItemModCfm', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModCfm_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer = OCT_STR(name=u'pDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyConfirmTransfer')))
    _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer._const_cont = __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain
    _PDUSessionResourceModifyItemModCfm_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModCfm_iE_Extensions._cont = __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_
    _PDUSessionResourceModifyItemModCfm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModCfm._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceModifyItemModCfm_pDUSessionID),
        (u'pDUSessionResourceModifyConfirmTransfer', _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer),
        (u'iE-Extensions', _PDUSessionResourceModifyItemModCfm_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModCfm._ext = []
    
    #-----< PDUSessionResourceModifyItemModCfm-ExtIEs >-----#
    PDUSessionResourceModifyItemModCfm_ExtIEs = CLASS(name=u'PDUSessionResourceModifyItemModCfm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModCfm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModInd >-----#
    PDUSessionResourceModifyListModInd = SEQ_OF(name=u'PDUSessionResourceModifyListModInd', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModInd')))
    PDUSessionResourceModifyListModInd._cont = _PDUSessionResourceModifyListModInd__item_
    PDUSessionResourceModifyListModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModInd >-----#
    PDUSessionResourceModifyItemModInd = SEQ(name=u'PDUSessionResourceModifyItemModInd', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModInd_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer = OCT_STR(name=u'pDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyIndicationTransfer')))
    _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer._const_cont = __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain
    _PDUSessionResourceModifyItemModInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModInd_iE_Extensions._cont = __PDUSessionResourceModifyItemModInd_iE_Extensions__item_
    _PDUSessionResourceModifyItemModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModInd._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceModifyItemModInd_pDUSessionID),
        (u'pDUSessionResourceModifyIndicationTransfer', _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer),
        (u'iE-Extensions', _PDUSessionResourceModifyItemModInd_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModInd._ext = []
    
    #-----< PDUSessionResourceModifyItemModInd-ExtIEs >-----#
    PDUSessionResourceModifyItemModInd_ExtIEs = CLASS(name=u'PDUSessionResourceModifyItemModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModReq >-----#
    PDUSessionResourceModifyListModReq = SEQ_OF(name=u'PDUSessionResourceModifyListModReq', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModReq')))
    PDUSessionResourceModifyListModReq._cont = _PDUSessionResourceModifyListModReq__item_
    PDUSessionResourceModifyListModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModReq >-----#
    PDUSessionResourceModifyItemModReq = SEQ(name=u'PDUSessionResourceModifyItemModReq', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModReq_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer = OCT_STR(name=u'pDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyRequestTransfer')))
    _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer._const_cont = __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain
    _PDUSessionResourceModifyItemModReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Extension', _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModReq_iE_Extensions._cont = __PDUSessionResourceModifyItemModReq_iE_Extensions__item_
    _PDUSessionResourceModifyItemModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceModifyItemModReq_pDUSessionID),
        (u'nAS-PDU', _PDUSessionResourceModifyItemModReq_nAS_PDU),
        (u'pDUSessionResourceModifyRequestTransfer', _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceModifyItemModReq_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModReq._ext = []
    
    #-----< PDUSessionResourceModifyItemModReq-ExtIEs >-----#
    PDUSessionResourceModifyItemModReq_ExtIEs = CLASS(name=u'PDUSessionResourceModifyItemModReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceModifyItemModReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Extension', _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModRes >-----#
    PDUSessionResourceModifyListModRes = SEQ_OF(name=u'PDUSessionResourceModifyListModRes', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModRes')))
    PDUSessionResourceModifyListModRes._cont = _PDUSessionResourceModifyListModRes__item_
    PDUSessionResourceModifyListModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModRes >-----#
    PDUSessionResourceModifyItemModRes = SEQ(name=u'PDUSessionResourceModifyItemModRes', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer = OCT_STR(name=u'pDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyResponseTransfer')))
    _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer._const_cont = __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain
    _PDUSessionResourceModifyItemModRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModRes_iE_Extensions._cont = __PDUSessionResourceModifyItemModRes_iE_Extensions__item_
    _PDUSessionResourceModifyItemModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceModifyItemModRes_pDUSessionID),
        (u'pDUSessionResourceModifyResponseTransfer', _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer),
        (u'iE-Extensions', _PDUSessionResourceModifyItemModRes_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModRes._ext = []
    
    #-----< PDUSessionResourceModifyItemModRes-ExtIEs >-----#
    PDUSessionResourceModifyItemModRes_ExtIEs = CLASS(name=u'PDUSessionResourceModifyItemModRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyUnsuccessfulTransfer >-----#
    PDUSessionResourceModifyUnsuccessfulTransfer = SEQ(name=u'PDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name=u'criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _PDUSessionResourceModifyUnsuccessfulTransfer_cause),
        (u'criticalityDiagnostics', _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics),
        (u'iE-Extensions', _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyList >-----#
    PDUSessionResourceNotifyList = SEQ_OF(name=u'PDUSessionResourceNotifyList', mode=MODE_TYPE)
    _PDUSessionResourceNotifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyItem')))
    PDUSessionResourceNotifyList._cont = _PDUSessionResourceNotifyList__item_
    PDUSessionResourceNotifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceNotifyItem >-----#
    PDUSessionResourceNotifyItem = SEQ(name=u'PDUSessionResourceNotifyItem', mode=MODE_TYPE)
    _PDUSessionResourceNotifyItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer = OCT_STR(name=u'pDUSessionResourceNotifyTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain = SEQ(name='_cont_pDUSessionResourceNotifyTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyTransfer')))
    _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer._const_cont = __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain
    _PDUSessionResourceNotifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceNotifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceNotifyItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyItem_iE_Extensions._cont = __PDUSessionResourceNotifyItem_iE_Extensions__item_
    _PDUSessionResourceNotifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceNotifyItem_pDUSessionID),
        (u'pDUSessionResourceNotifyTransfer', _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer),
        (u'iE-Extensions', _PDUSessionResourceNotifyItem_iE_Extensions),
        ])
    PDUSessionResourceNotifyItem._ext = []
    
    #-----< PDUSessionResourceNotifyItem-ExtIEs >-----#
    PDUSessionResourceNotifyItem_ExtIEs = CLASS(name=u'PDUSessionResourceNotifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceNotifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyReleasedTransfer >-----#
    PDUSessionResourceNotifyReleasedTransfer = SEQ(name=u'PDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE)
    _PDUSessionResourceNotifyReleasedTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions._cont = __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyReleasedTransfer._cont = ASN1Dict([
        (u'cause', _PDUSessionResourceNotifyReleasedTransfer_cause),
        (u'iE-Extensions', _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions),
        ])
    PDUSessionResourceNotifyReleasedTransfer._ext = []
    
    #-----< PDUSessionResourceNotifyReleasedTransfer-ExtIEs >-----#
    PDUSessionResourceNotifyReleasedTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceNotifyReleasedTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    PDUSessionResourceNotifyReleasedTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyTransfer >-----#
    PDUSessionResourceNotifyTransfer = SEQ(name=u'PDUSessionResourceNotifyTransfer', mode=MODE_TYPE)
    _PDUSessionResourceNotifyTransfer_qosFlowNotifyList = SEQ_OF(name=u'qosFlowNotifyList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowNotifyList')), opt=True)
    _PDUSessionResourceNotifyTransfer_qosFlowReleasedList = SEQ_OF(name=u'qosFlowReleasedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceNotifyTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackList')))
    ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyTransfer_iE_Extensions._cont = __PDUSessionResourceNotifyTransfer_iE_Extensions__item_
    _PDUSessionResourceNotifyTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyTransfer._cont = ASN1Dict([
        (u'qosFlowNotifyList', _PDUSessionResourceNotifyTransfer_qosFlowNotifyList),
        (u'qosFlowReleasedList', _PDUSessionResourceNotifyTransfer_qosFlowReleasedList),
        (u'iE-Extensions', _PDUSessionResourceNotifyTransfer_iE_Extensions),
        ])
    PDUSessionResourceNotifyTransfer._ext = []
    
    #-----< PDUSessionResourceNotifyTransfer-ExtIEs >-----#
    PDUSessionResourceNotifyTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceNotifyTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackList')))
    PDUSessionResourceNotifyTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseCommandTransfer >-----#
    PDUSessionResourceReleaseCommandTransfer = SEQ(name=u'PDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE)
    _PDUSessionResourceReleaseCommandTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions._cont = __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseCommandTransfer._cont = ASN1Dict([
        (u'cause', _PDUSessionResourceReleaseCommandTransfer_cause),
        (u'iE-Extensions', _PDUSessionResourceReleaseCommandTransfer_iE_Extensions),
        ])
    PDUSessionResourceReleaseCommandTransfer._ext = []
    
    #-----< PDUSessionResourceReleaseCommandTransfer-ExtIEs >-----#
    PDUSessionResourceReleaseCommandTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceReleaseCommandTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleaseCommandTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListNot >-----#
    PDUSessionResourceReleasedListNot = SEQ_OF(name=u'PDUSessionResourceReleasedListNot', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListNot__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemNot')))
    PDUSessionResourceReleasedListNot._cont = _PDUSessionResourceReleasedListNot__item_
    PDUSessionResourceReleasedListNot._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemNot >-----#
    PDUSessionResourceReleasedItemNot = SEQ(name=u'PDUSessionResourceReleasedItemNot', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemNot_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer = OCT_STR(name=u'pDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain = SEQ(name='_cont_pDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyReleasedTransfer')))
    _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer._const_cont = __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain
    _PDUSessionResourceReleasedItemNot_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemNot_iE_Extensions._cont = __PDUSessionResourceReleasedItemNot_iE_Extensions__item_
    _PDUSessionResourceReleasedItemNot_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemNot._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceReleasedItemNot_pDUSessionID),
        (u'pDUSessionResourceNotifyReleasedTransfer', _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer),
        (u'iE-Extensions', _PDUSessionResourceReleasedItemNot_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemNot._ext = []
    
    #-----< PDUSessionResourceReleasedItemNot-ExtIEs >-----#
    PDUSessionResourceReleasedItemNot_ExtIEs = CLASS(name=u'PDUSessionResourceReleasedItemNot-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemNot_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListPSAck >-----#
    PDUSessionResourceReleasedListPSAck = SEQ_OF(name=u'PDUSessionResourceReleasedListPSAck', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListPSAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemPSAck')))
    PDUSessionResourceReleasedListPSAck._cont = _PDUSessionResourceReleasedListPSAck__item_
    PDUSessionResourceReleasedListPSAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemPSAck >-----#
    PDUSessionResourceReleasedItemPSAck = SEQ(name=u'PDUSessionResourceReleasedItemPSAck', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemPSAck_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer = OCT_STR(name=u'pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain = SEQ(name='_cont_pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestUnsuccessfulTransfer')))
    _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer._const_cont = __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions._cont = __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemPSAck._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceReleasedItemPSAck_pDUSessionID),
        (u'pathSwitchRequestUnsuccessfulTransfer', _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceReleasedItemPSAck_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemPSAck._ext = []
    
    #-----< PDUSessionResourceReleasedItemPSAck-ExtIEs >-----#
    PDUSessionResourceReleasedItemPSAck_ExtIEs = CLASS(name=u'PDUSessionResourceReleasedItemPSAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemPSAck_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListPSFail >-----#
    PDUSessionResourceReleasedListPSFail = SEQ_OF(name=u'PDUSessionResourceReleasedListPSFail', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListPSFail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemPSFail')))
    PDUSessionResourceReleasedListPSFail._cont = _PDUSessionResourceReleasedListPSFail__item_
    PDUSessionResourceReleasedListPSFail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemPSFail >-----#
    PDUSessionResourceReleasedItemPSFail = SEQ(name=u'PDUSessionResourceReleasedItemPSFail', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemPSFail_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer = OCT_STR(name=u'pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain = SEQ(name='_cont_pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestUnsuccessfulTransfer')))
    _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer._const_cont = __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions._cont = __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemPSFail._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceReleasedItemPSFail_pDUSessionID),
        (u'pathSwitchRequestUnsuccessfulTransfer', _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceReleasedItemPSFail_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemPSFail._ext = []
    
    #-----< PDUSessionResourceReleasedItemPSFail-ExtIEs >-----#
    PDUSessionResourceReleasedItemPSFail_ExtIEs = CLASS(name=u'PDUSessionResourceReleasedItemPSFail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemPSFail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListRelRes >-----#
    PDUSessionResourceReleasedListRelRes = SEQ_OF(name=u'PDUSessionResourceReleasedListRelRes', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListRelRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemRelRes')))
    PDUSessionResourceReleasedListRelRes._cont = _PDUSessionResourceReleasedListRelRes__item_
    PDUSessionResourceReleasedListRelRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemRelRes >-----#
    PDUSessionResourceReleasedItemRelRes = SEQ(name=u'PDUSessionResourceReleasedItemRelRes', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemRelRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer = OCT_STR(name=u'pDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer._const_cont = __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions._cont = __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemRelRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceReleasedItemRelRes_pDUSessionID),
        (u'pDUSessionResourceReleaseResponseTransfer', _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer),
        (u'iE-Extensions', _PDUSessionResourceReleasedItemRelRes_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemRelRes._ext = []
    
    #-----< PDUSessionResourceReleasedItemRelRes-ExtIEs >-----#
    PDUSessionResourceReleasedItemRelRes_ExtIEs = CLASS(name=u'PDUSessionResourceReleasedItemRelRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemRelRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseResponseTransfer >-----#
    PDUSessionResourceReleaseResponseTransfer = SEQ(name=u'PDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions._cont = __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseResponseTransfer._cont = ASN1Dict([
        (u'iE-Extensions', _PDUSessionResourceReleaseResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceReleaseResponseTransfer._ext = []
    
    #-----< PDUSessionResourceReleaseResponseTransfer-ExtIEs >-----#
    PDUSessionResourceReleaseResponseTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceReleaseResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    PDUSessionResourceReleaseResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceResumeListRESReq >-----#
    PDUSessionResourceResumeListRESReq = SEQ_OF(name=u'PDUSessionResourceResumeListRESReq', mode=MODE_TYPE)
    _PDUSessionResourceResumeListRESReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeItemRESReq')))
    PDUSessionResourceResumeListRESReq._cont = _PDUSessionResourceResumeListRESReq__item_
    PDUSessionResourceResumeListRESReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceResumeItemRESReq >-----#
    PDUSessionResourceResumeItemRESReq = SEQ(name=u'PDUSessionResourceResumeItemRESReq', mode=MODE_TYPE)
    _PDUSessionResourceResumeItemRESReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer = OCT_STR(name=u'uEContextResumeRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain = SEQ(name='_cont_uEContextResumeRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextResumeRequestTransfer')))
    _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer._const_cont = __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain
    _PDUSessionResourceResumeItemRESReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceResumeItemRESReq_iE_Extensions._cont = __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_
    _PDUSessionResourceResumeItemRESReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceResumeItemRESReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceResumeItemRESReq_pDUSessionID),
        (u'uEContextResumeRequestTransfer', _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceResumeItemRESReq_iE_Extensions),
        ])
    PDUSessionResourceResumeItemRESReq._ext = []
    
    #-----< PDUSessionResourceResumeItemRESReq-ExtIEs >-----#
    PDUSessionResourceResumeItemRESReq_ExtIEs = CLASS(name=u'PDUSessionResourceResumeItemRESReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceResumeItemRESReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceResumeListRESRes >-----#
    PDUSessionResourceResumeListRESRes = SEQ_OF(name=u'PDUSessionResourceResumeListRESRes', mode=MODE_TYPE)
    _PDUSessionResourceResumeListRESRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeItemRESRes')))
    PDUSessionResourceResumeListRESRes._cont = _PDUSessionResourceResumeListRESRes__item_
    PDUSessionResourceResumeListRESRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceResumeItemRESRes >-----#
    PDUSessionResourceResumeItemRESRes = SEQ(name=u'PDUSessionResourceResumeItemRESRes', mode=MODE_TYPE)
    _PDUSessionResourceResumeItemRESRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer = OCT_STR(name=u'uEContextResumeResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain = SEQ(name='_cont_uEContextResumeResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextResumeResponseTransfer')))
    _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer._const_cont = __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain
    _PDUSessionResourceResumeItemRESRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceResumeItemRESRes_iE_Extensions._cont = __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_
    _PDUSessionResourceResumeItemRESRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceResumeItemRESRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceResumeItemRESRes_pDUSessionID),
        (u'uEContextResumeResponseTransfer', _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer),
        (u'iE-Extensions', _PDUSessionResourceResumeItemRESRes_iE_Extensions),
        ])
    PDUSessionResourceResumeItemRESRes._ext = []
    
    #-----< PDUSessionResourceResumeItemRESRes-ExtIEs >-----#
    PDUSessionResourceResumeItemRESRes_ExtIEs = CLASS(name=u'PDUSessionResourceResumeItemRESRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceResumeItemRESRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSecondaryRATUsageList >-----#
    PDUSessionResourceSecondaryRATUsageList = SEQ_OF(name=u'PDUSessionResourceSecondaryRATUsageList', mode=MODE_TYPE)
    _PDUSessionResourceSecondaryRATUsageList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageItem')))
    PDUSessionResourceSecondaryRATUsageList._cont = _PDUSessionResourceSecondaryRATUsageList__item_
    PDUSessionResourceSecondaryRATUsageList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSecondaryRATUsageItem >-----#
    PDUSessionResourceSecondaryRATUsageItem = SEQ(name=u'PDUSessionResourceSecondaryRATUsageItem', mode=MODE_TYPE)
    _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer = OCT_STR(name=u'secondaryRATDataUsageReportTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain = SEQ(name='_cont_secondaryRATDataUsageReportTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATDataUsageReportTransfer')))
    _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer._const_cont = __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions._cont = __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSecondaryRATUsageItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID),
        (u'secondaryRATDataUsageReportTransfer', _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer),
        (u'iE-Extensions', _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions),
        ])
    PDUSessionResourceSecondaryRATUsageItem._ext = []
    
    #-----< PDUSessionResourceSecondaryRATUsageItem-ExtIEs >-----#
    PDUSessionResourceSecondaryRATUsageItem_ExtIEs = CLASS(name=u'PDUSessionResourceSecondaryRATUsageItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSecondaryRATUsageItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListCxtReq >-----#
    PDUSessionResourceSetupListCxtReq = SEQ_OF(name=u'PDUSessionResourceSetupListCxtReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListCxtReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemCxtReq')))
    PDUSessionResourceSetupListCxtReq._cont = _PDUSessionResourceSetupListCxtReq__item_
    PDUSessionResourceSetupListCxtReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemCxtReq >-----#
    PDUSessionResourceSetupItemCxtReq = SEQ(name=u'PDUSessionResourceSetupItemCxtReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemCxtReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemCxtReq_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceSetupItemCxtReq_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer = OCT_STR(name=u'pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer._const_cont = __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions._cont = __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemCxtReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSetupItemCxtReq_pDUSessionID),
        (u'nAS-PDU', _PDUSessionResourceSetupItemCxtReq_nAS_PDU),
        (u's-NSSAI', _PDUSessionResourceSetupItemCxtReq_s_NSSAI),
        (u'pDUSessionResourceSetupRequestTransfer', _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceSetupItemCxtReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemCxtReq._ext = []
    
    #-----< PDUSessionResourceSetupItemCxtReq-ExtIEs >-----#
    PDUSessionResourceSetupItemCxtReq_ExtIEs = CLASS(name=u'PDUSessionResourceSetupItemCxtReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemCxtReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListCxtRes >-----#
    PDUSessionResourceSetupListCxtRes = SEQ_OF(name=u'PDUSessionResourceSetupListCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceSetupListCxtRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemCxtRes')))
    PDUSessionResourceSetupListCxtRes._cont = _PDUSessionResourceSetupListCxtRes__item_
    PDUSessionResourceSetupListCxtRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemCxtRes >-----#
    PDUSessionResourceSetupItemCxtRes = SEQ(name=u'PDUSessionResourceSetupItemCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemCxtRes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer = OCT_STR(name=u'pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupResponseTransfer')))
    _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer._const_cont = __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions._cont = __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemCxtRes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSetupItemCxtRes_pDUSessionID),
        (u'pDUSessionResourceSetupResponseTransfer', _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer),
        (u'iE-Extensions', _PDUSessionResourceSetupItemCxtRes_iE_Extensions),
        ])
    PDUSessionResourceSetupItemCxtRes._ext = []
    
    #-----< PDUSessionResourceSetupItemCxtRes-ExtIEs >-----#
    PDUSessionResourceSetupItemCxtRes_ExtIEs = CLASS(name=u'PDUSessionResourceSetupItemCxtRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupItemCxtRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListHOReq >-----#
    PDUSessionResourceSetupListHOReq = SEQ_OF(name=u'PDUSessionResourceSetupListHOReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListHOReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemHOReq')))
    PDUSessionResourceSetupListHOReq._cont = _PDUSessionResourceSetupListHOReq__item_
    PDUSessionResourceSetupListHOReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemHOReq >-----#
    PDUSessionResourceSetupItemHOReq = SEQ(name=u'PDUSessionResourceSetupItemHOReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemHOReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemHOReq_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer = OCT_STR(name=u'handoverRequestTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain = SEQ(name='_cont_handoverRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer._const_cont = __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain
    _PDUSessionResourceSetupItemHOReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemHOReq_iE_Extensions._cont = __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemHOReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemHOReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSetupItemHOReq_pDUSessionID),
        (u's-NSSAI', _PDUSessionResourceSetupItemHOReq_s_NSSAI),
        (u'handoverRequestTransfer', _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceSetupItemHOReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemHOReq._ext = []
    
    #-----< PDUSessionResourceSetupItemHOReq-ExtIEs >-----#
    PDUSessionResourceSetupItemHOReq_ExtIEs = CLASS(name=u'PDUSessionResourceSetupItemHOReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemHOReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListSUReq >-----#
    PDUSessionResourceSetupListSUReq = SEQ_OF(name=u'PDUSessionResourceSetupListSUReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemSUReq')))
    PDUSessionResourceSetupListSUReq._cont = _PDUSessionResourceSetupListSUReq__item_
    PDUSessionResourceSetupListSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemSUReq >-----#
    PDUSessionResourceSetupItemSUReq = SEQ(name=u'PDUSessionResourceSetupItemSUReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemSUReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU = OCT_STR(name=u'pDUSessionNAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceSetupItemSUReq_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer = OCT_STR(name=u'pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer._const_cont = __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain
    _PDUSessionResourceSetupItemSUReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemSUReq_iE_Extensions._cont = __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemSUReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSetupItemSUReq_pDUSessionID),
        (u'pDUSessionNAS-PDU', _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU),
        (u's-NSSAI', _PDUSessionResourceSetupItemSUReq_s_NSSAI),
        (u'pDUSessionResourceSetupRequestTransfer', _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceSetupItemSUReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemSUReq._ext = []
    
    #-----< PDUSessionResourceSetupItemSUReq-ExtIEs >-----#
    PDUSessionResourceSetupItemSUReq_ExtIEs = CLASS(name=u'PDUSessionResourceSetupItemSUReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemSUReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListSURes >-----#
    PDUSessionResourceSetupListSURes = SEQ_OF(name=u'PDUSessionResourceSetupListSURes', mode=MODE_TYPE)
    _PDUSessionResourceSetupListSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemSURes')))
    PDUSessionResourceSetupListSURes._cont = _PDUSessionResourceSetupListSURes__item_
    PDUSessionResourceSetupListSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemSURes >-----#
    PDUSessionResourceSetupItemSURes = SEQ(name=u'PDUSessionResourceSetupItemSURes', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemSURes_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer = OCT_STR(name=u'pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupResponseTransfer')))
    _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer._const_cont = __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain
    _PDUSessionResourceSetupItemSURes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemSURes_iE_Extensions._cont = __PDUSessionResourceSetupItemSURes_iE_Extensions__item_
    _PDUSessionResourceSetupItemSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemSURes._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSetupItemSURes_pDUSessionID),
        (u'pDUSessionResourceSetupResponseTransfer', _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer),
        (u'iE-Extensions', _PDUSessionResourceSetupItemSURes_iE_Extensions),
        ])
    PDUSessionResourceSetupItemSURes._ext = []
    
    #-----< PDUSessionResourceSetupItemSURes-ExtIEs >-----#
    PDUSessionResourceSetupItemSURes_ExtIEs = CLASS(name=u'PDUSessionResourceSetupItemSURes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupItemSURes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupRequestTransfer >-----#
    PDUSessionResourceSetupRequestTransfer = SEQ(name=u'PDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupRequestTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingNotPossible')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionType')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupRequestTransfer_protocolIEs._cont = __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_
    _PDUSessionResourceSetupRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupRequestTransfer._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceSetupRequestTransfer_protocolIEs),
        ])
    PDUSessionResourceSetupRequestTransfer._ext = []
    
    #-----< PDUSessionResourceSetupRequestTransferIEs >-----#
    PDUSessionResourceSetupRequestTransferIEs = CLASS(name=u'PDUSessionResourceSetupRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingNotPossible')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionType')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_10 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    PDUSessionResourceSetupRequestTransferIEs._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_13), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupResponseTransfer >-----#
    PDUSessionResourceSetupResponseTransfer = SEQ(name=u'PDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation = SEQ(name=u'dLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name=u'additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_securityResult = SEQ(name=u'securityResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList = SEQ_OF(name=u'qosFlowFailedToSetupList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions._cont = __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupResponseTransfer._cont = ASN1Dict([
        (u'dLQosFlowPerTNLInformation', _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation),
        (u'additionalDLQosFlowPerTNLInformation', _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation),
        (u'securityResult', _PDUSessionResourceSetupResponseTransfer_securityResult),
        (u'qosFlowFailedToSetupList', _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList),
        (u'iE-Extensions', _PDUSessionResourceSetupResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceSetupResponseTransfer._ext = []
    
    #-----< PDUSessionResourceSetupResponseTransfer-ExtIEs >-----#
    PDUSessionResourceSetupResponseTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceSetupResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PDUSessionResourceSetupResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupUnsuccessfulTransfer >-----#
    PDUSessionResourceSetupUnsuccessfulTransfer = SEQ(name=u'PDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupUnsuccessfulTransfer_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name=u'criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupUnsuccessfulTransfer._cont = ASN1Dict([
        (u'cause', _PDUSessionResourceSetupUnsuccessfulTransfer_cause),
        (u'criticalityDiagnostics', _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics),
        (u'iE-Extensions', _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceSetupUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs = CLASS(name=u'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSuspendListSUSReq >-----#
    PDUSessionResourceSuspendListSUSReq = SEQ_OF(name=u'PDUSessionResourceSuspendListSUSReq', mode=MODE_TYPE)
    _PDUSessionResourceSuspendListSUSReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendItemSUSReq')))
    PDUSessionResourceSuspendListSUSReq._cont = _PDUSessionResourceSuspendListSUSReq__item_
    PDUSessionResourceSuspendListSUSReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSuspendItemSUSReq >-----#
    PDUSessionResourceSuspendItemSUSReq = SEQ(name=u'PDUSessionResourceSuspendItemSUSReq', mode=MODE_TYPE)
    _PDUSessionResourceSuspendItemSUSReq_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer = OCT_STR(name=u'uEContextSuspendRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain = SEQ(name='_cont_uEContextSuspendRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextSuspendRequestTransfer')))
    _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer._const_cont = __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions._cont = __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSuspendItemSUSReq._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSuspendItemSUSReq_pDUSessionID),
        (u'uEContextSuspendRequestTransfer', _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceSuspendItemSUSReq_iE_Extensions),
        ])
    PDUSessionResourceSuspendItemSUSReq._ext = []
    
    #-----< PDUSessionResourceSuspendItemSUSReq-ExtIEs >-----#
    PDUSessionResourceSuspendItemSUSReq_ExtIEs = CLASS(name=u'PDUSessionResourceSuspendItemSUSReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSuspendItemSUSReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSwitchedList >-----#
    PDUSessionResourceSwitchedList = SEQ_OF(name=u'PDUSessionResourceSwitchedList', mode=MODE_TYPE)
    _PDUSessionResourceSwitchedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedItem')))
    PDUSessionResourceSwitchedList._cont = _PDUSessionResourceSwitchedList__item_
    PDUSessionResourceSwitchedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSwitchedItem >-----#
    PDUSessionResourceSwitchedItem = SEQ(name=u'PDUSessionResourceSwitchedItem', mode=MODE_TYPE)
    _PDUSessionResourceSwitchedItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer = OCT_STR(name=u'pathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain = SEQ(name='_cont_pathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestAcknowledgeTransfer')))
    _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer._const_cont = __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain
    _PDUSessionResourceSwitchedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceSwitchedItem_iE_Extensions._cont = __PDUSessionResourceSwitchedItem_iE_Extensions__item_
    _PDUSessionResourceSwitchedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSwitchedItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceSwitchedItem_pDUSessionID),
        (u'pathSwitchRequestAcknowledgeTransfer', _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer),
        (u'iE-Extensions', _PDUSessionResourceSwitchedItem_iE_Extensions),
        ])
    PDUSessionResourceSwitchedItem._ext = []
    
    #-----< PDUSessionResourceSwitchedItem-ExtIEs >-----#
    PDUSessionResourceSwitchedItem_ExtIEs = CLASS(name=u'PDUSessionResourceSwitchedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSwitchedItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Extension', _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToBeSwitchedDLList >-----#
    PDUSessionResourceToBeSwitchedDLList = SEQ_OF(name=u'PDUSessionResourceToBeSwitchedDLList', mode=MODE_TYPE)
    _PDUSessionResourceToBeSwitchedDLList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLItem')))
    PDUSessionResourceToBeSwitchedDLList._cont = _PDUSessionResourceToBeSwitchedDLList__item_
    PDUSessionResourceToBeSwitchedDLList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToBeSwitchedDLItem >-----#
    PDUSessionResourceToBeSwitchedDLItem = SEQ(name=u'PDUSessionResourceToBeSwitchedDLItem', mode=MODE_TYPE)
    _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer = OCT_STR(name=u'pathSwitchRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain = SEQ(name='_cont_pathSwitchRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestTransfer')))
    _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer._const_cont = __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions._cont = __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToBeSwitchedDLItem._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID),
        (u'pathSwitchRequestTransfer', _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer),
        (u'iE-Extensions', _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions),
        ])
    PDUSessionResourceToBeSwitchedDLItem._ext = []
    
    #-----< PDUSessionResourceToBeSwitchedDLItem-ExtIEs >-----#
    PDUSessionResourceToBeSwitchedDLItem_ExtIEs = CLASS(name=u'PDUSessionResourceToBeSwitchedDLItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToBeSwitchedDLItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToReleaseListHOCmd >-----#
    PDUSessionResourceToReleaseListHOCmd = SEQ_OF(name=u'PDUSessionResourceToReleaseListHOCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseListHOCmd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseItemHOCmd')))
    PDUSessionResourceToReleaseListHOCmd._cont = _PDUSessionResourceToReleaseListHOCmd__item_
    PDUSessionResourceToReleaseListHOCmd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToReleaseItemHOCmd >-----#
    PDUSessionResourceToReleaseItemHOCmd = SEQ(name=u'PDUSessionResourceToReleaseItemHOCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer = OCT_STR(name=u'handoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain = SEQ(name='_cont_handoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverPreparationUnsuccessfulTransfer')))
    _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer._const_cont = __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_._ext = None
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions._cont = __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToReleaseItemHOCmd._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID),
        (u'handoverPreparationUnsuccessfulTransfer', _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer),
        (u'iE-Extensions', _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions),
        ])
    PDUSessionResourceToReleaseItemHOCmd._ext = []
    
    #-----< PDUSessionResourceToReleaseItemHOCmd-ExtIEs >-----#
    PDUSessionResourceToReleaseItemHOCmd_ExtIEs = CLASS(name=u'PDUSessionResourceToReleaseItemHOCmd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToReleaseItemHOCmd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToReleaseListRelCmd >-----#
    PDUSessionResourceToReleaseListRelCmd = SEQ_OF(name=u'PDUSessionResourceToReleaseListRelCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseListRelCmd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseItemRelCmd')))
    PDUSessionResourceToReleaseListRelCmd._cont = _PDUSessionResourceToReleaseListRelCmd__item_
    PDUSessionResourceToReleaseListRelCmd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToReleaseItemRelCmd >-----#
    PDUSessionResourceToReleaseItemRelCmd = SEQ(name=u'PDUSessionResourceToReleaseItemRelCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID = INT(name=u'pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer = OCT_STR(name=u'pDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain = SEQ(name='_cont_pDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseCommandTransfer')))
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer._const_cont = __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_._ext = None
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions._cont = __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToReleaseItemRelCmd._cont = ASN1Dict([
        (u'pDUSessionID', _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID),
        (u'pDUSessionResourceReleaseCommandTransfer', _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer),
        (u'iE-Extensions', _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions),
        ])
    PDUSessionResourceToReleaseItemRelCmd._ext = []
    
    #-----< PDUSessionResourceToReleaseItemRelCmd-ExtIEs >-----#
    PDUSessionResourceToReleaseItemRelCmd_ExtIEs = CLASS(name=u'PDUSessionResourceToReleaseItemRelCmd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToReleaseItemRelCmd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionType >-----#
    PDUSessionType = ENUM(name=u'PDUSessionType', mode=MODE_TYPE)
    PDUSessionType._cont = ASN1Dict([(u'ipv4', 0), (u'ipv6', 1), (u'ipv4v6', 2), (u'ethernet', 3), (u'unstructured', 4)])
    PDUSessionType._ext = []
    
    #-----< PDUSessionUsageReport >-----#
    PDUSessionUsageReport = SEQ(name=u'PDUSessionUsageReport', mode=MODE_TYPE)
    _PDUSessionUsageReport_rATType = ENUM(name=u'rATType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PDUSessionUsageReport_rATType._cont = ASN1Dict([(u'nr', 0), (u'eutra', 1), (u'nr-unlicensed', 2), (u'e-utra-unlicensed', 3)])
    _PDUSessionUsageReport_rATType._ext = [u'nr-unlicensed', u'e-utra-unlicensed']
    _PDUSessionUsageReport_pDUSessionTimedReportList = SEQ_OF(name=u'pDUSessionTimedReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReportList')))
    _PDUSessionUsageReport_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionUsageReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionUsageReport_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PDUSessionUsageReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__id_tab
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab_id = u'id'
    ___PDUSessionUsageReport_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PDUSessionUsageReport_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionUsageReport_iE_Extensions__item__id),
        (u'criticality', ___PDUSessionUsageReport_iE_Extensions__item__criticality),
        (u'extensionValue', ___PDUSessionUsageReport_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionUsageReport_iE_Extensions__item_._ext = None
    _PDUSessionUsageReport_iE_Extensions._cont = __PDUSessionUsageReport_iE_Extensions__item_
    _PDUSessionUsageReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionUsageReport._cont = ASN1Dict([
        (u'rATType', _PDUSessionUsageReport_rATType),
        (u'pDUSessionTimedReportList', _PDUSessionUsageReport_pDUSessionTimedReportList),
        (u'iE-Extensions', _PDUSessionUsageReport_iE_Extensions),
        ])
    PDUSessionUsageReport._ext = []
    
    #-----< PDUSessionUsageReport-ExtIEs >-----#
    PDUSessionUsageReport_ExtIEs = CLASS(name=u'PDUSessionUsageReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionUsageReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Periodicity >-----#
    Periodicity = INT(name=u'Periodicity', mode=MODE_TYPE)
    Periodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=640000)], ev=[], er=[])
    
    #-----< PeriodicRegistrationUpdateTimer >-----#
    PeriodicRegistrationUpdateTimer = BIT_STR(name=u'PeriodicRegistrationUpdateTimer', mode=MODE_TYPE)
    PeriodicRegistrationUpdateTimer._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< PLMNIdentity >-----#
    PLMNIdentity = OCT_STR(name=u'PLMNIdentity', mode=MODE_TYPE)
    PLMNIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PLMNSupportList >-----#
    PLMNSupportList = SEQ_OF(name=u'PLMNSupportList', mode=MODE_TYPE)
    _PLMNSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportItem')))
    PLMNSupportList._cont = _PLMNSupportList__item_
    PLMNSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< PLMNSupportItem >-----#
    PLMNSupportItem = SEQ(name=u'PLMNSupportItem', mode=MODE_TYPE)
    _PLMNSupportItem_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _PLMNSupportItem_sliceSupportList = SEQ_OF(name=u'sliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportList')))
    _PLMNSupportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PLMNSupportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PLMNSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    ____PLMNSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Extension', _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'reject'), (u'Extension', _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PLMNSupportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PLMNSupportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PLMNSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PLMNSupportItem_iE_Extensions__item__id),
        (u'criticality', ___PLMNSupportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PLMNSupportItem_iE_Extensions__item__extensionValue),
        ])
    __PLMNSupportItem_iE_Extensions__item_._ext = None
    _PLMNSupportItem_iE_Extensions._cont = __PLMNSupportItem_iE_Extensions__item_
    _PLMNSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNSupportItem._cont = ASN1Dict([
        (u'pLMNIdentity', _PLMNSupportItem_pLMNIdentity),
        (u'sliceSupportList', _PLMNSupportItem_sliceSupportList),
        (u'iE-Extensions', _PLMNSupportItem_iE_Extensions),
        ])
    PLMNSupportItem._ext = []
    
    #-----< PLMNSupportItem-ExtIEs >-----#
    PLMNSupportItem_ExtIEs = CLASS(name=u'PLMNSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PLMNSupportItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _PLMNSupportItem_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    PLMNSupportItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Extension', _PLMNSupportItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'reject'), (u'Extension', _PLMNSupportItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PNI-NPN-MobilityInformation >-----#
    PNI_NPN_MobilityInformation = SEQ(name=u'PNI-NPN-MobilityInformation', mode=MODE_TYPE)
    _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List = SEQ_OF(name=u'allowed-PNI-NPI-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-List')))
    _PNI_NPN_MobilityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PNI_NPN_MobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PNI_NPN_MobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PNI_NPN_MobilityInformation_iE_Extensions__item__id),
        (u'criticality', ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __PNI_NPN_MobilityInformation_iE_Extensions__item_._ext = None
    _PNI_NPN_MobilityInformation_iE_Extensions._cont = __PNI_NPN_MobilityInformation_iE_Extensions__item_
    _PNI_NPN_MobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PNI_NPN_MobilityInformation._cont = ASN1Dict([
        (u'allowed-PNI-NPI-List', _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List),
        (u'iE-Extensions', _PNI_NPN_MobilityInformation_iE_Extensions),
        ])
    PNI_NPN_MobilityInformation._ext = []
    
    #-----< PNI-NPN-MobilityInformation-ExtIEs >-----#
    PNI_NPN_MobilityInformation_ExtIEs = CLASS(name=u'PNI-NPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PNI_NPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PortNumber >-----#
    PortNumber = OCT_STR(name=u'PortNumber', mode=MODE_TYPE)
    PortNumber._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = []
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = []
    
    #-----< PriorityLevelARP >-----#
    PriorityLevelARP = INT(name=u'PriorityLevelARP', mode=MODE_TYPE)
    PriorityLevelARP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< PriorityLevelQos >-----#
    PriorityLevelQos = INT(name=u'PriorityLevelQos', mode=MODE_TYPE)
    PriorityLevelQos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=[], er=[])
    
    #-----< PWSFailedCellIDList >-----#
    PWSFailedCellIDList = CHOICE(name=u'PWSFailedCellIDList', mode=MODE_TYPE)
    _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList = SEQ_OF(name=u'eUTRA-CGI-PWSFailedList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIList')))
    _PWSFailedCellIDList_nR_CGI_PWSFailedList = SEQ_OF(name=u'nR-CGI-PWSFailedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIList')))
    _PWSFailedCellIDList_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __PWSFailedCellIDList_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___PWSFailedCellIDList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_id._const_tab = ___PWSFailedCellIDList_choice_Extensions_id_tab
    __PWSFailedCellIDList_choice_Extensions_id._const_tab_at = None
    __PWSFailedCellIDList_choice_Extensions_id._const_tab_id = u'id'
    __PWSFailedCellIDList_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PWSFailedCellIDList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab = ___PWSFailedCellIDList_choice_Extensions_criticality_tab
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab_id = u'criticality'
    __PWSFailedCellIDList_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PWSFailedCellIDList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_value._const_tab = ___PWSFailedCellIDList_choice_Extensions_value_tab
    __PWSFailedCellIDList_choice_Extensions_value._const_tab_at = ('..', u'id')
    __PWSFailedCellIDList_choice_Extensions_value._const_tab_id = u'Value'
    _PWSFailedCellIDList_choice_Extensions._cont = ASN1Dict([
        (u'id', __PWSFailedCellIDList_choice_Extensions_id),
        (u'criticality', __PWSFailedCellIDList_choice_Extensions_criticality),
        (u'value', __PWSFailedCellIDList_choice_Extensions_value),
        ])
    _PWSFailedCellIDList_choice_Extensions._ext = None
    PWSFailedCellIDList._cont = ASN1Dict([
        (u'eUTRA-CGI-PWSFailedList', _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList),
        (u'nR-CGI-PWSFailedList', _PWSFailedCellIDList_nR_CGI_PWSFailedList),
        (u'choice-Extensions', _PWSFailedCellIDList_choice_Extensions),
        ])
    PWSFailedCellIDList._ext = None
    
    #-----< PWSFailedCellIDList-ExtIEs >-----#
    PWSFailedCellIDList_ExtIEs = CLASS(name=u'PWSFailedCellIDList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    PWSFailedCellIDList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosCharacteristics >-----#
    QosCharacteristics = CHOICE(name=u'QosCharacteristics', mode=MODE_TYPE)
    _QosCharacteristics_nonDynamic5QI = SEQ(name=u'nonDynamic5QI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NonDynamic5QIDescriptor')))
    _QosCharacteristics_dynamic5QI = SEQ(name=u'dynamic5QI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Dynamic5QIDescriptor')))
    _QosCharacteristics_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __QosCharacteristics_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___QosCharacteristics_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_id._const_tab = ___QosCharacteristics_choice_Extensions_id_tab
    __QosCharacteristics_choice_Extensions_id._const_tab_at = None
    __QosCharacteristics_choice_Extensions_id._const_tab_id = u'id'
    __QosCharacteristics_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___QosCharacteristics_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_criticality._const_tab = ___QosCharacteristics_choice_Extensions_criticality_tab
    __QosCharacteristics_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __QosCharacteristics_choice_Extensions_criticality._const_tab_id = u'criticality'
    __QosCharacteristics_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___QosCharacteristics_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_value._const_tab = ___QosCharacteristics_choice_Extensions_value_tab
    __QosCharacteristics_choice_Extensions_value._const_tab_at = ('..', u'id')
    __QosCharacteristics_choice_Extensions_value._const_tab_id = u'Value'
    _QosCharacteristics_choice_Extensions._cont = ASN1Dict([
        (u'id', __QosCharacteristics_choice_Extensions_id),
        (u'criticality', __QosCharacteristics_choice_Extensions_criticality),
        (u'value', __QosCharacteristics_choice_Extensions_value),
        ])
    _QosCharacteristics_choice_Extensions._ext = None
    QosCharacteristics._cont = ASN1Dict([
        (u'nonDynamic5QI', _QosCharacteristics_nonDynamic5QI),
        (u'dynamic5QI', _QosCharacteristics_dynamic5QI),
        (u'choice-Extensions', _QosCharacteristics_choice_Extensions),
        ])
    QosCharacteristics._ext = None
    
    #-----< QosCharacteristics-ExtIEs >-----#
    QosCharacteristics_ExtIEs = CLASS(name=u'QosCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    QosCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowAcceptedList >-----#
    QosFlowAcceptedList = SEQ_OF(name=u'QosFlowAcceptedList', mode=MODE_TYPE)
    _QosFlowAcceptedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAcceptedItem')))
    QosFlowAcceptedList._cont = _QosFlowAcceptedList__item_
    QosFlowAcceptedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAcceptedItem >-----#
    QosFlowAcceptedItem = SEQ(name=u'QosFlowAcceptedItem', mode=MODE_TYPE)
    _QosFlowAcceptedItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAcceptedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAcceptedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAcceptedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowAcceptedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowAcceptedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowAcceptedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowAcceptedItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowAcceptedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAcceptedItem_iE_Extensions__item_._ext = None
    _QosFlowAcceptedItem_iE_Extensions._cont = __QosFlowAcceptedItem_iE_Extensions__item_
    _QosFlowAcceptedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAcceptedItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowAcceptedItem_qosFlowIdentifier),
        (u'iE-Extensions', _QosFlowAcceptedItem_iE_Extensions),
        ])
    QosFlowAcceptedItem._ext = []
    
    #-----< QosFlowAcceptedItem-ExtIEs >-----#
    QosFlowAcceptedItem_ExtIEs = CLASS(name=u'QosFlowAcceptedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAcceptedItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowAcceptedItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _QosFlowAcceptedItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowAddOrModifyRequestList >-----#
    QosFlowAddOrModifyRequestList = SEQ_OF(name=u'QosFlowAddOrModifyRequestList', mode=MODE_TYPE)
    _QosFlowAddOrModifyRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestItem')))
    QosFlowAddOrModifyRequestList._cont = _QosFlowAddOrModifyRequestList__item_
    QosFlowAddOrModifyRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAddOrModifyRequestItem >-----#
    QosFlowAddOrModifyRequestItem = SEQ(name=u'QosFlowAddOrModifyRequestItem', mode=MODE_TYPE)
    _QosFlowAddOrModifyRequestItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters = SEQ(name=u'qosFlowLevelQosParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowLevelQosParameters')), opt=True)
    _QosFlowAddOrModifyRequestItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')), opt=True)
    _QosFlowAddOrModifyRequestItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_._ext = None
    _QosFlowAddOrModifyRequestItem_iE_Extensions._cont = __QosFlowAddOrModifyRequestItem_iE_Extensions__item_
    _QosFlowAddOrModifyRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAddOrModifyRequestItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowAddOrModifyRequestItem_qosFlowIdentifier),
        (u'qosFlowLevelQosParameters', _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters),
        (u'e-RAB-ID', _QosFlowAddOrModifyRequestItem_e_RAB_ID),
        (u'iE-Extensions', _QosFlowAddOrModifyRequestItem_iE_Extensions),
        ])
    QosFlowAddOrModifyRequestItem._ext = []
    
    #-----< QosFlowAddOrModifyRequestItem-ExtIEs >-----#
    QosFlowAddOrModifyRequestItem_ExtIEs = CLASS(name=u'QosFlowAddOrModifyRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    QosFlowAddOrModifyRequestItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowAddOrModifyResponseList >-----#
    QosFlowAddOrModifyResponseList = SEQ_OF(name=u'QosFlowAddOrModifyResponseList', mode=MODE_TYPE)
    _QosFlowAddOrModifyResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyResponseItem')))
    QosFlowAddOrModifyResponseList._cont = _QosFlowAddOrModifyResponseList__item_
    QosFlowAddOrModifyResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAddOrModifyResponseItem >-----#
    QosFlowAddOrModifyResponseItem = SEQ(name=u'QosFlowAddOrModifyResponseItem', mode=MODE_TYPE)
    _QosFlowAddOrModifyResponseItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAddOrModifyResponseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_._ext = None
    _QosFlowAddOrModifyResponseItem_iE_Extensions._cont = __QosFlowAddOrModifyResponseItem_iE_Extensions__item_
    _QosFlowAddOrModifyResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAddOrModifyResponseItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowAddOrModifyResponseItem_qosFlowIdentifier),
        (u'iE-Extensions', _QosFlowAddOrModifyResponseItem_iE_Extensions),
        ])
    QosFlowAddOrModifyResponseItem._ext = []
    
    #-----< QosFlowAddOrModifyResponseItem-ExtIEs >-----#
    QosFlowAddOrModifyResponseItem_ExtIEs = CLASS(name=u'QosFlowAddOrModifyResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowAddOrModifyResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowFeedbackList >-----#
    QosFlowFeedbackList = SEQ_OF(name=u'QosFlowFeedbackList', mode=MODE_TYPE)
    _QosFlowFeedbackList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackItem')))
    QosFlowFeedbackList._cont = _QosFlowFeedbackList__item_
    QosFlowFeedbackList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowFeedbackItem >-----#
    QosFlowFeedbackItem = SEQ(name=u'QosFlowFeedbackItem', mode=MODE_TYPE)
    _QosFlowFeedbackItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowFeedbackItem_updateFeedback = BIT_STR(name=u'updateFeedback', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UpdateFeedback')), opt=True)
    _QosFlowFeedbackItem_cNpacketDelayBudgetDL = INT(name=u'cNpacketDelayBudgetDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')), opt=True)
    _QosFlowFeedbackItem_cNpacketDelayBudgetUL = INT(name=u'cNpacketDelayBudgetUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')), opt=True)
    _QosFlowFeedbackItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowFeedbackItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowFeedbackItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowFeedbackItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__id_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowFeedbackItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowFeedbackItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowFeedbackItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowFeedbackItem_iE_Extensions__item_._ext = None
    _QosFlowFeedbackItem_iE_Extensions._cont = __QosFlowFeedbackItem_iE_Extensions__item_
    _QosFlowFeedbackItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowFeedbackItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowFeedbackItem_qosFlowIdentifier),
        (u'updateFeedback', _QosFlowFeedbackItem_updateFeedback),
        (u'cNpacketDelayBudgetDL', _QosFlowFeedbackItem_cNpacketDelayBudgetDL),
        (u'cNpacketDelayBudgetUL', _QosFlowFeedbackItem_cNpacketDelayBudgetUL),
        (u'iE-Extensions', _QosFlowFeedbackItem_iE_Extensions),
        ])
    QosFlowFeedbackItem._ext = []
    
    #-----< QosFlowFeedbackItem-ExtIEs >-----#
    QosFlowFeedbackItem_ExtIEs = CLASS(name=u'QosFlowFeedbackItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowFeedbackItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowIdentifier >-----#
    QosFlowIdentifier = INT(name=u'QosFlowIdentifier', mode=MODE_TYPE)
    QosFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< QosFlowInformationList >-----#
    QosFlowInformationList = SEQ_OF(name=u'QosFlowInformationList', mode=MODE_TYPE)
    _QosFlowInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowInformationItem')))
    QosFlowInformationList._cont = _QosFlowInformationList__item_
    QosFlowInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowInformationItem >-----#
    QosFlowInformationItem = SEQ(name=u'QosFlowInformationItem', mode=MODE_TYPE)
    _QosFlowInformationItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowInformationItem_dLForwarding = ENUM(name=u'dLForwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DLForwarding')), opt=True)
    _QosFlowInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ULForwarding')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    ____QosFlowInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 163), (u'criticality', u'ignore'), (u'Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowInformationItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowInformationItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowInformationItem_iE_Extensions__item_._ext = None
    _QosFlowInformationItem_iE_Extensions._cont = __QosFlowInformationItem_iE_Extensions__item_
    _QosFlowInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowInformationItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowInformationItem_qosFlowIdentifier),
        (u'dLForwarding', _QosFlowInformationItem_dLForwarding),
        (u'iE-Extensions', _QosFlowInformationItem_iE_Extensions),
        ])
    QosFlowInformationItem._ext = []
    
    #-----< QosFlowInformationItem-ExtIEs >-----#
    QosFlowInformationItem_ExtIEs = CLASS(name=u'QosFlowInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowInformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ULForwarding')))
    _QosFlowInformationItem_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _QosFlowInformationItem_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    QosFlowInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 163), (u'criticality', u'ignore'), (u'Extension', _QosFlowInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _QosFlowInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 354), (u'criticality', u'ignore'), (u'Extension', _QosFlowInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowLevelQosParameters >-----#
    QosFlowLevelQosParameters = SEQ(name=u'QosFlowLevelQosParameters', mode=MODE_TYPE)
    _QosFlowLevelQosParameters_qosCharacteristics = CHOICE(name=u'qosCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosCharacteristics')))
    _QosFlowLevelQosParameters_allocationAndRetentionPriority = SEQ(name=u'allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AllocationAndRetentionPriority')))
    _QosFlowLevelQosParameters_gBR_QosInformation = SEQ(name=u'gBR-QosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GBR-QosInformation')), opt=True)
    _QosFlowLevelQosParameters_reflectiveQosAttribute = ENUM(name=u'reflectiveQosAttribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReflectiveQosAttribute')), opt=True)
    _QosFlowLevelQosParameters_additionalQosFlowInformation = ENUM(name=u'additionalQosFlowInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AdditionalQosFlowInformation')), opt=True)
    _QosFlowLevelQosParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowLevelQosParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowLevelQosParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringRequest')))
    _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringReportingFrequency')))
    ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowLevelQosParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowLevelQosParameters_iE_Extensions__item__id),
        (u'criticality', ___QosFlowLevelQosParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue),
        ])
    __QosFlowLevelQosParameters_iE_Extensions__item_._ext = None
    _QosFlowLevelQosParameters_iE_Extensions._cont = __QosFlowLevelQosParameters_iE_Extensions__item_
    _QosFlowLevelQosParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowLevelQosParameters._cont = ASN1Dict([
        (u'qosCharacteristics', _QosFlowLevelQosParameters_qosCharacteristics),
        (u'allocationAndRetentionPriority', _QosFlowLevelQosParameters_allocationAndRetentionPriority),
        (u'gBR-QosInformation', _QosFlowLevelQosParameters_gBR_QosInformation),
        (u'reflectiveQosAttribute', _QosFlowLevelQosParameters_reflectiveQosAttribute),
        (u'additionalQosFlowInformation', _QosFlowLevelQosParameters_additionalQosFlowInformation),
        (u'iE-Extensions', _QosFlowLevelQosParameters_iE_Extensions),
        ])
    QosFlowLevelQosParameters._ext = []
    
    #-----< QosFlowLevelQosParameters-ExtIEs >-----#
    QosFlowLevelQosParameters_ExtIEs = CLASS(name=u'QosFlowLevelQosParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowLevelQosParameters_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringRequest')))
    _QosFlowLevelQosParameters_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringReportingFrequency')))
    QosFlowLevelQosParameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _QosFlowLevelQosParameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _QosFlowLevelQosParameters_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosMonitoringRequest >-----#
    QosMonitoringRequest = ENUM(name=u'QosMonitoringRequest', mode=MODE_TYPE)
    QosMonitoringRequest._cont = ASN1Dict([(u'ul', 0), (u'dl', 1), (u'both', 2), (u'stop', 3)])
    QosMonitoringRequest._ext = [u'stop']
    
    #-----< QosMonitoringReportingFrequency >-----#
    QosMonitoringReportingFrequency = INT(name=u'QosMonitoringReportingFrequency', mode=MODE_TYPE)
    QosMonitoringReportingFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1800)], ev=[], er=[])
    
    #-----< QosFlowListWithCause >-----#
    QosFlowListWithCause = SEQ_OF(name=u'QosFlowListWithCause', mode=MODE_TYPE)
    _QosFlowListWithCause__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowWithCauseItem')))
    QosFlowListWithCause._cont = _QosFlowListWithCause__item_
    QosFlowListWithCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowWithCauseItem >-----#
    QosFlowWithCauseItem = SEQ(name=u'QosFlowWithCauseItem', mode=MODE_TYPE)
    _QosFlowWithCauseItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowWithCauseItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _QosFlowWithCauseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowWithCauseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowWithCauseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowWithCauseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__id_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowWithCauseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowWithCauseItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowWithCauseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowWithCauseItem_iE_Extensions__item_._ext = None
    _QosFlowWithCauseItem_iE_Extensions._cont = __QosFlowWithCauseItem_iE_Extensions__item_
    _QosFlowWithCauseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowWithCauseItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowWithCauseItem_qosFlowIdentifier),
        (u'cause', _QosFlowWithCauseItem_cause),
        (u'iE-Extensions', _QosFlowWithCauseItem_iE_Extensions),
        ])
    QosFlowWithCauseItem._ext = []
    
    #-----< QosFlowWithCauseItem-ExtIEs >-----#
    QosFlowWithCauseItem_ExtIEs = CLASS(name=u'QosFlowWithCauseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowWithCauseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowModifyConfirmList >-----#
    QosFlowModifyConfirmList = SEQ_OF(name=u'QosFlowModifyConfirmList', mode=MODE_TYPE)
    _QosFlowModifyConfirmList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowModifyConfirmItem')))
    QosFlowModifyConfirmList._cont = _QosFlowModifyConfirmList__item_
    QosFlowModifyConfirmList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowModifyConfirmItem >-----#
    QosFlowModifyConfirmItem = SEQ(name=u'QosFlowModifyConfirmItem', mode=MODE_TYPE)
    _QosFlowModifyConfirmItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowModifyConfirmItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowModifyConfirmItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowModifyConfirmItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowModifyConfirmItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowModifyConfirmItem_iE_Extensions__item_._ext = None
    _QosFlowModifyConfirmItem_iE_Extensions._cont = __QosFlowModifyConfirmItem_iE_Extensions__item_
    _QosFlowModifyConfirmItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowModifyConfirmItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowModifyConfirmItem_qosFlowIdentifier),
        (u'iE-Extensions', _QosFlowModifyConfirmItem_iE_Extensions),
        ])
    QosFlowModifyConfirmItem._ext = []
    
    #-----< QosFlowModifyConfirmItem-ExtIEs >-----#
    QosFlowModifyConfirmItem_ExtIEs = CLASS(name=u'QosFlowModifyConfirmItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowModifyConfirmItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowNotifyList >-----#
    QosFlowNotifyList = SEQ_OF(name=u'QosFlowNotifyList', mode=MODE_TYPE)
    _QosFlowNotifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowNotifyItem')))
    QosFlowNotifyList._cont = _QosFlowNotifyList__item_
    QosFlowNotifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowNotifyItem >-----#
    QosFlowNotifyItem = SEQ(name=u'QosFlowNotifyItem', mode=MODE_TYPE)
    _QosFlowNotifyItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowNotifyItem_notificationCause = ENUM(name=u'notificationCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotificationCause')))
    _QosFlowNotifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowNotifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowNotifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowNotifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetNotifyIndex')))
    ____QosFlowNotifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowNotifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowNotifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowNotifyItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowNotifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowNotifyItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowNotifyItem_iE_Extensions__item_._ext = None
    _QosFlowNotifyItem_iE_Extensions._cont = __QosFlowNotifyItem_iE_Extensions__item_
    _QosFlowNotifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowNotifyItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowNotifyItem_qosFlowIdentifier),
        (u'notificationCause', _QosFlowNotifyItem_notificationCause),
        (u'iE-Extensions', _QosFlowNotifyItem_iE_Extensions),
        ])
    QosFlowNotifyItem._ext = []
    
    #-----< QosFlowNotifyItem-ExtIEs >-----#
    QosFlowNotifyItem_ExtIEs = CLASS(name=u'QosFlowNotifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowNotifyItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetNotifyIndex')))
    QosFlowNotifyItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _QosFlowNotifyItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowParametersList >-----#
    QosFlowParametersList = SEQ_OF(name=u'QosFlowParametersList', mode=MODE_TYPE)
    _QosFlowParametersList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersItem')))
    QosFlowParametersList._cont = _QosFlowParametersList__item_
    QosFlowParametersList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowParametersItem >-----#
    QosFlowParametersItem = SEQ(name=u'QosFlowParametersItem', mode=MODE_TYPE)
    _QosFlowParametersItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowParametersItem_alternativeQoSParaSetList = SEQ_OF(name=u'alternativeQoSParaSetList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')), opt=True)
    _QosFlowParametersItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowParametersItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowParametersItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowParametersItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')))
    ____QosFlowParametersItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowParametersItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowParametersItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowParametersItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowParametersItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowParametersItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowParametersItem_iE_Extensions__item_._ext = None
    _QosFlowParametersItem_iE_Extensions._cont = __QosFlowParametersItem_iE_Extensions__item_
    _QosFlowParametersItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowParametersItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowParametersItem_qosFlowIdentifier),
        (u'alternativeQoSParaSetList', _QosFlowParametersItem_alternativeQoSParaSetList),
        (u'iE-Extensions', _QosFlowParametersItem_iE_Extensions),
        ])
    QosFlowParametersItem._ext = []
    
    #-----< QosFlowParametersItem-ExtIEs >-----#
    QosFlowParametersItem_ExtIEs = CLASS(name=u'QosFlowParametersItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowParametersItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _QosFlowParametersItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _QosFlowParametersItem_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')))
    QosFlowParametersItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 187), (u'criticality', u'ignore'), (u'Extension', _QosFlowParametersItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'ignore'), (u'Extension', _QosFlowParametersItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Extension', _QosFlowParametersItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowPerTNLInformation >-----#
    QosFlowPerTNLInformation = SEQ(name=u'QosFlowPerTNLInformation', mode=MODE_TYPE)
    _QosFlowPerTNLInformation_uPTransportLayerInformation = CHOICE(name=u'uPTransportLayerInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _QosFlowPerTNLInformation_associatedQosFlowList = SEQ_OF(name=u'associatedQosFlowList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    _QosFlowPerTNLInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowPerTNLInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowPerTNLInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowPerTNLInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowPerTNLInformation_iE_Extensions__item__id),
        (u'criticality', ___QosFlowPerTNLInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue),
        ])
    __QosFlowPerTNLInformation_iE_Extensions__item_._ext = None
    _QosFlowPerTNLInformation_iE_Extensions._cont = __QosFlowPerTNLInformation_iE_Extensions__item_
    _QosFlowPerTNLInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowPerTNLInformation._cont = ASN1Dict([
        (u'uPTransportLayerInformation', _QosFlowPerTNLInformation_uPTransportLayerInformation),
        (u'associatedQosFlowList', _QosFlowPerTNLInformation_associatedQosFlowList),
        (u'iE-Extensions', _QosFlowPerTNLInformation_iE_Extensions),
        ])
    QosFlowPerTNLInformation._ext = []
    
    #-----< QosFlowPerTNLInformation-ExtIEs >-----#
    QosFlowPerTNLInformation_ExtIEs = CLASS(name=u'QosFlowPerTNLInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowPerTNLInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowPerTNLInformationList >-----#
    QosFlowPerTNLInformationList = SEQ_OF(name=u'QosFlowPerTNLInformationList', mode=MODE_TYPE)
    _QosFlowPerTNLInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationItem')))
    QosFlowPerTNLInformationList._cont = _QosFlowPerTNLInformationList__item_
    QosFlowPerTNLInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< QosFlowPerTNLInformationItem >-----#
    QosFlowPerTNLInformationItem = SEQ(name=u'QosFlowPerTNLInformationItem', mode=MODE_TYPE)
    _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation = SEQ(name=u'qosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _QosFlowPerTNLInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowPerTNLInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowPerTNLInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowPerTNLInformationItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowPerTNLInformationItem_iE_Extensions__item_._ext = None
    _QosFlowPerTNLInformationItem_iE_Extensions._cont = __QosFlowPerTNLInformationItem_iE_Extensions__item_
    _QosFlowPerTNLInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowPerTNLInformationItem._cont = ASN1Dict([
        (u'qosFlowPerTNLInformation', _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation),
        (u'iE-Extensions', _QosFlowPerTNLInformationItem_iE_Extensions),
        ])
    QosFlowPerTNLInformationItem._ext = []
    
    #-----< QosFlowPerTNLInformationItem-ExtIEs >-----#
    QosFlowPerTNLInformationItem_ExtIEs = CLASS(name=u'QosFlowPerTNLInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowPerTNLInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowSetupRequestList >-----#
    QosFlowSetupRequestList = SEQ_OF(name=u'QosFlowSetupRequestList', mode=MODE_TYPE)
    _QosFlowSetupRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestItem')))
    QosFlowSetupRequestList._cont = _QosFlowSetupRequestList__item_
    QosFlowSetupRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowSetupRequestItem >-----#
    QosFlowSetupRequestItem = SEQ(name=u'QosFlowSetupRequestItem', mode=MODE_TYPE)
    _QosFlowSetupRequestItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowSetupRequestItem_qosFlowLevelQosParameters = SEQ(name=u'qosFlowLevelQosParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowLevelQosParameters')))
    _QosFlowSetupRequestItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')), opt=True)
    _QosFlowSetupRequestItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowSetupRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowSetupRequestItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowSetupRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowSetupRequestItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowSetupRequestItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowSetupRequestItem_iE_Extensions__item_._ext = None
    _QosFlowSetupRequestItem_iE_Extensions._cont = __QosFlowSetupRequestItem_iE_Extensions__item_
    _QosFlowSetupRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowSetupRequestItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowSetupRequestItem_qosFlowIdentifier),
        (u'qosFlowLevelQosParameters', _QosFlowSetupRequestItem_qosFlowLevelQosParameters),
        (u'e-RAB-ID', _QosFlowSetupRequestItem_e_RAB_ID),
        (u'iE-Extensions', _QosFlowSetupRequestItem_iE_Extensions),
        ])
    QosFlowSetupRequestItem._ext = []
    
    #-----< QosFlowSetupRequestItem-ExtIEs >-----#
    QosFlowSetupRequestItem_ExtIEs = CLASS(name=u'QosFlowSetupRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowSetupRequestItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _QosFlowSetupRequestItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    QosFlowSetupRequestItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'ignore'), (u'Extension', _QosFlowSetupRequestItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _QosFlowSetupRequestItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowListWithDataForwarding >-----#
    QosFlowListWithDataForwarding = SEQ_OF(name=u'QosFlowListWithDataForwarding', mode=MODE_TYPE)
    _QosFlowListWithDataForwarding__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowItemWithDataForwarding')))
    QosFlowListWithDataForwarding._cont = _QosFlowListWithDataForwarding__item_
    QosFlowListWithDataForwarding._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowItemWithDataForwarding >-----#
    QosFlowItemWithDataForwarding = SEQ(name=u'QosFlowItemWithDataForwarding', mode=MODE_TYPE)
    _QosFlowItemWithDataForwarding_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowItemWithDataForwarding_dataForwardingAccepted = ENUM(name=u'dataForwardingAccepted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingAccepted')), opt=True)
    _QosFlowItemWithDataForwarding_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowItemWithDataForwarding_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowItemWithDataForwarding_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowItemWithDataForwarding_iE_Extensions__item__id),
        (u'criticality', ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue),
        ])
    __QosFlowItemWithDataForwarding_iE_Extensions__item_._ext = None
    _QosFlowItemWithDataForwarding_iE_Extensions._cont = __QosFlowItemWithDataForwarding_iE_Extensions__item_
    _QosFlowItemWithDataForwarding_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowItemWithDataForwarding._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowItemWithDataForwarding_qosFlowIdentifier),
        (u'dataForwardingAccepted', _QosFlowItemWithDataForwarding_dataForwardingAccepted),
        (u'iE-Extensions', _QosFlowItemWithDataForwarding_iE_Extensions),
        ])
    QosFlowItemWithDataForwarding._ext = []
    
    #-----< QosFlowItemWithDataForwarding-ExtIEs >-----#
    QosFlowItemWithDataForwarding_ExtIEs = CLASS(name=u'QosFlowItemWithDataForwarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowItemWithDataForwarding_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowToBeForwardedList >-----#
    QosFlowToBeForwardedList = SEQ_OF(name=u'QosFlowToBeForwardedList', mode=MODE_TYPE)
    _QosFlowToBeForwardedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowToBeForwardedItem')))
    QosFlowToBeForwardedList._cont = _QosFlowToBeForwardedList__item_
    QosFlowToBeForwardedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowToBeForwardedItem >-----#
    QosFlowToBeForwardedItem = SEQ(name=u'QosFlowToBeForwardedItem', mode=MODE_TYPE)
    _QosFlowToBeForwardedItem_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowToBeForwardedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowToBeForwardedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QosFlowToBeForwardedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QosFlowToBeForwardedItem_iE_Extensions__item__id),
        (u'criticality', ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowToBeForwardedItem_iE_Extensions__item_._ext = None
    _QosFlowToBeForwardedItem_iE_Extensions._cont = __QosFlowToBeForwardedItem_iE_Extensions__item_
    _QosFlowToBeForwardedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowToBeForwardedItem._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QosFlowToBeForwardedItem_qosFlowIdentifier),
        (u'iE-Extensions', _QosFlowToBeForwardedItem_iE_Extensions),
        ])
    QosFlowToBeForwardedItem._ext = []
    
    #-----< QosFlowToBeForwardedItem-ExtIEs >-----#
    QosFlowToBeForwardedItem_ExtIEs = CLASS(name=u'QosFlowToBeForwardedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowToBeForwardedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoSFlowsUsageReportList >-----#
    QoSFlowsUsageReportList = SEQ_OF(name=u'QoSFlowsUsageReportList', mode=MODE_TYPE)
    _QoSFlowsUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QoSFlowsUsageReport-Item')))
    QoSFlowsUsageReportList._cont = _QoSFlowsUsageReportList__item_
    QoSFlowsUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoSFlowsUsageReport-Item >-----#
    QoSFlowsUsageReport_Item = SEQ(name=u'QoSFlowsUsageReport-Item', mode=MODE_TYPE)
    _QoSFlowsUsageReport_Item_qosFlowIdentifier = INT(name=u'qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QoSFlowsUsageReport_Item_rATType = ENUM(name=u'rATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QoSFlowsUsageReport_Item_rATType._cont = ASN1Dict([(u'nr', 0), (u'eutra', 1), (u'nr-unlicensed', 2), (u'e-utra-unlicensed', 3)])
    _QoSFlowsUsageReport_Item_rATType._ext = [u'nr-unlicensed', u'e-utra-unlicensed']
    _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList = SEQ_OF(name=u'qoSFlowsTimedReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReportList')))
    _QoSFlowsUsageReport_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoSFlowsUsageReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __QoSFlowsUsageReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___QoSFlowsUsageReport_Item_iE_Extensions__item__id),
        (u'criticality', ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue),
        ])
    __QoSFlowsUsageReport_Item_iE_Extensions__item_._ext = None
    _QoSFlowsUsageReport_Item_iE_Extensions._cont = __QoSFlowsUsageReport_Item_iE_Extensions__item_
    _QoSFlowsUsageReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoSFlowsUsageReport_Item._cont = ASN1Dict([
        (u'qosFlowIdentifier', _QoSFlowsUsageReport_Item_qosFlowIdentifier),
        (u'rATType', _QoSFlowsUsageReport_Item_rATType),
        (u'qoSFlowsTimedReportList', _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList),
        (u'iE-Extensions', _QoSFlowsUsageReport_Item_iE_Extensions),
        ])
    QoSFlowsUsageReport_Item._ext = []
    
    #-----< QoSFlowsUsageReport-Item-ExtIEs >-----#
    QoSFlowsUsageReport_Item_ExtIEs = CLASS(name=u'QoSFlowsUsageReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QoSFlowsUsageReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Range >-----#
    Range = ENUM(name=u'Range', mode=MODE_TYPE)
    Range._cont = ASN1Dict([(u'm50', 0), (u'm80', 1), (u'm180', 2), (u'm200', 3), (u'm350', 4), (u'm400', 5), (u'm500', 6), (u'm700', 7), (u'm1000', 8)])
    Range._ext = []
    
    #-----< RANNodeName >-----#
    RANNodeName = STR_PRINT(name=u'RANNodeName', mode=MODE_TYPE)
    RANNodeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANNodeNameVisibleString >-----#
    RANNodeNameVisibleString = STR_VIS(name=u'RANNodeNameVisibleString', mode=MODE_TYPE)
    RANNodeNameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANNodeNameUTF8String >-----#
    RANNodeNameUTF8String = STR_UTF8(name=u'RANNodeNameUTF8String', mode=MODE_TYPE)
    RANNodeNameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANPagingPriority >-----#
    RANPagingPriority = INT(name=u'RANPagingPriority', mode=MODE_TYPE)
    RANPagingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RANStatusTransfer-TransparentContainer >-----#
    RANStatusTransfer_TransparentContainer = SEQ(name=u'RANStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList = SEQ_OF(name=u'dRBsSubjectToStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToStatusTransferList')))
    _RANStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _RANStatusTransfer_TransparentContainer_iE_Extensions._cont = __RANStatusTransfer_TransparentContainer_iE_Extensions__item_
    _RANStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANStatusTransfer_TransparentContainer._cont = ASN1Dict([
        (u'dRBsSubjectToStatusTransferList', _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList),
        (u'iE-Extensions', _RANStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    RANStatusTransfer_TransparentContainer._ext = []
    
    #-----< RANStatusTransfer-TransparentContainer-ExtIEs >-----#
    RANStatusTransfer_TransparentContainer_ExtIEs = CLASS(name=u'RANStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RANStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAN-UE-NGAP-ID >-----#
    RAN_UE_NGAP_ID = INT(name=u'RAN-UE-NGAP-ID', mode=MODE_TYPE)
    RAN_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< RAT-Information >-----#
    RAT_Information = ENUM(name=u'RAT-Information', mode=MODE_TYPE)
    RAT_Information._cont = ASN1Dict([(u'unlicensed', 0), (u'nb-IoT', 1)])
    RAT_Information._ext = []
    
    #-----< RATRestrictions >-----#
    RATRestrictions = SEQ_OF(name=u'RATRestrictions', mode=MODE_TYPE)
    _RATRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictions-Item')))
    RATRestrictions._cont = _RATRestrictions__item_
    RATRestrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RATRestrictions-Item >-----#
    RATRestrictions_Item = SEQ(name=u'RATRestrictions-Item', mode=MODE_TYPE)
    _RATRestrictions_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _RATRestrictions_Item_rATRestrictionInformation = BIT_STR(name=u'rATRestrictionInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictionInformation')))
    _RATRestrictions_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RATRestrictions_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RATRestrictions_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RATRestrictions_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRATRestrictionInformation')))
    ____RATRestrictions_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab_at = None
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___RATRestrictions_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RATRestrictions_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RATRestrictions_Item_iE_Extensions__item__id),
        (u'criticality', ___RATRestrictions_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___RATRestrictions_Item_iE_Extensions__item__extensionValue),
        ])
    __RATRestrictions_Item_iE_Extensions__item_._ext = None
    _RATRestrictions_Item_iE_Extensions._cont = __RATRestrictions_Item_iE_Extensions__item_
    _RATRestrictions_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RATRestrictions_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _RATRestrictions_Item_pLMNIdentity),
        (u'rATRestrictionInformation', _RATRestrictions_Item_rATRestrictionInformation),
        (u'iE-Extensions', _RATRestrictions_Item_iE_Extensions),
        ])
    RATRestrictions_Item._ext = []
    
    #-----< RATRestrictions-Item-ExtIEs >-----#
    RATRestrictions_Item_ExtIEs = CLASS(name=u'RATRestrictions-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _RATRestrictions_Item_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRATRestrictionInformation')))
    RATRestrictions_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _RATRestrictions_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RATRestrictionInformation >-----#
    RATRestrictionInformation = BIT_STR(name=u'RATRestrictionInformation', mode=MODE_TYPE)
    RATRestrictionInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellsForPaging >-----#
    RecommendedCellsForPaging = SEQ(name=u'RecommendedCellsForPaging', mode=MODE_TYPE)
    _RecommendedCellsForPaging_recommendedCellList = SEQ_OF(name=u'recommendedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellList')))
    _RecommendedCellsForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellsForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__id_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedCellsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedCellsForPaging_iE_Extensions__item__id),
        (u'criticality', ___RecommendedCellsForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellsForPaging_iE_Extensions__item_._ext = None
    _RecommendedCellsForPaging_iE_Extensions._cont = __RecommendedCellsForPaging_iE_Extensions__item_
    _RecommendedCellsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellsForPaging._cont = ASN1Dict([
        (u'recommendedCellList', _RecommendedCellsForPaging_recommendedCellList),
        (u'iE-Extensions', _RecommendedCellsForPaging_iE_Extensions),
        ])
    RecommendedCellsForPaging._ext = []
    
    #-----< RecommendedCellsForPaging-ExtIEs >-----#
    RecommendedCellsForPaging_ExtIEs = CLASS(name=u'RecommendedCellsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellList >-----#
    RecommendedCellList = SEQ_OF(name=u'RecommendedCellList', mode=MODE_TYPE)
    _RecommendedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellItem')))
    RecommendedCellList._cont = _RecommendedCellList__item_
    RecommendedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedCellItem >-----#
    RecommendedCellItem = SEQ(name=u'RecommendedCellItem', mode=MODE_TYPE)
    _RecommendedCellItem_nGRAN_CGI = CHOICE(name=u'nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _RecommendedCellItem_timeStayedInCell = INT(name=u'timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecommendedCellItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _RecommendedCellItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab = ____RecommendedCellItem_iE_Extensions__item__id_tab
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedCellItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab = ____RecommendedCellItem_iE_Extensions__item__criticality_tab
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedCellItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedCellItem_iE_Extensions__item__id),
        (u'criticality', ___RecommendedCellItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedCellItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellItem_iE_Extensions__item_._ext = None
    _RecommendedCellItem_iE_Extensions._cont = __RecommendedCellItem_iE_Extensions__item_
    _RecommendedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellItem._cont = ASN1Dict([
        (u'nGRAN-CGI', _RecommendedCellItem_nGRAN_CGI),
        (u'timeStayedInCell', _RecommendedCellItem_timeStayedInCell),
        (u'iE-Extensions', _RecommendedCellItem_iE_Extensions),
        ])
    RecommendedCellItem._ext = []
    
    #-----< RecommendedCellItem-ExtIEs >-----#
    RecommendedCellItem_ExtIEs = CLASS(name=u'RecommendedCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedRANNodesForPaging >-----#
    RecommendedRANNodesForPaging = SEQ(name=u'RecommendedRANNodesForPaging', mode=MODE_TYPE)
    _RecommendedRANNodesForPaging_recommendedRANNodeList = SEQ_OF(name=u'recommendedRANNodeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodeList')))
    _RecommendedRANNodesForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedRANNodesForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedRANNodesForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedRANNodesForPaging_iE_Extensions__item__id),
        (u'criticality', ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedRANNodesForPaging_iE_Extensions__item_._ext = None
    _RecommendedRANNodesForPaging_iE_Extensions._cont = __RecommendedRANNodesForPaging_iE_Extensions__item_
    _RecommendedRANNodesForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedRANNodesForPaging._cont = ASN1Dict([
        (u'recommendedRANNodeList', _RecommendedRANNodesForPaging_recommendedRANNodeList),
        (u'iE-Extensions', _RecommendedRANNodesForPaging_iE_Extensions),
        ])
    RecommendedRANNodesForPaging._ext = []
    
    #-----< RecommendedRANNodesForPaging-ExtIEs >-----#
    RecommendedRANNodesForPaging_ExtIEs = CLASS(name=u'RecommendedRANNodesForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedRANNodesForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedRANNodeList >-----#
    RecommendedRANNodeList = SEQ_OF(name=u'RecommendedRANNodeList', mode=MODE_TYPE)
    _RecommendedRANNodeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodeItem')))
    RecommendedRANNodeList._cont = _RecommendedRANNodeList__item_
    RecommendedRANNodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedRANNodeItem >-----#
    RecommendedRANNodeItem = SEQ(name=u'RecommendedRANNodeItem', mode=MODE_TYPE)
    _RecommendedRANNodeItem_aMFPagingTarget = CHOICE(name=u'aMFPagingTarget', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPagingTarget')))
    _RecommendedRANNodeItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedRANNodeItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedRANNodeItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedRANNodeItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__id_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedRANNodeItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedRANNodeItem_iE_Extensions__item__id),
        (u'criticality', ___RecommendedRANNodeItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedRANNodeItem_iE_Extensions__item_._ext = None
    _RecommendedRANNodeItem_iE_Extensions._cont = __RecommendedRANNodeItem_iE_Extensions__item_
    _RecommendedRANNodeItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedRANNodeItem._cont = ASN1Dict([
        (u'aMFPagingTarget', _RecommendedRANNodeItem_aMFPagingTarget),
        (u'iE-Extensions', _RecommendedRANNodeItem_iE_Extensions),
        ])
    RecommendedRANNodeItem._ext = []
    
    #-----< RecommendedRANNodeItem-ExtIEs >-----#
    RecommendedRANNodeItem_ExtIEs = CLASS(name=u'RecommendedRANNodeItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedRANNodeItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RedirectionVoiceFallback >-----#
    RedirectionVoiceFallback = ENUM(name=u'RedirectionVoiceFallback', mode=MODE_TYPE)
    RedirectionVoiceFallback._cont = ASN1Dict([(u'possible', 0), (u'not-possible', 1)])
    RedirectionVoiceFallback._ext = []
    
    #-----< RedundantPDUSessionInformation >-----#
    RedundantPDUSessionInformation = SEQ(name=u'RedundantPDUSessionInformation', mode=MODE_TYPE)
    _RedundantPDUSessionInformation_rSN = ENUM(name=u'rSN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RSN')))
    _RedundantPDUSessionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RedundantPDUSessionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RedundantPDUSessionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_at = None
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RedundantPDUSessionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RedundantPDUSessionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__criticality_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RedundantPDUSessionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RedundantPDUSessionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__extensionValue_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RedundantPDUSessionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RedundantPDUSessionInformation_iE_Extensions__item__id),
        (u'criticality', ___RedundantPDUSessionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue),
        ])
    __RedundantPDUSessionInformation_iE_Extensions__item_._ext = None
    _RedundantPDUSessionInformation_iE_Extensions._cont = __RedundantPDUSessionInformation_iE_Extensions__item_
    _RedundantPDUSessionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RedundantPDUSessionInformation._cont = ASN1Dict([
        (u'rSN', _RedundantPDUSessionInformation_rSN),
        (u'iE-Extensions', _RedundantPDUSessionInformation_iE_Extensions),
        ])
    RedundantPDUSessionInformation._ext = []
    
    #-----< RedundantPDUSessionInformation-ExtIEs >-----#
    RedundantPDUSessionInformation_ExtIEs = CLASS(name=u'RedundantPDUSessionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RedundantPDUSessionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RedundantQosFlowIndicator >-----#
    RedundantQosFlowIndicator = ENUM(name=u'RedundantQosFlowIndicator', mode=MODE_TYPE)
    RedundantQosFlowIndicator._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    RedundantQosFlowIndicator._ext = None
    
    #-----< ReflectiveQosAttribute >-----#
    ReflectiveQosAttribute = ENUM(name=u'ReflectiveQosAttribute', mode=MODE_TYPE)
    ReflectiveQosAttribute._cont = ASN1Dict([(u'subject-to', 0)])
    ReflectiveQosAttribute._ext = []
    
    #-----< RelativeAMFCapacity >-----#
    RelativeAMFCapacity = INT(name=u'RelativeAMFCapacity', mode=MODE_TYPE)
    RelativeAMFCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name=u'ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([(u'cell', 0)])
    ReportArea._ext = []
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name=u'RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name=u'ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([(u'reset-all', 0)])
    ResetAll._ext = []
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name=u'ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([(u'r1', 0), (u'r2', 1), (u'r4', 2), (u'r8', 3), (u'r16', 4), (u'r32', 5), (u'r64', 6), (u'rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name=u'ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'min1', 8), (u'min6', 9), (u'min12', 10), (u'min30', 11), (u'min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< ExtendedReportIntervalMDT >-----#
    ExtendedReportIntervalMDT = ENUM(name=u'ExtendedReportIntervalMDT', mode=MODE_TYPE)
    ExtendedReportIntervalMDT._cont = ASN1Dict([(u'ms20480', 0), (u'ms40960', 1)])
    ExtendedReportIntervalMDT._ext = []
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name=u'ResetType', mode=MODE_TYPE)
    _ResetType_nG_Interface = ENUM(name=u'nG-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ResetAll')))
    _ResetType_partOfNG_Interface = SEQ_OF(name=u'partOfNG-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _ResetType_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ResetType_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___ResetType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_id._const_tab = ___ResetType_choice_Extensions_id_tab
    __ResetType_choice_Extensions_id._const_tab_at = None
    __ResetType_choice_Extensions_id._const_tab_id = u'id'
    __ResetType_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_criticality._const_tab = ___ResetType_choice_Extensions_criticality_tab
    __ResetType_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __ResetType_choice_Extensions_criticality._const_tab_id = u'criticality'
    __ResetType_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___ResetType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_value._const_tab = ___ResetType_choice_Extensions_value_tab
    __ResetType_choice_Extensions_value._const_tab_at = ('..', u'id')
    __ResetType_choice_Extensions_value._const_tab_id = u'Value'
    _ResetType_choice_Extensions._cont = ASN1Dict([
        (u'id', __ResetType_choice_Extensions_id),
        (u'criticality', __ResetType_choice_Extensions_criticality),
        (u'value', __ResetType_choice_Extensions_value),
        ])
    _ResetType_choice_Extensions._ext = None
    ResetType._cont = ASN1Dict([
        (u'nG-Interface', _ResetType_nG_Interface),
        (u'partOfNG-Interface', _ResetType_partOfNG_Interface),
        (u'choice-Extensions', _ResetType_choice_Extensions),
        ])
    ResetType._ext = None
    
    #-----< ResetType-ExtIEs >-----#
    ResetType_ExtIEs = CLASS(name=u'ResetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ResetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RGLevelWirelineAccessCharacteristics >-----#
    RGLevelWirelineAccessCharacteristics = OCT_STR(name=u'RGLevelWirelineAccessCharacteristics', mode=MODE_TYPE)
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name=u'RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RoutingID >-----#
    RoutingID = OCT_STR(name=u'RoutingID', mode=MODE_TYPE)
    
    #-----< RRCContainer >-----#
    RRCContainer = OCT_STR(name=u'RRCContainer', mode=MODE_TYPE)
    
    #-----< RRCEstablishmentCause >-----#
    RRCEstablishmentCause = ENUM(name=u'RRCEstablishmentCause', mode=MODE_TYPE)
    RRCEstablishmentCause._cont = ASN1Dict([(u'emergency', 0), (u'highPriorityAccess', 1), (u'mt-Access', 2), (u'mo-Signalling', 3), (u'mo-Data', 4), (u'mo-VoiceCall', 5), (u'mo-VideoCall', 6), (u'mo-SMS', 7), (u'mps-PriorityAccess', 8), (u'mcs-PriorityAccess', 9), (u'notAvailable', 10), (u'mo-ExceptionData', 11)])
    RRCEstablishmentCause._ext = [u'notAvailable', u'mo-ExceptionData']
    
    #-----< RRCInactiveTransitionReportRequest >-----#
    RRCInactiveTransitionReportRequest = ENUM(name=u'RRCInactiveTransitionReportRequest', mode=MODE_TYPE)
    RRCInactiveTransitionReportRequest._cont = ASN1Dict([(u'subsequent-state-transition-report', 0), (u'single-rrc-connected-state-report', 1), (u'cancel-report', 2)])
    RRCInactiveTransitionReportRequest._ext = []
    
    #-----< RRCState >-----#
    RRCState = ENUM(name=u'RRCState', mode=MODE_TYPE)
    RRCState._cont = ASN1Dict([(u'inactive', 0), (u'connected', 1)])
    RRCState._ext = []
    
    #-----< RSN >-----#
    RSN = ENUM(name=u'RSN', mode=MODE_TYPE)
    RSN._cont = ASN1Dict([(u'v1', 0), (u'v2', 1)])
    RSN._ext = []
    
    #-----< RIMInformationTransfer >-----#
    RIMInformationTransfer = SEQ(name=u'RIMInformationTransfer', mode=MODE_TYPE)
    _RIMInformationTransfer_targetRANNodeID = SEQ(name=u'targetRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID')))
    _RIMInformationTransfer_sourceRANNodeID = SEQ(name=u'sourceRANNodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceRANNodeID')))
    _RIMInformationTransfer_rIMInformation = SEQ(name=u'rIMInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RIMInformation')))
    _RIMInformationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMInformationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RIMInformationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RIMInformationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab = ____RIMInformationTransfer_iE_Extensions__item__id_tab
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___RIMInformationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RIMInformationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab = ____RIMInformationTransfer_iE_Extensions__item__criticality_tab
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab = ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RIMInformationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RIMInformationTransfer_iE_Extensions__item__id),
        (u'criticality', ___RIMInformationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___RIMInformationTransfer_iE_Extensions__item__extensionValue),
        ])
    __RIMInformationTransfer_iE_Extensions__item_._ext = None
    _RIMInformationTransfer_iE_Extensions._cont = __RIMInformationTransfer_iE_Extensions__item_
    _RIMInformationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMInformationTransfer._cont = ASN1Dict([
        (u'targetRANNodeID', _RIMInformationTransfer_targetRANNodeID),
        (u'sourceRANNodeID', _RIMInformationTransfer_sourceRANNodeID),
        (u'rIMInformation', _RIMInformationTransfer_rIMInformation),
        (u'iE-Extensions', _RIMInformationTransfer_iE_Extensions),
        ])
    RIMInformationTransfer._ext = []
    
    #-----< RIMInformationTransfer-ExtIEs >-----#
    RIMInformationTransfer_ExtIEs = CLASS(name=u'RIMInformationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RIMInformationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMInformation >-----#
    RIMInformation = SEQ(name=u'RIMInformation', mode=MODE_TYPE)
    _RIMInformation_targetgNBSetID = BIT_STR(name=u'targetgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GNBSetID')))
    _RIMInformation_rIM_RSDetection = ENUM(name=u'rIM-RSDetection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RIMInformation_rIM_RSDetection._cont = ASN1Dict([(u'rs-detected', 0), (u'rs-disappeared', 1)])
    _RIMInformation_rIM_RSDetection._ext = []
    _RIMInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RIMInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__id._const_tab = ____RIMInformation_iE_Extensions__item__id_tab
    ___RIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___RIMInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RIMInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__criticality._const_tab = ____RIMInformation_iE_Extensions__item__criticality_tab
    ___RIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RIMInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RIMInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab = ____RIMInformation_iE_Extensions__item__extensionValue_tab
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RIMInformation_iE_Extensions__item__id),
        (u'criticality', ___RIMInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RIMInformation_iE_Extensions__item__extensionValue),
        ])
    __RIMInformation_iE_Extensions__item_._ext = None
    _RIMInformation_iE_Extensions._cont = __RIMInformation_iE_Extensions__item_
    _RIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMInformation._cont = ASN1Dict([
        (u'targetgNBSetID', _RIMInformation_targetgNBSetID),
        (u'rIM-RSDetection', _RIMInformation_rIM_RSDetection),
        (u'iE-Extensions', _RIMInformation_iE_Extensions),
        ])
    RIMInformation._ext = []
    
    #-----< RIMInformation-ExtIEs >-----#
    RIMInformation_ExtIEs = CLASS(name=u'RIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBSetID >-----#
    GNBSetID = BIT_STR(name=u'GNBSetID', mode=MODE_TYPE)
    GNBSetID._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    
    #-----< ScheduledCommunicationTime >-----#
    ScheduledCommunicationTime = SEQ(name=u'ScheduledCommunicationTime', mode=MODE_TYPE)
    _ScheduledCommunicationTime_dayofWeek = BIT_STR(name=u'dayofWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_dayofWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _ScheduledCommunicationTime_timeofDayStart = INT(name=u'timeofDayStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_timeofDayEnd = INT(name=u'timeofDayEnd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayEnd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ScheduledCommunicationTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ScheduledCommunicationTime_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__id_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_at = None
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_id = u'id'
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ScheduledCommunicationTime_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ScheduledCommunicationTime_iE_Extensions__item__id),
        (u'criticality', ___ScheduledCommunicationTime_iE_Extensions__item__criticality),
        (u'extensionValue', ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue),
        ])
    __ScheduledCommunicationTime_iE_Extensions__item_._ext = None
    _ScheduledCommunicationTime_iE_Extensions._cont = __ScheduledCommunicationTime_iE_Extensions__item_
    _ScheduledCommunicationTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ScheduledCommunicationTime._cont = ASN1Dict([
        (u'dayofWeek', _ScheduledCommunicationTime_dayofWeek),
        (u'timeofDayStart', _ScheduledCommunicationTime_timeofDayStart),
        (u'timeofDayEnd', _ScheduledCommunicationTime_timeofDayEnd),
        (u'iE-Extensions', _ScheduledCommunicationTime_iE_Extensions),
        ])
    ScheduledCommunicationTime._ext = []
    
    #-----< ScheduledCommunicationTime-ExtIEs >-----#
    ScheduledCommunicationTime_ExtIEs = CLASS(name=u'ScheduledCommunicationTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ScheduledCommunicationTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCTP-TLAs >-----#
    SCTP_TLAs = SEQ_OF(name=u'SCTP-TLAs', mode=MODE_TYPE)
    _SCTP_TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    SCTP_TLAs._cont = _SCTP_TLAs__item_
    SCTP_TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< SD >-----#
    SD = OCT_STR(name=u'SD', mode=MODE_TYPE)
    SD._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SecondaryRATUsageInformation >-----#
    SecondaryRATUsageInformation = SEQ(name=u'SecondaryRATUsageInformation', mode=MODE_TYPE)
    _SecondaryRATUsageInformation_pDUSessionUsageReport = SEQ(name=u'pDUSessionUsageReport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionUsageReport')), opt=True)
    _SecondaryRATUsageInformation_qosFlowsUsageReportList = SEQ_OF(name=u'qosFlowsUsageReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QoSFlowsUsageReportList')), opt=True)
    _SecondaryRATUsageInformation_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATUsageInformation_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATUsageInformation_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryRATUsageInformation_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__id_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab_at = None
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab_id = u'id'
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryRATUsageInformation_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___SecondaryRATUsageInformation_iE_Extension__item__id),
        (u'criticality', ___SecondaryRATUsageInformation_iE_Extension__item__criticality),
        (u'extensionValue', ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue),
        ])
    __SecondaryRATUsageInformation_iE_Extension__item_._ext = None
    _SecondaryRATUsageInformation_iE_Extension._cont = __SecondaryRATUsageInformation_iE_Extension__item_
    _SecondaryRATUsageInformation_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATUsageInformation._cont = ASN1Dict([
        (u'pDUSessionUsageReport', _SecondaryRATUsageInformation_pDUSessionUsageReport),
        (u'qosFlowsUsageReportList', _SecondaryRATUsageInformation_qosFlowsUsageReportList),
        (u'iE-Extension', _SecondaryRATUsageInformation_iE_Extension),
        ])
    SecondaryRATUsageInformation._ext = []
    
    #-----< SecondaryRATUsageInformation-ExtIEs >-----#
    SecondaryRATUsageInformation_ExtIEs = CLASS(name=u'SecondaryRATUsageInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecondaryRATUsageInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReportTransfer >-----#
    SecondaryRATDataUsageReportTransfer = SEQ(name=u'SecondaryRATDataUsageReportTransfer', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation = SEQ(name=u'secondaryRATUsageInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')), opt=True)
    _SecondaryRATDataUsageReportTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id),
        (u'criticality', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue),
        ])
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_._ext = None
    _SecondaryRATDataUsageReportTransfer_iE_Extensions._cont = __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_
    _SecondaryRATDataUsageReportTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReportTransfer._cont = ASN1Dict([
        (u'secondaryRATUsageInformation', _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation),
        (u'iE-Extensions', _SecondaryRATDataUsageReportTransfer_iE_Extensions),
        ])
    SecondaryRATDataUsageReportTransfer._ext = []
    
    #-----< SecondaryRATDataUsageReportTransfer-ExtIEs >-----#
    SecondaryRATDataUsageReportTransfer_ExtIEs = CLASS(name=u'SecondaryRATDataUsageReportTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecondaryRATDataUsageReportTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityContext >-----#
    SecurityContext = SEQ(name=u'SecurityContext', mode=MODE_TYPE)
    _SecurityContext_nextHopChainingCount = INT(name=u'nextHopChainingCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NextHopChainingCount')))
    _SecurityContext_nextHopNH = BIT_STR(name=u'nextHopNH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _SecurityContext_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityContext_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityContext_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityContext_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__id._const_tab = ____SecurityContext_iE_Extensions__item__id_tab
    ___SecurityContext_iE_Extensions__item__id._const_tab_at = None
    ___SecurityContext_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecurityContext_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityContext_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__criticality._const_tab = ____SecurityContext_iE_Extensions__item__criticality_tab
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityContext_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab = ____SecurityContext_iE_Extensions__item__extensionValue_tab
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityContext_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityContext_iE_Extensions__item__id),
        (u'criticality', ___SecurityContext_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecurityContext_iE_Extensions__item__extensionValue),
        ])
    __SecurityContext_iE_Extensions__item_._ext = None
    _SecurityContext_iE_Extensions._cont = __SecurityContext_iE_Extensions__item_
    _SecurityContext_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityContext._cont = ASN1Dict([
        (u'nextHopChainingCount', _SecurityContext_nextHopChainingCount),
        (u'nextHopNH', _SecurityContext_nextHopNH),
        (u'iE-Extensions', _SecurityContext_iE_Extensions),
        ])
    SecurityContext._ext = []
    
    #-----< SecurityContext-ExtIEs >-----#
    SecurityContext_ExtIEs = CLASS(name=u'SecurityContext-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecurityContext_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityIndication >-----#
    SecurityIndication = SEQ(name=u'SecurityIndication', mode=MODE_TYPE)
    _SecurityIndication_integrityProtectionIndication = ENUM(name=u'integrityProtectionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntegrityProtectionIndication')))
    _SecurityIndication_confidentialityProtectionIndication = ENUM(name=u'confidentialityProtectionIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfidentialityProtectionIndication')))
    _SecurityIndication_maximumIntegrityProtectedDataRate_UL = ENUM(name=u'maximumIntegrityProtectedDataRate-UL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')), opt=True)
    _SecurityIndication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityIndication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')))
    ____SecurityIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__id._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__id._const_tab_at = None
    ___SecurityIndication_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecurityIndication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityIndication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityIndication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityIndication_iE_Extensions__item__id),
        (u'criticality', ___SecurityIndication_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecurityIndication_iE_Extensions__item__extensionValue),
        ])
    __SecurityIndication_iE_Extensions__item_._ext = None
    _SecurityIndication_iE_Extensions._cont = __SecurityIndication_iE_Extensions__item_
    _SecurityIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityIndication._cont = ASN1Dict([
        (u'integrityProtectionIndication', _SecurityIndication_integrityProtectionIndication),
        (u'confidentialityProtectionIndication', _SecurityIndication_confidentialityProtectionIndication),
        (u'maximumIntegrityProtectedDataRate-UL', _SecurityIndication_maximumIntegrityProtectedDataRate_UL),
        (u'iE-Extensions', _SecurityIndication_iE_Extensions),
        ])
    SecurityIndication._ext = []
    
    #-----< SecurityIndication-ExtIEs >-----#
    SecurityIndication_ExtIEs = CLASS(name=u'SecurityIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SecurityIndication_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')))
    SecurityIndication_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _SecurityIndication_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityKey >-----#
    SecurityKey = BIT_STR(name=u'SecurityKey', mode=MODE_TYPE)
    SecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SecurityResult >-----#
    SecurityResult = SEQ(name=u'SecurityResult', mode=MODE_TYPE)
    _SecurityResult_integrityProtectionResult = ENUM(name=u'integrityProtectionResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntegrityProtectionResult')))
    _SecurityResult_confidentialityProtectionResult = ENUM(name=u'confidentialityProtectionResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfidentialityProtectionResult')))
    _SecurityResult_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityResult_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityResult_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__id._const_tab = ____SecurityResult_iE_Extensions__item__id_tab
    ___SecurityResult_iE_Extensions__item__id._const_tab_at = None
    ___SecurityResult_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecurityResult_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__criticality._const_tab = ____SecurityResult_iE_Extensions__item__criticality_tab
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityResult_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab = ____SecurityResult_iE_Extensions__item__extensionValue_tab
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityResult_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityResult_iE_Extensions__item__id),
        (u'criticality', ___SecurityResult_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecurityResult_iE_Extensions__item__extensionValue),
        ])
    __SecurityResult_iE_Extensions__item_._ext = None
    _SecurityResult_iE_Extensions._cont = __SecurityResult_iE_Extensions__item_
    _SecurityResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityResult._cont = ASN1Dict([
        (u'integrityProtectionResult', _SecurityResult_integrityProtectionResult),
        (u'confidentialityProtectionResult', _SecurityResult_confidentialityProtectionResult),
        (u'iE-Extensions', _SecurityResult_iE_Extensions),
        ])
    SecurityResult._ext = []
    
    #-----< SecurityResult-ExtIEs >-----#
    SecurityResult_ExtIEs = CLASS(name=u'SecurityResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecurityResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasurementConfiguration >-----#
    SensorMeasurementConfiguration = SEQ(name=u'SensorMeasurementConfiguration', mode=MODE_TYPE)
    _SensorMeasurementConfiguration_sensorMeasConfig = ENUM(name=u'sensorMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfig')))
    _SensorMeasurementConfiguration_sensorMeasConfigNameList = SEQ_OF(name=u'sensorMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfigNameList')), opt=True)
    _SensorMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SensorMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SensorMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___SensorMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasurementConfiguration_iE_Extensions__item_._ext = None
    _SensorMeasurementConfiguration_iE_Extensions._cont = __SensorMeasurementConfiguration_iE_Extensions__item_
    _SensorMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasurementConfiguration._cont = ASN1Dict([
        (u'sensorMeasConfig', _SensorMeasurementConfiguration_sensorMeasConfig),
        (u'sensorMeasConfigNameList', _SensorMeasurementConfiguration_sensorMeasConfigNameList),
        (u'iE-Extensions', _SensorMeasurementConfiguration_iE_Extensions),
        ])
    SensorMeasurementConfiguration._ext = []
    
    #-----< SensorMeasurementConfiguration-ExtIEs >-----#
    SensorMeasurementConfiguration_ExtIEs = CLASS(name=u'SensorMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SensorMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfigNameList >-----#
    SensorMeasConfigNameList = SEQ_OF(name=u'SensorMeasConfigNameList', mode=MODE_TYPE)
    _SensorMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfigNameItem')))
    SensorMeasConfigNameList._cont = _SensorMeasConfigNameList__item_
    SensorMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SensorMeasConfigNameItem >-----#
    SensorMeasConfigNameItem = SEQ(name=u'SensorMeasConfigNameItem', mode=MODE_TYPE)
    _SensorMeasConfigNameItem_sensorNameConfig = CHOICE(name=u'sensorNameConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorNameConfig')))
    _SensorMeasConfigNameItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasConfigNameItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SensorMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SensorMeasConfigNameItem_iE_Extensions__item__id),
        (u'criticality', ___SensorMeasConfigNameItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasConfigNameItem_iE_Extensions__item_._ext = None
    _SensorMeasConfigNameItem_iE_Extensions._cont = __SensorMeasConfigNameItem_iE_Extensions__item_
    _SensorMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasConfigNameItem._cont = ASN1Dict([
        (u'sensorNameConfig', _SensorMeasConfigNameItem_sensorNameConfig),
        (u'iE-Extensions', _SensorMeasConfigNameItem_iE_Extensions),
        ])
    SensorMeasConfigNameItem._ext = []
    
    #-----< SensorMeasConfigNameItem-ExtIEs >-----#
    SensorMeasConfigNameItem_ExtIEs = CLASS(name=u'SensorMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SensorMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfig >-----#
    SensorMeasConfig = ENUM(name=u'SensorMeasConfig', mode=MODE_TYPE)
    SensorMeasConfig._cont = ASN1Dict([(u'setup', 0)])
    SensorMeasConfig._ext = []
    
    #-----< SensorNameConfig >-----#
    SensorNameConfig = CHOICE(name=u'SensorNameConfig', mode=MODE_TYPE)
    _SensorNameConfig_uncompensatedBarometricConfig = ENUM(name=u'uncompensatedBarometricConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_uncompensatedBarometricConfig._cont = ASN1Dict([(u'true', 0)])
    _SensorNameConfig_uncompensatedBarometricConfig._ext = []
    _SensorNameConfig_ueSpeedConfig = ENUM(name=u'ueSpeedConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_ueSpeedConfig._cont = ASN1Dict([(u'true', 0)])
    _SensorNameConfig_ueSpeedConfig._ext = []
    _SensorNameConfig_ueOrientationConfig = ENUM(name=u'ueOrientationConfig', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_ueOrientationConfig._cont = ASN1Dict([(u'true', 0)])
    _SensorNameConfig_ueOrientationConfig._ext = []
    _SensorNameConfig_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SensorNameConfig_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___SensorNameConfig_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_id._const_tab = ___SensorNameConfig_choice_Extensions_id_tab
    __SensorNameConfig_choice_Extensions_id._const_tab_at = None
    __SensorNameConfig_choice_Extensions_id._const_tab_id = u'id'
    __SensorNameConfig_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___SensorNameConfig_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_criticality._const_tab = ___SensorNameConfig_choice_Extensions_criticality_tab
    __SensorNameConfig_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __SensorNameConfig_choice_Extensions_criticality._const_tab_id = u'criticality'
    __SensorNameConfig_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___SensorNameConfig_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_value._const_tab = ___SensorNameConfig_choice_Extensions_value_tab
    __SensorNameConfig_choice_Extensions_value._const_tab_at = ('..', u'id')
    __SensorNameConfig_choice_Extensions_value._const_tab_id = u'Value'
    _SensorNameConfig_choice_Extensions._cont = ASN1Dict([
        (u'id', __SensorNameConfig_choice_Extensions_id),
        (u'criticality', __SensorNameConfig_choice_Extensions_criticality),
        (u'value', __SensorNameConfig_choice_Extensions_value),
        ])
    _SensorNameConfig_choice_Extensions._ext = None
    SensorNameConfig._cont = ASN1Dict([
        (u'uncompensatedBarometricConfig', _SensorNameConfig_uncompensatedBarometricConfig),
        (u'ueSpeedConfig', _SensorNameConfig_ueSpeedConfig),
        (u'ueOrientationConfig', _SensorNameConfig_ueOrientationConfig),
        (u'choice-Extensions', _SensorNameConfig_choice_Extensions),
        ])
    SensorNameConfig._ext = None
    
    #-----< SensorNameConfig-ExtIEs >-----#
    SensorNameConfig_ExtIEs = CLASS(name=u'SensorNameConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    SensorNameConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name=u'SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< ServedGUAMIList >-----#
    ServedGUAMIList = SEQ_OF(name=u'ServedGUAMIList', mode=MODE_TYPE)
    _ServedGUAMIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIItem')))
    ServedGUAMIList._cont = _ServedGUAMIList__item_
    ServedGUAMIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedGUAMIItem >-----#
    ServedGUAMIItem = SEQ(name=u'ServedGUAMIItem', mode=MODE_TYPE)
    _ServedGUAMIItem_gUAMI = SEQ(name=u'gUAMI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _ServedGUAMIItem_backupAMFName = STR_PRINT(name=u'backupAMFName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFName')), opt=True)
    _ServedGUAMIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedGUAMIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ServedGUAMIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedGUAMIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMIType')))
    ____ServedGUAMIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'ignore'), (u'Extension', _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedGUAMIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedGUAMIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedGUAMIItem_iE_Extensions__item__id),
        (u'criticality', ___ServedGUAMIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedGUAMIItem_iE_Extensions__item__extensionValue),
        ])
    __ServedGUAMIItem_iE_Extensions__item_._ext = None
    _ServedGUAMIItem_iE_Extensions._cont = __ServedGUAMIItem_iE_Extensions__item_
    _ServedGUAMIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedGUAMIItem._cont = ASN1Dict([
        (u'gUAMI', _ServedGUAMIItem_gUAMI),
        (u'backupAMFName', _ServedGUAMIItem_backupAMFName),
        (u'iE-Extensions', _ServedGUAMIItem_iE_Extensions),
        ])
    ServedGUAMIItem._ext = []
    
    #-----< ServedGUAMIItem-ExtIEs >-----#
    ServedGUAMIItem_ExtIEs = CLASS(name=u'ServedGUAMIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _ServedGUAMIItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMIType')))
    ServedGUAMIItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'ignore'), (u'Extension', _ServedGUAMIItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServiceAreaInformation >-----#
    ServiceAreaInformation = SEQ_OF(name=u'ServiceAreaInformation', mode=MODE_TYPE)
    _ServiceAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServiceAreaInformation-Item')))
    ServiceAreaInformation._cont = _ServiceAreaInformation__item_
    ServiceAreaInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ServiceAreaInformation-Item >-----#
    ServiceAreaInformation_Item = SEQ(name=u'ServiceAreaInformation-Item', mode=MODE_TYPE)
    _ServiceAreaInformation_Item_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _ServiceAreaInformation_Item_allowedTACs = SEQ_OF(name=u'allowedTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AllowedTACs')), opt=True)
    _ServiceAreaInformation_Item_notAllowedTACs = SEQ_OF(name=u'notAllowedTACs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotAllowedTACs')), opt=True)
    _ServiceAreaInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServiceAreaInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ServiceAreaInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServiceAreaInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServiceAreaInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___ServiceAreaInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ServiceAreaInformation_Item_iE_Extensions__item_._ext = None
    _ServiceAreaInformation_Item_iE_Extensions._cont = __ServiceAreaInformation_Item_iE_Extensions__item_
    _ServiceAreaInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServiceAreaInformation_Item._cont = ASN1Dict([
        (u'pLMNIdentity', _ServiceAreaInformation_Item_pLMNIdentity),
        (u'allowedTACs', _ServiceAreaInformation_Item_allowedTACs),
        (u'notAllowedTACs', _ServiceAreaInformation_Item_notAllowedTACs),
        (u'iE-Extensions', _ServiceAreaInformation_Item_iE_Extensions),
        ])
    ServiceAreaInformation_Item._ext = []
    
    #-----< ServiceAreaInformation-Item-ExtIEs >-----#
    ServiceAreaInformation_Item_ExtIEs = CLASS(name=u'ServiceAreaInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ServiceAreaInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNB-UE-X2AP-ID >-----#
    SgNB_UE_X2AP_ID = INT(name=u'SgNB-UE-X2AP-ID', mode=MODE_TYPE)
    SgNB_UE_X2AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SliceOverloadList >-----#
    SliceOverloadList = SEQ_OF(name=u'SliceOverloadList', mode=MODE_TYPE)
    _SliceOverloadList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceOverloadItem')))
    SliceOverloadList._cont = _SliceOverloadList__item_
    SliceOverloadList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceOverloadItem >-----#
    SliceOverloadItem = SEQ(name=u'SliceOverloadItem', mode=MODE_TYPE)
    _SliceOverloadItem_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _SliceOverloadItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceOverloadItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SliceOverloadItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceOverloadItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab = ____SliceOverloadItem_iE_Extensions__item__id_tab
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceOverloadItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceOverloadItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab = ____SliceOverloadItem_iE_Extensions__item__criticality_tab
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceOverloadItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab = ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceOverloadItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceOverloadItem_iE_Extensions__item__id),
        (u'criticality', ___SliceOverloadItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceOverloadItem_iE_Extensions__item__extensionValue),
        ])
    __SliceOverloadItem_iE_Extensions__item_._ext = None
    _SliceOverloadItem_iE_Extensions._cont = __SliceOverloadItem_iE_Extensions__item_
    _SliceOverloadItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceOverloadItem._cont = ASN1Dict([
        (u's-NSSAI', _SliceOverloadItem_s_NSSAI),
        (u'iE-Extensions', _SliceOverloadItem_iE_Extensions),
        ])
    SliceOverloadItem._ext = []
    
    #-----< SliceOverloadItem-ExtIEs >-----#
    SliceOverloadItem_ExtIEs = CLASS(name=u'SliceOverloadItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SliceOverloadItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceSupportList >-----#
    SliceSupportList = SEQ_OF(name=u'SliceSupportList', mode=MODE_TYPE)
    _SliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportItem')))
    SliceSupportList._cont = _SliceSupportList__item_
    SliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceSupportItem >-----#
    SliceSupportItem = SEQ(name=u'SliceSupportItem', mode=MODE_TYPE)
    _SliceSupportItem_s_NSSAI = SEQ(name=u's-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _SliceSupportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SliceSupportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SliceSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__id._const_tab = ____SliceSupportItem_iE_Extensions__item__id_tab
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SliceSupportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab = ____SliceSupportItem_iE_Extensions__item__criticality_tab
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SliceSupportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceSupportItem_iE_Extensions__item__extensionValue_tab
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SliceSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SliceSupportItem_iE_Extensions__item__id),
        (u'criticality', ___SliceSupportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SliceSupportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceSupportItem_iE_Extensions__item_._ext = None
    _SliceSupportItem_iE_Extensions._cont = __SliceSupportItem_iE_Extensions__item_
    _SliceSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceSupportItem._cont = ASN1Dict([
        (u's-NSSAI', _SliceSupportItem_s_NSSAI),
        (u'iE-Extensions', _SliceSupportItem_iE_Extensions),
        ])
    SliceSupportItem._ext = []
    
    #-----< SliceSupportItem-ExtIEs >-----#
    SliceSupportItem_ExtIEs = CLASS(name=u'SliceSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SliceSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNPN-MobilityInformation >-----#
    SNPN_MobilityInformation = SEQ(name=u'SNPN-MobilityInformation', mode=MODE_TYPE)
    _SNPN_MobilityInformation_serving_NID = BIT_STR(name=u'serving-NID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _SNPN_MobilityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNPN_MobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SNPN_MobilityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNPN_MobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__id_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNPN_MobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNPN_MobilityInformation_iE_Extensions__item__id),
        (u'criticality', ___SNPN_MobilityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __SNPN_MobilityInformation_iE_Extensions__item_._ext = None
    _SNPN_MobilityInformation_iE_Extensions._cont = __SNPN_MobilityInformation_iE_Extensions__item_
    _SNPN_MobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNPN_MobilityInformation._cont = ASN1Dict([
        (u'serving-NID', _SNPN_MobilityInformation_serving_NID),
        (u'iE-Extensions', _SNPN_MobilityInformation_iE_Extensions),
        ])
    SNPN_MobilityInformation._ext = []
    
    #-----< SNPN-MobilityInformation-ExtIEs >-----#
    SNPN_MobilityInformation_ExtIEs = CLASS(name=u'SNPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SNPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< S-NSSAI >-----#
    S_NSSAI = SEQ(name=u'S-NSSAI', mode=MODE_TYPE)
    _S_NSSAI_sST = OCT_STR(name=u'sST', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SST')))
    _S_NSSAI_sD = OCT_STR(name=u'sD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SD')), opt=True)
    _S_NSSAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S_NSSAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___S_NSSAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____S_NSSAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__id._const_tab = ____S_NSSAI_iE_Extensions__item__id_tab
    ___S_NSSAI_iE_Extensions__item__id._const_tab_at = None
    ___S_NSSAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___S_NSSAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____S_NSSAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab = ____S_NSSAI_iE_Extensions__item__criticality_tab
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___S_NSSAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____S_NSSAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab = ____S_NSSAI_iE_Extensions__item__extensionValue_tab
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __S_NSSAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___S_NSSAI_iE_Extensions__item__id),
        (u'criticality', ___S_NSSAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___S_NSSAI_iE_Extensions__item__extensionValue),
        ])
    __S_NSSAI_iE_Extensions__item_._ext = None
    _S_NSSAI_iE_Extensions._cont = __S_NSSAI_iE_Extensions__item_
    _S_NSSAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S_NSSAI._cont = ASN1Dict([
        (u'sST', _S_NSSAI_sST),
        (u'sD', _S_NSSAI_sD),
        (u'iE-Extensions', _S_NSSAI_iE_Extensions),
        ])
    S_NSSAI._ext = []
    
    #-----< S-NSSAI-ExtIEs >-----#
    S_NSSAI_ExtIEs = CLASS(name=u'S-NSSAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    S_NSSAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONConfigurationTransfer >-----#
    SONConfigurationTransfer = SEQ(name=u'SONConfigurationTransfer', mode=MODE_TYPE)
    _SONConfigurationTransfer_targetRANNodeID = SEQ(name=u'targetRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID')))
    _SONConfigurationTransfer_sourceRANNodeID = SEQ(name=u'sourceRANNodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceRANNodeID')))
    _SONConfigurationTransfer_sONInformation = CHOICE(name=u'sONInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformation')))
    _SONConfigurationTransfer_xnTNLConfigurationInfo = SEQ(name=u'xnTNLConfigurationInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTNLConfigurationInfo')), opt=True)
    _SONConfigurationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SONConfigurationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SONConfigurationTransfer_iE_Extensions__item__id),
        (u'criticality', ___SONConfigurationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __SONConfigurationTransfer_iE_Extensions__item_._ext = None
    _SONConfigurationTransfer_iE_Extensions._cont = __SONConfigurationTransfer_iE_Extensions__item_
    _SONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONConfigurationTransfer._cont = ASN1Dict([
        (u'targetRANNodeID', _SONConfigurationTransfer_targetRANNodeID),
        (u'sourceRANNodeID', _SONConfigurationTransfer_sourceRANNodeID),
        (u'sONInformation', _SONConfigurationTransfer_sONInformation),
        (u'xnTNLConfigurationInfo', _SONConfigurationTransfer_xnTNLConfigurationInfo),
        (u'iE-Extensions', _SONConfigurationTransfer_iE_Extensions),
        ])
    SONConfigurationTransfer._ext = []
    
    #-----< SONConfigurationTransfer-ExtIEs >-----#
    SONConfigurationTransfer_ExtIEs = CLASS(name=u'SONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformation >-----#
    SONInformation = CHOICE(name=u'SONInformation', mode=MODE_TYPE)
    _SONInformation_sONInformationRequest = ENUM(name=u'sONInformationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformationRequest')))
    _SONInformation_sONInformationReply = SEQ(name=u'sONInformationReply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReply')))
    _SONInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SONInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___SONInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____SONInformation_choice_Extensions_id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReport')))
    ___SONInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', ____SONInformation_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SONInformation_choice_Extensions_id._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_id._const_tab_at = None
    __SONInformation_choice_Extensions_id._const_tab_id = u'id'
    __SONInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __SONInformation_choice_Extensions_criticality._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __SONInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __SONInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __SONInformation_choice_Extensions_value._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __SONInformation_choice_Extensions_value._const_tab_id = u'Value'
    _SONInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __SONInformation_choice_Extensions_id),
        (u'criticality', __SONInformation_choice_Extensions_criticality),
        (u'value', __SONInformation_choice_Extensions_value),
        ])
    _SONInformation_choice_Extensions._ext = None
    SONInformation._cont = ASN1Dict([
        (u'sONInformationRequest', _SONInformation_sONInformationRequest),
        (u'sONInformationReply', _SONInformation_sONInformationReply),
        (u'choice-Extensions', _SONInformation_choice_Extensions),
        ])
    SONInformation._ext = None
    
    #-----< SONInformation-ExtIEs >-----#
    SONInformation_ExtIEs = CLASS(name=u'SONInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _SONInformation_ExtIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReport')))
    SONInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', _SONInformation_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SONInformationReply >-----#
    SONInformationReply = SEQ(name=u'SONInformationReply', mode=MODE_TYPE)
    _SONInformationReply_xnTNLConfigurationInfo = SEQ(name=u'xnTNLConfigurationInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTNLConfigurationInfo')), opt=True)
    _SONInformationReply_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONInformationReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SONInformationReply_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SONInformationReply_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__id._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__id._const_tab_at = None
    ___SONInformationReply_iE_Extensions__item__id._const_tab_id = u'id'
    ___SONInformationReply_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SONInformationReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab = ____SONInformationReply_iE_Extensions__item__criticality_tab
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SONInformationReply_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SONInformationReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab = ____SONInformationReply_iE_Extensions__item__extensionValue_tab
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SONInformationReply_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SONInformationReply_iE_Extensions__item__id),
        (u'criticality', ___SONInformationReply_iE_Extensions__item__criticality),
        (u'extensionValue', ___SONInformationReply_iE_Extensions__item__extensionValue),
        ])
    __SONInformationReply_iE_Extensions__item_._ext = None
    _SONInformationReply_iE_Extensions._cont = __SONInformationReply_iE_Extensions__item_
    _SONInformationReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONInformationReply._cont = ASN1Dict([
        (u'xnTNLConfigurationInfo', _SONInformationReply_xnTNLConfigurationInfo),
        (u'iE-Extensions', _SONInformationReply_iE_Extensions),
        ])
    SONInformationReply._ext = []
    
    #-----< SONInformationReply-ExtIEs >-----#
    SONInformationReply_ExtIEs = CLASS(name=u'SONInformationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SONInformationReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformationReport >-----#
    SONInformationReport = CHOICE(name=u'SONInformationReport', mode=MODE_TYPE)
    _SONInformationReport_failureIndicationInformation = SEQ(name=u'failureIndicationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FailureIndication')))
    _SONInformationReport_hOReportInformation = SEQ(name=u'hOReportInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'HOReport')))
    _SONInformationReport_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SONInformationReport_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___SONInformationReport_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SONInformationReport_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SONInformationReport_choice_Extensions_id._const_tab = ___SONInformationReport_choice_Extensions_id_tab
    __SONInformationReport_choice_Extensions_id._const_tab_at = None
    __SONInformationReport_choice_Extensions_id._const_tab_id = u'id'
    __SONInformationReport_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___SONInformationReport_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SONInformationReport_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SONInformationReport_choice_Extensions_criticality._const_tab = ___SONInformationReport_choice_Extensions_criticality_tab
    __SONInformationReport_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __SONInformationReport_choice_Extensions_criticality._const_tab_id = u'criticality'
    __SONInformationReport_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___SONInformationReport_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SONInformationReport_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SONInformationReport_choice_Extensions_value._const_tab = ___SONInformationReport_choice_Extensions_value_tab
    __SONInformationReport_choice_Extensions_value._const_tab_at = ('..', u'id')
    __SONInformationReport_choice_Extensions_value._const_tab_id = u'Value'
    _SONInformationReport_choice_Extensions._cont = ASN1Dict([
        (u'id', __SONInformationReport_choice_Extensions_id),
        (u'criticality', __SONInformationReport_choice_Extensions_criticality),
        (u'value', __SONInformationReport_choice_Extensions_value),
        ])
    _SONInformationReport_choice_Extensions._ext = None
    SONInformationReport._cont = ASN1Dict([
        (u'failureIndicationInformation', _SONInformationReport_failureIndicationInformation),
        (u'hOReportInformation', _SONInformationReport_hOReportInformation),
        (u'choice-Extensions', _SONInformationReport_choice_Extensions),
        ])
    SONInformationReport._ext = None
    
    #-----< SONInformationReport-ExtIEs >-----#
    SONInformationReport_ExtIEs = CLASS(name=u'SONInformationReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    SONInformationReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformationRequest >-----#
    SONInformationRequest = ENUM(name=u'SONInformationRequest', mode=MODE_TYPE)
    SONInformationRequest._cont = ASN1Dict([(u'xn-TNL-configuration-info', 0)])
    SONInformationRequest._ext = []
    
    #-----< SourceNGRANNode-ToTargetNGRANNode-TransparentContainer >-----#
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer = SEQ(name=u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer', mode=MODE_TYPE)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer = OCT_STR(name=u'rRCContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RRCContainer')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList = SEQ_OF(name=u'pDUSessionResourceInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceInformationList')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList = SEQ_OF(name=u'e-RABInformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RABInformationList')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID = CHOICE(name=u'targetCell-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP = INT(name=u'indexToRFSP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation = SEQ_OF(name=u'uEHistoryInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformation')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformationFromTheUE')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceNodeID')))
    ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions._cont = __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer._cont = ASN1Dict([
        (u'rRCContainer', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer),
        (u'pDUSessionResourceInformationList', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList),
        (u'e-RABInformationList', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList),
        (u'targetCell-ID', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID),
        (u'indexToRFSP', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP),
        (u'uEHistoryInformation', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation),
        (u'iE-Extensions', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions),
        ])
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer._ext = []
    
    #-----< SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs >-----#
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs = CLASS(name=u'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SgNB-UE-X2AP-ID')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformationFromTheUE')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceNodeID')))
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceNodeID >-----#
    SourceNodeID = CHOICE(name=u'SourceNodeID', mode=MODE_TYPE)
    _SourceNodeID_sourceengNB_ID = SEQ(name=u'sourceengNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalGNB-ID')))
    _SourceNodeID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SourceNodeID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___SourceNodeID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_id._const_tab = ___SourceNodeID_choice_Extensions_id_tab
    __SourceNodeID_choice_Extensions_id._const_tab_at = None
    __SourceNodeID_choice_Extensions_id._const_tab_id = u'id'
    __SourceNodeID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___SourceNodeID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_criticality._const_tab = ___SourceNodeID_choice_Extensions_criticality_tab
    __SourceNodeID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __SourceNodeID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __SourceNodeID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___SourceNodeID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_value._const_tab = ___SourceNodeID_choice_Extensions_value_tab
    __SourceNodeID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __SourceNodeID_choice_Extensions_value._const_tab_id = u'Value'
    _SourceNodeID_choice_Extensions._cont = ASN1Dict([
        (u'id', __SourceNodeID_choice_Extensions_id),
        (u'criticality', __SourceNodeID_choice_Extensions_criticality),
        (u'value', __SourceNodeID_choice_Extensions_value),
        ])
    _SourceNodeID_choice_Extensions._ext = None
    SourceNodeID._cont = ASN1Dict([
        (u'sourceengNB-ID', _SourceNodeID_sourceengNB_ID),
        (u'choice-Extensions', _SourceNodeID_choice_Extensions),
        ])
    SourceNodeID._ext = None
    
    #-----< SourceNodeID-ExtIEs >-----#
    SourceNodeID_ExtIEs = CLASS(name=u'SourceNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    SourceNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name=u'SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([(u'subscription-information', 0), (u'statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< SourceRANNodeID >-----#
    SourceRANNodeID = SEQ(name=u'SourceRANNodeID', mode=MODE_TYPE)
    _SourceRANNodeID_globalRANNodeID = CHOICE(name=u'globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _SourceRANNodeID_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _SourceRANNodeID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRANNodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceRANNodeID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceRANNodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab = ____SourceRANNodeID_iE_Extensions__item__id_tab
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab_at = None
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceRANNodeID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SourceRANNodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab = ____SourceRANNodeID_iE_Extensions__item__criticality_tab
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceRANNodeID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab = ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceRANNodeID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceRANNodeID_iE_Extensions__item__id),
        (u'criticality', ___SourceRANNodeID_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceRANNodeID_iE_Extensions__item__extensionValue),
        ])
    __SourceRANNodeID_iE_Extensions__item_._ext = None
    _SourceRANNodeID_iE_Extensions._cont = __SourceRANNodeID_iE_Extensions__item_
    _SourceRANNodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRANNodeID._cont = ASN1Dict([
        (u'globalRANNodeID', _SourceRANNodeID_globalRANNodeID),
        (u'selectedTAI', _SourceRANNodeID_selectedTAI),
        (u'iE-Extensions', _SourceRANNodeID_iE_Extensions),
        ])
    SourceRANNodeID._ext = []
    
    #-----< SourceRANNodeID-ExtIEs >-----#
    SourceRANNodeID_ExtIEs = CLASS(name=u'SourceRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SourceRANNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceToTarget-TransparentContainer >-----#
    SourceToTarget_TransparentContainer = OCT_STR(name=u'SourceToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceToTarget-AMFInformationReroute >-----#
    SourceToTarget_AMFInformationReroute = SEQ(name=u'SourceToTarget-AMFInformationReroute', mode=MODE_TYPE)
    _SourceToTarget_AMFInformationReroute_configuredNSSAI = OCT_STR(name=u'configuredNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredNSSAI')), opt=True)
    _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN = OCT_STR(name=u'rejectedNSSAIinPLMN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RejectedNSSAIinPLMN')), opt=True)
    _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA = OCT_STR(name=u'rejectedNSSAIinTA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RejectedNSSAIinTA')), opt=True)
    _SourceToTarget_AMFInformationReroute_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab_at = None
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id),
        (u'criticality', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue),
        ])
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_._ext = None
    _SourceToTarget_AMFInformationReroute_iE_Extensions._cont = __SourceToTarget_AMFInformationReroute_iE_Extensions__item_
    _SourceToTarget_AMFInformationReroute_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceToTarget_AMFInformationReroute._cont = ASN1Dict([
        (u'configuredNSSAI', _SourceToTarget_AMFInformationReroute_configuredNSSAI),
        (u'rejectedNSSAIinPLMN', _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN),
        (u'rejectedNSSAIinTA', _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA),
        (u'iE-Extensions', _SourceToTarget_AMFInformationReroute_iE_Extensions),
        ])
    SourceToTarget_AMFInformationReroute._ext = []
    
    #-----< SourceToTarget-AMFInformationReroute-ExtIEs >-----#
    SourceToTarget_AMFInformationReroute_ExtIEs = CLASS(name=u'SourceToTarget-AMFInformationReroute-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SourceToTarget_AMFInformationReroute_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name=u'SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([(u'possible', 0), (u'notPossible', 1)])
    SRVCCOperationPossible._ext = []
    
    #-----< ConfiguredNSSAI >-----#
    ConfiguredNSSAI = OCT_STR(name=u'ConfiguredNSSAI', mode=MODE_TYPE)
    ConfiguredNSSAI._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< RejectedNSSAIinPLMN >-----#
    RejectedNSSAIinPLMN = OCT_STR(name=u'RejectedNSSAIinPLMN', mode=MODE_TYPE)
    RejectedNSSAIinPLMN._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RejectedNSSAIinTA >-----#
    RejectedNSSAIinTA = OCT_STR(name=u'RejectedNSSAIinTA', mode=MODE_TYPE)
    RejectedNSSAIinTA._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< SST >-----#
    SST = OCT_STR(name=u'SST', mode=MODE_TYPE)
    SST._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SupportedTAList >-----#
    SupportedTAList = SEQ_OF(name=u'SupportedTAList', mode=MODE_TYPE)
    _SupportedTAList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAItem')))
    SupportedTAList._cont = _SupportedTAList__item_
    SupportedTAList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SupportedTAItem >-----#
    SupportedTAItem = SEQ(name=u'SupportedTAItem', mode=MODE_TYPE)
    _SupportedTAItem_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    _SupportedTAItem_broadcastPLMNList = SEQ_OF(name=u'broadcastPLMNList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BroadcastPLMNList')))
    _SupportedTAItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedTAItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SupportedTAItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SupportedTAItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredTACIndication')))
    _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAT-Information')))
    ____SupportedTAItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 272), (u'criticality', u'ignore'), (u'Extension', _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Extension', _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SupportedTAItem_iE_Extensions__item__id._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__id._const_tab_at = None
    ___SupportedTAItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SupportedTAItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SupportedTAItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SupportedTAItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SupportedTAItem_iE_Extensions__item__id),
        (u'criticality', ___SupportedTAItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SupportedTAItem_iE_Extensions__item__extensionValue),
        ])
    __SupportedTAItem_iE_Extensions__item_._ext = None
    _SupportedTAItem_iE_Extensions._cont = __SupportedTAItem_iE_Extensions__item_
    _SupportedTAItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedTAItem._cont = ASN1Dict([
        (u'tAC', _SupportedTAItem_tAC),
        (u'broadcastPLMNList', _SupportedTAItem_broadcastPLMNList),
        (u'iE-Extensions', _SupportedTAItem_iE_Extensions),
        ])
    SupportedTAItem._ext = []
    
    #-----< SupportedTAItem-ExtIEs >-----#
    SupportedTAItem_ExtIEs = CLASS(name=u'SupportedTAItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SupportedTAItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredTACIndication')))
    _SupportedTAItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAT-Information')))
    SupportedTAItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 272), (u'criticality', u'ignore'), (u'Extension', _SupportedTAItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Extension', _SupportedTAItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SuspendIndicator >-----#
    SuspendIndicator = ENUM(name=u'SuspendIndicator', mode=MODE_TYPE)
    SuspendIndicator._cont = ASN1Dict([(u'true', 0)])
    SuspendIndicator._ext = []
    
    #-----< Suspend-Request-Indication >-----#
    Suspend_Request_Indication = ENUM(name=u'Suspend-Request-Indication', mode=MODE_TYPE)
    Suspend_Request_Indication._cont = ASN1Dict([(u'suspend-requested', 0)])
    Suspend_Request_Indication._ext = []
    
    #-----< Suspend-Response-Indication >-----#
    Suspend_Response_Indication = ENUM(name=u'Suspend-Response-Indication', mode=MODE_TYPE)
    Suspend_Response_Indication._cont = ASN1Dict([(u'suspend-indicated', 0)])
    Suspend_Response_Indication._ext = []
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name=u'TAI', mode=MODE_TYPE)
    _TAI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _TAI_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_iE_Extensions__item__id),
        (u'criticality', ___TAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        (u'pLMNIdentity', _TAI_pLMNIdentity),
        (u'tAC', _TAI_tAC),
        (u'iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = []
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name=u'TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIBroadcastEUTRA >-----#
    TAIBroadcastEUTRA = SEQ_OF(name=u'TAIBroadcastEUTRA', mode=MODE_TYPE)
    _TAIBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastEUTRA-Item')))
    TAIBroadcastEUTRA._cont = _TAIBroadcastEUTRA__item_
    TAIBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAIBroadcastEUTRA-Item >-----#
    TAIBroadcastEUTRA_Item = SEQ(name=u'TAIBroadcastEUTRA-Item', mode=MODE_TYPE)
    _TAIBroadcastEUTRA_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA = SEQ_OF(name=u'completedCellsInTAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-EUTRA')))
    _TAIBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _TAIBroadcastEUTRA_Item_iE_Extensions._cont = __TAIBroadcastEUTRA_Item_iE_Extensions__item_
    _TAIBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBroadcastEUTRA_Item._cont = ASN1Dict([
        (u'tAI', _TAIBroadcastEUTRA_Item_tAI),
        (u'completedCellsInTAI-EUTRA', _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA),
        (u'iE-Extensions', _TAIBroadcastEUTRA_Item_iE_Extensions),
        ])
    TAIBroadcastEUTRA_Item._ext = []
    
    #-----< TAIBroadcastEUTRA-Item-ExtIEs >-----#
    TAIBroadcastEUTRA_Item_ExtIEs = CLASS(name=u'TAIBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIBroadcastNR >-----#
    TAIBroadcastNR = SEQ_OF(name=u'TAIBroadcastNR', mode=MODE_TYPE)
    _TAIBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastNR-Item')))
    TAIBroadcastNR._cont = _TAIBroadcastNR__item_
    TAIBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAIBroadcastNR-Item >-----#
    TAIBroadcastNR_Item = SEQ(name=u'TAIBroadcastNR-Item', mode=MODE_TYPE)
    _TAIBroadcastNR_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIBroadcastNR_Item_completedCellsInTAI_NR = SEQ_OF(name=u'completedCellsInTAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-NR')))
    _TAIBroadcastNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBroadcastNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBroadcastNR_Item_iE_Extensions__item__id),
        (u'criticality', ___TAIBroadcastNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __TAIBroadcastNR_Item_iE_Extensions__item_._ext = None
    _TAIBroadcastNR_Item_iE_Extensions._cont = __TAIBroadcastNR_Item_iE_Extensions__item_
    _TAIBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBroadcastNR_Item._cont = ASN1Dict([
        (u'tAI', _TAIBroadcastNR_Item_tAI),
        (u'completedCellsInTAI-NR', _TAIBroadcastNR_Item_completedCellsInTAI_NR),
        (u'iE-Extensions', _TAIBroadcastNR_Item_iE_Extensions),
        ])
    TAIBroadcastNR_Item._ext = []
    
    #-----< TAIBroadcastNR-Item-ExtIEs >-----#
    TAIBroadcastNR_Item_ExtIEs = CLASS(name=u'TAIBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAICancelledEUTRA >-----#
    TAICancelledEUTRA = SEQ_OF(name=u'TAICancelledEUTRA', mode=MODE_TYPE)
    _TAICancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledEUTRA-Item')))
    TAICancelledEUTRA._cont = _TAICancelledEUTRA__item_
    TAICancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAICancelledEUTRA-Item >-----#
    TAICancelledEUTRA_Item = SEQ(name=u'TAICancelledEUTRA-Item', mode=MODE_TYPE)
    _TAICancelledEUTRA_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA = SEQ_OF(name=u'cancelledCellsInTAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-EUTRA')))
    _TAICancelledEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAICancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAICancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAICancelledEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TAICancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _TAICancelledEUTRA_Item_iE_Extensions._cont = __TAICancelledEUTRA_Item_iE_Extensions__item_
    _TAICancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAICancelledEUTRA_Item._cont = ASN1Dict([
        (u'tAI', _TAICancelledEUTRA_Item_tAI),
        (u'cancelledCellsInTAI-EUTRA', _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA),
        (u'iE-Extensions', _TAICancelledEUTRA_Item_iE_Extensions),
        ])
    TAICancelledEUTRA_Item._ext = []
    
    #-----< TAICancelledEUTRA-Item-ExtIEs >-----#
    TAICancelledEUTRA_Item_ExtIEs = CLASS(name=u'TAICancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAICancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAICancelledNR >-----#
    TAICancelledNR = SEQ_OF(name=u'TAICancelledNR', mode=MODE_TYPE)
    _TAICancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledNR-Item')))
    TAICancelledNR._cont = _TAICancelledNR__item_
    TAICancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAICancelledNR-Item >-----#
    TAICancelledNR_Item = SEQ(name=u'TAICancelledNR-Item', mode=MODE_TYPE)
    _TAICancelledNR_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAICancelledNR_Item_cancelledCellsInTAI_NR = SEQ_OF(name=u'cancelledCellsInTAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-NR')))
    _TAICancelledNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAICancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAICancelledNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAICancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__id_tab
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAICancelledNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAICancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAICancelledNR_Item_iE_Extensions__item__id),
        (u'criticality', ___TAICancelledNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAICancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __TAICancelledNR_Item_iE_Extensions__item_._ext = None
    _TAICancelledNR_Item_iE_Extensions._cont = __TAICancelledNR_Item_iE_Extensions__item_
    _TAICancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAICancelledNR_Item._cont = ASN1Dict([
        (u'tAI', _TAICancelledNR_Item_tAI),
        (u'cancelledCellsInTAI-NR', _TAICancelledNR_Item_cancelledCellsInTAI_NR),
        (u'iE-Extensions', _TAICancelledNR_Item_iE_Extensions),
        ])
    TAICancelledNR_Item._ext = []
    
    #-----< TAICancelledNR-Item-ExtIEs >-----#
    TAICancelledNR_Item_ExtIEs = CLASS(name=u'TAICancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAICancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForInactive >-----#
    TAIListForInactive = SEQ_OF(name=u'TAIListForInactive', mode=MODE_TYPE)
    _TAIListForInactive__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForInactiveItem')))
    TAIListForInactive._cont = _TAIListForInactive__item_
    TAIListForInactive._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TAIListForInactiveItem >-----#
    TAIListForInactiveItem = SEQ(name=u'TAIListForInactiveItem', mode=MODE_TYPE)
    _TAIListForInactiveItem_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIListForInactiveItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIListForInactiveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIListForInactiveItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIListForInactiveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__id_tab
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIListForInactiveItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIListForInactiveItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIListForInactiveItem_iE_Extensions__item__id),
        (u'criticality', ___TAIListForInactiveItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIListForInactiveItem_iE_Extensions__item__extensionValue),
        ])
    __TAIListForInactiveItem_iE_Extensions__item_._ext = None
    _TAIListForInactiveItem_iE_Extensions._cont = __TAIListForInactiveItem_iE_Extensions__item_
    _TAIListForInactiveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIListForInactiveItem._cont = ASN1Dict([
        (u'tAI', _TAIListForInactiveItem_tAI),
        (u'iE-Extensions', _TAIListForInactiveItem_iE_Extensions),
        ])
    TAIListForInactiveItem._ext = []
    
    #-----< TAIListForInactiveItem-ExtIEs >-----#
    TAIListForInactiveItem_ExtIEs = CLASS(name=u'TAIListForInactiveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIListForInactiveItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForPaging >-----#
    TAIListForPaging = SEQ_OF(name=u'TAIListForPaging', mode=MODE_TYPE)
    _TAIListForPaging__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPagingItem')))
    TAIListForPaging._cont = _TAIListForPaging__item_
    TAIListForPaging._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TAIListForPagingItem >-----#
    TAIListForPagingItem = SEQ(name=u'TAIListForPagingItem', mode=MODE_TYPE)
    _TAIListForPagingItem_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIListForPagingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIListForPagingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIListForPagingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIListForPagingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab = ____TAIListForPagingItem_iE_Extensions__item__id_tab
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIListForPagingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIListForPagingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab = ____TAIListForPagingItem_iE_Extensions__item__criticality_tab
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab = ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIListForPagingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIListForPagingItem_iE_Extensions__item__id),
        (u'criticality', ___TAIListForPagingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIListForPagingItem_iE_Extensions__item__extensionValue),
        ])
    __TAIListForPagingItem_iE_Extensions__item_._ext = None
    _TAIListForPagingItem_iE_Extensions._cont = __TAIListForPagingItem_iE_Extensions__item_
    _TAIListForPagingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIListForPagingItem._cont = ASN1Dict([
        (u'tAI', _TAIListForPagingItem_tAI),
        (u'iE-Extensions', _TAIListForPagingItem_iE_Extensions),
        ])
    TAIListForPagingItem._ext = []
    
    #-----< TAIListForPagingItem-ExtIEs >-----#
    TAIListForPagingItem_ExtIEs = CLASS(name=u'TAIListForPagingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIListForPagingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForRestart >-----#
    TAIListForRestart = SEQ_OF(name=u'TAIListForRestart', mode=MODE_TYPE)
    _TAIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListForRestart._cont = _TAIListForRestart__item_
    TAIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< TAIListForWarning >-----#
    TAIListForWarning = SEQ_OF(name=u'TAIListForWarning', mode=MODE_TYPE)
    _TAIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListForWarning._cont = _TAIListForWarning__item_
    TAIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TargeteNB-ID >-----#
    TargeteNB_ID = SEQ(name=u'TargeteNB-ID', mode=MODE_TYPE)
    _TargeteNB_ID_globalENB_ID = SEQ(name=u'globalENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalNgENB-ID')))
    _TargeteNB_ID_selected_EPS_TAI = SEQ(name=u'selected-EPS-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAI')))
    _TargeteNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargeteNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab = ____TargeteNB_ID_iE_Extensions__item__id_tab
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargeteNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ID_iE_Extensions__item__criticality_tab
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargeteNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargeteNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargeteNB_ID_iE_Extensions__item__id),
        (u'criticality', ___TargeteNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargeteNB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ID_iE_Extensions__item_._ext = None
    _TargeteNB_ID_iE_Extensions._cont = __TargeteNB_ID_iE_Extensions__item_
    _TargeteNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ID._cont = ASN1Dict([
        (u'globalENB-ID', _TargeteNB_ID_globalENB_ID),
        (u'selected-EPS-TAI', _TargeteNB_ID_selected_EPS_TAI),
        (u'iE-Extensions', _TargeteNB_ID_iE_Extensions),
        ])
    TargeteNB_ID._ext = []
    
    #-----< TargeteNB-ID-ExtIEs >-----#
    TargeteNB_ID_ExtIEs = CLASS(name=u'TargeteNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargeteNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name=u'TargetID', mode=MODE_TYPE)
    _TargetID_targetRANNodeID = SEQ(name=u'targetRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID')))
    _TargetID_targeteNB_ID = SEQ(name=u'targeteNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargeteNB-ID')))
    _TargetID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TargetID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___TargetID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____TargetID_choice_Extensions_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetRNC-ID')))
    ___TargetID_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 178), (u'criticality', u'reject'), (u'Value', ____TargetID_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TargetID_choice_Extensions_id._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_id._const_tab_at = None
    __TargetID_choice_Extensions_id._const_tab_id = u'id'
    __TargetID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __TargetID_choice_Extensions_criticality._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __TargetID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __TargetID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __TargetID_choice_Extensions_value._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __TargetID_choice_Extensions_value._const_tab_id = u'Value'
    _TargetID_choice_Extensions._cont = ASN1Dict([
        (u'id', __TargetID_choice_Extensions_id),
        (u'criticality', __TargetID_choice_Extensions_criticality),
        (u'value', __TargetID_choice_Extensions_value),
        ])
    _TargetID_choice_Extensions._ext = None
    TargetID._cont = ASN1Dict([
        (u'targetRANNodeID', _TargetID_targetRANNodeID),
        (u'targeteNB-ID', _TargetID_targeteNB_ID),
        (u'choice-Extensions', _TargetID_choice_Extensions),
        ])
    TargetID._ext = None
    
    #-----< TargetID-ExtIEs >-----#
    TargetID_ExtIEs = CLASS(name=u'TargetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TargetID_ExtIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetRNC-ID')))
    TargetID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 178), (u'criticality', u'reject'), (u'Value', _TargetID_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-TransparentContainer >-----#
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer = SEQ(name=u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer', mode=MODE_TYPE)
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer = OCT_STR(name=u'rRCContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RRCContainer')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoList')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 267), (u'criticality', u'ignore'), (u'Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_._ext = None
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions._cont = __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer._cont = ASN1Dict([
        (u'rRCContainer', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer),
        (u'iE-Extensions', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions),
        ])
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer._ext = []
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs >-----#
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs = CLASS(name=u'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoList')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 267), (u'criticality', u'ignore'), (u'Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer >-----#
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer = SEQ(name=u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer', mode=MODE_TYPE)
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation = SEQ(name=u'cell-CAGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cell-CAGInformation')), opt=True)
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_._ext = None
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions._cont = __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer._cont = ASN1Dict([
        (u'cell-CAGInformation', _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation),
        (u'iE-Extensions', _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions),
        ])
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer._ext = []
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs >-----#
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs = CLASS(name=u'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRANNodeID >-----#
    TargetRANNodeID = SEQ(name=u'TargetRANNodeID', mode=MODE_TYPE)
    _TargetRANNodeID_globalRANNodeID = CHOICE(name=u'globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _TargetRANNodeID_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TargetRANNodeID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRANNodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRANNodeID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetRANNodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab = ____TargetRANNodeID_iE_Extensions__item__id_tab
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetRANNodeID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetRANNodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab = ____TargetRANNodeID_iE_Extensions__item__criticality_tab
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetRANNodeID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab = ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetRANNodeID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetRANNodeID_iE_Extensions__item__id),
        (u'criticality', ___TargetRANNodeID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetRANNodeID_iE_Extensions__item__extensionValue),
        ])
    __TargetRANNodeID_iE_Extensions__item_._ext = None
    _TargetRANNodeID_iE_Extensions._cont = __TargetRANNodeID_iE_Extensions__item_
    _TargetRANNodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRANNodeID._cont = ASN1Dict([
        (u'globalRANNodeID', _TargetRANNodeID_globalRANNodeID),
        (u'selectedTAI', _TargetRANNodeID_selectedTAI),
        (u'iE-Extensions', _TargetRANNodeID_iE_Extensions),
        ])
    TargetRANNodeID._ext = []
    
    #-----< TargetRANNodeID-ExtIEs >-----#
    TargetRANNodeID_ExtIEs = CLASS(name=u'TargetRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetRANNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name=u'TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LAI')))
    _TargetRNC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RNC-ID')))
    _TargetRNC_ID_extendedRNC_ID = INT(name=u'extendedRNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRNC-ID')), opt=True)
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__criticality_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetRNC_ID_iE_Extensions__item__id),
        (u'criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        (u'lAI', _TargetRNC_ID_lAI),
        (u'rNC-ID', _TargetRNC_ID_rNC_ID),
        (u'extendedRNC-ID', _TargetRNC_ID_extendedRNC_ID),
        (u'iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = []
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name=u'TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetToSource-TransparentContainer >-----#
    TargetToSource_TransparentContainer = OCT_STR(name=u'TargetToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargettoSource-Failure-TransparentContainer >-----#
    TargettoSource_Failure_TransparentContainer = OCT_STR(name=u'TargettoSource-Failure-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TimerApproachForGUAMIRemoval >-----#
    TimerApproachForGUAMIRemoval = ENUM(name=u'TimerApproachForGUAMIRemoval', mode=MODE_TYPE)
    TimerApproachForGUAMIRemoval._cont = ASN1Dict([(u'apply-timer', 0)])
    TimerApproachForGUAMIRemoval._ext = []
    
    #-----< TimeStamp >-----#
    TimeStamp = OCT_STR(name=u'TimeStamp', mode=MODE_TYPE)
    TimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name=u'TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([(u'v1s', 0), (u'v2s', 1), (u'v5s', 2), (u'v10s', 3), (u'v20s', 4), (u'v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TimeUEStayedInCell >-----#
    TimeUEStayedInCell = INT(name=u'TimeUEStayedInCell', mode=MODE_TYPE)
    TimeUEStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TimeUEStayedInCellEnhancedGranularity >-----#
    TimeUEStayedInCellEnhancedGranularity = INT(name=u'TimeUEStayedInCellEnhancedGranularity', mode=MODE_TYPE)
    TimeUEStayedInCellEnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TNAP-ID >-----#
    TNAP_ID = OCT_STR(name=u'TNAP-ID', mode=MODE_TYPE)
    
    #-----< TNGF-ID >-----#
    TNGF_ID = CHOICE(name=u'TNGF-ID', mode=MODE_TYPE)
    _TNGF_ID_tNGF_ID = BIT_STR(name=u'tNGF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNGF_ID_tNGF_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=[], er=[])
    _TNGF_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TNGF_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___TNGF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_id._const_tab = ___TNGF_ID_choice_Extensions_id_tab
    __TNGF_ID_choice_Extensions_id._const_tab_at = None
    __TNGF_ID_choice_Extensions_id._const_tab_id = u'id'
    __TNGF_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___TNGF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_criticality._const_tab = ___TNGF_ID_choice_Extensions_criticality_tab
    __TNGF_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __TNGF_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __TNGF_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___TNGF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_value._const_tab = ___TNGF_ID_choice_Extensions_value_tab
    __TNGF_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __TNGF_ID_choice_Extensions_value._const_tab_id = u'Value'
    _TNGF_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __TNGF_ID_choice_Extensions_id),
        (u'criticality', __TNGF_ID_choice_Extensions_criticality),
        (u'value', __TNGF_ID_choice_Extensions_value),
        ])
    _TNGF_ID_choice_Extensions._ext = None
    TNGF_ID._cont = ASN1Dict([
        (u'tNGF-ID', _TNGF_ID_tNGF_ID),
        (u'choice-Extensions', _TNGF_ID_choice_Extensions),
        ])
    TNGF_ID._ext = None
    
    #-----< TNGF-ID-ExtIEs >-----#
    TNGF_ID_ExtIEs = CLASS(name=u'TNGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    TNGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAddressWeightFactor >-----#
    TNLAddressWeightFactor = INT(name=u'TNLAddressWeightFactor', mode=MODE_TYPE)
    TNLAddressWeightFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TNLAssociationList >-----#
    TNLAssociationList = SEQ_OF(name=u'TNLAssociationList', mode=MODE_TYPE)
    _TNLAssociationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationItem')))
    TNLAssociationList._cont = _TNLAssociationList__item_
    TNLAssociationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLAssociationItem >-----#
    TNLAssociationItem = SEQ(name=u'TNLAssociationItem', mode=MODE_TYPE)
    _TNLAssociationItem_tNLAssociationAddress = CHOICE(name=u'tNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _TNLAssociationItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _TNLAssociationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLAssociationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TNLAssociationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TNLAssociationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab = ____TNLAssociationItem_iE_Extensions__item__id_tab
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab_at = None
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TNLAssociationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TNLAssociationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab = ____TNLAssociationItem_iE_Extensions__item__criticality_tab
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TNLAssociationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab = ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TNLAssociationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TNLAssociationItem_iE_Extensions__item__id),
        (u'criticality', ___TNLAssociationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TNLAssociationItem_iE_Extensions__item__extensionValue),
        ])
    __TNLAssociationItem_iE_Extensions__item_._ext = None
    _TNLAssociationItem_iE_Extensions._cont = __TNLAssociationItem_iE_Extensions__item_
    _TNLAssociationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLAssociationItem._cont = ASN1Dict([
        (u'tNLAssociationAddress', _TNLAssociationItem_tNLAssociationAddress),
        (u'cause', _TNLAssociationItem_cause),
        (u'iE-Extensions', _TNLAssociationItem_iE_Extensions),
        ])
    TNLAssociationItem._ext = []
    
    #-----< TNLAssociationItem-ExtIEs >-----#
    TNLAssociationItem_ExtIEs = CLASS(name=u'TNLAssociationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TNLAssociationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name=u'TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([(u'ue', 0), (u'non-ue', 1), (u'both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TooearlyIntersystemHO >-----#
    TooearlyIntersystemHO = SEQ(name=u'TooearlyIntersystemHO', mode=MODE_TYPE)
    _TooearlyIntersystemHO_sourcecellID = SEQ(name=u'sourcecellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _TooearlyIntersystemHO_failurecellID = CHOICE(name=u'failurecellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _TooearlyIntersystemHO_uERLFReportContainer = CHOICE(name=u'uERLFReportContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _TooearlyIntersystemHO_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TooearlyIntersystemHO_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TooearlyIntersystemHO_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TooearlyIntersystemHO_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__id_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab_at = None
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab_id = u'id'
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TooearlyIntersystemHO_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TooearlyIntersystemHO_iE_Extensions__item__id),
        (u'criticality', ___TooearlyIntersystemHO_iE_Extensions__item__criticality),
        (u'extensionValue', ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue),
        ])
    __TooearlyIntersystemHO_iE_Extensions__item_._ext = None
    _TooearlyIntersystemHO_iE_Extensions._cont = __TooearlyIntersystemHO_iE_Extensions__item_
    _TooearlyIntersystemHO_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TooearlyIntersystemHO._cont = ASN1Dict([
        (u'sourcecellID', _TooearlyIntersystemHO_sourcecellID),
        (u'failurecellID', _TooearlyIntersystemHO_failurecellID),
        (u'uERLFReportContainer', _TooearlyIntersystemHO_uERLFReportContainer),
        (u'iE-Extensions', _TooearlyIntersystemHO_iE_Extensions),
        ])
    TooearlyIntersystemHO._ext = []
    
    #-----< TooearlyIntersystemHO-ExtIEs >-----#
    TooearlyIntersystemHO_ExtIEs = CLASS(name=u'TooearlyIntersystemHO-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TooearlyIntersystemHO_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name=u'TraceActivation', mode=MODE_TYPE)
    _TraceActivation_nGRANTraceID = OCT_STR(name=u'nGRANTraceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name=u'interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name=u'traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name=u'traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceActivation_iE_Extensions__item__id),
        (u'criticality', ___TraceActivation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        (u'nGRANTraceID', _TraceActivation_nGRANTraceID),
        (u'interfacesToTrace', _TraceActivation_interfacesToTrace),
        (u'traceDepth', _TraceActivation_traceDepth),
        (u'traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        (u'iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name=u'TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2), (u'minimumWithoutVendorSpecificExtension', 3), (u'mediumWithoutVendorSpecificExtension', 4), (u'maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< TrafficLoadReductionIndication >-----#
    TrafficLoadReductionIndication = INT(name=u'TrafficLoadReductionIndication', mode=MODE_TYPE)
    TrafficLoadReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=99)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name=u'TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name=u'tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__criticality_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        (u'tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        (u'iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name=u'TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name=u'TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name=u'TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name=u'tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TABasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__criticality_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__extensionValue_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TABasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        (u'tAListforMDT', _TABasedMDT_tAListforMDT),
        (u'iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name=u'TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name=u'TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name=u'Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name=u'Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Threshold-SINR >-----#
    Threshold_SINR = INT(name=u'Threshold-SINR', mode=MODE_TYPE)
    Threshold_SINR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< TimeToTrigger >-----#
    TimeToTrigger = ENUM(name=u'TimeToTrigger', mode=MODE_TYPE)
    TimeToTrigger._cont = ASN1Dict([(u'ms0', 0), (u'ms40', 1), (u'ms64', 2), (u'ms80', 3), (u'ms100', 4), (u'ms128', 5), (u'ms160', 6), (u'ms256', 7), (u'ms320', 8), (u'ms480', 9), (u'ms512', 10), (u'ms640', 11), (u'ms1024', 12), (u'ms1280', 13), (u'ms2560', 14), (u'ms5120', 15)])
    TimeToTrigger._ext = None
    
    #-----< TWAP-ID >-----#
    TWAP_ID = OCT_STR(name=u'TWAP-ID', mode=MODE_TYPE)
    
    #-----< TWIF-ID >-----#
    TWIF_ID = CHOICE(name=u'TWIF-ID', mode=MODE_TYPE)
    _TWIF_ID_tWIF_ID = BIT_STR(name=u'tWIF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TWIF_ID_tWIF_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=[], er=[])
    _TWIF_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TWIF_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___TWIF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_id._const_tab = ___TWIF_ID_choice_Extensions_id_tab
    __TWIF_ID_choice_Extensions_id._const_tab_at = None
    __TWIF_ID_choice_Extensions_id._const_tab_id = u'id'
    __TWIF_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___TWIF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_criticality._const_tab = ___TWIF_ID_choice_Extensions_criticality_tab
    __TWIF_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __TWIF_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __TWIF_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___TWIF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_value._const_tab = ___TWIF_ID_choice_Extensions_value_tab
    __TWIF_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __TWIF_ID_choice_Extensions_value._const_tab_id = u'Value'
    _TWIF_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __TWIF_ID_choice_Extensions_id),
        (u'criticality', __TWIF_ID_choice_Extensions_criticality),
        (u'value', __TWIF_ID_choice_Extensions_value),
        ])
    _TWIF_ID_choice_Extensions._ext = None
    TWIF_ID._cont = ASN1Dict([
        (u'tWIF-ID', _TWIF_ID_tWIF_ID),
        (u'choice-Extensions', _TWIF_ID_choice_Extensions),
        ])
    TWIF_ID._ext = None
    
    #-----< TWIF-ID-ExtIEs >-----#
    TWIF_ID_ExtIEs = CLASS(name=u'TWIF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    TWIF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCAssistanceInformation >-----#
    TSCAssistanceInformation = SEQ(name=u'TSCAssistanceInformation', mode=MODE_TYPE)
    _TSCAssistanceInformation_periodicity = INT(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Periodicity')))
    _TSCAssistanceInformation_burstArrivalTime = OCT_STR(name=u'burstArrivalTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')), opt=True)
    _TSCAssistanceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCAssistanceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TSCAssistanceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TSCAssistanceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TSCAssistanceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TSCAssistanceInformation_iE_Extensions__item__id),
        (u'criticality', ___TSCAssistanceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TSCAssistanceInformation_iE_Extensions__item__extensionValue),
        ])
    __TSCAssistanceInformation_iE_Extensions__item_._ext = None
    _TSCAssistanceInformation_iE_Extensions._cont = __TSCAssistanceInformation_iE_Extensions__item_
    _TSCAssistanceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCAssistanceInformation._cont = ASN1Dict([
        (u'periodicity', _TSCAssistanceInformation_periodicity),
        (u'burstArrivalTime', _TSCAssistanceInformation_burstArrivalTime),
        (u'iE-Extensions', _TSCAssistanceInformation_iE_Extensions),
        ])
    TSCAssistanceInformation._ext = []
    
    #-----< TSCAssistanceInformation-ExtIEs >-----#
    TSCAssistanceInformation_ExtIEs = CLASS(name=u'TSCAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TSCAssistanceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficCharacteristics >-----#
    TSCTrafficCharacteristics = SEQ(name=u'TSCTrafficCharacteristics', mode=MODE_TYPE)
    _TSCTrafficCharacteristics_tSCAssistanceInformationDL = SEQ(name=u'tSCAssistanceInformationDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_tSCAssistanceInformationUL = SEQ(name=u'tSCAssistanceInformationUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficCharacteristics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_id = u'id'
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TSCTrafficCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TSCTrafficCharacteristics_iE_Extensions__item__id),
        (u'criticality', ___TSCTrafficCharacteristics_iE_Extensions__item__criticality),
        (u'extensionValue', ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficCharacteristics_iE_Extensions__item_._ext = None
    _TSCTrafficCharacteristics_iE_Extensions._cont = __TSCTrafficCharacteristics_iE_Extensions__item_
    _TSCTrafficCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficCharacteristics._cont = ASN1Dict([
        (u'tSCAssistanceInformationDL', _TSCTrafficCharacteristics_tSCAssistanceInformationDL),
        (u'tSCAssistanceInformationUL', _TSCTrafficCharacteristics_tSCAssistanceInformationUL),
        (u'iE-Extensions', _TSCTrafficCharacteristics_iE_Extensions),
        ])
    TSCTrafficCharacteristics._ext = []
    
    #-----< TSCTrafficCharacteristics-ExtIEs >-----#
    TSCTrafficCharacteristics_ExtIEs = CLASS(name=u'TSCTrafficCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TSCTrafficCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEAggregateMaximumBitRate >-----#
    UEAggregateMaximumBitRate = SEQ(name=u'UEAggregateMaximumBitRate', mode=MODE_TYPE)
    _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL = INT(name=u'uEAggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL = INT(name=u'uEAggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEAggregateMaximumBitRate_iE_Extensions__item__id),
        (u'criticality', ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitRate_iE_Extensions._cont = __UEAggregateMaximumBitRate_iE_Extensions__item_
    _UEAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitRate._cont = ASN1Dict([
        (u'uEAggregateMaximumBitRateDL', _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL),
        (u'uEAggregateMaximumBitRateUL', _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL),
        (u'iE-Extensions', _UEAggregateMaximumBitRate_iE_Extensions),
        ])
    UEAggregateMaximumBitRate._ext = []
    
    #-----< UEAggregateMaximumBitRate-ExtIEs >-----#
    UEAggregateMaximumBitRate_ExtIEs = CLASS(name=u'UEAggregateMaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEAggregateMaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalNG-connectionList >-----#
    UE_associatedLogicalNG_connectionList = SEQ_OF(name=u'UE-associatedLogicalNG-connectionList', mode=MODE_TYPE)
    _UE_associatedLogicalNG_connectionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionItem')))
    UE_associatedLogicalNG_connectionList._cont = _UE_associatedLogicalNG_connectionList__item_
    UE_associatedLogicalNG_connectionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalNG-connectionItem >-----#
    UE_associatedLogicalNG_connectionItem = SEQ(name=u'UE-associatedLogicalNG-connectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID = INT(name=u'aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')), opt=True)
    _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID = INT(name=u'rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')), opt=True)
    _UE_associatedLogicalNG_connectionItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id),
        (u'criticality', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalNG_connectionItem_iE_Extensions._cont = __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_
    _UE_associatedLogicalNG_connectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalNG_connectionItem._cont = ASN1Dict([
        (u'aMF-UE-NGAP-ID', _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID),
        (u'rAN-UE-NGAP-ID', _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID),
        (u'iE-Extensions', _UE_associatedLogicalNG_connectionItem_iE_Extensions),
        ])
    UE_associatedLogicalNG_connectionItem._ext = []
    
    #-----< UE-associatedLogicalNG-connectionItem-ExtIEs >-----#
    UE_associatedLogicalNG_connectionItem_ExtIEs = CLASS(name=u'UE-associatedLogicalNG-connectionItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalNG_connectionItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoRequest >-----#
    UECapabilityInfoRequest = ENUM(name=u'UECapabilityInfoRequest', mode=MODE_TYPE)
    UECapabilityInfoRequest._cont = ASN1Dict([(u'requested', 0)])
    UECapabilityInfoRequest._ext = []
    
    #-----< UEContextRequest >-----#
    UEContextRequest = ENUM(name=u'UEContextRequest', mode=MODE_TYPE)
    UEContextRequest._cont = ASN1Dict([(u'requested', 0)])
    UEContextRequest._ext = []
    
    #-----< UEContextResumeRequestTransfer >-----#
    UEContextResumeRequestTransfer = SEQ(name=u'UEContextResumeRequestTransfer', mode=MODE_TYPE)
    _UEContextResumeRequestTransfer_qosFlowFailedToResumeList = SEQ_OF(name=u'qosFlowFailedToResumeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _UEContextResumeRequestTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextResumeRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEContextResumeRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeRequestTransfer_iE_Extensions__item__id),
        (u'criticality', ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextResumeRequestTransfer_iE_Extensions__item_._ext = None
    _UEContextResumeRequestTransfer_iE_Extensions._cont = __UEContextResumeRequestTransfer_iE_Extensions__item_
    _UEContextResumeRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextResumeRequestTransfer._cont = ASN1Dict([
        (u'qosFlowFailedToResumeList', _UEContextResumeRequestTransfer_qosFlowFailedToResumeList),
        (u'iE-Extensions', _UEContextResumeRequestTransfer_iE_Extensions),
        ])
    UEContextResumeRequestTransfer._ext = []
    
    #-----< UEContextResumeRequestTransfer-ExtIEs >-----#
    UEContextResumeRequestTransfer_ExtIEs = CLASS(name=u'UEContextResumeRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextResumeRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponseTransfer >-----#
    UEContextResumeResponseTransfer = SEQ(name=u'UEContextResumeResponseTransfer', mode=MODE_TYPE)
    _UEContextResumeResponseTransfer_qosFlowFailedToResumeList = SEQ_OF(name=u'qosFlowFailedToResumeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _UEContextResumeResponseTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextResumeResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEContextResumeResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeResponseTransfer_iE_Extensions__item__id),
        (u'criticality', ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextResumeResponseTransfer_iE_Extensions__item_._ext = None
    _UEContextResumeResponseTransfer_iE_Extensions._cont = __UEContextResumeResponseTransfer_iE_Extensions__item_
    _UEContextResumeResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextResumeResponseTransfer._cont = ASN1Dict([
        (u'qosFlowFailedToResumeList', _UEContextResumeResponseTransfer_qosFlowFailedToResumeList),
        (u'iE-Extensions', _UEContextResumeResponseTransfer_iE_Extensions),
        ])
    UEContextResumeResponseTransfer._ext = []
    
    #-----< UEContextResumeResponseTransfer-ExtIEs >-----#
    UEContextResumeResponseTransfer_ExtIEs = CLASS(name=u'UEContextResumeResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextResumeResponseTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequestTransfer >-----#
    UEContextSuspendRequestTransfer = SEQ(name=u'UEContextSuspendRequestTransfer', mode=MODE_TYPE)
    _UEContextSuspendRequestTransfer_suspendIndicator = ENUM(name=u'suspendIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SuspendIndicator')), opt=True)
    _UEContextSuspendRequestTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextSuspendRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEContextSuspendRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendRequestTransfer_iE_Extensions__item__id),
        (u'criticality', ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextSuspendRequestTransfer_iE_Extensions__item_._ext = None
    _UEContextSuspendRequestTransfer_iE_Extensions._cont = __UEContextSuspendRequestTransfer_iE_Extensions__item_
    _UEContextSuspendRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextSuspendRequestTransfer._cont = ASN1Dict([
        (u'suspendIndicator', _UEContextSuspendRequestTransfer_suspendIndicator),
        (u'iE-Extensions', _UEContextSuspendRequestTransfer_iE_Extensions),
        ])
    UEContextSuspendRequestTransfer._ext = []
    
    #-----< UEContextSuspendRequestTransfer-ExtIEs >-----#
    UEContextSuspendRequestTransfer_ExtIEs = CLASS(name=u'UEContextSuspendRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextSuspendRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-DifferentiationInfo >-----#
    UE_DifferentiationInfo = SEQ(name=u'UE-DifferentiationInfo', mode=MODE_TYPE)
    _UE_DifferentiationInfo_periodicCommunicationIndicator = ENUM(name=u'periodicCommunicationIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_periodicCommunicationIndicator._cont = ASN1Dict([(u'periodically', 0), (u'ondemand', 1)])
    _UE_DifferentiationInfo_periodicCommunicationIndicator._ext = []
    _UE_DifferentiationInfo_periodicTime = INT(name=u'periodicTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_periodicTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=[], er=[])
    _UE_DifferentiationInfo_scheduledCommunicationTime = SEQ(name=u'scheduledCommunicationTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ScheduledCommunicationTime')), opt=True)
    _UE_DifferentiationInfo_stationaryIndication = ENUM(name=u'stationaryIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_stationaryIndication._cont = ASN1Dict([(u'stationary', 0), (u'mobile', 1)])
    _UE_DifferentiationInfo_stationaryIndication._ext = []
    _UE_DifferentiationInfo_trafficProfile = ENUM(name=u'trafficProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_trafficProfile._cont = ASN1Dict([(u'single-packet', 0), (u'dual-packets', 1), (u'multiple-packets', 2)])
    _UE_DifferentiationInfo_trafficProfile._ext = []
    _UE_DifferentiationInfo_batteryIndication = ENUM(name=u'batteryIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_batteryIndication._cont = ASN1Dict([(u'battery-powered', 0), (u'battery-powered-not-rechargeable-or-replaceable', 1), (u'not-battery-powered', 2)])
    _UE_DifferentiationInfo_batteryIndication._ext = []
    _UE_DifferentiationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_DifferentiationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_DifferentiationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_DifferentiationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__id_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_at = None
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_DifferentiationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_DifferentiationInfo_iE_Extensions__item__id),
        (u'criticality', ___UE_DifferentiationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue),
        ])
    __UE_DifferentiationInfo_iE_Extensions__item_._ext = None
    _UE_DifferentiationInfo_iE_Extensions._cont = __UE_DifferentiationInfo_iE_Extensions__item_
    _UE_DifferentiationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_DifferentiationInfo._cont = ASN1Dict([
        (u'periodicCommunicationIndicator', _UE_DifferentiationInfo_periodicCommunicationIndicator),
        (u'periodicTime', _UE_DifferentiationInfo_periodicTime),
        (u'scheduledCommunicationTime', _UE_DifferentiationInfo_scheduledCommunicationTime),
        (u'stationaryIndication', _UE_DifferentiationInfo_stationaryIndication),
        (u'trafficProfile', _UE_DifferentiationInfo_trafficProfile),
        (u'batteryIndication', _UE_DifferentiationInfo_batteryIndication),
        (u'iE-Extensions', _UE_DifferentiationInfo_iE_Extensions),
        ])
    UE_DifferentiationInfo._ext = []
    
    #-----< UE-DifferentiationInfo-ExtIEs >-----#
    UE_DifferentiationInfo_ExtIEs = CLASS(name=u'UE-DifferentiationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_DifferentiationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEHistoryInformation >-----#
    UEHistoryInformation = SEQ_OF(name=u'UEHistoryInformation', mode=MODE_TYPE)
    _UEHistoryInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedCellItem')))
    UEHistoryInformation._cont = _UEHistoryInformation__item_
    UEHistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UEHistoryInformationFromTheUE >-----#
    UEHistoryInformationFromTheUE = CHOICE(name=u'UEHistoryInformationFromTheUE', mode=MODE_TYPE)
    _UEHistoryInformationFromTheUE_nR = OCT_STR(name=u'nR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRMobilityHistoryReport')))
    _UEHistoryInformationFromTheUE_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEHistoryInformationFromTheUE_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab_at = None
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab_id = u'id'
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UEHistoryInformationFromTheUE_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab_id = u'Value'
    _UEHistoryInformationFromTheUE_choice_Extensions._cont = ASN1Dict([
        (u'id', __UEHistoryInformationFromTheUE_choice_Extensions_id),
        (u'criticality', __UEHistoryInformationFromTheUE_choice_Extensions_criticality),
        (u'value', __UEHistoryInformationFromTheUE_choice_Extensions_value),
        ])
    _UEHistoryInformationFromTheUE_choice_Extensions._ext = None
    UEHistoryInformationFromTheUE._cont = ASN1Dict([
        (u'nR', _UEHistoryInformationFromTheUE_nR),
        (u'choice-Extensions', _UEHistoryInformationFromTheUE_choice_Extensions),
        ])
    UEHistoryInformationFromTheUE._ext = None
    
    #-----< UEHistoryInformationFromTheUE-ExtIEs >-----#
    UEHistoryInformationFromTheUE_ExtIEs = CLASS(name=u'UEHistoryInformationFromTheUE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEHistoryInformationFromTheUE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = CHOICE(name=u'UEIdentityIndexValue', mode=MODE_TYPE)
    _UEIdentityIndexValue_indexLength10 = BIT_STR(name=u'indexLength10', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEIdentityIndexValue_indexLength10._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _UEIdentityIndexValue_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEIdentityIndexValue_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UEIdentityIndexValue_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_id._const_tab = ___UEIdentityIndexValue_choice_Extensions_id_tab
    __UEIdentityIndexValue_choice_Extensions_id._const_tab_at = None
    __UEIdentityIndexValue_choice_Extensions_id._const_tab_id = u'id'
    __UEIdentityIndexValue_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEIdentityIndexValue_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab = ___UEIdentityIndexValue_choice_Extensions_criticality_tab
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UEIdentityIndexValue_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEIdentityIndexValue_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_value._const_tab = ___UEIdentityIndexValue_choice_Extensions_value_tab
    __UEIdentityIndexValue_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UEIdentityIndexValue_choice_Extensions_value._const_tab_id = u'Value'
    _UEIdentityIndexValue_choice_Extensions._cont = ASN1Dict([
        (u'id', __UEIdentityIndexValue_choice_Extensions_id),
        (u'criticality', __UEIdentityIndexValue_choice_Extensions_criticality),
        (u'value', __UEIdentityIndexValue_choice_Extensions_value),
        ])
    _UEIdentityIndexValue_choice_Extensions._ext = None
    UEIdentityIndexValue._cont = ASN1Dict([
        (u'indexLength10', _UEIdentityIndexValue_indexLength10),
        (u'choice-Extensions', _UEIdentityIndexValue_choice_Extensions),
        ])
    UEIdentityIndexValue._ext = None
    
    #-----< UEIdentityIndexValue-ExtIEs >-----#
    UEIdentityIndexValue_ExtIEs = CLASS(name=u'UEIdentityIndexValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEIdentityIndexValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-NGAP-IDs >-----#
    UE_NGAP_IDs = CHOICE(name=u'UE-NGAP-IDs', mode=MODE_TYPE)
    _UE_NGAP_IDs_uE_NGAP_ID_pair = SEQ(name=u'uE-NGAP-ID-pair', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-ID-pair')))
    _UE_NGAP_IDs_aMF_UE_NGAP_ID = INT(name=u'aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UE_NGAP_IDs_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_NGAP_IDs_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UE_NGAP_IDs_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_id._const_tab = ___UE_NGAP_IDs_choice_Extensions_id_tab
    __UE_NGAP_IDs_choice_Extensions_id._const_tab_at = None
    __UE_NGAP_IDs_choice_Extensions_id._const_tab_id = u'id'
    __UE_NGAP_IDs_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UE_NGAP_IDs_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab = ___UE_NGAP_IDs_choice_Extensions_criticality_tab
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UE_NGAP_IDs_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UE_NGAP_IDs_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_value._const_tab = ___UE_NGAP_IDs_choice_Extensions_value_tab
    __UE_NGAP_IDs_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UE_NGAP_IDs_choice_Extensions_value._const_tab_id = u'Value'
    _UE_NGAP_IDs_choice_Extensions._cont = ASN1Dict([
        (u'id', __UE_NGAP_IDs_choice_Extensions_id),
        (u'criticality', __UE_NGAP_IDs_choice_Extensions_criticality),
        (u'value', __UE_NGAP_IDs_choice_Extensions_value),
        ])
    _UE_NGAP_IDs_choice_Extensions._ext = None
    UE_NGAP_IDs._cont = ASN1Dict([
        (u'uE-NGAP-ID-pair', _UE_NGAP_IDs_uE_NGAP_ID_pair),
        (u'aMF-UE-NGAP-ID', _UE_NGAP_IDs_aMF_UE_NGAP_ID),
        (u'choice-Extensions', _UE_NGAP_IDs_choice_Extensions),
        ])
    UE_NGAP_IDs._ext = None
    
    #-----< UE-NGAP-IDs-ExtIEs >-----#
    UE_NGAP_IDs_ExtIEs = CLASS(name=u'UE-NGAP-IDs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UE_NGAP_IDs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-NGAP-ID-pair >-----#
    UE_NGAP_ID_pair = SEQ(name=u'UE-NGAP-ID-pair', mode=MODE_TYPE)
    _UE_NGAP_ID_pair_aMF_UE_NGAP_ID = INT(name=u'aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UE_NGAP_ID_pair_rAN_UE_NGAP_ID = INT(name=u'rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UE_NGAP_ID_pair_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_NGAP_ID_pair_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_NGAP_ID_pair_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab_at = None
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_NGAP_ID_pair_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_NGAP_ID_pair_iE_Extensions__item__id),
        (u'criticality', ___UE_NGAP_ID_pair_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue),
        ])
    __UE_NGAP_ID_pair_iE_Extensions__item_._ext = None
    _UE_NGAP_ID_pair_iE_Extensions._cont = __UE_NGAP_ID_pair_iE_Extensions__item_
    _UE_NGAP_ID_pair_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_NGAP_ID_pair._cont = ASN1Dict([
        (u'aMF-UE-NGAP-ID', _UE_NGAP_ID_pair_aMF_UE_NGAP_ID),
        (u'rAN-UE-NGAP-ID', _UE_NGAP_ID_pair_rAN_UE_NGAP_ID),
        (u'iE-Extensions', _UE_NGAP_ID_pair_iE_Extensions),
        ])
    UE_NGAP_ID_pair._ext = []
    
    #-----< UE-NGAP-ID-pair-ExtIEs >-----#
    UE_NGAP_ID_pair_ExtIEs = CLASS(name=u'UE-NGAP-ID-pair-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_NGAP_ID_pair_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEPagingIdentity >-----#
    UEPagingIdentity = CHOICE(name=u'UEPagingIdentity', mode=MODE_TYPE)
    _UEPagingIdentity_fiveG_S_TMSI = SEQ(name=u'fiveG-S-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _UEPagingIdentity_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEPagingIdentity_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UEPagingIdentity_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_id._const_tab = ___UEPagingIdentity_choice_Extensions_id_tab
    __UEPagingIdentity_choice_Extensions_id._const_tab_at = None
    __UEPagingIdentity_choice_Extensions_id._const_tab_id = u'id'
    __UEPagingIdentity_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEPagingIdentity_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_criticality._const_tab = ___UEPagingIdentity_choice_Extensions_criticality_tab
    __UEPagingIdentity_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UEPagingIdentity_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UEPagingIdentity_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEPagingIdentity_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_value._const_tab = ___UEPagingIdentity_choice_Extensions_value_tab
    __UEPagingIdentity_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UEPagingIdentity_choice_Extensions_value._const_tab_id = u'Value'
    _UEPagingIdentity_choice_Extensions._cont = ASN1Dict([
        (u'id', __UEPagingIdentity_choice_Extensions_id),
        (u'criticality', __UEPagingIdentity_choice_Extensions_criticality),
        (u'value', __UEPagingIdentity_choice_Extensions_value),
        ])
    _UEPagingIdentity_choice_Extensions._ext = None
    UEPagingIdentity._cont = ASN1Dict([
        (u'fiveG-S-TMSI', _UEPagingIdentity_fiveG_S_TMSI),
        (u'choice-Extensions', _UEPagingIdentity_choice_Extensions),
        ])
    UEPagingIdentity._ext = None
    
    #-----< UEPagingIdentity-ExtIEs >-----#
    UEPagingIdentity_ExtIEs = CLASS(name=u'UEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEPresence >-----#
    UEPresence = ENUM(name=u'UEPresence', mode=MODE_TYPE)
    UEPresence._cont = ASN1Dict([(u'in', 0), (u'out', 1), (u'unknown', 2)])
    UEPresence._ext = []
    
    #-----< UEPresenceInAreaOfInterestList >-----#
    UEPresenceInAreaOfInterestList = SEQ_OF(name=u'UEPresenceInAreaOfInterestList', mode=MODE_TYPE)
    _UEPresenceInAreaOfInterestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestItem')))
    UEPresenceInAreaOfInterestList._cont = _UEPresenceInAreaOfInterestList__item_
    UEPresenceInAreaOfInterestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UEPresenceInAreaOfInterestItem >-----#
    UEPresenceInAreaOfInterestItem = SEQ(name=u'UEPresenceInAreaOfInterestItem', mode=MODE_TYPE)
    _UEPresenceInAreaOfInterestItem_locationReportingReferenceID = INT(name=u'locationReportingReferenceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')))
    _UEPresenceInAreaOfInterestItem_uEPresence = ENUM(name=u'uEPresence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEPresence')))
    _UEPresenceInAreaOfInterestItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab_at = None
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id),
        (u'criticality', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue),
        ])
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_._ext = None
    _UEPresenceInAreaOfInterestItem_iE_Extensions._cont = __UEPresenceInAreaOfInterestItem_iE_Extensions__item_
    _UEPresenceInAreaOfInterestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEPresenceInAreaOfInterestItem._cont = ASN1Dict([
        (u'locationReportingReferenceID', _UEPresenceInAreaOfInterestItem_locationReportingReferenceID),
        (u'uEPresence', _UEPresenceInAreaOfInterestItem_uEPresence),
        (u'iE-Extensions', _UEPresenceInAreaOfInterestItem_iE_Extensions),
        ])
    UEPresenceInAreaOfInterestItem._ext = []
    
    #-----< UEPresenceInAreaOfInterestItem-ExtIEs >-----#
    UEPresenceInAreaOfInterestItem_ExtIEs = CLASS(name=u'UEPresenceInAreaOfInterestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEPresenceInAreaOfInterestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UERadioCapability >-----#
    UERadioCapability = OCT_STR(name=u'UERadioCapability', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPaging >-----#
    UERadioCapabilityForPaging = SEQ(name=u'UERadioCapabilityForPaging', mode=MODE_TYPE)
    _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR = OCT_STR(name=u'uERadioCapabilityForPagingOfNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNR')), opt=True)
    _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA = OCT_STR(name=u'uERadioCapabilityForPagingOfEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfEUTRA')), opt=True)
    _UERadioCapabilityForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UERadioCapabilityForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UERadioCapabilityForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNB-IoT')))
    ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Extension', _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab_at = None
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UERadioCapabilityForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityForPaging_iE_Extensions__item__id),
        (u'criticality', ___UERadioCapabilityForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue),
        ])
    __UERadioCapabilityForPaging_iE_Extensions__item_._ext = None
    _UERadioCapabilityForPaging_iE_Extensions._cont = __UERadioCapabilityForPaging_iE_Extensions__item_
    _UERadioCapabilityForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UERadioCapabilityForPaging._cont = ASN1Dict([
        (u'uERadioCapabilityForPagingOfNR', _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR),
        (u'uERadioCapabilityForPagingOfEUTRA', _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA),
        (u'iE-Extensions', _UERadioCapabilityForPaging_iE_Extensions),
        ])
    UERadioCapabilityForPaging._ext = []
    
    #-----< UERadioCapabilityForPaging-ExtIEs >-----#
    UERadioCapabilityForPaging_ExtIEs = CLASS(name=u'UERadioCapabilityForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UERadioCapabilityForPaging_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNB-IoT')))
    UERadioCapabilityForPaging_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Extension', _UERadioCapabilityForPaging_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityForPagingOfNB-IoT >-----#
    UERadioCapabilityForPagingOfNB_IoT = OCT_STR(name=u'UERadioCapabilityForPagingOfNB-IoT', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPagingOfNR >-----#
    UERadioCapabilityForPagingOfNR = OCT_STR(name=u'UERadioCapabilityForPagingOfNR', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPagingOfEUTRA >-----#
    UERadioCapabilityForPagingOfEUTRA = OCT_STR(name=u'UERadioCapabilityForPagingOfEUTRA', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityID >-----#
    UERadioCapabilityID = OCT_STR(name=u'UERadioCapabilityID', mode=MODE_TYPE)
    
    #-----< UERetentionInformation >-----#
    UERetentionInformation = ENUM(name=u'UERetentionInformation', mode=MODE_TYPE)
    UERetentionInformation._cont = ASN1Dict([(u'ues-retained', 0)])
    UERetentionInformation._ext = []
    
    #-----< UERLFReportContainer >-----#
    UERLFReportContainer = CHOICE(name=u'UERLFReportContainer', mode=MODE_TYPE)
    _UERLFReportContainer_nR = OCT_STR(name=u'nR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRUERLFReportContainer')))
    _UERLFReportContainer_lTE = OCT_STR(name=u'lTE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LTEUERLFReportContainer')))
    _UERLFReportContainer_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UERLFReportContainer_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UERLFReportContainer_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_id._const_tab = ___UERLFReportContainer_choice_Extensions_id_tab
    __UERLFReportContainer_choice_Extensions_id._const_tab_at = None
    __UERLFReportContainer_choice_Extensions_id._const_tab_id = u'id'
    __UERLFReportContainer_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERLFReportContainer_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_criticality._const_tab = ___UERLFReportContainer_choice_Extensions_criticality_tab
    __UERLFReportContainer_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UERLFReportContainer_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UERLFReportContainer_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERLFReportContainer_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_value._const_tab = ___UERLFReportContainer_choice_Extensions_value_tab
    __UERLFReportContainer_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UERLFReportContainer_choice_Extensions_value._const_tab_id = u'Value'
    _UERLFReportContainer_choice_Extensions._cont = ASN1Dict([
        (u'id', __UERLFReportContainer_choice_Extensions_id),
        (u'criticality', __UERLFReportContainer_choice_Extensions_criticality),
        (u'value', __UERLFReportContainer_choice_Extensions_value),
        ])
    _UERLFReportContainer_choice_Extensions._ext = None
    UERLFReportContainer._cont = ASN1Dict([
        (u'nR', _UERLFReportContainer_nR),
        (u'lTE', _UERLFReportContainer_lTE),
        (u'choice-Extensions', _UERLFReportContainer_choice_Extensions),
        ])
    UERLFReportContainer._ext = None
    
    #-----< UERLFReportContainer-ExtIEs >-----#
    UERLFReportContainer_ExtIEs = CLASS(name=u'UERLFReportContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UERLFReportContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name=u'UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_nRencryptionAlgorithms = BIT_STR(name=u'nRencryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRencryptionAlgorithms')))
    _UESecurityCapabilities_nRintegrityProtectionAlgorithms = BIT_STR(name=u'nRintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRintegrityProtectionAlgorithms')))
    _UESecurityCapabilities_eUTRAencryptionAlgorithms = BIT_STR(name=u'eUTRAencryptionAlgorithms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAencryptionAlgorithms')))
    _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms = BIT_STR(name=u'eUTRAintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAintegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = u'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UESecurityCapabilities_iE_Extensions__item__id),
        (u'criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        (u'extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        (u'nRencryptionAlgorithms', _UESecurityCapabilities_nRencryptionAlgorithms),
        (u'nRintegrityProtectionAlgorithms', _UESecurityCapabilities_nRintegrityProtectionAlgorithms),
        (u'eUTRAencryptionAlgorithms', _UESecurityCapabilities_eUTRAencryptionAlgorithms),
        (u'eUTRAintegrityProtectionAlgorithms', _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms),
        (u'iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name=u'UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-UP-CIoT-Support >-----#
    UE_UP_CIoT_Support = ENUM(name=u'UE-UP-CIoT-Support', mode=MODE_TYPE)
    UE_UP_CIoT_Support._cont = ASN1Dict([(u'supported', 0)])
    UE_UP_CIoT_Support._ext = []
    
    #-----< UL-CP-SecurityInformation >-----#
    UL_CP_SecurityInformation = SEQ(name=u'UL-CP-SecurityInformation', mode=MODE_TYPE)
    _UL_CP_SecurityInformation_ul_NAS_MAC = BIT_STR(name=u'ul-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UL-NAS-MAC')))
    _UL_CP_SecurityInformation_ul_NAS_Count = BIT_STR(name=u'ul-NAS-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UL-NAS-Count')))
    _UL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UL_CP_SecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CP_SecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___UL_CP_SecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _UL_CP_SecurityInformation_iE_Extensions._cont = __UL_CP_SecurityInformation_iE_Extensions__item_
    _UL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CP_SecurityInformation._cont = ASN1Dict([
        (u'ul-NAS-MAC', _UL_CP_SecurityInformation_ul_NAS_MAC),
        (u'ul-NAS-Count', _UL_CP_SecurityInformation_ul_NAS_Count),
        (u'iE-Extensions', _UL_CP_SecurityInformation_iE_Extensions),
        ])
    UL_CP_SecurityInformation._ext = []
    
    #-----< UL-CP-SecurityInformation-ExtIEs >-----#
    UL_CP_SecurityInformation_ExtIEs = CLASS(name=u'UL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-NAS-MAC >-----#
    UL_NAS_MAC = BIT_STR(name=u'UL-NAS-MAC', mode=MODE_TYPE)
    UL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UL-NAS-Count >-----#
    UL_NAS_Count = BIT_STR(name=u'UL-NAS-Count', mode=MODE_TYPE)
    UL_NAS_Count._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< UL-NGU-UP-TNLModifyList >-----#
    UL_NGU_UP_TNLModifyList = SEQ_OF(name=u'UL-NGU-UP-TNLModifyList', mode=MODE_TYPE)
    _UL_NGU_UP_TNLModifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyItem')))
    UL_NGU_UP_TNLModifyList._cont = _UL_NGU_UP_TNLModifyList__item_
    UL_NGU_UP_TNLModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UL-NGU-UP-TNLModifyItem >-----#
    UL_NGU_UP_TNLModifyItem = SEQ(name=u'UL-NGU-UP-TNLModifyItem', mode=MODE_TYPE)
    _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation = CHOICE(name=u'uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation = CHOICE(name=u'dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id),
        (u'criticality', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue),
        ])
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_._ext = None
    _UL_NGU_UP_TNLModifyItem_iE_Extensions._cont = __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_
    _UL_NGU_UP_TNLModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_NGU_UP_TNLModifyItem._cont = ASN1Dict([
        (u'uL-NGU-UP-TNLInformation', _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation),
        (u'dL-NGU-UP-TNLInformation', _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation),
        (u'iE-Extensions', _UL_NGU_UP_TNLModifyItem_iE_Extensions),
        ])
    UL_NGU_UP_TNLModifyItem._ext = []
    
    #-----< UL-NGU-UP-TNLModifyItem-ExtIEs >-----#
    UL_NGU_UP_TNLModifyItem_ExtIEs = CLASS(name=u'UL-NGU-UP-TNLModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    UL_NGU_UP_TNLModifyItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'ignore'), (u'Extension', _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Extension', _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UnavailableGUAMIList >-----#
    UnavailableGUAMIList = SEQ_OF(name=u'UnavailableGUAMIList', mode=MODE_TYPE)
    _UnavailableGUAMIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIItem')))
    UnavailableGUAMIList._cont = _UnavailableGUAMIList__item_
    UnavailableGUAMIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UnavailableGUAMIItem >-----#
    UnavailableGUAMIItem = SEQ(name=u'UnavailableGUAMIItem', mode=MODE_TYPE)
    _UnavailableGUAMIItem_gUAMI = SEQ(name=u'gUAMI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _UnavailableGUAMIItem_timerApproachForGUAMIRemoval = ENUM(name=u'timerApproachForGUAMIRemoval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimerApproachForGUAMIRemoval')), opt=True)
    _UnavailableGUAMIItem_backupAMFName = STR_PRINT(name=u'backupAMFName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFName')), opt=True)
    _UnavailableGUAMIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnavailableGUAMIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UnavailableGUAMIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UnavailableGUAMIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__id_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab_at = None
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UnavailableGUAMIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UnavailableGUAMIItem_iE_Extensions__item__id),
        (u'criticality', ___UnavailableGUAMIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue),
        ])
    __UnavailableGUAMIItem_iE_Extensions__item_._ext = None
    _UnavailableGUAMIItem_iE_Extensions._cont = __UnavailableGUAMIItem_iE_Extensions__item_
    _UnavailableGUAMIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnavailableGUAMIItem._cont = ASN1Dict([
        (u'gUAMI', _UnavailableGUAMIItem_gUAMI),
        (u'timerApproachForGUAMIRemoval', _UnavailableGUAMIItem_timerApproachForGUAMIRemoval),
        (u'backupAMFName', _UnavailableGUAMIItem_backupAMFName),
        (u'iE-Extensions', _UnavailableGUAMIItem_iE_Extensions),
        ])
    UnavailableGUAMIItem._ext = []
    
    #-----< UnavailableGUAMIItem-ExtIEs >-----#
    UnavailableGUAMIItem_ExtIEs = CLASS(name=u'UnavailableGUAMIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UnavailableGUAMIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULForwarding >-----#
    ULForwarding = ENUM(name=u'ULForwarding', mode=MODE_TYPE)
    ULForwarding._cont = ASN1Dict([(u'ul-forwarding-proposed', 0)])
    ULForwarding._ext = []
    
    #-----< UpdateFeedback >-----#
    UpdateFeedback = BIT_STR(name=u'UpdateFeedback', mode=MODE_TYPE)
    UpdateFeedback._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformation >-----#
    UPTransportLayerInformation = CHOICE(name=u'UPTransportLayerInformation', mode=MODE_TYPE)
    _UPTransportLayerInformation_gTPTunnel = SEQ(name=u'gTPTunnel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GTPTunnel')))
    _UPTransportLayerInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UPTransportLayerInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UPTransportLayerInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_id._const_tab = ___UPTransportLayerInformation_choice_Extensions_id_tab
    __UPTransportLayerInformation_choice_Extensions_id._const_tab_at = None
    __UPTransportLayerInformation_choice_Extensions_id._const_tab_id = u'id'
    __UPTransportLayerInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UPTransportLayerInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab = ___UPTransportLayerInformation_choice_Extensions_criticality_tab
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UPTransportLayerInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UPTransportLayerInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_value._const_tab = ___UPTransportLayerInformation_choice_Extensions_value_tab
    __UPTransportLayerInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UPTransportLayerInformation_choice_Extensions_value._const_tab_id = u'Value'
    _UPTransportLayerInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __UPTransportLayerInformation_choice_Extensions_id),
        (u'criticality', __UPTransportLayerInformation_choice_Extensions_criticality),
        (u'value', __UPTransportLayerInformation_choice_Extensions_value),
        ])
    _UPTransportLayerInformation_choice_Extensions._ext = None
    UPTransportLayerInformation._cont = ASN1Dict([
        (u'gTPTunnel', _UPTransportLayerInformation_gTPTunnel),
        (u'choice-Extensions', _UPTransportLayerInformation_choice_Extensions),
        ])
    UPTransportLayerInformation._ext = None
    
    #-----< UPTransportLayerInformation-ExtIEs >-----#
    UPTransportLayerInformation_ExtIEs = CLASS(name=u'UPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformationList >-----#
    UPTransportLayerInformationList = SEQ_OF(name=u'UPTransportLayerInformationList', mode=MODE_TYPE)
    _UPTransportLayerInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationItem')))
    UPTransportLayerInformationList._cont = _UPTransportLayerInformationList__item_
    UPTransportLayerInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< UPTransportLayerInformationItem >-----#
    UPTransportLayerInformationItem = SEQ(name=u'UPTransportLayerInformationItem', mode=MODE_TYPE)
    _UPTransportLayerInformationItem_nGU_UP_TNLInformation = CHOICE(name=u'nGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPTransportLayerInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UPTransportLayerInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UPTransportLayerInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UPTransportLayerInformationItem_iE_Extensions__item__id),
        (u'criticality', ___UPTransportLayerInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue),
        ])
    __UPTransportLayerInformationItem_iE_Extensions__item_._ext = None
    _UPTransportLayerInformationItem_iE_Extensions._cont = __UPTransportLayerInformationItem_iE_Extensions__item_
    _UPTransportLayerInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPTransportLayerInformationItem._cont = ASN1Dict([
        (u'nGU-UP-TNLInformation', _UPTransportLayerInformationItem_nGU_UP_TNLInformation),
        (u'iE-Extensions', _UPTransportLayerInformationItem_iE_Extensions),
        ])
    UPTransportLayerInformationItem._ext = []
    
    #-----< UPTransportLayerInformationItem-ExtIEs >-----#
    UPTransportLayerInformationItem_ExtIEs = CLASS(name=u'UPTransportLayerInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UPTransportLayerInformationItem_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    UPTransportLayerInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _UPTransportLayerInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformationPairList >-----#
    UPTransportLayerInformationPairList = SEQ_OF(name=u'UPTransportLayerInformationPairList', mode=MODE_TYPE)
    _UPTransportLayerInformationPairList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairItem')))
    UPTransportLayerInformationPairList._cont = _UPTransportLayerInformationPairList__item_
    UPTransportLayerInformationPairList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< UPTransportLayerInformationPairItem >-----#
    UPTransportLayerInformationPairItem = SEQ(name=u'UPTransportLayerInformationPairItem', mode=MODE_TYPE)
    _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation = CHOICE(name=u'uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation = CHOICE(name=u'dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationPairItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPTransportLayerInformationPairItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab_at = None
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UPTransportLayerInformationPairItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UPTransportLayerInformationPairItem_iE_Extensions__item__id),
        (u'criticality', ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue),
        ])
    __UPTransportLayerInformationPairItem_iE_Extensions__item_._ext = None
    _UPTransportLayerInformationPairItem_iE_Extensions._cont = __UPTransportLayerInformationPairItem_iE_Extensions__item_
    _UPTransportLayerInformationPairItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPTransportLayerInformationPairItem._cont = ASN1Dict([
        (u'uL-NGU-UP-TNLInformation', _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation),
        (u'dL-NGU-UP-TNLInformation', _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation),
        (u'iE-Extensions', _UPTransportLayerInformationPairItem_iE_Extensions),
        ])
    UPTransportLayerInformationPairItem._ext = []
    
    #-----< UPTransportLayerInformationPairItem-ExtIEs >-----#
    UPTransportLayerInformationPairItem_ExtIEs = CLASS(name=u'UPTransportLayerInformationPairItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UPTransportLayerInformationPairItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< URI-address >-----#
    URI_address = STR_VIS(name=u'URI-address', mode=MODE_TYPE)
    
    #-----< UserLocationInformation >-----#
    UserLocationInformation = CHOICE(name=u'UserLocationInformation', mode=MODE_TYPE)
    _UserLocationInformation_userLocationInformationEUTRA = SEQ(name=u'userLocationInformationEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationEUTRA')))
    _UserLocationInformation_userLocationInformationNR = SEQ(name=u'userLocationInformationNR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationNR')))
    _UserLocationInformation_userLocationInformationN3IWF = SEQ(name=u'userLocationInformationN3IWF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationN3IWF')))
    _UserLocationInformation_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UserLocationInformation_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UserLocationInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTNGF')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTWIF')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationW-AGF')))
    ___UserLocationInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UserLocationInformation_choice_Extensions_id._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_id._const_tab_at = None
    __UserLocationInformation_choice_Extensions_id._const_tab_id = u'id'
    __UserLocationInformation_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __UserLocationInformation_choice_Extensions_criticality._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UserLocationInformation_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UserLocationInformation_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __UserLocationInformation_choice_Extensions_value._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UserLocationInformation_choice_Extensions_value._const_tab_id = u'Value'
    _UserLocationInformation_choice_Extensions._cont = ASN1Dict([
        (u'id', __UserLocationInformation_choice_Extensions_id),
        (u'criticality', __UserLocationInformation_choice_Extensions_criticality),
        (u'value', __UserLocationInformation_choice_Extensions_value),
        ])
    _UserLocationInformation_choice_Extensions._ext = None
    UserLocationInformation._cont = ASN1Dict([
        (u'userLocationInformationEUTRA', _UserLocationInformation_userLocationInformationEUTRA),
        (u'userLocationInformationNR', _UserLocationInformation_userLocationInformationNR),
        (u'userLocationInformationN3IWF', _UserLocationInformation_userLocationInformationN3IWF),
        (u'choice-Extensions', _UserLocationInformation_choice_Extensions),
        ])
    UserLocationInformation._ext = None
    
    #-----< UserLocationInformation-ExtIEs >-----#
    UserLocationInformation_ExtIEs = CLASS(name=u'UserLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UserLocationInformation_ExtIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTNGF')))
    _UserLocationInformation_ExtIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTWIF')))
    _UserLocationInformation_ExtIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationW-AGF')))
    UserLocationInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', _UserLocationInformation_ExtIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _UserLocationInformation_ExtIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _UserLocationInformation_ExtIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationEUTRA >-----#
    UserLocationInformationEUTRA = SEQ(name=u'UserLocationInformationEUTRA', mode=MODE_TYPE)
    _UserLocationInformationEUTRA_eUTRA_CGI = SEQ(name=u'eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _UserLocationInformationEUTRA_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _UserLocationInformationEUTRA_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeStamp')), opt=True)
    _UserLocationInformationEUTRA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationEUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationEUTRA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformationEUTRA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformationEUTRA_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformationEUTRA_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationEUTRA_iE_Extensions__item_._ext = None
    _UserLocationInformationEUTRA_iE_Extensions._cont = __UserLocationInformationEUTRA_iE_Extensions__item_
    _UserLocationInformationEUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationEUTRA._cont = ASN1Dict([
        (u'eUTRA-CGI', _UserLocationInformationEUTRA_eUTRA_CGI),
        (u'tAI', _UserLocationInformationEUTRA_tAI),
        (u'timeStamp', _UserLocationInformationEUTRA_timeStamp),
        (u'iE-Extensions', _UserLocationInformationEUTRA_iE_Extensions),
        ])
    UserLocationInformationEUTRA._ext = []
    
    #-----< UserLocationInformationEUTRA-ExtIEs >-----#
    UserLocationInformationEUTRA_ExtIEs = CLASS(name=u'UserLocationInformationEUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationEUTRA_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    UserLocationInformationEUTRA_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _UserLocationInformationEUTRA_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationN3IWF >-----#
    UserLocationInformationN3IWF = SEQ(name=u'UserLocationInformationN3IWF', mode=MODE_TYPE)
    _UserLocationInformationN3IWF_iPAddress = BIT_STR(name=u'iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationN3IWF_portNumber = OCT_STR(name=u'portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')))
    _UserLocationInformationN3IWF_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationN3IWF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationN3IWF_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UserLocationInformationN3IWF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationN3IWF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__criticality_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UserLocationInformationN3IWF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationN3IWF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__extensionValue_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformationN3IWF_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformationN3IWF_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformationN3IWF_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationN3IWF_iE_Extensions__item_._ext = None
    _UserLocationInformationN3IWF_iE_Extensions._cont = __UserLocationInformationN3IWF_iE_Extensions__item_
    _UserLocationInformationN3IWF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationN3IWF._cont = ASN1Dict([
        (u'iPAddress', _UserLocationInformationN3IWF_iPAddress),
        (u'portNumber', _UserLocationInformationN3IWF_portNumber),
        (u'iE-Extensions', _UserLocationInformationN3IWF_iE_Extensions),
        ])
    UserLocationInformationN3IWF._ext = []
    
    #-----< UserLocationInformationN3IWF-ExtIEs >-----#
    UserLocationInformationN3IWF_ExtIEs = CLASS(name=u'UserLocationInformationN3IWF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UserLocationInformationN3IWF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationTNGF >-----#
    UserLocationInformationTNGF = SEQ(name=u'UserLocationInformationTNGF', mode=MODE_TYPE)
    _UserLocationInformationTNGF_tNAP_ID = OCT_STR(name=u'tNAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNAP-ID')))
    _UserLocationInformationTNGF_iPAddress = BIT_STR(name=u'iPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationTNGF_portNumber = OCT_STR(name=u'portNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')), opt=True)
    _UserLocationInformationTNGF_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationTNGF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationTNGF_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformationTNGF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTNGF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__id_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UserLocationInformationTNGF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTNGF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__criticality_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UserLocationInformationTNGF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTNGF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__extensionValue_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformationTNGF_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformationTNGF_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformationTNGF_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationTNGF_iE_Extensions__item_._ext = None
    _UserLocationInformationTNGF_iE_Extensions._cont = __UserLocationInformationTNGF_iE_Extensions__item_
    _UserLocationInformationTNGF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationTNGF._cont = ASN1Dict([
        (u'tNAP-ID', _UserLocationInformationTNGF_tNAP_ID),
        (u'iPAddress', _UserLocationInformationTNGF_iPAddress),
        (u'portNumber', _UserLocationInformationTNGF_portNumber),
        (u'iE-Extensions', _UserLocationInformationTNGF_iE_Extensions),
        ])
    UserLocationInformationTNGF._ext = []
    
    #-----< UserLocationInformationTNGF-ExtIEs >-----#
    UserLocationInformationTNGF_ExtIEs = CLASS(name=u'UserLocationInformationTNGF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UserLocationInformationTNGF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationTWIF >-----#
    UserLocationInformationTWIF = SEQ(name=u'UserLocationInformationTWIF', mode=MODE_TYPE)
    _UserLocationInformationTWIF_tWAP_ID = OCT_STR(name=u'tWAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TWAP-ID')))
    _UserLocationInformationTWIF_iPAddress = BIT_STR(name=u'iPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationTWIF_portNumber = OCT_STR(name=u'portNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')), opt=True)
    _UserLocationInformationTWIF_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationTWIF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationTWIF_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformationTWIF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTWIF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__id_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UserLocationInformationTWIF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTWIF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__criticality_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UserLocationInformationTWIF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserLocationInformationTWIF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__extensionValue_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformationTWIF_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformationTWIF_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformationTWIF_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationTWIF_iE_Extensions__item_._ext = None
    _UserLocationInformationTWIF_iE_Extensions._cont = __UserLocationInformationTWIF_iE_Extensions__item_
    _UserLocationInformationTWIF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationTWIF._cont = ASN1Dict([
        (u'tWAP-ID', _UserLocationInformationTWIF_tWAP_ID),
        (u'iPAddress', _UserLocationInformationTWIF_iPAddress),
        (u'portNumber', _UserLocationInformationTWIF_portNumber),
        (u'iE-Extensions', _UserLocationInformationTWIF_iE_Extensions),
        ])
    UserLocationInformationTWIF._ext = []
    
    #-----< UserLocationInformationTWIF-ExtIEs >-----#
    UserLocationInformationTWIF_ExtIEs = CLASS(name=u'UserLocationInformationTWIF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UserLocationInformationTWIF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationW-AGF >-----#
    UserLocationInformationW_AGF = CHOICE(name=u'UserLocationInformationW-AGF', mode=MODE_TYPE)
    _UserLocationInformationW_AGF_globalLine_ID = SEQ(name=u'globalLine-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalLine-ID')))
    _UserLocationInformationW_AGF_hFCNode_ID = OCT_STR(name=u'hFCNode-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'HFCNode-ID')))
    _UserLocationInformationW_AGF_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UserLocationInformationW_AGF_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___UserLocationInformationW_AGF_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID')))
    ___UserLocationInformationW_AGF_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab_at = None
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab_id = u'id'
    __UserLocationInformationW_AGF_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab_id = u'criticality'
    __UserLocationInformationW_AGF_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab_at = ('..', u'id')
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab_id = u'Value'
    _UserLocationInformationW_AGF_choice_Extensions._cont = ASN1Dict([
        (u'id', __UserLocationInformationW_AGF_choice_Extensions_id),
        (u'criticality', __UserLocationInformationW_AGF_choice_Extensions_criticality),
        (u'value', __UserLocationInformationW_AGF_choice_Extensions_value),
        ])
    _UserLocationInformationW_AGF_choice_Extensions._ext = None
    UserLocationInformationW_AGF._cont = ASN1Dict([
        (u'globalLine-ID', _UserLocationInformationW_AGF_globalLine_ID),
        (u'hFCNode-ID', _UserLocationInformationW_AGF_hFCNode_ID),
        (u'choice-Extensions', _UserLocationInformationW_AGF_choice_Extensions),
        ])
    UserLocationInformationW_AGF._ext = None
    
    #-----< UserLocationInformationW-AGF-ExtIEs >-----#
    UserLocationInformationW_AGF_ExtIEs = CLASS(name=u'UserLocationInformationW-AGF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UserLocationInformationW_AGF_ExtIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID')))
    UserLocationInformationW_AGF_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', _UserLocationInformationW_AGF_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationNR >-----#
    UserLocationInformationNR = SEQ(name=u'UserLocationInformationNR', mode=MODE_TYPE)
    _UserLocationInformationNR_nR_CGI = SEQ(name=u'nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _UserLocationInformationNR_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _UserLocationInformationNR_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeStamp')), opt=True)
    _UserLocationInformationNR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationNR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationNR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformationNR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    ____UserLocationInformationNR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'reject'), (u'Extension', _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformationNR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformationNR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformationNR_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformationNR_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformationNR_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationNR_iE_Extensions__item_._ext = None
    _UserLocationInformationNR_iE_Extensions._cont = __UserLocationInformationNR_iE_Extensions__item_
    _UserLocationInformationNR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationNR._cont = ASN1Dict([
        (u'nR-CGI', _UserLocationInformationNR_nR_CGI),
        (u'tAI', _UserLocationInformationNR_tAI),
        (u'timeStamp', _UserLocationInformationNR_timeStamp),
        (u'iE-Extensions', _UserLocationInformationNR_iE_Extensions),
        ])
    UserLocationInformationNR._ext = []
    
    #-----< UserLocationInformationNR-ExtIEs >-----#
    UserLocationInformationNR_ExtIEs = CLASS(name=u'UserLocationInformationNR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationNR_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _UserLocationInformationNR_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    UserLocationInformationNR_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _UserLocationInformationNR_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'reject'), (u'Extension', _UserLocationInformationNR_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserPlaneSecurityInformation >-----#
    UserPlaneSecurityInformation = SEQ(name=u'UserPlaneSecurityInformation', mode=MODE_TYPE)
    _UserPlaneSecurityInformation_securityResult = SEQ(name=u'securityResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _UserPlaneSecurityInformation_securityIndication = SEQ(name=u'securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _UserPlaneSecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserPlaneSecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserPlaneSecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserPlaneSecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserPlaneSecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___UserPlaneSecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UserPlaneSecurityInformation_iE_Extensions__item_._ext = None
    _UserPlaneSecurityInformation_iE_Extensions._cont = __UserPlaneSecurityInformation_iE_Extensions__item_
    _UserPlaneSecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserPlaneSecurityInformation._cont = ASN1Dict([
        (u'securityResult', _UserPlaneSecurityInformation_securityResult),
        (u'securityIndication', _UserPlaneSecurityInformation_securityIndication),
        (u'iE-Extensions', _UserPlaneSecurityInformation_iE_Extensions),
        ])
    UserPlaneSecurityInformation._ext = []
    
    #-----< UserPlaneSecurityInformation-ExtIEs >-----#
    UserPlaneSecurityInformation_ExtIEs = CLASS(name=u'UserPlaneSecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UserPlaneSecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VolumeTimedReportList >-----#
    VolumeTimedReportList = SEQ_OF(name=u'VolumeTimedReportList', mode=MODE_TYPE)
    _VolumeTimedReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReport-Item')))
    VolumeTimedReportList._cont = _VolumeTimedReportList__item_
    VolumeTimedReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< VolumeTimedReport-Item >-----#
    VolumeTimedReport_Item = SEQ(name=u'VolumeTimedReport-Item', mode=MODE_TYPE)
    _VolumeTimedReport_Item_startTimeStamp = OCT_STR(name=u'startTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_startTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _VolumeTimedReport_Item_endTimeStamp = OCT_STR(name=u'endTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_endTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _VolumeTimedReport_Item_usageCountUL = INT(name=u'usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _VolumeTimedReport_Item_usageCountDL = INT(name=u'usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _VolumeTimedReport_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __VolumeTimedReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___VolumeTimedReport_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____VolumeTimedReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__id_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __VolumeTimedReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___VolumeTimedReport_Item_iE_Extensions__item__id),
        (u'criticality', ___VolumeTimedReport_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue),
        ])
    __VolumeTimedReport_Item_iE_Extensions__item_._ext = None
    _VolumeTimedReport_Item_iE_Extensions._cont = __VolumeTimedReport_Item_iE_Extensions__item_
    _VolumeTimedReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    VolumeTimedReport_Item._cont = ASN1Dict([
        (u'startTimeStamp', _VolumeTimedReport_Item_startTimeStamp),
        (u'endTimeStamp', _VolumeTimedReport_Item_endTimeStamp),
        (u'usageCountUL', _VolumeTimedReport_Item_usageCountUL),
        (u'usageCountDL', _VolumeTimedReport_Item_usageCountDL),
        (u'iE-Extensions', _VolumeTimedReport_Item_iE_Extensions),
        ])
    VolumeTimedReport_Item._ext = []
    
    #-----< VolumeTimedReport-Item-ExtIEs >-----#
    VolumeTimedReport_Item_ExtIEs = CLASS(name=u'VolumeTimedReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    VolumeTimedReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< W-AGF-ID >-----#
    W_AGF_ID = CHOICE(name=u'W-AGF-ID', mode=MODE_TYPE)
    _W_AGF_ID_w_AGF_ID = BIT_STR(name=u'w-AGF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _W_AGF_ID_w_AGF_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    _W_AGF_ID_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __W_AGF_ID_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___W_AGF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_id._const_tab = ___W_AGF_ID_choice_Extensions_id_tab
    __W_AGF_ID_choice_Extensions_id._const_tab_at = None
    __W_AGF_ID_choice_Extensions_id._const_tab_id = u'id'
    __W_AGF_ID_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___W_AGF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_criticality._const_tab = ___W_AGF_ID_choice_Extensions_criticality_tab
    __W_AGF_ID_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __W_AGF_ID_choice_Extensions_criticality._const_tab_id = u'criticality'
    __W_AGF_ID_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___W_AGF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_value._const_tab = ___W_AGF_ID_choice_Extensions_value_tab
    __W_AGF_ID_choice_Extensions_value._const_tab_at = ('..', u'id')
    __W_AGF_ID_choice_Extensions_value._const_tab_id = u'Value'
    _W_AGF_ID_choice_Extensions._cont = ASN1Dict([
        (u'id', __W_AGF_ID_choice_Extensions_id),
        (u'criticality', __W_AGF_ID_choice_Extensions_criticality),
        (u'value', __W_AGF_ID_choice_Extensions_value),
        ])
    _W_AGF_ID_choice_Extensions._ext = None
    W_AGF_ID._cont = ASN1Dict([
        (u'w-AGF-ID', _W_AGF_ID_w_AGF_ID),
        (u'choice-Extensions', _W_AGF_ID_choice_Extensions),
        ])
    W_AGF_ID._ext = None
    
    #-----< W-AGF-ID-ExtIEs >-----#
    W_AGF_ID_ExtIEs = CLASS(name=u'W-AGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    W_AGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WarningAreaCoordinates >-----#
    WarningAreaCoordinates = OCT_STR(name=u'WarningAreaCoordinates', mode=MODE_TYPE)
    WarningAreaCoordinates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< WarningAreaList >-----#
    WarningAreaList = CHOICE(name=u'WarningAreaList', mode=MODE_TYPE)
    _WarningAreaList_eUTRA_CGIListForWarning = SEQ_OF(name=u'eUTRA-CGIListForWarning', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIListForWarning')))
    _WarningAreaList_nR_CGIListForWarning = SEQ_OF(name=u'nR-CGIListForWarning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIListForWarning')))
    _WarningAreaList_tAIListForWarning = SEQ_OF(name=u'tAIListForWarning', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListForWarning')))
    _WarningAreaList_emergencyAreaIDList = SEQ_OF(name=u'emergencyAreaIDList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDList')))
    _WarningAreaList_choice_Extensions = SEQ(name=u'choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __WarningAreaList_choice_Extensions_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ___WarningAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_id._const_tab = ___WarningAreaList_choice_Extensions_id_tab
    __WarningAreaList_choice_Extensions_id._const_tab_at = None
    __WarningAreaList_choice_Extensions_id._const_tab_id = u'id'
    __WarningAreaList_choice_Extensions_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___WarningAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_criticality._const_tab = ___WarningAreaList_choice_Extensions_criticality_tab
    __WarningAreaList_choice_Extensions_criticality._const_tab_at = ('..', u'id')
    __WarningAreaList_choice_Extensions_criticality._const_tab_id = u'criticality'
    __WarningAreaList_choice_Extensions_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___WarningAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_value._const_tab = ___WarningAreaList_choice_Extensions_value_tab
    __WarningAreaList_choice_Extensions_value._const_tab_at = ('..', u'id')
    __WarningAreaList_choice_Extensions_value._const_tab_id = u'Value'
    _WarningAreaList_choice_Extensions._cont = ASN1Dict([
        (u'id', __WarningAreaList_choice_Extensions_id),
        (u'criticality', __WarningAreaList_choice_Extensions_criticality),
        (u'value', __WarningAreaList_choice_Extensions_value),
        ])
    _WarningAreaList_choice_Extensions._ext = None
    WarningAreaList._cont = ASN1Dict([
        (u'eUTRA-CGIListForWarning', _WarningAreaList_eUTRA_CGIListForWarning),
        (u'nR-CGIListForWarning', _WarningAreaList_nR_CGIListForWarning),
        (u'tAIListForWarning', _WarningAreaList_tAIListForWarning),
        (u'emergencyAreaIDList', _WarningAreaList_emergencyAreaIDList),
        (u'choice-Extensions', _WarningAreaList_choice_Extensions),
        ])
    WarningAreaList._ext = None
    
    #-----< WarningAreaList-ExtIEs >-----#
    WarningAreaList_ExtIEs = CLASS(name=u'WarningAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    WarningAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WarningMessageContents >-----#
    WarningMessageContents = OCT_STR(name=u'WarningMessageContents', mode=MODE_TYPE)
    WarningMessageContents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9600)], ev=None, er=[])
    
    #-----< WarningSecurityInfo >-----#
    WarningSecurityInfo = OCT_STR(name=u'WarningSecurityInfo', mode=MODE_TYPE)
    WarningSecurityInfo._const_sz = ASN1Set(rv=[50], rr=[], ev=None, er=[])
    
    #-----< WarningType >-----#
    WarningType = OCT_STR(name=u'WarningType', mode=MODE_TYPE)
    WarningType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< WLANMeasurementConfiguration >-----#
    WLANMeasurementConfiguration = SEQ(name=u'WLANMeasurementConfiguration', mode=MODE_TYPE)
    _WLANMeasurementConfiguration_wlanMeasConfig = ENUM(name=u'wlanMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfig')))
    _WLANMeasurementConfiguration_wlanMeasConfigNameList = SEQ_OF(name=u'wlanMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfigNameList')), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi = ENUM(name=u'wlan-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi._cont = ASN1Dict([(u'true', 0)])
    _WLANMeasurementConfiguration_wlan_rssi._ext = []
    _WLANMeasurementConfiguration_wlan_rtt = ENUM(name=u'wlan-rtt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rtt._cont = ASN1Dict([(u'true', 0)])
    _WLANMeasurementConfiguration_wlan_rtt._ext = []
    _WLANMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___WLANMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementConfiguration_iE_Extensions__item_._ext = None
    _WLANMeasurementConfiguration_iE_Extensions._cont = __WLANMeasurementConfiguration_iE_Extensions__item_
    _WLANMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementConfiguration._cont = ASN1Dict([
        (u'wlanMeasConfig', _WLANMeasurementConfiguration_wlanMeasConfig),
        (u'wlanMeasConfigNameList', _WLANMeasurementConfiguration_wlanMeasConfigNameList),
        (u'wlan-rssi', _WLANMeasurementConfiguration_wlan_rssi),
        (u'wlan-rtt', _WLANMeasurementConfiguration_wlan_rtt),
        (u'iE-Extensions', _WLANMeasurementConfiguration_iE_Extensions),
        ])
    WLANMeasurementConfiguration._ext = []
    
    #-----< WLANMeasurementConfiguration-ExtIEs >-----#
    WLANMeasurementConfiguration_ExtIEs = CLASS(name=u'WLANMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WLANMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfigNameList >-----#
    WLANMeasConfigNameList = SEQ_OF(name=u'WLANMeasConfigNameList', mode=MODE_TYPE)
    _WLANMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfigNameItem')))
    WLANMeasConfigNameList._cont = _WLANMeasConfigNameList__item_
    WLANMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< WLANMeasConfigNameItem >-----#
    WLANMeasConfigNameItem = SEQ(name=u'WLANMeasConfigNameItem', mode=MODE_TYPE)
    _WLANMeasConfigNameItem_wLANName = OCT_STR(name=u'wLANName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANName')))
    _WLANMeasConfigNameItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasConfigNameItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANMeasConfigNameItem_iE_Extensions__item__id),
        (u'criticality', ___WLANMeasConfigNameItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasConfigNameItem_iE_Extensions__item_._ext = None
    _WLANMeasConfigNameItem_iE_Extensions._cont = __WLANMeasConfigNameItem_iE_Extensions__item_
    _WLANMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasConfigNameItem._cont = ASN1Dict([
        (u'wLANName', _WLANMeasConfigNameItem_wLANName),
        (u'iE-Extensions', _WLANMeasConfigNameItem_iE_Extensions),
        ])
    WLANMeasConfigNameItem._ext = []
    
    #-----< WLANMeasConfigNameItem-ExtIEs >-----#
    WLANMeasConfigNameItem_ExtIEs = CLASS(name=u'WLANMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WLANMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfig >-----#
    WLANMeasConfig = ENUM(name=u'WLANMeasConfig', mode=MODE_TYPE)
    WLANMeasConfig._cont = ASN1Dict([(u'setup', 0)])
    WLANMeasConfig._ext = []
    
    #-----< WLANName >-----#
    WLANName = OCT_STR(name=u'WLANName', mode=MODE_TYPE)
    WLANName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WUS-Assistance-Information >-----#
    WUS_Assistance_Information = SEQ(name=u'WUS-Assistance-Information', mode=MODE_TYPE)
    _WUS_Assistance_Information_pagingProbabilityInformation = ENUM(name=u'pagingProbabilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingProbabilityInformation')))
    _WUS_Assistance_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WUS_Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WUS_Assistance_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__id_tab
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___WUS_Assistance_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WUS_Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WUS_Assistance_Information_iE_Extensions__item__id),
        (u'criticality', ___WUS_Assistance_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___WUS_Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __WUS_Assistance_Information_iE_Extensions__item_._ext = None
    _WUS_Assistance_Information_iE_Extensions._cont = __WUS_Assistance_Information_iE_Extensions__item_
    _WUS_Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WUS_Assistance_Information._cont = ASN1Dict([
        (u'pagingProbabilityInformation', _WUS_Assistance_Information_pagingProbabilityInformation),
        (u'iE-Extensions', _WUS_Assistance_Information_iE_Extensions),
        ])
    WUS_Assistance_Information._ext = []
    
    #-----< WUS-Assistance-Information-ExtIEs >-----#
    WUS_Assistance_Information_ExtIEs = CLASS(name=u'WUS-Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WUS_Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< XnExtTLAs >-----#
    XnExtTLAs = SEQ_OF(name=u'XnExtTLAs', mode=MODE_TYPE)
    _XnExtTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'XnExtTLA-Item')))
    XnExtTLAs._cont = _XnExtTLAs__item_
    XnExtTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< XnExtTLA-Item >-----#
    XnExtTLA_Item = SEQ(name=u'XnExtTLA-Item', mode=MODE_TYPE)
    _XnExtTLA_Item_iPsecTLA = BIT_STR(name=u'iPsecTLA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')), opt=True)
    _XnExtTLA_Item_gTP_TLAs = SEQ_OF(name=u'gTP-TLAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnGTP-TLAs')), opt=True)
    _XnExtTLA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __XnExtTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___XnExtTLA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____XnExtTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SCTP-TLAs')))
    ____XnExtTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___XnExtTLA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __XnExtTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___XnExtTLA_Item_iE_Extensions__item__id),
        (u'criticality', ___XnExtTLA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___XnExtTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __XnExtTLA_Item_iE_Extensions__item_._ext = None
    _XnExtTLA_Item_iE_Extensions._cont = __XnExtTLA_Item_iE_Extensions__item_
    _XnExtTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    XnExtTLA_Item._cont = ASN1Dict([
        (u'iPsecTLA', _XnExtTLA_Item_iPsecTLA),
        (u'gTP-TLAs', _XnExtTLA_Item_gTP_TLAs),
        (u'iE-Extensions', _XnExtTLA_Item_iE_Extensions),
        ])
    XnExtTLA_Item._ext = []
    
    #-----< XnExtTLA-Item-ExtIEs >-----#
    XnExtTLA_Item_ExtIEs = CLASS(name=u'XnExtTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _XnExtTLA_Item_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SCTP-TLAs')))
    XnExtTLA_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _XnExtTLA_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< XnGTP-TLAs >-----#
    XnGTP_TLAs = SEQ_OF(name=u'XnGTP-TLAs', mode=MODE_TYPE)
    _XnGTP_TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    XnGTP_TLAs._cont = _XnGTP_TLAs__item_
    XnGTP_TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< XnTLAs >-----#
    XnTLAs = SEQ_OF(name=u'XnTLAs', mode=MODE_TYPE)
    _XnTLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    XnTLAs._cont = _XnTLAs__item_
    XnTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< XnTNLConfigurationInfo >-----#
    XnTNLConfigurationInfo = SEQ(name=u'XnTNLConfigurationInfo', mode=MODE_TYPE)
    _XnTNLConfigurationInfo_xnTransportLayerAddresses = SEQ_OF(name=u'xnTransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTLAs')))
    _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses = SEQ_OF(name=u'xnExtendedTransportLayerAddresses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnExtTLAs')), opt=True)
    _XnTNLConfigurationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __XnTNLConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___XnTNLConfigurationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'id']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __XnTNLConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___XnTNLConfigurationInfo_iE_Extensions__item__id),
        (u'criticality', ___XnTNLConfigurationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __XnTNLConfigurationInfo_iE_Extensions__item_._ext = None
    _XnTNLConfigurationInfo_iE_Extensions._cont = __XnTNLConfigurationInfo_iE_Extensions__item_
    _XnTNLConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    XnTNLConfigurationInfo._cont = ASN1Dict([
        (u'xnTransportLayerAddresses', _XnTNLConfigurationInfo_xnTransportLayerAddresses),
        (u'xnExtendedTransportLayerAddresses', _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses),
        (u'iE-Extensions', _XnTNLConfigurationInfo_iE_Extensions),
        ])
    XnTNLConfigurationInfo._ext = []
    
    #-----< XnTNLConfigurationInfo-ExtIEs >-----#
    XnTNLConfigurationInfo_ExtIEs = CLASS(name=u'XnTNLConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    XnTNLConfigurationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _AdditionalDLUPTNLInformationForHOList__item_,
        AdditionalDLUPTNLInformationForHOList,
        _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation,
        _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList,
        _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation,
        ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab,
        _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue,
        __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_,
        _AdditionalDLUPTNLInformationForHOItem_iE_Extensions,
        AdditionalDLUPTNLInformationForHOItem,
        AdditionalDLUPTNLInformationForHOItem_ExtIEs,
        _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0,
        AdditionalQosFlowInformation,
        _AllocationAndRetentionPriority_priorityLevelARP,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _Allowed_CAG_List_per_PLMN__item_,
        Allowed_CAG_List_per_PLMN,
        _AllowedNSSAI__item_,
        AllowedNSSAI,
        _AllowedNSSAI_Item_s_NSSAI,
        ____AllowedNSSAI_Item_iE_Extensions__item__id_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__id,
        ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__criticality,
        ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue,
        __AllowedNSSAI_Item_iE_Extensions__item_,
        _AllowedNSSAI_Item_iE_Extensions,
        AllowedNSSAI_Item,
        AllowedNSSAI_Item_ExtIEs,
        _Allowed_PNI_NPN_List__item_,
        Allowed_PNI_NPN_List,
        _Allowed_PNI_NPN_Item_pLMNIdentity,
        _Allowed_PNI_NPN_Item_pNI_NPN_restricted,
        _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__id,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue,
        __Allowed_PNI_NPN_Item_iE_Extensions__item_,
        _Allowed_PNI_NPN_Item_iE_Extensions,
        Allowed_PNI_NPN_Item,
        Allowed_PNI_NPN_Item_ExtIEs,
        _AllowedTACs__item_,
        AllowedTACs,
        AlternativeQoSParaSetIndex,
        AlternativeQoSParaSetNotifyIndex,
        _AlternativeQoSParaSetList__item_,
        AlternativeQoSParaSetList,
        _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL,
        _AlternativeQoSParaSetItem_packetDelayBudget,
        _AlternativeQoSParaSetItem_packetErrorRate,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__id,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue,
        __AlternativeQoSParaSetItem_iE_Extensions__item_,
        _AlternativeQoSParaSetItem_iE_Extensions,
        AlternativeQoSParaSetItem,
        AlternativeQoSParaSetItem_ExtIEs,
        AMFName,
        AMFNameVisibleString,
        AMFNameUTF8String,
        _AMFPagingTarget_globalRANNodeID,
        _AMFPagingTarget_tAI,
        ___AMFPagingTarget_choice_Extensions_id_tab,
        __AMFPagingTarget_choice_Extensions_id,
        ___AMFPagingTarget_choice_Extensions_criticality_tab,
        __AMFPagingTarget_choice_Extensions_criticality,
        ___AMFPagingTarget_choice_Extensions_value_tab,
        __AMFPagingTarget_choice_Extensions_value,
        _AMFPagingTarget_choice_Extensions,
        AMFPagingTarget,
        AMFPagingTarget_ExtIEs,
        AMFPointer,
        AMFRegionID,
        AMFSetID,
        _AMF_TNLAssociationSetupList__item_,
        AMF_TNLAssociationSetupList,
        _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationSetupItem_iE_Extensions__item_,
        _AMF_TNLAssociationSetupItem_iE_Extensions,
        AMF_TNLAssociationSetupItem,
        AMF_TNLAssociationSetupItem_ExtIEs,
        _AMF_TNLAssociationToAddList__item_,
        AMF_TNLAssociationToAddList,
        _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress,
        _AMF_TNLAssociationToAddItem_tNLAssociationUsage,
        _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToAddItem_iE_Extensions__item_,
        _AMF_TNLAssociationToAddItem_iE_Extensions,
        AMF_TNLAssociationToAddItem,
        AMF_TNLAssociationToAddItem_ExtIEs,
        _AMF_TNLAssociationToRemoveList__item_,
        AMF_TNLAssociationToRemoveList,
        _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress,
        ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab,
        _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_,
        _AMF_TNLAssociationToRemoveItem_iE_Extensions,
        AMF_TNLAssociationToRemoveItem,
        AMF_TNLAssociationToRemoveItem_ExtIEs,
        _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0,
        _AMF_TNLAssociationToUpdateList__item_,
        AMF_TNLAssociationToUpdateList,
        _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress,
        _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage,
        _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_,
        _AMF_TNLAssociationToUpdateItem_iE_Extensions,
        AMF_TNLAssociationToUpdateItem,
        AMF_TNLAssociationToUpdateItem_ExtIEs,
        AMF_UE_NGAP_ID,
        _AreaOfInterest_areaOfInterestTAIList,
        _AreaOfInterest_areaOfInterestCellList,
        _AreaOfInterest_areaOfInterestRANNodeList,
        ____AreaOfInterest_iE_Extensions__item__id_tab,
        ___AreaOfInterest_iE_Extensions__item__id,
        ____AreaOfInterest_iE_Extensions__item__criticality_tab,
        ___AreaOfInterest_iE_Extensions__item__criticality,
        ____AreaOfInterest_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterest_iE_Extensions__item__extensionValue,
        __AreaOfInterest_iE_Extensions__item_,
        _AreaOfInterest_iE_Extensions,
        AreaOfInterest,
        AreaOfInterest_ExtIEs,
        _AreaOfInterestCellList__item_,
        AreaOfInterestCellList,
        _AreaOfInterestCellItem_nGRAN_CGI,
        ____AreaOfInterestCellItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__id,
        ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__criticality,
        ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestCellItem_iE_Extensions__item_,
        _AreaOfInterestCellItem_iE_Extensions,
        AreaOfInterestCellItem,
        AreaOfInterestCellItem_ExtIEs,
        _AreaOfInterestList__item_,
        AreaOfInterestList,
        _AreaOfInterestItem_areaOfInterest,
        _AreaOfInterestItem_locationReportingReferenceID,
        ____AreaOfInterestItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestItem_iE_Extensions__item__id,
        ____AreaOfInterestItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestItem_iE_Extensions__item__criticality,
        ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestItem_iE_Extensions__item_,
        _AreaOfInterestItem_iE_Extensions,
        AreaOfInterestItem,
        AreaOfInterestItem_ExtIEs,
        _AreaOfInterestRANNodeList__item_,
        AreaOfInterestRANNodeList,
        _AreaOfInterestRANNodeItem_globalRANNodeID,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__id,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestRANNodeItem_iE_Extensions__item_,
        _AreaOfInterestRANNodeItem_iE_Extensions,
        AreaOfInterestRANNodeItem,
        AreaOfInterestRANNodeItem_ExtIEs,
        _AreaOfInterestTAIList__item_,
        AreaOfInterestTAIList,
        _AreaOfInterestTAIItem_tAI,
        ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__id,
        ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__criticality,
        ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestTAIItem_iE_Extensions__item_,
        _AreaOfInterestTAIItem_iE_Extensions,
        AreaOfInterestTAIItem,
        AreaOfInterestTAIItem_ExtIEs,
        _AssistanceDataForPaging_assistanceDataForRecommendedCells,
        _AssistanceDataForPaging_pagingAttemptInformation,
        ____AssistanceDataForPaging_iE_Extensions__item__id_tab,
        _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0,
        _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1,
        ___AssistanceDataForPaging_iE_Extensions__item__id,
        ___AssistanceDataForPaging_iE_Extensions__item__criticality,
        ___AssistanceDataForPaging_iE_Extensions__item__extensionValue,
        __AssistanceDataForPaging_iE_Extensions__item_,
        _AssistanceDataForPaging_iE_Extensions,
        AssistanceDataForPaging,
        AssistanceDataForPaging_ExtIEs,
        _AssistanceDataForPaging_ExtIEs_val_Extension_0,
        _AssistanceDataForPaging_ExtIEs_val_Extension_1,
        _AssistanceDataForRecommendedCells_recommendedCellsForPaging,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__id,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue,
        __AssistanceDataForRecommendedCells_iE_Extensions__item_,
        _AssistanceDataForRecommendedCells_iE_Extensions,
        AssistanceDataForRecommendedCells,
        AssistanceDataForRecommendedCells_ExtIEs,
        _AssociatedQosFlowList__item_,
        AssociatedQosFlowList,
        _AssociatedQosFlowItem_qosFlowIdentifier,
        _AssociatedQosFlowItem_qosFlowMappingIndication,
        ____AssociatedQosFlowItem_iE_Extensions__item__id_tab,
        _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AssociatedQosFlowItem_iE_Extensions__item__id,
        ___AssociatedQosFlowItem_iE_Extensions__item__criticality,
        ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue,
        __AssociatedQosFlowItem_iE_Extensions__item_,
        _AssociatedQosFlowItem_iE_Extensions,
        AssociatedQosFlowItem,
        AssociatedQosFlowItem_ExtIEs,
        _AssociatedQosFlowItem_ExtIEs_val_Extension_0,
        AuthenticatedIndication,
        AveragingWindow,
        _AreaScopeOfMDT_NR_cellBased,
        _AreaScopeOfMDT_NR_tABased,
        _AreaScopeOfMDT_NR_pLMNWide,
        _AreaScopeOfMDT_NR_tAIBased,
        ___AreaScopeOfMDT_NR_choice_Extensions_id_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_id,
        ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_criticality,
        ___AreaScopeOfMDT_NR_choice_Extensions_value_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_value,
        _AreaScopeOfMDT_NR_choice_Extensions,
        AreaScopeOfMDT_NR,
        AreaScopeOfMDT_NR_ExtIEs,
        _AreaScopeOfMDT_EUTRA_cellBased,
        _AreaScopeOfMDT_EUTRA_tABased,
        _AreaScopeOfMDT_EUTRA_pLMNWide,
        _AreaScopeOfMDT_EUTRA_tAIBased,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_id,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_value,
        _AreaScopeOfMDT_EUTRA_choice_Extensions,
        AreaScopeOfMDT_EUTRA,
        AreaScopeOfMDT_EUTRA_ExtIEs,
        _AreaScopeOfNeighCellsList__item_,
        AreaScopeOfNeighCellsList,
        _AreaScopeOfNeighCellsItem_nrFrequencyInfo,
        _AreaScopeOfNeighCellsItem_pciListForMDT,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue,
        __AreaScopeOfNeighCellsItem_iE_Extensions__item_,
        _AreaScopeOfNeighCellsItem_iE_Extensions,
        AreaScopeOfNeighCellsItem,
        AreaScopeOfNeighCellsItem_ExtIEs,
        BitRate,
        _BroadcastCancelledAreaList_cellIDCancelledEUTRA,
        _BroadcastCancelledAreaList_tAICancelledEUTRA,
        _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA,
        _BroadcastCancelledAreaList_cellIDCancelledNR,
        _BroadcastCancelledAreaList_tAICancelledNR,
        _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR,
        ___BroadcastCancelledAreaList_choice_Extensions_id_tab,
        __BroadcastCancelledAreaList_choice_Extensions_id,
        ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab,
        __BroadcastCancelledAreaList_choice_Extensions_criticality,
        ___BroadcastCancelledAreaList_choice_Extensions_value_tab,
        __BroadcastCancelledAreaList_choice_Extensions_value,
        _BroadcastCancelledAreaList_choice_Extensions,
        BroadcastCancelledAreaList,
        BroadcastCancelledAreaList_ExtIEs,
        _BroadcastCompletedAreaList_cellIDBroadcastEUTRA,
        _BroadcastCompletedAreaList_tAIBroadcastEUTRA,
        _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA,
        _BroadcastCompletedAreaList_cellIDBroadcastNR,
        _BroadcastCompletedAreaList_tAIBroadcastNR,
        _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR,
        ___BroadcastCompletedAreaList_choice_Extensions_id_tab,
        __BroadcastCompletedAreaList_choice_Extensions_id,
        ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab,
        __BroadcastCompletedAreaList_choice_Extensions_criticality,
        ___BroadcastCompletedAreaList_choice_Extensions_value_tab,
        __BroadcastCompletedAreaList_choice_Extensions_value,
        _BroadcastCompletedAreaList_choice_Extensions,
        BroadcastCompletedAreaList,
        BroadcastCompletedAreaList_ExtIEs,
        _BroadcastPLMNList__item_,
        BroadcastPLMNList,
        _BroadcastPLMNItem_pLMNIdentity,
        _BroadcastPLMNItem_tAISliceSupportList,
        ____BroadcastPLMNItem_iE_Extensions__item__id_tab,
        _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___BroadcastPLMNItem_iE_Extensions__item__id,
        ___BroadcastPLMNItem_iE_Extensions__item__criticality,
        ___BroadcastPLMNItem_iE_Extensions__item__extensionValue,
        __BroadcastPLMNItem_iE_Extensions__item_,
        _BroadcastPLMNItem_iE_Extensions,
        BroadcastPLMNItem,
        BroadcastPLMNItem_ExtIEs,
        _BroadcastPLMNItem_ExtIEs_val_Extension_0,
        _BroadcastPLMNItem_ExtIEs_val_Extension_1,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfig,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList,
        _BluetoothMeasurementConfiguration_bt_rssi,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__id,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __BluetoothMeasurementConfiguration_iE_Extensions__item_,
        _BluetoothMeasurementConfiguration_iE_Extensions,
        BluetoothMeasurementConfiguration,
        BluetoothMeasurementConfiguration_ExtIEs,
        _BluetoothMeasConfigNameList__item_,
        BluetoothMeasConfigNameList,
        _BluetoothMeasConfigNameItem_bluetoothName,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__id,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __BluetoothMeasConfigNameItem_iE_Extensions__item_,
        _BluetoothMeasConfigNameItem_iE_Extensions,
        BluetoothMeasConfigNameItem,
        BluetoothMeasConfigNameItem_ExtIEs,
        BluetoothMeasConfig,
        BluetoothName,
        BurstArrivalTime,
        CAG_ID,
        CancelAllWarningMessages,
        _CancelledCellsInEAI_EUTRA__item_,
        CancelledCellsInEAI_EUTRA,
        _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI,
        _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_,
        _CancelledCellsInEAI_EUTRA_Item_iE_Extensions,
        CancelledCellsInEAI_EUTRA_Item,
        CancelledCellsInEAI_EUTRA_Item_ExtIEs,
        _CancelledCellsInEAI_NR__item_,
        CancelledCellsInEAI_NR,
        _CancelledCellsInEAI_NR_Item_nR_CGI,
        _CancelledCellsInEAI_NR_Item_numberOfBroadcasts,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInEAI_NR_Item_iE_Extensions__item_,
        _CancelledCellsInEAI_NR_Item_iE_Extensions,
        CancelledCellsInEAI_NR_Item,
        CancelledCellsInEAI_NR_Item_ExtIEs,
        _CancelledCellsInTAI_EUTRA__item_,
        CancelledCellsInTAI_EUTRA,
        _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI,
        _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_,
        _CancelledCellsInTAI_EUTRA_Item_iE_Extensions,
        CancelledCellsInTAI_EUTRA_Item,
        CancelledCellsInTAI_EUTRA_Item_ExtIEs,
        _CancelledCellsInTAI_NR__item_,
        CancelledCellsInTAI_NR,
        _CancelledCellsInTAI_NR_Item_nR_CGI,
        _CancelledCellsInTAI_NR_Item_numberOfBroadcasts,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInTAI_NR_Item_iE_Extensions__item_,
        _CancelledCellsInTAI_NR_Item_iE_Extensions,
        CancelledCellsInTAI_NR_Item,
        CancelledCellsInTAI_NR_Item_ExtIEs,
        _CandidateCellList__item_,
        CandidateCellList,
        _CandidateCellItem_candidateCell,
        ____CandidateCellItem_iE_Extensions__item__id_tab,
        ___CandidateCellItem_iE_Extensions__item__id,
        ____CandidateCellItem_iE_Extensions__item__criticality_tab,
        ___CandidateCellItem_iE_Extensions__item__criticality,
        ____CandidateCellItem_iE_Extensions__item__extensionValue_tab,
        ___CandidateCellItem_iE_Extensions__item__extensionValue,
        __CandidateCellItem_iE_Extensions__item_,
        _CandidateCellItem_iE_Extensions,
        CandidateCellItem,
        CandidateCellItem_ExtIEs,
        _CandidateCell_candidateCGI,
        _CandidateCell_candidatePCI,
        ___CandidateCell_choice_Extensions_id_tab,
        __CandidateCell_choice_Extensions_id,
        ___CandidateCell_choice_Extensions_criticality_tab,
        __CandidateCell_choice_Extensions_criticality,
        ___CandidateCell_choice_Extensions_value_tab,
        __CandidateCell_choice_Extensions_value,
        _CandidateCell_choice_Extensions,
        CandidateCell,
        CandidateCell_ExtIEs,
        _CandidateCellID_candidateCellID,
        ____CandidateCellID_iE_Extensions__item__id_tab,
        ___CandidateCellID_iE_Extensions__item__id,
        ____CandidateCellID_iE_Extensions__item__criticality_tab,
        ___CandidateCellID_iE_Extensions__item__criticality,
        ____CandidateCellID_iE_Extensions__item__extensionValue_tab,
        ___CandidateCellID_iE_Extensions__item__extensionValue,
        __CandidateCellID_iE_Extensions__item_,
        _CandidateCellID_iE_Extensions,
        CandidateCellID,
        CandidateCellID_ExtIEs,
        _CandidatePCI_candidatePCI,
        _CandidatePCI_candidateNRARFCN,
        ____CandidatePCI_iE_Extensions__item__id_tab,
        ___CandidatePCI_iE_Extensions__item__id,
        ____CandidatePCI_iE_Extensions__item__criticality_tab,
        ___CandidatePCI_iE_Extensions__item__criticality,
        ____CandidatePCI_iE_Extensions__item__extensionValue_tab,
        ___CandidatePCI_iE_Extensions__item__extensionValue,
        __CandidatePCI_iE_Extensions__item_,
        _CandidatePCI_iE_Extensions,
        CandidatePCI,
        CandidatePCI_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_nas,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_Extensions_id_tab,
        __Cause_choice_Extensions_id,
        ___Cause_choice_Extensions_criticality_tab,
        __Cause_choice_Extensions_criticality,
        ___Cause_choice_Extensions_value_tab,
        __Cause_choice_Extensions_value,
        _Cause_choice_Extensions,
        Cause,
        Cause_ExtIEs,
        CauseMisc,
        CauseNas,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _Cell_CAGInformation_nGRAN_CGI,
        _Cell_CAGInformation_cellCAGList,
        ____Cell_CAGInformation_iE_Extensions__item__id_tab,
        ___Cell_CAGInformation_iE_Extensions__item__id,
        ____Cell_CAGInformation_iE_Extensions__item__criticality_tab,
        ___Cell_CAGInformation_iE_Extensions__item__criticality,
        ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab,
        ___Cell_CAGInformation_iE_Extensions__item__extensionValue,
        __Cell_CAGInformation_iE_Extensions__item_,
        _Cell_CAGInformation_iE_Extensions,
        Cell_CAGInformation,
        Cell_CAGInformation_ExtIEs,
        _CellCAGList__item_,
        CellCAGList,
        _CellIDBroadcastEUTRA__item_,
        CellIDBroadcastEUTRA,
        _CellIDBroadcastEUTRA_Item_eUTRA_CGI,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __CellIDBroadcastEUTRA_Item_iE_Extensions__item_,
        _CellIDBroadcastEUTRA_Item_iE_Extensions,
        CellIDBroadcastEUTRA_Item,
        CellIDBroadcastEUTRA_Item_ExtIEs,
        _CellIDBroadcastNR__item_,
        CellIDBroadcastNR,
        _CellIDBroadcastNR_Item_nR_CGI,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__id,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __CellIDBroadcastNR_Item_iE_Extensions__item_,
        _CellIDBroadcastNR_Item_iE_Extensions,
        CellIDBroadcastNR_Item,
        CellIDBroadcastNR_Item_ExtIEs,
        _CellIDCancelledEUTRA__item_,
        CellIDCancelledEUTRA,
        _CellIDCancelledEUTRA_Item_eUTRA_CGI,
        _CellIDCancelledEUTRA_Item_numberOfBroadcasts,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __CellIDCancelledEUTRA_Item_iE_Extensions__item_,
        _CellIDCancelledEUTRA_Item_iE_Extensions,
        CellIDCancelledEUTRA_Item,
        CellIDCancelledEUTRA_Item_ExtIEs,
        _CellIDCancelledNR__item_,
        CellIDCancelledNR,
        _CellIDCancelledNR_Item_nR_CGI,
        _CellIDCancelledNR_Item_numberOfBroadcasts,
        ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__id,
        ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__criticality,
        ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue,
        __CellIDCancelledNR_Item_iE_Extensions__item_,
        _CellIDCancelledNR_Item_iE_Extensions,
        CellIDCancelledNR_Item,
        CellIDCancelledNR_Item_ExtIEs,
        _CellIDListForRestart_eUTRA_CGIListforRestart,
        _CellIDListForRestart_nR_CGIListforRestart,
        ___CellIDListForRestart_choice_Extensions_id_tab,
        __CellIDListForRestart_choice_Extensions_id,
        ___CellIDListForRestart_choice_Extensions_criticality_tab,
        __CellIDListForRestart_choice_Extensions_criticality,
        ___CellIDListForRestart_choice_Extensions_value_tab,
        __CellIDListForRestart_choice_Extensions_value,
        _CellIDListForRestart_choice_Extensions,
        CellIDListForRestart,
        CellIDListForRestart_ExtIEs,
        CellSize,
        _CellType_cellSize,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        CEmodeBSupport_Indicator,
        CEmodeBrestricted,
        _CNAssistedRANTuning_expectedUEBehaviour,
        ____CNAssistedRANTuning_iE_Extensions__item__id_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__id,
        ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__criticality,
        ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__extensionValue,
        __CNAssistedRANTuning_iE_Extensions__item_,
        _CNAssistedRANTuning_iE_Extensions,
        CNAssistedRANTuning,
        CNAssistedRANTuning_ExtIEs,
        _CNTypeRestrictionsForEquivalent__item_,
        CNTypeRestrictionsForEquivalent,
        _CNTypeRestrictionsForEquivalentItem_plmnIdentity,
        _CNTypeRestrictionsForEquivalentItem_cn_Type,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue,
        __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_,
        _CNTypeRestrictionsForEquivalentItem_iE_Extensions,
        CNTypeRestrictionsForEquivalentItem,
        CNTypeRestrictionsForEquivalentItem_ExtIEs,
        CNTypeRestrictionsForServing,
        CommonNetworkInstance,
        _CompletedCellsInEAI_EUTRA__item_,
        CompletedCellsInEAI_EUTRA,
        _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_,
        _CompletedCellsInEAI_EUTRA_Item_iE_Extensions,
        CompletedCellsInEAI_EUTRA_Item,
        CompletedCellsInEAI_EUTRA_Item_ExtIEs,
        _CompletedCellsInEAI_NR__item_,
        CompletedCellsInEAI_NR,
        _CompletedCellsInEAI_NR_Item_nR_CGI,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInEAI_NR_Item_iE_Extensions__item_,
        _CompletedCellsInEAI_NR_Item_iE_Extensions,
        CompletedCellsInEAI_NR_Item,
        CompletedCellsInEAI_NR_Item_ExtIEs,
        _CompletedCellsInTAI_EUTRA__item_,
        CompletedCellsInTAI_EUTRA,
        _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_,
        _CompletedCellsInTAI_EUTRA_Item_iE_Extensions,
        CompletedCellsInTAI_EUTRA_Item,
        CompletedCellsInTAI_EUTRA_Item_ExtIEs,
        _CompletedCellsInTAI_NR__item_,
        CompletedCellsInTAI_NR,
        _CompletedCellsInTAI_NR_Item_nR_CGI,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInTAI_NR_Item_iE_Extensions__item_,
        _CompletedCellsInTAI_NR_Item_iE_Extensions,
        CompletedCellsInTAI_NR_Item,
        CompletedCellsInTAI_NR_Item_ExtIEs,
        ConcurrentWarningMessageInd,
        ConfidentialityProtectionIndication,
        ConfidentialityProtectionResult,
        ConfiguredTACIndication,
        _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue,
        _CoreNetworkAssistanceInformationForInactive_uESpecificDRX,
        _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer,
        _CoreNetworkAssistanceInformationForInactive_mICOModeIndication,
        _CoreNetworkAssistanceInformationForInactive_tAIListForInactive,
        _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour,
        ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue,
        __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_,
        _CoreNetworkAssistanceInformationForInactive_iE_Extensions,
        CoreNetworkAssistanceInformationForInactive,
        CoreNetworkAssistanceInformationForInactive_ExtIEs,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3,
        _COUNTValueForPDCP_SN12_pDCP_SN12,
        _COUNTValueForPDCP_SN12_hFN_PDCP_SN12,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__id,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue,
        __COUNTValueForPDCP_SN12_iE_Extensions__item_,
        _COUNTValueForPDCP_SN12_iE_Extensions,
        COUNTValueForPDCP_SN12,
        COUNTValueForPDCP_SN12_ExtIEs,
        _COUNTValueForPDCP_SN18_pDCP_SN18,
        _COUNTValueForPDCP_SN18_hFN_PDCP_SN18,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__id,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue,
        __COUNTValueForPDCP_SN18_iE_Extensions__item_,
        _COUNTValueForPDCP_SN18_iE_Extensions,
        COUNTValueForPDCP_SN18,
        COUNTValueForPDCP_SN18_ExtIEs,
        CoverageEnhancementLevel,
        _CPTransportLayerInformation_endpointIPAddress,
        ___CPTransportLayerInformation_choice_Extensions_id_tab,
        ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0,
        __CPTransportLayerInformation_choice_Extensions_id,
        __CPTransportLayerInformation_choice_Extensions_criticality,
        __CPTransportLayerInformation_choice_Extensions_value,
        _CPTransportLayerInformation_choice_Extensions,
        CPTransportLayerInformation,
        CPTransportLayerInformation_ExtIEs,
        _CPTransportLayerInformation_ExtIEs_val_Value_0,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        _CellBasedMDT_NR_cellIdListforMDT,
        ____CellBasedMDT_NR_iE_Extensions__item__id_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__id,
        ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__criticality,
        ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__extensionValue,
        __CellBasedMDT_NR_iE_Extensions__item_,
        _CellBasedMDT_NR_iE_Extensions,
        CellBasedMDT_NR,
        CellBasedMDT_NR_ExtIEs,
        _CellIdListforMDT_NR__item_,
        CellIdListforMDT_NR,
        _CellBasedMDT_EUTRA_cellIdListforMDT,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__id,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue,
        __CellBasedMDT_EUTRA_iE_Extensions__item_,
        _CellBasedMDT_EUTRA_iE_Extensions,
        CellBasedMDT_EUTRA,
        CellBasedMDT_EUTRA_ExtIEs,
        _CellIdListforMDT_EUTRA__item_,
        CellIdListforMDT_EUTRA,
        DataCodingScheme,
        DataForwardingAccepted,
        DataForwardingNotPossible,
        _DataForwardingResponseDRBList__item_,
        DataForwardingResponseDRBList,
        _DataForwardingResponseDRBItem_dRB_ID,
        _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation,
        _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__id,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue,
        __DataForwardingResponseDRBItem_iE_Extensions__item_,
        _DataForwardingResponseDRBItem_iE_Extensions,
        DataForwardingResponseDRBItem,
        DataForwardingResponseDRBItem_ExtIEs,
        _DAPSRequestInfo_dAPSIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        _DAPSResponseInfoList__item_,
        DAPSResponseInfoList,
        _DAPSResponseInfoItem_dRB_ID,
        _DAPSResponseInfoItem_dAPSResponseInfo,
        ____DAPSResponseInfoItem_iE_Extension__item__id_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__id,
        ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__criticality,
        ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__extensionValue,
        __DAPSResponseInfoItem_iE_Extension__item_,
        _DAPSResponseInfoItem_iE_Extension,
        DAPSResponseInfoItem,
        DAPSResponseInfoItem_ExtIEs,
        _DAPSResponseInfo_dapsresponseindicator,
        ____DAPSResponseInfo_iE_Extensions__item__id_tab,
        ___DAPSResponseInfo_iE_Extensions__item__id,
        ____DAPSResponseInfo_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfo_iE_Extensions__item__criticality,
        ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfo_iE_Extensions__item__extensionValue,
        __DAPSResponseInfo_iE_Extensions__item_,
        _DAPSResponseInfo_iE_Extensions,
        DAPSResponseInfo,
        DAPSResponseInfo_ExtIEs,
        _DataForwardingResponseERABList__item_,
        DataForwardingResponseERABList,
        _DataForwardingResponseERABListItem_e_RAB_ID,
        _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__id,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue,
        __DataForwardingResponseERABListItem_iE_Extensions__item_,
        _DataForwardingResponseERABListItem_iE_Extensions,
        DataForwardingResponseERABListItem,
        DataForwardingResponseERABListItem_ExtIEs,
        DelayCritical,
        _DL_CP_SecurityInformation_dl_NAS_MAC,
        ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__id,
        ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __DL_CP_SecurityInformation_iE_Extensions__item_,
        _DL_CP_SecurityInformation_iE_Extensions,
        DL_CP_SecurityInformation,
        DL_CP_SecurityInformation_ExtIEs,
        DL_NAS_MAC,
        DLForwarding,
        DL_NGU_TNLInformationReused,
        DirectForwardingPathAvailability,
        DRB_ID,
        _DRBsSubjectToStatusTransferList__item_,
        DRBsSubjectToStatusTransferList,
        _DRBsSubjectToStatusTransferItem_dRB_ID,
        _DRBsSubjectToStatusTransferItem_dRBStatusUL,
        _DRBsSubjectToStatusTransferItem_dRBStatusDL,
        ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab,
        _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue,
        __DRBsSubjectToStatusTransferItem_iE_Extension__item_,
        _DRBsSubjectToStatusTransferItem_iE_Extension,
        DRBsSubjectToStatusTransferItem,
        DRBsSubjectToStatusTransferItem_ExtIEs,
        _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0,
        _DRBStatusDL_dRBStatusDL12,
        _DRBStatusDL_dRBStatusDL18,
        ___DRBStatusDL_choice_Extensions_id_tab,
        __DRBStatusDL_choice_Extensions_id,
        ___DRBStatusDL_choice_Extensions_criticality_tab,
        __DRBStatusDL_choice_Extensions_criticality,
        ___DRBStatusDL_choice_Extensions_value_tab,
        __DRBStatusDL_choice_Extensions_value,
        _DRBStatusDL_choice_Extensions,
        DRBStatusDL,
        DRBStatusDL_ExtIEs,
        _DRBStatusDL12_dL_COUNTValue,
        ____DRBStatusDL12_iE_Extension__item__id_tab,
        ___DRBStatusDL12_iE_Extension__item__id,
        ____DRBStatusDL12_iE_Extension__item__criticality_tab,
        ___DRBStatusDL12_iE_Extension__item__criticality,
        ____DRBStatusDL12_iE_Extension__item__extensionValue_tab,
        ___DRBStatusDL12_iE_Extension__item__extensionValue,
        __DRBStatusDL12_iE_Extension__item_,
        _DRBStatusDL12_iE_Extension,
        DRBStatusDL12,
        DRBStatusDL12_ExtIEs,
        _DRBStatusDL18_dL_COUNTValue,
        ____DRBStatusDL18_iE_Extension__item__id_tab,
        ___DRBStatusDL18_iE_Extension__item__id,
        ____DRBStatusDL18_iE_Extension__item__criticality_tab,
        ___DRBStatusDL18_iE_Extension__item__criticality,
        ____DRBStatusDL18_iE_Extension__item__extensionValue_tab,
        ___DRBStatusDL18_iE_Extension__item__extensionValue,
        __DRBStatusDL18_iE_Extension__item_,
        _DRBStatusDL18_iE_Extension,
        DRBStatusDL18,
        DRBStatusDL18_ExtIEs,
        _DRBStatusUL_dRBStatusUL12,
        _DRBStatusUL_dRBStatusUL18,
        ___DRBStatusUL_choice_Extensions_id_tab,
        __DRBStatusUL_choice_Extensions_id,
        ___DRBStatusUL_choice_Extensions_criticality_tab,
        __DRBStatusUL_choice_Extensions_criticality,
        ___DRBStatusUL_choice_Extensions_value_tab,
        __DRBStatusUL_choice_Extensions_value,
        _DRBStatusUL_choice_Extensions,
        DRBStatusUL,
        DRBStatusUL_ExtIEs,
        _DRBStatusUL12_uL_COUNTValue,
        _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs,
        ____DRBStatusUL12_iE_Extension__item__id_tab,
        ___DRBStatusUL12_iE_Extension__item__id,
        ____DRBStatusUL12_iE_Extension__item__criticality_tab,
        ___DRBStatusUL12_iE_Extension__item__criticality,
        ____DRBStatusUL12_iE_Extension__item__extensionValue_tab,
        ___DRBStatusUL12_iE_Extension__item__extensionValue,
        __DRBStatusUL12_iE_Extension__item_,
        _DRBStatusUL12_iE_Extension,
        DRBStatusUL12,
        DRBStatusUL12_ExtIEs,
        _DRBStatusUL18_uL_COUNTValue,
        _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs,
        ____DRBStatusUL18_iE_Extension__item__id_tab,
        ___DRBStatusUL18_iE_Extension__item__id,
        ____DRBStatusUL18_iE_Extension__item__criticality_tab,
        ___DRBStatusUL18_iE_Extension__item__criticality,
        ____DRBStatusUL18_iE_Extension__item__extensionValue_tab,
        ___DRBStatusUL18_iE_Extension__item__extensionValue,
        __DRBStatusUL18_iE_Extension__item_,
        _DRBStatusUL18_iE_Extension,
        DRBStatusUL18,
        DRBStatusUL18_ExtIEs,
        _DRBsToQosFlowsMappingList__item_,
        DRBsToQosFlowsMappingList,
        _DRBsToQosFlowsMappingItem_dRB_ID,
        _DRBsToQosFlowsMappingItem_associatedQosFlowList,
        ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab,
        _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue,
        __DRBsToQosFlowsMappingItem_iE_Extensions__item_,
        _DRBsToQosFlowsMappingItem_iE_Extensions,
        DRBsToQosFlowsMappingItem,
        DRBsToQosFlowsMappingItem_ExtIEs,
        _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_priorityLevelQos,
        _Dynamic5QIDescriptor_packetDelayBudget,
        _Dynamic5QIDescriptor_packetErrorRate,
        _Dynamic5QIDescriptor_fiveQI,
        _Dynamic5QIDescriptor_delayCritical,
        _Dynamic5QIDescriptor_averagingWindow,
        _Dynamic5QIDescriptor_maximumDataBurstVolume,
        ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2,
        ___Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Dynamic5QIDescriptor_iE_Extensions__item_,
        _Dynamic5QIDescriptor_iE_Extensions,
        Dynamic5QIDescriptor,
        Dynamic5QIDescriptor_ExtIEs,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_2,
        _EarlyStatusTransfer_TransparentContainer_procedureStage,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _EarlyStatusTransfer_TransparentContainer_iE_Extensions,
        EarlyStatusTransfer_TransparentContainer,
        EarlyStatusTransfer_TransparentContainer_ExtIEs,
        _ProcedureStageChoice_first_dl_count,
        ___ProcedureStageChoice_choice_Extensions_id_tab,
        __ProcedureStageChoice_choice_Extensions_id,
        ___ProcedureStageChoice_choice_Extensions_criticality_tab,
        __ProcedureStageChoice_choice_Extensions_criticality,
        ___ProcedureStageChoice_choice_Extensions_value_tab,
        __ProcedureStageChoice_choice_Extensions_value,
        _ProcedureStageChoice_choice_Extensions,
        ProcedureStageChoice,
        ProcedureStageChoice_ExtIEs,
        _FirstDLCount_dRBsSubjectToEarlyStatusTransfer,
        ____FirstDLCount_iE_Extension__item__id_tab,
        ___FirstDLCount_iE_Extension__item__id,
        ____FirstDLCount_iE_Extension__item__criticality_tab,
        ___FirstDLCount_iE_Extension__item__criticality,
        ____FirstDLCount_iE_Extension__item__extensionValue_tab,
        ___FirstDLCount_iE_Extension__item__extensionValue,
        __FirstDLCount_iE_Extension__item_,
        _FirstDLCount_iE_Extension,
        FirstDLCount,
        FirstDLCount_ExtIEs,
        _DRBsSubjectToEarlyStatusTransfer_List__item_,
        DRBsSubjectToEarlyStatusTransfer_List,
        _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID,
        _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue,
        __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_,
        _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension,
        DRBsSubjectToEarlyStatusTransfer_Item,
        DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs,
        EDT_Session,
        EmergencyAreaID,
        _EmergencyAreaIDBroadcastEUTRA__item_,
        EmergencyAreaIDBroadcastEUTRA,
        _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID,
        _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_,
        _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions,
        EmergencyAreaIDBroadcastEUTRA_Item,
        EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs,
        _EmergencyAreaIDBroadcastNR__item_,
        EmergencyAreaIDBroadcastNR,
        _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID,
        _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_,
        _EmergencyAreaIDBroadcastNR_Item_iE_Extensions,
        EmergencyAreaIDBroadcastNR_Item,
        EmergencyAreaIDBroadcastNR_Item_ExtIEs,
        _EmergencyAreaIDCancelledEUTRA__item_,
        EmergencyAreaIDCancelledEUTRA,
        _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID,
        _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_,
        _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions,
        EmergencyAreaIDCancelledEUTRA_Item,
        EmergencyAreaIDCancelledEUTRA_Item_ExtIEs,
        _EmergencyAreaIDCancelledNR__item_,
        EmergencyAreaIDCancelledNR,
        _EmergencyAreaIDCancelledNR_Item_emergencyAreaID,
        _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_,
        _EmergencyAreaIDCancelledNR_Item_iE_Extensions,
        EmergencyAreaIDCancelledNR_Item,
        EmergencyAreaIDCancelledNR_Item_ExtIEs,
        _EmergencyAreaIDList__item_,
        EmergencyAreaIDList,
        _EmergencyAreaIDListForRestart__item_,
        EmergencyAreaIDListForRestart,
        _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator,
        _EmergencyFallbackIndicator_emergencyServiceTargetCN,
        ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__id,
        ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__criticality,
        ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue,
        __EmergencyFallbackIndicator_iE_Extensions__item_,
        _EmergencyFallbackIndicator_iE_Extensions,
        EmergencyFallbackIndicator,
        EmergencyFallbackIndicator_ExtIEs,
        EmergencyFallbackRequestIndicator,
        EmergencyServiceTargetCN,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ___ENB_ID_choice_Extensions_id_tab,
        __ENB_ID_choice_Extensions_id,
        ___ENB_ID_choice_Extensions_criticality_tab,
        __ENB_ID_choice_Extensions_criticality,
        ___ENB_ID_choice_Extensions_value_tab,
        __ENB_ID_choice_Extensions_value,
        _ENB_ID_choice_Extensions,
        ENB_ID,
        ENB_ID_ExtIEs,
        Enhanced_CoverageRestriction,
        Extended_ConnectedTime,
        EN_DCSONConfigurationTransfer,
        _EndpointIPAddressAndPort_endpointIPAddress,
        _EndpointIPAddressAndPort_portNumber,
        ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__id,
        ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__criticality,
        ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue,
        __EndpointIPAddressAndPort_iE_Extensions__item_,
        _EndpointIPAddressAndPort_iE_Extensions,
        EndpointIPAddressAndPort,
        EndIndication,
        EndpointIPAddressAndPort_ExtIEs,
        _EquivalentPLMNs__item_,
        EquivalentPLMNs,
        EPS_TAC,
        _EPS_TAI_pLMNIdentity,
        _EPS_TAI_ePS_TAC,
        ____EPS_TAI_iE_Extensions__item__id_tab,
        ___EPS_TAI_iE_Extensions__item__id,
        ____EPS_TAI_iE_Extensions__item__criticality_tab,
        ___EPS_TAI_iE_Extensions__item__criticality,
        ____EPS_TAI_iE_Extensions__item__extensionValue_tab,
        ___EPS_TAI_iE_Extensions__item__extensionValue,
        __EPS_TAI_iE_Extensions__item_,
        _EPS_TAI_iE_Extensions,
        EPS_TAI,
        EPS_TAI_ExtIEs,
        E_RAB_ID,
        _E_RABInformationList__item_,
        E_RABInformationList,
        _E_RABInformationItem_e_RAB_ID,
        _E_RABInformationItem_dLForwarding,
        ____E_RABInformationItem_iE_Extensions__item__id_tab,
        _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABInformationItem_iE_Extensions__item__id,
        ___E_RABInformationItem_iE_Extensions__item__criticality,
        ___E_RABInformationItem_iE_Extensions__item__extensionValue,
        __E_RABInformationItem_iE_Extensions__item_,
        _E_RABInformationItem_iE_Extensions,
        E_RABInformationItem,
        E_RABInformationItem_ExtIEs,
        _E_RABInformationItem_ExtIEs_val_Extension_0,
        _E_RABInformationItem_ExtIEs_val_Extension_1,
        EUTRACellIdentity,
        _EUTRA_CGI_pLMNIdentity,
        _EUTRA_CGI_eUTRACellIdentity,
        ____EUTRA_CGI_iE_Extensions__item__id_tab,
        ___EUTRA_CGI_iE_Extensions__item__id,
        ____EUTRA_CGI_iE_Extensions__item__criticality_tab,
        ___EUTRA_CGI_iE_Extensions__item__criticality,
        ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_CGI_iE_Extensions__item__extensionValue,
        __EUTRA_CGI_iE_Extensions__item_,
        _EUTRA_CGI_iE_Extensions,
        EUTRA_CGI,
        EUTRA_CGI_ExtIEs,
        _EUTRA_CGIList__item_,
        EUTRA_CGIList,
        _EUTRA_CGIListForWarning__item_,
        EUTRA_CGIListForWarning,
        EUTRAencryptionAlgorithms,
        EUTRAintegrityProtectionAlgorithms,
        EventType,
        ExpectedActivityPeriod,
        ExpectedHOInterval,
        ExpectedIdlePeriod,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        _ExpectedUEBehaviour_expectedUEActivityBehaviour,
        _ExpectedUEBehaviour_expectedHOInterval,
        _ExpectedUEBehaviour_expectedUEMobility,
        _ExpectedUEBehaviour_expectedUEMovingTrajectory,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        ExpectedUEMobility,
        _ExpectedUEMovingTrajectory__item_,
        ExpectedUEMovingTrajectory,
        _ExpectedUEMovingTrajectoryItem_nGRAN_CGI,
        _ExpectedUEMovingTrajectoryItem_timeStayedInCell,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue,
        __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_,
        _ExpectedUEMovingTrajectoryItem_iE_Extensions,
        ExpectedUEMovingTrajectoryItem,
        ExpectedUEMovingTrajectoryItem_ExtIEs,
        _Extended_AMFName_aMFNameVisibleString,
        _Extended_AMFName_aMFNameUTF8String,
        ____Extended_AMFName_iE_Extensions__item__id_tab,
        ___Extended_AMFName_iE_Extensions__item__id,
        ____Extended_AMFName_iE_Extensions__item__criticality_tab,
        ___Extended_AMFName_iE_Extensions__item__criticality,
        ____Extended_AMFName_iE_Extensions__item__extensionValue_tab,
        ___Extended_AMFName_iE_Extensions__item__extensionValue,
        __Extended_AMFName_iE_Extensions__item_,
        _Extended_AMFName_iE_Extensions,
        Extended_AMFName,
        Extended_AMFName_ExtIEs,
        ExtendedPacketDelayBudget,
        _Extended_RANNodeName_rANNodeNameVisibleString,
        _Extended_RANNodeName_rANNodeNameUTF8String,
        ____Extended_RANNodeName_iE_Extensions__item__id_tab,
        ___Extended_RANNodeName_iE_Extensions__item__id,
        ____Extended_RANNodeName_iE_Extensions__item__criticality_tab,
        ___Extended_RANNodeName_iE_Extensions__item__criticality,
        ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab,
        ___Extended_RANNodeName_iE_Extensions__item__extensionValue,
        __Extended_RANNodeName_iE_Extensions__item_,
        _Extended_RANNodeName_iE_Extensions,
        Extended_RANNodeName,
        Extended_RANNodeName_ExtIEs,
        _ExtendedRATRestrictionInformation_primaryRATRestriction,
        _ExtendedRATRestrictionInformation_secondaryRATRestriction,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__id,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue,
        __ExtendedRATRestrictionInformation_iE_Extensions__item_,
        _ExtendedRATRestrictionInformation_iE_Extensions,
        ExtendedRATRestrictionInformation,
        ExtendedRATRestrictionInformation_ExtIEs,
        ExtendedRNC_ID,
        _ExtendedSliceSupportList__item_,
        ExtendedSliceSupportList,
        ExtendedUEIdentityIndexValue,
        _EventTrigger_outOfCoverage,
        _EventTrigger_eventL1LoggedMDTConfig,
        ___EventTrigger_choice_Extensions_id_tab,
        __EventTrigger_choice_Extensions_id,
        ___EventTrigger_choice_Extensions_criticality_tab,
        __EventTrigger_choice_Extensions_criticality,
        ___EventTrigger_choice_Extensions_value_tab,
        __EventTrigger_choice_Extensions_value,
        _EventTrigger_choice_Extensions,
        EventTrigger,
        EventTrigger_ExtIEs,
        _EventL1LoggedMDTConfig_l1Threshold,
        _EventL1LoggedMDTConfig_hysteresis,
        _EventL1LoggedMDTConfig_timeToTrigger,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__id,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue,
        __EventL1LoggedMDTConfig_iE_Extensions__item_,
        _EventL1LoggedMDTConfig_iE_Extensions,
        EventL1LoggedMDTConfig,
        EventL1LoggedMDTConfig_ExtIEs,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRP,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRQ,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_id,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_value,
        _MeasurementThresholdL1LoggedMDT_choice_Extensions,
        MeasurementThresholdL1LoggedMDT,
        MeasurementThresholdL1LoggedMDT_ExtIEs,
        _FailureIndication_uERLFReportContainer,
        ____FailureIndication_iE_Extensions__item__id_tab,
        ___FailureIndication_iE_Extensions__item__id,
        ____FailureIndication_iE_Extensions__item__criticality_tab,
        ___FailureIndication_iE_Extensions__item__criticality,
        ____FailureIndication_iE_Extensions__item__extensionValue_tab,
        ___FailureIndication_iE_Extensions__item__extensionValue,
        __FailureIndication_iE_Extensions__item_,
        _FailureIndication_iE_Extensions,
        FailureIndication,
        FailureIndication_ExtIEs,
        _FiveG_S_TMSI_aMFSetID,
        _FiveG_S_TMSI_aMFPointer,
        _FiveG_S_TMSI_fiveG_TMSI,
        ____FiveG_S_TMSI_iE_Extensions__item__id_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__id,
        ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__criticality,
        ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__extensionValue,
        __FiveG_S_TMSI_iE_Extensions__item_,
        _FiveG_S_TMSI_iE_Extensions,
        FiveG_S_TMSI,
        FiveG_S_TMSI_ExtIEs,
        FiveG_TMSI,
        FiveQI,
        _ForbiddenAreaInformation__item_,
        ForbiddenAreaInformation,
        _ForbiddenAreaInformation_Item_pLMNIdentity,
        _ForbiddenAreaInformation_Item_forbiddenTACs,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__id,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue,
        __ForbiddenAreaInformation_Item_iE_Extensions__item_,
        _ForbiddenAreaInformation_Item_iE_Extensions,
        ForbiddenAreaInformation_Item,
        ForbiddenAreaInformation_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _FromEUTRANtoNGRAN_sourceeNBID,
        _FromEUTRANtoNGRAN_targetNGRANnodeID,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__id,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue,
        __FromEUTRANtoNGRAN_iE_Extensions__item_,
        _FromEUTRANtoNGRAN_iE_Extensions,
        FromEUTRANtoNGRAN,
        FromEUTRANtoNGRAN_ExtIEs,
        _FromNGRANtoEUTRAN_sourceNGRANnodeID,
        _FromNGRANtoEUTRAN_targeteNBID,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__id,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue,
        __FromNGRANtoEUTRAN_iE_Extensions__item_,
        _FromNGRANtoEUTRAN_iE_Extensions,
        FromNGRANtoEUTRAN,
        FromNGRANtoEUTRAN_ExtIEs,
        _GBR_QosInformation_maximumFlowBitRateDL,
        _GBR_QosInformation_maximumFlowBitRateUL,
        _GBR_QosInformation_guaranteedFlowBitRateDL,
        _GBR_QosInformation_guaranteedFlowBitRateUL,
        _GBR_QosInformation_notificationControl,
        _GBR_QosInformation_maximumPacketLossRateDL,
        _GBR_QosInformation_maximumPacketLossRateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QosInformation_ExtIEs_val_Extension_0,
        GlobalCable_ID,
        _GlobalENB_ID_pLMNidentity,
        _GlobalENB_ID_eNB_ID,
        ____GlobalENB_ID_iE_Extensions__item__id_tab,
        ___GlobalENB_ID_iE_Extensions__item__id,
        ____GlobalENB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalENB_ID_iE_Extensions__item__criticality,
        ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalENB_ID_iE_Extensions__item__extensionValue,
        __GlobalENB_ID_iE_Extensions__item_,
        _GlobalENB_ID_iE_Extensions,
        GlobalENB_ID,
        GlobalENB_ID_ExtIEs,
        _GlobalGNB_ID_pLMNIdentity,
        _GlobalGNB_ID_gNB_ID,
        ____GlobalGNB_ID_iE_Extensions__item__id_tab,
        ___GlobalGNB_ID_iE_Extensions__item__id,
        ____GlobalGNB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalGNB_ID_iE_Extensions__item__criticality,
        ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalGNB_ID_iE_Extensions__item__extensionValue,
        __GlobalGNB_ID_iE_Extensions__item_,
        _GlobalGNB_ID_iE_Extensions,
        GlobalGNB_ID,
        GlobalGNB_ID_ExtIEs,
        _GlobalN3IWF_ID_pLMNIdentity,
        _GlobalN3IWF_ID_n3IWF_ID,
        ____GlobalN3IWF_ID_iE_Extensions__item__id_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__id,
        ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__criticality,
        ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue,
        __GlobalN3IWF_ID_iE_Extensions__item_,
        _GlobalN3IWF_ID_iE_Extensions,
        GlobalN3IWF_ID,
        GlobalN3IWF_ID_ExtIEs,
        _GlobalLine_ID_globalLineIdentity,
        _GlobalLine_ID_lineType,
        ____GlobalLine_ID_iE_Extensions__item__id_tab,
        ___GlobalLine_ID_iE_Extensions__item__id,
        ____GlobalLine_ID_iE_Extensions__item__criticality_tab,
        ___GlobalLine_ID_iE_Extensions__item__criticality,
        ____GlobalLine_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalLine_ID_iE_Extensions__item__extensionValue,
        __GlobalLine_ID_iE_Extensions__item_,
        _GlobalLine_ID_iE_Extensions,
        GlobalLine_ID,
        GlobalLine_ID_ExtIEs,
        GlobalLineIdentity,
        _GlobalNgENB_ID_pLMNIdentity,
        _GlobalNgENB_ID_ngENB_ID,
        ____GlobalNgENB_ID_iE_Extensions__item__id_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__id,
        ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__criticality,
        ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__extensionValue,
        __GlobalNgENB_ID_iE_Extensions__item_,
        _GlobalNgENB_ID_iE_Extensions,
        GlobalNgENB_ID,
        GlobalNgENB_ID_ExtIEs,
        _GlobalRANNodeID_globalGNB_ID,
        _GlobalRANNodeID_globalNgENB_ID,
        _GlobalRANNodeID_globalN3IWF_ID,
        ___GlobalRANNodeID_choice_Extensions_id_tab,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2,
        __GlobalRANNodeID_choice_Extensions_id,
        __GlobalRANNodeID_choice_Extensions_criticality,
        __GlobalRANNodeID_choice_Extensions_value,
        _GlobalRANNodeID_choice_Extensions,
        GlobalRANNodeID,
        GlobalRANNodeID_ExtIEs,
        _GlobalRANNodeID_ExtIEs_val_Value_0,
        _GlobalRANNodeID_ExtIEs_val_Value_1,
        _GlobalRANNodeID_ExtIEs_val_Value_2,
        _GlobalTNGF_ID_pLMNIdentity,
        _GlobalTNGF_ID_tNGF_ID,
        ____GlobalTNGF_ID_iE_Extensions__item__id_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__id,
        ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__criticality,
        ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__extensionValue,
        __GlobalTNGF_ID_iE_Extensions__item_,
        _GlobalTNGF_ID_iE_Extensions,
        GlobalTNGF_ID,
        GlobalTNGF_ID_ExtIEs,
        _GlobalTWIF_ID_pLMNIdentity,
        _GlobalTWIF_ID_tWIF_ID,
        ____GlobalTWIF_ID_iE_Extensions__item__id_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__id,
        ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__criticality,
        ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__extensionValue,
        __GlobalTWIF_ID_iE_Extensions__item_,
        _GlobalTWIF_ID_iE_Extensions,
        GlobalTWIF_ID,
        GlobalTWIF_ID_ExtIEs,
        _GlobalW_AGF_ID_pLMNIdentity,
        _GlobalW_AGF_ID_w_AGF_ID,
        ____GlobalW_AGF_ID_iE_Extensions__item__id_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__id,
        ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__criticality,
        ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue,
        __GlobalW_AGF_ID_iE_Extensions__item_,
        _GlobalW_AGF_ID_iE_Extensions,
        GlobalW_AGF_ID,
        GlobalW_AGF_ID_ExtIEs,
        _GNB_ID_gNB_ID,
        ___GNB_ID_choice_Extensions_id_tab,
        __GNB_ID_choice_Extensions_id,
        ___GNB_ID_choice_Extensions_criticality_tab,
        __GNB_ID_choice_Extensions_criticality,
        ___GNB_ID_choice_Extensions_value_tab,
        __GNB_ID_choice_Extensions_value,
        _GNB_ID_choice_Extensions,
        GNB_ID,
        GNB_ID_ExtIEs,
        GTP_TEID,
        _GTPTunnel_transportLayerAddress,
        _GTPTunnel_gTP_TEID,
        ____GTPTunnel_iE_Extensions__item__id_tab,
        ___GTPTunnel_iE_Extensions__item__id,
        ____GTPTunnel_iE_Extensions__item__criticality_tab,
        ___GTPTunnel_iE_Extensions__item__criticality,
        ____GTPTunnel_iE_Extensions__item__extensionValue_tab,
        ___GTPTunnel_iE_Extensions__item__extensionValue,
        __GTPTunnel_iE_Extensions__item_,
        _GTPTunnel_iE_Extensions,
        GTPTunnel,
        GTPTunnel_ExtIEs,
        _GUAMI_pLMNIdentity,
        _GUAMI_aMFRegionID,
        _GUAMI_aMFSetID,
        _GUAMI_aMFPointer,
        ____GUAMI_iE_Extensions__item__id_tab,
        ___GUAMI_iE_Extensions__item__id,
        ____GUAMI_iE_Extensions__item__criticality_tab,
        ___GUAMI_iE_Extensions__item__criticality,
        ____GUAMI_iE_Extensions__item__extensionValue_tab,
        ___GUAMI_iE_Extensions__item__extensionValue,
        __GUAMI_iE_Extensions__item_,
        _GUAMI_iE_Extensions,
        GUAMI,
        GUAMI_ExtIEs,
        GUAMIType,
        _HandoverCommandTransfer_dLForwardingUP_TNLInformation,
        _HandoverCommandTransfer_qosFlowToBeForwardedList,
        _HandoverCommandTransfer_dataForwardingResponseDRBList,
        ____HandoverCommandTransfer_iE_Extensions__item__id_tab,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        ___HandoverCommandTransfer_iE_Extensions__item__id,
        ___HandoverCommandTransfer_iE_Extensions__item__criticality,
        ___HandoverCommandTransfer_iE_Extensions__item__extensionValue,
        __HandoverCommandTransfer_iE_Extensions__item_,
        _HandoverCommandTransfer_iE_Extensions,
        HandoverCommandTransfer,
        HandoverCommandTransfer_ExtIEs,
        _HandoverCommandTransfer_ExtIEs_val_Extension_0,
        _HandoverCommandTransfer_ExtIEs_val_Extension_1,
        _HandoverCommandTransfer_ExtIEs_val_Extension_2,
        _HandoverCommandTransfer_ExtIEs_val_Extension_3,
        _HandoverCommandTransfer_ExtIEs_val_Extension_4,
        HandoverFlag,
        _HandoverPreparationUnsuccessfulTransfer_cause,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_,
        _HandoverPreparationUnsuccessfulTransfer_iE_Extensions,
        HandoverPreparationUnsuccessfulTransfer,
        HandoverPreparationUnsuccessfulTransfer_ExtIEs,
        _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation,
        _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation,
        _HandoverRequestAcknowledgeTransfer_securityResult,
        _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList,
        _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList,
        _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList,
        ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue,
        __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_,
        _HandoverRequestAcknowledgeTransfer_iE_Extensions,
        HandoverRequestAcknowledgeTransfer,
        HandoverRequestAcknowledgeTransfer_ExtIEs,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6,
        _HandoverRequiredTransfer_directForwardingPathAvailability,
        ____HandoverRequiredTransfer_iE_Extensions__item__id_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__id,
        ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__criticality,
        ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue,
        __HandoverRequiredTransfer_iE_Extensions__item_,
        _HandoverRequiredTransfer_iE_Extensions,
        HandoverRequiredTransfer,
        HandoverRequiredTransfer_ExtIEs,
        _HandoverResourceAllocationUnsuccessfulTransfer_cause,
        _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_,
        _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions,
        HandoverResourceAllocationUnsuccessfulTransfer,
        HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs,
        HandoverType,
        HFCNode_ID,
        _HOReport_handoverReportType,
        _HOReport_handoverCause,
        _HOReport_sourcecellCGI,
        _HOReport_targetcellCGI,
        _HOReport_reestablishmentcellCGI,
        _HOReport_sourcecellC_RNTI,
        _HOReport_targetcellinE_UTRAN,
        _HOReport_mobilityInformation,
        _HOReport_uERLFReportContainer,
        ____HOReport_iE_Extensions__item__id_tab,
        ___HOReport_iE_Extensions__item__id,
        ____HOReport_iE_Extensions__item__criticality_tab,
        ___HOReport_iE_Extensions__item__criticality,
        ____HOReport_iE_Extensions__item__extensionValue_tab,
        ___HOReport_iE_Extensions__item__extensionValue,
        __HOReport_iE_Extensions__item_,
        _HOReport_iE_Extensions,
        HOReport,
        HOReport_ExtIEs,
        Hysteresis,
        IAB_Authorized,
        IAB_Supported,
        IABNodeIndication,
        IMSVoiceSupportIndicator,
        IndexToRFSP,
        _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging,
        _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue,
        __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_,
        _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions,
        InfoOnRecommendedCellsAndRANNodesForPaging,
        InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs,
        IntegrityProtectionIndication,
        IntegrityProtectionResult,
        IntendedNumberOfPagingAttempts,
        InterfacesToTrace,
        _ImmediateMDTNr_measurementsToActivate,
        _ImmediateMDTNr_m1Configuration,
        _ImmediateMDTNr_m4Configuration,
        _ImmediateMDTNr_m5Configuration,
        _ImmediateMDTNr_m6Configuration,
        _ImmediateMDTNr_m7Configuration,
        _ImmediateMDTNr_bluetoothMeasurementConfiguration,
        _ImmediateMDTNr_wLANMeasurementConfiguration,
        _ImmediateMDTNr_mDT_Location_Info,
        _ImmediateMDTNr_sensorMeasurementConfiguration,
        ____ImmediateMDTNr_iE_Extensions__item__id_tab,
        ___ImmediateMDTNr_iE_Extensions__item__id,
        ____ImmediateMDTNr_iE_Extensions__item__criticality_tab,
        ___ImmediateMDTNr_iE_Extensions__item__criticality,
        ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab,
        ___ImmediateMDTNr_iE_Extensions__item__extensionValue,
        __ImmediateMDTNr_iE_Extensions__item_,
        _ImmediateMDTNr_iE_Extensions,
        ImmediateMDTNr,
        ImmediateMDTNr_ExtIEs,
        _InterSystemFailureIndication_uERLFReportContainer,
        ____InterSystemFailureIndication_iE_Extensions__item__id_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__id,
        ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__criticality,
        ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__extensionValue,
        __InterSystemFailureIndication_iE_Extensions__item_,
        _InterSystemFailureIndication_iE_Extensions,
        InterSystemFailureIndication,
        InterSystemFailureIndication_ExtIEs,
        _IntersystemSONConfigurationTransfer_transferType,
        _IntersystemSONConfigurationTransfer_intersystemSONInformation,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __IntersystemSONConfigurationTransfer_iE_Extensions__item_,
        _IntersystemSONConfigurationTransfer_iE_Extensions,
        IntersystemSONConfigurationTransfer,
        IntersystemSONConfigurationTransfer_ExtIEs,
        _IntersystemSONTransferType_fromEUTRANtoNGRAN,
        _IntersystemSONTransferType_fromNGRANtoEUTRAN,
        ___IntersystemSONTransferType_choice_Extensions_id_tab,
        __IntersystemSONTransferType_choice_Extensions_id,
        ___IntersystemSONTransferType_choice_Extensions_criticality_tab,
        __IntersystemSONTransferType_choice_Extensions_criticality,
        ___IntersystemSONTransferType_choice_Extensions_value_tab,
        __IntersystemSONTransferType_choice_Extensions_value,
        _IntersystemSONTransferType_choice_Extensions,
        IntersystemSONTransferType,
        IntersystemSONTransferType_ExtIEs,
        _IntersystemSONeNBID_globaleNBID,
        _IntersystemSONeNBID_selectedEPSTAI,
        ____IntersystemSONeNBID_iE_Extensions__item__id_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__id,
        ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__criticality,
        ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__extensionValue,
        __IntersystemSONeNBID_iE_Extensions__item_,
        _IntersystemSONeNBID_iE_Extensions,
        IntersystemSONeNBID,
        IntersystemSONeNBID_ExtIEs,
        _IntersystemSONNGRANnodeID_globalRANNodeID,
        _IntersystemSONNGRANnodeID_selectedTAI,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__id,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue,
        __IntersystemSONNGRANnodeID_iE_Extensions__item_,
        _IntersystemSONNGRANnodeID_iE_Extensions,
        IntersystemSONNGRANnodeID,
        IntersystemSONNGRANnodeID_ExtIEs,
        _IntersystemSONInformation_intersystemSONInformationReport,
        ___IntersystemSONInformation_choice_Extensions_id_tab,
        __IntersystemSONInformation_choice_Extensions_id,
        ___IntersystemSONInformation_choice_Extensions_criticality_tab,
        __IntersystemSONInformation_choice_Extensions_criticality,
        ___IntersystemSONInformation_choice_Extensions_value_tab,
        __IntersystemSONInformation_choice_Extensions_value,
        _IntersystemSONInformation_choice_Extensions,
        IntersystemSONInformation,
        IntersystemSONInformation_ExtIEs,
        _IntersystemSONInformationReport_hOReportInformation,
        _IntersystemSONInformationReport_failureIndicationInformation,
        ___IntersystemSONInformationReport_choice_Extensions_id_tab,
        __IntersystemSONInformationReport_choice_Extensions_id,
        ___IntersystemSONInformationReport_choice_Extensions_criticality_tab,
        __IntersystemSONInformationReport_choice_Extensions_criticality,
        ___IntersystemSONInformationReport_choice_Extensions_value_tab,
        __IntersystemSONInformationReport_choice_Extensions_value,
        _IntersystemSONInformationReport_choice_Extensions,
        IntersystemSONInformationReport,
        IntersystemSONInformationReport_ExtIEs,
        _InterSystemHOReport_handoverReportType,
        ____InterSystemHOReport_iE_Extensions__item__id_tab,
        ___InterSystemHOReport_iE_Extensions__item__id,
        ____InterSystemHOReport_iE_Extensions__item__criticality_tab,
        ___InterSystemHOReport_iE_Extensions__item__criticality,
        ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab,
        ___InterSystemHOReport_iE_Extensions__item__extensionValue,
        __InterSystemHOReport_iE_Extensions__item_,
        _InterSystemHOReport_iE_Extensions,
        InterSystemHOReport,
        InterSystemHOReport_ExtIEs,
        _InterSystemHandoverReportType_tooearlyIntersystemHO,
        _InterSystemHandoverReportType_intersystemUnnecessaryHO,
        ___InterSystemHandoverReportType_choice_Extensions_id_tab,
        __InterSystemHandoverReportType_choice_Extensions_id,
        ___InterSystemHandoverReportType_choice_Extensions_criticality_tab,
        __InterSystemHandoverReportType_choice_Extensions_criticality,
        ___InterSystemHandoverReportType_choice_Extensions_value_tab,
        __InterSystemHandoverReportType_choice_Extensions_value,
        _InterSystemHandoverReportType_choice_Extensions,
        InterSystemHandoverReportType,
        InterSystemHandoverReportType_ExtIEs,
        _IntersystemUnnecessaryHO_sourcecellID,
        _IntersystemUnnecessaryHO_targetcellID,
        _IntersystemUnnecessaryHO_earlyIRATHO,
        _IntersystemUnnecessaryHO_candidateCellList,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__id,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue,
        __IntersystemUnnecessaryHO_iE_Extensions__item_,
        _IntersystemUnnecessaryHO_iE_Extensions,
        IntersystemUnnecessaryHO,
        IntersystemUnnecessaryHO_ExtIEs,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastVisitedCellInformation_nGRANCell,
        _LastVisitedCellInformation_eUTRANCell,
        _LastVisitedCellInformation_uTRANCell,
        _LastVisitedCellInformation_gERANCell,
        ___LastVisitedCellInformation_choice_Extensions_id_tab,
        __LastVisitedCellInformation_choice_Extensions_id,
        ___LastVisitedCellInformation_choice_Extensions_criticality_tab,
        __LastVisitedCellInformation_choice_Extensions_criticality,
        ___LastVisitedCellInformation_choice_Extensions_value_tab,
        __LastVisitedCellInformation_choice_Extensions_value,
        _LastVisitedCellInformation_choice_Extensions,
        LastVisitedCellInformation,
        LastVisitedCellInformation_ExtIEs,
        _LastVisitedCellItem_lastVisitedCellInformation,
        ____LastVisitedCellItem_iE_Extensions__item__id_tab,
        ___LastVisitedCellItem_iE_Extensions__item__id,
        ____LastVisitedCellItem_iE_Extensions__item__criticality_tab,
        ___LastVisitedCellItem_iE_Extensions__item__criticality,
        ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab,
        ___LastVisitedCellItem_iE_Extensions__item__extensionValue,
        __LastVisitedCellItem_iE_Extensions__item_,
        _LastVisitedCellItem_iE_Extensions,
        LastVisitedCellItem,
        LastVisitedCellItem_ExtIEs,
        LastVisitedEUTRANCellInformation,
        LastVisitedGERANCellInformation,
        _LastVisitedNGRANCellInformation_globalCellID,
        _LastVisitedNGRANCellInformation_cellType,
        _LastVisitedNGRANCellInformation_timeUEStayedInCell,
        _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity,
        _LastVisitedNGRANCellInformation_hOCauseValue,
        ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__id,
        ____LastVisitedNGRANCellInformation_iE_Extensions__item__criticality_tab,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality,
        ____LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue_tab,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedNGRANCellInformation_iE_Extensions__item_,
        _LastVisitedNGRANCellInformation_iE_Extensions,
        LastVisitedNGRANCellInformation,
        LastVisitedNGRANCellInformation_ExtIEs,
        LastVisitedUTRANCellInformation,
        LineType,
        LocationReportingAdditionalInfo,
        LocationReportingReferenceID,
        _LocationReportingRequestType_eventType,
        _LocationReportingRequestType_reportArea,
        _LocationReportingRequestType_areaOfInterestList,
        _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled,
        ____LocationReportingRequestType_iE_Extensions__item__id_tab,
        _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0,
        ___LocationReportingRequestType_iE_Extensions__item__id,
        ___LocationReportingRequestType_iE_Extensions__item__criticality,
        ___LocationReportingRequestType_iE_Extensions__item__extensionValue,
        __LocationReportingRequestType_iE_Extensions__item_,
        _LocationReportingRequestType_iE_Extensions,
        LocationReportingRequestType,
        LocationReportingRequestType_ExtIEs,
        _LocationReportingRequestType_ExtIEs_val_Extension_0,
        _LoggedMDTNr_loggingInterval,
        _LoggedMDTNr_loggingDuration,
        _LoggedMDTNr_loggedMDTTrigger,
        _LoggedMDTNr_bluetoothMeasurementConfiguration,
        _LoggedMDTNr_wLANMeasurementConfiguration,
        _LoggedMDTNr_sensorMeasurementConfiguration,
        _LoggedMDTNr_areaScopeOfNeighCellsList,
        ____LoggedMDTNr_iE_Extensions__item__id_tab,
        ___LoggedMDTNr_iE_Extensions__item__id,
        ____LoggedMDTNr_iE_Extensions__item__criticality_tab,
        ___LoggedMDTNr_iE_Extensions__item__criticality,
        ____LoggedMDTNr_iE_Extensions__item__extensionValue_tab,
        ___LoggedMDTNr_iE_Extensions__item__extensionValue,
        __LoggedMDTNr_iE_Extensions__item_,
        _LoggedMDTNr_iE_Extensions,
        LoggedMDTNr,
        LoggedMDTNr_ExtIEs,
        LoggingInterval,
        LoggingDuration,
        Links_to_log,
        _LoggedMDTTrigger_periodical,
        _LoggedMDTTrigger_eventTrigger,
        ___LoggedMDTTrigger_choice_Extensions_id_tab,
        __LoggedMDTTrigger_choice_Extensions_id,
        ___LoggedMDTTrigger_choice_Extensions_criticality_tab,
        __LoggedMDTTrigger_choice_Extensions_criticality,
        ___LoggedMDTTrigger_choice_Extensions_value_tab,
        __LoggedMDTTrigger_choice_Extensions_value,
        _LoggedMDTTrigger_choice_Extensions,
        LoggedMDTTrigger,
        LoggedMDTTrigger_ExtIEs,
        LTEM_Indication,
        LTEUERLFReportContainer,
        _LTEV2XServicesAuthorized_vehicleUE,
        _LTEV2XServicesAuthorized_pedestrianUE,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__id,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __LTEV2XServicesAuthorized_iE_Extensions__item_,
        _LTEV2XServicesAuthorized_iE_Extensions,
        LTEV2XServicesAuthorized,
        LTEV2XServicesAuthorized_ExtIEs,
        _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions,
        LTEUESidelinkAggregateMaximumBitrate,
        LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs,
        MaskedIMEISV,
        MaximumDataBurstVolume,
        MessageIdentifier,
        MaximumIntegrityProtectedDataRate,
        MicoAllPLMN,
        MICOModeIndication,
        MobilityInformation,
        _MobilityRestrictionList_servingPLMN,
        _MobilityRestrictionList_equivalentPLMNs,
        _MobilityRestrictionList_rATRestrictions,
        _MobilityRestrictionList_forbiddenAreaInformation,
        _MobilityRestrictionList_serviceAreaInformation,
        ____MobilityRestrictionList_iE_Extensions__item__id_tab,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3,
        ___MobilityRestrictionList_iE_Extensions__item__id,
        ___MobilityRestrictionList_iE_Extensions__item__criticality,
        ___MobilityRestrictionList_iE_Extensions__item__extensionValue,
        __MobilityRestrictionList_iE_Extensions__item_,
        _MobilityRestrictionList_iE_Extensions,
        MobilityRestrictionList,
        MobilityRestrictionList_ExtIEs,
        _MobilityRestrictionList_ExtIEs_val_Extension_0,
        _MobilityRestrictionList_ExtIEs_val_Extension_1,
        _MobilityRestrictionList_ExtIEs_val_Extension_2,
        _MobilityRestrictionList_ExtIEs_val_Extension_3,
        _MDTPLMNList__item_,
        MDTPLMNList,
        _MDT_Configuration_mdt_Config_NR,
        _MDT_Configuration_mdt_Config_EUTRA,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        ___MDT_Configuration_iE_Extensions__item__id,
        ____MDT_Configuration_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ____MDT_Configuration_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_NR_mdt_Activation,
        _MDT_Configuration_NR_areaScopeOfMDT,
        _MDT_Configuration_NR_mDTModeNr,
        _MDT_Configuration_NR_signallingBasedMDTPLMNList,
        ____MDT_Configuration_NR_iE_Extensions__item__id_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__id,
        ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__criticality,
        ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__extensionValue,
        __MDT_Configuration_NR_iE_Extensions__item_,
        _MDT_Configuration_NR_iE_Extensions,
        MDT_Configuration_NR,
        MDT_Configuration_NR_ExtIEs,
        _MDT_Configuration_EUTRA_mdt_Activation,
        _MDT_Configuration_EUTRA_areaScopeOfMDT,
        _MDT_Configuration_EUTRA_mDTMode,
        _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__id,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue,
        __MDT_Configuration_EUTRA_iE_Extensions__item_,
        _MDT_Configuration_EUTRA_iE_Extensions,
        MDT_Configuration_EUTRA,
        MDT_Configuration_EUTRA_ExtIEs,
        MDT_Activation,
        _MDTModeNr_immediateMDTNr,
        _MDTModeNr_loggedMDTNr,
        ___MDTModeNr_choice_Extensions_id_tab,
        __MDTModeNr_choice_Extensions_id,
        ___MDTModeNr_choice_Extensions_criticality_tab,
        __MDTModeNr_choice_Extensions_criticality,
        ___MDTModeNr_choice_Extensions_value_tab,
        __MDTModeNr_choice_Extensions_value,
        _MDTModeNr_choice_Extensions,
        MDTModeNr,
        MDTModeNr_ExtIEs,
        MDTModeEutra,
        MeasurementsToActivate,
        _M1Configuration_m1reportingTrigger,
        _M1Configuration_m1thresholdEventA2,
        _M1Configuration_m1periodicReporting,
        ____M1Configuration_iE_Extensions__item__id_tab,
        ___M1Configuration_iE_Extensions__item__id,
        ____M1Configuration_iE_Extensions__item__criticality_tab,
        ___M1Configuration_iE_Extensions__item__criticality,
        ____M1Configuration_iE_Extensions__item__extensionValue_tab,
        ___M1Configuration_iE_Extensions__item__extensionValue,
        __M1Configuration_iE_Extensions__item_,
        _M1Configuration_iE_Extensions,
        M1Configuration,
        M1Configuration_ExtIEs,
        M1ReportingTrigger,
        _M1ThresholdEventA2_m1ThresholdType,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        _M1ThresholdType_threshold_RSRP,
        _M1ThresholdType_threshold_RSRQ,
        _M1ThresholdType_threshold_SINR,
        ___M1ThresholdType_choice_Extensions_id_tab,
        __M1ThresholdType_choice_Extensions_id,
        ___M1ThresholdType_choice_Extensions_criticality_tab,
        __M1ThresholdType_choice_Extensions_criticality,
        ___M1ThresholdType_choice_Extensions_value_tab,
        __M1ThresholdType_choice_Extensions_value,
        _M1ThresholdType_choice_Extensions,
        M1ThresholdType,
        M1ThresholdType_ExtIEs,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        _M1PeriodicReporting_ExtIEs_val_Extension_0,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        ___M4Configuration_iE_Extensions__item__id,
        ____M4Configuration_iE_Extensions__item__criticality_tab,
        ___M4Configuration_iE_Extensions__item__criticality,
        ____M4Configuration_iE_Extensions__item__extensionValue_tab,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ____M5Configuration_iE_Extensions__item__criticality_tab,
        ___M5Configuration_iE_Extensions__item__criticality,
        ____M5Configuration_iE_Extensions__item__extensionValue_tab,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ____M6Configuration_iE_Extensions__item__criticality_tab,
        ___M6Configuration_iE_Extensions__item__criticality,
        ____M6Configuration_iE_Extensions__item__extensionValue_tab,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_Interval,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ____M7Configuration_iE_Extensions__item__criticality_tab,
        ___M7Configuration_iE_Extensions__item__criticality,
        ____M7Configuration_iE_Extensions__item__extensionValue_tab,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        _MDT_Location_Info_mDT_Location_Information,
        ____MDT_Location_Info_iE_Extensions__item__id_tab,
        ___MDT_Location_Info_iE_Extensions__item__id,
        ____MDT_Location_Info_iE_Extensions__item__criticality_tab,
        ___MDT_Location_Info_iE_Extensions__item__criticality,
        ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab,
        ___MDT_Location_Info_iE_Extensions__item__extensionValue,
        __MDT_Location_Info_iE_Extensions__item_,
        _MDT_Location_Info_iE_Extensions,
        MDT_Location_Info,
        MDT_Location_Info_ExtIEs,
        MDT_Location_Information,
        _N3IWF_ID_n3IWF_ID,
        ___N3IWF_ID_choice_Extensions_id_tab,
        __N3IWF_ID_choice_Extensions_id,
        ___N3IWF_ID_choice_Extensions_criticality_tab,
        __N3IWF_ID_choice_Extensions_criticality,
        ___N3IWF_ID_choice_Extensions_value_tab,
        __N3IWF_ID_choice_Extensions_value,
        _N3IWF_ID_choice_Extensions,
        N3IWF_ID,
        N3IWF_ID_ExtIEs,
        NAS_PDU,
        NASSecurityParametersFromNGRAN,
        NB_IoT_DefaultPagingDRX,
        NB_IoT_PagingDRX,
        NB_IoT_Paging_eDRXCycle,
        NB_IoT_Paging_TimeWindow,
        _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle,
        _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue,
        __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_,
        _NB_IoT_Paging_eDRXInfo_iE_Extensions,
        NB_IoT_Paging_eDRXInfo,
        NB_IoT_Paging_eDRXInfo_ExtIEs,
        NB_IoT_UEPriority,
        NetworkInstance,
        NewSecurityContextInd,
        NextHopChainingCount,
        NextPagingAreaScope,
        _NgENB_ID_macroNgENB_ID,
        _NgENB_ID_shortMacroNgENB_ID,
        _NgENB_ID_longMacroNgENB_ID,
        ___NgENB_ID_choice_Extensions_id_tab,
        __NgENB_ID_choice_Extensions_id,
        ___NgENB_ID_choice_Extensions_criticality_tab,
        __NgENB_ID_choice_Extensions_criticality,
        ___NgENB_ID_choice_Extensions_value_tab,
        __NgENB_ID_choice_Extensions_value,
        _NgENB_ID_choice_Extensions,
        NgENB_ID,
        NgENB_ID_ExtIEs,
        NotifySourceNGRANNode,
        _NGRAN_CGI_nR_CGI,
        _NGRAN_CGI_eUTRA_CGI,
        ___NGRAN_CGI_choice_Extensions_id_tab,
        __NGRAN_CGI_choice_Extensions_id,
        ___NGRAN_CGI_choice_Extensions_criticality_tab,
        __NGRAN_CGI_choice_Extensions_criticality,
        ___NGRAN_CGI_choice_Extensions_value_tab,
        __NGRAN_CGI_choice_Extensions_value,
        _NGRAN_CGI_choice_Extensions,
        NGRAN_CGI,
        NGRAN_CGI_ExtIEs,
        _NGRAN_TNLAssociationToRemoveList__item_,
        NGRAN_TNLAssociationToRemoveList,
        _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress,
        _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue,
        __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_,
        _NGRAN_TNLAssociationToRemoveItem_iE_Extensions,
        NGRAN_TNLAssociationToRemoveItem,
        NGRAN_TNLAssociationToRemoveItem_ExtIEs,
        NGRANTraceID,
        NID,
        _NonDynamic5QIDescriptor_fiveQI,
        _NonDynamic5QIDescriptor_priorityLevelQos,
        _NonDynamic5QIDescriptor_averagingWindow,
        _NonDynamic5QIDescriptor_maximumDataBurstVolume,
        ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__id,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamic5QIDescriptor_iE_Extensions__item_,
        _NonDynamic5QIDescriptor_iE_Extensions,
        NonDynamic5QIDescriptor,
        NonDynamic5QIDescriptor_ExtIEs,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _NotAllowedTACs__item_,
        NotAllowedTACs,
        NotificationCause,
        NotificationControl,
        _NPN_AccessInformation_pNI_NPN_Access_Information,
        ___NPN_AccessInformation_choice_Extensions_id_tab,
        __NPN_AccessInformation_choice_Extensions_id,
        ___NPN_AccessInformation_choice_Extensions_criticality_tab,
        __NPN_AccessInformation_choice_Extensions_criticality,
        ___NPN_AccessInformation_choice_Extensions_value_tab,
        __NPN_AccessInformation_choice_Extensions_value,
        _NPN_AccessInformation_choice_Extensions,
        NPN_AccessInformation,
        NPN_AccessInformation_ExtIEs,
        _NPN_MobilityInformation_sNPN_MobilityInformation,
        _NPN_MobilityInformation_pNI_NPN_MobilityInformation,
        ___NPN_MobilityInformation_choice_Extensions_id_tab,
        __NPN_MobilityInformation_choice_Extensions_id,
        ___NPN_MobilityInformation_choice_Extensions_criticality_tab,
        __NPN_MobilityInformation_choice_Extensions_criticality,
        ___NPN_MobilityInformation_choice_Extensions_value_tab,
        __NPN_MobilityInformation_choice_Extensions_value,
        _NPN_MobilityInformation_choice_Extensions,
        NPN_MobilityInformation,
        NPN_MobilityInformation_ExtIEs,
        _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance,
        ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_id,
        ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_criticality,
        ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_value,
        _NPN_PagingAssistanceInformation_choice_Extensions,
        NPN_PagingAssistanceInformation,
        NPN_PagingAssistanceInformation_ExtIEs,
        _NPN_Support_sNPN,
        ___NPN_Support_choice_Extensions_id_tab,
        __NPN_Support_choice_Extensions_id,
        ___NPN_Support_choice_Extensions_criticality_tab,
        __NPN_Support_choice_Extensions_criticality,
        ___NPN_Support_choice_Extensions_value_tab,
        __NPN_Support_choice_Extensions_value,
        _NPN_Support_choice_Extensions,
        NPN_Support,
        NPN_Support_ExtIEs,
        NRCellIdentity,
        _NR_CGI_pLMNIdentity,
        _NR_CGI_nRCellIdentity,
        ____NR_CGI_iE_Extensions__item__id_tab,
        ___NR_CGI_iE_Extensions__item__id,
        ____NR_CGI_iE_Extensions__item__criticality_tab,
        ___NR_CGI_iE_Extensions__item__criticality,
        ____NR_CGI_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_iE_Extensions__item__extensionValue,
        __NR_CGI_iE_Extensions__item_,
        _NR_CGI_iE_Extensions,
        NR_CGI,
        NR_CGI_ExtIEs,
        _NR_CGIList__item_,
        NR_CGIList,
        _NR_CGIListForWarning__item_,
        NR_CGIListForWarning,
        NRencryptionAlgorithms,
        NRintegrityProtectionAlgorithms,
        NRMobilityHistoryReport,
        NRPPa_PDU,
        NRUERLFReportContainer,
        NumberOfBroadcasts,
        NumberOfBroadcastsRequested,
        NRARFCN,
        NRFrequencyBand,
        _NRFrequencyBand_List__item_,
        NRFrequencyBand_List,
        _NRFrequencyBandItem_nr_frequency_band,
        ____NRFrequencyBandItem_iE_Extension__item__id_tab,
        ___NRFrequencyBandItem_iE_Extension__item__id,
        ____NRFrequencyBandItem_iE_Extension__item__criticality_tab,
        ___NRFrequencyBandItem_iE_Extension__item__criticality,
        ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab,
        ___NRFrequencyBandItem_iE_Extension__item__extensionValue,
        __NRFrequencyBandItem_iE_Extension__item_,
        _NRFrequencyBandItem_iE_Extension,
        NRFrequencyBandItem,
        NRFrequencyBandItem_ExtIEs,
        _NRFrequencyInfo_nrARFCN,
        _NRFrequencyInfo_frequencyBand_List,
        ____NRFrequencyInfo_iE_Extension__item__id_tab,
        ___NRFrequencyInfo_iE_Extension__item__id,
        ____NRFrequencyInfo_iE_Extension__item__criticality_tab,
        ___NRFrequencyInfo_iE_Extension__item__criticality,
        ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab,
        ___NRFrequencyInfo_iE_Extension__item__extensionValue,
        __NRFrequencyInfo_iE_Extension__item_,
        _NRFrequencyInfo_iE_Extension,
        NRFrequencyInfo,
        NRFrequencyInfo_ExtIEs,
        NR_PCI,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        VehicleUE,
        PedestrianUE,
        _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        OverloadAction,
        _OverloadResponse_overloadAction,
        ___OverloadResponse_choice_Extensions_id_tab,
        __OverloadResponse_choice_Extensions_id,
        ___OverloadResponse_choice_Extensions_criticality_tab,
        __OverloadResponse_choice_Extensions_criticality,
        ___OverloadResponse_choice_Extensions_value_tab,
        __OverloadResponse_choice_Extensions_value,
        _OverloadResponse_choice_Extensions,
        OverloadResponse,
        OverloadResponse_ExtIEs,
        _OverloadStartNSSAIList__item_,
        OverloadStartNSSAIList,
        _OverloadStartNSSAIItem_sliceOverloadList,
        _OverloadStartNSSAIItem_sliceOverloadResponse,
        _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication,
        ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__id,
        ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__criticality,
        ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue,
        __OverloadStartNSSAIItem_iE_Extensions__item_,
        _OverloadStartNSSAIItem_iE_Extensions,
        OverloadStartNSSAIItem,
        OverloadStartNSSAIItem_ExtIEs,
        PacketDelayBudget,
        _PacketErrorRate_pERScalar,
        _PacketErrorRate_pERExponent,
        ____PacketErrorRate_iE_Extensions__item__id_tab,
        ___PacketErrorRate_iE_Extensions__item__id,
        ____PacketErrorRate_iE_Extensions__item__criticality_tab,
        ___PacketErrorRate_iE_Extensions__item__criticality,
        ____PacketErrorRate_iE_Extensions__item__extensionValue_tab,
        ___PacketErrorRate_iE_Extensions__item__extensionValue,
        __PacketErrorRate_iE_Extensions__item_,
        _PacketErrorRate_iE_Extensions,
        PacketErrorRate,
        PacketErrorRate_ExtIEs,
        PacketLossRate,
        _PagingAssisDataforCEcapabUE_eUTRA_CGI,
        _PagingAssisDataforCEcapabUE_coverageEnhancementLevel,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue,
        __PagingAssisDataforCEcapabUE_iE_Extensions__item_,
        _PagingAssisDataforCEcapabUE_iE_Extensions,
        PagingAssisDataforCEcapabUE,
        PagingAssisDataforCEcapabUE_ExtIEs,
        _PagingAttemptInformation_pagingAttemptCount,
        _PagingAttemptInformation_intendedNumberOfPagingAttempts,
        _PagingAttemptInformation_nextPagingAreaScope,
        ____PagingAttemptInformation_iE_Extensions__item__id_tab,
        ___PagingAttemptInformation_iE_Extensions__item__id,
        ____PagingAttemptInformation_iE_Extensions__item__criticality_tab,
        ___PagingAttemptInformation_iE_Extensions__item__criticality,
        ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab,
        ___PagingAttemptInformation_iE_Extensions__item__extensionValue,
        __PagingAttemptInformation_iE_Extensions__item_,
        _PagingAttemptInformation_iE_Extensions,
        PagingAttemptInformation,
        PagingAttemptInformation_ExtIEs,
        PagingAttemptCount,
        PagingDRX,
        PagingOrigin,
        PagingPriority,
        _PagingeDRXInformation_paging_eDRX_Cycle,
        _PagingeDRXInformation_paging_Time_Window,
        ____PagingeDRXInformation_iE_Extensions__item__id_tab,
        ___PagingeDRXInformation_iE_Extensions__item__id,
        ____PagingeDRXInformation_iE_Extensions__item__criticality_tab,
        ___PagingeDRXInformation_iE_Extensions__item__criticality,
        ____PagingeDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___PagingeDRXInformation_iE_Extensions__item__extensionValue,
        __PagingeDRXInformation_iE_Extensions__item_,
        _PagingeDRXInformation_iE_Extensions,
        PagingeDRXInformation,
        PagingeDRXInformation_ExtIEs,
        Paging_eDRX_Cycle,
        Paging_Time_Window,
        PagingProbabilityInformation,
        _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation,
        _PathSwitchRequestAcknowledgeTransfer_securityIndication,
        ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_,
        _PathSwitchRequestAcknowledgeTransfer_iE_Extensions,
        PathSwitchRequestAcknowledgeTransfer,
        PathSwitchRequestAcknowledgeTransfer_ExtIEs,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3,
        _PathSwitchRequestSetupFailedTransfer_cause,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_,
        _PathSwitchRequestSetupFailedTransfer_iE_Extensions,
        PathSwitchRequestSetupFailedTransfer,
        PathSwitchRequestSetupFailedTransfer_ExtIEs,
        _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation,
        _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused,
        _PathSwitchRequestTransfer_userPlaneSecurityInformation,
        _PathSwitchRequestTransfer_qosFlowAcceptedList,
        ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        ___PathSwitchRequestTransfer_iE_Extensions__item__id,
        ___PathSwitchRequestTransfer_iE_Extensions__item__criticality,
        ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestTransfer_iE_Extensions__item_,
        _PathSwitchRequestTransfer_iE_Extensions,
        PathSwitchRequestTransfer,
        PathSwitchRequestTransfer_ExtIEs,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_0,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_1,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_2,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_3,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_4,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_5,
        _PathSwitchRequestUnsuccessfulTransfer_cause,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_,
        _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions,
        PathSwitchRequestUnsuccessfulTransfer,
        PathSwitchRequestUnsuccessfulTransfer_ExtIEs,
        _PC5QoSParameters_pc5QoSFlowList,
        _PC5QoSParameters_pc5LinkAggregateBitRates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5QoSFlowList__item_,
        PC5QoSFlowList,
        _PC5QoSFlowItem_pQI,
        _PC5QoSFlowItem_pc5FlowBitRates,
        _PC5QoSFlowItem_range,
        ____PC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__id,
        ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__criticality,
        ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __PC5QoSFlowItem_iE_Extensions__item_,
        _PC5QoSFlowItem_iE_Extensions,
        PC5QoSFlowItem,
        PC5QoSFlowItem_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        _PCIListForMDT__item_,
        PCIListForMDT,
        PrivacyIndicator,
        _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL,
        _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_,
        _PDUSessionAggregateMaximumBitRate_iE_Extensions,
        PDUSessionAggregateMaximumBitRate,
        PDUSessionAggregateMaximumBitRate_ExtIEs,
        PDUSessionID,
        _PDUSessionResourceAdmittedList__item_,
        PDUSessionResourceAdmittedList,
        _PDUSessionResourceAdmittedItem_pDUSessionID,
        __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain,
        _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceAdmittedItem_iE_Extensions__item_,
        _PDUSessionResourceAdmittedItem_iE_Extensions,
        PDUSessionResourceAdmittedItem,
        PDUSessionResourceAdmittedItem_ExtIEs,
        _PDUSessionResourceFailedToModifyListModCfm__item_,
        PDUSessionResourceFailedToModifyListModCfm,
        _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID,
        __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_,
        _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions,
        PDUSessionResourceFailedToModifyItemModCfm,
        PDUSessionResourceFailedToModifyItemModCfm_ExtIEs,
        _PDUSessionResourceFailedToModifyListModRes__item_,
        PDUSessionResourceFailedToModifyListModRes,
        _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID,
        __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions,
        PDUSessionResourceFailedToModifyItemModRes,
        PDUSessionResourceFailedToModifyItemModRes_ExtIEs,
        _PDUSessionResourceFailedToResumeListRESReq__item_,
        PDUSessionResourceFailedToResumeListRESReq,
        _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID,
        _PDUSessionResourceFailedToResumeItemRESReq_cause,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_,
        _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions,
        PDUSessionResourceFailedToResumeItemRESReq,
        PDUSessionResourceFailedToResumeItemRESReq_ExtIEs,
        _PDUSessionResourceFailedToResumeListRESRes__item_,
        PDUSessionResourceFailedToResumeListRESRes,
        _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID,
        _PDUSessionResourceFailedToResumeItemRESRes_cause,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions,
        PDUSessionResourceFailedToResumeItemRESRes,
        PDUSessionResourceFailedToResumeItemRESRes_ExtIEs,
        _PDUSessionResourceFailedToSetupListCxtFail__item_,
        PDUSessionResourceFailedToSetupListCxtFail,
        _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions,
        PDUSessionResourceFailedToSetupItemCxtFail,
        PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs,
        _PDUSessionResourceFailedToSetupListCxtRes__item_,
        PDUSessionResourceFailedToSetupListCxtRes,
        _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions,
        PDUSessionResourceFailedToSetupItemCxtRes,
        PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs,
        _PDUSessionResourceFailedToSetupListHOAck__item_,
        PDUSessionResourceFailedToSetupListHOAck,
        _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions,
        PDUSessionResourceFailedToSetupItemHOAck,
        PDUSessionResourceFailedToSetupItemHOAck_ExtIEs,
        _PDUSessionResourceFailedToSetupListPSReq__item_,
        PDUSessionResourceFailedToSetupListPSReq,
        _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain,
        _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions,
        PDUSessionResourceFailedToSetupItemPSReq,
        PDUSessionResourceFailedToSetupItemPSReq_ExtIEs,
        _PDUSessionResourceFailedToSetupListSURes__item_,
        PDUSessionResourceFailedToSetupListSURes,
        _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions,
        PDUSessionResourceFailedToSetupItemSURes,
        PDUSessionResourceFailedToSetupItemSURes_ExtIEs,
        _PDUSessionResourceHandoverList__item_,
        PDUSessionResourceHandoverList,
        _PDUSessionResourceHandoverItem_pDUSessionID,
        __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain,
        _PDUSessionResourceHandoverItem_handoverCommandTransfer,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__id,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceHandoverItem_iE_Extensions__item_,
        _PDUSessionResourceHandoverItem_iE_Extensions,
        PDUSessionResourceHandoverItem,
        PDUSessionResourceHandoverItem_ExtIEs,
        _PDUSessionResourceInformationList__item_,
        PDUSessionResourceInformationList,
        _PDUSessionResourceInformationItem_pDUSessionID,
        _PDUSessionResourceInformationItem_qosFlowInformationList,
        _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__id,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceInformationItem_iE_Extensions__item_,
        _PDUSessionResourceInformationItem_iE_Extensions,
        PDUSessionResourceInformationItem,
        PDUSessionResourceInformationItem_ExtIEs,
        _PDUSessionResourceListCxtRelCpl__item_,
        PDUSessionResourceListCxtRelCpl,
        _PDUSessionResourceItemCxtRelCpl_pDUSessionID,
        ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab,
        ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain,
        _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_,
        _PDUSessionResourceItemCxtRelCpl_iE_Extensions,
        PDUSessionResourceItemCxtRelCpl,
        PDUSessionResourceItemCxtRelCpl_ExtIEs,
        __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain,
        _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0,
        _PDUSessionResourceListCxtRelReq__item_,
        PDUSessionResourceListCxtRelReq,
        _PDUSessionResourceItemCxtRelReq_pDUSessionID,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_,
        _PDUSessionResourceItemCxtRelReq_iE_Extensions,
        PDUSessionResourceItemCxtRelReq,
        PDUSessionResourceItemCxtRelReq_ExtIEs,
        _PDUSessionResourceListHORqd__item_,
        PDUSessionResourceListHORqd,
        _PDUSessionResourceItemHORqd_pDUSessionID,
        __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain,
        _PDUSessionResourceItemHORqd_handoverRequiredTransfer,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__id,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemHORqd_iE_Extensions__item_,
        _PDUSessionResourceItemHORqd_iE_Extensions,
        PDUSessionResourceItemHORqd,
        PDUSessionResourceItemHORqd_ExtIEs,
        _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList,
        _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation,
        _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation,
        _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList,
        ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyConfirmTransfer_iE_Extensions,
        PDUSessionResourceModifyConfirmTransfer,
        PDUSessionResourceModifyConfirmTransfer_ExtIEs,
        _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceModifyIndicationUnsuccessfulTransfer,
        PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs,
        ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value,
        __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_,
        _PDUSessionResourceModifyRequestTransfer_protocolIEs,
        PDUSessionResourceModifyRequestTransfer,
        PDUSessionResourceModifyRequestTransferIEs,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_0,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_1,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_2,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_3,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_4,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_5,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_6,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_7,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_8,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_9,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_10,
        _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation,
        _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation,
        _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList,
        _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation,
        _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList,
        ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyResponseTransfer_iE_Extensions,
        PDUSessionResourceModifyResponseTransfer,
        PDUSessionResourceModifyResponseTransfer_ExtIEs,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5,
        _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation,
        _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation,
        ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyIndicationTransfer_iE_Extensions,
        PDUSessionResourceModifyIndicationTransfer,
        PDUSessionResourceModifyIndicationTransfer_ExtIEs,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4,
        _PDUSessionResourceModifyListModCfm__item_,
        PDUSessionResourceModifyListModCfm,
        _PDUSessionResourceModifyItemModCfm_pDUSessionID,
        __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain,
        _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModCfm_iE_Extensions,
        PDUSessionResourceModifyItemModCfm,
        PDUSessionResourceModifyItemModCfm_ExtIEs,
        _PDUSessionResourceModifyListModInd__item_,
        PDUSessionResourceModifyListModInd,
        _PDUSessionResourceModifyItemModInd_pDUSessionID,
        __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain,
        _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModInd_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModInd_iE_Extensions,
        PDUSessionResourceModifyItemModInd,
        PDUSessionResourceModifyItemModInd_ExtIEs,
        _PDUSessionResourceModifyListModReq__item_,
        PDUSessionResourceModifyListModReq,
        _PDUSessionResourceModifyItemModReq_pDUSessionID,
        _PDUSessionResourceModifyItemModReq_nAS_PDU,
        __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain,
        _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer,
        ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModReq_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModReq_iE_Extensions,
        PDUSessionResourceModifyItemModReq,
        PDUSessionResourceModifyItemModReq_ExtIEs,
        _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyListModRes__item_,
        PDUSessionResourceModifyListModRes,
        _PDUSessionResourceModifyItemModRes_pDUSessionID,
        __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain,
        _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModRes_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModRes_iE_Extensions,
        PDUSessionResourceModifyItemModRes,
        PDUSessionResourceModifyItemModRes_ExtIEs,
        _PDUSessionResourceModifyUnsuccessfulTransfer_cause,
        _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceModifyUnsuccessfulTransfer,
        PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs,
        _PDUSessionResourceNotifyList__item_,
        PDUSessionResourceNotifyList,
        _PDUSessionResourceNotifyItem_pDUSessionID,
        __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain,
        _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__id,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyItem_iE_Extensions__item_,
        _PDUSessionResourceNotifyItem_iE_Extensions,
        PDUSessionResourceNotifyItem,
        PDUSessionResourceNotifyItem_ExtIEs,
        _PDUSessionResourceNotifyReleasedTransfer_cause,
        ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_,
        _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions,
        PDUSessionResourceNotifyReleasedTransfer,
        PDUSessionResourceNotifyReleasedTransfer_ExtIEs,
        _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceNotifyTransfer_qosFlowNotifyList,
        _PDUSessionResourceNotifyTransfer_qosFlowReleasedList,
        ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyTransfer_iE_Extensions__item_,
        _PDUSessionResourceNotifyTransfer_iE_Extensions,
        PDUSessionResourceNotifyTransfer,
        PDUSessionResourceNotifyTransfer_ExtIEs,
        _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceReleaseCommandTransfer_cause,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_,
        _PDUSessionResourceReleaseCommandTransfer_iE_Extensions,
        PDUSessionResourceReleaseCommandTransfer,
        PDUSessionResourceReleaseCommandTransfer_ExtIEs,
        _PDUSessionResourceReleasedListNot__item_,
        PDUSessionResourceReleasedListNot,
        _PDUSessionResourceReleasedItemNot_pDUSessionID,
        __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain,
        _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemNot_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemNot_iE_Extensions,
        PDUSessionResourceReleasedItemNot,
        PDUSessionResourceReleasedItemNot_ExtIEs,
        _PDUSessionResourceReleasedListPSAck__item_,
        PDUSessionResourceReleasedListPSAck,
        _PDUSessionResourceReleasedItemPSAck_pDUSessionID,
        __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain,
        _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemPSAck_iE_Extensions,
        PDUSessionResourceReleasedItemPSAck,
        PDUSessionResourceReleasedItemPSAck_ExtIEs,
        _PDUSessionResourceReleasedListPSFail__item_,
        PDUSessionResourceReleasedListPSFail,
        _PDUSessionResourceReleasedItemPSFail_pDUSessionID,
        __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain,
        _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemPSFail_iE_Extensions,
        PDUSessionResourceReleasedItemPSFail,
        PDUSessionResourceReleasedItemPSFail_ExtIEs,
        _PDUSessionResourceReleasedListRelRes__item_,
        PDUSessionResourceReleasedListRelRes,
        _PDUSessionResourceReleasedItemRelRes_pDUSessionID,
        __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain,
        _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemRelRes_iE_Extensions,
        PDUSessionResourceReleasedItemRelRes,
        PDUSessionResourceReleasedItemRelRes_ExtIEs,
        ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceReleaseResponseTransfer_iE_Extensions,
        PDUSessionResourceReleaseResponseTransfer,
        PDUSessionResourceReleaseResponseTransfer_ExtIEs,
        _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceResumeListRESReq__item_,
        PDUSessionResourceResumeListRESReq,
        _PDUSessionResourceResumeItemRESReq_pDUSessionID,
        __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain,
        _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_,
        _PDUSessionResourceResumeItemRESReq_iE_Extensions,
        PDUSessionResourceResumeItemRESReq,
        PDUSessionResourceResumeItemRESReq_ExtIEs,
        _PDUSessionResourceResumeListRESRes__item_,
        PDUSessionResourceResumeListRESRes,
        _PDUSessionResourceResumeItemRESRes_pDUSessionID,
        __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain,
        _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_,
        _PDUSessionResourceResumeItemRESRes_iE_Extensions,
        PDUSessionResourceResumeItemRESRes,
        PDUSessionResourceResumeItemRESRes_ExtIEs,
        _PDUSessionResourceSecondaryRATUsageList__item_,
        PDUSessionResourceSecondaryRATUsageList,
        _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID,
        __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain,
        _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_,
        _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions,
        PDUSessionResourceSecondaryRATUsageItem,
        PDUSessionResourceSecondaryRATUsageItem_ExtIEs,
        _PDUSessionResourceSetupListCxtReq__item_,
        PDUSessionResourceSetupListCxtReq,
        _PDUSessionResourceSetupItemCxtReq_pDUSessionID,
        _PDUSessionResourceSetupItemCxtReq_nAS_PDU,
        _PDUSessionResourceSetupItemCxtReq_s_NSSAI,
        __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain,
        _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer,
        ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemCxtReq_iE_Extensions,
        PDUSessionResourceSetupItemCxtReq,
        PDUSessionResourceSetupItemCxtReq_ExtIEs,
        _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListCxtRes__item_,
        PDUSessionResourceSetupListCxtRes,
        _PDUSessionResourceSetupItemCxtRes_pDUSessionID,
        __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain,
        _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_,
        _PDUSessionResourceSetupItemCxtRes_iE_Extensions,
        PDUSessionResourceSetupItemCxtRes,
        PDUSessionResourceSetupItemCxtRes_ExtIEs,
        _PDUSessionResourceSetupListHOReq__item_,
        PDUSessionResourceSetupListHOReq,
        _PDUSessionResourceSetupItemHOReq_pDUSessionID,
        _PDUSessionResourceSetupItemHOReq_s_NSSAI,
        __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain,
        _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer,
        ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemHOReq_iE_Extensions,
        PDUSessionResourceSetupItemHOReq,
        PDUSessionResourceSetupItemHOReq_ExtIEs,
        _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListSUReq__item_,
        PDUSessionResourceSetupListSUReq,
        _PDUSessionResourceSetupItemSUReq_pDUSessionID,
        _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU,
        _PDUSessionResourceSetupItemSUReq_s_NSSAI,
        __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain,
        _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer,
        ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemSUReq_iE_Extensions,
        PDUSessionResourceSetupItemSUReq,
        PDUSessionResourceSetupItemSUReq_ExtIEs,
        _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListSURes__item_,
        PDUSessionResourceSetupListSURes,
        _PDUSessionResourceSetupItemSURes_pDUSessionID,
        __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain,
        _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemSURes_iE_Extensions__item_,
        _PDUSessionResourceSetupItemSURes_iE_Extensions,
        PDUSessionResourceSetupItemSURes,
        PDUSessionResourceSetupItemSURes_ExtIEs,
        ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value,
        __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_,
        _PDUSessionResourceSetupRequestTransfer_protocolIEs,
        PDUSessionResourceSetupRequestTransfer,
        PDUSessionResourceSetupRequestTransferIEs,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_0,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_1,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_2,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_3,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_4,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_5,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_6,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_7,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_8,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_9,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_10,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_11,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_12,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_13,
        _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation,
        _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation,
        _PDUSessionResourceSetupResponseTransfer_securityResult,
        _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList,
        ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceSetupResponseTransfer_iE_Extensions,
        PDUSessionResourceSetupResponseTransfer,
        PDUSessionResourceSetupResponseTransfer_ExtIEs,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceSetupUnsuccessfulTransfer_cause,
        _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceSetupUnsuccessfulTransfer,
        PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs,
        _PDUSessionResourceSuspendListSUSReq__item_,
        PDUSessionResourceSuspendListSUSReq,
        _PDUSessionResourceSuspendItemSUSReq_pDUSessionID,
        __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain,
        _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_,
        _PDUSessionResourceSuspendItemSUSReq_iE_Extensions,
        PDUSessionResourceSuspendItemSUSReq,
        PDUSessionResourceSuspendItemSUSReq_ExtIEs,
        _PDUSessionResourceSwitchedList__item_,
        PDUSessionResourceSwitchedList,
        _PDUSessionResourceSwitchedItem_pDUSessionID,
        __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain,
        _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer,
        ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSwitchedItem_iE_Extensions__item_,
        _PDUSessionResourceSwitchedItem_iE_Extensions,
        PDUSessionResourceSwitchedItem,
        PDUSessionResourceSwitchedItem_ExtIEs,
        _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0,
        _PDUSessionResourceToBeSwitchedDLList__item_,
        PDUSessionResourceToBeSwitchedDLList,
        _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID,
        __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain,
        _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_,
        _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions,
        PDUSessionResourceToBeSwitchedDLItem,
        PDUSessionResourceToBeSwitchedDLItem_ExtIEs,
        _PDUSessionResourceToReleaseListHOCmd__item_,
        PDUSessionResourceToReleaseListHOCmd,
        _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID,
        __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain,
        _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_,
        _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions,
        PDUSessionResourceToReleaseItemHOCmd,
        PDUSessionResourceToReleaseItemHOCmd_ExtIEs,
        _PDUSessionResourceToReleaseListRelCmd__item_,
        PDUSessionResourceToReleaseListRelCmd,
        _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID,
        __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain,
        _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_,
        _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions,
        PDUSessionResourceToReleaseItemRelCmd,
        PDUSessionResourceToReleaseItemRelCmd_ExtIEs,
        PDUSessionType,
        _PDUSessionUsageReport_rATType,
        _PDUSessionUsageReport_pDUSessionTimedReportList,
        ____PDUSessionUsageReport_iE_Extensions__item__id_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__id,
        ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__criticality,
        ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__extensionValue,
        __PDUSessionUsageReport_iE_Extensions__item_,
        _PDUSessionUsageReport_iE_Extensions,
        PDUSessionUsageReport,
        PDUSessionUsageReport_ExtIEs,
        Periodicity,
        PeriodicRegistrationUpdateTimer,
        PLMNIdentity,
        _PLMNSupportList__item_,
        PLMNSupportList,
        _PLMNSupportItem_pLMNIdentity,
        _PLMNSupportItem_sliceSupportList,
        ____PLMNSupportItem_iE_Extensions__item__id_tab,
        _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___PLMNSupportItem_iE_Extensions__item__id,
        ___PLMNSupportItem_iE_Extensions__item__criticality,
        ___PLMNSupportItem_iE_Extensions__item__extensionValue,
        __PLMNSupportItem_iE_Extensions__item_,
        _PLMNSupportItem_iE_Extensions,
        PLMNSupportItem,
        PLMNSupportItem_ExtIEs,
        _PLMNSupportItem_ExtIEs_val_Extension_0,
        _PLMNSupportItem_ExtIEs_val_Extension_1,
        _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__id,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue,
        __PNI_NPN_MobilityInformation_iE_Extensions__item_,
        _PNI_NPN_MobilityInformation_iE_Extensions,
        PNI_NPN_MobilityInformation,
        PNI_NPN_MobilityInformation_ExtIEs,
        PortNumber,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevelARP,
        PriorityLevelQos,
        _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList,
        _PWSFailedCellIDList_nR_CGI_PWSFailedList,
        ___PWSFailedCellIDList_choice_Extensions_id_tab,
        __PWSFailedCellIDList_choice_Extensions_id,
        ___PWSFailedCellIDList_choice_Extensions_criticality_tab,
        __PWSFailedCellIDList_choice_Extensions_criticality,
        ___PWSFailedCellIDList_choice_Extensions_value_tab,
        __PWSFailedCellIDList_choice_Extensions_value,
        _PWSFailedCellIDList_choice_Extensions,
        PWSFailedCellIDList,
        PWSFailedCellIDList_ExtIEs,
        _QosCharacteristics_nonDynamic5QI,
        _QosCharacteristics_dynamic5QI,
        ___QosCharacteristics_choice_Extensions_id_tab,
        __QosCharacteristics_choice_Extensions_id,
        ___QosCharacteristics_choice_Extensions_criticality_tab,
        __QosCharacteristics_choice_Extensions_criticality,
        ___QosCharacteristics_choice_Extensions_value_tab,
        __QosCharacteristics_choice_Extensions_value,
        _QosCharacteristics_choice_Extensions,
        QosCharacteristics,
        QosCharacteristics_ExtIEs,
        _QosFlowAcceptedList__item_,
        QosFlowAcceptedList,
        _QosFlowAcceptedItem_qosFlowIdentifier,
        ____QosFlowAcceptedItem_iE_Extensions__item__id_tab,
        _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowAcceptedItem_iE_Extensions__item__id,
        ___QosFlowAcceptedItem_iE_Extensions__item__criticality,
        ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue,
        __QosFlowAcceptedItem_iE_Extensions__item_,
        _QosFlowAcceptedItem_iE_Extensions,
        QosFlowAcceptedItem,
        QosFlowAcceptedItem_ExtIEs,
        _QosFlowAcceptedItem_ExtIEs_val_Extension_0,
        _QosFlowAddOrModifyRequestList__item_,
        QosFlowAddOrModifyRequestList,
        _QosFlowAddOrModifyRequestItem_qosFlowIdentifier,
        _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters,
        _QosFlowAddOrModifyRequestItem_e_RAB_ID,
        ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab,
        _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue,
        __QosFlowAddOrModifyRequestItem_iE_Extensions__item_,
        _QosFlowAddOrModifyRequestItem_iE_Extensions,
        QosFlowAddOrModifyRequestItem,
        QosFlowAddOrModifyRequestItem_ExtIEs,
        _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0,
        _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1,
        _QosFlowAddOrModifyResponseList__item_,
        QosFlowAddOrModifyResponseList,
        _QosFlowAddOrModifyResponseItem_qosFlowIdentifier,
        ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab,
        _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue,
        __QosFlowAddOrModifyResponseItem_iE_Extensions__item_,
        _QosFlowAddOrModifyResponseItem_iE_Extensions,
        QosFlowAddOrModifyResponseItem,
        QosFlowAddOrModifyResponseItem_ExtIEs,
        _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0,
        _QosFlowFeedbackList__item_,
        QosFlowFeedbackList,
        _QosFlowFeedbackItem_qosFlowIdentifier,
        _QosFlowFeedbackItem_updateFeedback,
        _QosFlowFeedbackItem_cNpacketDelayBudgetDL,
        _QosFlowFeedbackItem_cNpacketDelayBudgetUL,
        ____QosFlowFeedbackItem_iE_Extensions__item__id_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__id,
        ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__criticality,
        ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue,
        __QosFlowFeedbackItem_iE_Extensions__item_,
        _QosFlowFeedbackItem_iE_Extensions,
        QosFlowFeedbackItem,
        QosFlowFeedbackItem_ExtIEs,
        QosFlowIdentifier,
        _QosFlowInformationList__item_,
        QosFlowInformationList,
        _QosFlowInformationItem_qosFlowIdentifier,
        _QosFlowInformationItem_dLForwarding,
        ____QosFlowInformationItem_iE_Extensions__item__id_tab,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___QosFlowInformationItem_iE_Extensions__item__id,
        ___QosFlowInformationItem_iE_Extensions__item__criticality,
        ___QosFlowInformationItem_iE_Extensions__item__extensionValue,
        __QosFlowInformationItem_iE_Extensions__item_,
        _QosFlowInformationItem_iE_Extensions,
        QosFlowInformationItem,
        QosFlowInformationItem_ExtIEs,
        _QosFlowInformationItem_ExtIEs_val_Extension_0,
        _QosFlowInformationItem_ExtIEs_val_Extension_1,
        _QosFlowInformationItem_ExtIEs_val_Extension_2,
        _QosFlowLevelQosParameters_qosCharacteristics,
        _QosFlowLevelQosParameters_allocationAndRetentionPriority,
        _QosFlowLevelQosParameters_gBR_QosInformation,
        _QosFlowLevelQosParameters_reflectiveQosAttribute,
        _QosFlowLevelQosParameters_additionalQosFlowInformation,
        ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab,
        _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowLevelQosParameters_iE_Extensions__item__id,
        ___QosFlowLevelQosParameters_iE_Extensions__item__criticality,
        ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue,
        __QosFlowLevelQosParameters_iE_Extensions__item_,
        _QosFlowLevelQosParameters_iE_Extensions,
        QosFlowLevelQosParameters,
        QosFlowLevelQosParameters_ExtIEs,
        _QosFlowLevelQosParameters_ExtIEs_val_Extension_0,
        _QosFlowLevelQosParameters_ExtIEs_val_Extension_1,
        QosMonitoringRequest,
        QosMonitoringReportingFrequency,
        _QosFlowListWithCause__item_,
        QosFlowListWithCause,
        _QosFlowWithCauseItem_qosFlowIdentifier,
        _QosFlowWithCauseItem_cause,
        ____QosFlowWithCauseItem_iE_Extensions__item__id_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__id,
        ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__criticality,
        ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue,
        __QosFlowWithCauseItem_iE_Extensions__item_,
        _QosFlowWithCauseItem_iE_Extensions,
        QosFlowWithCauseItem,
        QosFlowWithCauseItem_ExtIEs,
        _QosFlowModifyConfirmList__item_,
        QosFlowModifyConfirmList,
        _QosFlowModifyConfirmItem_qosFlowIdentifier,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__id,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue,
        __QosFlowModifyConfirmItem_iE_Extensions__item_,
        _QosFlowModifyConfirmItem_iE_Extensions,
        QosFlowModifyConfirmItem,
        QosFlowModifyConfirmItem_ExtIEs,
        _QosFlowNotifyList__item_,
        QosFlowNotifyList,
        _QosFlowNotifyItem_qosFlowIdentifier,
        _QosFlowNotifyItem_notificationCause,
        ____QosFlowNotifyItem_iE_Extensions__item__id_tab,
        _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowNotifyItem_iE_Extensions__item__id,
        ___QosFlowNotifyItem_iE_Extensions__item__criticality,
        ___QosFlowNotifyItem_iE_Extensions__item__extensionValue,
        __QosFlowNotifyItem_iE_Extensions__item_,
        _QosFlowNotifyItem_iE_Extensions,
        QosFlowNotifyItem,
        QosFlowNotifyItem_ExtIEs,
        _QosFlowNotifyItem_ExtIEs_val_Extension_0,
        _QosFlowParametersList__item_,
        QosFlowParametersList,
        _QosFlowParametersItem_qosFlowIdentifier,
        _QosFlowParametersItem_alternativeQoSParaSetList,
        ____QosFlowParametersItem_iE_Extensions__item__id_tab,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___QosFlowParametersItem_iE_Extensions__item__id,
        ___QosFlowParametersItem_iE_Extensions__item__criticality,
        ___QosFlowParametersItem_iE_Extensions__item__extensionValue,
        __QosFlowParametersItem_iE_Extensions__item_,
        _QosFlowParametersItem_iE_Extensions,
        QosFlowParametersItem,
        QosFlowParametersItem_ExtIEs,
        _QosFlowParametersItem_ExtIEs_val_Extension_0,
        _QosFlowParametersItem_ExtIEs_val_Extension_1,
        _QosFlowParametersItem_ExtIEs_val_Extension_2,
        _QosFlowPerTNLInformation_uPTransportLayerInformation,
        _QosFlowPerTNLInformation_associatedQosFlowList,
        ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__id,
        ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__criticality,
        ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue,
        __QosFlowPerTNLInformation_iE_Extensions__item_,
        _QosFlowPerTNLInformation_iE_Extensions,
        QosFlowPerTNLInformation,
        QosFlowPerTNLInformation_ExtIEs,
        _QosFlowPerTNLInformationList__item_,
        QosFlowPerTNLInformationList,
        _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__id,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue,
        __QosFlowPerTNLInformationItem_iE_Extensions__item_,
        _QosFlowPerTNLInformationItem_iE_Extensions,
        QosFlowPerTNLInformationItem,
        QosFlowPerTNLInformationItem_ExtIEs,
        _QosFlowSetupRequestList__item_,
        QosFlowSetupRequestList,
        _QosFlowSetupRequestItem_qosFlowIdentifier,
        _QosFlowSetupRequestItem_qosFlowLevelQosParameters,
        _QosFlowSetupRequestItem_e_RAB_ID,
        ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab,
        _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowSetupRequestItem_iE_Extensions__item__id,
        ___QosFlowSetupRequestItem_iE_Extensions__item__criticality,
        ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue,
        __QosFlowSetupRequestItem_iE_Extensions__item_,
        _QosFlowSetupRequestItem_iE_Extensions,
        QosFlowSetupRequestItem,
        QosFlowSetupRequestItem_ExtIEs,
        _QosFlowSetupRequestItem_ExtIEs_val_Extension_0,
        _QosFlowSetupRequestItem_ExtIEs_val_Extension_1,
        _QosFlowListWithDataForwarding__item_,
        QosFlowListWithDataForwarding,
        _QosFlowItemWithDataForwarding_qosFlowIdentifier,
        _QosFlowItemWithDataForwarding_dataForwardingAccepted,
        ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab,
        _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__id,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue,
        __QosFlowItemWithDataForwarding_iE_Extensions__item_,
        _QosFlowItemWithDataForwarding_iE_Extensions,
        QosFlowItemWithDataForwarding,
        QosFlowItemWithDataForwarding_ExtIEs,
        _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0,
        _QosFlowToBeForwardedList__item_,
        QosFlowToBeForwardedList,
        _QosFlowToBeForwardedItem_qosFlowIdentifier,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__id,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue,
        __QosFlowToBeForwardedItem_iE_Extensions__item_,
        _QosFlowToBeForwardedItem_iE_Extensions,
        QosFlowToBeForwardedItem,
        QosFlowToBeForwardedItem_ExtIEs,
        _QoSFlowsUsageReportList__item_,
        QoSFlowsUsageReportList,
        _QoSFlowsUsageReport_Item_qosFlowIdentifier,
        _QoSFlowsUsageReport_Item_rATType,
        _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__id,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue,
        __QoSFlowsUsageReport_Item_iE_Extensions__item_,
        _QoSFlowsUsageReport_Item_iE_Extensions,
        QoSFlowsUsageReport_Item,
        QoSFlowsUsageReport_Item_ExtIEs,
        Range,
        RANNodeName,
        RANNodeNameVisibleString,
        RANNodeNameUTF8String,
        RANPagingPriority,
        _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __RANStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _RANStatusTransfer_TransparentContainer_iE_Extensions,
        RANStatusTransfer_TransparentContainer,
        RANStatusTransfer_TransparentContainer_ExtIEs,
        RAN_UE_NGAP_ID,
        RAT_Information,
        _RATRestrictions__item_,
        RATRestrictions,
        _RATRestrictions_Item_pLMNIdentity,
        _RATRestrictions_Item_rATRestrictionInformation,
        ____RATRestrictions_Item_iE_Extensions__item__id_tab,
        _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___RATRestrictions_Item_iE_Extensions__item__id,
        ___RATRestrictions_Item_iE_Extensions__item__criticality,
        ___RATRestrictions_Item_iE_Extensions__item__extensionValue,
        __RATRestrictions_Item_iE_Extensions__item_,
        _RATRestrictions_Item_iE_Extensions,
        RATRestrictions_Item,
        RATRestrictions_Item_ExtIEs,
        _RATRestrictions_Item_ExtIEs_val_Extension_0,
        RATRestrictionInformation,
        _RecommendedCellsForPaging_recommendedCellList,
        ____RecommendedCellsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__id,
        ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__criticality,
        ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedCellsForPaging_iE_Extensions__item_,
        _RecommendedCellsForPaging_iE_Extensions,
        RecommendedCellsForPaging,
        RecommendedCellsForPaging_ExtIEs,
        _RecommendedCellList__item_,
        RecommendedCellList,
        _RecommendedCellItem_nGRAN_CGI,
        _RecommendedCellItem_timeStayedInCell,
        ____RecommendedCellItem_iE_Extensions__item__id_tab,
        ___RecommendedCellItem_iE_Extensions__item__id,
        ____RecommendedCellItem_iE_Extensions__item__criticality_tab,
        ___RecommendedCellItem_iE_Extensions__item__criticality,
        ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellItem_iE_Extensions__item__extensionValue,
        __RecommendedCellItem_iE_Extensions__item_,
        _RecommendedCellItem_iE_Extensions,
        RecommendedCellItem,
        RecommendedCellItem_ExtIEs,
        _RecommendedRANNodesForPaging_recommendedRANNodeList,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__id,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue,
        __RecommendedRANNodesForPaging_iE_Extensions__item_,
        _RecommendedRANNodesForPaging_iE_Extensions,
        RecommendedRANNodesForPaging,
        RecommendedRANNodesForPaging_ExtIEs,
        _RecommendedRANNodeList__item_,
        RecommendedRANNodeList,
        _RecommendedRANNodeItem_aMFPagingTarget,
        ____RecommendedRANNodeItem_iE_Extensions__item__id_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__id,
        ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__criticality,
        ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue,
        __RecommendedRANNodeItem_iE_Extensions__item_,
        _RecommendedRANNodeItem_iE_Extensions,
        RecommendedRANNodeItem,
        RecommendedRANNodeItem_ExtIEs,
        RedirectionVoiceFallback,
        _RedundantPDUSessionInformation_rSN,
        ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab,
        ___RedundantPDUSessionInformation_iE_Extensions__item__id,
        ____RedundantPDUSessionInformation_iE_Extensions__item__criticality_tab,
        ___RedundantPDUSessionInformation_iE_Extensions__item__criticality,
        ____RedundantPDUSessionInformation_iE_Extensions__item__extensionValue_tab,
        ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue,
        __RedundantPDUSessionInformation_iE_Extensions__item_,
        _RedundantPDUSessionInformation_iE_Extensions,
        RedundantPDUSessionInformation,
        RedundantPDUSessionInformation_ExtIEs,
        RedundantQosFlowIndicator,
        ReflectiveQosAttribute,
        RelativeAMFCapacity,
        ReportArea,
        RepetitionPeriod,
        ResetAll,
        ReportAmountMDT,
        ReportIntervalMDT,
        ExtendedReportIntervalMDT,
        _ResetType_nG_Interface,
        _ResetType_partOfNG_Interface,
        ___ResetType_choice_Extensions_id_tab,
        __ResetType_choice_Extensions_id,
        ___ResetType_choice_Extensions_criticality_tab,
        __ResetType_choice_Extensions_criticality,
        ___ResetType_choice_Extensions_value_tab,
        __ResetType_choice_Extensions_value,
        _ResetType_choice_Extensions,
        ResetType,
        ResetType_ExtIEs,
        RGLevelWirelineAccessCharacteristics,
        RNC_ID,
        RoutingID,
        RRCContainer,
        RRCEstablishmentCause,
        RRCInactiveTransitionReportRequest,
        RRCState,
        RSN,
        _RIMInformationTransfer_targetRANNodeID,
        _RIMInformationTransfer_sourceRANNodeID,
        _RIMInformationTransfer_rIMInformation,
        ____RIMInformationTransfer_iE_Extensions__item__id_tab,
        ___RIMInformationTransfer_iE_Extensions__item__id,
        ____RIMInformationTransfer_iE_Extensions__item__criticality_tab,
        ___RIMInformationTransfer_iE_Extensions__item__criticality,
        ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab,
        ___RIMInformationTransfer_iE_Extensions__item__extensionValue,
        __RIMInformationTransfer_iE_Extensions__item_,
        _RIMInformationTransfer_iE_Extensions,
        RIMInformationTransfer,
        RIMInformationTransfer_ExtIEs,
        _RIMInformation_targetgNBSetID,
        _RIMInformation_rIM_RSDetection,
        ____RIMInformation_iE_Extensions__item__id_tab,
        ___RIMInformation_iE_Extensions__item__id,
        ____RIMInformation_iE_Extensions__item__criticality_tab,
        ___RIMInformation_iE_Extensions__item__criticality,
        ____RIMInformation_iE_Extensions__item__extensionValue_tab,
        ___RIMInformation_iE_Extensions__item__extensionValue,
        __RIMInformation_iE_Extensions__item_,
        _RIMInformation_iE_Extensions,
        RIMInformation,
        RIMInformation_ExtIEs,
        GNBSetID,
        _ScheduledCommunicationTime_dayofWeek,
        _ScheduledCommunicationTime_timeofDayStart,
        _ScheduledCommunicationTime_timeofDayEnd,
        ____ScheduledCommunicationTime_iE_Extensions__item__id_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__id,
        ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__criticality,
        ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue,
        __ScheduledCommunicationTime_iE_Extensions__item_,
        _ScheduledCommunicationTime_iE_Extensions,
        ScheduledCommunicationTime,
        ScheduledCommunicationTime_ExtIEs,
        _SCTP_TLAs__item_,
        SCTP_TLAs,
        SD,
        _SecondaryRATUsageInformation_pDUSessionUsageReport,
        _SecondaryRATUsageInformation_qosFlowsUsageReportList,
        ____SecondaryRATUsageInformation_iE_Extension__item__id_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__id,
        ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__criticality,
        ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue,
        __SecondaryRATUsageInformation_iE_Extension__item_,
        _SecondaryRATUsageInformation_iE_Extension,
        SecondaryRATUsageInformation,
        SecondaryRATUsageInformation_ExtIEs,
        _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue,
        __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_,
        _SecondaryRATDataUsageReportTransfer_iE_Extensions,
        SecondaryRATDataUsageReportTransfer,
        SecondaryRATDataUsageReportTransfer_ExtIEs,
        _SecurityContext_nextHopChainingCount,
        _SecurityContext_nextHopNH,
        ____SecurityContext_iE_Extensions__item__id_tab,
        ___SecurityContext_iE_Extensions__item__id,
        ____SecurityContext_iE_Extensions__item__criticality_tab,
        ___SecurityContext_iE_Extensions__item__criticality,
        ____SecurityContext_iE_Extensions__item__extensionValue_tab,
        ___SecurityContext_iE_Extensions__item__extensionValue,
        __SecurityContext_iE_Extensions__item_,
        _SecurityContext_iE_Extensions,
        SecurityContext,
        SecurityContext_ExtIEs,
        _SecurityIndication_integrityProtectionIndication,
        _SecurityIndication_confidentialityProtectionIndication,
        _SecurityIndication_maximumIntegrityProtectedDataRate_UL,
        ____SecurityIndication_iE_Extensions__item__id_tab,
        _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0,
        ___SecurityIndication_iE_Extensions__item__id,
        ___SecurityIndication_iE_Extensions__item__criticality,
        ___SecurityIndication_iE_Extensions__item__extensionValue,
        __SecurityIndication_iE_Extensions__item_,
        _SecurityIndication_iE_Extensions,
        SecurityIndication,
        SecurityIndication_ExtIEs,
        _SecurityIndication_ExtIEs_val_Extension_0,
        SecurityKey,
        _SecurityResult_integrityProtectionResult,
        _SecurityResult_confidentialityProtectionResult,
        ____SecurityResult_iE_Extensions__item__id_tab,
        ___SecurityResult_iE_Extensions__item__id,
        ____SecurityResult_iE_Extensions__item__criticality_tab,
        ___SecurityResult_iE_Extensions__item__criticality,
        ____SecurityResult_iE_Extensions__item__extensionValue_tab,
        ___SecurityResult_iE_Extensions__item__extensionValue,
        __SecurityResult_iE_Extensions__item_,
        _SecurityResult_iE_Extensions,
        SecurityResult,
        SecurityResult_ExtIEs,
        _SensorMeasurementConfiguration_sensorMeasConfig,
        _SensorMeasurementConfiguration_sensorMeasConfigNameList,
        ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__id,
        ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__criticality,
        ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __SensorMeasurementConfiguration_iE_Extensions__item_,
        _SensorMeasurementConfiguration_iE_Extensions,
        SensorMeasurementConfiguration,
        SensorMeasurementConfiguration_ExtIEs,
        _SensorMeasConfigNameList__item_,
        SensorMeasConfigNameList,
        _SensorMeasConfigNameItem_sensorNameConfig,
        ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__id,
        ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__criticality,
        ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __SensorMeasConfigNameItem_iE_Extensions__item_,
        _SensorMeasConfigNameItem_iE_Extensions,
        SensorMeasConfigNameItem,
        SensorMeasConfigNameItem_ExtIEs,
        SensorMeasConfig,
        _SensorNameConfig_uncompensatedBarometricConfig,
        _SensorNameConfig_ueSpeedConfig,
        _SensorNameConfig_ueOrientationConfig,
        ___SensorNameConfig_choice_Extensions_id_tab,
        __SensorNameConfig_choice_Extensions_id,
        ___SensorNameConfig_choice_Extensions_criticality_tab,
        __SensorNameConfig_choice_Extensions_criticality,
        ___SensorNameConfig_choice_Extensions_value_tab,
        __SensorNameConfig_choice_Extensions_value,
        _SensorNameConfig_choice_Extensions,
        SensorNameConfig,
        SensorNameConfig_ExtIEs,
        SerialNumber,
        _ServedGUAMIList__item_,
        ServedGUAMIList,
        _ServedGUAMIItem_gUAMI,
        _ServedGUAMIItem_backupAMFName,
        ____ServedGUAMIItem_iE_Extensions__item__id_tab,
        _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServedGUAMIItem_iE_Extensions__item__id,
        ___ServedGUAMIItem_iE_Extensions__item__criticality,
        ___ServedGUAMIItem_iE_Extensions__item__extensionValue,
        __ServedGUAMIItem_iE_Extensions__item_,
        _ServedGUAMIItem_iE_Extensions,
        ServedGUAMIItem,
        ServedGUAMIItem_ExtIEs,
        _ServedGUAMIItem_ExtIEs_val_Extension_0,
        _ServiceAreaInformation__item_,
        ServiceAreaInformation,
        _ServiceAreaInformation_Item_pLMNIdentity,
        _ServiceAreaInformation_Item_allowedTACs,
        _ServiceAreaInformation_Item_notAllowedTACs,
        ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__id,
        ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__criticality,
        ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue,
        __ServiceAreaInformation_Item_iE_Extensions__item_,
        _ServiceAreaInformation_Item_iE_Extensions,
        ServiceAreaInformation_Item,
        ServiceAreaInformation_Item_ExtIEs,
        SgNB_UE_X2AP_ID,
        _SliceOverloadList__item_,
        SliceOverloadList,
        _SliceOverloadItem_s_NSSAI,
        ____SliceOverloadItem_iE_Extensions__item__id_tab,
        ___SliceOverloadItem_iE_Extensions__item__id,
        ____SliceOverloadItem_iE_Extensions__item__criticality_tab,
        ___SliceOverloadItem_iE_Extensions__item__criticality,
        ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab,
        ___SliceOverloadItem_iE_Extensions__item__extensionValue,
        __SliceOverloadItem_iE_Extensions__item_,
        _SliceOverloadItem_iE_Extensions,
        SliceOverloadItem,
        SliceOverloadItem_ExtIEs,
        _SliceSupportList__item_,
        SliceSupportList,
        _SliceSupportItem_s_NSSAI,
        ____SliceSupportItem_iE_Extensions__item__id_tab,
        ___SliceSupportItem_iE_Extensions__item__id,
        ____SliceSupportItem_iE_Extensions__item__criticality_tab,
        ___SliceSupportItem_iE_Extensions__item__criticality,
        ____SliceSupportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceSupportItem_iE_Extensions__item__extensionValue,
        __SliceSupportItem_iE_Extensions__item_,
        _SliceSupportItem_iE_Extensions,
        SliceSupportItem,
        SliceSupportItem_ExtIEs,
        _SNPN_MobilityInformation_serving_NID,
        ____SNPN_MobilityInformation_iE_Extensions__item__id_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__id,
        ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__criticality,
        ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue,
        __SNPN_MobilityInformation_iE_Extensions__item_,
        _SNPN_MobilityInformation_iE_Extensions,
        SNPN_MobilityInformation,
        SNPN_MobilityInformation_ExtIEs,
        _S_NSSAI_sST,
        _S_NSSAI_sD,
        ____S_NSSAI_iE_Extensions__item__id_tab,
        ___S_NSSAI_iE_Extensions__item__id,
        ____S_NSSAI_iE_Extensions__item__criticality_tab,
        ___S_NSSAI_iE_Extensions__item__criticality,
        ____S_NSSAI_iE_Extensions__item__extensionValue_tab,
        ___S_NSSAI_iE_Extensions__item__extensionValue,
        __S_NSSAI_iE_Extensions__item_,
        _S_NSSAI_iE_Extensions,
        S_NSSAI,
        S_NSSAI_ExtIEs,
        _SONConfigurationTransfer_targetRANNodeID,
        _SONConfigurationTransfer_sourceRANNodeID,
        _SONConfigurationTransfer_sONInformation,
        _SONConfigurationTransfer_xnTNLConfigurationInfo,
        ____SONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__id,
        ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__criticality,
        ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __SONConfigurationTransfer_iE_Extensions__item_,
        _SONConfigurationTransfer_iE_Extensions,
        SONConfigurationTransfer,
        SONConfigurationTransfer_ExtIEs,
        _SONInformation_sONInformationRequest,
        _SONInformation_sONInformationReply,
        ___SONInformation_choice_Extensions_id_tab,
        ____SONInformation_choice_Extensions_id_tab_val_Value_0,
        __SONInformation_choice_Extensions_id,
        __SONInformation_choice_Extensions_criticality,
        __SONInformation_choice_Extensions_value,
        _SONInformation_choice_Extensions,
        SONInformation,
        SONInformation_ExtIEs,
        _SONInformation_ExtIEs_val_Value_0,
        _SONInformationReply_xnTNLConfigurationInfo,
        ____SONInformationReply_iE_Extensions__item__id_tab,
        ___SONInformationReply_iE_Extensions__item__id,
        ____SONInformationReply_iE_Extensions__item__criticality_tab,
        ___SONInformationReply_iE_Extensions__item__criticality,
        ____SONInformationReply_iE_Extensions__item__extensionValue_tab,
        ___SONInformationReply_iE_Extensions__item__extensionValue,
        __SONInformationReply_iE_Extensions__item_,
        _SONInformationReply_iE_Extensions,
        SONInformationReply,
        SONInformationReply_ExtIEs,
        _SONInformationReport_failureIndicationInformation,
        _SONInformationReport_hOReportInformation,
        ___SONInformationReport_choice_Extensions_id_tab,
        __SONInformationReport_choice_Extensions_id,
        ___SONInformationReport_choice_Extensions_criticality_tab,
        __SONInformationReport_choice_Extensions_criticality,
        ___SONInformationReport_choice_Extensions_value_tab,
        __SONInformationReport_choice_Extensions_value,
        _SONInformationReport_choice_Extensions,
        SONInformationReport,
        SONInformationReport_ExtIEs,
        SONInformationRequest,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation,
        ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions,
        SourceNGRANNode_ToTargetNGRANNode_TransparentContainer,
        SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceNodeID_sourceengNB_ID,
        ___SourceNodeID_choice_Extensions_id_tab,
        __SourceNodeID_choice_Extensions_id,
        ___SourceNodeID_choice_Extensions_criticality_tab,
        __SourceNodeID_choice_Extensions_criticality,
        ___SourceNodeID_choice_Extensions_value_tab,
        __SourceNodeID_choice_Extensions_value,
        _SourceNodeID_choice_Extensions,
        SourceNodeID,
        SourceNodeID_ExtIEs,
        SourceOfUEActivityBehaviourInformation,
        _SourceRANNodeID_globalRANNodeID,
        _SourceRANNodeID_selectedTAI,
        ____SourceRANNodeID_iE_Extensions__item__id_tab,
        ___SourceRANNodeID_iE_Extensions__item__id,
        ____SourceRANNodeID_iE_Extensions__item__criticality_tab,
        ___SourceRANNodeID_iE_Extensions__item__criticality,
        ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab,
        ___SourceRANNodeID_iE_Extensions__item__extensionValue,
        __SourceRANNodeID_iE_Extensions__item_,
        _SourceRANNodeID_iE_Extensions,
        SourceRANNodeID,
        SourceRANNodeID_ExtIEs,
        SourceToTarget_TransparentContainer,
        _SourceToTarget_AMFInformationReroute_configuredNSSAI,
        _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN,
        _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue,
        __SourceToTarget_AMFInformationReroute_iE_Extensions__item_,
        _SourceToTarget_AMFInformationReroute_iE_Extensions,
        SourceToTarget_AMFInformationReroute,
        SourceToTarget_AMFInformationReroute_ExtIEs,
        SRVCCOperationPossible,
        ConfiguredNSSAI,
        RejectedNSSAIinPLMN,
        RejectedNSSAIinTA,
        SST,
        _SupportedTAList__item_,
        SupportedTAList,
        _SupportedTAItem_tAC,
        _SupportedTAItem_broadcastPLMNList,
        ____SupportedTAItem_iE_Extensions__item__id_tab,
        _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___SupportedTAItem_iE_Extensions__item__id,
        ___SupportedTAItem_iE_Extensions__item__criticality,
        ___SupportedTAItem_iE_Extensions__item__extensionValue,
        __SupportedTAItem_iE_Extensions__item_,
        _SupportedTAItem_iE_Extensions,
        SupportedTAItem,
        SupportedTAItem_ExtIEs,
        _SupportedTAItem_ExtIEs_val_Extension_0,
        _SupportedTAItem_ExtIEs_val_Extension_1,
        SuspendIndicator,
        Suspend_Request_Indication,
        Suspend_Response_Indication,
        TAC,
        _TAI_pLMNIdentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        _TAIBroadcastEUTRA__item_,
        TAIBroadcastEUTRA,
        _TAIBroadcastEUTRA_Item_tAI,
        _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __TAIBroadcastEUTRA_Item_iE_Extensions__item_,
        _TAIBroadcastEUTRA_Item_iE_Extensions,
        TAIBroadcastEUTRA_Item,
        TAIBroadcastEUTRA_Item_ExtIEs,
        _TAIBroadcastNR__item_,
        TAIBroadcastNR,
        _TAIBroadcastNR_Item_tAI,
        _TAIBroadcastNR_Item_completedCellsInTAI_NR,
        ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__id,
        ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__criticality,
        ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __TAIBroadcastNR_Item_iE_Extensions__item_,
        _TAIBroadcastNR_Item_iE_Extensions,
        TAIBroadcastNR_Item,
        TAIBroadcastNR_Item_ExtIEs,
        _TAICancelledEUTRA__item_,
        TAICancelledEUTRA,
        _TAICancelledEUTRA_Item_tAI,
        _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__id,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __TAICancelledEUTRA_Item_iE_Extensions__item_,
        _TAICancelledEUTRA_Item_iE_Extensions,
        TAICancelledEUTRA_Item,
        TAICancelledEUTRA_Item_ExtIEs,
        _TAICancelledNR__item_,
        TAICancelledNR,
        _TAICancelledNR_Item_tAI,
        _TAICancelledNR_Item_cancelledCellsInTAI_NR,
        ____TAICancelledNR_Item_iE_Extensions__item__id_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__id,
        ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__criticality,
        ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__extensionValue,
        __TAICancelledNR_Item_iE_Extensions__item_,
        _TAICancelledNR_Item_iE_Extensions,
        TAICancelledNR_Item,
        TAICancelledNR_Item_ExtIEs,
        _TAIListForInactive__item_,
        TAIListForInactive,
        _TAIListForInactiveItem_tAI,
        ____TAIListForInactiveItem_iE_Extensions__item__id_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__id,
        ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__criticality,
        ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__extensionValue,
        __TAIListForInactiveItem_iE_Extensions__item_,
        _TAIListForInactiveItem_iE_Extensions,
        TAIListForInactiveItem,
        TAIListForInactiveItem_ExtIEs,
        _TAIListForPaging__item_,
        TAIListForPaging,
        _TAIListForPagingItem_tAI,
        ____TAIListForPagingItem_iE_Extensions__item__id_tab,
        ___TAIListForPagingItem_iE_Extensions__item__id,
        ____TAIListForPagingItem_iE_Extensions__item__criticality_tab,
        ___TAIListForPagingItem_iE_Extensions__item__criticality,
        ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab,
        ___TAIListForPagingItem_iE_Extensions__item__extensionValue,
        __TAIListForPagingItem_iE_Extensions__item_,
        _TAIListForPagingItem_iE_Extensions,
        TAIListForPagingItem,
        TAIListForPagingItem_ExtIEs,
        _TAIListForRestart__item_,
        TAIListForRestart,
        _TAIListForWarning__item_,
        TAIListForWarning,
        _TargeteNB_ID_globalENB_ID,
        _TargeteNB_ID_selected_EPS_TAI,
        ____TargeteNB_ID_iE_Extensions__item__id_tab,
        ___TargeteNB_ID_iE_Extensions__item__id,
        ____TargeteNB_ID_iE_Extensions__item__criticality_tab,
        ___TargeteNB_ID_iE_Extensions__item__criticality,
        ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargeteNB_ID_iE_Extensions__item__extensionValue,
        __TargeteNB_ID_iE_Extensions__item_,
        _TargeteNB_ID_iE_Extensions,
        TargeteNB_ID,
        TargeteNB_ID_ExtIEs,
        _TargetID_targetRANNodeID,
        _TargetID_targeteNB_ID,
        ___TargetID_choice_Extensions_id_tab,
        ____TargetID_choice_Extensions_id_tab_val_Value_0,
        __TargetID_choice_Extensions_id,
        __TargetID_choice_Extensions_criticality,
        __TargetID_choice_Extensions_value,
        _TargetID_choice_Extensions,
        TargetID,
        TargetID_ExtIEs,
        _TargetID_ExtIEs_val_Value_0,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer,
        ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions,
        TargetNGRANNode_ToSourceNGRANNode_TransparentContainer,
        TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1,
        _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation,
        ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id,
        ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality_tab,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality,
        ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue,
        __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_,
        _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions,
        TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer,
        TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs,
        _TargetRANNodeID_globalRANNodeID,
        _TargetRANNodeID_selectedTAI,
        ____TargetRANNodeID_iE_Extensions__item__id_tab,
        ___TargetRANNodeID_iE_Extensions__item__id,
        ____TargetRANNodeID_iE_Extensions__item__criticality_tab,
        ___TargetRANNodeID_iE_Extensions__item__criticality,
        ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab,
        ___TargetRANNodeID_iE_Extensions__item__extensionValue,
        __TargetRANNodeID_iE_Extensions__item_,
        _TargetRANNodeID_iE_Extensions,
        TargetRANNodeID,
        TargetRANNodeID_ExtIEs,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rNC_ID,
        _TargetRNC_ID_extendedRNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ____TargetRNC_ID_iE_Extensions__item__criticality_tab,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        TargetToSource_TransparentContainer,
        TargettoSource_Failure_TransparentContainer,
        TimerApproachForGUAMIRemoval,
        TimeStamp,
        TimeToWait,
        TimeUEStayedInCell,
        TimeUEStayedInCellEnhancedGranularity,
        TNAP_ID,
        _TNGF_ID_tNGF_ID,
        ___TNGF_ID_choice_Extensions_id_tab,
        __TNGF_ID_choice_Extensions_id,
        ___TNGF_ID_choice_Extensions_criticality_tab,
        __TNGF_ID_choice_Extensions_criticality,
        ___TNGF_ID_choice_Extensions_value_tab,
        __TNGF_ID_choice_Extensions_value,
        _TNGF_ID_choice_Extensions,
        TNGF_ID,
        TNGF_ID_ExtIEs,
        TNLAddressWeightFactor,
        _TNLAssociationList__item_,
        TNLAssociationList,
        _TNLAssociationItem_tNLAssociationAddress,
        _TNLAssociationItem_cause,
        ____TNLAssociationItem_iE_Extensions__item__id_tab,
        ___TNLAssociationItem_iE_Extensions__item__id,
        ____TNLAssociationItem_iE_Extensions__item__criticality_tab,
        ___TNLAssociationItem_iE_Extensions__item__criticality,
        ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab,
        ___TNLAssociationItem_iE_Extensions__item__extensionValue,
        __TNLAssociationItem_iE_Extensions__item_,
        _TNLAssociationItem_iE_Extensions,
        TNLAssociationItem,
        TNLAssociationItem_ExtIEs,
        TNLAssociationUsage,
        _TooearlyIntersystemHO_sourcecellID,
        _TooearlyIntersystemHO_failurecellID,
        _TooearlyIntersystemHO_uERLFReportContainer,
        ____TooearlyIntersystemHO_iE_Extensions__item__id_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__id,
        ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__criticality,
        ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue,
        __TooearlyIntersystemHO_iE_Extensions__item_,
        _TooearlyIntersystemHO_iE_Extensions,
        TooearlyIntersystemHO,
        TooearlyIntersystemHO_ExtIEs,
        _TraceActivation_nGRANTraceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        TraceDepth,
        TrafficLoadReductionIndication,
        TransportLayerAddress,
        TypeOfError,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ____TAIBasedMDT_iE_Extensions__item__criticality_tab,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ____TABasedMDT_iE_Extensions__item__criticality_tab,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ____TABasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        Threshold_RSRP,
        Threshold_RSRQ,
        Threshold_SINR,
        TimeToTrigger,
        TWAP_ID,
        _TWIF_ID_tWIF_ID,
        ___TWIF_ID_choice_Extensions_id_tab,
        __TWIF_ID_choice_Extensions_id,
        ___TWIF_ID_choice_Extensions_criticality_tab,
        __TWIF_ID_choice_Extensions_criticality,
        ___TWIF_ID_choice_Extensions_value_tab,
        __TWIF_ID_choice_Extensions_value,
        _TWIF_ID_choice_Extensions,
        TWIF_ID,
        TWIF_ID_ExtIEs,
        _TSCAssistanceInformation_periodicity,
        _TSCAssistanceInformation_burstArrivalTime,
        ____TSCAssistanceInformation_iE_Extensions__item__id_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__id,
        ____TSCAssistanceInformation_iE_Extensions__item__criticality_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__criticality,
        ____TSCAssistanceInformation_iE_Extensions__item__extensionValue_tab,
        ___TSCAssistanceInformation_iE_Extensions__item__extensionValue,
        __TSCAssistanceInformation_iE_Extensions__item_,
        _TSCAssistanceInformation_iE_Extensions,
        TSCAssistanceInformation,
        TSCAssistanceInformation_ExtIEs,
        _TSCTrafficCharacteristics_tSCAssistanceInformationDL,
        _TSCTrafficCharacteristics_tSCAssistanceInformationUL,
        ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__id,
        ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__criticality,
        ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue,
        __TSCTrafficCharacteristics_iE_Extensions__item_,
        _TSCTrafficCharacteristics_iE_Extensions,
        TSCTrafficCharacteristics,
        TSCTrafficCharacteristics_ExtIEs,
        _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL,
        _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__id,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitRate_iE_Extensions__item_,
        _UEAggregateMaximumBitRate_iE_Extensions,
        UEAggregateMaximumBitRate,
        UEAggregateMaximumBitRate_ExtIEs,
        _UE_associatedLogicalNG_connectionList__item_,
        UE_associatedLogicalNG_connectionList,
        _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID,
        _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_,
        _UE_associatedLogicalNG_connectionItem_iE_Extensions,
        UE_associatedLogicalNG_connectionItem,
        UE_associatedLogicalNG_connectionItem_ExtIEs,
        UECapabilityInfoRequest,
        UEContextRequest,
        _UEContextResumeRequestTransfer_qosFlowFailedToResumeList,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__id,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue,
        __UEContextResumeRequestTransfer_iE_Extensions__item_,
        _UEContextResumeRequestTransfer_iE_Extensions,
        UEContextResumeRequestTransfer,
        UEContextResumeRequestTransfer_ExtIEs,
        _UEContextResumeResponseTransfer_qosFlowFailedToResumeList,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__id,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue,
        __UEContextResumeResponseTransfer_iE_Extensions__item_,
        _UEContextResumeResponseTransfer_iE_Extensions,
        UEContextResumeResponseTransfer,
        UEContextResumeResponseTransfer_ExtIEs,
        _UEContextSuspendRequestTransfer_suspendIndicator,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__id,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue,
        __UEContextSuspendRequestTransfer_iE_Extensions__item_,
        _UEContextSuspendRequestTransfer_iE_Extensions,
        UEContextSuspendRequestTransfer,
        UEContextSuspendRequestTransfer_ExtIEs,
        _UE_DifferentiationInfo_periodicCommunicationIndicator,
        _UE_DifferentiationInfo_periodicTime,
        _UE_DifferentiationInfo_scheduledCommunicationTime,
        _UE_DifferentiationInfo_stationaryIndication,
        _UE_DifferentiationInfo_trafficProfile,
        _UE_DifferentiationInfo_batteryIndication,
        ____UE_DifferentiationInfo_iE_Extensions__item__id_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__id,
        ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__criticality,
        ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue,
        __UE_DifferentiationInfo_iE_Extensions__item_,
        _UE_DifferentiationInfo_iE_Extensions,
        UE_DifferentiationInfo,
        UE_DifferentiationInfo_ExtIEs,
        _UEHistoryInformation__item_,
        UEHistoryInformation,
        _UEHistoryInformationFromTheUE_nR,
        ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_id,
        ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_criticality,
        ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_value,
        _UEHistoryInformationFromTheUE_choice_Extensions,
        UEHistoryInformationFromTheUE,
        UEHistoryInformationFromTheUE_ExtIEs,
        _UEIdentityIndexValue_indexLength10,
        ___UEIdentityIndexValue_choice_Extensions_id_tab,
        __UEIdentityIndexValue_choice_Extensions_id,
        ___UEIdentityIndexValue_choice_Extensions_criticality_tab,
        __UEIdentityIndexValue_choice_Extensions_criticality,
        ___UEIdentityIndexValue_choice_Extensions_value_tab,
        __UEIdentityIndexValue_choice_Extensions_value,
        _UEIdentityIndexValue_choice_Extensions,
        UEIdentityIndexValue,
        UEIdentityIndexValue_ExtIEs,
        _UE_NGAP_IDs_uE_NGAP_ID_pair,
        _UE_NGAP_IDs_aMF_UE_NGAP_ID,
        ___UE_NGAP_IDs_choice_Extensions_id_tab,
        __UE_NGAP_IDs_choice_Extensions_id,
        ___UE_NGAP_IDs_choice_Extensions_criticality_tab,
        __UE_NGAP_IDs_choice_Extensions_criticality,
        ___UE_NGAP_IDs_choice_Extensions_value_tab,
        __UE_NGAP_IDs_choice_Extensions_value,
        _UE_NGAP_IDs_choice_Extensions,
        UE_NGAP_IDs,
        UE_NGAP_IDs_ExtIEs,
        _UE_NGAP_ID_pair_aMF_UE_NGAP_ID,
        _UE_NGAP_ID_pair_rAN_UE_NGAP_ID,
        ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__id,
        ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__criticality,
        ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue,
        __UE_NGAP_ID_pair_iE_Extensions__item_,
        _UE_NGAP_ID_pair_iE_Extensions,
        UE_NGAP_ID_pair,
        UE_NGAP_ID_pair_ExtIEs,
        _UEPagingIdentity_fiveG_S_TMSI,
        ___UEPagingIdentity_choice_Extensions_id_tab,
        __UEPagingIdentity_choice_Extensions_id,
        ___UEPagingIdentity_choice_Extensions_criticality_tab,
        __UEPagingIdentity_choice_Extensions_criticality,
        ___UEPagingIdentity_choice_Extensions_value_tab,
        __UEPagingIdentity_choice_Extensions_value,
        _UEPagingIdentity_choice_Extensions,
        UEPagingIdentity,
        UEPagingIdentity_ExtIEs,
        UEPresence,
        _UEPresenceInAreaOfInterestList__item_,
        UEPresenceInAreaOfInterestList,
        _UEPresenceInAreaOfInterestItem_locationReportingReferenceID,
        _UEPresenceInAreaOfInterestItem_uEPresence,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue,
        __UEPresenceInAreaOfInterestItem_iE_Extensions__item_,
        _UEPresenceInAreaOfInterestItem_iE_Extensions,
        UEPresenceInAreaOfInterestItem,
        UEPresenceInAreaOfInterestItem_ExtIEs,
        UERadioCapability,
        _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR,
        _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA,
        ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab,
        _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0,
        ___UERadioCapabilityForPaging_iE_Extensions__item__id,
        ___UERadioCapabilityForPaging_iE_Extensions__item__criticality,
        ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue,
        __UERadioCapabilityForPaging_iE_Extensions__item_,
        _UERadioCapabilityForPaging_iE_Extensions,
        UERadioCapabilityForPaging,
        UERadioCapabilityForPaging_ExtIEs,
        _UERadioCapabilityForPaging_ExtIEs_val_Extension_0,
        UERadioCapabilityForPagingOfNB_IoT,
        UERadioCapabilityForPagingOfNR,
        UERadioCapabilityForPagingOfEUTRA,
        UERadioCapabilityID,
        UERetentionInformation,
        _UERLFReportContainer_nR,
        _UERLFReportContainer_lTE,
        ___UERLFReportContainer_choice_Extensions_id_tab,
        __UERLFReportContainer_choice_Extensions_id,
        ___UERLFReportContainer_choice_Extensions_criticality_tab,
        __UERLFReportContainer_choice_Extensions_criticality,
        ___UERLFReportContainer_choice_Extensions_value_tab,
        __UERLFReportContainer_choice_Extensions_value,
        _UERLFReportContainer_choice_Extensions,
        UERLFReportContainer,
        UERLFReportContainer_ExtIEs,
        _UESecurityCapabilities_nRencryptionAlgorithms,
        _UESecurityCapabilities_nRintegrityProtectionAlgorithms,
        _UESecurityCapabilities_eUTRAencryptionAlgorithms,
        _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ____UESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        UE_UP_CIoT_Support,
        _UL_CP_SecurityInformation_ul_NAS_MAC,
        _UL_CP_SecurityInformation_ul_NAS_Count,
        ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__id,
        ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __UL_CP_SecurityInformation_iE_Extensions__item_,
        _UL_CP_SecurityInformation_iE_Extensions,
        UL_CP_SecurityInformation,
        UL_CP_SecurityInformation_ExtIEs,
        UL_NAS_MAC,
        UL_NAS_Count,
        _UL_NGU_UP_TNLModifyList__item_,
        UL_NGU_UP_TNLModifyList,
        _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation,
        _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation,
        ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab,
        _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue,
        __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_,
        _UL_NGU_UP_TNLModifyItem_iE_Extensions,
        UL_NGU_UP_TNLModifyItem,
        UL_NGU_UP_TNLModifyItem_ExtIEs,
        _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0,
        _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1,
        _UnavailableGUAMIList__item_,
        UnavailableGUAMIList,
        _UnavailableGUAMIItem_gUAMI,
        _UnavailableGUAMIItem_timerApproachForGUAMIRemoval,
        _UnavailableGUAMIItem_backupAMFName,
        ____UnavailableGUAMIItem_iE_Extensions__item__id_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__id,
        ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__criticality,
        ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue,
        __UnavailableGUAMIItem_iE_Extensions__item_,
        _UnavailableGUAMIItem_iE_Extensions,
        UnavailableGUAMIItem,
        UnavailableGUAMIItem_ExtIEs,
        ULForwarding,
        UpdateFeedback,
        _UPTransportLayerInformation_gTPTunnel,
        ___UPTransportLayerInformation_choice_Extensions_id_tab,
        __UPTransportLayerInformation_choice_Extensions_id,
        ___UPTransportLayerInformation_choice_Extensions_criticality_tab,
        __UPTransportLayerInformation_choice_Extensions_criticality,
        ___UPTransportLayerInformation_choice_Extensions_value_tab,
        __UPTransportLayerInformation_choice_Extensions_value,
        _UPTransportLayerInformation_choice_Extensions,
        UPTransportLayerInformation,
        UPTransportLayerInformation_ExtIEs,
        _UPTransportLayerInformationList__item_,
        UPTransportLayerInformationList,
        _UPTransportLayerInformationItem_nGU_UP_TNLInformation,
        ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab,
        _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___UPTransportLayerInformationItem_iE_Extensions__item__id,
        ___UPTransportLayerInformationItem_iE_Extensions__item__criticality,
        ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue,
        __UPTransportLayerInformationItem_iE_Extensions__item_,
        _UPTransportLayerInformationItem_iE_Extensions,
        UPTransportLayerInformationItem,
        UPTransportLayerInformationItem_ExtIEs,
        _UPTransportLayerInformationItem_ExtIEs_val_Extension_0,
        _UPTransportLayerInformationPairList__item_,
        UPTransportLayerInformationPairList,
        _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation,
        _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__id,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue,
        __UPTransportLayerInformationPairItem_iE_Extensions__item_,
        _UPTransportLayerInformationPairItem_iE_Extensions,
        UPTransportLayerInformationPairItem,
        UPTransportLayerInformationPairItem_ExtIEs,
        URI_address,
        _UserLocationInformation_userLocationInformationEUTRA,
        _UserLocationInformation_userLocationInformationNR,
        _UserLocationInformation_userLocationInformationN3IWF,
        ___UserLocationInformation_choice_Extensions_id_tab,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2,
        __UserLocationInformation_choice_Extensions_id,
        __UserLocationInformation_choice_Extensions_criticality,
        __UserLocationInformation_choice_Extensions_value,
        _UserLocationInformation_choice_Extensions,
        UserLocationInformation,
        UserLocationInformation_ExtIEs,
        _UserLocationInformation_ExtIEs_val_Value_0,
        _UserLocationInformation_ExtIEs_val_Value_1,
        _UserLocationInformation_ExtIEs_val_Value_2,
        _UserLocationInformationEUTRA_eUTRA_CGI,
        _UserLocationInformationEUTRA_tAI,
        _UserLocationInformationEUTRA_timeStamp,
        ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab,
        _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformationEUTRA_iE_Extensions__item__id,
        ___UserLocationInformationEUTRA_iE_Extensions__item__criticality,
        ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue,
        __UserLocationInformationEUTRA_iE_Extensions__item_,
        _UserLocationInformationEUTRA_iE_Extensions,
        UserLocationInformationEUTRA,
        UserLocationInformationEUTRA_ExtIEs,
        _UserLocationInformationEUTRA_ExtIEs_val_Extension_0,
        _UserLocationInformationN3IWF_iPAddress,
        _UserLocationInformationN3IWF_portNumber,
        ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab,
        ___UserLocationInformationN3IWF_iE_Extensions__item__id,
        ____UserLocationInformationN3IWF_iE_Extensions__item__criticality_tab,
        ___UserLocationInformationN3IWF_iE_Extensions__item__criticality,
        ____UserLocationInformationN3IWF_iE_Extensions__item__extensionValue_tab,
        ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue,
        __UserLocationInformationN3IWF_iE_Extensions__item_,
        _UserLocationInformationN3IWF_iE_Extensions,
        UserLocationInformationN3IWF,
        UserLocationInformationN3IWF_ExtIEs,
        _UserLocationInformationTNGF_tNAP_ID,
        _UserLocationInformationTNGF_iPAddress,
        _UserLocationInformationTNGF_portNumber,
        ____UserLocationInformationTNGF_iE_Extensions__item__id_tab,
        ___UserLocationInformationTNGF_iE_Extensions__item__id,
        ____UserLocationInformationTNGF_iE_Extensions__item__criticality_tab,
        ___UserLocationInformationTNGF_iE_Extensions__item__criticality,
        ____UserLocationInformationTNGF_iE_Extensions__item__extensionValue_tab,
        ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue,
        __UserLocationInformationTNGF_iE_Extensions__item_,
        _UserLocationInformationTNGF_iE_Extensions,
        UserLocationInformationTNGF,
        UserLocationInformationTNGF_ExtIEs,
        _UserLocationInformationTWIF_tWAP_ID,
        _UserLocationInformationTWIF_iPAddress,
        _UserLocationInformationTWIF_portNumber,
        ____UserLocationInformationTWIF_iE_Extensions__item__id_tab,
        ___UserLocationInformationTWIF_iE_Extensions__item__id,
        ____UserLocationInformationTWIF_iE_Extensions__item__criticality_tab,
        ___UserLocationInformationTWIF_iE_Extensions__item__criticality,
        ____UserLocationInformationTWIF_iE_Extensions__item__extensionValue_tab,
        ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue,
        __UserLocationInformationTWIF_iE_Extensions__item_,
        _UserLocationInformationTWIF_iE_Extensions,
        UserLocationInformationTWIF,
        UserLocationInformationTWIF_ExtIEs,
        _UserLocationInformationW_AGF_globalLine_ID,
        _UserLocationInformationW_AGF_hFCNode_ID,
        ___UserLocationInformationW_AGF_choice_Extensions_id_tab,
        ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0,
        __UserLocationInformationW_AGF_choice_Extensions_id,
        __UserLocationInformationW_AGF_choice_Extensions_criticality,
        __UserLocationInformationW_AGF_choice_Extensions_value,
        _UserLocationInformationW_AGF_choice_Extensions,
        UserLocationInformationW_AGF,
        UserLocationInformationW_AGF_ExtIEs,
        _UserLocationInformationW_AGF_ExtIEs_val_Value_0,
        _UserLocationInformationNR_nR_CGI,
        _UserLocationInformationNR_tAI,
        _UserLocationInformationNR_timeStamp,
        ____UserLocationInformationNR_iE_Extensions__item__id_tab,
        _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0,
        _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1,
        ___UserLocationInformationNR_iE_Extensions__item__id,
        ___UserLocationInformationNR_iE_Extensions__item__criticality,
        ___UserLocationInformationNR_iE_Extensions__item__extensionValue,
        __UserLocationInformationNR_iE_Extensions__item_,
        _UserLocationInformationNR_iE_Extensions,
        UserLocationInformationNR,
        UserLocationInformationNR_ExtIEs,
        _UserLocationInformationNR_ExtIEs_val_Extension_0,
        _UserLocationInformationNR_ExtIEs_val_Extension_1,
        _UserPlaneSecurityInformation_securityResult,
        _UserPlaneSecurityInformation_securityIndication,
        ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__id,
        ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__criticality,
        ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue,
        __UserPlaneSecurityInformation_iE_Extensions__item_,
        _UserPlaneSecurityInformation_iE_Extensions,
        UserPlaneSecurityInformation,
        UserPlaneSecurityInformation_ExtIEs,
        _VolumeTimedReportList__item_,
        VolumeTimedReportList,
        _VolumeTimedReport_Item_startTimeStamp,
        _VolumeTimedReport_Item_endTimeStamp,
        _VolumeTimedReport_Item_usageCountUL,
        _VolumeTimedReport_Item_usageCountDL,
        ____VolumeTimedReport_Item_iE_Extensions__item__id_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__id,
        ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__criticality,
        ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue,
        __VolumeTimedReport_Item_iE_Extensions__item_,
        _VolumeTimedReport_Item_iE_Extensions,
        VolumeTimedReport_Item,
        VolumeTimedReport_Item_ExtIEs,
        _W_AGF_ID_w_AGF_ID,
        ___W_AGF_ID_choice_Extensions_id_tab,
        __W_AGF_ID_choice_Extensions_id,
        ___W_AGF_ID_choice_Extensions_criticality_tab,
        __W_AGF_ID_choice_Extensions_criticality,
        ___W_AGF_ID_choice_Extensions_value_tab,
        __W_AGF_ID_choice_Extensions_value,
        _W_AGF_ID_choice_Extensions,
        W_AGF_ID,
        W_AGF_ID_ExtIEs,
        WarningAreaCoordinates,
        _WarningAreaList_eUTRA_CGIListForWarning,
        _WarningAreaList_nR_CGIListForWarning,
        _WarningAreaList_tAIListForWarning,
        _WarningAreaList_emergencyAreaIDList,
        ___WarningAreaList_choice_Extensions_id_tab,
        __WarningAreaList_choice_Extensions_id,
        ___WarningAreaList_choice_Extensions_criticality_tab,
        __WarningAreaList_choice_Extensions_criticality,
        ___WarningAreaList_choice_Extensions_value_tab,
        __WarningAreaList_choice_Extensions_value,
        _WarningAreaList_choice_Extensions,
        WarningAreaList,
        WarningAreaList_ExtIEs,
        WarningMessageContents,
        WarningSecurityInfo,
        WarningType,
        _WLANMeasurementConfiguration_wlanMeasConfig,
        _WLANMeasurementConfiguration_wlanMeasConfigNameList,
        _WLANMeasurementConfiguration_wlan_rssi,
        _WLANMeasurementConfiguration_wlan_rtt,
        ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__id,
        ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__criticality,
        ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __WLANMeasurementConfiguration_iE_Extensions__item_,
        _WLANMeasurementConfiguration_iE_Extensions,
        WLANMeasurementConfiguration,
        WLANMeasurementConfiguration_ExtIEs,
        _WLANMeasConfigNameList__item_,
        WLANMeasConfigNameList,
        _WLANMeasConfigNameItem_wLANName,
        ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__id,
        ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__criticality,
        ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __WLANMeasConfigNameItem_iE_Extensions__item_,
        _WLANMeasConfigNameItem_iE_Extensions,
        WLANMeasConfigNameItem,
        WLANMeasConfigNameItem_ExtIEs,
        WLANMeasConfig,
        WLANName,
        _WUS_Assistance_Information_pagingProbabilityInformation,
        ____WUS_Assistance_Information_iE_Extensions__item__id_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__id,
        ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__criticality,
        ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__extensionValue,
        __WUS_Assistance_Information_iE_Extensions__item_,
        _WUS_Assistance_Information_iE_Extensions,
        WUS_Assistance_Information,
        WUS_Assistance_Information_ExtIEs,
        _XnExtTLAs__item_,
        XnExtTLAs,
        _XnExtTLA_Item_iPsecTLA,
        _XnExtTLA_Item_gTP_TLAs,
        ____XnExtTLA_Item_iE_Extensions__item__id_tab,
        _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___XnExtTLA_Item_iE_Extensions__item__id,
        ___XnExtTLA_Item_iE_Extensions__item__criticality,
        ___XnExtTLA_Item_iE_Extensions__item__extensionValue,
        __XnExtTLA_Item_iE_Extensions__item_,
        _XnExtTLA_Item_iE_Extensions,
        XnExtTLA_Item,
        XnExtTLA_Item_ExtIEs,
        _XnExtTLA_Item_ExtIEs_val_Extension_0,
        _XnGTP_TLAs__item_,
        XnGTP_TLAs,
        _XnTLAs__item_,
        XnTLAs,
        _XnTNLConfigurationInfo_xnTransportLayerAddresses,
        _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses,
        ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__id,
        ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__criticality,
        ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue,
        __XnTNLConfigurationInfo_iE_Extensions__item_,
        _XnTNLConfigurationInfo_iE_Extensions,
        XnTNLConfigurationInfo,
        XnTNLConfigurationInfo_ExtIEs,
    ]

class NGAP_PDU_Contents:

    _name_  = u'NGAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 1]
    
    _obj_ = [
        u'PDUSessionResourceSetupRequest',
        u'PDUSessionResourceSetupRequestIEs',
        u'PDUSessionResourceSetupResponse',
        u'PDUSessionResourceSetupResponseIEs',
        u'PDUSessionResourceReleaseCommand',
        u'PDUSessionResourceReleaseCommandIEs',
        u'PDUSessionResourceReleaseResponse',
        u'PDUSessionResourceReleaseResponseIEs',
        u'PDUSessionResourceModifyRequest',
        u'PDUSessionResourceModifyRequestIEs',
        u'PDUSessionResourceModifyResponse',
        u'PDUSessionResourceModifyResponseIEs',
        u'PDUSessionResourceNotify',
        u'PDUSessionResourceNotifyIEs',
        u'PDUSessionResourceModifyIndication',
        u'PDUSessionResourceModifyIndicationIEs',
        u'PDUSessionResourceModifyConfirm',
        u'PDUSessionResourceModifyConfirmIEs',
        u'InitialContextSetupRequest',
        u'InitialContextSetupRequestIEs',
        u'InitialContextSetupResponse',
        u'InitialContextSetupResponseIEs',
        u'InitialContextSetupFailure',
        u'InitialContextSetupFailureIEs',
        u'UEContextReleaseRequest',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete',
        u'UEContextReleaseComplete-IEs',
        u'UEContextResumeRequest',
        u'UEContextResumeRequestIEs',
        u'UEContextResumeResponse',
        u'UEContextResumeResponseIEs',
        u'UEContextResumeFailure',
        u'UEContextResumeFailureIEs',
        u'UEContextSuspendRequest',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponse',
        u'UEContextSuspendResponseIEs',
        u'UEContextSuspendFailure',
        u'UEContextSuspendFailureIEs',
        u'UEContextModificationRequest',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponse',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailure',
        u'UEContextModificationFailureIEs',
        u'RRCInactiveTransitionReport',
        u'RRCInactiveTransitionReportIEs',
        u'RetrieveUEInformation',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransfer',
        u'UEInformationTransferIEs',
        u'RANCPRelocationIndication',
        u'RANCPRelocationIndicationIEs',
        u'HandoverRequired',
        u'HandoverRequiredIEs',
        u'HandoverCommand',
        u'HandoverCommandIEs',
        u'HandoverPreparationFailure',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequest',
        u'HandoverRequestIEs',
        u'HandoverRequestAcknowledge',
        u'HandoverRequestAcknowledgeIEs',
        u'HandoverFailure',
        u'HandoverFailureIEs',
        u'HandoverNotify',
        u'HandoverNotifyIEs',
        u'PathSwitchRequest',
        u'PathSwitchRequestIEs',
        u'PathSwitchRequestAcknowledge',
        u'PathSwitchRequestAcknowledgeIEs',
        u'PathSwitchRequestFailure',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancel',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledge',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccess',
        u'HandoverSuccessIEs',
        u'UplinkRANEarlyStatusTransfer',
        u'UplinkRANEarlyStatusTransferIEs',
        u'DownlinkRANEarlyStatusTransfer',
        u'DownlinkRANEarlyStatusTransferIEs',
        u'UplinkRANStatusTransfer',
        u'UplinkRANStatusTransferIEs',
        u'DownlinkRANStatusTransfer',
        u'DownlinkRANStatusTransferIEs',
        u'Paging',
        u'PagingIEs',
        u'InitialUEMessage',
        u'InitialUEMessage-IEs',
        u'DownlinkNASTransport',
        u'DownlinkNASTransport-IEs',
        u'UplinkNASTransport',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest',
        u'RerouteNASRequest-IEs',
        u'NGSetupRequest',
        u'NGSetupRequestIEs',
        u'NGSetupResponse',
        u'NGSetupResponseIEs',
        u'NGSetupFailure',
        u'NGSetupFailureIEs',
        u'RANConfigurationUpdate',
        u'RANConfigurationUpdateIEs',
        u'RANConfigurationUpdateAcknowledge',
        u'RANConfigurationUpdateAcknowledgeIEs',
        u'RANConfigurationUpdateFailure',
        u'RANConfigurationUpdateFailureIEs',
        u'AMFConfigurationUpdate',
        u'AMFConfigurationUpdateIEs',
        u'AMFConfigurationUpdateAcknowledge',
        u'AMFConfigurationUpdateAcknowledgeIEs',
        u'AMFConfigurationUpdateFailure',
        u'AMFConfigurationUpdateFailureIEs',
        u'AMFStatusIndication',
        u'AMFStatusIndicationIEs',
        u'NGReset',
        u'NGResetIEs',
        u'NGResetAcknowledge',
        u'NGResetAcknowledgeIEs',
        u'ErrorIndication',
        u'ErrorIndicationIEs',
        u'OverloadStart',
        u'OverloadStartIEs',
        u'OverloadStop',
        u'OverloadStopIEs',
        u'UplinkRANConfigurationTransfer',
        u'UplinkRANConfigurationTransferIEs',
        u'DownlinkRANConfigurationTransfer',
        u'DownlinkRANConfigurationTransferIEs',
        u'WriteReplaceWarningRequest',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponse',
        u'WriteReplaceWarningResponseIEs',
        u'PWSCancelRequest',
        u'PWSCancelRequestIEs',
        u'PWSCancelResponse',
        u'PWSCancelResponseIEs',
        u'PWSRestartIndication',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndication',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedNRPPaTransport',
        u'DownlinkUEAssociatedNRPPaTransportIEs',
        u'UplinkUEAssociatedNRPPaTransport',
        u'UplinkUEAssociatedNRPPaTransportIEs',
        u'DownlinkNonUEAssociatedNRPPaTransport',
        u'DownlinkNonUEAssociatedNRPPaTransportIEs',
        u'UplinkNonUEAssociatedNRPPaTransport',
        u'UplinkNonUEAssociatedNRPPaTransportIEs',
        u'TraceStart',
        u'TraceStartIEs',
        u'TraceFailureIndication',
        u'TraceFailureIndicationIEs',
        u'DeactivateTrace',
        u'DeactivateTraceIEs',
        u'CellTrafficTrace',
        u'CellTrafficTraceIEs',
        u'LocationReportingControl',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndication',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReport',
        u'LocationReportIEs',
        u'UETNLABindingReleaseRequest',
        u'UETNLABindingReleaseRequestIEs',
        u'UERadioCapabilityInfoIndication',
        u'UERadioCapabilityInfoIndicationIEs',
        u'UERadioCapabilityCheckRequest',
        u'UERadioCapabilityCheckRequestIEs',
        u'UERadioCapabilityCheckResponse',
        u'UERadioCapabilityCheckResponseIEs',
        u'PrivateMessage',
        u'PrivateMessageIEs',
        u'SecondaryRATDataUsageReport',
        u'SecondaryRATDataUsageReportIEs',
        u'UplinkRIMInformationTransfer',
        u'UplinkRIMInformationTransferIEs',
        u'DownlinkRIMInformationTransfer',
        u'DownlinkRIMInformationTransferIEs',
        u'ConnectionEstablishmentIndication',
        u'ConnectionEstablishmentIndicationIEs',
        u'UERadioCapabilityIDMappingRequest',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponse',
        u'UERadioCapabilityIDMappingResponseIEs',
        u'AMFCPRelocationIndication',
        u'AMFCPRelocationIndicationIEs',
        ]
    _type_ = [
        u'PDUSessionResourceSetupRequest',
        u'PDUSessionResourceSetupResponse',
        u'PDUSessionResourceReleaseCommand',
        u'PDUSessionResourceReleaseResponse',
        u'PDUSessionResourceModifyRequest',
        u'PDUSessionResourceModifyResponse',
        u'PDUSessionResourceNotify',
        u'PDUSessionResourceModifyIndication',
        u'PDUSessionResourceModifyConfirm',
        u'InitialContextSetupRequest',
        u'InitialContextSetupResponse',
        u'InitialContextSetupFailure',
        u'UEContextReleaseRequest',
        u'UEContextReleaseCommand',
        u'UEContextReleaseComplete',
        u'UEContextResumeRequest',
        u'UEContextResumeResponse',
        u'UEContextResumeFailure',
        u'UEContextSuspendRequest',
        u'UEContextSuspendResponse',
        u'UEContextSuspendFailure',
        u'UEContextModificationRequest',
        u'UEContextModificationResponse',
        u'UEContextModificationFailure',
        u'RRCInactiveTransitionReport',
        u'RetrieveUEInformation',
        u'UEInformationTransfer',
        u'RANCPRelocationIndication',
        u'HandoverRequired',
        u'HandoverCommand',
        u'HandoverPreparationFailure',
        u'HandoverRequest',
        u'HandoverRequestAcknowledge',
        u'HandoverFailure',
        u'HandoverNotify',
        u'PathSwitchRequest',
        u'PathSwitchRequestAcknowledge',
        u'PathSwitchRequestFailure',
        u'HandoverCancel',
        u'HandoverCancelAcknowledge',
        u'HandoverSuccess',
        u'UplinkRANEarlyStatusTransfer',
        u'DownlinkRANEarlyStatusTransfer',
        u'UplinkRANStatusTransfer',
        u'DownlinkRANStatusTransfer',
        u'Paging',
        u'InitialUEMessage',
        u'DownlinkNASTransport',
        u'UplinkNASTransport',
        u'NASNonDeliveryIndication',
        u'RerouteNASRequest',
        u'NGSetupRequest',
        u'NGSetupResponse',
        u'NGSetupFailure',
        u'RANConfigurationUpdate',
        u'RANConfigurationUpdateAcknowledge',
        u'RANConfigurationUpdateFailure',
        u'AMFConfigurationUpdate',
        u'AMFConfigurationUpdateAcknowledge',
        u'AMFConfigurationUpdateFailure',
        u'AMFStatusIndication',
        u'NGReset',
        u'NGResetAcknowledge',
        u'ErrorIndication',
        u'OverloadStart',
        u'OverloadStop',
        u'UplinkRANConfigurationTransfer',
        u'DownlinkRANConfigurationTransfer',
        u'WriteReplaceWarningRequest',
        u'WriteReplaceWarningResponse',
        u'PWSCancelRequest',
        u'PWSCancelResponse',
        u'PWSRestartIndication',
        u'PWSFailureIndication',
        u'DownlinkUEAssociatedNRPPaTransport',
        u'UplinkUEAssociatedNRPPaTransport',
        u'DownlinkNonUEAssociatedNRPPaTransport',
        u'UplinkNonUEAssociatedNRPPaTransport',
        u'TraceStart',
        u'TraceFailureIndication',
        u'DeactivateTrace',
        u'CellTrafficTrace',
        u'LocationReportingControl',
        u'LocationReportingFailureIndication',
        u'LocationReport',
        u'UETNLABindingReleaseRequest',
        u'UERadioCapabilityInfoIndication',
        u'UERadioCapabilityCheckRequest',
        u'UERadioCapabilityCheckResponse',
        u'PrivateMessage',
        u'SecondaryRATDataUsageReport',
        u'UplinkRIMInformationTransfer',
        u'DownlinkRIMInformationTransfer',
        u'ConnectionEstablishmentIndication',
        u'UERadioCapabilityIDMappingRequest',
        u'UERadioCapabilityIDMappingResponse',
        u'AMFCPRelocationIndication',
        ]
    _set_ = [
        u'PDUSessionResourceSetupRequestIEs',
        u'PDUSessionResourceSetupResponseIEs',
        u'PDUSessionResourceReleaseCommandIEs',
        u'PDUSessionResourceReleaseResponseIEs',
        u'PDUSessionResourceModifyRequestIEs',
        u'PDUSessionResourceModifyResponseIEs',
        u'PDUSessionResourceNotifyIEs',
        u'PDUSessionResourceModifyIndicationIEs',
        u'PDUSessionResourceModifyConfirmIEs',
        u'InitialContextSetupRequestIEs',
        u'InitialContextSetupResponseIEs',
        u'InitialContextSetupFailureIEs',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete-IEs',
        u'UEContextResumeRequestIEs',
        u'UEContextResumeResponseIEs',
        u'UEContextResumeFailureIEs',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponseIEs',
        u'UEContextSuspendFailureIEs',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailureIEs',
        u'RRCInactiveTransitionReportIEs',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransferIEs',
        u'RANCPRelocationIndicationIEs',
        u'HandoverRequiredIEs',
        u'HandoverCommandIEs',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequestIEs',
        u'HandoverRequestAcknowledgeIEs',
        u'HandoverFailureIEs',
        u'HandoverNotifyIEs',
        u'PathSwitchRequestIEs',
        u'PathSwitchRequestAcknowledgeIEs',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccessIEs',
        u'UplinkRANEarlyStatusTransferIEs',
        u'DownlinkRANEarlyStatusTransferIEs',
        u'UplinkRANStatusTransferIEs',
        u'DownlinkRANStatusTransferIEs',
        u'PagingIEs',
        u'InitialUEMessage-IEs',
        u'DownlinkNASTransport-IEs',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest-IEs',
        u'NGSetupRequestIEs',
        u'NGSetupResponseIEs',
        u'NGSetupFailureIEs',
        u'RANConfigurationUpdateIEs',
        u'RANConfigurationUpdateAcknowledgeIEs',
        u'RANConfigurationUpdateFailureIEs',
        u'AMFConfigurationUpdateIEs',
        u'AMFConfigurationUpdateAcknowledgeIEs',
        u'AMFConfigurationUpdateFailureIEs',
        u'AMFStatusIndicationIEs',
        u'NGResetIEs',
        u'NGResetAcknowledgeIEs',
        u'ErrorIndicationIEs',
        u'OverloadStartIEs',
        u'OverloadStopIEs',
        u'UplinkRANConfigurationTransferIEs',
        u'DownlinkRANConfigurationTransferIEs',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponseIEs',
        u'PWSCancelRequestIEs',
        u'PWSCancelResponseIEs',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedNRPPaTransportIEs',
        u'UplinkUEAssociatedNRPPaTransportIEs',
        u'DownlinkNonUEAssociatedNRPPaTransportIEs',
        u'UplinkNonUEAssociatedNRPPaTransportIEs',
        u'TraceStartIEs',
        u'TraceFailureIndicationIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReportIEs',
        u'UETNLABindingReleaseRequestIEs',
        u'UERadioCapabilityInfoIndicationIEs',
        u'UERadioCapabilityCheckRequestIEs',
        u'UERadioCapabilityCheckResponseIEs',
        u'PrivateMessageIEs',
        u'SecondaryRATDataUsageReportIEs',
        u'UplinkRIMInformationTransferIEs',
        u'DownlinkRIMInformationTransferIEs',
        u'ConnectionEstablishmentIndicationIEs',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponseIEs',
        u'AMFCPRelocationIndicationIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'PDUSessionResourceSetupRequestIEs',
        u'PDUSessionResourceSetupResponseIEs',
        u'PDUSessionResourceReleaseCommandIEs',
        u'PDUSessionResourceReleaseResponseIEs',
        u'PDUSessionResourceModifyRequestIEs',
        u'PDUSessionResourceModifyResponseIEs',
        u'PDUSessionResourceNotifyIEs',
        u'PDUSessionResourceModifyIndicationIEs',
        u'PDUSessionResourceModifyConfirmIEs',
        u'InitialContextSetupRequestIEs',
        u'InitialContextSetupResponseIEs',
        u'InitialContextSetupFailureIEs',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete-IEs',
        u'UEContextResumeRequestIEs',
        u'UEContextResumeResponseIEs',
        u'UEContextResumeFailureIEs',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponseIEs',
        u'UEContextSuspendFailureIEs',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailureIEs',
        u'RRCInactiveTransitionReportIEs',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransferIEs',
        u'RANCPRelocationIndicationIEs',
        u'HandoverRequiredIEs',
        u'HandoverCommandIEs',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequestIEs',
        u'HandoverRequestAcknowledgeIEs',
        u'HandoverFailureIEs',
        u'HandoverNotifyIEs',
        u'PathSwitchRequestIEs',
        u'PathSwitchRequestAcknowledgeIEs',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccessIEs',
        u'UplinkRANEarlyStatusTransferIEs',
        u'DownlinkRANEarlyStatusTransferIEs',
        u'UplinkRANStatusTransferIEs',
        u'DownlinkRANStatusTransferIEs',
        u'PagingIEs',
        u'InitialUEMessage-IEs',
        u'DownlinkNASTransport-IEs',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest-IEs',
        u'NGSetupRequestIEs',
        u'NGSetupResponseIEs',
        u'NGSetupFailureIEs',
        u'RANConfigurationUpdateIEs',
        u'RANConfigurationUpdateAcknowledgeIEs',
        u'RANConfigurationUpdateFailureIEs',
        u'AMFConfigurationUpdateIEs',
        u'AMFConfigurationUpdateAcknowledgeIEs',
        u'AMFConfigurationUpdateFailureIEs',
        u'AMFStatusIndicationIEs',
        u'NGResetIEs',
        u'NGResetAcknowledgeIEs',
        u'ErrorIndicationIEs',
        u'OverloadStartIEs',
        u'OverloadStopIEs',
        u'UplinkRANConfigurationTransferIEs',
        u'DownlinkRANConfigurationTransferIEs',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponseIEs',
        u'PWSCancelRequestIEs',
        u'PWSCancelResponseIEs',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedNRPPaTransportIEs',
        u'UplinkUEAssociatedNRPPaTransportIEs',
        u'DownlinkNonUEAssociatedNRPPaTransportIEs',
        u'UplinkNonUEAssociatedNRPPaTransportIEs',
        u'TraceStartIEs',
        u'TraceFailureIndicationIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReportIEs',
        u'UETNLABindingReleaseRequestIEs',
        u'UERadioCapabilityInfoIndicationIEs',
        u'UERadioCapabilityCheckRequestIEs',
        u'UERadioCapabilityCheckResponseIEs',
        u'PrivateMessageIEs',
        u'SecondaryRATDataUsageReportIEs',
        u'UplinkRIMInformationTransferIEs',
        u'DownlinkRIMInformationTransferIEs',
        u'ConnectionEstablishmentIndicationIEs',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponseIEs',
        u'AMFCPRelocationIndicationIEs',
        ]
    _param_ = [
        ]
    
    #-----< PDUSessionResourceSetupRequest >-----#
    PDUSessionResourceSetupRequest = SEQ(name=u'PDUSessionResourceSetupRequest', mode=MODE_TYPE)
    _PDUSessionResourceSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSUReq')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupRequest_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceSetupRequest_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupRequest_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupRequest_protocolIEs._cont = __PDUSessionResourceSetupRequest_protocolIEs__item_
    _PDUSessionResourceSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceSetupRequest_protocolIEs),
        ])
    PDUSessionResourceSetupRequest._ext = []
    
    #-----< PDUSessionResourceSetupRequestIEs >-----#
    PDUSessionResourceSetupRequestIEs = CLASS(name=u'PDUSessionResourceSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceSetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceSetupRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceSetupRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _PDUSessionResourceSetupRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSUReq')))
    _PDUSessionResourceSetupRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    PDUSessionResourceSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupRequestIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupResponse >-----#
    PDUSessionResourceSetupResponse = SEQ(name=u'PDUSessionResourceSetupResponse', mode=MODE_TYPE)
    _PDUSessionResourceSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSURes')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListSURes')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceSetupResponse_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceSetupResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupResponse_protocolIEs._cont = __PDUSessionResourceSetupResponse_protocolIEs__item_
    _PDUSessionResourceSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceSetupResponse_protocolIEs),
        ])
    PDUSessionResourceSetupResponse._ext = []
    
    #-----< PDUSessionResourceSetupResponseIEs >-----#
    PDUSessionResourceSetupResponseIEs = CLASS(name=u'PDUSessionResourceSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceSetupResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceSetupResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSURes')))
    _PDUSessionResourceSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListSURes')))
    _PDUSessionResourceSetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceSetupResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseCommand >-----#
    PDUSessionResourceReleaseCommand = SEQ(name=u'PDUSessionResourceReleaseCommand', mode=MODE_TYPE)
    _PDUSessionResourceReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListRelCmd')))
    ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceReleaseCommand_protocolIEs__item__value),
        ])
    __PDUSessionResourceReleaseCommand_protocolIEs__item_._ext = None
    _PDUSessionResourceReleaseCommand_protocolIEs._cont = __PDUSessionResourceReleaseCommand_protocolIEs__item_
    _PDUSessionResourceReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceReleaseCommand_protocolIEs),
        ])
    PDUSessionResourceReleaseCommand._ext = []
    
    #-----< PDUSessionResourceReleaseCommandIEs >-----#
    PDUSessionResourceReleaseCommandIEs = CLASS(name=u'PDUSessionResourceReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListRelCmd')))
    PDUSessionResourceReleaseCommandIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceReleaseCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceReleaseCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseCommandIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseCommandIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceReleaseCommandIEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseResponse >-----#
    PDUSessionResourceReleaseResponse = SEQ(name=u'PDUSessionResourceReleaseResponse', mode=MODE_TYPE)
    _PDUSessionResourceReleaseResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListRelRes')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceReleaseResponse_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceReleaseResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceReleaseResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceReleaseResponse_protocolIEs._cont = __PDUSessionResourceReleaseResponse_protocolIEs__item_
    _PDUSessionResourceReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseResponse._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceReleaseResponse_protocolIEs),
        ])
    PDUSessionResourceReleaseResponse._ext = []
    
    #-----< PDUSessionResourceReleaseResponseIEs >-----#
    PDUSessionResourceReleaseResponseIEs = CLASS(name=u'PDUSessionResourceReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListRelRes')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceReleaseResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceReleaseResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyRequest >-----#
    PDUSessionResourceModifyRequest = SEQ(name=u'PDUSessionResourceModifyRequest', mode=MODE_TYPE)
    _PDUSessionResourceModifyRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModReq')))
    ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyRequest_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceModifyRequest_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyRequest_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyRequest_protocolIEs._cont = __PDUSessionResourceModifyRequest_protocolIEs__item_
    _PDUSessionResourceModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyRequest._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceModifyRequest_protocolIEs),
        ])
    PDUSessionResourceModifyRequest._ext = []
    
    #-----< PDUSessionResourceModifyRequestIEs >-----#
    PDUSessionResourceModifyRequestIEs = CLASS(name=u'PDUSessionResourceModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceModifyRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModReq')))
    PDUSessionResourceModifyRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyRequestIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyResponse >-----#
    PDUSessionResourceModifyResponse = SEQ(name=u'PDUSessionResourceModifyResponse', mode=MODE_TYPE)
    _PDUSessionResourceModifyResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModRes')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModRes')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceModifyResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyResponse_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceModifyResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyResponse_protocolIEs._cont = __PDUSessionResourceModifyResponse_protocolIEs__item_
    _PDUSessionResourceModifyResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyResponse._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceModifyResponse_protocolIEs),
        ])
    PDUSessionResourceModifyResponse._ext = []
    
    #-----< PDUSessionResourceModifyResponseIEs >-----#
    PDUSessionResourceModifyResponseIEs = CLASS(name=u'PDUSessionResourceModifyResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModRes')))
    _PDUSessionResourceModifyResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModRes')))
    _PDUSessionResourceModifyResponseIEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PDUSessionResourceModifyResponseIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceModifyResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyResponseIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotify >-----#
    PDUSessionResourceNotify = SEQ(name=u'PDUSessionResourceNotify', mode=MODE_TYPE)
    _PDUSessionResourceNotify_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceNotify_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceNotify_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyList')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListNot')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____PDUSessionResourceNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceNotify_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceNotify_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceNotify_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceNotify_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceNotify_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceNotify_protocolIEs__item__value),
        ])
    __PDUSessionResourceNotify_protocolIEs__item_._ext = None
    _PDUSessionResourceNotify_protocolIEs._cont = __PDUSessionResourceNotify_protocolIEs__item_
    _PDUSessionResourceNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotify._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceNotify_protocolIEs),
        ])
    PDUSessionResourceNotify._ext = []
    
    #-----< PDUSessionResourceNotifyIEs >-----#
    PDUSessionResourceNotifyIEs = CLASS(name=u'PDUSessionResourceNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceNotifyIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceNotifyIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceNotifyIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyList')))
    _PDUSessionResourceNotifyIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListNot')))
    _PDUSessionResourceNotifyIEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    PDUSessionResourceNotifyIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceNotifyIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceNotifyIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceNotifyIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceNotifyIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceNotifyIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndication >-----#
    PDUSessionResourceModifyIndication = SEQ(name=u'PDUSessionResourceModifyIndication', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModInd')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceModifyIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyIndication_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceModifyIndication_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyIndication_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyIndication_protocolIEs._cont = __PDUSessionResourceModifyIndication_protocolIEs__item_
    _PDUSessionResourceModifyIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndication._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceModifyIndication_protocolIEs),
        ])
    PDUSessionResourceModifyIndication._ext = []
    
    #-----< PDUSessionResourceModifyIndicationIEs >-----#
    PDUSessionResourceModifyIndicationIEs = CLASS(name=u'PDUSessionResourceModifyIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModInd')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    PDUSessionResourceModifyIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _PDUSessionResourceModifyIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyConfirm >-----#
    PDUSessionResourceModifyConfirm = SEQ(name=u'PDUSessionResourceModifyConfirm', mode=MODE_TYPE)
    _PDUSessionResourceModifyConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModCfm')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModCfm')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 62), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __PDUSessionResourceModifyConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PDUSessionResourceModifyConfirm_protocolIEs__item__id),
        (u'criticality', ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality),
        (u'value', ___PDUSessionResourceModifyConfirm_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyConfirm_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyConfirm_protocolIEs._cont = __PDUSessionResourceModifyConfirm_protocolIEs__item_
    _PDUSessionResourceModifyConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyConfirm._cont = ASN1Dict([
        (u'protocolIEs', _PDUSessionResourceModifyConfirm_protocolIEs),
        ])
    PDUSessionResourceModifyConfirm._ext = []
    
    #-----< PDUSessionResourceModifyConfirmIEs >-----#
    PDUSessionResourceModifyConfirmIEs = CLASS(name=u'PDUSessionResourceModifyConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModCfm')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModCfm')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceModifyConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 62), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyConfirmIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PDUSessionResourceModifyConfirmIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupRequest >-----#
    InitialContextSetupRequest = SEQ(name=u'InitialContextSetupRequest', mode=MODE_TYPE)
    _InitialContextSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtReq')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupRequest_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupRequest_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupRequest_protocolIEs__item__value),
        ])
    __InitialContextSetupRequest_protocolIEs__item_._ext = None
    _InitialContextSetupRequest_protocolIEs._cont = __InitialContextSetupRequest_protocolIEs__item_
    _InitialContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupRequest_protocolIEs),
        ])
    InitialContextSetupRequest._ext = []
    
    #-----< InitialContextSetupRequestIEs >-----#
    InitialContextSetupRequestIEs = CLASS(name=u'InitialContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupRequestIEs_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _InitialContextSetupRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _InitialContextSetupRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _InitialContextSetupRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _InitialContextSetupRequestIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtReq')))
    _InitialContextSetupRequestIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _InitialContextSetupRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _InitialContextSetupRequestIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _InitialContextSetupRequestIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _InitialContextSetupRequestIEs_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _InitialContextSetupRequestIEs_val_Value_13 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _InitialContextSetupRequestIEs_val_Value_14 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _InitialContextSetupRequestIEs_val_Value_15 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _InitialContextSetupRequestIEs_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _InitialContextSetupRequestIEs_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _InitialContextSetupRequestIEs_val_Value_19 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _InitialContextSetupRequestIEs_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _InitialContextSetupRequestIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _InitialContextSetupRequestIEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _InitialContextSetupRequestIEs_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _InitialContextSetupRequestIEs_val_Value_24 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _InitialContextSetupRequestIEs_val_Value_25 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _InitialContextSetupRequestIEs_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _InitialContextSetupRequestIEs_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_29 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_31 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _InitialContextSetupRequestIEs_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _InitialContextSetupRequestIEs_val_Value_33 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _InitialContextSetupRequestIEs_val_Value_34 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _InitialContextSetupRequestIEs_val_Value_35 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _InitialContextSetupRequestIEs_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    InitialContextSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_36), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupResponse >-----#
    InitialContextSetupResponse = SEQ(name=u'InitialContextSetupResponse', mode=MODE_TYPE)
    _InitialContextSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtRes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtRes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupResponse_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupResponse_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupResponse_protocolIEs__item__value),
        ])
    __InitialContextSetupResponse_protocolIEs__item_._ext = None
    _InitialContextSetupResponse_protocolIEs._cont = __InitialContextSetupResponse_protocolIEs__item_
    _InitialContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupResponse_protocolIEs),
        ])
    InitialContextSetupResponse._ext = []
    
    #-----< InitialContextSetupResponseIEs >-----#
    InitialContextSetupResponseIEs = CLASS(name=u'InitialContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtRes')))
    _InitialContextSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtRes')))
    _InitialContextSetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupFailure >-----#
    InitialContextSetupFailure = SEQ(name=u'InitialContextSetupFailure', mode=MODE_TYPE)
    _InitialContextSetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtFail')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupFailure_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupFailure_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupFailure_protocolIEs__item__value),
        ])
    __InitialContextSetupFailure_protocolIEs__item_._ext = None
    _InitialContextSetupFailure_protocolIEs._cont = __InitialContextSetupFailure_protocolIEs__item_
    _InitialContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupFailure_protocolIEs),
        ])
    InitialContextSetupFailure._ext = []
    
    #-----< InitialContextSetupFailureIEs >-----#
    InitialContextSetupFailureIEs = CLASS(name=u'InitialContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupFailureIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtFail')))
    _InitialContextSetupFailureIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _InitialContextSetupFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name=u'UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelReq')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 133), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequest-IEs >-----#
    UEContextReleaseRequest_IEs = CLASS(name=u'UEContextReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelReq')))
    _UEContextReleaseRequest_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    UEContextReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 133), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name=u'UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-IDs')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommand-IEs >-----#
    UEContextReleaseCommand_IEs = CLASS(name=u'UEContextReleaseCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseCommand_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-IDs')))
    _UEContextReleaseCommand_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    UEContextReleaseCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommand_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name=u'UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelCpl')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseComplete_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseComplete-IEs >-----#
    UEContextReleaseComplete_IEs = CLASS(name=u'UEContextReleaseComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseComplete_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UEContextReleaseComplete_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextReleaseComplete_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelCpl')))
    _UEContextReleaseComplete_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _UEContextReleaseComplete_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    UEContextReleaseComplete_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeRequest >-----#
    UEContextResumeRequest = SEQ(name=u'UEContextResumeRequest', mode=MODE_TYPE)
    _UEContextResumeRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Request-Indication')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____UEContextResumeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 229), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeRequest_protocolIEs__item__value),
        ])
    __UEContextResumeRequest_protocolIEs__item_._ext = None
    _UEContextResumeRequest_protocolIEs._cont = __UEContextResumeRequest_protocolIEs__item_
    _UEContextResumeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeRequest_protocolIEs),
        ])
    UEContextResumeRequest._ext = []
    
    #-----< UEContextResumeRequestIEs >-----#
    UEContextResumeRequestIEs = CLASS(name=u'UEContextResumeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeRequestIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _UEContextResumeRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESReq')))
    _UEContextResumeRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESReq')))
    _UEContextResumeRequestIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Request-Indication')))
    _UEContextResumeRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextResumeRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    UEContextResumeRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Value', _UEContextResumeRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 229), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'ignore'), (u'Value', _UEContextResumeRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _UEContextResumeRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _UEContextResumeRequestIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponse >-----#
    UEContextResumeResponse = SEQ(name=u'UEContextResumeResponse', mode=MODE_TYPE)
    _UEContextResumeResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Response-Indication')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'reject'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 236), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeResponse_protocolIEs__item__value),
        ])
    __UEContextResumeResponse_protocolIEs__item_._ext = None
    _UEContextResumeResponse_protocolIEs._cont = __UEContextResumeResponse_protocolIEs__item_
    _UEContextResumeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeResponse_protocolIEs),
        ])
    UEContextResumeResponse._ext = []
    
    #-----< UEContextResumeResponseIEs >-----#
    UEContextResumeResponseIEs = CLASS(name=u'UEContextResumeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESRes')))
    _UEContextResumeResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESRes')))
    _UEContextResumeResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _UEContextResumeResponseIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Response-Indication')))
    _UEContextResumeResponseIEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _UEContextResumeResponseIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Value', _UEContextResumeResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'reject'), (u'Value', _UEContextResumeResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _UEContextResumeResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 236), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeFailure >-----#
    UEContextResumeFailure = SEQ(name=u'UEContextResumeFailure', mode=MODE_TYPE)
    _UEContextResumeFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeFailure_protocolIEs__item__value),
        ])
    __UEContextResumeFailure_protocolIEs__item_._ext = None
    _UEContextResumeFailure_protocolIEs._cont = __UEContextResumeFailure_protocolIEs__item_
    _UEContextResumeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeFailure_protocolIEs),
        ])
    UEContextResumeFailure._ext = []
    
    #-----< UEContextResumeFailureIEs >-----#
    UEContextResumeFailureIEs = CLASS(name=u'UEContextResumeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextResumeFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequest >-----#
    UEContextSuspendRequest = SEQ(name=u'UEContextSuspendRequest', mode=MODE_TYPE)
    _UEContextSuspendRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendListSUSReq')))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSuspendRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSuspendRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextSuspendRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextSuspendRequest_protocolIEs__item__value),
        ])
    __UEContextSuspendRequest_protocolIEs__item_._ext = None
    _UEContextSuspendRequest_protocolIEs._cont = __UEContextSuspendRequest_protocolIEs__item_
    _UEContextSuspendRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSuspendRequest_protocolIEs),
        ])
    UEContextSuspendRequest._ext = []
    
    #-----< UEContextSuspendRequestIEs >-----#
    UEContextSuspendRequestIEs = CLASS(name=u'UEContextSuspendRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextSuspendRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    _UEContextSuspendRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendListSUSReq')))
    UEContextSuspendRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UEContextSuspendRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UEContextSuspendRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'reject'), (u'Value', _UEContextSuspendRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendResponse >-----#
    UEContextSuspendResponse = SEQ(name=u'UEContextSuspendResponse', mode=MODE_TYPE)
    _UEContextSuspendResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSuspendResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSuspendResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextSuspendResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextSuspendResponse_protocolIEs__item__value),
        ])
    __UEContextSuspendResponse_protocolIEs__item_._ext = None
    _UEContextSuspendResponse_protocolIEs._cont = __UEContextSuspendResponse_protocolIEs__item_
    _UEContextSuspendResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSuspendResponse_protocolIEs),
        ])
    UEContextSuspendResponse._ext = []
    
    #-----< UEContextSuspendResponseIEs >-----#
    UEContextSuspendResponseIEs = CLASS(name=u'UEContextSuspendResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _UEContextSuspendResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextSuspendResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _UEContextSuspendResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendFailure >-----#
    UEContextSuspendFailure = SEQ(name=u'UEContextSuspendFailure', mode=MODE_TYPE)
    _UEContextSuspendFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextSuspendFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextSuspendFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSuspendFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSuspendFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextSuspendFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextSuspendFailure_protocolIEs__item__value),
        ])
    __UEContextSuspendFailure_protocolIEs__item_._ext = None
    _UEContextSuspendFailure_protocolIEs._cont = __UEContextSuspendFailure_protocolIEs__item_
    _UEContextSuspendFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSuspendFailure_protocolIEs),
        ])
    UEContextSuspendFailure._ext = []
    
    #-----< UEContextSuspendFailureIEs >-----#
    UEContextSuspendFailureIEs = CLASS(name=u'UEContextSuspendFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextSuspendFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextSuspendFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name=u'UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name=u'UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _UEContextModificationRequestIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _UEContextModificationRequestIEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _UEContextModificationRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _UEContextModificationRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _UEContextModificationRequestIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _UEContextModificationRequestIEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _UEContextModificationRequestIEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _UEContextModificationRequestIEs_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _UEContextModificationRequestIEs_val_Value_20 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _UEContextModificationRequestIEs_val_Value_21 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_21), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name=u'UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name=u'UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _UEContextModificationResponseIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UEContextModificationResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name=u'UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name=u'UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RRCInactiveTransitionReport >-----#
    RRCInactiveTransitionReport = SEQ(name=u'RRCInactiveTransitionReport', mode=MODE_TYPE)
    _RRCInactiveTransitionReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RRCInactiveTransitionReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RRCInactiveTransitionReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RRCInactiveTransitionReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____RRCInactiveTransitionReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab_at = None
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab_id = u'id'
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RRCInactiveTransitionReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab_id = u'Value'
    __RRCInactiveTransitionReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RRCInactiveTransitionReport_protocolIEs__item__id),
        (u'criticality', ___RRCInactiveTransitionReport_protocolIEs__item__criticality),
        (u'value', ___RRCInactiveTransitionReport_protocolIEs__item__value),
        ])
    __RRCInactiveTransitionReport_protocolIEs__item_._ext = None
    _RRCInactiveTransitionReport_protocolIEs._cont = __RRCInactiveTransitionReport_protocolIEs__item_
    _RRCInactiveTransitionReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RRCInactiveTransitionReport._cont = ASN1Dict([
        (u'protocolIEs', _RRCInactiveTransitionReport_protocolIEs),
        ])
    RRCInactiveTransitionReport._ext = []
    
    #-----< RRCInactiveTransitionReportIEs >-----#
    RRCInactiveTransitionReportIEs = CLASS(name=u'RRCInactiveTransitionReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RRCInactiveTransitionReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _RRCInactiveTransitionReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RRCInactiveTransitionReportIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _RRCInactiveTransitionReportIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    RRCInactiveTransitionReportIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _RRCInactiveTransitionReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _RRCInactiveTransitionReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _RRCInactiveTransitionReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _RRCInactiveTransitionReportIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEInformation >-----#
    RetrieveUEInformation = SEQ(name=u'RetrieveUEInformation', mode=MODE_TYPE)
    _RetrieveUEInformation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEInformation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RetrieveUEInformation_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ____RetrieveUEInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_id = u'id'
    ___RetrieveUEInformation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RetrieveUEInformation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_id = u'Value'
    __RetrieveUEInformation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RetrieveUEInformation_protocolIEs__item__id),
        (u'criticality', ___RetrieveUEInformation_protocolIEs__item__criticality),
        (u'value', ___RetrieveUEInformation_protocolIEs__item__value),
        ])
    __RetrieveUEInformation_protocolIEs__item_._ext = None
    _RetrieveUEInformation_protocolIEs._cont = __RetrieveUEInformation_protocolIEs__item_
    _RetrieveUEInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEInformation._cont = ASN1Dict([
        (u'protocolIEs', _RetrieveUEInformation_protocolIEs),
        ])
    RetrieveUEInformation._ext = []
    
    #-----< RetrieveUEInformationIEs >-----#
    RetrieveUEInformationIEs = CLASS(name=u'RetrieveUEInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RetrieveUEInformationIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    RetrieveUEInformationIEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _RetrieveUEInformationIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInformationTransfer >-----#
    UEInformationTransfer = SEQ(name=u'UEInformationTransfer', mode=MODE_TYPE)
    _UEInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UEInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    ____UEInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEInformationTransfer_protocolIEs__item__id._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UEInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UEInformationTransfer_protocolIEs__item__value._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UEInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___UEInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___UEInformationTransfer_protocolIEs__item__value),
        ])
    __UEInformationTransfer_protocolIEs__item_._ext = None
    _UEInformationTransfer_protocolIEs._cont = __UEInformationTransfer_protocolIEs__item_
    _UEInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UEInformationTransfer_protocolIEs),
        ])
    UEInformationTransfer._ext = []
    
    #-----< UEInformationTransferIEs >-----#
    UEInformationTransferIEs = CLASS(name=u'UEInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEInformationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _UEInformationTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _UEInformationTransferIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UEInformationTransferIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _UEInformationTransferIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _UEInformationTransferIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    UEInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _UEInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANCPRelocationIndication >-----#
    RANCPRelocationIndication = SEQ(name=u'RANCPRelocationIndication', mode=MODE_TYPE)
    _RANCPRelocationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANCPRelocationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RANCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-CP-SecurityInformation')))
    ____RANCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 211), (u'criticality', u'reject'), (u'Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RANCPRelocationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANCPRelocationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RANCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANCPRelocationIndication_protocolIEs__item__id),
        (u'criticality', ___RANCPRelocationIndication_protocolIEs__item__criticality),
        (u'value', ___RANCPRelocationIndication_protocolIEs__item__value),
        ])
    __RANCPRelocationIndication_protocolIEs__item_._ext = None
    _RANCPRelocationIndication_protocolIEs._cont = __RANCPRelocationIndication_protocolIEs__item_
    _RANCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANCPRelocationIndication._cont = ASN1Dict([
        (u'protocolIEs', _RANCPRelocationIndication_protocolIEs),
        ])
    RANCPRelocationIndication._ext = []
    
    #-----< RANCPRelocationIndicationIEs >-----#
    RANCPRelocationIndicationIEs = CLASS(name=u'RANCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANCPRelocationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RANCPRelocationIndicationIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _RANCPRelocationIndicationIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _RANCPRelocationIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _RANCPRelocationIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-CP-SecurityInformation')))
    RANCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _RANCPRelocationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _RANCPRelocationIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _RANCPRelocationIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _RANCPRelocationIndicationIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 211), (u'criticality', u'reject'), (u'Value', _RANCPRelocationIndicationIEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequired >-----#
    HandoverRequired = SEQ(name=u'HandoverRequired', mode=MODE_TYPE)
    _HandoverRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequired_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListHORqd')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    ____HandoverRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverRequired_protocolIEs__item__id._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequired_protocolIEs__item__criticality._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequired_protocolIEs__item__value._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequired_protocolIEs__item__id),
        (u'criticality', ___HandoverRequired_protocolIEs__item__criticality),
        (u'value', ___HandoverRequired_protocolIEs__item__value),
        ])
    __HandoverRequired_protocolIEs__item_._ext = None
    _HandoverRequired_protocolIEs._cont = __HandoverRequired_protocolIEs__item_
    _HandoverRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequired._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequired_protocolIEs),
        ])
    HandoverRequired._ext = []
    
    #-----< HandoverRequiredIEs >-----#
    HandoverRequiredIEs = CLASS(name=u'HandoverRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequiredIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequiredIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverRequiredIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverRequiredIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverRequiredIEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetID')))
    _HandoverRequiredIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _HandoverRequiredIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListHORqd')))
    _HandoverRequiredIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    HandoverRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCommand >-----#
    HandoverCommand = SEQ(name=u'HandoverCommand', mode=MODE_TYPE)
    _HandoverCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NASSecurityParametersFromNGRAN')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListHOCmd')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommand_protocolIEs__item__id._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__id._const_tab_at = None
    ___HandoverCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCommand_protocolIEs__item__criticality._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCommand_protocolIEs__item__value._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCommand_protocolIEs__item__id),
        (u'criticality', ___HandoverCommand_protocolIEs__item__criticality),
        (u'value', ___HandoverCommand_protocolIEs__item__value),
        ])
    __HandoverCommand_protocolIEs__item_._ext = None
    _HandoverCommand_protocolIEs._cont = __HandoverCommand_protocolIEs__item_
    _HandoverCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCommand._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCommand_protocolIEs),
        ])
    HandoverCommand._ext = []
    
    #-----< HandoverCommandIEs >-----#
    HandoverCommandIEs = CLASS(name=u'HandoverCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCommandIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCommandIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverCommandIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NASSecurityParametersFromNGRAN')))
    _HandoverCommandIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverList')))
    _HandoverCommandIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListHOCmd')))
    _HandoverCommandIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    HandoverCommandIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name=u'HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverPreparationFailure_protocolIEs__item__id),
        (u'criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        (u'value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        (u'protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailureIEs >-----#
    HandoverPreparationFailureIEs = CLASS(name=u'HandoverPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverPreparationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverPreparationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverPreparationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverPreparationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverPreparationFailureIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    HandoverPreparationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name=u'HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListHOReq')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 37), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequest_protocolIEs__item__id),
        (u'criticality', ___HandoverRequest_protocolIEs__item__criticality),
        (u'value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequestIEs >-----#
    HandoverRequestIEs = CLASS(name=u'HandoverRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequestIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _HandoverRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _HandoverRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _HandoverRequestIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _HandoverRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _HandoverRequestIEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListHOReq')))
    _HandoverRequestIEs_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _HandoverRequestIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _HandoverRequestIEs_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _HandoverRequestIEs_val_Value_13 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    _HandoverRequestIEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _HandoverRequestIEs_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _HandoverRequestIEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _HandoverRequestIEs_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _HandoverRequestIEs_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _HandoverRequestIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _HandoverRequestIEs_val_Value_20 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequestIEs_val_Value_21 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _HandoverRequestIEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _HandoverRequestIEs_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _HandoverRequestIEs_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_25 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_27 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_28 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _HandoverRequestIEs_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _HandoverRequestIEs_val_Value_30 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _HandoverRequestIEs_val_Value_31 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _HandoverRequestIEs_val_Value_32 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _HandoverRequestIEs_val_Value_33 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    HandoverRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 37), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_10), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_13), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_17), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 199), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_33), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name=u'HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedList')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListHOAck')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledgeIEs >-----#
    HandoverRequestAcknowledgeIEs = CLASS(name=u'HandoverRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequestAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedList')))
    _HandoverRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListHOAck')))
    _HandoverRequestAcknowledgeIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _HandoverRequestAcknowledgeIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledgeIEs_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    HandoverRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverFailure >-----#
    HandoverFailure = SEQ(name=u'HandoverFailure', mode=MODE_TYPE)
    _HandoverFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    ____HandoverFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverFailure_protocolIEs__item__id._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverFailure_protocolIEs__item__criticality._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverFailure_protocolIEs__item__value._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverFailure_protocolIEs__item__id),
        (u'criticality', ___HandoverFailure_protocolIEs__item__criticality),
        (u'value', ___HandoverFailure_protocolIEs__item__value),
        ])
    __HandoverFailure_protocolIEs__item_._ext = None
    _HandoverFailure_protocolIEs._cont = __HandoverFailure_protocolIEs__item_
    _HandoverFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverFailure._cont = ASN1Dict([
        (u'protocolIEs', _HandoverFailure_protocolIEs),
        ])
    HandoverFailure._ext = []
    
    #-----< HandoverFailureIEs >-----#
    HandoverFailureIEs = CLASS(name=u'HandoverFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverFailureIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    HandoverFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverNotify >-----#
    HandoverNotify = SEQ(name=u'HandoverNotify', mode=MODE_TYPE)
    _HandoverNotify_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverNotify_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverNotify_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NotifySourceNGRANNode')))
    ____HandoverNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverNotify_protocolIEs__item__id._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__id._const_tab_at = None
    ___HandoverNotify_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverNotify_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverNotify_protocolIEs__item__criticality._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverNotify_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverNotify_protocolIEs__item__value._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverNotify_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverNotify_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverNotify_protocolIEs__item__id),
        (u'criticality', ___HandoverNotify_protocolIEs__item__criticality),
        (u'value', ___HandoverNotify_protocolIEs__item__value),
        ])
    __HandoverNotify_protocolIEs__item_._ext = None
    _HandoverNotify_protocolIEs._cont = __HandoverNotify_protocolIEs__item_
    _HandoverNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverNotify._cont = ASN1Dict([
        (u'protocolIEs', _HandoverNotify_protocolIEs),
        ])
    HandoverNotify._ext = []
    
    #-----< HandoverNotifyIEs >-----#
    HandoverNotifyIEs = CLASS(name=u'HandoverNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverNotifyIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverNotifyIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverNotifyIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _HandoverNotifyIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NotifySourceNGRANNode')))
    HandoverNotifyIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverNotifyIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _HandoverNotifyIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequest >-----#
    PathSwitchRequest = SEQ(name=u'PathSwitchRequest', mode=MODE_TYPE)
    _PathSwitchRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLList')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListPSReq')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    ____PathSwitchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 76), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequest_protocolIEs__item__id._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequest_protocolIEs__item__value._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequest_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequest_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequest_protocolIEs__item__value),
        ])
    __PathSwitchRequest_protocolIEs__item_._ext = None
    _PathSwitchRequest_protocolIEs._cont = __PathSwitchRequest_protocolIEs__item_
    _PathSwitchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequest._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequest_protocolIEs),
        ])
    PathSwitchRequest._ext = []
    
    #-----< PathSwitchRequestIEs >-----#
    PathSwitchRequestIEs = CLASS(name=u'PathSwitchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PathSwitchRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLList')))
    _PathSwitchRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListPSReq')))
    _PathSwitchRequestIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    PathSwitchRequestIEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 76), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestAcknowledge >-----#
    PathSwitchRequestAcknowledge = SEQ(name=u'PathSwitchRequestAcknowledge', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSAck')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequestAcknowledge_protocolIEs__item__value),
        ])
    __PathSwitchRequestAcknowledge_protocolIEs__item_._ext = None
    _PathSwitchRequestAcknowledge_protocolIEs._cont = __PathSwitchRequestAcknowledge_protocolIEs__item_
    _PathSwitchRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequestAcknowledge_protocolIEs),
        ])
    PathSwitchRequestAcknowledge._ext = []
    
    #-----< PathSwitchRequestAcknowledgeIEs >-----#
    PathSwitchRequestAcknowledgeIEs = CLASS(name=u'PathSwitchRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSAck')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_17 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_23 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_24 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_25 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    PathSwitchRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_25), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestFailure >-----#
    PathSwitchRequestFailure = SEQ(name=u'PathSwitchRequestFailure', mode=MODE_TYPE)
    _PathSwitchRequestFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSFail')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequestFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequestFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestFailure_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequestFailure_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequestFailure_protocolIEs__item__value),
        ])
    __PathSwitchRequestFailure_protocolIEs__item_._ext = None
    _PathSwitchRequestFailure_protocolIEs._cont = __PathSwitchRequestFailure_protocolIEs__item_
    _PathSwitchRequestFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestFailure._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequestFailure_protocolIEs),
        ])
    PathSwitchRequestFailure._ext = []
    
    #-----< PathSwitchRequestFailureIEs >-----#
    PathSwitchRequestFailureIEs = CLASS(name=u'PathSwitchRequestFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSFail')))
    _PathSwitchRequestFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PathSwitchRequestFailureIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name=u'HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCancel_protocolIEs__item__id),
        (u'criticality', ___HandoverCancel_protocolIEs__item__criticality),
        (u'value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancelIEs >-----#
    HandoverCancelIEs = CLASS(name=u'HandoverCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCancelIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCancelIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCancelIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    HandoverCancelIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverCancelIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _HandoverCancelIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverCancelIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancelAcknowledge >-----#
    HandoverCancelAcknowledge = SEQ(name=u'HandoverCancelAcknowledge', mode=MODE_TYPE)
    _HandoverCancelAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancelAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCancelAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCancelAcknowledge_protocolIEs__item__id),
        (u'criticality', ___HandoverCancelAcknowledge_protocolIEs__item__criticality),
        (u'value', ___HandoverCancelAcknowledge_protocolIEs__item__value),
        ])
    __HandoverCancelAcknowledge_protocolIEs__item_._ext = None
    _HandoverCancelAcknowledge_protocolIEs._cont = __HandoverCancelAcknowledge_protocolIEs__item_
    _HandoverCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancelAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCancelAcknowledge_protocolIEs),
        ])
    HandoverCancelAcknowledge._ext = []
    
    #-----< HandoverCancelAcknowledgeIEs >-----#
    HandoverCancelAcknowledgeIEs = CLASS(name=u'HandoverCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCancelAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    HandoverCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverSuccess >-----#
    HandoverSuccess = SEQ(name=u'HandoverSuccess', mode=MODE_TYPE)
    _HandoverSuccess_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverSuccess_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____HandoverSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    ____HandoverSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverSuccess_protocolIEs__item__id._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__id._const_tab_at = None
    ___HandoverSuccess_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverSuccess_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverSuccess_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___HandoverSuccess_protocolIEs__item__value._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverSuccess_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverSuccess_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverSuccess_protocolIEs__item__id),
        (u'criticality', ___HandoverSuccess_protocolIEs__item__criticality),
        (u'value', ___HandoverSuccess_protocolIEs__item__value),
        ])
    __HandoverSuccess_protocolIEs__item_._ext = None
    _HandoverSuccess_protocolIEs._cont = __HandoverSuccess_protocolIEs__item_
    _HandoverSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverSuccess._cont = ASN1Dict([
        (u'protocolIEs', _HandoverSuccess_protocolIEs),
        ])
    HandoverSuccess._ext = []
    
    #-----< HandoverSuccessIEs >-----#
    HandoverSuccessIEs = CLASS(name=u'HandoverSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverSuccessIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverSuccessIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    HandoverSuccessIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverSuccessIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _HandoverSuccessIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRANEarlyStatusTransfer >-----#
    UplinkRANEarlyStatusTransfer = SEQ(name=u'UplinkRANEarlyStatusTransfer', mode=MODE_TYPE)
    _UplinkRANEarlyStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_._ext = None
    _UplinkRANEarlyStatusTransfer_protocolIEs._cont = __UplinkRANEarlyStatusTransfer_protocolIEs__item_
    _UplinkRANEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANEarlyStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UplinkRANEarlyStatusTransfer_protocolIEs),
        ])
    UplinkRANEarlyStatusTransfer._ext = []
    
    #-----< UplinkRANEarlyStatusTransferIEs >-----#
    UplinkRANEarlyStatusTransferIEs = CLASS(name=u'UplinkRANEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    UplinkRANEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UplinkRANEarlyStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UplinkRANEarlyStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _UplinkRANEarlyStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANEarlyStatusTransfer >-----#
    DownlinkRANEarlyStatusTransfer = SEQ(name=u'DownlinkRANEarlyStatusTransfer', mode=MODE_TYPE)
    _DownlinkRANEarlyStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_._ext = None
    _DownlinkRANEarlyStatusTransfer_protocolIEs._cont = __DownlinkRANEarlyStatusTransfer_protocolIEs__item_
    _DownlinkRANEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANEarlyStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkRANEarlyStatusTransfer_protocolIEs),
        ])
    DownlinkRANEarlyStatusTransfer._ext = []
    
    #-----< DownlinkRANEarlyStatusTransferIEs >-----#
    DownlinkRANEarlyStatusTransferIEs = CLASS(name=u'DownlinkRANEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    DownlinkRANEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRANStatusTransfer >-----#
    UplinkRANStatusTransfer = SEQ(name=u'UplinkRANStatusTransfer', mode=MODE_TYPE)
    _UplinkRANStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkRANStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    ____UplinkRANStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkRANStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkRANStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkRANStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___UplinkRANStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___UplinkRANStatusTransfer_protocolIEs__item__value),
        ])
    __UplinkRANStatusTransfer_protocolIEs__item_._ext = None
    _UplinkRANStatusTransfer_protocolIEs._cont = __UplinkRANStatusTransfer_protocolIEs__item_
    _UplinkRANStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UplinkRANStatusTransfer_protocolIEs),
        ])
    UplinkRANStatusTransfer._ext = []
    
    #-----< UplinkRANStatusTransferIEs >-----#
    UplinkRANStatusTransferIEs = CLASS(name=u'UplinkRANStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkRANStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkRANStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    UplinkRANStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UplinkRANStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UplinkRANStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _UplinkRANStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANStatusTransfer >-----#
    DownlinkRANStatusTransfer = SEQ(name=u'DownlinkRANStatusTransfer', mode=MODE_TYPE)
    _DownlinkRANStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkRANStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkRANStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkRANStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___DownlinkRANStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___DownlinkRANStatusTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANStatusTransfer_protocolIEs__item_._ext = None
    _DownlinkRANStatusTransfer_protocolIEs._cont = __DownlinkRANStatusTransfer_protocolIEs__item_
    _DownlinkRANStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkRANStatusTransfer_protocolIEs),
        ])
    DownlinkRANStatusTransfer._ext = []
    
    #-----< DownlinkRANStatusTransferIEs >-----#
    DownlinkRANStatusTransferIEs = CLASS(name=u'DownlinkRANStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkRANStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkRANStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    DownlinkRANStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _DownlinkRANStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _DownlinkRANStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _DownlinkRANStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name=u'Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPagingIdentity')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingOrigin')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXInfo')))
    _____Paging_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____Paging_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WUS-Assistance-Information')))
    _____Paging_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingeDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = u'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__value._const_tab_id = u'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Paging_protocolIEs__item__id),
        (u'criticality', ___Paging_protocolIEs__item__criticality),
        (u'value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        (u'protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name=u'PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPagingIdentity')))
    _PagingIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPaging')))
    _PagingIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _PagingIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingOrigin')))
    _PagingIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForPaging')))
    _PagingIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXInfo')))
    _PagingIEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-PagingDRX')))
    _PagingIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _PagingIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WUS-Assistance-Information')))
    _PagingIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingeDRXInformation')))
    _PagingIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    PagingIEs._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_12), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUEMessage >-----#
    InitialUEMessage = SEQ(name=u'InitialUEMessage', mode=MODE_TYPE)
    _InitialUEMessage_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialUEMessage_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialUEMessage_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____InitialUEMessage_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextRequest')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IABNodeIndication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBSupport-Indicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEM-Indication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EDT-Session')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AuthenticatedIndication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    ____InitialUEMessage_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 225), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialUEMessage_protocolIEs__item__id._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__id._const_tab_at = None
    ___InitialUEMessage_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialUEMessage_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialUEMessage_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___InitialUEMessage_protocolIEs__item__value._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialUEMessage_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialUEMessage_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialUEMessage_protocolIEs__item__id),
        (u'criticality', ___InitialUEMessage_protocolIEs__item__criticality),
        (u'value', ___InitialUEMessage_protocolIEs__item__value),
        ])
    __InitialUEMessage_protocolIEs__item_._ext = None
    _InitialUEMessage_protocolIEs._cont = __InitialUEMessage_protocolIEs__item_
    _InitialUEMessage_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialUEMessage._cont = ASN1Dict([
        (u'protocolIEs', _InitialUEMessage_protocolIEs),
        ])
    InitialUEMessage._ext = []
    
    #-----< InitialUEMessage-IEs >-----#
    InitialUEMessage_IEs = CLASS(name=u'InitialUEMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialUEMessage_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialUEMessage_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _InitialUEMessage_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _InitialUEMessage_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _InitialUEMessage_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _InitialUEMessage_IEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _InitialUEMessage_IEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextRequest')))
    _InitialUEMessage_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _InitialUEMessage_IEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    _InitialUEMessage_IEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _InitialUEMessage_IEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IABNodeIndication')))
    _InitialUEMessage_IEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBSupport-Indicator')))
    _InitialUEMessage_IEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEM-Indication')))
    _InitialUEMessage_IEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EDT-Session')))
    _InitialUEMessage_IEs_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AuthenticatedIndication')))
    _InitialUEMessage_IEs_val_Value_15 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    InitialUEMessage_IEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 225), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNASTransport >-----#
    DownlinkNASTransport = SEQ(name=u'DownlinkNASTransport', mode=MODE_TYPE)
    _DownlinkNASTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNASTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UECapabilityInfoRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____DownlinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkNASTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkNASTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkNASTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkNASTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkNASTransport_protocolIEs__item__value),
        ])
    __DownlinkNASTransport_protocolIEs__item_._ext = None
    _DownlinkNASTransport_protocolIEs._cont = __DownlinkNASTransport_protocolIEs__item_
    _DownlinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNASTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkNASTransport_protocolIEs),
        ])
    DownlinkNASTransport._ext = []
    
    #-----< DownlinkNASTransport-IEs >-----#
    DownlinkNASTransport_IEs = CLASS(name=u'DownlinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkNASTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkNASTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkNASTransport_IEs_val_Value_2 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _DownlinkNASTransport_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _DownlinkNASTransport_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _DownlinkNASTransport_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _DownlinkNASTransport_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _DownlinkNASTransport_IEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _DownlinkNASTransport_IEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _DownlinkNASTransport_IEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _DownlinkNASTransport_IEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _DownlinkNASTransport_IEs_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _DownlinkNASTransport_IEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _DownlinkNASTransport_IEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _DownlinkNASTransport_IEs_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _DownlinkNASTransport_IEs_val_Value_15 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UECapabilityInfoRequest')))
    _DownlinkNASTransport_IEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _DownlinkNASTransport_IEs_val_Value_17 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    DownlinkNASTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_17), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNASTransport >-----#
    UplinkNASTransport = SEQ(name=u'UplinkNASTransport', mode=MODE_TYPE)
    _UplinkNASTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkNASTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    ____UplinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 239), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 246), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkNASTransport_protocolIEs__item__id._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkNASTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkNASTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkNASTransport_protocolIEs__item__value._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkNASTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkNASTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkNASTransport_protocolIEs__item__value),
        ])
    __UplinkNASTransport_protocolIEs__item_._ext = None
    _UplinkNASTransport_protocolIEs._cont = __UplinkNASTransport_protocolIEs__item_
    _UplinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNASTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkNASTransport_protocolIEs),
        ])
    UplinkNASTransport._ext = []
    
    #-----< UplinkNASTransport-IEs >-----#
    UplinkNASTransport_IEs = CLASS(name=u'UplinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkNASTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkNASTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkNASTransport_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _UplinkNASTransport_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UplinkNASTransport_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _UplinkNASTransport_IEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _UplinkNASTransport_IEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    UplinkNASTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 239), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 246), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASNonDeliveryIndication >-----#
    NASNonDeliveryIndication = SEQ(name=u'NASNonDeliveryIndication', mode=MODE_TYPE)
    _NASNonDeliveryIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NASNonDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NASNonDeliveryIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___NASNonDeliveryIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NASNonDeliveryIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __NASNonDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NASNonDeliveryIndication_protocolIEs__item__id),
        (u'criticality', ___NASNonDeliveryIndication_protocolIEs__item__criticality),
        (u'value', ___NASNonDeliveryIndication_protocolIEs__item__value),
        ])
    __NASNonDeliveryIndication_protocolIEs__item_._ext = None
    _NASNonDeliveryIndication_protocolIEs._cont = __NASNonDeliveryIndication_protocolIEs__item_
    _NASNonDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASNonDeliveryIndication._cont = ASN1Dict([
        (u'protocolIEs', _NASNonDeliveryIndication_protocolIEs),
        ])
    NASNonDeliveryIndication._ext = []
    
    #-----< NASNonDeliveryIndication-IEs >-----#
    NASNonDeliveryIndication_IEs = CLASS(name=u'NASNonDeliveryIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NASNonDeliveryIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _NASNonDeliveryIndication_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    NASNonDeliveryIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name=u'RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RerouteNASRequest_protocolIEs__item__id),
        (u'criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        (u'value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        (u'protocolIEs', _RerouteNASRequest_protocolIEs),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequest-IEs >-----#
    RerouteNASRequest_IEs = CLASS(name=u'RerouteNASRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RerouteNASRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RerouteNASRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _RerouteNASRequest_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _RerouteNASRequest_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _RerouteNASRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _RerouteNASRequest_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    RerouteNASRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequest_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequest_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupRequest >-----#
    NGSetupRequest = SEQ(name=u'NGSetupRequest', mode=MODE_TYPE)
    _NGSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NGSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    ____NGSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NGSetupRequest_protocolIEs__item__id._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___NGSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___NGSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NGSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGSetupRequest_protocolIEs__item__value._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NGSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __NGSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NGSetupRequest_protocolIEs__item__id),
        (u'criticality', ___NGSetupRequest_protocolIEs__item__criticality),
        (u'value', ___NGSetupRequest_protocolIEs__item__value),
        ])
    __NGSetupRequest_protocolIEs__item_._ext = None
    _NGSetupRequest_protocolIEs._cont = __NGSetupRequest_protocolIEs__item_
    _NGSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _NGSetupRequest_protocolIEs),
        ])
    NGSetupRequest._ext = []
    
    #-----< NGSetupRequestIEs >-----#
    NGSetupRequestIEs = CLASS(name=u'NGSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupRequestIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _NGSetupRequestIEs_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _NGSetupRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _NGSetupRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _NGSetupRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _NGSetupRequestIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _NGSetupRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    NGSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _NGSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _NGSetupRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _NGSetupRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _NGSetupRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _NGSetupRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _NGSetupRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _NGSetupRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupResponse >-----#
    NGSetupResponse = SEQ(name=u'NGSetupResponse', mode=MODE_TYPE)
    _NGSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NGSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Supported')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    ____NGSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NGSetupResponse_protocolIEs__item__id._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___NGSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___NGSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NGSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGSetupResponse_protocolIEs__item__value._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NGSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __NGSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NGSetupResponse_protocolIEs__item__id),
        (u'criticality', ___NGSetupResponse_protocolIEs__item__criticality),
        (u'value', ___NGSetupResponse_protocolIEs__item__value),
        ])
    __NGSetupResponse_protocolIEs__item_._ext = None
    _NGSetupResponse_protocolIEs._cont = __NGSetupResponse_protocolIEs__item_
    _NGSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _NGSetupResponse_protocolIEs),
        ])
    NGSetupResponse._ext = []
    
    #-----< NGSetupResponseIEs >-----#
    NGSetupResponseIEs = CLASS(name=u'NGSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupResponseIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _NGSetupResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _NGSetupResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _NGSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _NGSetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _NGSetupResponseIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _NGSetupResponseIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Supported')))
    _NGSetupResponseIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    NGSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _NGSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _NGSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _NGSetupResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', _NGSetupResponseIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _NGSetupResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _NGSetupResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', _NGSetupResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', _NGSetupResponseIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupFailure >-----#
    NGSetupFailure = SEQ(name=u'NGSetupFailure', mode=MODE_TYPE)
    _NGSetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NGSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____NGSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NGSetupFailure_protocolIEs__item__id._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___NGSetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___NGSetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NGSetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGSetupFailure_protocolIEs__item__value._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NGSetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __NGSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NGSetupFailure_protocolIEs__item__id),
        (u'criticality', ___NGSetupFailure_protocolIEs__item__criticality),
        (u'value', ___NGSetupFailure_protocolIEs__item__value),
        ])
    __NGSetupFailure_protocolIEs__item_._ext = None
    _NGSetupFailure_protocolIEs._cont = __NGSetupFailure_protocolIEs__item_
    _NGSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _NGSetupFailure_protocolIEs),
        ])
    NGSetupFailure._ext = []
    
    #-----< NGSetupFailureIEs >-----#
    NGSetupFailureIEs = CLASS(name=u'NGSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _NGSetupFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _NGSetupFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    NGSetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _NGSetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _NGSetupFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _NGSetupFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdate >-----#
    RANConfigurationUpdate = SEQ(name=u'RANConfigurationUpdate', mode=MODE_TYPE)
    _RANConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RANConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveList')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    ____RANConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'reject'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___RANConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __RANConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___RANConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___RANConfigurationUpdate_protocolIEs__item__value),
        ])
    __RANConfigurationUpdate_protocolIEs__item_._ext = None
    _RANConfigurationUpdate_protocolIEs._cont = __RANConfigurationUpdate_protocolIEs__item_
    _RANConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _RANConfigurationUpdate_protocolIEs),
        ])
    RANConfigurationUpdate._ext = []
    
    #-----< RANConfigurationUpdateIEs >-----#
    RANConfigurationUpdateIEs = CLASS(name=u'RANConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _RANConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _RANConfigurationUpdateIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _RANConfigurationUpdateIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _RANConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveList')))
    _RANConfigurationUpdateIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _RANConfigurationUpdateIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    RANConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _RANConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'reject'), (u'Value', _RANConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdateAcknowledge >-----#
    RANConfigurationUpdateAcknowledge = SEQ(name=u'RANConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _RANConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _RANConfigurationUpdateAcknowledge_protocolIEs._cont = __RANConfigurationUpdateAcknowledge_protocolIEs__item_
    _RANConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _RANConfigurationUpdateAcknowledge_protocolIEs),
        ])
    RANConfigurationUpdateAcknowledge._ext = []
    
    #-----< RANConfigurationUpdateAcknowledgeIEs >-----#
    RANConfigurationUpdateAcknowledgeIEs = CLASS(name=u'RANConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    RANConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdateFailure >-----#
    RANConfigurationUpdateFailure = SEQ(name=u'RANConfigurationUpdateFailure', mode=MODE_TYPE)
    _RANConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __RANConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___RANConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___RANConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __RANConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _RANConfigurationUpdateFailure_protocolIEs._cont = __RANConfigurationUpdateFailure_protocolIEs__item_
    _RANConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _RANConfigurationUpdateFailure_protocolIEs),
        ])
    RANConfigurationUpdateFailure._ext = []
    
    #-----< RANConfigurationUpdateFailureIEs >-----#
    RANConfigurationUpdateFailureIEs = CLASS(name=u'RANConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _RANConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _RANConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    RANConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _RANConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdate >-----#
    AMFConfigurationUpdate = SEQ(name=u'AMFConfigurationUpdate', mode=MODE_TYPE)
    _AMFConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____AMFConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    ____AMFConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___AMFConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AMFConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __AMFConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AMFConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___AMFConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___AMFConfigurationUpdate_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdate_protocolIEs__item_._ext = None
    _AMFConfigurationUpdate_protocolIEs._cont = __AMFConfigurationUpdate_protocolIEs__item_
    _AMFConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _AMFConfigurationUpdate_protocolIEs),
        ])
    AMFConfigurationUpdate._ext = []
    
    #-----< AMFConfigurationUpdateIEs >-----#
    AMFConfigurationUpdateIEs = CLASS(name=u'AMFConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _AMFConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _AMFConfigurationUpdateIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _AMFConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _AMFConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddList')))
    _AMFConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveList')))
    _AMFConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateList')))
    _AMFConfigurationUpdateIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    AMFConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 80), (u'criticality', u'reject'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdateAcknowledge >-----#
    AMFConfigurationUpdateAcknowledge = SEQ(name=u'AMFConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _AMFConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupList')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationList')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _AMFConfigurationUpdateAcknowledge_protocolIEs._cont = __AMFConfigurationUpdateAcknowledge_protocolIEs__item_
    _AMFConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _AMFConfigurationUpdateAcknowledge_protocolIEs),
        ])
    AMFConfigurationUpdateAcknowledge._ext = []
    
    #-----< AMFConfigurationUpdateAcknowledgeIEs >-----#
    AMFConfigurationUpdateAcknowledgeIEs = CLASS(name=u'AMFConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupList')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationList')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    AMFConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdateFailure >-----#
    AMFConfigurationUpdateFailure = SEQ(name=u'AMFConfigurationUpdateFailure', mode=MODE_TYPE)
    _AMFConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __AMFConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AMFConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___AMFConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _AMFConfigurationUpdateFailure_protocolIEs._cont = __AMFConfigurationUpdateFailure_protocolIEs__item_
    _AMFConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _AMFConfigurationUpdateFailure_protocolIEs),
        ])
    AMFConfigurationUpdateFailure._ext = []
    
    #-----< AMFConfigurationUpdateFailureIEs >-----#
    AMFConfigurationUpdateFailureIEs = CLASS(name=u'AMFConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _AMFConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _AMFConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    AMFConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _AMFConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFStatusIndication >-----#
    AMFStatusIndication = SEQ(name=u'AMFStatusIndication', mode=MODE_TYPE)
    _AMFStatusIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFStatusIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____AMFStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIList')))
    ____AMFStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'reject'), (u'Value', _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___AMFStatusIndication_protocolIEs__item__id._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___AMFStatusIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___AMFStatusIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AMFStatusIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFStatusIndication_protocolIEs__item__value._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AMFStatusIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __AMFStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AMFStatusIndication_protocolIEs__item__id),
        (u'criticality', ___AMFStatusIndication_protocolIEs__item__criticality),
        (u'value', ___AMFStatusIndication_protocolIEs__item__value),
        ])
    __AMFStatusIndication_protocolIEs__item_._ext = None
    _AMFStatusIndication_protocolIEs._cont = __AMFStatusIndication_protocolIEs__item_
    _AMFStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFStatusIndication._cont = ASN1Dict([
        (u'protocolIEs', _AMFStatusIndication_protocolIEs),
        ])
    AMFStatusIndication._ext = []
    
    #-----< AMFStatusIndicationIEs >-----#
    AMFStatusIndicationIEs = CLASS(name=u'AMFStatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFStatusIndicationIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIList')))
    AMFStatusIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'reject'), (u'Value', _AMFStatusIndicationIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NGReset >-----#
    NGReset = SEQ(name=u'NGReset', mode=MODE_TYPE)
    _NGReset_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGReset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGReset_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NGReset_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGReset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____NGReset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ResetType')))
    ____NGReset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____NGReset_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', _____NGReset_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___NGReset_protocolIEs__item__id._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__id._const_tab_at = None
    ___NGReset_protocolIEs__item__id._const_tab_id = u'id'
    ___NGReset_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGReset_protocolIEs__item__criticality._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NGReset_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NGReset_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGReset_protocolIEs__item__value._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NGReset_protocolIEs__item__value._const_tab_id = u'Value'
    __NGReset_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NGReset_protocolIEs__item__id),
        (u'criticality', ___NGReset_protocolIEs__item__criticality),
        (u'value', ___NGReset_protocolIEs__item__value),
        ])
    __NGReset_protocolIEs__item_._ext = None
    _NGReset_protocolIEs._cont = __NGReset_protocolIEs__item_
    _NGReset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGReset._cont = ASN1Dict([
        (u'protocolIEs', _NGReset_protocolIEs),
        ])
    NGReset._ext = []
    
    #-----< NGResetIEs >-----#
    NGResetIEs = CLASS(name=u'NGResetIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGResetIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _NGResetIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ResetType')))
    NGResetIEs._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _NGResetIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', _NGResetIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NGResetAcknowledge >-----#
    NGResetAcknowledge = SEQ(name=u'NGResetAcknowledge', mode=MODE_TYPE)
    _NGResetAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGResetAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____NGResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____NGResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___NGResetAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NGResetAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __NGResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NGResetAcknowledge_protocolIEs__item__id),
        (u'criticality', ___NGResetAcknowledge_protocolIEs__item__criticality),
        (u'value', ___NGResetAcknowledge_protocolIEs__item__value),
        ])
    __NGResetAcknowledge_protocolIEs__item_._ext = None
    _NGResetAcknowledge_protocolIEs._cont = __NGResetAcknowledge_protocolIEs__item_
    _NGResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGResetAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _NGResetAcknowledge_protocolIEs),
        ])
    NGResetAcknowledge._ext = []
    
    #-----< NGResetAcknowledgeIEs >-----#
    NGResetAcknowledgeIEs = CLASS(name=u'NGResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGResetAcknowledgeIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _NGResetAcknowledgeIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    NGResetAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _NGResetAcknowledgeIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _NGResetAcknowledgeIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name=u'ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _ErrorIndicationIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStart >-----#
    OverloadStart = SEQ(name=u'OverloadStart', mode=MODE_TYPE)
    _OverloadStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __OverloadStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___OverloadStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____OverloadStart_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIList')))
    ____OverloadStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___OverloadStart_protocolIEs__item__id._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__id._const_tab_at = None
    ___OverloadStart_protocolIEs__item__id._const_tab_id = u'id'
    ___OverloadStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___OverloadStart_protocolIEs__item__criticality._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OverloadStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OverloadStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___OverloadStart_protocolIEs__item__value._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OverloadStart_protocolIEs__item__value._const_tab_id = u'Value'
    __OverloadStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OverloadStart_protocolIEs__item__id),
        (u'criticality', ___OverloadStart_protocolIEs__item__criticality),
        (u'value', ___OverloadStart_protocolIEs__item__value),
        ])
    __OverloadStart_protocolIEs__item_._ext = None
    _OverloadStart_protocolIEs._cont = __OverloadStart_protocolIEs__item_
    _OverloadStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStart._cont = ASN1Dict([
        (u'protocolIEs', _OverloadStart_protocolIEs),
        ])
    OverloadStart._ext = []
    
    #-----< OverloadStartIEs >-----#
    OverloadStartIEs = CLASS(name=u'OverloadStartIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _OverloadStartIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')))
    _OverloadStartIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')))
    _OverloadStartIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIList')))
    OverloadStartIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _OverloadStartIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _OverloadStartIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _OverloadStartIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStop >-----#
    OverloadStop = SEQ(name=u'OverloadStop', mode=MODE_TYPE)
    _OverloadStop_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __OverloadStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___OverloadStop_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____OverloadStop_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__id._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__id._const_tab_at = None
    ___OverloadStop_protocolIEs__item__id._const_tab_id = u'id'
    ___OverloadStop_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ____OverloadStop_protocolIEs__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__criticality._const_tab = ____OverloadStop_protocolIEs__item__criticality_tab
    ___OverloadStop_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OverloadStop_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OverloadStop_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ____OverloadStop_protocolIEs__item__value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__value._const_tab = ____OverloadStop_protocolIEs__item__value_tab
    ___OverloadStop_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OverloadStop_protocolIEs__item__value._const_tab_id = u'Value'
    __OverloadStop_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OverloadStop_protocolIEs__item__id),
        (u'criticality', ___OverloadStop_protocolIEs__item__criticality),
        (u'value', ___OverloadStop_protocolIEs__item__value),
        ])
    __OverloadStop_protocolIEs__item_._ext = None
    _OverloadStop_protocolIEs._cont = __OverloadStop_protocolIEs__item_
    _OverloadStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStop._cont = ASN1Dict([
        (u'protocolIEs', _OverloadStop_protocolIEs),
        ])
    OverloadStop._ext = []
    
    #-----< OverloadStopIEs >-----#
    OverloadStopIEs = CLASS(name=u'OverloadStopIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    OverloadStopIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkRANConfigurationTransfer >-----#
    UplinkRANConfigurationTransfer = SEQ(name=u'UplinkRANConfigurationTransfer', mode=MODE_TYPE)
    _UplinkRANConfigurationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkRANConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkRANConfigurationTransfer_protocolIEs__item__id),
        (u'criticality', ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality),
        (u'value', ___UplinkRANConfigurationTransfer_protocolIEs__item__value),
        ])
    __UplinkRANConfigurationTransfer_protocolIEs__item_._ext = None
    _UplinkRANConfigurationTransfer_protocolIEs._cont = __UplinkRANConfigurationTransfer_protocolIEs__item_
    _UplinkRANConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANConfigurationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UplinkRANConfigurationTransfer_protocolIEs),
        ])
    UplinkRANConfigurationTransfer._ext = []
    
    #-----< UplinkRANConfigurationTransferIEs >-----#
    UplinkRANConfigurationTransferIEs = CLASS(name=u'UplinkRANConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANConfigurationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _UplinkRANConfigurationTransferIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _UplinkRANConfigurationTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    UplinkRANConfigurationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Value', _UplinkRANConfigurationTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _UplinkRANConfigurationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _UplinkRANConfigurationTransferIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANConfigurationTransfer >-----#
    DownlinkRANConfigurationTransfer = SEQ(name=u'DownlinkRANConfigurationTransfer', mode=MODE_TYPE)
    _DownlinkRANConfigurationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkRANConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkRANConfigurationTransfer_protocolIEs__item__id),
        (u'criticality', ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality),
        (u'value', ___DownlinkRANConfigurationTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANConfigurationTransfer_protocolIEs__item_._ext = None
    _DownlinkRANConfigurationTransfer_protocolIEs._cont = __DownlinkRANConfigurationTransfer_protocolIEs__item_
    _DownlinkRANConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANConfigurationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkRANConfigurationTransfer_protocolIEs),
        ])
    DownlinkRANConfigurationTransfer._ext = []
    
    #-----< DownlinkRANConfigurationTransferIEs >-----#
    DownlinkRANConfigurationTransferIEs = CLASS(name=u'DownlinkRANConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANConfigurationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _DownlinkRANConfigurationTransferIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _DownlinkRANConfigurationTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    DownlinkRANConfigurationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _DownlinkRANConfigurationTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _DownlinkRANConfigurationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _DownlinkRANConfigurationTransferIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name=u'WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcastsRequested')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningType')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningSecurityInfo')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataCodingScheme')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningMessageContents')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConcurrentWarningMessageInd')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaCoordinates')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name=u'WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcastsRequested')))
    _WriteReplaceWarningRequestIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningType')))
    _WriteReplaceWarningRequestIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningSecurityInfo')))
    _WriteReplaceWarningRequestIEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataCodingScheme')))
    _WriteReplaceWarningRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningMessageContents')))
    _WriteReplaceWarningRequestIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConcurrentWarningMessageInd')))
    _WriteReplaceWarningRequestIEs_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaCoordinates')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name=u'WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCompletedAreaList')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name=u'WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCompletedAreaList')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelRequest >-----#
    PWSCancelRequest = SEQ(name=u'PWSCancelRequest', mode=MODE_TYPE)
    _PWSCancelRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSCancelRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PWSCancelRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelAllWarningMessages')))
    ____PWSCancelRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelRequest_protocolIEs__item__id._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSCancelRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSCancelRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PWSCancelRequest_protocolIEs__item__value._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSCancelRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSCancelRequest_protocolIEs__item__id),
        (u'criticality', ___PWSCancelRequest_protocolIEs__item__criticality),
        (u'value', ___PWSCancelRequest_protocolIEs__item__value),
        ])
    __PWSCancelRequest_protocolIEs__item_._ext = None
    _PWSCancelRequest_protocolIEs._cont = __PWSCancelRequest_protocolIEs__item_
    _PWSCancelRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelRequest._cont = ASN1Dict([
        (u'protocolIEs', _PWSCancelRequest_protocolIEs),
        ])
    PWSCancelRequest._ext = []
    
    #-----< PWSCancelRequestIEs >-----#
    PWSCancelRequestIEs = CLASS(name=u'PWSCancelRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSCancelRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _PWSCancelRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _PWSCancelRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _PWSCancelRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelAllWarningMessages')))
    PWSCancelRequestIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _PWSCancelRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _PWSCancelRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelResponse >-----#
    PWSCancelResponse = SEQ(name=u'PWSCancelResponse', mode=MODE_TYPE)
    _PWSCancelResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSCancelResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PWSCancelResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCancelledAreaList')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PWSCancelResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelResponse_protocolIEs__item__id._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSCancelResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSCancelResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PWSCancelResponse_protocolIEs__item__value._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSCancelResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSCancelResponse_protocolIEs__item__id),
        (u'criticality', ___PWSCancelResponse_protocolIEs__item__criticality),
        (u'value', ___PWSCancelResponse_protocolIEs__item__value),
        ])
    __PWSCancelResponse_protocolIEs__item_._ext = None
    _PWSCancelResponse_protocolIEs._cont = __PWSCancelResponse_protocolIEs__item_
    _PWSCancelResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelResponse._cont = ASN1Dict([
        (u'protocolIEs', _PWSCancelResponse_protocolIEs),
        ])
    PWSCancelResponse._ext = []
    
    #-----< PWSCancelResponseIEs >-----#
    PWSCancelResponseIEs = CLASS(name=u'PWSCancelResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSCancelResponseIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _PWSCancelResponseIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _PWSCancelResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCancelledAreaList')))
    _PWSCancelResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PWSCancelResponseIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _PWSCancelResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _PWSCancelResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _PWSCancelResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _PWSCancelResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name=u'PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDListForRestart')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSRestartIndication_protocolIEs__item__id),
        (u'criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        (u'value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name=u'PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDListForRestart')))
    _PWSRestartIndicationIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _PWSRestartIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDListForRestart')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name=u'PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PWSFailedCellIDList')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSFailureIndication_protocolIEs__item__id),
        (u'criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        (u'value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name=u'PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PWSFailedCellIDList')))
    _PWSFailureIndicationIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkUEAssociatedNRPPaTransport >-----#
    DownlinkUEAssociatedNRPPaTransport = SEQ(name=u'DownlinkUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs._cont = __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkUEAssociatedNRPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkUEAssociatedNRPPaTransport_protocolIEs),
        ])
    DownlinkUEAssociatedNRPPaTransport._ext = []
    
    #-----< DownlinkUEAssociatedNRPPaTransportIEs >-----#
    DownlinkUEAssociatedNRPPaTransportIEs = CLASS(name=u'DownlinkUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    DownlinkUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkUEAssociatedNRPPaTransport >-----#
    UplinkUEAssociatedNRPPaTransport = SEQ(name=u'UplinkUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _UplinkUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _UplinkUEAssociatedNRPPaTransport_protocolIEs._cont = __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_
    _UplinkUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkUEAssociatedNRPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkUEAssociatedNRPPaTransport_protocolIEs),
        ])
    UplinkUEAssociatedNRPPaTransport._ext = []
    
    #-----< UplinkUEAssociatedNRPPaTransportIEs >-----#
    UplinkUEAssociatedNRPPaTransportIEs = CLASS(name=u'UplinkUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    UplinkUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNonUEAssociatedNRPPaTransport >-----#
    DownlinkNonUEAssociatedNRPPaTransport = SEQ(name=u'DownlinkNonUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs._cont = __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNonUEAssociatedNRPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs),
        ])
    DownlinkNonUEAssociatedNRPPaTransport._ext = []
    
    #-----< DownlinkNonUEAssociatedNRPPaTransportIEs >-----#
    DownlinkNonUEAssociatedNRPPaTransportIEs = CLASS(name=u'DownlinkNonUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    DownlinkNonUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNonUEAssociatedNRPPaTransport >-----#
    UplinkNonUEAssociatedNRPPaTransport = SEQ(name=u'UplinkNonUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs._cont = __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNonUEAssociatedNRPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkNonUEAssociatedNRPPaTransport_protocolIEs),
        ])
    UplinkNonUEAssociatedNRPPaTransport._ext = []
    
    #-----< UplinkNonUEAssociatedNRPPaTransportIEs >-----#
    UplinkNonUEAssociatedNRPPaTransportIEs = CLASS(name=u'UplinkNonUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    UplinkNonUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'reject'), (u'Value', _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'reject'), (u'Value', _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name=u'TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = u'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = u'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TraceStart_protocolIEs__item__id),
        (u'criticality', ___TraceStart_protocolIEs__item__criticality),
        (u'value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        (u'protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name=u'TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Value', _TraceStartIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceFailureIndication >-----#
    TraceFailureIndication = SEQ(name=u'TraceFailureIndication', mode=MODE_TYPE)
    _TraceFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __TraceFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___TraceFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____TraceFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____TraceFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TraceFailureIndication_protocolIEs__item__id._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___TraceFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TraceFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___TraceFailureIndication_protocolIEs__item__value._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __TraceFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TraceFailureIndication_protocolIEs__item__id),
        (u'criticality', ___TraceFailureIndication_protocolIEs__item__criticality),
        (u'value', ___TraceFailureIndication_protocolIEs__item__value),
        ])
    __TraceFailureIndication_protocolIEs__item_._ext = None
    _TraceFailureIndication_protocolIEs._cont = __TraceFailureIndication_protocolIEs__item_
    _TraceFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _TraceFailureIndication_protocolIEs),
        ])
    TraceFailureIndication._ext = []
    
    #-----< TraceFailureIndicationIEs >-----#
    TraceFailureIndicationIEs = CLASS(name=u'TraceFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TraceFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _TraceFailureIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _TraceFailureIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _TraceFailureIndicationIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    TraceFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _TraceFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _TraceFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _TraceFailureIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _TraceFailureIndicationIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name=u'DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DeactivateTrace_protocolIEs__item__id),
        (u'criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        (u'value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        (u'protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name=u'DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _DeactivateTraceIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name=u'CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6 = STR_VIS(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellTrafficTrace_protocolIEs__item__id),
        (u'criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        (u'value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        (u'protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name=u'CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _CellTrafficTraceIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _CellTrafficTraceIEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_6 = STR_VIS(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name=u'LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingControl_protocolIEs__item__id),
        (u'criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        (u'value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        (u'protocolIEs', _LocationReportingControl_protocolIEs),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name=u'LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportingControlIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportingControlIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _LocationReportingControlIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _LocationReportingControlIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _LocationReportingControlIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingFailureIndication >-----#
    LocationReportingFailureIndication = SEQ(name=u'LocationReportingFailureIndication', mode=MODE_TYPE)
    _LocationReportingFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReportingFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReportingFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingFailureIndication_protocolIEs__item__id),
        (u'criticality', ___LocationReportingFailureIndication_protocolIEs__item__criticality),
        (u'value', ___LocationReportingFailureIndication_protocolIEs__item__value),
        ])
    __LocationReportingFailureIndication_protocolIEs__item_._ext = None
    _LocationReportingFailureIndication_protocolIEs._cont = __LocationReportingFailureIndication_protocolIEs__item_
    _LocationReportingFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _LocationReportingFailureIndication_protocolIEs),
        ])
    LocationReportingFailureIndication._ext = []
    
    #-----< LocationReportingFailureIndicationIEs >-----#
    LocationReportingFailureIndicationIEs = CLASS(name=u'LocationReportingFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportingFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    LocationReportingFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name=u'LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestList')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReport_protocolIEs__item__id),
        (u'criticality', ___LocationReport_protocolIEs__item__criticality),
        (u'value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        (u'protocolIEs', _LocationReport_protocolIEs),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name=u'LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _LocationReportIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestList')))
    _LocationReportIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    LocationReportIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _LocationReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _LocationReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UETNLABindingReleaseRequest >-----#
    UETNLABindingReleaseRequest = SEQ(name=u'UETNLABindingReleaseRequest', mode=MODE_TYPE)
    _UETNLABindingReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UETNLABindingReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UETNLABindingReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UETNLABindingReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UETNLABindingReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UETNLABindingReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___UETNLABindingReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___UETNLABindingReleaseRequest_protocolIEs__item__value),
        ])
    __UETNLABindingReleaseRequest_protocolIEs__item_._ext = None
    _UETNLABindingReleaseRequest_protocolIEs._cont = __UETNLABindingReleaseRequest_protocolIEs__item_
    _UETNLABindingReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UETNLABindingReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _UETNLABindingReleaseRequest_protocolIEs),
        ])
    UETNLABindingReleaseRequest._ext = []
    
    #-----< UETNLABindingReleaseRequestIEs >-----#
    UETNLABindingReleaseRequestIEs = CLASS(name=u'UETNLABindingReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UETNLABindingReleaseRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UETNLABindingReleaseRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    UETNLABindingReleaseRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UETNLABindingReleaseRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UETNLABindingReleaseRequestIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityInfoIndication >-----#
    UERadioCapabilityInfoIndication = SEQ(name=u'UERadioCapabilityInfoIndication', mode=MODE_TYPE)
    _UERadioCapabilityInfoIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityInfoIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityInfoIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityInfoIndication_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityInfoIndication_protocolIEs__item__value),
        ])
    __UERadioCapabilityInfoIndication_protocolIEs__item_._ext = None
    _UERadioCapabilityInfoIndication_protocolIEs._cont = __UERadioCapabilityInfoIndication_protocolIEs__item_
    _UERadioCapabilityInfoIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityInfoIndication._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityInfoIndication_protocolIEs),
        ])
    UERadioCapabilityInfoIndication._ext = []
    
    #-----< UERadioCapabilityInfoIndicationIEs >-----#
    UERadioCapabilityInfoIndicationIEs = CLASS(name=u'UERadioCapabilityInfoIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    UERadioCapabilityInfoIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityInfoIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityInfoIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityInfoIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityInfoIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityInfoIndicationIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityCheckRequest >-----#
    UERadioCapabilityCheckRequest = SEQ(name=u'UERadioCapabilityCheckRequest', mode=MODE_TYPE)
    _UERadioCapabilityCheckRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityCheckRequest_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityCheckRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityCheckRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityCheckRequest_protocolIEs._cont = __UERadioCapabilityCheckRequest_protocolIEs__item_
    _UERadioCapabilityCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityCheckRequest._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityCheckRequest_protocolIEs),
        ])
    UERadioCapabilityCheckRequest._ext = []
    
    #-----< UERadioCapabilityCheckRequestIEs >-----#
    UERadioCapabilityCheckRequestIEs = CLASS(name=u'UERadioCapabilityCheckRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityCheckRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityCheckRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityCheckRequestIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityCheckRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityCheckRequestIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityCheckRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityCheckRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityCheckRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityCheckRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityCheckResponse >-----#
    UERadioCapabilityCheckResponse = SEQ(name=u'UERadioCapabilityCheckResponse', mode=MODE_TYPE)
    _UERadioCapabilityCheckResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityCheckResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IMSVoiceSupportIndicator')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityCheckResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityCheckResponse_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityCheckResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityCheckResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityCheckResponse_protocolIEs._cont = __UERadioCapabilityCheckResponse_protocolIEs__item_
    _UERadioCapabilityCheckResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityCheckResponse._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityCheckResponse_protocolIEs),
        ])
    UERadioCapabilityCheckResponse._ext = []
    
    #-----< UERadioCapabilityCheckResponseIEs >-----#
    UERadioCapabilityCheckResponseIEs = CLASS(name=u'UERadioCapabilityCheckResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityCheckResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityCheckResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityCheckResponseIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IMSVoiceSupportIndicator')))
    _UERadioCapabilityCheckResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityCheckResponseIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityCheckResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityCheckResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityCheckResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityCheckResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessageIEs >-----#
    PrivateMessageIEs = CLASS(name=u'PrivateMessageIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    PrivateMessageIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReport >-----#
    SecondaryRATDataUsageReport = SEQ(name=u'SecondaryRATDataUsageReport', mode=MODE_TYPE)
    _SecondaryRATDataUsageReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __SecondaryRATDataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryRATDataUsageReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageList')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverFlag')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 143), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_id = u'id'
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecondaryRATDataUsageReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_id = u'Value'
    __SecondaryRATDataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecondaryRATDataUsageReport_protocolIEs__item__id),
        (u'criticality', ___SecondaryRATDataUsageReport_protocolIEs__item__criticality),
        (u'value', ___SecondaryRATDataUsageReport_protocolIEs__item__value),
        ])
    __SecondaryRATDataUsageReport_protocolIEs__item_._ext = None
    _SecondaryRATDataUsageReport_protocolIEs._cont = __SecondaryRATDataUsageReport_protocolIEs__item_
    _SecondaryRATDataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReport._cont = ASN1Dict([
        (u'protocolIEs', _SecondaryRATDataUsageReport_protocolIEs),
        ])
    SecondaryRATDataUsageReport._ext = []
    
    #-----< SecondaryRATDataUsageReportIEs >-----#
    SecondaryRATDataUsageReportIEs = CLASS(name=u'SecondaryRATDataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageList')))
    _SecondaryRATDataUsageReportIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverFlag')))
    _SecondaryRATDataUsageReportIEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    SecondaryRATDataUsageReportIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 142), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 143), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRIMInformationTransfer >-----#
    UplinkRIMInformationTransfer = SEQ(name=u'UplinkRIMInformationTransfer', mode=MODE_TYPE)
    _UplinkRIMInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRIMInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRIMInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkRIMInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkRIMInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkRIMInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___UplinkRIMInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___UplinkRIMInformationTransfer_protocolIEs__item__value),
        ])
    __UplinkRIMInformationTransfer_protocolIEs__item_._ext = None
    _UplinkRIMInformationTransfer_protocolIEs._cont = __UplinkRIMInformationTransfer_protocolIEs__item_
    _UplinkRIMInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRIMInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UplinkRIMInformationTransfer_protocolIEs),
        ])
    UplinkRIMInformationTransfer._ext = []
    
    #-----< UplinkRIMInformationTransferIEs >-----#
    UplinkRIMInformationTransferIEs = CLASS(name=u'UplinkRIMInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRIMInformationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    UplinkRIMInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _UplinkRIMInformationTransferIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRIMInformationTransfer >-----#
    DownlinkRIMInformationTransfer = SEQ(name=u'DownlinkRIMInformationTransfer', mode=MODE_TYPE)
    _DownlinkRIMInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRIMInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkRIMInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkRIMInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___DownlinkRIMInformationTransfer_protocolIEs__item__value),
        ])
    __DownlinkRIMInformationTransfer_protocolIEs__item_._ext = None
    _DownlinkRIMInformationTransfer_protocolIEs._cont = __DownlinkRIMInformationTransfer_protocolIEs__item_
    _DownlinkRIMInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRIMInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkRIMInformationTransfer_protocolIEs),
        ])
    DownlinkRIMInformationTransfer._ext = []
    
    #-----< DownlinkRIMInformationTransferIEs >-----#
    DownlinkRIMInformationTransferIEs = CLASS(name=u'DownlinkRIMInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRIMInformationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    DownlinkRIMInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _DownlinkRIMInformationTransferIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionEstablishmentIndication >-----#
    ConnectionEstablishmentIndication = SEQ(name=u'ConnectionEstablishmentIndication', mode=MODE_TYPE)
    _ConnectionEstablishmentIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __ConnectionEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___ConnectionEstablishmentIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-CP-SecurityInformation')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ConnectionEstablishmentIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ConnectionEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ConnectionEstablishmentIndication_protocolIEs__item__id),
        (u'criticality', ___ConnectionEstablishmentIndication_protocolIEs__item__criticality),
        (u'value', ___ConnectionEstablishmentIndication_protocolIEs__item__value),
        ])
    __ConnectionEstablishmentIndication_protocolIEs__item_._ext = None
    _ConnectionEstablishmentIndication_protocolIEs._cont = __ConnectionEstablishmentIndication_protocolIEs__item_
    _ConnectionEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ConnectionEstablishmentIndication._cont = ASN1Dict([
        (u'protocolIEs', _ConnectionEstablishmentIndication_protocolIEs),
        ])
    ConnectionEstablishmentIndication._ext = []
    
    #-----< ConnectionEstablishmentIndicationIEs >-----#
    ConnectionEstablishmentIndicationIEs = CLASS(name=u'ConnectionEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _ConnectionEstablishmentIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _ConnectionEstablishmentIndicationIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _ConnectionEstablishmentIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _ConnectionEstablishmentIndicationIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _ConnectionEstablishmentIndicationIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _ConnectionEstablishmentIndicationIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-CP-SecurityInformation')))
    _ConnectionEstablishmentIndicationIEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _ConnectionEstablishmentIndicationIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _ConnectionEstablishmentIndicationIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ConnectionEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingRequest >-----#
    UERadioCapabilityIDMappingRequest = SEQ(name=u'UERadioCapabilityIDMappingRequest', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingRequest_protocolIEs._cont = __UERadioCapabilityIDMappingRequest_protocolIEs__item_
    _UERadioCapabilityIDMappingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingRequest._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityIDMappingRequest_protocolIEs),
        ])
    UERadioCapabilityIDMappingRequest._ext = []
    
    #-----< UERadioCapabilityIDMappingRequestIEs >-----#
    UERadioCapabilityIDMappingRequestIEs = CLASS(name=u'UERadioCapabilityIDMappingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityIDMappingRequestIEs._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityIDMappingRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingResponse >-----#
    UERadioCapabilityIDMappingResponse = SEQ(name=u'UERadioCapabilityIDMappingResponse', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingResponse_protocolIEs._cont = __UERadioCapabilityIDMappingResponse_protocolIEs__item_
    _UERadioCapabilityIDMappingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingResponse._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityIDMappingResponse_protocolIEs),
        ])
    UERadioCapabilityIDMappingResponse._ext = []
    
    #-----< UERadioCapabilityIDMappingResponseIEs >-----#
    UERadioCapabilityIDMappingResponseIEs = CLASS(name=u'UERadioCapabilityIDMappingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityIDMappingResponseIEs._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFCPRelocationIndication >-----#
    AMFCPRelocationIndication = SEQ(name=u'AMFCPRelocationIndication', mode=MODE_TYPE)
    _AMFCPRelocationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFCPRelocationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'id']))
    ____AMFCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    ____AMFCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___AMFCPRelocationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'criticality']))
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AMFCPRelocationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), [u'Value']))
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __AMFCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AMFCPRelocationIndication_protocolIEs__item__id),
        (u'criticality', ___AMFCPRelocationIndication_protocolIEs__item__criticality),
        (u'value', ___AMFCPRelocationIndication_protocolIEs__item__value),
        ])
    __AMFCPRelocationIndication_protocolIEs__item_._ext = None
    _AMFCPRelocationIndication_protocolIEs._cont = __AMFCPRelocationIndication_protocolIEs__item_
    _AMFCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFCPRelocationIndication._cont = ASN1Dict([
        (u'protocolIEs', _AMFCPRelocationIndication_protocolIEs),
        ])
    AMFCPRelocationIndication._ext = []
    
    #-----< AMFCPRelocationIndicationIEs >-----#
    AMFCPRelocationIndicationIEs = CLASS(name=u'AMFCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFCPRelocationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _AMFCPRelocationIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _AMFCPRelocationIndicationIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _AMFCPRelocationIndicationIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    AMFCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _AMFCPRelocationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'reject'), (u'Value', _AMFCPRelocationIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _AMFCPRelocationIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _AMFCPRelocationIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__id,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__value,
        __PDUSessionResourceSetupRequest_protocolIEs__item_,
        _PDUSessionResourceSetupRequest_protocolIEs,
        PDUSessionResourceSetupRequest,
        PDUSessionResourceSetupRequestIEs,
        _PDUSessionResourceSetupRequestIEs_val_Value_0,
        _PDUSessionResourceSetupRequestIEs_val_Value_1,
        _PDUSessionResourceSetupRequestIEs_val_Value_2,
        _PDUSessionResourceSetupRequestIEs_val_Value_3,
        _PDUSessionResourceSetupRequestIEs_val_Value_4,
        _PDUSessionResourceSetupRequestIEs_val_Value_5,
        ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__id,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__value,
        __PDUSessionResourceSetupResponse_protocolIEs__item_,
        _PDUSessionResourceSetupResponse_protocolIEs,
        PDUSessionResourceSetupResponse,
        PDUSessionResourceSetupResponseIEs,
        _PDUSessionResourceSetupResponseIEs_val_Value_0,
        _PDUSessionResourceSetupResponseIEs_val_Value_1,
        _PDUSessionResourceSetupResponseIEs_val_Value_2,
        _PDUSessionResourceSetupResponseIEs_val_Value_3,
        _PDUSessionResourceSetupResponseIEs_val_Value_4,
        ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__id,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__value,
        __PDUSessionResourceReleaseCommand_protocolIEs__item_,
        _PDUSessionResourceReleaseCommand_protocolIEs,
        PDUSessionResourceReleaseCommand,
        PDUSessionResourceReleaseCommandIEs,
        _PDUSessionResourceReleaseCommandIEs_val_Value_0,
        _PDUSessionResourceReleaseCommandIEs_val_Value_1,
        _PDUSessionResourceReleaseCommandIEs_val_Value_2,
        _PDUSessionResourceReleaseCommandIEs_val_Value_3,
        _PDUSessionResourceReleaseCommandIEs_val_Value_4,
        ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__id,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__value,
        __PDUSessionResourceReleaseResponse_protocolIEs__item_,
        _PDUSessionResourceReleaseResponse_protocolIEs,
        PDUSessionResourceReleaseResponse,
        PDUSessionResourceReleaseResponseIEs,
        _PDUSessionResourceReleaseResponseIEs_val_Value_0,
        _PDUSessionResourceReleaseResponseIEs_val_Value_1,
        _PDUSessionResourceReleaseResponseIEs_val_Value_2,
        _PDUSessionResourceReleaseResponseIEs_val_Value_3,
        _PDUSessionResourceReleaseResponseIEs_val_Value_4,
        ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__id,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__value,
        __PDUSessionResourceModifyRequest_protocolIEs__item_,
        _PDUSessionResourceModifyRequest_protocolIEs,
        PDUSessionResourceModifyRequest,
        PDUSessionResourceModifyRequestIEs,
        _PDUSessionResourceModifyRequestIEs_val_Value_0,
        _PDUSessionResourceModifyRequestIEs_val_Value_1,
        _PDUSessionResourceModifyRequestIEs_val_Value_2,
        _PDUSessionResourceModifyRequestIEs_val_Value_3,
        ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__id,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__value,
        __PDUSessionResourceModifyResponse_protocolIEs__item_,
        _PDUSessionResourceModifyResponse_protocolIEs,
        PDUSessionResourceModifyResponse,
        PDUSessionResourceModifyResponseIEs,
        _PDUSessionResourceModifyResponseIEs_val_Value_0,
        _PDUSessionResourceModifyResponseIEs_val_Value_1,
        _PDUSessionResourceModifyResponseIEs_val_Value_2,
        _PDUSessionResourceModifyResponseIEs_val_Value_3,
        _PDUSessionResourceModifyResponseIEs_val_Value_4,
        _PDUSessionResourceModifyResponseIEs_val_Value_5,
        ____PDUSessionResourceNotify_protocolIEs__item__id_tab,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceNotify_protocolIEs__item__id,
        ___PDUSessionResourceNotify_protocolIEs__item__criticality,
        ___PDUSessionResourceNotify_protocolIEs__item__value,
        __PDUSessionResourceNotify_protocolIEs__item_,
        _PDUSessionResourceNotify_protocolIEs,
        PDUSessionResourceNotify,
        PDUSessionResourceNotifyIEs,
        _PDUSessionResourceNotifyIEs_val_Value_0,
        _PDUSessionResourceNotifyIEs_val_Value_1,
        _PDUSessionResourceNotifyIEs_val_Value_2,
        _PDUSessionResourceNotifyIEs_val_Value_3,
        _PDUSessionResourceNotifyIEs_val_Value_4,
        ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__id,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__value,
        __PDUSessionResourceModifyIndication_protocolIEs__item_,
        _PDUSessionResourceModifyIndication_protocolIEs,
        PDUSessionResourceModifyIndication,
        PDUSessionResourceModifyIndicationIEs,
        _PDUSessionResourceModifyIndicationIEs_val_Value_0,
        _PDUSessionResourceModifyIndicationIEs_val_Value_1,
        _PDUSessionResourceModifyIndicationIEs_val_Value_2,
        _PDUSessionResourceModifyIndicationIEs_val_Value_3,
        ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__id,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__value,
        __PDUSessionResourceModifyConfirm_protocolIEs__item_,
        _PDUSessionResourceModifyConfirm_protocolIEs,
        PDUSessionResourceModifyConfirm,
        PDUSessionResourceModifyConfirmIEs,
        _PDUSessionResourceModifyConfirmIEs_val_Value_0,
        _PDUSessionResourceModifyConfirmIEs_val_Value_1,
        _PDUSessionResourceModifyConfirmIEs_val_Value_2,
        _PDUSessionResourceModifyConfirmIEs_val_Value_3,
        _PDUSessionResourceModifyConfirmIEs_val_Value_4,
        ____InitialContextSetupRequest_protocolIEs__item__id_tab,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        ___InitialContextSetupRequest_protocolIEs__item__id,
        ___InitialContextSetupRequest_protocolIEs__item__criticality,
        ___InitialContextSetupRequest_protocolIEs__item__value,
        __InitialContextSetupRequest_protocolIEs__item_,
        _InitialContextSetupRequest_protocolIEs,
        InitialContextSetupRequest,
        InitialContextSetupRequestIEs,
        _InitialContextSetupRequestIEs_val_Value_0,
        _InitialContextSetupRequestIEs_val_Value_1,
        _InitialContextSetupRequestIEs_val_Value_2,
        _InitialContextSetupRequestIEs_val_Value_3,
        _InitialContextSetupRequestIEs_val_Value_4,
        _InitialContextSetupRequestIEs_val_Value_5,
        _InitialContextSetupRequestIEs_val_Value_6,
        _InitialContextSetupRequestIEs_val_Value_7,
        _InitialContextSetupRequestIEs_val_Value_8,
        _InitialContextSetupRequestIEs_val_Value_9,
        _InitialContextSetupRequestIEs_val_Value_10,
        _InitialContextSetupRequestIEs_val_Value_11,
        _InitialContextSetupRequestIEs_val_Value_12,
        _InitialContextSetupRequestIEs_val_Value_13,
        _InitialContextSetupRequestIEs_val_Value_14,
        _InitialContextSetupRequestIEs_val_Value_15,
        _InitialContextSetupRequestIEs_val_Value_16,
        _InitialContextSetupRequestIEs_val_Value_17,
        _InitialContextSetupRequestIEs_val_Value_18,
        _InitialContextSetupRequestIEs_val_Value_19,
        _InitialContextSetupRequestIEs_val_Value_20,
        _InitialContextSetupRequestIEs_val_Value_21,
        _InitialContextSetupRequestIEs_val_Value_22,
        _InitialContextSetupRequestIEs_val_Value_23,
        _InitialContextSetupRequestIEs_val_Value_24,
        _InitialContextSetupRequestIEs_val_Value_25,
        _InitialContextSetupRequestIEs_val_Value_26,
        _InitialContextSetupRequestIEs_val_Value_27,
        _InitialContextSetupRequestIEs_val_Value_28,
        _InitialContextSetupRequestIEs_val_Value_29,
        _InitialContextSetupRequestIEs_val_Value_30,
        _InitialContextSetupRequestIEs_val_Value_31,
        _InitialContextSetupRequestIEs_val_Value_32,
        _InitialContextSetupRequestIEs_val_Value_33,
        _InitialContextSetupRequestIEs_val_Value_34,
        _InitialContextSetupRequestIEs_val_Value_35,
        _InitialContextSetupRequestIEs_val_Value_36,
        ____InitialContextSetupResponse_protocolIEs__item__id_tab,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupResponse_protocolIEs__item__id,
        ___InitialContextSetupResponse_protocolIEs__item__criticality,
        ___InitialContextSetupResponse_protocolIEs__item__value,
        __InitialContextSetupResponse_protocolIEs__item_,
        _InitialContextSetupResponse_protocolIEs,
        InitialContextSetupResponse,
        InitialContextSetupResponseIEs,
        _InitialContextSetupResponseIEs_val_Value_0,
        _InitialContextSetupResponseIEs_val_Value_1,
        _InitialContextSetupResponseIEs_val_Value_2,
        _InitialContextSetupResponseIEs_val_Value_3,
        _InitialContextSetupResponseIEs_val_Value_4,
        ____InitialContextSetupFailure_protocolIEs__item__id_tab,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupFailure_protocolIEs__item__id,
        ___InitialContextSetupFailure_protocolIEs__item__criticality,
        ___InitialContextSetupFailure_protocolIEs__item__value,
        __InitialContextSetupFailure_protocolIEs__item_,
        _InitialContextSetupFailure_protocolIEs,
        InitialContextSetupFailure,
        InitialContextSetupFailureIEs,
        _InitialContextSetupFailureIEs_val_Value_0,
        _InitialContextSetupFailureIEs_val_Value_1,
        _InitialContextSetupFailureIEs_val_Value_2,
        _InitialContextSetupFailureIEs_val_Value_3,
        _InitialContextSetupFailureIEs_val_Value_4,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequest_IEs,
        _UEContextReleaseRequest_IEs_val_Value_0,
        _UEContextReleaseRequest_IEs_val_Value_1,
        _UEContextReleaseRequest_IEs_val_Value_2,
        _UEContextReleaseRequest_IEs_val_Value_3,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommand_IEs,
        _UEContextReleaseCommand_IEs_val_Value_0,
        _UEContextReleaseCommand_IEs_val_Value_1,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseComplete_IEs,
        _UEContextReleaseComplete_IEs_val_Value_0,
        _UEContextReleaseComplete_IEs_val_Value_1,
        _UEContextReleaseComplete_IEs_val_Value_2,
        _UEContextReleaseComplete_IEs_val_Value_3,
        _UEContextReleaseComplete_IEs_val_Value_4,
        _UEContextReleaseComplete_IEs_val_Value_5,
        _UEContextReleaseComplete_IEs_val_Value_6,
        ____UEContextResumeRequest_protocolIEs__item__id_tab,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextResumeRequest_protocolIEs__item__id,
        ___UEContextResumeRequest_protocolIEs__item__criticality,
        ___UEContextResumeRequest_protocolIEs__item__value,
        __UEContextResumeRequest_protocolIEs__item_,
        _UEContextResumeRequest_protocolIEs,
        UEContextResumeRequest,
        UEContextResumeRequestIEs,
        _UEContextResumeRequestIEs_val_Value_0,
        _UEContextResumeRequestIEs_val_Value_1,
        _UEContextResumeRequestIEs_val_Value_2,
        _UEContextResumeRequestIEs_val_Value_3,
        _UEContextResumeRequestIEs_val_Value_4,
        _UEContextResumeRequestIEs_val_Value_5,
        _UEContextResumeRequestIEs_val_Value_6,
        _UEContextResumeRequestIEs_val_Value_7,
        ____UEContextResumeResponse_protocolIEs__item__id_tab,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextResumeResponse_protocolIEs__item__id,
        ___UEContextResumeResponse_protocolIEs__item__criticality,
        ___UEContextResumeResponse_protocolIEs__item__value,
        __UEContextResumeResponse_protocolIEs__item_,
        _UEContextResumeResponse_protocolIEs,
        UEContextResumeResponse,
        UEContextResumeResponseIEs,
        _UEContextResumeResponseIEs_val_Value_0,
        _UEContextResumeResponseIEs_val_Value_1,
        _UEContextResumeResponseIEs_val_Value_2,
        _UEContextResumeResponseIEs_val_Value_3,
        _UEContextResumeResponseIEs_val_Value_4,
        _UEContextResumeResponseIEs_val_Value_5,
        _UEContextResumeResponseIEs_val_Value_6,
        _UEContextResumeResponseIEs_val_Value_7,
        ____UEContextResumeFailure_protocolIEs__item__id_tab,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeFailure_protocolIEs__item__id,
        ___UEContextResumeFailure_protocolIEs__item__criticality,
        ___UEContextResumeFailure_protocolIEs__item__value,
        __UEContextResumeFailure_protocolIEs__item_,
        _UEContextResumeFailure_protocolIEs,
        UEContextResumeFailure,
        UEContextResumeFailureIEs,
        _UEContextResumeFailureIEs_val_Value_0,
        _UEContextResumeFailureIEs_val_Value_1,
        _UEContextResumeFailureIEs_val_Value_2,
        _UEContextResumeFailureIEs_val_Value_3,
        ____UEContextSuspendRequest_protocolIEs__item__id_tab,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextSuspendRequest_protocolIEs__item__id,
        ___UEContextSuspendRequest_protocolIEs__item__criticality,
        ___UEContextSuspendRequest_protocolIEs__item__value,
        __UEContextSuspendRequest_protocolIEs__item_,
        _UEContextSuspendRequest_protocolIEs,
        UEContextSuspendRequest,
        UEContextSuspendRequestIEs,
        _UEContextSuspendRequestIEs_val_Value_0,
        _UEContextSuspendRequestIEs_val_Value_1,
        _UEContextSuspendRequestIEs_val_Value_2,
        _UEContextSuspendRequestIEs_val_Value_3,
        _UEContextSuspendRequestIEs_val_Value_4,
        ____UEContextSuspendResponse_protocolIEs__item__id_tab,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendResponse_protocolIEs__item__id,
        ___UEContextSuspendResponse_protocolIEs__item__criticality,
        ___UEContextSuspendResponse_protocolIEs__item__value,
        __UEContextSuspendResponse_protocolIEs__item_,
        _UEContextSuspendResponse_protocolIEs,
        UEContextSuspendResponse,
        UEContextSuspendResponseIEs,
        _UEContextSuspendResponseIEs_val_Value_0,
        _UEContextSuspendResponseIEs_val_Value_1,
        _UEContextSuspendResponseIEs_val_Value_2,
        _UEContextSuspendResponseIEs_val_Value_3,
        ____UEContextSuspendFailure_protocolIEs__item__id_tab,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendFailure_protocolIEs__item__id,
        ___UEContextSuspendFailure_protocolIEs__item__criticality,
        ___UEContextSuspendFailure_protocolIEs__item__value,
        __UEContextSuspendFailure_protocolIEs__item_,
        _UEContextSuspendFailure_protocolIEs,
        UEContextSuspendFailure,
        UEContextSuspendFailureIEs,
        _UEContextSuspendFailureIEs_val_Value_0,
        _UEContextSuspendFailureIEs_val_Value_1,
        _UEContextSuspendFailureIEs_val_Value_2,
        _UEContextSuspendFailureIEs_val_Value_3,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        _UEContextModificationResponseIEs_val_Value_3,
        _UEContextModificationResponseIEs_val_Value_4,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        ____RRCInactiveTransitionReport_protocolIEs__item__id_tab,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3,
        ___RRCInactiveTransitionReport_protocolIEs__item__id,
        ___RRCInactiveTransitionReport_protocolIEs__item__criticality,
        ___RRCInactiveTransitionReport_protocolIEs__item__value,
        __RRCInactiveTransitionReport_protocolIEs__item_,
        _RRCInactiveTransitionReport_protocolIEs,
        RRCInactiveTransitionReport,
        RRCInactiveTransitionReportIEs,
        _RRCInactiveTransitionReportIEs_val_Value_0,
        _RRCInactiveTransitionReportIEs_val_Value_1,
        _RRCInactiveTransitionReportIEs_val_Value_2,
        _RRCInactiveTransitionReportIEs_val_Value_3,
        ____RetrieveUEInformation_protocolIEs__item__id_tab,
        _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0,
        ___RetrieveUEInformation_protocolIEs__item__id,
        ___RetrieveUEInformation_protocolIEs__item__criticality,
        ___RetrieveUEInformation_protocolIEs__item__value,
        __RetrieveUEInformation_protocolIEs__item_,
        _RetrieveUEInformation_protocolIEs,
        RetrieveUEInformation,
        RetrieveUEInformationIEs,
        _RetrieveUEInformationIEs_val_Value_0,
        ____UEInformationTransfer_protocolIEs__item__id_tab,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___UEInformationTransfer_protocolIEs__item__id,
        ___UEInformationTransfer_protocolIEs__item__criticality,
        ___UEInformationTransfer_protocolIEs__item__value,
        __UEInformationTransfer_protocolIEs__item_,
        _UEInformationTransfer_protocolIEs,
        UEInformationTransfer,
        UEInformationTransferIEs,
        _UEInformationTransferIEs_val_Value_0,
        _UEInformationTransferIEs_val_Value_1,
        _UEInformationTransferIEs_val_Value_2,
        _UEInformationTransferIEs_val_Value_3,
        _UEInformationTransferIEs_val_Value_4,
        _UEInformationTransferIEs_val_Value_5,
        ____RANCPRelocationIndication_protocolIEs__item__id_tab,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4,
        ___RANCPRelocationIndication_protocolIEs__item__id,
        ___RANCPRelocationIndication_protocolIEs__item__criticality,
        ___RANCPRelocationIndication_protocolIEs__item__value,
        __RANCPRelocationIndication_protocolIEs__item_,
        _RANCPRelocationIndication_protocolIEs,
        RANCPRelocationIndication,
        RANCPRelocationIndicationIEs,
        _RANCPRelocationIndicationIEs_val_Value_0,
        _RANCPRelocationIndicationIEs_val_Value_1,
        _RANCPRelocationIndicationIEs_val_Value_2,
        _RANCPRelocationIndicationIEs_val_Value_3,
        _RANCPRelocationIndicationIEs_val_Value_4,
        ____HandoverRequired_protocolIEs__item__id_tab,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverRequired_protocolIEs__item__id,
        ___HandoverRequired_protocolIEs__item__criticality,
        ___HandoverRequired_protocolIEs__item__value,
        __HandoverRequired_protocolIEs__item_,
        _HandoverRequired_protocolIEs,
        HandoverRequired,
        HandoverRequiredIEs,
        _HandoverRequiredIEs_val_Value_0,
        _HandoverRequiredIEs_val_Value_1,
        _HandoverRequiredIEs_val_Value_2,
        _HandoverRequiredIEs_val_Value_3,
        _HandoverRequiredIEs_val_Value_4,
        _HandoverRequiredIEs_val_Value_5,
        _HandoverRequiredIEs_val_Value_6,
        _HandoverRequiredIEs_val_Value_7,
        ____HandoverCommand_protocolIEs__item__id_tab,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverCommand_protocolIEs__item__id,
        ___HandoverCommand_protocolIEs__item__criticality,
        ___HandoverCommand_protocolIEs__item__value,
        __HandoverCommand_protocolIEs__item_,
        _HandoverCommand_protocolIEs,
        HandoverCommand,
        HandoverCommandIEs,
        _HandoverCommandIEs_val_Value_0,
        _HandoverCommandIEs_val_Value_1,
        _HandoverCommandIEs_val_Value_2,
        _HandoverCommandIEs_val_Value_3,
        _HandoverCommandIEs_val_Value_4,
        _HandoverCommandIEs_val_Value_5,
        _HandoverCommandIEs_val_Value_6,
        _HandoverCommandIEs_val_Value_7,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailureIEs,
        _HandoverPreparationFailureIEs_val_Value_0,
        _HandoverPreparationFailureIEs_val_Value_1,
        _HandoverPreparationFailureIEs_val_Value_2,
        _HandoverPreparationFailureIEs_val_Value_3,
        _HandoverPreparationFailureIEs_val_Value_4,
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequestIEs,
        _HandoverRequestIEs_val_Value_0,
        _HandoverRequestIEs_val_Value_1,
        _HandoverRequestIEs_val_Value_2,
        _HandoverRequestIEs_val_Value_3,
        _HandoverRequestIEs_val_Value_4,
        _HandoverRequestIEs_val_Value_5,
        _HandoverRequestIEs_val_Value_6,
        _HandoverRequestIEs_val_Value_7,
        _HandoverRequestIEs_val_Value_8,
        _HandoverRequestIEs_val_Value_9,
        _HandoverRequestIEs_val_Value_10,
        _HandoverRequestIEs_val_Value_11,
        _HandoverRequestIEs_val_Value_12,
        _HandoverRequestIEs_val_Value_13,
        _HandoverRequestIEs_val_Value_14,
        _HandoverRequestIEs_val_Value_15,
        _HandoverRequestIEs_val_Value_16,
        _HandoverRequestIEs_val_Value_17,
        _HandoverRequestIEs_val_Value_18,
        _HandoverRequestIEs_val_Value_19,
        _HandoverRequestIEs_val_Value_20,
        _HandoverRequestIEs_val_Value_21,
        _HandoverRequestIEs_val_Value_22,
        _HandoverRequestIEs_val_Value_23,
        _HandoverRequestIEs_val_Value_24,
        _HandoverRequestIEs_val_Value_25,
        _HandoverRequestIEs_val_Value_26,
        _HandoverRequestIEs_val_Value_27,
        _HandoverRequestIEs_val_Value_28,
        _HandoverRequestIEs_val_Value_29,
        _HandoverRequestIEs_val_Value_30,
        _HandoverRequestIEs_val_Value_31,
        _HandoverRequestIEs_val_Value_32,
        _HandoverRequestIEs_val_Value_33,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledgeIEs,
        _HandoverRequestAcknowledgeIEs_val_Value_0,
        _HandoverRequestAcknowledgeIEs_val_Value_1,
        _HandoverRequestAcknowledgeIEs_val_Value_2,
        _HandoverRequestAcknowledgeIEs_val_Value_3,
        _HandoverRequestAcknowledgeIEs_val_Value_4,
        _HandoverRequestAcknowledgeIEs_val_Value_5,
        _HandoverRequestAcknowledgeIEs_val_Value_6,
        ____HandoverFailure_protocolIEs__item__id_tab,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverFailure_protocolIEs__item__id,
        ___HandoverFailure_protocolIEs__item__criticality,
        ___HandoverFailure_protocolIEs__item__value,
        __HandoverFailure_protocolIEs__item_,
        _HandoverFailure_protocolIEs,
        HandoverFailure,
        HandoverFailureIEs,
        _HandoverFailureIEs_val_Value_0,
        _HandoverFailureIEs_val_Value_1,
        _HandoverFailureIEs_val_Value_2,
        _HandoverFailureIEs_val_Value_3,
        ____HandoverNotify_protocolIEs__item__id_tab,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverNotify_protocolIEs__item__id,
        ___HandoverNotify_protocolIEs__item__criticality,
        ___HandoverNotify_protocolIEs__item__value,
        __HandoverNotify_protocolIEs__item_,
        _HandoverNotify_protocolIEs,
        HandoverNotify,
        HandoverNotifyIEs,
        _HandoverNotifyIEs_val_Value_0,
        _HandoverNotifyIEs_val_Value_1,
        _HandoverNotifyIEs_val_Value_2,
        _HandoverNotifyIEs_val_Value_3,
        ____PathSwitchRequest_protocolIEs__item__id_tab,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6,
        ___PathSwitchRequest_protocolIEs__item__id,
        ___PathSwitchRequest_protocolIEs__item__criticality,
        ___PathSwitchRequest_protocolIEs__item__value,
        __PathSwitchRequest_protocolIEs__item_,
        _PathSwitchRequest_protocolIEs,
        PathSwitchRequest,
        PathSwitchRequestIEs,
        _PathSwitchRequestIEs_val_Value_0,
        _PathSwitchRequestIEs_val_Value_1,
        _PathSwitchRequestIEs_val_Value_2,
        _PathSwitchRequestIEs_val_Value_3,
        _PathSwitchRequestIEs_val_Value_4,
        _PathSwitchRequestIEs_val_Value_5,
        _PathSwitchRequestIEs_val_Value_6,
        ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__id,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__value,
        __PathSwitchRequestAcknowledge_protocolIEs__item_,
        _PathSwitchRequestAcknowledge_protocolIEs,
        PathSwitchRequestAcknowledge,
        PathSwitchRequestAcknowledgeIEs,
        _PathSwitchRequestAcknowledgeIEs_val_Value_0,
        _PathSwitchRequestAcknowledgeIEs_val_Value_1,
        _PathSwitchRequestAcknowledgeIEs_val_Value_2,
        _PathSwitchRequestAcknowledgeIEs_val_Value_3,
        _PathSwitchRequestAcknowledgeIEs_val_Value_4,
        _PathSwitchRequestAcknowledgeIEs_val_Value_5,
        _PathSwitchRequestAcknowledgeIEs_val_Value_6,
        _PathSwitchRequestAcknowledgeIEs_val_Value_7,
        _PathSwitchRequestAcknowledgeIEs_val_Value_8,
        _PathSwitchRequestAcknowledgeIEs_val_Value_9,
        _PathSwitchRequestAcknowledgeIEs_val_Value_10,
        _PathSwitchRequestAcknowledgeIEs_val_Value_11,
        _PathSwitchRequestAcknowledgeIEs_val_Value_12,
        _PathSwitchRequestAcknowledgeIEs_val_Value_13,
        _PathSwitchRequestAcknowledgeIEs_val_Value_14,
        _PathSwitchRequestAcknowledgeIEs_val_Value_15,
        _PathSwitchRequestAcknowledgeIEs_val_Value_16,
        _PathSwitchRequestAcknowledgeIEs_val_Value_17,
        _PathSwitchRequestAcknowledgeIEs_val_Value_18,
        _PathSwitchRequestAcknowledgeIEs_val_Value_19,
        _PathSwitchRequestAcknowledgeIEs_val_Value_20,
        _PathSwitchRequestAcknowledgeIEs_val_Value_21,
        _PathSwitchRequestAcknowledgeIEs_val_Value_22,
        _PathSwitchRequestAcknowledgeIEs_val_Value_23,
        _PathSwitchRequestAcknowledgeIEs_val_Value_24,
        _PathSwitchRequestAcknowledgeIEs_val_Value_25,
        ____PathSwitchRequestFailure_protocolIEs__item__id_tab,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PathSwitchRequestFailure_protocolIEs__item__id,
        ___PathSwitchRequestFailure_protocolIEs__item__criticality,
        ___PathSwitchRequestFailure_protocolIEs__item__value,
        __PathSwitchRequestFailure_protocolIEs__item_,
        _PathSwitchRequestFailure_protocolIEs,
        PathSwitchRequestFailure,
        PathSwitchRequestFailureIEs,
        _PathSwitchRequestFailureIEs_val_Value_0,
        _PathSwitchRequestFailureIEs_val_Value_1,
        _PathSwitchRequestFailureIEs_val_Value_2,
        _PathSwitchRequestFailureIEs_val_Value_3,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancelIEs,
        _HandoverCancelIEs_val_Value_0,
        _HandoverCancelIEs_val_Value_1,
        _HandoverCancelIEs_val_Value_2,
        ____HandoverCancelAcknowledge_protocolIEs__item__id_tab,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancelAcknowledge_protocolIEs__item__id,
        ___HandoverCancelAcknowledge_protocolIEs__item__criticality,
        ___HandoverCancelAcknowledge_protocolIEs__item__value,
        __HandoverCancelAcknowledge_protocolIEs__item_,
        _HandoverCancelAcknowledge_protocolIEs,
        HandoverCancelAcknowledge,
        HandoverCancelAcknowledgeIEs,
        _HandoverCancelAcknowledgeIEs_val_Value_0,
        _HandoverCancelAcknowledgeIEs_val_Value_1,
        _HandoverCancelAcknowledgeIEs_val_Value_2,
        ____HandoverSuccess_protocolIEs__item__id_tab,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1,
        ___HandoverSuccess_protocolIEs__item__id,
        ___HandoverSuccess_protocolIEs__item__criticality,
        ___HandoverSuccess_protocolIEs__item__value,
        __HandoverSuccess_protocolIEs__item_,
        _HandoverSuccess_protocolIEs,
        HandoverSuccess,
        HandoverSuccessIEs,
        _HandoverSuccessIEs_val_Value_0,
        _HandoverSuccessIEs_val_Value_1,
        ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value,
        __UplinkRANEarlyStatusTransfer_protocolIEs__item_,
        _UplinkRANEarlyStatusTransfer_protocolIEs,
        UplinkRANEarlyStatusTransfer,
        UplinkRANEarlyStatusTransferIEs,
        _UplinkRANEarlyStatusTransferIEs_val_Value_0,
        _UplinkRANEarlyStatusTransferIEs_val_Value_1,
        _UplinkRANEarlyStatusTransferIEs_val_Value_2,
        ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value,
        __DownlinkRANEarlyStatusTransfer_protocolIEs__item_,
        _DownlinkRANEarlyStatusTransfer_protocolIEs,
        DownlinkRANEarlyStatusTransfer,
        DownlinkRANEarlyStatusTransferIEs,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_0,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_1,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_2,
        ____UplinkRANStatusTransfer_protocolIEs__item__id_tab,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANStatusTransfer_protocolIEs__item__id,
        ___UplinkRANStatusTransfer_protocolIEs__item__criticality,
        ___UplinkRANStatusTransfer_protocolIEs__item__value,
        __UplinkRANStatusTransfer_protocolIEs__item_,
        _UplinkRANStatusTransfer_protocolIEs,
        UplinkRANStatusTransfer,
        UplinkRANStatusTransferIEs,
        _UplinkRANStatusTransferIEs_val_Value_0,
        _UplinkRANStatusTransferIEs_val_Value_1,
        _UplinkRANStatusTransferIEs_val_Value_2,
        ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANStatusTransfer_protocolIEs__item__id,
        ___DownlinkRANStatusTransfer_protocolIEs__item__criticality,
        ___DownlinkRANStatusTransfer_protocolIEs__item__value,
        __DownlinkRANStatusTransfer_protocolIEs__item_,
        _DownlinkRANStatusTransfer_protocolIEs,
        DownlinkRANStatusTransfer,
        DownlinkRANStatusTransferIEs,
        _DownlinkRANStatusTransferIEs_val_Value_0,
        _DownlinkRANStatusTransferIEs_val_Value_1,
        _DownlinkRANStatusTransferIEs_val_Value_2,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        _____Paging_protocolIEs__item__id_tab_val_Value_7,
        _____Paging_protocolIEs__item__id_tab_val_Value_8,
        _____Paging_protocolIEs__item__id_tab_val_Value_9,
        _____Paging_protocolIEs__item__id_tab_val_Value_10,
        _____Paging_protocolIEs__item__id_tab_val_Value_11,
        _____Paging_protocolIEs__item__id_tab_val_Value_12,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        _PagingIEs_val_Value_7,
        _PagingIEs_val_Value_8,
        _PagingIEs_val_Value_9,
        _PagingIEs_val_Value_10,
        _PagingIEs_val_Value_11,
        _PagingIEs_val_Value_12,
        ____InitialUEMessage_protocolIEs__item__id_tab,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15,
        ___InitialUEMessage_protocolIEs__item__id,
        ___InitialUEMessage_protocolIEs__item__criticality,
        ___InitialUEMessage_protocolIEs__item__value,
        __InitialUEMessage_protocolIEs__item_,
        _InitialUEMessage_protocolIEs,
        InitialUEMessage,
        InitialUEMessage_IEs,
        _InitialUEMessage_IEs_val_Value_0,
        _InitialUEMessage_IEs_val_Value_1,
        _InitialUEMessage_IEs_val_Value_2,
        _InitialUEMessage_IEs_val_Value_3,
        _InitialUEMessage_IEs_val_Value_4,
        _InitialUEMessage_IEs_val_Value_5,
        _InitialUEMessage_IEs_val_Value_6,
        _InitialUEMessage_IEs_val_Value_7,
        _InitialUEMessage_IEs_val_Value_8,
        _InitialUEMessage_IEs_val_Value_9,
        _InitialUEMessage_IEs_val_Value_10,
        _InitialUEMessage_IEs_val_Value_11,
        _InitialUEMessage_IEs_val_Value_12,
        _InitialUEMessage_IEs_val_Value_13,
        _InitialUEMessage_IEs_val_Value_14,
        _InitialUEMessage_IEs_val_Value_15,
        ____DownlinkNASTransport_protocolIEs__item__id_tab,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17,
        ___DownlinkNASTransport_protocolIEs__item__id,
        ___DownlinkNASTransport_protocolIEs__item__criticality,
        ___DownlinkNASTransport_protocolIEs__item__value,
        __DownlinkNASTransport_protocolIEs__item_,
        _DownlinkNASTransport_protocolIEs,
        DownlinkNASTransport,
        DownlinkNASTransport_IEs,
        _DownlinkNASTransport_IEs_val_Value_0,
        _DownlinkNASTransport_IEs_val_Value_1,
        _DownlinkNASTransport_IEs_val_Value_2,
        _DownlinkNASTransport_IEs_val_Value_3,
        _DownlinkNASTransport_IEs_val_Value_4,
        _DownlinkNASTransport_IEs_val_Value_5,
        _DownlinkNASTransport_IEs_val_Value_6,
        _DownlinkNASTransport_IEs_val_Value_7,
        _DownlinkNASTransport_IEs_val_Value_8,
        _DownlinkNASTransport_IEs_val_Value_9,
        _DownlinkNASTransport_IEs_val_Value_10,
        _DownlinkNASTransport_IEs_val_Value_11,
        _DownlinkNASTransport_IEs_val_Value_12,
        _DownlinkNASTransport_IEs_val_Value_13,
        _DownlinkNASTransport_IEs_val_Value_14,
        _DownlinkNASTransport_IEs_val_Value_15,
        _DownlinkNASTransport_IEs_val_Value_16,
        _DownlinkNASTransport_IEs_val_Value_17,
        ____UplinkNASTransport_protocolIEs__item__id_tab,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        ___UplinkNASTransport_protocolIEs__item__id,
        ___UplinkNASTransport_protocolIEs__item__criticality,
        ___UplinkNASTransport_protocolIEs__item__value,
        __UplinkNASTransport_protocolIEs__item_,
        _UplinkNASTransport_protocolIEs,
        UplinkNASTransport,
        UplinkNASTransport_IEs,
        _UplinkNASTransport_IEs_val_Value_0,
        _UplinkNASTransport_IEs_val_Value_1,
        _UplinkNASTransport_IEs_val_Value_2,
        _UplinkNASTransport_IEs_val_Value_3,
        _UplinkNASTransport_IEs_val_Value_4,
        _UplinkNASTransport_IEs_val_Value_5,
        _UplinkNASTransport_IEs_val_Value_6,
        ____NASNonDeliveryIndication_protocolIEs__item__id_tab,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3,
        ___NASNonDeliveryIndication_protocolIEs__item__id,
        ___NASNonDeliveryIndication_protocolIEs__item__criticality,
        ___NASNonDeliveryIndication_protocolIEs__item__value,
        __NASNonDeliveryIndication_protocolIEs__item_,
        _NASNonDeliveryIndication_protocolIEs,
        NASNonDeliveryIndication,
        NASNonDeliveryIndication_IEs,
        _NASNonDeliveryIndication_IEs_val_Value_0,
        _NASNonDeliveryIndication_IEs_val_Value_1,
        _NASNonDeliveryIndication_IEs_val_Value_2,
        _NASNonDeliveryIndication_IEs_val_Value_3,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        RerouteNASRequest,
        RerouteNASRequest_IEs,
        _RerouteNASRequest_IEs_val_Value_0,
        _RerouteNASRequest_IEs_val_Value_1,
        _RerouteNASRequest_IEs_val_Value_2,
        _RerouteNASRequest_IEs_val_Value_3,
        _RerouteNASRequest_IEs_val_Value_4,
        _RerouteNASRequest_IEs_val_Value_5,
        ____NGSetupRequest_protocolIEs__item__id_tab,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        ___NGSetupRequest_protocolIEs__item__id,
        ___NGSetupRequest_protocolIEs__item__criticality,
        ___NGSetupRequest_protocolIEs__item__value,
        __NGSetupRequest_protocolIEs__item_,
        _NGSetupRequest_protocolIEs,
        NGSetupRequest,
        NGSetupRequestIEs,
        _NGSetupRequestIEs_val_Value_0,
        _NGSetupRequestIEs_val_Value_1,
        _NGSetupRequestIEs_val_Value_2,
        _NGSetupRequestIEs_val_Value_3,
        _NGSetupRequestIEs_val_Value_4,
        _NGSetupRequestIEs_val_Value_5,
        _NGSetupRequestIEs_val_Value_6,
        ____NGSetupResponse_protocolIEs__item__id_tab,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___NGSetupResponse_protocolIEs__item__id,
        ___NGSetupResponse_protocolIEs__item__criticality,
        ___NGSetupResponse_protocolIEs__item__value,
        __NGSetupResponse_protocolIEs__item_,
        _NGSetupResponse_protocolIEs,
        NGSetupResponse,
        NGSetupResponseIEs,
        _NGSetupResponseIEs_val_Value_0,
        _NGSetupResponseIEs_val_Value_1,
        _NGSetupResponseIEs_val_Value_2,
        _NGSetupResponseIEs_val_Value_3,
        _NGSetupResponseIEs_val_Value_4,
        _NGSetupResponseIEs_val_Value_5,
        _NGSetupResponseIEs_val_Value_6,
        _NGSetupResponseIEs_val_Value_7,
        ____NGSetupFailure_protocolIEs__item__id_tab,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___NGSetupFailure_protocolIEs__item__id,
        ___NGSetupFailure_protocolIEs__item__criticality,
        ___NGSetupFailure_protocolIEs__item__value,
        __NGSetupFailure_protocolIEs__item_,
        _NGSetupFailure_protocolIEs,
        NGSetupFailure,
        NGSetupFailureIEs,
        _NGSetupFailureIEs_val_Value_0,
        _NGSetupFailureIEs_val_Value_1,
        _NGSetupFailureIEs_val_Value_2,
        ____RANConfigurationUpdate_protocolIEs__item__id_tab,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___RANConfigurationUpdate_protocolIEs__item__id,
        ___RANConfigurationUpdate_protocolIEs__item__criticality,
        ___RANConfigurationUpdate_protocolIEs__item__value,
        __RANConfigurationUpdate_protocolIEs__item_,
        _RANConfigurationUpdate_protocolIEs,
        RANConfigurationUpdate,
        RANConfigurationUpdateIEs,
        _RANConfigurationUpdateIEs_val_Value_0,
        _RANConfigurationUpdateIEs_val_Value_1,
        _RANConfigurationUpdateIEs_val_Value_2,
        _RANConfigurationUpdateIEs_val_Value_3,
        _RANConfigurationUpdateIEs_val_Value_4,
        _RANConfigurationUpdateIEs_val_Value_5,
        _RANConfigurationUpdateIEs_val_Value_6,
        ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __RANConfigurationUpdateAcknowledge_protocolIEs__item_,
        _RANConfigurationUpdateAcknowledge_protocolIEs,
        RANConfigurationUpdateAcknowledge,
        RANConfigurationUpdateAcknowledgeIEs,
        _RANConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___RANConfigurationUpdateFailure_protocolIEs__item__id,
        ___RANConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___RANConfigurationUpdateFailure_protocolIEs__item__value,
        __RANConfigurationUpdateFailure_protocolIEs__item_,
        _RANConfigurationUpdateFailure_protocolIEs,
        RANConfigurationUpdateFailure,
        RANConfigurationUpdateFailureIEs,
        _RANConfigurationUpdateFailureIEs_val_Value_0,
        _RANConfigurationUpdateFailureIEs_val_Value_1,
        _RANConfigurationUpdateFailureIEs_val_Value_2,
        ____AMFConfigurationUpdate_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        ___AMFConfigurationUpdate_protocolIEs__item__id,
        ___AMFConfigurationUpdate_protocolIEs__item__criticality,
        ___AMFConfigurationUpdate_protocolIEs__item__value,
        __AMFConfigurationUpdate_protocolIEs__item_,
        _AMFConfigurationUpdate_protocolIEs,
        AMFConfigurationUpdate,
        AMFConfigurationUpdateIEs,
        _AMFConfigurationUpdateIEs_val_Value_0,
        _AMFConfigurationUpdateIEs_val_Value_1,
        _AMFConfigurationUpdateIEs_val_Value_2,
        _AMFConfigurationUpdateIEs_val_Value_3,
        _AMFConfigurationUpdateIEs_val_Value_4,
        _AMFConfigurationUpdateIEs_val_Value_5,
        _AMFConfigurationUpdateIEs_val_Value_6,
        _AMFConfigurationUpdateIEs_val_Value_7,
        ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __AMFConfigurationUpdateAcknowledge_protocolIEs__item_,
        _AMFConfigurationUpdateAcknowledge_protocolIEs,
        AMFConfigurationUpdateAcknowledge,
        AMFConfigurationUpdateAcknowledgeIEs,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2,
        ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__id,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__value,
        __AMFConfigurationUpdateFailure_protocolIEs__item_,
        _AMFConfigurationUpdateFailure_protocolIEs,
        AMFConfigurationUpdateFailure,
        AMFConfigurationUpdateFailureIEs,
        _AMFConfigurationUpdateFailureIEs_val_Value_0,
        _AMFConfigurationUpdateFailureIEs_val_Value_1,
        _AMFConfigurationUpdateFailureIEs_val_Value_2,
        ____AMFStatusIndication_protocolIEs__item__id_tab,
        _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        ___AMFStatusIndication_protocolIEs__item__id,
        ___AMFStatusIndication_protocolIEs__item__criticality,
        ___AMFStatusIndication_protocolIEs__item__value,
        __AMFStatusIndication_protocolIEs__item_,
        _AMFStatusIndication_protocolIEs,
        AMFStatusIndication,
        AMFStatusIndicationIEs,
        _AMFStatusIndicationIEs_val_Value_0,
        ____NGReset_protocolIEs__item__id_tab,
        _____NGReset_protocolIEs__item__id_tab_val_Value_0,
        _____NGReset_protocolIEs__item__id_tab_val_Value_1,
        ___NGReset_protocolIEs__item__id,
        ___NGReset_protocolIEs__item__criticality,
        ___NGReset_protocolIEs__item__value,
        __NGReset_protocolIEs__item_,
        _NGReset_protocolIEs,
        NGReset,
        NGResetIEs,
        _NGResetIEs_val_Value_0,
        _NGResetIEs_val_Value_1,
        ____NGResetAcknowledge_protocolIEs__item__id_tab,
        _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___NGResetAcknowledge_protocolIEs__item__id,
        ___NGResetAcknowledge_protocolIEs__item__criticality,
        ___NGResetAcknowledge_protocolIEs__item__value,
        __NGResetAcknowledge_protocolIEs__item_,
        _NGResetAcknowledge_protocolIEs,
        NGResetAcknowledge,
        NGResetAcknowledgeIEs,
        _NGResetAcknowledgeIEs_val_Value_0,
        _NGResetAcknowledgeIEs_val_Value_1,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____OverloadStart_protocolIEs__item__id_tab,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_0,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_1,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_2,
        ___OverloadStart_protocolIEs__item__id,
        ___OverloadStart_protocolIEs__item__criticality,
        ___OverloadStart_protocolIEs__item__value,
        __OverloadStart_protocolIEs__item_,
        _OverloadStart_protocolIEs,
        OverloadStart,
        OverloadStartIEs,
        _OverloadStartIEs_val_Value_0,
        _OverloadStartIEs_val_Value_1,
        _OverloadStartIEs_val_Value_2,
        ____OverloadStop_protocolIEs__item__id_tab,
        ___OverloadStop_protocolIEs__item__id,
        ____OverloadStop_protocolIEs__item__criticality_tab,
        ___OverloadStop_protocolIEs__item__criticality,
        ____OverloadStop_protocolIEs__item__value_tab,
        ___OverloadStop_protocolIEs__item__value,
        __OverloadStop_protocolIEs__item_,
        _OverloadStop_protocolIEs,
        OverloadStop,
        OverloadStopIEs,
        ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__id,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__value,
        __UplinkRANConfigurationTransfer_protocolIEs__item_,
        _UplinkRANConfigurationTransfer_protocolIEs,
        UplinkRANConfigurationTransfer,
        UplinkRANConfigurationTransferIEs,
        _UplinkRANConfigurationTransferIEs_val_Value_0,
        _UplinkRANConfigurationTransferIEs_val_Value_1,
        _UplinkRANConfigurationTransferIEs_val_Value_2,
        ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__id,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__value,
        __DownlinkRANConfigurationTransfer_protocolIEs__item_,
        _DownlinkRANConfigurationTransfer_protocolIEs,
        DownlinkRANConfigurationTransfer,
        DownlinkRANConfigurationTransferIEs,
        _DownlinkRANConfigurationTransferIEs_val_Value_0,
        _DownlinkRANConfigurationTransferIEs_val_Value_1,
        _DownlinkRANConfigurationTransferIEs_val_Value_2,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        _WriteReplaceWarningRequestIEs_val_Value_5,
        _WriteReplaceWarningRequestIEs_val_Value_6,
        _WriteReplaceWarningRequestIEs_val_Value_7,
        _WriteReplaceWarningRequestIEs_val_Value_8,
        _WriteReplaceWarningRequestIEs_val_Value_9,
        _WriteReplaceWarningRequestIEs_val_Value_10,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ____PWSCancelRequest_protocolIEs__item__id_tab,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PWSCancelRequest_protocolIEs__item__id,
        ___PWSCancelRequest_protocolIEs__item__criticality,
        ___PWSCancelRequest_protocolIEs__item__value,
        __PWSCancelRequest_protocolIEs__item_,
        _PWSCancelRequest_protocolIEs,
        PWSCancelRequest,
        PWSCancelRequestIEs,
        _PWSCancelRequestIEs_val_Value_0,
        _PWSCancelRequestIEs_val_Value_1,
        _PWSCancelRequestIEs_val_Value_2,
        _PWSCancelRequestIEs_val_Value_3,
        ____PWSCancelResponse_protocolIEs__item__id_tab,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3,
        ___PWSCancelResponse_protocolIEs__item__id,
        ___PWSCancelResponse_protocolIEs__item__criticality,
        ___PWSCancelResponse_protocolIEs__item__value,
        __PWSCancelResponse_protocolIEs__item_,
        _PWSCancelResponse_protocolIEs,
        PWSCancelResponse,
        PWSCancelResponseIEs,
        _PWSCancelResponseIEs_val_Value_0,
        _PWSCancelResponseIEs_val_Value_1,
        _PWSCancelResponseIEs_val_Value_2,
        _PWSCancelResponseIEs_val_Value_3,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        _PWSRestartIndicationIEs_val_Value_2,
        _PWSRestartIndicationIEs_val_Value_3,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_,
        _DownlinkUEAssociatedNRPPaTransport_protocolIEs,
        DownlinkUEAssociatedNRPPaTransport,
        DownlinkUEAssociatedNRPPaTransportIEs,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3,
        ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_,
        _UplinkUEAssociatedNRPPaTransport_protocolIEs,
        UplinkUEAssociatedNRPPaTransport,
        UplinkUEAssociatedNRPPaTransportIEs,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3,
        ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_,
        _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs,
        DownlinkNonUEAssociatedNRPPaTransport,
        DownlinkNonUEAssociatedNRPPaTransportIEs,
        _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0,
        _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1,
        ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_,
        _UplinkNonUEAssociatedNRPPaTransport_protocolIEs,
        UplinkNonUEAssociatedNRPPaTransport,
        UplinkNonUEAssociatedNRPPaTransportIEs,
        _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0,
        _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____TraceFailureIndication_protocolIEs__item__id_tab,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___TraceFailureIndication_protocolIEs__item__id,
        ___TraceFailureIndication_protocolIEs__item__criticality,
        ___TraceFailureIndication_protocolIEs__item__value,
        __TraceFailureIndication_protocolIEs__item_,
        _TraceFailureIndication_protocolIEs,
        TraceFailureIndication,
        TraceFailureIndicationIEs,
        _TraceFailureIndicationIEs_val_Value_0,
        _TraceFailureIndicationIEs_val_Value_1,
        _TraceFailureIndicationIEs_val_Value_2,
        _TraceFailureIndicationIEs_val_Value_3,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        _CellTrafficTraceIEs_val_Value_6,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        _LocationReportingControlIEs_val_Value_1,
        _LocationReportingControlIEs_val_Value_2,
        ____LocationReportingFailureIndication_protocolIEs__item__id_tab,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingFailureIndication_protocolIEs__item__id,
        ___LocationReportingFailureIndication_protocolIEs__item__criticality,
        ___LocationReportingFailureIndication_protocolIEs__item__value,
        __LocationReportingFailureIndication_protocolIEs__item_,
        _LocationReportingFailureIndication_protocolIEs,
        LocationReportingFailureIndication,
        LocationReportingFailureIndicationIEs,
        _LocationReportingFailureIndicationIEs_val_Value_0,
        _LocationReportingFailureIndicationIEs_val_Value_1,
        _LocationReportingFailureIndicationIEs_val_Value_2,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_3,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_4,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        _LocationReportIEs_val_Value_3,
        _LocationReportIEs_val_Value_4,
        ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab,
        _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        ___UETNLABindingReleaseRequest_protocolIEs__item__id,
        ___UETNLABindingReleaseRequest_protocolIEs__item__criticality,
        ___UETNLABindingReleaseRequest_protocolIEs__item__value,
        __UETNLABindingReleaseRequest_protocolIEs__item_,
        _UETNLABindingReleaseRequest_protocolIEs,
        UETNLABindingReleaseRequest,
        UETNLABindingReleaseRequestIEs,
        _UETNLABindingReleaseRequestIEs_val_Value_0,
        _UETNLABindingReleaseRequestIEs_val_Value_1,
        ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__id,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__value,
        __UERadioCapabilityInfoIndication_protocolIEs__item_,
        _UERadioCapabilityInfoIndication_protocolIEs,
        UERadioCapabilityInfoIndication,
        UERadioCapabilityInfoIndicationIEs,
        _UERadioCapabilityInfoIndicationIEs_val_Value_0,
        _UERadioCapabilityInfoIndicationIEs_val_Value_1,
        _UERadioCapabilityInfoIndicationIEs_val_Value_2,
        _UERadioCapabilityInfoIndicationIEs_val_Value_3,
        _UERadioCapabilityInfoIndicationIEs_val_Value_4,
        ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__id,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__value,
        __UERadioCapabilityCheckRequest_protocolIEs__item_,
        _UERadioCapabilityCheckRequest_protocolIEs,
        UERadioCapabilityCheckRequest,
        UERadioCapabilityCheckRequestIEs,
        _UERadioCapabilityCheckRequestIEs_val_Value_0,
        _UERadioCapabilityCheckRequestIEs_val_Value_1,
        _UERadioCapabilityCheckRequestIEs_val_Value_2,
        _UERadioCapabilityCheckRequestIEs_val_Value_3,
        ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__id,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__value,
        __UERadioCapabilityCheckResponse_protocolIEs__item_,
        _UERadioCapabilityCheckResponse_protocolIEs,
        UERadioCapabilityCheckResponse,
        UERadioCapabilityCheckResponseIEs,
        _UERadioCapabilityCheckResponseIEs_val_Value_0,
        _UERadioCapabilityCheckResponseIEs_val_Value_1,
        _UERadioCapabilityCheckResponseIEs_val_Value_2,
        _UERadioCapabilityCheckResponseIEs_val_Value_3,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessageIEs,
        ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4,
        ___SecondaryRATDataUsageReport_protocolIEs__item__id,
        ___SecondaryRATDataUsageReport_protocolIEs__item__criticality,
        ___SecondaryRATDataUsageReport_protocolIEs__item__value,
        __SecondaryRATDataUsageReport_protocolIEs__item_,
        _SecondaryRATDataUsageReport_protocolIEs,
        SecondaryRATDataUsageReport,
        SecondaryRATDataUsageReportIEs,
        _SecondaryRATDataUsageReportIEs_val_Value_0,
        _SecondaryRATDataUsageReportIEs_val_Value_1,
        _SecondaryRATDataUsageReportIEs_val_Value_2,
        _SecondaryRATDataUsageReportIEs_val_Value_3,
        _SecondaryRATDataUsageReportIEs_val_Value_4,
        ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab,
        _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___UplinkRIMInformationTransfer_protocolIEs__item__id,
        ___UplinkRIMInformationTransfer_protocolIEs__item__criticality,
        ___UplinkRIMInformationTransfer_protocolIEs__item__value,
        __UplinkRIMInformationTransfer_protocolIEs__item_,
        _UplinkRIMInformationTransfer_protocolIEs,
        UplinkRIMInformationTransfer,
        UplinkRIMInformationTransferIEs,
        _UplinkRIMInformationTransferIEs_val_Value_0,
        ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab,
        _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__id,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__value,
        __DownlinkRIMInformationTransfer_protocolIEs__item_,
        _DownlinkRIMInformationTransfer_protocolIEs,
        DownlinkRIMInformationTransfer,
        DownlinkRIMInformationTransferIEs,
        _DownlinkRIMInformationTransferIEs_val_Value_0,
        ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11,
        ___ConnectionEstablishmentIndication_protocolIEs__item__id,
        ___ConnectionEstablishmentIndication_protocolIEs__item__criticality,
        ___ConnectionEstablishmentIndication_protocolIEs__item__value,
        __ConnectionEstablishmentIndication_protocolIEs__item_,
        _ConnectionEstablishmentIndication_protocolIEs,
        ConnectionEstablishmentIndication,
        ConnectionEstablishmentIndicationIEs,
        _ConnectionEstablishmentIndicationIEs_val_Value_0,
        _ConnectionEstablishmentIndicationIEs_val_Value_1,
        _ConnectionEstablishmentIndicationIEs_val_Value_2,
        _ConnectionEstablishmentIndicationIEs_val_Value_3,
        _ConnectionEstablishmentIndicationIEs_val_Value_4,
        _ConnectionEstablishmentIndicationIEs_val_Value_5,
        _ConnectionEstablishmentIndicationIEs_val_Value_6,
        _ConnectionEstablishmentIndicationIEs_val_Value_7,
        _ConnectionEstablishmentIndicationIEs_val_Value_8,
        _ConnectionEstablishmentIndicationIEs_val_Value_9,
        _ConnectionEstablishmentIndicationIEs_val_Value_10,
        _ConnectionEstablishmentIndicationIEs_val_Value_11,
        ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value,
        __UERadioCapabilityIDMappingRequest_protocolIEs__item_,
        _UERadioCapabilityIDMappingRequest_protocolIEs,
        UERadioCapabilityIDMappingRequest,
        UERadioCapabilityIDMappingRequestIEs,
        _UERadioCapabilityIDMappingRequestIEs_val_Value_0,
        ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value,
        __UERadioCapabilityIDMappingResponse_protocolIEs__item_,
        _UERadioCapabilityIDMappingResponse_protocolIEs,
        UERadioCapabilityIDMappingResponse,
        UERadioCapabilityIDMappingResponseIEs,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_0,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_1,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_2,
        ____AMFCPRelocationIndication_protocolIEs__item__id_tab,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        ___AMFCPRelocationIndication_protocolIEs__item__id,
        ___AMFCPRelocationIndication_protocolIEs__item__criticality,
        ___AMFCPRelocationIndication_protocolIEs__item__value,
        __AMFCPRelocationIndication_protocolIEs__item_,
        _AMFCPRelocationIndication_protocolIEs,
        AMFCPRelocationIndication,
        AMFCPRelocationIndicationIEs,
        _AMFCPRelocationIndicationIEs_val_Value_0,
        _AMFCPRelocationIndicationIEs_val_Value_1,
        _AMFCPRelocationIndicationIEs_val_Value_2,
        _AMFCPRelocationIndicationIEs_val_Value_3,
    ]

class NGAP_PDU_Descriptions:

    _name_  = u'NGAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 0]
    
    _obj_ = [
        u'NGAP-ELEMENTARY-PROCEDURE',
        u'NGAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'NGAP-ELEMENTARY-PROCEDURES',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'aMFConfigurationUpdate',
        u'aMFCPRelocationIndication',
        u'aMFStatusIndication',
        u'cellTrafficTrace',
        u'connectionEstablishmentIndication',
        u'deactivateTrace',
        u'downlinkNASTransport',
        u'downlinkNonUEAssociatedNRPPaTransport',
        u'downlinkRANConfigurationTransfer',
        u'downlinkRANEarlyStatusTransfer',
        u'downlinkRANStatusTransfer',
        u'downlinkUEAssociatedNRPPaTransport',
        u'errorIndication',
        u'handoverCancel',
        u'handoverNotification',
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverSuccess',
        u'initialContextSetup',
        u'initialUEMessage',
        u'locationReport',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'nASNonDeliveryIndication',
        u'nGReset',
        u'nGSetup',
        u'overloadStart',
        u'overloadStop',
        u'paging',
        u'pathSwitchRequest',
        u'pDUSessionResourceModify',
        u'pDUSessionResourceModifyIndication',
        u'pDUSessionResourceNotify',
        u'pDUSessionResourceRelease',
        u'pDUSessionResourceSetup',
        u'privateMessage',
        u'pWSCancel',
        u'pWSFailureIndication',
        u'pWSRestartIndication',
        u'rANConfigurationUpdate',
        u'rANCPRelocationIndication',
        u'rerouteNASRequest',
        u'retrieveUEInformation',
        u'rRCInactiveTransitionReport',
        u'secondaryRATDataUsageReport',
        u'traceFailureIndication',
        u'traceStart',
        u'uEContextModification',
        u'uEContextRelease',
        u'uEContextReleaseRequest',
        u'uEContextResume',
        u'uEContextSuspend',
        u'uEInformationTransfer',
        u'uERadioCapabilityCheck',
        u'uERadioCapabilityIDMapping',
        u'uERadioCapabilityInfoIndication',
        u'uETNLABindingRelease',
        u'uplinkNASTransport',
        u'uplinkNonUEAssociatedNRPPaTransport',
        u'uplinkRANConfigurationTransfer',
        u'uplinkRANEarlyStatusTransfer',
        u'uplinkRANStatusTransfer',
        u'uplinkUEAssociatedNRPPaTransport',
        u'writeReplaceWarning',
        u'uplinkRIMInformationTransfer',
        u'downlinkRIMInformationTransfer',
        ]
    _type_ = [
        u'NGAP-ELEMENTARY-PROCEDURE',
        u'NGAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'NGAP-ELEMENTARY-PROCEDURES',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'aMFConfigurationUpdate',
        u'aMFCPRelocationIndication',
        u'aMFStatusIndication',
        u'cellTrafficTrace',
        u'connectionEstablishmentIndication',
        u'deactivateTrace',
        u'downlinkNASTransport',
        u'downlinkNonUEAssociatedNRPPaTransport',
        u'downlinkRANConfigurationTransfer',
        u'downlinkRANEarlyStatusTransfer',
        u'downlinkRANStatusTransfer',
        u'downlinkUEAssociatedNRPPaTransport',
        u'errorIndication',
        u'handoverCancel',
        u'handoverNotification',
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverSuccess',
        u'initialContextSetup',
        u'initialUEMessage',
        u'locationReport',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'nASNonDeliveryIndication',
        u'nGReset',
        u'nGSetup',
        u'overloadStart',
        u'overloadStop',
        u'paging',
        u'pathSwitchRequest',
        u'pDUSessionResourceModify',
        u'pDUSessionResourceModifyIndication',
        u'pDUSessionResourceNotify',
        u'pDUSessionResourceRelease',
        u'pDUSessionResourceSetup',
        u'privateMessage',
        u'pWSCancel',
        u'pWSFailureIndication',
        u'pWSRestartIndication',
        u'rANConfigurationUpdate',
        u'rANCPRelocationIndication',
        u'rerouteNASRequest',
        u'retrieveUEInformation',
        u'rRCInactiveTransitionReport',
        u'secondaryRATDataUsageReport',
        u'traceFailureIndication',
        u'traceStart',
        u'uEContextModification',
        u'uEContextRelease',
        u'uEContextReleaseRequest',
        u'uEContextResume',
        u'uEContextSuspend',
        u'uEInformationTransfer',
        u'uERadioCapabilityCheck',
        u'uERadioCapabilityIDMapping',
        u'uERadioCapabilityInfoIndication',
        u'uETNLABindingRelease',
        u'uplinkNASTransport',
        u'uplinkNonUEAssociatedNRPPaTransport',
        u'uplinkRANConfigurationTransfer',
        u'uplinkRANEarlyStatusTransfer',
        u'uplinkRANStatusTransfer',
        u'uplinkUEAssociatedNRPPaTransport',
        u'writeReplaceWarning',
        u'uplinkRIMInformationTransfer',
        u'downlinkRIMInformationTransfer',
        ]
    _class_ = [
        u'NGAP-ELEMENTARY-PROCEDURE',
        u'NGAP-ELEMENTARY-PROCEDURES',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'aMFConfigurationUpdate',
        u'aMFCPRelocationIndication',
        u'aMFStatusIndication',
        u'cellTrafficTrace',
        u'connectionEstablishmentIndication',
        u'deactivateTrace',
        u'downlinkNASTransport',
        u'downlinkNonUEAssociatedNRPPaTransport',
        u'downlinkRANConfigurationTransfer',
        u'downlinkRANEarlyStatusTransfer',
        u'downlinkRANStatusTransfer',
        u'downlinkUEAssociatedNRPPaTransport',
        u'errorIndication',
        u'handoverCancel',
        u'handoverNotification',
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverSuccess',
        u'initialContextSetup',
        u'initialUEMessage',
        u'locationReport',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'nASNonDeliveryIndication',
        u'nGReset',
        u'nGSetup',
        u'overloadStart',
        u'overloadStop',
        u'paging',
        u'pathSwitchRequest',
        u'pDUSessionResourceModify',
        u'pDUSessionResourceModifyIndication',
        u'pDUSessionResourceNotify',
        u'pDUSessionResourceRelease',
        u'pDUSessionResourceSetup',
        u'privateMessage',
        u'pWSCancel',
        u'pWSFailureIndication',
        u'pWSRestartIndication',
        u'rANConfigurationUpdate',
        u'rANCPRelocationIndication',
        u'rerouteNASRequest',
        u'retrieveUEInformation',
        u'rRCInactiveTransitionReport',
        u'secondaryRATDataUsageReport',
        u'traceFailureIndication',
        u'traceStart',
        u'uEContextModification',
        u'uEContextRelease',
        u'uEContextReleaseRequest',
        u'uEContextResume',
        u'uEContextSuspend',
        u'uEInformationTransfer',
        u'uERadioCapabilityCheck',
        u'uERadioCapabilityIDMapping',
        u'uERadioCapabilityInfoIndication',
        u'uETNLABindingRelease',
        u'uplinkNASTransport',
        u'uplinkNonUEAssociatedNRPPaTransport',
        u'uplinkRANConfigurationTransfer',
        u'uplinkRANEarlyStatusTransfer',
        u'uplinkRANStatusTransfer',
        u'uplinkUEAssociatedNRPPaTransport',
        u'writeReplaceWarning',
        u'uplinkRIMInformationTransfer',
        u'downlinkRIMInformationTransfer',
        ]
    _param_ = [
        ]
    
    #-----< NGAP-ELEMENTARY-PROCEDURE >-----#
    NGAP_ELEMENTARY_PROCEDURE = CLASS(name=u'NGAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NGAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _NGAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')), default=u'ignore')
    NGAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _NGAP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _NGAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< NGAP-PDU >-----#
    NGAP_PDU = CHOICE(name=u'NGAP-PDU', mode=MODE_TYPE)
    _NGAP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'InitiatingMessage')))
    _NGAP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _NGAP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    NGAP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _NGAP_PDU_initiatingMessage),
        (u'successfulOutcome', _NGAP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _NGAP_PDU_unsuccessfulOutcome),
        ])
    NGAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 25), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 28), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20), (u'procedureCode', 51), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 64), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 6), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 63), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 7), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 61), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 57), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 52), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 62), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 50), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 25), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 28), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), (u'procedureCode', 51), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 64), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 6), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 63), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 7), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 61), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 57), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 52), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 62), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 50), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 25), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 28), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), (u'procedureCode', 51), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 64), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 6), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 63), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 7), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 61), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 57), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 52), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 62), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 50), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< NGAP-ELEMENTARY-PROCEDURES >-----#
    NGAP_ELEMENTARY_PROCEDURES = CLASS(name=u'NGAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    NGAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), (u'procedureCode', 25), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'procedureCode', 28), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), (u'procedureCode', 51), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'procedureCode', 64), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), (u'procedureCode', 6), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), (u'procedureCode', 63), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), (u'procedureCode', 7), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), (u'procedureCode', 61), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), (u'procedureCode', 57), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), (u'procedureCode', 52), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), (u'procedureCode', 62), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), (u'procedureCode', 50), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< NGAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    NGAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'NGAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    NGAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'procedureCode', 20), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), (u'procedureCode', 25), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'procedureCode', 28), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'procedureCode', 32), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), (u'procedureCode', 41), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), (u'SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), (u'procedureCode', 51), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< NGAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    NGAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'NGAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    NGAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 64), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 6), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 63), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 7), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 54), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), (u'procedureCode', 61), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), (u'procedureCode', 30), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), (u'procedureCode', 57), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), (u'procedureCode', 52), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), (u'procedureCode', 39), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), (u'procedureCode', 62), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), (u'procedureCode', 53), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), (u'procedureCode', 50), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< aMFConfigurationUpdate >-----#
    aMFConfigurationUpdate = CLASS(name=u'aMFConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _aMFConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _aMFConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    aMFConfigurationUpdate._val = dict([(u'InitiatingMessage', _aMFConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _aMFConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _aMFConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< aMFCPRelocationIndication >-----#
    aMFCPRelocationIndication = CLASS(name=u'aMFCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFCPRelocationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    aMFCPRelocationIndication._val = dict([(u'InitiatingMessage', _aMFCPRelocationIndication_val_InitiatingMessage), (u'procedureCode', 64), (u'criticality', u'reject')])
    
    #-----< aMFStatusIndication >-----#
    aMFStatusIndication = CLASS(name=u'aMFStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFStatusIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    aMFStatusIndication._val = dict([(u'InitiatingMessage', _aMFStatusIndication_val_InitiatingMessage), (u'procedureCode', 1), (u'criticality', u'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name=u'cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([(u'InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), (u'procedureCode', 2), (u'criticality', u'ignore')])
    
    #-----< connectionEstablishmentIndication >-----#
    connectionEstablishmentIndication = CLASS(name=u'connectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _connectionEstablishmentIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    connectionEstablishmentIndication._val = dict([(u'InitiatingMessage', _connectionEstablishmentIndication_val_InitiatingMessage), (u'procedureCode', 65), (u'criticality', u'reject')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name=u'deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([(u'InitiatingMessage', _deactivateTrace_val_InitiatingMessage), (u'procedureCode', 3), (u'criticality', u'ignore')])
    
    #-----< downlinkNASTransport >-----#
    downlinkNASTransport = CLASS(name=u'downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkNASTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    downlinkNASTransport._val = dict([(u'InitiatingMessage', _downlinkNASTransport_val_InitiatingMessage), (u'procedureCode', 4), (u'criticality', u'ignore')])
    
    #-----< downlinkNonUEAssociatedNRPPaTransport >-----#
    downlinkNonUEAssociatedNRPPaTransport = CLASS(name=u'downlinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    downlinkNonUEAssociatedNRPPaTransport._val = dict([(u'InitiatingMessage', _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage), (u'procedureCode', 5), (u'criticality', u'ignore')])
    
    #-----< downlinkRANConfigurationTransfer >-----#
    downlinkRANConfigurationTransfer = CLASS(name=u'downlinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANConfigurationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    downlinkRANConfigurationTransfer._val = dict([(u'InitiatingMessage', _downlinkRANConfigurationTransfer_val_InitiatingMessage), (u'procedureCode', 6), (u'criticality', u'ignore')])
    
    #-----< downlinkRANEarlyStatusTransfer >-----#
    downlinkRANEarlyStatusTransfer = CLASS(name=u'downlinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANEarlyStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    downlinkRANEarlyStatusTransfer._val = dict([(u'InitiatingMessage', _downlinkRANEarlyStatusTransfer_val_InitiatingMessage), (u'procedureCode', 63), (u'criticality', u'ignore')])
    
    #-----< downlinkRANStatusTransfer >-----#
    downlinkRANStatusTransfer = CLASS(name=u'downlinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    downlinkRANStatusTransfer._val = dict([(u'InitiatingMessage', _downlinkRANStatusTransfer_val_InitiatingMessage), (u'procedureCode', 7), (u'criticality', u'ignore')])
    
    #-----< downlinkUEAssociatedNRPPaTransport >-----#
    downlinkUEAssociatedNRPPaTransport = CLASS(name=u'downlinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    downlinkUEAssociatedNRPPaTransport._val = dict([(u'InitiatingMessage', _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage), (u'procedureCode', 8), (u'criticality', u'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 9), (u'criticality', u'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name=u'handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _handoverCancel_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    handoverCancel._val = dict([(u'InitiatingMessage', _handoverCancel_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverCancel_val_SuccessfulOutcome), (u'procedureCode', 10), (u'criticality', u'reject')])
    
    #-----< handoverNotification >-----#
    handoverNotification = CLASS(name=u'handoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverNotification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    handoverNotification._val = dict([(u'InitiatingMessage', _handoverNotification_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name=u'handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([(u'InitiatingMessage', _handoverPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 12), (u'criticality', u'reject')])
    
    #-----< handoverResourceAllocation >-----#
    handoverResourceAllocation = CLASS(name=u'handoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverResourceAllocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _handoverResourceAllocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverResourceAllocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    handoverResourceAllocation._val = dict([(u'InitiatingMessage', _handoverResourceAllocation_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverResourceAllocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _handoverResourceAllocation_val_UnsuccessfulOutcome), (u'procedureCode', 13), (u'criticality', u'reject')])
    
    #-----< handoverSuccess >-----#
    handoverSuccess = CLASS(name=u'handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverSuccess_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    handoverSuccess._val = dict([(u'InitiatingMessage', _handoverSuccess_val_InitiatingMessage), (u'procedureCode', 61), (u'criticality', u'ignore')])
    
    #-----< initialContextSetup >-----#
    initialContextSetup = CLASS(name=u'initialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _initialContextSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _initialContextSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _initialContextSetup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    initialContextSetup._val = dict([(u'InitiatingMessage', _initialContextSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _initialContextSetup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _initialContextSetup_val_UnsuccessfulOutcome), (u'procedureCode', 14), (u'criticality', u'reject')])
    
    #-----< initialUEMessage >-----#
    initialUEMessage = CLASS(name=u'initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _initialUEMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    initialUEMessage._val = dict([(u'InitiatingMessage', _initialUEMessage_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name=u'locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([(u'InitiatingMessage', _locationReport_val_InitiatingMessage), (u'procedureCode', 18), (u'criticality', u'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name=u'locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([(u'InitiatingMessage', _locationReportingControl_val_InitiatingMessage), (u'procedureCode', 16), (u'criticality', u'ignore')])
    
    #-----< locationReportingFailureIndication >-----#
    locationReportingFailureIndication = CLASS(name=u'locationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReportingFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    locationReportingFailureIndication._val = dict([(u'InitiatingMessage', _locationReportingFailureIndication_val_InitiatingMessage), (u'procedureCode', 17), (u'criticality', u'ignore')])
    
    #-----< nASNonDeliveryIndication >-----#
    nASNonDeliveryIndication = CLASS(name=u'nASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nASNonDeliveryIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    nASNonDeliveryIndication._val = dict([(u'InitiatingMessage', _nASNonDeliveryIndication_val_InitiatingMessage), (u'procedureCode', 19), (u'criticality', u'ignore')])
    
    #-----< nGReset >-----#
    nGReset = CLASS(name=u'nGReset', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nGReset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _nGReset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    nGReset._val = dict([(u'InitiatingMessage', _nGReset_val_InitiatingMessage), (u'SuccessfulOutcome', _nGReset_val_SuccessfulOutcome), (u'procedureCode', 20), (u'criticality', u'reject')])
    
    #-----< nGSetup >-----#
    nGSetup = CLASS(name=u'nGSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nGSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _nGSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _nGSetup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    nGSetup._val = dict([(u'InitiatingMessage', _nGSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _nGSetup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _nGSetup_val_UnsuccessfulOutcome), (u'procedureCode', 21), (u'criticality', u'reject')])
    
    #-----< overloadStart >-----#
    overloadStart = CLASS(name=u'overloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _overloadStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    overloadStart._val = dict([(u'InitiatingMessage', _overloadStart_val_InitiatingMessage), (u'procedureCode', 22), (u'criticality', u'ignore')])
    
    #-----< overloadStop >-----#
    overloadStop = CLASS(name=u'overloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _overloadStop_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    overloadStop._val = dict([(u'InitiatingMessage', _overloadStop_val_InitiatingMessage), (u'procedureCode', 23), (u'criticality', u'reject')])
    
    #-----< paging >-----#
    paging = CLASS(name=u'paging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    paging._val = dict([(u'InitiatingMessage', _paging_val_InitiatingMessage), (u'procedureCode', 24), (u'criticality', u'ignore')])
    
    #-----< pathSwitchRequest >-----#
    pathSwitchRequest = CLASS(name=u'pathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pathSwitchRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _pathSwitchRequest_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _pathSwitchRequest_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    pathSwitchRequest._val = dict([(u'InitiatingMessage', _pathSwitchRequest_val_InitiatingMessage), (u'SuccessfulOutcome', _pathSwitchRequest_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _pathSwitchRequest_val_UnsuccessfulOutcome), (u'procedureCode', 25), (u'criticality', u'reject')])
    
    #-----< pDUSessionResourceModify >-----#
    pDUSessionResourceModify = CLASS(name=u'pDUSessionResourceModify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceModify_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _pDUSessionResourceModify_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    pDUSessionResourceModify._val = dict([(u'InitiatingMessage', _pDUSessionResourceModify_val_InitiatingMessage), (u'SuccessfulOutcome', _pDUSessionResourceModify_val_SuccessfulOutcome), (u'procedureCode', 26), (u'criticality', u'reject')])
    
    #-----< pDUSessionResourceModifyIndication >-----#
    pDUSessionResourceModifyIndication = CLASS(name=u'pDUSessionResourceModifyIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceModifyIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _pDUSessionResourceModifyIndication_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    pDUSessionResourceModifyIndication._val = dict([(u'InitiatingMessage', _pDUSessionResourceModifyIndication_val_InitiatingMessage), (u'SuccessfulOutcome', _pDUSessionResourceModifyIndication_val_SuccessfulOutcome), (u'procedureCode', 27), (u'criticality', u'reject')])
    
    #-----< pDUSessionResourceNotify >-----#
    pDUSessionResourceNotify = CLASS(name=u'pDUSessionResourceNotify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceNotify_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    pDUSessionResourceNotify._val = dict([(u'InitiatingMessage', _pDUSessionResourceNotify_val_InitiatingMessage), (u'procedureCode', 30), (u'criticality', u'ignore')])
    
    #-----< pDUSessionResourceRelease >-----#
    pDUSessionResourceRelease = CLASS(name=u'pDUSessionResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _pDUSessionResourceRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    pDUSessionResourceRelease._val = dict([(u'InitiatingMessage', _pDUSessionResourceRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _pDUSessionResourceRelease_val_SuccessfulOutcome), (u'procedureCode', 28), (u'criticality', u'reject')])
    
    #-----< pDUSessionResourceSetup >-----#
    pDUSessionResourceSetup = CLASS(name=u'pDUSessionResourceSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _pDUSessionResourceSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    pDUSessionResourceSetup._val = dict([(u'InitiatingMessage', _pDUSessionResourceSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _pDUSessionResourceSetup_val_SuccessfulOutcome), (u'procedureCode', 29), (u'criticality', u'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 31), (u'criticality', u'ignore')])
    
    #-----< pWSCancel >-----#
    pWSCancel = CLASS(name=u'pWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _pWSCancel_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    pWSCancel._val = dict([(u'InitiatingMessage', _pWSCancel_val_InitiatingMessage), (u'SuccessfulOutcome', _pWSCancel_val_SuccessfulOutcome), (u'procedureCode', 32), (u'criticality', u'reject')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name=u'pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([(u'InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), (u'procedureCode', 33), (u'criticality', u'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name=u'pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([(u'InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), (u'procedureCode', 34), (u'criticality', u'ignore')])
    
    #-----< rANConfigurationUpdate >-----#
    rANConfigurationUpdate = CLASS(name=u'rANConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rANConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _rANConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _rANConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    rANConfigurationUpdate._val = dict([(u'InitiatingMessage', _rANConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _rANConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _rANConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 35), (u'criticality', u'reject')])
    
    #-----< rANCPRelocationIndication >-----#
    rANCPRelocationIndication = CLASS(name=u'rANCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rANCPRelocationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    rANCPRelocationIndication._val = dict([(u'InitiatingMessage', _rANCPRelocationIndication_val_InitiatingMessage), (u'procedureCode', 57), (u'criticality', u'reject')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name=u'rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([(u'InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), (u'procedureCode', 36), (u'criticality', u'reject')])
    
    #-----< retrieveUEInformation >-----#
    retrieveUEInformation = CLASS(name=u'retrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _retrieveUEInformation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    retrieveUEInformation._val = dict([(u'InitiatingMessage', _retrieveUEInformation_val_InitiatingMessage), (u'procedureCode', 55), (u'criticality', u'reject')])
    
    #-----< rRCInactiveTransitionReport >-----#
    rRCInactiveTransitionReport = CLASS(name=u'rRCInactiveTransitionReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rRCInactiveTransitionReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    rRCInactiveTransitionReport._val = dict([(u'InitiatingMessage', _rRCInactiveTransitionReport_val_InitiatingMessage), (u'procedureCode', 37), (u'criticality', u'ignore')])
    
    #-----< secondaryRATDataUsageReport >-----#
    secondaryRATDataUsageReport = CLASS(name=u'secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _secondaryRATDataUsageReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    secondaryRATDataUsageReport._val = dict([(u'InitiatingMessage', _secondaryRATDataUsageReport_val_InitiatingMessage), (u'procedureCode', 52), (u'criticality', u'ignore')])
    
    #-----< traceFailureIndication >-----#
    traceFailureIndication = CLASS(name=u'traceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _traceFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    traceFailureIndication._val = dict([(u'InitiatingMessage', _traceFailureIndication_val_InitiatingMessage), (u'procedureCode', 38), (u'criticality', u'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name=u'traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([(u'InitiatingMessage', _traceStart_val_InitiatingMessage), (u'procedureCode', 39), (u'criticality', u'ignore')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name=u'uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([(u'InitiatingMessage', _uEContextModification_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), (u'procedureCode', 40), (u'criticality', u'reject')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name=u'uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([(u'InitiatingMessage', _uEContextRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), (u'procedureCode', 41), (u'criticality', u'reject')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name=u'uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([(u'InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), (u'procedureCode', 42), (u'criticality', u'ignore')])
    
    #-----< uEContextResume >-----#
    uEContextResume = CLASS(name=u'uEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextResume_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _uEContextResume_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _uEContextResume_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    uEContextResume._val = dict([(u'InitiatingMessage', _uEContextResume_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextResume_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextResume_val_UnsuccessfulOutcome), (u'procedureCode', 58), (u'criticality', u'reject')])
    
    #-----< uEContextSuspend >-----#
    uEContextSuspend = CLASS(name=u'uEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextSuspend_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _uEContextSuspend_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _uEContextSuspend_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    uEContextSuspend._val = dict([(u'InitiatingMessage', _uEContextSuspend_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextSuspend_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextSuspend_val_UnsuccessfulOutcome), (u'procedureCode', 59), (u'criticality', u'reject')])
    
    #-----< uEInformationTransfer >-----#
    uEInformationTransfer = CLASS(name=u'uEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    uEInformationTransfer._val = dict([(u'InitiatingMessage', _uEInformationTransfer_val_InitiatingMessage), (u'procedureCode', 56), (u'criticality', u'reject')])
    
    #-----< uERadioCapabilityCheck >-----#
    uERadioCapabilityCheck = CLASS(name=u'uERadioCapabilityCheck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityCheck_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _uERadioCapabilityCheck_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    uERadioCapabilityCheck._val = dict([(u'InitiatingMessage', _uERadioCapabilityCheck_val_InitiatingMessage), (u'SuccessfulOutcome', _uERadioCapabilityCheck_val_SuccessfulOutcome), (u'procedureCode', 43), (u'criticality', u'reject')])
    
    #-----< uERadioCapabilityIDMapping >-----#
    uERadioCapabilityIDMapping = CLASS(name=u'uERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityIDMapping_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _uERadioCapabilityIDMapping_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    uERadioCapabilityIDMapping._val = dict([(u'InitiatingMessage', _uERadioCapabilityIDMapping_val_InitiatingMessage), (u'SuccessfulOutcome', _uERadioCapabilityIDMapping_val_SuccessfulOutcome), (u'procedureCode', 60), (u'criticality', u'reject')])
    
    #-----< uERadioCapabilityInfoIndication >-----#
    uERadioCapabilityInfoIndication = CLASS(name=u'uERadioCapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityInfoIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    uERadioCapabilityInfoIndication._val = dict([(u'InitiatingMessage', _uERadioCapabilityInfoIndication_val_InitiatingMessage), (u'procedureCode', 44), (u'criticality', u'ignore')])
    
    #-----< uETNLABindingRelease >-----#
    uETNLABindingRelease = CLASS(name=u'uETNLABindingRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uETNLABindingRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    uETNLABindingRelease._val = dict([(u'InitiatingMessage', _uETNLABindingRelease_val_InitiatingMessage), (u'procedureCode', 45), (u'criticality', u'ignore')])
    
    #-----< uplinkNASTransport >-----#
    uplinkNASTransport = CLASS(name=u'uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkNASTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    uplinkNASTransport._val = dict([(u'InitiatingMessage', _uplinkNASTransport_val_InitiatingMessage), (u'procedureCode', 46), (u'criticality', u'ignore')])
    
    #-----< uplinkNonUEAssociatedNRPPaTransport >-----#
    uplinkNonUEAssociatedNRPPaTransport = CLASS(name=u'uplinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    uplinkNonUEAssociatedNRPPaTransport._val = dict([(u'InitiatingMessage', _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage), (u'procedureCode', 47), (u'criticality', u'ignore')])
    
    #-----< uplinkRANConfigurationTransfer >-----#
    uplinkRANConfigurationTransfer = CLASS(name=u'uplinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANConfigurationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    uplinkRANConfigurationTransfer._val = dict([(u'InitiatingMessage', _uplinkRANConfigurationTransfer_val_InitiatingMessage), (u'procedureCode', 48), (u'criticality', u'ignore')])
    
    #-----< uplinkRANEarlyStatusTransfer >-----#
    uplinkRANEarlyStatusTransfer = CLASS(name=u'uplinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANEarlyStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    uplinkRANEarlyStatusTransfer._val = dict([(u'InitiatingMessage', _uplinkRANEarlyStatusTransfer_val_InitiatingMessage), (u'procedureCode', 62), (u'criticality', u'reject')])
    
    #-----< uplinkRANStatusTransfer >-----#
    uplinkRANStatusTransfer = CLASS(name=u'uplinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    uplinkRANStatusTransfer._val = dict([(u'InitiatingMessage', _uplinkRANStatusTransfer_val_InitiatingMessage), (u'procedureCode', 49), (u'criticality', u'ignore')])
    
    #-----< uplinkUEAssociatedNRPPaTransport >-----#
    uplinkUEAssociatedNRPPaTransport = CLASS(name=u'uplinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    uplinkUEAssociatedNRPPaTransport._val = dict([(u'InitiatingMessage', _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage), (u'procedureCode', 50), (u'criticality', u'ignore')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name=u'writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([(u'InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), (u'SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), (u'procedureCode', 51), (u'criticality', u'reject')])
    
    #-----< uplinkRIMInformationTransfer >-----#
    uplinkRIMInformationTransfer = CLASS(name=u'uplinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRIMInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    uplinkRIMInformationTransfer._val = dict([(u'InitiatingMessage', _uplinkRIMInformationTransfer_val_InitiatingMessage), (u'procedureCode', 53), (u'criticality', u'ignore')])
    
    #-----< downlinkRIMInformationTransfer >-----#
    downlinkRIMInformationTransfer = CLASS(name=u'downlinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRIMInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    downlinkRIMInformationTransfer._val = dict([(u'InitiatingMessage', _downlinkRIMInformationTransfer_val_InitiatingMessage), (u'procedureCode', 54), (u'criticality', u'ignore')])
    
    _all_ = [
        _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _NGAP_ELEMENTARY_PROCEDURE_procedureCode,
        _NGAP_ELEMENTARY_PROCEDURE_criticality,
        NGAP_ELEMENTARY_PROCEDURE,
        _NGAP_PDU_initiatingMessage,
        _NGAP_PDU_successfulOutcome,
        _NGAP_PDU_unsuccessfulOutcome,
        NGAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        NGAP_ELEMENTARY_PROCEDURES,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        NGAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        NGAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        aMFConfigurationUpdate,
        _aMFConfigurationUpdate_val_InitiatingMessage,
        _aMFConfigurationUpdate_val_SuccessfulOutcome,
        _aMFConfigurationUpdate_val_UnsuccessfulOutcome,
        aMFCPRelocationIndication,
        _aMFCPRelocationIndication_val_InitiatingMessage,
        aMFStatusIndication,
        _aMFStatusIndication_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        connectionEstablishmentIndication,
        _connectionEstablishmentIndication_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        downlinkNASTransport,
        _downlinkNASTransport_val_InitiatingMessage,
        downlinkNonUEAssociatedNRPPaTransport,
        _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage,
        downlinkRANConfigurationTransfer,
        _downlinkRANConfigurationTransfer_val_InitiatingMessage,
        downlinkRANEarlyStatusTransfer,
        _downlinkRANEarlyStatusTransfer_val_InitiatingMessage,
        downlinkRANStatusTransfer,
        _downlinkRANStatusTransfer_val_InitiatingMessage,
        downlinkUEAssociatedNRPPaTransport,
        _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        _handoverCancel_val_SuccessfulOutcome,
        handoverNotification,
        _handoverNotification_val_InitiatingMessage,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        handoverResourceAllocation,
        _handoverResourceAllocation_val_InitiatingMessage,
        _handoverResourceAllocation_val_SuccessfulOutcome,
        _handoverResourceAllocation_val_UnsuccessfulOutcome,
        handoverSuccess,
        _handoverSuccess_val_InitiatingMessage,
        initialContextSetup,
        _initialContextSetup_val_InitiatingMessage,
        _initialContextSetup_val_SuccessfulOutcome,
        _initialContextSetup_val_UnsuccessfulOutcome,
        initialUEMessage,
        _initialUEMessage_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReportingFailureIndication,
        _locationReportingFailureIndication_val_InitiatingMessage,
        nASNonDeliveryIndication,
        _nASNonDeliveryIndication_val_InitiatingMessage,
        nGReset,
        _nGReset_val_InitiatingMessage,
        _nGReset_val_SuccessfulOutcome,
        nGSetup,
        _nGSetup_val_InitiatingMessage,
        _nGSetup_val_SuccessfulOutcome,
        _nGSetup_val_UnsuccessfulOutcome,
        overloadStart,
        _overloadStart_val_InitiatingMessage,
        overloadStop,
        _overloadStop_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        pathSwitchRequest,
        _pathSwitchRequest_val_InitiatingMessage,
        _pathSwitchRequest_val_SuccessfulOutcome,
        _pathSwitchRequest_val_UnsuccessfulOutcome,
        pDUSessionResourceModify,
        _pDUSessionResourceModify_val_InitiatingMessage,
        _pDUSessionResourceModify_val_SuccessfulOutcome,
        pDUSessionResourceModifyIndication,
        _pDUSessionResourceModifyIndication_val_InitiatingMessage,
        _pDUSessionResourceModifyIndication_val_SuccessfulOutcome,
        pDUSessionResourceNotify,
        _pDUSessionResourceNotify_val_InitiatingMessage,
        pDUSessionResourceRelease,
        _pDUSessionResourceRelease_val_InitiatingMessage,
        _pDUSessionResourceRelease_val_SuccessfulOutcome,
        pDUSessionResourceSetup,
        _pDUSessionResourceSetup_val_InitiatingMessage,
        _pDUSessionResourceSetup_val_SuccessfulOutcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        pWSCancel,
        _pWSCancel_val_InitiatingMessage,
        _pWSCancel_val_SuccessfulOutcome,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        rANConfigurationUpdate,
        _rANConfigurationUpdate_val_InitiatingMessage,
        _rANConfigurationUpdate_val_SuccessfulOutcome,
        _rANConfigurationUpdate_val_UnsuccessfulOutcome,
        rANCPRelocationIndication,
        _rANCPRelocationIndication_val_InitiatingMessage,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
        retrieveUEInformation,
        _retrieveUEInformation_val_InitiatingMessage,
        rRCInactiveTransitionReport,
        _rRCInactiveTransitionReport_val_InitiatingMessage,
        secondaryRATDataUsageReport,
        _secondaryRATDataUsageReport_val_InitiatingMessage,
        traceFailureIndication,
        _traceFailureIndication_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        uEContextResume,
        _uEContextResume_val_InitiatingMessage,
        _uEContextResume_val_SuccessfulOutcome,
        _uEContextResume_val_UnsuccessfulOutcome,
        uEContextSuspend,
        _uEContextSuspend_val_InitiatingMessage,
        _uEContextSuspend_val_SuccessfulOutcome,
        _uEContextSuspend_val_UnsuccessfulOutcome,
        uEInformationTransfer,
        _uEInformationTransfer_val_InitiatingMessage,
        uERadioCapabilityCheck,
        _uERadioCapabilityCheck_val_InitiatingMessage,
        _uERadioCapabilityCheck_val_SuccessfulOutcome,
        uERadioCapabilityIDMapping,
        _uERadioCapabilityIDMapping_val_InitiatingMessage,
        _uERadioCapabilityIDMapping_val_SuccessfulOutcome,
        uERadioCapabilityInfoIndication,
        _uERadioCapabilityInfoIndication_val_InitiatingMessage,
        uETNLABindingRelease,
        _uETNLABindingRelease_val_InitiatingMessage,
        uplinkNASTransport,
        _uplinkNASTransport_val_InitiatingMessage,
        uplinkNonUEAssociatedNRPPaTransport,
        _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage,
        uplinkRANConfigurationTransfer,
        _uplinkRANConfigurationTransfer_val_InitiatingMessage,
        uplinkRANEarlyStatusTransfer,
        _uplinkRANEarlyStatusTransfer_val_InitiatingMessage,
        uplinkRANStatusTransfer,
        _uplinkRANStatusTransfer_val_InitiatingMessage,
        uplinkUEAssociatedNRPPaTransport,
        _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        uplinkRIMInformationTransfer,
        _uplinkRIMInformationTransfer_val_InitiatingMessage,
        downlinkRIMInformationTransfer,
        _downlinkRIMInformationTransfer_val_InitiatingMessage,
    ]

init_modules(NGAP_CommonDataTypes, NGAP_Constants, NGAP_Containers, NGAP_IEs, NGAP_PDU_Contents, NGAP_PDU_Descriptions)
