# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class NRPPA_CommonDataTypes:

    _name_  = u'NRPPA-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 3]
    
    _obj_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'Criticality',
        u'NRPPATransactionID',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'NRPPATransactionID',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< NRPPATransactionID >-----#
    NRPPATransactionID = INT(name=u'NRPPATransactionID', mode=MODE_TYPE)
    NRPPATransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        NRPPATransactionID,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class NRPPA_Constants:

    _name_  = u'NRPPA-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 4]
    
    _obj_ = [
        u'id-errorIndication',
        u'id-privateMessage',
        u'id-e-CIDMeasurementInitiation',
        u'id-e-CIDMeasurementFailureIndication',
        u'id-e-CIDMeasurementReport',
        u'id-e-CIDMeasurementTermination',
        u'id-oTDOAInformationExchange',
        u'id-assistanceInformationControl',
        u'id-assistanceInformationFeedback',
        u'id-positioningInformationExchange',
        u'id-positioningInformationUpdate',
        u'id-Measurement',
        u'id-MeasurementReport',
        u'id-MeasurementUpdate',
        u'id-MeasurementAbort',
        u'id-MeasurementFailureIndication',
        u'id-tRPInformationExchange',
        u'id-positioningActivation',
        u'id-positioningDeactivation',
        u'maxNrOfErrors',
        u'maxCellinRANnode',
        u'maxIndexesReport',
        u'maxNoMeas',
        u'maxCellReport',
        u'maxCellReportNR',
        u'maxnoOTDOAtypes',
        u'maxServCell',
        u'maxEUTRAMeas',
        u'maxGERANMeas',
        u'maxNRMeas',
        u'maxUTRANMeas',
        u'maxWLANchannels',
        u'maxnoFreqHoppingBandsMinusOne',
        u'maxNoPath',
        u'maxNrOfPosSImessage',
        u'maxnoAssistInfoFailureListItems',
        u'maxNrOfSegments',
        u'maxNrOfPosSIBs',
        u'maxNoOfMeasTRPs',
        u'maxnoTRPs',
        u'maxnoTRPInfoTypes',
        u'maxnoofAngleInfo',
        u'maxnolcs-gcs-translation',
        u'maxnoBcastCell',
        u'maxnoSRSTriggerStates',
        u'maxnoSpatialRelations',
        u'maxnoPosMeas',
        u'maxnoSRS-Carriers',
        u'maxnoSCSs',
        u'maxnoSRS-Resources',
        u'maxnoSRS-PosResources',
        u'maxnoSRS-ResourceSets',
        u'maxnoSRS-ResourcePerSet',
        u'maxnoSRS-PosResourceSets',
        u'maxnoSRS-PosResourcePerSet',
        u'maxPRS-ResourceSets',
        u'maxPRS-ResourcesPerSet',
        u'maxNoSSBs',
        u'maxnoofPRSresourceSet',
        u'maxnoofPRSresource',
        u'id-Cause',
        u'id-CriticalityDiagnostics',
        u'id-LMF-UE-Measurement-ID',
        u'id-ReportCharacteristics',
        u'id-MeasurementPeriodicity',
        u'id-MeasurementQuantities',
        u'id-RAN-UE-Measurement-ID',
        u'id-E-CID-MeasurementResult',
        u'id-OTDOACells',
        u'id-OTDOA-Information-Type-Group',
        u'id-OTDOA-Information-Type-Item',
        u'id-MeasurementQuantities-Item',
        u'id-RequestedSRSTransmissionCharacteristics',
        u'id-Cell-Portion-ID',
        u'id-OtherRATMeasurementQuantities',
        u'id-OtherRATMeasurementQuantities-Item',
        u'id-OtherRATMeasurementResult',
        u'id-WLANMeasurementQuantities',
        u'id-WLANMeasurementQuantities-Item',
        u'id-WLANMeasurementResult',
        u'id-TDD-Config-EUTRA-Item',
        u'id-Assistance-Information',
        u'id-Broadcast',
        u'id-AssistanceInformationFailureList',
        u'id-SRSConfiguration',
        u'id-MeasurementResult',
        u'id-TRP-ID',
        u'id-TRPInformationTypeListTRPReq',
        u'id-TRPInformationListTRPResp',
        u'id-MeasurementBeamInfoRequest',
        u'id-ResultSS-RSRP',
        u'id-ResultSS-RSRQ',
        u'id-ResultCSI-RSRP',
        u'id-ResultCSI-RSRQ',
        u'id-AngleOfArrivalNR',
        u'id-GeographicalCoordinates',
        u'id-PositioningBroadcastCells',
        u'id-LMF-Measurement-ID',
        u'id-RAN-Measurement-ID',
        u'id-TRP-MeasurementRequestList',
        u'id-TRP-MeasurementResponseList',
        u'id-TRP-MeasurementReportList',
        u'id-SRSType',
        u'id-ActivationTime',
        u'id-SRSResourceSetID',
        u'id-TRPList',
        u'id-SRSSpatialRelation',
        u'id-SystemFrameNumber',
        u'id-SlotNumber',
        u'id-SRSResourceTrigger',
        u'id-TRPMeasurementQuantities',
        u'id-AbortTransmission',
        u'id-SFNInitialisationTime',
        u'id-ResultNR',
        u'id-ResultEUTRA',
        u'id-TRPInformationTypeItem',
        u'id-CGI-NR',
        u'id-SFNInitialisationTime-NR',
        u'id-Cell-ID',
        u'id-SrsFrequency',
        u'id-TRPType',
        u'id-SRSSpatialRelationPerSRSResource',
        u'id-MeasurementPeriodicityExtended',
        u'id-PRS-Resource-ID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-errorIndication',
        u'id-privateMessage',
        u'id-e-CIDMeasurementInitiation',
        u'id-e-CIDMeasurementFailureIndication',
        u'id-e-CIDMeasurementReport',
        u'id-e-CIDMeasurementTermination',
        u'id-oTDOAInformationExchange',
        u'id-assistanceInformationControl',
        u'id-assistanceInformationFeedback',
        u'id-positioningInformationExchange',
        u'id-positioningInformationUpdate',
        u'id-Measurement',
        u'id-MeasurementReport',
        u'id-MeasurementUpdate',
        u'id-MeasurementAbort',
        u'id-MeasurementFailureIndication',
        u'id-tRPInformationExchange',
        u'id-positioningActivation',
        u'id-positioningDeactivation',
        u'maxNrOfErrors',
        u'maxCellinRANnode',
        u'maxIndexesReport',
        u'maxNoMeas',
        u'maxCellReport',
        u'maxCellReportNR',
        u'maxnoOTDOAtypes',
        u'maxServCell',
        u'maxEUTRAMeas',
        u'maxGERANMeas',
        u'maxNRMeas',
        u'maxUTRANMeas',
        u'maxWLANchannels',
        u'maxnoFreqHoppingBandsMinusOne',
        u'maxNoPath',
        u'maxNrOfPosSImessage',
        u'maxnoAssistInfoFailureListItems',
        u'maxNrOfSegments',
        u'maxNrOfPosSIBs',
        u'maxNoOfMeasTRPs',
        u'maxnoTRPs',
        u'maxnoTRPInfoTypes',
        u'maxnoofAngleInfo',
        u'maxnolcs-gcs-translation',
        u'maxnoBcastCell',
        u'maxnoSRSTriggerStates',
        u'maxnoSpatialRelations',
        u'maxnoPosMeas',
        u'maxnoSRS-Carriers',
        u'maxnoSCSs',
        u'maxnoSRS-Resources',
        u'maxnoSRS-PosResources',
        u'maxnoSRS-ResourceSets',
        u'maxnoSRS-ResourcePerSet',
        u'maxnoSRS-PosResourceSets',
        u'maxnoSRS-PosResourcePerSet',
        u'maxPRS-ResourceSets',
        u'maxPRS-ResourcesPerSet',
        u'maxNoSSBs',
        u'maxnoofPRSresourceSet',
        u'maxnoofPRSresource',
        u'id-Cause',
        u'id-CriticalityDiagnostics',
        u'id-LMF-UE-Measurement-ID',
        u'id-ReportCharacteristics',
        u'id-MeasurementPeriodicity',
        u'id-MeasurementQuantities',
        u'id-RAN-UE-Measurement-ID',
        u'id-E-CID-MeasurementResult',
        u'id-OTDOACells',
        u'id-OTDOA-Information-Type-Group',
        u'id-OTDOA-Information-Type-Item',
        u'id-MeasurementQuantities-Item',
        u'id-RequestedSRSTransmissionCharacteristics',
        u'id-Cell-Portion-ID',
        u'id-OtherRATMeasurementQuantities',
        u'id-OtherRATMeasurementQuantities-Item',
        u'id-OtherRATMeasurementResult',
        u'id-WLANMeasurementQuantities',
        u'id-WLANMeasurementQuantities-Item',
        u'id-WLANMeasurementResult',
        u'id-TDD-Config-EUTRA-Item',
        u'id-Assistance-Information',
        u'id-Broadcast',
        u'id-AssistanceInformationFailureList',
        u'id-SRSConfiguration',
        u'id-MeasurementResult',
        u'id-TRP-ID',
        u'id-TRPInformationTypeListTRPReq',
        u'id-TRPInformationListTRPResp',
        u'id-MeasurementBeamInfoRequest',
        u'id-ResultSS-RSRP',
        u'id-ResultSS-RSRQ',
        u'id-ResultCSI-RSRP',
        u'id-ResultCSI-RSRQ',
        u'id-AngleOfArrivalNR',
        u'id-GeographicalCoordinates',
        u'id-PositioningBroadcastCells',
        u'id-LMF-Measurement-ID',
        u'id-RAN-Measurement-ID',
        u'id-TRP-MeasurementRequestList',
        u'id-TRP-MeasurementResponseList',
        u'id-TRP-MeasurementReportList',
        u'id-SRSType',
        u'id-ActivationTime',
        u'id-SRSResourceSetID',
        u'id-TRPList',
        u'id-SRSSpatialRelation',
        u'id-SystemFrameNumber',
        u'id-SlotNumber',
        u'id-SRSResourceTrigger',
        u'id-TRPMeasurementQuantities',
        u'id-AbortTransmission',
        u'id-SFNInitialisationTime',
        u'id-ResultNR',
        u'id-ResultEUTRA',
        u'id-TRPInformationTypeItem',
        u'id-CGI-NR',
        u'id-SFNInitialisationTime-NR',
        u'id-Cell-ID',
        u'id-SrsFrequency',
        u'id-TRPType',
        u'id-SRSSpatialRelationPerSRSResource',
        u'id-MeasurementPeriodicityExtended',
        u'id-PRS-Resource-ID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name=u'id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 0
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 1
    
    #-----< id-e-CIDMeasurementInitiation >-----#
    id_e_CIDMeasurementInitiation = INT(name=u'id-e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementInitiation._val = 2
    
    #-----< id-e-CIDMeasurementFailureIndication >-----#
    id_e_CIDMeasurementFailureIndication = INT(name=u'id-e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementFailureIndication._val = 3
    
    #-----< id-e-CIDMeasurementReport >-----#
    id_e_CIDMeasurementReport = INT(name=u'id-e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementReport._val = 4
    
    #-----< id-e-CIDMeasurementTermination >-----#
    id_e_CIDMeasurementTermination = INT(name=u'id-e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementTermination._val = 5
    
    #-----< id-oTDOAInformationExchange >-----#
    id_oTDOAInformationExchange = INT(name=u'id-oTDOAInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_oTDOAInformationExchange._val = 6
    
    #-----< id-assistanceInformationControl >-----#
    id_assistanceInformationControl = INT(name=u'id-assistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_assistanceInformationControl._val = 7
    
    #-----< id-assistanceInformationFeedback >-----#
    id_assistanceInformationFeedback = INT(name=u'id-assistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_assistanceInformationFeedback._val = 8
    
    #-----< id-positioningInformationExchange >-----#
    id_positioningInformationExchange = INT(name=u'id-positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningInformationExchange._val = 9
    
    #-----< id-positioningInformationUpdate >-----#
    id_positioningInformationUpdate = INT(name=u'id-positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningInformationUpdate._val = 10
    
    #-----< id-Measurement >-----#
    id_Measurement = INT(name=u'id-Measurement', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_Measurement._val = 11
    
    #-----< id-MeasurementReport >-----#
    id_MeasurementReport = INT(name=u'id-MeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementReport._val = 12
    
    #-----< id-MeasurementUpdate >-----#
    id_MeasurementUpdate = INT(name=u'id-MeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementUpdate._val = 13
    
    #-----< id-MeasurementAbort >-----#
    id_MeasurementAbort = INT(name=u'id-MeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementAbort._val = 14
    
    #-----< id-MeasurementFailureIndication >-----#
    id_MeasurementFailureIndication = INT(name=u'id-MeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementFailureIndication._val = 15
    
    #-----< id-tRPInformationExchange >-----#
    id_tRPInformationExchange = INT(name=u'id-tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_tRPInformationExchange._val = 16
    
    #-----< id-positioningActivation >-----#
    id_positioningActivation = INT(name=u'id-positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningActivation._val = 17
    
    #-----< id-positioningDeactivation >-----#
    id_positioningDeactivation = INT(name=u'id-positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningDeactivation._val = 18
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name=u'maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxCellinRANnode >-----#
    maxCellinRANnode = INT(name=u'maxCellinRANnode', mode=MODE_VALUE)
    maxCellinRANnode._val = 3840
    
    #-----< maxIndexesReport >-----#
    maxIndexesReport = INT(name=u'maxIndexesReport', mode=MODE_VALUE)
    maxIndexesReport._val = 64
    
    #-----< maxNoMeas >-----#
    maxNoMeas = INT(name=u'maxNoMeas', mode=MODE_VALUE)
    maxNoMeas._val = 64
    
    #-----< maxCellReport >-----#
    maxCellReport = INT(name=u'maxCellReport', mode=MODE_VALUE)
    maxCellReport._val = 9
    
    #-----< maxCellReportNR >-----#
    maxCellReportNR = INT(name=u'maxCellReportNR', mode=MODE_VALUE)
    maxCellReportNR._val = 9
    
    #-----< maxnoOTDOAtypes >-----#
    maxnoOTDOAtypes = INT(name=u'maxnoOTDOAtypes', mode=MODE_VALUE)
    maxnoOTDOAtypes._val = 63
    
    #-----< maxServCell >-----#
    maxServCell = INT(name=u'maxServCell', mode=MODE_VALUE)
    maxServCell._val = 5
    
    #-----< maxEUTRAMeas >-----#
    maxEUTRAMeas = INT(name=u'maxEUTRAMeas', mode=MODE_VALUE)
    maxEUTRAMeas._val = 8
    
    #-----< maxGERANMeas >-----#
    maxGERANMeas = INT(name=u'maxGERANMeas', mode=MODE_VALUE)
    maxGERANMeas._val = 8
    
    #-----< maxNRMeas >-----#
    maxNRMeas = INT(name=u'maxNRMeas', mode=MODE_VALUE)
    maxNRMeas._val = 8
    
    #-----< maxUTRANMeas >-----#
    maxUTRANMeas = INT(name=u'maxUTRANMeas', mode=MODE_VALUE)
    maxUTRANMeas._val = 8
    
    #-----< maxWLANchannels >-----#
    maxWLANchannels = INT(name=u'maxWLANchannels', mode=MODE_VALUE)
    maxWLANchannels._val = 16
    
    #-----< maxnoFreqHoppingBandsMinusOne >-----#
    maxnoFreqHoppingBandsMinusOne = INT(name=u'maxnoFreqHoppingBandsMinusOne', mode=MODE_VALUE)
    maxnoFreqHoppingBandsMinusOne._val = 7
    
    #-----< maxNoPath >-----#
    maxNoPath = INT(name=u'maxNoPath', mode=MODE_VALUE)
    maxNoPath._val = 2
    
    #-----< maxNrOfPosSImessage >-----#
    maxNrOfPosSImessage = INT(name=u'maxNrOfPosSImessage', mode=MODE_VALUE)
    maxNrOfPosSImessage._val = 32
    
    #-----< maxnoAssistInfoFailureListItems >-----#
    maxnoAssistInfoFailureListItems = INT(name=u'maxnoAssistInfoFailureListItems', mode=MODE_VALUE)
    maxnoAssistInfoFailureListItems._val = 32
    
    #-----< maxNrOfSegments >-----#
    maxNrOfSegments = INT(name=u'maxNrOfSegments', mode=MODE_VALUE)
    maxNrOfSegments._val = 64
    
    #-----< maxNrOfPosSIBs >-----#
    maxNrOfPosSIBs = INT(name=u'maxNrOfPosSIBs', mode=MODE_VALUE)
    maxNrOfPosSIBs._val = 32
    
    #-----< maxNoOfMeasTRPs >-----#
    maxNoOfMeasTRPs = INT(name=u'maxNoOfMeasTRPs', mode=MODE_VALUE)
    maxNoOfMeasTRPs._val = 64
    
    #-----< maxnoTRPs >-----#
    maxnoTRPs = INT(name=u'maxnoTRPs', mode=MODE_VALUE)
    maxnoTRPs._val = 65535
    
    #-----< maxnoTRPInfoTypes >-----#
    maxnoTRPInfoTypes = INT(name=u'maxnoTRPInfoTypes', mode=MODE_VALUE)
    maxnoTRPInfoTypes._val = 64
    
    #-----< maxnoofAngleInfo >-----#
    maxnoofAngleInfo = INT(name=u'maxnoofAngleInfo', mode=MODE_VALUE)
    maxnoofAngleInfo._val = 65535
    
    #-----< maxnolcs-gcs-translation >-----#
    maxnolcs_gcs_translation = INT(name=u'maxnolcs-gcs-translation', mode=MODE_VALUE)
    maxnolcs_gcs_translation._val = 3
    
    #-----< maxnoBcastCell >-----#
    maxnoBcastCell = INT(name=u'maxnoBcastCell', mode=MODE_VALUE)
    maxnoBcastCell._val = 16384
    
    #-----< maxnoSRSTriggerStates >-----#
    maxnoSRSTriggerStates = INT(name=u'maxnoSRSTriggerStates', mode=MODE_VALUE)
    maxnoSRSTriggerStates._val = 3
    
    #-----< maxnoSpatialRelations >-----#
    maxnoSpatialRelations = INT(name=u'maxnoSpatialRelations', mode=MODE_VALUE)
    maxnoSpatialRelations._val = 64
    
    #-----< maxnoPosMeas >-----#
    maxnoPosMeas = INT(name=u'maxnoPosMeas', mode=MODE_VALUE)
    maxnoPosMeas._val = 16384
    
    #-----< maxnoSRS-Carriers >-----#
    maxnoSRS_Carriers = INT(name=u'maxnoSRS-Carriers', mode=MODE_VALUE)
    maxnoSRS_Carriers._val = 32
    
    #-----< maxnoSCSs >-----#
    maxnoSCSs = INT(name=u'maxnoSCSs', mode=MODE_VALUE)
    maxnoSCSs._val = 5
    
    #-----< maxnoSRS-Resources >-----#
    maxnoSRS_Resources = INT(name=u'maxnoSRS-Resources', mode=MODE_VALUE)
    maxnoSRS_Resources._val = 64
    
    #-----< maxnoSRS-PosResources >-----#
    maxnoSRS_PosResources = INT(name=u'maxnoSRS-PosResources', mode=MODE_VALUE)
    maxnoSRS_PosResources._val = 64
    
    #-----< maxnoSRS-ResourceSets >-----#
    maxnoSRS_ResourceSets = INT(name=u'maxnoSRS-ResourceSets', mode=MODE_VALUE)
    maxnoSRS_ResourceSets._val = 16
    
    #-----< maxnoSRS-ResourcePerSet >-----#
    maxnoSRS_ResourcePerSet = INT(name=u'maxnoSRS-ResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_ResourcePerSet._val = 16
    
    #-----< maxnoSRS-PosResourceSets >-----#
    maxnoSRS_PosResourceSets = INT(name=u'maxnoSRS-PosResourceSets', mode=MODE_VALUE)
    maxnoSRS_PosResourceSets._val = 16
    
    #-----< maxnoSRS-PosResourcePerSet >-----#
    maxnoSRS_PosResourcePerSet = INT(name=u'maxnoSRS-PosResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_PosResourcePerSet._val = 16
    
    #-----< maxPRS-ResourceSets >-----#
    maxPRS_ResourceSets = INT(name=u'maxPRS-ResourceSets', mode=MODE_VALUE)
    maxPRS_ResourceSets._val = 2
    
    #-----< maxPRS-ResourcesPerSet >-----#
    maxPRS_ResourcesPerSet = INT(name=u'maxPRS-ResourcesPerSet', mode=MODE_VALUE)
    maxPRS_ResourcesPerSet._val = 64
    
    #-----< maxNoSSBs >-----#
    maxNoSSBs = INT(name=u'maxNoSSBs', mode=MODE_VALUE)
    maxNoSSBs._val = 255
    
    #-----< maxnoofPRSresourceSet >-----#
    maxnoofPRSresourceSet = INT(name=u'maxnoofPRSresourceSet', mode=MODE_VALUE)
    maxnoofPRSresourceSet._val = 8
    
    #-----< maxnoofPRSresource >-----#
    maxnoofPRSresource = INT(name=u'maxnoofPRSresource', mode=MODE_VALUE)
    maxnoofPRSresource._val = 64
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 0
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 1
    
    #-----< id-LMF-UE-Measurement-ID >-----#
    id_LMF_UE_Measurement_ID = INT(name=u'id-LMF-UE-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_UE_Measurement_ID._val = 2
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name=u'id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 3
    
    #-----< id-MeasurementPeriodicity >-----#
    id_MeasurementPeriodicity = INT(name=u'id-MeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementPeriodicity._val = 4
    
    #-----< id-MeasurementQuantities >-----#
    id_MeasurementQuantities = INT(name=u'id-MeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementQuantities._val = 5
    
    #-----< id-RAN-UE-Measurement-ID >-----#
    id_RAN_UE_Measurement_ID = INT(name=u'id-RAN-UE-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_Measurement_ID._val = 6
    
    #-----< id-E-CID-MeasurementResult >-----#
    id_E_CID_MeasurementResult = INT(name=u'id-E-CID-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementResult._val = 7
    
    #-----< id-OTDOACells >-----#
    id_OTDOACells = INT(name=u'id-OTDOACells', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOACells._val = 8
    
    #-----< id-OTDOA-Information-Type-Group >-----#
    id_OTDOA_Information_Type_Group = INT(name=u'id-OTDOA-Information-Type-Group', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_Information_Type_Group._val = 9
    
    #-----< id-OTDOA-Information-Type-Item >-----#
    id_OTDOA_Information_Type_Item = INT(name=u'id-OTDOA-Information-Type-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_Information_Type_Item._val = 10
    
    #-----< id-MeasurementQuantities-Item >-----#
    id_MeasurementQuantities_Item = INT(name=u'id-MeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementQuantities_Item._val = 11
    
    #-----< id-RequestedSRSTransmissionCharacteristics >-----#
    id_RequestedSRSTransmissionCharacteristics = INT(name=u'id-RequestedSRSTransmissionCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSRSTransmissionCharacteristics._val = 12
    
    #-----< id-Cell-Portion-ID >-----#
    id_Cell_Portion_ID = INT(name=u'id-Cell-Portion-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Portion_ID._val = 14
    
    #-----< id-OtherRATMeasurementQuantities >-----#
    id_OtherRATMeasurementQuantities = INT(name=u'id-OtherRATMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementQuantities._val = 15
    
    #-----< id-OtherRATMeasurementQuantities-Item >-----#
    id_OtherRATMeasurementQuantities_Item = INT(name=u'id-OtherRATMeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementQuantities_Item._val = 16
    
    #-----< id-OtherRATMeasurementResult >-----#
    id_OtherRATMeasurementResult = INT(name=u'id-OtherRATMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementResult._val = 17
    
    #-----< id-WLANMeasurementQuantities >-----#
    id_WLANMeasurementQuantities = INT(name=u'id-WLANMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementQuantities._val = 19
    
    #-----< id-WLANMeasurementQuantities-Item >-----#
    id_WLANMeasurementQuantities_Item = INT(name=u'id-WLANMeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementQuantities_Item._val = 20
    
    #-----< id-WLANMeasurementResult >-----#
    id_WLANMeasurementResult = INT(name=u'id-WLANMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementResult._val = 21
    
    #-----< id-TDD-Config-EUTRA-Item >-----#
    id_TDD_Config_EUTRA_Item = INT(name=u'id-TDD-Config-EUTRA-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_Config_EUTRA_Item._val = 22
    
    #-----< id-Assistance-Information >-----#
    id_Assistance_Information = INT(name=u'id-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Assistance_Information._val = 23
    
    #-----< id-Broadcast >-----#
    id_Broadcast = INT(name=u'id-Broadcast', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast._val = 24
    
    #-----< id-AssistanceInformationFailureList >-----#
    id_AssistanceInformationFailureList = INT(name=u'id-AssistanceInformationFailureList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceInformationFailureList._val = 25
    
    #-----< id-SRSConfiguration >-----#
    id_SRSConfiguration = INT(name=u'id-SRSConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSConfiguration._val = 26
    
    #-----< id-MeasurementResult >-----#
    id_MeasurementResult = INT(name=u'id-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementResult._val = 27
    
    #-----< id-TRP-ID >-----#
    id_TRP_ID = INT(name=u'id-TRP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_ID._val = 28
    
    #-----< id-TRPInformationTypeListTRPReq >-----#
    id_TRPInformationTypeListTRPReq = INT(name=u'id-TRPInformationTypeListTRPReq', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeListTRPReq._val = 29
    
    #-----< id-TRPInformationListTRPResp >-----#
    id_TRPInformationListTRPResp = INT(name=u'id-TRPInformationListTRPResp', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationListTRPResp._val = 30
    
    #-----< id-MeasurementBeamInfoRequest >-----#
    id_MeasurementBeamInfoRequest = INT(name=u'id-MeasurementBeamInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementBeamInfoRequest._val = 31
    
    #-----< id-ResultSS-RSRP >-----#
    id_ResultSS_RSRP = INT(name=u'id-ResultSS-RSRP', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultSS_RSRP._val = 32
    
    #-----< id-ResultSS-RSRQ >-----#
    id_ResultSS_RSRQ = INT(name=u'id-ResultSS-RSRQ', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultSS_RSRQ._val = 33
    
    #-----< id-ResultCSI-RSRP >-----#
    id_ResultCSI_RSRP = INT(name=u'id-ResultCSI-RSRP', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultCSI_RSRP._val = 34
    
    #-----< id-ResultCSI-RSRQ >-----#
    id_ResultCSI_RSRQ = INT(name=u'id-ResultCSI-RSRQ', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultCSI_RSRQ._val = 35
    
    #-----< id-AngleOfArrivalNR >-----#
    id_AngleOfArrivalNR = INT(name=u'id-AngleOfArrivalNR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AngleOfArrivalNR._val = 36
    
    #-----< id-GeographicalCoordinates >-----#
    id_GeographicalCoordinates = INT(name=u'id-GeographicalCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_GeographicalCoordinates._val = 37
    
    #-----< id-PositioningBroadcastCells >-----#
    id_PositioningBroadcastCells = INT(name=u'id-PositioningBroadcastCells', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningBroadcastCells._val = 38
    
    #-----< id-LMF-Measurement-ID >-----#
    id_LMF_Measurement_ID = INT(name=u'id-LMF-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_Measurement_ID._val = 39
    
    #-----< id-RAN-Measurement-ID >-----#
    id_RAN_Measurement_ID = INT(name=u'id-RAN-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_Measurement_ID._val = 40
    
    #-----< id-TRP-MeasurementRequestList >-----#
    id_TRP_MeasurementRequestList = INT(name=u'id-TRP-MeasurementRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementRequestList._val = 41
    
    #-----< id-TRP-MeasurementResponseList >-----#
    id_TRP_MeasurementResponseList = INT(name=u'id-TRP-MeasurementResponseList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementResponseList._val = 42
    
    #-----< id-TRP-MeasurementReportList >-----#
    id_TRP_MeasurementReportList = INT(name=u'id-TRP-MeasurementReportList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementReportList._val = 43
    
    #-----< id-SRSType >-----#
    id_SRSType = INT(name=u'id-SRSType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSType._val = 44
    
    #-----< id-ActivationTime >-----#
    id_ActivationTime = INT(name=u'id-ActivationTime', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationTime._val = 45
    
    #-----< id-SRSResourceSetID >-----#
    id_SRSResourceSetID = INT(name=u'id-SRSResourceSetID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourceSetID._val = 46
    
    #-----< id-TRPList >-----#
    id_TRPList = INT(name=u'id-TRPList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPList._val = 47
    
    #-----< id-SRSSpatialRelation >-----#
    id_SRSSpatialRelation = INT(name=u'id-SRSSpatialRelation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelation._val = 48
    
    #-----< id-SystemFrameNumber >-----#
    id_SystemFrameNumber = INT(name=u'id-SystemFrameNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SystemFrameNumber._val = 49
    
    #-----< id-SlotNumber >-----#
    id_SlotNumber = INT(name=u'id-SlotNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SlotNumber._val = 50
    
    #-----< id-SRSResourceTrigger >-----#
    id_SRSResourceTrigger = INT(name=u'id-SRSResourceTrigger', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourceTrigger._val = 51
    
    #-----< id-TRPMeasurementQuantities >-----#
    id_TRPMeasurementQuantities = INT(name=u'id-TRPMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPMeasurementQuantities._val = 52
    
    #-----< id-AbortTransmission >-----#
    id_AbortTransmission = INT(name=u'id-AbortTransmission', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AbortTransmission._val = 53
    
    #-----< id-SFNInitialisationTime >-----#
    id_SFNInitialisationTime = INT(name=u'id-SFNInitialisationTime', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime._val = 54
    
    #-----< id-ResultNR >-----#
    id_ResultNR = INT(name=u'id-ResultNR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultNR._val = 55
    
    #-----< id-ResultEUTRA >-----#
    id_ResultEUTRA = INT(name=u'id-ResultEUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultEUTRA._val = 56
    
    #-----< id-TRPInformationTypeItem >-----#
    id_TRPInformationTypeItem = INT(name=u'id-TRPInformationTypeItem', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeItem._val = 57
    
    #-----< id-CGI-NR >-----#
    id_CGI_NR = INT(name=u'id-CGI-NR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CGI_NR._val = 58
    
    #-----< id-SFNInitialisationTime-NR >-----#
    id_SFNInitialisationTime_NR = INT(name=u'id-SFNInitialisationTime-NR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime_NR._val = 59
    
    #-----< id-Cell-ID >-----#
    id_Cell_ID = INT(name=u'id-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_ID._val = 60
    
    #-----< id-SrsFrequency >-----#
    id_SrsFrequency = INT(name=u'id-SrsFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SrsFrequency._val = 61
    
    #-----< id-TRPType >-----#
    id_TRPType = INT(name=u'id-TRPType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPType._val = 62
    
    #-----< id-SRSSpatialRelationPerSRSResource >-----#
    id_SRSSpatialRelationPerSRSResource = INT(name=u'id-SRSSpatialRelationPerSRSResource', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelationPerSRSResource._val = 63
    
    #-----< id-MeasurementPeriodicityExtended >-----#
    id_MeasurementPeriodicityExtended = INT(name=u'id-MeasurementPeriodicityExtended', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementPeriodicityExtended._val = 64
    
    #-----< id-PRS-Resource-ID >-----#
    id_PRS_Resource_ID = INT(name=u'id-PRS-Resource-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Resource_ID._val = 65
    
    _all_ = [
        id_errorIndication,
        id_privateMessage,
        id_e_CIDMeasurementInitiation,
        id_e_CIDMeasurementFailureIndication,
        id_e_CIDMeasurementReport,
        id_e_CIDMeasurementTermination,
        id_oTDOAInformationExchange,
        id_assistanceInformationControl,
        id_assistanceInformationFeedback,
        id_positioningInformationExchange,
        id_positioningInformationUpdate,
        id_Measurement,
        id_MeasurementReport,
        id_MeasurementUpdate,
        id_MeasurementAbort,
        id_MeasurementFailureIndication,
        id_tRPInformationExchange,
        id_positioningActivation,
        id_positioningDeactivation,
        maxNrOfErrors,
        maxCellinRANnode,
        maxIndexesReport,
        maxNoMeas,
        maxCellReport,
        maxCellReportNR,
        maxnoOTDOAtypes,
        maxServCell,
        maxEUTRAMeas,
        maxGERANMeas,
        maxNRMeas,
        maxUTRANMeas,
        maxWLANchannels,
        maxnoFreqHoppingBandsMinusOne,
        maxNoPath,
        maxNrOfPosSImessage,
        maxnoAssistInfoFailureListItems,
        maxNrOfSegments,
        maxNrOfPosSIBs,
        maxNoOfMeasTRPs,
        maxnoTRPs,
        maxnoTRPInfoTypes,
        maxnoofAngleInfo,
        maxnolcs_gcs_translation,
        maxnoBcastCell,
        maxnoSRSTriggerStates,
        maxnoSpatialRelations,
        maxnoPosMeas,
        maxnoSRS_Carriers,
        maxnoSCSs,
        maxnoSRS_Resources,
        maxnoSRS_PosResources,
        maxnoSRS_ResourceSets,
        maxnoSRS_ResourcePerSet,
        maxnoSRS_PosResourceSets,
        maxnoSRS_PosResourcePerSet,
        maxPRS_ResourceSets,
        maxPRS_ResourcesPerSet,
        maxNoSSBs,
        maxnoofPRSresourceSet,
        maxnoofPRSresource,
        id_Cause,
        id_CriticalityDiagnostics,
        id_LMF_UE_Measurement_ID,
        id_ReportCharacteristics,
        id_MeasurementPeriodicity,
        id_MeasurementQuantities,
        id_RAN_UE_Measurement_ID,
        id_E_CID_MeasurementResult,
        id_OTDOACells,
        id_OTDOA_Information_Type_Group,
        id_OTDOA_Information_Type_Item,
        id_MeasurementQuantities_Item,
        id_RequestedSRSTransmissionCharacteristics,
        id_Cell_Portion_ID,
        id_OtherRATMeasurementQuantities,
        id_OtherRATMeasurementQuantities_Item,
        id_OtherRATMeasurementResult,
        id_WLANMeasurementQuantities,
        id_WLANMeasurementQuantities_Item,
        id_WLANMeasurementResult,
        id_TDD_Config_EUTRA_Item,
        id_Assistance_Information,
        id_Broadcast,
        id_AssistanceInformationFailureList,
        id_SRSConfiguration,
        id_MeasurementResult,
        id_TRP_ID,
        id_TRPInformationTypeListTRPReq,
        id_TRPInformationListTRPResp,
        id_MeasurementBeamInfoRequest,
        id_ResultSS_RSRP,
        id_ResultSS_RSRQ,
        id_ResultCSI_RSRP,
        id_ResultCSI_RSRQ,
        id_AngleOfArrivalNR,
        id_GeographicalCoordinates,
        id_PositioningBroadcastCells,
        id_LMF_Measurement_ID,
        id_RAN_Measurement_ID,
        id_TRP_MeasurementRequestList,
        id_TRP_MeasurementResponseList,
        id_TRP_MeasurementReportList,
        id_SRSType,
        id_ActivationTime,
        id_SRSResourceSetID,
        id_TRPList,
        id_SRSSpatialRelation,
        id_SystemFrameNumber,
        id_SlotNumber,
        id_SRSResourceTrigger,
        id_TRPMeasurementQuantities,
        id_AbortTransmission,
        id_SFNInitialisationTime,
        id_ResultNR,
        id_ResultEUTRA,
        id_TRPInformationTypeItem,
        id_CGI_NR,
        id_SFNInitialisationTime_NR,
        id_Cell_ID,
        id_SrsFrequency,
        id_TRPType,
        id_SRSSpatialRelationPerSRSResource,
        id_MeasurementPeriodicityExtended,
        id_PRS_Resource_ID,
    ]

class NRPPA_Containers:

    _name_  = u'NRPPA-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 5]
    
    _obj_ = [
        u'NRPPA-PROTOCOL-IES',
        u'NRPPA-PROTOCOL-EXTENSION',
        u'NRPPA-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'NRPPA-PROTOCOL-IES',
        u'NRPPA-PROTOCOL-EXTENSION',
        u'NRPPA-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'NRPPA-PROTOCOL-IES',
        u'NRPPA-PROTOCOL-EXTENSION',
        u'NRPPA-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< NRPPA-PROTOCOL-IES >-----#
    NRPPA_PROTOCOL_IES = CLASS(name=u'NRPPA-PROTOCOL-IES', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NRPPA_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _NRPPA_PROTOCOL_IES_id),
        (u'criticality', _NRPPA_PROTOCOL_IES_criticality),
        (u'Value', _NRPPA_PROTOCOL_IES_Value),
        (u'presence', _NRPPA_PROTOCOL_IES_presence),
        ])
    
    #-----< NRPPA-PROTOCOL-EXTENSION >-----#
    NRPPA_PROTOCOL_EXTENSION = CLASS(name=u'NRPPA-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NRPPA_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _NRPPA_PROTOCOL_EXTENSION_id),
        (u'criticality', _NRPPA_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _NRPPA_PROTOCOL_EXTENSION_Extension),
        (u'presence', _NRPPA_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< NRPPA-PRIVATE-IES >-----#
    NRPPA_PRIVATE_IES = CLASS(name=u'NRPPA-PRIVATE-IES', mode=MODE_TYPE)
    _NRPPA_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'PrivateIE-ID')))
    _NRPPA_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _NRPPA_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _NRPPA_PRIVATE_IES_id),
        (u'criticality', _NRPPA_PRIVATE_IES_criticality),
        (u'Value', _NRPPA_PRIVATE_IES_Value),
        (u'presence', _NRPPA_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name=u'ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _NRPPA_PROTOCOL_IES_id,
        _NRPPA_PROTOCOL_IES_criticality,
        _NRPPA_PROTOCOL_IES_Value,
        _NRPPA_PROTOCOL_IES_presence,
        NRPPA_PROTOCOL_IES,
        _NRPPA_PROTOCOL_EXTENSION_id,
        _NRPPA_PROTOCOL_EXTENSION_criticality,
        _NRPPA_PROTOCOL_EXTENSION_Extension,
        _NRPPA_PROTOCOL_EXTENSION_presence,
        NRPPA_PROTOCOL_EXTENSION,
        _NRPPA_PRIVATE_IES_id,
        _NRPPA_PRIVATE_IES_criticality,
        _NRPPA_PRIVATE_IES_Value,
        _NRPPA_PRIVATE_IES_presence,
        NRPPA_PRIVATE_IES,
    ]

class NRPPA_IEs:

    _name_  = u'NRPPA-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 2]
    
    _obj_ = [
        u'AbortTransmission',
        u'AbortTransmission-ExtIEs',
        u'ActiveULBWP',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalPathList',
        u'AdditionalPathListItem',
        u'AdditionalPathListItem-ExtIEs',
        u'AperiodicSRSResourceTriggerList',
        u'AperiodicSRSResourceTrigger',
        u'Assistance-Information',
        u'Assistance-Information-ExtIEs',
        u'AssistanceInformationFailureList',
        u'AssistanceInformationFailureList-ExtIEs',
        u'AssistanceInformationMetaData',
        u'AssistanceInformationMetaData-ExtIEs',
        u'BandwidthSRS',
        u'BandwidthSRS-ExtIEs',
        u'BCCH',
        u'Broadcast',
        u'BroadcastPeriodicity',
        u'PositioningBroadcastCells',
        u'BSSID',
        u'Cause',
        u'Cause-ExtensionIE',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'Cell-Portion-ID',
        u'CGI-EUTRA',
        u'CGI-EUTRA-ExtIEs',
        u'CGI-NR',
        u'CGI-NR-ExtIEs',
        u'CPLength-EUTRA',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'DL-Bandwidth-EUTRA',
        u'DL-PRS',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'E-CID-MeasurementResult',
        u'E-CID-MeasurementResult-ExtIEs',
        u'EUTRACellIdentifier',
        u'EARFCN',
        u'GeographicalCoordinates',
        u'GeographicalCoordinates-ExtIEs',
        u'GNB-RxTxTimeDiff',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'HESSID',
        u'LCS-to-GCS-TranslationAoA',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCS-to-GCS-TranslationItem',
        u'LCS-to-GCS-TranslationItem-ExtIEs',
        u'LocationUncertainty',
        u'LocationUncertainty-ExtIEs',
        u'Measurement-ID',
        u'MeasurementBeamInfoRequest',
        u'MeasurementBeamInfo',
        u'MeasurementBeamInfo-ExtIEs',
        u'MeasurementPeriodicity',
        u'MeasurementPeriodicityExtended',
        u'MeasurementQuantities',
        u'MeasurementQuantities-ItemIEs',
        u'MeasurementQuantities-Item',
        u'MeasurementQuantitiesValue-ExtIEs',
        u'MeasurementQuantitiesValue',
        u'MeasuredResults',
        u'MeasuredResultsValue',
        u'MeasuredResultsValue-ExtensionIE',
        u'NarrowBandIndex',
        u'NG-RANAccessPointPosition',
        u'NG-RANAccessPointPosition-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NG-RAN-CGI',
        u'NG-RAN-CGI-ExtIEs',
        u'NG-RANCell',
        u'NG-RANCell-ExtensionIE',
        u'NR-ARFCN',
        u'NRCellIdentifier',
        u'NR-PCI',
        u'NR-PRS-Beam-Information',
        u'NR-PRS-Beam-Information-IEs',
        u'NR-PRS-Beam-InformationItem',
        u'NR-PRS-Beam-InformationItem-ExtIEs',
        u'NumberOfAntennaPorts-EUTRA',
        u'NumberOfDlFrames-EUTRA',
        u'NumberOfDlFrames-Extended-EUTRA',
        u'NumberOfFrequencyHoppingBands',
        u'NZP-CSI-RS-ResourceID',
        u'OTDOACells',
        u'OTDOACells-ExtIEs',
        u'OTDOACell-Information',
        u'OTDOACell-Information-Item',
        u'OTDOACell-Information-Item-ExtensionIE',
        u'OTDOA-Information-Item',
        u'OtherRATMeasurementQuantities',
        u'OtherRATMeasurementQuantities-ItemIEs',
        u'OtherRATMeasurementQuantities-Item',
        u'OtherRATMeasurementQuantitiesValue-ExtIEs',
        u'OtherRATMeasurementQuantitiesValue',
        u'OtherRATMeasurementResult',
        u'OtherRATMeasuredResultsValue',
        u'OtherRATMeasuredResultsValue-ExtensionIE',
        u'Outcome',
        u'PathlossReferenceInformation',
        u'PathlossReferenceInformation-ExtIEs',
        u'PathlossReferenceSignal',
        u'PathlossReferenceSignal-ExtensionIE',
        u'PCI-EUTRA',
        u'PhysCellIDGERAN',
        u'PhysCellIDUTRA-FDD',
        u'PhysCellIDUTRA-TDD',
        u'PLMN-Identity',
        u'PeriodicityList',
        u'PeriodicityItem',
        u'PosSIBs',
        u'PosSIBs-ExtIEs',
        u'PosSIB-Segments',
        u'PosSIB-Segments-ExtIEs',
        u'PosSIB-Type',
        u'PosSRSResource-List',
        u'PosSRSResource-Item',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResourceSet-List',
        u'PosSRSResourceID-List',
        u'PosSRSResourceSet-Item',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'PosResourceSetType',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePeriodic',
        u'PosResourceSetTypePeriodic-ExtIEs',
        u'PosResourceSetTypeSemi-persistent',
        u'PosResourceSetTypeSemi-persistent-ExtIEs',
        u'PosResourceSetTypeAperiodic',
        u'PosResourceSetTypeAperiodic-ExtIEs',
        u'PRS-Bandwidth-EUTRA',
        u'PRSAngleItem',
        u'PRSAngleItem-ExtIEs',
        u'PRSInformationPos',
        u'PRSInformationPos-ExtIEs',
        u'PRSConfiguration',
        u'PRSConfiguration-ExtIEs',
        u'PRS-ConfigurationIndex-EUTRA',
        u'PRS-ID-EUTRA',
        u'PRSMutingConfiguration-EUTRA',
        u'PRSMutingConfiguration-EUTRA-ExtensionIE',
        u'PRSOccasionGroup-EUTRA',
        u'PRSFrequencyHoppingConfiguration-EUTRA',
        u'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        u'PRSMuting',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2',
        u'PRSMutingOption2-ExtIEs',
        u'PRSResource-List',
        u'PRSResource-Item',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRSResourceSet-List',
        u'PRSResourceSet-Item',
        u'PRSResourceSet-Item-ExtIEs',
        u'PRS-Resource-ID',
        u'PRS-Resource-Set-ID',
        u'PRS-ID',
        u'ReferenceSignal',
        u'ReferenceSignal-ExtensionIE',
        u'ReferencePoint',
        u'ReferencePoint-ExtIEs',
        u'CoordinateID',
        u'RelativeGeodeticLocation',
        u'RelativeGeodeticLocation-ExtIEs',
        u'RelativeCartesianLocation',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativePathDelay',
        u'RelativePathDelay-ExtIEs',
        u'ReportCharacteristics',
        u'RequestedSRSTransmissionCharacteristics',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'SRSResourceSet-Item',
        u'SRSResourceSet-Item-ExtIEs',
        u'ResourceSetType',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'ResourceType',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'ResultCSI-RSRP',
        u'ResultCSI-RSRP-Item',
        u'ResultCSI-RSRP-Item-ExtIEs',
        u'ResultCSI-RSRP-PerCSI-RS',
        u'ResultCSI-RSRP-PerCSI-RS-Item',
        u'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        u'ResultCSI-RSRQ',
        u'ResultCSI-RSRQ-Item',
        u'ResultCSI-RSRQ-Item-ExtIEs',
        u'ResultCSI-RSRQ-PerCSI-RS',
        u'ResultCSI-RSRQ-PerCSI-RS-Item',
        u'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        u'ResultEUTRA',
        u'ResultEUTRA-Item',
        u'ResultEUTRA-Item-ExtIEs',
        u'ResultRSRP-EUTRA',
        u'ResultRSRP-EUTRA-Item',
        u'ResultRSRP-EUTRA-Item-ExtIEs',
        u'ResultRSRQ-EUTRA',
        u'ResultRSRQ-EUTRA-Item',
        u'ResultRSRQ-EUTRA-Item-ExtIEs',
        u'ResultSS-RSRP',
        u'ResultSS-RSRP-Item',
        u'ResultSS-RSRP-Item-ExtIEs',
        u'ResultSS-RSRP-PerSSB',
        u'ResultSS-RSRP-PerSSB-Item',
        u'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        u'ResultSS-RSRQ',
        u'ResultSS-RSRQ-Item',
        u'ResultSS-RSRQ-Item-ExtIEs',
        u'ResultSS-RSRQ-PerSSB',
        u'ResultSS-RSRQ-PerSSB-Item',
        u'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        u'ResultGERAN',
        u'ResultGERAN-Item',
        u'ResultGERAN-Item-ExtIEs',
        u'ResultNR',
        u'ResultNR-Item',
        u'ResultNR-Item-ExtIEs',
        u'ResultUTRAN',
        u'ResultUTRAN-Item',
        u'ResultUTRAN-Item-ExtIEs',
        u'RSSI',
        u'SCS-SpecificCarrier',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information',
        u'Search-window-information-ExtIEs',
        u'RelativeTime1900',
        u'SFNInitialisationTime-EUTRA',
        u'SlotNumber',
        u'SpatialDirectionInformation',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceID',
        u'SpatialRelationforResourceIDItem',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResource-List',
        u'SpatialRelationPerSRSResourceItem',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialRelationPos',
        u'SpatialInformationPos-ExtIEs',
        u'SRSConfig',
        u'SRSConfig-ExtIEs',
        u'SRSCarrier-List',
        u'SRSCarrier-List-Item',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfiguration',
        u'SRSConfiguration-ExtIEs',
        u'SrsFrequency',
        u'SRSPosResourceID',
        u'SRSResource',
        u'SRSResource-ExtIEs',
        u'SRSResourceID',
        u'SRSResource-List',
        u'SRSResourceSet-List',
        u'SRSResourceID-List',
        u'SRSResourceSet',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceSetID',
        u'SRSResourceTrigger',
        u'SRSResourceTrigger-ExtIEs',
        u'SSBInfo',
        u'SSBInfo-ExtIEs',
        u'SSBInfoItem',
        u'SSBInfoItem-ExtIEs',
        u'SSB',
        u'SSB-ExtIEs',
        u'SSBBurstPosition',
        u'SSBBurstPosition-ExtIEs',
        u'SSB-Index',
        u'SSID',
        u'SystemFrameNumber',
        u'SystemInformation',
        u'SystemInformation-ExtIEs',
        u'TAC',
        u'TDD-Config-EUTRA-Item',
        u'TDD-Config-EUTRA-Item-Item-ExtIEs',
        u'TF-Configuration',
        u'TF-Configuration-ExtIEs',
        u'TimeStamp',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex',
        u'TimeStampSlotIndex-ExtIEs',
        u'TP-ID-EUTRA',
        u'TP-Type-EUTRA',
        u'TransmissionComb',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos',
        u'TransmissionCombPos-ExtIEs',
        u'TRPMeasurementQuantities',
        u'TRPMeasurementQuantitiesList-Item',
        u'TRPMeasurementQuantitiesList-Item-ExtIEs',
        u'TRPMeasurementQuantities-Item',
        u'TrpMeasurementResult',
        u'TrpMeasurementResultItem',
        u'TrpMeasurementResultItem-ExtIEs',
        u'TrpMeasuredResultsValue',
        u'TrpMeasuredResultsValue-ExtIEs',
        u'TrpMeasurementQuality',
        u'TrpMeasurementQuality-ExtIEs',
        u'TrpMeasurementTimingQuality',
        u'TrpMeasurementTimingQuality-ExtIEs',
        u'TrpMeasurementAngleQuality',
        u'TrpMeasurementAngleQuality-ExtIEs',
        u'TRP-MeasurementRequestList',
        u'TRP-MeasurementRequestItem',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRP-MeasurementResponseList',
        u'TRP-MeasurementResponseItem',
        u'TRP-MeasurementResponseItem-ExtIEs',
        u'TRPInformationListTRPResp',
        u'TRPInformationTRPResp-ExtIEs',
        u'TRPInformation',
        u'TRPInformation-ExtIEs',
        u'TRPInformationTypeResponseList',
        u'TRPInformationTypeResponseItem',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPInformationTypeListTRPReq',
        u'TRPInformationTypeItemTRPReq',
        u'TRPInformationTypeItem',
        u'TRPList',
        u'TRPItem',
        u'TRPItem-ExtIEs',
        u'TRP-ID',
        u'TRPPositionDefinitionType',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType',
        u'TRPReferencePointType-ExtIEs',
        u'TRPType',
        u'TypeOfError',
        u'UARFCN',
        u'UE-Measurement-ID',
        u'UTRA-EcN0',
        u'UTRA-RSCP',
        u'UL-AoA',
        u'UL-AoA-ExtIEs',
        u'UL-RTOAMeasurement',
        u'UL-RTOAMeasurement-ExtIEs',
        u'ULRTOAMeas',
        u'ULRTOAMeas-ExtIEs',
        u'UL-SRS-RSRP',
        u'UplinkChannelBW-PerSCS-List',
        u'ValueRSRP-EUTRA',
        u'ValueRSRQ-EUTRA',
        u'ValueRSRP-NR',
        u'ValueRSRQ-NR',
        u'WLANMeasurementQuantities',
        u'WLANMeasurementQuantities-ItemIEs',
        u'WLANMeasurementQuantities-Item',
        u'WLANMeasurementQuantitiesValue-ExtIEs',
        u'WLANMeasurementQuantitiesValue',
        u'WLANMeasurementResult',
        u'WLANMeasurementResult-Item',
        u'WLANMeasurementResult-Item-ExtIEs',
        u'WLAN-RSSI',
        u'WLANBand',
        u'WLANChannelList',
        u'WLANChannel',
        u'WLANCountryCode',
        u'WLANOperatingClass',
        ]
    _type_ = [
        u'AbortTransmission',
        u'ActiveULBWP',
        u'AdditionalPathList',
        u'AdditionalPathListItem',
        u'AperiodicSRSResourceTriggerList',
        u'AperiodicSRSResourceTrigger',
        u'Assistance-Information',
        u'AssistanceInformationFailureList',
        u'AssistanceInformationMetaData',
        u'BandwidthSRS',
        u'BCCH',
        u'Broadcast',
        u'BroadcastPeriodicity',
        u'PositioningBroadcastCells',
        u'BSSID',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'Cell-Portion-ID',
        u'CGI-EUTRA',
        u'CGI-NR',
        u'CPLength-EUTRA',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'DL-Bandwidth-EUTRA',
        u'DL-PRS',
        u'DL-PRSMutingPattern',
        u'DLPRSResourceCoordinates',
        u'DLPRSResourceSetARP',
        u'DL-PRSResourceSetARPLocation',
        u'DLPRSResourceARP',
        u'DL-PRSResourceARPLocation',
        u'E-CID-MeasurementResult',
        u'EUTRACellIdentifier',
        u'EARFCN',
        u'GeographicalCoordinates',
        u'GNB-RxTxTimeDiff',
        u'GNBRxTxTimeDiffMeas',
        u'HESSID',
        u'LCS-to-GCS-TranslationAoA',
        u'LCS-to-GCS-TranslationItem',
        u'LocationUncertainty',
        u'Measurement-ID',
        u'MeasurementBeamInfoRequest',
        u'MeasurementBeamInfo',
        u'MeasurementPeriodicity',
        u'MeasurementPeriodicityExtended',
        u'MeasurementQuantities',
        u'MeasurementQuantities-Item',
        u'MeasurementQuantitiesValue',
        u'MeasuredResults',
        u'MeasuredResultsValue',
        u'NarrowBandIndex',
        u'NG-RANAccessPointPosition',
        u'NGRANHighAccuracyAccessPointPosition',
        u'NG-RAN-CGI',
        u'NG-RANCell',
        u'NR-ARFCN',
        u'NRCellIdentifier',
        u'NR-PCI',
        u'NR-PRS-Beam-Information',
        u'NR-PRS-Beam-InformationItem',
        u'NumberOfAntennaPorts-EUTRA',
        u'NumberOfDlFrames-EUTRA',
        u'NumberOfDlFrames-Extended-EUTRA',
        u'NumberOfFrequencyHoppingBands',
        u'NZP-CSI-RS-ResourceID',
        u'OTDOACells',
        u'OTDOACell-Information',
        u'OTDOACell-Information-Item',
        u'OTDOA-Information-Item',
        u'OtherRATMeasurementQuantities',
        u'OtherRATMeasurementQuantities-Item',
        u'OtherRATMeasurementQuantitiesValue',
        u'OtherRATMeasurementResult',
        u'OtherRATMeasuredResultsValue',
        u'Outcome',
        u'PathlossReferenceInformation',
        u'PathlossReferenceSignal',
        u'PCI-EUTRA',
        u'PhysCellIDGERAN',
        u'PhysCellIDUTRA-FDD',
        u'PhysCellIDUTRA-TDD',
        u'PLMN-Identity',
        u'PeriodicityList',
        u'PeriodicityItem',
        u'PosSIBs',
        u'PosSIB-Segments',
        u'PosSIB-Type',
        u'PosSRSResource-List',
        u'PosSRSResource-Item',
        u'PosSRSResourceSet-List',
        u'PosSRSResourceID-List',
        u'PosSRSResourceSet-Item',
        u'PosResourceSetType',
        u'PosResourceSetTypePeriodic',
        u'PosResourceSetTypeSemi-persistent',
        u'PosResourceSetTypeAperiodic',
        u'PRS-Bandwidth-EUTRA',
        u'PRSAngleItem',
        u'PRSInformationPos',
        u'PRSConfiguration',
        u'PRS-ConfigurationIndex-EUTRA',
        u'PRS-ID-EUTRA',
        u'PRSMutingConfiguration-EUTRA',
        u'PRSOccasionGroup-EUTRA',
        u'PRSFrequencyHoppingConfiguration-EUTRA',
        u'PRSMuting',
        u'PRSMutingOption1',
        u'PRSMutingOption2',
        u'PRSResource-List',
        u'PRSResource-Item',
        u'PRSResource-QCLInfo',
        u'PRSResource-QCLSourceSSB',
        u'PRSResource-QCLSourcePRS',
        u'PRSResourceSet-List',
        u'PRSResourceSet-Item',
        u'PRS-Resource-ID',
        u'PRS-Resource-Set-ID',
        u'PRS-ID',
        u'ReferenceSignal',
        u'ReferencePoint',
        u'CoordinateID',
        u'RelativeGeodeticLocation',
        u'RelativeCartesianLocation',
        u'RelativePathDelay',
        u'ReportCharacteristics',
        u'RequestedSRSTransmissionCharacteristics',
        u'SRSResourceSet-Item',
        u'ResourceSetType',
        u'ResourceSetTypePeriodic',
        u'ResourceSetTypeSemi-persistent',
        u'ResourceSetTypeAperiodic',
        u'ResourceType',
        u'ResourceTypePeriodic',
        u'ResourceTypeSemi-persistent',
        u'ResourceTypeAperiodic',
        u'ResourceTypePos',
        u'ResourceTypePeriodicPos',
        u'ResourceTypeSemi-persistentPos',
        u'ResourceTypeAperiodicPos',
        u'ResultCSI-RSRP',
        u'ResultCSI-RSRP-Item',
        u'ResultCSI-RSRP-PerCSI-RS',
        u'ResultCSI-RSRP-PerCSI-RS-Item',
        u'ResultCSI-RSRQ',
        u'ResultCSI-RSRQ-Item',
        u'ResultCSI-RSRQ-PerCSI-RS',
        u'ResultCSI-RSRQ-PerCSI-RS-Item',
        u'ResultEUTRA',
        u'ResultEUTRA-Item',
        u'ResultRSRP-EUTRA',
        u'ResultRSRP-EUTRA-Item',
        u'ResultRSRQ-EUTRA',
        u'ResultRSRQ-EUTRA-Item',
        u'ResultSS-RSRP',
        u'ResultSS-RSRP-Item',
        u'ResultSS-RSRP-PerSSB',
        u'ResultSS-RSRP-PerSSB-Item',
        u'ResultSS-RSRQ',
        u'ResultSS-RSRQ-Item',
        u'ResultSS-RSRQ-PerSSB',
        u'ResultSS-RSRQ-PerSSB-Item',
        u'ResultGERAN',
        u'ResultGERAN-Item',
        u'ResultNR',
        u'ResultNR-Item',
        u'ResultUTRAN',
        u'ResultUTRAN-Item',
        u'RSSI',
        u'SCS-SpecificCarrier',
        u'Search-window-information',
        u'RelativeTime1900',
        u'SFNInitialisationTime-EUTRA',
        u'SlotNumber',
        u'SpatialDirectionInformation',
        u'SpatialRelationInfo',
        u'SpatialRelationforResourceID',
        u'SpatialRelationforResourceIDItem',
        u'SpatialRelationPerSRSResource',
        u'SpatialRelationPerSRSResource-List',
        u'SpatialRelationPerSRSResourceItem',
        u'SpatialRelationPos',
        u'SRSConfig',
        u'SRSCarrier-List',
        u'SRSCarrier-List-Item',
        u'SRSConfiguration',
        u'SrsFrequency',
        u'SRSPosResourceID',
        u'SRSResource',
        u'SRSResourceID',
        u'SRSResource-List',
        u'SRSResourceSet-List',
        u'SRSResourceID-List',
        u'SRSResourceSet',
        u'SRSResourceSetID',
        u'SRSResourceTrigger',
        u'SSBInfo',
        u'SSBInfoItem',
        u'SSB',
        u'SSBBurstPosition',
        u'SSB-Index',
        u'SSID',
        u'SystemFrameNumber',
        u'SystemInformation',
        u'TAC',
        u'TDD-Config-EUTRA-Item',
        u'TF-Configuration',
        u'TimeStamp',
        u'TimeStampSlotIndex',
        u'TP-ID-EUTRA',
        u'TP-Type-EUTRA',
        u'TransmissionComb',
        u'TransmissionCombPos',
        u'TRPMeasurementQuantities',
        u'TRPMeasurementQuantitiesList-Item',
        u'TRPMeasurementQuantities-Item',
        u'TrpMeasurementResult',
        u'TrpMeasurementResultItem',
        u'TrpMeasuredResultsValue',
        u'TrpMeasurementQuality',
        u'TrpMeasurementTimingQuality',
        u'TrpMeasurementAngleQuality',
        u'TRP-MeasurementRequestList',
        u'TRP-MeasurementRequestItem',
        u'TRP-MeasurementResponseList',
        u'TRP-MeasurementResponseItem',
        u'TRPInformationListTRPResp',
        u'TRPInformation',
        u'TRPInformationTypeResponseList',
        u'TRPInformationTypeResponseItem',
        u'TRPInformationTypeListTRPReq',
        u'TRPInformationTypeItem',
        u'TRPList',
        u'TRPItem',
        u'TRP-ID',
        u'TRPPositionDefinitionType',
        u'TRPPositionDirect',
        u'TRPPositionDirectAccuracy',
        u'TRPPositionReferenced',
        u'TRPReferencePointType',
        u'TRPType',
        u'TypeOfError',
        u'UARFCN',
        u'UE-Measurement-ID',
        u'UTRA-EcN0',
        u'UTRA-RSCP',
        u'UL-AoA',
        u'UL-RTOAMeasurement',
        u'ULRTOAMeas',
        u'UL-SRS-RSRP',
        u'UplinkChannelBW-PerSCS-List',
        u'ValueRSRP-EUTRA',
        u'ValueRSRQ-EUTRA',
        u'ValueRSRP-NR',
        u'ValueRSRQ-NR',
        u'WLANMeasurementQuantities',
        u'WLANMeasurementQuantities-Item',
        u'WLANMeasurementQuantitiesValue',
        u'WLANMeasurementResult',
        u'WLANMeasurementResult-Item',
        u'WLAN-RSSI',
        u'WLANBand',
        u'WLANChannelList',
        u'WLANChannel',
        u'WLANCountryCode',
        u'WLANOperatingClass',
        ]
    _set_ = [
        u'AbortTransmission-ExtIEs',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalPathListItem-ExtIEs',
        u'Assistance-Information-ExtIEs',
        u'AssistanceInformationFailureList-ExtIEs',
        u'AssistanceInformationMetaData-ExtIEs',
        u'BandwidthSRS-ExtIEs',
        u'Cause-ExtensionIE',
        u'CGI-EUTRA-ExtIEs',
        u'CGI-NR-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'E-CID-MeasurementResult-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCS-to-GCS-TranslationItem-ExtIEs',
        u'LocationUncertainty-ExtIEs',
        u'MeasurementBeamInfo-ExtIEs',
        u'MeasurementQuantities-ItemIEs',
        u'MeasurementQuantitiesValue-ExtIEs',
        u'MeasuredResultsValue-ExtensionIE',
        u'NG-RANAccessPointPosition-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NG-RAN-CGI-ExtIEs',
        u'NG-RANCell-ExtensionIE',
        u'NR-PRS-Beam-Information-IEs',
        u'NR-PRS-Beam-InformationItem-ExtIEs',
        u'OTDOACells-ExtIEs',
        u'OTDOACell-Information-Item-ExtensionIE',
        u'OtherRATMeasurementQuantities-ItemIEs',
        u'OtherRATMeasurementQuantitiesValue-ExtIEs',
        u'OtherRATMeasuredResultsValue-ExtensionIE',
        u'PathlossReferenceInformation-ExtIEs',
        u'PathlossReferenceSignal-ExtensionIE',
        u'PosSIBs-ExtIEs',
        u'PosSIB-Segments-ExtIEs',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePeriodic-ExtIEs',
        u'PosResourceSetTypeSemi-persistent-ExtIEs',
        u'PosResourceSetTypeAperiodic-ExtIEs',
        u'PRSAngleItem-ExtIEs',
        u'PRSInformationPos-ExtIEs',
        u'PRSConfiguration-ExtIEs',
        u'PRSMutingConfiguration-EUTRA-ExtensionIE',
        u'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2-ExtIEs',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRSResourceSet-Item-ExtIEs',
        u'ReferenceSignal-ExtensionIE',
        u'ReferencePoint-ExtIEs',
        u'RelativeGeodeticLocation-ExtIEs',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativePathDelay-ExtIEs',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'SRSResourceSet-Item-ExtIEs',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'ResultCSI-RSRP-Item-ExtIEs',
        u'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        u'ResultCSI-RSRQ-Item-ExtIEs',
        u'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        u'ResultEUTRA-Item-ExtIEs',
        u'ResultRSRP-EUTRA-Item-ExtIEs',
        u'ResultRSRQ-EUTRA-Item-ExtIEs',
        u'ResultSS-RSRP-Item-ExtIEs',
        u'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        u'ResultSS-RSRQ-Item-ExtIEs',
        u'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        u'ResultGERAN-Item-ExtIEs',
        u'ResultNR-Item-ExtIEs',
        u'ResultUTRAN-Item-ExtIEs',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information-ExtIEs',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialInformationPos-ExtIEs',
        u'SRSConfig-ExtIEs',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfiguration-ExtIEs',
        u'SRSResource-ExtIEs',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceTrigger-ExtIEs',
        u'SSBInfo-ExtIEs',
        u'SSBInfoItem-ExtIEs',
        u'SSB-ExtIEs',
        u'SSBBurstPosition-ExtIEs',
        u'SystemInformation-ExtIEs',
        u'TDD-Config-EUTRA-Item-Item-ExtIEs',
        u'TF-Configuration-ExtIEs',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex-ExtIEs',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos-ExtIEs',
        u'TRPMeasurementQuantitiesList-Item-ExtIEs',
        u'TrpMeasurementResultItem-ExtIEs',
        u'TrpMeasuredResultsValue-ExtIEs',
        u'TrpMeasurementQuality-ExtIEs',
        u'TrpMeasurementTimingQuality-ExtIEs',
        u'TrpMeasurementAngleQuality-ExtIEs',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRP-MeasurementResponseItem-ExtIEs',
        u'TRPInformationTRPResp-ExtIEs',
        u'TRPInformation-ExtIEs',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPInformationTypeItemTRPReq',
        u'TRPItem-ExtIEs',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType-ExtIEs',
        u'UL-AoA-ExtIEs',
        u'UL-RTOAMeasurement-ExtIEs',
        u'ULRTOAMeas-ExtIEs',
        u'WLANMeasurementQuantities-ItemIEs',
        u'WLANMeasurementQuantitiesValue-ExtIEs',
        u'WLANMeasurementResult-Item-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'AbortTransmission-ExtIEs',
        u'ActiveULBWP-ExtIEs',
        u'AdditionalPathListItem-ExtIEs',
        u'Assistance-Information-ExtIEs',
        u'AssistanceInformationFailureList-ExtIEs',
        u'AssistanceInformationMetaData-ExtIEs',
        u'BandwidthSRS-ExtIEs',
        u'Cause-ExtensionIE',
        u'CGI-EUTRA-ExtIEs',
        u'CGI-NR-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'DL-PRS-ExtIEs',
        u'DL-PRSMutingPattern-ExtIEs',
        u'DLPRSResourceCoordinates-ExtIEs',
        u'DLPRSResourceSetARP-ExtIEs',
        u'DL-PRSResourceSetARPLocation-ExtIEs',
        u'DLPRSResourceARP-ExtIEs',
        u'DL-PRSResourceARPLocation-ExtIEs',
        u'E-CID-MeasurementResult-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GNB-RxTxTimeDiff-ExtIEs',
        u'GNBRxTxTimeDiffMeas-ExtIEs',
        u'LCS-to-GCS-TranslationAoA-ExtIEs',
        u'LCS-to-GCS-TranslationItem-ExtIEs',
        u'LocationUncertainty-ExtIEs',
        u'MeasurementBeamInfo-ExtIEs',
        u'MeasurementQuantities-ItemIEs',
        u'MeasurementQuantitiesValue-ExtIEs',
        u'MeasuredResultsValue-ExtensionIE',
        u'NG-RANAccessPointPosition-ExtIEs',
        u'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        u'NG-RAN-CGI-ExtIEs',
        u'NG-RANCell-ExtensionIE',
        u'NR-PRS-Beam-Information-IEs',
        u'NR-PRS-Beam-InformationItem-ExtIEs',
        u'OTDOACells-ExtIEs',
        u'OTDOACell-Information-Item-ExtensionIE',
        u'OtherRATMeasurementQuantities-ItemIEs',
        u'OtherRATMeasurementQuantitiesValue-ExtIEs',
        u'OtherRATMeasuredResultsValue-ExtensionIE',
        u'PathlossReferenceInformation-ExtIEs',
        u'PathlossReferenceSignal-ExtensionIE',
        u'PosSIBs-ExtIEs',
        u'PosSIB-Segments-ExtIEs',
        u'PosSRSResource-Item-ExtIEs',
        u'PosSRSResourceSet-Item-ExtIEs',
        u'PosResourceSetType-ExtIEs',
        u'PosResourceSetTypePeriodic-ExtIEs',
        u'PosResourceSetTypeSemi-persistent-ExtIEs',
        u'PosResourceSetTypeAperiodic-ExtIEs',
        u'PRSAngleItem-ExtIEs',
        u'PRSInformationPos-ExtIEs',
        u'PRSConfiguration-ExtIEs',
        u'PRSMutingConfiguration-EUTRA-ExtensionIE',
        u'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        u'PRSMuting-ExtIEs',
        u'PRSMutingOption1-ExtIEs',
        u'PRSMutingOption2-ExtIEs',
        u'PRSResource-Item-ExtIEs',
        u'PRSResource-QCLInfo-ExtIEs',
        u'PRSResource-QCLSourceSSB-ExtIEs',
        u'PRSResource-QCLSourcePRS-ExtIEs',
        u'PRSResourceSet-Item-ExtIEs',
        u'ReferenceSignal-ExtensionIE',
        u'ReferencePoint-ExtIEs',
        u'RelativeGeodeticLocation-ExtIEs',
        u'RelativeCartesianLocation-ExtIEs',
        u'RelativePathDelay-ExtIEs',
        u'RequestedSRSTransmissionCharacteristics-ExtIEs',
        u'SRSResourceSet-Item-ExtIEs',
        u'ResourceSetType-ExtIEs',
        u'ResourceSetTypePeriodic-ExtIEs',
        u'ResourceSetTypeSemi-persistent-ExtIEs',
        u'ResourceSetTypeAperiodic-ExtIEs',
        u'ResourceType-ExtIEs',
        u'ResourceTypePeriodic-ExtIEs',
        u'ResourceTypeSemi-persistent-ExtIEs',
        u'ResourceTypeAperiodic-ExtIEs',
        u'ResourceTypePos-ExtIEs',
        u'ResourceTypePeriodicPos-ExtIEs',
        u'ResourceTypeSemi-persistentPos-ExtIEs',
        u'ResourceTypeAperiodicPos-ExtIEs',
        u'ResultCSI-RSRP-Item-ExtIEs',
        u'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        u'ResultCSI-RSRQ-Item-ExtIEs',
        u'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        u'ResultEUTRA-Item-ExtIEs',
        u'ResultRSRP-EUTRA-Item-ExtIEs',
        u'ResultRSRQ-EUTRA-Item-ExtIEs',
        u'ResultSS-RSRP-Item-ExtIEs',
        u'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        u'ResultSS-RSRQ-Item-ExtIEs',
        u'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        u'ResultGERAN-Item-ExtIEs',
        u'ResultNR-Item-ExtIEs',
        u'ResultUTRAN-Item-ExtIEs',
        u'SCS-SpecificCarrier-ExtIEs',
        u'Search-window-information-ExtIEs',
        u'SpatialDirectionInformation-ExtIEs',
        u'SpatialRelationInfo-ExtIEs',
        u'SpatialRelationforResourceIDItem-ExtIEs',
        u'SpatialRelationPerSRSResource-ExtIEs',
        u'SpatialRelationPerSRSResourceItem-ExtIEs',
        u'SpatialInformationPos-ExtIEs',
        u'SRSConfig-ExtIEs',
        u'SRSCarrier-List-Item-ExtIEs',
        u'SRSConfiguration-ExtIEs',
        u'SRSResource-ExtIEs',
        u'SRSResourceSet-ExtIEs',
        u'SRSResourceTrigger-ExtIEs',
        u'SSBInfo-ExtIEs',
        u'SSBInfoItem-ExtIEs',
        u'SSB-ExtIEs',
        u'SSBBurstPosition-ExtIEs',
        u'SystemInformation-ExtIEs',
        u'TDD-Config-EUTRA-Item-Item-ExtIEs',
        u'TF-Configuration-ExtIEs',
        u'TimeStamp-ExtIEs',
        u'TimeStampSlotIndex-ExtIEs',
        u'TransmissionComb-ExtIEs',
        u'TransmissionCombPos-ExtIEs',
        u'TRPMeasurementQuantitiesList-Item-ExtIEs',
        u'TrpMeasurementResultItem-ExtIEs',
        u'TrpMeasuredResultsValue-ExtIEs',
        u'TrpMeasurementQuality-ExtIEs',
        u'TrpMeasurementTimingQuality-ExtIEs',
        u'TrpMeasurementAngleQuality-ExtIEs',
        u'TRP-MeasurementRequestItem-ExtIEs',
        u'TRP-MeasurementResponseItem-ExtIEs',
        u'TRPInformationTRPResp-ExtIEs',
        u'TRPInformation-ExtIEs',
        u'TRPInformationTypeResponseItem-ExtIEs',
        u'TRPInformationTypeItemTRPReq',
        u'TRPItem-ExtIEs',
        u'TRPPositionDefinitionType-ExtIEs',
        u'TRPPositionDirect-ExtIEs',
        u'TRPPositionDirectAccuracy-ExtIEs',
        u'TRPPositionReferenced-ExtIEs',
        u'TRPReferencePointType-ExtIEs',
        u'UL-AoA-ExtIEs',
        u'UL-RTOAMeasurement-ExtIEs',
        u'ULRTOAMeas-ExtIEs',
        u'WLANMeasurementQuantities-ItemIEs',
        u'WLANMeasurementQuantitiesValue-ExtIEs',
        u'WLANMeasurementResult-Item-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AbortTransmission >-----#
    AbortTransmission = CHOICE(name=u'AbortTransmission', mode=MODE_TYPE)
    _AbortTransmission_deactivateSRSResourceSetID = INT(name=u'deactivateSRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSetID')))
    _AbortTransmission_releaseALL = NULL(name=u'releaseALL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AbortTransmission_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __AbortTransmission_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___AbortTransmission_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_id._const_tab = ___AbortTransmission_choice_extension_id_tab
    __AbortTransmission_choice_extension_id._const_tab_at = None
    __AbortTransmission_choice_extension_id._const_tab_id = u'id'
    __AbortTransmission_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___AbortTransmission_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_criticality._const_tab = ___AbortTransmission_choice_extension_criticality_tab
    __AbortTransmission_choice_extension_criticality._const_tab_at = ('..', u'id')
    __AbortTransmission_choice_extension_criticality._const_tab_id = u'criticality'
    __AbortTransmission_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___AbortTransmission_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_value._const_tab = ___AbortTransmission_choice_extension_value_tab
    __AbortTransmission_choice_extension_value._const_tab_at = ('..', u'id')
    __AbortTransmission_choice_extension_value._const_tab_id = u'Value'
    _AbortTransmission_choice_extension._cont = ASN1Dict([
        (u'id', __AbortTransmission_choice_extension_id),
        (u'criticality', __AbortTransmission_choice_extension_criticality),
        (u'value', __AbortTransmission_choice_extension_value),
        ])
    _AbortTransmission_choice_extension._ext = None
    AbortTransmission._cont = ASN1Dict([
        (u'deactivateSRSResourceSetID', _AbortTransmission_deactivateSRSResourceSetID),
        (u'releaseALL', _AbortTransmission_releaseALL),
        (u'choice-extension', _AbortTransmission_choice_extension),
        ])
    AbortTransmission._ext = None
    
    #-----< AbortTransmission-ExtIEs >-----#
    AbortTransmission_ExtIEs = CLASS(name=u'AbortTransmission-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    AbortTransmission_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActiveULBWP >-----#
    ActiveULBWP = SEQ(name=u'ActiveULBWP', mode=MODE_TYPE)
    _ActiveULBWP_locationAndBandwidth = INT(name=u'locationAndBandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_locationAndBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37949)], ev=[], er=[])
    _ActiveULBWP_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _ActiveULBWP_subcarrierSpacing._ext = []
    _ActiveULBWP_cyclicPrefix = ENUM(name=u'cyclicPrefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_cyclicPrefix._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    _ActiveULBWP_cyclicPrefix._ext = None
    _ActiveULBWP_txDirectCurrentLocation = INT(name=u'txDirectCurrentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_txDirectCurrentLocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3301)], ev=[], er=[])
    _ActiveULBWP_shift7dot5kHz = ENUM(name=u'shift7dot5kHz', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActiveULBWP_shift7dot5kHz._cont = ASN1Dict([(u'true', 0)])
    _ActiveULBWP_shift7dot5kHz._ext = []
    _ActiveULBWP_sRSConfig = SEQ(name=u'sRSConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfig')))
    _ActiveULBWP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActiveULBWP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ActiveULBWP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ActiveULBWP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__id._const_tab = ____ActiveULBWP_iE_Extensions__item__id_tab
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_at = None
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_id = u'id'
    ___ActiveULBWP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab = ____ActiveULBWP_iE_Extensions__item__criticality_tab
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ActiveULBWP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab = ____ActiveULBWP_iE_Extensions__item__extensionValue_tab
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ActiveULBWP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ActiveULBWP_iE_Extensions__item__id),
        (u'criticality', ___ActiveULBWP_iE_Extensions__item__criticality),
        (u'extensionValue', ___ActiveULBWP_iE_Extensions__item__extensionValue),
        ])
    __ActiveULBWP_iE_Extensions__item_._ext = None
    _ActiveULBWP_iE_Extensions._cont = __ActiveULBWP_iE_Extensions__item_
    _ActiveULBWP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActiveULBWP._cont = ASN1Dict([
        (u'locationAndBandwidth', _ActiveULBWP_locationAndBandwidth),
        (u'subcarrierSpacing', _ActiveULBWP_subcarrierSpacing),
        (u'cyclicPrefix', _ActiveULBWP_cyclicPrefix),
        (u'txDirectCurrentLocation', _ActiveULBWP_txDirectCurrentLocation),
        (u'shift7dot5kHz', _ActiveULBWP_shift7dot5kHz),
        (u'sRSConfig', _ActiveULBWP_sRSConfig),
        (u'iE-Extensions', _ActiveULBWP_iE_Extensions),
        ])
    ActiveULBWP._ext = []
    
    #-----< ActiveULBWP-ExtIEs >-----#
    ActiveULBWP_ExtIEs = CLASS(name=u'ActiveULBWP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ActiveULBWP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPathList >-----#
    AdditionalPathList = SEQ_OF(name=u'AdditionalPathList', mode=MODE_TYPE)
    _AdditionalPathList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathListItem')))
    AdditionalPathList._cont = _AdditionalPathList__item_
    AdditionalPathList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPathListItem >-----#
    AdditionalPathListItem = SEQ(name=u'AdditionalPathListItem', mode=MODE_TYPE)
    _AdditionalPathListItem_relativeTimeOfPath = CHOICE(name=u'relativeTimeOfPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativePathDelay')))
    _AdditionalPathListItem_pathQuality = CHOICE(name=u'pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementQuality')), opt=True)
    _AdditionalPathListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPathListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AdditionalPathListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalPathListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AdditionalPathListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab = ____AdditionalPathListItem_iE_Extensions__item__id_tab
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalPathListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AdditionalPathListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AdditionalPathListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab = ____AdditionalPathListItem_iE_Extensions__item__criticality_tab
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AdditionalPathListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AdditionalPathListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPathListItem_iE_Extensions__item__extensionValue_tab
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalPathListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalPathListItem_iE_Extensions__item__id),
        (u'criticality', ___AdditionalPathListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalPathListItem_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPathListItem_iE_Extensions__item_._ext = None
    _AdditionalPathListItem_iE_Extensions._cont = __AdditionalPathListItem_iE_Extensions__item_
    _AdditionalPathListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPathListItem._cont = ASN1Dict([
        (u'relativeTimeOfPath', _AdditionalPathListItem_relativeTimeOfPath),
        (u'pathQuality', _AdditionalPathListItem_pathQuality),
        (u'iE-Extensions', _AdditionalPathListItem_iE_Extensions),
        ])
    AdditionalPathListItem._ext = []
    
    #-----< AdditionalPathListItem-ExtIEs >-----#
    AdditionalPathListItem_ExtIEs = CLASS(name=u'AdditionalPathListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AdditionalPathListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRSResourceTriggerList >-----#
    AperiodicSRSResourceTriggerList = SEQ_OF(name=u'AperiodicSRSResourceTriggerList', mode=MODE_TYPE)
    _AperiodicSRSResourceTriggerList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AperiodicSRSResourceTrigger')))
    AperiodicSRSResourceTriggerList._cont = _AperiodicSRSResourceTriggerList__item_
    AperiodicSRSResourceTriggerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AperiodicSRSResourceTrigger >-----#
    AperiodicSRSResourceTrigger = INT(name=u'AperiodicSRSResourceTrigger', mode=MODE_TYPE)
    AperiodicSRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Assistance-Information >-----#
    Assistance_Information = SEQ(name=u'Assistance-Information', mode=MODE_TYPE)
    _Assistance_Information_systemInformation = SEQ_OF(name=u'systemInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SystemInformation')))
    _Assistance_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Assistance_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__id._const_tab = ____Assistance_Information_iE_Extensions__item__id_tab
    ___Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___Assistance_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Assistance_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab = ____Assistance_Information_iE_Extensions__item__criticality_tab
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Assistance_Information_iE_Extensions__item__id),
        (u'criticality', ___Assistance_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __Assistance_Information_iE_Extensions__item_._ext = None
    _Assistance_Information_iE_Extensions._cont = __Assistance_Information_iE_Extensions__item_
    _Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Assistance_Information._cont = ASN1Dict([
        (u'systemInformation', _Assistance_Information_systemInformation),
        (u'iE-Extensions', _Assistance_Information_iE_Extensions),
        ])
    Assistance_Information._ext = []
    
    #-----< Assistance-Information-ExtIEs >-----#
    Assistance_Information_ExtIEs = CLASS(name=u'Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationFailureList >-----#
    AssistanceInformationFailureList = SEQ_OF(name=u'AssistanceInformationFailureList', mode=MODE_TYPE)
    _AssistanceInformationFailureList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AssistanceInformationFailureList__item__posSIB_Type = ENUM(name=u'posSIB-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Type')))
    __AssistanceInformationFailureList__item__outcome = ENUM(name=u'outcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Outcome')))
    __AssistanceInformationFailureList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___AssistanceInformationFailureList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab_at = None
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___AssistanceInformationFailureList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____AssistanceInformationFailureList__item__iE_Extensions__item__id),
        (u'criticality', ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue),
        ])
    ___AssistanceInformationFailureList__item__iE_Extensions__item_._ext = None
    __AssistanceInformationFailureList__item__iE_Extensions._cont = ___AssistanceInformationFailureList__item__iE_Extensions__item_
    __AssistanceInformationFailureList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _AssistanceInformationFailureList__item_._cont = ASN1Dict([
        (u'posSIB-Type', __AssistanceInformationFailureList__item__posSIB_Type),
        (u'outcome', __AssistanceInformationFailureList__item__outcome),
        (u'iE-Extensions', __AssistanceInformationFailureList__item__iE_Extensions),
        ])
    _AssistanceInformationFailureList__item_._ext = []
    AssistanceInformationFailureList._cont = _AssistanceInformationFailureList__item_
    AssistanceInformationFailureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AssistanceInformationFailureList-ExtIEs >-----#
    AssistanceInformationFailureList_ExtIEs = CLASS(name=u'AssistanceInformationFailureList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AssistanceInformationFailureList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationMetaData >-----#
    AssistanceInformationMetaData = SEQ(name=u'AssistanceInformationMetaData', mode=MODE_TYPE)
    _AssistanceInformationMetaData_encrypted = ENUM(name=u'encrypted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_encrypted._cont = ASN1Dict([(u'true', 0)])
    _AssistanceInformationMetaData_encrypted._ext = []
    _AssistanceInformationMetaData_gNSSID = ENUM(name=u'gNSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_gNSSID._cont = ASN1Dict([(u'gps', 0), (u'sbas', 1), (u'qzss', 2), (u'galileo', 3), (u'glonass', 4), (u'bds', 5), (u'navic', 6)])
    _AssistanceInformationMetaData_gNSSID._ext = []
    _AssistanceInformationMetaData_sBASID = ENUM(name=u'sBASID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_sBASID._cont = ASN1Dict([(u'waas', 0), (u'egnos', 1), (u'msas', 2), (u'gagan', 3)])
    _AssistanceInformationMetaData_sBASID._ext = []
    _AssistanceInformationMetaData_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceInformationMetaData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AssistanceInformationMetaData_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceInformationMetaData_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__id_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceInformationMetaData_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceInformationMetaData_iE_Extensions__item__id),
        (u'criticality', ___AssistanceInformationMetaData_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue),
        ])
    __AssistanceInformationMetaData_iE_Extensions__item_._ext = None
    _AssistanceInformationMetaData_iE_Extensions._cont = __AssistanceInformationMetaData_iE_Extensions__item_
    _AssistanceInformationMetaData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceInformationMetaData._cont = ASN1Dict([
        (u'encrypted', _AssistanceInformationMetaData_encrypted),
        (u'gNSSID', _AssistanceInformationMetaData_gNSSID),
        (u'sBASID', _AssistanceInformationMetaData_sBASID),
        (u'iE-Extensions', _AssistanceInformationMetaData_iE_Extensions),
        ])
    AssistanceInformationMetaData._ext = []
    
    #-----< AssistanceInformationMetaData-ExtIEs >-----#
    AssistanceInformationMetaData_ExtIEs = CLASS(name=u'AssistanceInformationMetaData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AssistanceInformationMetaData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BandwidthSRS >-----#
    BandwidthSRS = CHOICE(name=u'BandwidthSRS', mode=MODE_TYPE)
    _BandwidthSRS_fR1 = ENUM(name=u'fR1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BandwidthSRS_fR1._cont = ASN1Dict([(u'mHz5', 0), (u'mHz10', 1), (u'mHz20', 2), (u'mHz40', 3), (u'mHz50', 4), (u'mHz80', 5), (u'mHz100', 6)])
    _BandwidthSRS_fR1._ext = []
    _BandwidthSRS_fR2 = ENUM(name=u'fR2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BandwidthSRS_fR2._cont = ASN1Dict([(u'mHz50', 0), (u'mHz100', 1), (u'mHz200', 2), (u'mHz400', 3)])
    _BandwidthSRS_fR2._ext = []
    _BandwidthSRS_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __BandwidthSRS_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___BandwidthSRS_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_id._const_tab = ___BandwidthSRS_choice_extension_id_tab
    __BandwidthSRS_choice_extension_id._const_tab_at = None
    __BandwidthSRS_choice_extension_id._const_tab_id = u'id'
    __BandwidthSRS_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___BandwidthSRS_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_criticality._const_tab = ___BandwidthSRS_choice_extension_criticality_tab
    __BandwidthSRS_choice_extension_criticality._const_tab_at = ('..', u'id')
    __BandwidthSRS_choice_extension_criticality._const_tab_id = u'criticality'
    __BandwidthSRS_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___BandwidthSRS_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_value._const_tab = ___BandwidthSRS_choice_extension_value_tab
    __BandwidthSRS_choice_extension_value._const_tab_at = ('..', u'id')
    __BandwidthSRS_choice_extension_value._const_tab_id = u'Value'
    _BandwidthSRS_choice_extension._cont = ASN1Dict([
        (u'id', __BandwidthSRS_choice_extension_id),
        (u'criticality', __BandwidthSRS_choice_extension_criticality),
        (u'value', __BandwidthSRS_choice_extension_value),
        ])
    _BandwidthSRS_choice_extension._ext = None
    BandwidthSRS._cont = ASN1Dict([
        (u'fR1', _BandwidthSRS_fR1),
        (u'fR2', _BandwidthSRS_fR2),
        (u'choice-extension', _BandwidthSRS_choice_extension),
        ])
    BandwidthSRS._ext = None
    
    #-----< BandwidthSRS-ExtIEs >-----#
    BandwidthSRS_ExtIEs = CLASS(name=u'BandwidthSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    BandwidthSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCCH >-----#
    BCCH = INT(name=u'BCCH', mode=MODE_TYPE)
    BCCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< Broadcast >-----#
    Broadcast = ENUM(name=u'Broadcast', mode=MODE_TYPE)
    Broadcast._cont = ASN1Dict([(u'start', 0), (u'stop', 1)])
    Broadcast._ext = []
    
    #-----< BroadcastPeriodicity >-----#
    BroadcastPeriodicity = ENUM(name=u'BroadcastPeriodicity', mode=MODE_TYPE)
    BroadcastPeriodicity._cont = ASN1Dict([(u'ms80', 0), (u'ms160', 1), (u'ms320', 2), (u'ms640', 3), (u'ms1280', 4), (u'ms2560', 5), (u'ms5120', 6)])
    BroadcastPeriodicity._ext = []
    
    #-----< PositioningBroadcastCells >-----#
    PositioningBroadcastCells = SEQ_OF(name=u'PositioningBroadcastCells', mode=MODE_TYPE)
    _PositioningBroadcastCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NG-RAN-CGI')))
    PositioningBroadcastCells._cont = _PositioningBroadcastCells__item_
    PositioningBroadcastCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< BSSID >-----#
    BSSID = OCT_STR(name=u'BSSID', mode=MODE_TYPE)
    BSSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseRadioNetwork')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseMisc')))
    _Cause_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __Cause_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___Cause_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_id._const_tab = ___Cause_choice_Extension_id_tab
    __Cause_choice_Extension_id._const_tab_at = None
    __Cause_choice_Extension_id._const_tab_id = u'id'
    __Cause_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___Cause_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_criticality._const_tab = ___Cause_choice_Extension_criticality_tab
    __Cause_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __Cause_choice_Extension_criticality._const_tab_id = u'criticality'
    __Cause_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___Cause_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_value._const_tab = ___Cause_choice_Extension_value_tab
    __Cause_choice_Extension_value._const_tab_at = ('..', u'id')
    __Cause_choice_Extension_value._const_tab_id = u'Value'
    _Cause_choice_Extension._cont = ASN1Dict([
        (u'id', __Cause_choice_Extension_id),
        (u'criticality', __Cause_choice_Extension_criticality),
        (u'value', __Cause_choice_Extension_value),
        ])
    _Cause_choice_Extension._ext = None
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        (u'choice-Extension', _Cause_choice_Extension),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtensionIE >-----#
    Cause_ExtensionIE = CLASS(name=u'Cause-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    Cause_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'unspecified', 0)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'unspecified', 5), (u'abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unspecified', 0), (u'requested-item-not-supported', 1), (u'requested-item-temporarily-not-available', 2)])
    CauseRadioNetwork._ext = []
    
    #-----< Cell-Portion-ID >-----#
    Cell_Portion_ID = INT(name=u'Cell-Portion-ID', mode=MODE_TYPE)
    Cell_Portion_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< CGI-EUTRA >-----#
    CGI_EUTRA = SEQ(name=u'CGI-EUTRA', mode=MODE_TYPE)
    _CGI_EUTRA_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _CGI_EUTRA_eUTRAcellIdentifier = BIT_STR(name=u'eUTRAcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EUTRACellIdentifier')))
    _CGI_EUTRA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CGI_EUTRA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____CGI_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab = ____CGI_EUTRA_iE_Extensions__item__id_tab
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab_id = u'id'
    ___CGI_EUTRA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CGI_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab = ____CGI_EUTRA_iE_Extensions__item__criticality_tab
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CGI_EUTRA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CGI_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CGI_EUTRA_iE_Extensions__item__id),
        (u'criticality', ___CGI_EUTRA_iE_Extensions__item__criticality),
        (u'extensionValue', ___CGI_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __CGI_EUTRA_iE_Extensions__item_._ext = None
    _CGI_EUTRA_iE_Extensions._cont = __CGI_EUTRA_iE_Extensions__item_
    _CGI_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI_EUTRA._cont = ASN1Dict([
        (u'pLMN-Identity', _CGI_EUTRA_pLMN_Identity),
        (u'eUTRAcellIdentifier', _CGI_EUTRA_eUTRAcellIdentifier),
        (u'iE-Extensions', _CGI_EUTRA_iE_Extensions),
        ])
    CGI_EUTRA._ext = []
    
    #-----< CGI-EUTRA-ExtIEs >-----#
    CGI_EUTRA_ExtIEs = CLASS(name=u'CGI-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CGI_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI-NR >-----#
    CGI_NR = SEQ(name=u'CGI-NR', mode=MODE_TYPE)
    _CGI_NR_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _CGI_NR_nRcellIdentifier = BIT_STR(name=u'nRcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NRCellIdentifier')))
    _CGI_NR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CGI_NR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____CGI_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__id._const_tab = ____CGI_NR_iE_Extensions__item__id_tab
    ___CGI_NR_iE_Extensions__item__id._const_tab_at = None
    ___CGI_NR_iE_Extensions__item__id._const_tab_id = u'id'
    ___CGI_NR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CGI_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__criticality._const_tab = ____CGI_NR_iE_Extensions__item__criticality_tab
    ___CGI_NR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CGI_NR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CGI_NR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CGI_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab = ____CGI_NR_iE_Extensions__item__extensionValue_tab
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CGI_NR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CGI_NR_iE_Extensions__item__id),
        (u'criticality', ___CGI_NR_iE_Extensions__item__criticality),
        (u'extensionValue', ___CGI_NR_iE_Extensions__item__extensionValue),
        ])
    __CGI_NR_iE_Extensions__item_._ext = None
    _CGI_NR_iE_Extensions._cont = __CGI_NR_iE_Extensions__item_
    _CGI_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI_NR._cont = ASN1Dict([
        (u'pLMN-Identity', _CGI_NR_pLMN_Identity),
        (u'nRcellIdentifier', _CGI_NR_nRcellIdentifier),
        (u'iE-Extensions', _CGI_NR_iE_Extensions),
        ])
    CGI_NR._ext = []
    
    #-----< CGI-NR-ExtIEs >-----#
    CGI_NR_ExtIEs = CLASS(name=u'CGI-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CGI_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPLength-EUTRA >-----#
    CPLength_EUTRA = ENUM(name=u'CPLength-EUTRA', mode=MODE_TYPE)
    CPLength_EUTRA._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    CPLength_EUTRA._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_nrppatransactionID = INT(name=u'nrppatransactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'nrppatransactionID', _CriticalityDiagnostics_nrppatransactionID),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        (u'criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        (u'iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        (u'iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        (u'typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        (u'iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Bandwidth-EUTRA >-----#
    DL_Bandwidth_EUTRA = ENUM(name=u'DL-Bandwidth-EUTRA', mode=MODE_TYPE)
    DL_Bandwidth_EUTRA._cont = ASN1Dict([(u'bw6', 0), (u'bw15', 1), (u'bw25', 2), (u'bw50', 3), (u'bw75', 4), (u'bw100', 5)])
    DL_Bandwidth_EUTRA._ext = []
    
    #-----< DL-PRS >-----#
    DL_PRS = SEQ(name=u'DL-PRS', mode=MODE_TYPE)
    _DL_PRS_prsid = INT(name=u'prsid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRS_prsid._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _DL_PRS_dl_PRSResourceSetID = INT(name=u'dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _DL_PRS_dl_PRSResourceID = INT(name=u'dl-PRSResourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _DL_PRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DL_PRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_PRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__id._const_tab = ____DL_PRS_iE_Extensions__item__id_tab
    ___DL_PRS_iE_Extensions__item__id._const_tab_at = None
    ___DL_PRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_PRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_PRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__criticality._const_tab = ____DL_PRS_iE_Extensions__item__criticality_tab
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_PRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab = ____DL_PRS_iE_Extensions__item__extensionValue_tab
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_PRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_PRS_iE_Extensions__item__id),
        (u'criticality', ___DL_PRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_PRS_iE_Extensions__item__extensionValue),
        ])
    __DL_PRS_iE_Extensions__item_._ext = None
    _DL_PRS_iE_Extensions._cont = __DL_PRS_iE_Extensions__item_
    _DL_PRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PRS._cont = ASN1Dict([
        (u'prsid', _DL_PRS_prsid),
        (u'dl-PRSResourceSetID', _DL_PRS_dl_PRSResourceSetID),
        (u'dl-PRSResourceID', _DL_PRS_dl_PRSResourceID),
        (u'iE-Extensions', _DL_PRS_iE_Extensions),
        ])
    DL_PRS._ext = []
    
    #-----< DL-PRS-ExtIEs >-----#
    DL_PRS_ExtIEs = CLASS(name=u'DL-PRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DL_PRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSMutingPattern >-----#
    DL_PRSMutingPattern = CHOICE(name=u'DL-PRSMutingPattern', mode=MODE_TYPE)
    _DL_PRSMutingPattern_two = BIT_STR(name=u'two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_four = BIT_STR(name=u'four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_six = BIT_STR(name=u'six', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_six._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_eight = BIT_STR(name=u'eight', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_sixteen = BIT_STR(name=u'sixteen', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_thirty_two = BIT_STR(name=u'thirty-two', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSMutingPattern_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___DL_PRSMutingPattern_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_id._const_tab = ___DL_PRSMutingPattern_choice_extension_id_tab
    __DL_PRSMutingPattern_choice_extension_id._const_tab_at = None
    __DL_PRSMutingPattern_choice_extension_id._const_tab_id = u'id'
    __DL_PRSMutingPattern_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab = ___DL_PRSMutingPattern_choice_extension_criticality_tab
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_id = u'criticality'
    __DL_PRSMutingPattern_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSMutingPattern_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_value._const_tab = ___DL_PRSMutingPattern_choice_extension_value_tab
    __DL_PRSMutingPattern_choice_extension_value._const_tab_at = ('..', u'id')
    __DL_PRSMutingPattern_choice_extension_value._const_tab_id = u'Value'
    _DL_PRSMutingPattern_choice_extension._cont = ASN1Dict([
        (u'id', __DL_PRSMutingPattern_choice_extension_id),
        (u'criticality', __DL_PRSMutingPattern_choice_extension_criticality),
        (u'value', __DL_PRSMutingPattern_choice_extension_value),
        ])
    _DL_PRSMutingPattern_choice_extension._ext = None
    DL_PRSMutingPattern._cont = ASN1Dict([
        (u'two', _DL_PRSMutingPattern_two),
        (u'four', _DL_PRSMutingPattern_four),
        (u'six', _DL_PRSMutingPattern_six),
        (u'eight', _DL_PRSMutingPattern_eight),
        (u'sixteen', _DL_PRSMutingPattern_sixteen),
        (u'thirty-two', _DL_PRSMutingPattern_thirty_two),
        (u'choice-extension', _DL_PRSMutingPattern_choice_extension),
        ])
    DL_PRSMutingPattern._ext = None
    
    #-----< DL-PRSMutingPattern-ExtIEs >-----#
    DL_PRSMutingPattern_ExtIEs = CLASS(name=u'DL-PRSMutingPattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSMutingPattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceCoordinates >-----#
    DLPRSResourceCoordinates = SEQ(name=u'DLPRSResourceCoordinates', mode=MODE_TYPE)
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP = SEQ_OF(name=u'listofDL-PRSResourceSetARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceSetARP')))
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._cont = __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _DLPRSResourceCoordinates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceCoordinates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceCoordinates_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceCoordinates_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceCoordinates_iE_Extensions__item_._ext = None
    _DLPRSResourceCoordinates_iE_Extensions._cont = __DLPRSResourceCoordinates_iE_Extensions__item_
    _DLPRSResourceCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceCoordinates._cont = ASN1Dict([
        (u'listofDL-PRSResourceSetARP', _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP),
        (u'iE-Extensions', _DLPRSResourceCoordinates_iE_Extensions),
        ])
    DLPRSResourceCoordinates._ext = []
    
    #-----< DLPRSResourceCoordinates-ExtIEs >-----#
    DLPRSResourceCoordinates_ExtIEs = CLASS(name=u'DLPRSResourceCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceSetARP >-----#
    DLPRSResourceSetARP = SEQ(name=u'DLPRSResourceSetARP', mode=MODE_TYPE)
    _DLPRSResourceSetARP_dl_PRSResourceSetID = INT(name=u'dl-PRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation = CHOICE(name=u'dL-PRSResourceSetARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSResourceSetARPLocation')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP = SEQ_OF(name=u'listofDL-PRSResourceARP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceARP')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._cont = __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _DLPRSResourceSetARP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceSetARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceSetARP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__id_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceSetARP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceSetARP_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceSetARP_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceSetARP_iE_Extensions__item_._ext = None
    _DLPRSResourceSetARP_iE_Extensions._cont = __DLPRSResourceSetARP_iE_Extensions__item_
    _DLPRSResourceSetARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceSetARP._cont = ASN1Dict([
        (u'dl-PRSResourceSetID', _DLPRSResourceSetARP_dl_PRSResourceSetID),
        (u'dL-PRSResourceSetARPLocation', _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation),
        (u'listofDL-PRSResourceARP', _DLPRSResourceSetARP_listofDL_PRSResourceARP),
        (u'iE-Extensions', _DLPRSResourceSetARP_iE_Extensions),
        ])
    DLPRSResourceSetARP._ext = []
    
    #-----< DLPRSResourceSetARP-ExtIEs >-----#
    DLPRSResourceSetARP_ExtIEs = CLASS(name=u'DLPRSResourceSetARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceSetARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceSetARPLocation >-----#
    DL_PRSResourceSetARPLocation = CHOICE(name=u'DL-PRSResourceSetARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceSetARPLocation_relativeGeodeticLocation = SEQ(name=u'relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceSetARPLocation_relativeCartesianLocation = SEQ(name=u'relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceSetARPLocation_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSResourceSetARPLocation_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_id = u'id'
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_id = u'criticality'
    __DL_PRSResourceSetARPLocation_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_at = ('..', u'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_id = u'Value'
    _DL_PRSResourceSetARPLocation_choice_Extension._cont = ASN1Dict([
        (u'id', __DL_PRSResourceSetARPLocation_choice_Extension_id),
        (u'criticality', __DL_PRSResourceSetARPLocation_choice_Extension_criticality),
        (u'value', __DL_PRSResourceSetARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceSetARPLocation_choice_Extension._ext = None
    DL_PRSResourceSetARPLocation._cont = ASN1Dict([
        (u'relativeGeodeticLocation', _DL_PRSResourceSetARPLocation_relativeGeodeticLocation),
        (u'relativeCartesianLocation', _DL_PRSResourceSetARPLocation_relativeCartesianLocation),
        (u'choice-Extension', _DL_PRSResourceSetARPLocation_choice_Extension),
        ])
    DL_PRSResourceSetARPLocation._ext = None
    
    #-----< DL-PRSResourceSetARPLocation-ExtIEs >-----#
    DL_PRSResourceSetARPLocation_ExtIEs = CLASS(name=u'DL-PRSResourceSetARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSResourceSetARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceARP >-----#
    DLPRSResourceARP = SEQ(name=u'DLPRSResourceARP', mode=MODE_TYPE)
    _DLPRSResourceARP_dl_PRSResourceID = INT(name=u'dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceARP_dL_PRSResourceARPLocation = CHOICE(name=u'dL-PRSResourceARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSResourceARPLocation')))
    _DLPRSResourceARP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceARP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceARP_iE_Extensions__item__id_tab
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_id = u'id'
    ___DLPRSResourceARP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DLPRSResourceARP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DLPRSResourceARP_iE_Extensions__item__id),
        (u'criticality', ___DLPRSResourceARP_iE_Extensions__item__criticality),
        (u'extensionValue', ___DLPRSResourceARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceARP_iE_Extensions__item_._ext = None
    _DLPRSResourceARP_iE_Extensions._cont = __DLPRSResourceARP_iE_Extensions__item_
    _DLPRSResourceARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceARP._cont = ASN1Dict([
        (u'dl-PRSResourceID', _DLPRSResourceARP_dl_PRSResourceID),
        (u'dL-PRSResourceARPLocation', _DLPRSResourceARP_dL_PRSResourceARPLocation),
        (u'iE-Extensions', _DLPRSResourceARP_iE_Extensions),
        ])
    DLPRSResourceARP._ext = []
    
    #-----< DLPRSResourceARP-ExtIEs >-----#
    DLPRSResourceARP_ExtIEs = CLASS(name=u'DLPRSResourceARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceARPLocation >-----#
    DL_PRSResourceARPLocation = CHOICE(name=u'DL-PRSResourceARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceARPLocation_relativeGeodeticLocation = SEQ(name=u'relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceARPLocation_relativeCartesianLocation = SEQ(name=u'relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceARPLocation_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSResourceARPLocation_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_id_tab
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_id = u'id'
    __DL_PRSResourceARPLocation_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_id = u'criticality'
    __DL_PRSResourceARPLocation_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_value_tab
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_at = ('..', u'id')
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_id = u'Value'
    _DL_PRSResourceARPLocation_choice_Extension._cont = ASN1Dict([
        (u'id', __DL_PRSResourceARPLocation_choice_Extension_id),
        (u'criticality', __DL_PRSResourceARPLocation_choice_Extension_criticality),
        (u'value', __DL_PRSResourceARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceARPLocation_choice_Extension._ext = None
    DL_PRSResourceARPLocation._cont = ASN1Dict([
        (u'relativeGeodeticLocation', _DL_PRSResourceARPLocation_relativeGeodeticLocation),
        (u'relativeCartesianLocation', _DL_PRSResourceARPLocation_relativeCartesianLocation),
        (u'choice-Extension', _DL_PRSResourceARPLocation_choice_Extension),
        ])
    DL_PRSResourceARPLocation._ext = None
    
    #-----< DL-PRSResourceARPLocation-ExtIEs >-----#
    DL_PRSResourceARPLocation_ExtIEs = CLASS(name=u'DL-PRSResourceARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSResourceARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementResult >-----#
    E_CID_MeasurementResult = SEQ(name=u'E-CID-MeasurementResult', mode=MODE_TYPE)
    _E_CID_MeasurementResult_servingCell_ID = SEQ(name=u'servingCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RAN-CGI')))
    _E_CID_MeasurementResult_servingCellTAC = OCT_STR(name=u'servingCellTAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TAC')))
    _E_CID_MeasurementResult_nG_RANAccessPointPosition = SEQ(name=u'nG-RANAccessPointPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')), opt=True)
    _E_CID_MeasurementResult_measuredResults = SEQ_OF(name=u'measuredResults', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasuredResults')), opt=True)
    _E_CID_MeasurementResult_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementResult_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Extension', _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_CID_MeasurementResult_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_CID_MeasurementResult_iE_Extensions__item__id),
        (u'criticality', ___E_CID_MeasurementResult_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementResult_iE_Extensions__item_._ext = None
    _E_CID_MeasurementResult_iE_Extensions._cont = __E_CID_MeasurementResult_iE_Extensions__item_
    _E_CID_MeasurementResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementResult._cont = ASN1Dict([
        (u'servingCell-ID', _E_CID_MeasurementResult_servingCell_ID),
        (u'servingCellTAC', _E_CID_MeasurementResult_servingCellTAC),
        (u'nG-RANAccessPointPosition', _E_CID_MeasurementResult_nG_RANAccessPointPosition),
        (u'measuredResults', _E_CID_MeasurementResult_measuredResults),
        (u'iE-Extensions', _E_CID_MeasurementResult_iE_Extensions),
        ])
    E_CID_MeasurementResult._ext = []
    
    #-----< E-CID-MeasurementResult-ExtIEs >-----#
    E_CID_MeasurementResult_ExtIEs = CLASS(name=u'E-CID-MeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _E_CID_MeasurementResult_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    E_CID_MeasurementResult_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Extension', _E_CID_MeasurementResult_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EUTRACellIdentifier >-----#
    EUTRACellIdentifier = BIT_STR(name=u'EUTRACellIdentifier', mode=MODE_TYPE)
    EUTRACellIdentifier._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EARFCN >-----#
    EARFCN = INT(name=u'EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=[], er=[])
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_tRPPositionDefinitionType = CHOICE(name=u'tRPPositionDefinitionType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDefinitionType')))
    _GeographicalCoordinates_dLPRSResourceCoordinates = SEQ(name=u'dLPRSResourceCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceCoordinates')), opt=True)
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeographicalCoordinates_iE_Extensions__item__id),
        (u'criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'tRPPositionDefinitionType', _GeographicalCoordinates_tRPPositionDefinitionType),
        (u'dLPRSResourceCoordinates', _GeographicalCoordinates_dLPRSResourceCoordinates),
        (u'iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name=u'GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-RxTxTimeDiff >-----#
    GNB_RxTxTimeDiff = SEQ(name=u'GNB-RxTxTimeDiff', mode=MODE_TYPE)
    _GNB_RxTxTimeDiff_rxTxTimeDiff = CHOICE(name=u'rxTxTimeDiff', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GNBRxTxTimeDiffMeas')))
    _GNB_RxTxTimeDiff_additionalPathList = SEQ_OF(name=u'additionalPathList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathList')), opt=True)
    _GNB_RxTxTimeDiff_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_RxTxTimeDiff_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_at = None
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_RxTxTimeDiff_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_RxTxTimeDiff_iE_Extensions__item__id),
        (u'criticality', ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue),
        ])
    __GNB_RxTxTimeDiff_iE_Extensions__item_._ext = None
    _GNB_RxTxTimeDiff_iE_Extensions._cont = __GNB_RxTxTimeDiff_iE_Extensions__item_
    _GNB_RxTxTimeDiff_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_RxTxTimeDiff._cont = ASN1Dict([
        (u'rxTxTimeDiff', _GNB_RxTxTimeDiff_rxTxTimeDiff),
        (u'additionalPathList', _GNB_RxTxTimeDiff_additionalPathList),
        (u'iE-Extensions', _GNB_RxTxTimeDiff_iE_Extensions),
        ])
    GNB_RxTxTimeDiff._ext = []
    
    #-----< GNB-RxTxTimeDiff-ExtIEs >-----#
    GNB_RxTxTimeDiff_ExtIEs = CLASS(name=u'GNB-RxTxTimeDiff-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    GNB_RxTxTimeDiff_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBRxTxTimeDiffMeas >-----#
    GNBRxTxTimeDiffMeas = CHOICE(name=u'GNBRxTxTimeDiffMeas', mode=MODE_TYPE)
    _GNBRxTxTimeDiffMeas_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __GNBRxTxTimeDiffMeas_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_id_tab
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_at = None
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_id = u'id'
    __GNBRxTxTimeDiffMeas_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_at = ('..', u'id')
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_id = u'criticality'
    __GNBRxTxTimeDiffMeas_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_value_tab
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_at = ('..', u'id')
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_id = u'Value'
    _GNBRxTxTimeDiffMeas_choice_extension._cont = ASN1Dict([
        (u'id', __GNBRxTxTimeDiffMeas_choice_extension_id),
        (u'criticality', __GNBRxTxTimeDiffMeas_choice_extension_criticality),
        (u'value', __GNBRxTxTimeDiffMeas_choice_extension_value),
        ])
    _GNBRxTxTimeDiffMeas_choice_extension._ext = None
    GNBRxTxTimeDiffMeas._cont = ASN1Dict([
        (u'k0', _GNBRxTxTimeDiffMeas_k0),
        (u'k1', _GNBRxTxTimeDiffMeas_k1),
        (u'k2', _GNBRxTxTimeDiffMeas_k2),
        (u'k3', _GNBRxTxTimeDiffMeas_k3),
        (u'k4', _GNBRxTxTimeDiffMeas_k4),
        (u'k5', _GNBRxTxTimeDiffMeas_k5),
        (u'choice-extension', _GNBRxTxTimeDiffMeas_choice_extension),
        ])
    GNBRxTxTimeDiffMeas._ext = None
    
    #-----< GNBRxTxTimeDiffMeas-ExtIEs >-----#
    GNBRxTxTimeDiffMeas_ExtIEs = CLASS(name=u'GNBRxTxTimeDiffMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    GNBRxTxTimeDiffMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HESSID >-----#
    HESSID = OCT_STR(name=u'HESSID', mode=MODE_TYPE)
    HESSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< LCS-to-GCS-TranslationAoA >-----#
    LCS_to_GCS_TranslationAoA = SEQ(name=u'LCS-to-GCS-TranslationAoA', mode=MODE_TYPE)
    _LCS_to_GCS_TranslationAoA_alpha = INT(name=u'alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_beta = INT(name=u'beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_gamma = INT(name=u'gamma', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationAoA_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_TranslationAoA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id._const_tab_id = u'id'
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id),
        (u'criticality', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality),
        (u'extensionValue', ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_TranslationAoA_iE_Extensions__item_._ext = None
    _LCS_to_GCS_TranslationAoA_iE_Extensions._cont = __LCS_to_GCS_TranslationAoA_iE_Extensions__item_
    _LCS_to_GCS_TranslationAoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_TranslationAoA._cont = ASN1Dict([
        (u'alpha', _LCS_to_GCS_TranslationAoA_alpha),
        (u'beta', _LCS_to_GCS_TranslationAoA_beta),
        (u'gamma', _LCS_to_GCS_TranslationAoA_gamma),
        (u'iE-Extensions', _LCS_to_GCS_TranslationAoA_iE_Extensions),
        ])
    LCS_to_GCS_TranslationAoA._ext = []
    
    #-----< LCS-to-GCS-TranslationAoA-ExtIEs >-----#
    LCS_to_GCS_TranslationAoA_ExtIEs = CLASS(name=u'LCS-to-GCS-TranslationAoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LCS_to_GCS_TranslationAoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCS-to-GCS-TranslationItem >-----#
    LCS_to_GCS_TranslationItem = SEQ(name=u'LCS-to-GCS-TranslationItem', mode=MODE_TYPE)
    _LCS_to_GCS_TranslationItem_alpha = INT(name=u'alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_alphaFine = INT(name=u'alphaFine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_alphaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_beta = INT(name=u'beta', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_betaFine = INT(name=u'betaFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_betaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_gamma = INT(name=u'gamma', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_gammaFine = INT(name=u'gammaFine', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_gammaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id),
        (u'criticality', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_._ext = None
    _LCS_to_GCS_TranslationItem_iE_Extensions._cont = __LCS_to_GCS_TranslationItem_iE_Extensions__item_
    _LCS_to_GCS_TranslationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_TranslationItem._cont = ASN1Dict([
        (u'alpha', _LCS_to_GCS_TranslationItem_alpha),
        (u'alphaFine', _LCS_to_GCS_TranslationItem_alphaFine),
        (u'beta', _LCS_to_GCS_TranslationItem_beta),
        (u'betaFine', _LCS_to_GCS_TranslationItem_betaFine),
        (u'gamma', _LCS_to_GCS_TranslationItem_gamma),
        (u'gammaFine', _LCS_to_GCS_TranslationItem_gammaFine),
        (u'iE-Extensions', _LCS_to_GCS_TranslationItem_iE_Extensions),
        ])
    LCS_to_GCS_TranslationItem._ext = []
    
    #-----< LCS-to-GCS-TranslationItem-ExtIEs >-----#
    LCS_to_GCS_TranslationItem_ExtIEs = CLASS(name=u'LCS-to-GCS-TranslationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LCS_to_GCS_TranslationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationUncertainty >-----#
    LocationUncertainty = SEQ(name=u'LocationUncertainty', mode=MODE_TYPE)
    _LocationUncertainty_horizontalUncertainty = INT(name=u'horizontalUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_horizontalConfidence = INT(name=u'horizontalConfidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_verticalUncertainty = INT(name=u'verticalUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_verticalConfidence = INT(name=u'verticalConfidence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LocationUncertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__id._const_tab = ____LocationUncertainty_iE_Extensions__item__id_tab
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___LocationUncertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab = ____LocationUncertainty_iE_Extensions__item__criticality_tab
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LocationUncertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab = ____LocationUncertainty_iE_Extensions__item__extensionValue_tab
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LocationUncertainty_iE_Extensions__item__id),
        (u'criticality', ___LocationUncertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___LocationUncertainty_iE_Extensions__item__extensionValue),
        ])
    __LocationUncertainty_iE_Extensions__item_._ext = None
    _LocationUncertainty_iE_Extensions._cont = __LocationUncertainty_iE_Extensions__item_
    _LocationUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationUncertainty._cont = ASN1Dict([
        (u'horizontalUncertainty', _LocationUncertainty_horizontalUncertainty),
        (u'horizontalConfidence', _LocationUncertainty_horizontalConfidence),
        (u'verticalUncertainty', _LocationUncertainty_verticalUncertainty),
        (u'verticalConfidence', _LocationUncertainty_verticalConfidence),
        (u'iE-Extensions', _LocationUncertainty_iE_Extensions),
        ])
    LocationUncertainty._ext = []
    
    #-----< LocationUncertainty-ExtIEs >-----#
    LocationUncertainty_ExtIEs = CLASS(name=u'LocationUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LocationUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Measurement-ID >-----#
    Measurement_ID = INT(name=u'Measurement-ID', mode=MODE_TYPE)
    Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< MeasurementBeamInfoRequest >-----#
    MeasurementBeamInfoRequest = ENUM(name=u'MeasurementBeamInfoRequest', mode=MODE_TYPE)
    MeasurementBeamInfoRequest._cont = ASN1Dict([(u'true', 0)])
    MeasurementBeamInfoRequest._ext = []
    
    #-----< MeasurementBeamInfo >-----#
    MeasurementBeamInfo = SEQ(name=u'MeasurementBeamInfo', mode=MODE_TYPE)
    _MeasurementBeamInfo_pRS_Resource_ID = INT(name=u'pRS-Resource-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _MeasurementBeamInfo_pRS_Resource_Set_ID = INT(name=u'pRS-Resource-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _MeasurementBeamInfo_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _MeasurementBeamInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementBeamInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___MeasurementBeamInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__id_tab
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementBeamInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementBeamInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementBeamInfo_iE_Extensions__item__id),
        (u'criticality', ___MeasurementBeamInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementBeamInfo_iE_Extensions__item__extensionValue),
        ])
    __MeasurementBeamInfo_iE_Extensions__item_._ext = None
    _MeasurementBeamInfo_iE_Extensions._cont = __MeasurementBeamInfo_iE_Extensions__item_
    _MeasurementBeamInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementBeamInfo._cont = ASN1Dict([
        (u'pRS-Resource-ID', _MeasurementBeamInfo_pRS_Resource_ID),
        (u'pRS-Resource-Set-ID', _MeasurementBeamInfo_pRS_Resource_Set_ID),
        (u'sSB-Index', _MeasurementBeamInfo_sSB_Index),
        (u'iE-Extensions', _MeasurementBeamInfo_iE_Extensions),
        ])
    MeasurementBeamInfo._ext = []
    
    #-----< MeasurementBeamInfo-ExtIEs >-----#
    MeasurementBeamInfo_ExtIEs = CLASS(name=u'MeasurementBeamInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    MeasurementBeamInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementPeriodicity >-----#
    MeasurementPeriodicity = ENUM(name=u'MeasurementPeriodicity', mode=MODE_TYPE)
    MeasurementPeriodicity._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'min1', 8), (u'min6', 9), (u'min12', 10), (u'min30', 11), (u'min60', 12), (u'ms20480', 13), (u'ms40960', 14), (u'extended', 15)])
    MeasurementPeriodicity._ext = [u'ms20480', u'ms40960', u'extended']
    
    #-----< MeasurementPeriodicityExtended >-----#
    MeasurementPeriodicityExtended = ENUM(name=u'MeasurementPeriodicityExtended', mode=MODE_TYPE)
    MeasurementPeriodicityExtended._cont = ASN1Dict([(u'ms160', 0), (u'ms320', 1), (u'ms1280', 2), (u'ms2560', 3), (u'ms61440', 4), (u'ms81920', 5), (u'ms368640', 6), (u'ms737280', 7), (u'ms1843200', 8)])
    MeasurementPeriodicityExtended._ext = []
    
    #-----< MeasurementQuantities >-----#
    MeasurementQuantities = SEQ_OF(name=u'MeasurementQuantities', mode=MODE_TYPE)
    _MeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementQuantities__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___MeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____MeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities-Item')))
    ___MeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', ____MeasurementQuantities__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementQuantities__item__id._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__id._const_tab_at = None
    __MeasurementQuantities__item__id._const_tab_id = u'id'
    __MeasurementQuantities__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __MeasurementQuantities__item__criticality._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__criticality._const_tab_at = ('..', u'id')
    __MeasurementQuantities__item__criticality._const_tab_id = u'criticality'
    __MeasurementQuantities__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __MeasurementQuantities__item__value._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__value._const_tab_at = ('..', u'id')
    __MeasurementQuantities__item__value._const_tab_id = u'Value'
    _MeasurementQuantities__item_._cont = ASN1Dict([
        (u'id', __MeasurementQuantities__item__id),
        (u'criticality', __MeasurementQuantities__item__criticality),
        (u'value', __MeasurementQuantities__item__value),
        ])
    _MeasurementQuantities__item_._ext = None
    MeasurementQuantities._cont = _MeasurementQuantities__item_
    MeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MeasurementQuantities-ItemIEs >-----#
    MeasurementQuantities_ItemIEs = CLASS(name=u'MeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities-Item')))
    MeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', _MeasurementQuantities_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantities-Item >-----#
    MeasurementQuantities_Item = SEQ(name=u'MeasurementQuantities-Item', mode=MODE_TYPE)
    _MeasurementQuantities_Item_measurementQuantitiesValue = ENUM(name=u'measurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantitiesValue')))
    _MeasurementQuantities_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___MeasurementQuantities_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementQuantities_Item_iE_Extensions__item__id),
        (u'criticality', ___MeasurementQuantities_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _MeasurementQuantities_Item_iE_Extensions._cont = __MeasurementQuantities_Item_iE_Extensions__item_
    _MeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementQuantities_Item._cont = ASN1Dict([
        (u'measurementQuantitiesValue', _MeasurementQuantities_Item_measurementQuantitiesValue),
        (u'iE-Extensions', _MeasurementQuantities_Item_iE_Extensions),
        ])
    MeasurementQuantities_Item._ext = []
    
    #-----< MeasurementQuantitiesValue-ExtIEs >-----#
    MeasurementQuantitiesValue_ExtIEs = CLASS(name=u'MeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    MeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementQuantitiesValue >-----#
    MeasurementQuantitiesValue = ENUM(name=u'MeasurementQuantitiesValue', mode=MODE_TYPE)
    MeasurementQuantitiesValue._cont = ASN1Dict([(u'cell-ID', 0), (u'angleOfArrival', 1), (u'timingAdvanceType1', 2), (u'timingAdvanceType2', 3), (u'rSRP', 4), (u'rSRQ', 5), (u'sS-RSRP', 6), (u'sS-RSRQ', 7), (u'cSI-RSRP', 8), (u'cSI-RSRQ', 9), (u'angleOfArrivalNR', 10)])
    MeasurementQuantitiesValue._ext = [u'sS-RSRP', u'sS-RSRQ', u'cSI-RSRP', u'cSI-RSRQ', u'angleOfArrivalNR']
    
    #-----< MeasuredResults >-----#
    MeasuredResults = SEQ_OF(name=u'MeasuredResults', mode=MODE_TYPE)
    _MeasuredResults__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasuredResultsValue')))
    MeasuredResults._cont = _MeasuredResults__item_
    MeasuredResults._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MeasuredResultsValue >-----#
    MeasuredResultsValue = CHOICE(name=u'MeasuredResultsValue', mode=MODE_TYPE)
    _MeasuredResultsValue_valueAngleOfArrival_EUTRA = INT(name=u'valueAngleOfArrival-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueAngleOfArrival_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=719)], ev=None, er=[])
    _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA = INT(name=u'valueTimingAdvanceType1-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA = INT(name=u'valueTimingAdvanceType2-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    _MeasuredResultsValue_resultRSRP_EUTRA = SEQ_OF(name=u'resultRSRP-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRP-EUTRA')))
    _MeasuredResultsValue_resultRSRQ_EUTRA = SEQ_OF(name=u'resultRSRQ-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRQ-EUTRA')))
    _MeasuredResultsValue_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __MeasuredResultsValue_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___MeasuredResultsValue_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    ___MeasuredResultsValue_choice_Extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_Extension_id._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_id._const_tab_at = None
    __MeasuredResultsValue_choice_Extension_id._const_tab_id = u'id'
    __MeasuredResultsValue_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __MeasuredResultsValue_choice_Extension_criticality._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __MeasuredResultsValue_choice_Extension_criticality._const_tab_id = u'criticality'
    __MeasuredResultsValue_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __MeasuredResultsValue_choice_Extension_value._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_value._const_tab_at = ('..', u'id')
    __MeasuredResultsValue_choice_Extension_value._const_tab_id = u'Value'
    _MeasuredResultsValue_choice_Extension._cont = ASN1Dict([
        (u'id', __MeasuredResultsValue_choice_Extension_id),
        (u'criticality', __MeasuredResultsValue_choice_Extension_criticality),
        (u'value', __MeasuredResultsValue_choice_Extension_value),
        ])
    _MeasuredResultsValue_choice_Extension._ext = None
    MeasuredResultsValue._cont = ASN1Dict([
        (u'valueAngleOfArrival-EUTRA', _MeasuredResultsValue_valueAngleOfArrival_EUTRA),
        (u'valueTimingAdvanceType1-EUTRA', _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA),
        (u'valueTimingAdvanceType2-EUTRA', _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA),
        (u'resultRSRP-EUTRA', _MeasuredResultsValue_resultRSRP_EUTRA),
        (u'resultRSRQ-EUTRA', _MeasuredResultsValue_resultRSRQ_EUTRA),
        (u'choice-Extension', _MeasuredResultsValue_choice_Extension),
        ])
    MeasuredResultsValue._ext = None
    
    #-----< MeasuredResultsValue-ExtensionIE >-----#
    MeasuredResultsValue_ExtensionIE = CLASS(name=u'MeasuredResultsValue-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasuredResultsValue_ExtensionIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP')))
    _MeasuredResultsValue_ExtensionIE_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ')))
    _MeasuredResultsValue_ExtensionIE_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP')))
    _MeasuredResultsValue_ExtensionIE_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ')))
    _MeasuredResultsValue_ExtensionIE_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    MeasuredResultsValue_ExtensionIE._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _MeasuredResultsValue_ExtensionIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _MeasuredResultsValue_ExtensionIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _MeasuredResultsValue_ExtensionIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _MeasuredResultsValue_ExtensionIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _MeasuredResultsValue_ExtensionIE_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NarrowBandIndex >-----#
    NarrowBandIndex = INT(name=u'NarrowBandIndex', mode=MODE_TYPE)
    NarrowBandIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< NG-RANAccessPointPosition >-----#
    NG_RANAccessPointPosition = SEQ(name=u'NG-RANAccessPointPosition', mode=MODE_TYPE)
    _NG_RANAccessPointPosition_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _NG_RANAccessPointPosition_latitudeSign._ext = None
    _NG_RANAccessPointPosition_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _NG_RANAccessPointPosition_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NG_RANAccessPointPosition_directionOfAltitude = ENUM(name=u'directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_directionOfAltitude._cont = ASN1Dict([(u'height', 0), (u'depth', 1)])
    _NG_RANAccessPointPosition_directionOfAltitude._ext = None
    _NG_RANAccessPointPosition_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NG_RANAccessPointPosition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_RANAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NG_RANAccessPointPosition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab_id = u'id'
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NG_RANAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NG_RANAccessPointPosition_iE_Extensions__item__id),
        (u'criticality', ___NG_RANAccessPointPosition_iE_Extensions__item__criticality),
        (u'extensionValue', ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NG_RANAccessPointPosition_iE_Extensions__item_._ext = None
    _NG_RANAccessPointPosition_iE_Extensions._cont = __NG_RANAccessPointPosition_iE_Extensions__item_
    _NG_RANAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_RANAccessPointPosition._cont = ASN1Dict([
        (u'latitudeSign', _NG_RANAccessPointPosition_latitudeSign),
        (u'latitude', _NG_RANAccessPointPosition_latitude),
        (u'longitude', _NG_RANAccessPointPosition_longitude),
        (u'directionOfAltitude', _NG_RANAccessPointPosition_directionOfAltitude),
        (u'altitude', _NG_RANAccessPointPosition_altitude),
        (u'uncertaintySemi-major', _NG_RANAccessPointPosition_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _NG_RANAccessPointPosition_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _NG_RANAccessPointPosition_orientationOfMajorAxis),
        (u'uncertaintyAltitude', _NG_RANAccessPointPosition_uncertaintyAltitude),
        (u'confidence', _NG_RANAccessPointPosition_confidence),
        (u'iE-Extensions', _NG_RANAccessPointPosition_iE_Extensions),
        ])
    NG_RANAccessPointPosition._ext = []
    
    #-----< NG-RANAccessPointPosition-ExtIEs >-----#
    NG_RANAccessPointPosition_ExtIEs = CLASS(name=u'NG-RANAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NG_RANAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANHighAccuracyAccessPointPosition >-----#
    NGRANHighAccuracyAccessPointPosition = SEQ(name=u'NGRANHighAccuracyAccessPointPosition', mode=MODE_TYPE)
    _NGRANHighAccuracyAccessPointPosition_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64000, ub=1280000)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence = INT(name=u'horizontalConfidence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence = INT(name=u'verticalConfidence', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_id = u'id'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id),
        (u'criticality', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality),
        (u'extensionValue', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._ext = None
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._cont = __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANHighAccuracyAccessPointPosition._cont = ASN1Dict([
        (u'latitude', _NGRANHighAccuracyAccessPointPosition_latitude),
        (u'longitude', _NGRANHighAccuracyAccessPointPosition_longitude),
        (u'altitude', _NGRANHighAccuracyAccessPointPosition_altitude),
        (u'uncertaintySemi-major', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis),
        (u'horizontalConfidence', _NGRANHighAccuracyAccessPointPosition_horizontalConfidence),
        (u'uncertaintyAltitude', _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude),
        (u'verticalConfidence', _NGRANHighAccuracyAccessPointPosition_verticalConfidence),
        (u'iE-Extensions', _NGRANHighAccuracyAccessPointPosition_iE_Extensions),
        ])
    NGRANHighAccuracyAccessPointPosition._ext = []
    
    #-----< NGRANHighAccuracyAccessPointPosition-ExtIEs >-----#
    NGRANHighAccuracyAccessPointPosition_ExtIEs = CLASS(name=u'NGRANHighAccuracyAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NGRANHighAccuracyAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-CGI >-----#
    NG_RAN_CGI = SEQ(name=u'NG-RAN-CGI', mode=MODE_TYPE)
    _NG_RAN_CGI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _NG_RAN_CGI_nG_RANcell = CHOICE(name=u'nG-RANcell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANCell')))
    _NG_RAN_CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_RAN_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NG_RAN_CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____NG_RAN_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab = ____NG_RAN_CGI_iE_Extensions__item__id_tab
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___NG_RAN_CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NG_RAN_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab = ____NG_RAN_CGI_iE_Extensions__item__criticality_tab
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab = ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NG_RAN_CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NG_RAN_CGI_iE_Extensions__item__id),
        (u'criticality', ___NG_RAN_CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___NG_RAN_CGI_iE_Extensions__item__extensionValue),
        ])
    __NG_RAN_CGI_iE_Extensions__item_._ext = None
    _NG_RAN_CGI_iE_Extensions._cont = __NG_RAN_CGI_iE_Extensions__item_
    _NG_RAN_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_RAN_CGI._cont = ASN1Dict([
        (u'pLMN-Identity', _NG_RAN_CGI_pLMN_Identity),
        (u'nG-RANcell', _NG_RAN_CGI_nG_RANcell),
        (u'iE-Extensions', _NG_RAN_CGI_iE_Extensions),
        ])
    NG_RAN_CGI._ext = []
    
    #-----< NG-RAN-CGI-ExtIEs >-----#
    NG_RAN_CGI_ExtIEs = CLASS(name=u'NG-RAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NG_RAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NG-RANCell >-----#
    NG_RANCell = CHOICE(name=u'NG-RANCell', mode=MODE_TYPE)
    _NG_RANCell_eUTRA_CellID = BIT_STR(name=u'eUTRA-CellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EUTRACellIdentifier')))
    _NG_RANCell_nR_CellID = BIT_STR(name=u'nR-CellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NRCellIdentifier')))
    _NG_RANCell_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __NG_RANCell_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___NG_RANCell_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_id._const_tab = ___NG_RANCell_choice_Extension_id_tab
    __NG_RANCell_choice_Extension_id._const_tab_at = None
    __NG_RANCell_choice_Extension_id._const_tab_id = u'id'
    __NG_RANCell_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___NG_RANCell_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_criticality._const_tab = ___NG_RANCell_choice_Extension_criticality_tab
    __NG_RANCell_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __NG_RANCell_choice_Extension_criticality._const_tab_id = u'criticality'
    __NG_RANCell_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___NG_RANCell_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_value._const_tab = ___NG_RANCell_choice_Extension_value_tab
    __NG_RANCell_choice_Extension_value._const_tab_at = ('..', u'id')
    __NG_RANCell_choice_Extension_value._const_tab_id = u'Value'
    _NG_RANCell_choice_Extension._cont = ASN1Dict([
        (u'id', __NG_RANCell_choice_Extension_id),
        (u'criticality', __NG_RANCell_choice_Extension_criticality),
        (u'value', __NG_RANCell_choice_Extension_value),
        ])
    _NG_RANCell_choice_Extension._ext = None
    NG_RANCell._cont = ASN1Dict([
        (u'eUTRA-CellID', _NG_RANCell_eUTRA_CellID),
        (u'nR-CellID', _NG_RANCell_nR_CellID),
        (u'choice-Extension', _NG_RANCell_choice_Extension),
        ])
    NG_RANCell._ext = None
    
    #-----< NG-RANCell-ExtensionIE >-----#
    NG_RANCell_ExtensionIE = CLASS(name=u'NG-RANCell-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    NG_RANCell_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-ARFCN >-----#
    NR_ARFCN = INT(name=u'NR-ARFCN', mode=MODE_TYPE)
    NR_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< NRCellIdentifier >-----#
    NRCellIdentifier = BIT_STR(name=u'NRCellIdentifier', mode=MODE_TYPE)
    NRCellIdentifier._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-PCI >-----#
    NR_PCI = INT(name=u'NR-PCI', mode=MODE_TYPE)
    NR_PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    
    #-----< NR-PRS-Beam-Information >-----#
    NR_PRS_Beam_Information = SEQ(name=u'NR-PRS-Beam-Information', mode=MODE_TYPE)
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList = SEQ_OF(name=u'nR-PRS-Beam-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NR-PRS-Beam-InformationItem')))
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList._cont = __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList = SEQ_OF(name=u'lCS-to-GCS-TranslationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-TranslationItem')))
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList._cont = __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _NR_PRS_Beam_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRS_Beam_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NR_PRS_Beam_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_PRS_Beam_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_PRS_Beam_Information_iE_Extensions__item__id),
        (u'criticality', ___NR_PRS_Beam_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue),
        ])
    __NR_PRS_Beam_Information_iE_Extensions__item_._ext = None
    _NR_PRS_Beam_Information_iE_Extensions._cont = __NR_PRS_Beam_Information_iE_Extensions__item_
    _NR_PRS_Beam_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRS_Beam_Information._cont = ASN1Dict([
        (u'nR-PRS-Beam-InformationList', _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList),
        (u'lCS-to-GCS-TranslationList', _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList),
        (u'iE-Extensions', _NR_PRS_Beam_Information_iE_Extensions),
        ])
    NR_PRS_Beam_Information._ext = []
    
    #-----< NR-PRS-Beam-Information-IEs >-----#
    NR_PRS_Beam_Information_IEs = CLASS(name=u'NR-PRS-Beam-Information-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NR_PRS_Beam_Information_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRS-Beam-InformationItem >-----#
    NR_PRS_Beam_InformationItem = SEQ(name=u'NR-PRS-Beam-InformationItem', mode=MODE_TYPE)
    _NR_PRS_Beam_InformationItem_pRSresourceSetID = INT(name=u'pRSresourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _NR_PRS_Beam_InformationItem_pRSAngleItem = SEQ_OF(name=u'pRSAngleItem', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NR_PRS_Beam_InformationItem_pRSAngleItem__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSAngleItem')))
    _NR_PRS_Beam_InformationItem_pRSAngleItem._cont = __NR_PRS_Beam_InformationItem_pRSAngleItem__item_
    _NR_PRS_Beam_InformationItem_pRSAngleItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _NR_PRS_Beam_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_._ext = None
    _NR_PRS_Beam_InformationItem_iE_Extensions._cont = __NR_PRS_Beam_InformationItem_iE_Extensions__item_
    _NR_PRS_Beam_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRS_Beam_InformationItem._cont = ASN1Dict([
        (u'pRSresourceSetID', _NR_PRS_Beam_InformationItem_pRSresourceSetID),
        (u'pRSAngleItem', _NR_PRS_Beam_InformationItem_pRSAngleItem),
        (u'iE-Extensions', _NR_PRS_Beam_InformationItem_iE_Extensions),
        ])
    NR_PRS_Beam_InformationItem._ext = []
    
    #-----< NR-PRS-Beam-InformationItem-ExtIEs >-----#
    NR_PRS_Beam_InformationItem_ExtIEs = CLASS(name=u'NR-PRS-Beam-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NR_PRS_Beam_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NumberOfAntennaPorts-EUTRA >-----#
    NumberOfAntennaPorts_EUTRA = ENUM(name=u'NumberOfAntennaPorts-EUTRA', mode=MODE_TYPE)
    NumberOfAntennaPorts_EUTRA._cont = ASN1Dict([(u'n1-or-n2', 0), (u'n4', 1)])
    NumberOfAntennaPorts_EUTRA._ext = []
    
    #-----< NumberOfDlFrames-EUTRA >-----#
    NumberOfDlFrames_EUTRA = ENUM(name=u'NumberOfDlFrames-EUTRA', mode=MODE_TYPE)
    NumberOfDlFrames_EUTRA._cont = ASN1Dict([(u'sf1', 0), (u'sf2', 1), (u'sf4', 2), (u'sf6', 3)])
    NumberOfDlFrames_EUTRA._ext = []
    
    #-----< NumberOfDlFrames-Extended-EUTRA >-----#
    NumberOfDlFrames_Extended_EUTRA = INT(name=u'NumberOfDlFrames-Extended-EUTRA', mode=MODE_TYPE)
    NumberOfDlFrames_Extended_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< NumberOfFrequencyHoppingBands >-----#
    NumberOfFrequencyHoppingBands = ENUM(name=u'NumberOfFrequencyHoppingBands', mode=MODE_TYPE)
    NumberOfFrequencyHoppingBands._cont = ASN1Dict([(u'twobands', 0), (u'fourbands', 1)])
    NumberOfFrequencyHoppingBands._ext = []
    
    #-----< NZP-CSI-RS-ResourceID >-----#
    NZP_CSI_RS_ResourceID = INT(name=u'NZP-CSI-RS-ResourceID', mode=MODE_TYPE)
    NZP_CSI_RS_ResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=191)], ev=None, er=[])
    
    #-----< OTDOACells >-----#
    OTDOACells = SEQ_OF(name=u'OTDOACells', mode=MODE_TYPE)
    _OTDOACells__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __OTDOACells__item__oTDOACellInfo = SEQ_OF(name=u'oTDOACellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACell-Information')))
    __OTDOACells__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___OTDOACells__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____OTDOACells__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____OTDOACells__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__id._const_tab = _____OTDOACells__item__iE_Extensions__item__id_tab
    ____OTDOACells__item__iE_Extensions__item__id._const_tab_at = None
    ____OTDOACells__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____OTDOACells__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____OTDOACells__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab = _____OTDOACells__item__iE_Extensions__item__criticality_tab
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____OTDOACells__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____OTDOACells__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab = _____OTDOACells__item__iE_Extensions__item__extensionValue_tab
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___OTDOACells__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____OTDOACells__item__iE_Extensions__item__id),
        (u'criticality', ____OTDOACells__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____OTDOACells__item__iE_Extensions__item__extensionValue),
        ])
    ___OTDOACells__item__iE_Extensions__item_._ext = None
    __OTDOACells__item__iE_Extensions._cont = ___OTDOACells__item__iE_Extensions__item_
    __OTDOACells__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _OTDOACells__item_._cont = ASN1Dict([
        (u'oTDOACellInfo', __OTDOACells__item__oTDOACellInfo),
        (u'iE-Extensions', __OTDOACells__item__iE_Extensions),
        ])
    _OTDOACells__item_._ext = []
    OTDOACells._cont = _OTDOACells__item_
    OTDOACells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3840)], ev=None, er=[])
    
    #-----< OTDOACells-ExtIEs >-----#
    OTDOACells_ExtIEs = CLASS(name=u'OTDOACells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OTDOACells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOACell-Information >-----#
    OTDOACell_Information = SEQ_OF(name=u'OTDOACell-Information', mode=MODE_TYPE)
    _OTDOACell_Information__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACell-Information-Item')))
    OTDOACell_Information._cont = _OTDOACell_Information__item_
    OTDOACell_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< OTDOACell-Information-Item >-----#
    OTDOACell_Information_Item = CHOICE(name=u'OTDOACell-Information-Item', mode=MODE_TYPE)
    _OTDOACell_Information_Item_pCI_EUTRA = INT(name=u'pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _OTDOACell_Information_Item_cGI_EUTRA = SEQ(name=u'cGI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')))
    _OTDOACell_Information_Item_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TAC')))
    _OTDOACell_Information_Item_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA = ENUM(name=u'pRS-Bandwidth-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Bandwidth-EUTRA')))
    _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA = INT(name=u'pRS-ConfigurationIndex-EUTRA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-ConfigurationIndex-EUTRA')))
    _OTDOACell_Information_Item_cPLength_EUTRA = ENUM(name=u'cPLength-EUTRA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CPLength-EUTRA')))
    _OTDOACell_Information_Item_numberOfDlFrames_EUTRA = ENUM(name=u'numberOfDlFrames-EUTRA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfDlFrames-EUTRA')))
    _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA = ENUM(name=u'numberOfAntennaPorts-EUTRA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfAntennaPorts-EUTRA')))
    _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA = BIT_STR(name=u'sFNInitialisationTime-EUTRA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    _OTDOACell_Information_Item_nG_RANAccessPointPosition = SEQ(name=u'nG-RANAccessPointPosition', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA = CHOICE(name=u'pRSMutingConfiguration-EUTRA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingConfiguration-EUTRA')))
    _OTDOACell_Information_Item_prsid_EUTRA = INT(name=u'prsid-EUTRA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-ID-EUTRA')))
    _OTDOACell_Information_Item_tpid_EUTRA = INT(name=u'tpid-EUTRA', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TP-ID-EUTRA')))
    _OTDOACell_Information_Item_tpType_EUTRA = ENUM(name=u'tpType-EUTRA', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TP-Type-EUTRA')))
    _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA = INT(name=u'numberOfDlFrames-Extended-EUTRA', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfDlFrames-Extended-EUTRA')))
    _OTDOACell_Information_Item_crsCPlength_EUTRA = ENUM(name=u'crsCPlength-EUTRA', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CPLength-EUTRA')))
    _OTDOACell_Information_Item_dL_Bandwidth_EUTRA = ENUM(name=u'dL-Bandwidth-EUTRA', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-Bandwidth-EUTRA')))
    _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA = ENUM(name=u'pRSOccasionGroup-EUTRA', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSOccasionGroup-EUTRA')))
    _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA = SEQ(name=u'pRSFrequencyHoppingConfiguration-EUTRA', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSFrequencyHoppingConfiguration-EUTRA')))
    _OTDOACell_Information_Item_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OTDOACell_Information_Item_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___OTDOACell_Information_Item_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TDD-Config-EUTRA-Item')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    ___OTDOACell_Information_Item_choice_Extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __OTDOACell_Information_Item_choice_Extension_id._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_id._const_tab_at = None
    __OTDOACell_Information_Item_choice_Extension_id._const_tab_id = u'id'
    __OTDOACell_Information_Item_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab_id = u'criticality'
    __OTDOACell_Information_Item_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __OTDOACell_Information_Item_choice_Extension_value._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_value._const_tab_at = ('..', u'id')
    __OTDOACell_Information_Item_choice_Extension_value._const_tab_id = u'Value'
    _OTDOACell_Information_Item_choice_Extension._cont = ASN1Dict([
        (u'id', __OTDOACell_Information_Item_choice_Extension_id),
        (u'criticality', __OTDOACell_Information_Item_choice_Extension_criticality),
        (u'value', __OTDOACell_Information_Item_choice_Extension_value),
        ])
    _OTDOACell_Information_Item_choice_Extension._ext = None
    OTDOACell_Information_Item._cont = ASN1Dict([
        (u'pCI-EUTRA', _OTDOACell_Information_Item_pCI_EUTRA),
        (u'cGI-EUTRA', _OTDOACell_Information_Item_cGI_EUTRA),
        (u'tAC', _OTDOACell_Information_Item_tAC),
        (u'eARFCN', _OTDOACell_Information_Item_eARFCN),
        (u'pRS-Bandwidth-EUTRA', _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA),
        (u'pRS-ConfigurationIndex-EUTRA', _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA),
        (u'cPLength-EUTRA', _OTDOACell_Information_Item_cPLength_EUTRA),
        (u'numberOfDlFrames-EUTRA', _OTDOACell_Information_Item_numberOfDlFrames_EUTRA),
        (u'numberOfAntennaPorts-EUTRA', _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA),
        (u'sFNInitialisationTime-EUTRA', _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA),
        (u'nG-RANAccessPointPosition', _OTDOACell_Information_Item_nG_RANAccessPointPosition),
        (u'pRSMutingConfiguration-EUTRA', _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA),
        (u'prsid-EUTRA', _OTDOACell_Information_Item_prsid_EUTRA),
        (u'tpid-EUTRA', _OTDOACell_Information_Item_tpid_EUTRA),
        (u'tpType-EUTRA', _OTDOACell_Information_Item_tpType_EUTRA),
        (u'numberOfDlFrames-Extended-EUTRA', _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA),
        (u'crsCPlength-EUTRA', _OTDOACell_Information_Item_crsCPlength_EUTRA),
        (u'dL-Bandwidth-EUTRA', _OTDOACell_Information_Item_dL_Bandwidth_EUTRA),
        (u'pRSOccasionGroup-EUTRA', _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA),
        (u'pRSFrequencyHoppingConfiguration-EUTRA', _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA),
        (u'choice-Extension', _OTDOACell_Information_Item_choice_Extension),
        ])
    OTDOACell_Information_Item._ext = None
    
    #-----< OTDOACell-Information-Item-ExtensionIE >-----#
    OTDOACell_Information_Item_ExtensionIE = CLASS(name=u'OTDOACell-Information-Item-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TDD-Config-EUTRA-Item')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    OTDOACell_Information_Item_ExtensionIE._val = ASN1Set(rv=[dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Item >-----#
    OTDOA_Information_Item = ENUM(name=u'OTDOA-Information-Item', mode=MODE_TYPE)
    OTDOA_Information_Item._cont = ASN1Dict([(u'pci', 0), (u'cGI', 1), (u'tac', 2), (u'earfcn', 3), (u'prsBandwidth', 4), (u'prsConfigIndex', 5), (u'cpLength', 6), (u'noDlFrames', 7), (u'noAntennaPorts', 8), (u'sFNInitTime', 9), (u'nG-RANAccessPointPosition', 10), (u'prsmutingconfiguration', 11), (u'prsid', 12), (u'tpid', 13), (u'tpType', 14), (u'crsCPlength', 15), (u'dlBandwidth', 16), (u'multipleprsConfigurationsperCell', 17), (u'prsOccasionGroup', 18), (u'prsFrequencyHoppingConfiguration', 19), (u'tddConfig', 20)])
    OTDOA_Information_Item._ext = [u'tddConfig']
    
    #-----< OtherRATMeasurementQuantities >-----#
    OtherRATMeasurementQuantities = SEQ_OF(name=u'OtherRATMeasurementQuantities', mode=MODE_TYPE)
    _OtherRATMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OtherRATMeasurementQuantities__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___OtherRATMeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities-Item')))
    ___OtherRATMeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __OtherRATMeasurementQuantities__item__id._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__id._const_tab_at = None
    __OtherRATMeasurementQuantities__item__id._const_tab_id = u'id'
    __OtherRATMeasurementQuantities__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __OtherRATMeasurementQuantities__item__criticality._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__criticality._const_tab_at = ('..', u'id')
    __OtherRATMeasurementQuantities__item__criticality._const_tab_id = u'criticality'
    __OtherRATMeasurementQuantities__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __OtherRATMeasurementQuantities__item__value._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__value._const_tab_at = ('..', u'id')
    __OtherRATMeasurementQuantities__item__value._const_tab_id = u'Value'
    _OtherRATMeasurementQuantities__item_._cont = ASN1Dict([
        (u'id', __OtherRATMeasurementQuantities__item__id),
        (u'criticality', __OtherRATMeasurementQuantities__item__criticality),
        (u'value', __OtherRATMeasurementQuantities__item__value),
        ])
    _OtherRATMeasurementQuantities__item_._ext = None
    OtherRATMeasurementQuantities._cont = _OtherRATMeasurementQuantities__item_
    OtherRATMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< OtherRATMeasurementQuantities-ItemIEs >-----#
    OtherRATMeasurementQuantities_ItemIEs = CLASS(name=u'OtherRATMeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OtherRATMeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities-Item')))
    OtherRATMeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', _OtherRATMeasurementQuantities_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< OtherRATMeasurementQuantities-Item >-----#
    OtherRATMeasurementQuantities_Item = SEQ(name=u'OtherRATMeasurementQuantities-Item', mode=MODE_TYPE)
    _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue = ENUM(name=u'otherRATMeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantitiesValue')))
    _OtherRATMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id),
        (u'criticality', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _OtherRATMeasurementQuantities_Item_iE_Extensions._cont = __OtherRATMeasurementQuantities_Item_iE_Extensions__item_
    _OtherRATMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OtherRATMeasurementQuantities_Item._cont = ASN1Dict([
        (u'otherRATMeasurementQuantitiesValue', _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue),
        (u'iE-Extensions', _OtherRATMeasurementQuantities_Item_iE_Extensions),
        ])
    OtherRATMeasurementQuantities_Item._ext = []
    
    #-----< OtherRATMeasurementQuantitiesValue-ExtIEs >-----#
    OtherRATMeasurementQuantitiesValue_ExtIEs = CLASS(name=u'OtherRATMeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OtherRATMeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OtherRATMeasurementQuantitiesValue >-----#
    OtherRATMeasurementQuantitiesValue = ENUM(name=u'OtherRATMeasurementQuantitiesValue', mode=MODE_TYPE)
    OtherRATMeasurementQuantitiesValue._cont = ASN1Dict([(u'geran', 0), (u'utran', 1), (u'nR', 2), (u'eUTRA', 3)])
    OtherRATMeasurementQuantitiesValue._ext = [u'nR', u'eUTRA']
    
    #-----< OtherRATMeasurementResult >-----#
    OtherRATMeasurementResult = SEQ_OF(name=u'OtherRATMeasurementResult', mode=MODE_TYPE)
    _OtherRATMeasurementResult__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasuredResultsValue')))
    OtherRATMeasurementResult._cont = _OtherRATMeasurementResult__item_
    OtherRATMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OtherRATMeasuredResultsValue >-----#
    OtherRATMeasuredResultsValue = CHOICE(name=u'OtherRATMeasuredResultsValue', mode=MODE_TYPE)
    _OtherRATMeasuredResultsValue_resultGERAN = SEQ_OF(name=u'resultGERAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultGERAN')))
    _OtherRATMeasuredResultsValue_resultUTRAN = SEQ_OF(name=u'resultUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultUTRAN')))
    _OtherRATMeasuredResultsValue_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OtherRATMeasuredResultsValue_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___OtherRATMeasuredResultsValue_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR')))
    ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA')))
    ___OtherRATMeasuredResultsValue_choice_Extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab_at = None
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab_id = u'id'
    __OtherRATMeasuredResultsValue_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab_id = u'criticality'
    __OtherRATMeasuredResultsValue_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab_at = ('..', u'id')
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab_id = u'Value'
    _OtherRATMeasuredResultsValue_choice_Extension._cont = ASN1Dict([
        (u'id', __OtherRATMeasuredResultsValue_choice_Extension_id),
        (u'criticality', __OtherRATMeasuredResultsValue_choice_Extension_criticality),
        (u'value', __OtherRATMeasuredResultsValue_choice_Extension_value),
        ])
    _OtherRATMeasuredResultsValue_choice_Extension._ext = None
    OtherRATMeasuredResultsValue._cont = ASN1Dict([
        (u'resultGERAN', _OtherRATMeasuredResultsValue_resultGERAN),
        (u'resultUTRAN', _OtherRATMeasuredResultsValue_resultUTRAN),
        (u'choice-Extension', _OtherRATMeasuredResultsValue_choice_Extension),
        ])
    OtherRATMeasuredResultsValue._ext = None
    
    #-----< OtherRATMeasuredResultsValue-ExtensionIE >-----#
    OtherRATMeasuredResultsValue_ExtensionIE = CLASS(name=u'OtherRATMeasuredResultsValue-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR')))
    _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA')))
    OtherRATMeasuredResultsValue_ExtensionIE._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Outcome >-----#
    Outcome = ENUM(name=u'Outcome', mode=MODE_TYPE)
    Outcome._cont = ASN1Dict([(u'failed', 0)])
    Outcome._ext = []
    
    #-----< PathlossReferenceInformation >-----#
    PathlossReferenceInformation = SEQ(name=u'PathlossReferenceInformation', mode=MODE_TYPE)
    _PathlossReferenceInformation_pathlossReferenceSignal = CHOICE(name=u'pathlossReferenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PathlossReferenceSignal')))
    _PathlossReferenceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathlossReferenceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PathlossReferenceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PathlossReferenceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__id_tab
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab_at = None
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PathlossReferenceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PathlossReferenceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PathlossReferenceInformation_iE_Extensions__item__id),
        (u'criticality', ___PathlossReferenceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PathlossReferenceInformation_iE_Extensions__item__extensionValue),
        ])
    __PathlossReferenceInformation_iE_Extensions__item_._ext = None
    _PathlossReferenceInformation_iE_Extensions._cont = __PathlossReferenceInformation_iE_Extensions__item_
    _PathlossReferenceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathlossReferenceInformation._cont = ASN1Dict([
        (u'pathlossReferenceSignal', _PathlossReferenceInformation_pathlossReferenceSignal),
        (u'iE-Extensions', _PathlossReferenceInformation_iE_Extensions),
        ])
    PathlossReferenceInformation._ext = []
    
    #-----< PathlossReferenceInformation-ExtIEs >-----#
    PathlossReferenceInformation_ExtIEs = CLASS(name=u'PathlossReferenceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PathlossReferenceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceSignal >-----#
    PathlossReferenceSignal = CHOICE(name=u'PathlossReferenceSignal', mode=MODE_TYPE)
    _PathlossReferenceSignal_sSB_Reference = SEQ(name=u'sSB-Reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _PathlossReferenceSignal_dL_PRS_Reference = SEQ(name=u'dL-PRS-Reference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRS')))
    _PathlossReferenceSignal_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PathlossReferenceSignal_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___PathlossReferenceSignal_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_id._const_tab = ___PathlossReferenceSignal_choice_Extension_id_tab
    __PathlossReferenceSignal_choice_Extension_id._const_tab_at = None
    __PathlossReferenceSignal_choice_Extension_id._const_tab_id = u'id'
    __PathlossReferenceSignal_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PathlossReferenceSignal_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab = ___PathlossReferenceSignal_choice_Extension_criticality_tab
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab_id = u'criticality'
    __PathlossReferenceSignal_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PathlossReferenceSignal_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_value._const_tab = ___PathlossReferenceSignal_choice_Extension_value_tab
    __PathlossReferenceSignal_choice_Extension_value._const_tab_at = ('..', u'id')
    __PathlossReferenceSignal_choice_Extension_value._const_tab_id = u'Value'
    _PathlossReferenceSignal_choice_Extension._cont = ASN1Dict([
        (u'id', __PathlossReferenceSignal_choice_Extension_id),
        (u'criticality', __PathlossReferenceSignal_choice_Extension_criticality),
        (u'value', __PathlossReferenceSignal_choice_Extension_value),
        ])
    _PathlossReferenceSignal_choice_Extension._ext = None
    PathlossReferenceSignal._cont = ASN1Dict([
        (u'sSB-Reference', _PathlossReferenceSignal_sSB_Reference),
        (u'dL-PRS-Reference', _PathlossReferenceSignal_dL_PRS_Reference),
        (u'choice-Extension', _PathlossReferenceSignal_choice_Extension),
        ])
    PathlossReferenceSignal._ext = None
    
    #-----< PathlossReferenceSignal-ExtensionIE >-----#
    PathlossReferenceSignal_ExtensionIE = CLASS(name=u'PathlossReferenceSignal-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PathlossReferenceSignal_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCI-EUTRA >-----#
    PCI_EUTRA = INT(name=u'PCI-EUTRA', mode=MODE_TYPE)
    PCI_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=[], er=[])
    
    #-----< PhysCellIDGERAN >-----#
    PhysCellIDGERAN = INT(name=u'PhysCellIDGERAN', mode=MODE_TYPE)
    PhysCellIDGERAN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< PhysCellIDUTRA-FDD >-----#
    PhysCellIDUTRA_FDD = INT(name=u'PhysCellIDUTRA-FDD', mode=MODE_TYPE)
    PhysCellIDUTRA_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< PhysCellIDUTRA-TDD >-----#
    PhysCellIDUTRA_TDD = INT(name=u'PhysCellIDUTRA-TDD', mode=MODE_TYPE)
    PhysCellIDUTRA_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name=u'PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PeriodicityList >-----#
    PeriodicityList = SEQ_OF(name=u'PeriodicityList', mode=MODE_TYPE)
    _PeriodicityList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PeriodicityItem')))
    PeriodicityList._cont = _PeriodicityList__item_
    PeriodicityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodicityItem >-----#
    PeriodicityItem = ENUM(name=u'PeriodicityItem', mode=MODE_TYPE)
    PeriodicityItem._cont = ASN1Dict([(u'ms0dot125', 0), (u'ms0dot25', 1), (u'ms0dot5', 2), (u'ms0dot625', 3), (u'ms1', 4), (u'ms1dot25', 5), (u'ms2', 6), (u'ms2dot5', 7), (u'ms4dot', 8), (u'ms5', 9), (u'ms8', 10), (u'ms10', 11), (u'ms16', 12), (u'ms20', 13), (u'ms32', 14), (u'ms40', 15), (u'ms64', 16), (u'ms80m', 17), (u'ms160', 18), (u'ms320', 19), (u'ms640m', 20), (u'ms1280', 21), (u'ms2560', 22), (u'ms5120', 23), (u'ms10240', 24)])
    PeriodicityItem._ext = []
    
    #-----< PosSIBs >-----#
    PosSIBs = SEQ_OF(name=u'PosSIBs', mode=MODE_TYPE)
    _PosSIBs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PosSIBs__item__posSIB_Type = ENUM(name=u'posSIB-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Type')))
    __PosSIBs__item__posSIB_Segments = SEQ_OF(name=u'posSIB-Segments', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Segments')))
    __PosSIBs__item__assistanceInformationMetaData = SEQ(name=u'assistanceInformationMetaData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationMetaData')), opt=True)
    __PosSIBs__item__broadcastPriority = INT(name=u'broadcastPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PosSIBs__item__broadcastPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    __PosSIBs__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PosSIBs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____PosSIBs__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____PosSIBs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__id._const_tab = _____PosSIBs__item__iE_Extensions__item__id_tab
    ____PosSIBs__item__iE_Extensions__item__id._const_tab_at = None
    ____PosSIBs__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____PosSIBs__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____PosSIBs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab = _____PosSIBs__item__iE_Extensions__item__criticality_tab
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____PosSIBs__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____PosSIBs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab = _____PosSIBs__item__iE_Extensions__item__extensionValue_tab
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___PosSIBs__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____PosSIBs__item__iE_Extensions__item__id),
        (u'criticality', ____PosSIBs__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____PosSIBs__item__iE_Extensions__item__extensionValue),
        ])
    ___PosSIBs__item__iE_Extensions__item_._ext = None
    __PosSIBs__item__iE_Extensions._cont = ___PosSIBs__item__iE_Extensions__item_
    __PosSIBs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PosSIBs__item_._cont = ASN1Dict([
        (u'posSIB-Type', __PosSIBs__item__posSIB_Type),
        (u'posSIB-Segments', __PosSIBs__item__posSIB_Segments),
        (u'assistanceInformationMetaData', __PosSIBs__item__assistanceInformationMetaData),
        (u'broadcastPriority', __PosSIBs__item__broadcastPriority),
        (u'iE-Extensions', __PosSIBs__item__iE_Extensions),
        ])
    _PosSIBs__item_._ext = []
    PosSIBs._cont = _PosSIBs__item_
    PosSIBs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PosSIBs-ExtIEs >-----#
    PosSIBs_ExtIEs = CLASS(name=u'PosSIBs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSIBs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSIB-Segments >-----#
    PosSIB_Segments = SEQ_OF(name=u'PosSIB-Segments', mode=MODE_TYPE)
    _PosSIB_Segments__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PosSIB_Segments__item__assistanceDataSIBelement = OCT_STR(name=u'assistanceDataSIBelement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PosSIB_Segments__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PosSIB_Segments__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____PosSIB_Segments__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____PosSIB_Segments__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__id_tab
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab_at = None
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____PosSIB_Segments__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___PosSIB_Segments__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____PosSIB_Segments__item__iE_Extensions__item__id),
        (u'criticality', ____PosSIB_Segments__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____PosSIB_Segments__item__iE_Extensions__item__extensionValue),
        ])
    ___PosSIB_Segments__item__iE_Extensions__item_._ext = None
    __PosSIB_Segments__item__iE_Extensions._cont = ___PosSIB_Segments__item__iE_Extensions__item_
    __PosSIB_Segments__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PosSIB_Segments__item_._cont = ASN1Dict([
        (u'assistanceDataSIBelement', __PosSIB_Segments__item__assistanceDataSIBelement),
        (u'iE-Extensions', __PosSIB_Segments__item__iE_Extensions),
        ])
    _PosSIB_Segments__item_._ext = []
    PosSIB_Segments._cont = _PosSIB_Segments__item_
    PosSIB_Segments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSIB-Segments-ExtIEs >-----#
    PosSIB_Segments_ExtIEs = CLASS(name=u'PosSIB-Segments-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSIB_Segments_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSIB-Type >-----#
    PosSIB_Type = ENUM(name=u'PosSIB-Type', mode=MODE_TYPE)
    PosSIB_Type._cont = ASN1Dict([(u'posSibType1-1', 0), (u'posSibType1-2', 1), (u'posSibType1-3', 2), (u'posSibType1-4', 3), (u'posSibType1-5', 4), (u'posSibType1-6', 5), (u'posSibType1-7', 6), (u'posSibType1-8', 7), (u'posSibType2-1', 8), (u'posSibType2-2', 9), (u'posSibType2-3', 10), (u'posSibType2-4', 11), (u'posSibType2-5', 12), (u'posSibType2-6', 13), (u'posSibType2-7', 14), (u'posSibType2-8', 15), (u'posSibType2-9', 16), (u'posSibType2-10', 17), (u'posSibType2-11', 18), (u'posSibType2-12', 19), (u'posSibType2-13', 20), (u'posSibType2-14', 21), (u'posSibType2-15', 22), (u'posSibType2-16', 23), (u'posSibType2-17', 24), (u'posSibType2-18', 25), (u'posSibType2-19', 26), (u'posSibType2-20', 27), (u'posSibType2-21', 28), (u'posSibType2-22', 29), (u'posSibType2-23', 30), (u'posSibType2-24', 31), (u'posSibType2-25', 32), (u'posSibType3-1', 33), (u'posSibType4-1', 34), (u'posSibType5-1', 35), (u'posSibType6-1', 36), (u'posSibType6-2', 37), (u'posSibType6-3', 38)])
    PosSIB_Type._ext = []
    
    #-----< PosSRSResource-List >-----#
    PosSRSResource_List = SEQ_OF(name=u'PosSRSResource-List', mode=MODE_TYPE)
    _PosSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResource-Item')))
    PosSRSResource_List._cont = _PosSRSResource_List__item_
    PosSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSRSResource-Item >-----#
    PosSRSResource_Item = SEQ(name=u'PosSRSResource-Item', mode=MODE_TYPE)
    _PosSRSResource_Item_srs_PosResourceId = INT(name=u'srs-PosResourceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    _PosSRSResource_Item_transmissionCombPos = CHOICE(name=u'transmissionCombPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TransmissionCombPos')))
    _PosSRSResource_Item_startPosition = INT(name=u'startPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _PosSRSResource_Item_nrofSymbols = ENUM(name=u'nrofSymbols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_nrofSymbols._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3), (u'n12', 4)])
    _PosSRSResource_Item_nrofSymbols._ext = None
    _PosSRSResource_Item_freqDomainShift = INT(name=u'freqDomainShift', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _PosSRSResource_Item_c_SRS = INT(name=u'c-SRS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PosSRSResource_Item_groupOrSequenceHopping = ENUM(name=u'groupOrSequenceHopping', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_groupOrSequenceHopping._cont = ASN1Dict([(u'neither', 0), (u'groupHopping', 1), (u'sequenceHopping', 2)])
    _PosSRSResource_Item_groupOrSequenceHopping._ext = None
    _PosSRSResource_Item_resourceTypePos = CHOICE(name=u'resourceTypePos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePos')))
    _PosSRSResource_Item_sequenceId = INT(name=u'sequenceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PosSRSResource_Item_spatialRelationPos = CHOICE(name=u'spatialRelationPos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPos')), opt=True)
    _PosSRSResource_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosSRSResource_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab = ____PosSRSResource_Item_iE_Extensions__item__id_tab
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosSRSResource_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResource_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosSRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosSRSResource_Item_iE_Extensions__item__id),
        (u'criticality', ___PosSRSResource_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosSRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResource_Item_iE_Extensions__item_._ext = None
    _PosSRSResource_Item_iE_Extensions._cont = __PosSRSResource_Item_iE_Extensions__item_
    _PosSRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResource_Item._cont = ASN1Dict([
        (u'srs-PosResourceId', _PosSRSResource_Item_srs_PosResourceId),
        (u'transmissionCombPos', _PosSRSResource_Item_transmissionCombPos),
        (u'startPosition', _PosSRSResource_Item_startPosition),
        (u'nrofSymbols', _PosSRSResource_Item_nrofSymbols),
        (u'freqDomainShift', _PosSRSResource_Item_freqDomainShift),
        (u'c-SRS', _PosSRSResource_Item_c_SRS),
        (u'groupOrSequenceHopping', _PosSRSResource_Item_groupOrSequenceHopping),
        (u'resourceTypePos', _PosSRSResource_Item_resourceTypePos),
        (u'sequenceId', _PosSRSResource_Item_sequenceId),
        (u'spatialRelationPos', _PosSRSResource_Item_spatialRelationPos),
        (u'iE-Extensions', _PosSRSResource_Item_iE_Extensions),
        ])
    PosSRSResource_Item._ext = []
    
    #-----< PosSRSResource-Item-ExtIEs >-----#
    PosSRSResource_Item_ExtIEs = CLASS(name=u'PosSRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResourceSet-List >-----#
    PosSRSResourceSet_List = SEQ_OF(name=u'PosSRSResourceSet-List', mode=MODE_TYPE)
    _PosSRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceSet-Item')))
    PosSRSResourceSet_List._cont = _PosSRSResourceSet_List__item_
    PosSRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResourceID-List >-----#
    PosSRSResourceID_List = SEQ_OF(name=u'PosSRSResourceID-List', mode=MODE_TYPE)
    _PosSRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    PosSRSResourceID_List._cont = _PosSRSResourceID_List__item_
    PosSRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResourceSet-Item >-----#
    PosSRSResourceSet_Item = SEQ(name=u'PosSRSResourceSet-Item', mode=MODE_TYPE)
    _PosSRSResourceSet_Item_possrsResourceSetID = INT(name=u'possrsResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResourceSet_Item_possrsResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PosSRSResourceSet_Item_possRSResourceID_List = SEQ_OF(name=u'possRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceID-List')))
    _PosSRSResourceSet_Item_posresourceSetType = CHOICE(name=u'posresourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetType')))
    _PosSRSResourceSet_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosSRSResourceSet_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosSRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosSRSResourceSet_Item_iE_Extensions__item__id),
        (u'criticality', ___PosSRSResourceSet_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PosSRSResourceSet_Item_iE_Extensions._cont = __PosSRSResourceSet_Item_iE_Extensions__item_
    _PosSRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResourceSet_Item._cont = ASN1Dict([
        (u'possrsResourceSetID', _PosSRSResourceSet_Item_possrsResourceSetID),
        (u'possRSResourceID-List', _PosSRSResourceSet_Item_possRSResourceID_List),
        (u'posresourceSetType', _PosSRSResourceSet_Item_posresourceSetType),
        (u'iE-Extensions', _PosSRSResourceSet_Item_iE_Extensions),
        ])
    PosSRSResourceSet_Item._ext = []
    
    #-----< PosSRSResourceSet-Item-ExtIEs >-----#
    PosSRSResourceSet_Item_ExtIEs = CLASS(name=u'PosSRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetType >-----#
    PosResourceSetType = CHOICE(name=u'PosResourceSetType', mode=MODE_TYPE)
    _PosResourceSetType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypePeriodic')))
    _PosResourceSetType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypeSemi-persistent')))
    _PosResourceSetType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypeAperiodic')))
    _PosResourceSetType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PosResourceSetType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___PosResourceSetType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_id._const_tab = ___PosResourceSetType_choice_extension_id_tab
    __PosResourceSetType_choice_extension_id._const_tab_at = None
    __PosResourceSetType_choice_extension_id._const_tab_id = u'id'
    __PosResourceSetType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PosResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_criticality._const_tab = ___PosResourceSetType_choice_extension_criticality_tab
    __PosResourceSetType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __PosResourceSetType_choice_extension_criticality._const_tab_id = u'criticality'
    __PosResourceSetType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PosResourceSetType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_value._const_tab = ___PosResourceSetType_choice_extension_value_tab
    __PosResourceSetType_choice_extension_value._const_tab_at = ('..', u'id')
    __PosResourceSetType_choice_extension_value._const_tab_id = u'Value'
    _PosResourceSetType_choice_extension._cont = ASN1Dict([
        (u'id', __PosResourceSetType_choice_extension_id),
        (u'criticality', __PosResourceSetType_choice_extension_criticality),
        (u'value', __PosResourceSetType_choice_extension_value),
        ])
    _PosResourceSetType_choice_extension._ext = None
    PosResourceSetType._cont = ASN1Dict([
        (u'periodic', _PosResourceSetType_periodic),
        (u'semi-persistent', _PosResourceSetType_semi_persistent),
        (u'aperiodic', _PosResourceSetType_aperiodic),
        (u'choice-extension', _PosResourceSetType_choice_extension),
        ])
    PosResourceSetType._ext = None
    
    #-----< PosResourceSetType-ExtIEs >-----#
    PosResourceSetType_ExtIEs = CLASS(name=u'PosResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PosResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypePeriodic >-----#
    PosResourceSetTypePeriodic = SEQ(name=u'PosResourceSetTypePeriodic', mode=MODE_TYPE)
    _PosResourceSetTypePeriodic_posperiodicSet = ENUM(name=u'posperiodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypePeriodic_posperiodicSet._cont = ASN1Dict([(u'true', 0)])
    _PosResourceSetTypePeriodic_posperiodicSet._ext = []
    _PosResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypePeriodic_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _PosResourceSetTypePeriodic_iE_Extensions._cont = __PosResourceSetTypePeriodic_iE_Extensions__item_
    _PosResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypePeriodic._cont = ASN1Dict([
        (u'posperiodicSet', _PosResourceSetTypePeriodic_posperiodicSet),
        (u'iE-Extensions', _PosResourceSetTypePeriodic_iE_Extensions),
        ])
    PosResourceSetTypePeriodic._ext = []
    
    #-----< PosResourceSetTypePeriodic-ExtIEs >-----#
    PosResourceSetTypePeriodic_ExtIEs = CLASS(name=u'PosResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeSemi-persistent >-----#
    PosResourceSetTypeSemi_persistent = SEQ(name=u'PosResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet = ENUM(name=u'possemi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet._cont = ASN1Dict([(u'true', 0)])
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet._ext = []
    _PosResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _PosResourceSetTypeSemi_persistent_iE_Extensions._cont = __PosResourceSetTypeSemi_persistent_iE_Extensions__item_
    _PosResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeSemi_persistent._cont = ASN1Dict([
        (u'possemi-persistentSet', _PosResourceSetTypeSemi_persistent_possemi_persistentSet),
        (u'iE-Extensions', _PosResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    PosResourceSetTypeSemi_persistent._ext = []
    
    #-----< PosResourceSetTypeSemi-persistent-ExtIEs >-----#
    PosResourceSetTypeSemi_persistent_ExtIEs = CLASS(name=u'PosResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeAperiodic >-----#
    PosResourceSetTypeAperiodic = SEQ(name=u'PosResourceSetTypeAperiodic', mode=MODE_TYPE)
    _PosResourceSetTypeAperiodic_sRSResourceTrigger = INT(name=u'sRSResourceTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeAperiodic_sRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _PosResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PosResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PosResourceSetTypeAperiodic_iE_Extensions__item__id),
        (u'criticality', ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _PosResourceSetTypeAperiodic_iE_Extensions._cont = __PosResourceSetTypeAperiodic_iE_Extensions__item_
    _PosResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeAperiodic._cont = ASN1Dict([
        (u'sRSResourceTrigger', _PosResourceSetTypeAperiodic_sRSResourceTrigger),
        (u'iE-Extensions', _PosResourceSetTypeAperiodic_iE_Extensions),
        ])
    PosResourceSetTypeAperiodic._ext = []
    
    #-----< PosResourceSetTypeAperiodic-ExtIEs >-----#
    PosResourceSetTypeAperiodic_ExtIEs = CLASS(name=u'PosResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Bandwidth-EUTRA >-----#
    PRS_Bandwidth_EUTRA = ENUM(name=u'PRS-Bandwidth-EUTRA', mode=MODE_TYPE)
    PRS_Bandwidth_EUTRA._cont = ASN1Dict([(u'bw6', 0), (u'bw15', 1), (u'bw25', 2), (u'bw50', 3), (u'bw75', 4), (u'bw100', 5)])
    PRS_Bandwidth_EUTRA._ext = []
    
    #-----< PRSAngleItem >-----#
    PRSAngleItem = SEQ(name=u'PRSAngleItem', mode=MODE_TYPE)
    _PRSAngleItem_nRPRSAzimuth = INT(name=u'nRPRSAzimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nRPRSAzimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _PRSAngleItem_nRPRSAzimuthFine = INT(name=u'nRPRSAzimuthFine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSAzimuthFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_nRPRSElevation = INT(name=u'nRPRSElevation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSElevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _PRSAngleItem_nRPRSElevationFine = INT(name=u'nRPRSElevationFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSElevationFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSAngleItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSAngleItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSAngleItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    ____PRSAngleItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Extension', _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PRSAngleItem_iE_Extensions__item__id._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSAngleItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSAngleItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSAngleItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSAngleItem_iE_Extensions__item__id),
        (u'criticality', ___PRSAngleItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSAngleItem_iE_Extensions__item__extensionValue),
        ])
    __PRSAngleItem_iE_Extensions__item_._ext = None
    _PRSAngleItem_iE_Extensions._cont = __PRSAngleItem_iE_Extensions__item_
    _PRSAngleItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSAngleItem._cont = ASN1Dict([
        (u'nRPRSAzimuth', _PRSAngleItem_nRPRSAzimuth),
        (u'nRPRSAzimuthFine', _PRSAngleItem_nRPRSAzimuthFine),
        (u'nRPRSElevation', _PRSAngleItem_nRPRSElevation),
        (u'nRPRSElevationFine', _PRSAngleItem_nRPRSElevationFine),
        (u'iE-Extensions', _PRSAngleItem_iE_Extensions),
        ])
    PRSAngleItem._ext = []
    
    #-----< PRSAngleItem-ExtIEs >-----#
    PRSAngleItem_ExtIEs = CLASS(name=u'PRSAngleItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _PRSAngleItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    PRSAngleItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Extension', _PRSAngleItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSInformationPos >-----#
    PRSInformationPos = SEQ(name=u'PRSInformationPos', mode=MODE_TYPE)
    _PRSInformationPos_pRS_IDPos = INT(name=u'pRS-IDPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_Set_IDPos = INT(name=u'pRS-Resource-Set-IDPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_Resource_Set_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_IDPos = INT(name=u'pRS-Resource-IDPos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSInformationPos_pRS_Resource_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRSInformationPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSInformationPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSInformationPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSInformationPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__id._const_tab = ____PRSInformationPos_iE_Extensions__item__id_tab
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_at = None
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSInformationPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab = ____PRSInformationPos_iE_Extensions__item__criticality_tab
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSInformationPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab = ____PRSInformationPos_iE_Extensions__item__extensionValue_tab
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSInformationPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSInformationPos_iE_Extensions__item__id),
        (u'criticality', ___PRSInformationPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSInformationPos_iE_Extensions__item__extensionValue),
        ])
    __PRSInformationPos_iE_Extensions__item_._ext = None
    _PRSInformationPos_iE_Extensions._cont = __PRSInformationPos_iE_Extensions__item_
    _PRSInformationPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSInformationPos._cont = ASN1Dict([
        (u'pRS-IDPos', _PRSInformationPos_pRS_IDPos),
        (u'pRS-Resource-Set-IDPos', _PRSInformationPos_pRS_Resource_Set_IDPos),
        (u'pRS-Resource-IDPos', _PRSInformationPos_pRS_Resource_IDPos),
        (u'iE-Extensions', _PRSInformationPos_iE_Extensions),
        ])
    PRSInformationPos._ext = []
    
    #-----< PRSInformationPos-ExtIEs >-----#
    PRSInformationPos_ExtIEs = CLASS(name=u'PRSInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSConfiguration >-----#
    PRSConfiguration = SEQ(name=u'PRSConfiguration', mode=MODE_TYPE)
    _PRSConfiguration_pRSResourceSet_List = SEQ_OF(name=u'pRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResourceSet-List')))
    _PRSConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__id._const_tab = ____PRSConfiguration_iE_Extensions__item__id_tab
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab = ____PRSConfiguration_iE_Extensions__item__criticality_tab
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____PRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSConfiguration_iE_Extensions__item__id),
        (u'criticality', ___PRSConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __PRSConfiguration_iE_Extensions__item_._ext = None
    _PRSConfiguration_iE_Extensions._cont = __PRSConfiguration_iE_Extensions__item_
    _PRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSConfiguration._cont = ASN1Dict([
        (u'pRSResourceSet-List', _PRSConfiguration_pRSResourceSet_List),
        (u'iE-Extensions', _PRSConfiguration_iE_Extensions),
        ])
    PRSConfiguration._ext = []
    
    #-----< PRSConfiguration-ExtIEs >-----#
    PRSConfiguration_ExtIEs = CLASS(name=u'PRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-ConfigurationIndex-EUTRA >-----#
    PRS_ConfigurationIndex_EUTRA = INT(name=u'PRS-ConfigurationIndex-EUTRA', mode=MODE_TYPE)
    PRS_ConfigurationIndex_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< PRS-ID-EUTRA >-----#
    PRS_ID_EUTRA = INT(name=u'PRS-ID-EUTRA', mode=MODE_TYPE)
    PRS_ID_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< PRSMutingConfiguration-EUTRA >-----#
    PRSMutingConfiguration_EUTRA = CHOICE(name=u'PRSMutingConfiguration-EUTRA', mode=MODE_TYPE)
    _PRSMutingConfiguration_EUTRA_two = BIT_STR(name=u'two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_four = BIT_STR(name=u'four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_eight = BIT_STR(name=u'eight', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_sixteen = BIT_STR(name=u'sixteen', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_thirty_two = BIT_STR(name=u'thirty-two', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_sixty_four = BIT_STR(name=u'sixty-four', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_sixty_four._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight = BIT_STR(name=u'one-hundred-and-twenty-eight', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six = BIT_STR(name=u'two-hundred-and-fifty-six', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve = BIT_STR(name=u'five-hundred-and-twelve', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve._const_sz = ASN1Set(rv=[512], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four = BIT_STR(name=u'one-thousand-and-twenty-four', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four._const_sz = ASN1Set(rv=[1024], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PRSMutingConfiguration_EUTRA_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab_at = None
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab_id = u'id'
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab_id = u'criticality'
    __PRSMutingConfiguration_EUTRA_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab_at = ('..', u'id')
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab_id = u'Value'
    _PRSMutingConfiguration_EUTRA_choice_Extension._cont = ASN1Dict([
        (u'id', __PRSMutingConfiguration_EUTRA_choice_Extension_id),
        (u'criticality', __PRSMutingConfiguration_EUTRA_choice_Extension_criticality),
        (u'value', __PRSMutingConfiguration_EUTRA_choice_Extension_value),
        ])
    _PRSMutingConfiguration_EUTRA_choice_Extension._ext = None
    PRSMutingConfiguration_EUTRA._cont = ASN1Dict([
        (u'two', _PRSMutingConfiguration_EUTRA_two),
        (u'four', _PRSMutingConfiguration_EUTRA_four),
        (u'eight', _PRSMutingConfiguration_EUTRA_eight),
        (u'sixteen', _PRSMutingConfiguration_EUTRA_sixteen),
        (u'thirty-two', _PRSMutingConfiguration_EUTRA_thirty_two),
        (u'sixty-four', _PRSMutingConfiguration_EUTRA_sixty_four),
        (u'one-hundred-and-twenty-eight', _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight),
        (u'two-hundred-and-fifty-six', _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six),
        (u'five-hundred-and-twelve', _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve),
        (u'one-thousand-and-twenty-four', _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four),
        (u'choice-Extension', _PRSMutingConfiguration_EUTRA_choice_Extension),
        ])
    PRSMutingConfiguration_EUTRA._ext = None
    
    #-----< PRSMutingConfiguration-EUTRA-ExtensionIE >-----#
    PRSMutingConfiguration_EUTRA_ExtensionIE = CLASS(name=u'PRSMutingConfiguration-EUTRA-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PRSMutingConfiguration_EUTRA_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSOccasionGroup-EUTRA >-----#
    PRSOccasionGroup_EUTRA = ENUM(name=u'PRSOccasionGroup-EUTRA', mode=MODE_TYPE)
    PRSOccasionGroup_EUTRA._cont = ASN1Dict([(u'og2', 0), (u'og4', 1), (u'og8', 2), (u'og16', 3), (u'og32', 4), (u'og64', 5), (u'og128', 6)])
    PRSOccasionGroup_EUTRA._ext = []
    
    #-----< PRSFrequencyHoppingConfiguration-EUTRA >-----#
    PRSFrequencyHoppingConfiguration_EUTRA = SEQ(name=u'PRSFrequencyHoppingConfiguration-EUTRA', mode=MODE_TYPE)
    _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands = ENUM(name=u'noOfFreqHoppingBands', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfFrequencyHoppingBands')))
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions = SEQ_OF(name=u'bandPositions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NarrowBandIndex')))
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions._cont = __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id),
        (u'criticality', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_._ext = None
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions._cont = __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSFrequencyHoppingConfiguration_EUTRA._cont = ASN1Dict([
        (u'noOfFreqHoppingBands', _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands),
        (u'bandPositions', _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions),
        (u'iE-Extensions', _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions),
        ])
    PRSFrequencyHoppingConfiguration_EUTRA._ext = []
    
    #-----< PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs >-----#
    PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs = CLASS(name=u'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMuting >-----#
    PRSMuting = SEQ(name=u'PRSMuting', mode=MODE_TYPE)
    _PRSMuting_pRSMutingOption1 = SEQ(name=u'pRSMutingOption1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingOption1')), opt=True)
    _PRSMuting_pRSMutingOption2 = SEQ(name=u'pRSMutingOption2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingOption2')), opt=True)
    _PRSMuting_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMuting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMuting_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMuting_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__id._const_tab = ____PRSMuting_iE_Extensions__item__id_tab
    ___PRSMuting_iE_Extensions__item__id._const_tab_at = None
    ___PRSMuting_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMuting_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMuting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__criticality._const_tab = ____PRSMuting_iE_Extensions__item__criticality_tab
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMuting_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab = ____PRSMuting_iE_Extensions__item__extensionValue_tab
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMuting_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMuting_iE_Extensions__item__id),
        (u'criticality', ___PRSMuting_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMuting_iE_Extensions__item__extensionValue),
        ])
    __PRSMuting_iE_Extensions__item_._ext = None
    _PRSMuting_iE_Extensions._cont = __PRSMuting_iE_Extensions__item_
    _PRSMuting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMuting._cont = ASN1Dict([
        (u'pRSMutingOption1', _PRSMuting_pRSMutingOption1),
        (u'pRSMutingOption2', _PRSMuting_pRSMutingOption2),
        (u'iE-Extensions', _PRSMuting_iE_Extensions),
        ])
    PRSMuting._ext = []
    
    #-----< PRSMuting-ExtIEs >-----#
    PRSMuting_ExtIEs = CLASS(name=u'PRSMuting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMuting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption1 >-----#
    PRSMutingOption1 = SEQ(name=u'PRSMutingOption1', mode=MODE_TYPE)
    _PRSMutingOption1_mutingPattern = CHOICE(name=u'mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption1_mutingBitRepetitionFactor = ENUM(name=u'mutingBitRepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingOption1_mutingBitRepetitionFactor._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3)])
    _PRSMutingOption1_mutingBitRepetitionFactor._ext = []
    _PRSMutingOption1_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption1_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMutingOption1_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab = ____PRSMutingOption1_iE_Extensions__item__id_tab
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMutingOption1_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption1_iE_Extensions__item__criticality_tab
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMutingOption1_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMutingOption1_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMutingOption1_iE_Extensions__item__id),
        (u'criticality', ___PRSMutingOption1_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMutingOption1_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption1_iE_Extensions__item_._ext = None
    _PRSMutingOption1_iE_Extensions._cont = __PRSMutingOption1_iE_Extensions__item_
    _PRSMutingOption1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption1._cont = ASN1Dict([
        (u'mutingPattern', _PRSMutingOption1_mutingPattern),
        (u'mutingBitRepetitionFactor', _PRSMutingOption1_mutingBitRepetitionFactor),
        (u'iE-Extensions', _PRSMutingOption1_iE_Extensions),
        ])
    PRSMutingOption1._ext = []
    
    #-----< PRSMutingOption1-ExtIEs >-----#
    PRSMutingOption1_ExtIEs = CLASS(name=u'PRSMutingOption1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMutingOption1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption2 >-----#
    PRSMutingOption2 = SEQ(name=u'PRSMutingOption2', mode=MODE_TYPE)
    _PRSMutingOption2_mutingPattern = CHOICE(name=u'mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSMutingOption2_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab = ____PRSMutingOption2_iE_Extensions__item__id_tab
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSMutingOption2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption2_iE_Extensions__item__criticality_tab
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSMutingOption2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSMutingOption2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSMutingOption2_iE_Extensions__item__id),
        (u'criticality', ___PRSMutingOption2_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSMutingOption2_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption2_iE_Extensions__item_._ext = None
    _PRSMutingOption2_iE_Extensions._cont = __PRSMutingOption2_iE_Extensions__item_
    _PRSMutingOption2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption2._cont = ASN1Dict([
        (u'mutingPattern', _PRSMutingOption2_mutingPattern),
        (u'iE-Extensions', _PRSMutingOption2_iE_Extensions),
        ])
    PRSMutingOption2._ext = []
    
    #-----< PRSMutingOption2-ExtIEs >-----#
    PRSMutingOption2_ExtIEs = CLASS(name=u'PRSMutingOption2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMutingOption2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-List >-----#
    PRSResource_List = SEQ_OF(name=u'PRSResource-List', mode=MODE_TYPE)
    _PRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-Item')))
    PRSResource_List._cont = _PRSResource_List__item_
    PRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSResource-Item >-----#
    PRSResource_Item = SEQ(name=u'PRSResource-Item', mode=MODE_TYPE)
    _PRSResource_Item_pRSResourceID = INT(name=u'pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _PRSResource_Item_sequenceID = INT(name=u'sequenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_sequenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _PRSResource_Item_rEOffset = INT(name=u'rEOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_rEOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=[], er=[])
    _PRSResource_Item_resourceSlotOffset = INT(name=u'resourceSlotOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _PRSResource_Item_resourceSymbolOffset = INT(name=u'resourceSymbolOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSymbolOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    _PRSResource_Item_qCLInfo = CHOICE(name=u'qCLInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLInfo')), opt=True)
    _PRSResource_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__id._const_tab = ____PRSResource_Item_iE_Extensions__item__id_tab
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSResource_Item_iE_Extensions__item__criticality_tab
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_Item_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_Item_iE_Extensions__item_._ext = None
    _PRSResource_Item_iE_Extensions._cont = __PRSResource_Item_iE_Extensions__item_
    _PRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_Item._cont = ASN1Dict([
        (u'pRSResourceID', _PRSResource_Item_pRSResourceID),
        (u'sequenceID', _PRSResource_Item_sequenceID),
        (u'rEOffset', _PRSResource_Item_rEOffset),
        (u'resourceSlotOffset', _PRSResource_Item_resourceSlotOffset),
        (u'resourceSymbolOffset', _PRSResource_Item_resourceSymbolOffset),
        (u'qCLInfo', _PRSResource_Item_qCLInfo),
        (u'iE-Extensions', _PRSResource_Item_iE_Extensions),
        ])
    PRSResource_Item._ext = []
    
    #-----< PRSResource-Item-ExtIEs >-----#
    PRSResource_Item_ExtIEs = CLASS(name=u'PRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLInfo >-----#
    PRSResource_QCLInfo = CHOICE(name=u'PRSResource-QCLInfo', mode=MODE_TYPE)
    _PRSResource_QCLInfo_qCLSourceSSB = SEQ(name=u'qCLSourceSSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLSourceSSB')))
    _PRSResource_QCLInfo_qCLSourcePRS = SEQ(name=u'qCLSourcePRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLSourcePRS')))
    _PRSResource_QCLInfo_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PRSResource_QCLInfo_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___PRSResource_QCLInfo_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_id._const_tab = ___PRSResource_QCLInfo_choice_Extension_id_tab
    __PRSResource_QCLInfo_choice_Extension_id._const_tab_at = None
    __PRSResource_QCLInfo_choice_Extension_id._const_tab_id = u'id'
    __PRSResource_QCLInfo_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PRSResource_QCLInfo_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab = ___PRSResource_QCLInfo_choice_Extension_criticality_tab
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab_id = u'criticality'
    __PRSResource_QCLInfo_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PRSResource_QCLInfo_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_value._const_tab = ___PRSResource_QCLInfo_choice_Extension_value_tab
    __PRSResource_QCLInfo_choice_Extension_value._const_tab_at = ('..', u'id')
    __PRSResource_QCLInfo_choice_Extension_value._const_tab_id = u'Value'
    _PRSResource_QCLInfo_choice_Extension._cont = ASN1Dict([
        (u'id', __PRSResource_QCLInfo_choice_Extension_id),
        (u'criticality', __PRSResource_QCLInfo_choice_Extension_criticality),
        (u'value', __PRSResource_QCLInfo_choice_Extension_value),
        ])
    _PRSResource_QCLInfo_choice_Extension._ext = None
    PRSResource_QCLInfo._cont = ASN1Dict([
        (u'qCLSourceSSB', _PRSResource_QCLInfo_qCLSourceSSB),
        (u'qCLSourcePRS', _PRSResource_QCLInfo_qCLSourcePRS),
        (u'choice-Extension', _PRSResource_QCLInfo_choice_Extension),
        ])
    PRSResource_QCLInfo._ext = None
    
    #-----< PRSResource-QCLInfo-ExtIEs >-----#
    PRSResource_QCLInfo_ExtIEs = CLASS(name=u'PRSResource-QCLInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PRSResource_QCLInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourceSSB >-----#
    PRSResource_QCLSourceSSB = SEQ(name=u'PRSResource-QCLSourceSSB', mode=MODE_TYPE)
    _PRSResource_QCLSourceSSB_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_QCLSourceSSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _PRSResource_QCLSourceSSB_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _PRSResource_QCLSourceSSB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourceSSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_QCLSourceSSB_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourceSSB_iE_Extensions._cont = __PRSResource_QCLSourceSSB_iE_Extensions__item_
    _PRSResource_QCLSourceSSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourceSSB._cont = ASN1Dict([
        (u'pCI-NR', _PRSResource_QCLSourceSSB_pCI_NR),
        (u'sSB-Index', _PRSResource_QCLSourceSSB_sSB_Index),
        (u'iE-Extensions', _PRSResource_QCLSourceSSB_iE_Extensions),
        ])
    PRSResource_QCLSourceSSB._ext = []
    
    #-----< PRSResource-QCLSourceSSB-ExtIEs >-----#
    PRSResource_QCLSourceSSB_ExtIEs = CLASS(name=u'PRSResource-QCLSourceSSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourceSSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourcePRS >-----#
    PRSResource_QCLSourcePRS = SEQ(name=u'PRSResource-QCLSourcePRS', mode=MODE_TYPE)
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID = INT(name=u'qCLSourcePRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID = INT(name=u'qCLSourcePRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _PRSResource_QCLSourcePRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourcePRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResource_QCLSourcePRS_iE_Extensions__item__id),
        (u'criticality', ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourcePRS_iE_Extensions._cont = __PRSResource_QCLSourcePRS_iE_Extensions__item_
    _PRSResource_QCLSourcePRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourcePRS._cont = ASN1Dict([
        (u'qCLSourcePRSResourceSetID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID),
        (u'qCLSourcePRSResourceID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID),
        (u'iE-Extensions', _PRSResource_QCLSourcePRS_iE_Extensions),
        ])
    PRSResource_QCLSourcePRS._ext = []
    
    #-----< PRSResource-QCLSourcePRS-ExtIEs >-----#
    PRSResource_QCLSourcePRS_ExtIEs = CLASS(name=u'PRSResource-QCLSourcePRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourcePRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResourceSet-List >-----#
    PRSResourceSet_List = SEQ_OF(name=u'PRSResourceSet-List', mode=MODE_TYPE)
    _PRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSResourceSet-Item')))
    PRSResourceSet_List._cont = _PRSResourceSet_List__item_
    PRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSResourceSet-Item >-----#
    PRSResourceSet_Item = SEQ(name=u'PRSResourceSet-Item', mode=MODE_TYPE)
    _PRSResourceSet_Item_pRSResourceSetID = INT(name=u'pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSResourceSet_Item_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _PRSResourceSet_Item_subcarrierSpacing._ext = []
    _PRSResourceSet_Item_pRSbandwidth = INT(name=u'pRSbandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _PRSResourceSet_Item_startPRB = INT(name=u'startPRB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_startPRB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2176)], ev=None, er=[])
    _PRSResourceSet_Item_pointA = INT(name=u'pointA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRSResourceSet_Item_combSize = ENUM(name=u'combSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_combSize._cont = ASN1Dict([(u'n2', 0), (u'n4', 1), (u'n6', 2), (u'n12', 3)])
    _PRSResourceSet_Item_combSize._ext = []
    _PRSResourceSet_Item_cPType = ENUM(name=u'cPType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_cPType._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    _PRSResourceSet_Item_cPType._ext = []
    _PRSResourceSet_Item_resourceSetPeriodicity = ENUM(name=u'resourceSetPeriodicity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([(u'n4', 0), (u'n5', 1), (u'n8', 2), (u'n10', 3), (u'n16', 4), (u'n20', 5), (u'n32', 6), (u'n40', 7), (u'n64', 8), (u'n80', 9), (u'n160', 10), (u'n320', 11), (u'n640', 12), (u'n1280', 13), (u'n2560', 14), (u'n5120', 15), (u'n10240', 16), (u'n20480', 17), (u'n40960', 18), (u'n81920', 19)])
    _PRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _PRSResourceSet_Item_resourceSetSlotOffset = INT(name=u'resourceSetSlotOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _PRSResourceSet_Item_resourceRepetitionFactor = ENUM(name=u'resourceRepetitionFactor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([(u'rf1', 0), (u'rf2', 1), (u'rf4', 2), (u'rf6', 3), (u'rf8', 4), (u'rf16', 5), (u'rf32', 6)])
    _PRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _PRSResourceSet_Item_resourceTimeGap = ENUM(name=u'resourceTimeGap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceTimeGap._cont = ASN1Dict([(u'tg1', 0), (u'tg2', 1), (u'tg4', 2), (u'tg8', 3), (u'tg16', 4), (u'tg32', 5)])
    _PRSResourceSet_Item_resourceTimeGap._ext = []
    _PRSResourceSet_Item_resourceNumberofSymbols = ENUM(name=u'resourceNumberofSymbols', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([(u'n2', 0), (u'n4', 1), (u'n6', 2), (u'n12', 3)])
    _PRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _PRSResourceSet_Item_pRSMuting = SEQ(name=u'pRSMuting', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMuting')), opt=True)
    _PRSResourceSet_Item_pRSResourceTransmitPower = INT(name=u'pRSResourceTransmitPower', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSResourceTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _PRSResourceSet_Item_pRSResource_List = SEQ_OF(name=u'pRSResource-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-List')))
    _PRSResourceSet_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResourceSet_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRSResourceSet_Item_iE_Extensions__item__id),
        (u'criticality', ___PRSResourceSet_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSResourceSet_Item_iE_Extensions._cont = __PRSResourceSet_Item_iE_Extensions__item_
    _PRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResourceSet_Item._cont = ASN1Dict([
        (u'pRSResourceSetID', _PRSResourceSet_Item_pRSResourceSetID),
        (u'subcarrierSpacing', _PRSResourceSet_Item_subcarrierSpacing),
        (u'pRSbandwidth', _PRSResourceSet_Item_pRSbandwidth),
        (u'startPRB', _PRSResourceSet_Item_startPRB),
        (u'pointA', _PRSResourceSet_Item_pointA),
        (u'combSize', _PRSResourceSet_Item_combSize),
        (u'cPType', _PRSResourceSet_Item_cPType),
        (u'resourceSetPeriodicity', _PRSResourceSet_Item_resourceSetPeriodicity),
        (u'resourceSetSlotOffset', _PRSResourceSet_Item_resourceSetSlotOffset),
        (u'resourceRepetitionFactor', _PRSResourceSet_Item_resourceRepetitionFactor),
        (u'resourceTimeGap', _PRSResourceSet_Item_resourceTimeGap),
        (u'resourceNumberofSymbols', _PRSResourceSet_Item_resourceNumberofSymbols),
        (u'pRSMuting', _PRSResourceSet_Item_pRSMuting),
        (u'pRSResourceTransmitPower', _PRSResourceSet_Item_pRSResourceTransmitPower),
        (u'pRSResource-List', _PRSResourceSet_Item_pRSResource_List),
        (u'iE-Extensions', _PRSResourceSet_Item_iE_Extensions),
        ])
    PRSResourceSet_Item._ext = []
    
    #-----< PRSResourceSet-Item-ExtIEs >-----#
    PRSResourceSet_Item_ExtIEs = CLASS(name=u'PRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-ID >-----#
    PRS_Resource_ID = INT(name=u'PRS-Resource-ID', mode=MODE_TYPE)
    PRS_Resource_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< PRS-Resource-Set-ID >-----#
    PRS_Resource_Set_ID = INT(name=u'PRS-Resource-Set-ID', mode=MODE_TYPE)
    PRS_Resource_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PRS-ID >-----#
    PRS_ID = INT(name=u'PRS-ID', mode=MODE_TYPE)
    PRS_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ReferenceSignal >-----#
    ReferenceSignal = CHOICE(name=u'ReferenceSignal', mode=MODE_TYPE)
    _ReferenceSignal_nZP_CSI_RS = INT(name=u'nZP-CSI-RS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NZP-CSI-RS-ResourceID')))
    _ReferenceSignal_sSB = SEQ(name=u'sSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _ReferenceSignal_sRS = INT(name=u'sRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    _ReferenceSignal_positioningSRS = INT(name=u'positioningSRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    _ReferenceSignal_dL_PRS = SEQ(name=u'dL-PRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRS')))
    _ReferenceSignal_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ReferenceSignal_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ReferenceSignal_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_id._const_tab = ___ReferenceSignal_choice_Extension_id_tab
    __ReferenceSignal_choice_Extension_id._const_tab_at = None
    __ReferenceSignal_choice_Extension_id._const_tab_id = u'id'
    __ReferenceSignal_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ReferenceSignal_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_criticality._const_tab = ___ReferenceSignal_choice_Extension_criticality_tab
    __ReferenceSignal_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __ReferenceSignal_choice_Extension_criticality._const_tab_id = u'criticality'
    __ReferenceSignal_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ReferenceSignal_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_value._const_tab = ___ReferenceSignal_choice_Extension_value_tab
    __ReferenceSignal_choice_Extension_value._const_tab_at = ('..', u'id')
    __ReferenceSignal_choice_Extension_value._const_tab_id = u'Value'
    _ReferenceSignal_choice_Extension._cont = ASN1Dict([
        (u'id', __ReferenceSignal_choice_Extension_id),
        (u'criticality', __ReferenceSignal_choice_Extension_criticality),
        (u'value', __ReferenceSignal_choice_Extension_value),
        ])
    _ReferenceSignal_choice_Extension._ext = None
    ReferenceSignal._cont = ASN1Dict([
        (u'nZP-CSI-RS', _ReferenceSignal_nZP_CSI_RS),
        (u'sSB', _ReferenceSignal_sSB),
        (u'sRS', _ReferenceSignal_sRS),
        (u'positioningSRS', _ReferenceSignal_positioningSRS),
        (u'dL-PRS', _ReferenceSignal_dL_PRS),
        (u'choice-Extension', _ReferenceSignal_choice_Extension),
        ])
    ReferenceSignal._ext = None
    
    #-----< ReferenceSignal-ExtensionIE >-----#
    ReferenceSignal_ExtensionIE = CLASS(name=u'ReferenceSignal-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ReferenceSignal_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferencePoint >-----#
    ReferencePoint = CHOICE(name=u'ReferencePoint', mode=MODE_TYPE)
    _ReferencePoint_relativeCoordinateID = INT(name=u'relativeCoordinateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CoordinateID')))
    _ReferencePoint_referencePointCoordinate = SEQ(name=u'referencePointCoordinate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _ReferencePoint_referencePointCoordinateHA = SEQ(name=u'referencePointCoordinateHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _ReferencePoint_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ReferencePoint_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ReferencePoint_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_id._const_tab = ___ReferencePoint_choice_Extension_id_tab
    __ReferencePoint_choice_Extension_id._const_tab_at = None
    __ReferencePoint_choice_Extension_id._const_tab_id = u'id'
    __ReferencePoint_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ReferencePoint_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_criticality._const_tab = ___ReferencePoint_choice_Extension_criticality_tab
    __ReferencePoint_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __ReferencePoint_choice_Extension_criticality._const_tab_id = u'criticality'
    __ReferencePoint_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ReferencePoint_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_value._const_tab = ___ReferencePoint_choice_Extension_value_tab
    __ReferencePoint_choice_Extension_value._const_tab_at = ('..', u'id')
    __ReferencePoint_choice_Extension_value._const_tab_id = u'Value'
    _ReferencePoint_choice_Extension._cont = ASN1Dict([
        (u'id', __ReferencePoint_choice_Extension_id),
        (u'criticality', __ReferencePoint_choice_Extension_criticality),
        (u'value', __ReferencePoint_choice_Extension_value),
        ])
    _ReferencePoint_choice_Extension._ext = None
    ReferencePoint._cont = ASN1Dict([
        (u'relativeCoordinateID', _ReferencePoint_relativeCoordinateID),
        (u'referencePointCoordinate', _ReferencePoint_referencePointCoordinate),
        (u'referencePointCoordinateHA', _ReferencePoint_referencePointCoordinateHA),
        (u'choice-Extension', _ReferencePoint_choice_Extension),
        ])
    ReferencePoint._ext = None
    
    #-----< ReferencePoint-ExtIEs >-----#
    ReferencePoint_ExtIEs = CLASS(name=u'ReferencePoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ReferencePoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoordinateID >-----#
    CoordinateID = INT(name=u'CoordinateID', mode=MODE_TYPE)
    CoordinateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< RelativeGeodeticLocation >-----#
    RelativeGeodeticLocation = SEQ(name=u'RelativeGeodeticLocation', mode=MODE_TYPE)
    _RelativeGeodeticLocation_milli_Arc_SecondUnits = ENUM(name=u'milli-Arc-SecondUnits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._cont = ASN1Dict([(u'zerodot03', 0), (u'zerodot3', 1), (u'three', 2)])
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._ext = []
    _RelativeGeodeticLocation_heightUnits = ENUM(name=u'heightUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_heightUnits._cont = ASN1Dict([(u'mm', 0), (u'cm', 1), (u'm', 2)])
    _RelativeGeodeticLocation_heightUnits._ext = []
    _RelativeGeodeticLocation_deltaLatitude = INT(name=u'deltaLatitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaLongitude = INT(name=u'deltaLongitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaHeight = INT(name=u'deltaHeight', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_locationUncertainty = SEQ(name=u'locationUncertainty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LocationUncertainty')))
    _RelativeGeodeticLocation_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeGeodeticLocation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RelativeGeodeticLocation_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__id_tab
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_at = None
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_id = u'id'
    ___RelativeGeodeticLocation_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __RelativeGeodeticLocation_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___RelativeGeodeticLocation_iE_extensions__item__id),
        (u'criticality', ___RelativeGeodeticLocation_iE_extensions__item__criticality),
        (u'extensionValue', ___RelativeGeodeticLocation_iE_extensions__item__extensionValue),
        ])
    __RelativeGeodeticLocation_iE_extensions__item_._ext = None
    _RelativeGeodeticLocation_iE_extensions._cont = __RelativeGeodeticLocation_iE_extensions__item_
    _RelativeGeodeticLocation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeGeodeticLocation._cont = ASN1Dict([
        (u'milli-Arc-SecondUnits', _RelativeGeodeticLocation_milli_Arc_SecondUnits),
        (u'heightUnits', _RelativeGeodeticLocation_heightUnits),
        (u'deltaLatitude', _RelativeGeodeticLocation_deltaLatitude),
        (u'deltaLongitude', _RelativeGeodeticLocation_deltaLongitude),
        (u'deltaHeight', _RelativeGeodeticLocation_deltaHeight),
        (u'locationUncertainty', _RelativeGeodeticLocation_locationUncertainty),
        (u'iE-extensions', _RelativeGeodeticLocation_iE_extensions),
        ])
    RelativeGeodeticLocation._ext = []
    
    #-----< RelativeGeodeticLocation-ExtIEs >-----#
    RelativeGeodeticLocation_ExtIEs = CLASS(name=u'RelativeGeodeticLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RelativeGeodeticLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeCartesianLocation >-----#
    RelativeCartesianLocation = SEQ(name=u'RelativeCartesianLocation', mode=MODE_TYPE)
    _RelativeCartesianLocation_xYZunit = ENUM(name=u'xYZunit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xYZunit._cont = ASN1Dict([(u'mm', 0), (u'cm', 1), (u'dm', 2)])
    _RelativeCartesianLocation_xYZunit._ext = []
    _RelativeCartesianLocation_xvalue = INT(name=u'xvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_yvalue = INT(name=u'yvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_yvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_zvalue = INT(name=u'zvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_zvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _RelativeCartesianLocation_locationUncertainty = SEQ(name=u'locationUncertainty', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LocationUncertainty')))
    _RelativeCartesianLocation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeCartesianLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RelativeCartesianLocation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__id_tab
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_at = None
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RelativeCartesianLocation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RelativeCartesianLocation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RelativeCartesianLocation_iE_Extensions__item__id),
        (u'criticality', ___RelativeCartesianLocation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RelativeCartesianLocation_iE_Extensions__item__extensionValue),
        ])
    __RelativeCartesianLocation_iE_Extensions__item_._ext = None
    _RelativeCartesianLocation_iE_Extensions._cont = __RelativeCartesianLocation_iE_Extensions__item_
    _RelativeCartesianLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeCartesianLocation._cont = ASN1Dict([
        (u'xYZunit', _RelativeCartesianLocation_xYZunit),
        (u'xvalue', _RelativeCartesianLocation_xvalue),
        (u'yvalue', _RelativeCartesianLocation_yvalue),
        (u'zvalue', _RelativeCartesianLocation_zvalue),
        (u'locationUncertainty', _RelativeCartesianLocation_locationUncertainty),
        (u'iE-Extensions', _RelativeCartesianLocation_iE_Extensions),
        ])
    RelativeCartesianLocation._ext = []
    
    #-----< RelativeCartesianLocation-ExtIEs >-----#
    RelativeCartesianLocation_ExtIEs = CLASS(name=u'RelativeCartesianLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RelativeCartesianLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativePathDelay >-----#
    RelativePathDelay = CHOICE(name=u'RelativePathDelay', mode=MODE_TYPE)
    _RelativePathDelay_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16351)], ev=None, er=[])
    _RelativePathDelay_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8176)], ev=None, er=[])
    _RelativePathDelay_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4088)], ev=None, er=[])
    _RelativePathDelay_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2044)], ev=None, er=[])
    _RelativePathDelay_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _RelativePathDelay_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _RelativePathDelay_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __RelativePathDelay_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___RelativePathDelay_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_id._const_tab = ___RelativePathDelay_choice_Extension_id_tab
    __RelativePathDelay_choice_Extension_id._const_tab_at = None
    __RelativePathDelay_choice_Extension_id._const_tab_id = u'id'
    __RelativePathDelay_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___RelativePathDelay_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_criticality._const_tab = ___RelativePathDelay_choice_Extension_criticality_tab
    __RelativePathDelay_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __RelativePathDelay_choice_Extension_criticality._const_tab_id = u'criticality'
    __RelativePathDelay_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___RelativePathDelay_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_value._const_tab = ___RelativePathDelay_choice_Extension_value_tab
    __RelativePathDelay_choice_Extension_value._const_tab_at = ('..', u'id')
    __RelativePathDelay_choice_Extension_value._const_tab_id = u'Value'
    _RelativePathDelay_choice_Extension._cont = ASN1Dict([
        (u'id', __RelativePathDelay_choice_Extension_id),
        (u'criticality', __RelativePathDelay_choice_Extension_criticality),
        (u'value', __RelativePathDelay_choice_Extension_value),
        ])
    _RelativePathDelay_choice_Extension._ext = None
    RelativePathDelay._cont = ASN1Dict([
        (u'k0', _RelativePathDelay_k0),
        (u'k1', _RelativePathDelay_k1),
        (u'k2', _RelativePathDelay_k2),
        (u'k3', _RelativePathDelay_k3),
        (u'k4', _RelativePathDelay_k4),
        (u'k5', _RelativePathDelay_k5),
        (u'choice-Extension', _RelativePathDelay_choice_Extension),
        ])
    RelativePathDelay._ext = None
    
    #-----< RelativePathDelay-ExtIEs >-----#
    RelativePathDelay_ExtIEs = CLASS(name=u'RelativePathDelay-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    RelativePathDelay_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = ENUM(name=u'ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._cont = ASN1Dict([(u'onDemand', 0), (u'periodic', 1)])
    ReportCharacteristics._ext = []
    
    #-----< RequestedSRSTransmissionCharacteristics >-----#
    RequestedSRSTransmissionCharacteristics = SEQ(name=u'RequestedSRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions = INT(name=u'numberOfTransmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=[], er=[])
    _RequestedSRSTransmissionCharacteristics_resourceType = ENUM(name=u'resourceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedSRSTransmissionCharacteristics_resourceType._cont = ASN1Dict([(u'periodic', 0), (u'semi-persistent', 1), (u'aperiodic', 2)])
    _RequestedSRSTransmissionCharacteristics_resourceType._ext = []
    _RequestedSRSTransmissionCharacteristics_bandwidth = CHOICE(name=u'bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BandwidthSRS')))
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet = SEQ_OF(name=u'listOfSRSResourceSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet-Item')))
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet._cont = __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _RequestedSRSTransmissionCharacteristics_sSBInformation = SEQ(name=u'sSBInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfo')), opt=True)
    _RequestedSRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SrsFrequency')))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Extension', _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = u'id'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id),
        (u'criticality', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        (u'extensionValue', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedSRSTransmissionCharacteristics._cont = ASN1Dict([
        (u'numberOfTransmissions', _RequestedSRSTransmissionCharacteristics_numberOfTransmissions),
        (u'resourceType', _RequestedSRSTransmissionCharacteristics_resourceType),
        (u'bandwidth', _RequestedSRSTransmissionCharacteristics_bandwidth),
        (u'listOfSRSResourceSet', _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet),
        (u'sSBInformation', _RequestedSRSTransmissionCharacteristics_sSBInformation),
        (u'iE-Extensions', _RequestedSRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedSRSTransmissionCharacteristics._ext = []
    
    #-----< RequestedSRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedSRSTransmissionCharacteristics_ExtIEs = CLASS(name=u'RequestedSRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SrsFrequency')))
    RequestedSRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Extension', _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSet-Item >-----#
    SRSResourceSet_Item = SEQ(name=u'SRSResourceSet-Item', mode=MODE_TYPE)
    _SRSResourceSet_Item_numberOfSRSResourcePerSet = INT(name=u'numberOfSRSResourcePerSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSResourceSet_Item_numberOfSRSResourcePerSet._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _SRSResourceSet_Item_periodicityList = SEQ_OF(name=u'periodicityList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PeriodicityList')), opt=True)
    _SRSResourceSet_Item_spatialRelationInformation = SEQ(name=u'spatialRelationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')), opt=True)
    _SRSResourceSet_Item_pathlossReferenceInformation = SEQ(name=u'pathlossReferenceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PathlossReferenceInformation')), opt=True)
    _SRSResourceSet_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    ____SRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceSet_Item_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceSet_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_Item_iE_Extensions__item_._ext = None
    _SRSResourceSet_Item_iE_Extensions._cont = __SRSResourceSet_Item_iE_Extensions__item_
    _SRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet_Item._cont = ASN1Dict([
        (u'numberOfSRSResourcePerSet', _SRSResourceSet_Item_numberOfSRSResourcePerSet),
        (u'periodicityList', _SRSResourceSet_Item_periodicityList),
        (u'spatialRelationInformation', _SRSResourceSet_Item_spatialRelationInformation),
        (u'pathlossReferenceInformation', _SRSResourceSet_Item_pathlossReferenceInformation),
        (u'iE-Extensions', _SRSResourceSet_Item_iE_Extensions),
        ])
    SRSResourceSet_Item._ext = []
    
    #-----< SRSResourceSet-Item-ExtIEs >-----#
    SRSResourceSet_Item_ExtIEs = CLASS(name=u'SRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _SRSResourceSet_Item_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    SRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _SRSResourceSet_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceSetType >-----#
    ResourceSetType = CHOICE(name=u'ResourceSetType', mode=MODE_TYPE)
    _ResourceSetType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypePeriodic')))
    _ResourceSetType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypeSemi-persistent')))
    _ResourceSetType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypeAperiodic')))
    _ResourceSetType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceSetType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ResourceSetType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_id._const_tab = ___ResourceSetType_choice_extension_id_tab
    __ResourceSetType_choice_extension_id._const_tab_at = None
    __ResourceSetType_choice_extension_id._const_tab_id = u'id'
    __ResourceSetType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_criticality._const_tab = ___ResourceSetType_choice_extension_criticality_tab
    __ResourceSetType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceSetType_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceSetType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ResourceSetType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_value._const_tab = ___ResourceSetType_choice_extension_value_tab
    __ResourceSetType_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceSetType_choice_extension_value._const_tab_id = u'Value'
    _ResourceSetType_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceSetType_choice_extension_id),
        (u'criticality', __ResourceSetType_choice_extension_criticality),
        (u'value', __ResourceSetType_choice_extension_value),
        ])
    _ResourceSetType_choice_extension._ext = None
    ResourceSetType._cont = ASN1Dict([
        (u'periodic', _ResourceSetType_periodic),
        (u'semi-persistent', _ResourceSetType_semi_persistent),
        (u'aperiodic', _ResourceSetType_aperiodic),
        (u'choice-extension', _ResourceSetType_choice_extension),
        ])
    ResourceSetType._ext = None
    
    #-----< ResourceSetType-ExtIEs >-----#
    ResourceSetType_ExtIEs = CLASS(name=u'ResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypePeriodic >-----#
    ResourceSetTypePeriodic = SEQ(name=u'ResourceSetTypePeriodic', mode=MODE_TYPE)
    _ResourceSetTypePeriodic_periodicSet = ENUM(name=u'periodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypePeriodic_periodicSet._cont = ASN1Dict([(u'true', 0)])
    _ResourceSetTypePeriodic_periodicSet._ext = []
    _ResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypePeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypePeriodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypePeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceSetTypePeriodic_iE_Extensions._cont = __ResourceSetTypePeriodic_iE_Extensions__item_
    _ResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypePeriodic._cont = ASN1Dict([
        (u'periodicSet', _ResourceSetTypePeriodic_periodicSet),
        (u'iE-Extensions', _ResourceSetTypePeriodic_iE_Extensions),
        ])
    ResourceSetTypePeriodic._ext = []
    
    #-----< ResourceSetTypePeriodic-ExtIEs >-----#
    ResourceSetTypePeriodic_ExtIEs = CLASS(name=u'ResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeSemi-persistent >-----#
    ResourceSetTypeSemi_persistent = SEQ(name=u'ResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceSetTypeSemi_persistent_semi_persistentSet = ENUM(name=u'semi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeSemi_persistent_semi_persistentSet._cont = ASN1Dict([(u'true', 0)])
    _ResourceSetTypeSemi_persistent_semi_persistentSet._ext = []
    _ResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceSetTypeSemi_persistent_iE_Extensions._cont = __ResourceSetTypeSemi_persistent_iE_Extensions__item_
    _ResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeSemi_persistent._cont = ASN1Dict([
        (u'semi-persistentSet', _ResourceSetTypeSemi_persistent_semi_persistentSet),
        (u'iE-Extensions', _ResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    ResourceSetTypeSemi_persistent._ext = []
    
    #-----< ResourceSetTypeSemi-persistent-ExtIEs >-----#
    ResourceSetTypeSemi_persistent_ExtIEs = CLASS(name=u'ResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeAperiodic >-----#
    ResourceSetTypeAperiodic = SEQ(name=u'ResourceSetTypeAperiodic', mode=MODE_TYPE)
    _ResourceSetTypeAperiodic_sRSResourceTrigger = INT(name=u'sRSResourceTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_sRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ResourceSetTypeAperiodic_slotoffset = INT(name=u'slotoffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_slotoffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceSetTypeAperiodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceSetTypeAperiodic_iE_Extensions._cont = __ResourceSetTypeAperiodic_iE_Extensions__item_
    _ResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeAperiodic._cont = ASN1Dict([
        (u'sRSResourceTrigger', _ResourceSetTypeAperiodic_sRSResourceTrigger),
        (u'slotoffset', _ResourceSetTypeAperiodic_slotoffset),
        (u'iE-Extensions', _ResourceSetTypeAperiodic_iE_Extensions),
        ])
    ResourceSetTypeAperiodic._ext = []
    
    #-----< ResourceSetTypeAperiodic-ExtIEs >-----#
    ResourceSetTypeAperiodic_ExtIEs = CLASS(name=u'ResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceType >-----#
    ResourceType = CHOICE(name=u'ResourceType', mode=MODE_TYPE)
    _ResourceType_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePeriodic')))
    _ResourceType_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeSemi-persistent')))
    _ResourceType_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeAperiodic')))
    _ResourceType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ResourceType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_id._const_tab = ___ResourceType_choice_extension_id_tab
    __ResourceType_choice_extension_id._const_tab_at = None
    __ResourceType_choice_extension_id._const_tab_id = u'id'
    __ResourceType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ResourceType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_criticality._const_tab = ___ResourceType_choice_extension_criticality_tab
    __ResourceType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceType_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ResourceType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_value._const_tab = ___ResourceType_choice_extension_value_tab
    __ResourceType_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceType_choice_extension_value._const_tab_id = u'Value'
    _ResourceType_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceType_choice_extension_id),
        (u'criticality', __ResourceType_choice_extension_criticality),
        (u'value', __ResourceType_choice_extension_value),
        ])
    _ResourceType_choice_extension._ext = None
    ResourceType._cont = ASN1Dict([
        (u'periodic', _ResourceType_periodic),
        (u'semi-persistent', _ResourceType_semi_persistent),
        (u'aperiodic', _ResourceType_aperiodic),
        (u'choice-extension', _ResourceType_choice_extension),
        ])
    ResourceType._ext = None
    
    #-----< ResourceType-ExtIEs >-----#
    ResourceType_ExtIEs = CLASS(name=u'ResourceType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodic >-----#
    ResourceTypePeriodic = SEQ(name=u'ResourceTypePeriodic', mode=MODE_TYPE)
    _ResourceTypePeriodic_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16)])
    _ResourceTypePeriodic_periodicity._ext = []
    _ResourceTypePeriodic_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypePeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypePeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypePeriodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypePeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceTypePeriodic_iE_Extensions._cont = __ResourceTypePeriodic_iE_Extensions__item_
    _ResourceTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodic._cont = ASN1Dict([
        (u'periodicity', _ResourceTypePeriodic_periodicity),
        (u'offset', _ResourceTypePeriodic_offset),
        (u'iE-Extensions', _ResourceTypePeriodic_iE_Extensions),
        ])
    ResourceTypePeriodic._ext = []
    
    #-----< ResourceTypePeriodic-ExtIEs >-----#
    ResourceTypePeriodic_ExtIEs = CLASS(name=u'ResourceTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistent >-----#
    ResourceTypeSemi_persistent = SEQ(name=u'ResourceTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceTypeSemi_persistent_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16)])
    _ResourceTypeSemi_persistent_periodicity._ext = []
    _ResourceTypeSemi_persistent_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypeSemi_persistent_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeSemi_persistent_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistent_iE_Extensions._cont = __ResourceTypeSemi_persistent_iE_Extensions__item_
    _ResourceTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistent._cont = ASN1Dict([
        (u'periodicity', _ResourceTypeSemi_persistent_periodicity),
        (u'offset', _ResourceTypeSemi_persistent_offset),
        (u'iE-Extensions', _ResourceTypeSemi_persistent_iE_Extensions),
        ])
    ResourceTypeSemi_persistent._ext = []
    
    #-----< ResourceTypeSemi-persistent-ExtIEs >-----#
    ResourceTypeSemi_persistent_ExtIEs = CLASS(name=u'ResourceTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodic >-----#
    ResourceTypeAperiodic = SEQ(name=u'ResourceTypeAperiodic', mode=MODE_TYPE)
    _ResourceTypeAperiodic_aperiodicResourceType = ENUM(name=u'aperiodicResourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodic_aperiodicResourceType._cont = ASN1Dict([(u'true', 0)])
    _ResourceTypeAperiodic_aperiodicResourceType._ext = []
    _ResourceTypeAperiodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeAperiodic_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeAperiodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodic_iE_Extensions._cont = __ResourceTypeAperiodic_iE_Extensions__item_
    _ResourceTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodic._cont = ASN1Dict([
        (u'aperiodicResourceType', _ResourceTypeAperiodic_aperiodicResourceType),
        (u'iE-Extensions', _ResourceTypeAperiodic_iE_Extensions),
        ])
    ResourceTypeAperiodic._ext = []
    
    #-----< ResourceTypeAperiodic-ExtIEs >-----#
    ResourceTypeAperiodic_ExtIEs = CLASS(name=u'ResourceTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePos >-----#
    ResourceTypePos = CHOICE(name=u'ResourceTypePos', mode=MODE_TYPE)
    _ResourceTypePos_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePeriodicPos')))
    _ResourceTypePos_semi_persistent = SEQ(name=u'semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeSemi-persistentPos')))
    _ResourceTypePos_aperiodic = SEQ(name=u'aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeAperiodicPos')))
    _ResourceTypePos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceTypePos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ResourceTypePos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_id._const_tab = ___ResourceTypePos_choice_extension_id_tab
    __ResourceTypePos_choice_extension_id._const_tab_at = None
    __ResourceTypePos_choice_extension_id._const_tab_id = u'id'
    __ResourceTypePos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ResourceTypePos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_criticality._const_tab = ___ResourceTypePos_choice_extension_criticality_tab
    __ResourceTypePos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ResourceTypePos_choice_extension_criticality._const_tab_id = u'criticality'
    __ResourceTypePos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ResourceTypePos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_value._const_tab = ___ResourceTypePos_choice_extension_value_tab
    __ResourceTypePos_choice_extension_value._const_tab_at = ('..', u'id')
    __ResourceTypePos_choice_extension_value._const_tab_id = u'Value'
    _ResourceTypePos_choice_extension._cont = ASN1Dict([
        (u'id', __ResourceTypePos_choice_extension_id),
        (u'criticality', __ResourceTypePos_choice_extension_criticality),
        (u'value', __ResourceTypePos_choice_extension_value),
        ])
    _ResourceTypePos_choice_extension._ext = None
    ResourceTypePos._cont = ASN1Dict([
        (u'periodic', _ResourceTypePos_periodic),
        (u'semi-persistent', _ResourceTypePos_semi_persistent),
        (u'aperiodic', _ResourceTypePos_aperiodic),
        (u'choice-extension', _ResourceTypePos_choice_extension),
        ])
    ResourceTypePos._ext = None
    
    #-----< ResourceTypePos-ExtIEs >-----#
    ResourceTypePos_ExtIEs = CLASS(name=u'ResourceTypePos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceTypePos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodicPos >-----#
    ResourceTypePeriodicPos = SEQ(name=u'ResourceTypePeriodicPos', mode=MODE_TYPE)
    _ResourceTypePeriodicPos_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16), (u'slot5120', 17), (u'slot10240', 18), (u'slot40960', 19), (u'slot81920', 20)])
    _ResourceTypePeriodicPos_periodicity._ext = []
    _ResourceTypePeriodicPos_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypePeriodicPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodicPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypePeriodicPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypePeriodicPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypePeriodicPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodicPos_iE_Extensions__item_._ext = None
    _ResourceTypePeriodicPos_iE_Extensions._cont = __ResourceTypePeriodicPos_iE_Extensions__item_
    _ResourceTypePeriodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodicPos._cont = ASN1Dict([
        (u'periodicity', _ResourceTypePeriodicPos_periodicity),
        (u'offset', _ResourceTypePeriodicPos_offset),
        (u'iE-Extensions', _ResourceTypePeriodicPos_iE_Extensions),
        ])
    ResourceTypePeriodicPos._ext = []
    
    #-----< ResourceTypePeriodicPos-ExtIEs >-----#
    ResourceTypePeriodicPos_ExtIEs = CLASS(name=u'ResourceTypePeriodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypePeriodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistentPos >-----#
    ResourceTypeSemi_persistentPos = SEQ(name=u'ResourceTypeSemi-persistentPos', mode=MODE_TYPE)
    _ResourceTypeSemi_persistentPos_periodicity = ENUM(name=u'periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_periodicity._cont = ASN1Dict([(u'slot1', 0), (u'slot2', 1), (u'slot4', 2), (u'slot5', 3), (u'slot8', 4), (u'slot10', 5), (u'slot16', 6), (u'slot20', 7), (u'slot32', 8), (u'slot40', 9), (u'slot64', 10), (u'slot80', 11), (u'slot160', 12), (u'slot320', 13), (u'slot640', 14), (u'slot1280', 15), (u'slot2560', 16), (u'slot5120', 17), (u'slot10240', 18), (u'slot40960', 19), (u'slot81920', 20)])
    _ResourceTypeSemi_persistentPos_periodicity._ext = []
    _ResourceTypeSemi_persistentPos_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypeSemi_persistentPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistentPos_iE_Extensions._cont = __ResourceTypeSemi_persistentPos_iE_Extensions__item_
    _ResourceTypeSemi_persistentPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistentPos._cont = ASN1Dict([
        (u'periodicity', _ResourceTypeSemi_persistentPos_periodicity),
        (u'offset', _ResourceTypeSemi_persistentPos_offset),
        (u'iE-Extensions', _ResourceTypeSemi_persistentPos_iE_Extensions),
        ])
    ResourceTypeSemi_persistentPos._ext = []
    
    #-----< ResourceTypeSemi-persistentPos-ExtIEs >-----#
    ResourceTypeSemi_persistentPos_ExtIEs = CLASS(name=u'ResourceTypeSemi-persistentPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistentPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodicPos >-----#
    ResourceTypeAperiodicPos = SEQ(name=u'ResourceTypeAperiodicPos', mode=MODE_TYPE)
    _ResourceTypeAperiodicPos_slotOffset = INT(name=u'slotOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodicPos_slotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceTypeAperiodicPos_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResourceTypeAperiodicPos_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResourceTypeAperiodicPos_iE_Extensions__item__id),
        (u'criticality', ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodicPos_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodicPos_iE_Extensions._cont = __ResourceTypeAperiodicPos_iE_Extensions__item_
    _ResourceTypeAperiodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodicPos._cont = ASN1Dict([
        (u'slotOffset', _ResourceTypeAperiodicPos_slotOffset),
        (u'iE-Extensions', _ResourceTypeAperiodicPos_iE_Extensions),
        ])
    ResourceTypeAperiodicPos._ext = []
    
    #-----< ResourceTypeAperiodicPos-ExtIEs >-----#
    ResourceTypeAperiodicPos_ExtIEs = CLASS(name=u'ResourceTypeAperiodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRP >-----#
    ResultCSI_RSRP = SEQ_OF(name=u'ResultCSI-RSRP', mode=MODE_TYPE)
    _ResultCSI_RSRP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-Item')))
    ResultCSI_RSRP._cont = _ResultCSI_RSRP__item_
    ResultCSI_RSRP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultCSI-RSRP-Item >-----#
    ResultCSI_RSRP_Item = SEQ(name=u'ResultCSI-RSRP-Item', mode=MODE_TYPE)
    _ResultCSI_RSRP_Item_nR_PCI = INT(name=u'nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultCSI_RSRP_Item_nR_ARFCN = INT(name=u'nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultCSI_RSRP_Item_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell = INT(name=u'valueCSI-RSRP-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS = SEQ_OF(name=u'cSI-RSRP-PerCSI-RS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-PerCSI-RS')), opt=True)
    _ResultCSI_RSRP_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRP_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultCSI_RSRP_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultCSI_RSRP_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRP_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRP_Item_iE_Extensions._cont = __ResultCSI_RSRP_Item_iE_Extensions__item_
    _ResultCSI_RSRP_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRP_Item._cont = ASN1Dict([
        (u'nR-PCI', _ResultCSI_RSRP_Item_nR_PCI),
        (u'nR-ARFCN', _ResultCSI_RSRP_Item_nR_ARFCN),
        (u'cGI-NR', _ResultCSI_RSRP_Item_cGI_NR),
        (u'valueCSI-RSRP-Cell', _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell),
        (u'cSI-RSRP-PerCSI-RS', _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS),
        (u'iE-Extensions', _ResultCSI_RSRP_Item_iE_Extensions),
        ])
    ResultCSI_RSRP_Item._ext = []
    
    #-----< ResultCSI-RSRP-Item-ExtIEs >-----#
    ResultCSI_RSRP_Item_ExtIEs = CLASS(name=u'ResultCSI-RSRP-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRP_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRP-PerCSI-RS >-----#
    ResultCSI_RSRP_PerCSI_RS = SEQ_OF(name=u'ResultCSI-RSRP-PerCSI-RS', mode=MODE_TYPE)
    _ResultCSI_RSRP_PerCSI_RS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-PerCSI-RS-Item')))
    ResultCSI_RSRP_PerCSI_RS._cont = _ResultCSI_RSRP_PerCSI_RS__item_
    ResultCSI_RSRP_PerCSI_RS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultCSI-RSRP-PerCSI-RS-Item >-----#
    ResultCSI_RSRP_PerCSI_RS_Item = SEQ(name=u'ResultCSI-RSRP-PerCSI-RS-Item', mode=MODE_TYPE)
    _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index = INT(name=u'cSI-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP = INT(name=u'valueCSI-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')))
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions._cont = __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRP_PerCSI_RS_Item._cont = ASN1Dict([
        (u'cSI-RS-Index', _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index),
        (u'valueCSI-RSRP', _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP),
        (u'iE-Extensions', _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions),
        ])
    ResultCSI_RSRP_PerCSI_RS_Item._ext = []
    
    #-----< ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs >-----#
    ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs = CLASS(name=u'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRQ >-----#
    ResultCSI_RSRQ = SEQ_OF(name=u'ResultCSI-RSRQ', mode=MODE_TYPE)
    _ResultCSI_RSRQ__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-Item')))
    ResultCSI_RSRQ._cont = _ResultCSI_RSRQ__item_
    ResultCSI_RSRQ._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultCSI-RSRQ-Item >-----#
    ResultCSI_RSRQ_Item = SEQ(name=u'ResultCSI-RSRQ-Item', mode=MODE_TYPE)
    _ResultCSI_RSRQ_Item_nR_PCI = INT(name=u'nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultCSI_RSRQ_Item_nR_ARFCN = INT(name=u'nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultCSI_RSRQ_Item_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell = INT(name=u'valueCSI-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS = SEQ_OF(name=u'cSI-RSRQ-PerCSI-RS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-PerCSI-RS')), opt=True)
    _ResultCSI_RSRQ_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRQ_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultCSI_RSRQ_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultCSI_RSRQ_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRQ_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRQ_Item_iE_Extensions._cont = __ResultCSI_RSRQ_Item_iE_Extensions__item_
    _ResultCSI_RSRQ_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRQ_Item._cont = ASN1Dict([
        (u'nR-PCI', _ResultCSI_RSRQ_Item_nR_PCI),
        (u'nR-ARFCN', _ResultCSI_RSRQ_Item_nR_ARFCN),
        (u'cGI-NR', _ResultCSI_RSRQ_Item_cGI_NR),
        (u'valueCSI-RSRQ-Cell', _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell),
        (u'cSI-RSRQ-PerCSI-RS', _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS),
        (u'iE-Extensions', _ResultCSI_RSRQ_Item_iE_Extensions),
        ])
    ResultCSI_RSRQ_Item._ext = []
    
    #-----< ResultCSI-RSRQ-Item-ExtIEs >-----#
    ResultCSI_RSRQ_Item_ExtIEs = CLASS(name=u'ResultCSI-RSRQ-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRQ_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRQ-PerCSI-RS >-----#
    ResultCSI_RSRQ_PerCSI_RS = SEQ_OF(name=u'ResultCSI-RSRQ-PerCSI-RS', mode=MODE_TYPE)
    _ResultCSI_RSRQ_PerCSI_RS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-PerCSI-RS-Item')))
    ResultCSI_RSRQ_PerCSI_RS._cont = _ResultCSI_RSRQ_PerCSI_RS__item_
    ResultCSI_RSRQ_PerCSI_RS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultCSI-RSRQ-PerCSI-RS-Item >-----#
    ResultCSI_RSRQ_PerCSI_RS_Item = SEQ(name=u'ResultCSI-RSRQ-PerCSI-RS-Item', mode=MODE_TYPE)
    _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index = INT(name=u'cSI-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ = INT(name=u'valueCSI-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')))
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions._cont = __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRQ_PerCSI_RS_Item._cont = ASN1Dict([
        (u'cSI-RS-Index', _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index),
        (u'valueCSI-RSRQ', _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ),
        (u'iE-Extensions', _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions),
        ])
    ResultCSI_RSRQ_PerCSI_RS_Item._ext = []
    
    #-----< ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs >-----#
    ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs = CLASS(name=u'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultEUTRA >-----#
    ResultEUTRA = SEQ_OF(name=u'ResultEUTRA', mode=MODE_TYPE)
    _ResultEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA-Item')))
    ResultEUTRA._cont = _ResultEUTRA__item_
    ResultEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultEUTRA-Item >-----#
    ResultEUTRA_Item = SEQ(name=u'ResultEUTRA-Item', mode=MODE_TYPE)
    _ResultEUTRA_Item_pCI_EUTRA = INT(name=u'pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultEUTRA_Item_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultEUTRA_Item_valueRSRP_EUTRA = INT(name=u'valueRSRP-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-EUTRA')), opt=True)
    _ResultEUTRA_Item_valueRSRQ_EUTRA = INT(name=u'valueRSRQ-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-EUTRA')), opt=True)
    _ResultEUTRA_Item_cGI_EUTRA = SEQ(name=u'cGI-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultEUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultEUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__id_tab
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultEUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultEUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultEUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultEUTRA_Item_iE_Extensions__item_._ext = None
    _ResultEUTRA_Item_iE_Extensions._cont = __ResultEUTRA_Item_iE_Extensions__item_
    _ResultEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultEUTRA_Item._cont = ASN1Dict([
        (u'pCI-EUTRA', _ResultEUTRA_Item_pCI_EUTRA),
        (u'eARFCN', _ResultEUTRA_Item_eARFCN),
        (u'valueRSRP-EUTRA', _ResultEUTRA_Item_valueRSRP_EUTRA),
        (u'valueRSRQ-EUTRA', _ResultEUTRA_Item_valueRSRQ_EUTRA),
        (u'cGI-EUTRA', _ResultEUTRA_Item_cGI_EUTRA),
        (u'iE-Extensions', _ResultEUTRA_Item_iE_Extensions),
        ])
    ResultEUTRA_Item._ext = []
    
    #-----< ResultEUTRA-Item-ExtIEs >-----#
    ResultEUTRA_Item_ExtIEs = CLASS(name=u'ResultEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultRSRP-EUTRA >-----#
    ResultRSRP_EUTRA = SEQ_OF(name=u'ResultRSRP-EUTRA', mode=MODE_TYPE)
    _ResultRSRP_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRP-EUTRA-Item')))
    ResultRSRP_EUTRA._cont = _ResultRSRP_EUTRA__item_
    ResultRSRP_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultRSRP-EUTRA-Item >-----#
    ResultRSRP_EUTRA_Item = SEQ(name=u'ResultRSRP-EUTRA-Item', mode=MODE_TYPE)
    _ResultRSRP_EUTRA_Item_pCI_EUTRA = INT(name=u'pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultRSRP_EUTRA_Item_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultRSRP_EUTRA_Item_cGI_EUTRA = SEQ(name=u'cGI-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA = INT(name=u'valueRSRP-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-EUTRA')))
    _ResultRSRP_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_._ext = None
    _ResultRSRP_EUTRA_Item_iE_Extensions._cont = __ResultRSRP_EUTRA_Item_iE_Extensions__item_
    _ResultRSRP_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultRSRP_EUTRA_Item._cont = ASN1Dict([
        (u'pCI-EUTRA', _ResultRSRP_EUTRA_Item_pCI_EUTRA),
        (u'eARFCN', _ResultRSRP_EUTRA_Item_eARFCN),
        (u'cGI-EUTRA', _ResultRSRP_EUTRA_Item_cGI_EUTRA),
        (u'valueRSRP-EUTRA', _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA),
        (u'iE-Extensions', _ResultRSRP_EUTRA_Item_iE_Extensions),
        ])
    ResultRSRP_EUTRA_Item._ext = []
    
    #-----< ResultRSRP-EUTRA-Item-ExtIEs >-----#
    ResultRSRP_EUTRA_Item_ExtIEs = CLASS(name=u'ResultRSRP-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultRSRP_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultRSRQ-EUTRA >-----#
    ResultRSRQ_EUTRA = SEQ_OF(name=u'ResultRSRQ-EUTRA', mode=MODE_TYPE)
    _ResultRSRQ_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRQ-EUTRA-Item')))
    ResultRSRQ_EUTRA._cont = _ResultRSRQ_EUTRA__item_
    ResultRSRQ_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultRSRQ-EUTRA-Item >-----#
    ResultRSRQ_EUTRA_Item = SEQ(name=u'ResultRSRQ-EUTRA-Item', mode=MODE_TYPE)
    _ResultRSRQ_EUTRA_Item_pCI_EUTRA = INT(name=u'pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultRSRQ_EUTRA_Item_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultRSRQ_EUTRA_Item_cGI_UTRA = SEQ(name=u'cGI-UTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA = INT(name=u'valueRSRQ-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-EUTRA')))
    _ResultRSRQ_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_._ext = None
    _ResultRSRQ_EUTRA_Item_iE_Extensions._cont = __ResultRSRQ_EUTRA_Item_iE_Extensions__item_
    _ResultRSRQ_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultRSRQ_EUTRA_Item._cont = ASN1Dict([
        (u'pCI-EUTRA', _ResultRSRQ_EUTRA_Item_pCI_EUTRA),
        (u'eARFCN', _ResultRSRQ_EUTRA_Item_eARFCN),
        (u'cGI-UTRA', _ResultRSRQ_EUTRA_Item_cGI_UTRA),
        (u'valueRSRQ-EUTRA', _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA),
        (u'iE-Extensions', _ResultRSRQ_EUTRA_Item_iE_Extensions),
        ])
    ResultRSRQ_EUTRA_Item._ext = []
    
    #-----< ResultRSRQ-EUTRA-Item-ExtIEs >-----#
    ResultRSRQ_EUTRA_Item_ExtIEs = CLASS(name=u'ResultRSRQ-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultRSRQ_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRP >-----#
    ResultSS_RSRP = SEQ_OF(name=u'ResultSS-RSRP', mode=MODE_TYPE)
    _ResultSS_RSRP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-Item')))
    ResultSS_RSRP._cont = _ResultSS_RSRP__item_
    ResultSS_RSRP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultSS-RSRP-Item >-----#
    ResultSS_RSRP_Item = SEQ(name=u'ResultSS-RSRP-Item', mode=MODE_TYPE)
    _ResultSS_RSRP_Item_nR_PCI = INT(name=u'nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultSS_RSRP_Item_nR_ARFCN = INT(name=u'nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultSS_RSRP_Item_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultSS_RSRP_Item_valueSS_RSRP_Cell = INT(name=u'valueSS-RSRP-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultSS_RSRP_Item_sS_RSRP_PerSSB = SEQ_OF(name=u'sS-RSRP-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB')), opt=True)
    _ResultSS_RSRP_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRP_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRP_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultSS_RSRP_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultSS_RSRP_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultSS_RSRP_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRP_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRP_Item_iE_Extensions._cont = __ResultSS_RSRP_Item_iE_Extensions__item_
    _ResultSS_RSRP_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRP_Item._cont = ASN1Dict([
        (u'nR-PCI', _ResultSS_RSRP_Item_nR_PCI),
        (u'nR-ARFCN', _ResultSS_RSRP_Item_nR_ARFCN),
        (u'cGI-NR', _ResultSS_RSRP_Item_cGI_NR),
        (u'valueSS-RSRP-Cell', _ResultSS_RSRP_Item_valueSS_RSRP_Cell),
        (u'sS-RSRP-PerSSB', _ResultSS_RSRP_Item_sS_RSRP_PerSSB),
        (u'iE-Extensions', _ResultSS_RSRP_Item_iE_Extensions),
        ])
    ResultSS_RSRP_Item._ext = []
    
    #-----< ResultSS-RSRP-Item-ExtIEs >-----#
    ResultSS_RSRP_Item_ExtIEs = CLASS(name=u'ResultSS-RSRP-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRP_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRP-PerSSB >-----#
    ResultSS_RSRP_PerSSB = SEQ_OF(name=u'ResultSS-RSRP-PerSSB', mode=MODE_TYPE)
    _ResultSS_RSRP_PerSSB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB-Item')))
    ResultSS_RSRP_PerSSB._cont = _ResultSS_RSRP_PerSSB__item_
    ResultSS_RSRP_PerSSB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultSS-RSRP-PerSSB-Item >-----#
    ResultSS_RSRP_PerSSB_Item = SEQ(name=u'ResultSS-RSRP-PerSSB-Item', mode=MODE_TYPE)
    _ResultSS_RSRP_PerSSB_Item_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')))
    _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP = INT(name=u'valueSS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')))
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions._cont = __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRP_PerSSB_Item._cont = ASN1Dict([
        (u'sSB-Index', _ResultSS_RSRP_PerSSB_Item_sSB_Index),
        (u'valueSS-RSRP', _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP),
        (u'iE-Extensions', _ResultSS_RSRP_PerSSB_Item_iE_Extensions),
        ])
    ResultSS_RSRP_PerSSB_Item._ext = []
    
    #-----< ResultSS-RSRP-PerSSB-Item-ExtIEs >-----#
    ResultSS_RSRP_PerSSB_Item_ExtIEs = CLASS(name=u'ResultSS-RSRP-PerSSB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRP_PerSSB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRQ >-----#
    ResultSS_RSRQ = SEQ_OF(name=u'ResultSS-RSRQ', mode=MODE_TYPE)
    _ResultSS_RSRQ__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-Item')))
    ResultSS_RSRQ._cont = _ResultSS_RSRQ__item_
    ResultSS_RSRQ._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultSS-RSRQ-Item >-----#
    ResultSS_RSRQ_Item = SEQ(name=u'ResultSS-RSRQ-Item', mode=MODE_TYPE)
    _ResultSS_RSRQ_Item_nR_PCI = INT(name=u'nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultSS_RSRQ_Item_nR_ARFCN = INT(name=u'nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultSS_RSRQ_Item_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell = INT(name=u'valueSS-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB = SEQ_OF(name=u'sS-RSRQ-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB')), opt=True)
    _ResultSS_RSRQ_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRQ_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultSS_RSRQ_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultSS_RSRQ_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRQ_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRQ_Item_iE_Extensions._cont = __ResultSS_RSRQ_Item_iE_Extensions__item_
    _ResultSS_RSRQ_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRQ_Item._cont = ASN1Dict([
        (u'nR-PCI', _ResultSS_RSRQ_Item_nR_PCI),
        (u'nR-ARFCN', _ResultSS_RSRQ_Item_nR_ARFCN),
        (u'cGI-NR', _ResultSS_RSRQ_Item_cGI_NR),
        (u'valueSS-RSRQ-Cell', _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell),
        (u'sS-RSRQ-PerSSB', _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB),
        (u'iE-Extensions', _ResultSS_RSRQ_Item_iE_Extensions),
        ])
    ResultSS_RSRQ_Item._ext = []
    
    #-----< ResultSS-RSRQ-Item-ExtIEs >-----#
    ResultSS_RSRQ_Item_ExtIEs = CLASS(name=u'ResultSS-RSRQ-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRQ_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRQ-PerSSB >-----#
    ResultSS_RSRQ_PerSSB = SEQ_OF(name=u'ResultSS-RSRQ-PerSSB', mode=MODE_TYPE)
    _ResultSS_RSRQ_PerSSB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB-Item')))
    ResultSS_RSRQ_PerSSB._cont = _ResultSS_RSRQ_PerSSB__item_
    ResultSS_RSRQ_PerSSB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultSS-RSRQ-PerSSB-Item >-----#
    ResultSS_RSRQ_PerSSB_Item = SEQ(name=u'ResultSS-RSRQ-PerSSB-Item', mode=MODE_TYPE)
    _ResultSS_RSRQ_PerSSB_Item_sSB_Index = INT(name=u'sSB-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')))
    _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ = INT(name=u'valueSS-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')))
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions._cont = __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRQ_PerSSB_Item._cont = ASN1Dict([
        (u'sSB-Index', _ResultSS_RSRQ_PerSSB_Item_sSB_Index),
        (u'valueSS-RSRQ', _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ),
        (u'iE-Extensions', _ResultSS_RSRQ_PerSSB_Item_iE_Extensions),
        ])
    ResultSS_RSRQ_PerSSB_Item._ext = []
    
    #-----< ResultSS-RSRQ-PerSSB-Item-ExtIEs >-----#
    ResultSS_RSRQ_PerSSB_Item_ExtIEs = CLASS(name=u'ResultSS-RSRQ-PerSSB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRQ_PerSSB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultGERAN >-----#
    ResultGERAN = SEQ_OF(name=u'ResultGERAN', mode=MODE_TYPE)
    _ResultGERAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultGERAN-Item')))
    ResultGERAN._cont = _ResultGERAN__item_
    ResultGERAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultGERAN-Item >-----#
    ResultGERAN_Item = SEQ(name=u'ResultGERAN-Item', mode=MODE_TYPE)
    _ResultGERAN_Item_bCCH = INT(name=u'bCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BCCH')))
    _ResultGERAN_Item_physCellIDGERAN = INT(name=u'physCellIDGERAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDGERAN')))
    _ResultGERAN_Item_rSSI = INT(name=u'rSSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RSSI')))
    _ResultGERAN_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultGERAN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultGERAN_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultGERAN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab = ____ResultGERAN_Item_iE_Extensions__item__id_tab
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultGERAN_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultGERAN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab = ____ResultGERAN_Item_iE_Extensions__item__criticality_tab
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultGERAN_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultGERAN_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultGERAN_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultGERAN_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultGERAN_Item_iE_Extensions__item_._ext = None
    _ResultGERAN_Item_iE_Extensions._cont = __ResultGERAN_Item_iE_Extensions__item_
    _ResultGERAN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultGERAN_Item._cont = ASN1Dict([
        (u'bCCH', _ResultGERAN_Item_bCCH),
        (u'physCellIDGERAN', _ResultGERAN_Item_physCellIDGERAN),
        (u'rSSI', _ResultGERAN_Item_rSSI),
        (u'iE-Extensions', _ResultGERAN_Item_iE_Extensions),
        ])
    ResultGERAN_Item._ext = []
    
    #-----< ResultGERAN-Item-ExtIEs >-----#
    ResultGERAN_Item_ExtIEs = CLASS(name=u'ResultGERAN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultGERAN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultNR >-----#
    ResultNR = SEQ_OF(name=u'ResultNR', mode=MODE_TYPE)
    _ResultNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR-Item')))
    ResultNR._cont = _ResultNR__item_
    ResultNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultNR-Item >-----#
    ResultNR_Item = SEQ(name=u'ResultNR-Item', mode=MODE_TYPE)
    _ResultNR_Item_nR_PCI = INT(name=u'nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultNR_Item_nR_ARFCN = INT(name=u'nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultNR_Item_valueSS_RSRP_Cell = INT(name=u'valueSS-RSRP-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultNR_Item_valueSS_RSRQ_Cell = INT(name=u'valueSS-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultNR_Item_sS_RSRP_PerSSB = SEQ_OF(name=u'sS-RSRP-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB')), opt=True)
    _ResultNR_Item_sS_RSRQ_PerSSB = SEQ_OF(name=u'sS-RSRQ-PerSSB', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB')), opt=True)
    _ResultNR_Item_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultNR_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultNR_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__id._const_tab = ____ResultNR_Item_iE_Extensions__item__id_tab
    ___ResultNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultNR_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultNR_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab = ____ResultNR_Item_iE_Extensions__item__criticality_tab
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultNR_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultNR_Item_iE_Extensions__item__extensionValue_tab
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultNR_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultNR_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultNR_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultNR_Item_iE_Extensions__item_._ext = None
    _ResultNR_Item_iE_Extensions._cont = __ResultNR_Item_iE_Extensions__item_
    _ResultNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultNR_Item._cont = ASN1Dict([
        (u'nR-PCI', _ResultNR_Item_nR_PCI),
        (u'nR-ARFCN', _ResultNR_Item_nR_ARFCN),
        (u'valueSS-RSRP-Cell', _ResultNR_Item_valueSS_RSRP_Cell),
        (u'valueSS-RSRQ-Cell', _ResultNR_Item_valueSS_RSRQ_Cell),
        (u'sS-RSRP-PerSSB', _ResultNR_Item_sS_RSRP_PerSSB),
        (u'sS-RSRQ-PerSSB', _ResultNR_Item_sS_RSRQ_PerSSB),
        (u'cGI-NR', _ResultNR_Item_cGI_NR),
        (u'iE-Extensions', _ResultNR_Item_iE_Extensions),
        ])
    ResultNR_Item._ext = []
    
    #-----< ResultNR-Item-ExtIEs >-----#
    ResultNR_Item_ExtIEs = CLASS(name=u'ResultNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultUTRAN >-----#
    ResultUTRAN = SEQ_OF(name=u'ResultUTRAN', mode=MODE_TYPE)
    _ResultUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultUTRAN-Item')))
    ResultUTRAN._cont = _ResultUTRAN__item_
    ResultUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultUTRAN-Item >-----#
    ResultUTRAN_Item = SEQ(name=u'ResultUTRAN-Item', mode=MODE_TYPE)
    _ResultUTRAN_Item_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UARFCN')))
    _ResultUTRAN_Item_physCellIDUTRAN = CHOICE(name=u'physCellIDUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD = INT(name=u'physCellIDUTRA-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDUTRA-FDD')))
    __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD = INT(name=u'physCellIDUTRA-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDUTRA-TDD')))
    _ResultUTRAN_Item_physCellIDUTRAN._cont = ASN1Dict([
        (u'physCellIDUTRA-FDD', __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD),
        (u'physCellIDUTRA-TDD', __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD),
        ])
    _ResultUTRAN_Item_physCellIDUTRAN._ext = None
    _ResultUTRAN_Item_uTRA_RSCP = INT(name=u'uTRA-RSCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UTRA-RSCP')), opt=True)
    _ResultUTRAN_Item_uTRA_EcN0 = INT(name=u'uTRA-EcN0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UTRA-EcN0')), opt=True)
    _ResultUTRAN_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultUTRAN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultUTRAN_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____ResultUTRAN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__id_tab
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResultUTRAN_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResultUTRAN_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResultUTRAN_Item_iE_Extensions__item__id),
        (u'criticality', ___ResultUTRAN_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResultUTRAN_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultUTRAN_Item_iE_Extensions__item_._ext = None
    _ResultUTRAN_Item_iE_Extensions._cont = __ResultUTRAN_Item_iE_Extensions__item_
    _ResultUTRAN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultUTRAN_Item._cont = ASN1Dict([
        (u'uARFCN', _ResultUTRAN_Item_uARFCN),
        (u'physCellIDUTRAN', _ResultUTRAN_Item_physCellIDUTRAN),
        (u'uTRA-RSCP', _ResultUTRAN_Item_uTRA_RSCP),
        (u'uTRA-EcN0', _ResultUTRAN_Item_uTRA_EcN0),
        (u'iE-Extensions', _ResultUTRAN_Item_iE_Extensions),
        ])
    ResultUTRAN_Item._ext = []
    
    #-----< ResultUTRAN-Item-ExtIEs >-----#
    ResultUTRAN_Item_ExtIEs = CLASS(name=u'ResultUTRAN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultUTRAN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSSI >-----#
    RSSI = INT(name=u'RSSI', mode=MODE_TYPE)
    RSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< SCS-SpecificCarrier >-----#
    SCS_SpecificCarrier = SEQ(name=u'SCS-SpecificCarrier', mode=MODE_TYPE)
    _SCS_SpecificCarrier_offsetToCarrier = INT(name=u'offsetToCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _SCS_SpecificCarrier_subcarrierSpacing = ENUM(name=u'subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_subcarrierSpacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3)])
    _SCS_SpecificCarrier_subcarrierSpacing._ext = []
    _SCS_SpecificCarrier_carrierBandwidth = INT(name=u'carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=275)], ev=[], er=[])
    _SCS_SpecificCarrier_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCS_SpecificCarrier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SCS_SpecificCarrier_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__id_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_at = None
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_id = u'id'
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SCS_SpecificCarrier_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SCS_SpecificCarrier_iE_Extensions__item__id),
        (u'criticality', ___SCS_SpecificCarrier_iE_Extensions__item__criticality),
        (u'extensionValue', ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue),
        ])
    __SCS_SpecificCarrier_iE_Extensions__item_._ext = None
    _SCS_SpecificCarrier_iE_Extensions._cont = __SCS_SpecificCarrier_iE_Extensions__item_
    _SCS_SpecificCarrier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCS_SpecificCarrier._cont = ASN1Dict([
        (u'offsetToCarrier', _SCS_SpecificCarrier_offsetToCarrier),
        (u'subcarrierSpacing', _SCS_SpecificCarrier_subcarrierSpacing),
        (u'carrierBandwidth', _SCS_SpecificCarrier_carrierBandwidth),
        (u'iE-Extensions', _SCS_SpecificCarrier_iE_Extensions),
        ])
    SCS_SpecificCarrier._ext = []
    
    #-----< SCS-SpecificCarrier-ExtIEs >-----#
    SCS_SpecificCarrier_ExtIEs = CLASS(name=u'SCS-SpecificCarrier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SCS_SpecificCarrier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Search-window-information >-----#
    Search_window_information = SEQ(name=u'Search-window-information', mode=MODE_TYPE)
    _Search_window_information_expectedPropagationDelay = INT(name=u'expectedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_expectedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-3841, ub=3841)], ev=[], er=[])
    _Search_window_information_delayUncertainty = INT(name=u'delayUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_delayUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=246)], ev=[], er=[])
    _Search_window_information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Search_window_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Search_window_information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____Search_window_information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__id._const_tab = ____Search_window_information_iE_Extensions__item__id_tab
    ___Search_window_information_iE_Extensions__item__id._const_tab_at = None
    ___Search_window_information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Search_window_information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Search_window_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__criticality._const_tab = ____Search_window_information_iE_Extensions__item__criticality_tab
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Search_window_information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab = ____Search_window_information_iE_Extensions__item__extensionValue_tab
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Search_window_information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Search_window_information_iE_Extensions__item__id),
        (u'criticality', ___Search_window_information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Search_window_information_iE_Extensions__item__extensionValue),
        ])
    __Search_window_information_iE_Extensions__item_._ext = None
    _Search_window_information_iE_Extensions._cont = __Search_window_information_iE_Extensions__item_
    _Search_window_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Search_window_information._cont = ASN1Dict([
        (u'expectedPropagationDelay', _Search_window_information_expectedPropagationDelay),
        (u'delayUncertainty', _Search_window_information_delayUncertainty),
        (u'iE-Extensions', _Search_window_information_iE_Extensions),
        ])
    Search_window_information._ext = []
    
    #-----< Search-window-information-ExtIEs >-----#
    Search_window_information_ExtIEs = CLASS(name=u'Search-window-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Search_window_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeTime1900 >-----#
    RelativeTime1900 = BIT_STR(name=u'RelativeTime1900', mode=MODE_TYPE)
    RelativeTime1900._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< SFNInitialisationTime-EUTRA >-----#
    SFNInitialisationTime_EUTRA = BIT_STR(name=u'SFNInitialisationTime-EUTRA', mode=MODE_TYPE)
    SFNInitialisationTime_EUTRA._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< SlotNumber >-----#
    SlotNumber = INT(name=u'SlotNumber', mode=MODE_TYPE)
    SlotNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    
    #-----< SpatialDirectionInformation >-----#
    SpatialDirectionInformation = SEQ(name=u'SpatialDirectionInformation', mode=MODE_TYPE)
    _SpatialDirectionInformation_nR_PRS_Beam_Information = SEQ(name=u'nR-PRS-Beam-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PRS-Beam-Information')))
    _SpatialDirectionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialDirectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialDirectionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__id_tab
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialDirectionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialDirectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialDirectionInformation_iE_Extensions__item__id),
        (u'criticality', ___SpatialDirectionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialDirectionInformation_iE_Extensions__item__extensionValue),
        ])
    __SpatialDirectionInformation_iE_Extensions__item_._ext = None
    _SpatialDirectionInformation_iE_Extensions._cont = __SpatialDirectionInformation_iE_Extensions__item_
    _SpatialDirectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialDirectionInformation._cont = ASN1Dict([
        (u'nR-PRS-Beam-Information', _SpatialDirectionInformation_nR_PRS_Beam_Information),
        (u'iE-Extensions', _SpatialDirectionInformation_iE_Extensions),
        ])
    SpatialDirectionInformation._ext = []
    
    #-----< SpatialDirectionInformation-ExtIEs >-----#
    SpatialDirectionInformation_ExtIEs = CLASS(name=u'SpatialDirectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialDirectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationInfo >-----#
    SpatialRelationInfo = SEQ(name=u'SpatialRelationInfo', mode=MODE_TYPE)
    _SpatialRelationInfo_spatialRelationforResourceID = SEQ_OF(name=u'spatialRelationforResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationforResourceID')))
    _SpatialRelationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab = ____SpatialRelationInfo_iE_Extensions__item__id_tab
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab = ____SpatialRelationInfo_iE_Extensions__item__criticality_tab
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationInfo_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationInfo_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationInfo_iE_Extensions__item_._ext = None
    _SpatialRelationInfo_iE_Extensions._cont = __SpatialRelationInfo_iE_Extensions__item_
    _SpatialRelationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationInfo._cont = ASN1Dict([
        (u'spatialRelationforResourceID', _SpatialRelationInfo_spatialRelationforResourceID),
        (u'iE-Extensions', _SpatialRelationInfo_iE_Extensions),
        ])
    SpatialRelationInfo._ext = []
    
    #-----< SpatialRelationInfo-ExtIEs >-----#
    SpatialRelationInfo_ExtIEs = CLASS(name=u'SpatialRelationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationforResourceID >-----#
    SpatialRelationforResourceID = SEQ_OF(name=u'SpatialRelationforResourceID', mode=MODE_TYPE)
    _SpatialRelationforResourceID__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationforResourceIDItem')))
    SpatialRelationforResourceID._cont = _SpatialRelationforResourceID__item_
    SpatialRelationforResourceID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SpatialRelationforResourceIDItem >-----#
    SpatialRelationforResourceIDItem = SEQ(name=u'SpatialRelationforResourceIDItem', mode=MODE_TYPE)
    _SpatialRelationforResourceIDItem_referenceSignal = CHOICE(name=u'referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferenceSignal')))
    _SpatialRelationforResourceIDItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationforResourceIDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationforResourceIDItem_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._ext = None
    _SpatialRelationforResourceIDItem_iE_Extensions._cont = __SpatialRelationforResourceIDItem_iE_Extensions__item_
    _SpatialRelationforResourceIDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationforResourceIDItem._cont = ASN1Dict([
        (u'referenceSignal', _SpatialRelationforResourceIDItem_referenceSignal),
        (u'iE-Extensions', _SpatialRelationforResourceIDItem_iE_Extensions),
        ])
    SpatialRelationforResourceIDItem._ext = []
    
    #-----< SpatialRelationforResourceIDItem-ExtIEs >-----#
    SpatialRelationforResourceIDItem_ExtIEs = CLASS(name=u'SpatialRelationforResourceIDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationforResourceIDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource >-----#
    SpatialRelationPerSRSResource = SEQ(name=u'SpatialRelationPerSRSResource', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List = SEQ_OF(name=u'spatialRelationPerSRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource-List')))
    _SpatialRelationPerSRSResource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationPerSRSResource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationPerSRSResource_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResource_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResource_iE_Extensions._cont = __SpatialRelationPerSRSResource_iE_Extensions__item_
    _SpatialRelationPerSRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResource._cont = ASN1Dict([
        (u'spatialRelationPerSRSResource-List', _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List),
        (u'iE-Extensions', _SpatialRelationPerSRSResource_iE_Extensions),
        ])
    SpatialRelationPerSRSResource._ext = []
    
    #-----< SpatialRelationPerSRSResource-ExtIEs >-----#
    SpatialRelationPerSRSResource_ExtIEs = CLASS(name=u'SpatialRelationPerSRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource-List >-----#
    SpatialRelationPerSRSResource_List = SEQ_OF(name=u'SpatialRelationPerSRSResource-List', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResourceItem')))
    SpatialRelationPerSRSResource_List._cont = _SpatialRelationPerSRSResource_List__item_
    SpatialRelationPerSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SpatialRelationPerSRSResourceItem >-----#
    SpatialRelationPerSRSResourceItem = SEQ(name=u'SpatialRelationPerSRSResourceItem', mode=MODE_TYPE)
    _SpatialRelationPerSRSResourceItem_referenceSignal = CHOICE(name=u'referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferenceSignal')))
    _SpatialRelationPerSRSResourceItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id),
        (u'criticality', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResourceItem_iE_Extensions._cont = __SpatialRelationPerSRSResourceItem_iE_Extensions__item_
    _SpatialRelationPerSRSResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResourceItem._cont = ASN1Dict([
        (u'referenceSignal', _SpatialRelationPerSRSResourceItem_referenceSignal),
        (u'iE-Extensions', _SpatialRelationPerSRSResourceItem_iE_Extensions),
        ])
    SpatialRelationPerSRSResourceItem._ext = []
    
    #-----< SpatialRelationPerSRSResourceItem-ExtIEs >-----#
    SpatialRelationPerSRSResourceItem_ExtIEs = CLASS(name=u'SpatialRelationPerSRSResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResourceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPos >-----#
    SpatialRelationPos = CHOICE(name=u'SpatialRelationPos', mode=MODE_TYPE)
    _SpatialRelationPos_sSBPos = SEQ(name=u'sSBPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _SpatialRelationPos_pRSInformationPos = SEQ(name=u'pRSInformationPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSInformationPos')))
    _SpatialRelationPos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SpatialRelationPos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___SpatialRelationPos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_id._const_tab = ___SpatialRelationPos_choice_extension_id_tab
    __SpatialRelationPos_choice_extension_id._const_tab_at = None
    __SpatialRelationPos_choice_extension_id._const_tab_id = u'id'
    __SpatialRelationPos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___SpatialRelationPos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_criticality._const_tab = ___SpatialRelationPos_choice_extension_criticality_tab
    __SpatialRelationPos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SpatialRelationPos_choice_extension_criticality._const_tab_id = u'criticality'
    __SpatialRelationPos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___SpatialRelationPos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_value._const_tab = ___SpatialRelationPos_choice_extension_value_tab
    __SpatialRelationPos_choice_extension_value._const_tab_at = ('..', u'id')
    __SpatialRelationPos_choice_extension_value._const_tab_id = u'Value'
    _SpatialRelationPos_choice_extension._cont = ASN1Dict([
        (u'id', __SpatialRelationPos_choice_extension_id),
        (u'criticality', __SpatialRelationPos_choice_extension_criticality),
        (u'value', __SpatialRelationPos_choice_extension_value),
        ])
    _SpatialRelationPos_choice_extension._ext = None
    SpatialRelationPos._cont = ASN1Dict([
        (u'sSBPos', _SpatialRelationPos_sSBPos),
        (u'pRSInformationPos', _SpatialRelationPos_pRSInformationPos),
        (u'choice-extension', _SpatialRelationPos_choice_extension),
        ])
    SpatialRelationPos._ext = None
    
    #-----< SpatialInformationPos-ExtIEs >-----#
    SpatialInformationPos_ExtIEs = CLASS(name=u'SpatialInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SpatialInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfig >-----#
    SRSConfig = SEQ(name=u'SRSConfig', mode=MODE_TYPE)
    _SRSConfig_sRSResource_List = SEQ_OF(name=u'sRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResource-List')), opt=True)
    _SRSConfig_posSRSResource_List = SEQ_OF(name=u'posSRSResource-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResource-List')), opt=True)
    _SRSConfig_sRSResourceSet_List = SEQ_OF(name=u'sRSResourceSet-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet-List')), opt=True)
    _SRSConfig_posSRSResourceSet_List = SEQ_OF(name=u'posSRSResourceSet-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceSet-List')), opt=True)
    _SRSConfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSConfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__id._const_tab = ____SRSConfig_iE_Extensions__item__id_tab
    ___SRSConfig_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSConfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__criticality._const_tab = ____SRSConfig_iE_Extensions__item__criticality_tab
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSConfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab = ____SRSConfig_iE_Extensions__item__extensionValue_tab
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSConfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSConfig_iE_Extensions__item__id),
        (u'criticality', ___SRSConfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSConfig_iE_Extensions__item__extensionValue),
        ])
    __SRSConfig_iE_Extensions__item_._ext = None
    _SRSConfig_iE_Extensions._cont = __SRSConfig_iE_Extensions__item_
    _SRSConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfig._cont = ASN1Dict([
        (u'sRSResource-List', _SRSConfig_sRSResource_List),
        (u'posSRSResource-List', _SRSConfig_posSRSResource_List),
        (u'sRSResourceSet-List', _SRSConfig_sRSResourceSet_List),
        (u'posSRSResourceSet-List', _SRSConfig_posSRSResourceSet_List),
        (u'iE-Extensions', _SRSConfig_iE_Extensions),
        ])
    SRSConfig._ext = []
    
    #-----< SRSConfig-ExtIEs >-----#
    SRSConfig_ExtIEs = CLASS(name=u'SRSConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSCarrier-List >-----#
    SRSCarrier_List = SEQ_OF(name=u'SRSCarrier-List', mode=MODE_TYPE)
    _SRSCarrier_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSCarrier-List-Item')))
    SRSCarrier_List._cont = _SRSCarrier_List__item_
    SRSCarrier_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRSCarrier-List-Item >-----#
    SRSCarrier_List_Item = SEQ(name=u'SRSCarrier-List-Item', mode=MODE_TYPE)
    _SRSCarrier_List_Item_pointA = INT(name=u'pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSCarrier_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List = SEQ_OF(name=u'uplinkChannelBW-PerSCS-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UplinkChannelBW-PerSCS-List')))
    _SRSCarrier_List_Item_activeULBWP = SEQ(name=u'activeULBWP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ActiveULBWP')))
    _SRSCarrier_List_Item_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSCarrier_List_Item_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SRSCarrier_List_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSCarrier_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSCarrier_List_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__id_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSCarrier_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSCarrier_List_Item_iE_Extensions__item__id),
        (u'criticality', ___SRSCarrier_List_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSCarrier_List_Item_iE_Extensions__item_._ext = None
    _SRSCarrier_List_Item_iE_Extensions._cont = __SRSCarrier_List_Item_iE_Extensions__item_
    _SRSCarrier_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSCarrier_List_Item._cont = ASN1Dict([
        (u'pointA', _SRSCarrier_List_Item_pointA),
        (u'uplinkChannelBW-PerSCS-List', _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List),
        (u'activeULBWP', _SRSCarrier_List_Item_activeULBWP),
        (u'pCI-NR', _SRSCarrier_List_Item_pCI_NR),
        (u'iE-Extensions', _SRSCarrier_List_Item_iE_Extensions),
        ])
    SRSCarrier_List_Item._ext = []
    
    #-----< SRSCarrier-List-Item-ExtIEs >-----#
    SRSCarrier_List_Item_ExtIEs = CLASS(name=u'SRSCarrier-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSCarrier_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfiguration >-----#
    SRSConfiguration = SEQ(name=u'SRSConfiguration', mode=MODE_TYPE)
    _SRSConfiguration_sRSCarrier_List = SEQ_OF(name=u'sRSCarrier-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSCarrier-List')))
    _SRSConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__id._const_tab = ____SRSConfiguration_iE_Extensions__item__id_tab
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab = ____SRSConfiguration_iE_Extensions__item__criticality_tab
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSConfiguration_iE_Extensions__item__id),
        (u'criticality', ___SRSConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SRSConfiguration_iE_Extensions__item_._ext = None
    _SRSConfiguration_iE_Extensions._cont = __SRSConfiguration_iE_Extensions__item_
    _SRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfiguration._cont = ASN1Dict([
        (u'sRSCarrier-List', _SRSConfiguration_sRSCarrier_List),
        (u'iE-Extensions', _SRSConfiguration_iE_Extensions),
        ])
    SRSConfiguration._ext = []
    
    #-----< SRSConfiguration-ExtIEs >-----#
    SRSConfiguration_ExtIEs = CLASS(name=u'SRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SrsFrequency >-----#
    SrsFrequency = INT(name=u'SrsFrequency', mode=MODE_TYPE)
    SrsFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SRSPosResourceID >-----#
    SRSPosResourceID = INT(name=u'SRSPosResourceID', mode=MODE_TYPE)
    SRSPosResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource >-----#
    SRSResource = SEQ(name=u'SRSResource', mode=MODE_TYPE)
    _SRSResource_sRSResourceID = INT(name=u'sRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    _SRSResource_nrofSRS_Ports = ENUM(name=u'nrofSRS-Ports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSRS_Ports._cont = ASN1Dict([(u'port1', 0), (u'ports2', 1), (u'ports4', 2)])
    _SRSResource_nrofSRS_Ports._ext = None
    _SRSResource_transmissionComb = CHOICE(name=u'transmissionComb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TransmissionComb')))
    _SRSResource_startPosition = INT(name=u'startPosition', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _SRSResource_nrofSymbols = ENUM(name=u'nrofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSymbols._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2)])
    _SRSResource_nrofSymbols._ext = None
    _SRSResource_repetitionFactor = ENUM(name=u'repetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_repetitionFactor._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2)])
    _SRSResource_repetitionFactor._ext = None
    _SRSResource_freqDomainPosition = INT(name=u'freqDomainPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=67)], ev=None, er=[])
    _SRSResource_freqDomainShift = INT(name=u'freqDomainShift', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _SRSResource_c_SRS = INT(name=u'c-SRS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SRSResource_b_SRS = INT(name=u'b-SRS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_b_hop = INT(name=u'b-hop', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_hop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_groupOrSequenceHopping = ENUM(name=u'groupOrSequenceHopping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_groupOrSequenceHopping._cont = ASN1Dict([(u'neither', 0), (u'groupHopping', 1), (u'sequenceHopping', 2)])
    _SRSResource_groupOrSequenceHopping._ext = None
    _SRSResource_resourceType = CHOICE(name=u'resourceType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceType')))
    _SRSResource_sequenceId = INT(name=u'sequenceId', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _SRSResource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__id._const_tab = ____SRSResource_iE_Extensions__item__id_tab
    ___SRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SRSResource_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__criticality._const_tab = ____SRSResource_iE_Extensions__item__criticality_tab
    ___SRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab = ____SRSResource_iE_Extensions__item__extensionValue_tab
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResource_iE_Extensions__item__id),
        (u'criticality', ___SRSResource_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResource_iE_Extensions__item__extensionValue),
        ])
    __SRSResource_iE_Extensions__item_._ext = None
    _SRSResource_iE_Extensions._cont = __SRSResource_iE_Extensions__item_
    _SRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResource._cont = ASN1Dict([
        (u'sRSResourceID', _SRSResource_sRSResourceID),
        (u'nrofSRS-Ports', _SRSResource_nrofSRS_Ports),
        (u'transmissionComb', _SRSResource_transmissionComb),
        (u'startPosition', _SRSResource_startPosition),
        (u'nrofSymbols', _SRSResource_nrofSymbols),
        (u'repetitionFactor', _SRSResource_repetitionFactor),
        (u'freqDomainPosition', _SRSResource_freqDomainPosition),
        (u'freqDomainShift', _SRSResource_freqDomainShift),
        (u'c-SRS', _SRSResource_c_SRS),
        (u'b-SRS', _SRSResource_b_SRS),
        (u'b-hop', _SRSResource_b_hop),
        (u'groupOrSequenceHopping', _SRSResource_groupOrSequenceHopping),
        (u'resourceType', _SRSResource_resourceType),
        (u'sequenceId', _SRSResource_sequenceId),
        (u'iE-Extensions', _SRSResource_iE_Extensions),
        ])
    SRSResource._ext = []
    
    #-----< SRSResource-ExtIEs >-----#
    SRSResource_ExtIEs = CLASS(name=u'SRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceID >-----#
    SRSResourceID = INT(name=u'SRSResourceID', mode=MODE_TYPE)
    SRSResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource-List >-----#
    SRSResource_List = SEQ_OF(name=u'SRSResource-List', mode=MODE_TYPE)
    _SRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResource')))
    SRSResource_List._cont = _SRSResource_List__item_
    SRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRSResourceSet-List >-----#
    SRSResourceSet_List = SEQ_OF(name=u'SRSResourceSet-List', mode=MODE_TYPE)
    _SRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet')))
    SRSResourceSet_List._cont = _SRSResourceSet_List__item_
    SRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceID-List >-----#
    SRSResourceID_List = SEQ_OF(name=u'SRSResourceID-List', mode=MODE_TYPE)
    _SRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    SRSResourceID_List._cont = _SRSResourceID_List__item_
    SRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceSet >-----#
    SRSResourceSet = SEQ(name=u'SRSResourceSet', mode=MODE_TYPE)
    _SRSResourceSet_sRSResourceSetID = INT(name=u'sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResourceSet_sRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _SRSResourceSet_sRSResourceID_List = SEQ_OF(name=u'sRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID-List')))
    _SRSResourceSet_resourceSetType = CHOICE(name=u'resourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetType')))
    _SRSResourceSet_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceSet_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__id._const_tab = ____SRSResourceSet_iE_Extensions__item__id_tab
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceSet_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_iE_Extensions__item__criticality_tab
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceSet_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_iE_Extensions__item__extensionValue_tab
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceSet_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceSet_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceSet_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceSet_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_iE_Extensions__item_._ext = None
    _SRSResourceSet_iE_Extensions._cont = __SRSResourceSet_iE_Extensions__item_
    _SRSResourceSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet._cont = ASN1Dict([
        (u'sRSResourceSetID', _SRSResourceSet_sRSResourceSetID),
        (u'sRSResourceID-List', _SRSResourceSet_sRSResourceID_List),
        (u'resourceSetType', _SRSResourceSet_resourceSetType),
        (u'iE-Extensions', _SRSResourceSet_iE_Extensions),
        ])
    SRSResourceSet._ext = []
    
    #-----< SRSResourceSet-ExtIEs >-----#
    SRSResourceSet_ExtIEs = CLASS(name=u'SRSResourceSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResourceSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSetID >-----#
    SRSResourceSetID = INT(name=u'SRSResourceSetID', mode=MODE_TYPE)
    SRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< SRSResourceTrigger >-----#
    SRSResourceTrigger = SEQ(name=u'SRSResourceTrigger', mode=MODE_TYPE)
    _SRSResourceTrigger_aperiodicSRSResourceTriggerList = SEQ_OF(name=u'aperiodicSRSResourceTriggerList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AperiodicSRSResourceTriggerList')))
    _SRSResourceTrigger_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceTrigger_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceTrigger_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab = ____SRSResourceTrigger_iE_Extensions__item__id_tab
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRSResourceTrigger_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab = ____SRSResourceTrigger_iE_Extensions__item__criticality_tab
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRSResourceTrigger_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRSResourceTrigger_iE_Extensions__item__id),
        (u'criticality', ___SRSResourceTrigger_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRSResourceTrigger_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceTrigger_iE_Extensions__item_._ext = None
    _SRSResourceTrigger_iE_Extensions._cont = __SRSResourceTrigger_iE_Extensions__item_
    _SRSResourceTrigger_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceTrigger._cont = ASN1Dict([
        (u'aperiodicSRSResourceTriggerList', _SRSResourceTrigger_aperiodicSRSResourceTriggerList),
        (u'iE-Extensions', _SRSResourceTrigger_iE_Extensions),
        ])
    SRSResourceTrigger._ext = []
    
    #-----< SRSResourceTrigger-ExtIEs >-----#
    SRSResourceTrigger_ExtIEs = CLASS(name=u'SRSResourceTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResourceTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInfo >-----#
    SSBInfo = SEQ(name=u'SSBInfo', mode=MODE_TYPE)
    _SSBInfo_listOfSSBInfo = SEQ_OF(name=u'listOfSSBInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SSBInfo_listOfSSBInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfoItem')))
    _SSBInfo_listOfSSBInfo._cont = __SSBInfo_listOfSSBInfo__item_
    _SSBInfo_listOfSSBInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _SSBInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSBInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__id._const_tab = ____SSBInfo_iE_Extensions__item__id_tab
    ___SSBInfo_iE_Extensions__item__id._const_tab_at = None
    ___SSBInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__criticality._const_tab = ____SSBInfo_iE_Extensions__item__criticality_tab
    ___SSBInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab = ____SSBInfo_iE_Extensions__item__extensionValue_tab
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBInfo_iE_Extensions__item__id),
        (u'criticality', ___SSBInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBInfo_iE_Extensions__item__extensionValue),
        ])
    __SSBInfo_iE_Extensions__item_._ext = None
    _SSBInfo_iE_Extensions._cont = __SSBInfo_iE_Extensions__item_
    _SSBInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInfo._cont = ASN1Dict([
        (u'listOfSSBInfo', _SSBInfo_listOfSSBInfo),
        (u'iE-Extensions', _SSBInfo_iE_Extensions),
        ])
    SSBInfo._ext = []
    
    #-----< SSBInfo-ExtIEs >-----#
    SSBInfo_ExtIEs = CLASS(name=u'SSBInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSBInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInfoItem >-----#
    SSBInfoItem = SEQ(name=u'SSBInfoItem', mode=MODE_TYPE)
    _SSBInfoItem_sSB_Configuration = SEQ(name=u'sSB-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TF-Configuration')))
    _SSBInfoItem_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBInfoItem_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SSBInfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSBInfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SSBInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__id._const_tab = ____SSBInfoItem_iE_Extensions__item__id_tab
    ___SSBInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBInfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSBInfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSBInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab = ____SSBInfoItem_iE_Extensions__item__criticality_tab
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSBInfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSBInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab = ____SSBInfoItem_iE_Extensions__item__extensionValue_tab
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSBInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSBInfoItem_iE_Extensions__item__id),
        (u'criticality', ___SSBInfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSBInfoItem_iE_Extensions__item__extensionValue),
        ])
    __SSBInfoItem_iE_Extensions__item_._ext = None
    _SSBInfoItem_iE_Extensions._cont = __SSBInfoItem_iE_Extensions__item_
    _SSBInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInfoItem._cont = ASN1Dict([
        (u'sSB-Configuration', _SSBInfoItem_sSB_Configuration),
        (u'pCI-NR', _SSBInfoItem_pCI_NR),
        (u'iE-Extensions', _SSBInfoItem_iE_Extensions),
        ])
    SSBInfoItem._ext = []
    
    #-----< SSBInfoItem-ExtIEs >-----#
    SSBInfoItem_ExtIEs = CLASS(name=u'SSBInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSBInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB >-----#
    SSB = SEQ(name=u'SSB', mode=MODE_TYPE)
    _SSB_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SSB_ssb_index = INT(name=u'ssb-index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _SSB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SSB_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__id._const_tab = ____SSB_iE_Extensions__item__id_tab
    ___SSB_iE_Extensions__item__id._const_tab_at = None
    ___SSB_iE_Extensions__item__id._const_tab_id = u'id'
    ___SSB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__criticality._const_tab = ____SSB_iE_Extensions__item__criticality_tab
    ___SSB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SSB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SSB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__extensionValue._const_tab = ____SSB_iE_Extensions__item__extensionValue_tab
    ___SSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SSB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SSB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SSB_iE_Extensions__item__id),
        (u'criticality', ___SSB_iE_Extensions__item__criticality),
        (u'extensionValue', ___SSB_iE_Extensions__item__extensionValue),
        ])
    __SSB_iE_Extensions__item_._ext = None
    _SSB_iE_Extensions._cont = __SSB_iE_Extensions__item_
    _SSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB._cont = ASN1Dict([
        (u'pCI-NR', _SSB_pCI_NR),
        (u'ssb-index', _SSB_ssb_index),
        (u'iE-Extensions', _SSB_iE_Extensions),
        ])
    SSB._ext = []
    
    #-----< SSB-ExtIEs >-----#
    SSB_ExtIEs = CLASS(name=u'SSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBBurstPosition >-----#
    SSBBurstPosition = CHOICE(name=u'SSBBurstPosition', mode=MODE_TYPE)
    _SSBBurstPosition_shortBitmap = BIT_STR(name=u'shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSBBurstPosition_mediumBitmap = BIT_STR(name=u'mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSBBurstPosition_longBitmap = BIT_STR(name=u'longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSBBurstPosition_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SSBBurstPosition_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___SSBBurstPosition_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_id._const_tab = ___SSBBurstPosition_choice_extension_id_tab
    __SSBBurstPosition_choice_extension_id._const_tab_at = None
    __SSBBurstPosition_choice_extension_id._const_tab_id = u'id'
    __SSBBurstPosition_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___SSBBurstPosition_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_criticality._const_tab = ___SSBBurstPosition_choice_extension_criticality_tab
    __SSBBurstPosition_choice_extension_criticality._const_tab_at = ('..', u'id')
    __SSBBurstPosition_choice_extension_criticality._const_tab_id = u'criticality'
    __SSBBurstPosition_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___SSBBurstPosition_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_value._const_tab = ___SSBBurstPosition_choice_extension_value_tab
    __SSBBurstPosition_choice_extension_value._const_tab_at = ('..', u'id')
    __SSBBurstPosition_choice_extension_value._const_tab_id = u'Value'
    _SSBBurstPosition_choice_extension._cont = ASN1Dict([
        (u'id', __SSBBurstPosition_choice_extension_id),
        (u'criticality', __SSBBurstPosition_choice_extension_criticality),
        (u'value', __SSBBurstPosition_choice_extension_value),
        ])
    _SSBBurstPosition_choice_extension._ext = None
    SSBBurstPosition._cont = ASN1Dict([
        (u'shortBitmap', _SSBBurstPosition_shortBitmap),
        (u'mediumBitmap', _SSBBurstPosition_mediumBitmap),
        (u'longBitmap', _SSBBurstPosition_longBitmap),
        (u'choice-extension', _SSBBurstPosition_choice_extension),
        ])
    SSBBurstPosition._ext = None
    
    #-----< SSBBurstPosition-ExtIEs >-----#
    SSBBurstPosition_ExtIEs = CLASS(name=u'SSBBurstPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SSBBurstPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-Index >-----#
    SSB_Index = INT(name=u'SSB-Index', mode=MODE_TYPE)
    SSB_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SSID >-----#
    SSID = OCT_STR(name=u'SSID', mode=MODE_TYPE)
    SSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SystemFrameNumber >-----#
    SystemFrameNumber = INT(name=u'SystemFrameNumber', mode=MODE_TYPE)
    SystemFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< SystemInformation >-----#
    SystemInformation = SEQ_OF(name=u'SystemInformation', mode=MODE_TYPE)
    _SystemInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SystemInformation__item__broadcastPeriodicity = ENUM(name=u'broadcastPeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BroadcastPeriodicity')))
    __SystemInformation__item__posSIBs = SEQ_OF(name=u'posSIBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIBs')))
    __SystemInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SystemInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____SystemInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____SystemInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__id._const_tab = _____SystemInformation__item__iE_Extensions__item__id_tab
    ____SystemInformation__item__iE_Extensions__item__id._const_tab_at = None
    ____SystemInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____SystemInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____SystemInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab = _____SystemInformation__item__iE_Extensions__item__criticality_tab
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____SystemInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____SystemInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab = _____SystemInformation__item__iE_Extensions__item__extensionValue_tab
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___SystemInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____SystemInformation__item__iE_Extensions__item__id),
        (u'criticality', ____SystemInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____SystemInformation__item__iE_Extensions__item__extensionValue),
        ])
    ___SystemInformation__item__iE_Extensions__item_._ext = None
    __SystemInformation__item__iE_Extensions._cont = ___SystemInformation__item__iE_Extensions__item_
    __SystemInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SystemInformation__item_._cont = ASN1Dict([
        (u'broadcastPeriodicity', __SystemInformation__item__broadcastPeriodicity),
        (u'posSIBs', __SystemInformation__item__posSIBs),
        (u'iE-Extensions', __SystemInformation__item__iE_Extensions),
        ])
    _SystemInformation__item_._ext = []
    SystemInformation._cont = _SystemInformation__item_
    SystemInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SystemInformation-ExtIEs >-----#
    SystemInformation_ExtIEs = CLASS(name=u'SystemInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SystemInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TDD-Config-EUTRA-Item >-----#
    TDD_Config_EUTRA_Item = SEQ(name=u'TDD-Config-EUTRA-Item', mode=MODE_TYPE)
    _TDD_Config_EUTRA_Item_subframeAssignment = ENUM(name=u'subframeAssignment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_Config_EUTRA_Item_subframeAssignment._cont = ASN1Dict([(u'sa0', 0), (u'sa1', 1), (u'sa2', 2), (u'sa3', 3), (u'sa4', 4), (u'sa5', 5), (u'sa6', 6)])
    _TDD_Config_EUTRA_Item_subframeAssignment._ext = []
    _TDD_Config_EUTRA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Config_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_Config_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_Config_EUTRA_Item_iE_Extensions__item__id),
        (u'criticality', ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TDD_Config_EUTRA_Item_iE_Extensions__item_._ext = None
    _TDD_Config_EUTRA_Item_iE_Extensions._cont = __TDD_Config_EUTRA_Item_iE_Extensions__item_
    _TDD_Config_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Config_EUTRA_Item._cont = ASN1Dict([
        (u'subframeAssignment', _TDD_Config_EUTRA_Item_subframeAssignment),
        (u'iE-Extensions', _TDD_Config_EUTRA_Item_iE_Extensions),
        ])
    TDD_Config_EUTRA_Item._ext = []
    
    #-----< TDD-Config-EUTRA-Item-Item-ExtIEs >-----#
    TDD_Config_EUTRA_Item_Item_ExtIEs = CLASS(name=u'TDD-Config-EUTRA-Item-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TDD_Config_EUTRA_Item_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TF-Configuration >-----#
    TF_Configuration = SEQ(name=u'TF-Configuration', mode=MODE_TYPE)
    _TF_Configuration_sSB_frequency = INT(name=u'sSB-frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TF_Configuration_sSB_subcarrier_spacing = ENUM(name=u'sSB-subcarrier-spacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_subcarrier_spacing._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz120', 2), (u'kHz240', 3), (u'kHz60', 4)])
    _TF_Configuration_sSB_subcarrier_spacing._ext = [u'kHz60']
    _TF_Configuration_sSB_Transmit_power = INT(name=u'sSB-Transmit-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_Transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _TF_Configuration_sSB_periodicity = ENUM(name=u'sSB-periodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_periodicity._cont = ASN1Dict([(u'ms5', 0), (u'ms10', 1), (u'ms20', 2), (u'ms40', 3), (u'ms80', 4), (u'ms160', 5)])
    _TF_Configuration_sSB_periodicity._ext = []
    _TF_Configuration_sSB_half_frame_offset = INT(name=u'sSB-half-frame-offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_half_frame_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _TF_Configuration_sSB_SFN_offset = INT(name=u'sSB-SFN-offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_SFN_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _TF_Configuration_sSB_BurstPosition = CHOICE(name=u'sSB-BurstPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBBurstPosition')), opt=True)
    _TF_Configuration_sFN_initialisation_time = BIT_STR(name=u'sFN-initialisation-time', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')), opt=True)
    _TF_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TF_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TF_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TF_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__id._const_tab = ____TF_Configuration_iE_Extensions__item__id_tab
    ___TF_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___TF_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___TF_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TF_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab = ____TF_Configuration_iE_Extensions__item__criticality_tab
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TF_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TF_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab = ____TF_Configuration_iE_Extensions__item__extensionValue_tab
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TF_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TF_Configuration_iE_Extensions__item__id),
        (u'criticality', ___TF_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___TF_Configuration_iE_Extensions__item__extensionValue),
        ])
    __TF_Configuration_iE_Extensions__item_._ext = None
    _TF_Configuration_iE_Extensions._cont = __TF_Configuration_iE_Extensions__item_
    _TF_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TF_Configuration._cont = ASN1Dict([
        (u'sSB-frequency', _TF_Configuration_sSB_frequency),
        (u'sSB-subcarrier-spacing', _TF_Configuration_sSB_subcarrier_spacing),
        (u'sSB-Transmit-power', _TF_Configuration_sSB_Transmit_power),
        (u'sSB-periodicity', _TF_Configuration_sSB_periodicity),
        (u'sSB-half-frame-offset', _TF_Configuration_sSB_half_frame_offset),
        (u'sSB-SFN-offset', _TF_Configuration_sSB_SFN_offset),
        (u'sSB-BurstPosition', _TF_Configuration_sSB_BurstPosition),
        (u'sFN-initialisation-time', _TF_Configuration_sFN_initialisation_time),
        (u'iE-Extensions', _TF_Configuration_iE_Extensions),
        ])
    TF_Configuration._ext = []
    
    #-----< TF-Configuration-ExtIEs >-----#
    TF_Configuration_ExtIEs = CLASS(name=u'TF-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TF_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStamp >-----#
    TimeStamp = SEQ(name=u'TimeStamp', mode=MODE_TYPE)
    _TimeStamp_systemFrameNumber = INT(name=u'systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _TimeStamp_slotIndex = CHOICE(name=u'slotIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimeStampSlotIndex')))
    _TimeStamp_measurementTime = BIT_STR(name=u'measurementTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')), opt=True)
    _TimeStamp_iE_Extension = SEQ_OF(name=u'iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeStamp_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TimeStamp_iE_Extension__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TimeStamp_iE_Extension__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__id._const_tab = ____TimeStamp_iE_Extension__item__id_tab
    ___TimeStamp_iE_Extension__item__id._const_tab_at = None
    ___TimeStamp_iE_Extension__item__id._const_tab_id = u'id'
    ___TimeStamp_iE_Extension__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TimeStamp_iE_Extension__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__criticality._const_tab = ____TimeStamp_iE_Extension__item__criticality_tab
    ___TimeStamp_iE_Extension__item__criticality._const_tab_at = ('..', u'id')
    ___TimeStamp_iE_Extension__item__criticality._const_tab_id = u'criticality'
    ___TimeStamp_iE_Extension__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TimeStamp_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab = ____TimeStamp_iE_Extension__item__extensionValue_tab
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_at = ('..', u'id')
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_id = u'Extension'
    __TimeStamp_iE_Extension__item_._cont = ASN1Dict([
        (u'id', ___TimeStamp_iE_Extension__item__id),
        (u'criticality', ___TimeStamp_iE_Extension__item__criticality),
        (u'extensionValue', ___TimeStamp_iE_Extension__item__extensionValue),
        ])
    __TimeStamp_iE_Extension__item_._ext = None
    _TimeStamp_iE_Extension._cont = __TimeStamp_iE_Extension__item_
    _TimeStamp_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeStamp._cont = ASN1Dict([
        (u'systemFrameNumber', _TimeStamp_systemFrameNumber),
        (u'slotIndex', _TimeStamp_slotIndex),
        (u'measurementTime', _TimeStamp_measurementTime),
        (u'iE-Extension', _TimeStamp_iE_Extension),
        ])
    TimeStamp._ext = []
    
    #-----< TimeStamp-ExtIEs >-----#
    TimeStamp_ExtIEs = CLASS(name=u'TimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStampSlotIndex >-----#
    TimeStampSlotIndex = CHOICE(name=u'TimeStampSlotIndex', mode=MODE_TYPE)
    _TimeStampSlotIndex_sCS_15 = INT(name=u'sCS-15', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_15._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_30 = INT(name=u'sCS-30', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_30._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_60 = INT(name=u'sCS-60', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_60._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_120 = INT(name=u'sCS-120', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_120._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    _TimeStampSlotIndex_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TimeStampSlotIndex_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TimeStampSlotIndex_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_id._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_id._const_tab_at = None
    __TimeStampSlotIndex_choice_extension_id._const_tab_id = u'id'
    __TimeStampSlotIndex_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TimeStampSlotIndex_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_criticality._const_tab = ___TimeStampSlotIndex_choice_extension_criticality_tab
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_id = u'criticality'
    __TimeStampSlotIndex_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TimeStampSlotIndex_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_value._const_tab = ___TimeStampSlotIndex_choice_extension_value_tab
    __TimeStampSlotIndex_choice_extension_value._const_tab_at = ('..', u'id')
    __TimeStampSlotIndex_choice_extension_value._const_tab_id = u'Value'
    _TimeStampSlotIndex_choice_extension._cont = ASN1Dict([
        (u'id', __TimeStampSlotIndex_choice_extension_id),
        (u'criticality', __TimeStampSlotIndex_choice_extension_criticality),
        (u'value', __TimeStampSlotIndex_choice_extension_value),
        ])
    _TimeStampSlotIndex_choice_extension._ext = None
    TimeStampSlotIndex._cont = ASN1Dict([
        (u'sCS-15', _TimeStampSlotIndex_sCS_15),
        (u'sCS-30', _TimeStampSlotIndex_sCS_30),
        (u'sCS-60', _TimeStampSlotIndex_sCS_60),
        (u'sCS-120', _TimeStampSlotIndex_sCS_120),
        (u'choice-extension', _TimeStampSlotIndex_choice_extension),
        ])
    TimeStampSlotIndex._ext = None
    
    #-----< TimeStampSlotIndex-ExtIEs >-----#
    TimeStampSlotIndex_ExtIEs = CLASS(name=u'TimeStampSlotIndex-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TimeStampSlotIndex_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TP-ID-EUTRA >-----#
    TP_ID_EUTRA = INT(name=u'TP-ID-EUTRA', mode=MODE_TYPE)
    TP_ID_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< TP-Type-EUTRA >-----#
    TP_Type_EUTRA = ENUM(name=u'TP-Type-EUTRA', mode=MODE_TYPE)
    TP_Type_EUTRA._cont = ASN1Dict([(u'prs-only-tp', 0)])
    TP_Type_EUTRA._ext = []
    
    #-----< TransmissionComb >-----#
    TransmissionComb = CHOICE(name=u'TransmissionComb', mode=MODE_TYPE)
    _TransmissionComb_n2 = SEQ(name=u'n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2 = INT(name=u'combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionComb_n2_cyclicShift_n2 = INT(name=u'cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionComb_n2._cont = ASN1Dict([
        (u'combOffset-n2', __TransmissionComb_n2_combOffset_n2),
        (u'cyclicShift-n2', __TransmissionComb_n2_cyclicShift_n2),
        ])
    _TransmissionComb_n2._ext = None
    _TransmissionComb_n4 = SEQ(name=u'n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4 = INT(name=u'combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionComb_n4_cyclicShift_n4 = INT(name=u'cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionComb_n4._cont = ASN1Dict([
        (u'combOffset-n4', __TransmissionComb_n4_combOffset_n4),
        (u'cyclicShift-n4', __TransmissionComb_n4_cyclicShift_n4),
        ])
    _TransmissionComb_n4._ext = None
    _TransmissionComb_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TransmissionComb_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TransmissionComb_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_id._const_tab = ___TransmissionComb_choice_extension_id_tab
    __TransmissionComb_choice_extension_id._const_tab_at = None
    __TransmissionComb_choice_extension_id._const_tab_id = u'id'
    __TransmissionComb_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TransmissionComb_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_criticality._const_tab = ___TransmissionComb_choice_extension_criticality_tab
    __TransmissionComb_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TransmissionComb_choice_extension_criticality._const_tab_id = u'criticality'
    __TransmissionComb_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TransmissionComb_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_value._const_tab = ___TransmissionComb_choice_extension_value_tab
    __TransmissionComb_choice_extension_value._const_tab_at = ('..', u'id')
    __TransmissionComb_choice_extension_value._const_tab_id = u'Value'
    _TransmissionComb_choice_extension._cont = ASN1Dict([
        (u'id', __TransmissionComb_choice_extension_id),
        (u'criticality', __TransmissionComb_choice_extension_criticality),
        (u'value', __TransmissionComb_choice_extension_value),
        ])
    _TransmissionComb_choice_extension._ext = None
    TransmissionComb._cont = ASN1Dict([
        (u'n2', _TransmissionComb_n2),
        (u'n4', _TransmissionComb_n4),
        (u'choice-extension', _TransmissionComb_choice_extension),
        ])
    TransmissionComb._ext = None
    
    #-----< TransmissionComb-ExtIEs >-----#
    TransmissionComb_ExtIEs = CLASS(name=u'TransmissionComb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TransmissionComb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionCombPos >-----#
    TransmissionCombPos = CHOICE(name=u'TransmissionCombPos', mode=MODE_TYPE)
    _TransmissionCombPos_n2 = SEQ(name=u'n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2 = INT(name=u'combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionCombPos_n2_cyclicShift_n2 = INT(name=u'cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionCombPos_n2._cont = ASN1Dict([
        (u'combOffset-n2', __TransmissionCombPos_n2_combOffset_n2),
        (u'cyclicShift-n2', __TransmissionCombPos_n2_cyclicShift_n2),
        ])
    _TransmissionCombPos_n2._ext = None
    _TransmissionCombPos_n4 = SEQ(name=u'n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4 = INT(name=u'combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionCombPos_n4_cyclicShift_n4 = INT(name=u'cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionCombPos_n4._cont = ASN1Dict([
        (u'combOffset-n4', __TransmissionCombPos_n4_combOffset_n4),
        (u'cyclicShift-n4', __TransmissionCombPos_n4_cyclicShift_n4),
        ])
    _TransmissionCombPos_n4._ext = None
    _TransmissionCombPos_n8 = SEQ(name=u'n8', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8 = INT(name=u'combOffset-n8', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    __TransmissionCombPos_n8_cyclicShift_n8 = INT(name=u'cyclicShift-n8', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_cyclicShift_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TransmissionCombPos_n8._cont = ASN1Dict([
        (u'combOffset-n8', __TransmissionCombPos_n8_combOffset_n8),
        (u'cyclicShift-n8', __TransmissionCombPos_n8_cyclicShift_n8),
        ])
    _TransmissionCombPos_n8._ext = None
    _TransmissionCombPos_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TransmissionCombPos_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TransmissionCombPos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_id._const_tab = ___TransmissionCombPos_choice_extension_id_tab
    __TransmissionCombPos_choice_extension_id._const_tab_at = None
    __TransmissionCombPos_choice_extension_id._const_tab_id = u'id'
    __TransmissionCombPos_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TransmissionCombPos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_criticality._const_tab = ___TransmissionCombPos_choice_extension_criticality_tab
    __TransmissionCombPos_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TransmissionCombPos_choice_extension_criticality._const_tab_id = u'criticality'
    __TransmissionCombPos_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TransmissionCombPos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_value._const_tab = ___TransmissionCombPos_choice_extension_value_tab
    __TransmissionCombPos_choice_extension_value._const_tab_at = ('..', u'id')
    __TransmissionCombPos_choice_extension_value._const_tab_id = u'Value'
    _TransmissionCombPos_choice_extension._cont = ASN1Dict([
        (u'id', __TransmissionCombPos_choice_extension_id),
        (u'criticality', __TransmissionCombPos_choice_extension_criticality),
        (u'value', __TransmissionCombPos_choice_extension_value),
        ])
    _TransmissionCombPos_choice_extension._ext = None
    TransmissionCombPos._cont = ASN1Dict([
        (u'n2', _TransmissionCombPos_n2),
        (u'n4', _TransmissionCombPos_n4),
        (u'n8', _TransmissionCombPos_n8),
        (u'choice-extension', _TransmissionCombPos_choice_extension),
        ])
    TransmissionCombPos._ext = None
    
    #-----< TransmissionCombPos-ExtIEs >-----#
    TransmissionCombPos_ExtIEs = CLASS(name=u'TransmissionCombPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TransmissionCombPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuantities >-----#
    TRPMeasurementQuantities = SEQ_OF(name=u'TRPMeasurementQuantities', mode=MODE_TYPE)
    _TRPMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantitiesList-Item')))
    TRPMeasurementQuantities._cont = _TRPMeasurementQuantities__item_
    TRPMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< TRPMeasurementQuantitiesList-Item >-----#
    TRPMeasurementQuantitiesList_Item = SEQ(name=u'TRPMeasurementQuantitiesList-Item', mode=MODE_TYPE)
    _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item = ENUM(name=u'tRPMeasurementQuantities-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities-Item')))
    _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor = INT(name=u'timingReportingGranularityFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TRPMeasurementQuantitiesList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id),
        (u'criticality', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_._ext = None
    _TRPMeasurementQuantitiesList_Item_iE_Extensions._cont = __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_
    _TRPMeasurementQuantitiesList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPMeasurementQuantitiesList_Item._cont = ASN1Dict([
        (u'tRPMeasurementQuantities-Item', _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item),
        (u'timingReportingGranularityFactor', _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor),
        (u'iE-Extensions', _TRPMeasurementQuantitiesList_Item_iE_Extensions),
        ])
    TRPMeasurementQuantitiesList_Item._ext = []
    
    #-----< TRPMeasurementQuantitiesList-Item-ExtIEs >-----#
    TRPMeasurementQuantitiesList_Item_ExtIEs = CLASS(name=u'TRPMeasurementQuantitiesList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPMeasurementQuantitiesList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuantities-Item >-----#
    TRPMeasurementQuantities_Item = ENUM(name=u'TRPMeasurementQuantities-Item', mode=MODE_TYPE)
    TRPMeasurementQuantities_Item._cont = ASN1Dict([(u'gNB-RxTxTimeDiff', 0), (u'uL-SRS-RSRP', 1), (u'uL-AoA', 2), (u'uL-RTOA', 3)])
    TRPMeasurementQuantities_Item._ext = []
    
    #-----< TrpMeasurementResult >-----#
    TrpMeasurementResult = SEQ_OF(name=u'TrpMeasurementResult', mode=MODE_TYPE)
    _TrpMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementResultItem')))
    TrpMeasurementResult._cont = _TrpMeasurementResult__item_
    TrpMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< TrpMeasurementResultItem >-----#
    TrpMeasurementResultItem = SEQ(name=u'TrpMeasurementResultItem', mode=MODE_TYPE)
    _TrpMeasurementResultItem_measuredResultsValue = CHOICE(name=u'measuredResultsValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasuredResultsValue')))
    _TrpMeasurementResultItem_timeStamp = SEQ(name=u'timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimeStamp')))
    _TrpMeasurementResultItem_measurementQuality = CHOICE(name=u'measurementQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementQuality')), opt=True)
    _TrpMeasurementResultItem_measurementBeamInfo = SEQ(name=u'measurementBeamInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfo')), opt=True)
    _TrpMeasurementResultItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementResultItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TrpMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__id_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TrpMeasurementResultItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementResultItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__criticality_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TrpMeasurementResultItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementResultItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__extensionValue_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TrpMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TrpMeasurementResultItem_iE_Extensions__item__id),
        (u'criticality', ___TrpMeasurementResultItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __TrpMeasurementResultItem_iE_Extensions__item_._ext = None
    _TrpMeasurementResultItem_iE_Extensions._cont = __TrpMeasurementResultItem_iE_Extensions__item_
    _TrpMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementResultItem._cont = ASN1Dict([
        (u'measuredResultsValue', _TrpMeasurementResultItem_measuredResultsValue),
        (u'timeStamp', _TrpMeasurementResultItem_timeStamp),
        (u'measurementQuality', _TrpMeasurementResultItem_measurementQuality),
        (u'measurementBeamInfo', _TrpMeasurementResultItem_measurementBeamInfo),
        (u'iE-Extensions', _TrpMeasurementResultItem_iE_Extensions),
        ])
    TrpMeasurementResultItem._ext = []
    
    #-----< TrpMeasurementResultItem-ExtIEs >-----#
    TrpMeasurementResultItem_ExtIEs = CLASS(name=u'TrpMeasurementResultItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TrpMeasurementResultItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasuredResultsValue >-----#
    TrpMeasuredResultsValue = CHOICE(name=u'TrpMeasuredResultsValue', mode=MODE_TYPE)
    _TrpMeasuredResultsValue_uL_AngleOfArrival = SEQ(name=u'uL-AngleOfArrival', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    _TrpMeasuredResultsValue_uL_SRS_RSRP = INT(name=u'uL-SRS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRP')))
    _TrpMeasuredResultsValue_uL_RTOA = SEQ(name=u'uL-RTOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-RTOAMeasurement')))
    _TrpMeasuredResultsValue_gNB_RxTxTimeDiff = SEQ(name=u'gNB-RxTxTimeDiff', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GNB-RxTxTimeDiff')))
    _TrpMeasuredResultsValue_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TrpMeasuredResultsValue_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TrpMeasuredResultsValue_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasuredResultsValue_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasuredResultsValue_choice_extension_id._const_tab = ___TrpMeasuredResultsValue_choice_extension_id_tab
    __TrpMeasuredResultsValue_choice_extension_id._const_tab_at = None
    __TrpMeasuredResultsValue_choice_extension_id._const_tab_id = u'id'
    __TrpMeasuredResultsValue_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TrpMeasuredResultsValue_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasuredResultsValue_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab = ___TrpMeasuredResultsValue_choice_extension_criticality_tab
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab_id = u'criticality'
    __TrpMeasuredResultsValue_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TrpMeasuredResultsValue_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasuredResultsValue_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasuredResultsValue_choice_extension_value._const_tab = ___TrpMeasuredResultsValue_choice_extension_value_tab
    __TrpMeasuredResultsValue_choice_extension_value._const_tab_at = ('..', u'id')
    __TrpMeasuredResultsValue_choice_extension_value._const_tab_id = u'Value'
    _TrpMeasuredResultsValue_choice_extension._cont = ASN1Dict([
        (u'id', __TrpMeasuredResultsValue_choice_extension_id),
        (u'criticality', __TrpMeasuredResultsValue_choice_extension_criticality),
        (u'value', __TrpMeasuredResultsValue_choice_extension_value),
        ])
    _TrpMeasuredResultsValue_choice_extension._ext = None
    TrpMeasuredResultsValue._cont = ASN1Dict([
        (u'uL-AngleOfArrival', _TrpMeasuredResultsValue_uL_AngleOfArrival),
        (u'uL-SRS-RSRP', _TrpMeasuredResultsValue_uL_SRS_RSRP),
        (u'uL-RTOA', _TrpMeasuredResultsValue_uL_RTOA),
        (u'gNB-RxTxTimeDiff', _TrpMeasuredResultsValue_gNB_RxTxTimeDiff),
        (u'choice-extension', _TrpMeasuredResultsValue_choice_extension),
        ])
    TrpMeasuredResultsValue._ext = None
    
    #-----< TrpMeasuredResultsValue-ExtIEs >-----#
    TrpMeasuredResultsValue_ExtIEs = CLASS(name=u'TrpMeasuredResultsValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TrpMeasuredResultsValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementQuality >-----#
    TrpMeasurementQuality = CHOICE(name=u'TrpMeasurementQuality', mode=MODE_TYPE)
    _TrpMeasurementQuality_timingMeasQuality = SEQ(name=u'timingMeasQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementTimingQuality')))
    _TrpMeasurementQuality_angleMeasQuality = SEQ(name=u'angleMeasQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementAngleQuality')))
    _TrpMeasurementQuality_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TrpMeasurementQuality_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TrpMeasurementQuality_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_id._const_tab = ___TrpMeasurementQuality_choice_Extension_id_tab
    __TrpMeasurementQuality_choice_Extension_id._const_tab_at = None
    __TrpMeasurementQuality_choice_Extension_id._const_tab_id = u'id'
    __TrpMeasurementQuality_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TrpMeasurementQuality_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab = ___TrpMeasurementQuality_choice_Extension_criticality_tab
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab_id = u'criticality'
    __TrpMeasurementQuality_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TrpMeasurementQuality_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_value._const_tab = ___TrpMeasurementQuality_choice_Extension_value_tab
    __TrpMeasurementQuality_choice_Extension_value._const_tab_at = ('..', u'id')
    __TrpMeasurementQuality_choice_Extension_value._const_tab_id = u'Value'
    _TrpMeasurementQuality_choice_Extension._cont = ASN1Dict([
        (u'id', __TrpMeasurementQuality_choice_Extension_id),
        (u'criticality', __TrpMeasurementQuality_choice_Extension_criticality),
        (u'value', __TrpMeasurementQuality_choice_Extension_value),
        ])
    _TrpMeasurementQuality_choice_Extension._ext = None
    TrpMeasurementQuality._cont = ASN1Dict([
        (u'timingMeasQuality', _TrpMeasurementQuality_timingMeasQuality),
        (u'angleMeasQuality', _TrpMeasurementQuality_angleMeasQuality),
        (u'choice-Extension', _TrpMeasurementQuality_choice_Extension),
        ])
    TrpMeasurementQuality._ext = None
    
    #-----< TrpMeasurementQuality-ExtIEs >-----#
    TrpMeasurementQuality_ExtIEs = CLASS(name=u'TrpMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TrpMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementTimingQuality >-----#
    TrpMeasurementTimingQuality = SEQ(name=u'TrpMeasurementTimingQuality', mode=MODE_TYPE)
    _TrpMeasurementTimingQuality_measurementQuality = INT(name=u'measurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementTimingQuality_measurementQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TrpMeasurementTimingQuality_resolution = ENUM(name=u'resolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementTimingQuality_resolution._cont = ASN1Dict([(u'm0dot1', 0), (u'm1', 1), (u'm10', 2), (u'm30', 3)])
    _TrpMeasurementTimingQuality_resolution._ext = []
    _TrpMeasurementTimingQuality_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementTimingQuality_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementTimingQuality_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab_at = None
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab_id = u'id'
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TrpMeasurementTimingQuality_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TrpMeasurementTimingQuality_iE_extensions__item__id),
        (u'criticality', ___TrpMeasurementTimingQuality_iE_extensions__item__criticality),
        (u'extensionValue', ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue),
        ])
    __TrpMeasurementTimingQuality_iE_extensions__item_._ext = None
    _TrpMeasurementTimingQuality_iE_extensions._cont = __TrpMeasurementTimingQuality_iE_extensions__item_
    _TrpMeasurementTimingQuality_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementTimingQuality._cont = ASN1Dict([
        (u'measurementQuality', _TrpMeasurementTimingQuality_measurementQuality),
        (u'resolution', _TrpMeasurementTimingQuality_resolution),
        (u'iE-extensions', _TrpMeasurementTimingQuality_iE_extensions),
        ])
    TrpMeasurementTimingQuality._ext = []
    
    #-----< TrpMeasurementTimingQuality-ExtIEs >-----#
    TrpMeasurementTimingQuality_ExtIEs = CLASS(name=u'TrpMeasurementTimingQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TrpMeasurementTimingQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementAngleQuality >-----#
    TrpMeasurementAngleQuality = SEQ(name=u'TrpMeasurementAngleQuality', mode=MODE_TYPE)
    _TrpMeasurementAngleQuality_azimuthQuality = INT(name=u'azimuthQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementAngleQuality_azimuthQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TrpMeasurementAngleQuality_zenithQuality = INT(name=u'zenithQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TrpMeasurementAngleQuality_zenithQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TrpMeasurementAngleQuality_resolution = ENUM(name=u'resolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementAngleQuality_resolution._cont = ASN1Dict([(u'deg0dot1', 0)])
    _TrpMeasurementAngleQuality_resolution._ext = []
    _TrpMeasurementAngleQuality_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementAngleQuality_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementAngleQuality_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab_at = None
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab_id = u'id'
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TrpMeasurementAngleQuality_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TrpMeasurementAngleQuality_iE_extensions__item__id),
        (u'criticality', ___TrpMeasurementAngleQuality_iE_extensions__item__criticality),
        (u'extensionValue', ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue),
        ])
    __TrpMeasurementAngleQuality_iE_extensions__item_._ext = None
    _TrpMeasurementAngleQuality_iE_extensions._cont = __TrpMeasurementAngleQuality_iE_extensions__item_
    _TrpMeasurementAngleQuality_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementAngleQuality._cont = ASN1Dict([
        (u'azimuthQuality', _TrpMeasurementAngleQuality_azimuthQuality),
        (u'zenithQuality', _TrpMeasurementAngleQuality_zenithQuality),
        (u'resolution', _TrpMeasurementAngleQuality_resolution),
        (u'iE-extensions', _TrpMeasurementAngleQuality_iE_extensions),
        ])
    TrpMeasurementAngleQuality._ext = []
    
    #-----< TrpMeasurementAngleQuality-ExtIEs >-----#
    TrpMeasurementAngleQuality_ExtIEs = CLASS(name=u'TrpMeasurementAngleQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TrpMeasurementAngleQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementRequestList >-----#
    TRP_MeasurementRequestList = SEQ_OF(name=u'TRP-MeasurementRequestList', mode=MODE_TYPE)
    _TRP_MeasurementRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestItem')))
    TRP_MeasurementRequestList._cont = _TRP_MeasurementRequestList__item_
    TRP_MeasurementRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementRequestItem >-----#
    TRP_MeasurementRequestItem = SEQ(name=u'TRP-MeasurementRequestItem', mode=MODE_TYPE)
    _TRP_MeasurementRequestItem_tRP_ID = INT(name=u'tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_MeasurementRequestItem_search_window_information = SEQ(name=u'search-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Search-window-information')), opt=True)
    _TRP_MeasurementRequestItem_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementRequestItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementRequestItem_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_id = u'id'
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRP_MeasurementRequestItem_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRP_MeasurementRequestItem_iE_extensions__item__id),
        (u'criticality', ___TRP_MeasurementRequestItem_iE_extensions__item__criticality),
        (u'extensionValue', ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementRequestItem_iE_extensions__item_._ext = None
    _TRP_MeasurementRequestItem_iE_extensions._cont = __TRP_MeasurementRequestItem_iE_extensions__item_
    _TRP_MeasurementRequestItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementRequestItem._cont = ASN1Dict([
        (u'tRP-ID', _TRP_MeasurementRequestItem_tRP_ID),
        (u'search-window-information', _TRP_MeasurementRequestItem_search_window_information),
        (u'iE-extensions', _TRP_MeasurementRequestItem_iE_extensions),
        ])
    TRP_MeasurementRequestItem._ext = []
    
    #-----< TRP-MeasurementRequestItem-ExtIEs >-----#
    TRP_MeasurementRequestItem_ExtIEs = CLASS(name=u'TRP-MeasurementRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    TRP_MeasurementRequestItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementResponseList >-----#
    TRP_MeasurementResponseList = SEQ_OF(name=u'TRP-MeasurementResponseList', mode=MODE_TYPE)
    _TRP_MeasurementResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseItem')))
    TRP_MeasurementResponseList._cont = _TRP_MeasurementResponseList__item_
    TRP_MeasurementResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementResponseItem >-----#
    TRP_MeasurementResponseItem = SEQ(name=u'TRP-MeasurementResponseItem', mode=MODE_TYPE)
    _TRP_MeasurementResponseItem_tRP_ID = INT(name=u'tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_MeasurementResponseItem_measurementResult = SEQ_OF(name=u'measurementResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementResult')))
    _TRP_MeasurementResponseItem_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementResponseItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementResponseItem_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Extension', _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab_id = u'id'
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRP_MeasurementResponseItem_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRP_MeasurementResponseItem_iE_extensions__item__id),
        (u'criticality', ___TRP_MeasurementResponseItem_iE_extensions__item__criticality),
        (u'extensionValue', ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementResponseItem_iE_extensions__item_._ext = None
    _TRP_MeasurementResponseItem_iE_extensions._cont = __TRP_MeasurementResponseItem_iE_extensions__item_
    _TRP_MeasurementResponseItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementResponseItem._cont = ASN1Dict([
        (u'tRP-ID', _TRP_MeasurementResponseItem_tRP_ID),
        (u'measurementResult', _TRP_MeasurementResponseItem_measurementResult),
        (u'iE-extensions', _TRP_MeasurementResponseItem_iE_extensions),
        ])
    TRP_MeasurementResponseItem._ext = []
    
    #-----< TRP-MeasurementResponseItem-ExtIEs >-----#
    TRP_MeasurementResponseItem_ExtIEs = CLASS(name=u'TRP-MeasurementResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    TRP_MeasurementResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Extension', _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationListTRPResp >-----#
    TRPInformationListTRPResp = SEQ_OF(name=u'TRPInformationListTRPResp', mode=MODE_TYPE)
    _TRPInformationListTRPResp__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TRPInformationListTRPResp__item__tRPInformation = SEQ(name=u'tRPInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformation')))
    __TRPInformationListTRPResp__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TRPInformationListTRPResp__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab_at = None
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___TRPInformationListTRPResp__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____TRPInformationListTRPResp__item__iE_Extensions__item__id),
        (u'criticality', ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue),
        ])
    ___TRPInformationListTRPResp__item__iE_Extensions__item_._ext = None
    __TRPInformationListTRPResp__item__iE_Extensions._cont = ___TRPInformationListTRPResp__item__iE_Extensions__item_
    __TRPInformationListTRPResp__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TRPInformationListTRPResp__item_._cont = ASN1Dict([
        (u'tRPInformation', __TRPInformationListTRPResp__item__tRPInformation),
        (u'iE-Extensions', __TRPInformationListTRPResp__item__iE_Extensions),
        ])
    _TRPInformationListTRPResp__item_._ext = []
    TRPInformationListTRPResp._cont = _TRPInformationListTRPResp__item_
    TRPInformationListTRPResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPInformationTRPResp-ExtIEs >-----#
    TRPInformationTRPResp_ExtIEs = CLASS(name=u'TRPInformationTRPResp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPInformationTRPResp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformation >-----#
    TRPInformation = SEQ(name=u'TRPInformation', mode=MODE_TYPE)
    _TRPInformation_tRP_ID = INT(name=u'tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRPInformation_tRPInformationTypeResponseList = SEQ_OF(name=u'tRPInformationTypeResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeResponseList')))
    _TRPInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__id._const_tab = ____TRPInformation_iE_Extensions__item__id_tab
    ___TRPInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__criticality._const_tab = ____TRPInformation_iE_Extensions__item__criticality_tab
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPInformation_iE_Extensions__item__extensionValue_tab
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPInformation_iE_Extensions__item__id),
        (u'criticality', ___TRPInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPInformation_iE_Extensions__item_._ext = None
    _TRPInformation_iE_Extensions._cont = __TRPInformation_iE_Extensions__item_
    _TRPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformation._cont = ASN1Dict([
        (u'tRP-ID', _TRPInformation_tRP_ID),
        (u'tRPInformationTypeResponseList', _TRPInformation_tRPInformationTypeResponseList),
        (u'iE-Extensions', _TRPInformation_iE_Extensions),
        ])
    TRPInformation._ext = []
    
    #-----< TRPInformation-ExtIEs >-----#
    TRPInformation_ExtIEs = CLASS(name=u'TRPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeResponseList >-----#
    TRPInformationTypeResponseList = SEQ_OF(name=u'TRPInformationTypeResponseList', mode=MODE_TYPE)
    _TRPInformationTypeResponseList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeResponseItem')))
    TRPInformationTypeResponseList._cont = _TRPInformationTypeResponseList__item_
    TRPInformationTypeResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeResponseItem >-----#
    TRPInformationTypeResponseItem = CHOICE(name=u'TRPInformationTypeResponseItem', mode=MODE_TYPE)
    _TRPInformationTypeResponseItem_pCI_NR = INT(name=u'pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _TRPInformationTypeResponseItem_cGI_NR = SEQ(name=u'cGI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _TRPInformationTypeResponseItem_aRFCN = INT(name=u'aRFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_aRFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TRPInformationTypeResponseItem_pRSConfiguration = SEQ(name=u'pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfiguration')))
    _TRPInformationTypeResponseItem_sSBinformation = SEQ(name=u'sSBinformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfo')))
    _TRPInformationTypeResponseItem_sFNInitialisationTime = BIT_STR(name=u'sFNInitialisationTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _TRPInformationTypeResponseItem_spatialDirectionInformation = SEQ(name=u'spatialDirectionInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialDirectionInformation')))
    _TRPInformationTypeResponseItem_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    _TRPInformationTypeResponseItem_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPInformationTypeResponseItem_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPType')))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_at = None
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_id = u'id'
    __TRPInformationTypeResponseItem_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPInformationTypeResponseItem_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_id = u'Value'
    _TRPInformationTypeResponseItem_choice_extension._cont = ASN1Dict([
        (u'id', __TRPInformationTypeResponseItem_choice_extension_id),
        (u'criticality', __TRPInformationTypeResponseItem_choice_extension_criticality),
        (u'value', __TRPInformationTypeResponseItem_choice_extension_value),
        ])
    _TRPInformationTypeResponseItem_choice_extension._ext = None
    TRPInformationTypeResponseItem._cont = ASN1Dict([
        (u'pCI-NR', _TRPInformationTypeResponseItem_pCI_NR),
        (u'cGI-NR', _TRPInformationTypeResponseItem_cGI_NR),
        (u'aRFCN', _TRPInformationTypeResponseItem_aRFCN),
        (u'pRSConfiguration', _TRPInformationTypeResponseItem_pRSConfiguration),
        (u'sSBinformation', _TRPInformationTypeResponseItem_sSBinformation),
        (u'sFNInitialisationTime', _TRPInformationTypeResponseItem_sFNInitialisationTime),
        (u'spatialDirectionInformation', _TRPInformationTypeResponseItem_spatialDirectionInformation),
        (u'geographicalCoordinates', _TRPInformationTypeResponseItem_geographicalCoordinates),
        (u'choice-extension', _TRPInformationTypeResponseItem_choice_extension),
        ])
    TRPInformationTypeResponseItem._ext = None
    
    #-----< TRPInformationTypeResponseItem-ExtIEs >-----#
    TRPInformationTypeResponseItem_ExtIEs = CLASS(name=u'TRPInformationTypeResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPType')))
    TRPInformationTypeResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeListTRPReq >-----#
    TRPInformationTypeListTRPReq = SEQ_OF(name=u'TRPInformationTypeListTRPReq', mode=MODE_TYPE)
    _TRPInformationTypeListTRPReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPInformationTypeListTRPReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TRPInformationTypeListTRPReq__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeItem')))
    ___TRPInformationTypeListTRPReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeListTRPReq__item__id._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__id._const_tab_at = None
    __TRPInformationTypeListTRPReq__item__id._const_tab_id = u'id'
    __TRPInformationTypeListTRPReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __TRPInformationTypeListTRPReq__item__criticality._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_at = ('..', u'id')
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_id = u'criticality'
    __TRPInformationTypeListTRPReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __TRPInformationTypeListTRPReq__item__value._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__value._const_tab_at = ('..', u'id')
    __TRPInformationTypeListTRPReq__item__value._const_tab_id = u'Value'
    _TRPInformationTypeListTRPReq__item_._cont = ASN1Dict([
        (u'id', __TRPInformationTypeListTRPReq__item__id),
        (u'criticality', __TRPInformationTypeListTRPReq__item__criticality),
        (u'value', __TRPInformationTypeListTRPReq__item__value),
        ])
    _TRPInformationTypeListTRPReq__item_._ext = None
    TRPInformationTypeListTRPReq._cont = _TRPInformationTypeListTRPReq__item_
    TRPInformationTypeListTRPReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeItemTRPReq >-----#
    TRPInformationTypeItemTRPReq = CLASS(name=u'TRPInformationTypeItemTRPReq', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationTypeItemTRPReq_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeItem')))
    TRPInformationTypeItemTRPReq._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', _TRPInformationTypeItemTRPReq_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeItem >-----#
    TRPInformationTypeItem = ENUM(name=u'TRPInformationTypeItem', mode=MODE_TYPE)
    TRPInformationTypeItem._cont = ASN1Dict([(u'nrPCI', 0), (u'nG-RAN-CGI', 1), (u'arfcn', 2), (u'pRSConfig', 3), (u'sSBInfo', 4), (u'sFNInitTime', 5), (u'spatialDirectInfo', 6), (u'geoCoord', 7), (u'trp-type', 8)])
    TRPInformationTypeItem._ext = [u'trp-type']
    
    #-----< TRPList >-----#
    TRPList = SEQ_OF(name=u'TRPList', mode=MODE_TYPE)
    _TRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPItem')))
    TRPList._cont = _TRPList__item_
    TRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPItem >-----#
    TRPItem = SEQ(name=u'TRPItem', mode=MODE_TYPE)
    _TRPItem_tRP_ID = INT(name=u'tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRPItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__id._const_tab = ____TRPItem_iE_Extensions__item__id_tab
    ___TRPItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TRPItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__criticality._const_tab = ____TRPItem_iE_Extensions__item__criticality_tab
    ___TRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab = ____TRPItem_iE_Extensions__item__extensionValue_tab
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPItem_iE_Extensions__item__id),
        (u'criticality', ___TRPItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TRPItem_iE_Extensions__item__extensionValue),
        ])
    __TRPItem_iE_Extensions__item_._ext = None
    _TRPItem_iE_Extensions._cont = __TRPItem_iE_Extensions__item_
    _TRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPItem._cont = ASN1Dict([
        (u'tRP-ID', _TRPItem_tRP_ID),
        (u'iE-Extensions', _TRPItem_iE_Extensions),
        ])
    TRPItem._ext = []
    
    #-----< TRPItem-ExtIEs >-----#
    TRPItem_ExtIEs = CLASS(name=u'TRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-ID >-----#
    TRP_ID = INT(name=u'TRP-ID', mode=MODE_TYPE)
    TRP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< TRPPositionDefinitionType >-----#
    TRPPositionDefinitionType = CHOICE(name=u'TRPPositionDefinitionType', mode=MODE_TYPE)
    _TRPPositionDefinitionType_direct = SEQ(name=u'direct', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDirect')))
    _TRPPositionDefinitionType_referenced = SEQ(name=u'referenced', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionReferenced')))
    _TRPPositionDefinitionType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPPositionDefinitionType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TRPPositionDefinitionType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_id._const_tab = ___TRPPositionDefinitionType_choice_extension_id_tab
    __TRPPositionDefinitionType_choice_extension_id._const_tab_at = None
    __TRPPositionDefinitionType_choice_extension_id._const_tab_id = u'id'
    __TRPPositionDefinitionType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab = ___TRPPositionDefinitionType_choice_extension_criticality_tab
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPPositionDefinitionType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPPositionDefinitionType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_value._const_tab = ___TRPPositionDefinitionType_choice_extension_value_tab
    __TRPPositionDefinitionType_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPPositionDefinitionType_choice_extension_value._const_tab_id = u'Value'
    _TRPPositionDefinitionType_choice_extension._cont = ASN1Dict([
        (u'id', __TRPPositionDefinitionType_choice_extension_id),
        (u'criticality', __TRPPositionDefinitionType_choice_extension_criticality),
        (u'value', __TRPPositionDefinitionType_choice_extension_value),
        ])
    _TRPPositionDefinitionType_choice_extension._ext = None
    TRPPositionDefinitionType._cont = ASN1Dict([
        (u'direct', _TRPPositionDefinitionType_direct),
        (u'referenced', _TRPPositionDefinitionType_referenced),
        (u'choice-extension', _TRPPositionDefinitionType_choice_extension),
        ])
    TRPPositionDefinitionType._ext = None
    
    #-----< TRPPositionDefinitionType-ExtIEs >-----#
    TRPPositionDefinitionType_ExtIEs = CLASS(name=u'TRPPositionDefinitionType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPPositionDefinitionType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirect >-----#
    TRPPositionDirect = SEQ(name=u'TRPPositionDirect', mode=MODE_TYPE)
    _TRPPositionDirect_accuracy = CHOICE(name=u'accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDirectAccuracy')))
    _TRPPositionDirect_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionDirect_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPPositionDirect_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPPositionDirect_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__id._const_tab = ____TRPPositionDirect_iE_extensions__item__id_tab
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_id = u'id'
    ___TRPPositionDirect_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab = ____TRPPositionDirect_iE_extensions__item__criticality_tab
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPPositionDirect_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab = ____TRPPositionDirect_iE_extensions__item__extensionValue_tab
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPPositionDirect_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPPositionDirect_iE_extensions__item__id),
        (u'criticality', ___TRPPositionDirect_iE_extensions__item__criticality),
        (u'extensionValue', ___TRPPositionDirect_iE_extensions__item__extensionValue),
        ])
    __TRPPositionDirect_iE_extensions__item_._ext = None
    _TRPPositionDirect_iE_extensions._cont = __TRPPositionDirect_iE_extensions__item_
    _TRPPositionDirect_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionDirect._cont = ASN1Dict([
        (u'accuracy', _TRPPositionDirect_accuracy),
        (u'iE-extensions', _TRPPositionDirect_iE_extensions),
        ])
    TRPPositionDirect._ext = []
    
    #-----< TRPPositionDirect-ExtIEs >-----#
    TRPPositionDirect_ExtIEs = CLASS(name=u'TRPPositionDirect-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPPositionDirect_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirectAccuracy >-----#
    TRPPositionDirectAccuracy = CHOICE(name=u'TRPPositionDirectAccuracy', mode=MODE_TYPE)
    _TRPPositionDirectAccuracy_tRPPosition = SEQ(name=u'tRPPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _TRPPositionDirectAccuracy_tRPHAposition = SEQ(name=u'tRPHAposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _TRPPositionDirectAccuracy_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPPositionDirectAccuracy_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab = ___TRPPositionDirectAccuracy_choice_extension_id_tab
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_at = None
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_id = u'id'
    __TRPPositionDirectAccuracy_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab = ___TRPPositionDirectAccuracy_choice_extension_criticality_tab
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPPositionDirectAccuracy_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab = ___TRPPositionDirectAccuracy_choice_extension_value_tab
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_id = u'Value'
    _TRPPositionDirectAccuracy_choice_extension._cont = ASN1Dict([
        (u'id', __TRPPositionDirectAccuracy_choice_extension_id),
        (u'criticality', __TRPPositionDirectAccuracy_choice_extension_criticality),
        (u'value', __TRPPositionDirectAccuracy_choice_extension_value),
        ])
    _TRPPositionDirectAccuracy_choice_extension._ext = None
    TRPPositionDirectAccuracy._cont = ASN1Dict([
        (u'tRPPosition', _TRPPositionDirectAccuracy_tRPPosition),
        (u'tRPHAposition', _TRPPositionDirectAccuracy_tRPHAposition),
        (u'choice-extension', _TRPPositionDirectAccuracy_choice_extension),
        ])
    TRPPositionDirectAccuracy._ext = None
    
    #-----< TRPPositionDirectAccuracy-ExtIEs >-----#
    TRPPositionDirectAccuracy_ExtIEs = CLASS(name=u'TRPPositionDirectAccuracy-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPPositionDirectAccuracy_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionReferenced >-----#
    TRPPositionReferenced = SEQ(name=u'TRPPositionReferenced', mode=MODE_TYPE)
    _TRPPositionReferenced_referencePoint = CHOICE(name=u'referencePoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferencePoint')))
    _TRPPositionReferenced_referencePointType = CHOICE(name=u'referencePointType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPReferencePointType')))
    _TRPPositionReferenced_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionReferenced_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPPositionReferenced_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____TRPPositionReferenced_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab = ____TRPPositionReferenced_iE_extensions__item__id_tab
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_id = u'id'
    ___TRPPositionReferenced_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab = ____TRPPositionReferenced_iE_extensions__item__criticality_tab
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___TRPPositionReferenced_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab = ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __TRPPositionReferenced_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___TRPPositionReferenced_iE_extensions__item__id),
        (u'criticality', ___TRPPositionReferenced_iE_extensions__item__criticality),
        (u'extensionValue', ___TRPPositionReferenced_iE_extensions__item__extensionValue),
        ])
    __TRPPositionReferenced_iE_extensions__item_._ext = None
    _TRPPositionReferenced_iE_extensions._cont = __TRPPositionReferenced_iE_extensions__item_
    _TRPPositionReferenced_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionReferenced._cont = ASN1Dict([
        (u'referencePoint', _TRPPositionReferenced_referencePoint),
        (u'referencePointType', _TRPPositionReferenced_referencePointType),
        (u'iE-extensions', _TRPPositionReferenced_iE_extensions),
        ])
    TRPPositionReferenced._ext = []
    
    #-----< TRPPositionReferenced-ExtIEs >-----#
    TRPPositionReferenced_ExtIEs = CLASS(name=u'TRPPositionReferenced-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPPositionReferenced_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPReferencePointType >-----#
    TRPReferencePointType = CHOICE(name=u'TRPReferencePointType', mode=MODE_TYPE)
    _TRPReferencePointType_tRPPositionRelativeGeodetic = SEQ(name=u'tRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _TRPReferencePointType_tRPPositionRelativeCartesian = SEQ(name=u'tRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _TRPReferencePointType_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPReferencePointType_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___TRPReferencePointType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_id._const_tab = ___TRPReferencePointType_choice_extension_id_tab
    __TRPReferencePointType_choice_extension_id._const_tab_at = None
    __TRPReferencePointType_choice_extension_id._const_tab_id = u'id'
    __TRPReferencePointType_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPReferencePointType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_criticality._const_tab = ___TRPReferencePointType_choice_extension_criticality_tab
    __TRPReferencePointType_choice_extension_criticality._const_tab_at = ('..', u'id')
    __TRPReferencePointType_choice_extension_criticality._const_tab_id = u'criticality'
    __TRPReferencePointType_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPReferencePointType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_value._const_tab = ___TRPReferencePointType_choice_extension_value_tab
    __TRPReferencePointType_choice_extension_value._const_tab_at = ('..', u'id')
    __TRPReferencePointType_choice_extension_value._const_tab_id = u'Value'
    _TRPReferencePointType_choice_extension._cont = ASN1Dict([
        (u'id', __TRPReferencePointType_choice_extension_id),
        (u'criticality', __TRPReferencePointType_choice_extension_criticality),
        (u'value', __TRPReferencePointType_choice_extension_value),
        ])
    _TRPReferencePointType_choice_extension._ext = None
    TRPReferencePointType._cont = ASN1Dict([
        (u'tRPPositionRelativeGeodetic', _TRPReferencePointType_tRPPositionRelativeGeodetic),
        (u'tRPPositionRelativeCartesian', _TRPReferencePointType_tRPPositionRelativeCartesian),
        (u'choice-extension', _TRPReferencePointType_choice_extension),
        ])
    TRPReferencePointType._ext = None
    
    #-----< TRPReferencePointType-ExtIEs >-----#
    TRPReferencePointType_ExtIEs = CLASS(name=u'TRPReferencePointType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPReferencePointType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPType >-----#
    TRPType = ENUM(name=u'TRPType', mode=MODE_TYPE)
    TRPType._cont = ASN1Dict([(u'prsOnlyTP', 0), (u'srsOnlyRP', 1), (u'tp', 2), (u'rp', 3), (u'trp', 4)])
    TRPType._ext = []
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< UARFCN >-----#
    UARFCN = INT(name=u'UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    
    #-----< UE-Measurement-ID >-----#
    UE_Measurement_ID = INT(name=u'UE-Measurement-ID', mode=MODE_TYPE)
    UE_Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[ASN1RangeInt(lb=16, ub=256)])
    
    #-----< UTRA-EcN0 >-----#
    UTRA_EcN0 = INT(name=u'UTRA-EcN0', mode=MODE_TYPE)
    UTRA_EcN0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=49)], ev=[], er=[])
    
    #-----< UTRA-RSCP >-----#
    UTRA_RSCP = INT(name=u'UTRA-RSCP', mode=MODE_TYPE)
    UTRA_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-5, ub=91)], ev=[], er=[])
    
    #-----< UL-AoA >-----#
    UL_AoA = SEQ(name=u'UL-AoA', mode=MODE_TYPE)
    _UL_AoA_azimuthAoA = INT(name=u'azimuthAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_AoA_azimuthAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _UL_AoA_zenithAoA = INT(name=u'zenithAoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_AoA_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _UL_AoA_lCS_to_GCS_TranslationAoA = SEQ(name=u'lCS-to-GCS-TranslationAoA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-TranslationAoA')), opt=True)
    _UL_AoA_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UL_AoA_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__id._const_tab = ____UL_AoA_iE_extensions__item__id_tab
    ___UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___UL_AoA_iE_extensions__item__id._const_tab_id = u'id'
    ___UL_AoA_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__criticality._const_tab = ____UL_AoA_iE_extensions__item__criticality_tab
    ___UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_AoA_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_AoA_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab = ____UL_AoA_iE_extensions__item__extensionValue_tab
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_AoA_iE_extensions__item__id),
        (u'criticality', ___UL_AoA_iE_extensions__item__criticality),
        (u'extensionValue', ___UL_AoA_iE_extensions__item__extensionValue),
        ])
    __UL_AoA_iE_extensions__item_._ext = None
    _UL_AoA_iE_extensions._cont = __UL_AoA_iE_extensions__item_
    _UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_AoA._cont = ASN1Dict([
        (u'azimuthAoA', _UL_AoA_azimuthAoA),
        (u'zenithAoA', _UL_AoA_zenithAoA),
        (u'lCS-to-GCS-TranslationAoA', _UL_AoA_lCS_to_GCS_TranslationAoA),
        (u'iE-extensions', _UL_AoA_iE_extensions),
        ])
    UL_AoA._ext = []
    
    #-----< UL-AoA-ExtIEs >-----#
    UL_AoA_ExtIEs = CLASS(name=u'UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-RTOAMeasurement >-----#
    UL_RTOAMeasurement = SEQ(name=u'UL-RTOAMeasurement', mode=MODE_TYPE)
    _UL_RTOAMeasurement_uLRTOAmeas = CHOICE(name=u'uLRTOAmeas', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ULRTOAMeas')))
    _UL_RTOAMeasurement_additionalPathList = SEQ_OF(name=u'additionalPathList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathList')), opt=True)
    _UL_RTOAMeasurement_iE_extensions = SEQ_OF(name=u'iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_RTOAMeasurement_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UL_RTOAMeasurement_iE_extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_RTOAMeasurement_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_RTOAMeasurement_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__id_tab
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab_at = None
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab_id = u'id'
    ___UL_RTOAMeasurement_iE_extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_RTOAMeasurement_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_RTOAMeasurement_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__criticality_tab
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_RTOAMeasurement_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_RTOAMeasurement_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__extensionValue_tab
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_RTOAMeasurement_iE_extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_RTOAMeasurement_iE_extensions__item__id),
        (u'criticality', ___UL_RTOAMeasurement_iE_extensions__item__criticality),
        (u'extensionValue', ___UL_RTOAMeasurement_iE_extensions__item__extensionValue),
        ])
    __UL_RTOAMeasurement_iE_extensions__item_._ext = None
    _UL_RTOAMeasurement_iE_extensions._cont = __UL_RTOAMeasurement_iE_extensions__item_
    _UL_RTOAMeasurement_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_RTOAMeasurement._cont = ASN1Dict([
        (u'uLRTOAmeas', _UL_RTOAMeasurement_uLRTOAmeas),
        (u'additionalPathList', _UL_RTOAMeasurement_additionalPathList),
        (u'iE-extensions', _UL_RTOAMeasurement_iE_extensions),
        ])
    UL_RTOAMeasurement._ext = []
    
    #-----< UL-RTOAMeasurement-ExtIEs >-----#
    UL_RTOAMeasurement_ExtIEs = CLASS(name=u'UL-RTOAMeasurement-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    UL_RTOAMeasurement_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULRTOAMeas >-----#
    ULRTOAMeas = CHOICE(name=u'ULRTOAMeas', mode=MODE_TYPE)
    _ULRTOAMeas_k0 = INT(name=u'k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _ULRTOAMeas_k1 = INT(name=u'k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _ULRTOAMeas_k2 = INT(name=u'k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _ULRTOAMeas_k3 = INT(name=u'k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _ULRTOAMeas_k4 = INT(name=u'k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _ULRTOAMeas_k5 = INT(name=u'k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _ULRTOAMeas_choice_extension = SEQ(name=u'choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ULRTOAMeas_choice_extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___ULRTOAMeas_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_id._const_tab = ___ULRTOAMeas_choice_extension_id_tab
    __ULRTOAMeas_choice_extension_id._const_tab_at = None
    __ULRTOAMeas_choice_extension_id._const_tab_id = u'id'
    __ULRTOAMeas_choice_extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ULRTOAMeas_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_criticality._const_tab = ___ULRTOAMeas_choice_extension_criticality_tab
    __ULRTOAMeas_choice_extension_criticality._const_tab_at = ('..', u'id')
    __ULRTOAMeas_choice_extension_criticality._const_tab_id = u'criticality'
    __ULRTOAMeas_choice_extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ULRTOAMeas_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_value._const_tab = ___ULRTOAMeas_choice_extension_value_tab
    __ULRTOAMeas_choice_extension_value._const_tab_at = ('..', u'id')
    __ULRTOAMeas_choice_extension_value._const_tab_id = u'Value'
    _ULRTOAMeas_choice_extension._cont = ASN1Dict([
        (u'id', __ULRTOAMeas_choice_extension_id),
        (u'criticality', __ULRTOAMeas_choice_extension_criticality),
        (u'value', __ULRTOAMeas_choice_extension_value),
        ])
    _ULRTOAMeas_choice_extension._ext = None
    ULRTOAMeas._cont = ASN1Dict([
        (u'k0', _ULRTOAMeas_k0),
        (u'k1', _ULRTOAMeas_k1),
        (u'k2', _ULRTOAMeas_k2),
        (u'k3', _ULRTOAMeas_k3),
        (u'k4', _ULRTOAMeas_k4),
        (u'k5', _ULRTOAMeas_k5),
        (u'choice-extension', _ULRTOAMeas_choice_extension),
        ])
    ULRTOAMeas._ext = None
    
    #-----< ULRTOAMeas-ExtIEs >-----#
    ULRTOAMeas_ExtIEs = CLASS(name=u'ULRTOAMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ULRTOAMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-SRS-RSRP >-----#
    UL_SRS_RSRP = INT(name=u'UL-SRS-RSRP', mode=MODE_TYPE)
    UL_SRS_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< UplinkChannelBW-PerSCS-List >-----#
    UplinkChannelBW_PerSCS_List = SEQ_OF(name=u'UplinkChannelBW-PerSCS-List', mode=MODE_TYPE)
    _UplinkChannelBW_PerSCS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SCS-SpecificCarrier')))
    UplinkChannelBW_PerSCS_List._cont = _UplinkChannelBW_PerSCS_List__item_
    UplinkChannelBW_PerSCS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< ValueRSRP-EUTRA >-----#
    ValueRSRP_EUTRA = INT(name=u'ValueRSRP-EUTRA', mode=MODE_TYPE)
    ValueRSRP_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=[], er=[])
    
    #-----< ValueRSRQ-EUTRA >-----#
    ValueRSRQ_EUTRA = INT(name=u'ValueRSRQ-EUTRA', mode=MODE_TYPE)
    ValueRSRQ_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=[], er=[])
    
    #-----< ValueRSRP-NR >-----#
    ValueRSRP_NR = INT(name=u'ValueRSRP-NR', mode=MODE_TYPE)
    ValueRSRP_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ValueRSRQ-NR >-----#
    ValueRSRQ_NR = INT(name=u'ValueRSRQ-NR', mode=MODE_TYPE)
    ValueRSRQ_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities >-----#
    WLANMeasurementQuantities = SEQ_OF(name=u'WLANMeasurementQuantities', mode=MODE_TYPE)
    _WLANMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __WLANMeasurementQuantities__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___WLANMeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____WLANMeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities-Item')))
    ___WLANMeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', ____WLANMeasurementQuantities__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __WLANMeasurementQuantities__item__id._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__id._const_tab_at = None
    __WLANMeasurementQuantities__item__id._const_tab_id = u'id'
    __WLANMeasurementQuantities__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __WLANMeasurementQuantities__item__criticality._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__criticality._const_tab_at = ('..', u'id')
    __WLANMeasurementQuantities__item__criticality._const_tab_id = u'criticality'
    __WLANMeasurementQuantities__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __WLANMeasurementQuantities__item__value._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__value._const_tab_at = ('..', u'id')
    __WLANMeasurementQuantities__item__value._const_tab_id = u'Value'
    _WLANMeasurementQuantities__item_._cont = ASN1Dict([
        (u'id', __WLANMeasurementQuantities__item__id),
        (u'criticality', __WLANMeasurementQuantities__item__criticality),
        (u'value', __WLANMeasurementQuantities__item__value),
        ])
    _WLANMeasurementQuantities__item_._ext = None
    WLANMeasurementQuantities._cont = _WLANMeasurementQuantities__item_
    WLANMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities-ItemIEs >-----#
    WLANMeasurementQuantities_ItemIEs = CLASS(name=u'WLANMeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _WLANMeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities-Item')))
    WLANMeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', _WLANMeasurementQuantities_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities-Item >-----#
    WLANMeasurementQuantities_Item = SEQ(name=u'WLANMeasurementQuantities-Item', mode=MODE_TYPE)
    _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue = ENUM(name=u'wLANMeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantitiesValue')))
    _WLANMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANMeasurementQuantities_Item_iE_Extensions__item__id),
        (u'criticality', ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _WLANMeasurementQuantities_Item_iE_Extensions._cont = __WLANMeasurementQuantities_Item_iE_Extensions__item_
    _WLANMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementQuantities_Item._cont = ASN1Dict([
        (u'wLANMeasurementQuantitiesValue', _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue),
        (u'iE-Extensions', _WLANMeasurementQuantities_Item_iE_Extensions),
        ])
    WLANMeasurementQuantities_Item._ext = []
    
    #-----< WLANMeasurementQuantitiesValue-ExtIEs >-----#
    WLANMeasurementQuantitiesValue_ExtIEs = CLASS(name=u'WLANMeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    WLANMeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasurementQuantitiesValue >-----#
    WLANMeasurementQuantitiesValue = ENUM(name=u'WLANMeasurementQuantitiesValue', mode=MODE_TYPE)
    WLANMeasurementQuantitiesValue._cont = ASN1Dict([(u'wlan', 0)])
    WLANMeasurementQuantitiesValue._ext = []
    
    #-----< WLANMeasurementResult >-----#
    WLANMeasurementResult = SEQ_OF(name=u'WLANMeasurementResult', mode=MODE_TYPE)
    _WLANMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult-Item')))
    WLANMeasurementResult._cont = _WLANMeasurementResult__item_
    WLANMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< WLANMeasurementResult-Item >-----#
    WLANMeasurementResult_Item = SEQ(name=u'WLANMeasurementResult-Item', mode=MODE_TYPE)
    _WLANMeasurementResult_Item_wLAN_RSSI = INT(name=u'wLAN-RSSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLAN-RSSI')))
    _WLANMeasurementResult_Item_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSID')), opt=True)
    _WLANMeasurementResult_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BSSID')), opt=True)
    _WLANMeasurementResult_Item_hESSID = OCT_STR(name=u'hESSID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'HESSID')), opt=True)
    _WLANMeasurementResult_Item_operatingClass = INT(name=u'operatingClass', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANOperatingClass')), opt=True)
    _WLANMeasurementResult_Item_countryCode = ENUM(name=u'countryCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANCountryCode')), opt=True)
    _WLANMeasurementResult_Item_wLANChannelList = SEQ_OF(name=u'wLANChannelList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANChannelList')), opt=True)
    _WLANMeasurementResult_Item_wLANBand = ENUM(name=u'wLANBand', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANBand')), opt=True)
    _WLANMeasurementResult_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementResult_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANMeasurementResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANMeasurementResult_Item_iE_Extensions__item__id),
        (u'criticality', ___WLANMeasurementResult_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementResult_Item_iE_Extensions__item_._ext = None
    _WLANMeasurementResult_Item_iE_Extensions._cont = __WLANMeasurementResult_Item_iE_Extensions__item_
    _WLANMeasurementResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementResult_Item._cont = ASN1Dict([
        (u'wLAN-RSSI', _WLANMeasurementResult_Item_wLAN_RSSI),
        (u'sSID', _WLANMeasurementResult_Item_sSID),
        (u'bSSID', _WLANMeasurementResult_Item_bSSID),
        (u'hESSID', _WLANMeasurementResult_Item_hESSID),
        (u'operatingClass', _WLANMeasurementResult_Item_operatingClass),
        (u'countryCode', _WLANMeasurementResult_Item_countryCode),
        (u'wLANChannelList', _WLANMeasurementResult_Item_wLANChannelList),
        (u'wLANBand', _WLANMeasurementResult_Item_wLANBand),
        (u'iE-Extensions', _WLANMeasurementResult_Item_iE_Extensions),
        ])
    WLANMeasurementResult_Item._ext = []
    
    #-----< WLANMeasurementResult-Item-ExtIEs >-----#
    WLANMeasurementResult_Item_ExtIEs = CLASS(name=u'WLANMeasurementResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    WLANMeasurementResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLAN-RSSI >-----#
    WLAN_RSSI = INT(name=u'WLAN-RSSI', mode=MODE_TYPE)
    WLAN_RSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=141)], ev=[], er=[])
    
    #-----< WLANBand >-----#
    WLANBand = ENUM(name=u'WLANBand', mode=MODE_TYPE)
    WLANBand._cont = ASN1Dict([(u'band2dot4', 0), (u'band5', 1)])
    WLANBand._ext = []
    
    #-----< WLANChannelList >-----#
    WLANChannelList = SEQ_OF(name=u'WLANChannelList', mode=MODE_TYPE)
    _WLANChannelList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANChannel')))
    WLANChannelList._cont = _WLANChannelList__item_
    WLANChannelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< WLANChannel >-----#
    WLANChannel = INT(name=u'WLANChannel', mode=MODE_TYPE)
    WLANChannel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< WLANCountryCode >-----#
    WLANCountryCode = ENUM(name=u'WLANCountryCode', mode=MODE_TYPE)
    WLANCountryCode._cont = ASN1Dict([(u'unitedStates', 0), (u'europe', 1), (u'japan', 2), (u'global', 3)])
    WLANCountryCode._ext = []
    
    #-----< WLANOperatingClass >-----#
    WLANOperatingClass = INT(name=u'WLANOperatingClass', mode=MODE_TYPE)
    WLANOperatingClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    _all_ = [
        _AbortTransmission_deactivateSRSResourceSetID,
        _AbortTransmission_releaseALL,
        ___AbortTransmission_choice_extension_id_tab,
        __AbortTransmission_choice_extension_id,
        ___AbortTransmission_choice_extension_criticality_tab,
        __AbortTransmission_choice_extension_criticality,
        ___AbortTransmission_choice_extension_value_tab,
        __AbortTransmission_choice_extension_value,
        _AbortTransmission_choice_extension,
        AbortTransmission,
        AbortTransmission_ExtIEs,
        _ActiveULBWP_locationAndBandwidth,
        _ActiveULBWP_subcarrierSpacing,
        _ActiveULBWP_cyclicPrefix,
        _ActiveULBWP_txDirectCurrentLocation,
        _ActiveULBWP_shift7dot5kHz,
        _ActiveULBWP_sRSConfig,
        ____ActiveULBWP_iE_Extensions__item__id_tab,
        ___ActiveULBWP_iE_Extensions__item__id,
        ____ActiveULBWP_iE_Extensions__item__criticality_tab,
        ___ActiveULBWP_iE_Extensions__item__criticality,
        ____ActiveULBWP_iE_Extensions__item__extensionValue_tab,
        ___ActiveULBWP_iE_Extensions__item__extensionValue,
        __ActiveULBWP_iE_Extensions__item_,
        _ActiveULBWP_iE_Extensions,
        ActiveULBWP,
        ActiveULBWP_ExtIEs,
        _AdditionalPathList__item_,
        AdditionalPathList,
        _AdditionalPathListItem_relativeTimeOfPath,
        _AdditionalPathListItem_pathQuality,
        ____AdditionalPathListItem_iE_Extensions__item__id_tab,
        ___AdditionalPathListItem_iE_Extensions__item__id,
        ____AdditionalPathListItem_iE_Extensions__item__criticality_tab,
        ___AdditionalPathListItem_iE_Extensions__item__criticality,
        ____AdditionalPathListItem_iE_Extensions__item__extensionValue_tab,
        ___AdditionalPathListItem_iE_Extensions__item__extensionValue,
        __AdditionalPathListItem_iE_Extensions__item_,
        _AdditionalPathListItem_iE_Extensions,
        AdditionalPathListItem,
        AdditionalPathListItem_ExtIEs,
        _AperiodicSRSResourceTriggerList__item_,
        AperiodicSRSResourceTriggerList,
        AperiodicSRSResourceTrigger,
        _Assistance_Information_systemInformation,
        ____Assistance_Information_iE_Extensions__item__id_tab,
        ___Assistance_Information_iE_Extensions__item__id,
        ____Assistance_Information_iE_Extensions__item__criticality_tab,
        ___Assistance_Information_iE_Extensions__item__criticality,
        ____Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___Assistance_Information_iE_Extensions__item__extensionValue,
        __Assistance_Information_iE_Extensions__item_,
        _Assistance_Information_iE_Extensions,
        Assistance_Information,
        Assistance_Information_ExtIEs,
        __AssistanceInformationFailureList__item__posSIB_Type,
        __AssistanceInformationFailureList__item__outcome,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__id,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue,
        ___AssistanceInformationFailureList__item__iE_Extensions__item_,
        __AssistanceInformationFailureList__item__iE_Extensions,
        _AssistanceInformationFailureList__item_,
        AssistanceInformationFailureList,
        AssistanceInformationFailureList_ExtIEs,
        _AssistanceInformationMetaData_encrypted,
        _AssistanceInformationMetaData_gNSSID,
        _AssistanceInformationMetaData_sBASID,
        ____AssistanceInformationMetaData_iE_Extensions__item__id_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__id,
        ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__criticality,
        ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue,
        __AssistanceInformationMetaData_iE_Extensions__item_,
        _AssistanceInformationMetaData_iE_Extensions,
        AssistanceInformationMetaData,
        AssistanceInformationMetaData_ExtIEs,
        _BandwidthSRS_fR1,
        _BandwidthSRS_fR2,
        ___BandwidthSRS_choice_extension_id_tab,
        __BandwidthSRS_choice_extension_id,
        ___BandwidthSRS_choice_extension_criticality_tab,
        __BandwidthSRS_choice_extension_criticality,
        ___BandwidthSRS_choice_extension_value_tab,
        __BandwidthSRS_choice_extension_value,
        _BandwidthSRS_choice_extension,
        BandwidthSRS,
        BandwidthSRS_ExtIEs,
        BCCH,
        Broadcast,
        BroadcastPeriodicity,
        _PositioningBroadcastCells__item_,
        PositioningBroadcastCells,
        BSSID,
        _Cause_radioNetwork,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_Extension_id_tab,
        __Cause_choice_Extension_id,
        ___Cause_choice_Extension_criticality_tab,
        __Cause_choice_Extension_criticality,
        ___Cause_choice_Extension_value_tab,
        __Cause_choice_Extension_value,
        _Cause_choice_Extension,
        Cause,
        Cause_ExtensionIE,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        Cell_Portion_ID,
        _CGI_EUTRA_pLMN_Identity,
        _CGI_EUTRA_eUTRAcellIdentifier,
        ____CGI_EUTRA_iE_Extensions__item__id_tab,
        ___CGI_EUTRA_iE_Extensions__item__id,
        ____CGI_EUTRA_iE_Extensions__item__criticality_tab,
        ___CGI_EUTRA_iE_Extensions__item__criticality,
        ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___CGI_EUTRA_iE_Extensions__item__extensionValue,
        __CGI_EUTRA_iE_Extensions__item_,
        _CGI_EUTRA_iE_Extensions,
        CGI_EUTRA,
        CGI_EUTRA_ExtIEs,
        _CGI_NR_pLMN_Identity,
        _CGI_NR_nRcellIdentifier,
        ____CGI_NR_iE_Extensions__item__id_tab,
        ___CGI_NR_iE_Extensions__item__id,
        ____CGI_NR_iE_Extensions__item__criticality_tab,
        ___CGI_NR_iE_Extensions__item__criticality,
        ____CGI_NR_iE_Extensions__item__extensionValue_tab,
        ___CGI_NR_iE_Extensions__item__extensionValue,
        __CGI_NR_iE_Extensions__item_,
        _CGI_NR_iE_Extensions,
        CGI_NR,
        CGI_NR_ExtIEs,
        CPLength_EUTRA,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_nrppatransactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        DL_Bandwidth_EUTRA,
        _DL_PRS_prsid,
        _DL_PRS_dl_PRSResourceSetID,
        _DL_PRS_dl_PRSResourceID,
        ____DL_PRS_iE_Extensions__item__id_tab,
        ___DL_PRS_iE_Extensions__item__id,
        ____DL_PRS_iE_Extensions__item__criticality_tab,
        ___DL_PRS_iE_Extensions__item__criticality,
        ____DL_PRS_iE_Extensions__item__extensionValue_tab,
        ___DL_PRS_iE_Extensions__item__extensionValue,
        __DL_PRS_iE_Extensions__item_,
        _DL_PRS_iE_Extensions,
        DL_PRS,
        DL_PRS_ExtIEs,
        _DL_PRSMutingPattern_two,
        _DL_PRSMutingPattern_four,
        _DL_PRSMutingPattern_six,
        _DL_PRSMutingPattern_eight,
        _DL_PRSMutingPattern_sixteen,
        _DL_PRSMutingPattern_thirty_two,
        ___DL_PRSMutingPattern_choice_extension_id_tab,
        __DL_PRSMutingPattern_choice_extension_id,
        ___DL_PRSMutingPattern_choice_extension_criticality_tab,
        __DL_PRSMutingPattern_choice_extension_criticality,
        ___DL_PRSMutingPattern_choice_extension_value_tab,
        __DL_PRSMutingPattern_choice_extension_value,
        _DL_PRSMutingPattern_choice_extension,
        DL_PRSMutingPattern,
        DL_PRSMutingPattern_ExtIEs,
        __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_,
        _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP,
        ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__id,
        ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__criticality,
        ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue,
        __DLPRSResourceCoordinates_iE_Extensions__item_,
        _DLPRSResourceCoordinates_iE_Extensions,
        DLPRSResourceCoordinates,
        DLPRSResourceCoordinates_ExtIEs,
        _DLPRSResourceSetARP_dl_PRSResourceSetID,
        _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation,
        __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_,
        _DLPRSResourceSetARP_listofDL_PRSResourceARP,
        ____DLPRSResourceSetARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__id,
        ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__criticality,
        ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceSetARP_iE_Extensions__item_,
        _DLPRSResourceSetARP_iE_Extensions,
        DLPRSResourceSetARP,
        DLPRSResourceSetARP_ExtIEs,
        _DL_PRSResourceSetARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceSetARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_id,
        ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_value,
        _DL_PRSResourceSetARPLocation_choice_Extension,
        DL_PRSResourceSetARPLocation,
        DL_PRSResourceSetARPLocation_ExtIEs,
        _DLPRSResourceARP_dl_PRSResourceID,
        _DLPRSResourceARP_dL_PRSResourceARPLocation,
        ____DLPRSResourceARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceARP_iE_Extensions__item__id,
        ____DLPRSResourceARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceARP_iE_Extensions__item__criticality,
        ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceARP_iE_Extensions__item_,
        _DLPRSResourceARP_iE_Extensions,
        DLPRSResourceARP,
        DLPRSResourceARP_ExtIEs,
        _DL_PRSResourceARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceARPLocation_choice_Extension_id,
        ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceARPLocation_choice_Extension_value,
        _DL_PRSResourceARPLocation_choice_Extension,
        DL_PRSResourceARPLocation,
        DL_PRSResourceARPLocation_ExtIEs,
        _E_CID_MeasurementResult_servingCell_ID,
        _E_CID_MeasurementResult_servingCellTAC,
        _E_CID_MeasurementResult_nG_RANAccessPointPosition,
        _E_CID_MeasurementResult_measuredResults,
        ____E_CID_MeasurementResult_iE_Extensions__item__id_tab,
        _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_CID_MeasurementResult_iE_Extensions__item__id,
        ___E_CID_MeasurementResult_iE_Extensions__item__criticality,
        ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementResult_iE_Extensions__item_,
        _E_CID_MeasurementResult_iE_Extensions,
        E_CID_MeasurementResult,
        E_CID_MeasurementResult_ExtIEs,
        _E_CID_MeasurementResult_ExtIEs_val_Extension_0,
        EUTRACellIdentifier,
        EARFCN,
        _GeographicalCoordinates_tRPPositionDefinitionType,
        _GeographicalCoordinates_dLPRSResourceCoordinates,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GNB_RxTxTimeDiff_rxTxTimeDiff,
        _GNB_RxTxTimeDiff_additionalPathList,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__id,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__criticality_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue_tab,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue,
        __GNB_RxTxTimeDiff_iE_Extensions__item_,
        _GNB_RxTxTimeDiff_iE_Extensions,
        GNB_RxTxTimeDiff,
        GNB_RxTxTimeDiff_ExtIEs,
        _GNBRxTxTimeDiffMeas_k0,
        _GNBRxTxTimeDiffMeas_k1,
        _GNBRxTxTimeDiffMeas_k2,
        _GNBRxTxTimeDiffMeas_k3,
        _GNBRxTxTimeDiffMeas_k4,
        _GNBRxTxTimeDiffMeas_k5,
        ___GNBRxTxTimeDiffMeas_choice_extension_id_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_id,
        ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_criticality,
        ___GNBRxTxTimeDiffMeas_choice_extension_value_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_value,
        _GNBRxTxTimeDiffMeas_choice_extension,
        GNBRxTxTimeDiffMeas,
        GNBRxTxTimeDiffMeas_ExtIEs,
        HESSID,
        _LCS_to_GCS_TranslationAoA_alpha,
        _LCS_to_GCS_TranslationAoA_beta,
        _LCS_to_GCS_TranslationAoA_gamma,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__id,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__criticality,
        ____LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_TranslationAoA_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_TranslationAoA_iE_Extensions__item_,
        _LCS_to_GCS_TranslationAoA_iE_Extensions,
        LCS_to_GCS_TranslationAoA,
        LCS_to_GCS_TranslationAoA_ExtIEs,
        _LCS_to_GCS_TranslationItem_alpha,
        _LCS_to_GCS_TranslationItem_alphaFine,
        _LCS_to_GCS_TranslationItem_beta,
        _LCS_to_GCS_TranslationItem_betaFine,
        _LCS_to_GCS_TranslationItem_gamma,
        _LCS_to_GCS_TranslationItem_gammaFine,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_TranslationItem_iE_Extensions__item_,
        _LCS_to_GCS_TranslationItem_iE_Extensions,
        LCS_to_GCS_TranslationItem,
        LCS_to_GCS_TranslationItem_ExtIEs,
        _LocationUncertainty_horizontalUncertainty,
        _LocationUncertainty_horizontalConfidence,
        _LocationUncertainty_verticalUncertainty,
        _LocationUncertainty_verticalConfidence,
        ____LocationUncertainty_iE_Extensions__item__id_tab,
        ___LocationUncertainty_iE_Extensions__item__id,
        ____LocationUncertainty_iE_Extensions__item__criticality_tab,
        ___LocationUncertainty_iE_Extensions__item__criticality,
        ____LocationUncertainty_iE_Extensions__item__extensionValue_tab,
        ___LocationUncertainty_iE_Extensions__item__extensionValue,
        __LocationUncertainty_iE_Extensions__item_,
        _LocationUncertainty_iE_Extensions,
        LocationUncertainty,
        LocationUncertainty_ExtIEs,
        Measurement_ID,
        MeasurementBeamInfoRequest,
        _MeasurementBeamInfo_pRS_Resource_ID,
        _MeasurementBeamInfo_pRS_Resource_Set_ID,
        _MeasurementBeamInfo_sSB_Index,
        ____MeasurementBeamInfo_iE_Extensions__item__id_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__id,
        ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__criticality,
        ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__extensionValue,
        __MeasurementBeamInfo_iE_Extensions__item_,
        _MeasurementBeamInfo_iE_Extensions,
        MeasurementBeamInfo,
        MeasurementBeamInfo_ExtIEs,
        MeasurementPeriodicity,
        MeasurementPeriodicityExtended,
        ___MeasurementQuantities__item__id_tab,
        ____MeasurementQuantities__item__id_tab_val_Value_0,
        __MeasurementQuantities__item__id,
        __MeasurementQuantities__item__criticality,
        __MeasurementQuantities__item__value,
        _MeasurementQuantities__item_,
        MeasurementQuantities,
        MeasurementQuantities_ItemIEs,
        _MeasurementQuantities_ItemIEs_val_Value_0,
        _MeasurementQuantities_Item_measurementQuantitiesValue,
        ____MeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__id,
        ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __MeasurementQuantities_Item_iE_Extensions__item_,
        _MeasurementQuantities_Item_iE_Extensions,
        MeasurementQuantities_Item,
        MeasurementQuantitiesValue_ExtIEs,
        MeasurementQuantitiesValue,
        _MeasuredResults__item_,
        MeasuredResults,
        _MeasuredResultsValue_valueAngleOfArrival_EUTRA,
        _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA,
        _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA,
        _MeasuredResultsValue_resultRSRP_EUTRA,
        _MeasuredResultsValue_resultRSRQ_EUTRA,
        ___MeasuredResultsValue_choice_Extension_id_tab,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4,
        __MeasuredResultsValue_choice_Extension_id,
        __MeasuredResultsValue_choice_Extension_criticality,
        __MeasuredResultsValue_choice_Extension_value,
        _MeasuredResultsValue_choice_Extension,
        MeasuredResultsValue,
        MeasuredResultsValue_ExtensionIE,
        _MeasuredResultsValue_ExtensionIE_val_Value_0,
        _MeasuredResultsValue_ExtensionIE_val_Value_1,
        _MeasuredResultsValue_ExtensionIE_val_Value_2,
        _MeasuredResultsValue_ExtensionIE_val_Value_3,
        _MeasuredResultsValue_ExtensionIE_val_Value_4,
        NarrowBandIndex,
        _NG_RANAccessPointPosition_latitudeSign,
        _NG_RANAccessPointPosition_latitude,
        _NG_RANAccessPointPosition_longitude,
        _NG_RANAccessPointPosition_directionOfAltitude,
        _NG_RANAccessPointPosition_altitude,
        _NG_RANAccessPointPosition_uncertaintySemi_major,
        _NG_RANAccessPointPosition_uncertaintySemi_minor,
        _NG_RANAccessPointPosition_orientationOfMajorAxis,
        _NG_RANAccessPointPosition_uncertaintyAltitude,
        _NG_RANAccessPointPosition_confidence,
        ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__id,
        ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__criticality,
        ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue,
        __NG_RANAccessPointPosition_iE_Extensions__item_,
        _NG_RANAccessPointPosition_iE_Extensions,
        NG_RANAccessPointPosition,
        NG_RANAccessPointPosition_ExtIEs,
        _NGRANHighAccuracyAccessPointPosition_latitude,
        _NGRANHighAccuracyAccessPointPosition_longitude,
        _NGRANHighAccuracyAccessPointPosition_altitude,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor,
        _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis,
        _NGRANHighAccuracyAccessPointPosition_horizontalConfidence,
        _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude,
        _NGRANHighAccuracyAccessPointPosition_verticalConfidence,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue,
        __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_,
        _NGRANHighAccuracyAccessPointPosition_iE_Extensions,
        NGRANHighAccuracyAccessPointPosition,
        NGRANHighAccuracyAccessPointPosition_ExtIEs,
        _NG_RAN_CGI_pLMN_Identity,
        _NG_RAN_CGI_nG_RANcell,
        ____NG_RAN_CGI_iE_Extensions__item__id_tab,
        ___NG_RAN_CGI_iE_Extensions__item__id,
        ____NG_RAN_CGI_iE_Extensions__item__criticality_tab,
        ___NG_RAN_CGI_iE_Extensions__item__criticality,
        ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab,
        ___NG_RAN_CGI_iE_Extensions__item__extensionValue,
        __NG_RAN_CGI_iE_Extensions__item_,
        _NG_RAN_CGI_iE_Extensions,
        NG_RAN_CGI,
        NG_RAN_CGI_ExtIEs,
        _NG_RANCell_eUTRA_CellID,
        _NG_RANCell_nR_CellID,
        ___NG_RANCell_choice_Extension_id_tab,
        __NG_RANCell_choice_Extension_id,
        ___NG_RANCell_choice_Extension_criticality_tab,
        __NG_RANCell_choice_Extension_criticality,
        ___NG_RANCell_choice_Extension_value_tab,
        __NG_RANCell_choice_Extension_value,
        _NG_RANCell_choice_Extension,
        NG_RANCell,
        NG_RANCell_ExtensionIE,
        NR_ARFCN,
        NRCellIdentifier,
        NR_PCI,
        __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_,
        _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList,
        __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_,
        _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList,
        ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__id,
        ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__criticality,
        ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue,
        __NR_PRS_Beam_Information_iE_Extensions__item_,
        _NR_PRS_Beam_Information_iE_Extensions,
        NR_PRS_Beam_Information,
        NR_PRS_Beam_Information_IEs,
        _NR_PRS_Beam_InformationItem_pRSresourceSetID,
        __NR_PRS_Beam_InformationItem_pRSAngleItem__item_,
        _NR_PRS_Beam_InformationItem_pRSAngleItem,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue,
        __NR_PRS_Beam_InformationItem_iE_Extensions__item_,
        _NR_PRS_Beam_InformationItem_iE_Extensions,
        NR_PRS_Beam_InformationItem,
        NR_PRS_Beam_InformationItem_ExtIEs,
        NumberOfAntennaPorts_EUTRA,
        NumberOfDlFrames_EUTRA,
        NumberOfDlFrames_Extended_EUTRA,
        NumberOfFrequencyHoppingBands,
        NZP_CSI_RS_ResourceID,
        __OTDOACells__item__oTDOACellInfo,
        _____OTDOACells__item__iE_Extensions__item__id_tab,
        ____OTDOACells__item__iE_Extensions__item__id,
        _____OTDOACells__item__iE_Extensions__item__criticality_tab,
        ____OTDOACells__item__iE_Extensions__item__criticality,
        _____OTDOACells__item__iE_Extensions__item__extensionValue_tab,
        ____OTDOACells__item__iE_Extensions__item__extensionValue,
        ___OTDOACells__item__iE_Extensions__item_,
        __OTDOACells__item__iE_Extensions,
        _OTDOACells__item_,
        OTDOACells,
        OTDOACells_ExtIEs,
        _OTDOACell_Information__item_,
        OTDOACell_Information,
        _OTDOACell_Information_Item_pCI_EUTRA,
        _OTDOACell_Information_Item_cGI_EUTRA,
        _OTDOACell_Information_Item_tAC,
        _OTDOACell_Information_Item_eARFCN,
        _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA,
        _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA,
        _OTDOACell_Information_Item_cPLength_EUTRA,
        _OTDOACell_Information_Item_numberOfDlFrames_EUTRA,
        _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA,
        _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA,
        _OTDOACell_Information_Item_nG_RANAccessPointPosition,
        _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA,
        _OTDOACell_Information_Item_prsid_EUTRA,
        _OTDOACell_Information_Item_tpid_EUTRA,
        _OTDOACell_Information_Item_tpType_EUTRA,
        _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA,
        _OTDOACell_Information_Item_crsCPlength_EUTRA,
        _OTDOACell_Information_Item_dL_Bandwidth_EUTRA,
        _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA,
        _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA,
        ___OTDOACell_Information_Item_choice_Extension_id_tab,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2,
        __OTDOACell_Information_Item_choice_Extension_id,
        __OTDOACell_Information_Item_choice_Extension_criticality,
        __OTDOACell_Information_Item_choice_Extension_value,
        _OTDOACell_Information_Item_choice_Extension,
        OTDOACell_Information_Item,
        OTDOACell_Information_Item_ExtensionIE,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_0,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_1,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_2,
        OTDOA_Information_Item,
        ___OtherRATMeasurementQuantities__item__id_tab,
        ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0,
        __OtherRATMeasurementQuantities__item__id,
        __OtherRATMeasurementQuantities__item__criticality,
        __OtherRATMeasurementQuantities__item__value,
        _OtherRATMeasurementQuantities__item_,
        OtherRATMeasurementQuantities,
        OtherRATMeasurementQuantities_ItemIEs,
        _OtherRATMeasurementQuantities_ItemIEs_val_Value_0,
        _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __OtherRATMeasurementQuantities_Item_iE_Extensions__item_,
        _OtherRATMeasurementQuantities_Item_iE_Extensions,
        OtherRATMeasurementQuantities_Item,
        OtherRATMeasurementQuantitiesValue_ExtIEs,
        OtherRATMeasurementQuantitiesValue,
        _OtherRATMeasurementResult__item_,
        OtherRATMeasurementResult,
        _OtherRATMeasuredResultsValue_resultGERAN,
        _OtherRATMeasuredResultsValue_resultUTRAN,
        ___OtherRATMeasuredResultsValue_choice_Extension_id_tab,
        ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0,
        ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1,
        __OtherRATMeasuredResultsValue_choice_Extension_id,
        __OtherRATMeasuredResultsValue_choice_Extension_criticality,
        __OtherRATMeasuredResultsValue_choice_Extension_value,
        _OtherRATMeasuredResultsValue_choice_Extension,
        OtherRATMeasuredResultsValue,
        OtherRATMeasuredResultsValue_ExtensionIE,
        _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0,
        _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1,
        Outcome,
        _PathlossReferenceInformation_pathlossReferenceSignal,
        ____PathlossReferenceInformation_iE_Extensions__item__id_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__id,
        ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__criticality,
        ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__extensionValue,
        __PathlossReferenceInformation_iE_Extensions__item_,
        _PathlossReferenceInformation_iE_Extensions,
        PathlossReferenceInformation,
        PathlossReferenceInformation_ExtIEs,
        _PathlossReferenceSignal_sSB_Reference,
        _PathlossReferenceSignal_dL_PRS_Reference,
        ___PathlossReferenceSignal_choice_Extension_id_tab,
        __PathlossReferenceSignal_choice_Extension_id,
        ___PathlossReferenceSignal_choice_Extension_criticality_tab,
        __PathlossReferenceSignal_choice_Extension_criticality,
        ___PathlossReferenceSignal_choice_Extension_value_tab,
        __PathlossReferenceSignal_choice_Extension_value,
        _PathlossReferenceSignal_choice_Extension,
        PathlossReferenceSignal,
        PathlossReferenceSignal_ExtensionIE,
        PCI_EUTRA,
        PhysCellIDGERAN,
        PhysCellIDUTRA_FDD,
        PhysCellIDUTRA_TDD,
        PLMN_Identity,
        _PeriodicityList__item_,
        PeriodicityList,
        PeriodicityItem,
        __PosSIBs__item__posSIB_Type,
        __PosSIBs__item__posSIB_Segments,
        __PosSIBs__item__assistanceInformationMetaData,
        __PosSIBs__item__broadcastPriority,
        _____PosSIBs__item__iE_Extensions__item__id_tab,
        ____PosSIBs__item__iE_Extensions__item__id,
        _____PosSIBs__item__iE_Extensions__item__criticality_tab,
        ____PosSIBs__item__iE_Extensions__item__criticality,
        _____PosSIBs__item__iE_Extensions__item__extensionValue_tab,
        ____PosSIBs__item__iE_Extensions__item__extensionValue,
        ___PosSIBs__item__iE_Extensions__item_,
        __PosSIBs__item__iE_Extensions,
        _PosSIBs__item_,
        PosSIBs,
        PosSIBs_ExtIEs,
        __PosSIB_Segments__item__assistanceDataSIBelement,
        _____PosSIB_Segments__item__iE_Extensions__item__id_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__id,
        _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__criticality,
        _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__extensionValue,
        ___PosSIB_Segments__item__iE_Extensions__item_,
        __PosSIB_Segments__item__iE_Extensions,
        _PosSIB_Segments__item_,
        PosSIB_Segments,
        PosSIB_Segments_ExtIEs,
        PosSIB_Type,
        _PosSRSResource_List__item_,
        PosSRSResource_List,
        _PosSRSResource_Item_srs_PosResourceId,
        _PosSRSResource_Item_transmissionCombPos,
        _PosSRSResource_Item_startPosition,
        _PosSRSResource_Item_nrofSymbols,
        _PosSRSResource_Item_freqDomainShift,
        _PosSRSResource_Item_c_SRS,
        _PosSRSResource_Item_groupOrSequenceHopping,
        _PosSRSResource_Item_resourceTypePos,
        _PosSRSResource_Item_sequenceId,
        _PosSRSResource_Item_spatialRelationPos,
        ____PosSRSResource_Item_iE_Extensions__item__id_tab,
        ___PosSRSResource_Item_iE_Extensions__item__id,
        ____PosSRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResource_Item_iE_Extensions__item__criticality,
        ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResource_Item_iE_Extensions__item__extensionValue,
        __PosSRSResource_Item_iE_Extensions__item_,
        _PosSRSResource_Item_iE_Extensions,
        PosSRSResource_Item,
        PosSRSResource_Item_ExtIEs,
        _PosSRSResourceSet_List__item_,
        PosSRSResourceSet_List,
        _PosSRSResourceID_List__item_,
        PosSRSResourceID_List,
        _PosSRSResourceSet_Item_possrsResourceSetID,
        _PosSRSResourceSet_Item_possRSResourceID_List,
        _PosSRSResourceSet_Item_posresourceSetType,
        ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__id,
        ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PosSRSResourceSet_Item_iE_Extensions__item_,
        _PosSRSResourceSet_Item_iE_Extensions,
        PosSRSResourceSet_Item,
        PosSRSResourceSet_Item_ExtIEs,
        _PosResourceSetType_periodic,
        _PosResourceSetType_semi_persistent,
        _PosResourceSetType_aperiodic,
        ___PosResourceSetType_choice_extension_id_tab,
        __PosResourceSetType_choice_extension_id,
        ___PosResourceSetType_choice_extension_criticality_tab,
        __PosResourceSetType_choice_extension_criticality,
        ___PosResourceSetType_choice_extension_value_tab,
        __PosResourceSetType_choice_extension_value,
        _PosResourceSetType_choice_extension,
        PosResourceSetType,
        PosResourceSetType_ExtIEs,
        _PosResourceSetTypePeriodic_posperiodicSet,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__id,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __PosResourceSetTypePeriodic_iE_Extensions__item_,
        _PosResourceSetTypePeriodic_iE_Extensions,
        PosResourceSetTypePeriodic,
        PosResourceSetTypePeriodic_ExtIEs,
        _PosResourceSetTypeSemi_persistent_possemi_persistentSet,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _PosResourceSetTypeSemi_persistent_iE_Extensions,
        PosResourceSetTypeSemi_persistent,
        PosResourceSetTypeSemi_persistent_ExtIEs,
        _PosResourceSetTypeAperiodic_sRSResourceTrigger,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeAperiodic_iE_Extensions__item_,
        _PosResourceSetTypeAperiodic_iE_Extensions,
        PosResourceSetTypeAperiodic,
        PosResourceSetTypeAperiodic_ExtIEs,
        PRS_Bandwidth_EUTRA,
        _PRSAngleItem_nRPRSAzimuth,
        _PRSAngleItem_nRPRSAzimuthFine,
        _PRSAngleItem_nRPRSElevation,
        _PRSAngleItem_nRPRSElevationFine,
        ____PRSAngleItem_iE_Extensions__item__id_tab,
        _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRSAngleItem_iE_Extensions__item__id,
        ___PRSAngleItem_iE_Extensions__item__criticality,
        ___PRSAngleItem_iE_Extensions__item__extensionValue,
        __PRSAngleItem_iE_Extensions__item_,
        _PRSAngleItem_iE_Extensions,
        PRSAngleItem,
        PRSAngleItem_ExtIEs,
        _PRSAngleItem_ExtIEs_val_Extension_0,
        _PRSInformationPos_pRS_IDPos,
        _PRSInformationPos_pRS_Resource_Set_IDPos,
        _PRSInformationPos_pRS_Resource_IDPos,
        ____PRSInformationPos_iE_Extensions__item__id_tab,
        ___PRSInformationPos_iE_Extensions__item__id,
        ____PRSInformationPos_iE_Extensions__item__criticality_tab,
        ___PRSInformationPos_iE_Extensions__item__criticality,
        ____PRSInformationPos_iE_Extensions__item__extensionValue_tab,
        ___PRSInformationPos_iE_Extensions__item__extensionValue,
        __PRSInformationPos_iE_Extensions__item_,
        _PRSInformationPos_iE_Extensions,
        PRSInformationPos,
        PRSInformationPos_ExtIEs,
        _PRSConfiguration_pRSResourceSet_List,
        ____PRSConfiguration_iE_Extensions__item__id_tab,
        ___PRSConfiguration_iE_Extensions__item__id,
        ____PRSConfiguration_iE_Extensions__item__criticality_tab,
        ___PRSConfiguration_iE_Extensions__item__criticality,
        ____PRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___PRSConfiguration_iE_Extensions__item__extensionValue,
        __PRSConfiguration_iE_Extensions__item_,
        _PRSConfiguration_iE_Extensions,
        PRSConfiguration,
        PRSConfiguration_ExtIEs,
        PRS_ConfigurationIndex_EUTRA,
        PRS_ID_EUTRA,
        _PRSMutingConfiguration_EUTRA_two,
        _PRSMutingConfiguration_EUTRA_four,
        _PRSMutingConfiguration_EUTRA_eight,
        _PRSMutingConfiguration_EUTRA_sixteen,
        _PRSMutingConfiguration_EUTRA_thirty_two,
        _PRSMutingConfiguration_EUTRA_sixty_four,
        _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight,
        _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six,
        _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve,
        _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_id,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_criticality,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_value,
        _PRSMutingConfiguration_EUTRA_choice_Extension,
        PRSMutingConfiguration_EUTRA,
        PRSMutingConfiguration_EUTRA_ExtensionIE,
        PRSOccasionGroup_EUTRA,
        _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands,
        __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_,
        _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue,
        __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_,
        _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions,
        PRSFrequencyHoppingConfiguration_EUTRA,
        PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs,
        _PRSMuting_pRSMutingOption1,
        _PRSMuting_pRSMutingOption2,
        ____PRSMuting_iE_Extensions__item__id_tab,
        ___PRSMuting_iE_Extensions__item__id,
        ____PRSMuting_iE_Extensions__item__criticality_tab,
        ___PRSMuting_iE_Extensions__item__criticality,
        ____PRSMuting_iE_Extensions__item__extensionValue_tab,
        ___PRSMuting_iE_Extensions__item__extensionValue,
        __PRSMuting_iE_Extensions__item_,
        _PRSMuting_iE_Extensions,
        PRSMuting,
        PRSMuting_ExtIEs,
        _PRSMutingOption1_mutingPattern,
        _PRSMutingOption1_mutingBitRepetitionFactor,
        ____PRSMutingOption1_iE_Extensions__item__id_tab,
        ___PRSMutingOption1_iE_Extensions__item__id,
        ____PRSMutingOption1_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption1_iE_Extensions__item__criticality,
        ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption1_iE_Extensions__item__extensionValue,
        __PRSMutingOption1_iE_Extensions__item_,
        _PRSMutingOption1_iE_Extensions,
        PRSMutingOption1,
        PRSMutingOption1_ExtIEs,
        _PRSMutingOption2_mutingPattern,
        ____PRSMutingOption2_iE_Extensions__item__id_tab,
        ___PRSMutingOption2_iE_Extensions__item__id,
        ____PRSMutingOption2_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption2_iE_Extensions__item__criticality,
        ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption2_iE_Extensions__item__extensionValue,
        __PRSMutingOption2_iE_Extensions__item_,
        _PRSMutingOption2_iE_Extensions,
        PRSMutingOption2,
        PRSMutingOption2_ExtIEs,
        _PRSResource_List__item_,
        PRSResource_List,
        _PRSResource_Item_pRSResourceID,
        _PRSResource_Item_sequenceID,
        _PRSResource_Item_rEOffset,
        _PRSResource_Item_resourceSlotOffset,
        _PRSResource_Item_resourceSymbolOffset,
        _PRSResource_Item_qCLInfo,
        ____PRSResource_Item_iE_Extensions__item__id_tab,
        ___PRSResource_Item_iE_Extensions__item__id,
        ____PRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSResource_Item_iE_Extensions__item__criticality,
        ____PRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_Item_iE_Extensions__item__extensionValue,
        __PRSResource_Item_iE_Extensions__item_,
        _PRSResource_Item_iE_Extensions,
        PRSResource_Item,
        PRSResource_Item_ExtIEs,
        _PRSResource_QCLInfo_qCLSourceSSB,
        _PRSResource_QCLInfo_qCLSourcePRS,
        ___PRSResource_QCLInfo_choice_Extension_id_tab,
        __PRSResource_QCLInfo_choice_Extension_id,
        ___PRSResource_QCLInfo_choice_Extension_criticality_tab,
        __PRSResource_QCLInfo_choice_Extension_criticality,
        ___PRSResource_QCLInfo_choice_Extension_value_tab,
        __PRSResource_QCLInfo_choice_Extension_value,
        _PRSResource_QCLInfo_choice_Extension,
        PRSResource_QCLInfo,
        PRSResource_QCLInfo_ExtIEs,
        _PRSResource_QCLSourceSSB_pCI_NR,
        _PRSResource_QCLSourceSSB_sSB_Index,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__id,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourceSSB_iE_Extensions__item_,
        _PRSResource_QCLSourceSSB_iE_Extensions,
        PRSResource_QCLSourceSSB,
        PRSResource_QCLSourceSSB_ExtIEs,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__id,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourcePRS_iE_Extensions__item_,
        _PRSResource_QCLSourcePRS_iE_Extensions,
        PRSResource_QCLSourcePRS,
        PRSResource_QCLSourcePRS_ExtIEs,
        _PRSResourceSet_List__item_,
        PRSResourceSet_List,
        _PRSResourceSet_Item_pRSResourceSetID,
        _PRSResourceSet_Item_subcarrierSpacing,
        _PRSResourceSet_Item_pRSbandwidth,
        _PRSResourceSet_Item_startPRB,
        _PRSResourceSet_Item_pointA,
        _PRSResourceSet_Item_combSize,
        _PRSResourceSet_Item_cPType,
        _PRSResourceSet_Item_resourceSetPeriodicity,
        _PRSResourceSet_Item_resourceSetSlotOffset,
        _PRSResourceSet_Item_resourceRepetitionFactor,
        _PRSResourceSet_Item_resourceTimeGap,
        _PRSResourceSet_Item_resourceNumberofSymbols,
        _PRSResourceSet_Item_pRSMuting,
        _PRSResourceSet_Item_pRSResourceTransmitPower,
        _PRSResourceSet_Item_pRSResource_List,
        ____PRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__id,
        ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSResourceSet_Item_iE_Extensions__item_,
        _PRSResourceSet_Item_iE_Extensions,
        PRSResourceSet_Item,
        PRSResourceSet_Item_ExtIEs,
        PRS_Resource_ID,
        PRS_Resource_Set_ID,
        PRS_ID,
        _ReferenceSignal_nZP_CSI_RS,
        _ReferenceSignal_sSB,
        _ReferenceSignal_sRS,
        _ReferenceSignal_positioningSRS,
        _ReferenceSignal_dL_PRS,
        ___ReferenceSignal_choice_Extension_id_tab,
        __ReferenceSignal_choice_Extension_id,
        ___ReferenceSignal_choice_Extension_criticality_tab,
        __ReferenceSignal_choice_Extension_criticality,
        ___ReferenceSignal_choice_Extension_value_tab,
        __ReferenceSignal_choice_Extension_value,
        _ReferenceSignal_choice_Extension,
        ReferenceSignal,
        ReferenceSignal_ExtensionIE,
        _ReferencePoint_relativeCoordinateID,
        _ReferencePoint_referencePointCoordinate,
        _ReferencePoint_referencePointCoordinateHA,
        ___ReferencePoint_choice_Extension_id_tab,
        __ReferencePoint_choice_Extension_id,
        ___ReferencePoint_choice_Extension_criticality_tab,
        __ReferencePoint_choice_Extension_criticality,
        ___ReferencePoint_choice_Extension_value_tab,
        __ReferencePoint_choice_Extension_value,
        _ReferencePoint_choice_Extension,
        ReferencePoint,
        ReferencePoint_ExtIEs,
        CoordinateID,
        _RelativeGeodeticLocation_milli_Arc_SecondUnits,
        _RelativeGeodeticLocation_heightUnits,
        _RelativeGeodeticLocation_deltaLatitude,
        _RelativeGeodeticLocation_deltaLongitude,
        _RelativeGeodeticLocation_deltaHeight,
        _RelativeGeodeticLocation_locationUncertainty,
        ____RelativeGeodeticLocation_iE_extensions__item__id_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__id,
        ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__criticality,
        ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__extensionValue,
        __RelativeGeodeticLocation_iE_extensions__item_,
        _RelativeGeodeticLocation_iE_extensions,
        RelativeGeodeticLocation,
        RelativeGeodeticLocation_ExtIEs,
        _RelativeCartesianLocation_xYZunit,
        _RelativeCartesianLocation_xvalue,
        _RelativeCartesianLocation_yvalue,
        _RelativeCartesianLocation_zvalue,
        _RelativeCartesianLocation_locationUncertainty,
        ____RelativeCartesianLocation_iE_Extensions__item__id_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__id,
        ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__criticality,
        ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__extensionValue,
        __RelativeCartesianLocation_iE_Extensions__item_,
        _RelativeCartesianLocation_iE_Extensions,
        RelativeCartesianLocation,
        RelativeCartesianLocation_ExtIEs,
        _RelativePathDelay_k0,
        _RelativePathDelay_k1,
        _RelativePathDelay_k2,
        _RelativePathDelay_k3,
        _RelativePathDelay_k4,
        _RelativePathDelay_k5,
        ___RelativePathDelay_choice_Extension_id_tab,
        __RelativePathDelay_choice_Extension_id,
        ___RelativePathDelay_choice_Extension_criticality_tab,
        __RelativePathDelay_choice_Extension_criticality,
        ___RelativePathDelay_choice_Extension_value_tab,
        __RelativePathDelay_choice_Extension_value,
        _RelativePathDelay_choice_Extension,
        RelativePathDelay,
        RelativePathDelay_ExtIEs,
        ReportCharacteristics,
        _RequestedSRSTransmissionCharacteristics_numberOfTransmissions,
        _RequestedSRSTransmissionCharacteristics_resourceType,
        _RequestedSRSTransmissionCharacteristics_bandwidth,
        __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_,
        _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet,
        _RequestedSRSTransmissionCharacteristics_sSBInformation,
        ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedSRSTransmissionCharacteristics_iE_Extensions,
        RequestedSRSTransmissionCharacteristics,
        RequestedSRSTransmissionCharacteristics_ExtIEs,
        _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0,
        _SRSResourceSet_Item_numberOfSRSResourcePerSet,
        _SRSResourceSet_Item_periodicityList,
        _SRSResourceSet_Item_spatialRelationInformation,
        _SRSResourceSet_Item_pathlossReferenceInformation,
        ____SRSResourceSet_Item_iE_Extensions__item__id_tab,
        _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourceSet_Item_iE_Extensions__item__id,
        ___SRSResourceSet_Item_iE_Extensions__item__criticality,
        ___SRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __SRSResourceSet_Item_iE_Extensions__item_,
        _SRSResourceSet_Item_iE_Extensions,
        SRSResourceSet_Item,
        SRSResourceSet_Item_ExtIEs,
        _SRSResourceSet_Item_ExtIEs_val_Extension_0,
        _ResourceSetType_periodic,
        _ResourceSetType_semi_persistent,
        _ResourceSetType_aperiodic,
        ___ResourceSetType_choice_extension_id_tab,
        __ResourceSetType_choice_extension_id,
        ___ResourceSetType_choice_extension_criticality_tab,
        __ResourceSetType_choice_extension_criticality,
        ___ResourceSetType_choice_extension_value_tab,
        __ResourceSetType_choice_extension_value,
        _ResourceSetType_choice_extension,
        ResourceSetType,
        ResourceSetType_ExtIEs,
        _ResourceSetTypePeriodic_periodicSet,
        ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__id,
        ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypePeriodic_iE_Extensions__item_,
        _ResourceSetTypePeriodic_iE_Extensions,
        ResourceSetTypePeriodic,
        ResourceSetTypePeriodic_ExtIEs,
        _ResourceSetTypeSemi_persistent_semi_persistentSet,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _ResourceSetTypeSemi_persistent_iE_Extensions,
        ResourceSetTypeSemi_persistent,
        ResourceSetTypeSemi_persistent_ExtIEs,
        _ResourceSetTypeAperiodic_sRSResourceTrigger,
        _ResourceSetTypeAperiodic_slotoffset,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypeAperiodic_iE_Extensions__item_,
        _ResourceSetTypeAperiodic_iE_Extensions,
        ResourceSetTypeAperiodic,
        ResourceSetTypeAperiodic_ExtIEs,
        _ResourceType_periodic,
        _ResourceType_semi_persistent,
        _ResourceType_aperiodic,
        ___ResourceType_choice_extension_id_tab,
        __ResourceType_choice_extension_id,
        ___ResourceType_choice_extension_criticality_tab,
        __ResourceType_choice_extension_criticality,
        ___ResourceType_choice_extension_value_tab,
        __ResourceType_choice_extension_value,
        _ResourceType_choice_extension,
        ResourceType,
        ResourceType_ExtIEs,
        _ResourceTypePeriodic_periodicity,
        _ResourceTypePeriodic_offset,
        ____ResourceTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__id,
        ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodic_iE_Extensions__item_,
        _ResourceTypePeriodic_iE_Extensions,
        ResourceTypePeriodic,
        ResourceTypePeriodic_ExtIEs,
        _ResourceTypeSemi_persistent_periodicity,
        _ResourceTypeSemi_persistent_offset,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistent_iE_Extensions__item_,
        _ResourceTypeSemi_persistent_iE_Extensions,
        ResourceTypeSemi_persistent,
        ResourceTypeSemi_persistent_ExtIEs,
        _ResourceTypeAperiodic_aperiodicResourceType,
        ____ResourceTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__id,
        ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodic_iE_Extensions__item_,
        _ResourceTypeAperiodic_iE_Extensions,
        ResourceTypeAperiodic,
        ResourceTypeAperiodic_ExtIEs,
        _ResourceTypePos_periodic,
        _ResourceTypePos_semi_persistent,
        _ResourceTypePos_aperiodic,
        ___ResourceTypePos_choice_extension_id_tab,
        __ResourceTypePos_choice_extension_id,
        ___ResourceTypePos_choice_extension_criticality_tab,
        __ResourceTypePos_choice_extension_criticality,
        ___ResourceTypePos_choice_extension_value_tab,
        __ResourceTypePos_choice_extension_value,
        _ResourceTypePos_choice_extension,
        ResourceTypePos,
        ResourceTypePos_ExtIEs,
        _ResourceTypePeriodicPos_periodicity,
        _ResourceTypePeriodicPos_offset,
        ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__id,
        ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__criticality,
        ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodicPos_iE_Extensions__item_,
        _ResourceTypePeriodicPos_iE_Extensions,
        ResourceTypePeriodicPos,
        ResourceTypePeriodicPos_ExtIEs,
        _ResourceTypeSemi_persistentPos_periodicity,
        _ResourceTypeSemi_persistentPos_offset,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistentPos_iE_Extensions__item_,
        _ResourceTypeSemi_persistentPos_iE_Extensions,
        ResourceTypeSemi_persistentPos,
        ResourceTypeSemi_persistentPos_ExtIEs,
        _ResourceTypeAperiodicPos_slotOffset,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__id,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodicPos_iE_Extensions__item_,
        _ResourceTypeAperiodicPos_iE_Extensions,
        ResourceTypeAperiodicPos,
        ResourceTypeAperiodicPos_ExtIEs,
        _ResultCSI_RSRP__item_,
        ResultCSI_RSRP,
        _ResultCSI_RSRP_Item_nR_PCI,
        _ResultCSI_RSRP_Item_nR_ARFCN,
        _ResultCSI_RSRP_Item_cGI_NR,
        _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell,
        _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRP_Item_iE_Extensions__item_,
        _ResultCSI_RSRP_Item_iE_Extensions,
        ResultCSI_RSRP_Item,
        ResultCSI_RSRP_Item_ExtIEs,
        _ResultCSI_RSRP_PerCSI_RS__item_,
        ResultCSI_RSRP_PerCSI_RS,
        _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index,
        _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_,
        _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions,
        ResultCSI_RSRP_PerCSI_RS_Item,
        ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs,
        _ResultCSI_RSRQ__item_,
        ResultCSI_RSRQ,
        _ResultCSI_RSRQ_Item_nR_PCI,
        _ResultCSI_RSRQ_Item_nR_ARFCN,
        _ResultCSI_RSRQ_Item_cGI_NR,
        _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell,
        _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRQ_Item_iE_Extensions__item_,
        _ResultCSI_RSRQ_Item_iE_Extensions,
        ResultCSI_RSRQ_Item,
        ResultCSI_RSRQ_Item_ExtIEs,
        _ResultCSI_RSRQ_PerCSI_RS__item_,
        ResultCSI_RSRQ_PerCSI_RS,
        _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index,
        _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_,
        _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions,
        ResultCSI_RSRQ_PerCSI_RS_Item,
        ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs,
        _ResultEUTRA__item_,
        ResultEUTRA,
        _ResultEUTRA_Item_pCI_EUTRA,
        _ResultEUTRA_Item_eARFCN,
        _ResultEUTRA_Item_valueRSRP_EUTRA,
        _ResultEUTRA_Item_valueRSRQ_EUTRA,
        _ResultEUTRA_Item_cGI_EUTRA,
        ____ResultEUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__id,
        ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__criticality,
        ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultEUTRA_Item_iE_Extensions__item_,
        _ResultEUTRA_Item_iE_Extensions,
        ResultEUTRA_Item,
        ResultEUTRA_Item_ExtIEs,
        _ResultRSRP_EUTRA__item_,
        ResultRSRP_EUTRA,
        _ResultRSRP_EUTRA_Item_pCI_EUTRA,
        _ResultRSRP_EUTRA_Item_eARFCN,
        _ResultRSRP_EUTRA_Item_cGI_EUTRA,
        _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultRSRP_EUTRA_Item_iE_Extensions__item_,
        _ResultRSRP_EUTRA_Item_iE_Extensions,
        ResultRSRP_EUTRA_Item,
        ResultRSRP_EUTRA_Item_ExtIEs,
        _ResultRSRQ_EUTRA__item_,
        ResultRSRQ_EUTRA,
        _ResultRSRQ_EUTRA_Item_pCI_EUTRA,
        _ResultRSRQ_EUTRA_Item_eARFCN,
        _ResultRSRQ_EUTRA_Item_cGI_UTRA,
        _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultRSRQ_EUTRA_Item_iE_Extensions__item_,
        _ResultRSRQ_EUTRA_Item_iE_Extensions,
        ResultRSRQ_EUTRA_Item,
        ResultRSRQ_EUTRA_Item_ExtIEs,
        _ResultSS_RSRP__item_,
        ResultSS_RSRP,
        _ResultSS_RSRP_Item_nR_PCI,
        _ResultSS_RSRP_Item_nR_ARFCN,
        _ResultSS_RSRP_Item_cGI_NR,
        _ResultSS_RSRP_Item_valueSS_RSRP_Cell,
        _ResultSS_RSRP_Item_sS_RSRP_PerSSB,
        ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__id,
        ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRP_Item_iE_Extensions__item_,
        _ResultSS_RSRP_Item_iE_Extensions,
        ResultSS_RSRP_Item,
        ResultSS_RSRP_Item_ExtIEs,
        _ResultSS_RSRP_PerSSB__item_,
        ResultSS_RSRP_PerSSB,
        _ResultSS_RSRP_PerSSB_Item_sSB_Index,
        _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_,
        _ResultSS_RSRP_PerSSB_Item_iE_Extensions,
        ResultSS_RSRP_PerSSB_Item,
        ResultSS_RSRP_PerSSB_Item_ExtIEs,
        _ResultSS_RSRQ__item_,
        ResultSS_RSRQ,
        _ResultSS_RSRQ_Item_nR_PCI,
        _ResultSS_RSRQ_Item_nR_ARFCN,
        _ResultSS_RSRQ_Item_cGI_NR,
        _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell,
        _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__id,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRQ_Item_iE_Extensions__item_,
        _ResultSS_RSRQ_Item_iE_Extensions,
        ResultSS_RSRQ_Item,
        ResultSS_RSRQ_Item_ExtIEs,
        _ResultSS_RSRQ_PerSSB__item_,
        ResultSS_RSRQ_PerSSB,
        _ResultSS_RSRQ_PerSSB_Item_sSB_Index,
        _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_,
        _ResultSS_RSRQ_PerSSB_Item_iE_Extensions,
        ResultSS_RSRQ_PerSSB_Item,
        ResultSS_RSRQ_PerSSB_Item_ExtIEs,
        _ResultGERAN__item_,
        ResultGERAN,
        _ResultGERAN_Item_bCCH,
        _ResultGERAN_Item_physCellIDGERAN,
        _ResultGERAN_Item_rSSI,
        ____ResultGERAN_Item_iE_Extensions__item__id_tab,
        ___ResultGERAN_Item_iE_Extensions__item__id,
        ____ResultGERAN_Item_iE_Extensions__item__criticality_tab,
        ___ResultGERAN_Item_iE_Extensions__item__criticality,
        ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultGERAN_Item_iE_Extensions__item__extensionValue,
        __ResultGERAN_Item_iE_Extensions__item_,
        _ResultGERAN_Item_iE_Extensions,
        ResultGERAN_Item,
        ResultGERAN_Item_ExtIEs,
        _ResultNR__item_,
        ResultNR,
        _ResultNR_Item_nR_PCI,
        _ResultNR_Item_nR_ARFCN,
        _ResultNR_Item_valueSS_RSRP_Cell,
        _ResultNR_Item_valueSS_RSRQ_Cell,
        _ResultNR_Item_sS_RSRP_PerSSB,
        _ResultNR_Item_sS_RSRQ_PerSSB,
        _ResultNR_Item_cGI_NR,
        ____ResultNR_Item_iE_Extensions__item__id_tab,
        ___ResultNR_Item_iE_Extensions__item__id,
        ____ResultNR_Item_iE_Extensions__item__criticality_tab,
        ___ResultNR_Item_iE_Extensions__item__criticality,
        ____ResultNR_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultNR_Item_iE_Extensions__item__extensionValue,
        __ResultNR_Item_iE_Extensions__item_,
        _ResultNR_Item_iE_Extensions,
        ResultNR_Item,
        ResultNR_Item_ExtIEs,
        _ResultUTRAN__item_,
        ResultUTRAN,
        _ResultUTRAN_Item_uARFCN,
        __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD,
        __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD,
        _ResultUTRAN_Item_physCellIDUTRAN,
        _ResultUTRAN_Item_uTRA_RSCP,
        _ResultUTRAN_Item_uTRA_EcN0,
        ____ResultUTRAN_Item_iE_Extensions__item__id_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__id,
        ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__criticality,
        ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__extensionValue,
        __ResultUTRAN_Item_iE_Extensions__item_,
        _ResultUTRAN_Item_iE_Extensions,
        ResultUTRAN_Item,
        ResultUTRAN_Item_ExtIEs,
        RSSI,
        _SCS_SpecificCarrier_offsetToCarrier,
        _SCS_SpecificCarrier_subcarrierSpacing,
        _SCS_SpecificCarrier_carrierBandwidth,
        ____SCS_SpecificCarrier_iE_Extensions__item__id_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__id,
        ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__criticality,
        ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue,
        __SCS_SpecificCarrier_iE_Extensions__item_,
        _SCS_SpecificCarrier_iE_Extensions,
        SCS_SpecificCarrier,
        SCS_SpecificCarrier_ExtIEs,
        _Search_window_information_expectedPropagationDelay,
        _Search_window_information_delayUncertainty,
        ____Search_window_information_iE_Extensions__item__id_tab,
        ___Search_window_information_iE_Extensions__item__id,
        ____Search_window_information_iE_Extensions__item__criticality_tab,
        ___Search_window_information_iE_Extensions__item__criticality,
        ____Search_window_information_iE_Extensions__item__extensionValue_tab,
        ___Search_window_information_iE_Extensions__item__extensionValue,
        __Search_window_information_iE_Extensions__item_,
        _Search_window_information_iE_Extensions,
        Search_window_information,
        Search_window_information_ExtIEs,
        RelativeTime1900,
        SFNInitialisationTime_EUTRA,
        SlotNumber,
        _SpatialDirectionInformation_nR_PRS_Beam_Information,
        ____SpatialDirectionInformation_iE_Extensions__item__id_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__id,
        ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__criticality,
        ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__extensionValue,
        __SpatialDirectionInformation_iE_Extensions__item_,
        _SpatialDirectionInformation_iE_Extensions,
        SpatialDirectionInformation,
        SpatialDirectionInformation_ExtIEs,
        _SpatialRelationInfo_spatialRelationforResourceID,
        ____SpatialRelationInfo_iE_Extensions__item__id_tab,
        ___SpatialRelationInfo_iE_Extensions__item__id,
        ____SpatialRelationInfo_iE_Extensions__item__criticality_tab,
        ___SpatialRelationInfo_iE_Extensions__item__criticality,
        ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationInfo_iE_Extensions__item__extensionValue,
        __SpatialRelationInfo_iE_Extensions__item_,
        _SpatialRelationInfo_iE_Extensions,
        SpatialRelationInfo,
        SpatialRelationInfo_ExtIEs,
        _SpatialRelationforResourceID__item_,
        SpatialRelationforResourceID,
        _SpatialRelationforResourceIDItem_referenceSignal,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__id,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue,
        __SpatialRelationforResourceIDItem_iE_Extensions__item_,
        _SpatialRelationforResourceIDItem_iE_Extensions,
        SpatialRelationforResourceIDItem,
        SpatialRelationforResourceIDItem_ExtIEs,
        _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResource_iE_Extensions__item_,
        _SpatialRelationPerSRSResource_iE_Extensions,
        SpatialRelationPerSRSResource,
        SpatialRelationPerSRSResource_ExtIEs,
        _SpatialRelationPerSRSResource_List__item_,
        SpatialRelationPerSRSResource_List,
        _SpatialRelationPerSRSResourceItem_referenceSignal,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResourceItem_iE_Extensions__item_,
        _SpatialRelationPerSRSResourceItem_iE_Extensions,
        SpatialRelationPerSRSResourceItem,
        SpatialRelationPerSRSResourceItem_ExtIEs,
        _SpatialRelationPos_sSBPos,
        _SpatialRelationPos_pRSInformationPos,
        ___SpatialRelationPos_choice_extension_id_tab,
        __SpatialRelationPos_choice_extension_id,
        ___SpatialRelationPos_choice_extension_criticality_tab,
        __SpatialRelationPos_choice_extension_criticality,
        ___SpatialRelationPos_choice_extension_value_tab,
        __SpatialRelationPos_choice_extension_value,
        _SpatialRelationPos_choice_extension,
        SpatialRelationPos,
        SpatialInformationPos_ExtIEs,
        _SRSConfig_sRSResource_List,
        _SRSConfig_posSRSResource_List,
        _SRSConfig_sRSResourceSet_List,
        _SRSConfig_posSRSResourceSet_List,
        ____SRSConfig_iE_Extensions__item__id_tab,
        ___SRSConfig_iE_Extensions__item__id,
        ____SRSConfig_iE_Extensions__item__criticality_tab,
        ___SRSConfig_iE_Extensions__item__criticality,
        ____SRSConfig_iE_Extensions__item__extensionValue_tab,
        ___SRSConfig_iE_Extensions__item__extensionValue,
        __SRSConfig_iE_Extensions__item_,
        _SRSConfig_iE_Extensions,
        SRSConfig,
        SRSConfig_ExtIEs,
        _SRSCarrier_List__item_,
        SRSCarrier_List,
        _SRSCarrier_List_Item_pointA,
        _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List,
        _SRSCarrier_List_Item_activeULBWP,
        _SRSCarrier_List_Item_pCI_NR,
        ____SRSCarrier_List_Item_iE_Extensions__item__id_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__id,
        ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__criticality,
        ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue,
        __SRSCarrier_List_Item_iE_Extensions__item_,
        _SRSCarrier_List_Item_iE_Extensions,
        SRSCarrier_List_Item,
        SRSCarrier_List_Item_ExtIEs,
        _SRSConfiguration_sRSCarrier_List,
        ____SRSConfiguration_iE_Extensions__item__id_tab,
        ___SRSConfiguration_iE_Extensions__item__id,
        ____SRSConfiguration_iE_Extensions__item__criticality_tab,
        ___SRSConfiguration_iE_Extensions__item__criticality,
        ____SRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SRSConfiguration_iE_Extensions__item__extensionValue,
        __SRSConfiguration_iE_Extensions__item_,
        _SRSConfiguration_iE_Extensions,
        SRSConfiguration,
        SRSConfiguration_ExtIEs,
        SrsFrequency,
        SRSPosResourceID,
        _SRSResource_sRSResourceID,
        _SRSResource_nrofSRS_Ports,
        _SRSResource_transmissionComb,
        _SRSResource_startPosition,
        _SRSResource_nrofSymbols,
        _SRSResource_repetitionFactor,
        _SRSResource_freqDomainPosition,
        _SRSResource_freqDomainShift,
        _SRSResource_c_SRS,
        _SRSResource_b_SRS,
        _SRSResource_b_hop,
        _SRSResource_groupOrSequenceHopping,
        _SRSResource_resourceType,
        _SRSResource_sequenceId,
        ____SRSResource_iE_Extensions__item__id_tab,
        ___SRSResource_iE_Extensions__item__id,
        ____SRSResource_iE_Extensions__item__criticality_tab,
        ___SRSResource_iE_Extensions__item__criticality,
        ____SRSResource_iE_Extensions__item__extensionValue_tab,
        ___SRSResource_iE_Extensions__item__extensionValue,
        __SRSResource_iE_Extensions__item_,
        _SRSResource_iE_Extensions,
        SRSResource,
        SRSResource_ExtIEs,
        SRSResourceID,
        _SRSResource_List__item_,
        SRSResource_List,
        _SRSResourceSet_List__item_,
        SRSResourceSet_List,
        _SRSResourceID_List__item_,
        SRSResourceID_List,
        _SRSResourceSet_sRSResourceSetID,
        _SRSResourceSet_sRSResourceID_List,
        _SRSResourceSet_resourceSetType,
        ____SRSResourceSet_iE_Extensions__item__id_tab,
        ___SRSResourceSet_iE_Extensions__item__id,
        ____SRSResourceSet_iE_Extensions__item__criticality_tab,
        ___SRSResourceSet_iE_Extensions__item__criticality,
        ____SRSResourceSet_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceSet_iE_Extensions__item__extensionValue,
        __SRSResourceSet_iE_Extensions__item_,
        _SRSResourceSet_iE_Extensions,
        SRSResourceSet,
        SRSResourceSet_ExtIEs,
        SRSResourceSetID,
        _SRSResourceTrigger_aperiodicSRSResourceTriggerList,
        ____SRSResourceTrigger_iE_Extensions__item__id_tab,
        ___SRSResourceTrigger_iE_Extensions__item__id,
        ____SRSResourceTrigger_iE_Extensions__item__criticality_tab,
        ___SRSResourceTrigger_iE_Extensions__item__criticality,
        ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceTrigger_iE_Extensions__item__extensionValue,
        __SRSResourceTrigger_iE_Extensions__item_,
        _SRSResourceTrigger_iE_Extensions,
        SRSResourceTrigger,
        SRSResourceTrigger_ExtIEs,
        __SSBInfo_listOfSSBInfo__item_,
        _SSBInfo_listOfSSBInfo,
        ____SSBInfo_iE_Extensions__item__id_tab,
        ___SSBInfo_iE_Extensions__item__id,
        ____SSBInfo_iE_Extensions__item__criticality_tab,
        ___SSBInfo_iE_Extensions__item__criticality,
        ____SSBInfo_iE_Extensions__item__extensionValue_tab,
        ___SSBInfo_iE_Extensions__item__extensionValue,
        __SSBInfo_iE_Extensions__item_,
        _SSBInfo_iE_Extensions,
        SSBInfo,
        SSBInfo_ExtIEs,
        _SSBInfoItem_sSB_Configuration,
        _SSBInfoItem_pCI_NR,
        ____SSBInfoItem_iE_Extensions__item__id_tab,
        ___SSBInfoItem_iE_Extensions__item__id,
        ____SSBInfoItem_iE_Extensions__item__criticality_tab,
        ___SSBInfoItem_iE_Extensions__item__criticality,
        ____SSBInfoItem_iE_Extensions__item__extensionValue_tab,
        ___SSBInfoItem_iE_Extensions__item__extensionValue,
        __SSBInfoItem_iE_Extensions__item_,
        _SSBInfoItem_iE_Extensions,
        SSBInfoItem,
        SSBInfoItem_ExtIEs,
        _SSB_pCI_NR,
        _SSB_ssb_index,
        ____SSB_iE_Extensions__item__id_tab,
        ___SSB_iE_Extensions__item__id,
        ____SSB_iE_Extensions__item__criticality_tab,
        ___SSB_iE_Extensions__item__criticality,
        ____SSB_iE_Extensions__item__extensionValue_tab,
        ___SSB_iE_Extensions__item__extensionValue,
        __SSB_iE_Extensions__item_,
        _SSB_iE_Extensions,
        SSB,
        SSB_ExtIEs,
        _SSBBurstPosition_shortBitmap,
        _SSBBurstPosition_mediumBitmap,
        _SSBBurstPosition_longBitmap,
        ___SSBBurstPosition_choice_extension_id_tab,
        __SSBBurstPosition_choice_extension_id,
        ___SSBBurstPosition_choice_extension_criticality_tab,
        __SSBBurstPosition_choice_extension_criticality,
        ___SSBBurstPosition_choice_extension_value_tab,
        __SSBBurstPosition_choice_extension_value,
        _SSBBurstPosition_choice_extension,
        SSBBurstPosition,
        SSBBurstPosition_ExtIEs,
        SSB_Index,
        SSID,
        SystemFrameNumber,
        __SystemInformation__item__broadcastPeriodicity,
        __SystemInformation__item__posSIBs,
        _____SystemInformation__item__iE_Extensions__item__id_tab,
        ____SystemInformation__item__iE_Extensions__item__id,
        _____SystemInformation__item__iE_Extensions__item__criticality_tab,
        ____SystemInformation__item__iE_Extensions__item__criticality,
        _____SystemInformation__item__iE_Extensions__item__extensionValue_tab,
        ____SystemInformation__item__iE_Extensions__item__extensionValue,
        ___SystemInformation__item__iE_Extensions__item_,
        __SystemInformation__item__iE_Extensions,
        _SystemInformation__item_,
        SystemInformation,
        SystemInformation_ExtIEs,
        TAC,
        _TDD_Config_EUTRA_Item_subframeAssignment,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__id,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue,
        __TDD_Config_EUTRA_Item_iE_Extensions__item_,
        _TDD_Config_EUTRA_Item_iE_Extensions,
        TDD_Config_EUTRA_Item,
        TDD_Config_EUTRA_Item_Item_ExtIEs,
        _TF_Configuration_sSB_frequency,
        _TF_Configuration_sSB_subcarrier_spacing,
        _TF_Configuration_sSB_Transmit_power,
        _TF_Configuration_sSB_periodicity,
        _TF_Configuration_sSB_half_frame_offset,
        _TF_Configuration_sSB_SFN_offset,
        _TF_Configuration_sSB_BurstPosition,
        _TF_Configuration_sFN_initialisation_time,
        ____TF_Configuration_iE_Extensions__item__id_tab,
        ___TF_Configuration_iE_Extensions__item__id,
        ____TF_Configuration_iE_Extensions__item__criticality_tab,
        ___TF_Configuration_iE_Extensions__item__criticality,
        ____TF_Configuration_iE_Extensions__item__extensionValue_tab,
        ___TF_Configuration_iE_Extensions__item__extensionValue,
        __TF_Configuration_iE_Extensions__item_,
        _TF_Configuration_iE_Extensions,
        TF_Configuration,
        TF_Configuration_ExtIEs,
        _TimeStamp_systemFrameNumber,
        _TimeStamp_slotIndex,
        _TimeStamp_measurementTime,
        ____TimeStamp_iE_Extension__item__id_tab,
        ___TimeStamp_iE_Extension__item__id,
        ____TimeStamp_iE_Extension__item__criticality_tab,
        ___TimeStamp_iE_Extension__item__criticality,
        ____TimeStamp_iE_Extension__item__extensionValue_tab,
        ___TimeStamp_iE_Extension__item__extensionValue,
        __TimeStamp_iE_Extension__item_,
        _TimeStamp_iE_Extension,
        TimeStamp,
        TimeStamp_ExtIEs,
        _TimeStampSlotIndex_sCS_15,
        _TimeStampSlotIndex_sCS_30,
        _TimeStampSlotIndex_sCS_60,
        _TimeStampSlotIndex_sCS_120,
        ___TimeStampSlotIndex_choice_extension_id_tab,
        __TimeStampSlotIndex_choice_extension_id,
        ___TimeStampSlotIndex_choice_extension_criticality_tab,
        __TimeStampSlotIndex_choice_extension_criticality,
        ___TimeStampSlotIndex_choice_extension_value_tab,
        __TimeStampSlotIndex_choice_extension_value,
        _TimeStampSlotIndex_choice_extension,
        TimeStampSlotIndex,
        TimeStampSlotIndex_ExtIEs,
        TP_ID_EUTRA,
        TP_Type_EUTRA,
        __TransmissionComb_n2_combOffset_n2,
        __TransmissionComb_n2_cyclicShift_n2,
        _TransmissionComb_n2,
        __TransmissionComb_n4_combOffset_n4,
        __TransmissionComb_n4_cyclicShift_n4,
        _TransmissionComb_n4,
        ___TransmissionComb_choice_extension_id_tab,
        __TransmissionComb_choice_extension_id,
        ___TransmissionComb_choice_extension_criticality_tab,
        __TransmissionComb_choice_extension_criticality,
        ___TransmissionComb_choice_extension_value_tab,
        __TransmissionComb_choice_extension_value,
        _TransmissionComb_choice_extension,
        TransmissionComb,
        TransmissionComb_ExtIEs,
        __TransmissionCombPos_n2_combOffset_n2,
        __TransmissionCombPos_n2_cyclicShift_n2,
        _TransmissionCombPos_n2,
        __TransmissionCombPos_n4_combOffset_n4,
        __TransmissionCombPos_n4_cyclicShift_n4,
        _TransmissionCombPos_n4,
        __TransmissionCombPos_n8_combOffset_n8,
        __TransmissionCombPos_n8_cyclicShift_n8,
        _TransmissionCombPos_n8,
        ___TransmissionCombPos_choice_extension_id_tab,
        __TransmissionCombPos_choice_extension_id,
        ___TransmissionCombPos_choice_extension_criticality_tab,
        __TransmissionCombPos_choice_extension_criticality,
        ___TransmissionCombPos_choice_extension_value_tab,
        __TransmissionCombPos_choice_extension_value,
        _TransmissionCombPos_choice_extension,
        TransmissionCombPos,
        TransmissionCombPos_ExtIEs,
        _TRPMeasurementQuantities__item_,
        TRPMeasurementQuantities,
        _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item,
        _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue,
        __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_,
        _TRPMeasurementQuantitiesList_Item_iE_Extensions,
        TRPMeasurementQuantitiesList_Item,
        TRPMeasurementQuantitiesList_Item_ExtIEs,
        TRPMeasurementQuantities_Item,
        _TrpMeasurementResult__item_,
        TrpMeasurementResult,
        _TrpMeasurementResultItem_measuredResultsValue,
        _TrpMeasurementResultItem_timeStamp,
        _TrpMeasurementResultItem_measurementQuality,
        _TrpMeasurementResultItem_measurementBeamInfo,
        ____TrpMeasurementResultItem_iE_Extensions__item__id_tab,
        ___TrpMeasurementResultItem_iE_Extensions__item__id,
        ____TrpMeasurementResultItem_iE_Extensions__item__criticality_tab,
        ___TrpMeasurementResultItem_iE_Extensions__item__criticality,
        ____TrpMeasurementResultItem_iE_Extensions__item__extensionValue_tab,
        ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue,
        __TrpMeasurementResultItem_iE_Extensions__item_,
        _TrpMeasurementResultItem_iE_Extensions,
        TrpMeasurementResultItem,
        TrpMeasurementResultItem_ExtIEs,
        _TrpMeasuredResultsValue_uL_AngleOfArrival,
        _TrpMeasuredResultsValue_uL_SRS_RSRP,
        _TrpMeasuredResultsValue_uL_RTOA,
        _TrpMeasuredResultsValue_gNB_RxTxTimeDiff,
        ___TrpMeasuredResultsValue_choice_extension_id_tab,
        __TrpMeasuredResultsValue_choice_extension_id,
        ___TrpMeasuredResultsValue_choice_extension_criticality_tab,
        __TrpMeasuredResultsValue_choice_extension_criticality,
        ___TrpMeasuredResultsValue_choice_extension_value_tab,
        __TrpMeasuredResultsValue_choice_extension_value,
        _TrpMeasuredResultsValue_choice_extension,
        TrpMeasuredResultsValue,
        TrpMeasuredResultsValue_ExtIEs,
        _TrpMeasurementQuality_timingMeasQuality,
        _TrpMeasurementQuality_angleMeasQuality,
        ___TrpMeasurementQuality_choice_Extension_id_tab,
        __TrpMeasurementQuality_choice_Extension_id,
        ___TrpMeasurementQuality_choice_Extension_criticality_tab,
        __TrpMeasurementQuality_choice_Extension_criticality,
        ___TrpMeasurementQuality_choice_Extension_value_tab,
        __TrpMeasurementQuality_choice_Extension_value,
        _TrpMeasurementQuality_choice_Extension,
        TrpMeasurementQuality,
        TrpMeasurementQuality_ExtIEs,
        _TrpMeasurementTimingQuality_measurementQuality,
        _TrpMeasurementTimingQuality_resolution,
        ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__id,
        ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__criticality,
        ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue,
        __TrpMeasurementTimingQuality_iE_extensions__item_,
        _TrpMeasurementTimingQuality_iE_extensions,
        TrpMeasurementTimingQuality,
        TrpMeasurementTimingQuality_ExtIEs,
        _TrpMeasurementAngleQuality_azimuthQuality,
        _TrpMeasurementAngleQuality_zenithQuality,
        _TrpMeasurementAngleQuality_resolution,
        ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__id,
        ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__criticality,
        ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue,
        __TrpMeasurementAngleQuality_iE_extensions__item_,
        _TrpMeasurementAngleQuality_iE_extensions,
        TrpMeasurementAngleQuality,
        TrpMeasurementAngleQuality_ExtIEs,
        _TRP_MeasurementRequestList__item_,
        TRP_MeasurementRequestList,
        _TRP_MeasurementRequestItem_tRP_ID,
        _TRP_MeasurementRequestItem_search_window_information,
        ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0,
        ___TRP_MeasurementRequestItem_iE_extensions__item__id,
        ___TRP_MeasurementRequestItem_iE_extensions__item__criticality,
        ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementRequestItem_iE_extensions__item_,
        _TRP_MeasurementRequestItem_iE_extensions,
        TRP_MeasurementRequestItem,
        TRP_MeasurementRequestItem_ExtIEs,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementResponseList__item_,
        TRP_MeasurementResponseList,
        _TRP_MeasurementResponseItem_tRP_ID,
        _TRP_MeasurementResponseItem_measurementResult,
        ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0,
        ___TRP_MeasurementResponseItem_iE_extensions__item__id,
        ___TRP_MeasurementResponseItem_iE_extensions__item__criticality,
        ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementResponseItem_iE_extensions__item_,
        _TRP_MeasurementResponseItem_iE_extensions,
        TRP_MeasurementResponseItem,
        TRP_MeasurementResponseItem_ExtIEs,
        _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0,
        __TRPInformationListTRPResp__item__tRPInformation,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__id,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue,
        ___TRPInformationListTRPResp__item__iE_Extensions__item_,
        __TRPInformationListTRPResp__item__iE_Extensions,
        _TRPInformationListTRPResp__item_,
        TRPInformationListTRPResp,
        TRPInformationTRPResp_ExtIEs,
        _TRPInformation_tRP_ID,
        _TRPInformation_tRPInformationTypeResponseList,
        ____TRPInformation_iE_Extensions__item__id_tab,
        ___TRPInformation_iE_Extensions__item__id,
        ____TRPInformation_iE_Extensions__item__criticality_tab,
        ___TRPInformation_iE_Extensions__item__criticality,
        ____TRPInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPInformation_iE_Extensions__item__extensionValue,
        __TRPInformation_iE_Extensions__item_,
        _TRPInformation_iE_Extensions,
        TRPInformation,
        TRPInformation_ExtIEs,
        _TRPInformationTypeResponseList__item_,
        TRPInformationTypeResponseList,
        _TRPInformationTypeResponseItem_pCI_NR,
        _TRPInformationTypeResponseItem_cGI_NR,
        _TRPInformationTypeResponseItem_aRFCN,
        _TRPInformationTypeResponseItem_pRSConfiguration,
        _TRPInformationTypeResponseItem_sSBinformation,
        _TRPInformationTypeResponseItem_sFNInitialisationTime,
        _TRPInformationTypeResponseItem_spatialDirectionInformation,
        _TRPInformationTypeResponseItem_geographicalCoordinates,
        ___TRPInformationTypeResponseItem_choice_extension_id_tab,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0,
        __TRPInformationTypeResponseItem_choice_extension_id,
        __TRPInformationTypeResponseItem_choice_extension_criticality,
        __TRPInformationTypeResponseItem_choice_extension_value,
        _TRPInformationTypeResponseItem_choice_extension,
        TRPInformationTypeResponseItem,
        TRPInformationTypeResponseItem_ExtIEs,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_0,
        ___TRPInformationTypeListTRPReq__item__id_tab,
        ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0,
        __TRPInformationTypeListTRPReq__item__id,
        __TRPInformationTypeListTRPReq__item__criticality,
        __TRPInformationTypeListTRPReq__item__value,
        _TRPInformationTypeListTRPReq__item_,
        TRPInformationTypeListTRPReq,
        TRPInformationTypeItemTRPReq,
        _TRPInformationTypeItemTRPReq_val_Value_0,
        TRPInformationTypeItem,
        _TRPList__item_,
        TRPList,
        _TRPItem_tRP_ID,
        ____TRPItem_iE_Extensions__item__id_tab,
        ___TRPItem_iE_Extensions__item__id,
        ____TRPItem_iE_Extensions__item__criticality_tab,
        ___TRPItem_iE_Extensions__item__criticality,
        ____TRPItem_iE_Extensions__item__extensionValue_tab,
        ___TRPItem_iE_Extensions__item__extensionValue,
        __TRPItem_iE_Extensions__item_,
        _TRPItem_iE_Extensions,
        TRPItem,
        TRPItem_ExtIEs,
        TRP_ID,
        _TRPPositionDefinitionType_direct,
        _TRPPositionDefinitionType_referenced,
        ___TRPPositionDefinitionType_choice_extension_id_tab,
        __TRPPositionDefinitionType_choice_extension_id,
        ___TRPPositionDefinitionType_choice_extension_criticality_tab,
        __TRPPositionDefinitionType_choice_extension_criticality,
        ___TRPPositionDefinitionType_choice_extension_value_tab,
        __TRPPositionDefinitionType_choice_extension_value,
        _TRPPositionDefinitionType_choice_extension,
        TRPPositionDefinitionType,
        TRPPositionDefinitionType_ExtIEs,
        _TRPPositionDirect_accuracy,
        ____TRPPositionDirect_iE_extensions__item__id_tab,
        ___TRPPositionDirect_iE_extensions__item__id,
        ____TRPPositionDirect_iE_extensions__item__criticality_tab,
        ___TRPPositionDirect_iE_extensions__item__criticality,
        ____TRPPositionDirect_iE_extensions__item__extensionValue_tab,
        ___TRPPositionDirect_iE_extensions__item__extensionValue,
        __TRPPositionDirect_iE_extensions__item_,
        _TRPPositionDirect_iE_extensions,
        TRPPositionDirect,
        TRPPositionDirect_ExtIEs,
        _TRPPositionDirectAccuracy_tRPPosition,
        _TRPPositionDirectAccuracy_tRPHAposition,
        ___TRPPositionDirectAccuracy_choice_extension_id_tab,
        __TRPPositionDirectAccuracy_choice_extension_id,
        ___TRPPositionDirectAccuracy_choice_extension_criticality_tab,
        __TRPPositionDirectAccuracy_choice_extension_criticality,
        ___TRPPositionDirectAccuracy_choice_extension_value_tab,
        __TRPPositionDirectAccuracy_choice_extension_value,
        _TRPPositionDirectAccuracy_choice_extension,
        TRPPositionDirectAccuracy,
        TRPPositionDirectAccuracy_ExtIEs,
        _TRPPositionReferenced_referencePoint,
        _TRPPositionReferenced_referencePointType,
        ____TRPPositionReferenced_iE_extensions__item__id_tab,
        ___TRPPositionReferenced_iE_extensions__item__id,
        ____TRPPositionReferenced_iE_extensions__item__criticality_tab,
        ___TRPPositionReferenced_iE_extensions__item__criticality,
        ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab,
        ___TRPPositionReferenced_iE_extensions__item__extensionValue,
        __TRPPositionReferenced_iE_extensions__item_,
        _TRPPositionReferenced_iE_extensions,
        TRPPositionReferenced,
        TRPPositionReferenced_ExtIEs,
        _TRPReferencePointType_tRPPositionRelativeGeodetic,
        _TRPReferencePointType_tRPPositionRelativeCartesian,
        ___TRPReferencePointType_choice_extension_id_tab,
        __TRPReferencePointType_choice_extension_id,
        ___TRPReferencePointType_choice_extension_criticality_tab,
        __TRPReferencePointType_choice_extension_criticality,
        ___TRPReferencePointType_choice_extension_value_tab,
        __TRPReferencePointType_choice_extension_value,
        _TRPReferencePointType_choice_extension,
        TRPReferencePointType,
        TRPReferencePointType_ExtIEs,
        TRPType,
        TypeOfError,
        UARFCN,
        UE_Measurement_ID,
        UTRA_EcN0,
        UTRA_RSCP,
        _UL_AoA_azimuthAoA,
        _UL_AoA_zenithAoA,
        _UL_AoA_lCS_to_GCS_TranslationAoA,
        ____UL_AoA_iE_extensions__item__id_tab,
        ___UL_AoA_iE_extensions__item__id,
        ____UL_AoA_iE_extensions__item__criticality_tab,
        ___UL_AoA_iE_extensions__item__criticality,
        ____UL_AoA_iE_extensions__item__extensionValue_tab,
        ___UL_AoA_iE_extensions__item__extensionValue,
        __UL_AoA_iE_extensions__item_,
        _UL_AoA_iE_extensions,
        UL_AoA,
        UL_AoA_ExtIEs,
        _UL_RTOAMeasurement_uLRTOAmeas,
        _UL_RTOAMeasurement_additionalPathList,
        ____UL_RTOAMeasurement_iE_extensions__item__id_tab,
        ___UL_RTOAMeasurement_iE_extensions__item__id,
        ____UL_RTOAMeasurement_iE_extensions__item__criticality_tab,
        ___UL_RTOAMeasurement_iE_extensions__item__criticality,
        ____UL_RTOAMeasurement_iE_extensions__item__extensionValue_tab,
        ___UL_RTOAMeasurement_iE_extensions__item__extensionValue,
        __UL_RTOAMeasurement_iE_extensions__item_,
        _UL_RTOAMeasurement_iE_extensions,
        UL_RTOAMeasurement,
        UL_RTOAMeasurement_ExtIEs,
        _ULRTOAMeas_k0,
        _ULRTOAMeas_k1,
        _ULRTOAMeas_k2,
        _ULRTOAMeas_k3,
        _ULRTOAMeas_k4,
        _ULRTOAMeas_k5,
        ___ULRTOAMeas_choice_extension_id_tab,
        __ULRTOAMeas_choice_extension_id,
        ___ULRTOAMeas_choice_extension_criticality_tab,
        __ULRTOAMeas_choice_extension_criticality,
        ___ULRTOAMeas_choice_extension_value_tab,
        __ULRTOAMeas_choice_extension_value,
        _ULRTOAMeas_choice_extension,
        ULRTOAMeas,
        ULRTOAMeas_ExtIEs,
        UL_SRS_RSRP,
        _UplinkChannelBW_PerSCS_List__item_,
        UplinkChannelBW_PerSCS_List,
        ValueRSRP_EUTRA,
        ValueRSRQ_EUTRA,
        ValueRSRP_NR,
        ValueRSRQ_NR,
        ___WLANMeasurementQuantities__item__id_tab,
        ____WLANMeasurementQuantities__item__id_tab_val_Value_0,
        __WLANMeasurementQuantities__item__id,
        __WLANMeasurementQuantities__item__criticality,
        __WLANMeasurementQuantities__item__value,
        _WLANMeasurementQuantities__item_,
        WLANMeasurementQuantities,
        WLANMeasurementQuantities_ItemIEs,
        _WLANMeasurementQuantities_ItemIEs_val_Value_0,
        _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__id,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __WLANMeasurementQuantities_Item_iE_Extensions__item_,
        _WLANMeasurementQuantities_Item_iE_Extensions,
        WLANMeasurementQuantities_Item,
        WLANMeasurementQuantitiesValue_ExtIEs,
        WLANMeasurementQuantitiesValue,
        _WLANMeasurementResult__item_,
        WLANMeasurementResult,
        _WLANMeasurementResult_Item_wLAN_RSSI,
        _WLANMeasurementResult_Item_sSID,
        _WLANMeasurementResult_Item_bSSID,
        _WLANMeasurementResult_Item_hESSID,
        _WLANMeasurementResult_Item_operatingClass,
        _WLANMeasurementResult_Item_countryCode,
        _WLANMeasurementResult_Item_wLANChannelList,
        _WLANMeasurementResult_Item_wLANBand,
        ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__id,
        ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__criticality,
        ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue,
        __WLANMeasurementResult_Item_iE_Extensions__item_,
        _WLANMeasurementResult_Item_iE_Extensions,
        WLANMeasurementResult_Item,
        WLANMeasurementResult_Item_ExtIEs,
        WLAN_RSSI,
        WLANBand,
        _WLANChannelList__item_,
        WLANChannelList,
        WLANChannel,
        WLANCountryCode,
        WLANOperatingClass,
    ]

class NRPPA_PDU_Contents:

    _name_  = u'NRPPA-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 1]
    
    _obj_ = [
        u'E-CIDMeasurementInitiationRequest',
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand',
        u'E-CIDMeasurementTerminationCommand-IEs',
        u'OTDOAInformationRequest',
        u'OTDOAInformationRequest-IEs',
        u'OTDOA-Information-Type',
        u'OTDOA-Information-TypeIEs',
        u'OTDOA-Information-Type-Item',
        u'OTDOA-Information-Type-ItemExtIEs',
        u'OTDOAInformationResponse',
        u'OTDOAInformationResponse-IEs',
        u'OTDOAInformationFailure',
        u'OTDOAInformationFailure-IEs',
        u'AssistanceInformationControl',
        u'AssistanceInformationControl-IEs',
        u'AssistanceInformationFeedback',
        u'AssistanceInformationFeedback-IEs',
        u'ErrorIndication',
        u'ErrorIndication-IEs',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'PositioningInformationRequest',
        u'PositioningInformationRequest-IEs',
        u'PositioningInformationResponse',
        u'PositioningInformationResponse-IEs',
        u'PositioningInformationFailure',
        u'PositioningInformationFailure-IEs',
        u'PositioningInformationUpdate',
        u'PositioningInformationUpdate-IEs',
        u'MeasurementRequest',
        u'MeasurementRequest-IEs',
        u'MeasurementResponse',
        u'MeasurementResponse-IEs',
        u'MeasurementFailure',
        u'MeasurementFailure-IEs',
        u'MeasurementReport',
        u'MeasurementReport-IEs',
        u'MeasurementUpdate',
        u'MeasurementUpdate-IEs',
        u'MeasurementAbort',
        u'MeasurementAbort-IEs',
        u'MeasurementFailureIndication',
        u'MeasurementFailureIndication-IEs',
        u'TRPInformationRequest',
        u'TRPInformationRequest-IEs',
        u'TRPInformationResponse',
        u'TRPInformationResponse-IEs',
        u'TRPInformationFailure',
        u'TRPInformationFailure-IEs',
        u'PositioningActivationRequest',
        u'PositioningActivationRequestIEs',
        u'SRSType',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponse',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailure',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivation',
        u'PositioningDeactivationIEs',
        ]
    _type_ = [
        u'E-CIDMeasurementInitiationRequest',
        u'E-CIDMeasurementInitiationResponse',
        u'E-CIDMeasurementInitiationFailure',
        u'E-CIDMeasurementFailureIndication',
        u'E-CIDMeasurementReport',
        u'E-CIDMeasurementTerminationCommand',
        u'OTDOAInformationRequest',
        u'OTDOA-Information-Type',
        u'OTDOA-Information-Type-Item',
        u'OTDOAInformationResponse',
        u'OTDOAInformationFailure',
        u'AssistanceInformationControl',
        u'AssistanceInformationFeedback',
        u'ErrorIndication',
        u'PrivateMessage',
        u'PositioningInformationRequest',
        u'PositioningInformationResponse',
        u'PositioningInformationFailure',
        u'PositioningInformationUpdate',
        u'MeasurementRequest',
        u'MeasurementResponse',
        u'MeasurementFailure',
        u'MeasurementReport',
        u'MeasurementUpdate',
        u'MeasurementAbort',
        u'MeasurementFailureIndication',
        u'TRPInformationRequest',
        u'TRPInformationResponse',
        u'TRPInformationFailure',
        u'PositioningActivationRequest',
        u'SRSType',
        u'SemipersistentSRS',
        u'AperiodicSRS',
        u'PositioningActivationResponse',
        u'PositioningActivationFailure',
        u'PositioningDeactivation',
        ]
    _set_ = [
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand-IEs',
        u'OTDOAInformationRequest-IEs',
        u'OTDOA-Information-TypeIEs',
        u'OTDOA-Information-Type-ItemExtIEs',
        u'OTDOAInformationResponse-IEs',
        u'OTDOAInformationFailure-IEs',
        u'AssistanceInformationControl-IEs',
        u'AssistanceInformationFeedback-IEs',
        u'ErrorIndication-IEs',
        u'PrivateMessage-IEs',
        u'PositioningInformationRequest-IEs',
        u'PositioningInformationResponse-IEs',
        u'PositioningInformationFailure-IEs',
        u'PositioningInformationUpdate-IEs',
        u'MeasurementRequest-IEs',
        u'MeasurementResponse-IEs',
        u'MeasurementFailure-IEs',
        u'MeasurementReport-IEs',
        u'MeasurementUpdate-IEs',
        u'MeasurementAbort-IEs',
        u'MeasurementFailureIndication-IEs',
        u'TRPInformationRequest-IEs',
        u'TRPInformationResponse-IEs',
        u'TRPInformationFailure-IEs',
        u'PositioningActivationRequestIEs',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivationIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'E-CIDMeasurementInitiationRequest-IEs',
        u'E-CIDMeasurementInitiationResponse-IEs',
        u'E-CIDMeasurementInitiationFailure-IEs',
        u'E-CIDMeasurementFailureIndication-IEs',
        u'E-CIDMeasurementReport-IEs',
        u'E-CIDMeasurementTerminationCommand-IEs',
        u'OTDOAInformationRequest-IEs',
        u'OTDOA-Information-TypeIEs',
        u'OTDOA-Information-Type-ItemExtIEs',
        u'OTDOAInformationResponse-IEs',
        u'OTDOAInformationFailure-IEs',
        u'AssistanceInformationControl-IEs',
        u'AssistanceInformationFeedback-IEs',
        u'ErrorIndication-IEs',
        u'PrivateMessage-IEs',
        u'PositioningInformationRequest-IEs',
        u'PositioningInformationResponse-IEs',
        u'PositioningInformationFailure-IEs',
        u'PositioningInformationUpdate-IEs',
        u'MeasurementRequest-IEs',
        u'MeasurementResponse-IEs',
        u'MeasurementFailure-IEs',
        u'MeasurementReport-IEs',
        u'MeasurementUpdate-IEs',
        u'MeasurementAbort-IEs',
        u'MeasurementFailureIndication-IEs',
        u'TRPInformationRequest-IEs',
        u'TRPInformationResponse-IEs',
        u'TRPInformationFailure-IEs',
        u'PositioningActivationRequestIEs',
        u'SRSType-ExtIEs',
        u'SemipersistentSRS-ExtIEs',
        u'AperiodicSRS-ExtIEs',
        u'PositioningActivationResponseIEs',
        u'PositioningActivationFailureIEs',
        u'PositioningDeactivationIEs',
        ]
    _param_ = [
        ]
    
    #-----< E-CIDMeasurementInitiationRequest >-----#
    E_CIDMeasurementInitiationRequest = SEQ(name=u'E-CIDMeasurementInitiationRequest', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities')))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationRequest_protocolIEs._cont = __E_CIDMeasurementInitiationRequest_protocolIEs__item_
    _E_CIDMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationRequest_protocolIEs),
        ])
    E_CIDMeasurementInitiationRequest._ext = []
    
    #-----< E-CIDMeasurementInitiationRequest-IEs >-----#
    E_CIDMeasurementInitiationRequest_IEs = CLASS(name=u'E-CIDMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities')))
    E_CIDMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationResponse >-----#
    E_CIDMeasurementInitiationResponse = SEQ(name=u'E-CIDMeasurementInitiationResponse', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult')))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationResponse_protocolIEs._cont = __E_CIDMeasurementInitiationResponse_protocolIEs__item_
    _E_CIDMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationResponse_protocolIEs),
        ])
    E_CIDMeasurementInitiationResponse._ext = []
    
    #-----< E-CIDMeasurementInitiationResponse-IEs >-----#
    E_CIDMeasurementInitiationResponse_IEs = CLASS(name=u'E-CIDMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult')))
    E_CIDMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationFailure >-----#
    E_CIDMeasurementInitiationFailure = SEQ(name=u'E-CIDMeasurementInitiationFailure', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationFailure_protocolIEs._cont = __E_CIDMeasurementInitiationFailure_protocolIEs__item_
    _E_CIDMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementInitiationFailure_protocolIEs),
        ])
    E_CIDMeasurementInitiationFailure._ext = []
    
    #-----< E-CIDMeasurementInitiationFailure-IEs >-----#
    E_CIDMeasurementInitiationFailure_IEs = CLASS(name=u'E-CIDMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementFailureIndication >-----#
    E_CIDMeasurementFailureIndication = SEQ(name=u'E-CIDMeasurementFailureIndication', mode=MODE_TYPE)
    _E_CIDMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._ext = None
    _E_CIDMeasurementFailureIndication_protocolIEs._cont = __E_CIDMeasurementFailureIndication_protocolIEs__item_
    _E_CIDMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementFailureIndication_protocolIEs),
        ])
    E_CIDMeasurementFailureIndication._ext = []
    
    #-----< E-CIDMeasurementFailureIndication-IEs >-----#
    E_CIDMeasurementFailureIndication_IEs = CLASS(name=u'E-CIDMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    E_CIDMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementReport >-----#
    E_CIDMeasurementReport = SEQ(name=u'E-CIDMeasurementReport', mode=MODE_TYPE)
    _E_CIDMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementReport_protocolIEs__item__value),
        ])
    __E_CIDMeasurementReport_protocolIEs__item_._ext = None
    _E_CIDMeasurementReport_protocolIEs._cont = __E_CIDMeasurementReport_protocolIEs__item_
    _E_CIDMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementReport_protocolIEs),
        ])
    E_CIDMeasurementReport._ext = []
    
    #-----< E-CIDMeasurementReport-IEs >-----#
    E_CIDMeasurementReport_IEs = CLASS(name=u'E-CIDMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementReport_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    E_CIDMeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _E_CIDMeasurementReport_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementTerminationCommand >-----#
    E_CIDMeasurementTerminationCommand = SEQ(name=u'E-CIDMeasurementTerminationCommand', mode=MODE_TYPE)
    _E_CIDMeasurementTerminationCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id),
        (u'criticality', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality),
        (u'value', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value),
        ])
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._ext = None
    _E_CIDMeasurementTerminationCommand_protocolIEs._cont = __E_CIDMeasurementTerminationCommand_protocolIEs__item_
    _E_CIDMeasurementTerminationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementTerminationCommand._cont = ASN1Dict([
        (u'protocolIEs', _E_CIDMeasurementTerminationCommand_protocolIEs),
        ])
    E_CIDMeasurementTerminationCommand._ext = []
    
    #-----< E-CIDMeasurementTerminationCommand-IEs >-----#
    E_CIDMeasurementTerminationCommand_IEs = CLASS(name=u'E-CIDMeasurementTerminationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    E_CIDMeasurementTerminationCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationRequest >-----#
    OTDOAInformationRequest = SEQ(name=u'OTDOAInformationRequest', mode=MODE_TYPE)
    _OTDOAInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____OTDOAInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type')))
    ____OTDOAInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___OTDOAInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OTDOAInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __OTDOAInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OTDOAInformationRequest_protocolIEs__item__id),
        (u'criticality', ___OTDOAInformationRequest_protocolIEs__item__criticality),
        (u'value', ___OTDOAInformationRequest_protocolIEs__item__value),
        ])
    __OTDOAInformationRequest_protocolIEs__item_._ext = None
    _OTDOAInformationRequest_protocolIEs._cont = __OTDOAInformationRequest_protocolIEs__item_
    _OTDOAInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _OTDOAInformationRequest_protocolIEs),
        ])
    OTDOAInformationRequest._ext = []
    
    #-----< OTDOAInformationRequest-IEs >-----#
    OTDOAInformationRequest_IEs = CLASS(name=u'OTDOAInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationRequest_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type')))
    OTDOAInformationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _OTDOAInformationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Type >-----#
    OTDOA_Information_Type = SEQ_OF(name=u'OTDOA-Information-Type', mode=MODE_TYPE)
    _OTDOA_Information_Type__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OTDOA_Information_Type__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___OTDOA_Information_Type__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OTDOA_Information_Type__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type-Item')))
    ___OTDOA_Information_Type__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', ____OTDOA_Information_Type__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __OTDOA_Information_Type__item__id._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__id._const_tab_at = None
    __OTDOA_Information_Type__item__id._const_tab_id = u'id'
    __OTDOA_Information_Type__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    __OTDOA_Information_Type__item__criticality._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__criticality._const_tab_at = ('..', u'id')
    __OTDOA_Information_Type__item__criticality._const_tab_id = u'criticality'
    __OTDOA_Information_Type__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    __OTDOA_Information_Type__item__value._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__value._const_tab_at = ('..', u'id')
    __OTDOA_Information_Type__item__value._const_tab_id = u'Value'
    _OTDOA_Information_Type__item_._cont = ASN1Dict([
        (u'id', __OTDOA_Information_Type__item__id),
        (u'criticality', __OTDOA_Information_Type__item__criticality),
        (u'value', __OTDOA_Information_Type__item__value),
        ])
    _OTDOA_Information_Type__item_._ext = None
    OTDOA_Information_Type._cont = _OTDOA_Information_Type__item_
    OTDOA_Information_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< OTDOA-Information-TypeIEs >-----#
    OTDOA_Information_TypeIEs = CLASS(name=u'OTDOA-Information-TypeIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOA_Information_TypeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type-Item')))
    OTDOA_Information_TypeIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _OTDOA_Information_TypeIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Type-Item >-----#
    OTDOA_Information_Type_Item = SEQ(name=u'OTDOA-Information-Type-Item', mode=MODE_TYPE)
    _OTDOA_Information_Type_Item_oTDOA_Information_Type_Item = ENUM(name=u'oTDOA-Information-Type-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OTDOA-Information-Item')))
    _OTDOA_Information_Type_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_Information_Type_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __OTDOA_Information_Type_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___OTDOA_Information_Type_Item_iE_Extensions__item__id),
        (u'criticality', ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_Information_Type_Item_iE_Extensions__item_._ext = None
    _OTDOA_Information_Type_Item_iE_Extensions._cont = __OTDOA_Information_Type_Item_iE_Extensions__item_
    _OTDOA_Information_Type_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_Information_Type_Item._cont = ASN1Dict([
        (u'oTDOA-Information-Type-Item', _OTDOA_Information_Type_Item_oTDOA_Information_Type_Item),
        (u'iE-Extensions', _OTDOA_Information_Type_Item_iE_Extensions),
        ])
    OTDOA_Information_Type_Item._ext = []
    
    #-----< OTDOA-Information-Type-ItemExtIEs >-----#
    OTDOA_Information_Type_ItemExtIEs = CLASS(name=u'OTDOA-Information-Type-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OTDOA_Information_Type_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationResponse >-----#
    OTDOAInformationResponse = SEQ(name=u'OTDOAInformationResponse', mode=MODE_TYPE)
    _OTDOAInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____OTDOAInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACells')))
    _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____OTDOAInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___OTDOAInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OTDOAInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __OTDOAInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OTDOAInformationResponse_protocolIEs__item__id),
        (u'criticality', ___OTDOAInformationResponse_protocolIEs__item__criticality),
        (u'value', ___OTDOAInformationResponse_protocolIEs__item__value),
        ])
    __OTDOAInformationResponse_protocolIEs__item_._ext = None
    _OTDOAInformationResponse_protocolIEs._cont = __OTDOAInformationResponse_protocolIEs__item_
    _OTDOAInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _OTDOAInformationResponse_protocolIEs),
        ])
    OTDOAInformationResponse._ext = []
    
    #-----< OTDOAInformationResponse-IEs >-----#
    OTDOAInformationResponse_IEs = CLASS(name=u'OTDOAInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationResponse_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACells')))
    _OTDOAInformationResponse_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    OTDOAInformationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _OTDOAInformationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _OTDOAInformationResponse_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationFailure >-----#
    OTDOAInformationFailure = SEQ(name=u'OTDOAInformationFailure', mode=MODE_TYPE)
    _OTDOAInformationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____OTDOAInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____OTDOAInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___OTDOAInformationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OTDOAInformationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __OTDOAInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OTDOAInformationFailure_protocolIEs__item__id),
        (u'criticality', ___OTDOAInformationFailure_protocolIEs__item__criticality),
        (u'value', ___OTDOAInformationFailure_protocolIEs__item__value),
        ])
    __OTDOAInformationFailure_protocolIEs__item_._ext = None
    _OTDOAInformationFailure_protocolIEs._cont = __OTDOAInformationFailure_protocolIEs__item_
    _OTDOAInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationFailure._cont = ASN1Dict([
        (u'protocolIEs', _OTDOAInformationFailure_protocolIEs),
        ])
    OTDOAInformationFailure._ext = []
    
    #-----< OTDOAInformationFailure-IEs >-----#
    OTDOAInformationFailure_IEs = CLASS(name=u'OTDOAInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _OTDOAInformationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    OTDOAInformationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _OTDOAInformationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _OTDOAInformationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationControl >-----#
    AssistanceInformationControl = SEQ(name=u'AssistanceInformationControl', mode=MODE_TYPE)
    _AssistanceInformationControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __AssistanceInformationControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___AssistanceInformationControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____AssistanceInformationControl_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Assistance-Information')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Broadcast')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    ____AssistanceInformationControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab_at = None
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab_id = u'id'
    ___AssistanceInformationControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AssistanceInformationControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab_id = u'Value'
    __AssistanceInformationControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AssistanceInformationControl_protocolIEs__item__id),
        (u'criticality', ___AssistanceInformationControl_protocolIEs__item__criticality),
        (u'value', ___AssistanceInformationControl_protocolIEs__item__value),
        ])
    __AssistanceInformationControl_protocolIEs__item_._ext = None
    _AssistanceInformationControl_protocolIEs._cont = __AssistanceInformationControl_protocolIEs__item_
    _AssistanceInformationControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AssistanceInformationControl._cont = ASN1Dict([
        (u'protocolIEs', _AssistanceInformationControl_protocolIEs),
        ])
    AssistanceInformationControl._ext = []
    
    #-----< AssistanceInformationControl-IEs >-----#
    AssistanceInformationControl_IEs = CLASS(name=u'AssistanceInformationControl-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _AssistanceInformationControl_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Assistance-Information')))
    _AssistanceInformationControl_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Broadcast')))
    _AssistanceInformationControl_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    AssistanceInformationControl_IEs._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _AssistanceInformationControl_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _AssistanceInformationControl_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _AssistanceInformationControl_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationFeedback >-----#
    AssistanceInformationFeedback = SEQ(name=u'AssistanceInformationFeedback', mode=MODE_TYPE)
    _AssistanceInformationFeedback_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __AssistanceInformationFeedback_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___AssistanceInformationFeedback_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____AssistanceInformationFeedback_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationFailureList')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____AssistanceInformationFeedback_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab_at = None
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab_id = u'id'
    ___AssistanceInformationFeedback_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___AssistanceInformationFeedback_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab_id = u'Value'
    __AssistanceInformationFeedback_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___AssistanceInformationFeedback_protocolIEs__item__id),
        (u'criticality', ___AssistanceInformationFeedback_protocolIEs__item__criticality),
        (u'value', ___AssistanceInformationFeedback_protocolIEs__item__value),
        ])
    __AssistanceInformationFeedback_protocolIEs__item_._ext = None
    _AssistanceInformationFeedback_protocolIEs._cont = __AssistanceInformationFeedback_protocolIEs__item_
    _AssistanceInformationFeedback_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AssistanceInformationFeedback._cont = ASN1Dict([
        (u'protocolIEs', _AssistanceInformationFeedback_protocolIEs),
        ])
    AssistanceInformationFeedback._ext = []
    
    #-----< AssistanceInformationFeedback-IEs >-----#
    AssistanceInformationFeedback_IEs = CLASS(name=u'AssistanceInformationFeedback-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _AssistanceInformationFeedback_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationFailureList')))
    _AssistanceInformationFeedback_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    _AssistanceInformationFeedback_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    AssistanceInformationFeedback_IEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _AssistanceInformationFeedback_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _AssistanceInformationFeedback_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _AssistanceInformationFeedback_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name=u'ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationRequest >-----#
    PositioningInformationRequest = SEQ(name=u'PositioningInformationRequest', mode=MODE_TYPE)
    _PositioningInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedSRSTransmissionCharacteristics')))
    ____PositioningInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationRequest_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationRequest_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationRequest_protocolIEs__item__value),
        ])
    __PositioningInformationRequest_protocolIEs__item_._ext = None
    _PositioningInformationRequest_protocolIEs._cont = __PositioningInformationRequest_protocolIEs__item_
    _PositioningInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationRequest_protocolIEs),
        ])
    PositioningInformationRequest._ext = []
    
    #-----< PositioningInformationRequest-IEs >-----#
    PositioningInformationRequest_IEs = CLASS(name=u'PositioningInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationRequest_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedSRSTransmissionCharacteristics')))
    PositioningInformationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _PositioningInformationRequest_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationResponse >-----#
    PositioningInformationResponse = SEQ(name=u'PositioningInformationResponse', mode=MODE_TYPE)
    _PositioningInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationResponse_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationResponse_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationResponse_protocolIEs__item__value),
        ])
    __PositioningInformationResponse_protocolIEs__item_._ext = None
    _PositioningInformationResponse_protocolIEs._cont = __PositioningInformationResponse_protocolIEs__item_
    _PositioningInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationResponse_protocolIEs),
        ])
    PositioningInformationResponse._ext = []
    
    #-----< PositioningInformationResponse-IEs >-----#
    PositioningInformationResponse_IEs = CLASS(name=u'PositioningInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _PositioningInformationResponse_IEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _PositioningInformationResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PositioningInformationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponse_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _PositioningInformationResponse_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationFailure >-----#
    PositioningInformationFailure = SEQ(name=u'PositioningInformationFailure', mode=MODE_TYPE)
    _PositioningInformationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationFailure_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationFailure_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationFailure_protocolIEs__item__value),
        ])
    __PositioningInformationFailure_protocolIEs__item_._ext = None
    _PositioningInformationFailure_protocolIEs._cont = __PositioningInformationFailure_protocolIEs__item_
    _PositioningInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationFailure._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationFailure_protocolIEs),
        ])
    PositioningInformationFailure._ext = []
    
    #-----< PositioningInformationFailure-IEs >-----#
    PositioningInformationFailure_IEs = CLASS(name=u'PositioningInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _PositioningInformationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PositioningInformationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningInformationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _PositioningInformationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationUpdate >-----#
    PositioningInformationUpdate = SEQ(name=u'PositioningInformationUpdate', mode=MODE_TYPE)
    _PositioningInformationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningInformationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningInformationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningInformationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningInformationUpdate_protocolIEs__item__id),
        (u'criticality', ___PositioningInformationUpdate_protocolIEs__item__criticality),
        (u'value', ___PositioningInformationUpdate_protocolIEs__item__value),
        ])
    __PositioningInformationUpdate_protocolIEs__item_._ext = None
    _PositioningInformationUpdate_protocolIEs._cont = __PositioningInformationUpdate_protocolIEs__item_
    _PositioningInformationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _PositioningInformationUpdate_protocolIEs),
        ])
    PositioningInformationUpdate._ext = []
    
    #-----< PositioningInformationUpdate-IEs >-----#
    PositioningInformationUpdate_IEs = CLASS(name=u'PositioningInformationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationUpdate_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _PositioningInformationUpdate_IEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    PositioningInformationUpdate_IEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _PositioningInformationUpdate_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _PositioningInformationUpdate_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementRequest >-----#
    MeasurementRequest = SEQ(name=u'MeasurementRequest', mode=MODE_TYPE)
    _MeasurementRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestList')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfoRequest')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityExtended')))
    ____MeasurementRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 52), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___MeasurementRequest_protocolIEs__item__id._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__id._const_tab_at = None
    ___MeasurementRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementRequest_protocolIEs__item__value._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementRequest_protocolIEs__item__id),
        (u'criticality', ___MeasurementRequest_protocolIEs__item__criticality),
        (u'value', ___MeasurementRequest_protocolIEs__item__value),
        ])
    __MeasurementRequest_protocolIEs__item_._ext = None
    _MeasurementRequest_protocolIEs._cont = __MeasurementRequest_protocolIEs__item_
    _MeasurementRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementRequest._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementRequest_protocolIEs),
        ])
    MeasurementRequest._ext = []
    
    #-----< MeasurementRequest-IEs >-----#
    MeasurementRequest_IEs = CLASS(name=u'MeasurementRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementRequest_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestList')))
    _MeasurementRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _MeasurementRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _MeasurementRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities')))
    _MeasurementRequest_IEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _MeasurementRequest_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _MeasurementRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfoRequest')))
    _MeasurementRequest_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _MeasurementRequest_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    _MeasurementRequest_IEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityExtended')))
    MeasurementRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 52), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _MeasurementRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _MeasurementRequest_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _MeasurementRequest_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _MeasurementRequest_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _MeasurementRequest_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _MeasurementRequest_IEs_val_Value_10), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementResponse >-----#
    MeasurementResponse = SEQ(name=u'MeasurementResponse', mode=MODE_TYPE)
    _MeasurementResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MeasurementResponse_protocolIEs__item__id._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__id._const_tab_at = None
    ___MeasurementResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementResponse_protocolIEs__item__value._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementResponse_protocolIEs__item__id),
        (u'criticality', ___MeasurementResponse_protocolIEs__item__criticality),
        (u'value', ___MeasurementResponse_protocolIEs__item__value),
        ])
    __MeasurementResponse_protocolIEs__item_._ext = None
    _MeasurementResponse_protocolIEs._cont = __MeasurementResponse_protocolIEs__item_
    _MeasurementResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementResponse._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementResponse_protocolIEs),
        ])
    MeasurementResponse._ext = []
    
    #-----< MeasurementResponse-IEs >-----#
    MeasurementResponse_IEs = CLASS(name=u'MeasurementResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementResponse_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    _MeasurementResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _MeasurementResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 42), (u'criticality', u'reject'), (u'Value', _MeasurementResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _MeasurementResponse_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailure >-----#
    MeasurementFailure = SEQ(name=u'MeasurementFailure', mode=MODE_TYPE)
    _MeasurementFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MeasurementFailure_protocolIEs__item__id._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__id._const_tab_at = None
    ___MeasurementFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementFailure_protocolIEs__item__value._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementFailure_protocolIEs__item__id),
        (u'criticality', ___MeasurementFailure_protocolIEs__item__criticality),
        (u'value', ___MeasurementFailure_protocolIEs__item__value),
        ])
    __MeasurementFailure_protocolIEs__item_._ext = None
    _MeasurementFailure_protocolIEs._cont = __MeasurementFailure_protocolIEs__item_
    _MeasurementFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementFailure._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementFailure_protocolIEs),
        ])
    MeasurementFailure._ext = []
    
    #-----< MeasurementFailure-IEs >-----#
    MeasurementFailure_IEs = CLASS(name=u'MeasurementFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _MeasurementFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _MeasurementFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _MeasurementFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementReport >-----#
    MeasurementReport = SEQ(name=u'MeasurementReport', mode=MODE_TYPE)
    _MeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    ____MeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementReport_protocolIEs__item__id._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___MeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementReport_protocolIEs__item__criticality._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementReport_protocolIEs__item__value._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementReport_protocolIEs__item__id),
        (u'criticality', ___MeasurementReport_protocolIEs__item__criticality),
        (u'value', ___MeasurementReport_protocolIEs__item__value),
        ])
    __MeasurementReport_protocolIEs__item_._ext = None
    _MeasurementReport_protocolIEs._cont = __MeasurementReport_protocolIEs__item_
    _MeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementReport_protocolIEs),
        ])
    MeasurementReport._ext = []
    
    #-----< MeasurementReport-IEs >-----#
    MeasurementReport_IEs = CLASS(name=u'MeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementReport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementReport_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    MeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _MeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _MeasurementReport_IEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementUpdate >-----#
    MeasurementUpdate = SEQ(name=u'MeasurementUpdate', mode=MODE_TYPE)
    _MeasurementUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    ____MeasurementUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MeasurementUpdate_protocolIEs__item__id._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__id._const_tab_at = None
    ___MeasurementUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementUpdate_protocolIEs__item__value._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementUpdate_protocolIEs__item__id),
        (u'criticality', ___MeasurementUpdate_protocolIEs__item__criticality),
        (u'value', ___MeasurementUpdate_protocolIEs__item__value),
        ])
    __MeasurementUpdate_protocolIEs__item_._ext = None
    _MeasurementUpdate_protocolIEs._cont = __MeasurementUpdate_protocolIEs__item_
    _MeasurementUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementUpdate._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementUpdate_protocolIEs),
        ])
    MeasurementUpdate._ext = []
    
    #-----< MeasurementUpdate-IEs >-----#
    MeasurementUpdate_IEs = CLASS(name=u'MeasurementUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementUpdate_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementUpdate_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementUpdate_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    MeasurementUpdate_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementUpdate_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _MeasurementUpdate_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _MeasurementUpdate_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementAbort >-----#
    MeasurementAbort = SEQ(name=u'MeasurementAbort', mode=MODE_TYPE)
    _MeasurementAbort_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementAbort_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementAbort_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementAbort_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    ____MeasurementAbort_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementAbort_protocolIEs__item__id._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__id._const_tab_at = None
    ___MeasurementAbort_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementAbort_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementAbort_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementAbort_protocolIEs__item__value._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementAbort_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementAbort_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementAbort_protocolIEs__item__id),
        (u'criticality', ___MeasurementAbort_protocolIEs__item__criticality),
        (u'value', ___MeasurementAbort_protocolIEs__item__value),
        ])
    __MeasurementAbort_protocolIEs__item_._ext = None
    _MeasurementAbort_protocolIEs._cont = __MeasurementAbort_protocolIEs__item_
    _MeasurementAbort_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementAbort._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementAbort_protocolIEs),
        ])
    MeasurementAbort._ext = []
    
    #-----< MeasurementAbort-IEs >-----#
    MeasurementAbort_IEs = CLASS(name=u'MeasurementAbort-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementAbort_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementAbort_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    MeasurementAbort_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementAbort_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _MeasurementAbort_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailureIndication >-----#
    MeasurementFailureIndication = SEQ(name=u'MeasurementFailureIndication', mode=MODE_TYPE)
    _MeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____MeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    ____MeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___MeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __MeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___MeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___MeasurementFailureIndication_protocolIEs__item__value),
        ])
    __MeasurementFailureIndication_protocolIEs__item_._ext = None
    _MeasurementFailureIndication_protocolIEs._cont = __MeasurementFailureIndication_protocolIEs__item_
    _MeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _MeasurementFailureIndication_protocolIEs),
        ])
    MeasurementFailureIndication._ext = []
    
    #-----< MeasurementFailureIndication-IEs >-----#
    MeasurementFailureIndication_IEs = CLASS(name=u'MeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailureIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailureIndication_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    MeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _MeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _MeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _MeasurementFailureIndication_IEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationRequest >-----#
    TRPInformationRequest = SEQ(name=u'TRPInformationRequest', mode=MODE_TYPE)
    _TRPInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____TRPInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPList')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeListTRPReq')))
    ____TRPInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TRPInformationRequest_protocolIEs__item__id._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationRequest_protocolIEs__item__value._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationRequest_protocolIEs__item__id),
        (u'criticality', ___TRPInformationRequest_protocolIEs__item__criticality),
        (u'value', ___TRPInformationRequest_protocolIEs__item__value),
        ])
    __TRPInformationRequest_protocolIEs__item_._ext = None
    _TRPInformationRequest_protocolIEs._cont = __TRPInformationRequest_protocolIEs__item_
    _TRPInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationRequest_protocolIEs),
        ])
    TRPInformationRequest._ext = []
    
    #-----< TRPInformationRequest-IEs >-----#
    TRPInformationRequest_IEs = CLASS(name=u'TRPInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationRequest_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPList')))
    _TRPInformationRequest_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeListTRPReq')))
    TRPInformationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _TRPInformationRequest_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _TRPInformationRequest_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationResponse >-----#
    TRPInformationResponse = SEQ(name=u'TRPInformationResponse', mode=MODE_TYPE)
    _TRPInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____TRPInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationListTRPResp')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationResponse_protocolIEs__item__id._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationResponse_protocolIEs__item__value._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationResponse_protocolIEs__item__id),
        (u'criticality', ___TRPInformationResponse_protocolIEs__item__criticality),
        (u'value', ___TRPInformationResponse_protocolIEs__item__value),
        ])
    __TRPInformationResponse_protocolIEs__item_._ext = None
    _TRPInformationResponse_protocolIEs._cont = __TRPInformationResponse_protocolIEs__item_
    _TRPInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationResponse_protocolIEs),
        ])
    TRPInformationResponse._ext = []
    
    #-----< TRPInformationResponse-IEs >-----#
    TRPInformationResponse_IEs = CLASS(name=u'TRPInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationResponse_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationListTRPResp')))
    _TRPInformationResponse_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    TRPInformationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _TRPInformationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _TRPInformationResponse_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationFailure >-----#
    TRPInformationFailure = SEQ(name=u'TRPInformationFailure', mode=MODE_TYPE)
    _TRPInformationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____TRPInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationFailure_protocolIEs__item__id._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___TRPInformationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TRPInformationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___TRPInformationFailure_protocolIEs__item__value._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __TRPInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TRPInformationFailure_protocolIEs__item__id),
        (u'criticality', ___TRPInformationFailure_protocolIEs__item__criticality),
        (u'value', ___TRPInformationFailure_protocolIEs__item__value),
        ])
    __TRPInformationFailure_protocolIEs__item_._ext = None
    _TRPInformationFailure_protocolIEs._cont = __TRPInformationFailure_protocolIEs__item_
    _TRPInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationFailure._cont = ASN1Dict([
        (u'protocolIEs', _TRPInformationFailure_protocolIEs),
        ])
    TRPInformationFailure._ext = []
    
    #-----< TRPInformationFailure-IEs >-----#
    TRPInformationFailure_IEs = CLASS(name=u'TRPInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _TRPInformationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    TRPInformationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _TRPInformationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _TRPInformationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationRequest >-----#
    PositioningActivationRequest = SEQ(name=u'PositioningActivationRequest', mode=MODE_TYPE)
    _PositioningActivationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SRSType')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    ____PositioningActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationRequest_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationRequest_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationRequest_protocolIEs__item__value),
        ])
    __PositioningActivationRequest_protocolIEs__item_._ext = None
    _PositioningActivationRequest_protocolIEs._cont = __PositioningActivationRequest_protocolIEs__item_
    _PositioningActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationRequest._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationRequest_protocolIEs),
        ])
    PositioningActivationRequest._ext = []
    
    #-----< PositioningActivationRequestIEs >-----#
    PositioningActivationRequestIEs = CLASS(name=u'PositioningActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationRequestIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SRSType')))
    _PositioningActivationRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    PositioningActivationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _PositioningActivationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _PositioningActivationRequestIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSType >-----#
    SRSType = CHOICE(name=u'SRSType', mode=MODE_TYPE)
    _SRSType_semipersistentSRS = SEQ(name=u'semipersistentSRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SemipersistentSRS')))
    _SRSType_aperiodicSRS = SEQ(name=u'aperiodicSRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AperiodicSRS')))
    _SRSType_choice_Extension = SEQ(name=u'choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SRSType_choice_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ___SRSType_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_id._const_tab = ___SRSType_choice_Extension_id_tab
    __SRSType_choice_Extension_id._const_tab_at = None
    __SRSType_choice_Extension_id._const_tab_id = u'id'
    __SRSType_choice_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___SRSType_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_criticality._const_tab = ___SRSType_choice_Extension_criticality_tab
    __SRSType_choice_Extension_criticality._const_tab_at = ('..', u'id')
    __SRSType_choice_Extension_criticality._const_tab_id = u'criticality'
    __SRSType_choice_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___SRSType_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_value._const_tab = ___SRSType_choice_Extension_value_tab
    __SRSType_choice_Extension_value._const_tab_at = ('..', u'id')
    __SRSType_choice_Extension_value._const_tab_id = u'Value'
    _SRSType_choice_Extension._cont = ASN1Dict([
        (u'id', __SRSType_choice_Extension_id),
        (u'criticality', __SRSType_choice_Extension_criticality),
        (u'value', __SRSType_choice_Extension_value),
        ])
    _SRSType_choice_Extension._ext = None
    SRSType._cont = ASN1Dict([
        (u'semipersistentSRS', _SRSType_semipersistentSRS),
        (u'aperiodicSRS', _SRSType_aperiodicSRS),
        (u'choice-Extension', _SRSType_choice_Extension),
        ])
    SRSType._ext = None
    
    #-----< SRSType-ExtIEs >-----#
    SRSType_ExtIEs = CLASS(name=u'SRSType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SRSType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SemipersistentSRS >-----#
    SemipersistentSRS = SEQ(name=u'SemipersistentSRS', mode=MODE_TYPE)
    _SemipersistentSRS_sRSResourceSetID = INT(name=u'sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSetID')))
    _SemipersistentSRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SemipersistentSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SemipersistentSRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____SemipersistentSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    ____SemipersistentSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'ignore'), (u'Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_at = None
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___SemipersistentSRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SemipersistentSRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SemipersistentSRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SemipersistentSRS_iE_Extensions__item__id),
        (u'criticality', ___SemipersistentSRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___SemipersistentSRS_iE_Extensions__item__extensionValue),
        ])
    __SemipersistentSRS_iE_Extensions__item_._ext = None
    _SemipersistentSRS_iE_Extensions._cont = __SemipersistentSRS_iE_Extensions__item_
    _SemipersistentSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SemipersistentSRS._cont = ASN1Dict([
        (u'sRSResourceSetID', _SemipersistentSRS_sRSResourceSetID),
        (u'iE-Extensions', _SemipersistentSRS_iE_Extensions),
        ])
    SemipersistentSRS._ext = []
    
    #-----< SemipersistentSRS-ExtIEs >-----#
    SemipersistentSRS_ExtIEs = CLASS(name=u'SemipersistentSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _SemipersistentSRS_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')))
    _SemipersistentSRS_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    SemipersistentSRS_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'ignore'), (u'Extension', _SemipersistentSRS_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _SemipersistentSRS_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRS >-----#
    AperiodicSRS = SEQ(name=u'AperiodicSRS', mode=MODE_TYPE)
    _AperiodicSRS_aperiodic = ENUM(name=u'aperiodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AperiodicSRS_aperiodic._cont = ASN1Dict([(u'true', 0)])
    _AperiodicSRS_aperiodic._ext = []
    _AperiodicSRS_sRSResourceTrigger = SEQ(name=u'sRSResourceTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceTrigger')), opt=True)
    _AperiodicSRS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AperiodicSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AperiodicSRS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'id']))
    ____AperiodicSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__id._const_tab = ____AperiodicSRS_iE_Extensions__item__id_tab
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_at = None
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_id = u'id'
    ___AperiodicSRS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab = ____AperiodicSRS_iE_Extensions__item__criticality_tab
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AperiodicSRS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab = ____AperiodicSRS_iE_Extensions__item__extensionValue_tab
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AperiodicSRS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AperiodicSRS_iE_Extensions__item__id),
        (u'criticality', ___AperiodicSRS_iE_Extensions__item__criticality),
        (u'extensionValue', ___AperiodicSRS_iE_Extensions__item__extensionValue),
        ])
    __AperiodicSRS_iE_Extensions__item_._ext = None
    _AperiodicSRS_iE_Extensions._cont = __AperiodicSRS_iE_Extensions__item_
    _AperiodicSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AperiodicSRS._cont = ASN1Dict([
        (u'aperiodic', _AperiodicSRS_aperiodic),
        (u'sRSResourceTrigger', _AperiodicSRS_sRSResourceTrigger),
        (u'iE-Extensions', _AperiodicSRS_iE_Extensions),
        ])
    AperiodicSRS._ext = []
    
    #-----< AperiodicSRS-ExtIEs >-----#
    AperiodicSRS_ExtIEs = CLASS(name=u'AperiodicSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AperiodicSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationResponse >-----#
    PositioningActivationResponse = SEQ(name=u'PositioningActivationResponse', mode=MODE_TYPE)
    _PositioningActivationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    ____PositioningActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationResponse_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationResponse_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationResponse_protocolIEs__item__value),
        ])
    __PositioningActivationResponse_protocolIEs__item_._ext = None
    _PositioningActivationResponse_protocolIEs._cont = __PositioningActivationResponse_protocolIEs__item_
    _PositioningActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationResponse._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationResponse_protocolIEs),
        ])
    PositioningActivationResponse._ext = []
    
    #-----< PositioningActivationResponseIEs >-----#
    PositioningActivationResponseIEs = CLASS(name=u'PositioningActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _PositioningActivationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _PositioningActivationResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    PositioningActivationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _PositioningActivationResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationFailure >-----#
    PositioningActivationFailure = SEQ(name=u'PositioningActivationFailure', mode=MODE_TYPE)
    _PositioningActivationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningActivationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningActivationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningActivationFailure_protocolIEs__item__id),
        (u'criticality', ___PositioningActivationFailure_protocolIEs__item__criticality),
        (u'value', ___PositioningActivationFailure_protocolIEs__item__value),
        ])
    __PositioningActivationFailure_protocolIEs__item_._ext = None
    _PositioningActivationFailure_protocolIEs._cont = __PositioningActivationFailure_protocolIEs__item_
    _PositioningActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationFailure._cont = ASN1Dict([
        (u'protocolIEs', _PositioningActivationFailure_protocolIEs),
        ])
    PositioningActivationFailure._ext = []
    
    #-----< PositioningActivationFailureIEs >-----#
    PositioningActivationFailureIEs = CLASS(name=u'PositioningActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _PositioningActivationFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PositioningActivationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PositioningActivationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _PositioningActivationFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningDeactivation >-----#
    PositioningDeactivation = SEQ(name=u'PositioningDeactivation', mode=MODE_TYPE)
    _PositioningDeactivation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningDeactivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningDeactivation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'id']))
    ____PositioningDeactivation_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AbortTransmission')))
    ____PositioningDeactivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningDeactivation_protocolIEs__item__id._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_at = None
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_id = u'id'
    ___PositioningDeactivation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'criticality']))
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PositioningDeactivation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), [u'Value']))
    ___PositioningDeactivation_protocolIEs__item__value._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_id = u'Value'
    __PositioningDeactivation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PositioningDeactivation_protocolIEs__item__id),
        (u'criticality', ___PositioningDeactivation_protocolIEs__item__criticality),
        (u'value', ___PositioningDeactivation_protocolIEs__item__value),
        ])
    __PositioningDeactivation_protocolIEs__item_._ext = None
    _PositioningDeactivation_protocolIEs._cont = __PositioningDeactivation_protocolIEs__item_
    _PositioningDeactivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningDeactivation._cont = ASN1Dict([
        (u'protocolIEs', _PositioningDeactivation_protocolIEs),
        ])
    PositioningDeactivation._ext = []
    
    #-----< PositioningDeactivationIEs >-----#
    PositioningDeactivationIEs = CLASS(name=u'PositioningDeactivationIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningDeactivationIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AbortTransmission')))
    PositioningDeactivationIEs._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _PositioningDeactivationIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value,
        __E_CIDMeasurementInitiationRequest_protocolIEs__item_,
        _E_CIDMeasurementInitiationRequest_protocolIEs,
        E_CIDMeasurementInitiationRequest,
        E_CIDMeasurementInitiationRequest_IEs,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_0,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_1,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_2,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_3,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_4,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_5,
        ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value,
        __E_CIDMeasurementInitiationResponse_protocolIEs__item_,
        _E_CIDMeasurementInitiationResponse_protocolIEs,
        E_CIDMeasurementInitiationResponse,
        E_CIDMeasurementInitiationResponse_IEs,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_0,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_1,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_2,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_3,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_4,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_5,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value,
        __E_CIDMeasurementInitiationFailure_protocolIEs__item_,
        _E_CIDMeasurementInitiationFailure_protocolIEs,
        E_CIDMeasurementInitiationFailure,
        E_CIDMeasurementInitiationFailure_IEs,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_0,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_1,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_2,
        ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__id,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__value,
        __E_CIDMeasurementFailureIndication_protocolIEs__item_,
        _E_CIDMeasurementFailureIndication_protocolIEs,
        E_CIDMeasurementFailureIndication,
        E_CIDMeasurementFailureIndication_IEs,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_0,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_1,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_2,
        ____E_CIDMeasurementReport_protocolIEs__item__id_tab,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        ___E_CIDMeasurementReport_protocolIEs__item__id,
        ___E_CIDMeasurementReport_protocolIEs__item__criticality,
        ___E_CIDMeasurementReport_protocolIEs__item__value,
        __E_CIDMeasurementReport_protocolIEs__item_,
        _E_CIDMeasurementReport_protocolIEs,
        E_CIDMeasurementReport,
        E_CIDMeasurementReport_IEs,
        _E_CIDMeasurementReport_IEs_val_Value_0,
        _E_CIDMeasurementReport_IEs_val_Value_1,
        _E_CIDMeasurementReport_IEs_val_Value_2,
        _E_CIDMeasurementReport_IEs_val_Value_3,
        ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value,
        __E_CIDMeasurementTerminationCommand_protocolIEs__item_,
        _E_CIDMeasurementTerminationCommand_protocolIEs,
        E_CIDMeasurementTerminationCommand,
        E_CIDMeasurementTerminationCommand_IEs,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_0,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_1,
        ____OTDOAInformationRequest_protocolIEs__item__id_tab,
        _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___OTDOAInformationRequest_protocolIEs__item__id,
        ___OTDOAInformationRequest_protocolIEs__item__criticality,
        ___OTDOAInformationRequest_protocolIEs__item__value,
        __OTDOAInformationRequest_protocolIEs__item_,
        _OTDOAInformationRequest_protocolIEs,
        OTDOAInformationRequest,
        OTDOAInformationRequest_IEs,
        _OTDOAInformationRequest_IEs_val_Value_0,
        ___OTDOA_Information_Type__item__id_tab,
        ____OTDOA_Information_Type__item__id_tab_val_Value_0,
        __OTDOA_Information_Type__item__id,
        __OTDOA_Information_Type__item__criticality,
        __OTDOA_Information_Type__item__value,
        _OTDOA_Information_Type__item_,
        OTDOA_Information_Type,
        OTDOA_Information_TypeIEs,
        _OTDOA_Information_TypeIEs_val_Value_0,
        _OTDOA_Information_Type_Item_oTDOA_Information_Type_Item,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__id,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue,
        __OTDOA_Information_Type_Item_iE_Extensions__item_,
        _OTDOA_Information_Type_Item_iE_Extensions,
        OTDOA_Information_Type_Item,
        OTDOA_Information_Type_ItemExtIEs,
        ____OTDOAInformationResponse_protocolIEs__item__id_tab,
        _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___OTDOAInformationResponse_protocolIEs__item__id,
        ___OTDOAInformationResponse_protocolIEs__item__criticality,
        ___OTDOAInformationResponse_protocolIEs__item__value,
        __OTDOAInformationResponse_protocolIEs__item_,
        _OTDOAInformationResponse_protocolIEs,
        OTDOAInformationResponse,
        OTDOAInformationResponse_IEs,
        _OTDOAInformationResponse_IEs_val_Value_0,
        _OTDOAInformationResponse_IEs_val_Value_1,
        ____OTDOAInformationFailure_protocolIEs__item__id_tab,
        _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___OTDOAInformationFailure_protocolIEs__item__id,
        ___OTDOAInformationFailure_protocolIEs__item__criticality,
        ___OTDOAInformationFailure_protocolIEs__item__value,
        __OTDOAInformationFailure_protocolIEs__item_,
        _OTDOAInformationFailure_protocolIEs,
        OTDOAInformationFailure,
        OTDOAInformationFailure_IEs,
        _OTDOAInformationFailure_IEs_val_Value_0,
        _OTDOAInformationFailure_IEs_val_Value_1,
        ____AssistanceInformationControl_protocolIEs__item__id_tab,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2,
        ___AssistanceInformationControl_protocolIEs__item__id,
        ___AssistanceInformationControl_protocolIEs__item__criticality,
        ___AssistanceInformationControl_protocolIEs__item__value,
        __AssistanceInformationControl_protocolIEs__item_,
        _AssistanceInformationControl_protocolIEs,
        AssistanceInformationControl,
        AssistanceInformationControl_IEs,
        _AssistanceInformationControl_IEs_val_Value_0,
        _AssistanceInformationControl_IEs_val_Value_1,
        _AssistanceInformationControl_IEs_val_Value_2,
        ____AssistanceInformationFeedback_protocolIEs__item__id_tab,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2,
        ___AssistanceInformationFeedback_protocolIEs__item__id,
        ___AssistanceInformationFeedback_protocolIEs__item__criticality,
        ___AssistanceInformationFeedback_protocolIEs__item__value,
        __AssistanceInformationFeedback_protocolIEs__item_,
        _AssistanceInformationFeedback_protocolIEs,
        AssistanceInformationFeedback,
        AssistanceInformationFeedback_IEs,
        _AssistanceInformationFeedback_IEs_val_Value_0,
        _AssistanceInformationFeedback_IEs_val_Value_1,
        _AssistanceInformationFeedback_IEs_val_Value_2,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____PositioningInformationRequest_protocolIEs__item__id_tab,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___PositioningInformationRequest_protocolIEs__item__id,
        ___PositioningInformationRequest_protocolIEs__item__criticality,
        ___PositioningInformationRequest_protocolIEs__item__value,
        __PositioningInformationRequest_protocolIEs__item_,
        _PositioningInformationRequest_protocolIEs,
        PositioningInformationRequest,
        PositioningInformationRequest_IEs,
        _PositioningInformationRequest_IEs_val_Value_0,
        ____PositioningInformationResponse_protocolIEs__item__id_tab,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningInformationResponse_protocolIEs__item__id,
        ___PositioningInformationResponse_protocolIEs__item__criticality,
        ___PositioningInformationResponse_protocolIEs__item__value,
        __PositioningInformationResponse_protocolIEs__item_,
        _PositioningInformationResponse_protocolIEs,
        PositioningInformationResponse,
        PositioningInformationResponse_IEs,
        _PositioningInformationResponse_IEs_val_Value_0,
        _PositioningInformationResponse_IEs_val_Value_1,
        _PositioningInformationResponse_IEs_val_Value_2,
        ____PositioningInformationFailure_protocolIEs__item__id_tab,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningInformationFailure_protocolIEs__item__id,
        ___PositioningInformationFailure_protocolIEs__item__criticality,
        ___PositioningInformationFailure_protocolIEs__item__value,
        __PositioningInformationFailure_protocolIEs__item_,
        _PositioningInformationFailure_protocolIEs,
        PositioningInformationFailure,
        PositioningInformationFailure_IEs,
        _PositioningInformationFailure_IEs_val_Value_0,
        _PositioningInformationFailure_IEs_val_Value_1,
        ____PositioningInformationUpdate_protocolIEs__item__id_tab,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningInformationUpdate_protocolIEs__item__id,
        ___PositioningInformationUpdate_protocolIEs__item__criticality,
        ___PositioningInformationUpdate_protocolIEs__item__value,
        __PositioningInformationUpdate_protocolIEs__item_,
        _PositioningInformationUpdate_protocolIEs,
        PositioningInformationUpdate,
        PositioningInformationUpdate_IEs,
        _PositioningInformationUpdate_IEs_val_Value_0,
        _PositioningInformationUpdate_IEs_val_Value_1,
        ____MeasurementRequest_protocolIEs__item__id_tab,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10,
        ___MeasurementRequest_protocolIEs__item__id,
        ___MeasurementRequest_protocolIEs__item__criticality,
        ___MeasurementRequest_protocolIEs__item__value,
        __MeasurementRequest_protocolIEs__item_,
        _MeasurementRequest_protocolIEs,
        MeasurementRequest,
        MeasurementRequest_IEs,
        _MeasurementRequest_IEs_val_Value_0,
        _MeasurementRequest_IEs_val_Value_1,
        _MeasurementRequest_IEs_val_Value_2,
        _MeasurementRequest_IEs_val_Value_3,
        _MeasurementRequest_IEs_val_Value_4,
        _MeasurementRequest_IEs_val_Value_5,
        _MeasurementRequest_IEs_val_Value_6,
        _MeasurementRequest_IEs_val_Value_7,
        _MeasurementRequest_IEs_val_Value_8,
        _MeasurementRequest_IEs_val_Value_9,
        _MeasurementRequest_IEs_val_Value_10,
        ____MeasurementResponse_protocolIEs__item__id_tab,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MeasurementResponse_protocolIEs__item__id,
        ___MeasurementResponse_protocolIEs__item__criticality,
        ___MeasurementResponse_protocolIEs__item__value,
        __MeasurementResponse_protocolIEs__item_,
        _MeasurementResponse_protocolIEs,
        MeasurementResponse,
        MeasurementResponse_IEs,
        _MeasurementResponse_IEs_val_Value_0,
        _MeasurementResponse_IEs_val_Value_1,
        _MeasurementResponse_IEs_val_Value_2,
        _MeasurementResponse_IEs_val_Value_3,
        ____MeasurementFailure_protocolIEs__item__id_tab,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementFailure_protocolIEs__item__id,
        ___MeasurementFailure_protocolIEs__item__criticality,
        ___MeasurementFailure_protocolIEs__item__value,
        __MeasurementFailure_protocolIEs__item_,
        _MeasurementFailure_protocolIEs,
        MeasurementFailure,
        MeasurementFailure_IEs,
        _MeasurementFailure_IEs_val_Value_0,
        _MeasurementFailure_IEs_val_Value_1,
        _MeasurementFailure_IEs_val_Value_2,
        ____MeasurementReport_protocolIEs__item__id_tab,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementReport_protocolIEs__item__id,
        ___MeasurementReport_protocolIEs__item__criticality,
        ___MeasurementReport_protocolIEs__item__value,
        __MeasurementReport_protocolIEs__item_,
        _MeasurementReport_protocolIEs,
        MeasurementReport,
        MeasurementReport_IEs,
        _MeasurementReport_IEs_val_Value_0,
        _MeasurementReport_IEs_val_Value_1,
        _MeasurementReport_IEs_val_Value_2,
        ____MeasurementUpdate_protocolIEs__item__id_tab,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementUpdate_protocolIEs__item__id,
        ___MeasurementUpdate_protocolIEs__item__criticality,
        ___MeasurementUpdate_protocolIEs__item__value,
        __MeasurementUpdate_protocolIEs__item_,
        _MeasurementUpdate_protocolIEs,
        MeasurementUpdate,
        MeasurementUpdate_IEs,
        _MeasurementUpdate_IEs_val_Value_0,
        _MeasurementUpdate_IEs_val_Value_1,
        _MeasurementUpdate_IEs_val_Value_2,
        ____MeasurementAbort_protocolIEs__item__id_tab,
        _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1,
        ___MeasurementAbort_protocolIEs__item__id,
        ___MeasurementAbort_protocolIEs__item__criticality,
        ___MeasurementAbort_protocolIEs__item__value,
        __MeasurementAbort_protocolIEs__item_,
        _MeasurementAbort_protocolIEs,
        MeasurementAbort,
        MeasurementAbort_IEs,
        _MeasurementAbort_IEs_val_Value_0,
        _MeasurementAbort_IEs_val_Value_1,
        ____MeasurementFailureIndication_protocolIEs__item__id_tab,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementFailureIndication_protocolIEs__item__id,
        ___MeasurementFailureIndication_protocolIEs__item__criticality,
        ___MeasurementFailureIndication_protocolIEs__item__value,
        __MeasurementFailureIndication_protocolIEs__item_,
        _MeasurementFailureIndication_protocolIEs,
        MeasurementFailureIndication,
        MeasurementFailureIndication_IEs,
        _MeasurementFailureIndication_IEs_val_Value_0,
        _MeasurementFailureIndication_IEs_val_Value_1,
        _MeasurementFailureIndication_IEs_val_Value_2,
        ____TRPInformationRequest_protocolIEs__item__id_tab,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationRequest_protocolIEs__item__id,
        ___TRPInformationRequest_protocolIEs__item__criticality,
        ___TRPInformationRequest_protocolIEs__item__value,
        __TRPInformationRequest_protocolIEs__item_,
        _TRPInformationRequest_protocolIEs,
        TRPInformationRequest,
        TRPInformationRequest_IEs,
        _TRPInformationRequest_IEs_val_Value_0,
        _TRPInformationRequest_IEs_val_Value_1,
        ____TRPInformationResponse_protocolIEs__item__id_tab,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationResponse_protocolIEs__item__id,
        ___TRPInformationResponse_protocolIEs__item__criticality,
        ___TRPInformationResponse_protocolIEs__item__value,
        __TRPInformationResponse_protocolIEs__item_,
        _TRPInformationResponse_protocolIEs,
        TRPInformationResponse,
        TRPInformationResponse_IEs,
        _TRPInformationResponse_IEs_val_Value_0,
        _TRPInformationResponse_IEs_val_Value_1,
        ____TRPInformationFailure_protocolIEs__item__id_tab,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationFailure_protocolIEs__item__id,
        ___TRPInformationFailure_protocolIEs__item__criticality,
        ___TRPInformationFailure_protocolIEs__item__value,
        __TRPInformationFailure_protocolIEs__item_,
        _TRPInformationFailure_protocolIEs,
        TRPInformationFailure,
        TRPInformationFailure_IEs,
        _TRPInformationFailure_IEs_val_Value_0,
        _TRPInformationFailure_IEs_val_Value_1,
        ____PositioningActivationRequest_protocolIEs__item__id_tab,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningActivationRequest_protocolIEs__item__id,
        ___PositioningActivationRequest_protocolIEs__item__criticality,
        ___PositioningActivationRequest_protocolIEs__item__value,
        __PositioningActivationRequest_protocolIEs__item_,
        _PositioningActivationRequest_protocolIEs,
        PositioningActivationRequest,
        PositioningActivationRequestIEs,
        _PositioningActivationRequestIEs_val_Value_0,
        _PositioningActivationRequestIEs_val_Value_1,
        _SRSType_semipersistentSRS,
        _SRSType_aperiodicSRS,
        ___SRSType_choice_Extension_id_tab,
        __SRSType_choice_Extension_id,
        ___SRSType_choice_Extension_criticality_tab,
        __SRSType_choice_Extension_criticality,
        ___SRSType_choice_Extension_value_tab,
        __SRSType_choice_Extension_value,
        _SRSType_choice_Extension,
        SRSType,
        SRSType_ExtIEs,
        _SemipersistentSRS_sRSResourceSetID,
        ____SemipersistentSRS_iE_Extensions__item__id_tab,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1,
        ___SemipersistentSRS_iE_Extensions__item__id,
        ___SemipersistentSRS_iE_Extensions__item__criticality,
        ___SemipersistentSRS_iE_Extensions__item__extensionValue,
        __SemipersistentSRS_iE_Extensions__item_,
        _SemipersistentSRS_iE_Extensions,
        SemipersistentSRS,
        SemipersistentSRS_ExtIEs,
        _SemipersistentSRS_ExtIEs_val_Extension_0,
        _SemipersistentSRS_ExtIEs_val_Extension_1,
        _AperiodicSRS_aperiodic,
        _AperiodicSRS_sRSResourceTrigger,
        ____AperiodicSRS_iE_Extensions__item__id_tab,
        ___AperiodicSRS_iE_Extensions__item__id,
        ____AperiodicSRS_iE_Extensions__item__criticality_tab,
        ___AperiodicSRS_iE_Extensions__item__criticality,
        ____AperiodicSRS_iE_Extensions__item__extensionValue_tab,
        ___AperiodicSRS_iE_Extensions__item__extensionValue,
        __AperiodicSRS_iE_Extensions__item_,
        _AperiodicSRS_iE_Extensions,
        AperiodicSRS,
        AperiodicSRS_ExtIEs,
        ____PositioningActivationResponse_protocolIEs__item__id_tab,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningActivationResponse_protocolIEs__item__id,
        ___PositioningActivationResponse_protocolIEs__item__criticality,
        ___PositioningActivationResponse_protocolIEs__item__value,
        __PositioningActivationResponse_protocolIEs__item_,
        _PositioningActivationResponse_protocolIEs,
        PositioningActivationResponse,
        PositioningActivationResponseIEs,
        _PositioningActivationResponseIEs_val_Value_0,
        _PositioningActivationResponseIEs_val_Value_1,
        _PositioningActivationResponseIEs_val_Value_2,
        ____PositioningActivationFailure_protocolIEs__item__id_tab,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningActivationFailure_protocolIEs__item__id,
        ___PositioningActivationFailure_protocolIEs__item__criticality,
        ___PositioningActivationFailure_protocolIEs__item__value,
        __PositioningActivationFailure_protocolIEs__item_,
        _PositioningActivationFailure_protocolIEs,
        PositioningActivationFailure,
        PositioningActivationFailureIEs,
        _PositioningActivationFailureIEs_val_Value_0,
        _PositioningActivationFailureIEs_val_Value_1,
        ____PositioningDeactivation_protocolIEs__item__id_tab,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0,
        ___PositioningDeactivation_protocolIEs__item__id,
        ___PositioningDeactivation_protocolIEs__item__criticality,
        ___PositioningDeactivation_protocolIEs__item__value,
        __PositioningDeactivation_protocolIEs__item_,
        _PositioningDeactivation_protocolIEs,
        PositioningDeactivation,
        PositioningDeactivationIEs,
        _PositioningDeactivationIEs_val_Value_0,
    ]

class NRPPA_PDU_Descriptions:

    _name_  = u'NRPPA-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 0]
    
    _obj_ = [
        u'NRPPA-ELEMENTARY-PROCEDURE',
        u'NRPPA-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'NRPPA-ELEMENTARY-PROCEDURES',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'oTDOAInformationExchange',
        u'assistanceInformationControl',
        u'assistanceInformationFeedback',
        u'errorIndication',
        u'privateMessage',
        u'positioningInformationExchange',
        u'positioningInformationUpdate',
        u'measurement',
        u'measurementReport',
        u'measurementUpdate',
        u'measurementAbort',
        u'measurementFailureIndication',
        u'tRPInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        ]
    _type_ = [
        u'NRPPA-ELEMENTARY-PROCEDURE',
        u'NRPPA-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'NRPPA-ELEMENTARY-PROCEDURES',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'oTDOAInformationExchange',
        u'assistanceInformationControl',
        u'assistanceInformationFeedback',
        u'errorIndication',
        u'privateMessage',
        u'positioningInformationExchange',
        u'positioningInformationUpdate',
        u'measurement',
        u'measurementReport',
        u'measurementUpdate',
        u'measurementAbort',
        u'measurementFailureIndication',
        u'tRPInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        ]
    _class_ = [
        u'NRPPA-ELEMENTARY-PROCEDURE',
        u'NRPPA-ELEMENTARY-PROCEDURES',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        u'e-CIDMeasurementInitiation',
        u'e-CIDMeasurementFailureIndication',
        u'e-CIDMeasurementReport',
        u'e-CIDMeasurementTermination',
        u'oTDOAInformationExchange',
        u'assistanceInformationControl',
        u'assistanceInformationFeedback',
        u'errorIndication',
        u'privateMessage',
        u'positioningInformationExchange',
        u'positioningInformationUpdate',
        u'measurement',
        u'measurementReport',
        u'measurementUpdate',
        u'measurementAbort',
        u'measurementFailureIndication',
        u'tRPInformationExchange',
        u'positioningActivation',
        u'positioningDeactivation',
        ]
    _param_ = [
        ]
    
    #-----< NRPPA-ELEMENTARY-PROCEDURE >-----#
    NRPPA_ELEMENTARY_PROCEDURE = CLASS(name=u'NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NRPPA_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _NRPPA_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')), default=u'ignore')
    NRPPA_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _NRPPA_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _NRPPA_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< NRPPA-PDU >-----#
    NRPPA_PDU = CHOICE(name=u'NRPPA-PDU', mode=MODE_TYPE)
    _NRPPA_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'InitiatingMessage')))
    _NRPPA_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'SuccessfulOutcome')))
    _NRPPA_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'UnsuccessfulOutcome')))
    NRPPA_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _NRPPA_PDU_initiatingMessage),
        (u'successfulOutcome', _NRPPA_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _NRPPA_PDU_unsuccessfulOutcome),
        ])
    NRPPA_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 11), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 0), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_nrppatransactionID = INT(name=u'nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'nrppatransactionID', _InitiatingMessage_nrppatransactionID),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 11), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 0), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_nrppatransactionID = INT(name=u'nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'nrppatransactionID', _SuccessfulOutcome_nrppatransactionID),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 11), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 0), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_nrppatransactionID = INT(name=u'nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'nrppatransactionID', _UnsuccessfulOutcome_nrppatransactionID),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES >-----#
    NRPPA_ELEMENTARY_PROCEDURES = CLASS(name=u'NRPPA-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    NRPPA_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), (u'procedureCode', 11), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'procedureCode', 0), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), (u'procedureCode', 11), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), (u'procedureCode', 17), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 0), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 18), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< e-CIDMeasurementInitiation >-----#
    e_CIDMeasurementInitiation = CLASS(name=u'e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _e_CIDMeasurementInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    e_CIDMeasurementInitiation._val = dict([(u'InitiatingMessage', _e_CIDMeasurementInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _e_CIDMeasurementInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome), (u'procedureCode', 2), (u'criticality', u'reject')])
    
    #-----< e-CIDMeasurementFailureIndication >-----#
    e_CIDMeasurementFailureIndication = CLASS(name=u'e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    e_CIDMeasurementFailureIndication._val = dict([(u'InitiatingMessage', _e_CIDMeasurementFailureIndication_val_InitiatingMessage), (u'procedureCode', 3), (u'criticality', u'ignore')])
    
    #-----< e-CIDMeasurementReport >-----#
    e_CIDMeasurementReport = CLASS(name=u'e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    e_CIDMeasurementReport._val = dict([(u'InitiatingMessage', _e_CIDMeasurementReport_val_InitiatingMessage), (u'procedureCode', 4), (u'criticality', u'ignore')])
    
    #-----< e-CIDMeasurementTermination >-----#
    e_CIDMeasurementTermination = CLASS(name=u'e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    e_CIDMeasurementTermination._val = dict([(u'InitiatingMessage', _e_CIDMeasurementTermination_val_InitiatingMessage), (u'procedureCode', 5), (u'criticality', u'reject')])
    
    #-----< oTDOAInformationExchange >-----#
    oTDOAInformationExchange = CLASS(name=u'oTDOAInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _oTDOAInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _oTDOAInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _oTDOAInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    oTDOAInformationExchange._val = dict([(u'InitiatingMessage', _oTDOAInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _oTDOAInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _oTDOAInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< assistanceInformationControl >-----#
    assistanceInformationControl = CLASS(name=u'assistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _assistanceInformationControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    assistanceInformationControl._val = dict([(u'InitiatingMessage', _assistanceInformationControl_val_InitiatingMessage), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< assistanceInformationFeedback >-----#
    assistanceInformationFeedback = CLASS(name=u'assistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _assistanceInformationFeedback_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    assistanceInformationFeedback._val = dict([(u'InitiatingMessage', _assistanceInformationFeedback_val_InitiatingMessage), (u'procedureCode', 8), (u'criticality', u'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 0), (u'criticality', u'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 1), (u'criticality', u'ignore')])
    
    #-----< positioningInformationExchange >-----#
    positioningInformationExchange = CLASS(name=u'positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _positioningInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _positioningInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    positioningInformationExchange._val = dict([(u'InitiatingMessage', _positioningInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _positioningInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _positioningInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 9), (u'criticality', u'reject')])
    
    #-----< positioningInformationUpdate >-----#
    positioningInformationUpdate = CLASS(name=u'positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningInformationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    positioningInformationUpdate._val = dict([(u'InitiatingMessage', _positioningInformationUpdate_val_InitiatingMessage), (u'procedureCode', 10), (u'criticality', u'ignore')])
    
    #-----< measurement >-----#
    measurement = CLASS(name=u'measurement', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurement_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _measurement_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _measurement_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    measurement._val = dict([(u'InitiatingMessage', _measurement_val_InitiatingMessage), (u'SuccessfulOutcome', _measurement_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _measurement_val_UnsuccessfulOutcome), (u'procedureCode', 11), (u'criticality', u'reject')])
    
    #-----< measurementReport >-----#
    measurementReport = CLASS(name=u'measurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    measurementReport._val = dict([(u'InitiatingMessage', _measurementReport_val_InitiatingMessage), (u'procedureCode', 12), (u'criticality', u'ignore')])
    
    #-----< measurementUpdate >-----#
    measurementUpdate = CLASS(name=u'measurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    measurementUpdate._val = dict([(u'InitiatingMessage', _measurementUpdate_val_InitiatingMessage), (u'procedureCode', 13), (u'criticality', u'ignore')])
    
    #-----< measurementAbort >-----#
    measurementAbort = CLASS(name=u'measurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementAbort_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    measurementAbort._val = dict([(u'InitiatingMessage', _measurementAbort_val_InitiatingMessage), (u'procedureCode', 14), (u'criticality', u'ignore')])
    
    #-----< measurementFailureIndication >-----#
    measurementFailureIndication = CLASS(name=u'measurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    measurementFailureIndication._val = dict([(u'InitiatingMessage', _measurementFailureIndication_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< tRPInformationExchange >-----#
    tRPInformationExchange = CLASS(name=u'tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _tRPInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _tRPInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _tRPInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    tRPInformationExchange._val = dict([(u'InitiatingMessage', _tRPInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _tRPInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _tRPInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 16), (u'criticality', u'reject')])
    
    #-----< positioningActivation >-----#
    positioningActivation = CLASS(name=u'positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningActivation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _positioningActivation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _positioningActivation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    positioningActivation._val = dict([(u'InitiatingMessage', _positioningActivation_val_InitiatingMessage), (u'SuccessfulOutcome', _positioningActivation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _positioningActivation_val_UnsuccessfulOutcome), (u'procedureCode', 17), (u'criticality', u'reject')])
    
    #-----< positioningDeactivation >-----#
    positioningDeactivation = CLASS(name=u'positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningDeactivation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    positioningDeactivation._val = dict([(u'InitiatingMessage', _positioningDeactivation_val_InitiatingMessage), (u'procedureCode', 18), (u'criticality', u'ignore')])
    
    _all_ = [
        _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _NRPPA_ELEMENTARY_PROCEDURE_procedureCode,
        _NRPPA_ELEMENTARY_PROCEDURE_criticality,
        NRPPA_ELEMENTARY_PROCEDURE,
        _NRPPA_PDU_initiatingMessage,
        _NRPPA_PDU_successfulOutcome,
        _NRPPA_PDU_unsuccessfulOutcome,
        NRPPA_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_nrppatransactionID,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_nrppatransactionID,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_nrppatransactionID,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        NRPPA_ELEMENTARY_PROCEDURES,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        NRPPA_ELEMENTARY_PROCEDURES_CLASS_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        NRPPA_ELEMENTARY_PROCEDURES_CLASS_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        e_CIDMeasurementInitiation,
        _e_CIDMeasurementInitiation_val_InitiatingMessage,
        _e_CIDMeasurementInitiation_val_SuccessfulOutcome,
        _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome,
        e_CIDMeasurementFailureIndication,
        _e_CIDMeasurementFailureIndication_val_InitiatingMessage,
        e_CIDMeasurementReport,
        _e_CIDMeasurementReport_val_InitiatingMessage,
        e_CIDMeasurementTermination,
        _e_CIDMeasurementTermination_val_InitiatingMessage,
        oTDOAInformationExchange,
        _oTDOAInformationExchange_val_InitiatingMessage,
        _oTDOAInformationExchange_val_SuccessfulOutcome,
        _oTDOAInformationExchange_val_UnsuccessfulOutcome,
        assistanceInformationControl,
        _assistanceInformationControl_val_InitiatingMessage,
        assistanceInformationFeedback,
        _assistanceInformationFeedback_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        positioningInformationExchange,
        _positioningInformationExchange_val_InitiatingMessage,
        _positioningInformationExchange_val_SuccessfulOutcome,
        _positioningInformationExchange_val_UnsuccessfulOutcome,
        positioningInformationUpdate,
        _positioningInformationUpdate_val_InitiatingMessage,
        measurement,
        _measurement_val_InitiatingMessage,
        _measurement_val_SuccessfulOutcome,
        _measurement_val_UnsuccessfulOutcome,
        measurementReport,
        _measurementReport_val_InitiatingMessage,
        measurementUpdate,
        _measurementUpdate_val_InitiatingMessage,
        measurementAbort,
        _measurementAbort_val_InitiatingMessage,
        measurementFailureIndication,
        _measurementFailureIndication_val_InitiatingMessage,
        tRPInformationExchange,
        _tRPInformationExchange_val_InitiatingMessage,
        _tRPInformationExchange_val_SuccessfulOutcome,
        _tRPInformationExchange_val_UnsuccessfulOutcome,
        positioningActivation,
        _positioningActivation_val_InitiatingMessage,
        _positioningActivation_val_SuccessfulOutcome,
        _positioningActivation_val_UnsuccessfulOutcome,
        positioningDeactivation,
        _positioningDeactivation_val_InitiatingMessage,
    ]

init_modules(NRPPA_CommonDataTypes, NRPPA_Constants, NRPPA_Containers, NRPPA_IEs, NRPPA_PDU_Contents, NRPPA_PDU_Descriptions)
